=== added file '.kateconfig'
--- .kateconfig	1970-01-01 00:00:00 +0000
+++ .kateconfig	2011-12-15 14:17:54 +0000
@@ -0,0 +1,1 @@
+kate: tab-indents off; indent-width 4; replace-tabs on;

=== modified file 'app/CMakeLists.txt'
--- app/CMakeLists.txt	2011-07-20 13:46:34 +0000
+++ app/CMakeLists.txt	2011-12-15 14:17:54 +0000
@@ -20,7 +20,7 @@
 	contextmanager.cpp
 	gvcore.cpp
 	documentinfoprovider.cpp
-	documentpanel.cpp
+	viewmainpage.cpp
 	fileoperations.cpp
 	filtercontroller.cpp
 	folderviewcontextmanageritem.cpp
@@ -35,9 +35,9 @@
 	saveallhelper.cpp
 	savebar.cpp
 	sidebar.cpp
-	startpage.cpp
+	startmainpage.cpp
 	thumbnailviewhelper.cpp
-	thumbnailviewpanel.cpp
+	browsemainpage.cpp
 	)
 
 if (NOT GWENVIEW_SEMANTICINFO_BACKEND_NONE)
@@ -63,8 +63,8 @@
 	generalconfigpage.ui
 	imageviewconfigpage.ui
 	semanticinfodialog.ui
-	startpage.ui
-	thumbnailviewpanel.ui
+	startmainpage.ui
+	browsemainpage.ui
 	)
 
 if (NOT GWENVIEW_SEMANTICINFO_BACKEND_NONE)

=== modified file 'app/abstractcontextmanageritem.cpp'
--- app/abstractcontextmanageritem.cpp	2011-07-20 13:46:34 +0000
+++ app/abstractcontextmanageritem.cpp	2011-12-15 14:17:54 +0000
@@ -22,39 +22,40 @@
 // Local
 #include "contextmanager.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct AbstractContextManagerItemPrivate {
-	ContextManager* mContextManager;
-	QWidget* mWidget;
+    ContextManager* mContextManager;
+    QWidget* mWidget;
 };
 
 AbstractContextManagerItem::AbstractContextManagerItem(ContextManager* manager)
 : QObject(manager)
-, d(new AbstractContextManagerItemPrivate) {
-	d->mContextManager = manager;
-	d->mWidget = 0;
-}
-
-
-AbstractContextManagerItem::~AbstractContextManagerItem() {
-	delete d;
-}
-
-
-ContextManager* AbstractContextManagerItem::contextManager() const {
-	return d->mContextManager;
-}
-
-
-QWidget* AbstractContextManagerItem::widget() const {
-	return d->mWidget;
-}
-
-
-void AbstractContextManagerItem::setWidget(QWidget* widget) {
-	d->mWidget = widget;
-}
-
+, d(new AbstractContextManagerItemPrivate)
+{
+    d->mContextManager = manager;
+    d->mWidget = 0;
+}
+
+AbstractContextManagerItem::~AbstractContextManagerItem()
+{
+    delete d;
+}
+
+ContextManager* AbstractContextManagerItem::contextManager() const
+{
+    return d->mContextManager;
+}
+
+QWidget* AbstractContextManagerItem::widget() const
+{
+    return d->mWidget;
+}
+
+void AbstractContextManagerItem::setWidget(QWidget* widget)
+{
+    d->mWidget = widget;
+}
 
 } // namespace

=== modified file 'app/abstractcontextmanageritem.h'
--- app/abstractcontextmanageritem.h	2011-07-20 13:46:34 +0000
+++ app/abstractcontextmanageritem.h	2011-12-15 14:17:54 +0000
@@ -24,27 +24,28 @@
 // Qt
 #include <QWidget>
 
-
-namespace Gwenview {
+namespace Gwenview
+{
 
 class ContextManager;
 
 struct AbstractContextManagerItemPrivate;
-class AbstractContextManagerItem : public QObject {
-	Q_OBJECT
+class AbstractContextManagerItem : public QObject
+{
+    Q_OBJECT
 public:
-	AbstractContextManagerItem(ContextManager*);
-	virtual ~AbstractContextManagerItem();
-
-	QWidget* widget() const;
-
-	ContextManager* contextManager() const;
+    AbstractContextManagerItem(ContextManager*);
+    virtual ~AbstractContextManagerItem();
+
+    QWidget* widget() const;
+
+    ContextManager* contextManager() const;
 
 protected:
-	void setWidget(QWidget* widget);
+    void setWidget(QWidget* widget);
 
 private:
-	AbstractContextManagerItemPrivate * const d;
+    AbstractContextManagerItemPrivate * const d;
 };
 
 } // namespace

=== added file 'app/browsemainpage.cpp'
--- app/browsemainpage.cpp	1970-01-01 00:00:00 +0000
+++ app/browsemainpage.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,359 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "browsemainpage.moc"
+
+// Qt
+#include <QDropEvent>
+#include <QMenu>
+#include <QSlider>
+#include <QToolTip>
+#include <QVBoxLayout>
+
+// KDE
+#include <kactioncollection.h>
+#include <kactioncategory.h>
+#include <kactionmenu.h>
+#include <kdebug.h>
+#include <kfileitem.h>
+#include <kfileplacesmodel.h>
+#include <klineedit.h>
+#include <klocale.h>
+#include <kselectaction.h>
+#include <kstatusbar.h>
+#include <ktoggleaction.h>
+#include <kurlnavigator.h>
+
+// Local
+#include <filtercontroller.h>
+#include <fileoperations.h>
+#include <lib/document/documentfactory.h>
+#include <lib/gwenviewconfig.h>
+#include <lib/semanticinfo/abstractsemanticinfobackend.h>
+#include <lib/semanticinfo/sorteddirmodel.h>
+#include <lib/semanticinfo/tagmodel.h>
+#include <lib/sorting.h>
+#include <lib/archiveutils.h>
+#include <lib/thumbnailview/previewitemdelegate.h>
+#include <lib/thumbnailview/thumbnailview.h>
+#include <ui_browsemainpage.h>
+
+namespace Gwenview
+{
+
+inline Sorting::Enum sortingFromSortAction(const QAction* action)
+{
+    Q_ASSERT(action);
+    return Sorting::Enum(action->data().toInt());
+}
+
+struct BrowseMainPagePrivate : public Ui_BrowseMainPage {
+    BrowseMainPage* q;
+    KFilePlacesModel* mFilePlacesModel;
+    KUrlNavigator* mUrlNavigator;
+    SortedDirModel* mDirModel;
+    int mDocumentCount;
+    KActionCollection* mActionCollection;
+    FilterController* mFilterController;
+    KSelectAction* mSortAction;
+    QActionGroup* mThumbnailDetailsActionGroup;
+    PreviewItemDelegate* mDelegate;
+
+    void setupWidgets()
+    {
+        setupUi(q);
+        q->layout()->setMargin(0);
+
+        // mThumbnailView
+        mThumbnailView->setModel(mDirModel);
+
+        mDelegate = new PreviewItemDelegate(mThumbnailView);
+        mThumbnailView->setItemDelegate(mDelegate);
+        mThumbnailView->setSelectionMode(QAbstractItemView::ExtendedSelection);
+
+        // mUrlNavigator (use stupid layouting code because KUrlNavigator ctor
+        // can't be used directly from Designer)
+        mFilePlacesModel = new KFilePlacesModel(q);
+        mUrlNavigator = new KUrlNavigator(mFilePlacesModel, KUrl(), mUrlNavigatorContainer);
+        QVBoxLayout* layout = new QVBoxLayout(mUrlNavigatorContainer);
+        layout->setMargin(0);
+        layout->addWidget(mUrlNavigator);
+        QObject::connect(mUrlNavigator, SIGNAL(urlsDropped(KUrl, QDropEvent*)),
+                         q, SLOT(slotUrlsDropped(KUrl, QDropEvent*)));
+
+        // Thumbnail slider
+        QObject::connect(mThumbnailSlider, SIGNAL(valueChanged(int)),
+                         mThumbnailView, SLOT(setThumbnailSize(int)));
+        QObject::connect(mThumbnailView, SIGNAL(thumbnailSizeChanged(int)),
+                         mThumbnailSlider, SLOT(setValue(int)));
+    }
+
+    void setupActions(KActionCollection* actionCollection)
+    {
+        KActionCategory* view = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface", "View"), actionCollection);
+        KAction* action = view->addAction("edit_location", q, SLOT(editLocation()));
+        action->setText(i18nc("@action:inmenu Navigation Bar", "Edit Location"));
+        action->setShortcut(Qt::Key_F6);
+
+        mSortAction = view->add<KSelectAction>("sort_order");
+        mSortAction->setText(i18nc("@action:inmenu", "Sort By"));
+        action = mSortAction->addAction(i18nc("@addAction:inmenu", "Name"));
+        action->setData(QVariant(Sorting::Name));
+        action = mSortAction->addAction(i18nc("@addAction:inmenu", "Date"));
+        action->setData(QVariant(Sorting::Date));
+        action = mSortAction->addAction(i18nc("@addAction:inmenu", "Size"));
+        action->setData(QVariant(Sorting::Size));
+        QObject::connect(mSortAction, SIGNAL(triggered(QAction*)),
+                         q, SLOT(updateSortOrder()));
+
+        mThumbnailDetailsActionGroup = new QActionGroup(q);
+        mThumbnailDetailsActionGroup->setExclusive(false);
+        KActionMenu* thumbnailDetailsAction = view->add<KActionMenu>("thumbnail_details");
+        thumbnailDetailsAction->setText(i18nc("@action:inmenu", "Thumbnail Details"));
+#define addAction(text, detail) \
+    action = new KAction(q); \
+    thumbnailDetailsAction->addAction(action); \
+    action->setText(text); \
+    action->setCheckable(true); \
+    action->setChecked(GwenviewConfig::thumbnailDetails() & detail); \
+    action->setData(QVariant(detail)); \
+    mThumbnailDetailsActionGroup->addAction(action); \
+    QObject::connect(action, SIGNAL(triggered(bool)), \
+                     q, SLOT(updateThumbnailDetails()));
+        addAction(i18nc("@action:inmenu", "Filename"), PreviewItemDelegate::FileNameDetail);
+        addAction(i18nc("@action:inmenu", "Date"), PreviewItemDelegate::DateDetail);
+        addAction(i18nc("@action:inmenu", "Image Size"), PreviewItemDelegate::ImageSizeDetail);
+        addAction(i18nc("@action:inmenu", "File Size"), PreviewItemDelegate::FileSizeDetail);
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+        addAction(i18nc("@action:inmenu", "Rating"), PreviewItemDelegate::RatingDetail);
+#endif
+#undef addAction
+
+        KActionCategory* file = new KActionCategory(i18nc("@title actions category", "File"), actionCollection);
+        action = file->addAction("add_folder_to_places", q, SLOT(addFolderToPlaces()));
+        action->setText(i18nc("@action:inmenu", "Add Folder to Places"));
+    }
+
+    void setupFilterController()
+    {
+        QMenu* menu = new QMenu(mAddFilterButton);
+        mFilterController = new FilterController(mFilterFrame, mDirModel);
+        Q_FOREACH(QAction * action, mFilterController->actionList()) {
+            menu->addAction(action);
+        }
+        mAddFilterButton->setMenu(menu);
+    }
+
+    void updateDocumentCountLabel()
+    {
+        QString text = i18ncp("@label", "%1 document", "%1 documents", mDocumentCount);
+        mDocumentCountLabel->setText(text);
+    }
+
+    void setupDocumentCountConnections()
+    {
+        QObject::connect(mDirModel, SIGNAL(rowsInserted(QModelIndex, int, int)),
+                         q, SLOT(slotDirModelRowsInserted(QModelIndex, int, int)));
+
+        QObject::connect(mDirModel, SIGNAL(rowsAboutToBeRemoved(QModelIndex, int, int)),
+                         q, SLOT(slotDirModelRowsAboutToBeRemoved(QModelIndex, int, int)));
+
+        QObject::connect(mDirModel, SIGNAL(modelReset()),
+                         q, SLOT(slotDirModelReset()));
+    }
+
+    int documentCountInIndexRange(const QModelIndex& parent, int start, int end)
+    {
+        int count = 0;
+        for (int row = start; row <= end; ++row) {
+            QModelIndex index = mDirModel->index(row, 0, parent);
+            KFileItem item = mDirModel->itemForIndex(index);
+            if (!ArchiveUtils::fileItemIsDirOrArchive(item)) {
+                ++count;
+            }
+        }
+        return count;
+    }
+};
+
+BrowseMainPage::BrowseMainPage(QWidget* parent, SortedDirModel* dirModel, KActionCollection* actionCollection)
+: QWidget(parent)
+, d(new BrowseMainPagePrivate)
+{
+    d->q = this;
+    d->mDirModel = dirModel;
+    d->mDocumentCount = 0;
+    d->mActionCollection = actionCollection;
+    d->setupWidgets();
+    d->setupActions(actionCollection);
+    d->setupFilterController();
+    d->setupDocumentCountConnections();
+    loadConfig();
+    updateSortOrder();
+    updateThumbnailDetails();
+}
+
+BrowseMainPage::~BrowseMainPage()
+{
+    delete d;
+}
+
+void BrowseMainPage::loadConfig()
+{
+    d->mUrlNavigator->setUrlEditable(GwenviewConfig::urlNavigatorIsEditable());
+    d->mUrlNavigator->setShowFullPath(GwenviewConfig::urlNavigatorShowFullPath());
+
+    d->mThumbnailSlider->setValue(GwenviewConfig::thumbnailSize());
+    d->mThumbnailSlider->updateToolTip();
+    // If GwenviewConfig::thumbnailSize() returns the current value of
+    // mThumbnailSlider, it won't emit valueChanged() and the thumbnail view
+    // won't be updated. That's why we do it ourself.
+    d->mThumbnailView->setThumbnailSize(GwenviewConfig::thumbnailSize());
+
+    Q_FOREACH(QAction * action, d->mSortAction->actions()) {
+        if (sortingFromSortAction(action) == GwenviewConfig::sorting()) {
+            d->mSortAction->setCurrentAction(action);
+            break;
+        }
+    }
+}
+
+void BrowseMainPage::saveConfig() const
+{
+    GwenviewConfig::setUrlNavigatorIsEditable(d->mUrlNavigator->isUrlEditable());
+    GwenviewConfig::setUrlNavigatorShowFullPath(d->mUrlNavigator->showFullPath());
+    GwenviewConfig::setThumbnailSize(d->mThumbnailSlider->value());
+    GwenviewConfig::setSorting(sortingFromSortAction(d->mSortAction->currentAction()));
+    GwenviewConfig::setThumbnailDetails(d->mDelegate->thumbnailDetails());
+}
+
+ThumbnailView* BrowseMainPage::thumbnailView() const
+{
+    return d->mThumbnailView;
+}
+
+KUrlNavigator* BrowseMainPage::urlNavigator() const
+{
+    return d->mUrlNavigator;
+}
+
+void BrowseMainPage::reload()
+{
+    QModelIndexList list = d->mThumbnailView->selectionModel()->selectedIndexes();
+    Q_FOREACH(const QModelIndex & index, list) {
+        d->mThumbnailView->reloadThumbnail(index);
+    }
+    d->mDirModel->reload();
+}
+
+void BrowseMainPage::editLocation()
+{
+    d->mUrlNavigator->setUrlEditable(true);
+    d->mUrlNavigator->setFocus();
+}
+
+void BrowseMainPage::addFolderToPlaces()
+{
+    KUrl url = d->mUrlNavigator->locationUrl();
+    QString text = url.fileName();
+    if (text.isEmpty()) {
+        text = url.pathOrUrl();
+    }
+    d->mFilePlacesModel->addPlace(text, url);
+}
+
+void BrowseMainPage::slotDirModelRowsInserted(const QModelIndex& parent, int start, int end)
+{
+    int count = d->documentCountInIndexRange(parent, start, end);
+    if (count > 0) {
+        d->mDocumentCount += count;
+        d->updateDocumentCountLabel();
+    }
+}
+
+void BrowseMainPage::slotDirModelRowsAboutToBeRemoved(const QModelIndex& parent, int start, int end)
+{
+    int count = d->documentCountInIndexRange(parent, start, end);
+    if (count > 0) {
+        d->mDocumentCount -= count;
+        d->updateDocumentCountLabel();
+    }
+}
+
+void BrowseMainPage::slotDirModelReset()
+{
+    d->mDocumentCount = 0;
+    d->updateDocumentCountLabel();
+}
+
+void BrowseMainPage::updateSortOrder()
+{
+    const QAction* action = d->mSortAction->currentAction();
+    if (!action) {
+        kWarning() << "!action, this should not happen!";
+        return;
+    }
+
+    // This works because for now Sorting::Enum maps to KDirModel::ModelColumns
+    d->mDirModel->setSortRole(sortingFromSortAction(action));
+}
+
+void BrowseMainPage::updateThumbnailDetails()
+{
+    PreviewItemDelegate::ThumbnailDetails details = 0;
+    Q_FOREACH(const QAction * action, d->mThumbnailDetailsActionGroup->actions()) {
+        if (action->isChecked()) {
+            details |= PreviewItemDelegate::ThumbnailDetail(action->data().toInt());
+        }
+    }
+    d->mDelegate->setThumbnailDetails(details);
+}
+
+void BrowseMainPage::applyPalette(const QPalette& palette)
+{
+    d->mThumbnailView->setPalette(palette);
+}
+
+void BrowseMainPage::slotUrlsDropped(const KUrl& destUrl, QDropEvent* event)
+{
+    const KUrl::List urlList = KUrl::List::fromMimeData(event->mimeData());
+    if (urlList.isEmpty()) {
+        return;
+    }
+    event->acceptProposedAction();
+
+    // We can't call FileOperations::showMenuForDroppedUrls() directly because
+    // we need the slot to return so that the drop event is accepted. Otherwise
+    // the drop cursor is still visible when the menu is shown.
+    QMetaObject::invokeMethod(this, "showMenuForDroppedUrls", Qt::QueuedConnection, Q_ARG(KUrl::List, urlList), Q_ARG(KUrl, destUrl));
+}
+
+void BrowseMainPage::showMenuForDroppedUrls(const KUrl::List& urlList, const KUrl& destUrl)
+{
+    FileOperations::showMenuForDroppedUrls(d->mUrlNavigator, urlList, destUrl);
+}
+
+QToolButton* BrowseMainPage::toggleSideBarButton() const
+{
+    return d->mToggleSideBarButton;
+}
+
+} // namespace

=== added file 'app/browsemainpage.h'
--- app/browsemainpage.h	1970-01-01 00:00:00 +0000
+++ app/browsemainpage.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,87 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef BROWSEMAINPAGE_H
+#define BROWSEMAINPAGE_H
+
+// Qt
+#include <QWidget>
+
+// KDE
+#include <kurl.h>
+
+// Local
+
+class QDropEvent;
+class QModelIndex;
+class QToolButton;
+
+class KActionCollection;
+class KUrlNavigator;
+
+namespace Gwenview
+{
+
+class SortedDirModel;
+class ThumbnailView;
+
+struct BrowseMainPagePrivate;
+/**
+ * This class contains all the necessary widgets displayed in browse mode:
+ * the thumbnail view, the url navigator, the bottom bar.
+ */
+class BrowseMainPage : public QWidget
+{
+    Q_OBJECT
+public:
+    BrowseMainPage(QWidget* parent, SortedDirModel*, KActionCollection*);
+    ~BrowseMainPage();
+
+    void applyPalette(const QPalette&);
+
+    void reload();
+
+    ThumbnailView* thumbnailView() const;
+    KUrlNavigator* urlNavigator() const;
+
+    void loadConfig();
+    void saveConfig() const;
+
+    QToolButton* toggleSideBarButton() const;
+
+private Q_SLOTS:
+    void editLocation();
+    void addFolderToPlaces();
+
+    void slotDirModelRowsInserted(const QModelIndex& parent, int start, int end);
+    void slotDirModelRowsAboutToBeRemoved(const QModelIndex& parent, int start, int end);
+    void slotDirModelReset();
+    void updateSortOrder();
+    void updateThumbnailDetails();
+    void slotUrlsDropped(const KUrl& destUrl, QDropEvent*);
+    void showMenuForDroppedUrls(const KUrl::List&, const KUrl& destUrl);
+
+private:
+    BrowseMainPagePrivate* const d;
+};
+
+} // namespace
+
+#endif /* BROWSEMAINPAGE_H */

=== added file 'app/browsemainpage.ui'
--- app/browsemainpage.ui	1970-01-01 00:00:00 +0000
+++ app/browsemainpage.ui	2011-12-15 14:17:54 +0000
@@ -0,0 +1,130 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>BrowseMainPage</class>
+ <widget class="QWidget" name="BrowseMainPage">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>264</width>
+    <height>267</height>
+   </rect>
+  </property>
+  <layout class="QGridLayout" name="gridLayout">
+   <property name="spacing">
+    <number>0</number>
+   </property>
+   <item row="0" column="1">
+    <widget class="QWidget" name="mUrlNavigatorContainer" native="true">
+     <property name="sizePolicy">
+      <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
+       <horstretch>0</horstretch>
+       <verstretch>0</verstretch>
+      </sizepolicy>
+     </property>
+     <property name="minimumSize">
+      <size>
+       <width>0</width>
+       <height>10</height>
+      </size>
+     </property>
+    </widget>
+   </item>
+   <item row="1" column="0" colspan="2">
+    <widget class="Gwenview::ThumbnailView" name="mThumbnailView"/>
+   </item>
+   <item row="2" column="0" colspan="2">
+    <widget class="QFrame" name="mFilterFrame">
+     <property name="sizePolicy">
+      <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+       <horstretch>0</horstretch>
+       <verstretch>0</verstretch>
+      </sizepolicy>
+     </property>
+     <property name="frameShape">
+      <enum>QFrame::StyledPanel</enum>
+     </property>
+     <property name="frameShadow">
+      <enum>QFrame::Sunken</enum>
+     </property>
+    </widget>
+   </item>
+   <item row="3" column="0" colspan="2">
+    <widget class="QWidget" name="mStatusBarContainer" native="true">
+     <layout class="QHBoxLayout" name="horizontalLayout">
+      <property name="spacing">
+       <number>0</number>
+      </property>
+      <property name="margin">
+       <number>0</number>
+      </property>
+      <item>
+       <widget class="Gwenview::StatusBarToolButton" name="mToggleSideBarButton"/>
+      </item>
+      <item>
+       <widget class="Gwenview::StatusBarToolButton" name="mAddFilterButton">
+        <property name="text">
+         <string>Add Filter</string>
+        </property>
+        <property name="popupMode">
+         <enum>QToolButton::InstantPopup</enum>
+        </property>
+       </widget>
+      </item>
+      <item>
+       <widget class="QLabel" name="mDocumentCountLabel">
+        <property name="sizePolicy">
+         <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
+          <horstretch>1</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="text">
+         <string/>
+        </property>
+        <property name="alignment">
+         <set>Qt::AlignCenter</set>
+        </property>
+       </widget>
+      </item>
+      <item>
+       <widget class="Gwenview::ThumbnailSlider" name="mThumbnailSlider" native="true">
+        <property name="sizePolicy">
+         <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="minimumSize">
+         <size>
+          <width>120</width>
+          <height>0</height>
+         </size>
+        </property>
+       </widget>
+      </item>
+     </layout>
+    </widget>
+   </item>
+  </layout>
+ </widget>
+ <customwidgets>
+  <customwidget>
+   <class>Gwenview::ThumbnailView</class>
+   <extends>QListView</extends>
+   <header location="global">lib/thumbnailview/thumbnailview.h</header>
+  </customwidget>
+  <customwidget>
+   <class>Gwenview::StatusBarToolButton</class>
+   <extends>QToolButton</extends>
+   <header location="global">lib/statusbartoolbutton.h</header>
+  </customwidget>
+  <customwidget>
+   <class>Gwenview::ThumbnailSlider</class>
+   <extends>QWidget</extends>
+   <header location="global">lib/thumbnailview/thumbnailslider.h</header>
+  </customwidget>
+ </customwidgets>
+ <resources/>
+ <connections/>
+</ui>

=== modified file 'app/configdialog.cpp'
--- app/configdialog.cpp	2011-07-20 13:46:34 +0000
+++ app/configdialog.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -32,93 +32,93 @@
 #include "ui_advancedconfigpage.h"
 #include <lib/gwenviewconfig.h>
 #include <lib/invisiblebuttongroup.h>
-#include <lib/scrolltool.h>
-
-namespace Gwenview {
-
+
+namespace Gwenview
+{
 
 struct ConfigDialogPrivate {
-	InvisibleButtonGroup* mAlphaBackgroundModeGroup;
-	InvisibleButtonGroup* mWheelBehaviorGroup;
-	InvisibleButtonGroup* mThumbnailBarOrientationGroup;
-	Ui_GeneralConfigPage mGeneralConfigPage;
-	Ui_ImageViewConfigPage mImageViewConfigPage;
-	Ui_AdvancedConfigPage mAdvancedConfigPage;
+    InvisibleButtonGroup* mAlphaBackgroundModeGroup;
+    InvisibleButtonGroup* mWheelBehaviorGroup;
+    InvisibleButtonGroup* mThumbnailBarOrientationGroup;
+    Ui_GeneralConfigPage mGeneralConfigPage;
+    Ui_ImageViewConfigPage mImageViewConfigPage;
+    Ui_AdvancedConfigPage mAdvancedConfigPage;
 };
 
 template <class Ui>
-QWidget* setupPage(Ui& ui) {
-	QWidget* widget = new QWidget;
-	ui.setupUi(widget);
-	widget->layout()->setMargin(0);
-	return widget;
+QWidget* setupPage(Ui& ui)
+{
+    QWidget* widget = new QWidget;
+    ui.setupUi(widget);
+    widget->layout()->setMargin(0);
+    return widget;
 }
 
 ConfigDialog::ConfigDialog(QWidget* parent)
 : KConfigDialog(parent, "Settings", GwenviewConfig::self())
-, d(new ConfigDialogPrivate) {
-	setFaceType(KPageDialog::List);
-	setButtons(KDialog::Ok | KDialog::Cancel | KDialog::Apply | KDialog::Default);
-	showButtonSeparator(true);
-
-	QWidget* widget;
-	KPageWidgetItem* pageItem;
-
-	// General
-	widget = setupPage(d->mGeneralConfigPage);
-	pageItem = addPage(widget, i18n("General"));
-	pageItem->setIcon(KIcon("gwenview"));
-	connect(d->mGeneralConfigPage.kcfg_ViewBackgroundValue, SIGNAL(valueChanged(int)), SLOT(updateViewBackgroundFrame()));
-
-	// Image View
-	widget = setupPage(d->mImageViewConfigPage);
-
-	d->mAlphaBackgroundModeGroup = new InvisibleButtonGroup(widget);
-	d->mAlphaBackgroundModeGroup->setObjectName( QLatin1String("kcfg_AlphaBackgroundMode" ));
-	d->mAlphaBackgroundModeGroup->addButton(d->mImageViewConfigPage.checkBoardRadioButton, int(ImageView::AlphaBackgroundCheckBoard));
-	d->mAlphaBackgroundModeGroup->addButton(d->mImageViewConfigPage.solidColorRadioButton, int(ImageView::AlphaBackgroundSolid));
-
-	d->mWheelBehaviorGroup = new InvisibleButtonGroup(widget);
-	d->mWheelBehaviorGroup->setObjectName( QLatin1String("kcfg_MouseWheelBehavior" ));
-	d->mWheelBehaviorGroup->addButton(d->mImageViewConfigPage.mouseWheelScrollRadioButton, int(ScrollTool::MouseWheelScroll));
-	d->mWheelBehaviorGroup->addButton(d->mImageViewConfigPage.mouseWheelBrowseRadioButton, int(ScrollTool::MouseWheelBrowse));
-
-	d->mThumbnailBarOrientationGroup = new InvisibleButtonGroup(widget);
-	d->mThumbnailBarOrientationGroup->setObjectName( QLatin1String("kcfg_ThumbnailBarOrientation" ));
-	d->mThumbnailBarOrientationGroup->addButton(d->mImageViewConfigPage.horizontalRadioButton, int(Qt::Horizontal));
-	d->mThumbnailBarOrientationGroup->addButton(d->mImageViewConfigPage.verticalRadioButton, int(Qt::Vertical));
-
-	pageItem = addPage(widget, i18n("Image View"));
-	pageItem->setIcon(KIcon("view-preview"));
-
-	// Advanced
-	widget = setupPage(d->mAdvancedConfigPage);
-	pageItem = addPage(widget, i18n("Advanced"));
-	pageItem->setIcon(KIcon("preferences-other"));
-	d->mAdvancedConfigPage.cacheHelpLabel->setFont(KGlobalSettings::smallestReadableFont());
-
-	updateViewBackgroundFrame();
-}
-
-
-ConfigDialog::~ConfigDialog() {
-	delete d;
-}
-
-
-void ConfigDialog::updateViewBackgroundFrame() {
-	QColor color = QColor::fromHsv(0, 0, d->mGeneralConfigPage.kcfg_ViewBackgroundValue->value());
-	QString css =
-		QString(
-		"background-color: %1;"
-		"border-radius: 5px;"
-		"border: 1px solid %1;")
-		.arg(color.name());
-	// When using Oxygen, setting the background color via palette causes the
-	// pixels outside the frame to be painted with the new background color as
-	// well. Using CSS works more like expected.
-	d->mGeneralConfigPage.backgroundValueFrame->setStyleSheet(css);
-}
-
+, d(new ConfigDialogPrivate)
+{
+    setFaceType(KPageDialog::List);
+    setButtons(KDialog::Ok | KDialog::Cancel | KDialog::Apply | KDialog::Default);
+    showButtonSeparator(true);
+
+    QWidget* widget;
+    KPageWidgetItem* pageItem;
+
+    // General
+    widget = setupPage(d->mGeneralConfigPage);
+    pageItem = addPage(widget, i18n("General"));
+    pageItem->setIcon(KIcon("gwenview"));
+    connect(d->mGeneralConfigPage.kcfg_ViewBackgroundValue, SIGNAL(valueChanged(int)), SLOT(updateViewBackgroundFrame()));
+
+    // Image View
+    widget = setupPage(d->mImageViewConfigPage);
+
+    d->mAlphaBackgroundModeGroup = new InvisibleButtonGroup(widget);
+    d->mAlphaBackgroundModeGroup->setObjectName(QLatin1String("kcfg_AlphaBackgroundMode"));
+    d->mAlphaBackgroundModeGroup->addButton(d->mImageViewConfigPage.checkBoardRadioButton, int(RasterImageView::AlphaBackgroundCheckBoard));
+    d->mAlphaBackgroundModeGroup->addButton(d->mImageViewConfigPage.solidColorRadioButton, int(RasterImageView::AlphaBackgroundSolid));
+
+    d->mWheelBehaviorGroup = new InvisibleButtonGroup(widget);
+    d->mWheelBehaviorGroup->setObjectName(QLatin1String("kcfg_MouseWheelBehavior"));
+    d->mWheelBehaviorGroup->addButton(d->mImageViewConfigPage.mouseWheelScrollRadioButton, int(MouseWheelBehavior::Scroll));
+    d->mWheelBehaviorGroup->addButton(d->mImageViewConfigPage.mouseWheelBrowseRadioButton, int(MouseWheelBehavior::Browse));
+
+    d->mThumbnailBarOrientationGroup = new InvisibleButtonGroup(widget);
+    d->mThumbnailBarOrientationGroup->setObjectName(QLatin1String("kcfg_ThumbnailBarOrientation"));
+    d->mThumbnailBarOrientationGroup->addButton(d->mImageViewConfigPage.horizontalRadioButton, int(Qt::Horizontal));
+    d->mThumbnailBarOrientationGroup->addButton(d->mImageViewConfigPage.verticalRadioButton, int(Qt::Vertical));
+
+    pageItem = addPage(widget, i18n("Image View"));
+    pageItem->setIcon(KIcon("view-preview"));
+
+    // Advanced
+    widget = setupPage(d->mAdvancedConfigPage);
+    pageItem = addPage(widget, i18n("Advanced"));
+    pageItem->setIcon(KIcon("preferences-other"));
+    d->mAdvancedConfigPage.cacheHelpLabel->setFont(KGlobalSettings::smallestReadableFont());
+
+    updateViewBackgroundFrame();
+}
+
+ConfigDialog::~ConfigDialog()
+{
+    delete d;
+}
+
+void ConfigDialog::updateViewBackgroundFrame()
+{
+    QColor color = QColor::fromHsv(0, 0, d->mGeneralConfigPage.kcfg_ViewBackgroundValue->value());
+    QString css =
+        QString(
+            "background-color: %1;"
+            "border-radius: 5px;"
+            "border: 1px solid %1;")
+        .arg(color.name());
+    // When using Oxygen, setting the background color via palette causes the
+    // pixels outside the frame to be painted with the new background color as
+    // well. Using CSS works more like expected.
+    d->mGeneralConfigPage.backgroundValueFrame->setStyleSheet(css);
+}
 
 } // namespace

=== modified file 'app/configdialog.h'
--- app/configdialog.h	2011-07-20 13:46:34 +0000
+++ app/configdialog.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -28,24 +28,24 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ConfigDialogPrivate;
-class ConfigDialog : public KConfigDialog {
-	Q_OBJECT
+class ConfigDialog : public KConfigDialog
+{
+    Q_OBJECT
 public:
-	ConfigDialog(QWidget* parent);
-	~ConfigDialog();
+    ConfigDialog(QWidget* parent);
+    ~ConfigDialog();
 
 private Q_SLOTS:
-	void updateViewBackgroundFrame();
+    void updateViewBackgroundFrame();
 
 private:
-	ConfigDialogPrivate* const d;
+    ConfigDialogPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* CONFIGDIALOG_H */

=== modified file 'app/contextmanager.cpp'
--- app/contextmanager.cpp	2011-07-20 13:46:34 +0000
+++ app/contextmanager.cpp	2011-12-15 14:17:54 +0000
@@ -34,198 +34,199 @@
 #include <lib/document/documentfactory.h>
 #include <lib/semanticinfo/sorteddirmodel.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct ContextManagerPrivate {
-	QList<AbstractContextManagerItem*> mList;
-	SortedDirModel* mDirModel;
-	QItemSelectionModel* mSelectionModel;
-	KUrl mCurrentDirUrl;
-	KUrl mCurrentUrl;
-
-	bool mOnlyCurrentUrl;
-	bool mSelectedFileItemListNeedsUpdate;
-	QSet<QByteArray> mQueuedSignals;
-	KFileItemList mSelectedFileItemList;
-
-	QTimer* mQueuedSignalsTimer;
-
-	void queueSignal(const QByteArray& signal) {
-		mQueuedSignals << signal;
-		mQueuedSignalsTimer->start();
-	}
-
-	void updateSelectedFileItemList() {
-		if (!mSelectedFileItemListNeedsUpdate) {
-			return;
-		}
-		mSelectedFileItemList.clear();
-		if (!mOnlyCurrentUrl) {
-			QItemSelection selection = mSelectionModel->selection();
-			Q_FOREACH(const QModelIndex& index, selection.indexes()) {
-				mSelectedFileItemList << mDirModel->itemForIndex(index);
-			}
-		}
-
-		// At least add current url if it's valid (it may not be in
-		// the list if we are viewing a non-browsable url, for example
-		// using http protocol)
-		if (mSelectedFileItemList.isEmpty() && mCurrentUrl.isValid()) {
-			KFileItem item(KFileItem::Unknown, KFileItem::Unknown, mCurrentUrl);
-			mSelectedFileItemList << item;
-		}
-
-		mSelectedFileItemListNeedsUpdate = false;
-	}
+    QList<AbstractContextManagerItem*> mList;
+    SortedDirModel* mDirModel;
+    QItemSelectionModel* mSelectionModel;
+    KUrl mCurrentDirUrl;
+    KUrl mCurrentUrl;
+
+    bool mOnlyCurrentUrl;
+    bool mSelectedFileItemListNeedsUpdate;
+    QSet<QByteArray> mQueuedSignals;
+    KFileItemList mSelectedFileItemList;
+
+    QTimer* mQueuedSignalsTimer;
+
+    void queueSignal(const QByteArray& signal)
+    {
+        mQueuedSignals << signal;
+        mQueuedSignalsTimer->start();
+    }
+
+    void updateSelectedFileItemList()
+    {
+        if (!mSelectedFileItemListNeedsUpdate) {
+            return;
+        }
+        mSelectedFileItemList.clear();
+        if (!mOnlyCurrentUrl) {
+            QItemSelection selection = mSelectionModel->selection();
+            Q_FOREACH(const QModelIndex & index, selection.indexes()) {
+                mSelectedFileItemList << mDirModel->itemForIndex(index);
+            }
+        }
+
+        // At least add current url if it's valid (it may not be in
+        // the list if we are viewing a non-browsable url, for example
+        // using http protocol)
+        if (mSelectedFileItemList.isEmpty() && mCurrentUrl.isValid()) {
+            KFileItem item(KFileItem::Unknown, KFileItem::Unknown, mCurrentUrl);
+            mSelectedFileItemList << item;
+        }
+
+        mSelectedFileItemListNeedsUpdate = false;
+    }
 };
 
-
 ContextManager::ContextManager(SortedDirModel* dirModel, QItemSelectionModel* selectionModel, QObject* parent)
 : QObject(parent)
 , d(new ContextManagerPrivate)
 {
-	d->mQueuedSignalsTimer = new QTimer(this);
-	d->mQueuedSignalsTimer->setInterval(100);
-	d->mQueuedSignalsTimer->setSingleShot(true);
-	connect(d->mQueuedSignalsTimer, SIGNAL(timeout()),
-		SLOT(emitQueuedSignals()) );
-
-	d->mDirModel = dirModel;
-	connect(d->mDirModel, SIGNAL(dataChanged(const QModelIndex&, const QModelIndex&)),
-		SLOT(slotDirModelDataChanged(const QModelIndex&, const QModelIndex&)) );
-
-	d->mSelectionModel = selectionModel;
-	connect(d->mSelectionModel, SIGNAL(selectionChanged(const QItemSelection&, const QItemSelection&)),
-		SLOT(slotSelectionChanged()) );
-	connect(d->mSelectionModel, SIGNAL(currentChanged(const QModelIndex&, const QModelIndex&)),
-		SLOT(slotCurrentChanged(const QModelIndex&)) );
-
-	d->mSelectedFileItemListNeedsUpdate = false;
-	d->mOnlyCurrentUrl = false;
-}
-
-
-ContextManager::~ContextManager() {
-	qDeleteAll(d->mList);
-	delete d;
-}
-
-
-void ContextManager::addItem(AbstractContextManagerItem* item) {
-	d->mList << item;
-}
-
-
-void ContextManager::setCurrentUrl(const KUrl& currentUrl) {
-	if (d->mCurrentUrl == currentUrl) {
-		return;
-	}
-
-	d->mCurrentUrl = currentUrl;
-	Document::Ptr doc = DocumentFactory::instance()->load(currentUrl);
-	QUndoGroup* undoGroup = DocumentFactory::instance()->undoGroup();
-	undoGroup->addStack(doc->undoStack());
-	undoGroup->setActiveStack(doc->undoStack());
-
-	if (d->mOnlyCurrentUrl) {
-		d->mSelectedFileItemListNeedsUpdate = true;
-	}
-
-	d->queueSignal("selectionChanged");
-}
-
-
-KFileItemList ContextManager::selectedFileItemList() const {
-	d->updateSelectedFileItemList();
-	return d->mSelectedFileItemList;
-}
-
-
-void ContextManager::setCurrentDirUrl(const KUrl& url) {
-	if (url.equals(d->mCurrentDirUrl, KUrl::CompareWithoutTrailingSlash)) {
-		return;
-	}
-	d->mCurrentDirUrl = url;
-	currentDirUrlChanged();
-}
-
-
-KUrl ContextManager::currentDirUrl() const {
-	return d->mCurrentDirUrl;
-}
-
-
-KUrl ContextManager::currentUrl() const {
-	return d->mCurrentUrl;
-}
-
-
-SortedDirModel* ContextManager::dirModel() const {
-	return d->mDirModel;
-}
-
-
-void ContextManager::slotDirModelDataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight) {
-	// Data change can happen in the following cases:
-	// - items have been renamed
-	// - item bytes have been modified
-	// - item meta info has been retrieved or modified
-	//
-	// If a selected item is affected, schedule emission of a
-	// selectionDataChanged() signal. Don't emit it directly to avoid spamming
-	// the context items in case of a mass change.
-	QModelIndexList selectionList = d->mSelectionModel->selectedIndexes();
-	if (selectionList.isEmpty()) {
-		return;
-	}
-
-	QModelIndexList changedList;
-	for (int row=topLeft.row(); row <= bottomRight.row(); ++row) {
-		changedList << d->mDirModel->index(row, 0);
-	}
-
-	QModelIndexList& shortList = selectionList;
-	QModelIndexList& longList = changedList;
-	if (shortList.length() > longList.length()) {
-		qSwap(shortList, longList);
-	}
-	Q_FOREACH(const QModelIndex& index, shortList) {
-		if (longList.contains(index)) {
-			d->mSelectedFileItemListNeedsUpdate = true;
-			d->queueSignal("selectionDataChanged");
-			return;
-		}
-	}
-}
-
-
-void ContextManager::slotSelectionChanged() {
-	d->mSelectedFileItemListNeedsUpdate = true;
-	d->queueSignal("selectionChanged");
-}
-
-
-void Gwenview::ContextManager::slotCurrentChanged(const QModelIndex& index) {
-	KUrl url = d->mDirModel->urlForIndex(index);
-	setCurrentUrl(url);
-}
-
-
-void ContextManager::emitQueuedSignals() {
-	Q_FOREACH(const QByteArray& signal, d->mQueuedSignals) {
-		QMetaObject::invokeMethod(this, signal.data());
-	}
-	d->mQueuedSignals.clear();
-}
-
-
-void ContextManager::setOnlyCurrentUrl(bool onlyCurrentUrl) {
-	if (d->mOnlyCurrentUrl != onlyCurrentUrl) {
-		d->mOnlyCurrentUrl = onlyCurrentUrl;
-		d->mSelectedFileItemListNeedsUpdate = true;
-		d->queueSignal("selectionChanged");
-	}
-}
-
+    d->mQueuedSignalsTimer = new QTimer(this);
+    d->mQueuedSignalsTimer->setInterval(100);
+    d->mQueuedSignalsTimer->setSingleShot(true);
+    connect(d->mQueuedSignalsTimer, SIGNAL(timeout()),
+            SLOT(emitQueuedSignals()));
+
+    d->mDirModel = dirModel;
+    connect(d->mDirModel, SIGNAL(dataChanged(QModelIndex, QModelIndex)),
+            SLOT(slotDirModelDataChanged(QModelIndex, QModelIndex)));
+
+    d->mSelectionModel = selectionModel;
+    connect(d->mSelectionModel, SIGNAL(selectionChanged(QItemSelection, QItemSelection)),
+            SLOT(slotSelectionChanged()));
+    connect(d->mSelectionModel, SIGNAL(currentChanged(QModelIndex, QModelIndex)),
+            SLOT(slotCurrentChanged(QModelIndex)));
+
+    d->mSelectedFileItemListNeedsUpdate = false;
+    d->mOnlyCurrentUrl = false;
+}
+
+ContextManager::~ContextManager()
+{
+    qDeleteAll(d->mList);
+    delete d;
+}
+
+void ContextManager::addItem(AbstractContextManagerItem* item)
+{
+    d->mList << item;
+}
+
+void ContextManager::setCurrentUrl(const KUrl& currentUrl)
+{
+    if (d->mCurrentUrl == currentUrl) {
+        return;
+    }
+
+    d->mCurrentUrl = currentUrl;
+    Document::Ptr doc = DocumentFactory::instance()->load(currentUrl);
+    QUndoGroup* undoGroup = DocumentFactory::instance()->undoGroup();
+    undoGroup->addStack(doc->undoStack());
+    undoGroup->setActiveStack(doc->undoStack());
+
+    if (d->mOnlyCurrentUrl) {
+        d->mSelectedFileItemListNeedsUpdate = true;
+    }
+
+    d->queueSignal("selectionChanged");
+}
+
+KFileItemList ContextManager::selectedFileItemList() const
+{
+    d->updateSelectedFileItemList();
+    return d->mSelectedFileItemList;
+}
+
+void ContextManager::setCurrentDirUrl(const KUrl& url)
+{
+    if (url.equals(d->mCurrentDirUrl, KUrl::CompareWithoutTrailingSlash)) {
+        return;
+    }
+    d->mCurrentDirUrl = url;
+    currentDirUrlChanged();
+}
+
+KUrl ContextManager::currentDirUrl() const
+{
+    return d->mCurrentDirUrl;
+}
+
+KUrl ContextManager::currentUrl() const
+{
+    return d->mCurrentUrl;
+}
+
+SortedDirModel* ContextManager::dirModel() const
+{
+    return d->mDirModel;
+}
+
+void ContextManager::slotDirModelDataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
+{
+    // Data change can happen in the following cases:
+    // - items have been renamed
+    // - item bytes have been modified
+    // - item meta info has been retrieved or modified
+    //
+    // If a selected item is affected, schedule emission of a
+    // selectionDataChanged() signal. Don't emit it directly to avoid spamming
+    // the context items in case of a mass change.
+    QModelIndexList selectionList = d->mSelectionModel->selectedIndexes();
+    if (selectionList.isEmpty()) {
+        return;
+    }
+
+    QModelIndexList changedList;
+    for (int row = topLeft.row(); row <= bottomRight.row(); ++row) {
+        changedList << d->mDirModel->index(row, 0);
+    }
+
+    QModelIndexList& shortList = selectionList;
+    QModelIndexList& longList = changedList;
+    if (shortList.length() > longList.length()) {
+        qSwap(shortList, longList);
+    }
+    Q_FOREACH(const QModelIndex & index, shortList) {
+        if (longList.contains(index)) {
+            d->mSelectedFileItemListNeedsUpdate = true;
+            d->queueSignal("selectionDataChanged");
+            return;
+        }
+    }
+}
+
+void ContextManager::slotSelectionChanged()
+{
+    d->mSelectedFileItemListNeedsUpdate = true;
+    d->queueSignal("selectionChanged");
+}
+
+void Gwenview::ContextManager::slotCurrentChanged(const QModelIndex& index)
+{
+    KUrl url = d->mDirModel->urlForIndex(index);
+    setCurrentUrl(url);
+}
+
+void ContextManager::emitQueuedSignals()
+{
+    Q_FOREACH(const QByteArray & signal, d->mQueuedSignals) {
+        QMetaObject::invokeMethod(this, signal.data());
+    }
+    d->mQueuedSignals.clear();
+}
+
+void ContextManager::setOnlyCurrentUrl(bool onlyCurrentUrl)
+{
+    if (d->mOnlyCurrentUrl != onlyCurrentUrl) {
+        d->mOnlyCurrentUrl = onlyCurrentUrl;
+        d->mSelectedFileItemListNeedsUpdate = true;
+        d->queueSignal("selectionChanged");
+    }
+}
 
 } // namespace

=== modified file 'app/contextmanager.h'
--- app/contextmanager.h	2011-07-20 13:46:34 +0000
+++ app/contextmanager.h	2011-12-15 14:17:54 +0000
@@ -30,7 +30,8 @@
 class QItemSelectionModel;
 class QModelIndex;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class SortedDirModel;
 
@@ -39,49 +40,50 @@
 struct ContextManagerPrivate;
 
 /**
- * Manage the update of the contextual parts of the applications, 
+ * Manage the update of the contextual parts of the applications,
  * like the sidebar or the context menu.
  */
-class ContextManager : public QObject {
-	Q_OBJECT
+class ContextManager : public QObject
+{
+    Q_OBJECT
 public:
-	ContextManager(SortedDirModel*, QItemSelectionModel*, QObject* parent);
-
-	~ContextManager();
-
-	void addItem(AbstractContextManagerItem* item);
-
-	KUrl currentUrl() const;
-
-	void setCurrentDirUrl(const KUrl&);
-
-	KUrl currentDirUrl() const;
-
-	void setCurrentUrl(const KUrl& currentUrl);
-
-	KFileItemList selectedFileItemList() const;
-
-	SortedDirModel* dirModel() const;
-
-	/**
-	 * If true, selectedFileItemList() will only return current url
-	 * (useful in view mode)
-	 */
-	void setOnlyCurrentUrl(bool onlyCurrentUrl);
+    ContextManager(SortedDirModel*, QItemSelectionModel*, QObject* parent);
+
+    ~ContextManager();
+
+    void addItem(AbstractContextManagerItem* item);
+
+    KUrl currentUrl() const;
+
+    void setCurrentDirUrl(const KUrl&);
+
+    KUrl currentDirUrl() const;
+
+    void setCurrentUrl(const KUrl& currentUrl);
+
+    KFileItemList selectedFileItemList() const;
+
+    SortedDirModel* dirModel() const;
+
+    /**
+     * If true, selectedFileItemList() will only return current url
+     * (useful in view mode)
+     */
+    void setOnlyCurrentUrl(bool onlyCurrentUrl);
 
 Q_SIGNALS:
-	void selectionChanged();
-	void selectionDataChanged();
-	void currentDirUrlChanged();
+    void selectionChanged();
+    void selectionDataChanged();
+    void currentDirUrlChanged();
 
 private Q_SLOTS:
-	void slotDirModelDataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight);
-	void slotSelectionChanged();
-	void slotCurrentChanged(const QModelIndex&);
-	void emitQueuedSignals();
+    void slotDirModelDataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight);
+    void slotSelectionChanged();
+    void slotCurrentChanged(const QModelIndex&);
+    void emitQueuedSignals();
 
 private:
-	ContextManagerPrivate* const d;
+    ContextManagerPrivate* const d;
 };
 
 } // namespace

=== modified file 'app/documentinfoprovider.cpp'
--- app/documentinfoprovider.cpp	2011-07-20 13:46:34 +0000
+++ app/documentinfoprovider.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -30,97 +30,96 @@
 #include <lib/document/documentfactory.h>
 #include <lib/semanticinfo/sorteddirmodel.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct DocumentInfoProviderPrivate {
-	SortedDirModel* mDirModel;
+    SortedDirModel* mDirModel;
 };
 
-
 DocumentInfoProvider::DocumentInfoProvider(SortedDirModel* model)
 : AbstractDocumentInfoProvider(model)
-, d(new DocumentInfoProviderPrivate) {
-	d->mDirModel = model;
-	connect(DocumentFactory::instance(), SIGNAL(documentBusyStateChanged(const KUrl&, bool)),
-		SLOT(emitBusyStateChanged(const KUrl&, bool)) );
-
-	connect(DocumentFactory::instance(), SIGNAL(documentChanged(const KUrl&)),
-		SLOT(emitDocumentChanged(const KUrl&)) );
-}
-
-
-DocumentInfoProvider::~DocumentInfoProvider() {
-	delete d;
-}
-
-
-void DocumentInfoProvider::thumbnailForDocument(const KUrl& url, ThumbnailGroup::Enum group, QPixmap* outPix, QSize* outFullSize) const {
-	Q_ASSERT(outPix);
-	Q_ASSERT(outFullSize);
-	*outPix = QPixmap();
-	*outFullSize = QSize();
-	DocumentFactory* factory = DocumentFactory::instance();
-	const int pixelSize = ThumbnailGroup::pixelSize(group);
-
-	if (!factory->hasUrl(url)) {
-		return;
-	}
-
-	Document::Ptr doc = factory->load(url);
-	if (doc->loadingState() != Document::Loaded) {
-		return;
-	}
-
-	QImage image = doc->image();
-	if (image.width() > pixelSize || image.height() > pixelSize) {
-		image = image.scaled(pixelSize, pixelSize, Qt::KeepAspectRatio);
-	}
-	*outPix = QPixmap::fromImage(image);
-	*outFullSize = doc->size();
-}
-
-
-bool DocumentInfoProvider::isModified(const KUrl& url) {
-	DocumentFactory* factory = DocumentFactory::instance();
-
-	if (factory->hasUrl(url)) {
-		Document::Ptr doc = factory->load(url);
-		return doc->loadingState() == Document::Loaded && doc->isModified();
-	} else {
-		return false;
-	}
-}
-
-
-bool DocumentInfoProvider::isBusy(const KUrl& url) {
-	DocumentFactory* factory = DocumentFactory::instance();
-
-	if (factory->hasUrl(url)) {
-		Document::Ptr doc = factory->load(url);
-		return doc->isBusy();
-	} else {
-		return false;
-	}
-}
-
-
-void DocumentInfoProvider::emitBusyStateChanged(const KUrl& url, bool busy) {
-	QModelIndex index = d->mDirModel->indexForUrl(url);
-	if (!index.isValid()) {
-		return;
-	}
-	busyStateChanged(index, busy);
-}
-
-
-void DocumentInfoProvider::emitDocumentChanged(const KUrl& url) {
-	QModelIndex index = d->mDirModel->indexForUrl(url);
-	if (!index.isValid()) {
-		return;
-	}
-	documentChanged(index);
-}
-
+, d(new DocumentInfoProviderPrivate)
+{
+    d->mDirModel = model;
+    connect(DocumentFactory::instance(), SIGNAL(documentBusyStateChanged(KUrl, bool)),
+            SLOT(emitBusyStateChanged(KUrl, bool)));
+
+    connect(DocumentFactory::instance(), SIGNAL(documentChanged(KUrl)),
+            SLOT(emitDocumentChanged(KUrl)));
+}
+
+DocumentInfoProvider::~DocumentInfoProvider()
+{
+    delete d;
+}
+
+void DocumentInfoProvider::thumbnailForDocument(const KUrl& url, ThumbnailGroup::Enum group, QPixmap* outPix, QSize* outFullSize) const
+{
+    Q_ASSERT(outPix);
+    Q_ASSERT(outFullSize);
+    *outPix = QPixmap();
+    *outFullSize = QSize();
+    DocumentFactory* factory = DocumentFactory::instance();
+    const int pixelSize = ThumbnailGroup::pixelSize(group);
+
+    if (!factory->hasUrl(url)) {
+        return;
+    }
+
+    Document::Ptr doc = factory->load(url);
+    if (doc->loadingState() != Document::Loaded) {
+        return;
+    }
+
+    QImage image = doc->image();
+    if (image.width() > pixelSize || image.height() > pixelSize) {
+        image = image.scaled(pixelSize, pixelSize, Qt::KeepAspectRatio);
+    }
+    *outPix = QPixmap::fromImage(image);
+    *outFullSize = doc->size();
+}
+
+bool DocumentInfoProvider::isModified(const KUrl& url)
+{
+    DocumentFactory* factory = DocumentFactory::instance();
+
+    if (factory->hasUrl(url)) {
+        Document::Ptr doc = factory->load(url);
+        return doc->loadingState() == Document::Loaded && doc->isModified();
+    } else {
+        return false;
+    }
+}
+
+bool DocumentInfoProvider::isBusy(const KUrl& url)
+{
+    DocumentFactory* factory = DocumentFactory::instance();
+
+    if (factory->hasUrl(url)) {
+        Document::Ptr doc = factory->load(url);
+        return doc->isBusy();
+    } else {
+        return false;
+    }
+}
+
+void DocumentInfoProvider::emitBusyStateChanged(const KUrl& url, bool busy)
+{
+    QModelIndex index = d->mDirModel->indexForUrl(url);
+    if (!index.isValid()) {
+        return;
+    }
+    busyStateChanged(index, busy);
+}
+
+void DocumentInfoProvider::emitDocumentChanged(const KUrl& url)
+{
+    QModelIndex index = d->mDirModel->indexForUrl(url);
+    if (!index.isValid()) {
+        return;
+    }
+    documentChanged(index);
+}
 
 } // namespace

=== modified file 'app/documentinfoprovider.h'
--- app/documentinfoprovider.h	2011-07-20 13:46:34 +0000
+++ app/documentinfoprovider.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -28,32 +28,33 @@
 // Local
 #include <lib/thumbnailview/abstractdocumentinfoprovider.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class SortedDirModel;
 
 class DocumentInfoProviderPrivate;
-class DocumentInfoProvider : public AbstractDocumentInfoProvider {
-	Q_OBJECT
+class DocumentInfoProvider : public AbstractDocumentInfoProvider
+{
+    Q_OBJECT
 public:
-	DocumentInfoProvider(SortedDirModel* model);
-	~DocumentInfoProvider();
-
-	virtual bool isBusy(const KUrl& url);
-
-	virtual bool isModified(const KUrl& url);
-
-	virtual void thumbnailForDocument(const KUrl& url, ThumbnailGroup::Enum group, QPixmap* outPix, QSize* outFullSize) const;
+    DocumentInfoProvider(SortedDirModel* model);
+    ~DocumentInfoProvider();
+
+    virtual bool isBusy(const KUrl& url);
+
+    virtual bool isModified(const KUrl& url);
+
+    virtual void thumbnailForDocument(const KUrl& url, ThumbnailGroup::Enum group, QPixmap* outPix, QSize* outFullSize) const;
 
 private Q_SLOTS:
-	void emitBusyStateChanged(const KUrl&, bool);
-	void emitDocumentChanged(const KUrl&);
+    void emitBusyStateChanged(const KUrl&, bool);
+    void emitDocumentChanged(const KUrl&);
 
 private:
-	DocumentInfoProviderPrivate* const d;
+    DocumentInfoProviderPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* DOCUMENTINFOPROVIDER_H */

=== removed file 'app/documentpanel.cpp'
--- app/documentpanel.cpp	2011-07-20 13:46:34 +0000
+++ app/documentpanel.cpp	1970-01-01 00:00:00 +0000
@@ -1,754 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "documentpanel.moc"
-
-// Qt
-#include <QCheckBox>
-#include <QItemSelectionModel>
-#include <QLabel>
-#include <QShortcut>
-#include <QToolButton>
-#include <QVBoxLayout>
-
-// KDE
-#include <kactioncollection.h>
-#include <kactioncategory.h>
-#include <kdebug.h>
-#include <klocale.h>
-#include <kmenu.h>
-#include <kmessagebox.h>
-#include <ktoggleaction.h>
-
-// Local
-#include "fileoperations.h"
-#include "splitter.h"
-#include <lib/binder.h>
-#include <lib/document/document.h>
-#include <lib/documentview/abstractdocumentviewadapter.h>
-#include <lib/documentview/documentview.h>
-#include <lib/documentview/documentviewcontainer.h>
-#include <lib/documentview/documentviewcontroller.h>
-#include <lib/documentview/documentviewsynchronizer.h>
-#include <lib/gwenviewconfig.h>
-#include <lib/hudwidget.h>
-#include <lib/paintutils.h>
-#include <lib/semanticinfo/sorteddirmodel.h>
-#include <lib/slideshow.h>
-#include <lib/statusbartoolbutton.h>
-#include <lib/thumbnailview/thumbnailbarview.h>
-#include <lib/widgetfloater.h>
-#include <lib/zoomwidget.h>
-
-
-namespace Gwenview {
-
-#undef ENABLE_LOG
-#undef LOG
-//#define ENABLE_LOG
-#ifdef ENABLE_LOG
-#define LOG(x) kDebug() << x
-#else
-#define LOG(x) ;
-#endif
-
-
-const int DocumentPanel::MaxViewCount = 6;
-
-
-static QString rgba(const QColor &color) {
-	return QString::fromAscii("rgba(%1, %2, %3, %4)")
-		.arg(color.red())
-		.arg(color.green())
-		.arg(color.blue())
-		.arg(color.alpha());
-}
-
-
-static QString gradient(Qt::Orientation orientation, const QColor &color, int value) {
-	int x2, y2;
-	if (orientation == Qt::Horizontal) {
-		x2 = 0;
-		y2 = 1;
-	} else {
-		x2 = 1;
-		y2 = 0;
-	}
-	QString grad =
-		"qlineargradient(x1:0, y1:0, x2:%1, y2:%2,"
-		"stop:0 %3, stop: 1 %4)";
-	return grad
-		.arg(x2)
-		.arg(y2)
-		.arg(rgba(PaintUtils::adjustedHsv(color, 0, 0, qMin(255 - color.value(), value/2))))
-		.arg(rgba(PaintUtils::adjustedHsv(color, 0, 0, -qMin(color.value(), value/2))))
-		;
-}
-
-
-/*
- * Layout of mThumbnailSplitter is:
- *
- * +-mThumbnailSplitter--------------------------------+
- * |+-mAdapterContainer-------------------------------+|
- * ||+-mDocumentViews-------++-----------------------+||
- * |||                      ||                       |||
- * |||                      ||                       |||
- * |||                      ||                       |||
- * |||                      ||                       |||
- * |||                      ||                       |||
- * |||                      ||                       |||
- * |||                      ||                       |||
- * |||                      ||                       |||
- * ||+----------------------++-----------------------+||
- * ||+-mStatusBarContainer---------------------------+||
- * |||[mToggleThumbnailBarButton]       [mZoomWidget]|||
- * ||+-----------------------------------------------+||
- * |+-------------------------------------------------+|
- * |===================================================|
- * |+-mThumbnailBar-----------------------------------+|
- * ||                                                 ||
- * ||                                                 ||
- * |+-------------------------------------------------+|
- * +---------------------------------------------------+
- */
-struct DocumentPanelPrivate {
-	DocumentPanel* that;
-	KActionCollection* mActionCollection;
-	QSplitter *mThumbnailSplitter;
-	QWidget* mAdapterContainer;
-	DocumentViewController* mDocumentViewController;
-	QList<DocumentView*> mDocumentViews;
-	QList<HudWidget*> mHuds;
-	DocumentViewSynchronizer* mSynchronizer;
-	QToolButton* mToggleThumbnailBarButton;
-	DocumentViewContainer* mDocumentViewContainer;
-	QWidget* mStatusBarContainer;
-	ThumbnailBarView* mThumbnailBar;
-	KToggleAction* mToggleThumbnailBarAction;
-	KToggleAction* mSynchronizeAction;
-    QCheckBox* mSynchronizeCheckBox;
-
-	bool mFullScreenMode;
-	QPalette mNormalPalette;
-	QPalette mFullScreenPalette;
-	bool mCompareMode;
-	bool mThumbnailBarVisibleBeforeFullScreen;
-
-	void setupThumbnailBar() {
-		mThumbnailBar = new ThumbnailBarView;
-		ThumbnailBarItemDelegate* delegate = new ThumbnailBarItemDelegate(mThumbnailBar);
-		mThumbnailBar->setItemDelegate(delegate);
-		mThumbnailBar->setVisible(GwenviewConfig::thumbnailBarIsVisible());
-		mThumbnailBar->setSelectionMode(QAbstractItemView::ExtendedSelection);
-	}
-
-	void setupThumbnailBarStyleSheet() {
-		Qt::Orientation orientation = mThumbnailBar->orientation();
-		QColor bgColor = mNormalPalette.color(QPalette::Normal, QPalette::Window);
-		QColor bgSelColor = mNormalPalette.color(QPalette::Normal, QPalette::Highlight);
-
-		// Avoid dark and bright colors
-		bgColor.setHsv(bgColor.hue(), bgColor.saturation(), (127 + 3 * bgColor.value()) / 4);
-
-		QColor leftBorderColor = PaintUtils::adjustedHsv(bgColor, 0, 0, qMin(20, 255 - bgColor.value()));
-		QColor rightBorderColor = PaintUtils::adjustedHsv(bgColor, 0, 0, -qMin(40, bgColor.value()));
-		QColor borderSelColor = PaintUtils::adjustedHsv(bgSelColor, 0, 0, -qMin(60, bgSelColor.value()));
-
-		QString viewCss =
-			"#thumbnailBarView {"
-			"	background-color: rgba(0, 0, 0, 10%);"
-			"}";
-
-		QString itemCss =
-			"QListView::item {"
-			"	background-color: %1;"
-			"	border-left: 1px solid %2;"
-			"	border-right: 1px solid %3;"
-			"}";
-		itemCss = itemCss.arg(
-			gradient(orientation, bgColor, 46),
-			gradient(orientation, leftBorderColor, 36),
-			gradient(orientation, rightBorderColor, 26));
-
-		QString itemSelCss =
-			"QListView::item:selected {"
-			"	background-color: %1;"
-			"	border-left: 1px solid %2;"
-			"	border-right: 1px solid %2;"
-			"}";
-		itemSelCss = itemSelCss.arg(
-			gradient(orientation, bgSelColor, 56),
-			rgba(borderSelColor));
-
-		QString css = viewCss + itemCss + itemSelCss;
-		if (orientation == Qt::Vertical) {
-			css.replace("left", "top").replace("right", "bottom");
-		}
-
-		mThumbnailBar->setStyleSheet(css);
-	}
-
-	void setupAdapterContainer() {
-		mAdapterContainer = new QWidget;
-
-		QVBoxLayout* layout = new QVBoxLayout(mAdapterContainer);
-		layout->setMargin(0);
-		layout->setSpacing(0);
-		mDocumentViewContainer = new DocumentViewContainer;
-		mDocumentViewContainer->setAutoFillBackground(true);
-		mDocumentViewContainer->setBackgroundRole(QPalette::Base);
-		Q_FOREACH(DocumentView* view, mDocumentViews) {
-			mDocumentViewContainer->addView(view);
-		}
-		layout->addWidget(mDocumentViewContainer);
-		layout->addWidget(mStatusBarContainer);
-	}
-
-	void setupDocumentView(SlideShow* slideShow) {
-		mDocumentViewController = new DocumentViewController(mActionCollection, that);
-
-		ZoomWidget* zoomWidget = new ZoomWidget(that);
-		mDocumentViewController->setZoomWidget(zoomWidget);
-
-		for (int idx=0; idx < DocumentPanel::MaxViewCount; ++idx) {
-			DocumentView* view = new DocumentView(0, mActionCollection);
-
-			// Connect context menu
-			view->setContextMenuPolicy(Qt::CustomContextMenu);
-			QObject::connect(view, SIGNAL(customContextMenuRequested(const QPoint&)),
-				that, SLOT(showContextMenu()) );
-
-			QObject::connect(view, SIGNAL(completed()),
-				that, SIGNAL(completed()) );
-			QObject::connect(view, SIGNAL(previousImageRequested()),
-				that, SIGNAL(previousImageRequested()) );
-			QObject::connect(view, SIGNAL(nextImageRequested()),
-				that, SIGNAL(nextImageRequested()) );
-			QObject::connect(view, SIGNAL(captionUpdateRequested(const QString&)),
-				that, SIGNAL(captionUpdateRequested(const QString&)) );
-			QObject::connect(view, SIGNAL(toggleFullScreenRequested()),
-				that, SIGNAL(toggleFullScreenRequested()) );
-			QObject::connect(view, SIGNAL(focused(DocumentView*)),
-				that, SLOT(slotViewFocused(DocumentView*)) );
-
-			QObject::connect(view, SIGNAL(videoFinished()),
-				slideShow, SLOT(resumeAndGoToNextUrl()));
-
-			mDocumentViews << view;
-		}
-
-		mSynchronizer = new DocumentViewSynchronizer(that);
-	}
-
-	QToolButton* createHudButton(const QString& text, const char* iconName, bool showText) {
-		QToolButton* button = new QToolButton;
-		if (showText) {
-			button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
-			button->setText(text);
-		} else {
-			button->setToolTip(text);
-		}
-		button->setIcon(SmallIcon(iconName));
-		return button;
-	}
-
-	void setupViewHud(DocumentView* view) {
-		QToolButton* trashButton = createHudButton(i18n("Trash"), "user-trash", false);
-		QToolButton* deselectButton = createHudButton(i18n("Deselect"), "list-remove", true);
-
-		QWidget* content = new QWidget;
-		QHBoxLayout* layout = new QHBoxLayout(content);
-		layout->setMargin(0);
-		layout->setSpacing(4);
-		layout->addWidget(trashButton);
-		layout->addWidget(deselectButton);
-
-		HudWidget* hud = new HudWidget;
-		hud->init(content, HudWidget::OptionNone);
-		WidgetFloater* floater = new WidgetFloater(view);
-		floater->setChildWidget(hud);
-		floater->setAlignment(Qt::AlignBottom | Qt::AlignHCenter);
-
-		Binder<DocumentPanel, DocumentView*>::bind(trashButton, SIGNAL(clicked()), that, &DocumentPanel::trashView, view);
-		Binder<DocumentPanel, DocumentView*>::bind(deselectButton, SIGNAL(clicked()), that, &DocumentPanel::deselectView, view);
-
-		mHuds.append(hud);
-	}
-
-	void setupHuds() {
-		Q_FOREACH(DocumentView* view, mDocumentViews) {
-			setupViewHud(view);
-		}
-	}
-
-	void setupStatusBar() {
-		mStatusBarContainer = new QWidget;
-		mToggleThumbnailBarButton = new StatusBarToolButton;
-		mSynchronizeCheckBox = new QCheckBox(i18n("Synchronize"));
-		mSynchronizeCheckBox->hide();
-
-		QHBoxLayout* layout = new QHBoxLayout(mStatusBarContainer);
-		layout->setMargin(0);
-		layout->setSpacing(0);
-		layout->addWidget(mToggleThumbnailBarButton);
-		layout->addStretch();
-		layout->addWidget(mSynchronizeCheckBox);
-		layout->addStretch();
-		layout->addWidget(mDocumentViewController->zoomWidget());
-	}
-
-	void setupSplitter() {
-		Qt::Orientation orientation = GwenviewConfig::thumbnailBarOrientation();
-		mThumbnailSplitter = new Splitter(orientation == Qt::Horizontal ? Qt::Vertical : Qt::Horizontal, that);
-		mThumbnailBar->setOrientation(orientation);
-		mThumbnailBar->setRowCount(GwenviewConfig::thumbnailBarRowCount());
-		mThumbnailSplitter->addWidget(mAdapterContainer);
-		mThumbnailSplitter->addWidget(mThumbnailBar);
-		mThumbnailSplitter->setSizes(GwenviewConfig::thumbnailSplitterSizes());
-
-		QVBoxLayout* layout = new QVBoxLayout(that);
-		layout->setMargin(0);
-		layout->addWidget(mThumbnailSplitter);
-	}
-
-	void applyPalette() {
-		QPalette palette = mFullScreenMode ? mFullScreenPalette : mNormalPalette;
-		mDocumentViewContainer->setPalette(palette);
-	}
-
-	void saveSplitterConfig() {
-		if (mThumbnailBar->isVisible()) {
-			GwenviewConfig::setThumbnailSplitterSizes(mThumbnailSplitter->sizes());
-		}
-	}
-
-	DocumentView* currentView() const {
-		return mDocumentViewController->view();
-	}
-
-	void setCurrentView(DocumentView* view) {
-		DocumentView* oldView = currentView();
-		if (view == oldView) {
-			return;
-		}
-		if (oldView) {
-			oldView->setCurrent(false);
-		}
-		view->setCurrent(true);
-		mDocumentViewController->setView(view);
-		mSynchronizer->setCurrentView(view);
-
-		QModelIndex index = indexForView(view);
-		if (!index.isValid()) {
-			kWarning() << "No index found for current view";
-			return;
-		}
-		mThumbnailBar->selectionModel()->setCurrentIndex(index, QItemSelectionModel::Current);
-	}
-
-	QModelIndex indexForView(DocumentView* view) const {
-		KUrl url = view->url();
-		if (!url.isValid()) {
-			kWarning() << "View does not display any document!";
-			return QModelIndex();
-		}
-
-		// FIXME: Ugly coupling!
-		SortedDirModel* model = static_cast<SortedDirModel*>(mThumbnailBar->model());
-		return model->indexForUrl(url);
-	}
-};
-
-
-DocumentPanel::DocumentPanel(QWidget* parent, SlideShow* slideShow, KActionCollection* actionCollection)
-: QWidget(parent)
-, d(new DocumentPanelPrivate)
-{
-	d->that = this;
-	d->mActionCollection = actionCollection;
-	d->mFullScreenMode = false;
-	d->mCompareMode = false;
-	d->mThumbnailBarVisibleBeforeFullScreen = false;
-	d->mFullScreenPalette = QPalette(palette());
-	d->mFullScreenPalette.setColor(QPalette::Base, Qt::black);
-	d->mFullScreenPalette.setColor(QPalette::Text, Qt::white);
-
-	QShortcut* toggleFullScreenShortcut = new QShortcut(this);
-	toggleFullScreenShortcut->setKey(Qt::Key_Return);
-	connect(toggleFullScreenShortcut, SIGNAL(activated()), SIGNAL(toggleFullScreenRequested()) );
-
-	d->setupDocumentView(slideShow);
-
-	d->setupHuds();
-
-	d->setupStatusBar();
-
-	d->setupAdapterContainer();
-
-	d->setupThumbnailBar();
-
-	d->setupSplitter();
-
-	KActionCategory* view = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface","View"), actionCollection);
-
-	d->mToggleThumbnailBarAction = view->add<KToggleAction>(QString("toggle_thumbnailbar"));
-	d->mToggleThumbnailBarAction->setText(i18n("Thumbnail Bar"));
-	d->mToggleThumbnailBarAction->setIcon(KIcon("folder-image"));
-	d->mToggleThumbnailBarAction->setShortcut(Qt::CTRL | Qt::Key_B);
-	d->mToggleThumbnailBarAction->setChecked(GwenviewConfig::thumbnailBarIsVisible());
-	connect(d->mToggleThumbnailBarAction, SIGNAL(triggered(bool)),
-		this, SLOT(setThumbnailBarVisibility(bool)) );
-	d->mToggleThumbnailBarButton->setDefaultAction(d->mToggleThumbnailBarAction);
-
-	d->mSynchronizeAction = view->add<KToggleAction>("synchronize_views");
-	d->mSynchronizeAction->setText(i18n("Synchronize"));
-	d->mSynchronizeAction->setShortcut(Qt::CTRL | Qt::Key_Y);
-	connect(d->mSynchronizeAction, SIGNAL(toggled(bool)),
-		d->mSynchronizer, SLOT(setActive(bool)));
-	// Ensure mSynchronizeAction and mSynchronizeCheckBox are in sync
-	connect(d->mSynchronizeAction, SIGNAL(toggled(bool)),
-		d->mSynchronizeCheckBox, SLOT(setChecked(bool)));
-	connect(d->mSynchronizeCheckBox, SIGNAL(toggled(bool)),
-		d->mSynchronizeAction, SLOT(setChecked(bool)));
-}
-
-
-DocumentPanel::~DocumentPanel() {
-	delete d;
-}
-
-
-void DocumentPanel::loadConfig() {
-	// FIXME: Not symetric with saveConfig(). Check if it matters.
-	Q_FOREACH(DocumentView* view, d->mDocumentViews) {
-		if (view->adapter()) {
-			view->adapter()->loadConfig();
-		}
-	}
-
-	Qt::Orientation orientation = GwenviewConfig::thumbnailBarOrientation();
-	d->mThumbnailSplitter->setOrientation(orientation == Qt::Horizontal ? Qt::Vertical : Qt::Horizontal);
-	d->mThumbnailBar->setOrientation(orientation);
-	d->setupThumbnailBarStyleSheet();
-
-	int oldRowCount = d->mThumbnailBar->rowCount();
-	int newRowCount = GwenviewConfig::thumbnailBarRowCount();
-	if (oldRowCount != newRowCount) {
-		d->mThumbnailBar->setUpdatesEnabled(false);
-		int gridSize = d->mThumbnailBar->gridSize().width();
-
-		d->mThumbnailBar->setRowCount(newRowCount);
-
-		// Adjust splitter to ensure thumbnail size remains the same
-		int delta = (newRowCount - oldRowCount) * gridSize;
-		QList<int> sizes = d->mThumbnailSplitter->sizes();
-		Q_ASSERT(sizes.count() == 2);
-		sizes[0] -= delta;
-		sizes[1] += delta;
-		d->mThumbnailSplitter->setSizes(sizes);
-
-		d->mThumbnailBar->setUpdatesEnabled(true);
-	}
-}
-
-
-void DocumentPanel::saveConfig() {
-	d->saveSplitterConfig();
-	GwenviewConfig::setThumbnailBarIsVisible(d->mToggleThumbnailBarAction->isChecked());
-}
-
-
-void DocumentPanel::setThumbnailBarVisibility(bool visible) {
-	d->saveSplitterConfig();
-	d->mThumbnailBar->setVisible(visible);
-}
-
-
-int DocumentPanel::statusBarHeight() const {
-	return d->mStatusBarContainer->height();
-}
-
-
-void DocumentPanel::setFullScreenMode(bool fullScreenMode) {
-	d->mFullScreenMode = fullScreenMode;
-	d->mStatusBarContainer->setVisible(!fullScreenMode);
-	d->applyPalette();
-	if (fullScreenMode) {
-		d->mThumbnailBarVisibleBeforeFullScreen = d->mToggleThumbnailBarAction->isChecked();
-		if (d->mThumbnailBarVisibleBeforeFullScreen) {
-			d->mToggleThumbnailBarAction->trigger();
-		}
-	} else if (d->mThumbnailBarVisibleBeforeFullScreen) {
-		d->mToggleThumbnailBarAction->trigger();
-	}
-	d->mToggleThumbnailBarAction->setEnabled(!fullScreenMode);
-}
-
-
-bool DocumentPanel::isFullScreenMode() const {
-	return d->mFullScreenMode;
-}
-
-
-ThumbnailBarView* DocumentPanel::thumbnailBar() const {
-	return d->mThumbnailBar;
-}
-
-
-inline void addActionToMenu(KMenu* menu, KActionCollection* actionCollection, const char* name) {
-	QAction* action = actionCollection->action(name);
-	if (action) {
-		menu->addAction(action);
-	}
-}
-
-
-void DocumentPanel::showContextMenu() {
-	KMenu menu(this);
-	addActionToMenu(&menu, d->mActionCollection, "fullscreen");
-	menu.addSeparator();
-	addActionToMenu(&menu, d->mActionCollection, "go_previous");
-	addActionToMenu(&menu, d->mActionCollection, "go_next");
-	if (d->currentView()->adapter()->canZoom()) {
-		menu.addSeparator();
-		addActionToMenu(&menu, d->mActionCollection, "view_actual_size");
-		addActionToMenu(&menu, d->mActionCollection, "view_zoom_to_fit");
-		addActionToMenu(&menu, d->mActionCollection, "view_zoom_in");
-		addActionToMenu(&menu, d->mActionCollection, "view_zoom_out");
-	}
-	if (d->mCompareMode) {
-		menu.addSeparator();
-		addActionToMenu(&menu, d->mActionCollection, "synchronize_views");
-	}
-
-	menu.addSeparator();
-	addActionToMenu(&menu, d->mActionCollection, "file_copy_to");
-	addActionToMenu(&menu, d->mActionCollection, "file_move_to");
-	addActionToMenu(&menu, d->mActionCollection, "file_link_to");
-	menu.addSeparator();
-	addActionToMenu(&menu, d->mActionCollection, "file_open_with");
-	menu.exec(QCursor::pos());
-}
-
-
-QSize DocumentPanel::sizeHint() const {
-	return QSize(400, 300);
-}
-
-
-KUrl DocumentPanel::url() const {
-	if (!d->currentView()) {
-		LOG("!d->documentView()");
-		return KUrl();
-	}
-
-	return d->currentView()->url();
-}
-
-
-Document::Ptr DocumentPanel::currentDocument() const {
-	if (!d->currentView()) {
-		LOG("!d->documentView()");
-		return Document::Ptr();
-	}
-
-	return d->currentView()->document();
-}
-
-
-bool DocumentPanel::isEmpty() const {
-	if (!d->currentView()) {
-		return true;
-	}
-	return d->currentView()->isEmpty();
-}
-
-
-ImageView* DocumentPanel::imageView() const {
-	return d->currentView()->adapter()->imageView();
-}
-
-
-DocumentView* DocumentPanel::documentView() const {
-	return d->currentView();
-}
-
-
-void DocumentPanel::setNormalPalette(const QPalette& palette) {
-	d->mNormalPalette = palette;
-	d->applyPalette();
-	d->setupThumbnailBarStyleSheet();
-}
-
-
-void DocumentPanel::openUrl(const KUrl& url) {
-	openUrls(KUrl::List() << url, url);
-}
-
-
-void DocumentPanel::openUrls(const KUrl::List& urls, const KUrl& currentUrl) {
-	d->mCompareMode = urls.count() > 1;
-	QList<DocumentView*> visibleViews;
-
-	// Get a list of available views and urls we are not already displaying
-	QSet<KUrl> notDisplayedUrls = urls.toSet();
-	QList<DocumentView*> availableViews;
-	Q_FOREACH(DocumentView* view, d->mDocumentViews) {
-		KUrl url = view->url();
-		if (notDisplayedUrls.contains(url)) {
-			// view displays an url we must display, keep it
-			notDisplayedUrls.remove(url);
-			view->setCompareMode(d->mCompareMode);
-			if (url == currentUrl) {
-				d->setCurrentView(view);
-			} else {
-				view->setCurrent(false);
-			}
-			visibleViews.append(view);
-		} else {
-			// view url is not interesting, prepare to reuse it
-			availableViews.append(view);
-		}
-	}
-
-	// Show urls to display in available views
-	Q_FOREACH(const KUrl& url, notDisplayedUrls) {
-		if (availableViews.isEmpty()) {
-			kWarning() << "No room to load" << url << ". This should not happen";
-			break;
-		}
-		DocumentView* view = availableViews.takeFirst();
-		view->openUrl(url);
-		view->setCompareMode(d->mCompareMode);
-		if (url == currentUrl) {
-			d->setCurrentView(view);
-		} else {
-			view->setCurrent(false);
-		}
-		visibleViews.append(view);
-		view->show();
-	}
-
-	// Hide remaining available views
-	Q_FOREACH(DocumentView* view, availableViews) {
-		view->reset();
-		view->hide();
-	}
-
-	Q_FOREACH(HudWidget* hud, d->mHuds) {
-		hud->setVisible(d->mCompareMode);
-		if (d->mCompareMode) {
-			hud->raise();
-		}
-	}
-	d->mSynchronizeCheckBox->setVisible(d->mCompareMode);
-	if (d->mCompareMode) {
-		d->mSynchronizer->setDocumentViews(visibleViews);
-		d->mSynchronizer->setActive(d->mSynchronizeCheckBox->isChecked());
-	} else {
-		d->mSynchronizer->setActive(false);
-	}
-}
-
-
-void DocumentPanel::reload() {
-	Document::Ptr doc = d->currentView()->document();
-	if (!doc) {
-		kWarning() << "!doc";
-		return;
-	}
-	if (doc->isModified()) {
-		KGuiItem cont = KStandardGuiItem::cont();
-		cont.setText(i18nc("@action:button", "Discard Changes and Reload"));
-		int answer = KMessageBox::warningContinueCancel(this,
-			i18nc("@info", "This image has been modified. Reloading it will discard all your changes."),
-			QString() /* caption */,
-			cont);
-		if (answer != KMessageBox::Continue) {
-			return;
-		}
-	}
-	doc->reload();
-	// Call openUrl again because DocumentView may need to switch to a new
-	// adapter (for example because document was broken and it is not anymore)
-	d->currentView()->openUrl(doc->url());
-}
-
-
-void DocumentPanel::reset() {
-	int idx = 0;
-	Q_FOREACH(DocumentView* view, d->mDocumentViews) {
-		view->reset();
-		if (idx > 0) {
-			view->hide();
-		}
-		++idx;
-	}
-}
-
-void DocumentPanel::slotViewFocused(DocumentView* view) {
-	d->setCurrentView(view);
-}
-
-
-void DocumentPanel::trashView(DocumentView* view) {
-	KUrl url = view->url();
-	deselectView(view);
-	FileOperations::trash(KUrl::List() << url, this);
-}
-
-
-void DocumentPanel::deselectView(DocumentView* view) {
-	DocumentView* newCurrentView = 0;
-	if (view == d->currentView()) {
-		// We need to find a new view to set as current
-		int idx = d->mDocumentViews.indexOf(view);
-		// Look for the next visible view after the current one
-		for (int newIdx = idx + 1; newIdx < d->mDocumentViews.count(); ++newIdx) {
-			if (d->mDocumentViews.at(newIdx)->isVisible()) {
-				newCurrentView = d->mDocumentViews.at(newIdx);
-				break;
-			}
-		}
-		if (!newCurrentView) {
-			// No visible view found after the current one, look before
-			for (int newIdx = idx - 1; newIdx >= 0; --newIdx) {
-				if (d->mDocumentViews.at(newIdx)->isVisible()) {
-					newCurrentView = d->mDocumentViews.at(newIdx);
-					break;
-				}
-			}
-		}
-		if (!newCurrentView) {
-			kWarning() << "No view found to set as current, this should not happen!";
-		}
-	}
-
-	QModelIndex index = d->indexForView(view);
-	QItemSelectionModel* selectionModel = d->mThumbnailBar->selectionModel();
-	selectionModel->select(index, QItemSelectionModel::Deselect);
-
-	if (newCurrentView) {
-		d->setCurrentView(newCurrentView);
-	}
-}
-
-
-} // namespace

=== removed file 'app/documentpanel.h'
--- app/documentpanel.h	2011-07-20 13:46:34 +0000
+++ app/documentpanel.h	1970-01-01 00:00:00 +0000
@@ -1,137 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef DOCUMENTPANEL_H
-#define DOCUMENTPANEL_H
-
-// Local
-#include <lib/document/document.h>
-
-// KDE
-#include <kurl.h>
-
-// Qt
-#include <QWidget>
-
-class QPalette;
-
-class KActionCollection;
-
-namespace Gwenview {
-
-class DocumentView;
-class ImageView;
-class SlideShow;
-class ThumbnailBarView;
-
-struct DocumentPanelPrivate;
-
-/**
- * Holds the active document view and associated widgetry.
- */
-class DocumentPanel : public QWidget {
-	Q_OBJECT
-public:
-	static const int MaxViewCount;
-
-	DocumentPanel(QWidget* parent, SlideShow*, KActionCollection*);
-	~DocumentPanel();
-
-	ThumbnailBarView* thumbnailBar() const;
-
-	void loadConfig();
-
-	void saveConfig();
-
-	/**
-	 * Reset the view
-	 */
-	void reset();
-
-	void setFullScreenMode(bool fullScreen);
-
-	bool isFullScreenMode() const;
-
-	void setNormalPalette(const QPalette&);
-
-	int statusBarHeight() const;
-
-	virtual QSize sizeHint() const;
-
-	/**
-	 * Returns the url of the current document, or an invalid url if unknown
-	 */
-	KUrl url() const;
-
-	void openUrl(const KUrl& url);
-
-	/**
-	 * Opens up to MaxViewCount urls, and set currentUrl as the current one
-	 */
-	void openUrls(const KUrl::List& urls, const KUrl& currentUrl);
-
-	void reload();
-
-	Document::Ptr currentDocument() const;
-
-	bool isEmpty() const;
-
-	/**
-	 * Returns the image view, if the current adapter has one.
-	 */
-	ImageView* imageView() const;
-
-	/**
-	 * Returns the document view
-	 */
-	DocumentView* documentView() const;
-
-Q_SIGNALS:
-
-	/**
-	 * Emitted when the part has finished loading
-	 */
-	void completed();
-
-	void previousImageRequested();
-
-	void nextImageRequested();
-
-	void toggleFullScreenRequested();
-
-	void captionUpdateRequested(const QString&);
-
-private Q_SLOTS:
-	void setThumbnailBarVisibility(bool visible);
-
-	void showContextMenu();
-
-	void slotViewFocused(DocumentView*);
-
-	void trashView(Gwenview::DocumentView*);
-	void deselectView(DocumentView*);
-
-private:
-	friend struct DocumentPanelPrivate;
-	DocumentPanelPrivate* const d;
-};
-
-} // namespace
-
-#endif /* DOCUMENTPANEL_H */

=== modified file 'app/fileoperations.cpp'
--- app/fileoperations.cpp	2011-07-20 13:46:34 +0000
+++ app/fileoperations.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -40,173 +40,175 @@
 #include <lib/document/documentfactory.h>
 #include <lib/thumbnailloadjob.h>
 
-namespace Gwenview {
-
-namespace FileOperations {
-
-static void copyMoveOrLink(KonqOperations::Operation operation, const KUrl::List& urlList, QWidget* parent) {
-	Q_ASSERT(urlList.count() > 0);
-
-	KFileDialog dialog(
-		KUrl("kfiledialog:///<copyMoveOrLink>"),
-		QString() /* filter */,
-		parent);
-	dialog.setOperationMode(KFileDialog::Saving);
-	switch (operation) {
-	case KonqOperations::COPY:
-		dialog.setCaption(i18nc("@title:window", "Copy To"));
-		dialog.okButton()->setText(i18nc("@action:button", "Copy"));
-		break;
-	case KonqOperations::MOVE:
-		dialog.setCaption(i18nc("@title:window", "Move To"));
-		dialog.okButton()->setText(i18nc("@action:button", "Move"));
-		break;
-	case KonqOperations::LINK:
-		dialog.setCaption(i18nc("@title:window", "Link To"));
-		dialog.okButton()->setText(i18nc("@action:button", "Link"));
-		break;
-	default:
-		Q_ASSERT(0);
-	}
-	if (urlList.count() == 1) {
-		dialog.setMode(KFile::File);
-		dialog.setSelection(urlList[0].fileName());
-	} else {
-		dialog.setMode(KFile::ExistingOnly | KFile::Directory);
-	}
-	if (!dialog.exec()) {
-		return;
-	}
-
-	KUrl destUrl = dialog.selectedUrl();
-	KonqOperations::copy(parent, operation, urlList, destUrl);
-}
-
-
-static void delOrTrash(KonqOperations::Operation operation, const KUrl::List& urlList, QWidget* parent) {
-	Q_ASSERT(urlList.count() > 0);
-
-	if (!KonqOperations::askDeleteConfirmation(urlList, operation, KonqOperations::DEFAULT_CONFIRMATION, parent)) {
-		return;
-	}
-
-	KIO::Job* job = 0;
-	// KonqOperations::delOrTrash() handles the confirmation and does not provide
-	// a way to know if the deletion has been accepted.
-	// We need to know about the confirmation so that DocumentFactory can forget
-	// about the deleted urls. That's why we can't use KonqOperations::delOrTrash()
-	switch (operation) {
-	case KonqOperations::TRASH:
-		job = KIO::trash(urlList);
-		break;
-
-	case KonqOperations::DEL:
-		job = KIO::del(urlList);
-		break;
-
-	default:
-		kWarning() << "Unknown operation" << operation;
-		return;
-	}
-	Q_ASSERT(job);
-	job->ui()->setWindow(parent);
-
-	Q_FOREACH(const KUrl& url, urlList) {
-		DocumentFactory::instance()->forget(url);
-	}
-}
-
-
-void copyTo(const KUrl::List& urlList, QWidget* parent) {
-	copyMoveOrLink(KonqOperations::COPY, urlList, parent);
-}
-
-
-void moveTo(const KUrl::List& urlList, QWidget* parent) {
-	copyMoveOrLink(KonqOperations::MOVE, urlList, parent);
-}
-
-
-void linkTo(const KUrl::List& urlList, QWidget* parent) {
-	copyMoveOrLink(KonqOperations::LINK, urlList, parent);
-}
-
-
-void trash(const KUrl::List& urlList, QWidget* parent) {
-	delOrTrash(KonqOperations::TRASH, urlList, parent);
-}
-
-
-void del(const KUrl::List& urlList, QWidget* parent) {
-	delOrTrash(KonqOperations::DEL, urlList, parent);
-}
-
-
-void showMenuForDroppedUrls(QWidget* parent, const KUrl::List& urlList, const KUrl& destUrl) {
-	if (urlList.isEmpty()) {
-		kWarning() << "urlList is empty!";
-		return;
-	}
-
-	if (!destUrl.isValid()) {
-		kWarning() << "destUrl is not valid!";
-		return;
-	}
-
-	KMenu menu(parent);
-	QAction* moveAction = menu.addAction(
-		KIcon("go-jump"),
-		i18n("Move Here"));
-	QAction* copyAction = menu.addAction(
-		KIcon("edit-copy"),
-		i18n("Copy Here"));
-	QAction* linkAction = menu.addAction(
-		KIcon("edit-link"),
-		i18n("Link Here"));
-	menu.addSeparator();
-	menu.addAction(
-		KIcon("process-stop"),
-		i18n("Cancel"));
-
-	QAction* action = menu.exec(QCursor::pos());
-
-	KIO::Job* job = 0;
-	if (action == moveAction) {
-		job = KIO::move(urlList, destUrl);
-	} else if (action == copyAction) {
-		job = KIO::copy(urlList, destUrl);
-	} else if (action == linkAction) {
-		job = KIO::link(urlList, destUrl);
-	} else {
-		return;
-	}
-	Q_ASSERT(job);
-	job->ui()->setWindow(parent);
-}
-
-
-void rename(const KUrl& oldUrl, QWidget* parent) {
-	QString name = KInputDialog::getText(
-		i18nc("@title:window", "Rename") /* caption */,
-		i18n("Rename <filename>%1</filename> to:", oldUrl.fileName()) /* label */,
-		oldUrl.fileName() /* value */,
-		0 /* ok */,
-		parent
-		);
-	if (name.isEmpty() || name == oldUrl.fileName()) {
-		return;
-	}
-
-	KUrl newUrl = oldUrl;
-	newUrl.setFileName(name);
-	KIO::SimpleJob* job = KIO::rename(oldUrl, newUrl, KIO::HideProgressInfo);
-	if (!KIO::NetAccess::synchronousRun(job, parent)) {
-		job->ui()->showErrorMessage();
-		return;
-	}
-	ThumbnailLoadJob::moveThumbnail(oldUrl, newUrl);
-}
-
+namespace Gwenview
+{
+
+namespace FileOperations
+{
+
+static void copyMoveOrLink(KonqOperations::Operation operation, const KUrl::List& urlList, QWidget* parent)
+{
+    Q_ASSERT(urlList.count() > 0);
+
+    KFileDialog dialog(
+        KUrl("kfiledialog:///<copyMoveOrLink>"),
+        QString() /* filter */,
+        parent);
+    dialog.setOperationMode(KFileDialog::Saving);
+    switch (operation) {
+    case KonqOperations::COPY:
+        dialog.setCaption(i18nc("@title:window", "Copy To"));
+        dialog.okButton()->setText(i18nc("@action:button", "Copy"));
+        break;
+    case KonqOperations::MOVE:
+        dialog.setCaption(i18nc("@title:window", "Move To"));
+        dialog.okButton()->setText(i18nc("@action:button", "Move"));
+        break;
+    case KonqOperations::LINK:
+        dialog.setCaption(i18nc("@title:window", "Link To"));
+        dialog.okButton()->setText(i18nc("@action:button", "Link"));
+        break;
+    default:
+        Q_ASSERT(0);
+    }
+    if (urlList.count() == 1) {
+        dialog.setMode(KFile::File);
+        dialog.setSelection(urlList[0].fileName());
+    } else {
+        dialog.setMode(KFile::ExistingOnly | KFile::Directory);
+    }
+    if (!dialog.exec()) {
+        return;
+    }
+
+    KUrl destUrl = dialog.selectedUrl();
+    KonqOperations::copy(parent, operation, urlList, destUrl);
+}
+
+static void delOrTrash(KonqOperations::Operation operation, const KUrl::List& urlList, QWidget* parent)
+{
+    Q_ASSERT(urlList.count() > 0);
+
+    if (!KonqOperations::askDeleteConfirmation(urlList, operation, KonqOperations::DEFAULT_CONFIRMATION, parent)) {
+        return;
+    }
+
+    KIO::Job* job = 0;
+    // KonqOperations::delOrTrash() handles the confirmation and does not provide
+    // a way to know if the deletion has been accepted.
+    // We need to know about the confirmation so that DocumentFactory can forget
+    // about the deleted urls. That's why we can't use KonqOperations::delOrTrash()
+    switch (operation) {
+    case KonqOperations::TRASH:
+        job = KIO::trash(urlList);
+        break;
+
+    case KonqOperations::DEL:
+        job = KIO::del(urlList);
+        break;
+
+    default:
+        kWarning() << "Unknown operation" << operation;
+        return;
+    }
+    Q_ASSERT(job);
+    job->ui()->setWindow(parent);
+
+    Q_FOREACH(const KUrl & url, urlList) {
+        DocumentFactory::instance()->forget(url);
+    }
+}
+
+void copyTo(const KUrl::List& urlList, QWidget* parent)
+{
+    copyMoveOrLink(KonqOperations::COPY, urlList, parent);
+}
+
+void moveTo(const KUrl::List& urlList, QWidget* parent)
+{
+    copyMoveOrLink(KonqOperations::MOVE, urlList, parent);
+}
+
+void linkTo(const KUrl::List& urlList, QWidget* parent)
+{
+    copyMoveOrLink(KonqOperations::LINK, urlList, parent);
+}
+
+void trash(const KUrl::List& urlList, QWidget* parent)
+{
+    delOrTrash(KonqOperations::TRASH, urlList, parent);
+}
+
+void del(const KUrl::List& urlList, QWidget* parent)
+{
+    delOrTrash(KonqOperations::DEL, urlList, parent);
+}
+
+void showMenuForDroppedUrls(QWidget* parent, const KUrl::List& urlList, const KUrl& destUrl)
+{
+    if (urlList.isEmpty()) {
+        kWarning() << "urlList is empty!";
+        return;
+    }
+
+    if (!destUrl.isValid()) {
+        kWarning() << "destUrl is not valid!";
+        return;
+    }
+
+    KMenu menu(parent);
+    QAction* moveAction = menu.addAction(
+                              KIcon("go-jump"),
+                              i18n("Move Here"));
+    QAction* copyAction = menu.addAction(
+                              KIcon("edit-copy"),
+                              i18n("Copy Here"));
+    QAction* linkAction = menu.addAction(
+                              KIcon("edit-link"),
+                              i18n("Link Here"));
+    menu.addSeparator();
+    menu.addAction(
+        KIcon("process-stop"),
+        i18n("Cancel"));
+
+    QAction* action = menu.exec(QCursor::pos());
+
+    KIO::Job* job = 0;
+    if (action == moveAction) {
+        job = KIO::move(urlList, destUrl);
+    } else if (action == copyAction) {
+        job = KIO::copy(urlList, destUrl);
+    } else if (action == linkAction) {
+        job = KIO::link(urlList, destUrl);
+    } else {
+        return;
+    }
+    Q_ASSERT(job);
+    job->ui()->setWindow(parent);
+}
+
+void rename(const KUrl& oldUrl, QWidget* parent)
+{
+    QString name = KInputDialog::getText(
+                       i18nc("@title:window", "Rename") /* caption */,
+                       i18n("Rename <filename>%1</filename> to:", oldUrl.fileName()) /* label */,
+                       oldUrl.fileName() /* value */,
+                       0 /* ok */,
+                       parent
+                   );
+    if (name.isEmpty() || name == oldUrl.fileName()) {
+        return;
+    }
+
+    KUrl newUrl = oldUrl;
+    newUrl.setFileName(name);
+    KIO::SimpleJob* job = KIO::rename(oldUrl, newUrl, KIO::HideProgressInfo);
+    if (!KIO::NetAccess::synchronousRun(job, parent)) {
+        job->ui()->showErrorMessage();
+        return;
+    }
+    ThumbnailLoadJob::moveThumbnail(oldUrl, newUrl);
+}
 
 } // namespace
 

=== modified file 'app/fileoperations.h'
--- app/fileoperations.h	2011-07-20 13:46:34 +0000
+++ app/fileoperations.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -25,9 +25,11 @@
 
 class QWidget;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace FileOperations {
+namespace FileOperations
+{
 
 void copyTo(const KUrl::List& urlList, QWidget* parent);
 void moveTo(const KUrl::List& urlList, QWidget* parent);

=== modified file 'app/fileopscontextmanageritem.cpp'
--- app/fileopscontextmanageritem.cpp	2011-07-20 13:46:34 +0000
+++ app/fileopscontextmanageritem.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -55,398 +55,397 @@
 #include "fileoperations.h"
 #include "sidebar.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct FileOpsContextManagerItemPrivate {
-	FileOpsContextManagerItem* mContextManagerItem;
-	QListView* mThumbnailView;
-	KXMLGUIClient* mXMLGUIClient;
-	SideBarGroup* mGroup;
-	KAction* mCutAction;
-	KAction* mCopyAction;
-	KAction* mPasteAction;
-	KAction* mCopyToAction;
-	KAction* mMoveToAction;
-	KAction* mLinkToAction;
-	KAction* mRenameAction;
-	KAction* mTrashAction;
-	KAction* mDelAction;
-	KAction* mRestoreAction;
-	KAction* mShowPropertiesAction;
-	KAction* mCreateFolderAction;
-	KAction* mOpenWithAction;
-	QList<QAction*> mRegularFileActionList;
-	QList<QAction*> mTrashFileActionList;
-	QMap<QString, KService::Ptr> mServiceForName;
-	bool mInTrash;
-
-	KUrl::List urlList() const {
-		KUrl::List urlList;
-
-		KFileItemList list = mContextManagerItem->contextManager()->selectedFileItemList();
-		if (list.count() > 0) {
-			urlList = list.urlList();
-		} else {
-			KUrl url = mContextManagerItem->contextManager()->currentUrl();
-			Q_ASSERT(url.isValid());
-			urlList << url;
-		}
-		return urlList;
-	}
-
-
-	void updateServiceForName() {
-		// This code is inspired from
-		// kdebase/apps/lib/konq/konq_menuactions.cpp
-
-		// Get list of all distinct mimetypes in selection
-		QStringList mimeTypes;
-		Q_FOREACH(const KFileItem& item, mContextManagerItem->contextManager()->selectedFileItemList()) {
-			const QString mimeType = item.mimetype();
-			if (!mimeTypes.contains(mimeType)) {
-				mimeTypes << mimeType;
-			}
-		}
-
-		// Query trader
-		const QString firstMimeType = mimeTypes.takeFirst();
-		const QString constraintTemplate = "'%1' in ServiceTypes";
-		QStringList constraints;
-		Q_FOREACH(const QString& mimeType, mimeTypes) {
-			constraints << constraintTemplate.arg(mimeType);
-		}
-
-		KService::List services = KMimeTypeTrader::self()->query(
-			firstMimeType, "Application",
-			constraints.join(" and "));
-
-		// Update map
-		mServiceForName.clear();
-		Q_FOREACH(const KService::Ptr &service, services) {
-			mServiceForName[service->name()] = service;
-		}
-	}
-
-
-	QMimeData* selectionMimeData() {
-		QMimeData* mimeData = new QMimeData;
-		KFileItemList list = mContextManagerItem->contextManager()->selectedFileItemList();
-		list.urlList().populateMimeData(mimeData);
-		return mimeData;
-	}
-
-
-	KUrl pasteTargetUrl() const {
-		// If only one folder is selected, paste inside it, otherwise paste in
-		// current
-		KFileItemList list = mContextManagerItem->contextManager()->selectedFileItemList();
-		if (list.count() == 1 && list.first().isDir()) {
-			return list.first().url();
-		} else {
-			return mContextManagerItem->contextManager()->currentDirUrl();
-		}
-	}
+    FileOpsContextManagerItem* q;
+    QListView* mThumbnailView;
+    KXMLGUIClient* mXMLGUIClient;
+    SideBarGroup* mGroup;
+    KAction* mCutAction;
+    KAction* mCopyAction;
+    KAction* mPasteAction;
+    KAction* mCopyToAction;
+    KAction* mMoveToAction;
+    KAction* mLinkToAction;
+    KAction* mRenameAction;
+    KAction* mTrashAction;
+    KAction* mDelAction;
+    KAction* mRestoreAction;
+    KAction* mShowPropertiesAction;
+    KAction* mCreateFolderAction;
+    KAction* mOpenWithAction;
+    QList<QAction*> mRegularFileActionList;
+    QList<QAction*> mTrashFileActionList;
+    QMap<QString, KService::Ptr> mServiceForName;
+    bool mInTrash;
+
+    KUrl::List urlList() const {
+        KUrl::List urlList;
+
+        KFileItemList list = q->contextManager()->selectedFileItemList();
+        if (list.count() > 0) {
+            urlList = list.urlList();
+        } else {
+            KUrl url = q->contextManager()->currentUrl();
+            Q_ASSERT(url.isValid());
+            urlList << url;
+        }
+        return urlList;
+    }
+
+    void updateServiceForName()
+    {
+        // This code is inspired from
+        // kdebase/apps/lib/konq/konq_menuactions.cpp
+
+        // Get list of all distinct mimetypes in selection
+        QStringList mimeTypes;
+        Q_FOREACH(const KFileItem & item, q->contextManager()->selectedFileItemList()) {
+            const QString mimeType = item.mimetype();
+            if (!mimeTypes.contains(mimeType)) {
+                mimeTypes << mimeType;
+            }
+        }
+
+        // Query trader
+        const QString firstMimeType = mimeTypes.takeFirst();
+        const QString constraintTemplate = "'%1' in ServiceTypes";
+        QStringList constraints;
+        Q_FOREACH(const QString & mimeType, mimeTypes) {
+            constraints << constraintTemplate.arg(mimeType);
+        }
+
+        KService::List services = KMimeTypeTrader::self()->query(
+                                      firstMimeType, "Application",
+                                      constraints.join(" and "));
+
+        // Update map
+        mServiceForName.clear();
+        Q_FOREACH(const KService::Ptr & service, services) {
+            mServiceForName[service->name()] = service;
+        }
+    }
+
+    QMimeData* selectionMimeData()
+    {
+        QMimeData* mimeData = new QMimeData;
+        KFileItemList list = q->contextManager()->selectedFileItemList();
+        list.urlList().populateMimeData(mimeData);
+        return mimeData;
+    }
+
+    KUrl pasteTargetUrl() const {
+        // If only one folder is selected, paste inside it, otherwise paste in
+        // current
+        KFileItemList list = q->contextManager()->selectedFileItemList();
+        if (list.count() == 1 && list.first().isDir()) {
+            return list.first().url();
+        } else {
+            return q->contextManager()->currentDirUrl();
+        }
+    }
 };
 
-
-static QAction* createSeparator(QObject* parent) {
-	QAction* action = new KAction(parent);
-	action->setSeparator(true);
-	return action;
+static QAction* createSeparator(QObject* parent)
+{
+    QAction* action = new KAction(parent);
+    action->setSeparator(true);
+    return action;
 }
 
-
 FileOpsContextManagerItem::FileOpsContextManagerItem(ContextManager* manager, QListView* thumbnailView, KActionCollection* actionCollection, KXMLGUIClient* client)
 : AbstractContextManagerItem(manager)
-, d(new FileOpsContextManagerItemPrivate) {
-	d->mContextManagerItem = this;
-	d->mThumbnailView = thumbnailView;
-	d->mXMLGUIClient = client;
-	d->mGroup = new SideBarGroup(i18n("File Operations"));
-	setWidget(d->mGroup);
-	EventWatcher::install(d->mGroup, QEvent::Show, this, SLOT(updateSideBarContent()));
-
-	d->mInTrash = false;
-
-	connect(contextManager(), SIGNAL(selectionChanged()),
-		SLOT(updateActions()) );
-	connect(contextManager(), SIGNAL(currentDirUrlChanged()),
-		SLOT(updateActions()) );
-
-	KActionCategory* file = new KActionCategory(i18nc("@title actions category","File"), actionCollection);
-	KActionCategory* edit = new KActionCategory(i18nc("@title actions category","Edit"), actionCollection);
-
-	d->mCutAction = edit->addAction(KStandardAction::Cut, this, SLOT(cut()));
-
-	// Copied from Dolphin:
+, d(new FileOpsContextManagerItemPrivate)
+{
+    d->q = this;
+    d->mThumbnailView = thumbnailView;
+    d->mXMLGUIClient = client;
+    d->mGroup = new SideBarGroup(i18n("File Operations"));
+    setWidget(d->mGroup);
+    EventWatcher::install(d->mGroup, QEvent::Show, this, SLOT(updateSideBarContent()));
+
+    d->mInTrash = false;
+
+    connect(contextManager(), SIGNAL(selectionChanged()),
+            SLOT(updateActions()));
+    connect(contextManager(), SIGNAL(currentDirUrlChanged()),
+            SLOT(updateActions()));
+
+    KActionCategory* file = new KActionCategory(i18nc("@title actions category", "File"), actionCollection);
+    KActionCategory* edit = new KActionCategory(i18nc("@title actions category", "Edit"), actionCollection);
+
+    d->mCutAction = edit->addAction(KStandardAction::Cut, this, SLOT(cut()));
+
+    // Copied from Dolphin:
     // need to remove shift+del from cut action, else the shortcut for deletejob
     // doesn't work
-	KShortcut cutShortcut = d->mCutAction->shortcut();
-	cutShortcut.remove(Qt::SHIFT + Qt::Key_Delete, KShortcut::KeepEmpty);
-	d->mCutAction->setShortcut(cutShortcut);
-
-	d->mCopyAction = edit->addAction(KStandardAction::Copy, this, SLOT(copy()));
-	d->mPasteAction = edit->addAction(KStandardAction::Paste, this, SLOT(paste()));
-
-	d->mCopyToAction = file->addAction("file_copy_to",this,SLOT(copyTo()));
-	d->mCopyToAction->setText(i18nc("Verb", "Copy To..."));
-	d->mCopyToAction->setShortcut(Qt::Key_F7);
-
-	d->mMoveToAction = file->addAction("file_move_to",this,SLOT(moveTo()));
-	d->mMoveToAction->setText(i18nc("Verb", "Move To..."));
-	d->mMoveToAction->setShortcut(Qt::Key_F8);
-
-	d->mLinkToAction = file->addAction("file_link_to",this,SLOT(linkTo()));
-	d->mLinkToAction->setText(i18nc("Verb: create link to the file where user wants", "Link To..."));
-	d->mLinkToAction->setShortcut(Qt::Key_F9);
-
-	d->mRenameAction = file->addAction("file_rename",this,SLOT(rename()));
-	d->mRenameAction->setText(i18nc("Verb", "Rename..."));
-	d->mRenameAction->setShortcut(Qt::Key_F2);
-
-	d->mTrashAction = file->addAction("file_trash",this,SLOT(trash()));
-	d->mTrashAction->setText(i18nc("Verb", "Trash"));
-	d->mTrashAction->setIcon(KIcon("user-trash"));
-	d->mTrashAction->setShortcut(Qt::Key_Delete);
-
-	d->mDelAction = file->addAction("file_delete",this,SLOT(del()));
-	d->mDelAction->setText(i18n("Delete"));
-	d->mDelAction->setIcon(KIcon("edit-delete"));
-	d->mDelAction->setShortcut(QKeySequence(Qt::ShiftModifier | Qt::Key_Delete));
-
-	d->mRestoreAction = file->addAction("file_restore", this, SLOT(restore()));
-	d->mRestoreAction->setText(i18n("Restore"));
-
-	d->mShowPropertiesAction = file->addAction("file_show_properties",this,SLOT(showProperties()));
-	d->mShowPropertiesAction->setText(i18n("Properties"));
-	d->mShowPropertiesAction->setIcon(KIcon("document-properties"));
-
-	d->mCreateFolderAction = file->addAction("file_create_folder",this,SLOT(createFolder()));
-	d->mCreateFolderAction->setText(i18n("Create Folder..."));
-	d->mCreateFolderAction->setIcon(KIcon("folder-new"));
-
-	d->mOpenWithAction = file->addAction("file_open_with");
-	d->mOpenWithAction->setText(i18n("Open With"));
-	QMenu* menu = new QMenu;
-	d->mOpenWithAction->setMenu(menu);
-	connect(menu, SIGNAL(aboutToShow()),
-		SLOT(populateOpenMenu()) );
-	connect(menu, SIGNAL(triggered(QAction*)),
-		SLOT(openWith(QAction*)) );
-
-	d->mRegularFileActionList
-		<< d->mRenameAction
-		<< d->mTrashAction
-		<< d->mDelAction
-		<< createSeparator(this)
-		<< d->mCopyToAction
-		<< d->mMoveToAction
-		<< d->mLinkToAction
-		<< createSeparator(this)
-		<< d->mOpenWithAction
-		<< d->mShowPropertiesAction
-		<< createSeparator(this)
-		<< d->mCreateFolderAction
-		;
-
-	d->mTrashFileActionList
-		<< d->mRestoreAction
-		<< d->mDelAction
-		<< createSeparator(this)
-		<< d->mShowPropertiesAction
-		;
-
-	connect(QApplication::clipboard(), SIGNAL(dataChanged()),
-		SLOT(updatePasteAction()));
-	updatePasteAction();
-
-	// Delay action update because it must happen *after* main window has called
-	// createGUI(), otherwise calling d->mXMLGUIClient->plugActionList() will
-	// fail.
-	QMetaObject::invokeMethod(this, "updateActions", Qt::QueuedConnection);
-}
-
-
-FileOpsContextManagerItem::~FileOpsContextManagerItem() {
-	delete d->mOpenWithAction->menu();
-	delete d;
-}
-
-
-void FileOpsContextManagerItem::updateActions() {
-	const int count = contextManager()->selectedFileItemList().count();
-	const bool selectionNotEmpty = count > 0;
-	const bool urlIsValid = contextManager()->currentUrl().isValid();
-	const bool dirUrlIsValid = contextManager()->currentDirUrl().isValid();
-
-	d->mInTrash = contextManager()->currentDirUrl().protocol() == "trash";
-
-	d->mCutAction->setEnabled(selectionNotEmpty);
-	d->mCopyAction->setEnabled(selectionNotEmpty);
-	d->mCopyToAction->setEnabled(selectionNotEmpty);
-	d->mMoveToAction->setEnabled(selectionNotEmpty);
-	d->mLinkToAction->setEnabled(selectionNotEmpty);
-	d->mTrashAction->setEnabled(selectionNotEmpty);
-	d->mRestoreAction->setEnabled(selectionNotEmpty);
-	d->mDelAction->setEnabled(selectionNotEmpty);
-	d->mOpenWithAction->setEnabled(selectionNotEmpty);
-	d->mRenameAction->setEnabled(count == 1);
-
-	d->mCreateFolderAction->setEnabled(dirUrlIsValid);
-	d->mShowPropertiesAction->setEnabled(dirUrlIsValid || urlIsValid);
-
-	d->mXMLGUIClient->unplugActionList("file_action_list");
-	QList<QAction*>& list = d->mInTrash ? d->mTrashFileActionList : d->mRegularFileActionList;
-	d->mXMLGUIClient->plugActionList("file_action_list", list);
-
-	updateSideBarContent();
-}
-
-
-void FileOpsContextManagerItem::updatePasteAction() {
-	QPair<bool, QString> info = KonqOperations::pasteInfo(d->pasteTargetUrl());
-	d->mPasteAction->setEnabled(info.first);
-	d->mPasteAction->setText(info.second);
-}
-
-
-void FileOpsContextManagerItem::updateSideBarContent() {
-	if (!d->mGroup->isVisible()) {
-		return;
-	}
-
-	d->mGroup->clear();
-	QList<QAction*>& list = d->mInTrash ? d->mTrashFileActionList : d->mRegularFileActionList;
-	Q_FOREACH(QAction* action, list) {
-		if (action->isEnabled() && !action->isSeparator()) {
-			d->mGroup->addAction(action);
-		}
-	}
-}
-
-
-void FileOpsContextManagerItem::showProperties() {
-	KFileItemList list = contextManager()->selectedFileItemList();
-	if (list.count() > 0) {
-		KPropertiesDialog::showDialog(list, d->mGroup);
-	} else {
-		KUrl url = contextManager()->currentDirUrl();
-		KPropertiesDialog::showDialog(url, d->mGroup);
-	}
-}
-
-
-void FileOpsContextManagerItem::cut() {
-	QMimeData* mimeData = d->selectionMimeData();
-	KonqMimeData::addIsCutSelection(mimeData, true);
-	QApplication::clipboard()->setMimeData(mimeData);
-}
-
-
-void FileOpsContextManagerItem::copy() {
-	QMimeData* mimeData = d->selectionMimeData();
-	KonqMimeData::addIsCutSelection(mimeData, false);
-	QApplication::clipboard()->setMimeData(mimeData);
-}
-
-
-void FileOpsContextManagerItem::paste() {
-	const bool move = KonqMimeData::decodeIsCutSelection(QApplication::clipboard()->mimeData());
-	KIO::pasteClipboard(d->pasteTargetUrl(), d->mGroup, move);
-}
-
-
-void FileOpsContextManagerItem::trash() {
-	FileOperations::trash(d->urlList(), d->mGroup);
-}
-
-
-void FileOpsContextManagerItem::del() {
-	FileOperations::del(d->urlList(), d->mGroup);
-}
-
-
-void FileOpsContextManagerItem::restore() {
-	KonqOperations::restoreTrashedItems(d->urlList(), d->mGroup);
-}
-
-
-void FileOpsContextManagerItem::copyTo() {
-	FileOperations::copyTo(d->urlList(), d->mGroup);
-}
-
-
-void FileOpsContextManagerItem::moveTo() {
-	FileOperations::moveTo(d->urlList(), d->mGroup);
-}
-
-
-void FileOpsContextManagerItem::linkTo() {
-	FileOperations::linkTo(d->urlList(), d->mGroup);
-}
-
-
-void FileOpsContextManagerItem::rename() {
-	if (d->mThumbnailView->isVisible()) {
-		QModelIndex index = d->mThumbnailView->currentIndex();
-		d->mThumbnailView->edit(index);
-	} else {
-		FileOperations::rename(d->urlList().first(), d->mGroup);
-	}
-}
-
-
-void FileOpsContextManagerItem::createFolder() {
-	KUrl url = contextManager()->currentDirUrl();
-	KonqOperations::newDir(d->mGroup, url);
-}
-
-
-void FileOpsContextManagerItem::populateOpenMenu() {
-	QMenu* openMenu = d->mOpenWithAction->menu();
-	qDeleteAll(openMenu->actions());
-
-	d->updateServiceForName();
-
-	Q_FOREACH(const KService::Ptr &service, d->mServiceForName) {
-		QString text = service->name().replace( '&', "&&" );
-		QAction* action = openMenu->addAction(text);
-		action->setIcon(KIcon(service->icon()));
-		action->setData(service->name());
-	}
-
-	openMenu->addSeparator();
-	openMenu->addAction(i18n("Other Application..."));
-}
-
-
-void FileOpsContextManagerItem::openWith(QAction* action) {
-	Q_ASSERT(action);
-	KService::Ptr service;
-	KUrl::List list = d->urlList();
-
-	QString name = action->data().toString();
-	if (name.isEmpty()) {
-		// Other Application...
-		KOpenWithDialog dlg(list, d->mGroup);
-		if (!dlg.exec()) {
-			return;
-		}
-		service = dlg.service();
-
-		if (!service) {
-			// User entered a custom command
-			Q_ASSERT(!dlg.text().isEmpty());
-			KRun::run(dlg.text(), list, d->mGroup);
-			return;
-		}
-	} else {
-		service = d->mServiceForName[name];
-	}
-
-	Q_ASSERT(service);
-	KRun::run(*service, list, d->mGroup);
-}
-
+    KShortcut cutShortcut = d->mCutAction->shortcut();
+    cutShortcut.remove(Qt::SHIFT + Qt::Key_Delete, KShortcut::KeepEmpty);
+    d->mCutAction->setShortcut(cutShortcut);
+
+    d->mCopyAction = edit->addAction(KStandardAction::Copy, this, SLOT(copy()));
+    d->mPasteAction = edit->addAction(KStandardAction::Paste, this, SLOT(paste()));
+
+    d->mCopyToAction = file->addAction("file_copy_to", this, SLOT(copyTo()));
+    d->mCopyToAction->setText(i18nc("Verb", "Copy To..."));
+    d->mCopyToAction->setShortcut(Qt::Key_F7);
+
+    d->mMoveToAction = file->addAction("file_move_to", this, SLOT(moveTo()));
+    d->mMoveToAction->setText(i18nc("Verb", "Move To..."));
+    d->mMoveToAction->setShortcut(Qt::Key_F8);
+
+    d->mLinkToAction = file->addAction("file_link_to", this, SLOT(linkTo()));
+    d->mLinkToAction->setText(i18nc("Verb: create link to the file where user wants", "Link To..."));
+    d->mLinkToAction->setShortcut(Qt::Key_F9);
+
+    d->mRenameAction = file->addAction("file_rename", this, SLOT(rename()));
+    d->mRenameAction->setText(i18nc("Verb", "Rename..."));
+    d->mRenameAction->setShortcut(Qt::Key_F2);
+
+    d->mTrashAction = file->addAction("file_trash", this, SLOT(trash()));
+    d->mTrashAction->setText(i18nc("Verb", "Trash"));
+    d->mTrashAction->setIcon(KIcon("user-trash"));
+    d->mTrashAction->setShortcut(Qt::Key_Delete);
+
+    d->mDelAction = file->addAction("file_delete", this, SLOT(del()));
+    d->mDelAction->setText(i18n("Delete"));
+    d->mDelAction->setIcon(KIcon("edit-delete"));
+    d->mDelAction->setShortcut(QKeySequence(Qt::ShiftModifier | Qt::Key_Delete));
+
+    d->mRestoreAction = file->addAction("file_restore", this, SLOT(restore()));
+    d->mRestoreAction->setText(i18n("Restore"));
+
+    d->mShowPropertiesAction = file->addAction("file_show_properties", this, SLOT(showProperties()));
+    d->mShowPropertiesAction->setText(i18n("Properties"));
+    d->mShowPropertiesAction->setIcon(KIcon("document-properties"));
+
+    d->mCreateFolderAction = file->addAction("file_create_folder", this, SLOT(createFolder()));
+    d->mCreateFolderAction->setText(i18n("Create Folder..."));
+    d->mCreateFolderAction->setIcon(KIcon("folder-new"));
+
+    d->mOpenWithAction = file->addAction("file_open_with");
+    d->mOpenWithAction->setText(i18n("Open With"));
+    QMenu* menu = new QMenu;
+    d->mOpenWithAction->setMenu(menu);
+    connect(menu, SIGNAL(aboutToShow()),
+            SLOT(populateOpenMenu()));
+    connect(menu, SIGNAL(triggered(QAction*)),
+            SLOT(openWith(QAction*)));
+
+    d->mRegularFileActionList
+            << d->mRenameAction
+            << d->mTrashAction
+            << d->mDelAction
+            << createSeparator(this)
+            << d->mCopyToAction
+            << d->mMoveToAction
+            << d->mLinkToAction
+            << createSeparator(this)
+            << d->mOpenWithAction
+            << d->mShowPropertiesAction
+            << createSeparator(this)
+            << d->mCreateFolderAction
+            ;
+
+    d->mTrashFileActionList
+            << d->mRestoreAction
+            << d->mDelAction
+            << createSeparator(this)
+            << d->mShowPropertiesAction
+            ;
+
+    connect(QApplication::clipboard(), SIGNAL(dataChanged()),
+            SLOT(updatePasteAction()));
+    updatePasteAction();
+
+    // Delay action update because it must happen *after* main window has called
+    // createGUI(), otherwise calling d->mXMLGUIClient->plugActionList() will
+    // fail.
+    QMetaObject::invokeMethod(this, "updateActions", Qt::QueuedConnection);
+}
+
+FileOpsContextManagerItem::~FileOpsContextManagerItem()
+{
+    delete d->mOpenWithAction->menu();
+    delete d;
+}
+
+void FileOpsContextManagerItem::updateActions()
+{
+    const int count = contextManager()->selectedFileItemList().count();
+    const bool selectionNotEmpty = count > 0;
+    const bool urlIsValid = contextManager()->currentUrl().isValid();
+    const bool dirUrlIsValid = contextManager()->currentDirUrl().isValid();
+
+    d->mInTrash = contextManager()->currentDirUrl().protocol() == "trash";
+
+    d->mCutAction->setEnabled(selectionNotEmpty);
+    d->mCopyAction->setEnabled(selectionNotEmpty);
+    d->mCopyToAction->setEnabled(selectionNotEmpty);
+    d->mMoveToAction->setEnabled(selectionNotEmpty);
+    d->mLinkToAction->setEnabled(selectionNotEmpty);
+    d->mTrashAction->setEnabled(selectionNotEmpty);
+    d->mRestoreAction->setEnabled(selectionNotEmpty);
+    d->mDelAction->setEnabled(selectionNotEmpty);
+    d->mOpenWithAction->setEnabled(selectionNotEmpty);
+    d->mRenameAction->setEnabled(count == 1);
+
+    d->mCreateFolderAction->setEnabled(dirUrlIsValid);
+    d->mShowPropertiesAction->setEnabled(dirUrlIsValid || urlIsValid);
+
+    d->mXMLGUIClient->unplugActionList("file_action_list");
+    QList<QAction*>& list = d->mInTrash ? d->mTrashFileActionList : d->mRegularFileActionList;
+    d->mXMLGUIClient->plugActionList("file_action_list", list);
+
+    updateSideBarContent();
+}
+
+void FileOpsContextManagerItem::updatePasteAction()
+{
+    QPair<bool, QString> info = KonqOperations::pasteInfo(d->pasteTargetUrl());
+    d->mPasteAction->setEnabled(info.first);
+    d->mPasteAction->setText(info.second);
+}
+
+void FileOpsContextManagerItem::updateSideBarContent()
+{
+    if (!d->mGroup->isVisible()) {
+        return;
+    }
+
+    d->mGroup->clear();
+    QList<QAction*>& list = d->mInTrash ? d->mTrashFileActionList : d->mRegularFileActionList;
+    Q_FOREACH(QAction * action, list) {
+        if (action->isEnabled() && !action->isSeparator()) {
+            d->mGroup->addAction(action);
+        }
+    }
+}
+
+void FileOpsContextManagerItem::showProperties()
+{
+    KFileItemList list = contextManager()->selectedFileItemList();
+    if (list.count() > 0) {
+        KPropertiesDialog::showDialog(list, d->mGroup);
+    } else {
+        KUrl url = contextManager()->currentDirUrl();
+        KPropertiesDialog::showDialog(url, d->mGroup);
+    }
+}
+
+void FileOpsContextManagerItem::cut()
+{
+    QMimeData* mimeData = d->selectionMimeData();
+    KonqMimeData::addIsCutSelection(mimeData, true);
+    QApplication::clipboard()->setMimeData(mimeData);
+}
+
+void FileOpsContextManagerItem::copy()
+{
+    QMimeData* mimeData = d->selectionMimeData();
+    KonqMimeData::addIsCutSelection(mimeData, false);
+    QApplication::clipboard()->setMimeData(mimeData);
+}
+
+void FileOpsContextManagerItem::paste()
+{
+    const bool move = KonqMimeData::decodeIsCutSelection(QApplication::clipboard()->mimeData());
+    KIO::pasteClipboard(d->pasteTargetUrl(), d->mGroup, move);
+}
+
+void FileOpsContextManagerItem::trash()
+{
+    FileOperations::trash(d->urlList(), d->mGroup);
+}
+
+void FileOpsContextManagerItem::del()
+{
+    FileOperations::del(d->urlList(), d->mGroup);
+}
+
+void FileOpsContextManagerItem::restore()
+{
+    KonqOperations::restoreTrashedItems(d->urlList(), d->mGroup);
+}
+
+void FileOpsContextManagerItem::copyTo()
+{
+    FileOperations::copyTo(d->urlList(), d->mGroup);
+}
+
+void FileOpsContextManagerItem::moveTo()
+{
+    FileOperations::moveTo(d->urlList(), d->mGroup);
+}
+
+void FileOpsContextManagerItem::linkTo()
+{
+    FileOperations::linkTo(d->urlList(), d->mGroup);
+}
+
+void FileOpsContextManagerItem::rename()
+{
+    if (d->mThumbnailView->isVisible()) {
+        QModelIndex index = d->mThumbnailView->currentIndex();
+        d->mThumbnailView->edit(index);
+    } else {
+        FileOperations::rename(d->urlList().first(), d->mGroup);
+    }
+}
+
+void FileOpsContextManagerItem::createFolder()
+{
+    KUrl url = contextManager()->currentDirUrl();
+    KonqOperations::newDir(d->mGroup, url);
+}
+
+void FileOpsContextManagerItem::populateOpenMenu()
+{
+    QMenu* openMenu = d->mOpenWithAction->menu();
+    qDeleteAll(openMenu->actions());
+
+    d->updateServiceForName();
+
+    Q_FOREACH(const KService::Ptr & service, d->mServiceForName) {
+        QString text = service->name().replace('&', "&&");
+        QAction* action = openMenu->addAction(text);
+        action->setIcon(KIcon(service->icon()));
+        action->setData(service->name());
+    }
+
+    openMenu->addSeparator();
+    openMenu->addAction(i18n("Other Application..."));
+}
+
+void FileOpsContextManagerItem::openWith(QAction* action)
+{
+    Q_ASSERT(action);
+    KService::Ptr service;
+    KUrl::List list = d->urlList();
+
+    QString name = action->data().toString();
+    if (name.isEmpty()) {
+        // Other Application...
+        KOpenWithDialog dlg(list, d->mGroup);
+        if (!dlg.exec()) {
+            return;
+        }
+        service = dlg.service();
+
+        if (!service) {
+            // User entered a custom command
+            Q_ASSERT(!dlg.text().isEmpty());
+            KRun::run(dlg.text(), list, d->mGroup);
+            return;
+        }
+    } else {
+        service = d->mServiceForName[name];
+    }
+
+    Q_ASSERT(service);
+    KRun::run(*service, list, d->mGroup);
+}
 
 } // namespace

=== modified file 'app/fileopscontextmanageritem.h'
--- app/fileopscontextmanageritem.h	2011-07-20 13:46:34 +0000
+++ app/fileopscontextmanageritem.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -34,41 +34,41 @@
 class KActionCollection;
 class KXMLGUIClient;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct FileOpsContextManagerItemPrivate;
-class FileOpsContextManagerItem : public AbstractContextManagerItem {
-	Q_OBJECT
+class FileOpsContextManagerItem : public AbstractContextManagerItem
+{
+    Q_OBJECT
 public:
-	FileOpsContextManagerItem(Gwenview::ContextManager* manager, QListView* thumbnailView, KActionCollection* actionCollection, KXMLGUIClient* client);
-	~FileOpsContextManagerItem();
+    FileOpsContextManagerItem(Gwenview::ContextManager* manager, QListView* thumbnailView, KActionCollection* actionCollection, KXMLGUIClient* client);
+    ~FileOpsContextManagerItem();
 
 private Q_SLOTS:
-	void updateActions();
-	void updatePasteAction();
-	void updateSideBarContent();
+    void updateActions();
+    void updatePasteAction();
+    void updateSideBarContent();
 
-	void cut();
-	void copy();
-	void paste();
-	void rename();
-	void copyTo();
-	void moveTo();
-	void linkTo();
-	void trash();
-	void del();
-	void restore();
-	void showProperties();
-	void createFolder();
-	void populateOpenMenu();
-	void openWith(QAction* action);
+    void cut();
+    void copy();
+    void paste();
+    void rename();
+    void copyTo();
+    void moveTo();
+    void linkTo();
+    void trash();
+    void del();
+    void restore();
+    void showProperties();
+    void createFolder();
+    void populateOpenMenu();
+    void openWith(QAction* action);
 
 private:
-	FileOpsContextManagerItemPrivate* const d;
+    FileOpsContextManagerItemPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* FILEOPSCONTEXTMANAGERITEM_H */

=== modified file 'app/filtercontroller.cpp'
--- app/filtercontroller.cpp	2011-07-20 13:46:34 +0000
+++ app/filtercontroller.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -61,532 +61,551 @@
 #include <lib/semanticinfo/tagmodel.h>
 #endif
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * An AbstractSortedDirModelFilter which filters on the file names
  */
-class NameFilter : public AbstractSortedDirModelFilter {
+class NameFilter : public AbstractSortedDirModelFilter
+{
 public:
-	enum Mode {
-		Contains,
-		DoesNotContain
-	};
-	NameFilter(SortedDirModel* model)
-	: AbstractSortedDirModelFilter(model)
-	, mText()
-	, mMode(Contains)
-	{}
-
-	virtual bool needsSemanticInfo() const {
-		return false;
-	}
-
-	virtual bool acceptsIndex(const QModelIndex& index) const {
-		if (mText.isEmpty()) {
-			return true;
-		}
-		switch (mMode) {
-		case Contains:
-			return index.data().toString().contains(mText, Qt::CaseInsensitive);
-		default: /*DoesNotContain:*/
-			return !index.data().toString().contains(mText, Qt::CaseInsensitive);
-		}
-	}
-
-	void setText(const QString& text) {
-		mText = text;
-		model()->applyFilters();
-	}
-
-	void setMode(Mode mode) {
-		mMode = mode;
-		model()->applyFilters();
-	}
+    enum Mode {
+        Contains,
+        DoesNotContain
+    };
+    NameFilter(SortedDirModel* model)
+        : AbstractSortedDirModelFilter(model)
+        , mText()
+        , mMode(Contains)
+    {}
+
+    virtual bool needsSemanticInfo() const {
+        return false;
+    }
+
+    virtual bool acceptsIndex(const QModelIndex& index) const {
+        if (mText.isEmpty()) {
+            return true;
+        }
+        switch (mMode) {
+        case Contains:
+            return index.data().toString().contains(mText, Qt::CaseInsensitive);
+        default: /*DoesNotContain:*/
+            return !index.data().toString().contains(mText, Qt::CaseInsensitive);
+        }
+    }
+
+    void setText(const QString& text)
+    {
+        mText = text;
+        model()->applyFilters();
+    }
+
+    void setMode(Mode mode)
+    {
+        mMode = mode;
+        model()->applyFilters();
+    }
 
 private:
-	QString mText;
-	Mode mMode;
+    QString mText;
+    Mode mMode;
 };
 
 struct NameFilterWidgetPrivate {
-	QPointer<NameFilter> mFilter;
-	KComboBox* mModeComboBox;
-	KLineEdit* mLineEdit;
+    QPointer<NameFilter> mFilter;
+    KComboBox* mModeComboBox;
+    KLineEdit* mLineEdit;
 };
 
 NameFilterWidget::NameFilterWidget(SortedDirModel* model)
 : d(new NameFilterWidgetPrivate)
 {
-	d->mFilter = new NameFilter(model);
-
-	d->mModeComboBox = new KComboBox;
-	d->mModeComboBox->addItem(i18n("Name contains"), QVariant(NameFilter::Contains));
-	d->mModeComboBox->addItem(i18n("Name does not contain"), QVariant(NameFilter::DoesNotContain));
-
-	d->mLineEdit = new KLineEdit;
-
-	QHBoxLayout* layout = new QHBoxLayout(this);
-	layout->setMargin(0);
-	layout->setSpacing(2);
-	layout->addWidget(d->mModeComboBox);
-	layout->addWidget(d->mLineEdit);
-
-	QTimer* timer = new QTimer(this);
-	timer->setInterval(350);
-	timer->setSingleShot(true);
-	connect(timer, SIGNAL(timeout()), SLOT(applyNameFilter()));
-
-	connect(d->mLineEdit, SIGNAL(textChanged(const QString &)),
-		timer, SLOT(start()));
-
-	connect(d->mModeComboBox, SIGNAL(currentIndexChanged(int)),
-		SLOT(applyNameFilter()));
-
-	QTimer::singleShot(0, d->mLineEdit, SLOT(setFocus()));
+    d->mFilter = new NameFilter(model);
+
+    d->mModeComboBox = new KComboBox;
+    d->mModeComboBox->addItem(i18n("Name contains"), QVariant(NameFilter::Contains));
+    d->mModeComboBox->addItem(i18n("Name does not contain"), QVariant(NameFilter::DoesNotContain));
+
+    d->mLineEdit = new KLineEdit;
+
+    QHBoxLayout* layout = new QHBoxLayout(this);
+    layout->setMargin(0);
+    layout->setSpacing(2);
+    layout->addWidget(d->mModeComboBox);
+    layout->addWidget(d->mLineEdit);
+
+    QTimer* timer = new QTimer(this);
+    timer->setInterval(350);
+    timer->setSingleShot(true);
+    connect(timer, SIGNAL(timeout()), SLOT(applyNameFilter()));
+
+    connect(d->mLineEdit, SIGNAL(textChanged(QString)),
+            timer, SLOT(start()));
+
+    connect(d->mModeComboBox, SIGNAL(currentIndexChanged(int)),
+            SLOT(applyNameFilter()));
+
+    QTimer::singleShot(0, d->mLineEdit, SLOT(setFocus()));
 }
 
 NameFilterWidget::~NameFilterWidget()
 {
-	delete d->mFilter;
-	delete d;
+    delete d->mFilter;
+    delete d;
 }
 
-void NameFilterWidget::applyNameFilter() {
-	QVariant data = d->mModeComboBox->itemData(d->mModeComboBox->currentIndex());
-	d->mFilter->setMode(NameFilter::Mode(data.toInt()));
-	d->mFilter->setText(d->mLineEdit->text());
+void NameFilterWidget::applyNameFilter()
+{
+    QVariant data = d->mModeComboBox->itemData(d->mModeComboBox->currentIndex());
+    d->mFilter->setMode(NameFilter::Mode(data.toInt()));
+    d->mFilter->setText(d->mLineEdit->text());
 }
 
 /**
  * An AbstractSortedDirModelFilter which filters on the file dates
  */
-class DateFilter : public AbstractSortedDirModelFilter {
+class DateFilter : public AbstractSortedDirModelFilter
+{
 public:
-	enum Mode {
-		GreaterOrEqual,
-		Equal,
-		LessOrEqual
-	};
-	DateFilter(SortedDirModel* model)
-	: AbstractSortedDirModelFilter(model)
-	, mMode(GreaterOrEqual)
-	{}
-
-	virtual bool needsSemanticInfo() const {
-		return false;
-	}
-
-	virtual bool acceptsIndex(const QModelIndex& index) const {
-		if (!mDate.isValid()) {
-			return true;
-		}
-		KFileItem fileItem = model()->itemForSourceIndex(index);
-		QDate date = TimeUtils::dateTimeForFileItem(fileItem).date();
-		switch (mMode) {
-		case GreaterOrEqual:
-			return date >= mDate;
-		case Equal:
-			return date == mDate;
-		default: /* LessOrEqual */
-			return date <= mDate;
-		}
-	}
-
-	void setDate(const QDate& date) {
-		mDate = date;
-		model()->applyFilters();
-	}
-
-	void setMode(Mode mode) {
-		mMode = mode;
-		model()->applyFilters();
-	}
+    enum Mode {
+        GreaterOrEqual,
+        Equal,
+        LessOrEqual
+    };
+    DateFilter(SortedDirModel* model)
+        : AbstractSortedDirModelFilter(model)
+        , mMode(GreaterOrEqual)
+    {}
+
+    virtual bool needsSemanticInfo() const {
+        return false;
+    }
+
+    virtual bool acceptsIndex(const QModelIndex& index) const {
+        if (!mDate.isValid()) {
+            return true;
+        }
+        KFileItem fileItem = model()->itemForSourceIndex(index);
+        QDate date = TimeUtils::dateTimeForFileItem(fileItem).date();
+        switch (mMode) {
+        case GreaterOrEqual:
+            return date >= mDate;
+        case Equal:
+            return date == mDate;
+        default: /* LessOrEqual */
+            return date <= mDate;
+        }
+    }
+
+    void setDate(const QDate& date)
+    {
+        mDate = date;
+        model()->applyFilters();
+    }
+
+    void setMode(Mode mode)
+    {
+        mMode = mode;
+        model()->applyFilters();
+    }
 
 private:
-	QDate mDate;
-	Mode mMode;
+    QDate mDate;
+    Mode mMode;
 };
 
 struct DateFilterWidgetPrivate {
-	QPointer<DateFilter> mFilter;
-	KComboBox* mModeComboBox;
-	DateWidget* mDateWidget;
+    QPointer<DateFilter> mFilter;
+    KComboBox* mModeComboBox;
+    DateWidget* mDateWidget;
 };
 
 DateFilterWidget::DateFilterWidget(SortedDirModel* model)
 : d(new DateFilterWidgetPrivate)
 {
-	d->mFilter = new DateFilter(model);
-
-	d->mModeComboBox = new KComboBox;
-	d->mModeComboBox->addItem(i18n("Date >="), DateFilter::GreaterOrEqual);
-	d->mModeComboBox->addItem(i18n("Date ="),  DateFilter::Equal);
-	d->mModeComboBox->addItem(i18n("Date <="), DateFilter::LessOrEqual);
-
-	d->mDateWidget = new DateWidget;
-
-	QHBoxLayout* layout = new QHBoxLayout(this);
-	layout->setMargin(0);
-	layout->addWidget(d->mModeComboBox);
-	layout->addWidget(d->mDateWidget);
-
-	connect(d->mDateWidget, SIGNAL(dateChanged(const QDate&)),
-		SLOT(applyDateFilter()));
-	connect(d->mModeComboBox, SIGNAL(currentIndexChanged(int)),
-		SLOT(applyDateFilter()));
-
-	applyDateFilter();
+    d->mFilter = new DateFilter(model);
+
+    d->mModeComboBox = new KComboBox;
+    d->mModeComboBox->addItem(i18n("Date >="), DateFilter::GreaterOrEqual);
+    d->mModeComboBox->addItem(i18n("Date ="),  DateFilter::Equal);
+    d->mModeComboBox->addItem(i18n("Date <="), DateFilter::LessOrEqual);
+
+    d->mDateWidget = new DateWidget;
+
+    QHBoxLayout* layout = new QHBoxLayout(this);
+    layout->setMargin(0);
+    layout->addWidget(d->mModeComboBox);
+    layout->addWidget(d->mDateWidget);
+
+    connect(d->mDateWidget, SIGNAL(dateChanged(QDate)),
+            SLOT(applyDateFilter()));
+    connect(d->mModeComboBox, SIGNAL(currentIndexChanged(int)),
+            SLOT(applyDateFilter()));
+
+    applyDateFilter();
 }
 
 DateFilterWidget::~DateFilterWidget()
 {
-	delete d->mFilter;
-	delete d;
+    delete d->mFilter;
+    delete d;
 }
 
-void DateFilterWidget::applyDateFilter() {
-	QVariant data = d->mModeComboBox->itemData(d->mModeComboBox->currentIndex());
-	d->mFilter->setMode(DateFilter::Mode(data.toInt()));
-	d->mFilter->setDate(d->mDateWidget->date());
+void DateFilterWidget::applyDateFilter()
+{
+    QVariant data = d->mModeComboBox->itemData(d->mModeComboBox->currentIndex());
+    d->mFilter->setMode(DateFilter::Mode(data.toInt()));
+    d->mFilter->setDate(d->mDateWidget->date());
 }
 
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
 /**
  * An AbstractSortedDirModelFilter which filters on file ratings
  */
-class RatingFilter : public AbstractSortedDirModelFilter {
+class RatingFilter : public AbstractSortedDirModelFilter
+{
 public:
-	enum Mode {
-		GreaterOrEqual,
-		Equal,
-		LessOrEqual
-	};
-
-	RatingFilter(SortedDirModel* model)
-	: AbstractSortedDirModelFilter(model)
-	, mRating(0)
-	, mMode(GreaterOrEqual) {}
-
-	virtual bool needsSemanticInfo() const {
-		return true;
-	}
-
-	virtual bool acceptsIndex(const QModelIndex& index) const {
-		SemanticInfo info = model()->semanticInfoForSourceIndex(index);
-		switch (mMode) {
-		case GreaterOrEqual:
-			return info.mRating >= mRating;
-		case Equal:
-			return info.mRating == mRating;
-		default: /* LessOrEqual */
-			return info.mRating <= mRating;
-		}
-	}
-
-	void setRating(int value) {
-		mRating = value;
-		model()->applyFilters();
-	}
-
-	void setMode(Mode mode) {
-		mMode = mode;
-		model()->applyFilters();
-	}
+    enum Mode {
+        GreaterOrEqual,
+        Equal,
+        LessOrEqual
+    };
+
+    RatingFilter(SortedDirModel* model)
+        : AbstractSortedDirModelFilter(model)
+        , mRating(0)
+        , mMode(GreaterOrEqual) {}
+
+    virtual bool needsSemanticInfo() const {
+        return true;
+    }
+
+    virtual bool acceptsIndex(const QModelIndex& index) const {
+        SemanticInfo info = model()->semanticInfoForSourceIndex(index);
+        switch (mMode) {
+        case GreaterOrEqual:
+            return info.mRating >= mRating;
+        case Equal:
+            return info.mRating == mRating;
+        default: /* LessOrEqual */
+            return info.mRating <= mRating;
+        }
+    }
+
+    void setRating(int value)
+    {
+        mRating = value;
+        model()->applyFilters();
+    }
+
+    void setMode(Mode mode)
+    {
+        mMode = mode;
+        model()->applyFilters();
+    }
 
 private:
-	int mRating;
-	Mode mMode;
+    int mRating;
+    Mode mMode;
 };
 
 struct RatingWidgetPrivate {
-	KComboBox* mModeComboBox;
-	KRatingWidget* mRatingWidget;
-	QPointer<RatingFilter> mFilter;
+    KComboBox* mModeComboBox;
+    KRatingWidget* mRatingWidget;
+    QPointer<RatingFilter> mFilter;
 };
 
 RatingFilterWidget::RatingFilterWidget(SortedDirModel* model)
-: d(new RatingWidgetPrivate) {
-	d->mModeComboBox = new KComboBox;
-	d->mModeComboBox->addItem(i18n("Rating >="), RatingFilter::GreaterOrEqual);
-	d->mModeComboBox->addItem(i18n("Rating =") , RatingFilter::Equal);
-	d->mModeComboBox->addItem(i18n("Rating <="), RatingFilter::LessOrEqual);
-
-	d->mRatingWidget = new KRatingWidget;
-	d->mRatingWidget->setHalfStepsEnabled(true);
-	d->mRatingWidget->setMaxRating(10);
-
-	QHBoxLayout* layout = new QHBoxLayout(this);
-	layout->setMargin(0);
-	layout->addWidget(d->mModeComboBox);
-	layout->addWidget(d->mRatingWidget);
-
-	d->mFilter = new RatingFilter(model);
-
-	QObject::connect(d->mModeComboBox, SIGNAL(currentIndexChanged(int)),
-		SLOT(updateFilterMode()));
-
-	QObject::connect(d->mRatingWidget, SIGNAL(ratingChanged(int)),
-		SLOT(slotRatingChanged(int)));
-
-	updateFilterMode();
-}
-
-
-RatingFilterWidget::~RatingFilterWidget() {
-	delete d->mFilter;
-	delete d;
-}
-
-
-void RatingFilterWidget::slotRatingChanged(int value) {
-	d->mFilter->setRating(value);
-}
-
-
-void RatingFilterWidget::updateFilterMode() {
-	QVariant data = d->mModeComboBox->itemData(d->mModeComboBox->currentIndex());
-	d->mFilter->setMode(RatingFilter::Mode(data.toInt()));
-}
-
+: d(new RatingWidgetPrivate)
+{
+    d->mModeComboBox = new KComboBox;
+    d->mModeComboBox->addItem(i18n("Rating >="), RatingFilter::GreaterOrEqual);
+    d->mModeComboBox->addItem(i18n("Rating =") , RatingFilter::Equal);
+    d->mModeComboBox->addItem(i18n("Rating <="), RatingFilter::LessOrEqual);
+
+    d->mRatingWidget = new KRatingWidget;
+    d->mRatingWidget->setHalfStepsEnabled(true);
+    d->mRatingWidget->setMaxRating(10);
+
+    QHBoxLayout* layout = new QHBoxLayout(this);
+    layout->setMargin(0);
+    layout->addWidget(d->mModeComboBox);
+    layout->addWidget(d->mRatingWidget);
+
+    d->mFilter = new RatingFilter(model);
+
+    QObject::connect(d->mModeComboBox, SIGNAL(currentIndexChanged(int)),
+                     SLOT(updateFilterMode()));
+
+    QObject::connect(d->mRatingWidget, SIGNAL(ratingChanged(int)),
+                     SLOT(slotRatingChanged(int)));
+
+    updateFilterMode();
+}
+
+RatingFilterWidget::~RatingFilterWidget()
+{
+    delete d->mFilter;
+    delete d;
+}
+
+void RatingFilterWidget::slotRatingChanged(int value)
+{
+    d->mFilter->setRating(value);
+}
+
+void RatingFilterWidget::updateFilterMode()
+{
+    QVariant data = d->mModeComboBox->itemData(d->mModeComboBox->currentIndex());
+    d->mFilter->setMode(RatingFilter::Mode(data.toInt()));
+}
 
 /**
  * An AbstractSortedDirModelFilter which filters on associated tags
  */
-class TagFilter : public AbstractSortedDirModelFilter {
+class TagFilter : public AbstractSortedDirModelFilter
+{
 public:
-	TagFilter(SortedDirModel* model)
-	: AbstractSortedDirModelFilter(model)
-	, mWantMatchingTag(true)
-	{}
-
-	virtual bool needsSemanticInfo() const {
-		return true;
-	}
-
-	virtual bool acceptsIndex(const QModelIndex& index) const {
-		if (mTag.isEmpty()) {
-			return true;
-		}
-		SemanticInfo info = model()->semanticInfoForSourceIndex(index);
-		if (mWantMatchingTag) {
-			return info.mTags.contains(mTag);
-		} else {
-			return !info.mTags.contains(mTag);
-		}
-	}
-
-	void setTag(const SemanticInfoTag& tag) {
-		mTag = tag;
-		model()->applyFilters();
-	}
-
-	void setWantMatchingTag(bool value) {
-		mWantMatchingTag = value;
-		model()->applyFilters();
-	}
+    TagFilter(SortedDirModel* model)
+        : AbstractSortedDirModelFilter(model)
+        , mWantMatchingTag(true)
+    {}
+
+    virtual bool needsSemanticInfo() const {
+        return true;
+    }
+
+    virtual bool acceptsIndex(const QModelIndex& index) const {
+        if (mTag.isEmpty()) {
+            return true;
+        }
+        SemanticInfo info = model()->semanticInfoForSourceIndex(index);
+        if (mWantMatchingTag) {
+            return info.mTags.contains(mTag);
+        } else {
+            return !info.mTags.contains(mTag);
+        }
+    }
+
+    void setTag(const SemanticInfoTag& tag)
+    {
+        mTag = tag;
+        model()->applyFilters();
+    }
+
+    void setWantMatchingTag(bool value)
+    {
+        mWantMatchingTag = value;
+        model()->applyFilters();
+    }
 
 private:
-	SemanticInfoTag mTag;
-	bool mWantMatchingTag;
+    SemanticInfoTag mTag;
+    bool mWantMatchingTag;
 };
 
 struct TagFilterWidgetPrivate {
-	KComboBox* mModeComboBox;
-	QComboBox* mTagComboBox;
-	QPointer<TagFilter> mFilter;
+    KComboBox* mModeComboBox;
+    QComboBox* mTagComboBox;
+    QPointer<TagFilter> mFilter;
 };
 
 TagFilterWidget::TagFilterWidget(SortedDirModel* model)
-: d(new TagFilterWidgetPrivate) {
-	d->mFilter = new TagFilter(model);
-
-	d->mModeComboBox = new KComboBox;
-	d->mModeComboBox->addItem(i18n("Tagged"), QVariant(true));
-	d->mModeComboBox->addItem(i18n("Not Tagged"), QVariant(false));
-
-	d->mTagComboBox = new QComboBox;
-
-	QHBoxLayout* layout = new QHBoxLayout(this);
-	layout->setMargin(0);
-	layout->addWidget(d->mModeComboBox);
-	layout->addWidget(d->mTagComboBox);
-
-	AbstractSemanticInfoBackEnd* backEnd = model->semanticInfoBackEnd();
-	backEnd->refreshAllTags();
-	TagModel* tagModel = TagModel::createAllTagsModel(this, backEnd);
-
-	QCompleter* completer = new QCompleter(d->mTagComboBox);
-	completer->setCaseSensitivity(Qt::CaseInsensitive);
-	completer->setModel(tagModel);
-	d->mTagComboBox->setCompleter(completer);
-	d->mTagComboBox->setInsertPolicy(QComboBox::NoInsert);
-	d->mTagComboBox->setEditable(true);
-	d->mTagComboBox->setModel(tagModel);
-	d->mTagComboBox->setCurrentIndex(-1);
-
-	connect(d->mTagComboBox, SIGNAL(currentIndexChanged(int)), SLOT(updateTagSetFilter()) );
-
-	connect(d->mModeComboBox, SIGNAL(currentIndexChanged(int)), SLOT(updateTagSetFilter()) );
-
-	QTimer::singleShot(0, d->mTagComboBox, SLOT(setFocus()));
-}
-
-TagFilterWidget::~TagFilterWidget() {
-	delete d->mFilter;
-	delete d;
-}
-
-
-void TagFilterWidget::updateTagSetFilter() {
-	QModelIndex index = d->mTagComboBox->model()->index(d->mTagComboBox->currentIndex(), 0);
-	if (!index.isValid()) {
-		kWarning() << "Invalid index";
-		return;
-	}
-	SemanticInfoTag tag = index.data(TagModel::TagRole).toString();
-	d->mFilter->setTag(tag);
-
-	bool wantMatchingTag = d->mModeComboBox->itemData(d->mModeComboBox->currentIndex()).toBool();
-	d->mFilter->setWantMatchingTag(wantMatchingTag);
+: d(new TagFilterWidgetPrivate)
+{
+    d->mFilter = new TagFilter(model);
+
+    d->mModeComboBox = new KComboBox;
+    d->mModeComboBox->addItem(i18n("Tagged"), QVariant(true));
+    d->mModeComboBox->addItem(i18n("Not Tagged"), QVariant(false));
+
+    d->mTagComboBox = new QComboBox;
+
+    QHBoxLayout* layout = new QHBoxLayout(this);
+    layout->setMargin(0);
+    layout->addWidget(d->mModeComboBox);
+    layout->addWidget(d->mTagComboBox);
+
+    AbstractSemanticInfoBackEnd* backEnd = model->semanticInfoBackEnd();
+    backEnd->refreshAllTags();
+    TagModel* tagModel = TagModel::createAllTagsModel(this, backEnd);
+
+    QCompleter* completer = new QCompleter(d->mTagComboBox);
+    completer->setCaseSensitivity(Qt::CaseInsensitive);
+    completer->setModel(tagModel);
+    d->mTagComboBox->setCompleter(completer);
+    d->mTagComboBox->setInsertPolicy(QComboBox::NoInsert);
+    d->mTagComboBox->setEditable(true);
+    d->mTagComboBox->setModel(tagModel);
+    d->mTagComboBox->setCurrentIndex(-1);
+
+    connect(d->mTagComboBox, SIGNAL(currentIndexChanged(int)), SLOT(updateTagSetFilter()));
+
+    connect(d->mModeComboBox, SIGNAL(currentIndexChanged(int)), SLOT(updateTagSetFilter()));
+
+    QTimer::singleShot(0, d->mTagComboBox, SLOT(setFocus()));
+}
+
+TagFilterWidget::~TagFilterWidget()
+{
+    delete d->mFilter;
+    delete d;
+}
+
+void TagFilterWidget::updateTagSetFilter()
+{
+    QModelIndex index = d->mTagComboBox->model()->index(d->mTagComboBox->currentIndex(), 0);
+    if (!index.isValid()) {
+        kWarning() << "Invalid index";
+        return;
+    }
+    SemanticInfoTag tag = index.data(TagModel::TagRole).toString();
+    d->mFilter->setTag(tag);
+
+    bool wantMatchingTag = d->mModeComboBox->itemData(d->mModeComboBox->currentIndex()).toBool();
+    d->mFilter->setWantMatchingTag(wantMatchingTag);
 }
 #endif
 
-
 /**
  * A container for all filter widgets. It features a close button on the right.
  */
-class FilterWidgetContainer : public QFrame {
+class FilterWidgetContainer : public QFrame
+{
 public:
-	FilterWidgetContainer() {
-		QPalette pal = palette();
-		pal.setColor(QPalette::Window, pal.color(QPalette::Highlight));
-		setPalette(pal);
-	}
+    FilterWidgetContainer() {
+        QPalette pal = palette();
+        pal.setColor(QPalette::Window, pal.color(QPalette::Highlight));
+        setPalette(pal);
+    }
 
-	void setFilterWidget(QWidget* widget) {
-		QToolButton* closeButton = new QToolButton;
-		closeButton->setIcon(KIcon("window-close"));
-		closeButton->setAutoRaise(true);
-		closeButton->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Minimum);
-		int size = IconSize(KIconLoader::Small);
-		closeButton->setIconSize(QSize(size, size));
-		connect(closeButton, SIGNAL(clicked()), SLOT(deleteLater()));
-		QHBoxLayout* layout = new QHBoxLayout(this);
-		layout->setMargin(2);
-		layout->setSpacing(2);
-		layout->addWidget(widget);
-		layout->addWidget(closeButton);
-	}
+    void setFilterWidget(QWidget* widget)
+    {
+        QToolButton* closeButton = new QToolButton;
+        closeButton->setIcon(KIcon("window-close"));
+        closeButton->setAutoRaise(true);
+        closeButton->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Minimum);
+        int size = IconSize(KIconLoader::Small);
+        closeButton->setIconSize(QSize(size, size));
+        connect(closeButton, SIGNAL(clicked()), SLOT(deleteLater()));
+        QHBoxLayout* layout = new QHBoxLayout(this);
+        layout->setMargin(2);
+        layout->setSpacing(2);
+        layout->addWidget(widget);
+        layout->addWidget(closeButton);
+    }
 
 protected:
-	virtual void paintEvent(QPaintEvent*) {
-		QPainter painter(this);
-		painter.setRenderHint(QPainter::Antialiasing);
-		QPainterPath path = PaintUtils::roundedRectangle(QRectF(rect()).adjusted(0.5, 0.5, -0.5, -0.5), 6);
+    virtual void paintEvent(QPaintEvent*)
+    {
+        QPainter painter(this);
+        painter.setRenderHint(QPainter::Antialiasing);
+        QPainterPath path = PaintUtils::roundedRectangle(QRectF(rect()).adjusted(0.5, 0.5, -0.5, -0.5), 6);
 
-		QColor color = palette().color(QPalette::Highlight);
-		painter.fillPath(path, PaintUtils::alphaAdjustedF(color, 0.5));
-		painter.setPen(color);
-		painter.drawPath(path);
-	}
+        QColor color = palette().color(QPalette::Highlight);
+        painter.fillPath(path, PaintUtils::alphaAdjustedF(color, 0.5));
+        painter.setPen(color);
+        painter.drawPath(path);
+    }
 };
 
-
 struct FilterControllerPrivate {
-	FilterController* that;
-	QFrame* mFrame;
-	SortedDirModel* mDirModel;
-	QList<QAction*> mActionList;
-
-	int mFilterWidgetCount; /**< How many filter widgets are in mFrame */
-
-	void addAction(const QString& text, const char* slot) {
-		QAction* action = new QAction(text, that);
-		QObject::connect(action, SIGNAL(triggered()), that, slot);
-		mActionList << action;
-	}
-
-	void addFilter(QWidget* widget) {
-		if (mFrame->isHidden()) {
-			mFrame->show();
-		}
-		FilterWidgetContainer* container = new FilterWidgetContainer;
-		container->setFilterWidget(widget);
-		mFrame->layout()->addWidget(container);
-
-		mFilterWidgetCount++;
-		QObject::connect(container, SIGNAL(destroyed()), that, SLOT(slotFilterWidgetClosed()));
-	}
+    FilterController* q;
+    QFrame* mFrame;
+    SortedDirModel* mDirModel;
+    QList<QAction*> mActionList;
+
+    int mFilterWidgetCount; /**< How many filter widgets are in mFrame */
+
+    void addAction(const QString& text, const char* slot)
+    {
+        QAction* action = new QAction(text, q);
+        QObject::connect(action, SIGNAL(triggered()), q, slot);
+        mActionList << action;
+    }
+
+    void addFilter(QWidget* widget)
+    {
+        if (mFrame->isHidden()) {
+            mFrame->show();
+        }
+        FilterWidgetContainer* container = new FilterWidgetContainer;
+        container->setFilterWidget(widget);
+        mFrame->layout()->addWidget(container);
+
+        mFilterWidgetCount++;
+        QObject::connect(container, SIGNAL(destroyed()), q, SLOT(slotFilterWidgetClosed()));
+    }
 };
 
-
 FilterController::FilterController(QFrame* frame, SortedDirModel* dirModel)
 : QObject(frame)
-, d(new FilterControllerPrivate) {
-	d->that = this;
-	d->mFrame = frame;
-	d->mDirModel = dirModel;
-	d->mFilterWidgetCount = 0;
-
-	d->mFrame->hide();
-	FlowLayout* layout = new FlowLayout(d->mFrame);
-	layout->setSpacing(2);
-
-	d->addAction(i18nc("@action:inmenu", "Filter by Name"), SLOT(addFilterByName()));
-	d->addAction(i18nc("@action:inmenu", "Filter by Date"), SLOT(addFilterByDate()));
-#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
-	// Only add filters if Nepomuk is running
-	if (Nepomuk::ResourceManager::instance()->init() == 0) {
-#endif
-		d->addAction(i18nc("@action:inmenu", "Filter by Rating"), SLOT(addFilterByRating()));
-		d->addAction(i18nc("@action:inmenu", "Filter by Tag"), SLOT(addFilterByTag()));
-#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
-	}
-#endif
-#endif
-}
-
-
-FilterController::~FilterController() {
-	delete d;
-}
-
-
-QList<QAction*> FilterController::actionList() const {
-	return d->mActionList;
-}
-
-
-void FilterController::addFilterByName() {
-	d->addFilter(new NameFilterWidget(d->mDirModel));
-}
-
-
-void FilterController::addFilterByDate() {
-	d->addFilter(new DateFilterWidget(d->mDirModel));
-}
-
-
-#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-void FilterController::addFilterByRating() {
-	d->addFilter(new RatingFilterWidget(d->mDirModel));
-}
-
-
-void FilterController::addFilterByTag() {
-	d->addFilter(new TagFilterWidget(d->mDirModel));
-}
-#endif
-
-
-void FilterController::slotFilterWidgetClosed() {
-	d->mFilterWidgetCount--;
-	if (d->mFilterWidgetCount == 0) {
-		d->mFrame->hide();
-	}
-}
-
+, d(new FilterControllerPrivate)
+{
+    d->q = this;
+    d->mFrame = frame;
+    d->mDirModel = dirModel;
+    d->mFilterWidgetCount = 0;
+
+    d->mFrame->hide();
+    FlowLayout* layout = new FlowLayout(d->mFrame);
+    layout->setSpacing(2);
+
+    d->addAction(i18nc("@action:inmenu", "Filter by Name"), SLOT(addFilterByName()));
+    d->addAction(i18nc("@action:inmenu", "Filter by Date"), SLOT(addFilterByDate()));
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
+    // Only add filters if Nepomuk is running
+    if (Nepomuk::ResourceManager::instance()->init() == 0) {
+#endif
+        d->addAction(i18nc("@action:inmenu", "Filter by Rating"), SLOT(addFilterByRating()));
+        d->addAction(i18nc("@action:inmenu", "Filter by Tag"), SLOT(addFilterByTag()));
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
+    }
+#endif
+#endif
+}
+
+FilterController::~FilterController()
+{
+    delete d;
+}
+
+QList<QAction*> FilterController::actionList() const
+{
+    return d->mActionList;
+}
+
+void FilterController::addFilterByName()
+{
+    d->addFilter(new NameFilterWidget(d->mDirModel));
+}
+
+void FilterController::addFilterByDate()
+{
+    d->addFilter(new DateFilterWidget(d->mDirModel));
+}
+
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+void FilterController::addFilterByRating()
+{
+    d->addFilter(new RatingFilterWidget(d->mDirModel));
+}
+
+void FilterController::addFilterByTag()
+{
+    d->addFilter(new TagFilterWidget(d->mDirModel));
+}
+#endif
+
+void FilterController::slotFilterWidgetClosed()
+{
+    d->mFilterWidgetCount--;
+    if (d->mFilterWidgetCount == 0) {
+        d->mFrame->hide();
+    }
+}
 
 } // namespace

=== modified file 'app/filtercontroller.h'
--- app/filtercontroller.h	2011-07-20 13:46:34 +0000
+++ app/filtercontroller.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -35,101 +35,101 @@
 class QAction;
 class QFrame;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class SortedDirModel;
 
-
 struct NameFilterWidgetPrivate;
-class NameFilterWidget : public QWidget {
-	Q_OBJECT
+class NameFilterWidget : public QWidget
+{
+    Q_OBJECT
 public:
-	NameFilterWidget(SortedDirModel*);
-	~NameFilterWidget();
+    NameFilterWidget(SortedDirModel*);
+    ~NameFilterWidget();
 
 private Q_SLOTS:
-	void applyNameFilter();
+    void applyNameFilter();
 
 private:
-	NameFilterWidgetPrivate* const d;
+    NameFilterWidgetPrivate* const d;
 };
 
-
 struct DateFilterWidgetPrivate;
-class DateFilterWidget : public QWidget {
-	Q_OBJECT
+class DateFilterWidget : public QWidget
+{
+    Q_OBJECT
 public:
-	DateFilterWidget(SortedDirModel*);
-	~DateFilterWidget();
+    DateFilterWidget(SortedDirModel*);
+    ~DateFilterWidget();
 
 private Q_SLOTS:
-	void applyDateFilter();
+    void applyDateFilter();
 
 private:
-	DateFilterWidgetPrivate* const d;
+    DateFilterWidgetPrivate* const d;
 };
 
-
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
 class RatingWidgetPrivate;
-class RatingFilterWidget : public QWidget {
-	Q_OBJECT
+class RatingFilterWidget : public QWidget
+{
+    Q_OBJECT
 public:
-	RatingFilterWidget(SortedDirModel*);
-	~RatingFilterWidget();
+    RatingFilterWidget(SortedDirModel*);
+    ~RatingFilterWidget();
 
 private Q_SLOTS:
-	void slotRatingChanged(int value);
-	void updateFilterMode();
+    void slotRatingChanged(int value);
+    void updateFilterMode();
 
 private:
-	RatingWidgetPrivate* const d;
+    RatingWidgetPrivate* const d;
 };
 
-
 class TagFilterWidgetPrivate;
-class TagFilterWidget : public QWidget {
-	Q_OBJECT
+class TagFilterWidget : public QWidget
+{
+    Q_OBJECT
 public:
-	TagFilterWidget(SortedDirModel*);
-	~TagFilterWidget();
+    TagFilterWidget(SortedDirModel*);
+    ~TagFilterWidget();
 
 private Q_SLOTS:
-	void updateTagSetFilter();
+    void updateTagSetFilter();
 
 private:
-	TagFilterWidgetPrivate* const d;
+    TagFilterWidgetPrivate* const d;
 };
 #endif
 
-
 class FilterControllerPrivate;
 /**
  * This class manages the filter widgets in the filter frame and assign the
  * corresponding filters to the SortedDirModel
  */
-class FilterController : public QObject {
-	Q_OBJECT
+class FilterController : public QObject
+{
+    Q_OBJECT
 public:
-	FilterController(QFrame* filterFrame, SortedDirModel* model);
-	~FilterController();
+    FilterController(QFrame* filterFrame, SortedDirModel* model);
+    ~FilterController();
 
-	QList<QAction*> actionList() const;
+    QList<QAction*> actionList() const;
 
 private Q_SLOTS:
-	void addFilterByName();
-	void addFilterByDate();
+    void addFilterByName();
+    void addFilterByDate();
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	void addFilterByRating();
-	void addFilterByTag();
+    void addFilterByRating();
+    void addFilterByTag();
 #endif
-	void slotFilterWidgetClosed();
+    void slotFilterWidgetClosed();
 
 private:
-	FilterControllerPrivate* const d;
+    FilterControllerPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* FILTERCONTROLLER_H */

=== modified file 'app/folderviewcontextmanageritem.cpp'
--- app/folderviewcontextmanageritem.cpp	2011-07-20 13:46:34 +0000
+++ app/folderviewcontextmanageritem.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -46,254 +46,256 @@
 #define MODEL_CLASS SortedDirModel
 #endif
 
-
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 /**
  * This treeview accepts url drops
  */
-class UrlDropTreeView : public QTreeView {
+class UrlDropTreeView : public QTreeView
+{
 public:
-	UrlDropTreeView(QWidget* parent = 0)
-	: QTreeView(parent) {}
+    UrlDropTreeView(QWidget* parent = 0)
+        : QTreeView(parent) {}
 
 protected:
-	void dragEnterEvent(QDragEnterEvent* event) {
-		QAbstractItemView::dragEnterEvent(event);
-		setDirtyRegion(mDropRect);
-		if (event->mimeData()->hasUrls()) {
-			event->acceptProposedAction();
-		}
-	}
-
-
-	void dragMoveEvent(QDragMoveEvent* event) {
-		QAbstractItemView::dragMoveEvent(event);
-
-		QModelIndex index = indexAt(event->pos());
-
-		// This code has been copied from Dolphin
-		// (panels/folders/paneltreeview.cpp)
-		setDirtyRegion(mDropRect);
-		mDropRect = visualRect(index);
-		setDirtyRegion(mDropRect);
-
-		if (index.isValid()) {
-			event->acceptProposedAction();
-		} else {
-			event->ignore();
-		}
-	}
-
-
-	void dropEvent(QDropEvent* event) {
-		const KUrl::List urlList = KUrl::List::fromMimeData(event->mimeData());
-		const QModelIndex index = indexAt(event->pos());
-		if (!index.isValid()) {
-			kWarning() << "Invalid index!";
-			return;
-		}
-		const KUrl destUrl = static_cast<MODEL_CLASS*>(model())->urlForIndex(index);
-		FileOperations::showMenuForDroppedUrls(this, urlList, destUrl);
-	}
+    void dragEnterEvent(QDragEnterEvent* event)
+    {
+        QAbstractItemView::dragEnterEvent(event);
+        setDirtyRegion(mDropRect);
+        if (event->mimeData()->hasUrls()) {
+            event->acceptProposedAction();
+        }
+    }
+
+    void dragMoveEvent(QDragMoveEvent* event)
+    {
+        QAbstractItemView::dragMoveEvent(event);
+
+        QModelIndex index = indexAt(event->pos());
+
+        // This code has been copied from Dolphin
+        // (panels/folders/paneltreeview.cpp)
+        setDirtyRegion(mDropRect);
+        mDropRect = visualRect(index);
+        setDirtyRegion(mDropRect);
+
+        if (index.isValid()) {
+            event->acceptProposedAction();
+        } else {
+            event->ignore();
+        }
+    }
+
+    void dropEvent(QDropEvent* event)
+    {
+        const KUrl::List urlList = KUrl::List::fromMimeData(event->mimeData());
+        const QModelIndex index = indexAt(event->pos());
+        if (!index.isValid()) {
+            kWarning() << "Invalid index!";
+            return;
+        }
+        const KUrl destUrl = static_cast<MODEL_CLASS*>(model())->urlForIndex(index);
+        FileOperations::showMenuForDroppedUrls(this, urlList, destUrl);
+    }
 
 private:
-	QRect mDropRect;
+    QRect mDropRect;
 };
 
-
 struct FolderViewContextManagerItemPrivate {
-	FolderViewContextManagerItem* q;
-	MODEL_CLASS* mModel;
-	QTreeView* mView;
-
-	KUrl mUrlToSelect;
-	QPersistentModelIndex mExpandingIndex;
-
-	void setupModel() {
-		mModel = new MODEL_CLASS(q);
-		mView->setModel(mModel);
-		#ifndef USE_PLACETREE
-		for (int col = 1; col <= mModel->columnCount(); ++col) {
-			mView->header()->setSectionHidden(col, true);
-		}
-		mModel->dirLister()->openUrl(KUrl("/"));
-		#endif
-		QObject::connect(mModel, SIGNAL(rowsInserted(const QModelIndex&, int, int)),
-			q, SLOT(slotRowsInserted(const QModelIndex&, int, int)));
-	}
-
-	void setupView() {
-		mView = new UrlDropTreeView;
-		mView->setEditTriggers(QAbstractItemView::NoEditTriggers);
-		mView->setAcceptDrops(true);
-		mView->setVerticalScrollMode(QAbstractItemView::ScrollPerPixel);
-		mView->setHorizontalScrollMode(QAbstractItemView::ScrollPerPixel);
-
-		// Necessary to get the drop target highlighted
-		mView->viewport()->setAttribute(Qt::WA_Hover);
-
-		mView->setHeaderHidden(true);
-
-		// This is tricky: QTreeView header has stretchLastSection set to true.
-		// In this configuration, the header gets quite wide and cause an
-		// horizontal scrollbar to appear.
-		// To avoid this, set stretchLastSection to false and resizeMode to
-		// Stretch (we still want the column to take the full width of the
-		// widget).
-		mView->header()->setStretchLastSection(false);
-		mView->header()->setResizeMode(QHeaderView::ResizeToContents);
-
-		q->setWidget(mView);
-		QObject::connect(mView, SIGNAL(activated(const QModelIndex&)),
-			q, SLOT(slotActivated(const QModelIndex&)));
-		EventWatcher::install(mView, QEvent::Show, q, SLOT(expandToSelectedUrl()));
-	}
-
-	QModelIndex findClosestIndex(const QModelIndex& parent, const KUrl& wantedUrl) {
-		Q_ASSERT(mModel);
-		QModelIndex index = parent;
-		if (!index.isValid()) {
-			index = findRootIndex(wantedUrl);
-			if (!index.isValid()) {
-				return QModelIndex();
-			}
-		}
-
-		bool isParent;
-		KUrl url = mModel->urlForIndex(index);
-		QString relativePath = KUrl::relativePath(url.path(), wantedUrl.path(), &isParent);
-		if (!isParent) {
-			kWarning() << url << "is not a parent of" << wantedUrl << "!";
-			return QModelIndex();
-		}
-
-		QModelIndex lastFoundIndex = index;
-		Q_FOREACH(const QString& pathPart, relativePath.mid(1).split('/', QString::SkipEmptyParts)) {
-			bool found = false;
-			for (int row = 0; row < mModel->rowCount(lastFoundIndex); ++row) {
-				QModelIndex index = mModel->index(row, 0, lastFoundIndex);
-				if (index.data().toString() == pathPart) {
-					// FIXME: Check encoding
-					found = true;
-					lastFoundIndex = index;
-					break;
-				}
-			}
-			if (!found) {
-				break;
-			}
-		}
-		return lastFoundIndex;
-	}
-
-
-	QModelIndex findRootIndex(const KUrl& wantedUrl) {
-		QModelIndex matchIndex;
-		int matchUrlLength = 0;
-		for (int row = 0; row < mModel->rowCount(); ++row) {
-			QModelIndex index = mModel->index(row, 0);
-			KUrl url = mModel->urlForIndex(index);
-			int urlLength = url.url().length();
-			if (url.isParentOf(wantedUrl) && urlLength > matchUrlLength) {
-				matchIndex = index;
-				matchUrlLength = urlLength;
-			}
-		}
-		if (!matchIndex.isValid()) {
-			kWarning() << "Found no root index for" << wantedUrl;
-		}
-		return matchIndex;
-	}
+    FolderViewContextManagerItem* q;
+    MODEL_CLASS* mModel;
+    QTreeView* mView;
+
+    KUrl mUrlToSelect;
+    QPersistentModelIndex mExpandingIndex;
+
+    void setupModel()
+    {
+        mModel = new MODEL_CLASS(q);
+        mView->setModel(mModel);
+#ifndef USE_PLACETREE
+        for (int col = 1; col <= mModel->columnCount(); ++col) {
+            mView->header()->setSectionHidden(col, true);
+        }
+        mModel->dirLister()->openUrl(KUrl("/"));
+#endif
+        QObject::connect(mModel, SIGNAL(rowsInserted(QModelIndex, int, int)),
+                         q, SLOT(slotRowsInserted(QModelIndex, int, int)));
+    }
+
+    void setupView()
+    {
+        mView = new UrlDropTreeView;
+        mView->setEditTriggers(QAbstractItemView::NoEditTriggers);
+        mView->setAcceptDrops(true);
+        mView->setVerticalScrollMode(QAbstractItemView::ScrollPerPixel);
+        mView->setHorizontalScrollMode(QAbstractItemView::ScrollPerPixel);
+
+        // Necessary to get the drop target highlighted
+        mView->viewport()->setAttribute(Qt::WA_Hover);
+
+        mView->setHeaderHidden(true);
+
+        // This is tricky: QTreeView header has stretchLastSection set to true.
+        // In this configuration, the header gets quite wide and cause an
+        // horizontal scrollbar to appear.
+        // To avoid this, set stretchLastSection to false and resizeMode to
+        // Stretch (we still want the column to take the full width of the
+        // widget).
+        mView->header()->setStretchLastSection(false);
+        mView->header()->setResizeMode(QHeaderView::ResizeToContents);
+
+        q->setWidget(mView);
+        QObject::connect(mView, SIGNAL(activated(QModelIndex)),
+                         q, SLOT(slotActivated(QModelIndex)));
+        EventWatcher::install(mView, QEvent::Show, q, SLOT(expandToSelectedUrl()));
+    }
+
+    QModelIndex findClosestIndex(const QModelIndex& parent, const KUrl& wantedUrl)
+    {
+        Q_ASSERT(mModel);
+        QModelIndex index = parent;
+        if (!index.isValid()) {
+            index = findRootIndex(wantedUrl);
+            if (!index.isValid()) {
+                return QModelIndex();
+            }
+        }
+
+        bool isParent;
+        KUrl url = mModel->urlForIndex(index);
+        QString relativePath = KUrl::relativePath(url.path(), wantedUrl.path(), &isParent);
+        if (!isParent) {
+            kWarning() << url << "is not a parent of" << wantedUrl << "!";
+            return QModelIndex();
+        }
+
+        QModelIndex lastFoundIndex = index;
+        Q_FOREACH(const QString & pathPart, relativePath.mid(1).split('/', QString::SkipEmptyParts)) {
+            bool found = false;
+            for (int row = 0; row < mModel->rowCount(lastFoundIndex); ++row) {
+                QModelIndex index = mModel->index(row, 0, lastFoundIndex);
+                if (index.data().toString() == pathPart) {
+                    // FIXME: Check encoding
+                    found = true;
+                    lastFoundIndex = index;
+                    break;
+                }
+            }
+            if (!found) {
+                break;
+            }
+        }
+        return lastFoundIndex;
+    }
+
+    QModelIndex findRootIndex(const KUrl& wantedUrl)
+    {
+        QModelIndex matchIndex;
+        int matchUrlLength = 0;
+        for (int row = 0; row < mModel->rowCount(); ++row) {
+            QModelIndex index = mModel->index(row, 0);
+            KUrl url = mModel->urlForIndex(index);
+            int urlLength = url.url().length();
+            if (url.isParentOf(wantedUrl) && urlLength > matchUrlLength) {
+                matchIndex = index;
+                matchUrlLength = urlLength;
+            }
+        }
+        if (!matchIndex.isValid()) {
+            kWarning() << "Found no root index for" << wantedUrl;
+        }
+        return matchIndex;
+    }
 };
 
-
 FolderViewContextManagerItem::FolderViewContextManagerItem(ContextManager* manager)
 : AbstractContextManagerItem(manager)
-, d(new FolderViewContextManagerItemPrivate) {
-	d->q = this;
-	d->mModel = 0;
-
-	d->setupView();
-
-	connect(contextManager(), SIGNAL(currentDirUrlChanged()),
-		SLOT(slotCurrentDirUrlChanged()) );
-}
-
-
-FolderViewContextManagerItem::~FolderViewContextManagerItem() {
-	delete d;
-}
-
-
-void FolderViewContextManagerItem::slotCurrentDirUrlChanged() {
-	KUrl url = contextManager()->currentDirUrl();
-	if (url.isValid() && d->mUrlToSelect != url) {
-		d->mUrlToSelect = url;
-		d->mUrlToSelect.cleanPath();
-		d->mUrlToSelect.adjustPath(KUrl::RemoveTrailingSlash);
-		d->mExpandingIndex = QModelIndex();
-	}
-	if (!d->mView->isVisible()) {
-		return;
-	}
-
-	expandToSelectedUrl();
-}
-
-
-void FolderViewContextManagerItem::expandToSelectedUrl() {
-	if (!d->mUrlToSelect.isValid()) {
-		return;
-	}
-
-	if (!d->mModel) {
-		d->setupModel();
-	}
-
-	QModelIndex index = d->findClosestIndex(d->mExpandingIndex, d->mUrlToSelect);
-	if (!index.isValid()) {
-		return;
-	}
-	d->mExpandingIndex = index;
-
-	KUrl url = d->mModel->urlForIndex(d->mExpandingIndex);
-	if (d->mUrlToSelect == url) {
-		// We found our url
-		QItemSelectionModel* selModel = d->mView->selectionModel();
-		selModel->setCurrentIndex(d->mExpandingIndex, QItemSelectionModel::ClearAndSelect);
-		d->mView->scrollTo(d->mExpandingIndex);
-		d->mUrlToSelect = KUrl();
-		d->mExpandingIndex = QModelIndex();
-	} else {
-		// We found a parent of our url
-		d->mView->setExpanded(d->mExpandingIndex, true);
-	}
-}
-
-
-void FolderViewContextManagerItem::slotRowsInserted(const QModelIndex& parentIndex, int /*start*/, int /*end*/) {
-	// Can't trigger the case where parentIndex is invalid, but it most
-	// probably happen when root items are created. In this case we trigger
-	// expandToSelectedUrl without checking the url.
-	// See bug #191771
-	if (!parentIndex.isValid() || d->mModel->urlForIndex(parentIndex).isParentOf(d->mUrlToSelect)) {
-		d->mExpandingIndex = parentIndex;
-		// Hack because otherwise indexes are not in correct order!
-		QMetaObject::invokeMethod(this, "expandToSelectedUrl", Qt::QueuedConnection);
-	}
-}
-
-
-void FolderViewContextManagerItem::slotActivated(const QModelIndex& index) {
-	if (!index.isValid()) {
-		return;
-	}
-
-	KUrl url = d->mModel->urlForIndex(index);
-	emit urlChanged(url);
-}
-
+, d(new FolderViewContextManagerItemPrivate)
+{
+    d->q = this;
+    d->mModel = 0;
+
+    d->setupView();
+
+    connect(contextManager(), SIGNAL(currentDirUrlChanged()),
+            SLOT(slotCurrentDirUrlChanged()));
+}
+
+FolderViewContextManagerItem::~FolderViewContextManagerItem()
+{
+    delete d;
+}
+
+void FolderViewContextManagerItem::slotCurrentDirUrlChanged()
+{
+    KUrl url = contextManager()->currentDirUrl();
+    if (url.isValid() && d->mUrlToSelect != url) {
+        d->mUrlToSelect = url;
+        d->mUrlToSelect.cleanPath();
+        d->mUrlToSelect.adjustPath(KUrl::RemoveTrailingSlash);
+        d->mExpandingIndex = QModelIndex();
+    }
+    if (!d->mView->isVisible()) {
+        return;
+    }
+
+    expandToSelectedUrl();
+}
+
+void FolderViewContextManagerItem::expandToSelectedUrl()
+{
+    if (!d->mUrlToSelect.isValid()) {
+        return;
+    }
+
+    if (!d->mModel) {
+        d->setupModel();
+    }
+
+    QModelIndex index = d->findClosestIndex(d->mExpandingIndex, d->mUrlToSelect);
+    if (!index.isValid()) {
+        return;
+    }
+    d->mExpandingIndex = index;
+
+    KUrl url = d->mModel->urlForIndex(d->mExpandingIndex);
+    if (d->mUrlToSelect == url) {
+        // We found our url
+        QItemSelectionModel* selModel = d->mView->selectionModel();
+        selModel->setCurrentIndex(d->mExpandingIndex, QItemSelectionModel::ClearAndSelect);
+        d->mView->scrollTo(d->mExpandingIndex);
+        d->mUrlToSelect = KUrl();
+        d->mExpandingIndex = QModelIndex();
+    } else {
+        // We found a parent of our url
+        d->mView->setExpanded(d->mExpandingIndex, true);
+    }
+}
+
+void FolderViewContextManagerItem::slotRowsInserted(const QModelIndex& parentIndex, int /*start*/, int /*end*/)
+{
+    // Can't trigger the case where parentIndex is invalid, but it most
+    // probably happen when root items are created. In this case we trigger
+    // expandToSelectedUrl without checking the url.
+    // See bug #191771
+    if (!parentIndex.isValid() || d->mModel->urlForIndex(parentIndex).isParentOf(d->mUrlToSelect)) {
+        d->mExpandingIndex = parentIndex;
+        // Hack because otherwise indexes are not in correct order!
+        QMetaObject::invokeMethod(this, "expandToSelectedUrl", Qt::QueuedConnection);
+    }
+}
+
+void FolderViewContextManagerItem::slotActivated(const QModelIndex& index)
+{
+    if (!index.isValid()) {
+        return;
+    }
+
+    KUrl url = d->mModel->urlForIndex(index);
+    emit urlChanged(url);
+}
 
 } // namespace

=== modified file 'app/folderviewcontextmanageritem.h'
--- app/folderviewcontextmanageritem.h	2011-07-20 13:46:34 +0000
+++ app/folderviewcontextmanageritem.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -32,31 +32,31 @@
 
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct FolderViewContextManagerItemPrivate;
-class FolderViewContextManagerItem : public AbstractContextManagerItem {
-	Q_OBJECT
+class FolderViewContextManagerItem : public AbstractContextManagerItem
+{
+    Q_OBJECT
 public:
-	FolderViewContextManagerItem(ContextManager*);
-	~FolderViewContextManagerItem();
+    FolderViewContextManagerItem(ContextManager*);
+    ~FolderViewContextManagerItem();
 
 Q_SIGNALS:
-	void urlChanged(const KUrl&);
+    void urlChanged(const KUrl&);
 
 private Q_SLOTS:
-	void slotCurrentDirUrlChanged();
-	void expandToSelectedUrl();
-	void slotRowsInserted(const QModelIndex&, int start, int end);
-	void slotActivated(const QModelIndex&);
+    void slotCurrentDirUrlChanged();
+    void expandToSelectedUrl();
+    void slotRowsInserted(const QModelIndex&, int start, int end);
+    void slotActivated(const QModelIndex&);
 
 private:
-	friend class FolderViewContextManagerItemPrivate;
-	FolderViewContextManagerItemPrivate* const d;
+    friend class FolderViewContextManagerItemPrivate;
+    FolderViewContextManagerItemPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* FOLDERVIEWCONTEXTMANAGERITEM_H */

=== modified file 'app/fullscreencontent.cpp'
--- app/fullscreencontent.cpp	2011-07-20 13:46:34 +0000
+++ app/fullscreencontent.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -50,376 +50,382 @@
 #include <lib/thumbnailview/thumbnailbarview.h>
 #include <lib/slideshow.h>
 
-
-namespace Gwenview {
+namespace Gwenview
+{
 
 // Subclass QToolButton to make initStyleOption public
-class ButtonBarButton : public QToolButton {
+class ButtonBarButton : public QToolButton
+{
 public:
-	void initStyleOption(QStyleOptionToolButton* option) const {
-		return QToolButton::initStyleOption(option);
-	}
+    void initStyleOption(QStyleOptionToolButton* option) const
+    {
+        return QToolButton::initStyleOption(option);
+    }
 };
 
-static QToolButton* createButtonBarButton() {
-
-	ButtonBarButton* button = new ButtonBarButton;
-	QSize iconSize = QSize(32, 32);
-	button->setIconSize(iconSize);
-
-	// When the action icon changes, the button gets a few pixels larger. This
-	// is probably caused by the css styling.
-	// Setting a fixed size prevents this problem.
-	QStyleOptionToolButton opt;
-	button->initStyleOption(&opt);
-	QSize buttonSize = button->style()
-		->sizeFromContents(QStyle::CT_ToolButton, &opt, iconSize, button)
-		.expandedTo(QApplication::globalStrut());
-	button->setFixedSize(buttonSize);
-	return button;
+static QToolButton* createButtonBarButton()
+{
+
+    ButtonBarButton* button = new ButtonBarButton;
+    QSize iconSize = QSize(32, 32);
+    button->setIconSize(iconSize);
+
+    // When the action icon changes, the button gets a few pixels larger. This
+    // is probably caused by the css styling.
+    // Setting a fixed size prevents this problem.
+    QStyleOptionToolButton opt;
+    button->initStyleOption(&opt);
+    QSize buttonSize = button->style()
+                       ->sizeFromContents(QStyle::CT_ToolButton, &opt, iconSize, button)
+                       .expandedTo(QApplication::globalStrut());
+    button->setFixedSize(buttonSize);
+    return button;
 }
 
-
-class FullScreenConfigDialog : public QFrame, public Ui_FullScreenConfigDialog {
+class FullScreenConfigDialog : public QFrame, public Ui_FullScreenConfigDialog
+{
 public:
-	FullScreenConfigDialog(QWidget* parent)
-	: QFrame(parent) {
-		setWindowFlags(Qt::Popup);
-		setupUi(this);
-	}
+    FullScreenConfigDialog(QWidget* parent)
+        : QFrame(parent) {
+        setWindowFlags(Qt::Popup);
+        setupUi(this);
+    }
 };
 
-
 struct FullScreenContentPrivate {
-	FullScreenContent* that;
-	FullScreenBar* mFullScreenBar;
-	SlideShow* mSlideShow;
-	QWidget* mButtonBar;
-	ThumbnailBarView* mThumbnailBar;
-	QLabel* mInformationLabel;
-	Document::Ptr mCurrentDocument;
-	QPointer<ImageMetaInfoDialog> mImageMetaInfoDialog;
-	QPointer<FullScreenConfigDialog> mFullScreenConfigDialog;
-	QToolButton* mOptionsButton;
-
-	void createOptionsButton() {
-		mOptionsButton = createButtonBarButton();
-		mOptionsButton->setIcon(KIcon("configure"));
-		mOptionsButton->setToolTip(i18nc("@info:tooltip", "Configure Full Screen Mode"));
-		QObject::connect(mOptionsButton, SIGNAL(clicked()),
-			that, SLOT(showFullScreenConfigDialog()) );
-	}
-
-	void setupThemeListWidget(QListWidget* listWidget) {
-		QStringList themeList = FullScreenTheme::themeNameList();
-		listWidget->addItems(themeList);
-		int row = themeList.indexOf(FullScreenTheme::currentThemeName());
-		listWidget->setCurrentRow(row);
-
-		QObject::connect(listWidget, SIGNAL(currentTextChanged(const QString&)),
-			that, SLOT(setCurrentFullScreenTheme(const QString&)) );
-	}
-
-	void applyCurrentFullScreenTheme() {
-		FullScreenTheme theme(FullScreenTheme::currentThemeName());
-		mFullScreenBar->setStyleSheet(theme.styleSheet());
-		const bool fullWidth = GwenviewConfig::showFullScreenThumbnails();
-		mFullScreenBar->setProperty("fullWidth", fullWidth);
-	}
-
-	void createLayout() {
-		mThumbnailBar->setVisible(GwenviewConfig::showFullScreenThumbnails());
-		if (GwenviewConfig::showFullScreenThumbnails()) {
-			/*
-			Layout looks like this:
-			mButtonBar        |
-			------------------| mThumbnailBar
-			mInformationLabel |
-			*/
-			mInformationLabel->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
-			QGridLayout* layout = new QGridLayout(mFullScreenBar);
-			layout->setMargin(0);
-			layout->setSpacing(0);
-			layout->addWidget(mButtonBar, 0, 0, Qt::AlignTop | Qt::AlignLeft);
-			layout->addWidget(mInformationLabel, 1, 0);
-			layout->addWidget(mThumbnailBar, 0, 1, 2, 1);
-			mFullScreenBar->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
-			mFullScreenBar->setFixedHeight(GwenviewConfig::fullScreenBarHeight());
-		} else {
-			mInformationLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
-			QHBoxLayout* layout = new QHBoxLayout(mFullScreenBar);
-			layout->setMargin(0);
-			layout->setSpacing(2);
-			layout->addWidget(mButtonBar);
-			layout->addWidget(mInformationLabel);
-			mFullScreenBar->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
-			mFullScreenBar->setFixedHeight(layout->minimumSize().height());
-		}
-		mFullScreenBar->adjustSize();
-		applyCurrentFullScreenTheme();
-	}
-
-
-	void adjustBarWidth() {
-		if (GwenviewConfig::showFullScreenThumbnails()) {
-			return;
-		}
-		mFullScreenBar->adjustSize();
-	}
+    FullScreenContent* q;
+    FullScreenBar* mFullScreenBar;
+    SlideShow* mSlideShow;
+    QWidget* mButtonBar;
+    ThumbnailBarView* mThumbnailBar;
+    QLabel* mInformationLabel;
+    Document::Ptr mCurrentDocument;
+    QPointer<ImageMetaInfoDialog> mImageMetaInfoDialog;
+    QPointer<FullScreenConfigDialog> mFullScreenConfigDialog;
+    QToolButton* mOptionsButton;
+
+    void createOptionsButton()
+    {
+        mOptionsButton = createButtonBarButton();
+        mOptionsButton->setIcon(KIcon("configure"));
+        mOptionsButton->setToolTip(i18nc("@info:tooltip", "Configure Full Screen Mode"));
+        QObject::connect(mOptionsButton, SIGNAL(clicked()),
+                         q, SLOT(showFullScreenConfigDialog()));
+    }
+
+    void setupThemeListWidget(QListWidget* listWidget)
+    {
+        QStringList themeList = FullScreenTheme::themeNameList();
+        listWidget->addItems(themeList);
+        int row = themeList.indexOf(FullScreenTheme::currentThemeName());
+        listWidget->setCurrentRow(row);
+
+        QObject::connect(listWidget, SIGNAL(currentTextChanged(QString)),
+                         q, SLOT(setCurrentFullScreenTheme(QString)));
+    }
+
+    void applyCurrentFullScreenTheme()
+    {
+        FullScreenTheme theme(FullScreenTheme::currentThemeName());
+        mFullScreenBar->setStyleSheet(theme.styleSheet());
+        const bool fullWidth = GwenviewConfig::showFullScreenThumbnails();
+        mFullScreenBar->setProperty("fullWidth", fullWidth);
+    }
+
+    void createLayout()
+    {
+        mThumbnailBar->setVisible(GwenviewConfig::showFullScreenThumbnails());
+        if (GwenviewConfig::showFullScreenThumbnails()) {
+            /*
+            Layout looks like this:
+            mButtonBar        |
+            ------------------| mThumbnailBar
+            mInformationLabel |
+            */
+            mInformationLabel->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
+            QGridLayout* layout = new QGridLayout(mFullScreenBar);
+            layout->setMargin(0);
+            layout->setSpacing(0);
+            layout->addWidget(mButtonBar, 0, 0, Qt::AlignTop | Qt::AlignLeft);
+            layout->addWidget(mInformationLabel, 1, 0);
+            layout->addWidget(mThumbnailBar, 0, 1, 2, 1);
+            mFullScreenBar->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
+            mFullScreenBar->setFixedHeight(GwenviewConfig::fullScreenBarHeight());
+        } else {
+            mInformationLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
+            QHBoxLayout* layout = new QHBoxLayout(mFullScreenBar);
+            layout->setMargin(0);
+            layout->setSpacing(2);
+            layout->addWidget(mButtonBar);
+            layout->addWidget(mInformationLabel);
+            mFullScreenBar->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
+            mFullScreenBar->setFixedHeight(layout->minimumSize().height());
+        }
+        mFullScreenBar->adjustSize();
+        applyCurrentFullScreenTheme();
+    }
+
+    void adjustBarWidth()
+    {
+        if (GwenviewConfig::showFullScreenThumbnails()) {
+            return;
+        }
+        mFullScreenBar->adjustSize();
+    }
 };
 
-
 FullScreenContent::FullScreenContent(FullScreenBar* bar, KActionCollection* actionCollection, SlideShow* slideShow)
 : QObject(bar)
-, d(new FullScreenContentPrivate) {
-	d->that = this;
-	d->mFullScreenBar = bar;
-	d->mSlideShow = slideShow;
-	bar->installEventFilter(this);
-
-	// Hardcode base style. This is necessary because some styles like
-	// to paint stuff with an event filter rather than overloading QStyle
-	// methods, overwriting the stylesheet rendering.
-	// Oxygen is one of those styles.
-	QStyle* style = new QWindowsStyle;
-	d->mFullScreenBar->setStyle(style);
-	style->setParent(d->mFullScreenBar);
-
-	// Apply theme
-	d->applyCurrentFullScreenTheme();
-
-	// Button bar
-	d->mButtonBar = new QWidget;
-	d->mButtonBar->setObjectName( QLatin1String("buttonBar" ));
-	QHBoxLayout* buttonBarLayout = new QHBoxLayout(d->mButtonBar);
-	buttonBarLayout->setMargin(0);
-	buttonBarLayout->setSpacing(0);
-	QStringList actionNameList;
-	actionNameList
-		<< "fullscreen"
-		<< "toggle_slideshow"
-		<< "go_previous"
-		<< "go_next"
-		<< "rotate_left"
-		<< "rotate_right"
-		;
-	Q_FOREACH(const QString& actionName, actionNameList) {
-		QAction* action = actionCollection->action(actionName);
-		QToolButton* button = createButtonBarButton();
-		button->setDefaultAction(action);
-		buttonBarLayout->addWidget(button);
-	}
-
-	d->createOptionsButton();
-	buttonBarLayout->addWidget(d->mOptionsButton);
-
-	// Thumbnail bar
-	d->mThumbnailBar = new ThumbnailBarView(bar);
-	ThumbnailBarItemDelegate* delegate = new ThumbnailBarItemDelegate(d->mThumbnailBar);
-	d->mThumbnailBar->setItemDelegate(delegate);
-	d->mThumbnailBar->setSelectionMode(QAbstractItemView::ExtendedSelection);
-
-	// mInformationLabel
-	d->mInformationLabel = new QLabel;
-	d->mInformationLabel->setWordWrap(true);
-	d->mInformationLabel->setAlignment(Qt::AlignCenter);
-
-	d->createLayout();
-}
-
-
-FullScreenContent::~FullScreenContent() {
-	delete d;
-}
-
-
-ThumbnailBarView* FullScreenContent::thumbnailBar() const {
-	return d->mThumbnailBar;
-}
-
-
-void FullScreenContent::setCurrentUrl(const KUrl& url) {
-	d->mCurrentDocument = DocumentFactory::instance()->load(url);
-	connect(d->mCurrentDocument.data(),SIGNAL(metaInfoUpdated()),
-		SLOT(updateInformationLabel()) );
-	connect(d->mCurrentDocument.data(),SIGNAL(metaInfoUpdated()),
-		SLOT(updateMetaInfoDialog()) );
-	updateInformationLabel();
-	updateMetaInfoDialog();
-}
-
-
-void FullScreenContent::updateInformationLabel() {
-	if (!d->mCurrentDocument) {
-		kWarning() << "No document";
-		return;
-	}
-
-	if (!d->mInformationLabel->isVisible()) {
-		return;
-	}
-
-	ImageMetaInfoModel* model = d->mCurrentDocument->metaInfo();
-
-	QStringList valueList;
-	Q_FOREACH(const QString& key, GwenviewConfig::fullScreenPreferredMetaInfoKeyList()) {
-		const QString value = model->getValueForKey(key);
-		if (value.length() > 0) {
-			valueList << value;
-		}
-	}
-	QString text = valueList.join(i18nc("@item:intext fullscreen meta info separator", ", "));
-
-	d->mInformationLabel->setText(text);
-
-	d->adjustBarWidth();
-}
-
-
-void FullScreenContent::setCurrentFullScreenTheme(const QString& themeName) {
-	FullScreenTheme::setCurrentThemeName(themeName);
-	d->applyCurrentFullScreenTheme();
-}
-
-
-bool FullScreenContent::eventFilter(QObject*, QEvent* event) {
-	if (event->type() == QEvent::Show) {
-		updateInformationLabel();
-		updateMetaInfoDialog();
-	}
-	return false;
-}
-
-
-void FullScreenContent::showImageMetaInfoDialog() {
-	if (!d->mImageMetaInfoDialog) {
-		d->mImageMetaInfoDialog = new ImageMetaInfoDialog(d->mInformationLabel);
-		// Do not let the fullscreen theme propagate to this dialog for now,
-		// it's already quite complicated to create a theme
-		d->mImageMetaInfoDialog->setStyle(QApplication::style());
-		d->mImageMetaInfoDialog->setAttribute(Qt::WA_DeleteOnClose, true);
-		connect(d->mImageMetaInfoDialog, SIGNAL(preferredMetaInfoKeyListChanged(const QStringList&)),
-			SLOT(slotPreferredMetaInfoKeyListChanged(const QStringList&)) );
-		connect(d->mImageMetaInfoDialog, SIGNAL(destroyed()),
-			SLOT(enableAutoHiding()) );
-	}
-	if (d->mCurrentDocument) {
-		d->mImageMetaInfoDialog->setMetaInfo(d->mCurrentDocument->metaInfo(), GwenviewConfig::fullScreenPreferredMetaInfoKeyList());
-	}
-	d->mFullScreenBar->setAutoHidingEnabled(false);
-	d->mImageMetaInfoDialog->show();
-}
-
-
-void FullScreenContent::slotPreferredMetaInfoKeyListChanged(const QStringList& list) {
-	GwenviewConfig::setFullScreenPreferredMetaInfoKeyList(list);
-	GwenviewConfig::self()->writeConfig();
-	updateInformationLabel();
-}
-
-
-void FullScreenContent::updateMetaInfoDialog() {
-	if (!d->mImageMetaInfoDialog) {
-		return;
-	}
-	ImageMetaInfoModel* model = d->mCurrentDocument ? d->mCurrentDocument->metaInfo() : 0;
-	d->mImageMetaInfoDialog->setMetaInfo(model, GwenviewConfig::fullScreenPreferredMetaInfoKeyList());
-}
-
-
-static QString formatSlideShowIntervalText(int value) {
-	return i18ncp("Slideshow interval in seconds", "%1 sec", "%1 secs", value);
-}
-
-
-void FullScreenContent::updateSlideShowIntervalLabel() {
-	Q_ASSERT(d->mFullScreenConfigDialog);
-	int value = d->mFullScreenConfigDialog->mSlideShowIntervalSlider->value();
-	QString text = formatSlideShowIntervalText(value);
-	d->mFullScreenConfigDialog->mSlideShowIntervalLabel->setText(text);
-}
-
-
-void FullScreenContent::setFullScreenBarHeight(int value) {
-	d->mFullScreenBar->setFixedHeight(value);
-	GwenviewConfig::setFullScreenBarHeight(value);
-}
-
+, d(new FullScreenContentPrivate)
+{
+    d->q = this;
+    d->mFullScreenBar = bar;
+    d->mSlideShow = slideShow;
+    bar->installEventFilter(this);
+
+    // Hardcode base style. This is necessary because some styles like
+    // to paint stuff with an event filter rather than overloading QStyle
+    // methods, overwriting the stylesheet rendering.
+    // Oxygen is one of those styles.
+    QStyle* style = new QWindowsStyle;
+    d->mFullScreenBar->setStyle(style);
+    style->setParent(d->mFullScreenBar);
+
+    // Apply theme
+    d->applyCurrentFullScreenTheme();
+
+    // Button bar
+    d->mButtonBar = new QWidget;
+    d->mButtonBar->setObjectName(QLatin1String("buttonBar"));
+    QHBoxLayout* buttonBarLayout = new QHBoxLayout(d->mButtonBar);
+    buttonBarLayout->setMargin(0);
+    buttonBarLayout->setSpacing(0);
+    QStringList actionNameList;
+    actionNameList
+            << "fullscreen"
+            << "toggle_slideshow"
+            << "go_previous"
+            << "go_next"
+            << "rotate_left"
+            << "rotate_right"
+            ;
+    Q_FOREACH(const QString & actionName, actionNameList) {
+        QAction* action = actionCollection->action(actionName);
+        QToolButton* button = createButtonBarButton();
+        button->setDefaultAction(action);
+        buttonBarLayout->addWidget(button);
+    }
+
+    d->createOptionsButton();
+    buttonBarLayout->addWidget(d->mOptionsButton);
+
+    // Thumbnail bar
+    d->mThumbnailBar = new ThumbnailBarView(bar);
+    ThumbnailBarItemDelegate* delegate = new ThumbnailBarItemDelegate(d->mThumbnailBar);
+    d->mThumbnailBar->setItemDelegate(delegate);
+    d->mThumbnailBar->setSelectionMode(QAbstractItemView::ExtendedSelection);
+
+    // mInformationLabel
+    d->mInformationLabel = new QLabel;
+    d->mInformationLabel->setWordWrap(true);
+    d->mInformationLabel->setAlignment(Qt::AlignCenter);
+
+    d->createLayout();
+}
+
+FullScreenContent::~FullScreenContent()
+{
+    delete d;
+}
+
+ThumbnailBarView* FullScreenContent::thumbnailBar() const
+{
+    return d->mThumbnailBar;
+}
+
+void FullScreenContent::setCurrentUrl(const KUrl& url)
+{
+    d->mCurrentDocument = DocumentFactory::instance()->load(url);
+    connect(d->mCurrentDocument.data(), SIGNAL(metaInfoUpdated()),
+            SLOT(updateInformationLabel()));
+    connect(d->mCurrentDocument.data(), SIGNAL(metaInfoUpdated()),
+            SLOT(updateMetaInfoDialog()));
+    updateInformationLabel();
+    updateMetaInfoDialog();
+}
+
+void FullScreenContent::updateInformationLabel()
+{
+    if (!d->mCurrentDocument) {
+        kWarning() << "No document";
+        return;
+    }
+
+    if (!d->mInformationLabel->isVisible()) {
+        return;
+    }
+
+    ImageMetaInfoModel* model = d->mCurrentDocument->metaInfo();
+
+    QStringList valueList;
+    Q_FOREACH(const QString & key, GwenviewConfig::fullScreenPreferredMetaInfoKeyList()) {
+        const QString value = model->getValueForKey(key);
+        if (value.length() > 0) {
+            valueList << value;
+        }
+    }
+    QString text = valueList.join(i18nc("@item:intext fullscreen meta info separator", ", "));
+
+    d->mInformationLabel->setText(text);
+
+    d->adjustBarWidth();
+}
+
+void FullScreenContent::setCurrentFullScreenTheme(const QString& themeName)
+{
+    FullScreenTheme::setCurrentThemeName(themeName);
+    d->applyCurrentFullScreenTheme();
+}
+
+bool FullScreenContent::eventFilter(QObject*, QEvent* event)
+{
+    if (event->type() == QEvent::Show) {
+        updateInformationLabel();
+        updateMetaInfoDialog();
+    }
+    return false;
+}
+
+void FullScreenContent::showImageMetaInfoDialog()
+{
+    if (!d->mImageMetaInfoDialog) {
+        d->mImageMetaInfoDialog = new ImageMetaInfoDialog(d->mInformationLabel);
+        // Do not let the fullscreen theme propagate to this dialog for now,
+        // it's already quite complicated to create a theme
+        d->mImageMetaInfoDialog->setStyle(QApplication::style());
+        d->mImageMetaInfoDialog->setAttribute(Qt::WA_DeleteOnClose, true);
+        connect(d->mImageMetaInfoDialog, SIGNAL(preferredMetaInfoKeyListChanged(QStringList)),
+                SLOT(slotPreferredMetaInfoKeyListChanged(QStringList)));
+        connect(d->mImageMetaInfoDialog, SIGNAL(destroyed()),
+                SLOT(enableAutoHiding()));
+    }
+    if (d->mCurrentDocument) {
+        d->mImageMetaInfoDialog->setMetaInfo(d->mCurrentDocument->metaInfo(), GwenviewConfig::fullScreenPreferredMetaInfoKeyList());
+    }
+    d->mFullScreenBar->setAutoHidingEnabled(false);
+    d->mImageMetaInfoDialog->show();
+}
+
+void FullScreenContent::slotPreferredMetaInfoKeyListChanged(const QStringList& list)
+{
+    GwenviewConfig::setFullScreenPreferredMetaInfoKeyList(list);
+    GwenviewConfig::self()->writeConfig();
+    updateInformationLabel();
+}
+
+void FullScreenContent::updateMetaInfoDialog()
+{
+    if (!d->mImageMetaInfoDialog) {
+        return;
+    }
+    ImageMetaInfoModel* model = d->mCurrentDocument ? d->mCurrentDocument->metaInfo() : 0;
+    d->mImageMetaInfoDialog->setMetaInfo(model, GwenviewConfig::fullScreenPreferredMetaInfoKeyList());
+}
+
+static QString formatSlideShowIntervalText(int value)
+{
+    return i18ncp("Slideshow interval in seconds", "%1 sec", "%1 secs", value);
+}
+
+void FullScreenContent::updateSlideShowIntervalLabel()
+{
+    Q_ASSERT(d->mFullScreenConfigDialog);
+    int value = d->mFullScreenConfigDialog->mSlideShowIntervalSlider->value();
+    QString text = formatSlideShowIntervalText(value);
+    d->mFullScreenConfigDialog->mSlideShowIntervalLabel->setText(text);
+}
+
+void FullScreenContent::setFullScreenBarHeight(int value)
+{
+    d->mFullScreenBar->setFixedHeight(value);
+    GwenviewConfig::setFullScreenBarHeight(value);
+}
 
 /**
  * Helper function for showFullScreenConfigDialog
  */
-static void setupCheckBox(QCheckBox* checkBox, QAction* action) {
-	checkBox->setChecked(action->isChecked());
-	QObject::connect(checkBox, SIGNAL(toggled(bool)),
-		action, SLOT(trigger()) );
-}
-
-void FullScreenContent::showFullScreenConfigDialog() {
-	FullScreenConfigDialog* dialog = new FullScreenConfigDialog(d->mOptionsButton);
-	d->mFullScreenConfigDialog = dialog;
-	dialog->setAttribute(Qt::WA_DeleteOnClose, true);
-	dialog->setObjectName( QLatin1String("configDialog" ));
-
-	// Checkboxes
-	setupCheckBox(dialog->mSlideShowLoopCheckBox, d->mSlideShow->loopAction());
-	setupCheckBox(dialog->mSlideShowRandomCheckBox, d->mSlideShow->randomAction());
-
-	// Interval slider
-	dialog->mSlideShowIntervalSlider->setValue(int(GwenviewConfig::interval()));
-	connect(dialog->mSlideShowIntervalSlider, SIGNAL(valueChanged(int)),
-		d->mSlideShow, SLOT(setInterval(int)) );
-
-	// Interval label
-	connect(dialog->mSlideShowIntervalSlider, SIGNAL(valueChanged(int)),
-		SLOT(updateSlideShowIntervalLabel()) );
-	QString text = formatSlideShowIntervalText(88);
-	int width = dialog->mSlideShowIntervalLabel->fontMetrics().width(text);
-	dialog->mSlideShowIntervalLabel->setFixedWidth(width);
-	updateSlideShowIntervalLabel();
-
-	// Config button
-	connect(dialog->mConfigureDisplayedInformationButton, SIGNAL(clicked()),
-		SLOT(showImageMetaInfoDialog()) );
-
-	d->setupThemeListWidget(dialog->mThemeListWidget);
-
-	// Thumbnails check box
-	dialog->mShowThumbnailsCheckBox->setChecked(GwenviewConfig::showFullScreenThumbnails());
-	connect(dialog->mShowThumbnailsCheckBox, SIGNAL(toggled(bool)),
-		SLOT(slotShowThumbnailsToggled(bool)));
-
-	// Height slider
-	dialog->mHeightSlider->setValue(d->mFullScreenBar->height());
-	connect(dialog->mHeightSlider, SIGNAL(valueChanged(int)),
-		this, SLOT(setFullScreenBarHeight(int)) );
-
-	// Show dialog below the button
-	QRect buttonRect = d->mOptionsButton->rect();
-	QPoint pos;
-	if (dialog->isRightToLeft()) {
-		pos = buttonRect.bottomRight();
-		pos.rx() -= dialog->width() - 1;
-	} else {
-		pos = buttonRect.bottomLeft();
-	}
-	pos = d->mOptionsButton->mapToGlobal(pos);
-	dialog->move(pos);
-	dialog->show();
-}
-
-
-void FullScreenContent::enableAutoHiding() {
-	d->mFullScreenBar->setAutoHidingEnabled(true);
-}
-
-
-void FullScreenContent::slotShowThumbnailsToggled(bool value) {
-	GwenviewConfig::setShowFullScreenThumbnails(value);
-	GwenviewConfig::self()->writeConfig();
-	delete d->mFullScreenBar->layout();
-	d->createLayout();
-}
-
+static void setupCheckBox(QCheckBox* checkBox, QAction* action)
+{
+    checkBox->setChecked(action->isChecked());
+    QObject::connect(checkBox, SIGNAL(toggled(bool)),
+                     action, SLOT(trigger()));
+}
+
+void FullScreenContent::showFullScreenConfigDialog()
+{
+    FullScreenConfigDialog* dialog = new FullScreenConfigDialog(d->mOptionsButton);
+    d->mFullScreenConfigDialog = dialog;
+    dialog->setAttribute(Qt::WA_DeleteOnClose, true);
+    dialog->setObjectName(QLatin1String("configDialog"));
+
+    // Checkboxes
+    setupCheckBox(dialog->mSlideShowLoopCheckBox, d->mSlideShow->loopAction());
+    setupCheckBox(dialog->mSlideShowRandomCheckBox, d->mSlideShow->randomAction());
+
+    // Interval slider
+    dialog->mSlideShowIntervalSlider->setValue(int(GwenviewConfig::interval()));
+    connect(dialog->mSlideShowIntervalSlider, SIGNAL(valueChanged(int)),
+            d->mSlideShow, SLOT(setInterval(int)));
+
+    // Interval label
+    connect(dialog->mSlideShowIntervalSlider, SIGNAL(valueChanged(int)),
+            SLOT(updateSlideShowIntervalLabel()));
+    QString text = formatSlideShowIntervalText(88);
+    int width = dialog->mSlideShowIntervalLabel->fontMetrics().width(text);
+    dialog->mSlideShowIntervalLabel->setFixedWidth(width);
+    updateSlideShowIntervalLabel();
+
+    // Config button
+    connect(dialog->mConfigureDisplayedInformationButton, SIGNAL(clicked()),
+            SLOT(showImageMetaInfoDialog()));
+
+    d->setupThemeListWidget(dialog->mThemeListWidget);
+
+    // Thumbnails check box
+    dialog->mShowThumbnailsCheckBox->setChecked(GwenviewConfig::showFullScreenThumbnails());
+    connect(dialog->mShowThumbnailsCheckBox, SIGNAL(toggled(bool)),
+            SLOT(slotShowThumbnailsToggled(bool)));
+
+    // Height slider
+    dialog->mHeightSlider->setValue(d->mFullScreenBar->height());
+    connect(dialog->mHeightSlider, SIGNAL(valueChanged(int)),
+            this, SLOT(setFullScreenBarHeight(int)));
+
+    // Show dialog below the button
+    QRect buttonRect = d->mOptionsButton->rect();
+    QPoint pos;
+    if (dialog->isRightToLeft()) {
+        pos = buttonRect.bottomRight();
+        pos.rx() -= dialog->width() - 1;
+    } else {
+        pos = buttonRect.bottomLeft();
+    }
+    pos = d->mOptionsButton->mapToGlobal(pos);
+    dialog->move(pos);
+    dialog->show();
+}
+
+void FullScreenContent::enableAutoHiding()
+{
+    d->mFullScreenBar->setAutoHidingEnabled(true);
+}
+
+void FullScreenContent::slotShowThumbnailsToggled(bool value)
+{
+    GwenviewConfig::setShowFullScreenThumbnails(value);
+    GwenviewConfig::self()->writeConfig();
+    delete d->mFullScreenBar->layout();
+    d->createLayout();
+}
 
 } // namespace

=== modified file 'app/fullscreencontent.h'
--- app/fullscreencontent.h	2011-07-20 13:46:34 +0000
+++ app/fullscreencontent.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -33,48 +33,48 @@
 class KActionCollection;
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class FullScreenBar;
 class SlideShow;
 
 class ThumbnailBarView;
 
-
 struct FullScreenContentPrivate;
 /**
  * The content of the fullscreen bar
  */
-class FullScreenContent : public QObject {
-	Q_OBJECT
+class FullScreenContent : public QObject
+{
+    Q_OBJECT
 public:
-	FullScreenContent(FullScreenBar* parent, KActionCollection*, SlideShow*);
-	~FullScreenContent();
-
-	ThumbnailBarView* thumbnailBar() const;
-
-	void setCurrentUrl(const KUrl&);
+    FullScreenContent(FullScreenBar* parent, KActionCollection*, SlideShow*);
+    ~FullScreenContent();
+
+    ThumbnailBarView* thumbnailBar() const;
+
+    void setCurrentUrl(const KUrl&);
 
 protected:
-	bool eventFilter(QObject*, QEvent*);
+    bool eventFilter(QObject*, QEvent*);
 
 private Q_SLOTS:
-	void updateInformationLabel();
-	void updateMetaInfoDialog();
-	void showImageMetaInfoDialog();
-	void slotPreferredMetaInfoKeyListChanged(const QStringList& list);
-	void showFullScreenConfigDialog();
-	void updateSlideShowIntervalLabel();
-	void setCurrentFullScreenTheme(const QString& themeName);
-	void setFullScreenBarHeight(int value);
-	void enableAutoHiding();
-	void slotShowThumbnailsToggled(bool value);
+    void updateInformationLabel();
+    void updateMetaInfoDialog();
+    void showImageMetaInfoDialog();
+    void slotPreferredMetaInfoKeyListChanged(const QStringList& list);
+    void showFullScreenConfigDialog();
+    void updateSlideShowIntervalLabel();
+    void setCurrentFullScreenTheme(const QString& themeName);
+    void setFullScreenBarHeight(int value);
+    void enableAutoHiding();
+    void slotShowThumbnailsToggled(bool value);
 
 private:
-	FullScreenContentPrivate* const d;
+    FullScreenContentPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* FULLSCREENCONTENT_H */

=== modified file 'app/gvcore.cpp'
--- app/gvcore.cpp	2011-07-20 13:46:34 +0000
+++ app/gvcore.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -50,278 +50,279 @@
 #include <mainwindow.h>
 #include <saveallhelper.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct GvCorePrivate {
-	GvCore* q;
-	MainWindow* mMainWindow;
-	SortedDirModel* mDirModel;
-	HistoryModel* mRecentFoldersModel;
-	HistoryModel* mRecentUrlsModel;
-
-	bool showSaveAsDialog(const KUrl& url, KUrl* outUrl, QByteArray* format) {
-		KFileDialog dialog(url, QString(), mMainWindow);
-		dialog.setOperationMode(KFileDialog::Saving);
-		dialog.setSelection(url.fileName());
-		dialog.setMimeFilter(
-			KImageIO::mimeTypes(KImageIO::Writing), // List
-			MimeTypeUtils::urlMimeType(url)         // Default
-			);
-
-		// Show dialog
-		do {
-			if (!dialog.exec()) {
-				return false;
-			}
-
-			const QString mimeType = dialog.currentMimeFilter();
-			if (mimeType.isEmpty()) {
-				KMessageBox::sorry(
-					mMainWindow,
-					i18nc("@info",
-						"No image format selected.")
-					);
-				continue;
-			}
-
-			const QStringList typeList = KImageIO::typeForMime(mimeType);
-			if (typeList.count() > 0) {
-				*format = typeList[0].toAscii();
-				break;
-			}
-			KMessageBox::sorry(
-				mMainWindow,
-				i18nc("@info",
-					"Gwenview cannot save images as %1.", mimeType)
-				);
-		} while (true);
-
-		*outUrl = dialog.selectedUrl();
-		return true;
-	}
+    GvCore* q;
+    MainWindow* mMainWindow;
+    SortedDirModel* mDirModel;
+    HistoryModel* mRecentFoldersModel;
+    HistoryModel* mRecentUrlsModel;
+
+    bool showSaveAsDialog(const KUrl& url, KUrl* outUrl, QByteArray* format)
+    {
+        KFileDialog dialog(url, QString(), mMainWindow);
+        dialog.setOperationMode(KFileDialog::Saving);
+        dialog.setSelection(url.fileName());
+        dialog.setMimeFilter(
+            KImageIO::mimeTypes(KImageIO::Writing), // List
+            MimeTypeUtils::urlMimeType(url)         // Default
+        );
+
+        // Show dialog
+        do {
+            if (!dialog.exec()) {
+                return false;
+            }
+
+            const QString mimeType = dialog.currentMimeFilter();
+            if (mimeType.isEmpty()) {
+                KMessageBox::sorry(
+                    mMainWindow,
+                    i18nc("@info",
+                          "No image format selected.")
+                );
+                continue;
+            }
+
+            const QStringList typeList = KImageIO::typeForMime(mimeType);
+            if (typeList.count() > 0) {
+                *format = typeList[0].toAscii();
+                break;
+            }
+            KMessageBox::sorry(
+                mMainWindow,
+                i18nc("@info",
+                      "Gwenview cannot save images as %1.", mimeType)
+            );
+        } while (true);
+
+        *outUrl = dialog.selectedUrl();
+        return true;
+    }
 };
 
-
 GvCore::GvCore(MainWindow* mainWindow, SortedDirModel* dirModel)
 : QObject(mainWindow)
-, d(new GvCorePrivate) {
-	d->q = this;
-	d->mMainWindow = mainWindow;
-	d->mDirModel = dirModel;
-	d->mRecentFoldersModel = 0;
-	d->mRecentUrlsModel = 0;
-
-	connect(GwenviewConfig::self(), SIGNAL(configChanged()),
-		SLOT(slotConfigChanged()));
-}
-
-
-GvCore::~GvCore() {
-	delete d;
-}
-
-
-QAbstractItemModel* GvCore::recentFoldersModel() const {
-	if (!d->mRecentFoldersModel) {
-		d->mRecentFoldersModel = new HistoryModel(const_cast<GvCore*>(this), KStandardDirs::locateLocal("appdata", "recentfolders/"));
-	}
-	return d->mRecentFoldersModel;
-}
-
-
-QAbstractItemModel* GvCore::recentUrlsModel() const {
-	if (!d->mRecentUrlsModel) {
-		d->mRecentUrlsModel = new HistoryModel(const_cast<GvCore*>(this), KStandardDirs::locateLocal("appdata", "recenturls/"));
-	}
-	return d->mRecentUrlsModel;
-}
-
-
-AbstractSemanticInfoBackEnd* GvCore::semanticInfoBackEnd() const {
-	return d->mDirModel->semanticInfoBackEnd();
-}
-
-
-void GvCore::addUrlToRecentFolders(const KUrl& url) {
-	if (!GwenviewConfig::historyEnabled()) {
-		return;
-	}
-	recentFoldersModel();
-	d->mRecentFoldersModel->addUrl(url);
-}
-
-
-void GvCore::addUrlToRecentUrls(const KUrl& url) {
-	if (!GwenviewConfig::historyEnabled()) {
-		return;
-	}
-	recentUrlsModel();
-	d->mRecentUrlsModel->addUrl(url);
-}
-
-
-void GvCore::saveAll() {
-	SaveAllHelper helper(d->mMainWindow);
-	helper.save();
-}
-
-
-void GvCore::save(const KUrl& url) {
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	QByteArray format = doc->format();
-	const QStringList availableTypes = KImageIO::types(KImageIO::Writing);
-	if (availableTypes.contains(QString(format))) {
-		DocumentJob* job = doc->save(url, format);
-		connect(job, SIGNAL(result(KJob*)), SLOT(slotSaveResult(KJob*)));
-	} else {
-		// We don't know how to save in 'format', ask the user for a format we can
-		// write to.
-		KGuiItem saveUsingAnotherFormat = KStandardGuiItem::saveAs();
-		saveUsingAnotherFormat.setText(i18n("Save using another format"));
-		int result = KMessageBox::warningContinueCancel(
-			d->mMainWindow,
-			i18n("Gwenview cannot save images in '%1' format.", QString(format)),
-			QString() /* caption */,
-			saveUsingAnotherFormat
-			);
-		if (result == KMessageBox::Continue) {
-			saveAs(url);
-		}
-	}
-}
-
-
-void GvCore::saveAs(const KUrl& url) {
-	QByteArray format;
-	KUrl saveAsUrl;
-	if (!d->showSaveAsDialog(url, &saveAsUrl, &format)) {
-		return;
-	}
-
-	// Check for overwrite
-	if (KIO::NetAccess::exists(saveAsUrl, KIO::NetAccess::DestinationSide, d->mMainWindow)) {
-		int answer = KMessageBox::warningContinueCancel(
-			d->mMainWindow,
-			i18nc("@info",
-				"A file named <filename>%1</filename> already exists.\n"
-				"Are you sure you want to overwrite it?",
-				saveAsUrl.fileName()),
-			QString(),
-			KStandardGuiItem::overwrite());
-		if (answer == KMessageBox::Cancel) {
-			return;
-		}
-	}
-
-	// Start save
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	KJob* job = doc->save(saveAsUrl, format.data());
-	if (!job) {
-		const QString name = saveAsUrl.fileName().isEmpty() ? saveAsUrl.pathOrUrl() : saveAsUrl.fileName();
-		const QString msg = i18nc("@info", "<b>Saving <filename>%1</filename> failed:</b><br>%2",
-			name, doc->errorString());
-		KMessageBox::sorry(QApplication::activeWindow(), msg);
-	} else {
-		connect(job, SIGNAL(result(KJob*)), SLOT(slotSaveResult(KJob*)));
-	}
-}
-
-
-static void applyTransform(const KUrl& url, Orientation orientation) {
-	TransformImageOperation* op = new TransformImageOperation(orientation);
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	op->applyToDocument(doc);
-}
-
-
-void GvCore::slotSaveResult(KJob* _job) {
-	SaveJob* job = static_cast<SaveJob*>(_job);
-	KUrl oldUrl = job->oldUrl();
-	KUrl newUrl = job->newUrl();
-
-	if (job->error()) {
-		QString name = newUrl.fileName().isEmpty() ? newUrl.pathOrUrl() : newUrl.fileName();
-		QString msg = i18nc("@info", "<b>Saving <filename>%1</filename> failed:</b><br>%2",
-			name, job->errorString());
-
-		int result = KMessageBox::warningContinueCancel(
-			d->mMainWindow, msg,
-			QString() /* caption */,
-			KStandardGuiItem::saveAs());
-
-		if (result == KMessageBox::Continue) {
-			saveAs(newUrl);
-		}
-		return;
-	}
-
-	if (oldUrl != newUrl) {
-		d->mMainWindow->goToUrl(newUrl);
-
-		MessageBubble* bubble = new MessageBubble();
-		bubble->setText(i18n("You are now viewing the new document."));
-		KGuiItem item = KStandardGuiItem::back();
-		item.setText(i18n("Go back to the original"));
-		QToolButton* button = bubble->addButton(item);
-
-		BinderRef<MainWindow, KUrl>::bind(button, SIGNAL(clicked()), d->mMainWindow, &MainWindow::goToUrl, oldUrl);
-		connect(button, SIGNAL(clicked()),
-			bubble, SLOT(deleteLater()));
-
-		d->mMainWindow->showMessageBubble(bubble);
-	}
-}
-
-
-void GvCore::rotateLeft(const KUrl& url) {
-	applyTransform(url, ROT_270);
-}
-
-
-void GvCore::rotateRight(const KUrl& url) {
-	applyTransform(url, ROT_90);
-}
-
-
-void GvCore::setRating(const KUrl& url, int rating) {
-	QModelIndex index = d->mDirModel->indexForUrl(url);
-	if (!index.isValid()) {
-		kWarning() << "invalid index!";
-		return;
-	}
-	d->mDirModel->setData(index, rating, SemanticInfoDirModel::RatingRole);
-}
-
-
-bool GvCore::ensureDocumentIsEditable(const KUrl& url) {
-	// FIXME: Replace with a CheckEditableJob?
-	// This way we can factorize the error message
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-	if (doc->isEditable()) {
-		return true;
-	}
-
-	KMessageBox::sorry(
-		QApplication::activeWindow(),
-		i18nc("@info", "Gwenview cannot edit this kind of image.")
-		);
-	return false;
-}
-
-
-static void clearModel(QAbstractItemModel* model) {
-	model->removeRows(0, model->rowCount());
-}
-
-void GvCore::slotConfigChanged() {
-	if (!GwenviewConfig::historyEnabled()) {
-		clearModel(recentFoldersModel());
-		clearModel(recentUrlsModel());
-	}
-}
-
+, d(new GvCorePrivate)
+{
+    d->q = this;
+    d->mMainWindow = mainWindow;
+    d->mDirModel = dirModel;
+    d->mRecentFoldersModel = 0;
+    d->mRecentUrlsModel = 0;
+
+    connect(GwenviewConfig::self(), SIGNAL(configChanged()),
+            SLOT(slotConfigChanged()));
+}
+
+GvCore::~GvCore()
+{
+    delete d;
+}
+
+QAbstractItemModel* GvCore::recentFoldersModel() const
+{
+    if (!d->mRecentFoldersModel) {
+        d->mRecentFoldersModel = new HistoryModel(const_cast<GvCore*>(this), KStandardDirs::locateLocal("appdata", "recentfolders/"));
+    }
+    return d->mRecentFoldersModel;
+}
+
+QAbstractItemModel* GvCore::recentUrlsModel() const
+{
+    if (!d->mRecentUrlsModel) {
+        d->mRecentUrlsModel = new HistoryModel(const_cast<GvCore*>(this), KStandardDirs::locateLocal("appdata", "recenturls/"));
+    }
+    return d->mRecentUrlsModel;
+}
+
+AbstractSemanticInfoBackEnd* GvCore::semanticInfoBackEnd() const
+{
+    return d->mDirModel->semanticInfoBackEnd();
+}
+
+void GvCore::addUrlToRecentFolders(const KUrl& url)
+{
+    if (!GwenviewConfig::historyEnabled()) {
+        return;
+    }
+    recentFoldersModel();
+    d->mRecentFoldersModel->addUrl(url);
+}
+
+void GvCore::addUrlToRecentUrls(const KUrl& url)
+{
+    if (!GwenviewConfig::historyEnabled()) {
+        return;
+    }
+    recentUrlsModel();
+    d->mRecentUrlsModel->addUrl(url);
+}
+
+void GvCore::saveAll()
+{
+    SaveAllHelper helper(d->mMainWindow);
+    helper.save();
+}
+
+void GvCore::save(const KUrl& url)
+{
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    QByteArray format = doc->format();
+    const QStringList availableTypes = KImageIO::types(KImageIO::Writing);
+    if (availableTypes.contains(QString(format))) {
+        DocumentJob* job = doc->save(url, format);
+        connect(job, SIGNAL(result(KJob*)), SLOT(slotSaveResult(KJob*)));
+    } else {
+        // We don't know how to save in 'format', ask the user for a format we can
+        // write to.
+        KGuiItem saveUsingAnotherFormat = KStandardGuiItem::saveAs();
+        saveUsingAnotherFormat.setText(i18n("Save using another format"));
+        int result = KMessageBox::warningContinueCancel(
+                         d->mMainWindow,
+                         i18n("Gwenview cannot save images in '%1' format.", QString(format)),
+                         QString() /* caption */,
+                         saveUsingAnotherFormat
+                     );
+        if (result == KMessageBox::Continue) {
+            saveAs(url);
+        }
+    }
+}
+
+void GvCore::saveAs(const KUrl& url)
+{
+    QByteArray format;
+    KUrl saveAsUrl;
+    if (!d->showSaveAsDialog(url, &saveAsUrl, &format)) {
+        return;
+    }
+
+    // Check for overwrite
+    if (KIO::NetAccess::exists(saveAsUrl, KIO::NetAccess::DestinationSide, d->mMainWindow)) {
+        int answer = KMessageBox::warningContinueCancel(
+                         d->mMainWindow,
+                         i18nc("@info",
+                               "A file named <filename>%1</filename> already exists.\n"
+                               "Are you sure you want to overwrite it?",
+                               saveAsUrl.fileName()),
+                         QString(),
+                         KStandardGuiItem::overwrite());
+        if (answer == KMessageBox::Cancel) {
+            return;
+        }
+    }
+
+    // Start save
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    KJob* job = doc->save(saveAsUrl, format.data());
+    if (!job) {
+        const QString name = saveAsUrl.fileName().isEmpty() ? saveAsUrl.pathOrUrl() : saveAsUrl.fileName();
+        const QString msg = i18nc("@info", "<b>Saving <filename>%1</filename> failed:</b><br>%2",
+                                  name, doc->errorString());
+        KMessageBox::sorry(QApplication::activeWindow(), msg);
+    } else {
+        connect(job, SIGNAL(result(KJob*)), SLOT(slotSaveResult(KJob*)));
+    }
+}
+
+static void applyTransform(const KUrl& url, Orientation orientation)
+{
+    TransformImageOperation* op = new TransformImageOperation(orientation);
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    op->applyToDocument(doc);
+}
+
+void GvCore::slotSaveResult(KJob* _job)
+{
+    SaveJob* job = static_cast<SaveJob*>(_job);
+    KUrl oldUrl = job->oldUrl();
+    KUrl newUrl = job->newUrl();
+
+    if (job->error()) {
+        QString name = newUrl.fileName().isEmpty() ? newUrl.pathOrUrl() : newUrl.fileName();
+        QString msg = i18nc("@info", "<b>Saving <filename>%1</filename> failed:</b><br>%2",
+                            name, job->errorString());
+
+        int result = KMessageBox::warningContinueCancel(
+                         d->mMainWindow, msg,
+                         QString() /* caption */,
+                         KStandardGuiItem::saveAs());
+
+        if (result == KMessageBox::Continue) {
+            saveAs(newUrl);
+        }
+        return;
+    }
+
+    if (oldUrl != newUrl) {
+        d->mMainWindow->goToUrl(newUrl);
+
+        MessageBubble* bubble = new MessageBubble();
+        bubble->setText(i18n("You are now viewing the new document."));
+        KGuiItem item = KStandardGuiItem::back();
+        item.setText(i18n("Go back to the original"));
+        QToolButton* button = bubble->addButton(item);
+
+        BinderRef<MainWindow, KUrl>::bind(button, SIGNAL(clicked()), d->mMainWindow, &MainWindow::goToUrl, oldUrl);
+        connect(button, SIGNAL(clicked()),
+                bubble, SLOT(deleteLater()));
+
+        d->mMainWindow->showMessageBubble(bubble);
+    }
+}
+
+void GvCore::rotateLeft(const KUrl& url)
+{
+    applyTransform(url, ROT_270);
+}
+
+void GvCore::rotateRight(const KUrl& url)
+{
+    applyTransform(url, ROT_90);
+}
+
+void GvCore::setRating(const KUrl& url, int rating)
+{
+    QModelIndex index = d->mDirModel->indexForUrl(url);
+    if (!index.isValid()) {
+        kWarning() << "invalid index!";
+        return;
+    }
+    d->mDirModel->setData(index, rating, SemanticInfoDirModel::RatingRole);
+}
+
+bool GvCore::ensureDocumentIsEditable(const KUrl& url)
+{
+    // FIXME: Replace with a CheckEditableJob?
+    // This way we can factorize the error message
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+    if (doc->isEditable()) {
+        return true;
+    }
+
+    KMessageBox::sorry(
+        QApplication::activeWindow(),
+        i18nc("@info", "Gwenview cannot edit this kind of image.")
+    );
+    return false;
+}
+
+static void clearModel(QAbstractItemModel* model)
+{
+    model->removeRows(0, model->rowCount());
+}
+
+void GvCore::slotConfigChanged()
+{
+    if (!GwenviewConfig::historyEnabled()) {
+        clearModel(recentFoldersModel());
+        clearModel(recentUrlsModel());
+    }
+}
 
 } // namespace

=== modified file 'app/gvcore.h'
--- app/gvcore.h	2011-07-20 13:46:34 +0000
+++ app/gvcore.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -33,50 +33,51 @@
 
 class QAbstractItemModel;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class AbstractSemanticInfoBackEnd;
 class MainWindow;
 class SortedDirModel;
 
 class GvCorePrivate;
-class GvCore : public QObject {
-	Q_OBJECT
+class GvCore : public QObject
+{
+    Q_OBJECT
 public:
-	GvCore(MainWindow* mainWindow, SortedDirModel*);
-	~GvCore();
-
-	QAbstractItemModel* recentFoldersModel() const;
-	QAbstractItemModel* recentUrlsModel() const;
-	AbstractSemanticInfoBackEnd* semanticInfoBackEnd() const;
-
-	void addUrlToRecentFolders(const KUrl&);
-	void addUrlToRecentUrls(const KUrl& url);
-
-	/**
-	 * Checks if the document referenced by url is editable, shows a sorry
-	 * dialog if it's not.
-	 * @return true if editable, false if not
-	 */
-	static bool ensureDocumentIsEditable(const KUrl& url);
+    GvCore(MainWindow* mainWindow, SortedDirModel*);
+    ~GvCore();
+
+    QAbstractItemModel* recentFoldersModel() const;
+    QAbstractItemModel* recentUrlsModel() const;
+    AbstractSemanticInfoBackEnd* semanticInfoBackEnd() const;
+
+    void addUrlToRecentFolders(const KUrl&);
+    void addUrlToRecentUrls(const KUrl& url);
+
+    /**
+     * Checks if the document referenced by url is editable, shows a sorry
+     * dialog if it's not.
+     * @return true if editable, false if not
+     */
+    static bool ensureDocumentIsEditable(const KUrl& url);
 
 public Q_SLOTS:
-	void saveAll();
-	void save(const KUrl&);
-	void saveAs(const KUrl&);
-	void rotateLeft(const KUrl&);
-	void rotateRight(const KUrl&);
-	void setRating(const KUrl&, int);
+    void saveAll();
+    void save(const KUrl&);
+    void saveAs(const KUrl&);
+    void rotateLeft(const KUrl&);
+    void rotateRight(const KUrl&);
+    void setRating(const KUrl&, int);
 
 private Q_SLOTS:
-	void slotConfigChanged();
-	void slotSaveResult(KJob*);
+    void slotConfigChanged();
+    void slotSaveResult(KJob*);
 
 private:
-	GvCorePrivate* const d;
+    GvCorePrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* GVCORE_H */

=== modified file 'app/gwenview.desktop'
--- app/gwenview.desktop	2011-12-08 21:34:25 +0000
+++ app/gwenview.desktop	2011-12-15 14:17:54 +0000
@@ -45,6 +45,7 @@
 Name[pt_BR]=Gwenview
 Name[ro]=Gwenview
 Name[ru]=Gwenview
+Name[si]=Gwenview
 Name[sk]=Gwenview
 Name[sl]=Gwenview
 Name[sr]=Гвенвју
@@ -110,6 +111,7 @@
 GenericName[pt_BR]=Visualizador de imagens
 GenericName[ro]=Vizualizor de imagini
 GenericName[ru]=Просмотр изображений
+GenericName[si]=පිංතූර දසුන
 GenericName[sk]=Prehliadač obrázkov
 GenericName[sl]=Pregledovalnik slik
 GenericName[sr]=Приказивач слика
@@ -121,7 +123,7 @@
 GenericName[tg]=Намоиши тасвирот
 GenericName[th]=เครื่องมือแสดงภาพ
 GenericName[tr]=Resim Gösterici
-GenericName[ug]=سۈرەت كۆرگۈ
+GenericName[ug]=سۈرەت كۆرگۈچ
 GenericName[uk]=Переглядач зображень
 GenericName[uz]=Rasm koʻruvchi
 GenericName[uz@cyrillic]=Расм кўрувчи
@@ -175,6 +177,7 @@
 Comment[pt_BR]=Um visualizador de imagens simples
 Comment[ro]=Un vizualizator de imagini simplu
 Comment[ru]=Просмотр изображений
+Comment[si]=සරල පිංතූර දසුන
 Comment[sk]=Jednoduchý prehliadač obrázkov
 Comment[sl]=Preprost pregledovalnik slik
 Comment[sr]=Једноставан приказивач слика
@@ -184,7 +187,6 @@
 Comment[sv]=En enkel bildvisare
 Comment[th]=เครื่องมือแสดงภาพแบบพื้นฐาน
 Comment[tr]=Basit bir resim gösterici
-Comment[ug]=ئاددىي سۈرەت كۆرگۈ
 Comment[uk]=Простий переглядач зображень
 Comment[vi]=Bộ xem ảnh đơn giản
 Comment[x-test]=xxA simple image viewerxx

=== modified file 'app/imagemetainfodialog.cpp'
--- app/imagemetainfodialog.cpp	2011-07-20 13:46:34 +0000
+++ app/imagemetainfodialog.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -37,113 +37,117 @@
 // Local
 #include <lib/preferredimagemetainfomodel.h>
 
-namespace Gwenview {
-
-
-class MetaInfoDelegate : public QStyledItemDelegate {
+namespace Gwenview
+{
+
+class MetaInfoDelegate : public QStyledItemDelegate
+{
 public:
-	MetaInfoDelegate(QObject* parent)
-	: QStyledItemDelegate(parent)
-	{}
+    MetaInfoDelegate(QObject* parent)
+        : QStyledItemDelegate(parent)
+    {}
 
 protected:
-	virtual void paint(QPainter* painter, const QStyleOptionViewItem& _option, const QModelIndex& index) const {
-		QStyleOptionViewItemV4 option = _option;
-		if (!index.parent().isValid()) {
-			option.displayAlignment = Qt::AlignCenter | Qt::AlignBottom;
-			option.font.setBold(true);
-		}
-		QStyledItemDelegate::paint(painter, option, index);
-		if (!index.parent().isValid()) {
-			painter->drawLine(option.rect.bottomLeft(), option.rect.bottomRight());
-		}
-	}
+    virtual void paint(QPainter* painter, const QStyleOptionViewItem& _option, const QModelIndex& index) const
+    {
+        QStyleOptionViewItemV4 option = _option;
+        if (!index.parent().isValid()) {
+            option.displayAlignment = Qt::AlignCenter | Qt::AlignBottom;
+            option.font.setBold(true);
+        }
+        QStyledItemDelegate::paint(painter, option, index);
+        if (!index.parent().isValid()) {
+            painter->drawLine(option.rect.bottomLeft(), option.rect.bottomRight());
+        }
+    }
 
-	virtual QSize sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const {
-		QSize sh = QStyledItemDelegate::sizeHint(option, index);
-		if (!index.parent().isValid()) {
-			sh.setHeight(sh.height() * 3 / 2);
-		}
-		return sh;
-	}
+    virtual QSize sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const {
+        QSize sh = QStyledItemDelegate::sizeHint(option, index);
+        if (!index.parent().isValid()) {
+            sh.setHeight(sh.height() * 3 / 2);
+        }
+        return sh;
+    }
 };
 
 /**
  * A tree view which is always fully expanded
  */
-class ExpandedTreeView : public QTreeView {
+class ExpandedTreeView : public QTreeView
+{
 public:
-	ExpandedTreeView(QWidget* parent)
-	: QTreeView(parent) {}
+    ExpandedTreeView(QWidget* parent)
+        : QTreeView(parent) {}
 
 protected:
-	virtual void rowsInserted(const QModelIndex& parent, int start, int end) {
-		QTreeView::rowsInserted(parent, start, end);
-		if (!parent.isValid()) {
-			for (int row = start; row <= end; ++row) {
-				setUpRootIndex(row);
-			}
-		}
-	}
+    virtual void rowsInserted(const QModelIndex& parent, int start, int end)
+    {
+        QTreeView::rowsInserted(parent, start, end);
+        if (!parent.isValid()) {
+            for (int row = start; row <= end; ++row) {
+                setUpRootIndex(row);
+            }
+        }
+    }
 
-	virtual void reset() {
-		QTreeView::reset();
-		if (model()) {
-			for (int row = 0; row < model()->rowCount(); ++row) {
-				setUpRootIndex(row);
-			}
-		}
-	}
+    virtual void reset()
+    {
+        QTreeView::reset();
+        if (model()) {
+            for (int row = 0; row < model()->rowCount(); ++row) {
+                setUpRootIndex(row);
+            }
+        }
+    }
 
 private:
-	void setUpRootIndex(int row) {
-		expand(model()->index(row, 0));
-		setFirstColumnSpanned(row, QModelIndex(), true);
-	}
+    void setUpRootIndex(int row)
+    {
+        expand(model()->index(row, 0));
+        setFirstColumnSpanned(row, QModelIndex(), true);
+    }
 };
 
-
 struct ImageMetaInfoDialogPrivate {
-	std::auto_ptr<PreferredImageMetaInfoModel> mModel;
-	QTreeView* mTreeView;
+    std::auto_ptr<PreferredImageMetaInfoModel> mModel;
+    QTreeView* mTreeView;
 };
 
-
 ImageMetaInfoDialog::ImageMetaInfoDialog(QWidget* parent)
 : KDialog(parent)
-, d(new ImageMetaInfoDialogPrivate) {
-	d->mTreeView = new ExpandedTreeView(this);
-	d->mTreeView->setRootIsDecorated(false);
-	d->mTreeView->setIndentation(0);
-	d->mTreeView->setItemDelegate(new MetaInfoDelegate(d->mTreeView));
-	setMainWidget(d->mTreeView);
-	setCaption(i18nc("@title:window", "Meta Information"));
-	setButtons(KDialog::Close);
-}
-
-
-ImageMetaInfoDialog::~ImageMetaInfoDialog() {
-	delete d;
-}
-
-
-void ImageMetaInfoDialog::setMetaInfo(ImageMetaInfoModel* model, const QStringList& list) {
-	if (model) {
-		d->mModel.reset(new PreferredImageMetaInfoModel(model, list));
-		connect(d->mModel.get(), SIGNAL(preferredMetaInfoKeyListChanged(const QStringList&)),
-			this, SIGNAL(preferredMetaInfoKeyListChanged(const QStringList&)) );
-	} else {
-		d->mModel.reset(0);
-	}
-	d->mTreeView->setModel(d->mModel.get());
-
-	d->mTreeView->header()->resizeSection(0, sizeHint().width() / 2 - KDialog::marginHint()*2);
-}
-
-
-QSize ImageMetaInfoDialog::sizeHint() const {
-	return QSize(400, 300);
-}
-
+, d(new ImageMetaInfoDialogPrivate)
+{
+    d->mTreeView = new ExpandedTreeView(this);
+    d->mTreeView->setRootIsDecorated(false);
+    d->mTreeView->setIndentation(0);
+    d->mTreeView->setItemDelegate(new MetaInfoDelegate(d->mTreeView));
+    setMainWidget(d->mTreeView);
+    setCaption(i18nc("@title:window", "Meta Information"));
+    setButtons(KDialog::Close);
+}
+
+ImageMetaInfoDialog::~ImageMetaInfoDialog()
+{
+    delete d;
+}
+
+void ImageMetaInfoDialog::setMetaInfo(ImageMetaInfoModel* model, const QStringList& list)
+{
+    if (model) {
+        d->mModel.reset(new PreferredImageMetaInfoModel(model, list));
+        connect(d->mModel.get(), SIGNAL(preferredMetaInfoKeyListChanged(QStringList)),
+                this, SIGNAL(preferredMetaInfoKeyListChanged(QStringList)));
+    } else {
+        d->mModel.reset(0);
+    }
+    d->mTreeView->setModel(d->mModel.get());
+
+    d->mTreeView->header()->resizeSection(0, sizeHint().width() / 2 - KDialog::marginHint() * 2);
+}
+
+QSize ImageMetaInfoDialog::sizeHint() const
+{
+    return QSize(400, 300);
+}
 
 } // namespace

=== modified file 'app/imagemetainfodialog.h'
--- app/imagemetainfodialog.h	2011-07-20 13:46:34 +0000
+++ app/imagemetainfodialog.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -28,34 +28,33 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class ImageMetaInfoModel;
 
-
 class ImageMetaInfoDialogPrivate;
-class ImageMetaInfoDialog : public KDialog {
-	Q_OBJECT
+class ImageMetaInfoDialog : public KDialog
+{
+    Q_OBJECT
 public:
-	ImageMetaInfoDialog(QWidget* parent);
-	~ImageMetaInfoDialog();
-
-	/**
-	 * Defines the image metainfo model and the preferred metainfo key list.
-	 */
-	void setMetaInfo(ImageMetaInfoModel*, const QStringList& list);
-
-	virtual QSize sizeHint() const;
+    ImageMetaInfoDialog(QWidget* parent);
+    ~ImageMetaInfoDialog();
+
+    /**
+     * Defines the image metainfo model and the preferred metainfo key list.
+     */
+    void setMetaInfo(ImageMetaInfoModel*, const QStringList& list);
+
+    virtual QSize sizeHint() const;
 
 Q_SIGNALS:
-	void preferredMetaInfoKeyListChanged(const QStringList&);
+    void preferredMetaInfoKeyListChanged(const QStringList&);
 
 private:
-	ImageMetaInfoDialogPrivate* const d;
+    ImageMetaInfoDialogPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* IMAGEMETAINFODIALOG_H */

=== modified file 'app/imageopscontextmanageritem.cpp'
--- app/imageopscontextmanageritem.cpp	2011-07-20 13:46:34 +0000
+++ app/imageopscontextmanageritem.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -34,21 +34,22 @@
 
 // Local
 #include "contextmanager.h"
-#include "documentpanel.h"
+#include "viewmainpage.h"
 #include "gvcore.h"
 #include "mainwindow.h"
 #include "sidebar.h"
 #include <lib/crop/croptool.h>
 #include <lib/document/documentfactory.h>
+#include <lib/documentview/rasterimageview.h>
 #include <lib/eventwatcher.h>
 #include <lib/redeyereduction/redeyereductiontool.h>
 #include <lib/gwenviewconfig.h>
-#include <lib/imageview.h>
 #include <lib/resize/resizeimageoperation.h>
 #include <lib/resize/resizeimagedialog.h>
 #include <lib/transformimageoperation.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -60,236 +61,236 @@
 #endif
 
 struct ImageOpsContextManagerItem::Private {
-	ImageOpsContextManagerItem* that;
-	MainWindow* mMainWindow;
-	SideBarGroup* mGroup;
-
-	KAction* mRotateLeftAction;
-	KAction* mRotateRightAction;
-	KAction* mMirrorAction;
-	KAction* mFlipAction;
-	KAction* mResizeAction;
-	KAction* mCropAction;
-	KAction* mRedEyeReductionAction;
-	QList<KAction*> mActionList;
-
-	void setupActions() {
-		KActionCollection* actionCollection = mMainWindow->actionCollection();
-		KActionCategory* edit=new KActionCategory(i18nc("@title actions category - means actions changing image","Edit"), actionCollection);
-		mRotateLeftAction = edit->addAction("rotate_left",that, SLOT(rotateLeft()));
-		mRotateLeftAction->setText(i18n("Rotate Left"));
-		mRotateLeftAction->setIcon(KIcon("object-rotate-left"));
-		mRotateLeftAction->setShortcut(Qt::CTRL + Qt::Key_L);
-
-		mRotateRightAction = edit->addAction("rotate_right",that, SLOT(rotateRight()));
-		mRotateRightAction->setText(i18n("Rotate Right"));
-		mRotateRightAction->setIcon(KIcon("object-rotate-right"));
-		mRotateRightAction->setShortcut(Qt::CTRL + Qt::Key_R);
-
-		mMirrorAction = edit->addAction("mirror",that, SLOT(mirror()));
-		mMirrorAction->setText(i18n("Mirror"));
-		mMirrorAction->setIcon(KIcon("object-flip-horizontal"));
-
-		mFlipAction = edit->addAction("flip",that, SLOT(flip()));
-		mFlipAction->setText(i18n("Flip"));
-		mFlipAction->setIcon(KIcon("object-flip-vertical"));
-
-		mResizeAction = edit->addAction("resize",that, SLOT(resizeImage()) );
-		mResizeAction->setText(i18n("Resize"));
-		mResizeAction->setIcon(KIcon("transform-scale"));
-		mResizeAction->setShortcut(Qt::SHIFT + Qt::Key_R);
-
-		mCropAction = edit->addAction("crop",that, SLOT(crop()));
-		mCropAction->setText(i18n("Crop"));
-		mCropAction->setIcon(KIcon("transform-crop-and-resize"));
-		mCropAction->setShortcut(Qt::SHIFT + Qt::Key_C);
-
-		mRedEyeReductionAction = edit->addAction("red_eye_reduction",that, SLOT(startRedEyeReduction()) );
-		mRedEyeReductionAction->setText(i18n("Red Eye Reduction"));
-		//mRedEyeReductionAction->setIcon(KIcon("transform-crop-and-resize"));
-
-		mActionList
-			<< mRotateLeftAction
-			<< mRotateRightAction
-			<< mMirrorAction
-			<< mFlipAction
-			<< mResizeAction
-			<< mCropAction
-			<< mRedEyeReductionAction
-			;
-	}
-
-
-	bool ensureEditable() {
-		KUrl url = that->contextManager()->currentUrl();
-		return GvCore::ensureDocumentIsEditable(url);
-	}
+    ImageOpsContextManagerItem* q;
+    MainWindow* mMainWindow;
+    SideBarGroup* mGroup;
+
+    KAction* mRotateLeftAction;
+    KAction* mRotateRightAction;
+    KAction* mMirrorAction;
+    KAction* mFlipAction;
+    KAction* mResizeAction;
+    KAction* mCropAction;
+    KAction* mRedEyeReductionAction;
+    QList<KAction*> mActionList;
+
+    void setupActions()
+    {
+        KActionCollection* actionCollection = mMainWindow->actionCollection();
+        KActionCategory* edit = new KActionCategory(i18nc("@title actions category - means actions changing image", "Edit"), actionCollection);
+        mRotateLeftAction = edit->addAction("rotate_left", q, SLOT(rotateLeft()));
+        mRotateLeftAction->setText(i18n("Rotate Left"));
+        mRotateLeftAction->setIcon(KIcon("object-rotate-left"));
+        mRotateLeftAction->setShortcut(Qt::CTRL + Qt::Key_L);
+
+        mRotateRightAction = edit->addAction("rotate_right", q, SLOT(rotateRight()));
+        mRotateRightAction->setText(i18n("Rotate Right"));
+        mRotateRightAction->setIcon(KIcon("object-rotate-right"));
+        mRotateRightAction->setShortcut(Qt::CTRL + Qt::Key_R);
+
+        mMirrorAction = edit->addAction("mirror", q, SLOT(mirror()));
+        mMirrorAction->setText(i18n("Mirror"));
+        mMirrorAction->setIcon(KIcon("object-flip-horizontal"));
+
+        mFlipAction = edit->addAction("flip", q, SLOT(flip()));
+        mFlipAction->setText(i18n("Flip"));
+        mFlipAction->setIcon(KIcon("object-flip-vertical"));
+
+        mResizeAction = edit->addAction("resize", q, SLOT(resizeImage()));
+        mResizeAction->setText(i18n("Resize"));
+        mResizeAction->setIcon(KIcon("transform-scale"));
+        mResizeAction->setShortcut(Qt::SHIFT + Qt::Key_R);
+
+        mCropAction = edit->addAction("crop", q, SLOT(crop()));
+        mCropAction->setText(i18n("Crop"));
+        mCropAction->setIcon(KIcon("transform-crop-and-resize"));
+        mCropAction->setShortcut(Qt::SHIFT + Qt::Key_C);
+
+        mRedEyeReductionAction = edit->addAction("red_eye_reduction", q, SLOT(startRedEyeReduction()));
+        mRedEyeReductionAction->setText(i18n("Red Eye Reduction"));
+        //mRedEyeReductionAction->setIcon(KIcon("transform-crop-and-resize"));
+
+        mActionList
+                << mRotateLeftAction
+                << mRotateRightAction
+                << mMirrorAction
+                << mFlipAction
+                << mResizeAction
+                << mCropAction
+                << mRedEyeReductionAction
+                ;
+    }
+
+    bool ensureEditable()
+    {
+        KUrl url = q->contextManager()->currentUrl();
+        return GvCore::ensureDocumentIsEditable(url);
+    }
 };
 
-
 ImageOpsContextManagerItem::ImageOpsContextManagerItem(ContextManager* manager, MainWindow* mainWindow)
 : AbstractContextManagerItem(manager)
-, d(new Private) {
-	d->that = this;
-	d->mMainWindow = mainWindow;
-	d->mGroup = new SideBarGroup(i18n("Image Operations"));
-	setWidget(d->mGroup);
-	EventWatcher::install(d->mGroup, QEvent::Show, this, SLOT(updateSideBarContent()));
-	d->setupActions();
-	updateActions();
-	connect(contextManager(), SIGNAL(selectionChanged()),
-		SLOT(updateActions()) );
-	connect(mainWindow, SIGNAL(viewModeChanged()),
-		SLOT(updateActions()) );
-	connect(mainWindow->documentPanel(), SIGNAL(completed()),
-		SLOT(updateActions()) );
-}
-
-
-ImageOpsContextManagerItem::~ImageOpsContextManagerItem() {
-	delete d;
-}
-
-
-void ImageOpsContextManagerItem::updateSideBarContent() {
-	if (!d->mGroup->isVisible()) {
-		return;
-	}
-
-	d->mGroup->clear();
-	Q_FOREACH(KAction* action, d->mActionList) {
-		if (action->isEnabled()) {
-			d->mGroup->addAction(action);
-		}
-	}
-}
-
-
-void ImageOpsContextManagerItem::updateActions() {
-	bool canModify = d->mMainWindow->currentDocumentIsRasterImage();
-	bool documentPanelIsVisible = d->mMainWindow->documentPanel()->isVisible();
-	if (!documentPanelIsVisible) {
-		// Since we only support image operations on one image for now,
-		// disable actions if several images are selected and the document
-		// view is not visible.
-		if (contextManager()->selectedFileItemList().count() != 1) {
-			canModify = false;
-		}
-	}
-
-	d->mRotateLeftAction->setEnabled(canModify);
-	d->mRotateRightAction->setEnabled(canModify);
-	d->mMirrorAction->setEnabled(canModify);
-	d->mFlipAction->setEnabled(canModify);
-	d->mResizeAction->setEnabled(canModify);
-	d->mCropAction->setEnabled(canModify && documentPanelIsVisible);
-	d->mRedEyeReductionAction->setEnabled(canModify && documentPanelIsVisible);
-
-	updateSideBarContent();
-}
-
-
-void ImageOpsContextManagerItem::rotateLeft() {
-	TransformImageOperation* op = new TransformImageOperation(ROT_270);
-	applyImageOperation(op);
-}
-
-
-void ImageOpsContextManagerItem::rotateRight() {
-	TransformImageOperation* op = new TransformImageOperation(ROT_90);
-	applyImageOperation(op);
-}
-
-
-void ImageOpsContextManagerItem::mirror() {
-	TransformImageOperation* op = new TransformImageOperation(HFLIP);
-	applyImageOperation(op);
-}
-
-
-void ImageOpsContextManagerItem::flip() {
-	TransformImageOperation* op = new TransformImageOperation(VFLIP);
-	applyImageOperation(op);
-}
-
-
-void ImageOpsContextManagerItem::resizeImage() {
-	if (!d->ensureEditable()) {
-		return;
-	}
-	Document::Ptr doc = DocumentFactory::instance()->load(contextManager()->currentUrl());
-	doc->startLoadingFullImage();
+, d(new Private)
+{
+    d->q = this;
+    d->mMainWindow = mainWindow;
+    d->mGroup = new SideBarGroup(i18n("Image Operations"));
+    setWidget(d->mGroup);
+    EventWatcher::install(d->mGroup, QEvent::Show, this, SLOT(updateSideBarContent()));
+    d->setupActions();
+    updateActions();
+    connect(contextManager(), SIGNAL(selectionChanged()),
+            SLOT(updateActions()));
+    connect(mainWindow, SIGNAL(viewModeChanged()),
+            SLOT(updateActions()));
+    connect(mainWindow->documentPanel(), SIGNAL(completed()),
+            SLOT(updateActions()));
+}
+
+ImageOpsContextManagerItem::~ImageOpsContextManagerItem()
+{
+    delete d;
+}
+
+void ImageOpsContextManagerItem::updateSideBarContent()
+{
+    if (!d->mGroup->isVisible()) {
+        return;
+    }
+
+    d->mGroup->clear();
+    Q_FOREACH(KAction * action, d->mActionList) {
+        if (action->isEnabled()) {
+            d->mGroup->addAction(action);
+        }
+    }
+}
+
+void ImageOpsContextManagerItem::updateActions()
+{
+    bool canModify = d->mMainWindow->currentDocumentIsRasterImage();
+    bool documentPanelIsVisible = d->mMainWindow->documentPanel()->isVisible();
+    if (!documentPanelIsVisible) {
+        // Since we only support image operations on one image for now,
+        // disable actions if several images are selected and the document
+        // view is not visible.
+        if (contextManager()->selectedFileItemList().count() != 1) {
+            canModify = false;
+        }
+    }
+
+    d->mRotateLeftAction->setEnabled(canModify);
+    d->mRotateRightAction->setEnabled(canModify);
+    d->mMirrorAction->setEnabled(canModify);
+    d->mFlipAction->setEnabled(canModify);
+    d->mResizeAction->setEnabled(canModify);
+    d->mCropAction->setEnabled(canModify && documentPanelIsVisible);
+    d->mRedEyeReductionAction->setEnabled(canModify && documentPanelIsVisible);
+
+    updateSideBarContent();
+}
+
+void ImageOpsContextManagerItem::rotateLeft()
+{
+    TransformImageOperation* op = new TransformImageOperation(ROT_270);
+    applyImageOperation(op);
+}
+
+void ImageOpsContextManagerItem::rotateRight()
+{
+    TransformImageOperation* op = new TransformImageOperation(ROT_90);
+    applyImageOperation(op);
+}
+
+void ImageOpsContextManagerItem::mirror()
+{
+    TransformImageOperation* op = new TransformImageOperation(HFLIP);
+    applyImageOperation(op);
+}
+
+void ImageOpsContextManagerItem::flip()
+{
+    TransformImageOperation* op = new TransformImageOperation(VFLIP);
+    applyImageOperation(op);
+}
+
+void ImageOpsContextManagerItem::resizeImage()
+{
+    if (!d->ensureEditable()) {
+        return;
+    }
+    Document::Ptr doc = DocumentFactory::instance()->load(contextManager()->currentUrl());
+    doc->startLoadingFullImage();
     ResizeImageDialog dialog(d->mMainWindow);
     dialog.setOriginalSize(doc->size());
     if (!dialog.exec()) {
         return;
     }
-	ResizeImageOperation* op = new ResizeImageOperation(dialog.size());
-	applyImageOperation(op);
-}
-
-
-void ImageOpsContextManagerItem::crop() {
-	if (!d->ensureEditable()) {
-		return;
-	}
-	ImageView* imageView = d->mMainWindow->documentPanel()->imageView();
-	if (!imageView) {
-		kError() << "No ImageView available!";
-		return;
-	}
-	CropTool* tool = new CropTool(imageView);
-	connect(tool, SIGNAL(imageOperationRequested(AbstractImageOperation*)),
-		SLOT(applyImageOperation(AbstractImageOperation*)) );
-	connect(tool, SIGNAL(done()),
-		SLOT(restoreDefaultImageViewTool()) );
-
-	d->mMainWindow->setDistractionFreeMode(true);
-	imageView->setCurrentTool(tool);
-}
-
-
-void ImageOpsContextManagerItem::startRedEyeReduction() {
-	if (!d->ensureEditable()) {
-		return;
-	}
-	ImageView* imageView = d->mMainWindow->documentPanel()->imageView();
-	if (!imageView) {
-		kError() << "No ImageView available!";
-		return;
-	}
-	RedEyeReductionTool* tool = new RedEyeReductionTool(imageView);
-	connect(tool, SIGNAL(imageOperationRequested(AbstractImageOperation*)),
-		SLOT(applyImageOperation(AbstractImageOperation*)) );
-	connect(tool, SIGNAL(done()),
-		SLOT(restoreDefaultImageViewTool()) );
-
-	d->mMainWindow->setDistractionFreeMode(true);
-	imageView->setCurrentTool(tool);
-}
-
-
-void ImageOpsContextManagerItem::applyImageOperation(AbstractImageOperation* op) {
-	// For now, we only support operations on one image
-	KUrl url = contextManager()->currentUrl();
-
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	op->applyToDocument(doc);
-}
-
-
-void ImageOpsContextManagerItem::restoreDefaultImageViewTool() {
-	ImageView* imageView = d->mMainWindow->documentPanel()->imageView();
-	if (!imageView) {
-		kError() << "No ImageView available!";
-		return;
-	}
-
-	AbstractImageViewTool* tool = imageView->currentTool();
-	imageView->setCurrentTool(0);
-	tool->deleteLater();
-	d->mMainWindow->setDistractionFreeMode(false);
-}
-
+    ResizeImageOperation* op = new ResizeImageOperation(dialog.size());
+    applyImageOperation(op);
+}
+
+void ImageOpsContextManagerItem::crop()
+{
+    if (!d->ensureEditable()) {
+        return;
+    }
+    RasterImageView* imageView = d->mMainWindow->documentPanel()->imageView();
+    if (!imageView) {
+        kError() << "No ImageView available!";
+        return;
+    }
+    CropTool* tool = new CropTool(imageView);
+    connect(tool, SIGNAL(imageOperationRequested(AbstractImageOperation*)),
+            SLOT(applyImageOperation(AbstractImageOperation*)));
+    connect(tool, SIGNAL(done()),
+            SLOT(restoreDefaultImageViewTool()));
+
+    d->mMainWindow->setDistractionFreeMode(true);
+    imageView->setCurrentTool(tool);
+}
+
+void ImageOpsContextManagerItem::startRedEyeReduction()
+{
+    if (!d->ensureEditable()) {
+        return;
+    }
+    RasterImageView* view = d->mMainWindow->documentPanel()->imageView();
+    if (!view) {
+        kError() << "No RasterImageView available!";
+        return;
+    }
+    RedEyeReductionTool* tool = new RedEyeReductionTool(view);
+    connect(tool, SIGNAL(imageOperationRequested(AbstractImageOperation*)),
+            SLOT(applyImageOperation(AbstractImageOperation*)));
+    connect(tool, SIGNAL(done()),
+            SLOT(restoreDefaultImageViewTool()));
+
+    d->mMainWindow->setDistractionFreeMode(true);
+    view->setCurrentTool(tool);
+}
+
+void ImageOpsContextManagerItem::applyImageOperation(AbstractImageOperation* op)
+{
+    // For now, we only support operations on one image
+    KUrl url = contextManager()->currentUrl();
+
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    op->applyToDocument(doc);
+}
+
+void ImageOpsContextManagerItem::restoreDefaultImageViewTool()
+{
+    RasterImageView* imageView = d->mMainWindow->documentPanel()->imageView();
+    if (!imageView) {
+        kError() << "No RasterImageView available!";
+        return;
+    }
+
+    AbstractRasterImageViewTool* tool = imageView->currentTool();
+    imageView->setCurrentTool(0);
+    tool->deleteLater();
+    d->mMainWindow->setDistractionFreeMode(false);
+}
 
 } // namespace

=== modified file 'app/imageopscontextmanageritem.h'
--- app/imageopscontextmanageritem.h	2011-07-20 13:46:34 +0000
+++ app/imageopscontextmanageritem.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -28,41 +28,37 @@
 // Local
 #include "abstractcontextmanageritem.h"
 
-
-
-
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class AbstractImageOperation;
 class MainWindow;
 
-
-class ImageOpsContextManagerItem : public AbstractContextManagerItem {
-	Q_OBJECT
+class ImageOpsContextManagerItem : public AbstractContextManagerItem
+{
+    Q_OBJECT
 public:
-	ImageOpsContextManagerItem(ContextManager*, MainWindow*);
-	~ImageOpsContextManagerItem();
+    ImageOpsContextManagerItem(ContextManager*, MainWindow*);
+    ~ImageOpsContextManagerItem();
 
 private Q_SLOTS:
-	void updateActions();
-	void updateSideBarContent();
-	void rotateLeft();
-	void rotateRight();
-	void mirror();
-	void flip();
-	void resizeImage();
-	void crop();
-	void startRedEyeReduction();
-	void applyImageOperation(AbstractImageOperation*);
-	void restoreDefaultImageViewTool();
+    void updateActions();
+    void updateSideBarContent();
+    void rotateLeft();
+    void rotateRight();
+    void mirror();
+    void flip();
+    void resizeImage();
+    void crop();
+    void startRedEyeReduction();
+    void applyImageOperation(AbstractImageOperation*);
+    void restoreDefaultImageViewTool();
 
 private:
-	struct Private;
-	Private* const d;
+    struct Private;
+    Private* const d;
 };
 
-
 } // namespace
 
 #endif /* IMAGEOPSCONTEXTMANAGERITEM_H */

=== modified file 'app/infocontextmanageritem.cpp'
--- app/infocontextmanageritem.cpp	2011-07-20 13:46:34 +0000
+++ app/infocontextmanageritem.cpp	2011-12-15 14:17:54 +0000
@@ -46,7 +46,8 @@
 #include <lib/document/document.h>
 #include <lib/document/documentfactory.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -61,330 +62,339 @@
  * A label which fades out if its content does not fit. If the content is
  * cropped, a tooltip is shown when the mouse hovers the widget.
  */
-class FadingLabel : public QLabel {
+class FadingLabel : public QLabel
+{
 public:
-	explicit FadingLabel(QWidget* parent = 0)
-	: QLabel(parent)
-	{
-		setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
-		setTextInteractionFlags(Qt::TextBrowserInteraction);
-	}
+    explicit FadingLabel(QWidget* parent = 0)
+        : QLabel(parent) {
+        setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
+        setTextInteractionFlags(Qt::TextBrowserInteraction);
+    }
 
-	QSize minimumSizeHint() const {
-		return QSize();
-	}
+    QSize minimumSizeHint() const {
+        return QSize();
+    }
 
 protected:
-	void paintEvent(QPaintEvent* event) {
-		QLabel::paintEvent(event);
-		if (!isCropped()) {
-			return;
-		}
-
-		QLinearGradient gradient;
-		int gradientWidth = fontMetrics().averageCharWidth() * 4;
-		if (alignment() & Qt::AlignLeft) {
-			gradient.setStart(width() - gradientWidth, 0);
-			gradient.setFinalStop(width(), 0);
-			gradient.setColorAt(0, Qt::transparent);
-			gradient.setColorAt(1, palette().color(backgroundRole()));
-		} else {
-			gradient.setStart(0, 0);
-			gradient.setFinalStop(gradientWidth, 0);
-			gradient.setColorAt(0, palette().color(backgroundRole()));
-			gradient.setColorAt(1, Qt::transparent);
-		}
-		QPainter painter(this);
-		painter.fillRect(rect(), gradient);
-	}
-
-	bool event(QEvent* event) {
-		if (event->type() == QEvent::ToolTip) {
-			// Show tooltip if cropped
-			QHelpEvent* helpEvent = static_cast<QHelpEvent*>(event);
-			if (isCropped()) {
-				QToolTip::showText(helpEvent->globalPos(), text());
-			} else {
-				QToolTip::hideText();
-				event->ignore();
-			}
-			return true;
-		}
-		return QLabel::event(event);
-	}
-
-	inline bool isCropped() const {
-		return sizeHint().width() > width();
-	}
+    void paintEvent(QPaintEvent* event)
+    {
+        QLabel::paintEvent(event);
+        if (!isCropped()) {
+            return;
+        }
+
+        QLinearGradient gradient;
+        int gradientWidth = fontMetrics().averageCharWidth() * 4;
+        if (alignment() & Qt::AlignLeft) {
+            gradient.setStart(width() - gradientWidth, 0);
+            gradient.setFinalStop(width(), 0);
+            gradient.setColorAt(0, Qt::transparent);
+            gradient.setColorAt(1, palette().color(backgroundRole()));
+        } else {
+            gradient.setStart(0, 0);
+            gradient.setFinalStop(gradientWidth, 0);
+            gradient.setColorAt(0, palette().color(backgroundRole()));
+            gradient.setColorAt(1, Qt::transparent);
+        }
+        QPainter painter(this);
+        painter.fillRect(rect(), gradient);
+    }
+
+    bool event(QEvent* event)
+    {
+        if (event->type() == QEvent::ToolTip) {
+            // Show tooltip if cropped
+            QHelpEvent* helpEvent = static_cast<QHelpEvent*>(event);
+            if (isCropped()) {
+                QToolTip::showText(helpEvent->globalPos(), text());
+            } else {
+                QToolTip::hideText();
+                event->ignore();
+            }
+            return true;
+        }
+        return QLabel::event(event);
+    }
+
+    inline bool isCropped() const {
+        return sizeHint().width() > width();
+    }
 };
 
 /**
  * This widget is capable of showing multiple lines of key/value pairs.
  */
-class KeyValueWidget : public QWidget {
-	struct Row {
-		Row()
-		: keyLabel(new FadingLabel)
-		, valueLabel(new FadingLabel)
-		{
-			if (QApplication::isLeftToRight()) {
-				keyLabel->setAlignment(Qt::AlignRight);
-			} else {
-				valueLabel->setAlignment(Qt::AlignRight);
-			}
-		}
-
-		~Row() {
-			delete keyLabel;
-			delete valueLabel;
-		}
-
-		FadingLabel* keyLabel;
-		FadingLabel* valueLabel;
-	};
+class KeyValueWidget : public QWidget
+{
+    struct Row {
+        Row()
+            : keyLabel(new FadingLabel)
+            , valueLabel(new FadingLabel) {
+            if (QApplication::isLeftToRight()) {
+                keyLabel->setAlignment(Qt::AlignRight);
+            } else {
+                valueLabel->setAlignment(Qt::AlignRight);
+            }
+        }
+
+        ~Row() {
+            delete keyLabel;
+            delete valueLabel;
+        }
+
+        FadingLabel* keyLabel;
+        FadingLabel* valueLabel;
+    };
 public:
-	KeyValueWidget(QWidget* parent)
-	: QWidget(parent)
-	, mLayout(new QGridLayout(this))
-	{
-		mLayout->setMargin(0);
-		mLayout->setVerticalSpacing(0);
-		mLayout->setHorizontalSpacing(4);
-		setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);
-	}
-
-	QSize sizeHint() const {
-		int height = fontMetrics().height() * mRows.count();
-		return QSize(150, height);
-	}
-
-	void addRow(const QString& key, const QString& value) {
-		Row* row = new Row;
-		row->keyLabel->setText(i18nc(
-			"@item:intext %1 is a key, we append a colon to it. A value is displayed after",
-			"%1:", key));
-		row->valueLabel->setText(value);
-		mRows.append(row);
-
-		int rowCount = mLayout->rowCount();
-		mLayout->addWidget(row->keyLabel, rowCount, 0);
-		mLayout->addWidget(row->valueLabel, rowCount, 1);
-		updateKeyColumnWidth();
-		updateGeometry();
-	}
-
-	void clear() {
-		qDeleteAll(mRows);
-		mRows.clear();
-		updateGeometry();
-	}
+    KeyValueWidget(QWidget* parent)
+        : QWidget(parent)
+        , mLayout(new QGridLayout(this)) {
+        mLayout->setMargin(0);
+        mLayout->setVerticalSpacing(0);
+        mLayout->setHorizontalSpacing(4);
+        setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);
+    }
+
+    QSize sizeHint() const {
+        int height = fontMetrics().height() * mRows.count();
+        return QSize(150, height);
+    }
+
+    void addRow(const QString& key, const QString& value)
+    {
+        Row* row = new Row;
+        row->keyLabel->setText(i18nc(
+                                   "@item:intext %1 is a key, we append a colon to it. A value is displayed after",
+                                   "%1:", key));
+        row->valueLabel->setText(value);
+        mRows.append(row);
+
+        int rowCount = mLayout->rowCount();
+        mLayout->addWidget(row->keyLabel, rowCount, 0);
+        mLayout->addWidget(row->valueLabel, rowCount, 1);
+        updateKeyColumnWidth();
+        updateGeometry();
+    }
+
+    void clear()
+    {
+        qDeleteAll(mRows);
+        mRows.clear();
+        updateGeometry();
+    }
 
 protected:
-	void resizeEvent(QResizeEvent* event) {
-		QWidget::resizeEvent(event);
-		updateKeyColumnWidth();
-		updateGeometry();
-	}
+    void resizeEvent(QResizeEvent* event)
+    {
+        QWidget::resizeEvent(event);
+        updateKeyColumnWidth();
+        updateGeometry();
+    }
 
 private:
-	QList<Row*> mRows;
-	QGridLayout* mLayout;
+    QList<Row*> mRows;
+    QGridLayout* mLayout;
 
-	void updateKeyColumnWidth() {
-		const int maxWidth = width() / 2;
-		int keyWidth = 0;
-		Q_FOREACH(Row* row, mRows) {
-			int wantedWidth = row->keyLabel->sizeHint().width();
-			if (wantedWidth > keyWidth) {
-				keyWidth = qMin(wantedWidth, maxWidth);
-			}
-		}
-		Q_FOREACH(Row* row, mRows) {
-			row->keyLabel->setFixedWidth(keyWidth);
-		}
-	}
+    void updateKeyColumnWidth()
+    {
+        const int maxWidth = width() / 2;
+        int keyWidth = 0;
+        Q_FOREACH(Row * row, mRows) {
+            int wantedWidth = row->keyLabel->sizeHint().width();
+            if (wantedWidth > keyWidth) {
+                keyWidth = qMin(wantedWidth, maxWidth);
+            }
+        }
+        Q_FOREACH(Row * row, mRows) {
+            row->keyLabel->setFixedWidth(keyWidth);
+        }
+    }
 };
 
 struct InfoContextManagerItemPrivate {
-	InfoContextManagerItem* q;
-	SideBarGroup* mGroup;
-
-	// One selection fields
-	QWidget* mOneFileWidget;
-	KeyValueWidget* mKeyValueWidget;
-	Document::Ptr mDocument;
-
-	// Multiple selection fields
-	QLabel* mMultipleFilesLabel;
-
-	QPointer<ImageMetaInfoDialog> mImageMetaInfoDialog;
-
-	void updateMetaInfoDialog() {
-		if (!mImageMetaInfoDialog) {
-			return;
-		}
-		ImageMetaInfoModel* model = mDocument ? mDocument->metaInfo() : 0;
-		mImageMetaInfoDialog->setMetaInfo(model, GwenviewConfig::preferredMetaInfoKeyList());
-	}
-
-
-	void setupGroup() {
-		mOneFileWidget = new QWidget();
-
-		mKeyValueWidget = new KeyValueWidget(mOneFileWidget);
-
-		QLabel* moreLabel = new QLabel(mOneFileWidget);
-		moreLabel->setText(QString("<a href='#'>%1</a>").arg(i18nc("@action show more image meta info", "More...")));
-		moreLabel->setAlignment(Qt::AlignRight);
-
-		QVBoxLayout* layout = new QVBoxLayout(mOneFileWidget);
-		layout->setMargin(2);
-		layout->setSpacing(2);
-		layout->addWidget(mKeyValueWidget);
-		layout->addWidget(moreLabel);
-
-		mMultipleFilesLabel = new QLabel();
-
-		mGroup = new SideBarGroup(i18nc("@title:group", "Meta Information"));
-		q->setWidget(mGroup);
-		mGroup->addWidget(mOneFileWidget);
-		mGroup->addWidget(mMultipleFilesLabel);
-
-		EventWatcher::install(mGroup, QEvent::Show, q, SLOT(updateSideBarContent()));
-
-		QObject::connect(moreLabel, SIGNAL(linkActivated(const QString&)),
-			q, SLOT(showMetaInfoDialog()) );
-	}
-
-	void forgetCurrentDocument() {
-		if (mDocument) {
-			QObject::disconnect(mDocument.data(), 0, q, 0);
-			// "Garbage collect" document
-			mDocument = 0;
-		}
-	}
+    InfoContextManagerItem* q;
+    SideBarGroup* mGroup;
+
+    // One selection fields
+    QWidget* mOneFileWidget;
+    KeyValueWidget* mKeyValueWidget;
+    Document::Ptr mDocument;
+
+    // Multiple selection fields
+    QLabel* mMultipleFilesLabel;
+
+    QPointer<ImageMetaInfoDialog> mImageMetaInfoDialog;
+
+    void updateMetaInfoDialog()
+    {
+        if (!mImageMetaInfoDialog) {
+            return;
+        }
+        ImageMetaInfoModel* model = mDocument ? mDocument->metaInfo() : 0;
+        mImageMetaInfoDialog->setMetaInfo(model, GwenviewConfig::preferredMetaInfoKeyList());
+    }
+
+    void setupGroup()
+    {
+        mOneFileWidget = new QWidget();
+
+        mKeyValueWidget = new KeyValueWidget(mOneFileWidget);
+
+        QLabel* moreLabel = new QLabel(mOneFileWidget);
+        moreLabel->setText(QString("<a href='#'>%1</a>").arg(i18nc("@action show more image meta info", "More...")));
+        moreLabel->setAlignment(Qt::AlignRight);
+
+        QVBoxLayout* layout = new QVBoxLayout(mOneFileWidget);
+        layout->setMargin(2);
+        layout->setSpacing(2);
+        layout->addWidget(mKeyValueWidget);
+        layout->addWidget(moreLabel);
+
+        mMultipleFilesLabel = new QLabel();
+
+        mGroup = new SideBarGroup(i18nc("@title:group", "Meta Information"));
+        q->setWidget(mGroup);
+        mGroup->addWidget(mOneFileWidget);
+        mGroup->addWidget(mMultipleFilesLabel);
+
+        EventWatcher::install(mGroup, QEvent::Show, q, SLOT(updateSideBarContent()));
+
+        QObject::connect(moreLabel, SIGNAL(linkActivated(QString)),
+                         q, SLOT(showMetaInfoDialog()));
+    }
+
+    void forgetCurrentDocument()
+    {
+        if (mDocument) {
+            QObject::disconnect(mDocument.data(), 0, q, 0);
+            // "Garbage collect" document
+            mDocument = 0;
+        }
+    }
 };
 
-
 InfoContextManagerItem::InfoContextManagerItem(ContextManager* manager)
 : AbstractContextManagerItem(manager)
-, d(new InfoContextManagerItemPrivate) {
-	d->q = this;
-	d->setupGroup();
-	connect(contextManager(), SIGNAL(selectionChanged()),
-		SLOT(updateSideBarContent()) );
-	connect(contextManager(), SIGNAL(selectionDataChanged()),
-		SLOT(updateSideBarContent()) );
-}
-
-InfoContextManagerItem::~InfoContextManagerItem() {
-	delete d;
-}
-
-
-void InfoContextManagerItem::updateSideBarContent() {
-	LOG("updateSideBarContent");
-	if (!d->mGroup->isVisible()) {
-		LOG("updateSideBarContent: not visible, not updating");
-		return;
-	}
-	LOG("updateSideBarContent: really updating");
-
-	KFileItemList itemList = contextManager()->selectedFileItemList();
-	if (itemList.count() == 0) {
-		d->forgetCurrentDocument();
-		d->mOneFileWidget->hide();
-		d->mMultipleFilesLabel->hide();
-		d->updateMetaInfoDialog();
-		return;
-	}
-
-	KFileItem item = itemList.first();
-	if (itemList.count() == 1 && !ArchiveUtils::fileItemIsDirOrArchive(item)) {
-		fillOneFileGroup(item);
-	} else {
-		fillMultipleItemsGroup(itemList);
-	}
-	d->updateMetaInfoDialog();
-}
-
-void InfoContextManagerItem::fillOneFileGroup(const KFileItem& item) {
-	d->mOneFileWidget->show();
-	d->mMultipleFilesLabel->hide();
-
-	d->forgetCurrentDocument();
-	d->mDocument = DocumentFactory::instance()->load(item.url());
-	connect(d->mDocument.data(), SIGNAL(metaInfoUpdated()),
-		SLOT(updateOneFileInfo()) );
-
-	d->updateMetaInfoDialog();
-	updateOneFileInfo();
-}
-
-void InfoContextManagerItem::fillMultipleItemsGroup(const KFileItemList& itemList) {
-	d->forgetCurrentDocument();
-
-	int folderCount = 0, fileCount = 0;
-	Q_FOREACH(const KFileItem& item, itemList) {
-		if (item.isDir()) {
-			folderCount++;
-		} else {
-			fileCount++;
-		}
-	}
-
-	if (folderCount == 0) {
-		d->mMultipleFilesLabel->setText(i18ncp("@label", "%1 file selected", "%1 files selected", fileCount));
-	} else if (fileCount == 0) {
-		d->mMultipleFilesLabel->setText(i18ncp("@label", "%1 folder selected", "%1 folders selected", folderCount));
-	} else {
-		d->mMultipleFilesLabel->setText(i18nc("@label. The two parameters are strings like '2 folders' and '1 file'.",
-			"%1 and %2 selected", i18np("%1 folder", "%1 folders", folderCount), i18np("%1 file", "%1 files", fileCount)));
-	}
-	d->mOneFileWidget->hide();
-	d->mMultipleFilesLabel->show();
-}
-
-
-void InfoContextManagerItem::updateOneFileInfo() {
-	if (!d->mDocument) {
-		return;
-	}
-
-	QStringList list;
-	d->mKeyValueWidget->clear();
-	ImageMetaInfoModel* metaInfoModel = d->mDocument->metaInfo();
-	Q_FOREACH(const QString& key, GwenviewConfig::preferredMetaInfoKeyList()) {
-		QString label;
-		QString value;
-		metaInfoModel->getInfoForKey(key, &label, &value);
-
-		if (!label.isEmpty() && !value.isEmpty()) {
-			d->mKeyValueWidget->addRow(label, value);
-		}
-	}
-
-	d->mKeyValueWidget->show();
-}
-
-
-void InfoContextManagerItem::showMetaInfoDialog() {
-	if (!d->mImageMetaInfoDialog) {
-		d->mImageMetaInfoDialog = new ImageMetaInfoDialog(d->mOneFileWidget);
-		d->mImageMetaInfoDialog->setAttribute(Qt::WA_DeleteOnClose, true);
-		connect(d->mImageMetaInfoDialog, SIGNAL(preferredMetaInfoKeyListChanged(const QStringList&)),
-			SLOT(slotPreferredMetaInfoKeyListChanged(const QStringList&)) );
-	}
-	d->mImageMetaInfoDialog->setMetaInfo(d->mDocument ? d->mDocument->metaInfo() : 0, GwenviewConfig::preferredMetaInfoKeyList());
-	d->mImageMetaInfoDialog->show();
-}
-
-
-void InfoContextManagerItem::slotPreferredMetaInfoKeyListChanged(const QStringList& list) {
-	GwenviewConfig::setPreferredMetaInfoKeyList(list);
-	GwenviewConfig::self()->writeConfig();
-	updateOneFileInfo();
-}
-
+, d(new InfoContextManagerItemPrivate)
+{
+    d->q = this;
+    d->setupGroup();
+    connect(contextManager(), SIGNAL(selectionChanged()),
+            SLOT(updateSideBarContent()));
+    connect(contextManager(), SIGNAL(selectionDataChanged()),
+            SLOT(updateSideBarContent()));
+}
+
+InfoContextManagerItem::~InfoContextManagerItem()
+{
+    delete d;
+}
+
+void InfoContextManagerItem::updateSideBarContent()
+{
+    LOG("updateSideBarContent");
+    if (!d->mGroup->isVisible()) {
+        LOG("updateSideBarContent: not visible, not updating");
+        return;
+    }
+    LOG("updateSideBarContent: really updating");
+
+    KFileItemList itemList = contextManager()->selectedFileItemList();
+    if (itemList.count() == 0) {
+        d->forgetCurrentDocument();
+        d->mOneFileWidget->hide();
+        d->mMultipleFilesLabel->hide();
+        d->updateMetaInfoDialog();
+        return;
+    }
+
+    KFileItem item = itemList.first();
+    if (itemList.count() == 1 && !ArchiveUtils::fileItemIsDirOrArchive(item)) {
+        fillOneFileGroup(item);
+    } else {
+        fillMultipleItemsGroup(itemList);
+    }
+    d->updateMetaInfoDialog();
+}
+
+void InfoContextManagerItem::fillOneFileGroup(const KFileItem& item)
+{
+    d->mOneFileWidget->show();
+    d->mMultipleFilesLabel->hide();
+
+    d->forgetCurrentDocument();
+    d->mDocument = DocumentFactory::instance()->load(item.url());
+    connect(d->mDocument.data(), SIGNAL(metaInfoUpdated()),
+            SLOT(updateOneFileInfo()));
+
+    d->updateMetaInfoDialog();
+    updateOneFileInfo();
+}
+
+void InfoContextManagerItem::fillMultipleItemsGroup(const KFileItemList& itemList)
+{
+    d->forgetCurrentDocument();
+
+    int folderCount = 0, fileCount = 0;
+    Q_FOREACH(const KFileItem & item, itemList) {
+        if (item.isDir()) {
+            folderCount++;
+        } else {
+            fileCount++;
+        }
+    }
+
+    if (folderCount == 0) {
+        d->mMultipleFilesLabel->setText(i18ncp("@label", "%1 file selected", "%1 files selected", fileCount));
+    } else if (fileCount == 0) {
+        d->mMultipleFilesLabel->setText(i18ncp("@label", "%1 folder selected", "%1 folders selected", folderCount));
+    } else {
+        d->mMultipleFilesLabel->setText(i18nc("@label. The two parameters are strings like '2 folders' and '1 file'.",
+                                              "%1 and %2 selected", i18np("%1 folder", "%1 folders", folderCount), i18np("%1 file", "%1 files", fileCount)));
+    }
+    d->mOneFileWidget->hide();
+    d->mMultipleFilesLabel->show();
+}
+
+void InfoContextManagerItem::updateOneFileInfo()
+{
+    if (!d->mDocument) {
+        return;
+    }
+
+    QStringList list;
+    d->mKeyValueWidget->clear();
+    ImageMetaInfoModel* metaInfoModel = d->mDocument->metaInfo();
+    Q_FOREACH(const QString & key, GwenviewConfig::preferredMetaInfoKeyList()) {
+        QString label;
+        QString value;
+        metaInfoModel->getInfoForKey(key, &label, &value);
+
+        if (!label.isEmpty() && !value.isEmpty()) {
+            d->mKeyValueWidget->addRow(label, value);
+        }
+    }
+
+    d->mKeyValueWidget->show();
+}
+
+void InfoContextManagerItem::showMetaInfoDialog()
+{
+    if (!d->mImageMetaInfoDialog) {
+        d->mImageMetaInfoDialog = new ImageMetaInfoDialog(d->mOneFileWidget);
+        d->mImageMetaInfoDialog->setAttribute(Qt::WA_DeleteOnClose, true);
+        connect(d->mImageMetaInfoDialog, SIGNAL(preferredMetaInfoKeyListChanged(QStringList)),
+                SLOT(slotPreferredMetaInfoKeyListChanged(QStringList)));
+    }
+    d->mImageMetaInfoDialog->setMetaInfo(d->mDocument ? d->mDocument->metaInfo() : 0, GwenviewConfig::preferredMetaInfoKeyList());
+    d->mImageMetaInfoDialog->show();
+}
+
+void InfoContextManagerItem::slotPreferredMetaInfoKeyListChanged(const QStringList& list)
+{
+    GwenviewConfig::setPreferredMetaInfoKeyList(list);
+    GwenviewConfig::self()->writeConfig();
+    updateOneFileInfo();
+}
 
 } // namespace

=== modified file 'app/infocontextmanageritem.h'
--- app/infocontextmanageritem.h	2011-07-20 13:46:34 +0000
+++ app/infocontextmanageritem.h	2011-12-15 14:17:54 +0000
@@ -29,29 +29,31 @@
 class KFileItem;
 class KFileItemList;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct InfoContextManagerItemPrivate;
 
-class InfoContextManagerItem : public AbstractContextManagerItem {
-	Q_OBJECT
+class InfoContextManagerItem : public AbstractContextManagerItem
+{
+    Q_OBJECT
 public:
-	InfoContextManagerItem(ContextManager*);
-	~InfoContextManagerItem();
+    InfoContextManagerItem(ContextManager*);
+    ~InfoContextManagerItem();
 
 private Q_SLOTS:
-	void updateSideBarContent();
-	void updateOneFileInfo();
-	void showMetaInfoDialog();
-	void slotPreferredMetaInfoKeyListChanged(const QStringList&);
+    void updateSideBarContent();
+    void updateOneFileInfo();
+    void showMetaInfoDialog();
+    void slotPreferredMetaInfoKeyListChanged(const QStringList&);
 
 private:
-	void fillOneFileGroup(const KFileItem& item);
-
-	void fillMultipleItemsGroup(const KFileItemList& itemList);
-
-	friend class InfoContextManagerItemPrivate;
-	InfoContextManagerItemPrivate* const d;
+    void fillOneFileGroup(const KFileItem& item);
+
+    void fillMultipleItemsGroup(const KFileItemList& itemList);
+
+    friend class InfoContextManagerItemPrivate;
+    InfoContextManagerItemPrivate* const d;
 };
 
 } // namespace

=== modified file 'app/kipiexportaction.cpp'
--- app/kipiexportaction.cpp	2011-07-20 13:46:34 +0000
+++ app/kipiexportaction.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -33,37 +33,38 @@
 #include <lib/gwenviewconfig.h>
 #include "kipiinterface.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct KIPIExportActionPrivate {
-	KIPIExportAction* q;
-	KIPIInterface* mKIPIInterface;
-	QAction* mDefaultAction;
-	QList<QAction*> mExportActionList;
-
-	void updateMenu() {
-		KMenu* menu = static_cast<KMenu*>(q->menu());
-		menu->clear();
-
-		if (mDefaultAction) {
-			menu->addTitle(i18n("Last Used Plugin"));
-			menu->addAction(mDefaultAction);
-			menu->addTitle(i18n("Other Plugins"));
-		}
-		Q_FOREACH(QAction* action, mExportActionList) {
-			action->setIconVisibleInMenu(true);
-			if (action != mDefaultAction) {
-				menu->addAction(action);
-			}
-		}
-		if (menu->isEmpty()) {
-			QAction* action = new QAction(menu);
-			action->setText(i18n("No Plugin Found"));
-			action->setEnabled(false);
-			menu->addAction(action);
-		}
-	}
+    KIPIExportAction* q;
+    KIPIInterface* mKIPIInterface;
+    QAction* mDefaultAction;
+    QList<QAction*> mExportActionList;
+
+    void updateMenu()
+    {
+        KMenu* menu = static_cast<KMenu*>(q->menu());
+        menu->clear();
+
+        if (mDefaultAction) {
+            menu->addTitle(i18n("Last Used Plugin"));
+            menu->addAction(mDefaultAction);
+            menu->addTitle(i18n("Other Plugins"));
+        }
+        Q_FOREACH(QAction * action, mExportActionList) {
+            action->setIconVisibleInMenu(true);
+            if (action != mDefaultAction) {
+                menu->addAction(action);
+            }
+        }
+        if (menu->isEmpty()) {
+            QAction* action = new QAction(menu);
+            action->setText(i18n("No Plugin Found"));
+            action->setEnabled(false);
+            menu->addAction(action);
+        }
+    }
 };
 
 /**
@@ -73,56 +74,56 @@
  */
 KIPIExportAction::KIPIExportAction(QObject* parent)
 : KToolBarPopupAction(KIcon("document-share"), i18n("Share"), parent)
-, d(new KIPIExportActionPrivate) {
-	d->q = this;
-	d->mKIPIInterface = 0;
-	d->mDefaultAction = 0;
-
-	setDelayed(false);
-	connect(menu(), SIGNAL(aboutToShow()), SLOT(init()));
-	connect(menu(), SIGNAL(triggered(QAction*)), SLOT(setDefaultAction(QAction*)));
-}
-
-
-KIPIExportAction::~KIPIExportAction() {
-	delete d;
-}
-
-
-void KIPIExportAction::setKIPIInterface(KIPIInterface* interface) {
-	d->mKIPIInterface = interface;
-}
-
-
-void KIPIExportAction::init() {
-	if (!menu()->isEmpty()) {
-		return;
-	}
-	d->mKIPIInterface->loadPlugins();
-	d->mExportActionList = d->mKIPIInterface->pluginActions(KIPI::ExportPlugin);
-
-	// Look for default action
-	QString defaultActionText = GwenviewConfig::defaultExportPluginText();
-	Q_FOREACH(QAction* action, d->mExportActionList) {
-		if (action->text() == defaultActionText) {
-			setDefaultAction(action);
-			break;
-		}
-	}
-
-	d->updateMenu();
-}
-
-
-void KIPIExportAction::setDefaultAction(QAction* action) {
-	if (action == d->mDefaultAction) {
-		return;
-	}
-	d->mDefaultAction = action;
-
-	GwenviewConfig::setDefaultExportPluginText(action->text());
-	d->updateMenu();
-}
-
+, d(new KIPIExportActionPrivate)
+{
+    d->q = this;
+    d->mKIPIInterface = 0;
+    d->mDefaultAction = 0;
+
+    setDelayed(false);
+    connect(menu(), SIGNAL(aboutToShow()), SLOT(init()));
+    connect(menu(), SIGNAL(triggered(QAction*)), SLOT(setDefaultAction(QAction*)));
+}
+
+KIPIExportAction::~KIPIExportAction()
+{
+    delete d;
+}
+
+void KIPIExportAction::setKIPIInterface(KIPIInterface* interface)
+{
+    d->mKIPIInterface = interface;
+}
+
+void KIPIExportAction::init()
+{
+    if (!menu()->isEmpty()) {
+        return;
+    }
+    d->mKIPIInterface->loadPlugins();
+    d->mExportActionList = d->mKIPIInterface->pluginActions(KIPI::ExportPlugin);
+
+    // Look for default action
+    QString defaultActionText = GwenviewConfig::defaultExportPluginText();
+    Q_FOREACH(QAction * action, d->mExportActionList) {
+        if (action->text() == defaultActionText) {
+            setDefaultAction(action);
+            break;
+        }
+    }
+
+    d->updateMenu();
+}
+
+void KIPIExportAction::setDefaultAction(QAction* action)
+{
+    if (action == d->mDefaultAction) {
+        return;
+    }
+    d->mDefaultAction = action;
+
+    GwenviewConfig::setDefaultExportPluginText(action->text());
+    d->updateMenu();
+}
 
 } // namespace

=== modified file 'app/kipiexportaction.h'
--- app/kipiexportaction.h	2011-07-20 13:46:34 +0000
+++ app/kipiexportaction.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -28,28 +28,29 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class KIPIInterface;
 
 class KIPIExportActionPrivate;
-class KIPIExportAction : public KToolBarPopupAction {
-	Q_OBJECT
+class KIPIExportAction : public KToolBarPopupAction
+{
+    Q_OBJECT
 public:
-	KIPIExportAction(QObject* parent);
-	~KIPIExportAction();
+    KIPIExportAction(QObject* parent);
+    ~KIPIExportAction();
 
-	void setKIPIInterface(KIPIInterface*);
+    void setKIPIInterface(KIPIInterface*);
 
 private Q_SLOTS:
-	void init();
-	void setDefaultAction(QAction*);
+    void init();
+    void setDefaultAction(QAction*);
 
 private:
-	KIPIExportActionPrivate* const d;
+    KIPIExportActionPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* KIPIEXPORTACTION_H */

=== modified file 'app/kipiimagecollectionselector.cpp'
--- app/kipiimagecollectionselector.cpp	2011-07-20 13:46:34 +0000
+++ app/kipiimagecollectionselector.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,63 +30,61 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct KIPIImageCollectionSelectorPrivate {
-	KIPIInterface* mInterface;
-	QListWidget* mListWidget;
+    KIPIInterface* mInterface;
+    QListWidget* mListWidget;
 };
 
-
 KIPIImageCollectionSelector::KIPIImageCollectionSelector(KIPIInterface* interface, QWidget* parent)
 : KIPI::ImageCollectionSelector(parent)
-, d(new KIPIImageCollectionSelectorPrivate) {
-	d->mInterface = interface;
-
-	d->mListWidget = new QListWidget;
-	QList<KIPI::ImageCollection> list = interface->allAlbums();
-	Q_FOREACH(const KIPI::ImageCollection& collection, list) {
-		QListWidgetItem* item = new QListWidgetItem(d->mListWidget);
-		QString name = collection.name();
-		int imageCount = collection.images().size();
-		QString title = i18ncp("%1 is collection name, %2 is image count in collection",
-			"%1 (%2 image)", "%1 (%2 images)", name, imageCount);
-
-		item->setText(title);
-		item->setData(Qt::UserRole, name);
-	}
-
-	connect(d->mListWidget, SIGNAL(currentRowChanged(int)),
-		SIGNAL(selectionChanged()) );
-
-	QVBoxLayout* layout = new QVBoxLayout(this);
-	layout->addWidget(d->mListWidget);
-	layout->setMargin(0);
-}
-
-
-KIPIImageCollectionSelector::~KIPIImageCollectionSelector() {
-	delete d;
-}
-
-
-
-QList<KIPI::ImageCollection> KIPIImageCollectionSelector::selectedImageCollections() const {
-	QListWidgetItem* item = d->mListWidget->currentItem();
-	QList<KIPI::ImageCollection> selectedList;
-	if (item) {
-		QString name = item->data(Qt::UserRole).toString();
-		QList<KIPI::ImageCollection> list = d->mInterface->allAlbums();
-		Q_FOREACH(const KIPI::ImageCollection& collection, list) {
-			if (collection.name() == name) {
-				selectedList << collection;
-				break;
-			}
-		}
-	}
-	return selectedList;
-}
-
+, d(new KIPIImageCollectionSelectorPrivate)
+{
+    d->mInterface = interface;
+
+    d->mListWidget = new QListWidget;
+    QList<KIPI::ImageCollection> list = interface->allAlbums();
+    Q_FOREACH(const KIPI::ImageCollection & collection, list) {
+        QListWidgetItem* item = new QListWidgetItem(d->mListWidget);
+        QString name = collection.name();
+        int imageCount = collection.images().size();
+        QString title = i18ncp("%1 is collection name, %2 is image count in collection",
+                               "%1 (%2 image)", "%1 (%2 images)", name, imageCount);
+
+        item->setText(title);
+        item->setData(Qt::UserRole, name);
+    }
+
+    connect(d->mListWidget, SIGNAL(currentRowChanged(int)),
+            SIGNAL(selectionChanged()));
+
+    QVBoxLayout* layout = new QVBoxLayout(this);
+    layout->addWidget(d->mListWidget);
+    layout->setMargin(0);
+}
+
+KIPIImageCollectionSelector::~KIPIImageCollectionSelector()
+{
+    delete d;
+}
+
+QList<KIPI::ImageCollection> KIPIImageCollectionSelector::selectedImageCollections() const
+{
+    QListWidgetItem* item = d->mListWidget->currentItem();
+    QList<KIPI::ImageCollection> selectedList;
+    if (item) {
+        QString name = item->data(Qt::UserRole).toString();
+        QList<KIPI::ImageCollection> list = d->mInterface->allAlbums();
+        Q_FOREACH(const KIPI::ImageCollection & collection, list) {
+            if (collection.name() == name) {
+                selectedList << collection;
+                break;
+            }
+        }
+    }
+    return selectedList;
+}
 
 } // namespace

=== modified file 'app/kipiimagecollectionselector.h'
--- app/kipiimagecollectionselector.h	2011-07-20 13:46:34 +0000
+++ app/kipiimagecollectionselector.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,23 +32,23 @@
 // Local
 #include "kipiinterface.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct KIPIImageCollectionSelectorPrivate;
-class KIPIImageCollectionSelector : public KIPI::ImageCollectionSelector {
-	Q_OBJECT
+class KIPIImageCollectionSelector : public KIPI::ImageCollectionSelector
+{
+    Q_OBJECT
 public:
-	KIPIImageCollectionSelector(KIPIInterface*, QWidget* parent);
-	~KIPIImageCollectionSelector();
+    KIPIImageCollectionSelector(KIPIInterface*, QWidget* parent);
+    ~KIPIImageCollectionSelector();
 
-	virtual QList<KIPI::ImageCollection> selectedImageCollections() const;
+    virtual QList<KIPI::ImageCollection> selectedImageCollections() const;
 
 private:
-	KIPIImageCollectionSelectorPrivate* const d;
+    KIPIImageCollectionSelectorPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* KIPIIMAGECOLLECTIONSELECTOR_H */

=== modified file 'app/kipiinterface.cpp'
--- app/kipiinterface.cpp	2011-07-20 13:46:34 +0000
+++ app/kipiinterface.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2000-2008 Aurélien Gâteau <agateau@kde.org>
@@ -50,7 +50,8 @@
 #include <lib/mimetypeutils.h>
 #include <lib/semanticinfo/sorteddirmodel.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 #undef ENABLE_LOG
 #undef LOG
 
@@ -61,331 +62,349 @@
 #define LOG(x) ;
 #endif
 
-
-class KIPIImageInfo : public KIPI::ImageInfoShared {
-	static const QRegExp sExtensionRE;
+class KIPIImageInfo : public KIPI::ImageInfoShared
+{
+    static const QRegExp sExtensionRE;
 public:
-	KIPIImageInfo(KIPI::Interface* interface, const KUrl& url) : KIPI::ImageInfoShared(interface, url) {}
-
-	QString title() {
-		QString txt=_url.fileName();
-		txt.replace('_', ' ');
-		txt.remove(sExtensionRE);
-		return txt;
-	}
-
-	QString description() {
-		if (!_url.isLocalFile()) return QString();
-
-		JpegContent content;
-		bool ok=content.load(_url.toLocalFile());
-		if (!ok) return QString();
-
-		return content.comment();
-	}
-
-	void setDescription(const QString&) {}
-
-	int angle() {
-		loadMetaInfo();
-
-		if (!mMetaInfo.isValid()) {
-			return 0;
-		}
-
-		const KFileMetaInfoItem& mii = mMetaInfo.item("http://freedesktop.org/standards/xesam/1.0/core#orientation");
-		bool ok = false;
-		const Orientation orientation = (Orientation)mii.value().toInt(&ok);
-		if (!ok) {
-			return 0;
-		}
-
-		switch(orientation) {
-		case NOT_AVAILABLE:
-		case NORMAL:
-			return 0;
-
-		case ROT_90:
-			return 90;
-
-		case ROT_180:
-			return 180;
-
-		case ROT_270:
-			return 270;
-
-		case HFLIP:
-		case VFLIP:
-		case TRANSPOSE:
-		case TRANSVERSE:
-			kWarning() << "Can't represent an orientation value of" << orientation << "as an angle (" << _url << ')';
-			return 0;
-		}
-
-		kWarning() << "Don't know how to handle an orientation value of" << orientation << '(' << _url << ')';
-		return 0;
-	}
-
-	QMap<QString,QVariant> attributes() {
-		return QMap<QString,QVariant>();
-	}
-
-	void delAttributes( const QStringList& ) {}
-
-	void clearAttributes() {}
-
-	void addAttributes(const QMap<QString, QVariant>&) {}
+    KIPIImageInfo(KIPI::Interface* interface, const KUrl& url) : KIPI::ImageInfoShared(interface, url) {}
+
+    QString title()
+    {
+        QString txt = _url.fileName();
+        txt.replace('_', ' ');
+        txt.remove(sExtensionRE);
+        return txt;
+    }
+
+    QString description()
+    {
+        if (!_url.isLocalFile()) return QString();
+
+        JpegContent content;
+        bool ok = content.load(_url.toLocalFile());
+        if (!ok) return QString();
+
+        return content.comment();
+    }
+
+    void setDescription(const QString&)
+    {}
+
+    int angle()
+    {
+        loadMetaInfo();
+
+        if (!mMetaInfo.isValid()) {
+            return 0;
+        }
+
+        const KFileMetaInfoItem& mii = mMetaInfo.item("http://freedesktop.org/standards/xesam/1.0/core#orientation");
+        bool ok = false;
+        const Orientation orientation = (Orientation)mii.value().toInt(&ok);
+        if (!ok) {
+            return 0;
+        }
+
+        switch (orientation) {
+        case NOT_AVAILABLE:
+        case NORMAL:
+            return 0;
+
+        case ROT_90:
+            return 90;
+
+        case ROT_180:
+            return 180;
+
+        case ROT_270:
+            return 270;
+
+        case HFLIP:
+        case VFLIP:
+        case TRANSPOSE:
+        case TRANSVERSE:
+            kWarning() << "Can't represent an orientation value of" << orientation << "as an angle (" << _url << ')';
+            return 0;
+        }
+
+        kWarning() << "Don't know how to handle an orientation value of" << orientation << '(' << _url << ')';
+        return 0;
+    }
+
+    QMap<QString, QVariant> attributes() {
+        return QMap<QString, QVariant>();
+    }
+
+    void delAttributes(const QStringList&)
+    {}
+
+    void clearAttributes()
+    {}
+
+    void addAttributes(const QMap<QString, QVariant>&)
+    {}
 
 private:
-	KFileMetaInfo mMetaInfo;
+    KFileMetaInfo mMetaInfo;
 
-	void loadMetaInfo() {
-		if (!mMetaInfo.isValid()) {
-			mMetaInfo = KFileMetaInfo(_url);
-		}
-	}
+    void loadMetaInfo()
+    {
+        if (!mMetaInfo.isValid()) {
+            mMetaInfo = KFileMetaInfo(_url);
+        }
+    }
 };
 
-const QRegExp KIPIImageInfo::sExtensionRE("\\.[a-z0-9]+$", Qt::CaseInsensitive );
-
+const QRegExp KIPIImageInfo::sExtensionRE("\\.[a-z0-9]+$", Qt::CaseInsensitive);
 
 struct MenuInfo {
-	QString mName;
-	QList<QAction*> mActions;
-	MenuInfo() {}
-	MenuInfo(const QString& name) : mName(name) {}
+    QString mName;
+    QList<QAction*> mActions;
+    MenuInfo() {}
+    MenuInfo(const QString& name) : mName(name) {}
 };
 typedef QMap<KIPI::Category, MenuInfo> MenuInfoMap;
 
-
 struct KIPIInterfacePrivate {
-	KIPIInterface* that;
-	MainWindow* mMainWindow;
-	QMenu* mPluginMenu;
-	KIPI::PluginLoader* mPluginLoader;
-	KIPI::PluginLoader::PluginList mPluginQueue;
-	MenuInfoMap mMenuInfoMap;
-
-	void setupPluginsMenu() {
-		mPluginMenu = static_cast<QMenu*>(
-			mMainWindow->factory()->container("plugins", mMainWindow));
-		QObject::connect(mPluginMenu, SIGNAL(aboutToShow()),
-			that, SLOT(loadPlugins()) );
-	}
-
-	void createDummyPluginAction(const QString& text) {
-		KAction* action = mMainWindow->actionCollection()->add<KAction>("dummy_plugin");
-		action->setText(text);
-		action->setShortcutConfigurable(false);
-		action->setEnabled(false);
-		mPluginMenu->addAction(action);
-	}
+    KIPIInterface* q;
+    MainWindow* mMainWindow;
+    QMenu* mPluginMenu;
+    KIPI::PluginLoader* mPluginLoader;
+    KIPI::PluginLoader::PluginList mPluginQueue;
+    MenuInfoMap mMenuInfoMap;
+
+    void setupPluginsMenu()
+    {
+        mPluginMenu = static_cast<QMenu*>(
+                          mMainWindow->factory()->container("plugins", mMainWindow));
+        QObject::connect(mPluginMenu, SIGNAL(aboutToShow()),
+                         q, SLOT(loadPlugins()));
+    }
+
+    void createDummyPluginAction(const QString& text)
+    {
+        KAction* action = mMainWindow->actionCollection()->add<KAction>("dummy_plugin");
+        action->setText(text);
+        action->setShortcutConfigurable(false);
+        action->setEnabled(false);
+        mPluginMenu->addAction(action);
+    }
 };
 
 KIPIInterface::KIPIInterface(MainWindow* mainWindow)
-:KIPI::Interface(mainWindow)
-, d(new KIPIInterfacePrivate) {
-	d->that = this;
-	d->mMainWindow = mainWindow;
-	d->mPluginLoader = 0;
+: KIPI::Interface(mainWindow)
+, d(new KIPIInterfacePrivate)
+{
+    d->q = this;
+    d->mMainWindow = mainWindow;
+    d->mPluginLoader = 0;
 
-	d->setupPluginsMenu();
-	QObject::connect(d->mMainWindow->contextManager(), SIGNAL(selectionChanged()),
-		this, SLOT(slotSelectionChanged()) );
-	QObject::connect(d->mMainWindow->contextManager(), SIGNAL(currentDirUrlChanged()),
-		this, SLOT(slotDirectoryChanged()) );
+    d->setupPluginsMenu();
+    QObject::connect(d->mMainWindow->contextManager(), SIGNAL(selectionChanged()),
+                     this, SLOT(slotSelectionChanged()));
+    QObject::connect(d->mMainWindow->contextManager(), SIGNAL(currentDirUrlChanged()),
+                     this, SLOT(slotDirectoryChanged()));
 #if 0
 //TODO instead of delaying can we load them all at start-up to use actions somewhere else?
 // delay a bit, so that it's called after loadPlugins()
-	QTimer::singleShot( 0, this, SLOT( init()));
+    QTimer::singleShot(0, this, SLOT(init()));
 #endif
 }
 
-
-KIPIInterface::~KIPIInterface() {
-	delete d;
-}
-
-
-static bool actionLessThan(QAction* a1, QAction* a2) {
-	QString a1Text = a1->text().replace("&", "");
-	QString a2Text = a2->text().replace("&", "");
-	return QString::compare(a1Text, a2Text, Qt::CaseInsensitive) < 0;
-}
-
-
-void KIPIInterface::loadPlugins() {
-	// Already done
-	if (d->mPluginLoader) {
-		return;
-	}
-
-	d->mMenuInfoMap[KIPI::ImagesPlugin]      = MenuInfo(i18nc("@title:menu", "Images"));
-	d->mMenuInfoMap[KIPI::EffectsPlugin]     = MenuInfo(i18nc("@title:menu", "Effects"));
-	d->mMenuInfoMap[KIPI::ToolsPlugin]       = MenuInfo(i18nc("@title:menu", "Tools"));
-	d->mMenuInfoMap[KIPI::ImportPlugin]      = MenuInfo(i18nc("@title:menu", "Import"));
-	d->mMenuInfoMap[KIPI::ExportPlugin]      = MenuInfo(i18nc("@title:menu", "Export"));
-	d->mMenuInfoMap[KIPI::BatchPlugin]       = MenuInfo(i18nc("@title:menu", "Batch Processing"));
-	d->mMenuInfoMap[KIPI::CollectionsPlugin] = MenuInfo(i18nc("@title:menu", "Collections"));
-
-	d->mPluginLoader = new KIPI::PluginLoader(QStringList(), this);
-	d->mPluginQueue = d->mPluginLoader->pluginList();
-	d->createDummyPluginAction(i18n("Loading..."));
-	loadOnePlugin();
-}
-
-void KIPIInterface::loadOnePlugin() {
-	while (!d->mPluginQueue.isEmpty()) {
-		KIPI::PluginLoader::Info* pluginInfo = d->mPluginQueue.takeFirst();
-		if (!pluginInfo->shouldLoad()) {
-			continue;
-		}
-
-		KIPI::Plugin* plugin = pluginInfo->plugin();
-		if (!plugin) {
-			kWarning() << "Plugin from library" << pluginInfo->library() << "failed to load";
-			continue;
-		}
-
-		plugin->setup(d->mMainWindow);
-		QList<KAction*> actions = plugin->actions();
-		Q_FOREACH(KAction* action, actions) {
-			KIPI::Category category = plugin->category(action);
-
-			if (!d->mMenuInfoMap.contains(category)) {
-				kWarning() << "Unknown category '" << category;
-				continue;
-			}
-
-			d->mMenuInfoMap[category].mActions << action;
-		}
-		// FIXME: Port
-		//plugin->actionCollection()->readShortcutSettings();
-
-		// If we reach this point, we just loaded one plugin. Go back to the
-		// event loop. We will come back to load the remaining plugins or create
-		// the menu later
-		QMetaObject::invokeMethod(this, "loadOnePlugin", Qt::QueuedConnection);
-		return;
-	}
-
-	// If we reach this point, all plugins have been loaded. We can fill the
-	// menu
-	bool atLeastOnePluginLoaded = false;
-	MenuInfoMap::Iterator
-		it = d->mMenuInfoMap.begin(),
-		end = d->mMenuInfoMap.end();
-	for (; it != end; ++it) {
-		MenuInfo& info = it.value();
-		if (!info.mActions.isEmpty()) {
-			QMenu* menu = d->mPluginMenu->addMenu(info.mName);
-			qSort(info.mActions.begin(), info.mActions.end(), actionLessThan);
-			Q_FOREACH(QAction* action, info.mActions) {
-				atLeastOnePluginLoaded = true;
-				menu->addAction(action);
-			}
-		}
-	}
-
-	delete d->mMainWindow->actionCollection()->action("dummy_plugin");
-	if (!atLeastOnePluginLoaded) {
-		d->createDummyPluginAction(i18n("No Plugin Found"));
-	}
-}
-
-
-QList<QAction*> KIPIInterface::pluginActions(KIPI::Category category) const {
-	const_cast<KIPIInterface*>(this)->loadPlugins();
-	return d->mMenuInfoMap.value(category).mActions;
-}
-
-
-void KIPIInterface::init() {
-	slotDirectoryChanged();
-	slotSelectionChanged();
-}
-
-KIPI::ImageCollection KIPIInterface::currentAlbum() {
-	LOG("");
-	const ContextManager* contextManager = d->mMainWindow->contextManager();
-	const KUrl url = contextManager->currentDirUrl();
-	const SortedDirModel* model = contextManager->dirModel();
-
-	KUrl::List list;
-	const int count = model->rowCount();
-	for (int row = 0; row < count; ++row) {
-		const QModelIndex& index = model->index(row, 0);
-		const KFileItem item = model->itemForIndex(index);
-		if (MimeTypeUtils::fileItemKind(item) == MimeTypeUtils::KIND_RASTER_IMAGE) {
-			list << item.targetUrl();
-		}
-	}
-
-	return KIPI::ImageCollection(new ImageCollection(url, url.fileName(), list));
-}
-
-
-KIPI::ImageCollection KIPIInterface::currentSelection() {
-	LOG("");
-
-	KFileItemList fileList = d->mMainWindow->contextManager()->selectedFileItemList();
-	KUrl::List list = fileList.urlList();
-	KUrl url = d->mMainWindow->contextManager()->currentUrl();
-	
-	return KIPI::ImageCollection(new ImageCollection(url, url.fileName(), list));
-}
-
-
-QList<KIPI::ImageCollection> KIPIInterface::allAlbums() {
-	LOG("");
-	QList<KIPI::ImageCollection> list;
-	list << currentAlbum() << currentSelection();
-	return list;
-}
-
-
-KIPI::ImageInfo KIPIInterface::info(const KUrl& url) {
-	LOG("");
-	return KIPI::ImageInfo( new KIPIImageInfo(this, url) );
-}
-
-int KIPIInterface::features() const {
-	return KIPI::HostAcceptNewImages;
+KIPIInterface::~KIPIInterface()
+{
+    delete d;
+}
+
+static bool actionLessThan(QAction* a1, QAction* a2)
+{
+    QString a1Text = a1->text().replace("&", "");
+    QString a2Text = a2->text().replace("&", "");
+    return QString::compare(a1Text, a2Text, Qt::CaseInsensitive) < 0;
+}
+
+void KIPIInterface::loadPlugins()
+{
+    // Already done
+    if (d->mPluginLoader) {
+        return;
+    }
+
+    d->mMenuInfoMap[KIPI::ImagesPlugin]      = MenuInfo(i18nc("@title:menu", "Images"));
+    d->mMenuInfoMap[KIPI::EffectsPlugin]     = MenuInfo(i18nc("@title:menu", "Effects"));
+    d->mMenuInfoMap[KIPI::ToolsPlugin]       = MenuInfo(i18nc("@title:menu", "Tools"));
+    d->mMenuInfoMap[KIPI::ImportPlugin]      = MenuInfo(i18nc("@title:menu", "Import"));
+    d->mMenuInfoMap[KIPI::ExportPlugin]      = MenuInfo(i18nc("@title:menu", "Export"));
+    d->mMenuInfoMap[KIPI::BatchPlugin]       = MenuInfo(i18nc("@title:menu", "Batch Processing"));
+    d->mMenuInfoMap[KIPI::CollectionsPlugin] = MenuInfo(i18nc("@title:menu", "Collections"));
+
+    d->mPluginLoader = new KIPI::PluginLoader(QStringList(), this);
+    d->mPluginQueue = d->mPluginLoader->pluginList();
+    d->createDummyPluginAction(i18n("Loading..."));
+    loadOnePlugin();
+}
+
+void KIPIInterface::loadOnePlugin()
+{
+    while (!d->mPluginQueue.isEmpty()) {
+        KIPI::PluginLoader::Info* pluginInfo = d->mPluginQueue.takeFirst();
+        if (!pluginInfo->shouldLoad()) {
+            continue;
+        }
+
+        KIPI::Plugin* plugin = pluginInfo->plugin();
+        if (!plugin) {
+            kWarning() << "Plugin from library" << pluginInfo->library() << "failed to load";
+            continue;
+        }
+
+        plugin->setup(d->mMainWindow);
+        QList<KAction*> actions = plugin->actions();
+        Q_FOREACH(KAction * action, actions) {
+            KIPI::Category category = plugin->category(action);
+
+            if (!d->mMenuInfoMap.contains(category)) {
+                kWarning() << "Unknown category '" << category;
+                continue;
+            }
+
+            d->mMenuInfoMap[category].mActions << action;
+        }
+        // FIXME: Port
+        //plugin->actionCollection()->readShortcutSettings();
+
+        // If we reach this point, we just loaded one plugin. Go back to the
+        // event loop. We will come back to load the remaining plugins or create
+        // the menu later
+        QMetaObject::invokeMethod(this, "loadOnePlugin", Qt::QueuedConnection);
+        return;
+    }
+
+    // If we reach this point, all plugins have been loaded. We can fill the
+    // menu
+    bool atLeastOnePluginLoaded = false;
+    MenuInfoMap::Iterator
+    it = d->mMenuInfoMap.begin(),
+    end = d->mMenuInfoMap.end();
+    for (; it != end; ++it) {
+        MenuInfo& info = it.value();
+        if (!info.mActions.isEmpty()) {
+            QMenu* menu = d->mPluginMenu->addMenu(info.mName);
+            qSort(info.mActions.begin(), info.mActions.end(), actionLessThan);
+            Q_FOREACH(QAction * action, info.mActions) {
+                atLeastOnePluginLoaded = true;
+                menu->addAction(action);
+            }
+        }
+    }
+
+    delete d->mMainWindow->actionCollection()->action("dummy_plugin");
+    if (!atLeastOnePluginLoaded) {
+        d->createDummyPluginAction(i18n("No Plugin Found"));
+    }
+}
+
+QList<QAction*> KIPIInterface::pluginActions(KIPI::Category category) const
+{
+    const_cast<KIPIInterface*>(this)->loadPlugins();
+    return d->mMenuInfoMap.value(category).mActions;
+}
+
+void KIPIInterface::init()
+{
+    slotDirectoryChanged();
+    slotSelectionChanged();
+}
+
+KIPI::ImageCollection KIPIInterface::currentAlbum()
+{
+    LOG("");
+    const ContextManager* contextManager = d->mMainWindow->contextManager();
+    const KUrl url = contextManager->currentDirUrl();
+    const SortedDirModel* model = contextManager->dirModel();
+
+    KUrl::List list;
+    const int count = model->rowCount();
+    for (int row = 0; row < count; ++row) {
+        const QModelIndex& index = model->index(row, 0);
+        const KFileItem item = model->itemForIndex(index);
+        if (MimeTypeUtils::fileItemKind(item) == MimeTypeUtils::KIND_RASTER_IMAGE) {
+            list << item.targetUrl();
+        }
+    }
+
+    return KIPI::ImageCollection(new ImageCollection(url, url.fileName(), list));
+}
+
+KIPI::ImageCollection KIPIInterface::currentSelection()
+{
+    LOG("");
+
+    KFileItemList fileList = d->mMainWindow->contextManager()->selectedFileItemList();
+    KUrl::List list = fileList.urlList();
+    KUrl url = d->mMainWindow->contextManager()->currentUrl();
+
+    return KIPI::ImageCollection(new ImageCollection(url, url.fileName(), list));
+}
+
+QList<KIPI::ImageCollection> KIPIInterface::allAlbums()
+{
+    LOG("");
+    QList<KIPI::ImageCollection> list;
+    list << currentAlbum() << currentSelection();
+    return list;
+}
+
+KIPI::ImageInfo KIPIInterface::info(const KUrl& url)
+{
+    LOG("");
+    return KIPI::ImageInfo(new KIPIImageInfo(this, url));
+}
+
+int KIPIInterface::features() const
+{
+    return KIPI::HostAcceptNewImages;
 }
 
 /**
  * KDirLister will pick up the image if necessary, so no updating is needed
  * here, it is however necessary to discard caches if the plugin preserves timestamp
  */
-bool KIPIInterface::addImage(const KUrl&, QString&) {
-//TODO	setContext(const KUrl& currentUrl, const KFileItemList& selection)?
-	//Cache::instance()->invalidate( url );
-	return true;
+bool KIPIInterface::addImage(const KUrl&, QString&)
+{
+//TODO  setContext(const KUrl& currentUrl, const KFileItemList& selection)?
+    //Cache::instance()->invalidate( url );
+    return true;
 }
 
-void KIPIInterface::delImage(const KUrl&) {
+void KIPIInterface::delImage(const KUrl&)
+{
 //TODO
 }
 
-void KIPIInterface::refreshImages( const KUrl::List&) {
+void KIPIInterface::refreshImages(const KUrl::List&)
+{
 // TODO
 }
 
-KIPI::ImageCollectionSelector* KIPIInterface::imageCollectionSelector(QWidget *parent) {
-	return new KIPIImageCollectionSelector(this, parent);
-}
-
-KIPI::UploadWidget* KIPIInterface::uploadWidget(QWidget *parent) {
-	return (new KIPIUploadWidget(this, parent));
-}
-
-void KIPIInterface::slotSelectionChanged() {
-	emit selectionChanged(!d->mMainWindow->contextManager()->selectedFileItemList().isEmpty());
-}
-
-
-void KIPIInterface::slotDirectoryChanged() {
-	emit currentAlbumChanged(true);
+KIPI::ImageCollectionSelector* KIPIInterface::imageCollectionSelector(QWidget *parent)
+{
+    return new KIPIImageCollectionSelector(this, parent);
+}
+
+KIPI::UploadWidget* KIPIInterface::uploadWidget(QWidget *parent)
+{
+    return (new KIPIUploadWidget(this, parent));
+}
+
+void KIPIInterface::slotSelectionChanged()
+{
+    emit selectionChanged(!d->mMainWindow->contextManager()->selectedFileItemList().isEmpty());
+}
+
+void KIPIInterface::slotDirectoryChanged()
+{
+    emit currentAlbumChanged(true);
 }
 
 } //namespace

=== modified file 'app/kipiinterface.h'
--- app/kipiinterface.h	2011-07-20 13:46:34 +0000
+++ app/kipiinterface.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2000-2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,66 +29,83 @@
 
 class QAction;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct KIPIInterfacePrivate;
 
 class MainWindow;
 
-class KIPIInterface :public KIPI::Interface {
-	Q_OBJECT
+class KIPIInterface : public KIPI::Interface
+{
+    Q_OBJECT
 
 public:
-	KIPIInterface(MainWindow*);
-	virtual ~KIPIInterface();
-
-	KIPI::ImageCollection currentAlbum();
-	KIPI::ImageCollection currentSelection();
-	QList<KIPI::ImageCollection> allAlbums();
-	KIPI::ImageInfo info( const KUrl& url);
-	int features() const;
-	virtual bool addImage(const KUrl&, QString& err);
-	virtual void delImage( const KUrl& );
-	virtual void refreshImages( const KUrl::List& urls );
-
-	virtual KIPI::ImageCollectionSelector* imageCollectionSelector(QWidget *parent);
-	virtual KIPI::UploadWidget* uploadWidget(QWidget *parent);
-
-	QList<QAction*> pluginActions(KIPI::Category) const;
+    KIPIInterface(MainWindow*);
+    virtual ~KIPIInterface();
+
+    KIPI::ImageCollection currentAlbum();
+    KIPI::ImageCollection currentSelection();
+    QList<KIPI::ImageCollection> allAlbums();
+    KIPI::ImageInfo info(const KUrl& url);
+    int features() const;
+    virtual bool addImage(const KUrl&, QString& err);
+    virtual void delImage(const KUrl&);
+    virtual void refreshImages(const KUrl::List& urls);
+
+    virtual KIPI::ImageCollectionSelector* imageCollectionSelector(QWidget *parent);
+    virtual KIPI::UploadWidget* uploadWidget(QWidget *parent);
+
+    QList<QAction*> pluginActions(KIPI::Category) const;
 
 public Q_SLOTS:
-	void loadPlugins();
+    void loadPlugins();
 
 private Q_SLOTS:
-	void slotSelectionChanged();
-	void slotDirectoryChanged();
-	void init();
-	void loadOnePlugin();
+    void slotSelectionChanged();
+    void slotDirectoryChanged();
+    void init();
+    void loadOnePlugin();
 
 private:
-	KIPIInterfacePrivate* const d;
+    KIPIInterfacePrivate* const d;
 };
 
-class ImageCollection : public KIPI::ImageCollectionShared {
+class ImageCollection : public KIPI::ImageCollectionShared
+{
 public:
-	ImageCollection(KUrl dirURL, const QString& name, const KUrl::List& images)
-	: KIPI::ImageCollectionShared()
-    , mDirURL(dirURL)
-    , mName(name)
-    , mImages(images) {}
+    ImageCollection(KUrl dirURL, const QString& name, const KUrl::List& images)
+        : KIPI::ImageCollectionShared()
+        , mDirURL(dirURL)
+        , mName(name)
+        , mImages(images) {}
 
-	QString name()           { return mName; }
-	QString comment()        { return QString(); }
-	KUrl::List images()      { return mImages; }
-	KUrl uploadRoot()        { return KUrl("/"); }
-	KUrl uploadPath()        { return mDirURL; }
-	QString uploadRootName() { return "/"; }
-	bool isDirectory()       { return true; }
+    QString name()           {
+        return mName;
+    }
+    QString comment()        {
+        return QString();
+    }
+    KUrl::List images()      {
+        return mImages;
+    }
+    KUrl uploadRoot()        {
+        return KUrl("/");
+    }
+    KUrl uploadPath()        {
+        return mDirURL;
+    }
+    QString uploadRootName() {
+        return "/";
+    }
+    bool isDirectory()       {
+        return true;
+    }
 
 private:
     KUrl mDirURL;
-	QString mName;
-	KUrl::List mImages;
+    QString mName;
+    KUrl::List mImages;
 };
 
 } // namespace

=== modified file 'app/kipiuploadwidget.cpp'
--- app/kipiuploadwidget.cpp	2011-07-20 13:46:34 +0000
+++ app/kipiuploadwidget.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -31,28 +31,26 @@
 // Local
 #include "kipiinterface.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 KIPIUploadWidget::KIPIUploadWidget(KIPIInterface* interface, QWidget* parent)
 : KIPI::UploadWidget(parent)
-, mInterface(interface) {
-	QLabel* label = new QLabel(this);
-	KUrl url = mInterface->currentAlbum().uploadPath();
-	label->setText(i18n("Images will be uploaded here:\n%1", url.pathOrUrl()));
-	label->setWordWrap(true);
-
-	QVBoxLayout* layout = new QVBoxLayout(this);
-	layout->setMargin(0);
-	layout->addWidget(label);
-}
-
-
-KIPI::ImageCollection KIPIUploadWidget::selectedImageCollection() const {
-	return mInterface->currentAlbum();
-}
-
-
-
+, mInterface(interface)
+{
+    QLabel* label = new QLabel(this);
+    KUrl url = mInterface->currentAlbum().uploadPath();
+    label->setText(i18n("Images will be uploaded here:\n%1", url.pathOrUrl()));
+    label->setWordWrap(true);
+
+    QVBoxLayout* layout = new QVBoxLayout(this);
+    layout->setMargin(0);
+    layout->addWidget(label);
+}
+
+KIPI::ImageCollection KIPIUploadWidget::selectedImageCollection() const
+{
+    return mInterface->currentAlbum();
+}
 
 } // namespace

=== modified file 'app/kipiuploadwidget.h'
--- app/kipiuploadwidget.h	2011-07-20 13:46:34 +0000
+++ app/kipiuploadwidget.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -31,22 +31,23 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class KIPIInterface;
 
-class KIPIUploadWidget : public KIPI::UploadWidget {
-	Q_OBJECT
+class KIPIUploadWidget : public KIPI::UploadWidget
+{
+    Q_OBJECT
 public:
-	KIPIUploadWidget(KIPIInterface*, QWidget* parent);
+    KIPIUploadWidget(KIPIInterface*, QWidget* parent);
 
-	virtual KIPI::ImageCollection selectedImageCollection() const;
+    virtual KIPI::ImageCollection selectedImageCollection() const;
 
 private:
-	KIPIInterface* mInterface;
+    KIPIInterface* mInterface;
 };
 
-
 } // namespace
 
 #endif /* KIPIUPLOADWIDGET_H */

=== modified file 'app/main.cpp'
--- app/main.cpp	2011-07-20 13:46:34 +0000
+++ app/main.cpp	2011-12-15 14:17:54 +0000
@@ -40,101 +40,104 @@
 #include <lib/version.h>
 #include "mainwindow.h"
 
-class StartHelper {
+class StartHelper
+{
 public:
-	StartHelper()
-	: mFullScreen(false)
-	, mSlideShow(false)
-	{
-		KCmdLineArgs* args = KCmdLineArgs::parsedArgs();
-		if (args->count() > 0) {
-			parseArgs(args);
-		}
-		args->clear();
-	}
-
-	void parseArgs(KCmdLineArgs* args) {
-		if (args->count() > 1) {
-			// Createa a temp dir containing links to url args
-			mMultipleUrlsDir.reset(new KTempDir);
-			mUrl = KUrl::fromPath(mMultipleUrlsDir->name());
-			KUrl::List list;
-			for (int pos = 0; pos < args->count(); ++pos) {
-				list << args->url(pos);
-			}
-			KIO::CopyJob* job = KIO::link(list, mUrl);
-			job->exec();
-		} else {
-			mUrl = args->url(0);
-		}
-
-		if (mUrl.isValid() && (args->isSet("f") || args->isSet("s"))) {
-			mFullScreen = true;
-			if (args->isSet("s")) {
-				mSlideShow = true;
-			}
-		}
-	}
-
-	void createMainWindow() {
-		Gwenview::MainWindow* window = new Gwenview::MainWindow();
-		if (mUrl.isValid()) {
-			window->setInitialUrl(mUrl);
-		} else {
-			window->showStartPage();
-		}
-
-		window->show();
-		if (mFullScreen) {
-			window->actionCollection()->action("fullscreen")->trigger();
-		} else {
-			window->show();
-		}
-
-		if (mSlideShow) {
-			window->startSlideShow();
-		}
-	}
+    StartHelper()
+        : mFullScreen(false)
+        , mSlideShow(false) {
+        KCmdLineArgs* args = KCmdLineArgs::parsedArgs();
+        if (args->count() > 0) {
+            parseArgs(args);
+        }
+        args->clear();
+    }
+
+    void parseArgs(KCmdLineArgs* args)
+    {
+        if (args->count() > 1) {
+            // Createa a temp dir containing links to url args
+            mMultipleUrlsDir.reset(new KTempDir);
+            mUrl = KUrl::fromPath(mMultipleUrlsDir->name());
+            KUrl::List list;
+            for (int pos = 0; pos < args->count(); ++pos) {
+                list << args->url(pos);
+            }
+            KIO::CopyJob* job = KIO::link(list, mUrl);
+            job->exec();
+        } else {
+            mUrl = args->url(0);
+        }
+
+        if (mUrl.isValid() && (args->isSet("f") || args->isSet("s"))) {
+            mFullScreen = true;
+            if (args->isSet("s")) {
+                mSlideShow = true;
+            }
+        }
+    }
+
+    void createMainWindow()
+    {
+        Gwenview::MainWindow* window = new Gwenview::MainWindow();
+        if (mUrl.isValid()) {
+            window->setInitialUrl(mUrl);
+        } else {
+            window->showStartMainPage();
+        }
+
+        window->show();
+        if (mFullScreen) {
+            window->actionCollection()->action("fullscreen")->trigger();
+        } else {
+            window->show();
+        }
+
+        if (mSlideShow) {
+            window->startSlideShow();
+        }
+    }
 
 private:
-	KUrl mUrl;
-	bool mFullScreen;
-	bool mSlideShow;
-	std::auto_ptr<KTempDir> mMultipleUrlsDir;
-	std::auto_ptr<Gwenview::MainWindow> mMainWindow;
+    KUrl mUrl;
+    bool mFullScreen;
+    bool mSlideShow;
+    std::auto_ptr<KTempDir> mMultipleUrlsDir;
+    std::auto_ptr<Gwenview::MainWindow> mMainWindow;
 };
 
-int main(int argc, char *argv[]) {
-	KAboutData aboutData(
-		"gwenview",        /* appname */
-		0,                 /* catalogName */
-		ki18n("Gwenview"), /* programName */
-		GWENVIEW_VERSION); /* version */
-	aboutData.setShortDescription(ki18n("An Image Viewer"));
-	aboutData.setLicense(KAboutData::License_GPL);
-	aboutData.setCopyrightStatement(ki18n("Copyright 2000-2010 Aurélien Gâteau"));
-	aboutData.addAuthor(
-		ki18n("Aurélien Gâteau"),
-		ki18n("Main developer"),
-		"agateau@kde.org");
-
-	KCmdLineArgs::init( argc, argv, &aboutData );
-
-	KCmdLineOptions options;
-	options.add("f", ki18n("Start in fullscreen mode"));
-	options.add("s", ki18n("Start in slideshow mode"));
-	options.add("+[file or folder]", ki18n("A starting file or folder"));
-	KCmdLineArgs::addCmdLineOptions( options );
-
-	KApplication app;
-	Gwenview::ImageFormats::registerPlugins();
-
-	// startHelper must live for the whole live of the application
-	StartHelper startHelper;
-	if (app.isSessionRestored()) {
-		kRestoreMainWindows<Gwenview::MainWindow>();
-	} else {
-		startHelper.createMainWindow();
-	}
-	return app.exec();
+int main(int argc, char *argv[])
+{
+    KAboutData aboutData(
+        "gwenview",        /* appname */
+        0,                 /* catalogName */
+        ki18n("Gwenview"), /* programName */
+        GWENVIEW_VERSION); /* version */
+    aboutData.setShortDescription(ki18n("An Image Viewer"));
+    aboutData.setLicense(KAboutData::License_GPL);
+    aboutData.setCopyrightStatement(ki18n("Copyright 2000-2010 Aurélien Gâteau"));
+    aboutData.addAuthor(
+        ki18n("Aurélien Gâteau"),
+        ki18n("Main developer"),
+        "agateau@kde.org");
+
+    KCmdLineArgs::init(argc, argv, &aboutData);
+
+    KCmdLineOptions options;
+    options.add("f", ki18n("Start in fullscreen mode"));
+    options.add("s", ki18n("Start in slideshow mode"));
+    options.add("+[file or folder]", ki18n("A starting file or folder"));
+    KCmdLineArgs::addCmdLineOptions(options);
+
+    KApplication app;
+    Gwenview::ImageFormats::registerPlugins();
+
+    // startHelper must live for the whole live of the application
+    StartHelper startHelper;
+    if (app.isSessionRestored()) {
+        kRestoreMainWindows<Gwenview::MainWindow>();
+    } else {
+        startHelper.createMainWindow();
+    }
+    return app.exec();
 }

=== modified file 'app/mainwindow.cpp'
--- app/mainwindow.cpp	2011-07-20 13:46:34 +0000
+++ app/mainwindow.cpp	2011-12-15 14:17:54 +0000
@@ -63,7 +63,7 @@
 #include "configdialog.h"
 #include "contextmanager.h"
 #include "documentinfoprovider.h"
-#include "documentpanel.h"
+#include "viewmainpage.h"
 #include "fileopscontextmanageritem.h"
 #include "folderviewcontextmanageritem.h"
 #include "fullscreencontent.h"
@@ -84,9 +84,9 @@
 #include "savebar.h"
 #include "sidebar.h"
 #include "splitter.h"
-#include "startpage.h"
+#include "startmainpage.h"
 #include "thumbnailviewhelper.h"
-#include "thumbnailviewpanel.h"
+#include "browsemainpage.h"
 #include <lib/archiveutils.h>
 #include <lib/document/documentfactory.h>
 #include <lib/eventwatcher.h>
@@ -98,14 +98,14 @@
 #include <lib/slideshow.h>
 #include <lib/signalblocker.h>
 #include <lib/semanticinfo/sorteddirmodel.h>
-#include <lib/splittercollapser.h>
 #include <lib/thumbnailview/thumbnailbarview.h>
 #include <lib/thumbnailview/thumbnailview.h>
 #include <lib/thumbnailloadjob.h>
 #include <lib/urlutils.h>
 #include <lib/widgetfloater.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -126,1428 +126,1467 @@
 static const char* SESSION_CURRENT_PAGE_KEY = "Page";
 static const char* SESSION_URL_KEY = "Url";
 
-enum PageId {
-	StartPageId,
-	BrowsePageId,
-	ViewPageId
+enum MainPageId {
+    StartMainPageId,
+    BrowseMainPageId,
+    ViewMainPageId
 };
 
 struct MainWindowState {
-	PageId mPageId;
-	bool mToolBarVisible;
-	Qt::WindowStates mWindowState;
+    MainPageId mMainPageId;
+    bool mToolBarVisible;
+    Qt::WindowStates mWindowState;
 };
 
-
 struct MainWindow::Private {
-	GvCore* mGvCore;
-	MainWindow* mWindow;
-	QSplitter* mCentralSplitter;
-	QWidget* mContentWidget;
-	DocumentPanel* mDocumentPanel;
-	KUrlNavigator* mUrlNavigator;
-	ThumbnailView* mThumbnailView;
-	DocumentInfoProvider* mDocumentInfoProvider;
-	ThumbnailViewHelper* mThumbnailViewHelper;
-	ThumbnailViewPanel* mThumbnailViewPanel;
-	StartPage* mStartPage;
-	SideBar* mSideBar;
-	SplitterCollapser* mSideBarCollapser;
-	QStackedWidget* mViewStackedWidget;
-	FullScreenBar* mFullScreenBar;
-	FullScreenContent* mFullScreenContent;
-	SaveBar* mSaveBar;
-	bool mStartSlideShowWhenDirListerCompleted;
-	SlideShow* mSlideShow;
-	Preloader* mPreloader;
-#ifdef KIPI_FOUND
-	KIPIInterface* mKIPIInterface;
-#endif
-
-	QActionGroup* mViewModeActionGroup;
-	KAction* mBrowseAction;
-	KAction* mViewAction;
-	KAction* mGoUpAction;
-	KAction* mGoToPreviousAction;
-	KAction* mGoToNextAction;
-	KAction* mGoToFirstAction;
-	KAction* mGoToLastAction;
-	KToggleAction* mToggleSideBarAction;
-	KToggleFullScreenAction* mFullScreenAction;
-	KAction* mToggleSlideShowAction;
-	KToggleAction* mShowMenuBarAction;
-#ifdef KIPI_FOUND
-	KIPIExportAction* mKIPIExportAction;
-#endif
-
-	SortedDirModel* mDirModel;
-	ContextManager* mContextManager;
-
-	bool mDistractionFreeMode;
-	MainWindowState mStateBeforeFullScreen;
-
-	KUrl mUrlToSelect;
-
-	QString mCaption;
-
-	PageId mCurrentPageId;
-
-	QDateTime mFullScreenLeftAt;
-	KNotificationRestrictions* mNotificationRestrictions;
-
-	void setupWidgets() {
-		mCentralSplitter = new Splitter(Qt::Horizontal, mWindow);
-		mWindow->setCentralWidget(mCentralSplitter);
-
-		// Left side of splitter
-		mSideBar = new SideBar(mCentralSplitter);
-		EventWatcher::install(mSideBar, QList<QEvent::Type>() << QEvent::Show << QEvent::Hide,
-			mWindow, SLOT(updateToggleSideBarAction()));
-
-		// Right side of splitter
-		mContentWidget = new QWidget(mCentralSplitter);
-
-		mSaveBar = new SaveBar(mContentWidget, mWindow->actionCollection());
-		mViewStackedWidget = new QStackedWidget(mContentWidget);
-		QVBoxLayout* layout = new QVBoxLayout(mContentWidget);
-		layout->addWidget(mSaveBar);
-		layout->addWidget(mViewStackedWidget);
-		layout->setMargin(0);
-		layout->setSpacing(0);
-		////
-
-		mSideBarCollapser = new SplitterCollapser(mCentralSplitter, mSideBar);
-
-		mStartSlideShowWhenDirListerCompleted = false;
-		mSlideShow = new SlideShow(mWindow);
-
-		setupThumbnailView(mViewStackedWidget);
-		setupDocumentPanel(mViewStackedWidget);
-		setupStartPage(mViewStackedWidget);
-		mViewStackedWidget->addWidget(mThumbnailViewPanel);
-		mViewStackedWidget->addWidget(mDocumentPanel);
-		mViewStackedWidget->addWidget(mStartPage);
-		mViewStackedWidget->setCurrentWidget(mThumbnailViewPanel);
-
-		mCentralSplitter->setStretchFactor(0, 0);
-		mCentralSplitter->setStretchFactor(1, 1);
-
-		connect(mSaveBar, SIGNAL(requestSaveAll()),
-			mGvCore, SLOT(saveAll()) );
-		connect(mSaveBar, SIGNAL(goToUrl(const KUrl&)),
-			mWindow, SLOT(goToUrl(const KUrl&)) );
-
-		connect(mSlideShow, SIGNAL(goToUrl(const KUrl&)),
-			mWindow, SLOT(goToUrl(const KUrl&)) );
-	}
-
-	void setupThumbnailView(QWidget* parent) {
-		mThumbnailViewPanel = new ThumbnailViewPanel(parent, mDirModel, mWindow->actionCollection());
-
-		mThumbnailView = mThumbnailViewPanel->thumbnailView();
-		mUrlNavigator = mThumbnailViewPanel->urlNavigator();
-		QPalette pal = mUrlNavigator->palette();
-		pal.setColor(QPalette::Window, pal.color(QPalette::Window).dark(110));
-		mUrlNavigator->setAutoFillBackground(true);
-		mUrlNavigator->setPalette(pal);
-
-		mDocumentInfoProvider = new DocumentInfoProvider(mDirModel);
-		mThumbnailView->setDocumentInfoProvider(mDocumentInfoProvider);
-
-		mThumbnailViewHelper = new ThumbnailViewHelper(mDirModel, mWindow->actionCollection());
-		mThumbnailView->setThumbnailViewHelper(mThumbnailViewHelper);
-
-		// Connect thumbnail view
-		connect(mThumbnailView, SIGNAL(indexActivated(const QModelIndex&)),
-			mWindow, SLOT(slotThumbnailViewIndexActivated(const QModelIndex&)) );
-		connect(mThumbnailView->selectionModel(), SIGNAL(selectionChanged(const QItemSelection&, const QItemSelection&)),
-			mWindow, SLOT(slotSelectionChanged()) );
-
-		// Connect delegate
-		QAbstractItemDelegate* delegate = mThumbnailView->itemDelegate();
-		connect(delegate, SIGNAL(saveDocumentRequested(const KUrl&)),
-			mGvCore, SLOT(save(const KUrl&)) );
-		connect(delegate, SIGNAL(rotateDocumentLeftRequested(const KUrl&)),
-			mGvCore, SLOT(rotateLeft(const KUrl&)) );
-		connect(delegate, SIGNAL(rotateDocumentRightRequested(const KUrl&)),
-			mGvCore, SLOT(rotateRight(const KUrl&)) );
-		connect(delegate, SIGNAL(showDocumentInFullScreenRequested(const KUrl&)),
-			mWindow, SLOT(showDocumentInFullScreen(const KUrl&)) );
-		connect(delegate, SIGNAL(setDocumentRatingRequested(const KUrl&, int)),
-			mGvCore, SLOT(setRating(const KUrl&, int)) );
-
-		// Connect url navigator
-		connect(mUrlNavigator, SIGNAL(urlChanged(const KUrl&)),
-			mWindow, SLOT(openDirUrl(const KUrl&)) );
-	}
-
-	void setupDocumentPanel(QWidget* parent) {
-		mDocumentPanel = new DocumentPanel(parent, mSlideShow, mWindow->actionCollection());
-		connect(mDocumentPanel, SIGNAL(captionUpdateRequested(const QString&)),
-			mWindow, SLOT(setCaption(const QString&)) );
-		connect(mDocumentPanel, SIGNAL(completed()),
-			mWindow, SLOT(slotPartCompleted()) );
-		connect(mDocumentPanel, SIGNAL(previousImageRequested()),
-			mWindow, SLOT(goToPrevious()) );
-		connect(mDocumentPanel, SIGNAL(nextImageRequested()),
-			mWindow, SLOT(goToNext()) );
-
-		ThumbnailView* bar = mDocumentPanel->thumbnailBar();
-		bar->setModel(mDirModel);
-		bar->setDocumentInfoProvider(mDocumentInfoProvider);
-		bar->setThumbnailViewHelper(mThumbnailViewHelper);
-		bar->setSelectionModel(mThumbnailView->selectionModel());
-	}
-
-	void setupStartPage(QWidget* parent) {
-		mStartPage = new StartPage(parent, mGvCore);
-		connect(mStartPage, SIGNAL(urlSelected(const KUrl&)),
-			mWindow, SLOT(slotStartPageUrlSelected(const KUrl&)) );
-	}
-
-
-	void setupActions() {
-		KActionCollection* actionCollection = mWindow->actionCollection();
-		KActionCategory* file = new KActionCategory(i18nc("@title actions category","File"), actionCollection);
-		KActionCategory* view = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface","View"), actionCollection);
-
-		file->addAction(KStandardAction::Save,mWindow, SLOT(saveCurrent()));
-		file->addAction(KStandardAction::SaveAs,mWindow, SLOT(saveCurrentAs()));
-		file->addAction(KStandardAction::Open,mWindow, SLOT(openFile()));
-		file->addAction(KStandardAction::Print,mWindow, SLOT(print()));
-		file->addAction(KStandardAction::Quit,KApplication::kApplication(), SLOT(closeAllWindows()));
-
-		KAction* action = file->addAction("reload",mWindow,SLOT(reload()));
-		action->setText(i18nc("@action reload the currently viewed image", "Reload"));
-		action->setIcon(KIcon("view-refresh"));
-		action->setShortcut(Qt::Key_F5);
-
-
-		mBrowseAction = view->addAction("browse");
-		mBrowseAction->setText(i18nc("@action Switch to file list", "Browse"));
-		mBrowseAction->setCheckable(true);
-		mBrowseAction->setIcon(KIcon("view-list-icons"));
-
-		mViewAction = view->addAction("view");
-		mViewAction->setText(i18nc("@action Switch to image view", "View"));
-		mViewAction->setIcon(KIcon("view-preview"));
-		mViewAction->setCheckable(true);
-
-		mViewModeActionGroup = new QActionGroup(mWindow);
-		mViewModeActionGroup->addAction(mBrowseAction);
-		mViewModeActionGroup->addAction(mViewAction);
-
-		connect(mViewModeActionGroup, SIGNAL(triggered(QAction*)),
-			mWindow, SLOT(setActiveViewModeAction(QAction*)) );
-
-		mFullScreenAction = static_cast<KToggleFullScreenAction*>(view->addAction(KStandardAction::FullScreen,mWindow, SLOT(toggleFullScreen(bool))));
-		connect(mDocumentPanel, SIGNAL(toggleFullScreenRequested()),
-			mFullScreenAction, SLOT(trigger()) );
-
-		KAction* reduceLodAction = view->addAction("reduce_lod", mWindow, SLOT(reduceLevelOfDetails()));
-		// FIXME Find a better text for this action
-		reduceLodAction->setText(i18nc("@action Go back to a more general page (start page <- list <- image)", "Back"));
-		reduceLodAction->setShortcut(Qt::Key_Escape);
-
-		mGoToPreviousAction = view->addAction("go_previous",mWindow, SLOT(goToPrevious()));
-		mGoToPreviousAction->setIcon(KIcon("media-skip-backward"));
-		mGoToPreviousAction->setText(i18nc("@action Go to previous image", "Previous"));
-		mGoToPreviousAction->setToolTip(i18n("Go to Previous Image"));
-		mGoToPreviousAction->setShortcut(Qt::Key_Backspace);
-
-		mGoToNextAction = view->addAction("go_next",mWindow, SLOT(goToNext()));
-		mGoToNextAction->setIcon(KIcon("media-skip-forward"));
-		mGoToNextAction->setText(i18nc("@action Go to next image", "Next"));
-		mGoToNextAction->setToolTip(i18n("Go to Next Image"));
-		mGoToNextAction->setShortcut(Qt::Key_Space);
-
-		mGoToFirstAction = view->addAction("go_first",mWindow, SLOT(goToFirst()));
-		mGoToFirstAction->setText(i18nc("@action Go to first image", "First"));
-		mGoToFirstAction->setToolTip(i18n("Go to First Image"));
-		mGoToFirstAction->setShortcut(Qt::Key_Home);
-
-		mGoToLastAction = view->addAction("go_last",mWindow, SLOT(goToLast()));
-		mGoToLastAction->setText(i18nc("@action Go to last image", "Last"));
-		mGoToLastAction->setToolTip(i18n("Go to Last Image"));
-		mGoToLastAction->setShortcut(Qt::Key_End);
-
-		mGoUpAction = view->addAction(KStandardAction::Up,mWindow, SLOT(goUp()));
-
-		action = view->addAction("go_start_page",mWindow, SLOT(showStartPage()));
-		action->setIcon(KIcon("go-home"));
-		action->setText(i18nc("@action", "Start Page"));
-
-		mToggleSideBarAction = view->add<KToggleAction>("toggle_sidebar");
-		connect(mToggleSideBarAction, SIGNAL(toggled(bool)),
-			mWindow, SLOT(toggleSideBar(bool)));
-		mToggleSideBarAction->setIcon(KIcon("view-sidetree"));
-		mToggleSideBarAction->setShortcut(Qt::Key_F11);
-		mToggleSideBarAction->setText(i18nc("@action", "Sidebar"));
-
-		mToggleSlideShowAction = view->addAction("toggle_slideshow",mWindow, SLOT(toggleSlideShow()));
-		mWindow->updateSlideShowAction();
-		connect(mSlideShow, SIGNAL(stateChanged(bool)),
-			mWindow, SLOT(updateSlideShowAction()) );
-
-		mShowMenuBarAction = static_cast<KToggleAction*>(view->addAction(KStandardAction::ShowMenubar,mWindow, SLOT(toggleMenuBar())));
-
-		view->addAction(KStandardAction::KeyBindings,mWindow->guiFactory(),
-			SLOT(configureShortcuts()));
-
-		view->addAction(KStandardAction::Preferences,mWindow,
-			SLOT(showConfigDialog()));
-
-		view->addAction(KStandardAction::ConfigureToolbars,mWindow,
-			SLOT(configureToolbars()));
-
-#ifdef KIPI_FOUND
-		mKIPIExportAction = new KIPIExportAction(mWindow);
-		actionCollection->addAction("kipi_export", mKIPIExportAction);
-#endif
-	}
-
-	void setupUndoActions() {
-		// There is no KUndoGroup similar to KUndoStack. This code basically
-		// does the same as KUndoStack, but for the KUndoGroup actions.
-		QUndoGroup* undoGroup = DocumentFactory::instance()->undoGroup();
-		QAction* action;
-		KActionCollection* actionCollection =  mWindow->actionCollection();
-		KActionCategory* edit = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface","Edit"), actionCollection);
-
-		action = undoGroup->createRedoAction(actionCollection);
-		action->setObjectName(KStandardAction::name(KStandardAction::Redo));
-		action->setIcon(KIcon("edit-redo"));
-		action->setIconText(i18n("Redo"));
-		action->setShortcuts(KStandardShortcut::redo());
-		edit->addAction(action->objectName(), action);
-
-		action = undoGroup->createUndoAction(actionCollection);
-		action->setObjectName(KStandardAction::name(KStandardAction::Undo));
-		action->setIcon(KIcon("edit-undo"));
-		action->setIconText(i18n("Undo"));
-		action->setShortcuts(KStandardShortcut::undo());
-		edit->addAction(action->objectName(), action);
-	}
-
-
-	void setupContextManager() {
-		KActionCollection* actionCollection = mWindow->actionCollection();
-
-		mContextManager = new ContextManager(mDirModel, mThumbnailView->selectionModel(), mWindow);
-
-		// Create context manager items
-		FolderViewContextManagerItem* folderViewItem = new FolderViewContextManagerItem(mContextManager);
-		mContextManager->addItem(folderViewItem);
-		connect(folderViewItem, SIGNAL(urlChanged(const KUrl&)),
-			mWindow, SLOT(openDirUrl(const KUrl&)));
-
-		InfoContextManagerItem* infoItem = new InfoContextManagerItem(mContextManager);
-		mContextManager->addItem(infoItem);
-
-		#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		SemanticInfoContextManagerItem* semanticInfoItem = 0;
-		// When using Nepomuk, create a SemanticInfoContextManagerItem instance
-		// only if Nepomuk is available
-		// When using Fake backend always create it
-		#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
-		if (Nepomuk::ResourceManager::instance()->init() == 0) {
-		#endif
-			semanticInfoItem = new SemanticInfoContextManagerItem(mContextManager, actionCollection, mDocumentPanel);
-		#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
-		}
-		#endif
-		if (semanticInfoItem) {
-			mContextManager->addItem(semanticInfoItem);
-		}
-		#endif
-
-		ImageOpsContextManagerItem* imageOpsItem =
-			new ImageOpsContextManagerItem(mContextManager, mWindow);
-		mContextManager->addItem(imageOpsItem);
-
-		FileOpsContextManagerItem* fileOpsItem = new FileOpsContextManagerItem(mContextManager, mThumbnailView, actionCollection, mWindow);
-		mContextManager->addItem(fileOpsItem);
-
-		// Fill sidebar
-		SideBarPage* page;
-		page = new SideBarPage(i18n("Folders"));
-		page->setObjectName( QLatin1String("folders" ));
-		page->addWidget(folderViewItem->widget());
-		page->layout()->setMargin(0);
-		mSideBar->addPage(page);
-
-		page = new SideBarPage(i18n("Information"));
-		page->setObjectName( QLatin1String("information" ));
-		page->addWidget(infoItem->widget());
-		#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		if (semanticInfoItem) {
-			page->addWidget(semanticInfoItem->widget());
-		}
-		#endif
-		page->addStretch();
-		mSideBar->addPage(page);
-
-		page = new SideBarPage(i18n("Operations"));
-		page->setObjectName( QLatin1String("operations" ));
-		page->addWidget(imageOpsItem->widget());
-		page->addWidget(fileOpsItem->widget());
-		page->addStretch();
-		mSideBar->addPage(page);
-	}
-
-
-	void initDirModel() {
-		mDirModel->setKindFilter(
-			MimeTypeUtils::KIND_RASTER_IMAGE
-			| MimeTypeUtils::KIND_SVG_IMAGE
-			| MimeTypeUtils::KIND_VIDEO);
-		setDirModelShowDirs(true);
-
-		connect(mDirModel, SIGNAL(rowsInserted(const QModelIndex&, int, int)),
-			mWindow, SLOT(slotDirModelNewItems()) );
-
-		connect(mDirModel, SIGNAL(rowsRemoved(const QModelIndex&, int, int)),
-			mWindow, SLOT(updatePreviousNextActions()) );
-		connect(mDirModel, SIGNAL(modelReset()),
-			mWindow, SLOT(updatePreviousNextActions()) );
-
-		connect(mDirModel->dirLister(), SIGNAL(completed()),
-			mWindow, SLOT(slotDirListerCompleted()) );
-	}
-
-	void setDirModelShowDirs(bool showDirs) {
-		mDirModel->adjustKindFilter(MimeTypeUtils::KIND_DIR | MimeTypeUtils::KIND_ARCHIVE, showDirs);
-	}
-
-	QModelIndex currentIndex() const {
-		KUrl url = currentUrl();
-		return url.isValid() ? mDirModel->indexForUrl(url) : QModelIndex();
-	}
-
-	bool indexIsDirOrArchive(const QModelIndex& index) const {
-		Q_ASSERT(index.isValid());
-		KFileItem item = mDirModel->itemForIndex(index);
-		return ArchiveUtils::fileItemIsDirOrArchive(item);
-	}
-
-	void goTo(const QModelIndex& index) {
-		if (!index.isValid()) {
-			return;
-		}
-		mThumbnailView->setCurrentIndex(index);
-		mThumbnailView->scrollTo(index);
-	}
-
-
-	void goTo(int offset) {
-		QModelIndex index = currentIndex();
-		index = mDirModel->index(index.row() + offset, 0);
-		if (!index.isValid()) {
-			return;
-		}
-		if (!indexIsDirOrArchive(index)) {
-			goTo(index);
-		}
-	}
-
-	void goToFirstDocument() {
-		QModelIndex index;
-		for(int row=0;; ++row) {
-			index = mDirModel->index(row, 0);
-			if (!index.isValid()) {
-				return;
-			}
-
-			if (!indexIsDirOrArchive(index)) {
-				break;
-			}
-		}
-		goTo(index);
-	}
-
-	void goToLastDocument() {
-		QModelIndex index = mDirModel->index(mDirModel->rowCount() - 1, 0);
-		goTo(index);
-	}
-
-	void spreadCurrentDirUrl(const KUrl& url) {
-		mContextManager->setCurrentDirUrl(url);
-		mThumbnailViewHelper->setCurrentDirUrl(url);
-		if (url.isValid()) {
-			mUrlNavigator->setLocationUrl(url);
-			mGoUpAction->setEnabled(url.path() != "/");
-			mGvCore->addUrlToRecentFolders(url);
-		} else {
-			mGoUpAction->setEnabled(false);
-		}
-	}
-
-	void setupFullScreenBar() {
-		mFullScreenBar = new FullScreenBar(mDocumentPanel);
-		mFullScreenContent = new FullScreenContent(
-			mFullScreenBar, mWindow->actionCollection(), mSlideShow);
-
-		ThumbnailBarView* view = mFullScreenContent->thumbnailBar();
-		view->setModel(mDirModel);
-		view->setDocumentInfoProvider(mDocumentInfoProvider);
-		view->setThumbnailViewHelper(mThumbnailViewHelper);
-		view->setSelectionModel(mThumbnailView->selectionModel());
-	}
-
-
-	inline void setActionEnabled(const char* name, bool enabled) {
-		QAction* action = mWindow->actionCollection()->action(name);
-		if (action) {
-			action->setEnabled(enabled);
-		} else {
-			kWarning() << "Action" << name << "not found";
-		}
-	}
-
-
-	void setActionsDisabledOnStartPageEnabled(bool enabled) {
-		mBrowseAction->setEnabled(enabled);
-		mViewAction->setEnabled(enabled);
-		mToggleSideBarAction->setEnabled(enabled);
-		mFullScreenAction->setEnabled(enabled);
-		mToggleSlideShowAction->setEnabled(enabled);
-
-		setActionEnabled("reload", enabled);
-		setActionEnabled("go_start_page", enabled);
-		setActionEnabled("add_folder_to_places", enabled);
-	}
-
-	void updateDistractionsState() {
-		const bool isFullScreen = mFullScreenAction->isChecked();
-		mSideBarCollapser->setVisible(!mDistractionFreeMode && !isFullScreen);
-		mFullScreenBar->setActivated(!mDistractionFreeMode && isFullScreen);
-	}
-
-	void updateActions() {
-		bool isRasterImage = false;
-		bool canSave = false;
-		bool isModified = false;
-		const KUrl url = currentUrl();
-
-		if (url.isValid()) {
-			isRasterImage = mWindow->currentDocumentIsRasterImage();
-			canSave = isRasterImage;
-			isModified = DocumentFactory::instance()->load(url)->isModified();
-			if (mCurrentPageId != ViewPageId) {
-				// Saving only makes sense if exactly one image is selected
-				QItemSelection selection = mThumbnailView->selectionModel()->selection();
-				QModelIndexList indexList = selection.indexes();
-				if (indexList.count() != 1) {
-					canSave = false;
-				}
-			}
-		}
-
-		KActionCollection* actionCollection = mWindow->actionCollection();
-		actionCollection->action("file_save")->setEnabled(canSave && isModified);
-		actionCollection->action("file_save_as")->setEnabled(canSave);
-		actionCollection->action("file_print")->setEnabled(isRasterImage);
-	}
-
-	KUrl currentUrl() const {
-		if (mCurrentPageId == StartPageId) {
-			return KUrl();
-		}
-
-		if (mUrlToSelect.isValid()) {
-			// We are supposed to select this url whenever it appears in the
-			// dir model. For everyone it is as if it was already the current one
-			return mUrlToSelect;
-		}
-
-		// mThumbnailViewPanel and mDocumentPanel urls are almost always synced, but
-		// mThumbnailViewPanel can be more up-to-date because mDocumentPanel
-		// url is only updated when the DocumentView starts to load the
-		// document.
-		// This is why we only thrust mDocumentPanel url if it shows an url
-		// which can't be listed: in this case mThumbnailViewPanel url is
-		// empty.
-		if (mCurrentPageId == ViewPageId && !mDocumentPanel->isEmpty()) {
-			KUrl url = mDocumentPanel->url();
-			if (!KProtocolManager::supportsListing(url)) {
-				return url;
-			}
-		}
-
-		QModelIndex index = mThumbnailView->currentIndex();
-		if (!index.isValid()) {
-			return KUrl();
-		}
-		// Ignore the current index if it's not part of the selection. This
-		// situation can happen when you select an image, then click on the
-		// background of the thumbnail view.
-		if (mCurrentPageId == BrowsePageId && !mThumbnailView->selectionModel()->isSelected(index)) {
-			return KUrl();
-		}
-		KFileItem item = mDirModel->itemForIndex(index);
-		Q_ASSERT(!item.isNull());
-		return item.url();
-	}
-
-	void setUrlToSelect(const KUrl& url) {
-		if (!url.isValid()) {
-			kWarning() << "called with an invalid url, this should not happen!";
-			return;
-		}
-		mUrlToSelect = url;
-		updateContextDependentComponents();
-		selectUrlToSelect();
-	}
-
-	void selectUrlToSelect() {
-		QModelIndex index = mDirModel->indexForUrl(mUrlToSelect);
-		if (index.isValid()) {
-			if (index != mThumbnailView->currentIndex()) { // Avoid infinite recursion. Bug #243091
-				mThumbnailView->setCurrentIndex(index);
-			}
-			mThumbnailView->scrollTo(index, QAbstractItemView::PositionAtCenter);
-			mUrlToSelect = KUrl();
-		}
-	}
-
-	void updateContextDependentComponents() {
-		KUrl url = currentUrl();
-		mContextManager->setCurrentUrl(url);
-		mSaveBar->setCurrentUrl(url);
-		mSlideShow->setCurrentUrl(url);
-		mFullScreenContent->setCurrentUrl(url);
-	}
-
-	const char* sideBarConfigGroupName() const {
-		const char* name = 0;
-		switch (mCurrentPageId) {
-		case StartPageId:
-			kWarning() << "Should not happen!";
-			// Fall through
-		case BrowsePageId:
-			name = BROWSE_MODE_SIDE_BAR_GROUP;
-			break;
-		case ViewPageId:
-			name = mDocumentPanel->isFullScreenMode()
-				? FULLSCREEN_MODE_SIDE_BAR_GROUP
-				: VIEW_MODE_SIDE_BAR_GROUP;
-			break;
-		}
-		return name;
-	}
-
-	void loadSideBarConfig() {
-		static QMap<const char*, bool> defaultVisibility;
-		if (defaultVisibility.isEmpty()) {
-			defaultVisibility[BROWSE_MODE_SIDE_BAR_GROUP]     = true;
-			defaultVisibility[VIEW_MODE_SIDE_BAR_GROUP]       = true;
-			defaultVisibility[FULLSCREEN_MODE_SIDE_BAR_GROUP] = false;
-		}
-
-		const char* name = sideBarConfigGroupName();
-		KConfigGroup group(KGlobal::config(), name);
-		mSideBar->setVisible(group.readEntry(SIDE_BAR_IS_VISIBLE_KEY, defaultVisibility[name]));
-		mSideBar->setCurrentPage(GwenviewConfig::sideBarPage());
-	}
-
-	void saveSideBarConfig() const {
-		KConfigGroup group(KGlobal::config(), sideBarConfigGroupName());
-		group.writeEntry(SIDE_BAR_IS_VISIBLE_KEY, mSideBar->isVisible());
-		GwenviewConfig::setSideBarPage(mSideBar->currentPage());
-	}
-
-	void setScreenSaverEnabled(bool enabled) {
-		// Always delete mNotificationRestrictions, it does not hurt
-		delete mNotificationRestrictions;
-		if (!enabled) {
-			mNotificationRestrictions = new KNotificationRestrictions(KNotificationRestrictions::ScreenSaver, mWindow);
-		} else {
-			mNotificationRestrictions = 0;
-		}
-	}
+    GvCore* mGvCore;
+    MainWindow* q;
+    QSplitter* mCentralSplitter;
+    QWidget* mContentWidget;
+    ViewMainPage* mViewMainPage;
+    KUrlNavigator* mUrlNavigator;
+    ThumbnailView* mThumbnailView;
+    DocumentInfoProvider* mDocumentInfoProvider;
+    ThumbnailViewHelper* mThumbnailViewHelper;
+    BrowseMainPage* mBrowseMainPage;
+    StartMainPage* mStartMainPage;
+    SideBar* mSideBar;
+    QStackedWidget* mViewStackedWidget;
+    FullScreenBar* mFullScreenBar;
+    FullScreenContent* mFullScreenContent;
+    SaveBar* mSaveBar;
+    bool mStartSlideShowWhenDirListerCompleted;
+    SlideShow* mSlideShow;
+    Preloader* mPreloader;
+#ifdef KIPI_FOUND
+    KIPIInterface* mKIPIInterface;
+#endif
+
+    QActionGroup* mViewModeActionGroup;
+    KAction* mBrowseAction;
+    KAction* mViewAction;
+    KAction* mGoUpAction;
+    KAction* mGoToPreviousAction;
+    KAction* mGoToNextAction;
+    KAction* mGoToFirstAction;
+    KAction* mGoToLastAction;
+    KToggleAction* mToggleSideBarAction;
+    KToggleFullScreenAction* mFullScreenAction;
+    KAction* mToggleSlideShowAction;
+    KToggleAction* mShowMenuBarAction;
+#ifdef KIPI_FOUND
+    KIPIExportAction* mKIPIExportAction;
+#endif
+
+    SortedDirModel* mDirModel;
+    ContextManager* mContextManager;
+
+    bool mDistractionFreeMode;
+    MainWindowState mStateBeforeFullScreen;
+
+    KUrl mUrlToSelect;
+
+    QString mCaption;
+
+    MainPageId mCurrentMainPageId;
+
+    QDateTime mFullScreenLeftAt;
+    KNotificationRestrictions* mNotificationRestrictions;
+
+    void setupWidgets()
+    {
+        mCentralSplitter = new Splitter(Qt::Horizontal, q);
+        q->setCentralWidget(mCentralSplitter);
+
+        // Left side of splitter
+        mSideBar = new SideBar(mCentralSplitter);
+        EventWatcher::install(mSideBar, QList<QEvent::Type>() << QEvent::Show << QEvent::Hide,
+                              q, SLOT(updateToggleSideBarAction()));
+
+        // Right side of splitter
+        mContentWidget = new QWidget(mCentralSplitter);
+
+        mSaveBar = new SaveBar(mContentWidget, q->actionCollection());
+        mViewStackedWidget = new QStackedWidget(mContentWidget);
+        QVBoxLayout* layout = new QVBoxLayout(mContentWidget);
+        layout->addWidget(mSaveBar);
+        layout->addWidget(mViewStackedWidget);
+        layout->setMargin(0);
+        layout->setSpacing(0);
+        ////
+
+        mStartSlideShowWhenDirListerCompleted = false;
+        mSlideShow = new SlideShow(q);
+
+        setupThumbnailView(mViewStackedWidget);
+        setupViewMainPage(mViewStackedWidget);
+        setupStartMainPage(mViewStackedWidget);
+        mViewStackedWidget->addWidget(mBrowseMainPage);
+        mViewStackedWidget->addWidget(mViewMainPage);
+        mViewStackedWidget->addWidget(mStartMainPage);
+        mViewStackedWidget->setCurrentWidget(mBrowseMainPage);
+
+        mCentralSplitter->setStretchFactor(0, 0);
+        mCentralSplitter->setStretchFactor(1, 1);
+
+        connect(mSaveBar, SIGNAL(requestSaveAll()),
+                mGvCore, SLOT(saveAll()));
+        connect(mSaveBar, SIGNAL(goToUrl(KUrl)),
+                q, SLOT(goToUrl(KUrl)));
+
+        connect(mSlideShow, SIGNAL(goToUrl(KUrl)),
+                q, SLOT(goToUrl(KUrl)));
+    }
+
+    void setupThumbnailView(QWidget* parent)
+    {
+        mBrowseMainPage = new BrowseMainPage(parent, mDirModel, q->actionCollection());
+
+        mThumbnailView = mBrowseMainPage->thumbnailView();
+        mUrlNavigator = mBrowseMainPage->urlNavigator();
+        QPalette pal = mUrlNavigator->palette();
+        pal.setColor(QPalette::Window, pal.color(QPalette::Window).dark(110));
+        mUrlNavigator->setAutoFillBackground(true);
+        mUrlNavigator->setPalette(pal);
+
+        mDocumentInfoProvider = new DocumentInfoProvider(mDirModel);
+        mThumbnailView->setDocumentInfoProvider(mDocumentInfoProvider);
+
+        mThumbnailViewHelper = new ThumbnailViewHelper(mDirModel, q->actionCollection());
+        mThumbnailView->setThumbnailViewHelper(mThumbnailViewHelper);
+
+        // Connect thumbnail view
+        connect(mThumbnailView, SIGNAL(indexActivated(QModelIndex)),
+                q, SLOT(slotThumbnailViewIndexActivated(QModelIndex)));
+        connect(mThumbnailView->selectionModel(), SIGNAL(selectionChanged(QItemSelection, QItemSelection)),
+                q, SLOT(slotSelectionChanged()));
+
+        // Connect delegate
+        QAbstractItemDelegate* delegate = mThumbnailView->itemDelegate();
+        connect(delegate, SIGNAL(saveDocumentRequested(KUrl)),
+                mGvCore, SLOT(save(KUrl)));
+        connect(delegate, SIGNAL(rotateDocumentLeftRequested(KUrl)),
+                mGvCore, SLOT(rotateLeft(KUrl)));
+        connect(delegate, SIGNAL(rotateDocumentRightRequested(KUrl)),
+                mGvCore, SLOT(rotateRight(KUrl)));
+        connect(delegate, SIGNAL(showDocumentInFullScreenRequested(KUrl)),
+                q, SLOT(showDocumentInFullScreen(KUrl)));
+        connect(delegate, SIGNAL(setDocumentRatingRequested(KUrl, int)),
+                mGvCore, SLOT(setRating(KUrl, int)));
+
+        // Connect url navigator
+        connect(mUrlNavigator, SIGNAL(urlChanged(KUrl)),
+                q, SLOT(openDirUrl(KUrl)));
+    }
+
+    void setupViewMainPage(QWidget* parent)
+    {
+        mViewMainPage = new ViewMainPage(parent, mSlideShow, q->actionCollection());
+        connect(mViewMainPage, SIGNAL(captionUpdateRequested(QString)),
+                q, SLOT(setCaption(QString)));
+        connect(mViewMainPage, SIGNAL(completed()),
+                q, SLOT(slotPartCompleted()));
+        connect(mViewMainPage, SIGNAL(previousImageRequested()),
+                q, SLOT(goToPrevious()));
+        connect(mViewMainPage, SIGNAL(nextImageRequested()),
+                q, SLOT(goToNext()));
+
+        ThumbnailView* bar = mViewMainPage->thumbnailBar();
+        bar->setModel(mDirModel);
+        bar->setDocumentInfoProvider(mDocumentInfoProvider);
+        bar->setThumbnailViewHelper(mThumbnailViewHelper);
+        bar->setSelectionModel(mThumbnailView->selectionModel());
+    }
+
+    void setupStartMainPage(QWidget* parent)
+    {
+        mStartMainPage = new StartMainPage(parent, mGvCore);
+        connect(mStartMainPage, SIGNAL(urlSelected(KUrl)),
+                q, SLOT(slotStartMainPageUrlSelected(KUrl)));
+    }
+
+    void setupActions()
+    {
+        KActionCollection* actionCollection = q->actionCollection();
+        KActionCategory* file = new KActionCategory(i18nc("@title actions category", "File"), actionCollection);
+        KActionCategory* view = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface", "View"), actionCollection);
+
+        file->addAction(KStandardAction::Save, q, SLOT(saveCurrent()));
+        file->addAction(KStandardAction::SaveAs, q, SLOT(saveCurrentAs()));
+        file->addAction(KStandardAction::Open, q, SLOT(openFile()));
+        file->addAction(KStandardAction::Print, q, SLOT(print()));
+        file->addAction(KStandardAction::Quit, KApplication::kApplication(), SLOT(closeAllWindows()));
+
+        KAction* action = file->addAction("reload", q, SLOT(reload()));
+        action->setText(i18nc("@action reload the currently viewed image", "Reload"));
+        action->setIcon(KIcon("view-refresh"));
+        action->setShortcut(Qt::Key_F5);
+
+        mBrowseAction = view->addAction("browse");
+        mBrowseAction->setText(i18nc("@action Switch to file list", "Browse"));
+        mBrowseAction->setCheckable(true);
+        mBrowseAction->setIcon(KIcon("view-list-icons"));
+
+        mViewAction = view->addAction("view");
+        mViewAction->setText(i18nc("@action Switch to image view", "View"));
+        mViewAction->setIcon(KIcon("view-preview"));
+        mViewAction->setCheckable(true);
+
+        mViewModeActionGroup = new QActionGroup(q);
+        mViewModeActionGroup->addAction(mBrowseAction);
+        mViewModeActionGroup->addAction(mViewAction);
+
+        connect(mViewModeActionGroup, SIGNAL(triggered(QAction*)),
+                q, SLOT(setActiveViewModeAction(QAction*)));
+
+        mFullScreenAction = static_cast<KToggleFullScreenAction*>(view->addAction(KStandardAction::FullScreen, q, SLOT(toggleFullScreen(bool))));
+        connect(mViewMainPage, SIGNAL(toggleFullScreenRequested()),
+                mFullScreenAction, SLOT(trigger()));
+
+        KAction* reduceLodAction = view->addAction("reduce_lod", q, SLOT(reduceLevelOfDetails()));
+        // FIXME Find a better text for this action
+        reduceLodAction->setText(i18nc("@action Go back to a more general page (start page <- list <- image)", "Back"));
+        reduceLodAction->setShortcut(Qt::Key_Escape);
+
+        mGoToPreviousAction = view->addAction("go_previous", q, SLOT(goToPrevious()));
+        mGoToPreviousAction->setIcon(KIcon("media-skip-backward"));
+        mGoToPreviousAction->setText(i18nc("@action Go to previous image", "Previous"));
+        mGoToPreviousAction->setToolTip(i18n("Go to Previous Image"));
+        mGoToPreviousAction->setShortcut(Qt::Key_Backspace);
+
+        mGoToNextAction = view->addAction("go_next", q, SLOT(goToNext()));
+        mGoToNextAction->setIcon(KIcon("media-skip-forward"));
+        mGoToNextAction->setText(i18nc("@action Go to next image", "Next"));
+        mGoToNextAction->setToolTip(i18n("Go to Next Image"));
+        mGoToNextAction->setShortcut(Qt::Key_Space);
+
+        mGoToFirstAction = view->addAction("go_first", q, SLOT(goToFirst()));
+        mGoToFirstAction->setText(i18nc("@action Go to first image", "First"));
+        mGoToFirstAction->setToolTip(i18n("Go to First Image"));
+        mGoToFirstAction->setShortcut(Qt::Key_Home);
+
+        mGoToLastAction = view->addAction("go_last", q, SLOT(goToLast()));
+        mGoToLastAction->setText(i18nc("@action Go to last image", "Last"));
+        mGoToLastAction->setToolTip(i18n("Go to Last Image"));
+        mGoToLastAction->setShortcut(Qt::Key_End);
+
+        mGoUpAction = view->addAction(KStandardAction::Up, q, SLOT(goUp()));
+
+        action = view->addAction("go_start_page", q, SLOT(showStartMainPage()));
+        action->setIcon(KIcon("go-home"));
+        action->setText(i18nc("@action", "Start Page"));
+
+        mToggleSideBarAction = view->add<KToggleAction>("toggle_sidebar");
+        connect(mToggleSideBarAction, SIGNAL(toggled(bool)),
+                q, SLOT(toggleSideBar(bool)));
+        mToggleSideBarAction->setIcon(KIcon("view-sidetree"));
+        mToggleSideBarAction->setShortcut(Qt::Key_F11);
+        mToggleSideBarAction->setText(i18nc("@action", "Sidebar"));
+        connect(mBrowseMainPage->toggleSideBarButton(), SIGNAL(clicked()),
+                mToggleSideBarAction, SLOT(trigger()));
+        connect(mViewMainPage->toggleSideBarButton(), SIGNAL(clicked()),
+                mToggleSideBarAction, SLOT(trigger()));
+
+        mToggleSlideShowAction = view->addAction("toggle_slideshow", q, SLOT(toggleSlideShow()));
+        q->updateSlideShowAction();
+        connect(mSlideShow, SIGNAL(stateChanged(bool)),
+                q, SLOT(updateSlideShowAction()));
+
+        mShowMenuBarAction = static_cast<KToggleAction*>(view->addAction(KStandardAction::ShowMenubar, q, SLOT(toggleMenuBar())));
+
+        view->addAction(KStandardAction::KeyBindings, q->guiFactory(),
+                        SLOT(configureShortcuts()));
+
+        view->addAction(KStandardAction::Preferences, q,
+                        SLOT(showConfigDialog()));
+
+        view->addAction(KStandardAction::ConfigureToolbars, q,
+                        SLOT(configureToolbars()));
+
+#ifdef KIPI_FOUND
+        mKIPIExportAction = new KIPIExportAction(q);
+        actionCollection->addAction("kipi_export", mKIPIExportAction);
+#endif
+    }
+
+    void setupUndoActions()
+    {
+        // There is no KUndoGroup similar to KUndoStack. This code basically
+        // does the same as KUndoStack, but for the KUndoGroup actions.
+        QUndoGroup* undoGroup = DocumentFactory::instance()->undoGroup();
+        QAction* action;
+        KActionCollection* actionCollection =  q->actionCollection();
+        KActionCategory* edit = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface", "Edit"), actionCollection);
+
+        action = undoGroup->createRedoAction(actionCollection);
+        action->setObjectName(KStandardAction::name(KStandardAction::Redo));
+        action->setIcon(KIcon("edit-redo"));
+        action->setIconText(i18n("Redo"));
+        action->setShortcuts(KStandardShortcut::redo());
+        edit->addAction(action->objectName(), action);
+
+        action = undoGroup->createUndoAction(actionCollection);
+        action->setObjectName(KStandardAction::name(KStandardAction::Undo));
+        action->setIcon(KIcon("edit-undo"));
+        action->setIconText(i18n("Undo"));
+        action->setShortcuts(KStandardShortcut::undo());
+        edit->addAction(action->objectName(), action);
+    }
+
+    void setupContextManager()
+    {
+        KActionCollection* actionCollection = q->actionCollection();
+
+        mContextManager = new ContextManager(mDirModel, mThumbnailView->selectionModel(), q);
+
+        // Create context manager items
+        FolderViewContextManagerItem* folderViewItem = new FolderViewContextManagerItem(mContextManager);
+        mContextManager->addItem(folderViewItem);
+        connect(folderViewItem, SIGNAL(urlChanged(KUrl)),
+                q, SLOT(openDirUrl(KUrl)));
+
+        InfoContextManagerItem* infoItem = new InfoContextManagerItem(mContextManager);
+        mContextManager->addItem(infoItem);
+
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+        SemanticInfoContextManagerItem* semanticInfoItem = 0;
+        // When using Nepomuk, create a SemanticInfoContextManagerItem instance
+        // only if Nepomuk is available
+        // When using Fake backend always create it
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
+        if (Nepomuk::ResourceManager::instance()->init() == 0) {
+#endif
+            semanticInfoItem = new SemanticInfoContextManagerItem(mContextManager, actionCollection, mViewMainPage);
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
+        }
+#endif
+        if (semanticInfoItem) {
+            mContextManager->addItem(semanticInfoItem);
+        }
+#endif
+
+        ImageOpsContextManagerItem* imageOpsItem =
+            new ImageOpsContextManagerItem(mContextManager, q);
+        mContextManager->addItem(imageOpsItem);
+
+        FileOpsContextManagerItem* fileOpsItem = new FileOpsContextManagerItem(mContextManager, mThumbnailView, actionCollection, q);
+        mContextManager->addItem(fileOpsItem);
+
+        // Fill sidebar
+        SideBarPage* page;
+        page = new SideBarPage(i18n("Folders"));
+        page->setObjectName(QLatin1String("folders"));
+        page->addWidget(folderViewItem->widget());
+        page->layout()->setMargin(0);
+        mSideBar->addPage(page);
+
+        page = new SideBarPage(i18n("Information"));
+        page->setObjectName(QLatin1String("information"));
+        page->addWidget(infoItem->widget());
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+        if (semanticInfoItem) {
+            page->addWidget(semanticInfoItem->widget());
+        }
+#endif
+        page->addStretch();
+        mSideBar->addPage(page);
+
+        page = new SideBarPage(i18n("Operations"));
+        page->setObjectName(QLatin1String("operations"));
+        page->addWidget(imageOpsItem->widget());
+        page->addWidget(fileOpsItem->widget());
+        page->addStretch();
+        mSideBar->addPage(page);
+    }
+
+    void initDirModel()
+    {
+        mDirModel->setKindFilter(
+            MimeTypeUtils::KIND_RASTER_IMAGE
+            | MimeTypeUtils::KIND_SVG_IMAGE
+            | MimeTypeUtils::KIND_VIDEO);
+        setDirModelShowDirs(true);
+
+        connect(mDirModel, SIGNAL(rowsInserted(QModelIndex, int, int)),
+                q, SLOT(slotDirModelNewItems()));
+
+        connect(mDirModel, SIGNAL(rowsRemoved(QModelIndex, int, int)),
+                q, SLOT(updatePreviousNextActions()));
+        connect(mDirModel, SIGNAL(modelReset()),
+                q, SLOT(updatePreviousNextActions()));
+
+        connect(mDirModel->dirLister(), SIGNAL(completed()),
+                q, SLOT(slotDirListerCompleted()));
+    }
+
+    void setDirModelShowDirs(bool showDirs)
+    {
+        mDirModel->adjustKindFilter(MimeTypeUtils::KIND_DIR | MimeTypeUtils::KIND_ARCHIVE, showDirs);
+    }
+
+    QModelIndex currentIndex() const {
+        KUrl url = currentUrl();
+        return url.isValid() ? mDirModel->indexForUrl(url) : QModelIndex();
+    }
+
+    bool indexIsDirOrArchive(const QModelIndex& index) const {
+        Q_ASSERT(index.isValid());
+        KFileItem item = mDirModel->itemForIndex(index);
+        return ArchiveUtils::fileItemIsDirOrArchive(item);
+    }
+
+    void goTo(const QModelIndex& index)
+    {
+        if (!index.isValid()) {
+            return;
+        }
+        mThumbnailView->setCurrentIndex(index);
+        mThumbnailView->scrollTo(index);
+    }
+
+    void goTo(int offset)
+    {
+        QModelIndex index = currentIndex();
+        index = mDirModel->index(index.row() + offset, 0);
+        if (!index.isValid()) {
+            return;
+        }
+        if (!indexIsDirOrArchive(index)) {
+            goTo(index);
+        }
+    }
+
+    void goToFirstDocument()
+    {
+        QModelIndex index;
+        for (int row = 0;; ++row) {
+            index = mDirModel->index(row, 0);
+            if (!index.isValid()) {
+                return;
+            }
+
+            if (!indexIsDirOrArchive(index)) {
+                break;
+            }
+        }
+        goTo(index);
+    }
+
+    void goToLastDocument()
+    {
+        QModelIndex index = mDirModel->index(mDirModel->rowCount() - 1, 0);
+        goTo(index);
+    }
+
+    void spreadCurrentDirUrl(const KUrl& url)
+    {
+        mContextManager->setCurrentDirUrl(url);
+        mThumbnailViewHelper->setCurrentDirUrl(url);
+        if (url.isValid()) {
+            mUrlNavigator->setLocationUrl(url);
+            mGoUpAction->setEnabled(url.path() != "/");
+            mGvCore->addUrlToRecentFolders(url);
+        } else {
+            mGoUpAction->setEnabled(false);
+        }
+    }
+
+    void setupFullScreenBar()
+    {
+        mFullScreenBar = new FullScreenBar(mViewMainPage);
+        mFullScreenContent = new FullScreenContent(
+            mFullScreenBar, q->actionCollection(), mSlideShow);
+
+        ThumbnailBarView* view = mFullScreenContent->thumbnailBar();
+        view->setModel(mDirModel);
+        view->setDocumentInfoProvider(mDocumentInfoProvider);
+        view->setThumbnailViewHelper(mThumbnailViewHelper);
+        view->setSelectionModel(mThumbnailView->selectionModel());
+    }
+
+    inline void setActionEnabled(const char* name, bool enabled)
+    {
+        QAction* action = q->actionCollection()->action(name);
+        if (action) {
+            action->setEnabled(enabled);
+        } else {
+            kWarning() << "Action" << name << "not found";
+        }
+    }
+
+    void setActionsDisabledOnStartMainPageEnabled(bool enabled)
+    {
+        mBrowseAction->setEnabled(enabled);
+        mViewAction->setEnabled(enabled);
+        mToggleSideBarAction->setEnabled(enabled);
+        mFullScreenAction->setEnabled(enabled);
+        mToggleSlideShowAction->setEnabled(enabled);
+
+        setActionEnabled("reload", enabled);
+        setActionEnabled("go_start_page", enabled);
+        setActionEnabled("add_folder_to_places", enabled);
+    }
+
+    void updateDistractionsState()
+    {
+        const bool isFullScreen = mFullScreenAction->isChecked();
+        mFullScreenBar->setActivated(!mDistractionFreeMode && isFullScreen);
+    }
+
+    void updateActions()
+    {
+        bool isRasterImage = false;
+        bool canSave = false;
+        bool isModified = false;
+        const KUrl url = currentUrl();
+
+        if (url.isValid()) {
+            isRasterImage = q->currentDocumentIsRasterImage();
+            canSave = isRasterImage;
+            isModified = DocumentFactory::instance()->load(url)->isModified();
+            if (mCurrentMainPageId != ViewMainPageId) {
+                // Saving only makes sense if exactly one image is selected
+                QItemSelection selection = mThumbnailView->selectionModel()->selection();
+                QModelIndexList indexList = selection.indexes();
+                if (indexList.count() != 1) {
+                    canSave = false;
+                }
+            }
+        }
+
+        KActionCollection* actionCollection = q->actionCollection();
+        actionCollection->action("file_save")->setEnabled(canSave && isModified);
+        actionCollection->action("file_save_as")->setEnabled(canSave);
+        actionCollection->action("file_print")->setEnabled(isRasterImage);
+    }
+
+    KUrl currentUrl() const {
+        if (mCurrentMainPageId == StartMainPageId) {
+            return KUrl();
+        }
+
+        if (mUrlToSelect.isValid()) {
+            // We are supposed to select this url whenever it appears in the
+            // dir model. For everyone it is as if it was already the current one
+            return mUrlToSelect;
+        }
+
+        // mBrowseMainPage and mViewMainPage urls are almost always synced, but
+        // mBrowseMainPage can be more up-to-date because mViewMainPage
+        // url is only updated when the DocumentView starts to load the
+        // document.
+        // This is why we only thrust mViewMainPage url if it shows an url
+        // which can't be listed: in this case mBrowseMainPage url is
+        // empty.
+        if (mCurrentMainPageId == ViewMainPageId && !mViewMainPage->isEmpty()) {
+            KUrl url = mViewMainPage->url();
+            if (!KProtocolManager::supportsListing(url)) {
+                return url;
+            }
+        }
+
+        QModelIndex index = mThumbnailView->currentIndex();
+        if (!index.isValid()) {
+            return KUrl();
+        }
+        // Ignore the current index if it's not part of the selection. This
+        // situation can happen when you select an image, then click on the
+        // background of the thumbnail view.
+        if (mCurrentMainPageId == BrowseMainPageId && !mThumbnailView->selectionModel()->isSelected(index)) {
+            return KUrl();
+        }
+        KFileItem item = mDirModel->itemForIndex(index);
+        Q_ASSERT(!item.isNull());
+        return item.url();
+    }
+
+    void setUrlToSelect(const KUrl& url)
+    {
+        if (!url.isValid()) {
+            kWarning() << "called with an invalid url, this should not happen!";
+            return;
+        }
+        mUrlToSelect = url;
+        updateContextDependentComponents();
+        selectUrlToSelect();
+    }
+
+    void selectUrlToSelect()
+    {
+        QModelIndex index = mDirModel->indexForUrl(mUrlToSelect);
+        if (index.isValid()) {
+            if (index != mThumbnailView->currentIndex()) { // Avoid infinite recursion. Bug #243091
+                mThumbnailView->setCurrentIndex(index);
+            }
+            mThumbnailView->scrollTo(index, QAbstractItemView::PositionAtCenter);
+            mUrlToSelect = KUrl();
+        }
+    }
+
+    void updateContextDependentComponents()
+    {
+        KUrl url = currentUrl();
+        mContextManager->setCurrentUrl(url);
+        mSaveBar->setCurrentUrl(url);
+        mSlideShow->setCurrentUrl(url);
+        mFullScreenContent->setCurrentUrl(url);
+    }
+
+    const char* sideBarConfigGroupName() const {
+        const char* name = 0;
+        switch (mCurrentMainPageId) {
+        case StartMainPageId:
+            kWarning() << "Should not happen!";
+            // Fall through
+        case BrowseMainPageId:
+            name = BROWSE_MODE_SIDE_BAR_GROUP;
+            break;
+        case ViewMainPageId:
+            name = mViewMainPage->isFullScreenMode()
+                   ? FULLSCREEN_MODE_SIDE_BAR_GROUP
+                   : VIEW_MODE_SIDE_BAR_GROUP;
+            break;
+        }
+        return name;
+    }
+
+    void loadSideBarConfig()
+    {
+        static QMap<const char*, bool> defaultVisibility;
+        if (defaultVisibility.isEmpty()) {
+            defaultVisibility[BROWSE_MODE_SIDE_BAR_GROUP]     = true;
+            defaultVisibility[VIEW_MODE_SIDE_BAR_GROUP]       = true;
+            defaultVisibility[FULLSCREEN_MODE_SIDE_BAR_GROUP] = false;
+        }
+
+        const char* name = sideBarConfigGroupName();
+        KConfigGroup group(KGlobal::config(), name);
+        mSideBar->setVisible(group.readEntry(SIDE_BAR_IS_VISIBLE_KEY, defaultVisibility[name]));
+        mSideBar->setCurrentPage(GwenviewConfig::sideBarPage());
+    }
+
+    void saveSideBarConfig() const
+    {
+        KConfigGroup group(KGlobal::config(), sideBarConfigGroupName());
+        group.writeEntry(SIDE_BAR_IS_VISIBLE_KEY, mSideBar->isVisible());
+        GwenviewConfig::setSideBarPage(mSideBar->currentPage());
+    }
+
+    void setScreenSaverEnabled(bool enabled)
+    {
+        // Always delete mNotificationRestrictions, it does not hurt
+        delete mNotificationRestrictions;
+        if (!enabled) {
+            mNotificationRestrictions = new KNotificationRestrictions(KNotificationRestrictions::ScreenSaver, q);
+        } else {
+            mNotificationRestrictions = 0;
+        }
+    }
 };
 
-
 MainWindow::MainWindow()
 : KXmlGuiWindow(),
-d(new MainWindow::Private)
+      d(new MainWindow::Private)
 {
-	d->mWindow = this;
-	d->mCurrentPageId = StartPageId;
-	d->mDistractionFreeMode = false;
-	d->mDirModel = new SortedDirModel(this);
-	d->mGvCore = new GvCore(this, d->mDirModel);
-	d->mPreloader = new Preloader(this);
-	d->mNotificationRestrictions = 0;
-	d->initDirModel();
-	d->setupWidgets();
-	d->setupActions();
-	d->setupUndoActions();
-	d->setupContextManager();
-	d->setupFullScreenBar();
-	d->updateActions();
-	updatePreviousNextActions();
-	d->mSaveBar->initActionDependentWidgets();
-
-	createGUI();
-	loadConfig();
-
-	connect(DocumentFactory::instance(), SIGNAL(modifiedDocumentListChanged()),
-		SLOT(slotModifiedDocumentListChanged()) );
+    d->q = this;
+    d->mCurrentMainPageId = StartMainPageId;
+    d->mDistractionFreeMode = false;
+    d->mDirModel = new SortedDirModel(this);
+    d->mGvCore = new GvCore(this, d->mDirModel);
+    d->mPreloader = new Preloader(this);
+    d->mNotificationRestrictions = 0;
+    d->initDirModel();
+    d->setupWidgets();
+    d->setupActions();
+    d->setupUndoActions();
+    d->setupContextManager();
+    d->setupFullScreenBar();
+    d->updateActions();
+    updatePreviousNextActions();
+    d->mSaveBar->initActionDependentWidgets();
+
+    createGUI();
+    loadConfig();
+
+    connect(DocumentFactory::instance(), SIGNAL(modifiedDocumentListChanged()),
+            SLOT(slotModifiedDocumentListChanged()));
 
 #ifdef KIPI_FOUND
-	d->mKIPIInterface = new KIPIInterface(this);
-	d->mKIPIExportAction->setKIPIInterface(d->mKIPIInterface);
+    d->mKIPIInterface = new KIPIInterface(this);
+    d->mKIPIExportAction->setKIPIInterface(d->mKIPIInterface);
 #endif
-	setAutoSaveSettings();
-}
-
-
-MainWindow::~MainWindow() {
-	delete d;
-}
-
-ContextManager* MainWindow::contextManager() const {
-	return d->mContextManager;
-}
-
-DocumentPanel* MainWindow::documentPanel() const {
-	return d->mDocumentPanel;
-}
-
-
-bool MainWindow::currentDocumentIsRasterImage() const {
-	if (d->mCurrentPageId == ViewPageId) {
-		Document::Ptr doc = d->mDocumentPanel->currentDocument();
-		if (!doc) {
-			return false;
-		}
-		return doc->kind() == MimeTypeUtils::KIND_RASTER_IMAGE;
-	} else {
-		QModelIndex index = d->mThumbnailView->currentIndex();
-		if (!index.isValid()) {
-			return false;
-		}
-		KFileItem item = d->mDirModel->itemForIndex(index);
-		Q_ASSERT(!item.isNull());
-		return MimeTypeUtils::fileItemKind(item) == MimeTypeUtils::KIND_RASTER_IMAGE;
-	}
-}
-
-
-void MainWindow::setCaption(const QString& caption) {
-	// Keep a trace of caption to use it in slotModifiedDocumentListChanged()
-	d->mCaption = caption;
-	KXmlGuiWindow::setCaption(caption);
-}
-
-void MainWindow::setCaption(const QString& caption, bool modified) {
-	d->mCaption = caption;
-	KXmlGuiWindow::setCaption(caption, modified);
-}
-
-
-void MainWindow::slotModifiedDocumentListChanged() {
-	d->updateActions();
-
-	// Update caption
-	QList<KUrl> list = DocumentFactory::instance()->modifiedDocumentList();
-	bool modified = list.count() > 0;
-	setCaption(d->mCaption, modified);
-}
-
-
-void MainWindow::setInitialUrl(const KUrl& _url) {
-	Q_ASSERT(_url.isValid());
-	KUrl url = UrlUtils::fixUserEnteredUrl(_url);
-	if (url.protocol() == "http" || url.protocol() == "https") {
-		d->mGvCore->addUrlToRecentUrls(url);
-	}
-	if (UrlUtils::urlIsDirectory(url)) {
-		d->mBrowseAction->trigger();
-		openDirUrl(url);
-	} else {
-		d->mViewAction->trigger();
-		d->mDocumentPanel->openUrl(url);
-		d->setUrlToSelect(url);
-	}
-	d->updateContextDependentComponents();
-}
-
-
-void MainWindow::startSlideShow() {
-	// We need to wait until we have listed all images in the dirlister to
-	// start the slideshow because the SlideShow objects needs an image list to
-	// work.
-	d->mStartSlideShowWhenDirListerCompleted = true;
-}
-
-
-void MainWindow::setActiveViewModeAction(QAction* action) {
-	if (d->mCurrentPageId == StartPageId) {
-		d->mSideBarCollapser->show();
-	} else {
-		d->saveSideBarConfig();
-	}
-	if (action == d->mViewAction) {
-		d->mCurrentPageId = ViewPageId;
-		// Switching to view mode
-		d->setDirModelShowDirs(false);
-		d->mViewStackedWidget->setCurrentWidget(d->mDocumentPanel);
-		d->mContextManager->setOnlyCurrentUrl(true);
-		if (d->mDocumentPanel->isEmpty()) {
-			openSelectedDocuments();
-		}
-	} else {
-		d->mCurrentPageId = BrowsePageId;
-		// Switching to browse mode
-		d->mViewStackedWidget->setCurrentWidget(d->mThumbnailViewPanel);
-		if (!d->mDocumentPanel->isEmpty()
-			&& KProtocolManager::supportsListing(d->mDocumentPanel->url()))
-		{
-			// Reset the view to spare resources, but don't do it if we can't
-			// browse the url, otherwise if the user starts Gwenview this way:
-			// gwenview http://example.com/example.png
-			// and switch to browse mode, switching back to view mode won't bring
-			// his image back.
-			d->mDocumentPanel->reset();
-		}
-		d->setDirModelShowDirs(true);
-		setCaption(QString());
-		d->mContextManager->setOnlyCurrentUrl(false);
-	}
-	d->loadSideBarConfig();
-
-	emit viewModeChanged();
-}
-
-
-void MainWindow::slotThumbnailViewIndexActivated(const QModelIndex& index) {
-	if (!index.isValid()) {
-		return;
-	}
-
-	KFileItem item = d->mDirModel->itemForIndex(index);
-	if (item.isDir()) {
-		// Item is a dir, open it
-		openDirUrl(item.url());
-	} else {
-		QString protocol = ArchiveUtils::protocolForMimeType(item.mimetype());
-		if (!protocol.isEmpty()) {
-			// Item is an archive, tweak url then open it
-			KUrl url = item.url();
-			url.setProtocol(protocol);
-			openDirUrl(url);
-		} else {
-			// Item is a document, switch to view mode
-			d->mViewAction->trigger();
-		}
-	}
-}
-
-
-void MainWindow::openSelectedDocuments() {
-	if (d->mCurrentPageId != ViewPageId) {
-		return;
-	}
-
-	QModelIndex currentIndex = d->mThumbnailView->currentIndex();
-	if (!currentIndex.isValid()) {
-		return;
-	}
-
-	int count = 0;
-
-	KUrl::List urls;
-	KUrl currentUrl;
-	Q_FOREACH(const QModelIndex& index, d->mThumbnailView->selectionModel()->selectedIndexes()) {
-		KFileItem item = d->mDirModel->itemForIndex(index);
-		if (!item.isNull() && !ArchiveUtils::fileItemIsDirOrArchive(item)) {
-			KUrl url = item.url();
-			urls << url;
-			if (index == currentIndex) {
-				currentUrl = url;
-			}
-			++count;
-			if (count == DocumentPanel::MaxViewCount) {
-				break;
-			}
-		}
-	}
-
-	d->mDocumentPanel->openUrls(urls, currentUrl);
-}
-
-
-void MainWindow::goUp() {
-	if (d->mCurrentPageId == BrowsePageId) {
-		KUrl url = d->mDirModel->dirLister()->url();
-		url = url.upUrl();
-		openDirUrl(url);
-	} else {
-		d->mBrowseAction->trigger();
-	}
-}
-
-
-void MainWindow::showStartPage() {
-	if (d->mCurrentPageId != StartPageId) {
-		d->saveSideBarConfig();
-		d->mCurrentPageId = StartPageId;
-	}
-	d->setActionsDisabledOnStartPageEnabled(false);
-	d->spreadCurrentDirUrl(KUrl());
-
-	d->mSideBar->hide();
-	d->mSideBarCollapser->hide();
-	d->mViewStackedWidget->setCurrentWidget(d->mStartPage);
-
-	d->updateActions();
-	updatePreviousNextActions();
-	d->updateContextDependentComponents();
-}
-
-
-void MainWindow::slotStartPageUrlSelected(const KUrl& url) {
-	d->setActionsDisabledOnStartPageEnabled(true);
-
-	if (d->mBrowseAction->isChecked()) {
-		// Silently uncheck the action so that setInitialUrl() does the right thing
-		SignalBlocker blocker(d->mBrowseAction);
-		d->mBrowseAction->setChecked(false);
-	}
-
-	setInitialUrl(url);
-}
-
-
-void MainWindow::openDirUrl(const KUrl& url) {
-	const KUrl currentUrl = d->mContextManager->currentDirUrl();
-
-	if (url.equals(currentUrl, KUrl::CompareWithoutTrailingSlash)) {
-		return;
-	}
-
-	if (url.isParentOf(currentUrl)) {
-		// Keep first child between url and currentUrl selected
-		// If currentPath is      "/home/user/photos/2008/event"
-		// and wantedPath is      "/home/user/photos"
-		// pathToSelect should be "/home/user/photos/2008"
-		const QString currentPath = QDir::cleanPath(currentUrl.toLocalFile(KUrl::RemoveTrailingSlash));
-		const QString wantedPath  = QDir::cleanPath(url.toLocalFile(KUrl::RemoveTrailingSlash));
-		const QChar separator('/');
-		const int slashCount = wantedPath.count(separator);
-		const QString pathToSelect = currentPath.section(separator, 0, slashCount + 1);
-		KUrl urlToSelect = url;
-		urlToSelect.setPath(pathToSelect);
-		d->setUrlToSelect(urlToSelect);
-	}
-	d->mDirModel->dirLister()->openUrl(url);
-	d->spreadCurrentDirUrl(url);
-	d->mDocumentPanel->reset();
-}
-
-
-void MainWindow::toggleSideBar(bool on) {
-	d->mSideBar->setVisible(on);
-}
-
-
-void MainWindow::updateToggleSideBarAction() {
-	SignalBlocker blocker(d->mToggleSideBarAction);
-	d->mToggleSideBarAction->setChecked(d->mSideBar->isVisible());
-}
-
-
-void MainWindow::slotPartCompleted() {
-	d->updateActions();
-	KUrl url = d->mDocumentPanel->url();
-	if (!KProtocolManager::supportsListing(url)) {
-		return;
-	}
-
-	KUrl dirUrl = url;
-	dirUrl.setFileName(QString());
-	if (dirUrl.equals(d->mDirModel->dirLister()->url(), KUrl::CompareWithoutTrailingSlash)) {
-		QModelIndex index = d->mDirModel->indexForUrl(url);
-		QItemSelectionModel* selectionModel = d->mThumbnailView->selectionModel();
-		if (index.isValid() && !selectionModel->isSelected(index)) {
-			selectionModel->select(index, QItemSelectionModel::SelectCurrent);
-		}
-	} else {
-		d->mDirModel->dirLister()->openUrl(dirUrl);
-		d->spreadCurrentDirUrl(dirUrl);
-	}
-}
-
-
-void MainWindow::slotSelectionChanged() {
-	if (d->mCurrentPageId == ViewPageId) {
-		// The user selected a new file in the thumbnail view, since the
-		// document view is visible, let's show it
-		openSelectedDocuments();
-	} else {
-		// No document view, we need to load the document to set the undo group
-		// of document factory to the correct QUndoStack
-		QModelIndex index = d->mThumbnailView->currentIndex();
-		KFileItem item;
-		if (index.isValid()) {
-			item = d->mDirModel->itemForIndex(index);
-		}
-		QUndoGroup* undoGroup = DocumentFactory::instance()->undoGroup();
-		if (!item.isNull() && !ArchiveUtils::fileItemIsDirOrArchive(item)) {
-			KUrl url = item.url();
-			Document::Ptr doc = DocumentFactory::instance()->load(url);
-			undoGroup->addStack(doc->undoStack());
-			undoGroup->setActiveStack(doc->undoStack());
-		} else {
-			undoGroup->setActiveStack(0);
-		}
-	}
-
-	// Update UI
-	d->updateActions();
-	updatePreviousNextActions();
-	d->updateContextDependentComponents();
-
-	// Start preloading
-	QTimer::singleShot(PRELOAD_DELAY, this, SLOT(preloadNextUrl()) );
-}
-
-
-void MainWindow::slotDirModelNewItems() {
-	if (d->mUrlToSelect.isValid()) {
-		d->selectUrlToSelect();
-	}
-	if (d->mThumbnailView->selectionModel()->hasSelection()) {
-		updatePreviousNextActions();
-	}
-}
-
-
-void MainWindow::slotDirListerCompleted() {
-	if (d->mStartSlideShowWhenDirListerCompleted) {
-		d->mStartSlideShowWhenDirListerCompleted = false;
-		QTimer::singleShot(0, d->mToggleSlideShowAction, SLOT(trigger()));
-	}
-	if (d->mThumbnailView->selectionModel()->hasSelection()) {
-		updatePreviousNextActions();
-	} else if (!d->mUrlToSelect.isValid()) {
-		d->goToFirstDocument();
-	}
-}
-
-
-void MainWindow::goToPrevious() {
-	d->goTo(-1);
-}
-
-
-void MainWindow::goToNext() {
-	d->goTo(1);
-}
-
-void MainWindow::goToFirst() {
-	d->goToFirstDocument();
-}
-
-void MainWindow::goToLast() {
-	d->goToLastDocument();
-}
-
-void MainWindow::goToUrl(const KUrl& url) {
-	if (d->mCurrentPageId == ViewPageId) {
-		d->mDocumentPanel->openUrl(url);
-	}
-	KUrl dirUrl = url;
-	dirUrl.setFileName("");
-	if (!dirUrl.equals(d->mContextManager->currentDirUrl(), KUrl::CompareWithoutTrailingSlash)) {
-		d->mDirModel->dirLister()->openUrl(dirUrl);
-		d->spreadCurrentDirUrl(dirUrl);
-	}
-	d->setUrlToSelect(url);
-}
-
-
-void MainWindow::updatePreviousNextActions() {
-	QModelIndex index = d->currentIndex();
-
-	QModelIndex prevIndex = d->mDirModel->index(index.row() - 1, 0);
-	d->mGoToPreviousAction->setEnabled(prevIndex.isValid() && !d->indexIsDirOrArchive(prevIndex));
-	d->mGoToFirstAction->setEnabled(d->mGoToPreviousAction->isEnabled());
-
-	QModelIndex nextIndex = d->mDirModel->index(index.row() + 1, 0);
-	d->mGoToNextAction->setEnabled(nextIndex.isValid() && !d->indexIsDirOrArchive(nextIndex));
-	d->mGoToLastAction->setEnabled(d->mGoToNextAction->isEnabled());
-}
-
-
-void MainWindow::reduceLevelOfDetails() {
-	if (d->mFullScreenAction->isChecked()) {
-		d->mFullScreenAction->trigger();
-	} else if (d->mCurrentPageId == ViewPageId) {
-		d->mBrowseAction->trigger();
-	} else {
-		showStartPage();
-	}
-}
-
-
-void MainWindow::toggleFullScreen(bool checked) {
-	setUpdatesEnabled(false);
-	d->saveSideBarConfig();
-	if (checked) {
-		// Save MainWindow config now, this way if we quit while in
-		// fullscreen, we are sure latest MainWindow changes are remembered.
-		saveMainWindowSettings(autoSaveConfigGroup());
-		resetAutoSaveSettings();
-
-		// Save state
-		d->mStateBeforeFullScreen.mPageId = d->mCurrentPageId;
-		d->mStateBeforeFullScreen.mToolBarVisible = toolBar()->isVisible();
-		d->mStateBeforeFullScreen.mWindowState = windowState();
-
-		// Go full screen
-		d->mViewAction->trigger();
-
-		setWindowState(windowState() | Qt::WindowFullScreen);
-		menuBar()->hide();
-		toolBar()->hide();
-		d->mDocumentPanel->setFullScreenMode(true);
-		d->mSaveBar->setFullScreenMode(true);
-		d->updateDistractionsState();
-		d->setScreenSaverEnabled(false);
-
-		// HACK: Only load sidebar config now, because it looks at
-		// DocumentPanel fullScreenMode property to determine the sidebar
-		// config group.
-		d->loadSideBarConfig();
-	} else {
-		setAutoSaveSettings();
-
-		// Back to normal
-		d->mCurrentPageId = d->mStateBeforeFullScreen.mPageId;
-		if (d->mCurrentPageId == BrowsePageId) {
-			d->mBrowseAction->trigger();
-		}
-
-		d->mDocumentPanel->setFullScreenMode(false);
-		d->mSlideShow->stop();
-		d->mSaveBar->setFullScreenMode(false);
-		setWindowState(d->mStateBeforeFullScreen.mWindowState);
-		menuBar()->setVisible(d->mShowMenuBarAction->isChecked());
-		toolBar()->setVisible(d->mStateBeforeFullScreen.mToolBarVisible);
-
-		d->updateDistractionsState();
-		d->setScreenSaverEnabled(true);
-
-		// Keep this after mDocumentPanel->setFullScreenMode(false).
-		// See call to loadSideBarConfig() above.
-		d->loadSideBarConfig();
-
-		// See resizeEvent
-		d->mFullScreenLeftAt = QDateTime::currentDateTime();
-	}
-	setUpdatesEnabled(true);
-}
-
-
-void MainWindow::saveCurrent() {
-	d->mGvCore->save(d->currentUrl());
-}
-
-
-void MainWindow::saveCurrentAs() {
-	d->mGvCore->saveAs(d->currentUrl());
-}
-
-
-void MainWindow::reload() {
-	if (d->mCurrentPageId == ViewPageId) {
-		d->mDocumentPanel->reload();
-	} else {
-		d->mThumbnailViewPanel->reload();
-	}
-}
-
-
-void MainWindow::openFile() {
-	KUrl dirUrl = d->mDirModel->dirLister()->url();
-
-	KFileDialog dialog(dirUrl, QString(), this);
-	dialog.setCaption(i18nc("@title:window", "Open Image"));
-	const QStringList mimeFilter = MimeTypeUtils::imageMimeTypes();
-	dialog.setMimeFilter(mimeFilter);
-	dialog.setOperationMode(KFileDialog::Opening);
-	if (!dialog.exec()) {
-		return;
-	}
-
-	d->setActionsDisabledOnStartPageEnabled(true);
-	KUrl url = dialog.selectedUrl();
-	d->mViewAction->trigger();
-	d->mDocumentPanel->openUrl(url);
-	d->setUrlToSelect(url);
-	d->updateContextDependentComponents();
-}
-
-
-void MainWindow::showDocumentInFullScreen(const KUrl& url) {
-	d->mDocumentPanel->openUrl(url);
-	d->setUrlToSelect(url);
-	d->mFullScreenAction->trigger();
-}
-
-
-void MainWindow::toggleSlideShow() {
-	if (d->mSlideShow->isRunning()) {
-		d->mSlideShow->stop();
-	} else {
-		if (!d->mFullScreenAction->isChecked()) {
-			d->mFullScreenAction->trigger();
-		}
-		QList<KUrl> list;
-		for (int pos=0; pos < d->mDirModel->rowCount(); ++pos) {
-			QModelIndex index = d->mDirModel->index(pos, 0);
-			KFileItem item = d->mDirModel->itemForIndex(index);
-			MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
-			switch (kind) {
-			case MimeTypeUtils::KIND_SVG_IMAGE:
-			case MimeTypeUtils::KIND_RASTER_IMAGE:
-			case MimeTypeUtils::KIND_VIDEO:
-				list << item.url();
-				break;
-			default:
-				break;
-			}
-		}
-		d->mSlideShow->start(list);
-	}
-	updateSlideShowAction();
-}
-
-
-void MainWindow::updateSlideShowAction() {
-	if (d->mSlideShow->isRunning()) {
-		d->mToggleSlideShowAction->setText(i18n("Stop Slideshow"));
-		d->mToggleSlideShowAction->setIcon(KIcon("media-playback-pause"));
-	} else {
-		d->mToggleSlideShowAction->setText(i18n("Start Slideshow"));
-		d->mToggleSlideShowAction->setIcon(KIcon("media-playback-start"));
-	}
-}
-
-
-bool MainWindow::queryClose() {
-	saveConfig();
-	d->saveSideBarConfig();
-	QList<KUrl> list = DocumentFactory::instance()->modifiedDocumentList();
-	if (list.size() == 0) {
-		return true;
-	}
-
-	KGuiItem yes(i18n("Save All Changes"), "document-save-all");
-	KGuiItem no(i18n("Discard Changes"));
-	QString msg = i18np("One image has been modified.", "%1 images have been modified.", list.size())
-			+ '\n'
-			+ i18n("If you quit now, your changes will be lost.");
-	int answer = KMessageBox::warningYesNoCancel(
-		this,
-		msg,
-		QString() /* caption */,
-		yes,
-		no);
-
-	switch (answer) {
-	case KMessageBox::Yes:
-		d->mGvCore->saveAll();
-		// We need to wait a bit because the DocumentFactory is notified about
-		// saved documents through a queued connection.
-		qApp->processEvents();
-		return DocumentFactory::instance()->modifiedDocumentList().isEmpty();
-
-	case KMessageBox::No:
-		return true;
-
-	default: // cancel
-		return false;
-	}
-}
-
-
-bool MainWindow::queryExit() {
-	if (GwenviewConfig::deleteThumbnailCacheOnExit()) {
-		const QString dir = ThumbnailLoadJob::thumbnailBaseDir();
-		if (QFile::exists(dir)) {
-			KIO::NetAccess::del(KUrl::fromPath(dir), this);
-		}
-	}
-	return true;
-}
-
-
-void MainWindow::showConfigDialog() {
-	ConfigDialog dialog(this);
-	connect(&dialog, SIGNAL(settingsChanged(const QString&)), SLOT(loadConfig()));
-	dialog.exec();
-}
-
-
-void MainWindow::toggleMenuBar() {
-	if (!d->mFullScreenAction->isChecked()) {
-		menuBar()->setVisible(d->mShowMenuBarAction->isChecked());
-	}
-}
-
-
-void MainWindow::loadConfig() {
-	d->mDirModel->setBlackListedExtensions(GwenviewConfig::blackListedExtensions());
-	MimeTypeUtils::Kinds kind = d->mDirModel->kindFilter();
-	d->mDirModel->adjustKindFilter(MimeTypeUtils::KIND_VIDEO, GwenviewConfig::listVideos());
-
-	d->mDocumentPanel->loadConfig();
-	d->mThumbnailViewPanel->loadConfig();
-
-	// Colors
-	int value = GwenviewConfig::viewBackgroundValue();
-	QColor bgColor = QColor::fromHsv(0, 0, value);
-	QColor fgColor = value > 128 ? Qt::black : Qt::white;
-
-	QPalette pal = palette();
-	pal.setColor(QPalette::Base, bgColor);
-	pal.setColor(QPalette::Text, fgColor);
-
-	// Apply to widgets
-	d->mThumbnailViewPanel->applyPalette(pal);
-	d->mStartPage->applyPalette(pal);
-	d->mDocumentPanel->setNormalPalette(pal);
-
-	// FIXME: Should we avoid CSS here to get a more native look?
-	d->mSideBarCollapser->setAutoFillBackground(true);
-	d->mSideBarCollapser->setStyleSheet(
-		"	background-color: palette(window);"
-		"	border: 1px solid palette(mid);"
-		"	border-radius: 5px;"
-		);
-}
-
-
-void MainWindow::saveConfig() {
-	d->mDocumentPanel->saveConfig();
-	d->mThumbnailViewPanel->saveConfig();
-}
-
-
-void MainWindow::print() {
-	if (!currentDocumentIsRasterImage()) {
-		return;
-	}
-
-	Document::Ptr doc = DocumentFactory::instance()->load(d->currentUrl());
-	PrintHelper printHelper(this);
-	printHelper.print(doc);
-}
-
-
-void MainWindow::preloadNextUrl() {
-	static bool disablePreload = qgetenv("GWENVIEW_MAX_UNREFERENCED_IMAGES") == "0";
-	if (disablePreload) {
-		kDebug() << "Preloading disabled";
-		return;
-	}
-	QItemSelection selection = d->mThumbnailView->selectionModel()->selection();
-	if (selection.size() != 1) {
-		return;
-	}
-
-	QModelIndex index = selection.indexes()[0];
-	if (!index.isValid()) {
-		return;
-	}
-
-	if (d->mCurrentPageId == ViewPageId) {
-		// If we are in view mode, preload the next url, otherwise preload the
-		// selected one
-		index = d->mDirModel->sibling(index.row() + 1, index.column(), index);
-		if (!index.isValid()) {
-			return;
-		}
-	}
-
-	KFileItem item = d->mDirModel->itemForIndex(index);
-	if (!ArchiveUtils::fileItemIsDirOrArchive(item)) {
-		KUrl url = item.url();
-		if (url.isLocalFile()) {
-			QSize size = d->mViewStackedWidget->size();
-			d->mPreloader->preload(url, size);
-		}
-	}
-}
-
-
-QSize MainWindow::sizeHint() const {
-	return KXmlGuiWindow::sizeHint().expandedTo(QSize(750, 500));
-}
-
-
-void MainWindow::showEvent(QShowEvent *event) {
-	// We need to delay initializing the action state until the menu bar has
-	// been initialized, that's why it's done only in the showEvent()
-	d->mShowMenuBarAction->setChecked(menuBar()->isVisible());
-	KXmlGuiWindow::showEvent(event);
-}
-
-
-void MainWindow::resizeEvent(QResizeEvent* event) {
-	KXmlGuiWindow::resizeEvent(event);
-	// This is a small hack to execute code after leaving fullscreen, and after
-	// the window has been resized back to its former size.
-	if (d->mFullScreenLeftAt.isValid() && d->mFullScreenLeftAt.secsTo(QDateTime::currentDateTime()) < 2) {
-		if (d->mCurrentPageId == BrowsePageId) {
-			d->mThumbnailView->scrollToSelectedIndex();
-		}
-		d->mFullScreenLeftAt = QDateTime();
-	}
-}
-
-
-void MainWindow::setDistractionFreeMode(bool value) {
-	d->mDistractionFreeMode = value;
-	d->updateDistractionsState();
-}
-
-
-void MainWindow::showMessageBubble(MessageBubble* bubble) {
-	WidgetFloater* floater = new WidgetFloater(d->mContentWidget);
-	floater->setChildWidget(bubble);
-	floater->setAlignment(Qt::AlignHCenter | Qt::AlignTop);
-	bubble->show();
-}
-
-
-void MainWindow::saveProperties(KConfigGroup& group) {
-	group.writeEntry(SESSION_CURRENT_PAGE_KEY, int(d->mCurrentPageId));
-	group.writeEntry(SESSION_URL_KEY, d->currentUrl());
-}
-
-
-void MainWindow::readProperties(const KConfigGroup& group) {
-	PageId pageId = PageId(group.readEntry(SESSION_CURRENT_PAGE_KEY, int(StartPageId)));
-	if (pageId == StartPageId) {
-		d->mCurrentPageId = StartPageId;
-		showStartPage();
-	} else if (pageId == BrowsePageId) {
-		d->mBrowseAction->trigger();
-	} else {
-		d->mViewAction->trigger();
-	}
-	KUrl url = group.readEntry(SESSION_URL_KEY, KUrl());
-	if (!url.isValid()) {
-		kWarning() << "Invalid url!";
-		return;
-	}
-	goToUrl(url);
-}
-
+    setAutoSaveSettings();
+}
+
+MainWindow::~MainWindow()
+{
+    delete d;
+}
+
+ContextManager* MainWindow::contextManager() const
+{
+    return d->mContextManager;
+}
+
+ViewMainPage* MainWindow::documentPanel() const
+{
+    return d->mViewMainPage;
+}
+
+bool MainWindow::currentDocumentIsRasterImage() const
+{
+    if (d->mCurrentMainPageId == ViewMainPageId) {
+        Document::Ptr doc = d->mViewMainPage->currentDocument();
+        if (!doc) {
+            return false;
+        }
+        return doc->kind() == MimeTypeUtils::KIND_RASTER_IMAGE;
+    } else {
+        QModelIndex index = d->mThumbnailView->currentIndex();
+        if (!index.isValid()) {
+            return false;
+        }
+        KFileItem item = d->mDirModel->itemForIndex(index);
+        Q_ASSERT(!item.isNull());
+        return MimeTypeUtils::fileItemKind(item) == MimeTypeUtils::KIND_RASTER_IMAGE;
+    }
+}
+
+void MainWindow::setCaption(const QString& caption)
+{
+    // Keep a trace of caption to use it in slotModifiedDocumentListChanged()
+    d->mCaption = caption;
+    KXmlGuiWindow::setCaption(caption);
+}
+
+void MainWindow::setCaption(const QString& caption, bool modified)
+{
+    d->mCaption = caption;
+    KXmlGuiWindow::setCaption(caption, modified);
+}
+
+void MainWindow::slotModifiedDocumentListChanged()
+{
+    d->updateActions();
+
+    // Update caption
+    QList<KUrl> list = DocumentFactory::instance()->modifiedDocumentList();
+    bool modified = list.count() > 0;
+    setCaption(d->mCaption, modified);
+}
+
+void MainWindow::setInitialUrl(const KUrl& _url)
+{
+    Q_ASSERT(_url.isValid());
+    KUrl url = UrlUtils::fixUserEnteredUrl(_url);
+    if (url.protocol() == "http" || url.protocol() == "https") {
+        d->mGvCore->addUrlToRecentUrls(url);
+    }
+    if (UrlUtils::urlIsDirectory(url)) {
+        d->mBrowseAction->trigger();
+        openDirUrl(url);
+    } else {
+        d->mViewAction->trigger();
+        d->mViewMainPage->openUrl(url);
+        d->setUrlToSelect(url);
+    }
+    d->updateContextDependentComponents();
+}
+
+void MainWindow::startSlideShow()
+{
+    // We need to wait until we have listed all images in the dirlister to
+    // start the slideshow because the SlideShow objects needs an image list to
+    // work.
+    d->mStartSlideShowWhenDirListerCompleted = true;
+}
+
+void MainWindow::setActiveViewModeAction(QAction* action)
+{
+    if (d->mCurrentMainPageId != StartMainPageId) {
+        d->saveSideBarConfig();
+    }
+    if (action == d->mViewAction) {
+        d->mCurrentMainPageId = ViewMainPageId;
+        // Switching to view mode
+        d->setDirModelShowDirs(false);
+        d->mViewStackedWidget->setCurrentWidget(d->mViewMainPage);
+        d->mContextManager->setOnlyCurrentUrl(true);
+        if (d->mViewMainPage->isEmpty()) {
+            openSelectedDocuments();
+        }
+    } else {
+        d->mCurrentMainPageId = BrowseMainPageId;
+        // Switching to browse mode
+        d->mViewStackedWidget->setCurrentWidget(d->mBrowseMainPage);
+        if (!d->mViewMainPage->isEmpty()
+                && KProtocolManager::supportsListing(d->mViewMainPage->url())) {
+            // Reset the view to spare resources, but don't do it if we can't
+            // browse the url, otherwise if the user starts Gwenview this way:
+            // gwenview http://example.com/example.png
+            // and switch to browse mode, switching back to view mode won't bring
+            // his image back.
+            d->mViewMainPage->reset();
+        }
+        d->setDirModelShowDirs(true);
+        setCaption(QString());
+        d->mContextManager->setOnlyCurrentUrl(false);
+    }
+    d->loadSideBarConfig();
+
+    emit viewModeChanged();
+}
+
+void MainWindow::slotThumbnailViewIndexActivated(const QModelIndex& index)
+{
+    if (!index.isValid()) {
+        return;
+    }
+
+    KFileItem item = d->mDirModel->itemForIndex(index);
+    if (item.isDir()) {
+        // Item is a dir, open it
+        openDirUrl(item.url());
+    } else {
+        QString protocol = ArchiveUtils::protocolForMimeType(item.mimetype());
+        if (!protocol.isEmpty()) {
+            // Item is an archive, tweak url then open it
+            KUrl url = item.url();
+            url.setProtocol(protocol);
+            openDirUrl(url);
+        } else {
+            // Item is a document, switch to view mode
+            d->mViewAction->trigger();
+        }
+    }
+}
+
+void MainWindow::openSelectedDocuments()
+{
+    if (d->mCurrentMainPageId != ViewMainPageId) {
+        return;
+    }
+
+    QModelIndex currentIndex = d->mThumbnailView->currentIndex();
+    if (!currentIndex.isValid()) {
+        return;
+    }
+
+    int count = 0;
+
+    KUrl::List urls;
+    KUrl currentUrl;
+    QModelIndex firstDocumentIndex;
+    Q_FOREACH(const QModelIndex & index, d->mThumbnailView->selectionModel()->selectedIndexes()) {
+        KFileItem item = d->mDirModel->itemForIndex(index);
+        if (!item.isNull() && !ArchiveUtils::fileItemIsDirOrArchive(item)) {
+            KUrl url = item.url();
+            if (!firstDocumentIndex.isValid()) {
+                firstDocumentIndex = index;
+            }
+            urls << url;
+            if (index == currentIndex) {
+                currentUrl = url;
+            }
+            ++count;
+            if (count == ViewMainPage::MaxViewCount) {
+                break;
+            }
+        }
+    }
+    if (urls.isEmpty()) {
+        // No image to display
+        return;
+    }
+    if (currentUrl.isEmpty()) {
+        // Current index is not selected, or it is not a document: set
+        // firstDocumentIndex as current
+        if (!firstDocumentIndex.isValid()) {
+            kWarning() << "firstDocumentIndex is invalid. This should not happen!";
+            return;
+        }
+        d->mThumbnailView->selectionModel()->setCurrentIndex(firstDocumentIndex, QItemSelectionModel::Current);
+        currentUrl = urls.first();
+    }
+
+    d->mViewMainPage->openUrls(urls, currentUrl);
+}
+
+void MainWindow::goUp()
+{
+    if (d->mCurrentMainPageId == BrowseMainPageId) {
+        KUrl url = d->mDirModel->dirLister()->url();
+        url = url.upUrl();
+        openDirUrl(url);
+    } else {
+        d->mBrowseAction->trigger();
+    }
+}
+
+void MainWindow::showStartMainPage()
+{
+    if (d->mCurrentMainPageId != StartMainPageId) {
+        d->saveSideBarConfig();
+        d->mCurrentMainPageId = StartMainPageId;
+    }
+    d->setActionsDisabledOnStartMainPageEnabled(false);
+    d->spreadCurrentDirUrl(KUrl());
+
+    d->mSideBar->hide();
+    d->mViewStackedWidget->setCurrentWidget(d->mStartMainPage);
+
+    d->updateActions();
+    updatePreviousNextActions();
+    d->updateContextDependentComponents();
+}
+
+void MainWindow::slotStartMainPageUrlSelected(const KUrl& url)
+{
+    d->setActionsDisabledOnStartMainPageEnabled(true);
+
+    if (d->mBrowseAction->isChecked()) {
+        // Silently uncheck the action so that setInitialUrl() does the right thing
+        SignalBlocker blocker(d->mBrowseAction);
+        d->mBrowseAction->setChecked(false);
+    }
+
+    setInitialUrl(url);
+}
+
+void MainWindow::openDirUrl(const KUrl& url)
+{
+    const KUrl currentUrl = d->mContextManager->currentDirUrl();
+
+    if (url.equals(currentUrl, KUrl::CompareWithoutTrailingSlash)) {
+        return;
+    }
+
+    if (url.isParentOf(currentUrl)) {
+        // Keep first child between url and currentUrl selected
+        // If currentPath is      "/home/user/photos/2008/event"
+        // and wantedPath is      "/home/user/photos"
+        // pathToSelect should be "/home/user/photos/2008"
+        const QString currentPath = QDir::cleanPath(currentUrl.toLocalFile(KUrl::RemoveTrailingSlash));
+        const QString wantedPath  = QDir::cleanPath(url.toLocalFile(KUrl::RemoveTrailingSlash));
+        const QChar separator('/');
+        const int slashCount = wantedPath.count(separator);
+        const QString pathToSelect = currentPath.section(separator, 0, slashCount + 1);
+        KUrl urlToSelect = url;
+        urlToSelect.setPath(pathToSelect);
+        d->setUrlToSelect(urlToSelect);
+    }
+    d->mDirModel->dirLister()->openUrl(url);
+    d->spreadCurrentDirUrl(url);
+    d->mViewMainPage->reset();
+}
+
+void MainWindow::toggleSideBar(bool on)
+{
+    d->mSideBar->setVisible(on);
+}
+
+void MainWindow::updateToggleSideBarAction()
+{
+    SignalBlocker blocker(d->mToggleSideBarAction);
+    bool visible = d->mSideBar->isVisible();
+    d->mToggleSideBarAction->setChecked(visible);
+
+    QString text = QString::fromUtf8(visible ? "▮←" : "▮→");
+    QString toolTip = visible ? i18n("Hide Sidebar") : i18n("Show Sidebar");
+
+    QList<QToolButton*> lst;
+    lst << d->mBrowseMainPage->toggleSideBarButton()
+        << d->mViewMainPage->toggleSideBarButton();
+    Q_FOREACH(QToolButton * button, lst) {
+        button->setText(text);
+        button->setToolTip(toolTip);
+    }
+}
+
+void MainWindow::slotPartCompleted()
+{
+    d->updateActions();
+    KUrl url = d->mViewMainPage->url();
+    if (!KProtocolManager::supportsListing(url)) {
+        return;
+    }
+
+    KUrl dirUrl = url;
+    dirUrl.setFileName(QString());
+    if (dirUrl.equals(d->mDirModel->dirLister()->url(), KUrl::CompareWithoutTrailingSlash)) {
+        QModelIndex index = d->mDirModel->indexForUrl(url);
+        QItemSelectionModel* selectionModel = d->mThumbnailView->selectionModel();
+        if (index.isValid() && !selectionModel->isSelected(index)) {
+            // FIXME: QGV Reactivating this line prevents navigation to prev/next image
+            //selectionModel->select(index, QItemSelectionModel::SelectCurrent);
+        }
+    } else {
+        d->mDirModel->dirLister()->openUrl(dirUrl);
+        d->spreadCurrentDirUrl(dirUrl);
+    }
+}
+
+void MainWindow::slotSelectionChanged()
+{
+    if (d->mCurrentMainPageId == ViewMainPageId) {
+        // The user selected a new file in the thumbnail view, since the
+        // document view is visible, let's show it
+        openSelectedDocuments();
+    } else {
+        // No document view, we need to load the document to set the undo group
+        // of document factory to the correct QUndoStack
+        QModelIndex index = d->mThumbnailView->currentIndex();
+        KFileItem item;
+        if (index.isValid()) {
+            item = d->mDirModel->itemForIndex(index);
+        }
+        QUndoGroup* undoGroup = DocumentFactory::instance()->undoGroup();
+        if (!item.isNull() && !ArchiveUtils::fileItemIsDirOrArchive(item)) {
+            KUrl url = item.url();
+            Document::Ptr doc = DocumentFactory::instance()->load(url);
+            undoGroup->addStack(doc->undoStack());
+            undoGroup->setActiveStack(doc->undoStack());
+        } else {
+            undoGroup->setActiveStack(0);
+        }
+    }
+
+    // Update UI
+    d->updateActions();
+    updatePreviousNextActions();
+    d->updateContextDependentComponents();
+
+    // Start preloading
+    QTimer::singleShot(PRELOAD_DELAY, this, SLOT(preloadNextUrl()));
+}
+
+void MainWindow::slotDirModelNewItems()
+{
+    if (d->mUrlToSelect.isValid()) {
+        d->selectUrlToSelect();
+    }
+    if (d->mThumbnailView->selectionModel()->hasSelection()) {
+        updatePreviousNextActions();
+    }
+}
+
+void MainWindow::slotDirListerCompleted()
+{
+    if (d->mStartSlideShowWhenDirListerCompleted) {
+        d->mStartSlideShowWhenDirListerCompleted = false;
+        QTimer::singleShot(0, d->mToggleSlideShowAction, SLOT(trigger()));
+    }
+    if (d->mThumbnailView->selectionModel()->hasSelection()) {
+        updatePreviousNextActions();
+    } else if (!d->mUrlToSelect.isValid()) {
+        d->goToFirstDocument();
+    }
+}
+
+void MainWindow::goToPrevious()
+{
+    d->goTo(-1);
+}
+
+void MainWindow::goToNext()
+{
+    d->goTo(1);
+}
+
+void MainWindow::goToFirst()
+{
+    d->goToFirstDocument();
+}
+
+void MainWindow::goToLast()
+{
+    d->goToLastDocument();
+}
+
+void MainWindow::goToUrl(const KUrl& url)
+{
+    if (d->mCurrentMainPageId == ViewMainPageId) {
+        d->mViewMainPage->openUrl(url);
+    }
+    KUrl dirUrl = url;
+    dirUrl.setFileName("");
+    if (!dirUrl.equals(d->mContextManager->currentDirUrl(), KUrl::CompareWithoutTrailingSlash)) {
+        d->mDirModel->dirLister()->openUrl(dirUrl);
+        d->spreadCurrentDirUrl(dirUrl);
+    }
+    d->setUrlToSelect(url);
+}
+
+void MainWindow::updatePreviousNextActions()
+{
+    QModelIndex index = d->currentIndex();
+
+    QModelIndex prevIndex = d->mDirModel->index(index.row() - 1, 0);
+    d->mGoToPreviousAction->setEnabled(prevIndex.isValid() && !d->indexIsDirOrArchive(prevIndex));
+    d->mGoToFirstAction->setEnabled(d->mGoToPreviousAction->isEnabled());
+
+    QModelIndex nextIndex = d->mDirModel->index(index.row() + 1, 0);
+    d->mGoToNextAction->setEnabled(nextIndex.isValid() && !d->indexIsDirOrArchive(nextIndex));
+    d->mGoToLastAction->setEnabled(d->mGoToNextAction->isEnabled());
+}
+
+void MainWindow::reduceLevelOfDetails()
+{
+    if (d->mFullScreenAction->isChecked()) {
+        d->mFullScreenAction->trigger();
+    } else if (d->mCurrentMainPageId == ViewMainPageId) {
+        d->mBrowseAction->trigger();
+    } else {
+        showStartMainPage();
+    }
+}
+
+void MainWindow::toggleFullScreen(bool checked)
+{
+    setUpdatesEnabled(false);
+    d->saveSideBarConfig();
+    if (checked) {
+        // Save MainWindow config now, this way if we quit while in
+        // fullscreen, we are sure latest MainWindow changes are remembered.
+        saveMainWindowSettings(autoSaveConfigGroup());
+        resetAutoSaveSettings();
+
+        // Save state
+        d->mStateBeforeFullScreen.mMainPageId = d->mCurrentMainPageId;
+        d->mStateBeforeFullScreen.mToolBarVisible = toolBar()->isVisible();
+        d->mStateBeforeFullScreen.mWindowState = windowState();
+
+        // Go full screen
+        d->mViewAction->trigger();
+
+        setWindowState(windowState() | Qt::WindowFullScreen);
+        menuBar()->hide();
+        toolBar()->hide();
+        d->mViewMainPage->setFullScreenMode(true);
+        d->mSaveBar->setFullScreenMode(true);
+        d->updateDistractionsState();
+        d->setScreenSaverEnabled(false);
+
+        // HACK: Only load sidebar config now, because it looks at
+        // ViewMainPage fullScreenMode property to determine the sidebar
+        // config group.
+        d->loadSideBarConfig();
+    } else {
+        setAutoSaveSettings();
+
+        // Back to normal
+        d->mCurrentMainPageId = d->mStateBeforeFullScreen.mMainPageId;
+        if (d->mCurrentMainPageId == BrowseMainPageId) {
+            d->mBrowseAction->trigger();
+        }
+
+        d->mViewMainPage->setFullScreenMode(false);
+        d->mSlideShow->stop();
+        d->mSaveBar->setFullScreenMode(false);
+        setWindowState(d->mStateBeforeFullScreen.mWindowState);
+        menuBar()->setVisible(d->mShowMenuBarAction->isChecked());
+        toolBar()->setVisible(d->mStateBeforeFullScreen.mToolBarVisible);
+
+        d->updateDistractionsState();
+        d->setScreenSaverEnabled(true);
+
+        // Keep this after mViewMainPage->setFullScreenMode(false).
+        // See call to loadSideBarConfig() above.
+        d->loadSideBarConfig();
+
+        // See resizeEvent
+        d->mFullScreenLeftAt = QDateTime::currentDateTime();
+    }
+    setUpdatesEnabled(true);
+}
+
+void MainWindow::saveCurrent()
+{
+    d->mGvCore->save(d->currentUrl());
+}
+
+void MainWindow::saveCurrentAs()
+{
+    d->mGvCore->saveAs(d->currentUrl());
+}
+
+void MainWindow::reload()
+{
+    if (d->mCurrentMainPageId == ViewMainPageId) {
+        d->mViewMainPage->reload();
+    } else {
+        d->mBrowseMainPage->reload();
+    }
+}
+
+void MainWindow::openFile()
+{
+    KUrl dirUrl = d->mDirModel->dirLister()->url();
+
+    KFileDialog dialog(dirUrl, QString(), this);
+    dialog.setCaption(i18nc("@title:window", "Open Image"));
+    const QStringList mimeFilter = MimeTypeUtils::imageMimeTypes();
+    dialog.setMimeFilter(mimeFilter);
+    dialog.setOperationMode(KFileDialog::Opening);
+    if (!dialog.exec()) {
+        return;
+    }
+
+    d->setActionsDisabledOnStartMainPageEnabled(true);
+    KUrl url = dialog.selectedUrl();
+    d->mViewAction->trigger();
+    d->mViewMainPage->openUrl(url);
+    d->setUrlToSelect(url);
+    d->updateContextDependentComponents();
+}
+
+void MainWindow::showDocumentInFullScreen(const KUrl& url)
+{
+    d->mViewMainPage->openUrl(url);
+    d->setUrlToSelect(url);
+    d->mFullScreenAction->trigger();
+}
+
+void MainWindow::toggleSlideShow()
+{
+    if (d->mSlideShow->isRunning()) {
+        d->mSlideShow->stop();
+    } else {
+        if (!d->mFullScreenAction->isChecked()) {
+            d->mFullScreenAction->trigger();
+        }
+        QList<KUrl> list;
+        for (int pos = 0; pos < d->mDirModel->rowCount(); ++pos) {
+            QModelIndex index = d->mDirModel->index(pos, 0);
+            KFileItem item = d->mDirModel->itemForIndex(index);
+            MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
+            switch (kind) {
+            case MimeTypeUtils::KIND_SVG_IMAGE:
+            case MimeTypeUtils::KIND_RASTER_IMAGE:
+            case MimeTypeUtils::KIND_VIDEO:
+                list << item.url();
+                break;
+            default:
+                break;
+            }
+        }
+        d->mSlideShow->start(list);
+    }
+    updateSlideShowAction();
+}
+
+void MainWindow::updateSlideShowAction()
+{
+    if (d->mSlideShow->isRunning()) {
+        d->mToggleSlideShowAction->setText(i18n("Stop Slideshow"));
+        d->mToggleSlideShowAction->setIcon(KIcon("media-playback-pause"));
+    } else {
+        d->mToggleSlideShowAction->setText(i18n("Start Slideshow"));
+        d->mToggleSlideShowAction->setIcon(KIcon("media-playback-start"));
+    }
+}
+
+bool MainWindow::queryClose()
+{
+    saveConfig();
+    d->saveSideBarConfig();
+    QList<KUrl> list = DocumentFactory::instance()->modifiedDocumentList();
+    if (list.size() == 0) {
+        return true;
+    }
+
+    KGuiItem yes(i18n("Save All Changes"), "document-save-all");
+    KGuiItem no(i18n("Discard Changes"));
+    QString msg = i18np("One image has been modified.", "%1 images have been modified.", list.size())
+                  + '\n'
+                  + i18n("If you quit now, your changes will be lost.");
+    int answer = KMessageBox::warningYesNoCancel(
+                     this,
+                     msg,
+                     QString() /* caption */,
+                     yes,
+                     no);
+
+    switch (answer) {
+    case KMessageBox::Yes:
+        d->mGvCore->saveAll();
+        // We need to wait a bit because the DocumentFactory is notified about
+        // saved documents through a queued connection.
+        qApp->processEvents();
+        return DocumentFactory::instance()->modifiedDocumentList().isEmpty();
+
+    case KMessageBox::No:
+        return true;
+
+    default: // cancel
+        return false;
+    }
+}
+
+bool MainWindow::queryExit()
+{
+    if (GwenviewConfig::deleteThumbnailCacheOnExit()) {
+        const QString dir = ThumbnailLoadJob::thumbnailBaseDir();
+        if (QFile::exists(dir)) {
+            KIO::NetAccess::del(KUrl::fromPath(dir), this);
+        }
+    }
+    return true;
+}
+
+void MainWindow::showConfigDialog()
+{
+    ConfigDialog dialog(this);
+    connect(&dialog, SIGNAL(settingsChanged(QString)), SLOT(loadConfig()));
+    dialog.exec();
+}
+
+void MainWindow::toggleMenuBar()
+{
+    if (!d->mFullScreenAction->isChecked()) {
+        menuBar()->setVisible(d->mShowMenuBarAction->isChecked());
+    }
+}
+
+void MainWindow::loadConfig()
+{
+    d->mDirModel->setBlackListedExtensions(GwenviewConfig::blackListedExtensions());
+    d->mDirModel->adjustKindFilter(MimeTypeUtils::KIND_VIDEO, GwenviewConfig::listVideos());
+
+    d->mViewMainPage->loadConfig();
+    d->mBrowseMainPage->loadConfig();
+
+    // Colors
+    int value = GwenviewConfig::viewBackgroundValue();
+    QColor bgColor = QColor::fromHsv(0, 0, value);
+    QColor fgColor = value > 128 ? Qt::black : Qt::white;
+
+    QPalette pal = palette();
+    pal.setColor(QPalette::Base, bgColor);
+    pal.setColor(QPalette::Text, fgColor);
+
+    // Apply to widgets
+    d->mBrowseMainPage->applyPalette(pal);
+    d->mStartMainPage->applyPalette(pal);
+    d->mViewMainPage->setNormalPalette(pal);
+}
+
+void MainWindow::saveConfig()
+{
+    d->mViewMainPage->saveConfig();
+    d->mBrowseMainPage->saveConfig();
+}
+
+void MainWindow::print()
+{
+    if (!currentDocumentIsRasterImage()) {
+        return;
+    }
+
+    Document::Ptr doc = DocumentFactory::instance()->load(d->currentUrl());
+    PrintHelper printHelper(this);
+    printHelper.print(doc);
+}
+
+void MainWindow::preloadNextUrl()
+{
+    static bool disablePreload = qgetenv("GWENVIEW_MAX_UNREFERENCED_IMAGES") == "0";
+    if (disablePreload) {
+        kDebug() << "Preloading disabled";
+        return;
+    }
+    QItemSelection selection = d->mThumbnailView->selectionModel()->selection();
+    if (selection.size() != 1) {
+        return;
+    }
+
+    QModelIndex index = selection.indexes()[0];
+    if (!index.isValid()) {
+        return;
+    }
+
+    if (d->mCurrentMainPageId == ViewMainPageId) {
+        // If we are in view mode, preload the next url, otherwise preload the
+        // selected one
+        index = d->mDirModel->sibling(index.row() + 1, index.column(), index);
+        if (!index.isValid()) {
+            return;
+        }
+    }
+
+    KFileItem item = d->mDirModel->itemForIndex(index);
+    if (!ArchiveUtils::fileItemIsDirOrArchive(item)) {
+        KUrl url = item.url();
+        if (url.isLocalFile()) {
+            QSize size = d->mViewStackedWidget->size();
+            d->mPreloader->preload(url, size);
+        }
+    }
+}
+
+QSize MainWindow::sizeHint() const
+{
+    return KXmlGuiWindow::sizeHint().expandedTo(QSize(750, 500));
+}
+
+void MainWindow::showEvent(QShowEvent *event)
+{
+    // We need to delay initializing the action state until the menu bar has
+    // been initialized, that's why it's done only in the showEvent()
+    d->mShowMenuBarAction->setChecked(menuBar()->isVisible());
+    KXmlGuiWindow::showEvent(event);
+}
+
+void MainWindow::resizeEvent(QResizeEvent* event)
+{
+    KXmlGuiWindow::resizeEvent(event);
+    // This is a small hack to execute code after leaving fullscreen, and after
+    // the window has been resized back to its former size.
+    if (d->mFullScreenLeftAt.isValid() && d->mFullScreenLeftAt.secsTo(QDateTime::currentDateTime()) < 2) {
+        if (d->mCurrentMainPageId == BrowseMainPageId) {
+            d->mThumbnailView->scrollToSelectedIndex();
+        }
+        d->mFullScreenLeftAt = QDateTime();
+    }
+}
+
+void MainWindow::setDistractionFreeMode(bool value)
+{
+    d->mDistractionFreeMode = value;
+    d->updateDistractionsState();
+}
+
+void MainWindow::showMessageBubble(MessageBubble* bubble)
+{
+    WidgetFloater* floater = new WidgetFloater(d->mContentWidget);
+    floater->setChildWidget(bubble);
+    floater->setAlignment(Qt::AlignHCenter | Qt::AlignTop);
+    bubble->show();
+}
+
+void MainWindow::saveProperties(KConfigGroup& group)
+{
+    group.writeEntry(SESSION_CURRENT_PAGE_KEY, int(d->mCurrentMainPageId));
+    group.writeEntry(SESSION_URL_KEY, d->currentUrl());
+}
+
+void MainWindow::readProperties(const KConfigGroup& group)
+{
+    MainPageId pageId = MainPageId(group.readEntry(SESSION_CURRENT_PAGE_KEY, int(StartMainPageId)));
+    if (pageId == StartMainPageId) {
+        d->mCurrentMainPageId = StartMainPageId;
+        showStartMainPage();
+    } else if (pageId == BrowseMainPageId) {
+        d->mBrowseAction->trigger();
+    } else {
+        d->mViewAction->trigger();
+    }
+    KUrl url = group.readEntry(SESSION_URL_KEY, KUrl());
+    if (!url.isValid()) {
+        kWarning() << "Invalid url!";
+        return;
+    }
+    goToUrl(url);
+}
 
 } // namespace

=== modified file 'app/mainwindow.h'
--- app/mainwindow.h	2011-07-20 13:46:34 +0000
+++ app/mainwindow.h	2011-12-15 14:17:54 +0000
@@ -30,124 +30,126 @@
 
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-class DocumentPanel;
+class ViewMainPage;
 class ContextManager;
 class MessageBubble;
 
-class MainWindow : public KXmlGuiWindow {
-Q_OBJECT
+class MainWindow : public KXmlGuiWindow
+{
+    Q_OBJECT
 public:
-	MainWindow();
-	~MainWindow();
-	/**
-	 * Defines the url to display when the window is shown for the first time.
-	 */
-	void setInitialUrl(const KUrl&);
-
-	void startSlideShow();
-
-	DocumentPanel* documentPanel() const;
-
-	ContextManager* contextManager() const;
-
-	bool currentDocumentIsRasterImage() const;
-
-	void setDistractionFreeMode(bool);
-
-	void showMessageBubble(MessageBubble*);
+    MainWindow();
+    ~MainWindow();
+    /**
+     * Defines the url to display when the window is shown for the first time.
+     */
+    void setInitialUrl(const KUrl&);
+
+    void startSlideShow();
+
+    ViewMainPage* documentPanel() const;
+
+    ContextManager* contextManager() const;
+
+    bool currentDocumentIsRasterImage() const;
+
+    void setDistractionFreeMode(bool);
+
+    void showMessageBubble(MessageBubble*);
 
 public Q_SLOTS:
-	void showStartPage();
+    void showStartMainPage();
 
-	/**
-	 * Go to url, without changing current mode
-	 */
-	void goToUrl(const KUrl&);
+    /**
+     * Go to url, without changing current mode
+     */
+    void goToUrl(const KUrl&);
 
 Q_SIGNALS:
-	void viewModeChanged();
+    void viewModeChanged();
 
 public Q_SLOTS:
-	virtual void setCaption(const QString&);
+    virtual void setCaption(const QString&);
 
-	virtual void setCaption(const QString&, bool modified);
+    virtual void setCaption(const QString&, bool modified);
 
 protected:
-	virtual bool queryClose();
-	virtual bool queryExit();
-	virtual QSize sizeHint() const;
-	virtual void showEvent(QShowEvent*);
-	virtual void resizeEvent(QResizeEvent*);
-	virtual void saveProperties(KConfigGroup&);
-	virtual void readProperties(const KConfigGroup&);
+    virtual bool queryClose();
+    virtual bool queryExit();
+    virtual QSize sizeHint() const;
+    virtual void showEvent(QShowEvent*);
+    virtual void resizeEvent(QResizeEvent*);
+    virtual void saveProperties(KConfigGroup&);
+    virtual void readProperties(const KConfigGroup&);
 
 private Q_SLOTS:
-	void setActiveViewModeAction(QAction* action);
-	void openDirUrl(const KUrl&);
-	void slotThumbnailViewIndexActivated(const QModelIndex&);
-
-	void slotStartPageUrlSelected(const KUrl&);
-
-	void goUp();
-	void toggleSideBar(bool visible);
-	void updateToggleSideBarAction();
-	void slotModifiedDocumentListChanged();
-
-	/**
-	 * Init all the file list stuff. This should only be necessary when
-	 * Gwenview is started with an image as a parameter (in this case we load
-	 * the image before looking at the content of the image folder)
-	 */
-	void slotPartCompleted();
-	
-	/**
-	 * If an image is loaded but there is no item selected for it in the file
-	 * view, this function will select the corresponding item if it comes up in
-	 * list.
-	 */
-	void slotDirModelNewItems();
-
-	/**
-	 * If no image is selected, select the first one available.
-	 */
-	void slotDirListerCompleted();
-
-	void slotSelectionChanged();
-
-	void goToPrevious();
-	void goToNext();
-	void goToFirst();
-	void goToLast();
-	void updatePreviousNextActions();
-
-	void reduceLevelOfDetails();
-	void toggleFullScreen(bool);
-	void toggleSlideShow();
-	void updateSlideShowAction();
-
-	void saveCurrent();
-	void saveCurrentAs();
-	void openFile();
-	void reload();
-
-	void showDocumentInFullScreen(const KUrl&);
-
-	void showConfigDialog();
-	void loadConfig();
-	void print();
-
-	void preloadNextUrl();
-
-	void toggleMenuBar();
+    void setActiveViewModeAction(QAction* action);
+    void openDirUrl(const KUrl&);
+    void slotThumbnailViewIndexActivated(const QModelIndex&);
+
+    void slotStartMainPageUrlSelected(const KUrl&);
+
+    void goUp();
+    void toggleSideBar(bool visible);
+    void updateToggleSideBarAction();
+    void slotModifiedDocumentListChanged();
+
+    /**
+     * Init all the file list stuff. This should only be necessary when
+     * Gwenview is started with an image as a parameter (in this case we load
+     * the image before looking at the content of the image folder)
+     */
+    void slotPartCompleted();
+
+    /**
+     * If an image is loaded but there is no item selected for it in the file
+     * view, this function will select the corresponding item if it comes up in
+     * list.
+     */
+    void slotDirModelNewItems();
+
+    /**
+     * If no image is selected, select the first one available.
+     */
+    void slotDirListerCompleted();
+
+    void slotSelectionChanged();
+
+    void goToPrevious();
+    void goToNext();
+    void goToFirst();
+    void goToLast();
+    void updatePreviousNextActions();
+
+    void reduceLevelOfDetails();
+    void toggleFullScreen(bool);
+    void toggleSlideShow();
+    void updateSlideShowAction();
+
+    void saveCurrent();
+    void saveCurrentAs();
+    void openFile();
+    void reload();
+
+    void showDocumentInFullScreen(const KUrl&);
+
+    void showConfigDialog();
+    void loadConfig();
+    void print();
+
+    void preloadNextUrl();
+
+    void toggleMenuBar();
 
 private:
-	struct Private;
-	MainWindow::Private* const d;
+    struct Private;
+    MainWindow::Private* const d;
 
-	void openSelectedDocuments();
-	void saveConfig();
+    void openSelectedDocuments();
+    void saveConfig();
 };
 
 } // namespace

=== modified file 'app/preloader.cpp'
--- app/preloader.cpp	2011-07-20 13:46:34 +0000
+++ app/preloader.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,7 +29,8 @@
 // Local
 #include <lib/document/documentfactory.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -41,64 +42,63 @@
 #endif
 
 struct PreloaderPrivate {
-	Document::Ptr mDocument;
-	QSize mSize;
+    Document::Ptr mDocument;
+    QSize mSize;
 };
 
-
 Preloader::Preloader(QObject* parent)
 : QObject(parent)
-, d(new PreloaderPrivate) {
-}
-
-
-Preloader::~Preloader() {
-	delete d;
-}
-
-
-void Preloader::preload(const KUrl& url, const QSize& size) {
-	LOG("url=" << url);
-	if (d->mDocument) {
-		disconnect(d->mDocument.data(), 0, this, 0);
-	}
-
-	d->mDocument = DocumentFactory::instance()->load(url);
-	d->mSize = size;
-	connect(d->mDocument.data(), SIGNAL(metaInfoUpdated()),
-		SLOT(doPreload()) );
-
-	if (d->mDocument->size().isValid()) {
-		LOG("size is already available");
-		doPreload();
-	}
-}
-
-
-void Preloader::doPreload() {
-	if (!d->mDocument->size().isValid()) {
-		LOG("size not available yet");
-		return;
-	}
-
-	qreal zoom = qMin(
-		d->mSize.width() / qreal(d->mDocument->width()),
-		d->mSize.height() / qreal(d->mDocument->height())
-		);
-
-	if (zoom < Document::maxDownSampledZoom()) {
-		LOG("preloading down sampled, zoom=" << zoom);
-		d->mDocument->prepareDownSampledImageForZoom(zoom);
-	} else {
-		LOG("preloading full image");
-		d->mDocument->startLoadingFullImage();
-	}
-
-	// Forget about the document. Keeping a reference to it would prevent it
-	// from being garbage collected.
-	disconnect(d->mDocument.data(), 0, this, 0);
-	d->mDocument = 0;
-}
-
+, d(new PreloaderPrivate)
+{
+}
+
+Preloader::~Preloader()
+{
+    delete d;
+}
+
+void Preloader::preload(const KUrl& url, const QSize& size)
+{
+    LOG("url=" << url);
+    if (d->mDocument) {
+        disconnect(d->mDocument.data(), 0, this, 0);
+    }
+
+    d->mDocument = DocumentFactory::instance()->load(url);
+    d->mSize = size;
+    connect(d->mDocument.data(), SIGNAL(metaInfoUpdated()),
+            SLOT(doPreload()));
+
+    if (d->mDocument->size().isValid()) {
+        LOG("size is already available");
+        doPreload();
+    }
+}
+
+void Preloader::doPreload()
+{
+    if (!d->mDocument->size().isValid()) {
+        LOG("size not available yet");
+        return;
+    }
+
+    qreal zoom = qMin(
+                     d->mSize.width() / qreal(d->mDocument->width()),
+                     d->mSize.height() / qreal(d->mDocument->height())
+                 );
+
+    if (zoom < Document::maxDownSampledZoom()) {
+        LOG("preloading down sampled, zoom=" << zoom);
+        d->mDocument->prepareDownSampledImageForZoom(zoom);
+    } else {
+        LOG("preloading full image");
+        d->mDocument->startLoadingFullImage();
+    }
+
+    // Forget about the document. Keeping a reference to it would prevent it
+    // from being garbage collected.
+    disconnect(d->mDocument.data(), 0, this, 0);
+    d->mDocument = 0;
+}
 
 } // namespace

=== modified file 'app/preloader.h'
--- app/preloader.h	2011-07-20 13:46:34 +0000
+++ app/preloader.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,30 +32,30 @@
 
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class PreloaderPrivate;
 
 /**
  * This class preloads a document to fit a specific size.
  */
-class Preloader : public QObject {
-	Q_OBJECT
+class Preloader : public QObject
+{
+    Q_OBJECT
 public:
-	Preloader(QObject* parent);
-	~Preloader();
+    Preloader(QObject* parent);
+    ~Preloader();
 
-	void preload(const KUrl&, const QSize&);
+    void preload(const KUrl&, const QSize&);
 
 private Q_SLOTS:
-	void doPreload();
+    void doPreload();
 
 private:
-	PreloaderPrivate* const d;
+    PreloaderPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* PRELOADER_H */

=== modified file 'app/saveallhelper.cpp'
--- app/saveallhelper.cpp	2011-07-20 13:46:34 +0000
+++ app/saveallhelper.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -38,79 +38,77 @@
 #include <lib/document/documentfactory.h>
 #include <lib/document/documentjob.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct SaveAllHelperPrivate {
-	QWidget* mParent;
-	KProgressDialog* mProgressDialog;
-	QSet<DocumentJob*> mJobSet;
-	QStringList mErrorList;
+    QWidget* mParent;
+    KProgressDialog* mProgressDialog;
+    QSet<DocumentJob*> mJobSet;
+    QStringList mErrorList;
 };
 
-
 SaveAllHelper::SaveAllHelper(QWidget* parent)
-: d(new SaveAllHelperPrivate) {
-	d->mParent = parent;
-	d->mProgressDialog = new KProgressDialog(parent);
-	connect(d->mProgressDialog, SIGNAL(cancelClicked()), SLOT(slotCanceled()));
-	d->mProgressDialog->setLabelText(i18nc("@info:progress saving all image changes", "Saving..."));
-	d->mProgressDialog->setButtonText(i18n("&Stop"));
-	d->mProgressDialog->progressBar()->setMinimum(0);
-}
-
-
-SaveAllHelper::~SaveAllHelper() {
-	delete d;
-}
-
-
-void SaveAllHelper::save() {
-	KUrl::List list = DocumentFactory::instance()->modifiedDocumentList();
-	d->mProgressDialog->progressBar()->setRange(0, list.size());
-	d->mProgressDialog->progressBar()->setValue(0);
-	Q_FOREACH(const KUrl& url, list) {
-		Document::Ptr doc = DocumentFactory::instance()->load(url);
-		DocumentJob* job = doc->save(url, doc->format());
-		connect(job, SIGNAL(result(KJob*)), SLOT(slotResult(KJob*)));
-		d->mJobSet << job;
-	}
-
-	d->mProgressDialog->exec();
-
-	// Done, show message if necessary
-	if (d->mErrorList.count() > 0) {
-		QString msg = i18ncp("@info", "One document could not be saved:", "%1 documents could not be saved:", d->mErrorList.count());
-		msg += "<ul>";
-		Q_FOREACH(const QString& item, d->mErrorList) {
-			msg += "<li>" + item + "</li>";
-		}
-		msg += "</ul>";
-		KMessageBox::sorry(d->mParent, msg);
-	}
-}
-
-
-void SaveAllHelper::slotCanceled() {
-	Q_FOREACH(DocumentJob* job, d->mJobSet) {
-		job->kill();
-	}
-}
-
-
-void SaveAllHelper::slotResult(KJob* _job) {
-	DocumentJob* job = static_cast<DocumentJob*>(_job);
-	if (job->error()) {
-		KUrl url = job->document()->url();
-		QString name = url.fileName().isEmpty() ? url.pathOrUrl() : url.fileName();
-		d->mErrorList << i18nc("@info %1 is the name of the document which failed to save, %2 is the reason for the failure",
-			"<filename>%1</filename>: %2", name, job->errorString());
-	}
-	d->mJobSet.remove(job);
-	QProgressBar* bar = d->mProgressDialog->progressBar();
-	bar->setValue(bar->value() + 1);
-}
-
-
+: d(new SaveAllHelperPrivate)
+{
+    d->mParent = parent;
+    d->mProgressDialog = new KProgressDialog(parent);
+    connect(d->mProgressDialog, SIGNAL(cancelClicked()), SLOT(slotCanceled()));
+    d->mProgressDialog->setLabelText(i18nc("@info:progress saving all image changes", "Saving..."));
+    d->mProgressDialog->setButtonText(i18n("&Stop"));
+    d->mProgressDialog->progressBar()->setMinimum(0);
+}
+
+SaveAllHelper::~SaveAllHelper()
+{
+    delete d;
+}
+
+void SaveAllHelper::save()
+{
+    KUrl::List list = DocumentFactory::instance()->modifiedDocumentList();
+    d->mProgressDialog->progressBar()->setRange(0, list.size());
+    d->mProgressDialog->progressBar()->setValue(0);
+    Q_FOREACH(const KUrl & url, list) {
+        Document::Ptr doc = DocumentFactory::instance()->load(url);
+        DocumentJob* job = doc->save(url, doc->format());
+        connect(job, SIGNAL(result(KJob*)), SLOT(slotResult(KJob*)));
+        d->mJobSet << job;
+    }
+
+    d->mProgressDialog->exec();
+
+    // Done, show message if necessary
+    if (d->mErrorList.count() > 0) {
+        QString msg = i18ncp("@info", "One document could not be saved:", "%1 documents could not be saved:", d->mErrorList.count());
+        msg += "<ul>";
+        Q_FOREACH(const QString & item, d->mErrorList) {
+            msg += "<li>" + item + "</li>";
+        }
+        msg += "</ul>";
+        KMessageBox::sorry(d->mParent, msg);
+    }
+}
+
+void SaveAllHelper::slotCanceled()
+{
+    Q_FOREACH(DocumentJob * job, d->mJobSet) {
+        job->kill();
+    }
+}
+
+void SaveAllHelper::slotResult(KJob* _job)
+{
+    DocumentJob* job = static_cast<DocumentJob*>(_job);
+    if (job->error()) {
+        KUrl url = job->document()->url();
+        QString name = url.fileName().isEmpty() ? url.pathOrUrl() : url.fileName();
+        d->mErrorList << i18nc("@info %1 is the name of the document which failed to save, %2 is the reason for the failure",
+                               "<filename>%1</filename>: %2", name, job->errorString());
+    }
+    d->mJobSet.remove(job);
+    QProgressBar* bar = d->mProgressDialog->progressBar();
+    bar->setValue(bar->value() + 1);
+}
 
 } // namespace

=== modified file 'app/saveallhelper.h'
--- app/saveallhelper.h	2011-07-20 13:46:34 +0000
+++ app/saveallhelper.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -30,26 +30,27 @@
 
 class KJob;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class SaveAllHelperPrivate;
-class SaveAllHelper : public QObject {
-	Q_OBJECT
+class SaveAllHelper : public QObject
+{
+    Q_OBJECT
 public:
-	SaveAllHelper(QWidget* parent);
-	~SaveAllHelper();
+    SaveAllHelper(QWidget* parent);
+    ~SaveAllHelper();
 
-	void save();
+    void save();
 
 private Q_SLOTS:
-	void slotCanceled();
-	void slotResult(KJob*);
+    void slotCanceled();
+    void slotResult(KJob*);
 
 private:
-	SaveAllHelperPrivate* const d;
+    SaveAllHelperPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* SAVEALLHELPER_H */

=== modified file 'app/savebar.cpp'
--- app/savebar.cpp	2011-07-20 13:46:34 +0000
+++ app/savebar.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -42,338 +42,333 @@
 #include "lib/memoryutils.h"
 #include "lib/paintutils.h"
 
-namespace Gwenview {
-
-
-QToolButton* createToolButton() {
-	QToolButton* button = new QToolButton;
-	button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
-	button->hide();
-	return button;
+namespace Gwenview
+{
+
+QToolButton* createToolButton()
+{
+    QToolButton* button = new QToolButton;
+    button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
+    button->hide();
+    return button;
 }
 
-
 struct SaveBarPrivate {
-	SaveBar* that;
-	KActionCollection* mActionCollection;
-	QWidget* mSaveBarWidget;
-	QWidget* mTopRowWidget;
-	QToolButton* mUndoButton;
-	QToolButton* mRedoButton;
-	QToolButton* mSaveCurrentUrlButton;
-	QToolButton* mSaveAsButton;
-	QToolButton* mSaveAllButton;
-	QToolButton* mSaveAllFullScreenButton;
-	QLabel* mMessageLabel;
-	QLabel* mActionsLabel;
-	QFrame* mTooManyChangesFrame;
-	KUrl mCurrentUrl;
-	bool mFullScreenMode;
-
-	void createTooManyChangesFrame() {
-		mTooManyChangesFrame = new QFrame;
-
-		// Icon
-		QLabel* iconLabel = new QLabel;
-		QPixmap pix = KIconLoader::global()->loadIcon(
-			"dialog-warning", KIconLoader::Dialog, KIconLoader::SizeSmall);
-		iconLabel->setPixmap(pix);
-
-		// Text label
-		QLabel* textLabel = new QLabel;
-		textLabel->setText(
-			i18n("You have modified many images. To avoid memory problems, you should save your changes.")
-			);
-
-		mSaveAllFullScreenButton = createToolButton();
-
-		// Layout
-		QHBoxLayout* layout = new QHBoxLayout(mTooManyChangesFrame);
-		layout->setMargin(0);
-		layout->addWidget(iconLabel);
-		layout->addWidget(textLabel);
-		layout->addWidget(mSaveAllFullScreenButton);
-		mTooManyChangesFrame->hide();
-
-		// CSS
-		KColorScheme scheme(mSaveBarWidget->palette().currentColorGroup(), KColorScheme::Window);
-		QColor warningBackgroundColor = scheme.background(KColorScheme::NegativeBackground).color();
-		QColor warningBorderColor = PaintUtils::adjustedHsv(warningBackgroundColor, 0, 150, 0);
-		QColor warningColor = scheme.foreground(KColorScheme::NegativeText).color();
-
-		QString css =
-			".QFrame {"
-			"	background-color: %1;"
-			"	border: 1px solid %2;"
-			"	border-radius: 4px;"
-			"	padding: 3px;"
-			"}"
-			".QFrame QLabel {"
-			"	color: %3;"
-			"}"
-			;
-		css = css
-			.arg(warningBackgroundColor.name())
-			.arg(warningBorderColor.name())
-			.arg(warningColor.name())
-			;
-		mTooManyChangesFrame->setStyleSheet(css);
-	}
-
-	void applyNormalStyleSheet() {
-		QColor bgColor = QToolTip::palette().base().color();
-		QColor borderColor = PaintUtils::adjustedHsv(bgColor, 0, 150, 0);
-		QColor fgColor = QToolTip::palette().text().color();
-
-		QString css =
-			"#saveBarWidget {"
-			"	background-color: %1;"
-			"	border-top: 1px solid %2;"
-			"	border-bottom: 1px solid %2;"
-			"	color: %3;"
-			"}"
-			;
-
-		css = css
-			.arg(bgColor.name())
-			.arg(borderColor.name())
-			.arg(fgColor.name())
-			;
-		mSaveBarWidget->setStyleSheet(css);
-	}
-
-	void applyFullScreenStyleSheet() {
-		QString css =
-			"#saveBarWidget {"
-			"	background-color: #333;"
-			"}";
-		mSaveBarWidget->setStyleSheet(css);
-	}
-
-
-	void updateTooManyChangesFrame(const QList<KUrl>& list) {
-		qreal maxPercentageOfMemoryUsage = GwenviewConfig::percentageOfMemoryUsageWarning();
-		qulonglong maxMemoryUsage = MemoryUtils::getTotalMemory() * maxPercentageOfMemoryUsage;
-		qulonglong memoryUsage = 0;
-		Q_FOREACH(const KUrl& url, list) {
-			Document::Ptr doc = DocumentFactory::instance()->load(url);
-			memoryUsage += doc->memoryUsage();
-		}
-
-		mTooManyChangesFrame->setVisible(memoryUsage > maxMemoryUsage);
-	}
-
-
-	void updateTopRowWidget(const QList<KUrl>& lst) {
-		QStringList links;
-		QString message;
-
-		if (lst.contains(mCurrentUrl)) {
-			message = i18n("Current image modified");
-
-			mUndoButton->show();
-			mRedoButton->show();
-
-			if (lst.size() > 1) {
-				QString previous = i18n("Previous modified image");
-				QString next = i18n("Next modified image");
-				if (mCurrentUrl == lst[0]) {
-					links << previous;
-				} else {
-					links << QString("<a href='previous'>%1</a>").arg(previous);
-				}
-				if (mCurrentUrl == lst[lst.size() - 1]) {
-					links << next;
-				} else {
-					links << QString("<a href='next'>%1</a>").arg(next);
-				}
-			}
-		} else {
-			mUndoButton->hide();
-			mRedoButton->hide();
-
-			message = i18np("One image modified", "%1 images modified", lst.size());
-			if (lst.size() > 1) {
-				links << QString("<a href='first'>%1</a>").arg(i18n("Go to first modified image"));
-			} else {
-				links << QString("<a href='first'>%1</a>").arg(i18n("Go to it"));
-			}
-		}
-
-		mSaveCurrentUrlButton->setVisible(lst.contains(mCurrentUrl));
-		mSaveAsButton->setVisible(lst.contains(mCurrentUrl));
-		mSaveAllButton->setVisible(lst.size() >= 1);
-
-		mMessageLabel->setText(message);
-		mActionsLabel->setText(links.join(" | "));
-	}
-
-
-	void updateWidgetSizes() {
-		QVBoxLayout* layout = static_cast<QVBoxLayout*>(mSaveBarWidget->layout());
-		int topRowHeight = mFullScreenMode ? 0 : mTopRowWidget->height();
-		int bottomRowHeight = mTooManyChangesFrame->isVisibleTo(mSaveBarWidget) ? mTooManyChangesFrame->sizeHint().height() : 0;
-
-		int height = 2 * layout->margin() + topRowHeight + bottomRowHeight;
-		if (topRowHeight > 0 && bottomRowHeight > 0) {
-			height += layout->spacing();
-		}
-		mSaveBarWidget->setFixedHeight(height);
-		that->setFixedHeight(height);
-	}
+    SaveBar* q;
+    KActionCollection* mActionCollection;
+    QWidget* mSaveBarWidget;
+    QWidget* mTopRowWidget;
+    QToolButton* mUndoButton;
+    QToolButton* mRedoButton;
+    QToolButton* mSaveCurrentUrlButton;
+    QToolButton* mSaveAsButton;
+    QToolButton* mSaveAllButton;
+    QToolButton* mSaveAllFullScreenButton;
+    QLabel* mMessageLabel;
+    QLabel* mActionsLabel;
+    QFrame* mTooManyChangesFrame;
+    KUrl mCurrentUrl;
+    bool mFullScreenMode;
+
+    void createTooManyChangesFrame()
+    {
+        mTooManyChangesFrame = new QFrame;
+
+        // Icon
+        QLabel* iconLabel = new QLabel;
+        QPixmap pix = KIconLoader::global()->loadIcon(
+                          "dialog-warning", KIconLoader::Dialog, KIconLoader::SizeSmall);
+        iconLabel->setPixmap(pix);
+
+        // Text label
+        QLabel* textLabel = new QLabel;
+        textLabel->setText(
+            i18n("You have modified many images. To avoid memory problems, you should save your changes.")
+        );
+
+        mSaveAllFullScreenButton = createToolButton();
+
+        // Layout
+        QHBoxLayout* layout = new QHBoxLayout(mTooManyChangesFrame);
+        layout->setMargin(0);
+        layout->addWidget(iconLabel);
+        layout->addWidget(textLabel);
+        layout->addWidget(mSaveAllFullScreenButton);
+        mTooManyChangesFrame->hide();
+
+        // CSS
+        KColorScheme scheme(mSaveBarWidget->palette().currentColorGroup(), KColorScheme::Window);
+        QColor warningBackgroundColor = scheme.background(KColorScheme::NegativeBackground).color();
+        QColor warningBorderColor = PaintUtils::adjustedHsv(warningBackgroundColor, 0, 150, 0);
+        QColor warningColor = scheme.foreground(KColorScheme::NegativeText).color();
+
+        QString css =
+            ".QFrame {"
+            "	background-color: %1;"
+            "	border: 1px solid %2;"
+            "	border-radius: 4px;"
+            "	padding: 3px;"
+            "}"
+            ".QFrame QLabel {"
+            "	color: %3;"
+            "}"
+            ;
+        css = css
+              .arg(warningBackgroundColor.name())
+              .arg(warningBorderColor.name())
+              .arg(warningColor.name())
+              ;
+        mTooManyChangesFrame->setStyleSheet(css);
+    }
+
+    void applyNormalStyleSheet()
+    {
+        QColor bgColor = QToolTip::palette().base().color();
+        QColor borderColor = PaintUtils::adjustedHsv(bgColor, 0, 150, 0);
+        QColor fgColor = QToolTip::palette().text().color();
+
+        QString css =
+            "#saveBarWidget {"
+            "	background-color: %1;"
+            "	border-top: 1px solid %2;"
+            "	border-bottom: 1px solid %2;"
+            "	color: %3;"
+            "}"
+            ;
+
+        css = css
+              .arg(bgColor.name())
+              .arg(borderColor.name())
+              .arg(fgColor.name())
+              ;
+        mSaveBarWidget->setStyleSheet(css);
+    }
+
+    void applyFullScreenStyleSheet()
+    {
+        QString css =
+            "#saveBarWidget {"
+            "	background-color: #333;"
+            "}";
+        mSaveBarWidget->setStyleSheet(css);
+    }
+
+    void updateTooManyChangesFrame(const QList<KUrl>& list)
+    {
+        qreal maxPercentageOfMemoryUsage = GwenviewConfig::percentageOfMemoryUsageWarning();
+        qulonglong maxMemoryUsage = MemoryUtils::getTotalMemory() * maxPercentageOfMemoryUsage;
+        qulonglong memoryUsage = 0;
+        Q_FOREACH(const KUrl & url, list) {
+            Document::Ptr doc = DocumentFactory::instance()->load(url);
+            memoryUsage += doc->memoryUsage();
+        }
+
+        mTooManyChangesFrame->setVisible(memoryUsage > maxMemoryUsage);
+    }
+
+    void updateTopRowWidget(const QList<KUrl>& lst)
+    {
+        QStringList links;
+        QString message;
+
+        if (lst.contains(mCurrentUrl)) {
+            message = i18n("Current image modified");
+
+            mUndoButton->show();
+            mRedoButton->show();
+
+            if (lst.size() > 1) {
+                QString previous = i18n("Previous modified image");
+                QString next = i18n("Next modified image");
+                if (mCurrentUrl == lst[0]) {
+                    links << previous;
+                } else {
+                    links << QString("<a href='previous'>%1</a>").arg(previous);
+                }
+                if (mCurrentUrl == lst[lst.size() - 1]) {
+                    links << next;
+                } else {
+                    links << QString("<a href='next'>%1</a>").arg(next);
+                }
+            }
+        } else {
+            mUndoButton->hide();
+            mRedoButton->hide();
+
+            message = i18np("One image modified", "%1 images modified", lst.size());
+            if (lst.size() > 1) {
+                links << QString("<a href='first'>%1</a>").arg(i18n("Go to first modified image"));
+            } else {
+                links << QString("<a href='first'>%1</a>").arg(i18n("Go to it"));
+            }
+        }
+
+        mSaveCurrentUrlButton->setVisible(lst.contains(mCurrentUrl));
+        mSaveAsButton->setVisible(lst.contains(mCurrentUrl));
+        mSaveAllButton->setVisible(lst.size() >= 1);
+
+        mMessageLabel->setText(message);
+        mActionsLabel->setText(links.join(" | "));
+    }
+
+    void updateWidgetSizes()
+    {
+        QVBoxLayout* layout = static_cast<QVBoxLayout*>(mSaveBarWidget->layout());
+        int topRowHeight = mFullScreenMode ? 0 : mTopRowWidget->height();
+        int bottomRowHeight = mTooManyChangesFrame->isVisibleTo(mSaveBarWidget) ? mTooManyChangesFrame->sizeHint().height() : 0;
+
+        int height = 2 * layout->margin() + topRowHeight + bottomRowHeight;
+        if (topRowHeight > 0 && bottomRowHeight > 0) {
+            height += layout->spacing();
+        }
+        mSaveBarWidget->setFixedHeight(height);
+    }
 };
 
-
 SaveBar::SaveBar(QWidget* parent, KActionCollection* actionCollection)
 : SlideContainer(parent)
-, d(new SaveBarPrivate) {
-	d->that = this;
-	d->mFullScreenMode = false;
-	d->mActionCollection = actionCollection;
-	d->mSaveBarWidget = new QWidget();
-	d->mSaveBarWidget->setObjectName( QLatin1String("saveBarWidget" ));
-	d->applyNormalStyleSheet();
-
-	d->mMessageLabel = new QLabel;
-	d->mMessageLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
-
-	d->mUndoButton = createToolButton();
-	d->mRedoButton = createToolButton();
-	d->mSaveCurrentUrlButton = createToolButton();
-	d->mSaveAsButton = createToolButton();
-	d->mSaveAllButton = createToolButton();
-
-	d->mActionsLabel = new QLabel;
-	d->mActionsLabel->setAlignment(Qt::AlignCenter);
-	d->mActionsLabel->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
-
-	d->createTooManyChangesFrame();
-
-	// Setup top row
-	d->mTopRowWidget = new QWidget;
-	QHBoxLayout* rowLayout = new QHBoxLayout(d->mTopRowWidget);
-	rowLayout->addWidget(d->mMessageLabel);
-	rowLayout->addWidget(d->mUndoButton);
-	rowLayout->addWidget(d->mRedoButton);
-	rowLayout->addWidget(d->mActionsLabel);
-	rowLayout->addWidget(d->mSaveCurrentUrlButton);
-	rowLayout->addWidget(d->mSaveAsButton);
-	rowLayout->addWidget(d->mSaveAllButton);
-	rowLayout->setMargin(0);
-
-	// Setup bottom row
-	QHBoxLayout* bottomRowLayout = new QHBoxLayout;
-	bottomRowLayout->addStretch();
-	bottomRowLayout->addWidget(d->mTooManyChangesFrame);
-	bottomRowLayout->addStretch();
-
-	// Gather everything together
-	QVBoxLayout* layout = new QVBoxLayout(d->mSaveBarWidget);
-	layout->addWidget(d->mTopRowWidget);
-	layout->addLayout(bottomRowLayout);
-	layout->setMargin(3);
-	layout->setSpacing(3);
-
-	hide();
-
-	setContent(d->mSaveBarWidget);
-
-	connect(DocumentFactory::instance(), SIGNAL(modifiedDocumentListChanged()),
-		SLOT(updateContent()) );
-
-	connect(d->mActionsLabel, SIGNAL(linkActivated(const QString&)),
-		SLOT(triggerAction(const QString&)) );
-}
-
-
-SaveBar::~SaveBar() {
-	delete d;
-}
-
-
-void SaveBar::initActionDependentWidgets() {
-	d->mUndoButton->setDefaultAction(d->mActionCollection->action("edit_undo"));
-	d->mRedoButton->setDefaultAction(d->mActionCollection->action("edit_redo"));
-	d->mSaveCurrentUrlButton->setDefaultAction(d->mActionCollection->action("file_save"));
-	d->mSaveAsButton->setDefaultAction(d->mActionCollection->action("file_save_as"));
-
-	// FIXME: Not using an action for now
-	d->mSaveAllButton->setText(i18n("Save All"));
-	d->mSaveAllButton->setIcon(KIcon("document-save-all"));
-	connect(d->mSaveAllButton, SIGNAL(clicked()),
-		SIGNAL(requestSaveAll()) );
-
-	d->mSaveAllFullScreenButton->setText(i18n("Save All"));
-	connect(d->mSaveAllFullScreenButton, SIGNAL(clicked()),
-		SIGNAL(requestSaveAll()) );
-
-	int height = d->mUndoButton->sizeHint().height();
-	d->mTopRowWidget->setFixedHeight(height);
-	d->updateWidgetSizes();
-}
-
-
-void SaveBar::setFullScreenMode(bool value) {
-	d->mFullScreenMode = value;
-	d->mSaveAllFullScreenButton->setVisible(value);
-	if (value) {
-		d->applyFullScreenStyleSheet();
-	} else {
-		d->applyNormalStyleSheet();
-	}
-	updateContent();
-}
-
-
-void SaveBar::updateContent() {
-	QList<KUrl> lst = DocumentFactory::instance()->modifiedDocumentList();
-	if (lst.size() == 0) {
-		slideOut();
-		return;
-	}
-
-	if (d->mFullScreenMode) {
-		d->mTopRowWidget->hide();
-	} else {
-		d->mTopRowWidget->show();
-		d->updateTopRowWidget(lst);
-	}
-
-	d->updateTooManyChangesFrame(lst);
-
-	d->updateWidgetSizes();
-	if (d->mFullScreenMode && !d->mTooManyChangesFrame->isVisibleTo(d->mSaveBarWidget)) {
-		slideOut();
-	} else {
-		slideIn();
-	}
-}
-
-
-void SaveBar::triggerAction(const QString& action) {
-	QList<KUrl> lst = DocumentFactory::instance()->modifiedDocumentList();
-	if (action == "first") {
-		goToUrl(lst[0]);
-	} else if (action == "previous") {
-		int pos = lst.indexOf(d->mCurrentUrl);
-		--pos;
-		Q_ASSERT(pos >= 0);
-		goToUrl(lst[pos]);
-	} else if (action == "next") {
-		int pos = lst.indexOf(d->mCurrentUrl);
-		++pos;
-		Q_ASSERT(pos < lst.size());
-		goToUrl(lst[pos]);
-	} else {
-		kWarning() << "Unknown action: " << action ;
-	}
-}
-
-
-void SaveBar::setCurrentUrl(const KUrl& url) {
-	d->mCurrentUrl = url;
-	updateContent();
-}
-
+, d(new SaveBarPrivate)
+{
+    d->q = this;
+    d->mFullScreenMode = false;
+    d->mActionCollection = actionCollection;
+    d->mSaveBarWidget = new QWidget();
+    d->mSaveBarWidget->setObjectName(QLatin1String("saveBarWidget"));
+    d->applyNormalStyleSheet();
+
+    d->mMessageLabel = new QLabel;
+    d->mMessageLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
+
+    d->mUndoButton = createToolButton();
+    d->mRedoButton = createToolButton();
+    d->mSaveCurrentUrlButton = createToolButton();
+    d->mSaveAsButton = createToolButton();
+    d->mSaveAllButton = createToolButton();
+
+    d->mActionsLabel = new QLabel;
+    d->mActionsLabel->setAlignment(Qt::AlignCenter);
+    d->mActionsLabel->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
+
+    d->createTooManyChangesFrame();
+
+    // Setup top row
+    d->mTopRowWidget = new QWidget;
+    QHBoxLayout* rowLayout = new QHBoxLayout(d->mTopRowWidget);
+    rowLayout->addWidget(d->mMessageLabel);
+    rowLayout->addWidget(d->mUndoButton);
+    rowLayout->addWidget(d->mRedoButton);
+    rowLayout->addWidget(d->mActionsLabel);
+    rowLayout->addWidget(d->mSaveCurrentUrlButton);
+    rowLayout->addWidget(d->mSaveAsButton);
+    rowLayout->addWidget(d->mSaveAllButton);
+    rowLayout->setMargin(0);
+
+    // Setup bottom row
+    QHBoxLayout* bottomRowLayout = new QHBoxLayout;
+    bottomRowLayout->addStretch();
+    bottomRowLayout->addWidget(d->mTooManyChangesFrame);
+    bottomRowLayout->addStretch();
+
+    // Gather everything together
+    QVBoxLayout* layout = new QVBoxLayout(d->mSaveBarWidget);
+    layout->addWidget(d->mTopRowWidget);
+    layout->addLayout(bottomRowLayout);
+    layout->setMargin(3);
+    layout->setSpacing(3);
+
+    setContent(d->mSaveBarWidget);
+
+    connect(DocumentFactory::instance(), SIGNAL(modifiedDocumentListChanged()),
+            SLOT(updateContent()));
+
+    connect(d->mActionsLabel, SIGNAL(linkActivated(QString)),
+            SLOT(triggerAction(QString)));
+}
+
+SaveBar::~SaveBar()
+{
+    delete d;
+}
+
+void SaveBar::initActionDependentWidgets()
+{
+    d->mUndoButton->setDefaultAction(d->mActionCollection->action("edit_undo"));
+    d->mRedoButton->setDefaultAction(d->mActionCollection->action("edit_redo"));
+    d->mSaveCurrentUrlButton->setDefaultAction(d->mActionCollection->action("file_save"));
+    d->mSaveAsButton->setDefaultAction(d->mActionCollection->action("file_save_as"));
+
+    // FIXME: Not using an action for now
+    d->mSaveAllButton->setText(i18n("Save All"));
+    d->mSaveAllButton->setIcon(KIcon("document-save-all"));
+    connect(d->mSaveAllButton, SIGNAL(clicked()),
+            SIGNAL(requestSaveAll()));
+
+    d->mSaveAllFullScreenButton->setText(i18n("Save All"));
+    connect(d->mSaveAllFullScreenButton, SIGNAL(clicked()),
+            SIGNAL(requestSaveAll()));
+
+    int height = d->mUndoButton->sizeHint().height();
+    d->mTopRowWidget->setFixedHeight(height);
+    d->updateWidgetSizes();
+}
+
+void SaveBar::setFullScreenMode(bool value)
+{
+    d->mFullScreenMode = value;
+    d->mSaveAllFullScreenButton->setVisible(value);
+    if (value) {
+        d->applyFullScreenStyleSheet();
+    } else {
+        d->applyNormalStyleSheet();
+    }
+    updateContent();
+}
+
+void SaveBar::updateContent()
+{
+    QList<KUrl> lst = DocumentFactory::instance()->modifiedDocumentList();
+
+    if (d->mFullScreenMode) {
+        d->mTopRowWidget->hide();
+    } else {
+        d->mTopRowWidget->show();
+        d->updateTopRowWidget(lst);
+    }
+
+    d->updateTooManyChangesFrame(lst);
+
+    d->updateWidgetSizes();
+    if (lst.isEmpty() || (d->mFullScreenMode && !d->mTooManyChangesFrame->isVisibleTo(d->mSaveBarWidget))) {
+        slideOut();
+    } else {
+        slideIn();
+    }
+}
+
+void SaveBar::triggerAction(const QString& action)
+{
+    QList<KUrl> lst = DocumentFactory::instance()->modifiedDocumentList();
+    if (action == "first") {
+        goToUrl(lst[0]);
+    } else if (action == "previous") {
+        int pos = lst.indexOf(d->mCurrentUrl);
+        --pos;
+        Q_ASSERT(pos >= 0);
+        goToUrl(lst[pos]);
+    } else if (action == "next") {
+        int pos = lst.indexOf(d->mCurrentUrl);
+        ++pos;
+        Q_ASSERT(pos < lst.size());
+        goToUrl(lst[pos]);
+    } else {
+        kWarning() << "Unknown action: " << action ;
+    }
+}
+
+void SaveBar::setCurrentUrl(const KUrl& url)
+{
+    d->mCurrentUrl = url;
+    updateContent();
+}
 
 } // namespace

=== modified file 'app/savebar.h'
--- app/savebar.h	2011-07-20 13:46:34 +0000
+++ app/savebar.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -31,38 +31,38 @@
 class KActionCollection;
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class SaveBarPrivate;
-class SaveBar : public SlideContainer {
-	Q_OBJECT
+class SaveBar : public SlideContainer
+{
+    Q_OBJECT
 public:
-	SaveBar(QWidget* parent, KActionCollection* collection);
-	~SaveBar();
-
-	/**
-	 * Init widgets which depend on an initialized actionCollection
-	 */
-	void initActionDependentWidgets();
-
-	void setCurrentUrl(const KUrl&);
-
-	void setFullScreenMode(bool);
+    SaveBar(QWidget* parent, KActionCollection* collection);
+    ~SaveBar();
+
+    /**
+     * Init widgets which depend on an initialized actionCollection
+     */
+    void initActionDependentWidgets();
+
+    void setCurrentUrl(const KUrl&);
+
+    void setFullScreenMode(bool);
 
 Q_SIGNALS:
-	void requestSaveAll();
-	void goToUrl(const KUrl&);
+    void requestSaveAll();
+    void goToUrl(const KUrl&);
 
 private:
-	SaveBarPrivate* const d;
+    SaveBarPrivate* const d;
 
 private Q_SLOTS:
-	void updateContent();
-	void triggerAction(const QString& action);
+    void updateContent();
+    void triggerAction(const QString& action);
 };
 
-
 } // namespace
 
 #endif /* SAVEBAR_H */

=== modified file 'app/semanticinfocontextmanageritem.cpp'
--- app/semanticinfocontextmanageritem.cpp	2011-07-20 13:46:34 +0000
+++ app/semanticinfocontextmanageritem.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -41,7 +41,7 @@
 
 // Local
 #include "contextmanager.h"
-#include "documentpanel.h"
+#include "viewmainpage.h"
 #include "sidebar.h"
 #include "ui_semanticinfosidebaritem.h"
 #include "ui_semanticinfodialog.h"
@@ -54,382 +54,384 @@
 #include <lib/semanticinfo/semanticinfodirmodel.h>
 #include <lib/semanticinfo/sorteddirmodel.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 static const int RATING_INDICATOR_HIDE_DELAY = 3000;
 
-
 struct SemanticInfoDialog : public KDialog, public Ui_SemanticInfoDialog {
-	SemanticInfoDialog(QWidget* parent)
-	: KDialog(parent) {
-		setButtons(None);
-		QWidget* mainWidget = new QWidget;
-		setMainWidget(mainWidget);
-		setupUi(mainWidget);
-		mainWidget->layout()->setMargin(0);
-		setWindowTitle(mainWidget->windowTitle());
-
-		restoreDialogSize(configGroup());
-	}
-
-	~SemanticInfoDialog() {
-		KConfigGroup group = configGroup();
-		saveDialogSize(group);
-	}
-
-	KConfigGroup configGroup() const {
-		KSharedConfigPtr config = KGlobal::config();
-		return KConfigGroup(config, "SemanticInfoDialog");
-	}
+    SemanticInfoDialog(QWidget* parent)
+        : KDialog(parent) {
+        setButtons(None);
+        QWidget* mainWidget = new QWidget;
+        setMainWidget(mainWidget);
+        setupUi(mainWidget);
+        mainWidget->layout()->setMargin(0);
+        setWindowTitle(mainWidget->windowTitle());
+
+        restoreDialogSize(configGroup());
+    }
+
+    ~SemanticInfoDialog() {
+        KConfigGroup group = configGroup();
+        saveDialogSize(group);
+    }
+
+    KConfigGroup configGroup() const {
+        KSharedConfigPtr config = KGlobal::config();
+        return KConfigGroup(config, "SemanticInfoDialog");
+    }
 };
 
-
-class RatingIndicator : public HudWidget {
+class RatingIndicator : public HudWidget
+{
 public:
-	RatingIndicator(QWidget* parent)
-	: HudWidget(parent)
-	, mRatingWidget(new KRatingWidget)
-	, mHideTimer(new QTimer(this))
-	{
-		init(mRatingWidget, OptionNone);
-		WidgetFloater* floater = new WidgetFloater(parent);
-		floater->setAlignment(Qt::AlignHCenter | Qt::AlignBottom);
-		floater->setVerticalMargin(
-			KDialog::marginHint()
-			+ parent->style()->pixelMetric(QStyle::PM_ScrollBarExtent)
-			);
-		floater->setChildWidget(this);
-
-		mHideTimer->setInterval(RATING_INDICATOR_HIDE_DELAY);
-		mHideTimer->setSingleShot(true);
-		connect(mHideTimer, SIGNAL(timeout()), SLOT(deleteLater()));
-		hide();
-	}
-
-	void setRating(int rating) {
-		mRatingWidget->setRating(rating);
-	}
-
-	void show() {
-		HudWidget::show();
-		raise();
-		mHideTimer->start();
-	}
+    RatingIndicator(QWidget* parent)
+        : HudWidget(parent)
+        , mRatingWidget(new KRatingWidget)
+        , mHideTimer(new QTimer(this)) {
+        init(mRatingWidget, OptionNone);
+        WidgetFloater* floater = new WidgetFloater(parent);
+        floater->setAlignment(Qt::AlignHCenter | Qt::AlignBottom);
+        floater->setVerticalMargin(
+            KDialog::marginHint()
+            + parent->style()->pixelMetric(QStyle::PM_ScrollBarExtent)
+        );
+        floater->setChildWidget(this);
+
+        mHideTimer->setInterval(RATING_INDICATOR_HIDE_DELAY);
+        mHideTimer->setSingleShot(true);
+        connect(mHideTimer, SIGNAL(timeout()), SLOT(deleteLater()));
+        hide();
+    }
+
+    void setRating(int rating)
+    {
+        mRatingWidget->setRating(rating);
+    }
+
+    void show()
+    {
+        HudWidget::show();
+        raise();
+        mHideTimer->start();
+    }
 
 private:
-	KRatingWidget* mRatingWidget;
-	QTimer* mHideTimer;
+    KRatingWidget* mRatingWidget;
+    QTimer* mHideTimer;
 };
 
-
 struct SemanticInfoContextManagerItemPrivate : public Ui_SemanticInfoSideBarItem {
-	SemanticInfoContextManagerItem* that;
-	SideBarGroup* mGroup;
-	KActionCollection* mActionCollection;
-	DocumentPanel* mDocumentPanel;
-	QPointer<SemanticInfoDialog> mSemanticInfoDialog;
-	TagInfo mTagInfo;
-	KAction* mEditTagsAction;
-	QSignalMapper* mRatingMapper;
-	/** A list of all actions, so that we can disable them when necessary */
-	QList<KAction*> mActions;
-	QPointer<RatingIndicator> mRatingIndicator;
-
-	void setupGroup() {
-		mGroup = new SideBarGroup(i18n("Semantic Information"));
-		that->setWidget(mGroup);
-		EventWatcher::install(mGroup, QEvent::Show, that, SLOT(update()));
-
-		QWidget* container = new QWidget;
-		setupUi(container);
-		container->layout()->setMargin(0);
-		mGroup->addWidget(container);
-
-		QObject::connect(mRatingWidget, SIGNAL(ratingChanged(int)),
-			that, SLOT(slotRatingChanged(int)));
-		QObject::connect(mRatingMapper, SIGNAL(mapped(int)),
-			mRatingWidget, SLOT(setRating(int)) );
-
-		mDescriptionTextEdit->installEventFilter(that);
-
-		QObject::connect(mTagLabel, SIGNAL(linkActivated(const QString&)),
-			mEditTagsAction, SLOT(trigger()) );
-	}
-
-
-	void setupActions() {
-		KActionCategory* edit = new KActionCategory(i18nc("@title actions category","Edit"), mActionCollection);
-
-		mEditTagsAction = edit->addAction("edit_tags");
-		mEditTagsAction->setText(i18nc("@action", "Edit Tags"));
-		mEditTagsAction->setShortcut(Qt::CTRL | Qt::Key_T);
-		QObject::connect(mEditTagsAction, SIGNAL(triggered()),
-			that, SLOT(showSemanticInfoDialog()) );
-		mActions << mEditTagsAction;
-
-		mRatingMapper = new QSignalMapper(that);
-		for (int rating=0; rating <= 5; ++rating) {
-			KAction* action = edit->addAction(QString("rate_%1").arg(rating));
-			if (rating == 0) {
-				action->setText(i18nc("@action Rating value of zero", "Zero"));
-			} else {
-				action->setText(QString(rating, QChar(0x22C6))); /* 0x22C6 is the 'star' character */
-			}
-			action->setShortcut(Qt::Key_0 + rating);
-			QObject::connect(action, SIGNAL(triggered()), mRatingMapper, SLOT(map()) );
-			mRatingMapper->setMapping(action, rating * 2);
-			mActions << action;
-		}
-		QObject::connect(mRatingMapper, SIGNAL(mapped(int)), that, SLOT(slotRatingChanged(int)) );
-	}
-
-
-	void updateTagLabel() {
-		if (that->contextManager()->selectedFileItemList().isEmpty()) {
-			mTagLabel->clear();
-			return;
-		}
-
-		AbstractSemanticInfoBackEnd* backEnd = that->contextManager()->dirModel()->semanticInfoBackEnd();
-
-		TagInfo::ConstIterator
-			it = mTagInfo.constBegin(),
-			end = mTagInfo.constEnd();
-		QMap<QString, QString> labelMap;
-		for (; it!=end; ++it) {
-			SemanticInfoTag tag = it.key();
-			QString label = backEnd->labelForTag(tag);
-			if (!it.value()) {
-				// Tag is not present for all urls
-				label += '*';
-			}
-			labelMap[label.toLower()] = label;
-		}
-		QStringList labels(labelMap.values());
-
-		QString editLink = i18n("Edit");
-		QString text = labels.join(", ") + QString(" <a href='edit'>%1</a>").arg(editLink);
-		mTagLabel->setText(text);
-	}
-
-
-	void updateSemanticInfoDialog() {
-		mSemanticInfoDialog->mTagWidget->setEnabled(!that->contextManager()->selectedFileItemList().isEmpty());
-		mSemanticInfoDialog->mTagWidget->setTagInfo(mTagInfo);
-	}
+    SemanticInfoContextManagerItem* q;
+    SideBarGroup* mGroup;
+    KActionCollection* mActionCollection;
+    ViewMainPage* mViewMainPage;
+    QPointer<SemanticInfoDialog> mSemanticInfoDialog;
+    TagInfo mTagInfo;
+    KAction* mEditTagsAction;
+    QSignalMapper* mRatingMapper;
+    /** A list of all actions, so that we can disable them when necessary */
+    QList<KAction*> mActions;
+    QPointer<RatingIndicator> mRatingIndicator;
+
+    void setupGroup()
+    {
+        mGroup = new SideBarGroup(i18n("Semantic Information"));
+        q->setWidget(mGroup);
+        EventWatcher::install(mGroup, QEvent::Show, q, SLOT(update()));
+
+        QWidget* container = new QWidget;
+        setupUi(container);
+        container->layout()->setMargin(0);
+        mGroup->addWidget(container);
+
+        QObject::connect(mRatingWidget, SIGNAL(ratingChanged(int)),
+                         q, SLOT(slotRatingChanged(int)));
+        QObject::connect(mRatingMapper, SIGNAL(mapped(int)),
+                         mRatingWidget, SLOT(setRating(int)));
+
+        mDescriptionTextEdit->installEventFilter(q);
+
+        QObject::connect(mTagLabel, SIGNAL(linkActivated(QString)),
+                         mEditTagsAction, SLOT(trigger()));
+    }
+
+    void setupActions()
+    {
+        KActionCategory* edit = new KActionCategory(i18nc("@title actions category", "Edit"), mActionCollection);
+
+        mEditTagsAction = edit->addAction("edit_tags");
+        mEditTagsAction->setText(i18nc("@action", "Edit Tags"));
+        mEditTagsAction->setShortcut(Qt::CTRL | Qt::Key_T);
+        QObject::connect(mEditTagsAction, SIGNAL(triggered()),
+                         q, SLOT(showSemanticInfoDialog()));
+        mActions << mEditTagsAction;
+
+        mRatingMapper = new QSignalMapper(q);
+        for (int rating = 0; rating <= 5; ++rating) {
+            KAction* action = edit->addAction(QString("rate_%1").arg(rating));
+            if (rating == 0) {
+                action->setText(i18nc("@action Rating value of zero", "Zero"));
+            } else {
+                action->setText(QString(rating, QChar(0x22C6))); /* 0x22C6 is the 'star' character */
+            }
+            action->setShortcut(Qt::Key_0 + rating);
+            QObject::connect(action, SIGNAL(triggered()), mRatingMapper, SLOT(map()));
+            mRatingMapper->setMapping(action, rating * 2);
+            mActions << action;
+        }
+        QObject::connect(mRatingMapper, SIGNAL(mapped(int)), q, SLOT(slotRatingChanged(int)));
+    }
+
+    void updateTagLabel()
+    {
+        if (q->contextManager()->selectedFileItemList().isEmpty()) {
+            mTagLabel->clear();
+            return;
+        }
+
+        AbstractSemanticInfoBackEnd* backEnd = q->contextManager()->dirModel()->semanticInfoBackEnd();
+
+        TagInfo::ConstIterator
+        it = mTagInfo.constBegin(),
+        end = mTagInfo.constEnd();
+        QMap<QString, QString> labelMap;
+        for (; it != end; ++it) {
+            SemanticInfoTag tag = it.key();
+            QString label = backEnd->labelForTag(tag);
+            if (!it.value()) {
+                // Tag is not present for all urls
+                label += '*';
+            }
+            labelMap[label.toLower()] = label;
+        }
+        QStringList labels(labelMap.values());
+
+        QString editLink = i18n("Edit");
+        QString text = labels.join(", ") + QString(" <a href='edit'>%1</a>").arg(editLink);
+        mTagLabel->setText(text);
+    }
+
+    void updateSemanticInfoDialog()
+    {
+        mSemanticInfoDialog->mTagWidget->setEnabled(!q->contextManager()->selectedFileItemList().isEmpty());
+        mSemanticInfoDialog->mTagWidget->setTagInfo(mTagInfo);
+    }
 };
 
-
-SemanticInfoContextManagerItem::SemanticInfoContextManagerItem(ContextManager* manager, KActionCollection* actionCollection, DocumentPanel* documentPanel)
+SemanticInfoContextManagerItem::SemanticInfoContextManagerItem(ContextManager* manager, KActionCollection* actionCollection, ViewMainPage* documentPanel)
 : AbstractContextManagerItem(manager)
-, d(new SemanticInfoContextManagerItemPrivate) {
-	d->that = this;
-	d->mActionCollection = actionCollection;
-	d->mDocumentPanel = documentPanel;
-
-	connect(contextManager(), SIGNAL(selectionChanged()),
-		SLOT(slotSelectionChanged()) );
-	connect(contextManager(), SIGNAL(selectionDataChanged()),
-		SLOT(update()) );
-	connect(contextManager(), SIGNAL(currentDirUrlChanged()),
-		SLOT(update()) );
-
-	d->setupActions();
-	d->setupGroup();
-}
-
-
-SemanticInfoContextManagerItem::~SemanticInfoContextManagerItem() {
-	delete d;
-}
-
-
-inline int ratingForVariant(const QVariant& variant) {
-	if (variant.isValid()) {
-		return variant.toInt();
-	} else {
-		return 0;
-	}
-}
-
-
-void SemanticInfoContextManagerItem::slotSelectionChanged() {
-	if (d->mRatingIndicator) {
-		d->mRatingIndicator->deleteLater();
-	}
-	update();
-}
-
-
-void SemanticInfoContextManagerItem::update() {
-	KFileItemList itemList = contextManager()->selectedFileItemList();
-
-	bool first = true;
-	int rating = 0;
-	QString description;
-	SortedDirModel* dirModel = contextManager()->dirModel();
-
-	// This hash stores for how many items the tag is present
-	// If you have 3 items, and only 2 have the "Holiday" tag,
-	// then tagHash["Holiday"] will be 2 at the end of the loop.
-	typedef QHash<QString, int> TagHash;
-	TagHash tagHash;
-
-	Q_FOREACH(const KFileItem& item, itemList) {
-		QModelIndex index = dirModel->indexForItem(item);
-
-		QVariant value = dirModel->data(index, SemanticInfoDirModel::RatingRole);
-		if (first) {
-			rating = ratingForVariant(value);
-		} else if (rating != ratingForVariant(value)) {
-			// Ratings aren't the same, reset
-			rating = 0;
-		}
-
-		QString indexDescription = index.data(SemanticInfoDirModel::DescriptionRole).toString();
-		if (first) {
-			description = indexDescription;
-		} else if (description != indexDescription) {
-			description.clear();
-		}
-
-		// Fill tagHash, incrementing the tag count if it's already there
-		TagSet tagSet = TagSet::fromVariant(index.data(SemanticInfoDirModel::TagsRole));
-		Q_FOREACH(const QString& tag, tagSet) {
-			TagHash::Iterator it = tagHash.find(tag);
-			if (it == tagHash.end()) {
-				tagHash[tag] = 1;
-			} else {
-				++it.value();
-			}
-		}
-
-		first = false;
-	}
-	{
-		SignalBlocker blocker(d->mRatingWidget);
-		d->mRatingWidget->setRating(rating);
-	}
-	d->mDescriptionTextEdit->setText(description);
-
-	// Init tagInfo from tagHash
-	d->mTagInfo.clear();
-	int itemCount = itemList.count();
-	TagHash::ConstIterator
-		it = tagHash.constBegin(),
-		end = tagHash.constEnd();
-	for (; it!=end; ++it) {
-		QString tag = it.key();
-		int count = it.value();
-		d->mTagInfo[tag] = count == itemCount;
-	}
-
-	bool enabled = !contextManager()->selectedFileItemList().isEmpty();
-	Q_FOREACH(KAction* action, d->mActions) {
-		action->setEnabled(enabled);
-	}
-	d->updateTagLabel();
-	if (d->mSemanticInfoDialog) {
-		d->updateSemanticInfoDialog();
-	}
-}
-
-
-void SemanticInfoContextManagerItem::slotRatingChanged(int rating) {
-	KFileItemList itemList = contextManager()->selectedFileItemList();
-
-	// Show rating indicator in view mode, and only if sidebar is not visible
-	if (d->mDocumentPanel->isVisible() && !d->mRatingWidget->isVisible()) {
-		delete d->mRatingIndicator.data();
-		d->mRatingIndicator = new RatingIndicator(d->mDocumentPanel->documentView());
-		d->mRatingIndicator->setRating(rating);
-		d->mRatingIndicator->show();
-	}
-
-	SortedDirModel* dirModel = contextManager()->dirModel();
-	Q_FOREACH(const KFileItem& item, itemList) {
-		QModelIndex index = dirModel->indexForItem(item);
-		dirModel->setData(index, rating, SemanticInfoDirModel::RatingRole);
-	}
-}
-
-
-void SemanticInfoContextManagerItem::storeDescription() {
-	if (!d->mDescriptionTextEdit->document()->isModified()) {
-		return;
-	}
-	d->mDescriptionTextEdit->document()->setModified(false);
-	QString description = d->mDescriptionTextEdit->toPlainText();
-	KFileItemList itemList = contextManager()->selectedFileItemList();
-
-	SortedDirModel* dirModel = contextManager()->dirModel();
-	Q_FOREACH(const KFileItem& item, itemList) {
-		QModelIndex index = dirModel->indexForItem(item);
-		dirModel->setData(index, description, SemanticInfoDirModel::DescriptionRole);
-	}
-}
-
-
-void SemanticInfoContextManagerItem::assignTag(const SemanticInfoTag& tag) {
-	KFileItemList itemList = contextManager()->selectedFileItemList();
-
-	SortedDirModel* dirModel = contextManager()->dirModel();
-	Q_FOREACH(const KFileItem& item, itemList) {
-		QModelIndex index = dirModel->indexForItem(item);
-		TagSet tags = TagSet::fromVariant( dirModel->data(index, SemanticInfoDirModel::TagsRole) );
-		if (!tags.contains(tag)) {
-			tags << tag;
-			dirModel->setData(index, tags.toVariant(), SemanticInfoDirModel::TagsRole);
-		}
-	}
-}
-
-
-void SemanticInfoContextManagerItem::removeTag(const SemanticInfoTag& tag) {
-	KFileItemList itemList = contextManager()->selectedFileItemList();
-
-	SortedDirModel* dirModel = contextManager()->dirModel();
-	Q_FOREACH(const KFileItem& item, itemList) {
-		QModelIndex index = dirModel->indexForItem(item);
-		TagSet tags = TagSet::fromVariant( dirModel->data(index, SemanticInfoDirModel::TagsRole) );
-		if (tags.contains(tag)) {
-			tags.remove(tag);
-			dirModel->setData(index, tags.toVariant(), SemanticInfoDirModel::TagsRole);
-		}
-	}
-}
-
-
-void SemanticInfoContextManagerItem::showSemanticInfoDialog() {
-	if (!d->mSemanticInfoDialog) {
-		d->mSemanticInfoDialog = new SemanticInfoDialog(d->mGroup);
-		d->mSemanticInfoDialog->setAttribute(Qt::WA_DeleteOnClose, true);
-
-		connect(d->mSemanticInfoDialog->mPreviousButton, SIGNAL(clicked()),
-			d->mActionCollection->action("go_previous"), SLOT(trigger()) );
-		connect(d->mSemanticInfoDialog->mNextButton, SIGNAL(clicked()),
-			d->mActionCollection->action("go_next"), SLOT(trigger()) );
-		connect(d->mSemanticInfoDialog->mButtonBox, SIGNAL(rejected()),
-			d->mSemanticInfoDialog, SLOT(close()));
-
-		AbstractSemanticInfoBackEnd* backEnd = contextManager()->dirModel()->semanticInfoBackEnd();
-		d->mSemanticInfoDialog->mTagWidget->setSemanticInfoBackEnd(backEnd);
-		connect(d->mSemanticInfoDialog->mTagWidget, SIGNAL(tagAssigned(const SemanticInfoTag&)),
-			SLOT(assignTag(const SemanticInfoTag&)) );
-		connect(d->mSemanticInfoDialog->mTagWidget, SIGNAL(tagRemoved(const SemanticInfoTag&)),
-			SLOT(removeTag(const SemanticInfoTag&)) );
-	}
-	d->updateSemanticInfoDialog();
-	d->mSemanticInfoDialog->show();
-}
-
-
-bool SemanticInfoContextManagerItem::eventFilter(QObject*, QEvent* event) {
-	if (event->type() == QEvent::FocusOut) {
-		storeDescription();
-	}
-	return false;
-}
-
+, d(new SemanticInfoContextManagerItemPrivate)
+{
+    d->q = this;
+    d->mActionCollection = actionCollection;
+    d->mViewMainPage = documentPanel;
+
+    connect(contextManager(), SIGNAL(selectionChanged()),
+            SLOT(slotSelectionChanged()));
+    connect(contextManager(), SIGNAL(selectionDataChanged()),
+            SLOT(update()));
+    connect(contextManager(), SIGNAL(currentDirUrlChanged()),
+            SLOT(update()));
+
+    d->setupActions();
+    d->setupGroup();
+}
+
+SemanticInfoContextManagerItem::~SemanticInfoContextManagerItem()
+{
+    delete d;
+}
+
+inline int ratingForVariant(const QVariant& variant)
+{
+    if (variant.isValid()) {
+        return variant.toInt();
+    } else {
+        return 0;
+    }
+}
+
+void SemanticInfoContextManagerItem::slotSelectionChanged()
+{
+    if (d->mRatingIndicator) {
+        d->mRatingIndicator->deleteLater();
+    }
+    update();
+}
+
+void SemanticInfoContextManagerItem::update()
+{
+    KFileItemList itemList = contextManager()->selectedFileItemList();
+
+    bool first = true;
+    int rating = 0;
+    QString description;
+    SortedDirModel* dirModel = contextManager()->dirModel();
+
+    // This hash stores for how many items the tag is present
+    // If you have 3 items, and only 2 have the "Holiday" tag,
+    // then tagHash["Holiday"] will be 2 at the end of the loop.
+    typedef QHash<QString, int> TagHash;
+    TagHash tagHash;
+
+    Q_FOREACH(const KFileItem & item, itemList) {
+        QModelIndex index = dirModel->indexForItem(item);
+
+        QVariant value = dirModel->data(index, SemanticInfoDirModel::RatingRole);
+        if (first) {
+            rating = ratingForVariant(value);
+        } else if (rating != ratingForVariant(value)) {
+            // Ratings aren't the same, reset
+            rating = 0;
+        }
+
+        QString indexDescription = index.data(SemanticInfoDirModel::DescriptionRole).toString();
+        if (first) {
+            description = indexDescription;
+        } else if (description != indexDescription) {
+            description.clear();
+        }
+
+        // Fill tagHash, incrementing the tag count if it's already there
+        TagSet tagSet = TagSet::fromVariant(index.data(SemanticInfoDirModel::TagsRole));
+        Q_FOREACH(const QString & tag, tagSet) {
+            TagHash::Iterator it = tagHash.find(tag);
+            if (it == tagHash.end()) {
+                tagHash[tag] = 1;
+            } else {
+                ++it.value();
+            }
+        }
+
+        first = false;
+    }
+    {
+        SignalBlocker blocker(d->mRatingWidget);
+        d->mRatingWidget->setRating(rating);
+    }
+    d->mDescriptionTextEdit->setText(description);
+
+    // Init tagInfo from tagHash
+    d->mTagInfo.clear();
+    int itemCount = itemList.count();
+    TagHash::ConstIterator
+    it = tagHash.constBegin(),
+    end = tagHash.constEnd();
+    for (; it != end; ++it) {
+        QString tag = it.key();
+        int count = it.value();
+        d->mTagInfo[tag] = count == itemCount;
+    }
+
+    bool enabled = !contextManager()->selectedFileItemList().isEmpty();
+    Q_FOREACH(KAction * action, d->mActions) {
+        action->setEnabled(enabled);
+    }
+    d->updateTagLabel();
+    if (d->mSemanticInfoDialog) {
+        d->updateSemanticInfoDialog();
+    }
+}
+
+void SemanticInfoContextManagerItem::slotRatingChanged(int rating)
+{
+    KFileItemList itemList = contextManager()->selectedFileItemList();
+
+    // Show rating indicator in view mode, and only if sidebar is not visible
+    if (d->mViewMainPage->isVisible() && !d->mRatingWidget->isVisible()) {
+        delete d->mRatingIndicator.data();
+        // FIXME QGV
+        //d->mRatingIndicator = new RatingIndicator(d->mViewMainPage->documentView());
+        d->mRatingIndicator = new RatingIndicator(d->mViewMainPage);
+        d->mRatingIndicator->setRating(rating);
+        d->mRatingIndicator->show();
+    }
+
+    SortedDirModel* dirModel = contextManager()->dirModel();
+    Q_FOREACH(const KFileItem & item, itemList) {
+        QModelIndex index = dirModel->indexForItem(item);
+        dirModel->setData(index, rating, SemanticInfoDirModel::RatingRole);
+    }
+}
+
+void SemanticInfoContextManagerItem::storeDescription()
+{
+    if (!d->mDescriptionTextEdit->document()->isModified()) {
+        return;
+    }
+    d->mDescriptionTextEdit->document()->setModified(false);
+    QString description = d->mDescriptionTextEdit->toPlainText();
+    KFileItemList itemList = contextManager()->selectedFileItemList();
+
+    SortedDirModel* dirModel = contextManager()->dirModel();
+    Q_FOREACH(const KFileItem & item, itemList) {
+        QModelIndex index = dirModel->indexForItem(item);
+        dirModel->setData(index, description, SemanticInfoDirModel::DescriptionRole);
+    }
+}
+
+void SemanticInfoContextManagerItem::assignTag(const SemanticInfoTag& tag)
+{
+    KFileItemList itemList = contextManager()->selectedFileItemList();
+
+    SortedDirModel* dirModel = contextManager()->dirModel();
+    Q_FOREACH(const KFileItem & item, itemList) {
+        QModelIndex index = dirModel->indexForItem(item);
+        TagSet tags = TagSet::fromVariant(dirModel->data(index, SemanticInfoDirModel::TagsRole));
+        if (!tags.contains(tag)) {
+            tags << tag;
+            dirModel->setData(index, tags.toVariant(), SemanticInfoDirModel::TagsRole);
+        }
+    }
+}
+
+void SemanticInfoContextManagerItem::removeTag(const SemanticInfoTag& tag)
+{
+    KFileItemList itemList = contextManager()->selectedFileItemList();
+
+    SortedDirModel* dirModel = contextManager()->dirModel();
+    Q_FOREACH(const KFileItem & item, itemList) {
+        QModelIndex index = dirModel->indexForItem(item);
+        TagSet tags = TagSet::fromVariant(dirModel->data(index, SemanticInfoDirModel::TagsRole));
+        if (tags.contains(tag)) {
+            tags.remove(tag);
+            dirModel->setData(index, tags.toVariant(), SemanticInfoDirModel::TagsRole);
+        }
+    }
+}
+
+void SemanticInfoContextManagerItem::showSemanticInfoDialog()
+{
+    if (!d->mSemanticInfoDialog) {
+        d->mSemanticInfoDialog = new SemanticInfoDialog(d->mGroup);
+        d->mSemanticInfoDialog->setAttribute(Qt::WA_DeleteOnClose, true);
+
+        connect(d->mSemanticInfoDialog->mPreviousButton, SIGNAL(clicked()),
+                d->mActionCollection->action("go_previous"), SLOT(trigger()));
+        connect(d->mSemanticInfoDialog->mNextButton, SIGNAL(clicked()),
+                d->mActionCollection->action("go_next"), SLOT(trigger()));
+        connect(d->mSemanticInfoDialog->mButtonBox, SIGNAL(rejected()),
+                d->mSemanticInfoDialog, SLOT(close()));
+
+        AbstractSemanticInfoBackEnd* backEnd = contextManager()->dirModel()->semanticInfoBackEnd();
+        d->mSemanticInfoDialog->mTagWidget->setSemanticInfoBackEnd(backEnd);
+        connect(d->mSemanticInfoDialog->mTagWidget, SIGNAL(tagAssigned(SemanticInfoTag)),
+                SLOT(assignTag(SemanticInfoTag)));
+        connect(d->mSemanticInfoDialog->mTagWidget, SIGNAL(tagRemoved(SemanticInfoTag)),
+                SLOT(removeTag(SemanticInfoTag)));
+    }
+    d->updateSemanticInfoDialog();
+    d->mSemanticInfoDialog->show();
+}
+
+bool SemanticInfoContextManagerItem::eventFilter(QObject*, QEvent* event)
+{
+    if (event->type() == QEvent::FocusOut) {
+        storeDescription();
+    }
+    return false;
+}
 
 } // namespace

=== modified file 'app/semanticinfocontextmanageritem.h'
--- app/semanticinfocontextmanageritem.h	2011-07-20 13:46:34 +0000
+++ app/semanticinfocontextmanageritem.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -31,35 +31,36 @@
 
 class KActionCollection;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-class DocumentPanel;
+class ViewMainPage;
 
 struct SemanticInfoContextManagerItemPrivate;
-class SemanticInfoContextManagerItem : public AbstractContextManagerItem {
-	Q_OBJECT
+class SemanticInfoContextManagerItem : public AbstractContextManagerItem
+{
+    Q_OBJECT
 public:
-	SemanticInfoContextManagerItem(ContextManager*, KActionCollection*, DocumentPanel* documentPanel);
-	~SemanticInfoContextManagerItem();
+    SemanticInfoContextManagerItem(ContextManager*, KActionCollection*, ViewMainPage* documentPanel);
+    ~SemanticInfoContextManagerItem();
 
 protected:
-	virtual bool eventFilter(QObject*, QEvent*);
+    virtual bool eventFilter(QObject*, QEvent*);
 
 private Q_SLOTS:
-	void slotSelectionChanged();
-	void update();
-	void slotRatingChanged(int rating);
-	void storeDescription();
-	void assignTag(const SemanticInfoTag&);
-	void removeTag(const SemanticInfoTag&);
-	void showSemanticInfoDialog();
+    void slotSelectionChanged();
+    void update();
+    void slotRatingChanged(int rating);
+    void storeDescription();
+    void assignTag(const SemanticInfoTag&);
+    void removeTag(const SemanticInfoTag&);
+    void showSemanticInfoDialog();
 
 private:
-	friend class SemanticInfoContextManagerItemPrivate;
-	SemanticInfoContextManagerItemPrivate* const d;
+    friend class SemanticInfoContextManagerItemPrivate;
+    SemanticInfoContextManagerItemPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* SEMANTICINFOCONTEXTMANAGERITEM_H */

=== modified file 'app/sidebar.cpp'
--- app/sidebar.cpp	2011-07-20 13:46:34 +0000
+++ app/sidebar.cpp	2011-12-15 14:17:54 +0000
@@ -40,210 +40,208 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 /**
  * A button which always leave room for an icon, even if there is none, so that
  * all button texts are correctly aligned.
  */
-class SideBarButton : public QToolButton {
+class SideBarButton : public QToolButton
+{
 protected:
-	virtual void paintEvent(QPaintEvent* event) {
-		forceIcon();
-		QToolButton::paintEvent(event);
-	}
+    virtual void paintEvent(QPaintEvent* event)
+    {
+        forceIcon();
+        QToolButton::paintEvent(event);
+    }
 
-	virtual QSize sizeHint() const {
-		const_cast<SideBarButton*>(this)->forceIcon();
-		return QToolButton::sizeHint();
-	}
+    virtual QSize sizeHint() const {
+        const_cast<SideBarButton*>(this)->forceIcon();
+        return QToolButton::sizeHint();
+    }
 
 private:
-	void forceIcon() {
-		if (!icon().isNull()) {
-			return;
-		}
-
-		// Assign an empty icon to the button if there is no icon associated
-		// with the action so that all button texts are correctly aligned.
-		QSize wantedSize = iconSize();
-		if (mEmptyIcon.isNull() || mEmptyIcon.actualSize(wantedSize) != wantedSize) {
-			QPixmap pix(wantedSize);
-			pix.fill(Qt::transparent);
-			mEmptyIcon.addPixmap(pix);
-		}
-		setIcon(mEmptyIcon);
-	}
-
-	QIcon mEmptyIcon;
+    void forceIcon()
+    {
+        if (!icon().isNull()) {
+            return;
+        }
+
+        // Assign an empty icon to the button if there is no icon associated
+        // with the action so that all button texts are correctly aligned.
+        QSize wantedSize = iconSize();
+        if (mEmptyIcon.isNull() || mEmptyIcon.actualSize(wantedSize) != wantedSize) {
+            QPixmap pix(wantedSize);
+            pix.fill(Qt::transparent);
+            mEmptyIcon.addPixmap(pix);
+        }
+        setIcon(mEmptyIcon);
+    }
+
+    QIcon mEmptyIcon;
 };
 
-
 //- SideBarGroup ---------------------------------------------------------------
 struct SideBarGroupPrivate {
-	QFrame* mContainer;
-	QLabel* mTitleLabel;
+    QFrame* mContainer;
+    QLabel* mTitleLabel;
 };
 
-
 SideBarGroup::SideBarGroup(const QString& title)
 : QFrame()
-, d(new SideBarGroupPrivate) {
-	d->mContainer = 0;
-	d->mTitleLabel = new QLabel(this);
-	d->mTitleLabel->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
-	d->mTitleLabel->setFixedHeight(d->mTitleLabel->sizeHint().height() * 3 / 2);
-	QFont font(d->mTitleLabel->font());
-	font.setBold(true);
-	d->mTitleLabel->setFont(font);
-	d->mTitleLabel->setText(title);
-
-	QVBoxLayout* layout = new QVBoxLayout(this);
-	layout->setMargin(0);
-	layout->setSpacing(0);
-
-	layout->addWidget(d->mTitleLabel);
-
-	clear();
-}
-
-
-SideBarGroup::~SideBarGroup() {
-	delete d;
-}
-
-
-void SideBarGroup::paintEvent(QPaintEvent* event) {
-	QFrame::paintEvent(event);
-	if (parentWidget()->layout()->indexOf(this) != 0) {
-		// Draw a separator, but only if we are not the first group
-		QPainter painter(this);
-		QPen pen(palette().mid().color());
-		painter.setPen(pen);
-		painter.drawLine(rect().topLeft(), rect().topRight());
-	}
-}
-
-
-void SideBarGroup::addWidget(QWidget* widget) {
-	widget->setParent(d->mContainer);
-	d->mContainer->layout()->addWidget(widget);
-}
-
-
-void SideBarGroup::clear() {
-	if (d->mContainer) {
-		d->mContainer->deleteLater();
-	}
-
-	d->mContainer = new QFrame(this);
-	QVBoxLayout* containerLayout = new QVBoxLayout(d->mContainer);
-	containerLayout->setMargin(0);
-	containerLayout->setSpacing(0);
-
-	layout()->addWidget(d->mContainer);
-}
-
-
-void SideBarGroup::addAction(QAction* action) {
-	int size = KIconLoader::global()->currentSize(KIconLoader::Small);
-	QToolButton* button = new SideBarButton();
-	button->setFocusPolicy(Qt::NoFocus);
-	button->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Fixed);
-	button->setAutoRaise(true);
-	button->setDefaultAction(action);
-	button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
-	button->setIconSize(QSize(size, size));
-	if (action->menu()) {
-		button->setPopupMode(QToolButton::InstantPopup);
-	}
-	addWidget(button);
-}
-
+, d(new SideBarGroupPrivate)
+{
+    d->mContainer = 0;
+    d->mTitleLabel = new QLabel(this);
+    d->mTitleLabel->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
+    d->mTitleLabel->setFixedHeight(d->mTitleLabel->sizeHint().height() * 3 / 2);
+    QFont font(d->mTitleLabel->font());
+    font.setBold(true);
+    d->mTitleLabel->setFont(font);
+    d->mTitleLabel->setText(title);
+
+    QVBoxLayout* layout = new QVBoxLayout(this);
+    layout->setMargin(0);
+    layout->setSpacing(0);
+
+    layout->addWidget(d->mTitleLabel);
+
+    clear();
+}
+
+SideBarGroup::~SideBarGroup()
+{
+    delete d;
+}
+
+void SideBarGroup::paintEvent(QPaintEvent* event)
+{
+    QFrame::paintEvent(event);
+    if (parentWidget()->layout()->indexOf(this) != 0) {
+        // Draw a separator, but only if we are not the first group
+        QPainter painter(this);
+        QPen pen(palette().mid().color());
+        painter.setPen(pen);
+        painter.drawLine(rect().topLeft(), rect().topRight());
+    }
+}
+
+void SideBarGroup::addWidget(QWidget* widget)
+{
+    widget->setParent(d->mContainer);
+    d->mContainer->layout()->addWidget(widget);
+}
+
+void SideBarGroup::clear()
+{
+    if (d->mContainer) {
+        d->mContainer->deleteLater();
+    }
+
+    d->mContainer = new QFrame(this);
+    QVBoxLayout* containerLayout = new QVBoxLayout(d->mContainer);
+    containerLayout->setMargin(0);
+    containerLayout->setSpacing(0);
+
+    layout()->addWidget(d->mContainer);
+}
+
+void SideBarGroup::addAction(QAction* action)
+{
+    int size = KIconLoader::global()->currentSize(KIconLoader::Small);
+    QToolButton* button = new SideBarButton();
+    button->setFocusPolicy(Qt::NoFocus);
+    button->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Fixed);
+    button->setAutoRaise(true);
+    button->setDefaultAction(action);
+    button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
+    button->setIconSize(QSize(size, size));
+    if (action->menu()) {
+        button->setPopupMode(QToolButton::InstantPopup);
+    }
+    addWidget(button);
+}
 
 //- SideBarPage ----------------------------------------------------------------
 struct SideBarPagePrivate {
-	QString mTitle;
-	QVBoxLayout* mLayout;
+    QString mTitle;
+    QVBoxLayout* mLayout;
 };
 
-
 SideBarPage::SideBarPage(const QString& title)
 : QWidget()
 , d(new SideBarPagePrivate)
 {
-	d->mTitle = title;
-
-	d->mLayout = new QVBoxLayout(this);
-	d->mLayout->setMargin(0);
-}
-
-
-SideBarPage::~SideBarPage() {
-	delete d;
-}
-
-
-const QString& SideBarPage::title() const {
-	return d->mTitle;
-}
-
-
-void SideBarPage::addWidget(QWidget* widget) {
-	d->mLayout->addWidget(widget);
-}
-
-
-void SideBarPage::addStretch() {
-	d->mLayout->addStretch();
-}
-
+    d->mTitle = title;
+
+    d->mLayout = new QVBoxLayout(this);
+    d->mLayout->setMargin(0);
+}
+
+SideBarPage::~SideBarPage()
+{
+    delete d;
+}
+
+const QString& SideBarPage::title() const
+{
+    return d->mTitle;
+}
+
+void SideBarPage::addWidget(QWidget* widget)
+{
+    d->mLayout->addWidget(widget);
+}
+
+void SideBarPage::addStretch()
+{
+    d->mLayout->addStretch();
+}
 
 //- SideBar --------------------------------------------------------------------
 struct SideBarPrivate {
 };
 
-
 SideBar::SideBar(QWidget* parent)
 : QTabWidget(parent)
-, d(new SideBarPrivate) {
-	setFont(KGlobalSettings::smallestReadableFont());
-	tabBar()->setDocumentMode(true);
-	tabBar()->setUsesScrollButtons(false);
-	tabBar()->setFocusPolicy(Qt::NoFocus);
-	setTabPosition(QTabWidget::South);
-	setElideMode(Qt::ElideRight);
-}
-
-
-SideBar::~SideBar() {
-	delete d;
-}
-
-
-QSize SideBar::sizeHint() const {
-	return QSize(200, 200);
-}
-
-
-void SideBar::addPage(SideBarPage* page) {
-	addTab(page, page->title());
-}
-
-
-QString SideBar::currentPage() const {
-	return currentWidget()->objectName();
-}
-
-
-void SideBar::setCurrentPage(const QString& name) {
-	for (int index = 0; index < count(); ++index) {
-		if (widget(index)->objectName() == name) {
-			setCurrentIndex(index);
-		}
-	}
-}
-
+, d(new SideBarPrivate)
+{
+    setFont(KGlobalSettings::smallestReadableFont());
+    tabBar()->setDocumentMode(true);
+    tabBar()->setUsesScrollButtons(false);
+    tabBar()->setFocusPolicy(Qt::NoFocus);
+    setTabPosition(QTabWidget::South);
+    setElideMode(Qt::ElideRight);
+}
+
+SideBar::~SideBar()
+{
+    delete d;
+}
+
+QSize SideBar::sizeHint() const
+{
+    return QSize(200, 200);
+}
+
+void SideBar::addPage(SideBarPage* page)
+{
+    addTab(page, page->title());
+}
+
+QString SideBar::currentPage() const
+{
+    return currentWidget()->objectName();
+}
+
+void SideBar::setCurrentPage(const QString& name)
+{
+    for (int index = 0; index < count(); ++index) {
+        if (widget(index)->objectName() == name) {
+            setCurrentIndex(index);
+        }
+    }
+}
 
 } // namespace

=== modified file 'app/sidebar.h'
--- app/sidebar.h	2011-07-20 13:46:34 +0000
+++ app/sidebar.h	2011-12-15 14:17:54 +0000
@@ -24,62 +24,63 @@
 #include <QFrame>
 #include <QTabWidget>
 
-
-namespace Gwenview {
+namespace Gwenview
+{
 
 class SideBar;
 
 class SideBarGroupPrivate;
-class SideBarGroup : public QFrame {
-	Q_OBJECT
+class SideBarGroup : public QFrame
+{
+    Q_OBJECT
 public:
-	SideBarGroup(const QString& title);
-	~SideBarGroup();
+    SideBarGroup(const QString& title);
+    ~SideBarGroup();
 
-	void addWidget(QWidget*);
-	void addAction(QAction*);
-	void clear();
+    void addWidget(QWidget*);
+    void addAction(QAction*);
+    void clear();
 
 protected:
-	virtual void paintEvent(QPaintEvent*);
+    virtual void paintEvent(QPaintEvent*);
 
 private:
-	SideBarGroupPrivate* const d;
+    SideBarGroupPrivate* const d;
 };
 
-
 class SideBarPagePrivate;
-class SideBarPage : public QWidget {
-	Q_OBJECT
+class SideBarPage : public QWidget
+{
+    Q_OBJECT
 public:
-	SideBarPage(const QString& title);
-	~SideBarPage();
-	void addWidget(QWidget*);
-	void addStretch();
+    SideBarPage(const QString& title);
+    ~SideBarPage();
+    void addWidget(QWidget*);
+    void addStretch();
 
-	const QString& title() const;
+    const QString& title() const;
 
 private:
-	SideBarPagePrivate* const d;
+    SideBarPagePrivate* const d;
 };
 
-
 class SideBarPrivate;
-class SideBar : public QTabWidget {
-	Q_OBJECT
+class SideBar : public QTabWidget
+{
+    Q_OBJECT
 public:
-	SideBar(QWidget* parent);
-	~SideBar();
-
-	void addPage(SideBarPage*);
-
-	QString currentPage() const;
-	void setCurrentPage(const QString& name);
-
-	virtual QSize sizeHint() const;
+    SideBar(QWidget* parent);
+    ~SideBar();
+
+    void addPage(SideBarPage*);
+
+    QString currentPage() const;
+    void setCurrentPage(const QString& name);
+
+    virtual QSize sizeHint() const;
 
 private:
-	SideBarPrivate* const d;
+    SideBarPrivate* const d;
 };
 
 } // namespace

=== modified file 'app/slideshow.desktop'
--- app/slideshow.desktop	2011-12-08 21:34:25 +0000
+++ app/slideshow.desktop	2011-12-15 14:17:54 +0000
@@ -45,6 +45,7 @@
 Name[pt_BR]=Iniciar uma apresentação de slides
 Name[ro]=Pornește o prezentare
 Name[ru]=Запустить слайд-шоу
+Name[si]=සලයිඩ දර්ශනය ආරඹන්න
 Name[sk]=Spustiť prezentáciu
 Name[sl]=Začni predstavitev
 Name[sr]=Покрени слајдшоу
@@ -54,7 +55,6 @@
 Name[sv]=Starta ett bildspel
 Name[th]=เริ่มการนำเสนอ
 Name[tr]=Bir Slayt Gösterisi Başlat
-Name[ug]=تام تەسۋىرى باشلايدۇ
 Name[uk]=Почати показ слайдів
 Name[x-test]=xxStart a Slideshowxx
 Name[zh_CN]=以幻灯模式启动

=== modified file 'app/splitter.h'
--- app/splitter.h	2011-07-20 13:46:34 +0000
+++ app/splitter.h	2011-12-15 14:17:54 +0000
@@ -24,50 +24,49 @@
 #include <QPainter>
 #include <QSplitter>
 
-
-namespace Gwenview {
-
-
-class SplitterHandle : public QSplitterHandle {
+namespace Gwenview
+{
+
+class SplitterHandle : public QSplitterHandle
+{
 public:
-	SplitterHandle(Qt::Orientation orientation, QSplitter* parent)
-	: QSplitterHandle(orientation, parent) {}
+    SplitterHandle(Qt::Orientation orientation, QSplitter* parent)
+        : QSplitterHandle(orientation, parent) {}
 
 protected:
-	virtual void paintEvent(QPaintEvent* event) {
-		QSplitterHandle::paintEvent(event);
+    virtual void paintEvent(QPaintEvent* event) {
+        QSplitterHandle::paintEvent(event);
 
-		QPainter painter(this);
-		painter.setPen(palette().mid().color());
-		if (orientation() == Qt::Vertical) {
-			painter.drawLine(rect().topLeft(), rect().topRight());
-			painter.drawLine(rect().bottomLeft(), rect().bottomRight());
-		} else {
-			//painter.drawLine(rect().topLeft(), rect().bottomLeft());
-			painter.drawLine(rect().topRight(), rect().bottomRight());
-		}
-	}
+        QPainter painter(this);
+        painter.setPen(palette().mid().color());
+        if (orientation() == Qt::Vertical) {
+            painter.drawLine(rect().topLeft(), rect().topRight());
+            painter.drawLine(rect().bottomLeft(), rect().bottomRight());
+        } else {
+            //painter.drawLine(rect().topLeft(), rect().bottomLeft());
+            painter.drawLine(rect().topRight(), rect().bottomRight());
+        }
+    }
 };
 
-
 /**
  * Home made splitter to be able to define a custom handle which is border with
  * "mid" colored lines.
  */
-class Splitter : public QSplitter {
+class Splitter : public QSplitter
+{
 public:
-	Splitter(Qt::Orientation orientation, QWidget* parent)
-	: QSplitter(orientation, parent) {
-		setHandleWidth(handleWidth() + 2);
-	}
+    Splitter(Qt::Orientation orientation, QWidget* parent)
+        : QSplitter(orientation, parent) {
+        setHandleWidth(handleWidth() + 2);
+    }
 
 protected:
-	virtual QSplitterHandle* createHandle() {
-		return new SplitterHandle(orientation(), this);
-	}
+    virtual QSplitterHandle* createHandle() {
+        return new SplitterHandle(orientation(), this);
+    }
 };
 
-
 } // namespace
 
 #endif /* SPLITTER_H */

=== added file 'app/startmainpage.cpp'
--- app/startmainpage.cpp	1970-01-01 00:00:00 +0000
+++ app/startmainpage.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,332 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "startmainpage.moc"
+
+#include <config-gwenview.h>
+
+// Qt
+#include <QListView>
+#include <QMenu>
+#include <QPlastiqueStyle>
+#include <QStyledItemDelegate>
+
+// KDE
+#include <kfileplacesmodel.h>
+#include <kglobalsettings.h>
+#include <kicon.h>
+#include <kmimetype.h>
+
+// Local
+#include <gvcore.h>
+#include <ui_startmainpage.h>
+#include <lib/flowlayout.h>
+#include <lib/gwenviewconfig.h>
+#include <lib/thumbnailview/abstractthumbnailviewhelper.h>
+#include <lib/thumbnailview/previewitemdelegate.h>
+
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+#include <lib/semanticinfo/tagmodel.h>
+#endif
+
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
+#include <nepomuk/resourcemanager.h>
+#include <nepomuk/tag.h>
+#endif
+
+namespace Gwenview
+{
+
+class HistoryThumbnailViewHelper : public AbstractThumbnailViewHelper
+{
+public:
+    HistoryThumbnailViewHelper(QObject* parent)
+        : AbstractThumbnailViewHelper(parent)
+    {}
+
+    virtual void showContextMenu(QWidget*)
+    {
+    }
+
+    virtual void showMenuForUrlDroppedOnViewport(QWidget*, const KUrl::List&)
+    {
+    }
+
+    virtual void showMenuForUrlDroppedOnDir(QWidget*, const KUrl::List&, const KUrl&)
+    {
+    }
+};
+
+/**
+ * Inherit from QStyledItemDelegate to match KFilePlacesViewDelegate sizeHint
+ * height.
+ */
+class HistoryViewDelegate : public QStyledItemDelegate
+{
+public:
+    HistoryViewDelegate(QObject* parent = 0)
+        : QStyledItemDelegate(parent) {}
+
+    virtual QSize sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const {
+        QSize sh = QStyledItemDelegate::sizeHint(option, index);
+        int iconSize = static_cast<QAbstractItemView*>(parent())->iconSize().height();
+        // Copied from KFilePlacesViewDelegate::sizeHint()
+        int height = option.fontMetrics.height() / 2 + qMax(iconSize, option.fontMetrics.height());
+        sh.setHeight(qMax(sh.height(), height));
+        return sh;
+    }
+};
+
+struct StartMainPagePrivate : public Ui_StartMainPage {
+    StartMainPage* q;
+    GvCore* mGvCore;
+    KFilePlacesModel* mBookmarksModel;
+    bool mSearchUiInitialized;
+
+    void setupSearchUi()
+    {
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
+        if (Nepomuk::ResourceManager::instance()->init() == 0) {
+            mTagView->setModel(TagModel::createAllTagsModel(mTagView, mGvCore->semanticInfoBackEnd()));
+            mTagView->show();
+            mTagLabel->hide();
+        } else {
+            mTagView->hide();
+            mTagLabel->show();
+        }
+#else
+        mTagView->hide();
+        mTagLabel->hide();
+#endif
+    }
+
+    void updateHistoryTab()
+    {
+        mHistoryWidget->setVisible(GwenviewConfig::historyEnabled());
+        mHistoryDisabledLabel->setVisible(!GwenviewConfig::historyEnabled());
+    }
+};
+
+static void initViewPalette(QAbstractItemView* view, const QColor& fgColor)
+{
+    QWidget* viewport = view->viewport();
+    QPalette palette = viewport->palette();
+    palette.setColor(viewport->backgroundRole(), Qt::transparent);
+    palette.setColor(QPalette::WindowText, fgColor);
+    palette.setColor(QPalette::Text, fgColor);
+
+    // QListView uses QStyledItemDelegate, which uses the view palette for
+    // foreground color, while KFilePlacesView uses the viewport palette.
+    viewport->setPalette(palette);
+    view->setPalette(palette);
+}
+
+static bool styleIsGtkBased()
+{
+    const char* name = QApplication::style()->metaObject()->className();
+    return qstrcmp(name, "QGtkStyle") == 0;
+}
+
+StartMainPage::StartMainPage(QWidget* parent, GvCore* gvCore)
+: QFrame(parent)
+, d(new StartMainPagePrivate)
+{
+    d->q = this;
+    d->mGvCore = gvCore;
+    d->mSearchUiInitialized = false;
+
+    d->setupUi(this);
+    if (styleIsGtkBased()) {
+        // Gtk-based styles do not apply the correct background color on tabs.
+        // As a workaround, use the Plastique style instead.
+        QStyle* fix = new QPlastiqueStyle();
+        fix->setParent(this);
+        d->mHistoryWidget->tabBar()->setStyle(fix);
+        d->mPlacesTagsWidget->tabBar()->setStyle(fix);
+    }
+    setFrameStyle(QFrame::NoFrame);
+
+    // Bookmark view
+    d->mBookmarksModel = new KFilePlacesModel(this);
+
+    d->mBookmarksView->setModel(d->mBookmarksModel);
+    d->mBookmarksView->setAutoResizeItemsEnabled(false);
+
+    connect(d->mBookmarksView, SIGNAL(urlChanged(KUrl)),
+            SIGNAL(urlSelected(KUrl)));
+
+    // Tag view
+    connect(d->mTagView, SIGNAL(clicked(QModelIndex)),
+            SLOT(slotTagViewClicked(QModelIndex)));
+
+    // Recent folder view
+    connect(d->mRecentFoldersView, SIGNAL(indexActivated(QModelIndex)),
+            SLOT(slotListViewActivated(QModelIndex)));
+
+    connect(d->mRecentFoldersView, SIGNAL(customContextMenuRequested(QPoint)),
+            SLOT(showRecentFoldersViewContextMenu(QPoint)));
+
+    // Url bag view
+    d->mRecentUrlsView->setItemDelegate(new HistoryViewDelegate(d->mRecentUrlsView));
+
+    connect(d->mRecentUrlsView, SIGNAL(customContextMenuRequested(QPoint)),
+            SLOT(showRecentFoldersViewContextMenu(QPoint)));
+
+    if (KGlobalSettings::singleClick()) {
+        if (KGlobalSettings::changeCursorOverIcon()) {
+            d->mRecentUrlsView->setCursor(Qt::PointingHandCursor);
+        }
+        connect(d->mRecentUrlsView, SIGNAL(clicked(QModelIndex)),
+                SLOT(slotListViewActivated(QModelIndex)));
+    } else {
+        connect(d->mRecentUrlsView, SIGNAL(doubleClicked(QModelIndex)),
+                SLOT(slotListViewActivated(QModelIndex)));
+    }
+
+    d->updateHistoryTab();
+    connect(GwenviewConfig::self(), SIGNAL(configChanged()),
+            SLOT(slotConfigChanged()));
+}
+
+StartMainPage::~StartMainPage()
+{
+    delete d;
+}
+
+void StartMainPage::slotTagViewClicked(const QModelIndex& index)
+{
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
+    if (!index.isValid()) {
+        return;
+    }
+    // FIXME: Check label encoding
+    Nepomuk::Tag tagr(index.data().toString());
+    KUrl url = KUrl(tagr.resourceUri()).url();
+    emit urlSelected(url);
+#endif
+}
+
+void StartMainPage::applyPalette(const QPalette& newPalette)
+{
+    QColor fgColor = newPalette.text().color();
+
+    QPalette pal = palette();
+    pal.setBrush(backgroundRole(), newPalette.base());
+    pal.setBrush(QPalette::Button, newPalette.base());
+    pal.setBrush(QPalette::WindowText, fgColor);
+    pal.setBrush(QPalette::ButtonText, fgColor);
+    pal.setBrush(QPalette::Text, fgColor);
+    setPalette(pal);
+
+    initViewPalette(d->mBookmarksView, fgColor);
+    initViewPalette(d->mTagView, fgColor);
+    initViewPalette(d->mRecentFoldersView, fgColor);
+    initViewPalette(d->mRecentUrlsView, fgColor);
+}
+
+void StartMainPage::slotListViewActivated(const QModelIndex& index)
+{
+    if (!index.isValid()) {
+        return;
+    }
+    QVariant data = index.data(KFilePlacesModel::UrlRole);
+    KUrl url = data.toUrl();
+
+    // Prevent dir lister error
+    if (!url.isValid()) {
+        kError() << "Tried to open an invalid url";
+        return;
+    }
+    emit urlSelected(url);
+}
+
+void StartMainPage::showEvent(QShowEvent* event)
+{
+    if (GwenviewConfig::historyEnabled()) {
+        if (!d->mRecentFoldersView->model()) {
+            d->mRecentFoldersView->setThumbnailViewHelper(new HistoryThumbnailViewHelper(d->mRecentFoldersView));
+            d->mRecentFoldersView->setModel(d->mGvCore->recentFoldersModel());
+            PreviewItemDelegate* delegate = new PreviewItemDelegate(d->mRecentFoldersView);
+            delegate->setContextBarMode(PreviewItemDelegate::NoContextBar);
+            delegate->setTextElideMode(Qt::ElideLeft);
+            d->mRecentFoldersView->setItemDelegate(delegate);
+            d->mRecentFoldersView->setThumbnailSize(128);
+        }
+        if (!d->mRecentUrlsView->model()) {
+            d->mRecentUrlsView->setModel(d->mGvCore->recentUrlsModel());
+        }
+    }
+    if (!d->mSearchUiInitialized) {
+        d->mSearchUiInitialized = true;
+        d->setupSearchUi();
+    }
+    QFrame::showEvent(event);
+}
+
+void StartMainPage::showRecentFoldersViewContextMenu(const QPoint& pos)
+{
+    QAbstractItemView* view = qobject_cast<QAbstractItemView*>(sender());
+    KUrl url;
+    QModelIndex index = view->indexAt(pos);
+    if (index.isValid()) {
+        QVariant data = index.data(KFilePlacesModel::UrlRole);
+        url = data.toUrl();
+    }
+
+    // Create menu
+    QMenu menu(this);
+    bool fromRecentUrls = view == d->mRecentUrlsView;
+    QAction* addToPlacesAction = fromRecentUrls ? 0 : menu.addAction(KIcon("bookmark-new"), i18n("Add to Places"));
+    QAction* removeAction = menu.addAction(KIcon("edit-delete"), fromRecentUrls ? i18n("Forget this URL") : i18n("Forget this Folder"));
+    menu.addSeparator();
+    QAction* clearAction = menu.addAction(KIcon("edit-delete-all"), i18n("Forget All"));
+
+    if (!index.isValid()) {
+        if (addToPlacesAction) {
+            addToPlacesAction->setEnabled(false);
+        }
+        removeAction->setEnabled(false);
+    }
+
+    // Handle menu
+    QAction* action = menu.exec(view->mapToGlobal(pos));
+    if (!action) {
+        return;
+    }
+    if (action == addToPlacesAction) {
+        QString text = url.fileName();
+        if (text.isEmpty()) {
+            text = url.pathOrUrl();
+        }
+        d->mBookmarksModel->addPlace(text, url);
+    } else if (action == removeAction) {
+        view->model()->removeRow(index.row());
+    } else if (action == clearAction) {
+        view->model()->removeRows(0, view->model()->rowCount());
+    }
+}
+
+void StartMainPage::slotConfigChanged()
+{
+    d->updateHistoryTab();
+}
+
+} // namespace

=== added file 'app/startmainpage.h'
--- app/startmainpage.h	1970-01-01 00:00:00 +0000
+++ app/startmainpage.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,70 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef STARTMAINPAGE_H
+#define STARTMAINPAGE_H
+
+// Qt
+#include <QFrame>
+
+// KDE
+
+// Local
+
+class QModelIndex;
+class QPalette;
+class QShowEvent;
+
+class KUrl;
+
+namespace Gwenview
+{
+
+class GvCore;
+
+class StartMainPagePrivate;
+class StartMainPage : public QFrame
+{
+    Q_OBJECT
+public:
+    StartMainPage(QWidget* parent, GvCore*);
+    ~StartMainPage();
+
+    void applyPalette(const QPalette&);
+
+Q_SIGNALS:
+    void urlSelected(const KUrl& url);
+
+protected:
+    virtual void showEvent(QShowEvent*);
+
+private Q_SLOTS:
+    void slotListViewActivated(const QModelIndex& index);
+    void showRecentFoldersViewContextMenu(const QPoint& pos);
+    void slotTagViewClicked(const QModelIndex& index);
+    void slotConfigChanged();
+
+private:
+    StartMainPagePrivate* const d;
+};
+
+} // namespace
+
+#endif /* STARTMAINPAGE_H */

=== added file 'app/startmainpage.ui'
--- app/startmainpage.ui	1970-01-01 00:00:00 +0000
+++ app/startmainpage.ui	2011-12-15 14:17:54 +0000
@@ -0,0 +1,190 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>StartMainPage</class>
+ <widget class="QFrame" name="StartMainPage">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>584</width>
+    <height>618</height>
+   </rect>
+  </property>
+  <property name="autoFillBackground">
+   <bool>true</bool>
+  </property>
+  <property name="frameShape">
+   <enum>QFrame::StyledPanel</enum>
+  </property>
+  <property name="frameShadow">
+   <enum>QFrame::Sunken</enum>
+  </property>
+  <layout class="QHBoxLayout" name="horizontalLayout">
+   <item>
+    <layout class="QVBoxLayout" name="verticalLayout_4">
+     <item>
+      <widget class="QLabel" name="mHistoryDisabledLabel">
+       <property name="sizePolicy">
+        <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
+         <horstretch>0</horstretch>
+         <verstretch>0</verstretch>
+        </sizepolicy>
+       </property>
+       <property name="text">
+        <string>History has been disabled.</string>
+       </property>
+       <property name="alignment">
+        <set>Qt::AlignHCenter|Qt::AlignTop</set>
+       </property>
+      </widget>
+     </item>
+     <item>
+      <widget class="KTabWidget" name="mHistoryWidget">
+       <property name="currentIndex">
+        <number>0</number>
+       </property>
+       <property name="documentMode">
+        <bool>true</bool>
+       </property>
+       <widget class="QWidget" name="tab">
+        <attribute name="title">
+         <string>Recent Folders</string>
+        </attribute>
+        <layout class="QVBoxLayout" name="verticalLayout_5">
+         <item>
+          <widget class="Gwenview::ThumbnailView" name="mRecentFoldersView">
+           <property name="editTriggers">
+            <set>QAbstractItemView::NoEditTriggers</set>
+           </property>
+          </widget>
+         </item>
+        </layout>
+       </widget>
+       <widget class="QWidget" name="tab_2">
+        <attribute name="title">
+         <string>Recent URLs</string>
+        </attribute>
+        <layout class="QVBoxLayout" name="verticalLayout_6">
+         <item>
+          <widget class="QListView" name="mRecentUrlsView">
+           <property name="contextMenuPolicy">
+            <enum>Qt::CustomContextMenu</enum>
+           </property>
+           <property name="frameShape">
+            <enum>QFrame::NoFrame</enum>
+           </property>
+           <property name="editTriggers">
+            <set>QAbstractItemView::NoEditTriggers</set>
+           </property>
+           <property name="iconSize">
+            <size>
+             <width>32</width>
+             <height>32</height>
+            </size>
+           </property>
+          </widget>
+         </item>
+        </layout>
+       </widget>
+      </widget>
+     </item>
+    </layout>
+   </item>
+   <item>
+    <widget class="KTabWidget" name="mPlacesTagsWidget">
+     <property name="sizePolicy">
+      <sizepolicy hsizetype="Preferred" vsizetype="Expanding">
+       <horstretch>0</horstretch>
+       <verstretch>0</verstretch>
+      </sizepolicy>
+     </property>
+     <property name="currentIndex">
+      <number>0</number>
+     </property>
+     <property name="documentMode">
+      <bool>true</bool>
+     </property>
+     <widget class="QWidget" name="placesTab">
+      <attribute name="title">
+       <string>Places</string>
+      </attribute>
+      <layout class="QVBoxLayout" name="verticalLayout_2">
+       <item>
+        <widget class="KFilePlacesView" name="mBookmarksView">
+         <property name="cursor" stdset="0">
+          <cursorShape>PointingHandCursor</cursorShape>
+         </property>
+         <property name="frameShape">
+          <enum>QFrame::NoFrame</enum>
+         </property>
+         <property name="iconSize">
+          <size>
+           <width>32</width>
+           <height>32</height>
+          </size>
+         </property>
+        </widget>
+       </item>
+      </layout>
+     </widget>
+     <widget class="QWidget" name="tagsTab">
+      <attribute name="title">
+       <string>Tags</string>
+      </attribute>
+      <layout class="QVBoxLayout" name="verticalLayout">
+       <item>
+        <widget class="QLabel" name="mTagLabel">
+         <property name="text">
+          <string>Browsing by tags is not available. Make sure Nepomuk is properly installed on your computer.</string>
+         </property>
+         <property name="alignment">
+          <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignTop</set>
+         </property>
+         <property name="wordWrap">
+          <bool>true</bool>
+         </property>
+        </widget>
+       </item>
+       <item>
+        <widget class="QListView" name="mTagView">
+         <property name="cursor" stdset="0">
+          <cursorShape>PointingHandCursor</cursorShape>
+         </property>
+         <property name="frameShape">
+          <enum>QFrame::NoFrame</enum>
+         </property>
+         <property name="iconSize">
+          <size>
+           <width>32</width>
+           <height>32</height>
+          </size>
+         </property>
+        </widget>
+       </item>
+      </layout>
+     </widget>
+    </widget>
+   </item>
+  </layout>
+ </widget>
+ <customwidgets>
+  <customwidget>
+   <class>KTabWidget</class>
+   <extends>QTabWidget</extends>
+   <header>ktabwidget.h</header>
+   <container>1</container>
+  </customwidget>
+  <customwidget>
+   <class>KFilePlacesView</class>
+   <extends>QListView</extends>
+   <header location="global">kfileplacesview.h</header>
+  </customwidget>
+  <customwidget>
+   <class>Gwenview::ThumbnailView</class>
+   <extends>QListView</extends>
+   <header location="global">lib/thumbnailview/thumbnailview.h</header>
+  </customwidget>
+ </customwidgets>
+ <resources/>
+ <connections/>
+</ui>

=== removed file 'app/startpage.cpp'
--- app/startpage.cpp	2011-07-20 13:46:34 +0000
+++ app/startpage.cpp	1970-01-01 00:00:00 +0000
@@ -1,324 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
-
-*/
-// Self
-#include "startpage.moc"
-
-#include <config-gwenview.h>
-
-// Qt
-#include <QListView>
-#include <QMenu>
-#include <QPlastiqueStyle>
-#include <QStyledItemDelegate>
-
-// KDE
-#include <kfileplacesmodel.h>
-#include <kglobalsettings.h>
-#include <kicon.h>
-#include <kmimetype.h>
-
-// Local
-#include <gvcore.h>
-#include <ui_startpage.h>
-#include <lib/flowlayout.h>
-#include <lib/gwenviewconfig.h>
-#include <lib/thumbnailview/abstractthumbnailviewhelper.h>
-#include <lib/thumbnailview/previewitemdelegate.h>
-
-#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-#include <lib/semanticinfo/tagmodel.h>
-#endif
-
-#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
-#include <nepomuk/resourcemanager.h>
-#include <nepomuk/tag.h>
-#endif
-
-
-namespace Gwenview {
-
-class HistoryThumbnailViewHelper : public AbstractThumbnailViewHelper {
-public:
-	HistoryThumbnailViewHelper(QObject* parent)
-	: AbstractThumbnailViewHelper(parent)
-	{}
-
-	virtual void showContextMenu(QWidget*) {
-	}
-
-	virtual void showMenuForUrlDroppedOnViewport(QWidget*, const KUrl::List&) {
-	}
-
-	virtual void showMenuForUrlDroppedOnDir(QWidget*, const KUrl::List&, const KUrl&) {
-	}
-};
-
-/**
- * Inherit from QStyledItemDelegate to match KFilePlacesViewDelegate sizeHint
- * height.
- */
-class HistoryViewDelegate : public QStyledItemDelegate {
-public:
-	HistoryViewDelegate(QObject* parent = 0)
-	: QStyledItemDelegate(parent) {}
-
-	virtual QSize sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const {
-		QSize sh = QStyledItemDelegate::sizeHint(option, index);
-		int iconSize = static_cast<QAbstractItemView*>(parent())->iconSize().height();
-		// Copied from KFilePlacesViewDelegate::sizeHint()
-		int height = option.fontMetrics.height() / 2 + qMax(iconSize, option.fontMetrics.height());
-		sh.setHeight(qMax(sh.height(), height));
-		return sh;
-	}
-};
-
-
-struct StartPagePrivate : public Ui_StartPage{
-	StartPage* that;
-	GvCore* mGvCore;
-	KFilePlacesModel* mBookmarksModel;
-	bool mSearchUiInitialized;
-
-	void setupSearchUi() {
-	#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
-		if (Nepomuk::ResourceManager::instance()->init() == 0) {
-			mTagView->setModel(TagModel::createAllTagsModel(mTagView, mGvCore->semanticInfoBackEnd()));
-			mTagView->show();
-			mTagLabel->hide();
-		} else {
-			mTagView->hide();
-			mTagLabel->show();
-		}
-	#else
-		mTagView->hide();
-		mTagLabel->hide();
-	#endif
-	}
-
-	void updateHistoryTab() {
-		mHistoryWidget->setVisible(GwenviewConfig::historyEnabled());
-		mHistoryDisabledLabel->setVisible(!GwenviewConfig::historyEnabled());
-	}
-};
-
-static void initViewPalette(QAbstractItemView* view, const QColor& fgColor) {
-	QWidget* viewport = view->viewport();
-	QPalette palette = viewport->palette();
-	palette.setColor(viewport->backgroundRole(), Qt::transparent);
-	palette.setColor(QPalette::WindowText, fgColor);
-	palette.setColor(QPalette::Text, fgColor);
-
-	// QListView uses QStyledItemDelegate, which uses the view palette for
-	// foreground color, while KFilePlacesView uses the viewport palette.
-	viewport->setPalette(palette);
-	view->setPalette(palette);
-}
-
-static bool styleIsGtkBased() {
-	const char* name = QApplication::style()->metaObject()->className();
-	return qstrcmp(name, "QGtkStyle") == 0;
-}
-
-StartPage::StartPage(QWidget* parent, GvCore* gvCore)
-: QFrame(parent)
-, d(new StartPagePrivate) {
-	d->that = this;
-	d->mGvCore = gvCore;
-	d->mSearchUiInitialized = false;
-
-	d->setupUi(this);
-	if (styleIsGtkBased()) {
-		// Gtk-based styles do not apply the correct background color on tabs.
-		// As a workaround, use the Plastique style instead.
-		QStyle* fix = new QPlastiqueStyle();
-		fix->setParent(this);
-		d->mHistoryWidget->tabBar()->setStyle(fix);
-		d->mPlacesTagsWidget->tabBar()->setStyle(fix);
-	}
-	setFrameStyle(QFrame::NoFrame);
-
-	// Bookmark view
-	d->mBookmarksModel = new KFilePlacesModel(this);
-
-	d->mBookmarksView->setModel(d->mBookmarksModel);
-	d->mBookmarksView->setAutoResizeItemsEnabled(false);
-
-	connect(d->mBookmarksView, SIGNAL(urlChanged(const KUrl&)),
-		SIGNAL(urlSelected(const KUrl&)) );
-
-	// Tag view
-	connect(d->mTagView, SIGNAL(clicked(const QModelIndex&)),
-		SLOT(slotTagViewClicked(const QModelIndex&)));
-
-	// Recent folder view
-	connect(d->mRecentFoldersView, SIGNAL(indexActivated(const QModelIndex&)),
-		SLOT(slotListViewActivated(const QModelIndex&)) );
-
-	connect(d->mRecentFoldersView, SIGNAL(customContextMenuRequested(const QPoint&)),
-		SLOT(showRecentFoldersViewContextMenu(const QPoint&)));
-
-	// Url bag view
-	d->mRecentUrlsView->setItemDelegate(new HistoryViewDelegate(d->mRecentUrlsView));
-
-	connect(d->mRecentUrlsView, SIGNAL(customContextMenuRequested(const QPoint&)),
-		SLOT(showRecentFoldersViewContextMenu(const QPoint&)));
-
-	if (KGlobalSettings::singleClick()) {
-		if (KGlobalSettings::changeCursorOverIcon()) {
-			d->mRecentUrlsView->setCursor(Qt::PointingHandCursor);
-		}
-		connect(d->mRecentUrlsView, SIGNAL(clicked(const QModelIndex&)),
-			SLOT(slotListViewActivated(const QModelIndex&)) );
-	} else {
-		connect(d->mRecentUrlsView, SIGNAL(doubleClicked(const QModelIndex&)),
-			SLOT(slotListViewActivated(const QModelIndex&)) );
-	}
-
-	d->updateHistoryTab();
-	connect(GwenviewConfig::self(), SIGNAL(configChanged()),
-		SLOT(slotConfigChanged()));
-}
-
-
-StartPage::~StartPage() {
-	delete d;
-}
-
-
-void StartPage::slotTagViewClicked(const QModelIndex& index) {
-#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
-	if (!index.isValid()) {
-		return;
-	}
-	// FIXME: Check label encoding
-	Nepomuk::Tag tagr(index.data().toString());
-	KUrl url = KUrl(tagr.resourceUri()).url();
-	emit urlSelected(url);
-#endif
-}
-
-
-void StartPage::applyPalette(const QPalette& newPalette) {
-	QColor fgColor = newPalette.text().color();
-
-	QPalette pal = palette();
-	pal.setBrush(backgroundRole(), newPalette.base());
-	pal.setBrush(QPalette::Button, newPalette.base());
-	pal.setBrush(QPalette::WindowText, fgColor);
-	pal.setBrush(QPalette::ButtonText, fgColor);
-	pal.setBrush(QPalette::Text, fgColor);
-	setPalette(pal);
-
-	initViewPalette(d->mBookmarksView, fgColor);
-	initViewPalette(d->mTagView, fgColor);
-	initViewPalette(d->mRecentFoldersView, fgColor);
-	initViewPalette(d->mRecentUrlsView, fgColor);
-}
-
-
-void StartPage::slotListViewActivated(const QModelIndex& index) {
-	if (!index.isValid()) {
-		return;
-	}
-	QVariant data = index.data(KFilePlacesModel::UrlRole);
-	KUrl url = data.toUrl();
-
-	// Prevent dir lister error
-	if (!url.isValid()) {
-		kError() << "Tried to open an invalid url";
-		return;
-	}
-	emit urlSelected(url);
-}
-
-
-void StartPage::showEvent(QShowEvent* event) {
-	if (GwenviewConfig::historyEnabled()) {
-		if (!d->mRecentFoldersView->model()) {
-			d->mRecentFoldersView->setThumbnailViewHelper(new HistoryThumbnailViewHelper(d->mRecentFoldersView));
-			d->mRecentFoldersView->setModel(d->mGvCore->recentFoldersModel());
-			PreviewItemDelegate* delegate = new PreviewItemDelegate(d->mRecentFoldersView);
-			delegate->setContextBarMode(PreviewItemDelegate::NoContextBar);
-			delegate->setTextElideMode(Qt::ElideLeft);
-			d->mRecentFoldersView->setItemDelegate(delegate);
-			d->mRecentFoldersView->setThumbnailSize(128);
-		}
-		if (!d->mRecentUrlsView->model()) {
-			d->mRecentUrlsView->setModel(d->mGvCore->recentUrlsModel());
-		}
-	}
-	if (!d->mSearchUiInitialized) {
-		d->mSearchUiInitialized = true;
-		d->setupSearchUi();
-	}
-	QFrame::showEvent(event);
-}
-
-
-void StartPage::showRecentFoldersViewContextMenu(const QPoint& pos) {
-	QAbstractItemView* view = qobject_cast<QAbstractItemView*>(sender());
-	KUrl url;
-	QModelIndex index = view->indexAt(pos);
-	if (index.isValid()) {
-		QVariant data = index.data(KFilePlacesModel::UrlRole);
-		url = data.toUrl();
-	}
-
-	// Create menu
-	QMenu menu(this);
-	bool fromRecentUrls = view == d->mRecentUrlsView;
-	QAction* addToPlacesAction = fromRecentUrls ? 0 : menu.addAction(KIcon("bookmark-new"), i18n("Add to Places"));
-	QAction* removeAction = menu.addAction(KIcon("edit-delete"), fromRecentUrls ? i18n("Forget this URL") : i18n("Forget this Folder"));
-	menu.addSeparator();
-	QAction* clearAction = menu.addAction(KIcon("edit-delete-all"), i18n("Forget All"));
-
-	if (!index.isValid()) {
-		if (addToPlacesAction) {
-			addToPlacesAction->setEnabled(false);
-		}
-		removeAction->setEnabled(false);
-	}
-
-	// Handle menu
-	QAction* action = menu.exec(view->mapToGlobal(pos));
-	if (!action) {
-		return;
-	}
-	if (action == addToPlacesAction) {
-		QString text = url.fileName();
-		if (text.isEmpty()) {
-			text = url.pathOrUrl();
-		}
-		d->mBookmarksModel->addPlace(text, url);
-	} else if (action == removeAction) {
-		view->model()->removeRow(index.row());
-	} else if (action == clearAction) {
-		view->model()->removeRows(0, view->model()->rowCount());
-	}
-}
-
-
-void StartPage::slotConfigChanged() {
-	d->updateHistoryTab();
-}
-
-
-} // namespace

=== removed file 'app/startpage.h'
--- app/startpage.h	2011-07-20 13:46:34 +0000
+++ app/startpage.h	1970-01-01 00:00:00 +0000
@@ -1,69 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
-
-*/
-#ifndef STARTPAGE_H
-#define STARTPAGE_H
-
-// Qt
-#include <QFrame>
-
-// KDE
-
-// Local
-
-class QModelIndex;
-class QPalette;
-class QShowEvent;
-
-class KUrl;
-
-namespace Gwenview {
-
-class GvCore;
-
-class StartPagePrivate;
-class StartPage : public QFrame {
-	Q_OBJECT
-public:
-	StartPage(QWidget* parent, GvCore*);
-	~StartPage();
-
-	void applyPalette(const QPalette&);
-
-Q_SIGNALS:
-	void urlSelected(const KUrl& url);
-
-protected:
-	virtual void showEvent(QShowEvent*);
-
-private Q_SLOTS:
-	void slotListViewActivated(const QModelIndex& index);
-	void showRecentFoldersViewContextMenu(const QPoint& pos);
-	void slotTagViewClicked(const QModelIndex& index);
-	void slotConfigChanged();
-
-private:
-	StartPagePrivate* const d;
-};
-
-
-} // namespace
-
-#endif /* STARTPAGE_H */

=== removed file 'app/startpage.ui'
--- app/startpage.ui	2011-07-20 13:46:34 +0000
+++ app/startpage.ui	1970-01-01 00:00:00 +0000
@@ -1,190 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<ui version="4.0">
- <class>StartPage</class>
- <widget class="QFrame" name="StartPage">
-  <property name="geometry">
-   <rect>
-    <x>0</x>
-    <y>0</y>
-    <width>584</width>
-    <height>618</height>
-   </rect>
-  </property>
-  <property name="autoFillBackground">
-   <bool>true</bool>
-  </property>
-  <property name="frameShape">
-   <enum>QFrame::StyledPanel</enum>
-  </property>
-  <property name="frameShadow">
-   <enum>QFrame::Sunken</enum>
-  </property>
-  <layout class="QHBoxLayout" name="horizontalLayout">
-   <item>
-    <layout class="QVBoxLayout" name="verticalLayout_4">
-     <item>
-      <widget class="QLabel" name="mHistoryDisabledLabel">
-       <property name="sizePolicy">
-        <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
-         <horstretch>0</horstretch>
-         <verstretch>0</verstretch>
-        </sizepolicy>
-       </property>
-       <property name="text">
-        <string>History has been disabled.</string>
-       </property>
-       <property name="alignment">
-        <set>Qt::AlignHCenter|Qt::AlignTop</set>
-       </property>
-      </widget>
-     </item>
-     <item>
-      <widget class="KTabWidget" name="mHistoryWidget">
-       <property name="currentIndex">
-        <number>0</number>
-       </property>
-       <property name="documentMode">
-        <bool>true</bool>
-       </property>
-       <widget class="QWidget" name="tab">
-        <attribute name="title">
-         <string>Recent Folders</string>
-        </attribute>
-        <layout class="QVBoxLayout" name="verticalLayout_5">
-         <item>
-          <widget class="Gwenview::ThumbnailView" name="mRecentFoldersView">
-           <property name="editTriggers">
-            <set>QAbstractItemView::NoEditTriggers</set>
-           </property>
-          </widget>
-         </item>
-        </layout>
-       </widget>
-       <widget class="QWidget" name="tab_2">
-        <attribute name="title">
-         <string>Recent URLs</string>
-        </attribute>
-        <layout class="QVBoxLayout" name="verticalLayout_6">
-         <item>
-          <widget class="QListView" name="mRecentUrlsView">
-           <property name="contextMenuPolicy">
-            <enum>Qt::CustomContextMenu</enum>
-           </property>
-           <property name="frameShape">
-            <enum>QFrame::NoFrame</enum>
-           </property>
-           <property name="editTriggers">
-            <set>QAbstractItemView::NoEditTriggers</set>
-           </property>
-           <property name="iconSize">
-            <size>
-             <width>32</width>
-             <height>32</height>
-            </size>
-           </property>
-          </widget>
-         </item>
-        </layout>
-       </widget>
-      </widget>
-     </item>
-    </layout>
-   </item>
-   <item>
-    <widget class="KTabWidget" name="mPlacesTagsWidget">
-     <property name="sizePolicy">
-      <sizepolicy hsizetype="Preferred" vsizetype="Expanding">
-       <horstretch>0</horstretch>
-       <verstretch>0</verstretch>
-      </sizepolicy>
-     </property>
-     <property name="currentIndex">
-      <number>0</number>
-     </property>
-     <property name="documentMode">
-      <bool>true</bool>
-     </property>
-     <widget class="QWidget" name="placesTab">
-      <attribute name="title">
-       <string>Places</string>
-      </attribute>
-      <layout class="QVBoxLayout" name="verticalLayout_2">
-       <item>
-        <widget class="KFilePlacesView" name="mBookmarksView">
-         <property name="cursor" stdset="0">
-          <cursorShape>PointingHandCursor</cursorShape>
-         </property>
-         <property name="frameShape">
-          <enum>QFrame::NoFrame</enum>
-         </property>
-         <property name="iconSize">
-          <size>
-           <width>32</width>
-           <height>32</height>
-          </size>
-         </property>
-        </widget>
-       </item>
-      </layout>
-     </widget>
-     <widget class="QWidget" name="tagsTab">
-      <attribute name="title">
-       <string>Tags</string>
-      </attribute>
-      <layout class="QVBoxLayout" name="verticalLayout">
-       <item>
-        <widget class="QLabel" name="mTagLabel">
-         <property name="text">
-          <string>Browsing by tags is not available. Make sure Nepomuk is properly installed on your computer.</string>
-         </property>
-         <property name="alignment">
-          <set>Qt::AlignLeading|Qt::AlignLeft|Qt::AlignTop</set>
-         </property>
-         <property name="wordWrap">
-          <bool>true</bool>
-         </property>
-        </widget>
-       </item>
-       <item>
-        <widget class="QListView" name="mTagView">
-         <property name="cursor" stdset="0">
-          <cursorShape>PointingHandCursor</cursorShape>
-         </property>
-         <property name="frameShape">
-          <enum>QFrame::NoFrame</enum>
-         </property>
-         <property name="iconSize">
-          <size>
-           <width>32</width>
-           <height>32</height>
-          </size>
-         </property>
-        </widget>
-       </item>
-      </layout>
-     </widget>
-    </widget>
-   </item>
-  </layout>
- </widget>
- <customwidgets>
-  <customwidget>
-   <class>KTabWidget</class>
-   <extends>QTabWidget</extends>
-   <header>ktabwidget.h</header>
-   <container>1</container>
-  </customwidget>
-  <customwidget>
-   <class>KFilePlacesView</class>
-   <extends>QListView</extends>
-   <header location="global">kfileplacesview.h</header>
-  </customwidget>
-  <customwidget>
-   <class>Gwenview::ThumbnailView</class>
-   <extends>QListView</extends>
-   <header location="global">lib/thumbnailview/thumbnailview.h</header>
-  </customwidget>
- </customwidgets>
- <resources/>
- <connections/>
-</ui>

=== modified file 'app/thumbnailviewhelper.cpp'
--- app/thumbnailviewhelper.cpp	2011-07-20 13:46:34 +0000
+++ app/thumbnailviewhelper.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -37,80 +37,80 @@
 #include <lib/document/documentfactory.h>
 #include "fileoperations.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ThumbnailViewHelperPrivate {
-	KActionCollection* mActionCollection;
-	KUrl mCurrentDirUrl;
+    KActionCollection* mActionCollection;
+    KUrl mCurrentDirUrl;
 
-	void addActionToMenu(KMenu& popup, const char* name) {
-		QAction* action = mActionCollection->action(name);
-		if (!action) {
-			kWarning() << "Unknown action" << name;
-			return;
-		}
-		if (action->isEnabled()) {
-			popup.addAction(action);
-		}
-	}
+    void addActionToMenu(KMenu& popup, const char* name)
+    {
+        QAction* action = mActionCollection->action(name);
+        if (!action) {
+            kWarning() << "Unknown action" << name;
+            return;
+        }
+        if (action->isEnabled()) {
+            popup.addAction(action);
+        }
+    }
 };
 
-
 ThumbnailViewHelper::ThumbnailViewHelper(QObject* parent, KActionCollection* actionCollection)
 : AbstractThumbnailViewHelper(parent)
-, d(new ThumbnailViewHelperPrivate) {
-	d->mActionCollection = actionCollection;
-}
-
-
-ThumbnailViewHelper::~ThumbnailViewHelper() {
-	delete d;
-}
-
-
-void ThumbnailViewHelper::setCurrentDirUrl(const KUrl& url) {
-	d->mCurrentDirUrl = url;
-}
-
-
-void ThumbnailViewHelper::showContextMenu(QWidget* parent) {
-	KMenu popup(parent);
-	if (d->mCurrentDirUrl.protocol() == "trash") {
-		d->addActionToMenu(popup, "file_restore");
-		d->addActionToMenu(popup, "file_delete");
-		popup.addSeparator();
-		d->addActionToMenu(popup, "file_show_properties");
-	} else {
-		d->addActionToMenu(popup, "file_create_folder");
-		popup.addSeparator();
-		d->addActionToMenu(popup, "file_rename");
-		d->addActionToMenu(popup, "file_trash");
-		d->addActionToMenu(popup, "file_delete");
-		popup.addSeparator();
-		d->addActionToMenu(popup, "file_copy_to");
-		d->addActionToMenu(popup, "file_move_to");
-		d->addActionToMenu(popup, "file_link_to");
-		popup.addSeparator();
-		d->addActionToMenu(popup, "file_open_with");
+, d(new ThumbnailViewHelperPrivate)
+{
+    d->mActionCollection = actionCollection;
+}
+
+ThumbnailViewHelper::~ThumbnailViewHelper()
+{
+    delete d;
+}
+
+void ThumbnailViewHelper::setCurrentDirUrl(const KUrl& url)
+{
+    d->mCurrentDirUrl = url;
+}
+
+void ThumbnailViewHelper::showContextMenu(QWidget* parent)
+{
+    KMenu popup(parent);
+    if (d->mCurrentDirUrl.protocol() == "trash") {
+        d->addActionToMenu(popup, "file_restore");
+        d->addActionToMenu(popup, "file_delete");
+        popup.addSeparator();
+        d->addActionToMenu(popup, "file_show_properties");
+    } else {
+        d->addActionToMenu(popup, "file_create_folder");
+        popup.addSeparator();
+        d->addActionToMenu(popup, "file_rename");
+        d->addActionToMenu(popup, "file_trash");
+        d->addActionToMenu(popup, "file_delete");
+        popup.addSeparator();
+        d->addActionToMenu(popup, "file_copy_to");
+        d->addActionToMenu(popup, "file_move_to");
+        d->addActionToMenu(popup, "file_link_to");
+        popup.addSeparator();
+        d->addActionToMenu(popup, "file_open_with");
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		d->addActionToMenu(popup, "edit_tags");
+        d->addActionToMenu(popup, "edit_tags");
 #endif
-		popup.addSeparator();
-		d->addActionToMenu(popup, "file_show_properties");
-	}
-	popup.exec(QCursor::pos());
-}
-
-
-void ThumbnailViewHelper::showMenuForUrlDroppedOnViewport(QWidget* parent, const KUrl::List& lst) {
-	showMenuForUrlDroppedOnDir(parent, lst, d->mCurrentDirUrl);
-}
-
-
-void ThumbnailViewHelper::showMenuForUrlDroppedOnDir(QWidget* parent, const KUrl::List& urlList, const KUrl& destUrl) {
-	FileOperations::showMenuForDroppedUrls(parent, urlList, destUrl);
-}
-
+        popup.addSeparator();
+        d->addActionToMenu(popup, "file_show_properties");
+    }
+    popup.exec(QCursor::pos());
+}
+
+void ThumbnailViewHelper::showMenuForUrlDroppedOnViewport(QWidget* parent, const KUrl::List& lst)
+{
+    showMenuForUrlDroppedOnDir(parent, lst, d->mCurrentDirUrl);
+}
+
+void ThumbnailViewHelper::showMenuForUrlDroppedOnDir(QWidget* parent, const KUrl::List& urlList, const KUrl& destUrl)
+{
+    FileOperations::showMenuForDroppedUrls(parent, urlList, destUrl);
+}
 
 } // namespace

=== modified file 'app/thumbnailviewhelper.h'
--- app/thumbnailviewhelper.h	2011-07-20 13:46:34 +0000
+++ app/thumbnailviewhelper.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -30,30 +30,31 @@
 
 class KActionCollection;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class SortedDirModel;
 
 struct ThumbnailViewHelperPrivate;
-class ThumbnailViewHelper : public AbstractThumbnailViewHelper {
-	Q_OBJECT
+class ThumbnailViewHelper : public AbstractThumbnailViewHelper
+{
+    Q_OBJECT
 public:
-	ThumbnailViewHelper(QObject* parent, KActionCollection*);
-	~ThumbnailViewHelper();
-
-	virtual void showContextMenu(QWidget* parent);
-
-	virtual void showMenuForUrlDroppedOnViewport(QWidget* parent, const KUrl::List&);
-
-	virtual void showMenuForUrlDroppedOnDir(QWidget* parent, const KUrl::List&, const KUrl&);
-
-	void setCurrentDirUrl(const KUrl&);
+    ThumbnailViewHelper(QObject* parent, KActionCollection*);
+    ~ThumbnailViewHelper();
+
+    virtual void showContextMenu(QWidget* parent);
+
+    virtual void showMenuForUrlDroppedOnViewport(QWidget* parent, const KUrl::List&);
+
+    virtual void showMenuForUrlDroppedOnDir(QWidget* parent, const KUrl::List&, const KUrl&);
+
+    void setCurrentDirUrl(const KUrl&);
 
 private:
-	ThumbnailViewHelperPrivate* const d;
+    ThumbnailViewHelperPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* THUMBNAILVIEWHELPER_H */

=== removed file 'app/thumbnailviewpanel.cpp'
--- app/thumbnailviewpanel.cpp	2011-07-20 13:46:34 +0000
+++ app/thumbnailviewpanel.cpp	1970-01-01 00:00:00 +0000
@@ -1,349 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
-
-*/
-// Self
-#include "thumbnailviewpanel.moc"
-
-// Qt
-#include <QDropEvent>
-#include <QMenu>
-#include <QSlider>
-#include <QToolTip>
-#include <QVBoxLayout>
-
-// KDE
-#include <kactioncollection.h>
-#include <kactioncategory.h>
-#include <kactionmenu.h>
-#include <kdebug.h>
-#include <kfileitem.h>
-#include <kfileplacesmodel.h>
-#include <klineedit.h>
-#include <klocale.h>
-#include <kselectaction.h>
-#include <kstatusbar.h>
-#include <ktoggleaction.h>
-#include <kurlnavigator.h>
-
-// Local
-#include <filtercontroller.h>
-#include <fileoperations.h>
-#include <lib/document/documentfactory.h>
-#include <lib/gwenviewconfig.h>
-#include <lib/semanticinfo/abstractsemanticinfobackend.h>
-#include <lib/semanticinfo/sorteddirmodel.h>
-#include <lib/semanticinfo/tagmodel.h>
-#include <lib/sorting.h>
-#include <lib/archiveutils.h>
-#include <lib/thumbnailview/previewitemdelegate.h>
-#include <lib/thumbnailview/thumbnailview.h>
-#include <ui_thumbnailviewpanel.h>
-
-
-namespace Gwenview {
-
-inline Sorting::Enum sortingFromSortAction(const QAction* action) {
-	Q_ASSERT(action);
-	return Sorting::Enum(action->data().toInt());
-}
-
-struct ThumbnailViewPanelPrivate : public Ui_ThumbnailViewPanel {
-	ThumbnailViewPanel* that;
-	KFilePlacesModel* mFilePlacesModel;
-	KUrlNavigator* mUrlNavigator;
-	SortedDirModel* mDirModel;
-	int mDocumentCount;
-	KActionCollection* mActionCollection;
-	FilterController* mFilterController;
-	KSelectAction* mSortAction;
-	QActionGroup* mThumbnailDetailsActionGroup;
-	PreviewItemDelegate* mDelegate;
-
-	void setupWidgets() {
-		setupUi(that);
-		that->layout()->setMargin(0);
-
-		// mThumbnailView
-		mThumbnailView->setModel(mDirModel);
-
-		mDelegate = new PreviewItemDelegate(mThumbnailView);
-		mThumbnailView->setItemDelegate(mDelegate);
-		mThumbnailView->setSelectionMode(QAbstractItemView::ExtendedSelection);
-
-		// mUrlNavigator (use stupid layouting code because KUrlNavigator ctor
-		// can't be used directly from Designer)
-		mFilePlacesModel = new KFilePlacesModel(that);
-		mUrlNavigator = new KUrlNavigator(mFilePlacesModel, KUrl(), mUrlNavigatorContainer);
-		QVBoxLayout* layout = new QVBoxLayout(mUrlNavigatorContainer);
-		layout->setMargin(0);
-		layout->addWidget(mUrlNavigator);
-		QObject::connect(mUrlNavigator, SIGNAL(urlsDropped(const KUrl&, QDropEvent*)),
-			that, SLOT(slotUrlsDropped(const KUrl&, QDropEvent*)));
-
-		// Thumbnail slider
-		QObject::connect(mThumbnailSlider, SIGNAL(valueChanged(int)),
-			mThumbnailView, SLOT(setThumbnailSize(int)));
-		QObject::connect(mThumbnailView, SIGNAL(thumbnailSizeChanged(int)),
-			mThumbnailSlider, SLOT(setValue(int)));
-	}
-
-	void setupActions(KActionCollection* actionCollection) {
-		KActionCategory* view=new KActionCategory(i18nc("@title actions category - means actions changing smth in interface","View"), actionCollection);
-		KAction* action = view->addAction("edit_location",that, SLOT(editLocation()));
-		action->setText(i18nc("@action:inmenu Navigation Bar", "Edit Location"));
-		action->setShortcut(Qt::Key_F6);
-
-		mSortAction = view->add<KSelectAction>("sort_order");
-		mSortAction->setText(i18nc("@action:inmenu", "Sort By"));
-		action = mSortAction->addAction(i18nc("@addAction:inmenu", "Name"));
-		action->setData(QVariant(Sorting::Name));
-		action = mSortAction->addAction(i18nc("@addAction:inmenu", "Date"));
-		action->setData(QVariant(Sorting::Date));
-		action = mSortAction->addAction(i18nc("@addAction:inmenu", "Size"));
-		action->setData(QVariant(Sorting::Size));
-		QObject::connect(mSortAction, SIGNAL(triggered(QAction*)),
-			that, SLOT(updateSortOrder()));
-
-		mThumbnailDetailsActionGroup = new QActionGroup(that);
-		mThumbnailDetailsActionGroup->setExclusive(false);
-		KActionMenu* thumbnailDetailsAction = view->add<KActionMenu>("thumbnail_details");
-		thumbnailDetailsAction->setText(i18nc("@action:inmenu", "Thumbnail Details"));
-		#define addAction(text, detail) \
-			action = new KAction(that); \
-			thumbnailDetailsAction->addAction(action); \
-			action->setText(text); \
-			action->setCheckable(true); \
-			action->setChecked(GwenviewConfig::thumbnailDetails() & detail); \
-			action->setData(QVariant(detail)); \
-			mThumbnailDetailsActionGroup->addAction(action); \
-			QObject::connect(action, SIGNAL(triggered(bool)), \
-				that, SLOT(updateThumbnailDetails()));
-		addAction(i18nc("@action:inmenu", "Filename"), PreviewItemDelegate::FileNameDetail);
-		addAction(i18nc("@action:inmenu", "Date"), PreviewItemDelegate::DateDetail);
-		addAction(i18nc("@action:inmenu", "Image Size"), PreviewItemDelegate::ImageSizeDetail);
-		addAction(i18nc("@action:inmenu", "File Size"), PreviewItemDelegate::FileSizeDetail);
-		#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		addAction(i18nc("@action:inmenu", "Rating"), PreviewItemDelegate::RatingDetail);
-		#endif
-		#undef addAction
-
-		KActionCategory* file=new KActionCategory(i18nc("@title actions category","File"), actionCollection);
-		action = file->addAction("add_folder_to_places",that, SLOT(addFolderToPlaces()));
-		action->setText(i18nc("@action:inmenu", "Add Folder to Places"));
-	}
-
-	void setupFilterController() {
-		QMenu* menu = new QMenu(mAddFilterButton);
-		mFilterController = new FilterController(mFilterFrame, mDirModel);
-		Q_FOREACH(QAction* action, mFilterController->actionList()) {
-			menu->addAction(action);
-		}
-		mAddFilterButton->setMenu(menu);
-	}
-
-	void updateDocumentCountLabel() {
-		QString text = i18ncp("@label", "%1 document", "%1 documents", mDocumentCount);
-		mDocumentCountLabel->setText(text);
-	}
-
-	void setupDocumentCountConnections() {
-		QObject::connect(mDirModel, SIGNAL(rowsInserted(const QModelIndex&, int, int)),
-			that, SLOT(slotDirModelRowsInserted(const QModelIndex&, int, int)) );
-
-		QObject::connect(mDirModel, SIGNAL(rowsAboutToBeRemoved(const QModelIndex&, int, int)),
-			that, SLOT(slotDirModelRowsAboutToBeRemoved(const QModelIndex&, int, int)) );
-
-		QObject::connect(mDirModel, SIGNAL(modelReset()),
-			that, SLOT(slotDirModelReset()) );
-	}
-
-
-	int documentCountInIndexRange(const QModelIndex& parent, int start, int end) {
-		int count = 0;
-		for (int row=start; row<=end; ++row) {
-			QModelIndex index = mDirModel->index(row, 0, parent);
-			KFileItem item = mDirModel->itemForIndex(index);
-			if (!ArchiveUtils::fileItemIsDirOrArchive(item)) {
-				++count;
-			}
-		}
-		return count;
-	}
-};
-
-
-ThumbnailViewPanel::ThumbnailViewPanel(QWidget* parent, SortedDirModel* dirModel, KActionCollection* actionCollection)
-: QWidget(parent)
-, d(new ThumbnailViewPanelPrivate) {
-	d->that = this;
-	d->mDirModel = dirModel;
-	d->mDocumentCount = 0;
-	d->mActionCollection = actionCollection;
-	d->setupWidgets();
-	d->setupActions(actionCollection);
-	d->setupFilterController();
-	d->setupDocumentCountConnections();
-	loadConfig();
-	updateSortOrder();
-	updateThumbnailDetails();
-}
-
-
-ThumbnailViewPanel::~ThumbnailViewPanel() {
-	delete d;
-}
-
-
-void ThumbnailViewPanel::loadConfig() {
-	d->mUrlNavigator->setUrlEditable(GwenviewConfig::urlNavigatorIsEditable());
-	d->mUrlNavigator->setShowFullPath(GwenviewConfig::urlNavigatorShowFullPath());
-
-	d->mThumbnailSlider->setValue(GwenviewConfig::thumbnailSize());
-	d->mThumbnailSlider->updateToolTip();
-	// If GwenviewConfig::thumbnailSize() returns the current value of
-	// mThumbnailSlider, it won't emit valueChanged() and the thumbnail view
-	// won't be updated. That's why we do it ourself.
-	d->mThumbnailView->setThumbnailSize(GwenviewConfig::thumbnailSize());
-
-	Q_FOREACH(QAction* action, d->mSortAction->actions()) {
-		if (sortingFromSortAction(action) == GwenviewConfig::sorting()) {
-			d->mSortAction->setCurrentAction(action);
-			break;
-		}
-	}
-}
-
-
-void ThumbnailViewPanel::saveConfig() const {
-	GwenviewConfig::setUrlNavigatorIsEditable(d->mUrlNavigator->isUrlEditable());
-	GwenviewConfig::setUrlNavigatorShowFullPath(d->mUrlNavigator->showFullPath());
-	GwenviewConfig::setThumbnailSize(d->mThumbnailSlider->value());
-	GwenviewConfig::setSorting(sortingFromSortAction(d->mSortAction->currentAction()));
-	GwenviewConfig::setThumbnailDetails(d->mDelegate->thumbnailDetails());
-}
-
-
-ThumbnailView* ThumbnailViewPanel::thumbnailView() const {
-	return d->mThumbnailView;
-}
-
-
-KUrlNavigator* ThumbnailViewPanel::urlNavigator() const {
-	return d->mUrlNavigator;
-}
-
-
-void ThumbnailViewPanel::reload() {
-	QModelIndexList list = d->mThumbnailView->selectionModel()->selectedIndexes();
-	Q_FOREACH(const QModelIndex& index, list) {
-		d->mThumbnailView->reloadThumbnail(index);
-	}
-	d->mDirModel->reload();
-}
-
-
-void ThumbnailViewPanel::editLocation() {
-	d->mUrlNavigator->setUrlEditable(true);
-	d->mUrlNavigator->setFocus();
-}
-
-
-void ThumbnailViewPanel::addFolderToPlaces() {
-	KUrl url = d->mUrlNavigator->locationUrl();
-	QString text = url.fileName();
-	if (text.isEmpty()) {
-		text = url.pathOrUrl();
-	}
-	d->mFilePlacesModel->addPlace(text, url);
-}
-
-
-void ThumbnailViewPanel::slotDirModelRowsInserted(const QModelIndex& parent, int start, int end) {
-	int count = d->documentCountInIndexRange(parent, start, end);
-	if (count > 0) {
-		d->mDocumentCount += count;
-		d->updateDocumentCountLabel();
-	}
-}
-
-
-void ThumbnailViewPanel::slotDirModelRowsAboutToBeRemoved(const QModelIndex& parent, int start, int end) {
-	int count = d->documentCountInIndexRange(parent, start, end);
-	if (count > 0) {
-		d->mDocumentCount -= count;
-		d->updateDocumentCountLabel();
-	}
-}
-
-
-void ThumbnailViewPanel::slotDirModelReset() {
-	d->mDocumentCount = 0;
-	d->updateDocumentCountLabel();
-}
-
-
-void ThumbnailViewPanel::updateSortOrder() {
-	const QAction* action = d->mSortAction->currentAction();
-	if (!action) {
-		kWarning() << "!action, this should not happen!";
-		return;
-	}
-
-	// This works because for now Sorting::Enum maps to KDirModel::ModelColumns
-	d->mDirModel->setSortRole(sortingFromSortAction(action));
-}
-
-
-void ThumbnailViewPanel::updateThumbnailDetails() {
-	PreviewItemDelegate::ThumbnailDetails details = 0;
-	Q_FOREACH(const QAction* action, d->mThumbnailDetailsActionGroup->actions()) {
-		if (action->isChecked()) {
-			details |= PreviewItemDelegate::ThumbnailDetail(action->data().toInt());
-		}
-	}
-	d->mDelegate->setThumbnailDetails(details);
-}
-
-
-void ThumbnailViewPanel::applyPalette(const QPalette& palette) {
-	d->mThumbnailView->setPalette(palette);
-}
-
-
-void ThumbnailViewPanel::slotUrlsDropped(const KUrl& destUrl, QDropEvent* event) {
-	const KUrl::List urlList = KUrl::List::fromMimeData(event->mimeData());
-	if (urlList.isEmpty()) {
-		return;
-	}
-	event->acceptProposedAction();
-
-	// We can't call FileOperations::showMenuForDroppedUrls() directly because
-	// we need the slot to return so that the drop event is accepted. Otherwise
-	// the drop cursor is still visible when the menu is shown.
-	QMetaObject::invokeMethod(this, "showMenuForDroppedUrls", Qt::QueuedConnection, Q_ARG(KUrl::List, urlList), Q_ARG(KUrl, destUrl));
-}
-
-
-void ThumbnailViewPanel::showMenuForDroppedUrls(const KUrl::List& urlList, const KUrl& destUrl) {
-	FileOperations::showMenuForDroppedUrls(d->mUrlNavigator, urlList, destUrl);
-}
-
-
-} // namespace

=== removed file 'app/thumbnailviewpanel.h'
--- app/thumbnailviewpanel.h	2011-07-20 13:46:34 +0000
+++ app/thumbnailviewpanel.h	1970-01-01 00:00:00 +0000
@@ -1,83 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
-
-*/
-#ifndef THUMBNAILVIEWPANEL_H
-#define THUMBNAILVIEWPANEL_H
-
-// Qt
-#include <QWidget>
-
-// KDE
-#include <kurl.h>
-
-// Local
-
-class QDropEvent;
-class QModelIndex;
-
-class KActionCollection;
-class KUrlNavigator;
-
-namespace Gwenview {
-
-class SortedDirModel;
-class ThumbnailView;
-
-struct ThumbnailViewPanelPrivate;
-/**
- * This class contains all the necessary widgets displayed in browse mode:
- * the thumbnail view, the url navigator, the bottom bar.
- */
-class ThumbnailViewPanel : public QWidget {
-	Q_OBJECT
-public:
-	ThumbnailViewPanel(QWidget* parent, SortedDirModel*, KActionCollection*);
-	~ThumbnailViewPanel();
-
-	void applyPalette(const QPalette&);
-
-	void reload();
-
-	ThumbnailView* thumbnailView() const;
-	KUrlNavigator* urlNavigator() const;
-
-	void loadConfig();
-	void saveConfig() const;
-
-private Q_SLOTS:
-	void editLocation();
-	void addFolderToPlaces();
-
-	void slotDirModelRowsInserted(const QModelIndex& parent, int start, int end);
-	void slotDirModelRowsAboutToBeRemoved(const QModelIndex& parent, int start, int end);
-	void slotDirModelReset();
-	void updateSortOrder();
-	void updateThumbnailDetails();
-	void slotUrlsDropped(const KUrl& destUrl, QDropEvent*);
-	void showMenuForDroppedUrls(const KUrl::List&, const KUrl& destUrl);
-
-private:
-	ThumbnailViewPanelPrivate* const d;
-};
-
-
-} // namespace
-
-#endif /* THUMBNAILVIEWPANEL_H */

=== removed file 'app/thumbnailviewpanel.ui'
--- app/thumbnailviewpanel.ui	2011-07-20 13:46:34 +0000
+++ app/thumbnailviewpanel.ui	1970-01-01 00:00:00 +0000
@@ -1,127 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<ui version="4.0">
- <class>ThumbnailViewPanel</class>
- <widget class="QWidget" name="ThumbnailViewPanel">
-  <property name="geometry">
-   <rect>
-    <x>0</x>
-    <y>0</y>
-    <width>264</width>
-    <height>267</height>
-   </rect>
-  </property>
-  <layout class="QGridLayout" name="gridLayout">
-   <property name="spacing">
-    <number>0</number>
-   </property>
-   <item row="0" column="1">
-    <widget class="QWidget" name="mUrlNavigatorContainer" native="true">
-     <property name="sizePolicy">
-      <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
-       <horstretch>0</horstretch>
-       <verstretch>0</verstretch>
-      </sizepolicy>
-     </property>
-     <property name="minimumSize">
-      <size>
-       <width>0</width>
-       <height>10</height>
-      </size>
-     </property>
-    </widget>
-   </item>
-   <item row="1" column="0" colspan="2">
-    <widget class="Gwenview::ThumbnailView" name="mThumbnailView"/>
-   </item>
-   <item row="2" column="0" colspan="2">
-    <widget class="QFrame" name="mFilterFrame">
-     <property name="sizePolicy">
-      <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
-       <horstretch>0</horstretch>
-       <verstretch>0</verstretch>
-      </sizepolicy>
-     </property>
-     <property name="frameShape">
-      <enum>QFrame::StyledPanel</enum>
-     </property>
-     <property name="frameShadow">
-      <enum>QFrame::Sunken</enum>
-     </property>
-    </widget>
-   </item>
-   <item row="3" column="0" colspan="2">
-    <widget class="QWidget" name="mStatusBarContainer" native="true">
-     <layout class="QHBoxLayout" name="horizontalLayout">
-      <property name="spacing">
-       <number>0</number>
-      </property>
-      <property name="margin">
-       <number>0</number>
-      </property>
-      <item>
-       <widget class="Gwenview::StatusBarToolButton" name="mAddFilterButton">
-        <property name="text">
-         <string>Add Filter</string>
-        </property>
-        <property name="popupMode">
-         <enum>QToolButton::InstantPopup</enum>
-        </property>
-       </widget>
-      </item>
-      <item>
-       <widget class="QLabel" name="mDocumentCountLabel">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
-          <horstretch>1</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="text">
-         <string/>
-        </property>
-        <property name="alignment">
-         <set>Qt::AlignCenter</set>
-        </property>
-       </widget>
-      </item>
-      <item>
-       <widget class="Gwenview::ThumbnailSlider" name="mThumbnailSlider">
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
-          <horstretch>0</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="minimumSize">
-         <size>
-          <width>120</width>
-          <height>0</height>
-         </size>
-        </property>
-       </widget>
-      </item>
-     </layout>
-    </widget>
-   </item>
-  </layout>
- </widget>
- <customwidgets>
-  <customwidget>
-   <class>Gwenview::ThumbnailView</class>
-   <extends>QListView</extends>
-   <header location="global">lib/thumbnailview/thumbnailview.h</header>
-  </customwidget>
-  <customwidget>
-   <class>Gwenview::StatusBarToolButton</class>
-   <extends>QToolButton</extends>
-   <header location="global">lib/statusbartoolbutton.h</header>
-  </customwidget>
-  <customwidget>
-   <class>Gwenview::ThumbnailSlider</class>
-   <extends>QWidget</extends>
-   <header location="global">lib/thumbnailview/thumbnailslider.h</header>
-  </customwidget>
- </customwidgets>
- <resources/>
- <connections/>
-</ui>

=== added file 'app/viewmainpage.cpp'
--- app/viewmainpage.cpp	1970-01-01 00:00:00 +0000
+++ app/viewmainpage.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,730 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include "viewmainpage.moc"
+
+// Qt
+#include <QCheckBox>
+#include <QItemSelectionModel>
+#include <QLabel>
+#include <QShortcut>
+#include <QToolButton>
+#include <QVBoxLayout>
+
+// KDE
+#include <kactioncollection.h>
+#include <kactioncategory.h>
+#include <kdebug.h>
+#include <klocale.h>
+#include <kmenu.h>
+#include <kmessagebox.h>
+#include <ktoggleaction.h>
+
+// Local
+#include "fileoperations.h"
+#include "splitter.h"
+#include <lib/document/document.h>
+#include <lib/documentview/abstractdocumentviewadapter.h>
+#include <lib/documentview/documentview.h>
+#include <lib/documentview/documentviewcontainer.h>
+#include <lib/documentview/documentviewcontroller.h>
+#include <lib/documentview/documentviewsynchronizer.h>
+#include <lib/gwenviewconfig.h>
+#include <lib/paintutils.h>
+#include <lib/semanticinfo/sorteddirmodel.h>
+#include <lib/slidecontainer.h>
+#include <lib/slideshow.h>
+#include <lib/statusbartoolbutton.h>
+#include <lib/thumbnailview/thumbnailbarview.h>
+#include <lib/zoomwidget.h>
+
+namespace Gwenview
+{
+
+#undef ENABLE_LOG
+#undef LOG
+//#define ENABLE_LOG
+#ifdef ENABLE_LOG
+#define LOG(x) kDebug() << x
+#else
+#define LOG(x) ;
+#endif
+
+const int ViewMainPage::MaxViewCount = 6;
+
+static QString rgba(const QColor &color)
+{
+    return QString::fromAscii("rgba(%1, %2, %3, %4)")
+           .arg(color.red())
+           .arg(color.green())
+           .arg(color.blue())
+           .arg(color.alpha());
+}
+
+static QString gradient(Qt::Orientation orientation, const QColor &color, int value)
+{
+    int x2, y2;
+    if (orientation == Qt::Horizontal) {
+        x2 = 0;
+        y2 = 1;
+    } else {
+        x2 = 1;
+        y2 = 0;
+    }
+    QString grad =
+        "qlineargradient(x1:0, y1:0, x2:%1, y2:%2,"
+        "stop:0 %3, stop: 1 %4)";
+    return grad
+           .arg(x2)
+           .arg(y2)
+           .arg(rgba(PaintUtils::adjustedHsv(color, 0, 0, qMin(255 - color.value(), value / 2))))
+           .arg(rgba(PaintUtils::adjustedHsv(color, 0, 0, -qMin(color.value(), value / 2))))
+           ;
+}
+
+/*
+ * Layout of mThumbnailSplitter is:
+ *
+ * +-mThumbnailSplitter------------------------------------------------+
+ * |+-mAdapterContainer-----------------------------------------------+|
+ * ||+-mDocumentViewContainer----------------------------------------+||
+ * |||+-DocumentView----------------++-DocumentView-----------------+|||
+ * ||||                             ||                              ||||
+ * ||||                             ||                              ||||
+ * ||||                             ||                              ||||
+ * ||||                             ||                              ||||
+ * ||||                             ||                              ||||
+ * ||||                             ||                              ||||
+ * |||+-----------------------------++------------------------------+|||
+ * ||+---------------------------------------------------------------+||
+ * ||+-mToolContainer------------------------------------------------+||
+ * |||                                                               |||
+ * ||+---------------------------------------------------------------+||
+ * ||+-mStatusBarContainer-------------------------------------------+||
+ * |||[mToggleSideBarButton][mToggleThumbnailBarButton] [mZoomWidget]|||
+ * ||+---------------------------------------------------------------+||
+ * |+-----------------------------------------------------------------+|
+ * |===================================================================|
+ * |+-mThumbnailBar---------------------------------------------------+|
+ * ||                                                                 ||
+ * ||                                                                 ||
+ * |+-----------------------------------------------------------------+|
+ * +-------------------------------------------------------------------+
+ */
+struct ViewMainPagePrivate {
+    ViewMainPage* q;
+    SlideShow* mSlideShow;
+    KActionCollection* mActionCollection;
+    QSplitter *mThumbnailSplitter;
+    QWidget* mAdapterContainer;
+    DocumentViewController* mDocumentViewController;
+    QList<DocumentView*> mDocumentViews;
+    DocumentViewSynchronizer* mSynchronizer;
+    QToolButton* mToggleSideBarButton;
+    QToolButton* mToggleThumbnailBarButton;
+    ZoomWidget* mZoomWidget;
+    DocumentViewContainer* mDocumentViewContainer;
+    SlideContainer* mToolContainer;
+    QWidget* mStatusBarContainer;
+    ThumbnailBarView* mThumbnailBar;
+    KToggleAction* mToggleThumbnailBarAction;
+    KToggleAction* mSynchronizeAction;
+    QCheckBox* mSynchronizeCheckBox;
+
+    bool mFullScreenMode;
+    QPalette mNormalPalette;
+    QPalette mFullScreenPalette;
+    bool mCompareMode;
+    bool mThumbnailBarVisibleBeforeFullScreen;
+
+    void setupThumbnailBar()
+    {
+        mThumbnailBar = new ThumbnailBarView;
+        ThumbnailBarItemDelegate* delegate = new ThumbnailBarItemDelegate(mThumbnailBar);
+        mThumbnailBar->setItemDelegate(delegate);
+        mThumbnailBar->setVisible(GwenviewConfig::thumbnailBarIsVisible());
+        mThumbnailBar->setSelectionMode(QAbstractItemView::ExtendedSelection);
+    }
+
+    void setupThumbnailBarStyleSheet()
+    {
+        Qt::Orientation orientation = mThumbnailBar->orientation();
+        QColor bgColor = mNormalPalette.color(QPalette::Normal, QPalette::Window);
+        QColor bgSelColor = mNormalPalette.color(QPalette::Normal, QPalette::Highlight);
+
+        // Avoid dark and bright colors
+        bgColor.setHsv(bgColor.hue(), bgColor.saturation(), (127 + 3 * bgColor.value()) / 4);
+
+        QColor leftBorderColor = PaintUtils::adjustedHsv(bgColor, 0, 0, qMin(20, 255 - bgColor.value()));
+        QColor rightBorderColor = PaintUtils::adjustedHsv(bgColor, 0, 0, -qMin(40, bgColor.value()));
+        QColor borderSelColor = PaintUtils::adjustedHsv(bgSelColor, 0, 0, -qMin(60, bgSelColor.value()));
+
+        QString viewCss =
+            "#thumbnailBarView {"
+            "	background-color: rgba(0, 0, 0, 10%);"
+            "}";
+
+        QString itemCss =
+            "QListView::item {"
+            "	background-color: %1;"
+            "	border-left: 1px solid %2;"
+            "	border-right: 1px solid %3;"
+            "}";
+        itemCss = itemCss.arg(
+                      gradient(orientation, bgColor, 46),
+                      gradient(orientation, leftBorderColor, 36),
+                      gradient(orientation, rightBorderColor, 26));
+
+        QString itemSelCss =
+            "QListView::item:selected {"
+            "	background-color: %1;"
+            "	border-left: 1px solid %2;"
+            "	border-right: 1px solid %2;"
+            "}";
+        itemSelCss = itemSelCss.arg(
+                         gradient(orientation, bgSelColor, 56),
+                         rgba(borderSelColor));
+
+        QString css = viewCss + itemCss + itemSelCss;
+        if (orientation == Qt::Vertical) {
+            css.replace("left", "top").replace("right", "bottom");
+        }
+
+        mThumbnailBar->setStyleSheet(css);
+    }
+
+    void setupAdapterContainer()
+    {
+        mAdapterContainer = new QWidget;
+
+        QVBoxLayout* layout = new QVBoxLayout(mAdapterContainer);
+        layout->setMargin(0);
+        layout->setSpacing(0);
+        mDocumentViewContainer = new DocumentViewContainer;
+        mDocumentViewContainer->setAutoFillBackground(true);
+        mDocumentViewContainer->setBackgroundRole(QPalette::Base);
+        layout->addWidget(mDocumentViewContainer);
+        layout->addWidget(mToolContainer);
+        layout->addWidget(mStatusBarContainer);
+    }
+
+    void setupDocumentViewController()
+    {
+        mDocumentViewController = new DocumentViewController(mActionCollection, q);
+        mDocumentViewController->setZoomWidget(mZoomWidget);
+        mDocumentViewController->setToolContainer(mToolContainer);
+        mSynchronizer = new DocumentViewSynchronizer(q);
+    }
+
+    DocumentView* createDocumentView()
+    {
+        DocumentView* view = mDocumentViewContainer->createView();
+
+        // Connect context menu
+        QObject::connect(view, SIGNAL(contextMenuRequested()),
+                         q, SLOT(showContextMenu()));
+
+        QObject::connect(view, SIGNAL(completed()),
+                         q, SIGNAL(completed()));
+        QObject::connect(view, SIGNAL(previousImageRequested()),
+                         q, SIGNAL(previousImageRequested()));
+        QObject::connect(view, SIGNAL(nextImageRequested()),
+                         q, SIGNAL(nextImageRequested()));
+        QObject::connect(view, SIGNAL(captionUpdateRequested(QString)),
+                         q, SIGNAL(captionUpdateRequested(QString)));
+        QObject::connect(view, SIGNAL(toggleFullScreenRequested()),
+                         q, SIGNAL(toggleFullScreenRequested()));
+        QObject::connect(view, SIGNAL(focused(DocumentView*)),
+                         q, SLOT(slotViewFocused(DocumentView*)));
+        QObject::connect(view, SIGNAL(hudTrashClicked(DocumentView*)),
+                         q, SLOT(trashView(DocumentView*)));
+        QObject::connect(view, SIGNAL(hudDeselectClicked(DocumentView*)),
+                         q, SLOT(deselectView(DocumentView*)));
+
+        QObject::connect(view, SIGNAL(videoFinished()),
+                         mSlideShow, SLOT(resumeAndGoToNextUrl()));
+
+        mDocumentViews << view;
+
+        return view;
+    }
+
+    void deleteDocumentView(DocumentView* view)
+    {
+        mDocumentViewContainer->deleteView(view);
+        mDocumentViews.removeOne(view);
+    }
+
+    void setupToolContainer()
+    {
+        mToolContainer = new SlideContainer;
+    }
+
+    void setupStatusBar()
+    {
+        mStatusBarContainer = new QWidget;
+        mToggleSideBarButton = new StatusBarToolButton;
+        mToggleThumbnailBarButton = new StatusBarToolButton;
+        mZoomWidget = new ZoomWidget;
+        mSynchronizeCheckBox = new QCheckBox(i18n("Synchronize"));
+        mSynchronizeCheckBox->hide();
+
+        QHBoxLayout* layout = new QHBoxLayout(mStatusBarContainer);
+        layout->setMargin(0);
+        layout->setSpacing(0);
+        layout->addWidget(mToggleSideBarButton);
+        layout->addWidget(mToggleThumbnailBarButton);
+        layout->addStretch();
+        layout->addWidget(mSynchronizeCheckBox);
+        layout->addStretch();
+        layout->addWidget(mZoomWidget);
+    }
+
+    void setupSplitter()
+    {
+        Qt::Orientation orientation = GwenviewConfig::thumbnailBarOrientation();
+        mThumbnailSplitter = new Splitter(orientation == Qt::Horizontal ? Qt::Vertical : Qt::Horizontal, q);
+        mThumbnailBar->setOrientation(orientation);
+        mThumbnailBar->setRowCount(GwenviewConfig::thumbnailBarRowCount());
+        mThumbnailSplitter->addWidget(mAdapterContainer);
+        mThumbnailSplitter->addWidget(mThumbnailBar);
+        mThumbnailSplitter->setSizes(GwenviewConfig::thumbnailSplitterSizes());
+
+        QVBoxLayout* layout = new QVBoxLayout(q);
+        layout->setMargin(0);
+        layout->addWidget(mThumbnailSplitter);
+    }
+
+    void applyPalette()
+    {
+        QPalette palette = mFullScreenMode ? mFullScreenPalette : mNormalPalette;
+        mDocumentViewContainer->setPalette(palette);
+    }
+
+    void saveSplitterConfig()
+    {
+        if (mThumbnailBar->isVisible()) {
+            GwenviewConfig::setThumbnailSplitterSizes(mThumbnailSplitter->sizes());
+        }
+    }
+
+    DocumentView* currentView() const {
+        return mDocumentViewController->view();
+    }
+
+    void setCurrentView(DocumentView* view)
+    {
+        DocumentView* oldView = currentView();
+        if (view == oldView) {
+            return;
+        }
+        if (oldView) {
+            oldView->setCurrent(false);
+        }
+        view->setCurrent(true);
+        mDocumentViewController->setView(view);
+        mSynchronizer->setCurrentView(view);
+
+        QModelIndex index = indexForView(view);
+        if (!index.isValid()) {
+            kWarning() << "No index found for current view";
+            return;
+        }
+        mThumbnailBar->selectionModel()->setCurrentIndex(index, QItemSelectionModel::Current);
+    }
+
+    QModelIndex indexForView(DocumentView* view) const {
+        KUrl url = view->url();
+        if (!url.isValid()) {
+            kWarning() << "View does not display any document!";
+            return QModelIndex();
+        }
+
+        // FIXME: Ugly coupling!
+        SortedDirModel* model = static_cast<SortedDirModel*>(mThumbnailBar->model());
+        return model->indexForUrl(url);
+    }
+};
+
+ViewMainPage::ViewMainPage(QWidget* parent, SlideShow* slideShow, KActionCollection* actionCollection)
+: QWidget(parent)
+, d(new ViewMainPagePrivate)
+{
+    d->q = this;
+    d->mSlideShow = slideShow;
+    d->mActionCollection = actionCollection;
+    d->mFullScreenMode = false;
+    d->mCompareMode = false;
+    d->mThumbnailBarVisibleBeforeFullScreen = false;
+    d->mFullScreenPalette = QPalette(palette());
+    d->mFullScreenPalette.setColor(QPalette::Base, Qt::black);
+    d->mFullScreenPalette.setColor(QPalette::Text, Qt::white);
+
+    QShortcut* toggleFullScreenShortcut = new QShortcut(this);
+    toggleFullScreenShortcut->setKey(Qt::Key_Return);
+    connect(toggleFullScreenShortcut, SIGNAL(activated()), SIGNAL(toggleFullScreenRequested()));
+
+    d->setupToolContainer();
+    d->setupStatusBar();
+
+    d->setupAdapterContainer();
+
+    d->setupThumbnailBar();
+
+    d->setupSplitter();
+
+    d->setupDocumentViewController();
+
+    KActionCategory* view = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface", "View"), actionCollection);
+
+    d->mToggleThumbnailBarAction = view->add<KToggleAction>(QString("toggle_thumbnailbar"));
+    d->mToggleThumbnailBarAction->setText(i18n("Thumbnail Bar"));
+    d->mToggleThumbnailBarAction->setIcon(KIcon("folder-image"));
+    d->mToggleThumbnailBarAction->setShortcut(Qt::CTRL | Qt::Key_B);
+    d->mToggleThumbnailBarAction->setChecked(GwenviewConfig::thumbnailBarIsVisible());
+    connect(d->mToggleThumbnailBarAction, SIGNAL(triggered(bool)),
+            this, SLOT(setThumbnailBarVisibility(bool)));
+    d->mToggleThumbnailBarButton->setDefaultAction(d->mToggleThumbnailBarAction);
+
+    d->mSynchronizeAction = view->add<KToggleAction>("synchronize_views");
+    d->mSynchronizeAction->setText(i18n("Synchronize"));
+    d->mSynchronizeAction->setShortcut(Qt::CTRL | Qt::Key_Y);
+    connect(d->mSynchronizeAction, SIGNAL(toggled(bool)),
+            d->mSynchronizer, SLOT(setActive(bool)));
+    // Ensure mSynchronizeAction and mSynchronizeCheckBox are in sync
+    connect(d->mSynchronizeAction, SIGNAL(toggled(bool)),
+            d->mSynchronizeCheckBox, SLOT(setChecked(bool)));
+    connect(d->mSynchronizeCheckBox, SIGNAL(toggled(bool)),
+            d->mSynchronizeAction, SLOT(setChecked(bool)));
+}
+
+ViewMainPage::~ViewMainPage()
+{
+    delete d;
+}
+
+void ViewMainPage::loadConfig()
+{
+    // FIXME: Not symetric with saveConfig(). Check if it matters.
+    Q_FOREACH(DocumentView * view, d->mDocumentViews) {
+        view->loadAdapterConfig();
+    }
+
+    Qt::Orientation orientation = GwenviewConfig::thumbnailBarOrientation();
+    d->mThumbnailSplitter->setOrientation(orientation == Qt::Horizontal ? Qt::Vertical : Qt::Horizontal);
+    d->mThumbnailBar->setOrientation(orientation);
+    d->setupThumbnailBarStyleSheet();
+
+    int oldRowCount = d->mThumbnailBar->rowCount();
+    int newRowCount = GwenviewConfig::thumbnailBarRowCount();
+    if (oldRowCount != newRowCount) {
+        d->mThumbnailBar->setUpdatesEnabled(false);
+        int gridSize = d->mThumbnailBar->gridSize().width();
+
+        d->mThumbnailBar->setRowCount(newRowCount);
+
+        // Adjust splitter to ensure thumbnail size remains the same
+        int delta = (newRowCount - oldRowCount) * gridSize;
+        QList<int> sizes = d->mThumbnailSplitter->sizes();
+        Q_ASSERT(sizes.count() == 2);
+        sizes[0] -= delta;
+        sizes[1] += delta;
+        d->mThumbnailSplitter->setSizes(sizes);
+
+        d->mThumbnailBar->setUpdatesEnabled(true);
+    }
+}
+
+void ViewMainPage::saveConfig()
+{
+    d->saveSplitterConfig();
+    GwenviewConfig::setThumbnailBarIsVisible(d->mToggleThumbnailBarAction->isChecked());
+}
+
+void ViewMainPage::setThumbnailBarVisibility(bool visible)
+{
+    d->saveSplitterConfig();
+    d->mThumbnailBar->setVisible(visible);
+}
+
+int ViewMainPage::statusBarHeight() const
+{
+    return d->mStatusBarContainer->height();
+}
+
+void ViewMainPage::setFullScreenMode(bool fullScreenMode)
+{
+    d->mFullScreenMode = fullScreenMode;
+    d->mStatusBarContainer->setVisible(!fullScreenMode);
+    d->applyPalette();
+    if (fullScreenMode) {
+        d->mThumbnailBarVisibleBeforeFullScreen = d->mToggleThumbnailBarAction->isChecked();
+        if (d->mThumbnailBarVisibleBeforeFullScreen) {
+            d->mToggleThumbnailBarAction->trigger();
+        }
+    } else if (d->mThumbnailBarVisibleBeforeFullScreen) {
+        d->mToggleThumbnailBarAction->trigger();
+    }
+    d->mToggleThumbnailBarAction->setEnabled(!fullScreenMode);
+}
+
+bool ViewMainPage::isFullScreenMode() const
+{
+    return d->mFullScreenMode;
+}
+
+ThumbnailBarView* ViewMainPage::thumbnailBar() const
+{
+    return d->mThumbnailBar;
+}
+
+inline void addActionToMenu(KMenu* menu, KActionCollection* actionCollection, const char* name)
+{
+    QAction* action = actionCollection->action(name);
+    if (action) {
+        menu->addAction(action);
+    }
+}
+
+void ViewMainPage::showContextMenu()
+{
+    KMenu menu(this);
+    addActionToMenu(&menu, d->mActionCollection, "fullscreen");
+    menu.addSeparator();
+    addActionToMenu(&menu, d->mActionCollection, "go_previous");
+    addActionToMenu(&menu, d->mActionCollection, "go_next");
+    if (d->currentView()->canZoom()) {
+        menu.addSeparator();
+        addActionToMenu(&menu, d->mActionCollection, "view_actual_size");
+        addActionToMenu(&menu, d->mActionCollection, "view_zoom_to_fit");
+        addActionToMenu(&menu, d->mActionCollection, "view_zoom_in");
+        addActionToMenu(&menu, d->mActionCollection, "view_zoom_out");
+    }
+    if (d->mCompareMode) {
+        menu.addSeparator();
+        addActionToMenu(&menu, d->mActionCollection, "synchronize_views");
+    }
+
+    menu.addSeparator();
+    addActionToMenu(&menu, d->mActionCollection, "file_copy_to");
+    addActionToMenu(&menu, d->mActionCollection, "file_move_to");
+    addActionToMenu(&menu, d->mActionCollection, "file_link_to");
+    menu.addSeparator();
+    addActionToMenu(&menu, d->mActionCollection, "file_open_with");
+    menu.exec(QCursor::pos());
+}
+
+QSize ViewMainPage::sizeHint() const
+{
+    return QSize(400, 300);
+}
+
+KUrl ViewMainPage::url() const
+{
+    if (!d->currentView()) {
+        LOG("!d->documentView()");
+        return KUrl();
+    }
+
+    return d->currentView()->url();
+}
+
+Document::Ptr ViewMainPage::currentDocument() const
+{
+    if (!d->currentView()) {
+        LOG("!d->documentView()");
+        return Document::Ptr();
+    }
+
+    return d->currentView()->document();
+}
+
+bool ViewMainPage::isEmpty() const
+{
+    if (!d->currentView()) {
+        return true;
+    }
+    return d->currentView()->isEmpty();
+}
+
+RasterImageView* ViewMainPage::imageView() const
+{
+    if (!d->currentView()) {
+        return 0;
+    }
+    return d->currentView()->imageView();
+}
+
+DocumentView* ViewMainPage::documentView() const
+{
+    return d->currentView();
+}
+
+void ViewMainPage::setNormalPalette(const QPalette& palette)
+{
+    d->mNormalPalette = palette;
+    d->applyPalette();
+    d->setupThumbnailBarStyleSheet();
+}
+
+void ViewMainPage::openUrl(const KUrl& url)
+{
+    openUrls(KUrl::List() << url, url);
+}
+
+void ViewMainPage::openUrls(const KUrl::List& _urls, const KUrl& currentUrl)
+{
+    QSet<KUrl> urls = _urls.toSet();
+    d->mCompareMode = urls.count() > 1;
+
+    // Destroy views which show urls we don't care about, remove from "urls" the
+    // urls which already have a view.
+    Q_FOREACH(DocumentView * view, d->mDocumentViews) {
+        KUrl url = view->url();
+        if (urls.contains(url)) {
+            // view displays an url we must display, keep it
+            urls.remove(url);
+        } else {
+            // view url is not interesting, drop it
+            d->deleteDocumentView(view);
+        }
+    }
+
+    // Create view for remaining urls
+    typedef QPair<DocumentView*, KUrl> ViewUrlPair;
+    QList<ViewUrlPair> urlForViewList;
+    Q_FOREACH(const KUrl & url, urls) {
+        if (d->mDocumentViews.count() >= MaxViewCount) {
+            kWarning() << "Too many documents to show";
+            break;
+        }
+        DocumentView* view = d->createDocumentView();
+        urlForViewList << qMakePair(view, url);
+    }
+
+    d->mDocumentViewContainer->updateLayout();
+
+    // Load urls for new views. Do it only now because the view must have the
+    // correct size before it starts loading its url. Do not do it later because
+    // view->url() needs to be set for the next loop.
+    Q_FOREACH(const ViewUrlPair & pair, urlForViewList) {
+        pair.first->openUrl(pair.second);
+    }
+
+    // Init views
+    Q_FOREACH(DocumentView * view, d->mDocumentViews) {
+        view->setCompareMode(d->mCompareMode);
+        if (view->url() == currentUrl) {
+            d->setCurrentView(view);
+        } else {
+            view->setCurrent(false);
+        }
+    }
+
+    d->mSynchronizeCheckBox->setVisible(d->mCompareMode);
+    if (d->mCompareMode) {
+        d->mSynchronizer->setDocumentViews(d->mDocumentViews);
+        d->mSynchronizer->setActive(d->mSynchronizeCheckBox->isChecked());
+    } else {
+        d->mSynchronizer->setDocumentViews(QList<DocumentView*>());
+        d->mSynchronizer->setActive(false);
+    }
+}
+
+void ViewMainPage::reload()
+{
+    Document::Ptr doc = d->currentView()->document();
+    if (!doc) {
+        kWarning() << "!doc";
+        return;
+    }
+    if (doc->isModified()) {
+        KGuiItem cont = KStandardGuiItem::cont();
+        cont.setText(i18nc("@action:button", "Discard Changes and Reload"));
+        int answer = KMessageBox::warningContinueCancel(this,
+                     i18nc("@info", "This image has been modified. Reloading it will discard all your changes."),
+                     QString() /* caption */,
+                     cont);
+        if (answer != KMessageBox::Continue) {
+            return;
+        }
+    }
+    doc->reload();
+    // Call openUrl again because DocumentView may need to switch to a new
+    // adapter (for example because document was broken and it is not anymore)
+    d->currentView()->openUrl(doc->url());
+}
+
+void ViewMainPage::reset()
+{
+    d->mDocumentViewController->setView(0);
+    d->mDocumentViewContainer->reset();
+    d->mDocumentViews.clear();
+}
+
+void ViewMainPage::slotViewFocused(DocumentView* view)
+{
+    d->setCurrentView(view);
+}
+
+void ViewMainPage::trashView(DocumentView* view)
+{
+    KUrl url = view->url();
+    deselectView(view);
+    FileOperations::trash(KUrl::List() << url, this);
+}
+
+void ViewMainPage::deselectView(DocumentView* view)
+{
+    DocumentView* newCurrentView = 0;
+    if (view == d->currentView()) {
+        // We need to find a new view to set as current
+        int idx = d->mDocumentViews.indexOf(view);
+        // Look for the next visible view after the current one
+        for (int newIdx = idx + 1; newIdx < d->mDocumentViews.count(); ++newIdx) {
+            newCurrentView = d->mDocumentViews.at(newIdx);
+            break;
+        }
+        if (!newCurrentView) {
+            // No visible view found after the current one, look before
+            for (int newIdx = idx - 1; newIdx >= 0; --newIdx) {
+                newCurrentView = d->mDocumentViews.at(newIdx);
+                break;
+            }
+        }
+        if (!newCurrentView) {
+            kWarning() << "No view found to set as current, this should not happen!";
+        }
+    }
+
+    QModelIndex index = d->indexForView(view);
+    QItemSelectionModel* selectionModel = d->mThumbnailBar->selectionModel();
+    selectionModel->select(index, QItemSelectionModel::Deselect);
+
+    if (newCurrentView) {
+        d->setCurrentView(newCurrentView);
+    }
+}
+
+QToolButton* ViewMainPage::toggleSideBarButton() const
+{
+    return d->mToggleSideBarButton;
+}
+
+} // namespace

=== added file 'app/viewmainpage.h'
--- app/viewmainpage.h	1970-01-01 00:00:00 +0000
+++ app/viewmainpage.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,147 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef VIEWMAINPAGE_H
+#define VIEWMAINPAGE_H
+
+// Local
+#include <lib/document/document.h>
+
+// KDE
+#include <kurl.h>
+
+// Qt
+#include <QToolButton>
+#include <QWidget>
+
+class QPalette;
+
+class KActionCollection;
+
+namespace Gwenview
+{
+
+class DocumentView;
+class RasterImageView;
+class SlideShow;
+class ThumbnailBarView;
+
+struct ViewMainPagePrivate;
+
+/**
+ * Holds the active document view and associated widgetry.
+ */
+class ViewMainPage : public QWidget
+{
+    Q_OBJECT
+public:
+    static const int MaxViewCount;
+
+    ViewMainPage(QWidget* parent, SlideShow*, KActionCollection*);
+    ~ViewMainPage();
+
+    ThumbnailBarView* thumbnailBar() const;
+
+    void loadConfig();
+
+    void saveConfig();
+
+    /**
+     * Reset the view
+     */
+    void reset();
+
+    void setFullScreenMode(bool fullScreen);
+
+    bool isFullScreenMode() const;
+
+    void setNormalPalette(const QPalette&);
+
+    int statusBarHeight() const;
+
+    virtual QSize sizeHint() const;
+
+    /**
+     * Returns the url of the current document, or an invalid url if unknown
+     */
+    KUrl url() const;
+
+    void openUrl(const KUrl& url);
+
+    /**
+     * Opens up to MaxViewCount urls, and set currentUrl as the current one
+     */
+    void openUrls(const KUrl::List& urls, const KUrl& currentUrl);
+
+    void reload();
+
+    Document::Ptr currentDocument() const;
+
+    bool isEmpty() const;
+
+    /**
+     * Returns the image view, if the current adapter has one.
+     */
+    RasterImageView* imageView() const;
+
+    /**
+     * Returns the document view
+     */
+    DocumentView* documentView() const;
+
+    /**
+     * Sets a widget to show at the bottom of the panel
+     */
+    void setToolWidget(QWidget* widget);
+
+    QToolButton* toggleSideBarButton() const;
+
+Q_SIGNALS:
+
+    /**
+     * Emitted when the part has finished loading
+     */
+    void completed();
+
+    void previousImageRequested();
+
+    void nextImageRequested();
+
+    void toggleFullScreenRequested();
+
+    void captionUpdateRequested(const QString&);
+
+private Q_SLOTS:
+    void setThumbnailBarVisibility(bool visible);
+
+    void showContextMenu();
+
+    void slotViewFocused(DocumentView*);
+
+    void trashView(DocumentView*);
+    void deselectView(DocumentView*);
+
+private:
+    friend struct ViewMainPagePrivate;
+    ViewMainPagePrivate* const d;
+};
+
+} // namespace
+
+#endif /* VIEWMAINPAGE_H */

=== modified file 'cursors/zoom.png'
Binary files cursors/zoom.png and cursors/zoom.png differ
=== added file 'cursors/zoom.svg'
--- cursors/zoom.svg	1970-01-01 00:00:00 +0000
+++ cursors/zoom.svg	2011-12-15 14:17:54 +0000
@@ -0,0 +1,122 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="32"
+   height="32"
+   id="svg2"
+   version="1.1"
+   inkscape:version="0.48.2 r9819"
+   sodipodi:docname="zoom.svg"
+   inkscape:export-filename="/home/aurelien/kdesrc/gwenview/cursors/zoom.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <linearGradient
+       id="linearGradient3775">
+      <stop
+         style="stop-color:#858585;stop-opacity:0.4040404;"
+         offset="0"
+         id="stop3777" />
+      <stop
+         style="stop-color:#373737;stop-opacity:0.26262626;"
+         offset="1"
+         id="stop3779" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient3767">
+      <stop
+         style="stop-color:#d3fff5;stop-opacity:0;"
+         offset="0"
+         id="stop3769" />
+      <stop
+         style="stop-color:#d3fff5;stop-opacity:1;"
+         offset="1"
+         id="stop3771" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="9.1923882"
+     inkscape:cx="-1.2969196"
+     inkscape:cy="6.1206745"
+     inkscape:document-units="px"
+     inkscape:current-layer="g3778"
+     showgrid="true"
+     inkscape:snap-global="true"
+     inkscape:window-width="1362"
+     inkscape:window-height="716"
+     inkscape:window-x="0"
+     inkscape:window-y="25"
+     inkscape:window-maximized="1">
+    <inkscape:grid
+       type="xygrid"
+       id="grid3766"
+       empspacing="5"
+       visible="true"
+       enabled="true"
+       snapvisiblegridlinesonly="true" />
+  </sodipodi:namedview>
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1"
+     transform="translate(0,-1020.3622)">
+    <g
+       id="g3778"
+       transform="matrix(0.70710678,-0.70710678,0.70710678,0.70710678,-726.06138,309.85107)">
+      <rect
+         y="1041.8622"
+         x="9.5"
+         height="3"
+         width="3"
+         id="rect3770"
+         style="fill:#feffff;fill-opacity:1;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0" />
+      <path
+         inkscape:connector-curvature="0"
+         style="fill:#ffffff;fill-opacity:0.66285712;stroke:none;opacity:1"
+         d="m 11,1020.8622 c -5.7989895,0 -10.50000028,4.701 -10.50000028,10.5 0,5.799 4.70101078,10.5 10.50000028,10.5 5.79899,0 10.5,-4.701 10.5,-10.5 0,-5.799 -4.70101,-10.5 -10.5,-10.5 z"
+         id="path2995"
+         sodipodi:nodetypes="sssss"
+         inkscape:export-xdpi="90"
+         inkscape:export-ydpi="90" />
+      <path
+         id="path2996"
+         transform="translate(0,1020.3622)"
+         d="M 11,0.5 C 5.2010101,0.5 0.5,5.2010102 0.5,11 0.5,16.79899 5.2010101,21.5 11,21.5 16.79899,21.5 21.5,16.79899 21.5,11 21.5,5.2010102 16.79899,0.5 11,0.5 z m 0,3 c 4.142136,0 7.5,3.3578644 7.5,7.5 0,4.142136 -3.357864,7.5 -7.5,7.5 C 6.8578644,18.5 3.5,15.142136 3.5,11 3.5,6.8578644 6.8578644,3.5 11,3.5 z"
+         style="fill:#feffff;fill-opacity:1;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;stroke-dashoffset:0"
+         inkscape:connector-curvature="0" />
+      <path
+         sodipodi:nodetypes="ccczcc"
+         inkscape:connector-curvature="0"
+         id="rect3774"
+         d="m 8.5,1044.8622 5,0 0,13 c 0,0 -1.089744,0.6538 -2.5,0.6538 -1.4102561,0 -2.5,-0.6538 -2.5,-0.6538 z"
+         style="fill:#feffff;fill-opacity:1;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dashoffset:0" />
+    </g>
+  </g>
+</svg>

=== modified file 'doc/index.cache.bz2'
Binary files doc/index.cache.bz2 and doc/index.cache.bz2 differ
=== modified file 'importer/CMakeLists.txt'
--- importer/CMakeLists.txt	2011-07-20 13:46:34 +0000
+++ importer/CMakeLists.txt	2011-12-15 14:17:54 +0000
@@ -1,3 +1,5 @@
+project(importer)
+
 include_directories(
 	${CMAKE_CURRENT_SOURCE_DIR}/..
 	${CMAKE_CURRENT_BINARY_DIR}/..

=== modified file 'importer/dialogpage.cpp'
--- importer/dialogpage.cpp	2011-07-20 13:46:34 +0000
+++ importer/dialogpage.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -33,67 +33,65 @@
 // Local
 #include <ui_dialogpage.h>
 
-
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct DialogPagePrivate : public Ui_DialogPage {
-	QVBoxLayout* mLayout;
-	QList<KPushButton*> mButtons;
-	QSignalMapper* mMapper;
-	QEventLoop* mEventLoop;
+    QVBoxLayout* mLayout;
+    QList<KPushButton*> mButtons;
+    QSignalMapper* mMapper;
+    QEventLoop* mEventLoop;
 };
 
-
 DialogPage::DialogPage(QWidget* parent)
 : QWidget(parent)
-, d(new DialogPagePrivate) {
-	d->setupUi(this);
-	d->mLayout = new QVBoxLayout(d->mButtonContainer);
-	d->mMapper = new QSignalMapper(this);
-	connect(d->mMapper, SIGNAL(mapped(int)), SLOT(slotMapped(int)));
-}
-
-
-DialogPage::~DialogPage() {
-	delete d;
-}
-
-
-void DialogPage::removeButtons() {
-	qDeleteAll(d->mButtons);
-	d->mButtons.clear();
-}
-
-
-void DialogPage::setText(const QString& text) {
-	d->mLabel->setText(text);
-}
-
-
-int DialogPage::addButton(const KGuiItem& item) {
-	int id = d->mButtons.size();
-	KPushButton* button = new KPushButton(item);
-	button->setFixedHeight(button->sizeHint().height() * 2);
-
-	connect(button, SIGNAL(clicked()), d->mMapper, SLOT(map()));
-	d->mLayout->addWidget(button);
-	d->mMapper->setMapping(button, id);
-	d->mButtons << button;
-	return id;
-}
-
-
-int DialogPage::exec() {
-	QEventLoop loop;
-	d->mEventLoop = &loop;
-	return loop.exec();
-}
-
-
-void DialogPage::slotMapped(int value) {
-	d->mEventLoop->exit(value);
-}
-
+, d(new DialogPagePrivate)
+{
+    d->setupUi(this);
+    d->mLayout = new QVBoxLayout(d->mButtonContainer);
+    d->mMapper = new QSignalMapper(this);
+    connect(d->mMapper, SIGNAL(mapped(int)), SLOT(slotMapped(int)));
+}
+
+DialogPage::~DialogPage()
+{
+    delete d;
+}
+
+void DialogPage::removeButtons()
+{
+    qDeleteAll(d->mButtons);
+    d->mButtons.clear();
+}
+
+void DialogPage::setText(const QString& text)
+{
+    d->mLabel->setText(text);
+}
+
+int DialogPage::addButton(const KGuiItem& item)
+{
+    int id = d->mButtons.size();
+    KPushButton* button = new KPushButton(item);
+    button->setFixedHeight(button->sizeHint().height() * 2);
+
+    connect(button, SIGNAL(clicked()), d->mMapper, SLOT(map()));
+    d->mLayout->addWidget(button);
+    d->mMapper->setMapping(button, id);
+    d->mButtons << button;
+    return id;
+}
+
+int DialogPage::exec()
+{
+    QEventLoop loop;
+    d->mEventLoop = &loop;
+    return loop.exec();
+}
+
+void DialogPage::slotMapped(int value)
+{
+    d->mEventLoop->exit(value);
+}
 
 } // namespace

=== modified file 'importer/dialogpage.h'
--- importer/dialogpage.h	2011-07-20 13:46:34 +0000
+++ importer/dialogpage.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -28,32 +28,31 @@
 
 // Local
 
-
 class KGuiItem;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class DialogPagePrivate;
-class DialogPage : public QWidget {
-	Q_OBJECT
+class DialogPage : public QWidget
+{
+    Q_OBJECT
 public:
-	DialogPage(QWidget* parent = 0);
-	~DialogPage();
+    DialogPage(QWidget* parent = 0);
+    ~DialogPage();
 
-	void removeButtons();
-	void setText(const QString&);
-	int addButton(const KGuiItem&);
-	int exec();
+    void removeButtons();
+    void setText(const QString&);
+    int addButton(const KGuiItem&);
+    int exec();
 
 private Q_SLOTS:
-	void slotMapped(int);
+    void slotMapped(int);
 
 private:
-	DialogPagePrivate* const d;
+    DialogPagePrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* DIALOGPAGE_H */

=== modified file 'importer/documentdirfinder.cpp'
--- importer/documentdirfinder.cpp	2011-07-20 13:46:34 +0000
+++ importer/documentdirfinder.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -30,85 +30,84 @@
 // Local
 #include <lib/mimetypeutils.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct DocumentDirFinderPrivate {
-	KUrl mRootUrl;
-	KDirLister* mDirLister;
+    KUrl mRootUrl;
+    KDirLister* mDirLister;
 
-	KUrl mFoundDirUrl;
+    KUrl mFoundDirUrl;
 };
 
-
 DocumentDirFinder::DocumentDirFinder(const KUrl& rootUrl)
-: d(new DocumentDirFinderPrivate) {
-	d->mRootUrl = rootUrl;
-	d->mDirLister = new KDirLister(this);
-	connect(d->mDirLister, SIGNAL(itemsAdded(const KUrl&, const KFileItemList&)),
-		SLOT(slotItemsAdded(const KUrl&, const KFileItemList&)));
-	connect(d->mDirLister, SIGNAL(completed()),
-		SLOT(slotCompleted()));
-	d->mDirLister->openUrl(rootUrl);
-}
-
-
-DocumentDirFinder::~DocumentDirFinder() {
-	delete d;
-}
-
-
-void DocumentDirFinder::start() {
-	d->mDirLister->openUrl(d->mRootUrl);
-}
-
-
-void DocumentDirFinder::slotItemsAdded(const KUrl& dir, const KFileItemList& list) {
-	Q_FOREACH(const KFileItem& item, list) {
-		MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
-		switch (kind) {
-		case MimeTypeUtils::KIND_DIR:
-		case MimeTypeUtils::KIND_ARCHIVE:
-			if (d->mFoundDirUrl.isValid()) {
-				// This is the second dir we find, stop now
-				finish(dir, MultipleDirsFound);
-				return;
-			} else {
-				// First dir
-				d->mFoundDirUrl = item.url();
-			}
-			break;
-
-		case MimeTypeUtils::KIND_RASTER_IMAGE:
-		case MimeTypeUtils::KIND_SVG_IMAGE:
-		case MimeTypeUtils::KIND_VIDEO:
-			finish(dir, DocumentDirFound);
-			return;
-
-		case MimeTypeUtils::KIND_UNKNOWN:
-		case MimeTypeUtils::KIND_FILE:
-			break;
-		}
-	}
-}
-
-
-void DocumentDirFinder::slotCompleted() {
-	if (d->mFoundDirUrl.isValid()) {
-		KUrl url = d->mFoundDirUrl;
-		d->mFoundDirUrl = KUrl();
-		d->mDirLister->openUrl(url);
-	} else {
-		finish(d->mRootUrl, NoDocumentFound);
-	}
-}
-
-
-void DocumentDirFinder::finish(const KUrl& url, DocumentDirFinder::Status status) {
-	disconnect(d->mDirLister, 0, this, 0);
-	emit done(url, status);
-	deleteLater();
-}
-
+: d(new DocumentDirFinderPrivate)
+{
+    d->mRootUrl = rootUrl;
+    d->mDirLister = new KDirLister(this);
+    connect(d->mDirLister, SIGNAL(itemsAdded(KUrl, KFileItemList)),
+            SLOT(slotItemsAdded(KUrl, KFileItemList)));
+    connect(d->mDirLister, SIGNAL(completed()),
+            SLOT(slotCompleted()));
+    d->mDirLister->openUrl(rootUrl);
+}
+
+DocumentDirFinder::~DocumentDirFinder()
+{
+    delete d;
+}
+
+void DocumentDirFinder::start()
+{
+    d->mDirLister->openUrl(d->mRootUrl);
+}
+
+void DocumentDirFinder::slotItemsAdded(const KUrl& dir, const KFileItemList& list)
+{
+    Q_FOREACH(const KFileItem & item, list) {
+        MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
+        switch (kind) {
+        case MimeTypeUtils::KIND_DIR:
+        case MimeTypeUtils::KIND_ARCHIVE:
+            if (d->mFoundDirUrl.isValid()) {
+                // This is the second dir we find, stop now
+                finish(dir, MultipleDirsFound);
+                return;
+            } else {
+                // First dir
+                d->mFoundDirUrl = item.url();
+            }
+            break;
+
+        case MimeTypeUtils::KIND_RASTER_IMAGE:
+        case MimeTypeUtils::KIND_SVG_IMAGE:
+        case MimeTypeUtils::KIND_VIDEO:
+            finish(dir, DocumentDirFound);
+            return;
+
+        case MimeTypeUtils::KIND_UNKNOWN:
+        case MimeTypeUtils::KIND_FILE:
+            break;
+        }
+    }
+}
+
+void DocumentDirFinder::slotCompleted()
+{
+    if (d->mFoundDirUrl.isValid()) {
+        KUrl url = d->mFoundDirUrl;
+        d->mFoundDirUrl = KUrl();
+        d->mDirLister->openUrl(url);
+    } else {
+        finish(d->mRootUrl, NoDocumentFound);
+    }
+}
+
+void DocumentDirFinder::finish(const KUrl& url, DocumentDirFinder::Status status)
+{
+    disconnect(d->mDirLister, 0, this, 0);
+    emit done(url, status);
+    deleteLater();
+}
 
 } // namespace

=== modified file 'importer/documentdirfinder.h'
--- importer/documentdirfinder.h	2011-07-20 13:46:34 +0000
+++ importer/documentdirfinder.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -29,8 +29,8 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class DocumentDirFinderPrivate;
 
@@ -45,33 +45,33 @@
  *     ...
  *     /PICTnnnn.JPG
  */
-class DocumentDirFinder : public QObject {
-	Q_OBJECT
+class DocumentDirFinder : public QObject
+{
+    Q_OBJECT
 public:
-	enum Status {
-		NoDocumentFound,
-		DocumentDirFound,
-		MultipleDirsFound
-	};
-
-	DocumentDirFinder(const KUrl& rootUrl);
-	~DocumentDirFinder();
-
-	void start();
+    enum Status {
+        NoDocumentFound,
+        DocumentDirFound,
+        MultipleDirsFound
+    };
+
+    DocumentDirFinder(const KUrl& rootUrl);
+    ~DocumentDirFinder();
+
+    void start();
 
 Q_SIGNALS:
-	void done(const KUrl&, DocumentDirFinder::Status);
+    void done(const KUrl&, DocumentDirFinder::Status);
 
 private Q_SLOTS:
-	void slotItemsAdded(const KUrl&, const KFileItemList&);
-	void slotCompleted();
+    void slotItemsAdded(const KUrl&, const KFileItemList&);
+    void slotCompleted();
 
 private:
-	DocumentDirFinderPrivate* const d;
-	void finish(const KUrl&, Status);
+    DocumentDirFinderPrivate* const d;
+    void finish(const KUrl&, Status);
 };
 
-
 } // namespace
 
 #endif /* DOCUMENTDIRFINDER_H */

=== modified file 'importer/filenameformater.cpp'
--- importer/filenameformater.cpp	2011-07-20 13:46:34 +0000
+++ importer/filenameformater.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -31,83 +31,83 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 typedef QHash<QString, QString> Dict;
 
 struct FileNameFormaterPrivate {
-	QString mFormat;
+    QString mFormat;
 };
 
-
 FileNameFormater::FileNameFormater(const QString& format)
-: d(new FileNameFormaterPrivate) {
-	d->mFormat = format;
-}
-
-
-FileNameFormater::~FileNameFormater() {
-	delete d;
-}
-
-
-QString FileNameFormater::format(const KUrl& url, const KDateTime& dateTime) {
-	QFileInfo info(url.fileName());
-
-	// Keep in sync with helpMap()
-	Dict dict;
-	dict["date"]       = dateTime.toString("%Y-%m-%d");
-	dict["time"]       = dateTime.toString("%H-%M-%S");
-	dict["ext"]        = info.completeSuffix();
-	dict["ext.lower"]  = info.completeSuffix().toLower();
-	dict["name"]       = info.baseName();
-	dict["name.lower"] = info.baseName().toLower();
-
-	QString name;
-	int length = d->mFormat.length();
-	for (int pos=0; pos < length; ++pos) {
-		QChar ch = d->mFormat[pos];
-		if (ch == '{') {
-			if (pos == length - 1) {
-				// We are at the end, ignore this
-				break;
-			}
-			if (d->mFormat[pos + 1] == '{') {
-				// This is an escaped '{', skip one
-				name += '{';
-				++pos;
-				continue;
-			}
-			int end = d->mFormat.indexOf('}', pos + 1);
-			if (end == -1) {
-				// No '}' found, stop here
-				return name;
-			}
-			// Replace keyword with its value
-			QString keyword = d->mFormat.mid(pos + 1, end - pos - 1);
-			name += dict.value(keyword);
-			pos = end;
-		} else {
-			name += ch;
-		}
-	}
-	return name;
-}
-
-
-FileNameFormater::HelpMap FileNameFormater::helpMap() {
-	// Keep in sync with dict in format()
-	static HelpMap map;
-	if (map.isEmpty()) {
-		map["date"]       = i18n("Shooting date");
-		map["time"]       = i18n("Shooting time");
-		map["ext"]        = i18n("Original extension");
-		map["ext.lower"]  = i18n("Original extension, in lower case");
-		map["name"]       = i18n("Original filename");
-		map["name.lower"] = i18n("Original filename, in lower case");
-	}
-	return map;
-}
-
+: d(new FileNameFormaterPrivate)
+{
+    d->mFormat = format;
+}
+
+FileNameFormater::~FileNameFormater()
+{
+    delete d;
+}
+
+QString FileNameFormater::format(const KUrl& url, const KDateTime& dateTime)
+{
+    QFileInfo info(url.fileName());
+
+    // Keep in sync with helpMap()
+    Dict dict;
+    dict["date"]       = dateTime.toString("%Y-%m-%d");
+    dict["time"]       = dateTime.toString("%H-%M-%S");
+    dict["ext"]        = info.completeSuffix();
+    dict["ext.lower"]  = info.completeSuffix().toLower();
+    dict["name"]       = info.baseName();
+    dict["name.lower"] = info.baseName().toLower();
+
+    QString name;
+    int length = d->mFormat.length();
+    for (int pos = 0; pos < length; ++pos) {
+        QChar ch = d->mFormat[pos];
+        if (ch == '{') {
+            if (pos == length - 1) {
+                // We are at the end, ignore this
+                break;
+            }
+            if (d->mFormat[pos + 1] == '{') {
+                // This is an escaped '{', skip one
+                name += '{';
+                ++pos;
+                continue;
+            }
+            int end = d->mFormat.indexOf('}', pos + 1);
+            if (end == -1) {
+                // No '}' found, stop here
+                return name;
+            }
+            // Replace keyword with its value
+            QString keyword = d->mFormat.mid(pos + 1, end - pos - 1);
+            name += dict.value(keyword);
+            pos = end;
+        } else {
+            name += ch;
+        }
+    }
+    return name;
+}
+
+FileNameFormater::HelpMap FileNameFormater::helpMap()
+{
+    // Keep in sync with dict in format()
+    static HelpMap map;
+    if (map.isEmpty()) {
+        map["date"]       = i18n("Shooting date");
+        map["time"]       = i18n("Shooting time");
+        map["ext"]        = i18n("Original extension");
+        map["ext.lower"]  = i18n("Original extension, in lower case");
+        map["name"]       = i18n("Original filename");
+        map["name.lower"] = i18n("Original filename, in lower case");
+    }
+    return map;
+}
 
 } // namespace

=== modified file 'importer/filenameformater.h'
--- importer/filenameformater.h	2011-07-20 13:46:34 +0000
+++ importer/filenameformater.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -33,34 +33,34 @@
 class KDateTime;
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class FileNameFormaterPrivate;
-class FileNameFormater {
+class FileNameFormater
+{
 public:
-	typedef QMap<QString, QString> HelpMap;
-
-	FileNameFormater(const QString& format);
-	~FileNameFormater();
-
-	/**
-	 * Given an url and its dateTime, returns a filename according to the
-	 * format passed to the constructor
-	 */
-	QString format(const KUrl& url, const KDateTime& dateTime);
-
-	/**
-	 * Returns a map whose keys are the available keywords and values are the
-	 * keyword help
-	 */
-	static HelpMap helpMap();
+    typedef QMap<QString, QString> HelpMap;
+
+    FileNameFormater(const QString& format);
+    ~FileNameFormater();
+
+    /**
+     * Given an url and its dateTime, returns a filename according to the
+     * format passed to the constructor
+     */
+    QString format(const KUrl& url, const KDateTime& dateTime);
+
+    /**
+     * Returns a map whose keys are the available keywords and values are the
+     * keyword help
+     */
+    static HelpMap helpMap();
 
 private:
-	FileNameFormaterPrivate* const d;
+    FileNameFormaterPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* FILENAMEFORMATER_H */

=== modified file 'importer/fileutils.cpp'
--- importer/fileutils.cpp	2011-07-20 13:46:34 +0000
+++ importer/fileutils.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -35,86 +35,89 @@
 #include <kio/netaccess.h>
 #include <kurl.h>
 
-namespace Gwenview {
-namespace FileUtils {
-
-bool contentsAreIdentical(const KUrl& url1, const KUrl& url2, QWidget* authWindow) {
-	// FIXME: Support remote urls
-	QFile file1(KIO::NetAccess::mostLocalUrl(url1, authWindow).toLocalFile());
-	if (!file1.open(QIODevice::ReadOnly)) {
-		// Can't read url1, assume it's different from url2
-		kWarning() << "Can't read" << url1;
-		return false;
-	}
-
-	QFile file2(KIO::NetAccess::mostLocalUrl(url2, authWindow).toLocalFile());
-	if (!file2.open(QIODevice::ReadOnly)) {
-		// Can't read url2, assume it's different from url1
-		kWarning() << "Can't read" << url2;
-		return false;
-	}
-
-	const int CHUNK_SIZE = 4096;
-	while (!file1.atEnd() && !file2.atEnd()) {
-		QByteArray url1Array = file1.read(CHUNK_SIZE);
-		QByteArray url2Array = file2.read(CHUNK_SIZE);
-
-		if (url1Array != url2Array) {
-			return false;
-		}
-	}
-	if (file1.atEnd() && file2.atEnd()) {
-		return true;
-	} else {
-		kWarning() << "One file ended before the other";
-		return false;
-	}
-}
-
-RenameResult rename(const KUrl& src, const KUrl& dst_, QWidget* authWindow) {
-	KUrl dst = dst_;
-	RenameResult result = RenamedOK;
-	int count = 1;
-
-	QFileInfo fileInfo(dst.fileName());
-	QString prefix = fileInfo.baseName() + '_';
-	QString suffix = '.' + fileInfo.completeSuffix();
-
-	// Get src size
-	KIO::UDSEntry udsEntry;
-	KIO::NetAccess::stat(dst, udsEntry, authWindow);
-	KFileItem item(udsEntry, src, true /* delayedMimeTypes */);
-	KIO::filesize_t srcSize = item.size();
-
-	// Find unique name
-	while (KIO::NetAccess::stat(dst, udsEntry, authWindow)) {
-		// File exists. If it's not the same, try to create a new name
-		item = KFileItem(udsEntry, dst, true /* delayedMimeTypes */);
-		KIO::filesize_t dstSize = item.size();
-
-		if (srcSize == dstSize && contentsAreIdentical(src, dst, authWindow)) {
-			// Already imported, skip it
-			KIO::Job* job = KIO::file_delete(src, KIO::HideProgressInfo);
-			if (job->ui()) {
-				job->ui()->setWindow(authWindow);
-			}
-
-			return Skipped;
-		}
-		result = RenamedUnderNewName;
-
-		dst.setFileName(prefix + QString::number(count) + suffix);
-		++count;
-	}
-
-	// Rename
-	KIO::Job* job = KIO::rename(src, dst, KIO::HideProgressInfo);
-	if (!KIO::NetAccess::synchronousRun(job, authWindow)) {
-		result = RenameFailed;
-	}
-	return result;
-}
-
+namespace Gwenview
+{
+namespace FileUtils
+{
+
+bool contentsAreIdentical(const KUrl& url1, const KUrl& url2, QWidget* authWindow)
+{
+    // FIXME: Support remote urls
+    QFile file1(KIO::NetAccess::mostLocalUrl(url1, authWindow).toLocalFile());
+    if (!file1.open(QIODevice::ReadOnly)) {
+        // Can't read url1, assume it's different from url2
+        kWarning() << "Can't read" << url1;
+        return false;
+    }
+
+    QFile file2(KIO::NetAccess::mostLocalUrl(url2, authWindow).toLocalFile());
+    if (!file2.open(QIODevice::ReadOnly)) {
+        // Can't read url2, assume it's different from url1
+        kWarning() << "Can't read" << url2;
+        return false;
+    }
+
+    const int CHUNK_SIZE = 4096;
+    while (!file1.atEnd() && !file2.atEnd()) {
+        QByteArray url1Array = file1.read(CHUNK_SIZE);
+        QByteArray url2Array = file2.read(CHUNK_SIZE);
+
+        if (url1Array != url2Array) {
+            return false;
+        }
+    }
+    if (file1.atEnd() && file2.atEnd()) {
+        return true;
+    } else {
+        kWarning() << "One file ended before the other";
+        return false;
+    }
+}
+
+RenameResult rename(const KUrl& src, const KUrl& dst_, QWidget* authWindow)
+{
+    KUrl dst = dst_;
+    RenameResult result = RenamedOK;
+    int count = 1;
+
+    QFileInfo fileInfo(dst.fileName());
+    QString prefix = fileInfo.baseName() + '_';
+    QString suffix = '.' + fileInfo.completeSuffix();
+
+    // Get src size
+    KIO::UDSEntry udsEntry;
+    KIO::NetAccess::stat(dst, udsEntry, authWindow);
+    KFileItem item(udsEntry, src, true /* delayedMimeTypes */);
+    KIO::filesize_t srcSize = item.size();
+
+    // Find unique name
+    while (KIO::NetAccess::stat(dst, udsEntry, authWindow)) {
+        // File exists. If it's not the same, try to create a new name
+        item = KFileItem(udsEntry, dst, true /* delayedMimeTypes */);
+        KIO::filesize_t dstSize = item.size();
+
+        if (srcSize == dstSize && contentsAreIdentical(src, dst, authWindow)) {
+            // Already imported, skip it
+            KIO::Job* job = KIO::file_delete(src, KIO::HideProgressInfo);
+            if (job->ui()) {
+                job->ui()->setWindow(authWindow);
+            }
+
+            return Skipped;
+        }
+        result = RenamedUnderNewName;
+
+        dst.setFileName(prefix + QString::number(count) + suffix);
+        ++count;
+    }
+
+    // Rename
+    KIO::Job* job = KIO::rename(src, dst, KIO::HideProgressInfo);
+    if (!KIO::NetAccess::synchronousRun(job, authWindow)) {
+        result = RenameFailed;
+    }
+    return result;
+}
 
 } // namespace
 } // namespace

=== modified file 'importer/fileutils.h'
--- importer/fileutils.h	2011-07-20 13:46:34 +0000
+++ importer/fileutils.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -24,26 +24,28 @@
 class QWidget;
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace FileUtils {
+namespace FileUtils
+{
 
 enum RenameResult {
-	RenamedOK,           /** Renamed without problem */
-	RenamedUnderNewName, /** Destination already existed, so rename() added a suffix to make the name unique */
-	Skipped,             /** Destination already existed and contained the same data as source, so rename() just removed the source */
-	RenameFailed         /** Rename failed */
+    RenamedOK,           /** Renamed without problem */
+    RenamedUnderNewName, /** Destination already existed, so rename() added a suffix to make the name unique */
+    Skipped,             /** Destination already existed and contained the same data as source, so rename() just removed the source */
+    RenameFailed         /** Rename failed */
 };
 
 /**
  * Compare content of two urls, returns whether they are the same
  */
-bool contentsAreIdentical(const KUrl& url1, const KUrl& url2, QWidget* authWindow=0);
+bool contentsAreIdentical(const KUrl& url1, const KUrl& url2, QWidget* authWindow = 0);
 
 /**
  * Rename src to dst, returns RenameResult
  */
-RenameResult rename(const KUrl& src, const KUrl& dst, QWidget* authWindow=0);
+RenameResult rename(const KUrl& src, const KUrl& dst, QWidget* authWindow = 0);
 
 } // namespace
 } // namespace

=== modified file 'importer/gwenview_importer.desktop'
--- importer/gwenview_importer.desktop	2011-12-08 21:34:25 +0000
+++ importer/gwenview_importer.desktop	2011-12-15 14:17:54 +0000
@@ -40,11 +40,12 @@
 Name[nl]=Foto's met Gwenview downloaden
 Name[nn]=Overfør bilete med Gwenview
 Name[pa]=ਜੀਵੀਨ-ਵਿਊ ਨਾਲ ਫੋਟੋ ਡਾਊਨਲੋਡ ਕਰੋ
-Name[pl]=Download Photos with Gwenview
+Name[pl]=Pobierz zdjęcia z Gwenview
 Name[pt]=Obter as Fotografias com o Gwenview
 Name[pt_BR]=Transferir as fotos com o Gwenview
 Name[ro]=Descarcă fotografii cu Gwenview
 Name[ru]=Скопировать фотографии с помощью Gwenview
+Name[si]=Gwenview සමඟින් පිංතූර බාගන්න
 Name[sk]=Stiahnuť fotografie pomocou Gwenview
 Name[sl]=Prenesi fotografije z Gwenview
 Name[sr]=Преузимање фотографија Гвенвјуом
@@ -54,7 +55,6 @@
 Name[sv]=Ladda ner foton med Gwenview
 Name[th]=ดาวน์โหลดภาพถ่ายด้วยเกวนวิว
 Name[tr]=Gwenview ile Fotoğrafları İndir
-Name[ug]=سۈرەتلەرنى Gwenview بىلەن چۈشۈرۈش
 Name[uk]=Звантажити фотографії за допомогою Gwenview
 Name[x-test]=xxDownload Photos with Gwenviewxx
 Name[zh_CN]=用 Gwenview 下载照片

=== modified file 'importer/gwenview_importer_camera.desktop'
--- importer/gwenview_importer_camera.desktop	2011-12-08 21:34:25 +0000
+++ importer/gwenview_importer_camera.desktop	2011-12-15 14:17:54 +0000
@@ -39,11 +39,12 @@
 Name[nl]=Foto's met Gwenview downloaden
 Name[nn]=Overfør bilete med Gwenview
 Name[pa]=ਜੀਵੀਨ-ਵਿਊ ਨਾਲ ਫੋਟੋ ਡਾਊਨਲੋਡ ਕਰੋ
-Name[pl]=Download Photos with Gwenview
+Name[pl]=Pobierz zdjęcia z Gwenview
 Name[pt]=Obter as Fotografias com o Gwenview
 Name[pt_BR]=Transferir as fotos com o Gwenview
 Name[ro]=Descarcă fotografii cu Gwenview
 Name[ru]=Скопировать фотографии с помощью Gwenview
+Name[si]=Gwenview සමඟින් පිංතූර බාගන්න
 Name[sk]=Stiahnuť fotografie pomocou Gwenview
 Name[sl]=Prenesi fotografije z Gwenview
 Name[sr]=Преузимање фотографија Гвенвјуом
@@ -53,7 +54,6 @@
 Name[sv]=Ladda ner foton med Gwenview
 Name[th]=ดาวน์โหลดภาพถ่ายด้วยเกวนวิว
 Name[tr]=Gwenview ile Fotoğrafları İndir
-Name[ug]=سۈرەتلەرنى Gwenview بىلەن چۈشۈرۈش
 Name[uk]=Звантажити фотографії за допомогою Gwenview
 Name[x-test]=xxDownload Photos with Gwenviewxx
 Name[zh_CN]=用 Gwenview 下载照片

=== modified file 'importer/importdialog.cpp'
--- importer/importdialog.cpp	2011-07-20 13:46:34 +0000
+++ importer/importdialog.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -44,207 +44,210 @@
 #include "progresspage.h"
 #include "thumbnailpage.h"
 
-namespace Gwenview {
-
-
-class ImportDialogPrivate {
+namespace Gwenview
+{
+
+class ImportDialogPrivate
+{
 public:
-	ImportDialog* q;
-	QStackedWidget* mCentralWidget;
-	ThumbnailPage* mThumbnailPage;
-	ProgressPage* mProgressPage;
-	DialogPage* mDialogPage;
-	Importer* mImporter;
-
-	void deleteImportedUrls() {
-		KUrl::List importedUrls = mImporter->importedUrlList();
-		KUrl::List skippedUrls = mImporter->skippedUrlList();
-		int importedCount = importedUrls.count();
-		int skippedCount = skippedUrls.count();
-
-		if (importedCount == 0 && skippedCount == 0) {
-			return;
-		}
-
-		QStringList message;
-		message << i18np(
-			"One document has been imported.",
-			"%1 documents have been imported.",
-			importedCount);
-		if (skippedCount > 0) {
-			message << i18np(
-				"One document has been skipped because it had already been imported.",
-				"%1 documents have been skipped because they had already been imported.",
-				skippedCount);
-		}
-
-		if (mImporter->renamedCount() > 0) {
-			message[0].append("*");
-			message << "<small>* " + i18np(
-				"One of them has been renamed because another document with the same name had already been imported.",
-				"%1 of them have been renamed because other documents with the same name had already been imported.",
-				mImporter->renamedCount())
-				+ "</small>";
-		}
-
-		message << QString();
-		if (skippedCount == 0) {
-			message << i18np(
-				"Delete the imported document from the device?",
-				"Delete the %1 imported documents from the device?",
-				importedCount);
-		} else if (importedCount == 0) {
-			message << i18np(
-				"Delete the skipped document from the device?",
-				"Delete the %1 skipped documents from the device?",
-				skippedCount);
-		} else {
-			message << i18ncp(
-				"Singular sentence is actually never used.",
-				"Delete the imported or skipped document from the device?",
-				"Delete the %1 imported and skipped documents from the device?",
-				importedCount + skippedCount);
-		}
-
-		int answer = KMessageBox::questionYesNo(mCentralWidget,
-			"<qt>" + message.join("<br/>") + "</qt>",
-			i18nc("@title:window", "Import Finished"),
-			KStandardGuiItem::del(),
-			KGuiItem(i18n("Keep"))
-			);
-		if (answer != KMessageBox::Yes) {
-			return;
-		}
-		KUrl::List urls = importedUrls + skippedUrls;
-		while (true) {
-			KIO::Job* job = KIO::del(urls);
-			if (KIO::NetAccess::synchronousRun(job, q)) {
-				break;
-			}
-			// Deleting failed
-			int answer = KMessageBox::warningYesNo(mCentralWidget,
-				i18np("Failed to delete the document:\n%2",
-					"Failed to delete documents:\n%2",
-					urls.count(), job->errorString()),
-				QString(),
-				KGuiItem(i18n("Retry")),
-				KGuiItem(i18n("Ignore"))
-				);
-			if (answer != KMessageBox::Yes) {
-				// Ignore
-				break;
-			}
-		}
-	}
-
-	void startGwenview() {
-		KService::Ptr service = KService::serviceByDesktopName("gwenview");
-		if (!service) {
-			kError() << "Could not find gwenview";
-		} else {
-			KRun::run(*service, KUrl::List() << mThumbnailPage->destinationUrl(), 0 /* window */);
-		}
-	}
-
-	void showWhatNext() {
-		mCentralWidget->setCurrentWidget(mDialogPage);
-		mDialogPage->setText(i18n("What do you want to do now?"));
-		mDialogPage->removeButtons();
-		int gwenview = mDialogPage->addButton(KGuiItem(i18n("View Imported Documents with Gwenview"), "gwenview"));
-		int importMore = mDialogPage->addButton(KGuiItem(i18n("Import more Documents")));
-		mDialogPage->addButton(KGuiItem(i18n("Quit"), "dialog-cancel"));
-
-		int answer = mDialogPage->exec();
-		if (answer == gwenview) {
-			startGwenview();
-			qApp->quit();
-		} else if (answer == importMore) {
-			mCentralWidget->setCurrentWidget(mThumbnailPage);
-		} else { /* quit */
-			qApp->quit();
-		}
-	}
+    ImportDialog* q;
+    QStackedWidget* mCentralWidget;
+    ThumbnailPage* mThumbnailPage;
+    ProgressPage* mProgressPage;
+    DialogPage* mDialogPage;
+    Importer* mImporter;
+
+    void deleteImportedUrls()
+    {
+        KUrl::List importedUrls = mImporter->importedUrlList();
+        KUrl::List skippedUrls = mImporter->skippedUrlList();
+        int importedCount = importedUrls.count();
+        int skippedCount = skippedUrls.count();
+
+        if (importedCount == 0 && skippedCount == 0) {
+            return;
+        }
+
+        QStringList message;
+        message << i18np(
+                    "One document has been imported.",
+                    "%1 documents have been imported.",
+                    importedCount);
+        if (skippedCount > 0) {
+            message << i18np(
+                        "One document has been skipped because it had already been imported.",
+                        "%1 documents have been skipped because they had already been imported.",
+                        skippedCount);
+        }
+
+        if (mImporter->renamedCount() > 0) {
+            message[0].append("*");
+            message << "<small>* " + i18np(
+                        "One of them has been renamed because another document with the same name had already been imported.",
+                        "%1 of them have been renamed because other documents with the same name had already been imported.",
+                        mImporter->renamedCount())
+                    + "</small>";
+        }
+
+        message << QString();
+        if (skippedCount == 0) {
+            message << i18np(
+                        "Delete the imported document from the device?",
+                        "Delete the %1 imported documents from the device?",
+                        importedCount);
+        } else if (importedCount == 0) {
+            message << i18np(
+                        "Delete the skipped document from the device?",
+                        "Delete the %1 skipped documents from the device?",
+                        skippedCount);
+        } else {
+            message << i18ncp(
+                        "Singular sentence is actually never used.",
+                        "Delete the imported or skipped document from the device?",
+                        "Delete the %1 imported and skipped documents from the device?",
+                        importedCount + skippedCount);
+        }
+
+        int answer = KMessageBox::questionYesNo(mCentralWidget,
+                                                "<qt>" + message.join("<br/>") + "</qt>",
+                                                i18nc("@title:window", "Import Finished"),
+                                                KStandardGuiItem::del(),
+                                                KGuiItem(i18n("Keep"))
+                                               );
+        if (answer != KMessageBox::Yes) {
+            return;
+        }
+        KUrl::List urls = importedUrls + skippedUrls;
+        while (true) {
+            KIO::Job* job = KIO::del(urls);
+            if (KIO::NetAccess::synchronousRun(job, q)) {
+                break;
+            }
+            // Deleting failed
+            int answer = KMessageBox::warningYesNo(mCentralWidget,
+                                                   i18np("Failed to delete the document:\n%2",
+                                                           "Failed to delete documents:\n%2",
+                                                           urls.count(), job->errorString()),
+                                                   QString(),
+                                                   KGuiItem(i18n("Retry")),
+                                                   KGuiItem(i18n("Ignore"))
+                                                  );
+            if (answer != KMessageBox::Yes) {
+                // Ignore
+                break;
+            }
+        }
+    }
+
+    void startGwenview()
+    {
+        KService::Ptr service = KService::serviceByDesktopName("gwenview");
+        if (!service) {
+            kError() << "Could not find gwenview";
+        } else {
+            KRun::run(*service, KUrl::List() << mThumbnailPage->destinationUrl(), 0 /* window */);
+        }
+    }
+
+    void showWhatNext()
+    {
+        mCentralWidget->setCurrentWidget(mDialogPage);
+        mDialogPage->setText(i18n("What do you want to do now?"));
+        mDialogPage->removeButtons();
+        int gwenview = mDialogPage->addButton(KGuiItem(i18n("View Imported Documents with Gwenview"), "gwenview"));
+        int importMore = mDialogPage->addButton(KGuiItem(i18n("Import more Documents")));
+        mDialogPage->addButton(KGuiItem(i18n("Quit"), "dialog-cancel"));
+
+        int answer = mDialogPage->exec();
+        if (answer == gwenview) {
+            startGwenview();
+            qApp->quit();
+        } else if (answer == importMore) {
+            mCentralWidget->setCurrentWidget(mThumbnailPage);
+        } else { /* quit */
+            qApp->quit();
+        }
+    }
 };
 
-
 ImportDialog::ImportDialog()
-: d(new ImportDialogPrivate) {
-	d->q = this;
-	d->mImporter = new Importer(this);
-	connect(d->mImporter, SIGNAL(error(const QString&)),
-		SLOT(showImportError(const QString&)));
-	d->mThumbnailPage = new ThumbnailPage;
-
-	KUrl url = ImporterConfig::destinationUrl();
-	if (!url.isValid()) {
-		url = KUrl::fromPath(KGlobalSettings::picturesPath());
-		int year = QDate::currentDate().year();
-		url.addPath(QString::number(year));
-	}
-	d->mThumbnailPage->setDestinationUrl(url);
-
-	d->mProgressPage = new ProgressPage(d->mImporter);
-
-	d->mDialogPage = new DialogPage;
-
-	d->mCentralWidget = new QStackedWidget;
-	setCentralWidget(d->mCentralWidget);
-	d->mCentralWidget->addWidget(d->mThumbnailPage);
-	d->mCentralWidget->addWidget(d->mProgressPage);
-	d->mCentralWidget->addWidget(d->mDialogPage);
-
-	connect(d->mThumbnailPage, SIGNAL(importRequested()),
-		SLOT(startImport()));
-	connect(d->mThumbnailPage, SIGNAL(rejected()),
-		SLOT(close()));
-	connect(d->mImporter, SIGNAL(importFinished()),
-		SLOT(slotImportFinished()));
-
-	d->mCentralWidget->setCurrentWidget(d->mThumbnailPage);
-
-	setAutoSaveSettings();
-}
-
-
-ImportDialog::~ImportDialog() {
-	delete d;
-}
-
-
-QSize ImportDialog::sizeHint() const {
-	return QSize(700, 500);
-}
-
-
-void ImportDialog::setSourceUrl(const KUrl& url) {
-	d->mThumbnailPage->setSourceUrl(url);
-}
-
-
-void ImportDialog::startImport() {
-	KUrl url = d->mThumbnailPage->destinationUrl();
-	ImporterConfig::setDestinationUrl(url);
-	ImporterConfig::self()->writeConfig();
-
-	d->mCentralWidget->setCurrentWidget(d->mProgressPage);
-	d->mImporter->setAutoRenameFormat(
-		ImporterConfig::autoRename()
-		? ImporterConfig::autoRenameFormat()
-		: QString());
-	d->mImporter->start(d->mThumbnailPage->urlList(), url);
-}
-
-
-void ImportDialog::slotImportFinished() {
-	d->deleteImportedUrls();
-	d->showWhatNext();
-}
-
-
-void ImportDialog::showImportError(const QString& message) {
-	KMessageBox::sorry(this, message);
-	d->mCentralWidget->setCurrentWidget(d->mThumbnailPage);
-}
-
+: d(new ImportDialogPrivate)
+{
+    d->q = this;
+    d->mImporter = new Importer(this);
+    connect(d->mImporter, SIGNAL(error(QString)),
+            SLOT(showImportError(QString)));
+    d->mThumbnailPage = new ThumbnailPage;
+
+    KUrl url = ImporterConfig::destinationUrl();
+    if (!url.isValid()) {
+        url = KUrl::fromPath(KGlobalSettings::picturesPath());
+        int year = QDate::currentDate().year();
+        url.addPath(QString::number(year));
+    }
+    d->mThumbnailPage->setDestinationUrl(url);
+
+    d->mProgressPage = new ProgressPage(d->mImporter);
+
+    d->mDialogPage = new DialogPage;
+
+    d->mCentralWidget = new QStackedWidget;
+    setCentralWidget(d->mCentralWidget);
+    d->mCentralWidget->addWidget(d->mThumbnailPage);
+    d->mCentralWidget->addWidget(d->mProgressPage);
+    d->mCentralWidget->addWidget(d->mDialogPage);
+
+    connect(d->mThumbnailPage, SIGNAL(importRequested()),
+            SLOT(startImport()));
+    connect(d->mThumbnailPage, SIGNAL(rejected()),
+            SLOT(close()));
+    connect(d->mImporter, SIGNAL(importFinished()),
+            SLOT(slotImportFinished()));
+
+    d->mCentralWidget->setCurrentWidget(d->mThumbnailPage);
+
+    setAutoSaveSettings();
+}
+
+ImportDialog::~ImportDialog()
+{
+    delete d;
+}
+
+QSize ImportDialog::sizeHint() const
+{
+    return QSize(700, 500);
+}
+
+void ImportDialog::setSourceUrl(const KUrl& url)
+{
+    d->mThumbnailPage->setSourceUrl(url);
+}
+
+void ImportDialog::startImport()
+{
+    KUrl url = d->mThumbnailPage->destinationUrl();
+    ImporterConfig::setDestinationUrl(url);
+    ImporterConfig::self()->writeConfig();
+
+    d->mCentralWidget->setCurrentWidget(d->mProgressPage);
+    d->mImporter->setAutoRenameFormat(
+        ImporterConfig::autoRename()
+        ? ImporterConfig::autoRenameFormat()
+        : QString());
+    d->mImporter->start(d->mThumbnailPage->urlList(), url);
+}
+
+void ImportDialog::slotImportFinished()
+{
+    d->deleteImportedUrls();
+    d->showWhatNext();
+}
+
+void ImportDialog::showImportError(const QString& message)
+{
+    KMessageBox::sorry(this, message);
+    d->mCentralWidget->setCurrentWidget(d->mThumbnailPage);
+}
 
 } // namespace

=== modified file 'importer/importdialog.h'
--- importer/importdialog.h	2011-07-20 13:46:34 +0000
+++ importer/importdialog.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -29,31 +29,31 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class ImportDialogPrivate;
-class ImportDialog : public KMainWindow {
-	Q_OBJECT
+class ImportDialog : public KMainWindow
+{
+    Q_OBJECT
 public:
-	ImportDialog();
-	~ImportDialog();
+    ImportDialog();
+    ~ImportDialog();
 
-	virtual QSize sizeHint() const;
+    virtual QSize sizeHint() const;
 
 public Q_SLOTS:
-	void setSourceUrl(const KUrl&);
+    void setSourceUrl(const KUrl&);
 
 private Q_SLOTS:
-	void startImport();
-	void slotImportFinished();
-	void showImportError(const QString&);
+    void startImport();
+    void slotImportFinished();
+    void showImportError(const QString&);
 
 private:
-	ImportDialogPrivate* const d;
+    ImportDialogPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* IMPORTDIALOG_H */

=== modified file 'importer/importer.cpp'
--- importer/importer.cpp	2011-07-20 13:46:34 +0000
+++ importer/importer.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -44,180 +44,196 @@
 #include <filenameformater.h>
 #include <lib/timeutils.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct ImporterPrivate {
-	Importer* q;
-	QWidget* mAuthWindow;
-	std::auto_ptr<FileNameFormater> mFileNameFormater;
-	std::auto_ptr<KTempDir> mDestImportDir;
-
-	/* @defgroup reset Should be reset in start()
-	 * @{ */
-	KUrl::List mUrlList;
-	KUrl::List mImportedUrlList;
-	KUrl::List mSkippedUrlList;
-	int mRenamedCount;
-	int mProgress;
-	int mJobProgress;
-	/* @} */
-
-	KUrl mCurrentUrl;
-
-	void emitError(const QString& message) {
-		QMetaObject::invokeMethod(q, "error", Q_ARG(QString, message));
-	}
-
-	bool createImportDir(const KUrl url) {
-		Q_ASSERT(url.isLocalFile());
-		// FIXME: Support remote urls
-
-		if (!KStandardDirs::makeDir(url.toLocalFile())) {
-			emitError(i18n("Could not create destination folder."));
-			return false;
-		}
-		mDestImportDir.reset(new KTempDir(url.toLocalFile() + "/.gwenview_importer-"));
-		mDestImportDir->setAutoRemove(false);
-		if (mDestImportDir->status() != 0) {
-			const QString message = QString::fromLocal8Bit(::strerror(mDestImportDir->status()));
-			emitError(i18n("Could not create temporary upload folder:\n%1", message));
-			return false;
-		}
-		return true;
-	}
-
-	void importNext() {
-		if (mUrlList.empty()) {
-			q->finalizeImport();
-			return;
-		}
-		mCurrentUrl = mUrlList.takeFirst();
-		KUrl dst = KUrl(mDestImportDir->name());
-		dst.addPath(mCurrentUrl.fileName());
-		KIO::Job* job = KIO::copy(mCurrentUrl, dst, KIO::HideProgressInfo);
-		if (job->ui()) {
-			job->ui()->setWindow(mAuthWindow);
-		}
-		QObject::connect(job, SIGNAL(result(KJob*)),
-			q, SLOT(slotCopyDone(KJob*)));
-		QObject::connect(job, SIGNAL(percent(KJob*, unsigned long)),
-			q, SLOT(slotPercent(KJob*, unsigned long)));
-	}
-
-	void renameImportedUrl(const KUrl& src) {
-		KUrl dst = src;
-		dst.cd("..");
-		QString fileName;
-		if (mFileNameFormater.get()) {
-			KFileItem item(KFileItem::Unknown, KFileItem::Unknown, src, true /* delayedMimeTypes */);
-			KDateTime dateTime = TimeUtils::dateTimeForFileItem(item);
-			fileName = mFileNameFormater->format(src, dateTime);
-		} else {
-			fileName = src.fileName();
-		}
-		dst.setFileName(fileName);
-
-		FileUtils::RenameResult result = FileUtils::rename(src, dst, mAuthWindow);
-		switch (result) {
-		case FileUtils::RenamedOK:
-			mImportedUrlList << mCurrentUrl;
-			break;
-		case FileUtils::RenamedUnderNewName:
-			mRenamedCount++;
-			mImportedUrlList << mCurrentUrl;
-			break;
-		case FileUtils::Skipped:
-			mSkippedUrlList << mCurrentUrl;
-			break;
-		case FileUtils::RenameFailed:
-			kWarning() << "Rename failed for" << mCurrentUrl;
-		}
-		q->advance();
-		importNext();
-	}
+    Importer* q;
+    QWidget* mAuthWindow;
+    std::auto_ptr<FileNameFormater> mFileNameFormater;
+    std::auto_ptr<KTempDir> mDestImportDir;
+
+    /* @defgroup reset Should be reset in start()
+     * @{ */
+    KUrl::List mUrlList;
+    KUrl::List mImportedUrlList;
+    KUrl::List mSkippedUrlList;
+    int mRenamedCount;
+    int mProgress;
+    int mJobProgress;
+    /* @} */
+
+    KUrl mCurrentUrl;
+
+    void emitError(const QString& message)
+    {
+        QMetaObject::invokeMethod(q, "error", Q_ARG(QString, message));
+    }
+
+    bool createImportDir(const KUrl url)
+    {
+        Q_ASSERT(url.isLocalFile());
+        // FIXME: Support remote urls
+
+        if (!KStandardDirs::makeDir(url.toLocalFile())) {
+            emitError(i18n("Could not create destination folder."));
+            return false;
+        }
+        mDestImportDir.reset(new KTempDir(url.toLocalFile() + "/.gwenview_importer-"));
+        mDestImportDir->setAutoRemove(false);
+        if (mDestImportDir->status() != 0) {
+            const QString message = QString::fromLocal8Bit(::strerror(mDestImportDir->status()));
+            emitError(i18n("Could not create temporary upload folder:\n%1", message));
+            return false;
+        }
+        return true;
+    }
+
+    void importNext()
+    {
+        if (mUrlList.empty()) {
+            q->finalizeImport();
+            return;
+        }
+        mCurrentUrl = mUrlList.takeFirst();
+        KUrl dst = KUrl(mDestImportDir->name());
+        dst.addPath(mCurrentUrl.fileName());
+        KIO::Job* job = KIO::copy(mCurrentUrl, dst, KIO::HideProgressInfo);
+        if (job->ui()) {
+            job->ui()->setWindow(mAuthWindow);
+        }
+        QObject::connect(job, SIGNAL(result(KJob*)),
+                         q, SLOT(slotCopyDone(KJob*)));
+        QObject::connect(job, SIGNAL(percent(KJob*, ulong)),
+                         q, SLOT(slotPercent(KJob*, ulong)));
+    }
+
+    void renameImportedUrl(const KUrl& src)
+    {
+        KUrl dst = src;
+        dst.cd("..");
+        QString fileName;
+        if (mFileNameFormater.get()) {
+            KFileItem item(KFileItem::Unknown, KFileItem::Unknown, src, true /* delayedMimeTypes */);
+            KDateTime dateTime = TimeUtils::dateTimeForFileItem(item);
+            fileName = mFileNameFormater->format(src, dateTime);
+        } else {
+            fileName = src.fileName();
+        }
+        dst.setFileName(fileName);
+
+        FileUtils::RenameResult result = FileUtils::rename(src, dst, mAuthWindow);
+        switch (result) {
+        case FileUtils::RenamedOK:
+            mImportedUrlList << mCurrentUrl;
+            break;
+        case FileUtils::RenamedUnderNewName:
+            mRenamedCount++;
+            mImportedUrlList << mCurrentUrl;
+            break;
+        case FileUtils::Skipped:
+            mSkippedUrlList << mCurrentUrl;
+            break;
+        case FileUtils::RenameFailed:
+            kWarning() << "Rename failed for" << mCurrentUrl;
+        }
+        q->advance();
+        importNext();
+    }
 };
 
-
 Importer::Importer(QWidget* parent)
 : QObject(parent)
-, d(new ImporterPrivate) {
-	d->q = this;
-	d->mAuthWindow = parent;
-}
-
-Importer::~Importer() {
-	delete d;
-}
-
-void Importer::setAutoRenameFormat(const QString& format) {
-	if (format.isEmpty()) {
-		d->mFileNameFormater.reset(0);
-	} else {
-		d->mFileNameFormater.reset(new FileNameFormater(format));
-	}
-}
-
-void Importer::start(const KUrl::List& list, const KUrl& destination) {
-	d->mUrlList = list;
-	d->mImportedUrlList.clear();
-	d->mSkippedUrlList.clear();
-	d->mRenamedCount = 0;
-	d->mProgress = 0;
-	d->mJobProgress = 0;
-
-	emitProgressChanged();
-	maximumChanged(d->mUrlList.count() * 100);
-
-	if (!d->createImportDir(destination)) {
-		kWarning() << "Could not create import dir";
-		return;
-	}
-	d->importNext();
-}
-
-void Importer::slotCopyDone(KJob* _job) {
-	KIO::CopyJob* job = static_cast<KIO::CopyJob*>(_job);
-	KUrl url = job->destUrl();
-	if (job->error()) {
-		kWarning() << "FIXME: What do we do with failed urls?";
-		advance();
-		d->importNext();
-		return;
-	}
-
-	d->renameImportedUrl(url);
-}
-
-void Importer::finalizeImport() {
-	d->mDestImportDir->unlink();
-	importFinished();
-}
-
-void Importer::advance() {
-	++d->mProgress;
-	d->mJobProgress = 0;
-	emitProgressChanged();
-}
-
-void Importer::slotPercent(KJob*, unsigned long percent) {
-	d->mJobProgress = percent;
-	emitProgressChanged();
-}
-
-void Importer::emitProgressChanged() {
-	progressChanged(d->mProgress * 100 + d->mJobProgress);
-}
-
-KUrl::List Importer::importedUrlList() const {
-	return d->mImportedUrlList;
-}
-
-KUrl::List Importer::skippedUrlList() const {
-	return d->mSkippedUrlList;
-}
-
-int Importer::renamedCount() const {
-	return d->mRenamedCount;
+, d(new ImporterPrivate)
+{
+    d->q = this;
+    d->mAuthWindow = parent;
+}
+
+Importer::~Importer()
+{
+    delete d;
+}
+
+void Importer::setAutoRenameFormat(const QString& format)
+{
+    if (format.isEmpty()) {
+        d->mFileNameFormater.reset(0);
+    } else {
+        d->mFileNameFormater.reset(new FileNameFormater(format));
+    }
+}
+
+void Importer::start(const KUrl::List& list, const KUrl& destination)
+{
+    d->mUrlList = list;
+    d->mImportedUrlList.clear();
+    d->mSkippedUrlList.clear();
+    d->mRenamedCount = 0;
+    d->mProgress = 0;
+    d->mJobProgress = 0;
+
+    emitProgressChanged();
+    maximumChanged(d->mUrlList.count() * 100);
+
+    if (!d->createImportDir(destination)) {
+        kWarning() << "Could not create import dir";
+        return;
+    }
+    d->importNext();
+}
+
+void Importer::slotCopyDone(KJob* _job)
+{
+    KIO::CopyJob* job = static_cast<KIO::CopyJob*>(_job);
+    KUrl url = job->destUrl();
+    if (job->error()) {
+        kWarning() << "FIXME: What do we do with failed urls?";
+        advance();
+        d->importNext();
+        return;
+    }
+
+    d->renameImportedUrl(url);
+}
+
+void Importer::finalizeImport()
+{
+    d->mDestImportDir->unlink();
+    importFinished();
+}
+
+void Importer::advance()
+{
+    ++d->mProgress;
+    d->mJobProgress = 0;
+    emitProgressChanged();
+}
+
+void Importer::slotPercent(KJob*, unsigned long percent)
+{
+    d->mJobProgress = percent;
+    emitProgressChanged();
+}
+
+void Importer::emitProgressChanged()
+{
+    progressChanged(d->mProgress * 100 + d->mJobProgress);
+}
+
+KUrl::List Importer::importedUrlList() const
+{
+    return d->mImportedUrlList;
+}
+
+KUrl::List Importer::skippedUrlList() const
+{
+    return d->mSkippedUrlList;
+}
+
+int Importer::renamedCount() const
+{
+    return d->mRenamedCount;
 }
 
 } // namespace

=== modified file 'importer/importer.h'
--- importer/importer.h	2011-07-20 13:46:34 +0000
+++ importer/importer.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -31,61 +31,62 @@
 
 class KJob;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class ImporterPrivate;
-class Importer : public QObject {
-	Q_OBJECT
+class Importer : public QObject
+{
+    Q_OBJECT
 public:
-	Importer(QWidget* authWindow);
-	~Importer();
-
-	/**
-	 * Defines the auto-rename format applied to imported documents
-	 * Set to QString() to reset
-	 */
-	void setAutoRenameFormat(const QString&);
-
-	void start(const KUrl::List& list, const KUrl& destUrl);
-
-	KUrl::List importedUrlList() const;
-
-	/**
-	 * Documents which have been skipped during import
-	 */
-	KUrl::List skippedUrlList() const;
-
-	/**
-	 * How many documents have been renamed during import
-	 */
-	int renamedCount() const;
+    Importer(QWidget* authWindow);
+    ~Importer();
+
+    /**
+     * Defines the auto-rename format applied to imported documents
+     * Set to QString() to reset
+     */
+    void setAutoRenameFormat(const QString&);
+
+    void start(const KUrl::List& list, const KUrl& destUrl);
+
+    KUrl::List importedUrlList() const;
+
+    /**
+     * Documents which have been skipped during import
+     */
+    KUrl::List skippedUrlList() const;
+
+    /**
+     * How many documents have been renamed during import
+     */
+    int renamedCount() const;
 
 Q_SIGNALS:
-	void importFinished();
-
-	void progressChanged(int);
-
-	void maximumChanged(int);
-
-	/**
-	 * An error has occured and caused the whole process to stop without
-	 * importing anything
-	 */
-	void error(const QString& message);
+    void importFinished();
+
+    void progressChanged(int);
+
+    void maximumChanged(int);
+
+    /**
+     * An error has occured and caused the whole process to stop without
+     * importing anything
+     */
+    void error(const QString& message);
 
 private Q_SLOTS:
-	void slotCopyDone(KJob*);
-	void slotPercent(KJob*, unsigned long);
-	void emitProgressChanged();
+    void slotCopyDone(KJob*);
+    void slotPercent(KJob*, unsigned long);
+    void emitProgressChanged();
 
 private:
-	friend class ImporterPrivate;
-	ImporterPrivate* const d;
-	void advance();
-	void finalizeImport();
+    friend class ImporterPrivate;
+    ImporterPrivate* const d;
+    void advance();
+    void finalizeImport();
 };
 
-
 } // namespace
 
 #endif /* IMPORTER_H */

=== modified file 'importer/importerconfigdialog.cpp'
--- importer/importerconfigdialog.cpp	2011-09-08 12:26:41 +0000
+++ importer/importerconfigdialog.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -32,69 +32,70 @@
 #include "importerconfig.h"
 #include "ui_importerconfigdialog.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 static const QString PREVIEW_FILENAME = "PICT0012.JPG";
 static const KDateTime PREVIEW_DATETIME = KDateTime(QDate(2009, 10, 25), QTime(17, 51, 18));
 
 struct ImporterConfigDialogPrivate : public Ui_ImporterConfigDialog {
-	ImporterConfigDialog* q;
-
-	void setupHelpText() {
-		QString helpText = "<ul>";
-		FileNameFormater::HelpMap map = FileNameFormater::helpMap();
-		FileNameFormater::HelpMap::ConstIterator
-			it = map.constBegin(),
-			end = map.constEnd();
-		for (;it != end; ++it) {
-			QString keyword = '{' + it.key() + '}';
-			QString explanation = Qt::escape(it.value());
-			QString link = QString("<a href='%1'>%1</a>").arg(keyword);
-			helpText += "<li>" + i18nc("%1 is the importer keyword, %2 is keyword explanation", "%1: %2", link, explanation) + "</li>";
-		}
-		helpText += "</ul>";
-		mRenameFormatHelpLabel->setText(helpText);
-
-		QObject::connect(mRenameFormatHelpLabel, SIGNAL(linkActivated(const QString&)),
-			q, SLOT(slotHelpLinkActivated(const QString&)));
-	}
+    ImporterConfigDialog* q;
+
+    void setupHelpText()
+    {
+        QString helpText = "<ul>";
+        FileNameFormater::HelpMap map = FileNameFormater::helpMap();
+        FileNameFormater::HelpMap::ConstIterator
+        it = map.constBegin(),
+        end = map.constEnd();
+        for (; it != end; ++it) {
+            QString keyword = '{' + it.key() + '}';
+            QString explanation = Qt::escape(it.value());
+            QString link = QString("<a href='%1'>%1</a>").arg(keyword);
+            helpText += "<li>" + i18nc("%1 is the importer keyword, %2 is keyword explanation", "%1: %2", link, explanation) + "</li>";
+        }
+        helpText += "</ul>";
+        mRenameFormatHelpLabel->setText(helpText);
+
+        QObject::connect(mRenameFormatHelpLabel, SIGNAL(linkActivated(QString)),
+                         q, SLOT(slotHelpLinkActivated(QString)));
+    }
 };
 
-
 ImporterConfigDialog::ImporterConfigDialog(QWidget* parent)
 : KConfigDialog(parent, "Importer Settings", ImporterConfig::self())
-, d(new ImporterConfigDialogPrivate) {
-	d->q = this;
-	QWidget* widget = new QWidget;
-	d->setupUi(widget);
-	setFaceType(KPageDialog::Plain);
-	// Hide help button until there is actual documentation to show
-	showButton(KDialog::Help, false);
-	showButtonSeparator(true);
-	addPage(widget, QString());
-
-	connect(d->kcfg_AutoRenameFormat, SIGNAL(textChanged(const QString&)),
-		SLOT(updatePreview()));
-
-	d->setupHelpText();
-	updatePreview();
-}
-
-
-ImporterConfigDialog::~ImporterConfigDialog() {
-	delete d;
-}
-
-
-void ImporterConfigDialog::slotHelpLinkActivated(const QString& keyword) {
-	d->kcfg_AutoRenameFormat->insert(keyword);
-}
-
-
-void ImporterConfigDialog::updatePreview() {
-	FileNameFormater formater(d->kcfg_AutoRenameFormat->text());
-	d->mPreviewOutputLabel->setText(formater.format(KUrl::fromPath("/" + PREVIEW_FILENAME), PREVIEW_DATETIME));
-}
-
+, d(new ImporterConfigDialogPrivate)
+{
+    d->q = this;
+    QWidget* widget = new QWidget;
+    d->setupUi(widget);
+    setFaceType(KPageDialog::Plain);
+    // Hide help button until there is actual documentation to show
+    showButton(KDialog::Help, false);
+    showButtonSeparator(true);
+    addPage(widget, QString());
+
+    connect(d->kcfg_AutoRenameFormat, SIGNAL(textChanged(QString)),
+            SLOT(updatePreview()));
+
+    d->setupHelpText();
+    updatePreview();
+}
+
+ImporterConfigDialog::~ImporterConfigDialog()
+{
+    delete d;
+}
+
+void ImporterConfigDialog::slotHelpLinkActivated(const QString& keyword)
+{
+    d->kcfg_AutoRenameFormat->insert(keyword);
+}
+
+void ImporterConfigDialog::updatePreview()
+{
+    FileNameFormater formater(d->kcfg_AutoRenameFormat->text());
+    d->mPreviewOutputLabel->setText(formater.format(KUrl::fromPath("/" + PREVIEW_FILENAME), PREVIEW_DATETIME));
+}
 
 } // namespace

=== modified file 'importer/importerconfigdialog.h'
--- importer/importerconfigdialog.h	2011-07-20 13:46:34 +0000
+++ importer/importerconfigdialog.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -28,25 +28,25 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class ImporterConfigDialogPrivate;
-class ImporterConfigDialog : public KConfigDialog {
-	Q_OBJECT
+class ImporterConfigDialog : public KConfigDialog
+{
+    Q_OBJECT
 public:
-	ImporterConfigDialog(QWidget*);
-	~ImporterConfigDialog();
+    ImporterConfigDialog(QWidget*);
+    ~ImporterConfigDialog();
 
 private Q_SLOTS:
-	void slotHelpLinkActivated(const QString& keyword);
-	void updatePreview();
+    void slotHelpLinkActivated(const QString& keyword);
+    void updatePreview();
 
 private:
-	ImporterConfigDialogPrivate* const d;
+    ImporterConfigDialogPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* IMPORTERCONFIGDIALOG_H */

=== modified file 'importer/main.cpp'
--- importer/main.cpp	2011-07-20 13:46:34 +0000
+++ importer/main.cpp	2011-12-15 14:17:54 +0000
@@ -32,44 +32,45 @@
 #include <lib/version.h>
 #include "importdialog.h"
 
-int main(int argc, char *argv[]) {
-	KAboutData aboutData(
-		"gwenview_importer",        /* appname */
-		"gwenview",                          /* catalogName */
-		ki18n("Gwenview Importer"), /* programName */
-		GWENVIEW_VERSION);          /* version */
-	aboutData.setShortDescription(ki18n("Photo Importer"));
-	aboutData.setLicense(KAboutData::License_GPL);
-	aboutData.setCopyrightStatement(ki18n("Copyright 2009-2010 Aurélien Gâteau"));
-	aboutData.addAuthor(
-		ki18n("Aurélien Gâteau"),
-		ki18n("Main developer"),
-		"agateau@kde.org");
-
-	KCmdLineArgs::init(argc, argv, &aboutData);
-
-	KCmdLineOptions options;
-	options.add("+[folder]", ki18n("Source folder"));
-	KCmdLineArgs::addCmdLineOptions( options );
-
-	KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
-	if (args->count() != 1) {
-		kError() << "Wrong arg count. FIXME";
-		return 1;
-	}
-	KUrl url = args->url(0);
-	if (!url.isValid()) {
-		kError() << "Invalid url. FIXME";
-		return 1;
-	}
-	args->clear();
-
-	KApplication app;
-
-	Gwenview::ImageFormats::registerPlugins();
-
-	Gwenview::ImportDialog* dialog = new Gwenview::ImportDialog();
-	dialog->show();
-	QMetaObject::invokeMethod(dialog, "setSourceUrl", Qt::QueuedConnection, Q_ARG(KUrl, url));
-	return app.exec();
+int main(int argc, char *argv[])
+{
+    KAboutData aboutData(
+        "gwenview_importer",        /* appname */
+        "gwenview",                          /* catalogName */
+        ki18n("Gwenview Importer"), /* programName */
+        GWENVIEW_VERSION);          /* version */
+    aboutData.setShortDescription(ki18n("Photo Importer"));
+    aboutData.setLicense(KAboutData::License_GPL);
+    aboutData.setCopyrightStatement(ki18n("Copyright 2009-2010 Aurélien Gâteau"));
+    aboutData.addAuthor(
+        ki18n("Aurélien Gâteau"),
+        ki18n("Main developer"),
+        "agateau@kde.org");
+
+    KCmdLineArgs::init(argc, argv, &aboutData);
+
+    KCmdLineOptions options;
+    options.add("+[folder]", ki18n("Source folder"));
+    KCmdLineArgs::addCmdLineOptions(options);
+
+    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
+    if (args->count() != 1) {
+        kError() << "Wrong arg count. FIXME";
+        return 1;
+    }
+    KUrl url = args->url(0);
+    if (!url.isValid()) {
+        kError() << "Invalid url. FIXME";
+        return 1;
+    }
+    args->clear();
+
+    KApplication app;
+
+    Gwenview::ImageFormats::registerPlugins();
+
+    Gwenview::ImportDialog* dialog = new Gwenview::ImportDialog();
+    dialog->show();
+    QMetaObject::invokeMethod(dialog, "setSourceUrl", Qt::QueuedConnection, Q_ARG(KUrl, url));
+    return app.exec();
 }

=== modified file 'importer/progresspage.cpp'
--- importer/progresspage.cpp	2011-07-20 13:46:34 +0000
+++ importer/progresspage.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -25,27 +25,30 @@
 #include <ui_progresspage.h>
 #include "importer.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct ProgressPagePrivate : public Ui_ProgressPage {
-	ProgressPage* q;
-	Importer* mImporter;
+    ProgressPage* q;
+    Importer* mImporter;
 };
 
 ProgressPage::ProgressPage(Importer* importer)
-: d(new ProgressPagePrivate) {
-	d->q = this;
-	d->mImporter = importer;
-	d->setupUi(this);
+: d(new ProgressPagePrivate)
+{
+    d->q = this;
+    d->mImporter = importer;
+    d->setupUi(this);
 
-	connect(d->mImporter, SIGNAL(progressChanged(int)),
-		d->mProgressBar, SLOT(setValue(int)));
-	connect(d->mImporter, SIGNAL(maximumChanged(int)),
-		d->mProgressBar, SLOT(setMaximum(int)));
+    connect(d->mImporter, SIGNAL(progressChanged(int)),
+            d->mProgressBar, SLOT(setValue(int)));
+    connect(d->mImporter, SIGNAL(maximumChanged(int)),
+            d->mProgressBar, SLOT(setMaximum(int)));
 }
 
-ProgressPage::~ProgressPage() {
-	delete d;
+ProgressPage::~ProgressPage()
+{
+    delete d;
 }
 
 } // namespace

=== modified file 'importer/progresspage.h'
--- importer/progresspage.h	2011-07-20 13:46:34 +0000
+++ importer/progresspage.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -29,22 +29,23 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class Importer;
 
 class ProgressPagePrivate;
-class ProgressPage : public QWidget {
-	Q_OBJECT
+class ProgressPage : public QWidget
+{
+    Q_OBJECT
 public:
-	ProgressPage(Importer*);
-	~ProgressPage();
+    ProgressPage(Importer*);
+    ~ProgressPage();
 
 private:
-	ProgressPagePrivate* const d;
+    ProgressPagePrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* PROGRESSPAGE_H */

=== modified file 'importer/thumbnailpage.cpp'
--- importer/thumbnailpage.cpp	2011-07-20 13:46:34 +0000
+++ importer/thumbnailpage.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -40,248 +40,252 @@
 #include "importerconfigdialog.h"
 #include <ui_thumbnailpage.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 static const int DEFAULT_THUMBNAIL_SIZE = 128;
 
-
-class ImporterThumbnailViewHelper : public AbstractThumbnailViewHelper {
+class ImporterThumbnailViewHelper : public AbstractThumbnailViewHelper
+{
 public:
-	ImporterThumbnailViewHelper(QObject* parent)
-	: AbstractThumbnailViewHelper(parent)
-	{}
-
-	void showContextMenu(QWidget*)
-	{}
-
-	void showMenuForUrlDroppedOnViewport(QWidget*, const KUrl::List&)
-	{}
-
-	void showMenuForUrlDroppedOnDir(QWidget*, const KUrl::List&, const KUrl&)
-	{}
+    ImporterThumbnailViewHelper(QObject* parent)
+        : AbstractThumbnailViewHelper(parent)
+    {}
+
+    void showContextMenu(QWidget*)
+    {}
+
+    void showMenuForUrlDroppedOnViewport(QWidget*, const KUrl::List&)
+    {}
+
+    void showMenuForUrlDroppedOnDir(QWidget*, const KUrl::List&, const KUrl&)
+    {}
 };
 
-
 struct ThumbnailPagePrivate : public Ui_ThumbnailPage {
-	ThumbnailPage* q;
-	KUrlNavigator* mUrlNavigator;
-	SortedDirModel* mDirModel;
-	QPushButton* mImportSelectedButton;
-	QPushButton* mImportAllButton;
-	KUrl::List mUrlList;
-
-	void setupDirModel() {
-		mDirModel = new SortedDirModel(q);
-		mDirModel->setKindFilter(
-			MimeTypeUtils::KIND_DIR
-			| MimeTypeUtils::KIND_ARCHIVE
-			| MimeTypeUtils::KIND_RASTER_IMAGE
-			| MimeTypeUtils::KIND_SVG_IMAGE
-			| MimeTypeUtils::KIND_VIDEO
-			);
-	}
-
-	void setupIcons() {
-		const KIconLoader::Group group = KIconLoader::NoGroup;
-		const int size = KIconLoader::SizeHuge;
-		mSrcIconLabel->setPixmap(KIconLoader::global()->loadIcon("camera-photo", group, size));
-		mDstIconLabel->setPixmap(KIconLoader::global()->loadIcon("computer", group, size));
-	}
-
-	void setupDstUrlRequester() {
-		mDstUrlRequester->setMode(KFile::Directory | KFile::LocalOnly);
-	}
-
-	void setupUrlNavigator() {
-		mUrlNavigator = new KUrlNavigator(0 /* KFilePlacesModel */, KUrl(), mUrlNavigatorContainer);
-		mUrlNavigator->setShowFullPath(true);
-		QVBoxLayout* layout = new QVBoxLayout(mUrlNavigatorContainer);
-		layout->setMargin(0);
-		layout->addWidget(mUrlNavigator);
-
-		QObject::connect(mUrlNavigator, SIGNAL(urlChanged(const KUrl&)),
-			q, SLOT(openUrl(const KUrl&)) );
-	}
-
-	void setupThumbnailView() {
-		mThumbnailView->setModel(mDirModel);
-		mThumbnailView->setSelectionMode(QAbstractItemView::ExtendedSelection);
-		mThumbnailView->setThumbnailViewHelper(new ImporterThumbnailViewHelper(q));
-
-		PreviewItemDelegate* delegate = new PreviewItemDelegate(mThumbnailView);
-		delegate->setThumbnailDetails(PreviewItemDelegate::FileNameDetail);
-		delegate->setContextBarMode(PreviewItemDelegate::SelectionOnlyContextBar);
-		mThumbnailView->setItemDelegate(delegate);
-
-		// Colors
-		int value = GwenviewConfig::viewBackgroundValue();
-		QColor bgColor = QColor::fromHsv(0, 0, value);
-		QColor fgColor = value > 128 ? Qt::black : Qt::white;
-
-		QPalette pal = mThumbnailView->palette();
-		pal.setColor(QPalette::Base, bgColor);
-		pal.setColor(QPalette::Text, fgColor);
-
-		mThumbnailView->setPalette(pal);
-
-		QObject::connect(mSlider, SIGNAL(valueChanged(int)),
-			mThumbnailView, SLOT(setThumbnailSize(int)));
-		int thumbnailSize = DEFAULT_THUMBNAIL_SIZE;
-		mSlider->setValue(thumbnailSize);
-		mSlider->updateToolTip();
-		mThumbnailView->setThumbnailSize(thumbnailSize);
-
-		QObject::connect(mThumbnailView, SIGNAL(indexActivated(const QModelIndex&)),
-			q, SLOT(slotThumbnailViewIndexActivated(const QModelIndex&)));
-	}
-
-	void setupButtonBox() {
-		QObject::connect(mConfigureButton, SIGNAL(clicked()),
-			q, SLOT(showConfigDialog()));
-
-		mImportSelectedButton = mButtonBox->addButton(
-			i18n("Import Selected"), QDialogButtonBox::AcceptRole,
-			q, SLOT(slotImportSelected()));
-
-		mImportAllButton = mButtonBox->addButton(
-			i18n("Import All"), QDialogButtonBox::AcceptRole,
-			q, SLOT(slotImportAll()));
-
-		QObject::connect(
-			mThumbnailView->selectionModel(), SIGNAL(selectionChanged(const QItemSelection&, const QItemSelection&)),
-			q, SLOT(updateImportButtons()));
-		QObject::connect(
-			mDirModel, SIGNAL(rowsInserted(const QModelIndex&, int, int)),
-			q, SLOT(updateImportButtons()));
-		QObject::connect(
-			mDirModel, SIGNAL(rowsRemoved(const QModelIndex&, int, int)),
-			q, SLOT(updateImportButtons()));
-		QObject::connect(
-			mDirModel, SIGNAL(modelReset()),
-			q, SLOT(updateImportButtons()));
-
-		QObject::connect(
-			mButtonBox, SIGNAL(rejected()),
-			q, SIGNAL(rejected()));
-
-		q->updateImportButtons();
-	}
+    ThumbnailPage* q;
+    KUrlNavigator* mUrlNavigator;
+    SortedDirModel* mDirModel;
+    QPushButton* mImportSelectedButton;
+    QPushButton* mImportAllButton;
+    KUrl::List mUrlList;
+
+    void setupDirModel()
+    {
+        mDirModel = new SortedDirModel(q);
+        mDirModel->setKindFilter(
+            MimeTypeUtils::KIND_DIR
+            | MimeTypeUtils::KIND_ARCHIVE
+            | MimeTypeUtils::KIND_RASTER_IMAGE
+            | MimeTypeUtils::KIND_SVG_IMAGE
+            | MimeTypeUtils::KIND_VIDEO
+        );
+    }
+
+    void setupIcons()
+    {
+        const KIconLoader::Group group = KIconLoader::NoGroup;
+        const int size = KIconLoader::SizeHuge;
+        mSrcIconLabel->setPixmap(KIconLoader::global()->loadIcon("camera-photo", group, size));
+        mDstIconLabel->setPixmap(KIconLoader::global()->loadIcon("computer", group, size));
+    }
+
+    void setupDstUrlRequester()
+    {
+        mDstUrlRequester->setMode(KFile::Directory | KFile::LocalOnly);
+    }
+
+    void setupUrlNavigator()
+    {
+        mUrlNavigator = new KUrlNavigator(0 /* KFilePlacesModel */, KUrl(), mUrlNavigatorContainer);
+        mUrlNavigator->setShowFullPath(true);
+        QVBoxLayout* layout = new QVBoxLayout(mUrlNavigatorContainer);
+        layout->setMargin(0);
+        layout->addWidget(mUrlNavigator);
+
+        QObject::connect(mUrlNavigator, SIGNAL(urlChanged(KUrl)),
+                         q, SLOT(openUrl(KUrl)));
+    }
+
+    void setupThumbnailView()
+    {
+        mThumbnailView->setModel(mDirModel);
+        mThumbnailView->setSelectionMode(QAbstractItemView::ExtendedSelection);
+        mThumbnailView->setThumbnailViewHelper(new ImporterThumbnailViewHelper(q));
+
+        PreviewItemDelegate* delegate = new PreviewItemDelegate(mThumbnailView);
+        delegate->setThumbnailDetails(PreviewItemDelegate::FileNameDetail);
+        delegate->setContextBarMode(PreviewItemDelegate::SelectionOnlyContextBar);
+        mThumbnailView->setItemDelegate(delegate);
+
+        // Colors
+        int value = GwenviewConfig::viewBackgroundValue();
+        QColor bgColor = QColor::fromHsv(0, 0, value);
+        QColor fgColor = value > 128 ? Qt::black : Qt::white;
+
+        QPalette pal = mThumbnailView->palette();
+        pal.setColor(QPalette::Base, bgColor);
+        pal.setColor(QPalette::Text, fgColor);
+
+        mThumbnailView->setPalette(pal);
+
+        QObject::connect(mSlider, SIGNAL(valueChanged(int)),
+                         mThumbnailView, SLOT(setThumbnailSize(int)));
+        int thumbnailSize = DEFAULT_THUMBNAIL_SIZE;
+        mSlider->setValue(thumbnailSize);
+        mSlider->updateToolTip();
+        mThumbnailView->setThumbnailSize(thumbnailSize);
+
+        QObject::connect(mThumbnailView, SIGNAL(indexActivated(QModelIndex)),
+                         q, SLOT(slotThumbnailViewIndexActivated(QModelIndex)));
+    }
+
+    void setupButtonBox()
+    {
+        QObject::connect(mConfigureButton, SIGNAL(clicked()),
+                         q, SLOT(showConfigDialog()));
+
+        mImportSelectedButton = mButtonBox->addButton(
+                                    i18n("Import Selected"), QDialogButtonBox::AcceptRole,
+                                    q, SLOT(slotImportSelected()));
+
+        mImportAllButton = mButtonBox->addButton(
+                               i18n("Import All"), QDialogButtonBox::AcceptRole,
+                               q, SLOT(slotImportAll()));
+
+        QObject::connect(
+            mThumbnailView->selectionModel(), SIGNAL(selectionChanged(QItemSelection, QItemSelection)),
+            q, SLOT(updateImportButtons()));
+        QObject::connect(
+            mDirModel, SIGNAL(rowsInserted(QModelIndex, int, int)),
+            q, SLOT(updateImportButtons()));
+        QObject::connect(
+            mDirModel, SIGNAL(rowsRemoved(QModelIndex, int, int)),
+            q, SLOT(updateImportButtons()));
+        QObject::connect(
+            mDirModel, SIGNAL(modelReset()),
+            q, SLOT(updateImportButtons()));
+
+        QObject::connect(
+            mButtonBox, SIGNAL(rejected()),
+            q, SIGNAL(rejected()));
+
+        q->updateImportButtons();
+    }
 };
 
-
 ThumbnailPage::ThumbnailPage()
-: d(new ThumbnailPagePrivate) {
-	d->q = this;
-	d->setupUi(this);
-	d->setupIcons();
-	d->setupDirModel();
-	d->setupDstUrlRequester();
-	d->setupUrlNavigator();
-	d->setupThumbnailView();
-	d->setupButtonBox();
-}
-
-
-ThumbnailPage::~ThumbnailPage() {
-	delete d;
-}
-
-
-void ThumbnailPage::setSourceUrl(const KUrl& url) {
-	DocumentDirFinder* finder = new DocumentDirFinder(url);
-	connect(finder, SIGNAL(done(const KUrl&, DocumentDirFinder::Status)),
-		SLOT(slotDocumentDirFinderDone(const KUrl&, DocumentDirFinder::Status)));
-	finder->start();
-}
-
-
-void ThumbnailPage::slotDocumentDirFinderDone(const KUrl& url, DocumentDirFinder::Status status) {
-	kDebug() << url << "status:" << status;
-	kDebug() << "FIXME: Handle different status";
-	openUrl(url);
-}
-
-
-void ThumbnailPage::openUrl(const KUrl& url) {
-	d->mUrlNavigator->setLocationUrl(url);
-	d->mDirModel->dirLister()->openUrl(url);
-}
-
-
-KUrl::List ThumbnailPage::urlList() const {
-	return d->mUrlList;
-}
-
-
-
-void ThumbnailPage::setDestinationUrl(const KUrl& url) {
-	d->mDstUrlRequester->setUrl(url);
-}
-
-
-KUrl ThumbnailPage::destinationUrl() const {
-	return d->mDstUrlRequester->url();
-}
-
-
-void ThumbnailPage::slotThumbnailViewIndexActivated(const QModelIndex& index) {
-	if (!index.isValid()) {
-		return;
-	}
-
-	KFileItem item = d->mDirModel->itemForIndex(index);
-	if (item.isDir()) {
-		// Item is a dir, open it
-		openUrl(item.url());
-	} else {
-		QString protocol = ArchiveUtils::protocolForMimeType(item.mimetype());
-		if (!protocol.isEmpty()) {
-			// Item is an archive, tweak url then open it
-			KUrl url = item.url();
-			url.setProtocol(protocol);
-			openUrl(url);
-		}
-	}
-}
-
-
-void ThumbnailPage::slotImportSelected() {
-	importList(d->mThumbnailView->selectionModel()->selectedIndexes());
-}
-
-
-void ThumbnailPage::slotImportAll() {
-	QModelIndexList list;
-	for (int row = d->mDirModel->rowCount() - 1; row >= 0; --row) {
-		list << d->mDirModel->index(row, 0);
-	}
-	importList(list);
-}
-
-
-void ThumbnailPage::importList(const QModelIndexList& list) {
-	d->mUrlList.clear();
-	Q_FOREACH(const QModelIndex& index, list) {
-		KFileItem item = d->mDirModel->itemForIndex(index);
-		if (!ArchiveUtils::fileItemIsDirOrArchive(item)) {
-			d->mUrlList << item.url();
-		}
-		// FIXME: Handle dirs (do we want to import recursively?)
-	}
-	emit importRequested();
-}
-
-
-void ThumbnailPage::updateImportButtons() {
-	d->mImportSelectedButton->setEnabled(d->mThumbnailView->selectionModel()->hasSelection());
-	d->mImportAllButton->setEnabled(d->mDirModel->hasDocuments());
-}
-
-
-void ThumbnailPage::showConfigDialog() {
-	ImporterConfigDialog dialog(this);
-	dialog.exec();
-}
-
+: d(new ThumbnailPagePrivate)
+{
+    d->q = this;
+    d->setupUi(this);
+    d->setupIcons();
+    d->setupDirModel();
+    d->setupDstUrlRequester();
+    d->setupUrlNavigator();
+    d->setupThumbnailView();
+    d->setupButtonBox();
+}
+
+ThumbnailPage::~ThumbnailPage()
+{
+    delete d;
+}
+
+void ThumbnailPage::setSourceUrl(const KUrl& url)
+{
+    DocumentDirFinder* finder = new DocumentDirFinder(url);
+    connect(finder, SIGNAL(done(KUrl, DocumentDirFinder::Status)),
+            SLOT(slotDocumentDirFinderDone(KUrl, DocumentDirFinder::Status)));
+    finder->start();
+}
+
+void ThumbnailPage::slotDocumentDirFinderDone(const KUrl& url, DocumentDirFinder::Status status)
+{
+    kDebug() << url << "status:" << status;
+    kDebug() << "FIXME: Handle different status";
+    openUrl(url);
+}
+
+void ThumbnailPage::openUrl(const KUrl& url)
+{
+    d->mUrlNavigator->setLocationUrl(url);
+    d->mDirModel->dirLister()->openUrl(url);
+}
+
+KUrl::List ThumbnailPage::urlList() const
+{
+    return d->mUrlList;
+}
+
+void ThumbnailPage::setDestinationUrl(const KUrl& url)
+{
+    d->mDstUrlRequester->setUrl(url);
+}
+
+KUrl ThumbnailPage::destinationUrl() const
+{
+    return d->mDstUrlRequester->url();
+}
+
+void ThumbnailPage::slotThumbnailViewIndexActivated(const QModelIndex& index)
+{
+    if (!index.isValid()) {
+        return;
+    }
+
+    KFileItem item = d->mDirModel->itemForIndex(index);
+    if (item.isDir()) {
+        // Item is a dir, open it
+        openUrl(item.url());
+    } else {
+        QString protocol = ArchiveUtils::protocolForMimeType(item.mimetype());
+        if (!protocol.isEmpty()) {
+            // Item is an archive, tweak url then open it
+            KUrl url = item.url();
+            url.setProtocol(protocol);
+            openUrl(url);
+        }
+    }
+}
+
+void ThumbnailPage::slotImportSelected()
+{
+    importList(d->mThumbnailView->selectionModel()->selectedIndexes());
+}
+
+void ThumbnailPage::slotImportAll()
+{
+    QModelIndexList list;
+    for (int row = d->mDirModel->rowCount() - 1; row >= 0; --row) {
+        list << d->mDirModel->index(row, 0);
+    }
+    importList(list);
+}
+
+void ThumbnailPage::importList(const QModelIndexList& list)
+{
+    d->mUrlList.clear();
+    Q_FOREACH(const QModelIndex & index, list) {
+        KFileItem item = d->mDirModel->itemForIndex(index);
+        if (!ArchiveUtils::fileItemIsDirOrArchive(item)) {
+            d->mUrlList << item.url();
+        }
+        // FIXME: Handle dirs (do we want to import recursively?)
+    }
+    emit importRequested();
+}
+
+void ThumbnailPage::updateImportButtons()
+{
+    d->mImportSelectedButton->setEnabled(d->mThumbnailView->selectionModel()->hasSelection());
+    d->mImportAllButton->setEnabled(d->mDirModel->hasDocuments());
+}
+
+void ThumbnailPage::showConfigDialog()
+{
+    ImporterConfigDialog dialog(this);
+    dialog.exec();
+}
 
 } // namespace

=== modified file 'importer/thumbnailpage.h'
--- importer/thumbnailpage.h	2011-07-20 13:46:34 +0000
+++ importer/thumbnailpage.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -31,47 +31,47 @@
 // Local
 #include "documentdirfinder.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class ThumbnailPagePrivate;
-class ThumbnailPage : public QWidget {
-	Q_OBJECT
+class ThumbnailPage : public QWidget
+{
+    Q_OBJECT
 public:
-	ThumbnailPage();
-	~ThumbnailPage();
-
-	/**
-	 * Returns the list of urls to import
-	 * Only valid after importRequested() has been emitted
-	 */
-	KUrl::List urlList() const;
-
-	KUrl destinationUrl() const;
-	void setDestinationUrl(const KUrl&);
-
-	void setSourceUrl(const KUrl&);
+    ThumbnailPage();
+    ~ThumbnailPage();
+
+    /**
+     * Returns the list of urls to import
+     * Only valid after importRequested() has been emitted
+     */
+    KUrl::List urlList() const;
+
+    KUrl destinationUrl() const;
+    void setDestinationUrl(const KUrl&);
+
+    void setSourceUrl(const KUrl&);
 
 Q_SIGNALS:
-	void importRequested();
-	void rejected();
+    void importRequested();
+    void rejected();
 
 private Q_SLOTS:
-	void slotImportSelected();
-	void slotImportAll();
-	void updateImportButtons();
-	void slotThumbnailViewIndexActivated(const QModelIndex&);
-	void openUrl(const KUrl&);
-	void slotDocumentDirFinderDone(const KUrl& url, DocumentDirFinder::Status status);
-	void showConfigDialog();
+    void slotImportSelected();
+    void slotImportAll();
+    void updateImportButtons();
+    void slotThumbnailViewIndexActivated(const QModelIndex&);
+    void openUrl(const KUrl&);
+    void slotDocumentDirFinderDone(const KUrl& url, DocumentDirFinder::Status status);
+    void showConfigDialog();
 
 private:
-	friend class ThumbnailPagePrivate;
-	ThumbnailPagePrivate* const d;
-	void importList(const QModelIndexList&);
+    friend class ThumbnailPagePrivate;
+    ThumbnailPagePrivate* const d;
+    void importList(const QModelIndexList&);
 };
 
-
 } // namespace
 
 #endif /* THUMBNAILPAGE_H */

=== modified file 'lib/CMakeLists.txt'
--- lib/CMakeLists.txt	2011-07-20 13:46:34 +0000
+++ lib/CMakeLists.txt	2011-12-15 14:17:54 +0000
@@ -59,19 +59,22 @@
 	document/svgdocumentloadedimpl.cpp
 	document/videodocumentloadedimpl.cpp
 	documentview/abstractdocumentviewadapter.cpp
+	documentview/abstractimageview.cpp
+	documentview/abstractrasterimageviewtool.cpp
+	documentview/birdeyeview.cpp
 	documentview/documentview.cpp
 	documentview/documentviewcontroller.cpp
 	documentview/documentviewsynchronizer.cpp
+	documentview/imageviewadapter.cpp
+	documentview/loadingindicator.cpp
 	documentview/messageviewadapter.cpp
-	documentview/imageviewadapter.cpp
+	documentview/rasterimageview.cpp
 	documentview/svgviewadapter.cpp
 	documentview/videoviewadapter.cpp
 	abstractimageoperation.cpp
-	abstractimageviewtool.cpp
 	documentview/documentviewcontainer.cpp
 	binder.cpp
 	eventwatcher.cpp
-	splittercollapser.cpp
 	historymodel.cpp
 	archiveutils.cpp
 	datewidget.cpp
@@ -79,6 +82,8 @@
 	flowlayout.cpp
 	fullscreenbar.cpp
 	fullscreentheme.cpp
+	graphicshudwidget.cpp
+	graphicswidgetfloater.cpp
 	hudwidget.cpp
 	imageformats/imageformats.cpp
 	imageformats/jpegplugin.cpp
@@ -86,7 +91,6 @@
 	imagemetainfomodel.cpp
 	imagescaler.cpp
 	imageutils.cpp
-	imageview.cpp
 	invisiblebuttongroup.cpp
 	iodevicejpegsourcemanager.cpp
 	jpegcontent.cpp
@@ -101,7 +105,6 @@
 	print/printoptionspage.cpp
 	slidecontainer.cpp
 	slideshow.cpp
-	scrolltool.cpp
 	statusbartoolbutton.cpp
 	redeyereduction/redeyereductionimageoperation.cpp
 	redeyereduction/redeyereductiontool.cpp
@@ -161,7 +164,7 @@
 	crop/cropwidget.ui
 	documentview/messageview.ui
 	print/printoptionspage.ui
-	redeyereduction/redeyereductionhud.ui
+	redeyereduction/redeyereductionwidget.ui
 	resize/resizeimagewidget.ui
 	)
 
@@ -179,6 +182,7 @@
 	${KDE4_PHONON_LIBS}
 	${JPEG_LIBRARY}
 	${EXIV2_LIBRARIES}
+	${QT_QTOPENGL_LIBRARY}
 	)
 if( WIN32 )
 target_link_libraries( gwenviewlib ${EXPAT_LIBRARIES} )

=== modified file 'lib/abstractimageoperation.cpp'
--- lib/abstractimageoperation.cpp	2011-07-20 13:46:34 +0000
+++ lib/abstractimageoperation.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -31,81 +31,82 @@
 #include "document/documentfactory.h"
 #include "document/documentjob.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-class ImageOperationCommand : public QUndoCommand {
+class ImageOperationCommand : public QUndoCommand
+{
 public:
-	ImageOperationCommand(AbstractImageOperation* op)
-	: mOp(op)
-	{}
-
-	~ImageOperationCommand() {
-		delete mOp;
-	}
-
-	virtual void undo() {
-		mOp->undo();
-	}
+    ImageOperationCommand(AbstractImageOperation* op)
+        : mOp(op)
+    {}
+
+    ~ImageOperationCommand() {
+        delete mOp;
+    }
+
+    virtual void undo()
+    {
+        mOp->undo();
+    }
 
 private:
-	AbstractImageOperation* mOp;
+    AbstractImageOperation* mOp;
 };
 
-
 struct AbstractImageOperationPrivate {
-	QString mText;
-	KUrl mUrl;
+    QString mText;
+    KUrl mUrl;
 };
 
-
 AbstractImageOperation::AbstractImageOperation()
-: d(new AbstractImageOperationPrivate) {
-}
-
-
-AbstractImageOperation::~AbstractImageOperation() {
-	delete d;
-}
-
-
-void AbstractImageOperation::applyToDocument(Document::Ptr doc) {
-	d->mUrl = doc->url();
-	redo();
-}
-
-
-Document::Ptr AbstractImageOperation::document() const {
-	Document::Ptr doc = DocumentFactory::instance()->load(d->mUrl);
-	doc->startLoadingFullImage();
-	return doc;
-}
-
-
-void AbstractImageOperation::finish(bool ok) {
-	if (ok) {
-		ImageOperationCommand* command = new ImageOperationCommand(this);
-		command->setText(d->mText);
-		document()->undoStack()->push(command);
-	} else {
-		deleteLater();
-	}
-}
-
-
-void AbstractImageOperation::finishFromKJob(KJob* job) {
-	finish(job->error() == KJob::NoError);
-}
-
-
-void AbstractImageOperation::setText(const QString& text) {
-	d->mText = text;
-}
-
-
-void AbstractImageOperation::redoAsDocumentJob(DocumentJob* job) {
-	connect(job, SIGNAL(result(KJob*)), SLOT(finishFromKJob(KJob*)));
-	document()->enqueueJob(job);
-}
-
+: d(new AbstractImageOperationPrivate)
+{
+}
+
+AbstractImageOperation::~AbstractImageOperation()
+{
+    delete d;
+}
+
+void AbstractImageOperation::applyToDocument(Document::Ptr doc)
+{
+    d->mUrl = doc->url();
+    redo();
+}
+
+Document::Ptr AbstractImageOperation::document() const
+{
+    Document::Ptr doc = DocumentFactory::instance()->load(d->mUrl);
+    doc->startLoadingFullImage();
+    return doc;
+}
+
+void AbstractImageOperation::finish(bool ok)
+{
+    if (ok) {
+        ImageOperationCommand* command = new ImageOperationCommand(this);
+        command->setText(d->mText);
+        document()->undoStack()->push(command);
+    } else {
+        deleteLater();
+    }
+}
+
+void AbstractImageOperation::finishFromKJob(KJob* job)
+{
+    finish(job->error() == KJob::NoError);
+}
+
+void AbstractImageOperation::setText(const QString& text)
+{
+    d->mText = text;
+}
+
+void AbstractImageOperation::redoAsDocumentJob(DocumentJob* job)
+{
+    connect(job, SIGNAL(result(KJob*)), SLOT(finishFromKJob(KJob*)));
+    document()->enqueueJob(job);
+}
 
 } // namespace

=== modified file 'lib/abstractimageoperation.h'
--- lib/abstractimageoperation.h	2011-07-20 13:46:34 +0000
+++ lib/abstractimageoperation.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -33,8 +33,8 @@
 
 class KJob;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct AbstractImageOperationPrivate;
 
@@ -48,41 +48,41 @@
  * - Implement undo()
  * - Define the operation/command text with setText()
  */
-class GWENVIEWLIB_EXPORT AbstractImageOperation : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT AbstractImageOperation : public QObject
+{
+    Q_OBJECT
 public:
-	AbstractImageOperation();
-	virtual ~AbstractImageOperation();
+    AbstractImageOperation();
+    virtual ~AbstractImageOperation();
 
-	void applyToDocument(Document::Ptr);
-	Document::Ptr document() const;
+    void applyToDocument(Document::Ptr);
+    Document::Ptr document() const;
 
 protected:
-	virtual void redo() = 0;
-	virtual void undo() {}
-	void setText(const QString&);
+    virtual void redo() = 0;
+    virtual void undo() {}
+    void setText(const QString&);
 
-	/**
-	 * Convenience method which can be called from redo() if the operation is
-	 * implemented as a job
-	 */
-	void redoAsDocumentJob(DocumentJob* job);
+    /**
+     * Convenience method which can be called from redo() if the operation is
+     * implemented as a job
+     */
+    void redoAsDocumentJob(DocumentJob* job);
 
 protected Q_SLOTS:
-	void finish(bool ok);
+    void finish(bool ok);
 
-	/**
-	 * Convenience slot which call finish() correctly if job succeeded
-	 */
-	void finishFromKJob(KJob* job);
+    /**
+     * Convenience slot which call finish() correctly if job succeeded
+     */
+    void finishFromKJob(KJob* job);
 
 private:
-	AbstractImageOperationPrivate* const d;
+    AbstractImageOperationPrivate* const d;
 
-	friend class ImageOperationCommand;
+    friend class ImageOperationCommand;
 };
 
-
 } // namespace
 
 #endif /* ABSTRACTIMAGEOPERATION_H */

=== removed file 'lib/abstractimageviewtool.cpp'
--- lib/abstractimageviewtool.cpp	2011-07-20 13:46:34 +0000
+++ lib/abstractimageviewtool.cpp	1970-01-01 00:00:00 +0000
@@ -1,56 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-
-*/
-// Self
-#include "abstractimageviewtool.h"
-
-// Qt
-
-// KDE
-
-// Local
-#include "imageview.h"
-
-namespace Gwenview {
-
-
-struct AbstractImageViewToolPrivate {
-	ImageView* mImageView;
-};
-
-
-AbstractImageViewTool::AbstractImageViewTool(ImageView* view)
-: QObject(view)
-, d(new AbstractImageViewToolPrivate) {
-	d->mImageView = view;
-}
-
-
-AbstractImageViewTool::~AbstractImageViewTool() {
-	delete d;
-}
-
-
-ImageView* AbstractImageViewTool::imageView() const {
-	return d->mImageView;
-}
-
-
-} // namespace

=== removed file 'lib/abstractimageviewtool.h'
--- lib/abstractimageviewtool.h	2011-07-20 13:46:34 +0000
+++ lib/abstractimageviewtool.h	1970-01-01 00:00:00 +0000
@@ -1,69 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-
-*/
-#ifndef ABSTRACTIMAGEVIEWTOOL_H
-#define ABSTRACTIMAGEVIEWTOOL_H
-
-#include <lib/gwenviewlib_export.h>
-
-// Qt
-#include <QObject>
-
-// KDE
-
-// Local
-
-class QKeyEvent;
-class QMouseEvent;
-class QWheelEvent;
-class QPainter;
-
-namespace Gwenview {
-
-class ImageView;
-
-struct AbstractImageViewToolPrivate;
-class GWENVIEWLIB_EXPORT AbstractImageViewTool : public QObject {
-public:
-	AbstractImageViewTool(ImageView* view);
-	virtual ~AbstractImageViewTool();
-
-	ImageView* imageView() const;
-
-	virtual void paint(QPainter*) {}
-
-	virtual void mousePressEvent(QMouseEvent*) {}
-	virtual void mouseMoveEvent(QMouseEvent*) {}
-	virtual void mouseReleaseEvent(QMouseEvent*) {}
-	virtual void wheelEvent(QWheelEvent*) {}
-	virtual void keyPressEvent(QKeyEvent*) {}
-	virtual void keyReleaseEvent(QKeyEvent*) {}
-
-	virtual void toolActivated() {}
-	virtual void toolDeactivated() {}
-
-private:
-	AbstractImageViewToolPrivate * const d;
-};
-
-
-} // namespace
-
-#endif /* ABSTRACTIMAGEVIEWTOOL_H */

=== modified file 'lib/archiveutils.cpp'
--- lib/archiveutils.cpp	2011-07-20 13:46:34 +0000
+++ lib/archiveutils.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab
+// vim: set tabstop=4 shiftwidth=4 expandtab
 /*
 Gwenview - A simple image viewer for KDE
 Copyright 2000-2007 Aurélien Gâteau <agateau@kde.org>
@@ -27,44 +27,48 @@
 #include <kmimetype.h>
 #include <kprotocolmanager.h>
 
-namespace Gwenview {
-
-
-namespace ArchiveUtils {
-
-bool fileItemIsArchive(const KFileItem& item) {
-	KMimeType::Ptr mimeType = item.determineMimeType();
-	return !ArchiveUtils::protocolForMimeType(mimeType->name()).isEmpty();
-}
-
-bool fileItemIsDirOrArchive(const KFileItem& item) {
-	return item.isDir() || fileItemIsArchive(item);
-}
-
-QString protocolForMimeType(const QString& mimeType) {
-	static QHash<QString, QString> cache;
-	QHash<QString, QString>::ConstIterator it = cache.constFind(mimeType);
-	if (it != cache.constEnd()) {
-		return it.value();
-	}
-
-	QString protocol = KProtocolManager::protocolForArchiveMimetype(mimeType);
-	if (protocol.isEmpty()) {
-		// No protocol, try with mimeType parents. This is useful for .cbz for
-		// example
-		KMimeType::Ptr ptr = KMimeType::mimeType(mimeType);
-		if (ptr) {
-			Q_FOREACH(const QString& parentMimeType, ptr->allParentMimeTypes()) {
-				protocol = KProtocolManager::protocolForArchiveMimetype(parentMimeType);
-				if (!protocol.isEmpty()) {
-					break;
-				}
-			}
-		}
-	}
-
-	cache.insert(mimeType, protocol);
-	return protocol;
+namespace Gwenview
+{
+
+namespace ArchiveUtils
+{
+
+bool fileItemIsArchive(const KFileItem& item)
+{
+    KMimeType::Ptr mimeType = item.determineMimeType();
+    return !ArchiveUtils::protocolForMimeType(mimeType->name()).isEmpty();
+}
+
+bool fileItemIsDirOrArchive(const KFileItem& item)
+{
+    return item.isDir() || fileItemIsArchive(item);
+}
+
+QString protocolForMimeType(const QString& mimeType)
+{
+    static QHash<QString, QString> cache;
+    QHash<QString, QString>::ConstIterator it = cache.constFind(mimeType);
+    if (it != cache.constEnd()) {
+        return it.value();
+    }
+
+    QString protocol = KProtocolManager::protocolForArchiveMimetype(mimeType);
+    if (protocol.isEmpty()) {
+        // No protocol, try with mimeType parents. This is useful for .cbz for
+        // example
+        KMimeType::Ptr ptr = KMimeType::mimeType(mimeType);
+        if (ptr) {
+            Q_FOREACH(const QString & parentMimeType, ptr->allParentMimeTypes()) {
+                protocol = KProtocolManager::protocolForArchiveMimetype(parentMimeType);
+                if (!protocol.isEmpty()) {
+                    break;
+                }
+            }
+        }
+    }
+
+    cache.insert(mimeType, protocol);
+    return protocol;
 }
 
 } // namespace ArchiveUtils

=== modified file 'lib/archiveutils.h'
--- lib/archiveutils.h	2011-07-20 13:46:34 +0000
+++ lib/archiveutils.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab
+// vim: set tabstop=4 shiftwidth=4 expandtab
 /*
 Gwenview - A simple image viewer for KDE
 Copyright 2000-2004 Aurélien Gâteau <agateau@kde.org>
@@ -28,12 +28,14 @@
 
 class KFileItem;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * Helper functions to deal with archives
  */
-namespace ArchiveUtils {
+namespace ArchiveUtils
+{
 
 /**
  * Returns true if @p item is an archive

=== modified file 'lib/binder.cpp'
--- lib/binder.cpp	2011-07-20 13:46:34 +0000
+++ lib/binder.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -21,14 +21,16 @@
 // Self
 #include <binder.moc>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 BinderInternal::BinderInternal(QObject* parent)
 : QObject(parent)
 {
 }
 
-BinderInternal::~BinderInternal() {
+BinderInternal::~BinderInternal()
+{
 }
 
 } // namespace

=== modified file 'lib/binder.h'
--- lib/binder.h	2011-09-08 12:26:41 +0000
+++ lib/binder.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -26,21 +26,23 @@
 // Qt
 #include <QObject>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * @internal
  *
  * Necessary helper class because a QObject class cannot be a template
  */
-class GWENVIEWLIB_EXPORT BinderInternal : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT BinderInternal : public QObject
+{
+    Q_OBJECT
 public:
-	explicit BinderInternal(QObject* parent);
-	~BinderInternal();
+    explicit BinderInternal(QObject* parent);
+    ~BinderInternal();
 
 protected Q_SLOTS:
-	virtual void callMethod() {}
+    virtual void callMethod() {}
 };
 
 /**
@@ -79,29 +81,29 @@
 class BaseBinder : public BinderInternal
 {
 public:
-	typedef void (Receiver::*Method)(MethodArg);
-	static void bind(QObject* emitter, const char* signal, Receiver* receiver, Method method, MethodArg arg) {
-		BaseBinder<Receiver, Arg, MethodArg>* binder = new BaseBinder<Receiver, Arg, MethodArg>(emitter);
-		binder->mReceiver = receiver;
-		binder->mMethod = method;
-		binder->mArg = arg;
-		QObject::connect(emitter, signal, binder, SLOT(callMethod()));
-		QObject::connect(receiver, SIGNAL(destroyed(QObject*)), binder, SLOT(deleteLater()));
-	}
+    typedef void (Receiver::*Method)(MethodArg);
+    static void bind(QObject* emitter, const char* signal, Receiver* receiver, Method method, MethodArg arg) {
+        BaseBinder<Receiver, Arg, MethodArg>* binder = new BaseBinder<Receiver, Arg, MethodArg>(emitter);
+        binder->mReceiver = receiver;
+        binder->mMethod = method;
+        binder->mArg = arg;
+        QObject::connect(emitter, signal, binder, SLOT(callMethod()));
+        QObject::connect(receiver, SIGNAL(destroyed(QObject*)), binder, SLOT(deleteLater()));
+    }
 
 protected:
-	void callMethod() {
-		(mReceiver->*mMethod)(mArg);
-	}
+    void callMethod() {
+        (mReceiver->*mMethod)(mArg);
+    }
 
 private:
-	BaseBinder(QObject* emitter)
-	: BinderInternal(emitter)
-	{}
+    BaseBinder(QObject* emitter)
+        : BinderInternal(emitter)
+    {}
 
-	Receiver* mReceiver;
-	Method mMethod;
-	Arg mArg;
+    Receiver* mReceiver;
+    Method mMethod;
+    Arg mArg;
 };
 
 template <class Receiver, class Arg>

=== modified file 'lib/crop/cropimageoperation.cpp'
--- lib/crop/cropimageoperation.cpp	2011-07-20 13:46:34 +0000
+++ lib/crop/cropimageoperation.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -33,60 +33,61 @@
 #include "document/documentjob.h"
 #include "document/abstractdocumenteditor.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-class CropJob : public ThreadedDocumentJob {
+class CropJob : public ThreadedDocumentJob
+{
 public:
-	CropJob(const QRect& rect)
-	: mRect(rect)
-	{}
+    CropJob(const QRect& rect)
+        : mRect(rect)
+    {}
 
-	virtual void threadedStart() {
-		if (!checkDocumentEditor()) {
-			return;
-		}
-		const QImage src = document()->image();
-		const QImage dst = src.copy(mRect);
-		document()->editor()->setImage(dst);
-		setError(NoError);
-	}
+    virtual void threadedStart()
+    {
+        if (!checkDocumentEditor()) {
+            return;
+        }
+        const QImage src = document()->image();
+        const QImage dst = src.copy(mRect);
+        document()->editor()->setImage(dst);
+        setError(NoError);
+    }
 
 private:
-	QRect mRect;
+    QRect mRect;
 };
 
-
 struct CropImageOperationPrivate {
-	QRect mRect;
-	QImage mOriginalImage;
+    QRect mRect;
+    QImage mOriginalImage;
 };
 
-
 CropImageOperation::CropImageOperation(const QRect& rect)
-: d(new CropImageOperationPrivate) {
-	d->mRect = rect;
-	setText(i18n("Crop"));
-}
-
-
-CropImageOperation::~CropImageOperation() {
-	delete d;
-}
-
-
-void CropImageOperation::redo() {
-	d->mOriginalImage = document()->image();
-	redoAsDocumentJob(new CropJob(d->mRect));
-}
-
-
-void CropImageOperation::undo() {
-	if (!document()->editor()) {
-		kWarning() << "!document->editor()";
-		return;
-	}
-	document()->editor()->setImage(d->mOriginalImage);
-}
-
+: d(new CropImageOperationPrivate)
+{
+    d->mRect = rect;
+    setText(i18n("Crop"));
+}
+
+CropImageOperation::~CropImageOperation()
+{
+    delete d;
+}
+
+void CropImageOperation::redo()
+{
+    d->mOriginalImage = document()->image();
+    redoAsDocumentJob(new CropJob(d->mRect));
+}
+
+void CropImageOperation::undo()
+{
+    if (!document()->editor()) {
+        kWarning() << "!document->editor()";
+        return;
+    }
+    document()->editor()->setImage(d->mOriginalImage);
+}
 
 } // namespace

=== modified file 'lib/crop/cropimageoperation.h'
--- lib/crop/cropimageoperation.h	2011-07-20 13:46:34 +0000
+++ lib/crop/cropimageoperation.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -32,23 +32,23 @@
 
 class QRect;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct CropImageOperationPrivate;
-class GWENVIEWLIB_EXPORT CropImageOperation : public AbstractImageOperation {
+class GWENVIEWLIB_EXPORT CropImageOperation : public AbstractImageOperation
+{
 public:
-	CropImageOperation(const QRect&);
-	~CropImageOperation();
+    CropImageOperation(const QRect&);
+    ~CropImageOperation();
 
-	virtual void redo();
-	virtual void undo();
+    virtual void redo();
+    virtual void undo();
 
 private:
-	CropImageOperationPrivate* const d;
+    CropImageOperationPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* CROPIMAGEOPERATION_H */

=== modified file 'lib/crop/croptool.cpp'
--- lib/crop/croptool.cpp	2011-07-20 13:46:34 +0000
+++ lib/crop/croptool.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -21,11 +21,11 @@
 // Self
 #include "croptool.moc"
 
-#include <math.h>
-
 // Qt
+#include <qmath.h>
 #include <QApplication>
 #include <QFlags>
+#include <QGraphicsSceneMouseEvent>
 #include <QMouseEvent>
 #include <QPainter>
 #include <QRect>
@@ -38,507 +38,375 @@
 #include <kdialog.h>
 
 // Local
+#include <lib/documentview/rasterimageview.h>
 #include "cropimageoperation.h"
 #include "cropwidget.h"
-#include "imageview.h"
-#include "hudwidget.h"
 
 static const int HANDLE_SIZE = 15;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 enum CropHandleFlag {
-	CH_None,
-	CH_Top = 1,
-	CH_Left = 2,
-	CH_Right = 4,
-	CH_Bottom = 8,
-	CH_TopLeft = CH_Top | CH_Left,
-	CH_BottomLeft = CH_Bottom | CH_Left,
-	CH_TopRight = CH_Top | CH_Right,
-	CH_BottomRight = CH_Bottom | CH_Right,
-	CH_Content = 16
-};
-
-enum HudSide {
-	HS_None = 0, // Special value used to avoid initial animation
-	HS_Top = 1,
-	HS_Bottom = 2,
-	HS_Inside = 4,
-	HS_TopInside = HS_Top | HS_Inside,
-	HS_BottomInside = HS_Bottom | HS_Inside
-};
-
-typedef QPair<QPoint, HudSide> OptimalPosition;
-
-static const int HUD_TIMER_MAX_PIXELS_PER_UPDATE = 20;
-static const int HUD_TIMER_ANIMATION_INTERVAL = 20;
+    CH_None,
+    CH_Top = 1,
+    CH_Left = 2,
+    CH_Right = 4,
+    CH_Bottom = 8,
+    CH_TopLeft = CH_Top | CH_Left,
+    CH_BottomLeft = CH_Bottom | CH_Left,
+    CH_TopRight = CH_Top | CH_Right,
+    CH_BottomRight = CH_Bottom | CH_Right,
+    CH_Content = 16
+};
 
 Q_DECLARE_FLAGS(CropHandle, CropHandleFlag)
 
 } // namespace
 
-inline QPoint boundPointX(const QPoint& point, const QRect& rect) {
-	return QPoint(
-		qBound(rect.left(), point.x(), rect.right()),
-		point.y()
-		);
+inline QPoint boundPointX(const QPoint& point, const QRect& rect)
+{
+    return QPoint(
+               qBound(rect.left(), point.x(), rect.right()),
+               point.y()
+           );
 }
 
-inline QPoint boundPointXY(const QPoint& point, const QRect& rect) {
-	return QPoint(
-		qBound(rect.left(), point.x(), rect.right()),
-		qBound(rect.top(),  point.y(), rect.bottom())
-		);
+inline QPoint boundPointXY(const QPoint& point, const QRect& rect)
+{
+    return QPoint(
+               qBound(rect.left(), point.x(), rect.right()),
+               qBound(rect.top(),  point.y(), rect.bottom())
+           );
 }
 
 Q_DECLARE_OPERATORS_FOR_FLAGS(Gwenview::CropHandle)
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct CropToolPrivate {
-	CropTool* mCropTool;
-	HudSide mHudSide;
-	QRect mRect;
-	QList<CropHandle> mCropHandleList;
-	CropHandle mMovingHandle;
-	QPoint mLastMouseMovePos;
-	double mCropRatio;
-	HudWidget* mHudWidget;
-	CropWidget* mCropWidget;
-
-	QTimer* mHudTimer;
-	QPoint mHudEndPos;
-
-
-	QRect viewportCropRect() const {
-		return mCropTool->imageView()->mapToViewport(mRect.adjusted(0, 0, 1, 1));
-	}
-
-
-	QRect handleViewportRect(CropHandle handle) {
-		QSize viewportSize = mCropTool->imageView()->viewport()->size();
-		QRect rect = viewportCropRect();
-		int left, top;
-		if (handle & CH_Top) {
-			top = rect.top();
-		} else if (handle & CH_Bottom) {
-			top = rect.bottom() - HANDLE_SIZE;
-		} else {
-			top = rect.top() + (rect.height() - HANDLE_SIZE) / 2;
-			top = qBound(0, top, viewportSize.height() - HANDLE_SIZE);
-		}
-
-		if (handle & CH_Left) {
-			left = rect.left();
-		} else if (handle & CH_Right) {
-			left = rect.right() - HANDLE_SIZE;
-		} else {
-			left = rect.left() + (rect.width() - HANDLE_SIZE) / 2;
-			left = qBound(0, left, viewportSize.width() - HANDLE_SIZE);
-		}
-
-		return QRect(left, top, HANDLE_SIZE, HANDLE_SIZE);
-	}
-
-
-	CropHandle handleAt(const QPoint& pos) {
-		Q_FOREACH(const CropHandle& handle, mCropHandleList) {
-			QRect rect = handleViewportRect(handle);
-			if (rect.contains(pos)) {
-				return handle;
-			}
-		}
-		QRect rect = viewportCropRect();
-		if (rect.contains(pos)) {
-			return CH_Content;
-		}
-		return CH_None;
-	}
-
-	void updateCursor(CropHandle handle, bool buttonDown) {
-		Qt::CursorShape shape;
-		switch (handle) {
-		case CH_TopLeft:
-		case CH_BottomRight:
-			shape = Qt::SizeFDiagCursor;
-			break;
-		
-		case CH_TopRight:
-		case CH_BottomLeft:
-			shape = Qt::SizeBDiagCursor;
-			break;
-
-		case CH_Left:
-		case CH_Right:
-			shape = Qt::SizeHorCursor;
-			break;
-
-		case CH_Top:
-		case CH_Bottom:
-			shape = Qt::SizeVerCursor;
-			break;
-
-		case CH_Content:
-			shape = buttonDown ? Qt::ClosedHandCursor : Qt::OpenHandCursor;
-			break;
-
-		default:
-			shape = Qt::ArrowCursor;
-			break;
-		}
-		mCropTool->imageView()->viewport()->setCursor(shape);
-	}
-
-	void keepRectInsideImage() {
-		const QSize imageSize = mCropTool->imageView()->document()->size();
-		if (mRect.width() > imageSize.width() || mRect.height() > imageSize.height()) {
-			// This can happen when the crop ratio changes
-			QSize rectSize = mRect.size();
-			rectSize.scale(imageSize, Qt::KeepAspectRatio);
-			mRect.setSize(rectSize);
-		}
-
-		if (mRect.right() >= imageSize.width()) {
-			mRect.moveRight(imageSize.width() - 1);
-		} else if (mRect.left() < 0) {
-			mRect.moveLeft(0);
-		}
-		if (mRect.bottom() >= imageSize.height()) {
-			mRect.moveBottom(imageSize.height() - 1);
-		} else if (mRect.top() < 0) {
-			mRect.moveTop(0);
-		}
-	}
-
-
-	void setupHudWidget() {
-		mHudSide = HS_None;
-
-		ImageView* view = mCropTool->imageView();
-		mHudWidget = new HudWidget(view->viewport());
-		QObject::connect(mHudWidget, SIGNAL(closed()),
-			mCropTool, SIGNAL(done()));
-
-		mCropWidget = new CropWidget(0, view, mCropTool);
-		QObject::connect(mCropWidget, SIGNAL(cropRequested()),
-			mCropTool, SLOT(slotCropRequested()));
-
-		mHudWidget->init(mCropWidget, HudWidget::OptionCloseButton);
-		mHudWidget->setCursor(Qt::ArrowCursor);
-		mHudWidget->show();
-
-		mHudWidget->installEventFilter(mCropTool);
-
-		mHudTimer = new QTimer(mCropTool);
-		mHudTimer->setInterval(HUD_TIMER_ANIMATION_INTERVAL);
-		QObject::connect(mHudTimer, SIGNAL(timeout()),
-			mCropTool, SLOT(moveHudWidget()));
-	}
-
-	void connectToView() {
-		ImageView* view = mCropTool->imageView();
-		QObject::connect(view, SIGNAL(zoomChanged(qreal)),
-			mCropTool, SLOT(updateHudWidgetPosition()));
-		QObject::connect(view->horizontalScrollBar(), SIGNAL(valueChanged(int)),
-			mCropTool, SLOT(updateHudWidgetPosition()));
-		QObject::connect(view->verticalScrollBar(), SIGNAL(valueChanged(int)),
-			mCropTool, SLOT(updateHudWidgetPosition()));
-		// rangeChanged() is emitted when the view is resized
-		QObject::connect(view->horizontalScrollBar(), SIGNAL(rangeChanged(int, int)),
-			mCropTool, SLOT(updateHudWidgetPosition()));
-		QObject::connect(view->verticalScrollBar(), SIGNAL(rangeChanged(int, int)),
-			mCropTool, SLOT(updateHudWidgetPosition()));
-	}
-
-	OptimalPosition computeOptimalHudWidgetPosition() {
-		const ImageView* view = mCropTool->imageView();
-		const QRect viewportRect = view->viewport()->rect();
-		const QRect rect = view->mapToViewport(mRect).intersected(viewportRect);
-		const int margin = HANDLE_SIZE;
-		const int hudHeight = mHudWidget->height();
-		const QRect hudMaxRect = viewportRect.adjusted(0, 0, -mHudWidget->width(), -hudHeight);
-
-		OptimalPosition ret;
-
-		// Compute preferred and fallback positions. 'preferred' is outside the
-		// crop rect, on the current side. 'fallback' is outside on the other
-		// side.
-		OptimalPosition preferred = OptimalPosition(
-			QPoint(rect.left(), rect.bottom() + margin),
-			HS_Bottom);
-		OptimalPosition fallback = OptimalPosition(
-			QPoint(rect.left(), rect.top() - margin - hudHeight),
-			HS_Top);
-
-		if (mHudSide & HS_Top) {
-			qSwap(preferred, fallback);
-		}
-
-		// If possible, 'preferred' and 'fallback' are aligned on the left edge
-		// by default, but if they don't fit the viewport horizontally, adjust
-		// their X coordinate so that the hud remain visible
-		preferred.first = boundPointX(preferred.first, hudMaxRect);
-		fallback.first = boundPointX(fallback.first, hudMaxRect);
-
-		// Check if either 'preferred' or 'fallback' fits
-		if (hudMaxRect.contains(preferred.first)) {
-			ret = preferred;
-		} else if (hudMaxRect.contains(fallback.first)) {
-			ret = fallback;
-		} else {
-			// Does not fit outside, use a position inside rect
-			QPoint pos;
-			if (mHudSide & HS_Top) {
-				pos = QPoint(rect.left() + margin, rect.top() + margin);
-			} else {
-				pos = QPoint(rect.left() + margin, rect.bottom() - margin - hudHeight);
-			}
-			ret = OptimalPosition(pos, HudSide(mHudSide | HS_Inside));
-		}
-
-		// Ensure it's always fully visible
-		ret.first = boundPointXY(ret.first, hudMaxRect);
-		return ret;
-	}
+    CropTool* q;
+    QRect mRect;
+    QList<CropHandle> mCropHandleList;
+    CropHandle mMovingHandle;
+    QPoint mLastMouseMovePos;
+    double mCropRatio;
+    CropWidget* mCropWidget;
+
+    QRect viewportCropRect() const {
+        return q->imageView()->mapToView(mRect.adjusted(0, 0, 1, 1));
+    }
+
+    QRect handleViewportRect(CropHandle handle)
+    {
+        QSize viewportSize = q->imageView()->size().toSize();
+        QRect rect = viewportCropRect();
+        int left, top;
+        if (handle & CH_Top) {
+            top = rect.top();
+        } else if (handle & CH_Bottom) {
+            top = rect.bottom() - HANDLE_SIZE;
+        } else {
+            top = rect.top() + (rect.height() - HANDLE_SIZE) / 2;
+            top = qBound(0, top, viewportSize.height() - HANDLE_SIZE);
+        }
+
+        if (handle & CH_Left) {
+            left = rect.left();
+        } else if (handle & CH_Right) {
+            left = rect.right() - HANDLE_SIZE;
+        } else {
+            left = rect.left() + (rect.width() - HANDLE_SIZE) / 2;
+            left = qBound(0, left, viewportSize.width() - HANDLE_SIZE);
+        }
+
+        return QRect(left, top, HANDLE_SIZE, HANDLE_SIZE);
+    }
+
+    CropHandle handleAt(const QPointF& pos)
+    {
+        Q_FOREACH(const CropHandle & handle, mCropHandleList) {
+            QRectF rect = handleViewportRect(handle);
+            if (rect.contains(pos)) {
+                return handle;
+            }
+        }
+        QRectF rect = viewportCropRect();
+        if (rect.contains(pos)) {
+            return CH_Content;
+        }
+        return CH_None;
+    }
+
+    void updateCursor(CropHandle handle, bool buttonDown)
+    {
+        Qt::CursorShape shape;
+        switch (handle) {
+        case CH_TopLeft:
+        case CH_BottomRight:
+            shape = Qt::SizeFDiagCursor;
+            break;
+
+        case CH_TopRight:
+        case CH_BottomLeft:
+            shape = Qt::SizeBDiagCursor;
+            break;
+
+        case CH_Left:
+        case CH_Right:
+            shape = Qt::SizeHorCursor;
+            break;
+
+        case CH_Top:
+        case CH_Bottom:
+            shape = Qt::SizeVerCursor;
+            break;
+
+        case CH_Content:
+            shape = buttonDown ? Qt::ClosedHandCursor : Qt::OpenHandCursor;
+            break;
+
+        default:
+            shape = Qt::ArrowCursor;
+            break;
+        }
+        q->imageView()->setCursor(shape);
+    }
+
+    void keepRectInsideImage()
+    {
+        const QSize imageSize = q->imageView()->documentSize().toSize();
+        if (mRect.width() > imageSize.width() || mRect.height() > imageSize.height()) {
+            // This can happen when the crop ratio changes
+            QSize rectSize = mRect.size();
+            rectSize.scale(imageSize, Qt::KeepAspectRatio);
+            mRect.setSize(rectSize);
+        }
+
+        if (mRect.right() >= imageSize.width()) {
+            mRect.moveRight(imageSize.width() - 1);
+        } else if (mRect.left() < 0) {
+            mRect.moveLeft(0);
+        }
+        if (mRect.bottom() >= imageSize.height()) {
+            mRect.moveBottom(imageSize.height() - 1);
+        } else if (mRect.top() < 0) {
+            mRect.moveTop(0);
+        }
+    }
+
+    void setupWidget()
+    {
+        RasterImageView* view = q->imageView();
+        mCropWidget = new CropWidget(0, view, q);
+        QObject::connect(mCropWidget, SIGNAL(cropRequested()),
+                         q, SLOT(slotCropRequested()));
+        QObject::connect(mCropWidget, SIGNAL(done()),
+                         q, SIGNAL(done()));
+    }
 };
 
-
-CropTool::CropTool(ImageView* view)
-: AbstractImageViewTool(view)
-, d(new CropToolPrivate) {
-	d->mCropTool = this;
-	d->mCropHandleList << CH_Left << CH_Right << CH_Top << CH_Bottom << CH_TopLeft << CH_TopRight << CH_BottomLeft << CH_BottomRight;
-	d->mHudSide = HS_Bottom;
-	d->mMovingHandle = CH_None;
-	const QRect imageRect = QRect(QPoint(0, 0), view->document()->size());
-	const QRect viewportRect = view->mapToImage(view->viewport()->rect());
-	d->mRect = imageRect & viewportRect;
-	d->mCropRatio = 0.;
-
-	d->setupHudWidget();
-	d->connectToView();
-	updateHudWidgetPosition();
-}
-
-
-CropTool::~CropTool() {
-	delete d;
-}
-
-
-void CropTool::setCropRatio(double ratio) {
-	d->mCropRatio = ratio;
-}
-
-
-void CropTool::setRect(const QRect& rect) {
-	d->mRect = rect;
-	d->keepRectInsideImage();
-	if (d->mRect != rect) {
-		rectUpdated(d->mRect);
-	}
-	imageView()->viewport()->update();
-}
-
-
-QRect CropTool::rect() const {
-	return d->mRect;
-}
-
-
-void CropTool::paint(QPainter* painter) {
-	QRect rect = d->viewportCropRect();
-
-	QRect imageRect = imageView()->rect();
-
-	static const QColor outerColor  = QColor::fromHsvF(0, 0, 0, 0.5);
-	// For some reason nothing gets drawn if borderColor is not fully opaque!
-	//static const QColor borderColor = QColor::fromHsvF(0, 0, 1.0, 0.66);
-	static const QColor borderColor = QColor::fromHsvF(0, 0, 1.0);
-	static const QColor fillColor   = QColor::fromHsvF(0, 0, 0.75, 0.66);
-
-	QRegion outerRegion = QRegion(imageRect) - QRegion(rect);
-	Q_FOREACH(const QRect& outerRect, outerRegion.rects()) {
-		painter->fillRect(outerRect, outerColor);
-	}
-
-	painter->setPen(borderColor);
-
-	rect.adjust(0, 0, -1, -1);
-	painter->drawRect(rect);
-
-	if (d->mMovingHandle == CH_None) {
-		// Only draw handles when user is not resizing
-		painter->setBrush(fillColor);
-		Q_FOREACH(const CropHandle& handle, d->mCropHandleList) {
-			rect = d->handleViewportRect(handle);
-			painter->drawRect(rect);
-		}
-	}
-}
-
-
-void CropTool::mousePressEvent(QMouseEvent* event) {
-	// FIXME: Fade out?
-	//d->mHudWidget->hide();
-	d->mMovingHandle = d->handleAt(event->pos());
-	d->updateCursor(d->mMovingHandle, event->buttons() != Qt::NoButton);
-
-	if (d->mMovingHandle == CH_Content) {
-		d->mLastMouseMovePos = imageView()->mapToImage(event->pos());
-	}
-
-	// Update to hide handles
-	imageView()->viewport()->update();
-}
-
-
-void CropTool::mouseMoveEvent(QMouseEvent* event) {
-	if (event->buttons() == Qt::NoButton) {
-		// Make sure cursor is updated when moving over handles
-		CropHandle handle = d->handleAt(event->pos());
-		d->updateCursor(handle, false/* buttonDown*/);
-		return;
-	}
-
-	const QSize imageSize = imageView()->document()->size();
-
-	QPoint point = imageView()->mapToImage(event->pos());
-	int posX = qBound(0, point.x(), imageSize.width() - 1);
-	int posY = qBound(0, point.y(), imageSize.height() - 1);
-
-	if (d->mMovingHandle == CH_None) {
-		return;
-	}
-
-	// Adjust edge
-	if (d->mMovingHandle & CH_Top) {
-		d->mRect.setTop(posY);
-	} else if (d->mMovingHandle & CH_Bottom) {
-		d->mRect.setBottom(posY);
-	}
-	if (d->mMovingHandle & CH_Left) {
-		d->mRect.setLeft(posX);
-	} else if (d->mMovingHandle & CH_Right) {
-		d->mRect.setRight(posX);
-	}
-
-	// Normalize rect and handles (this is useful when user drag the right side
-	// of the crop rect to the left of the left side)
-	if (d->mRect.height() < 0) {
-		d->mMovingHandle = d->mMovingHandle ^ (CH_Top | CH_Bottom);
-	}
-	if (d->mRect.width() < 0) {
-		d->mMovingHandle = d->mMovingHandle ^ (CH_Left | CH_Right);
-	}
-	d->mRect = d->mRect.normalized();
-
-	// Enforce ratio
-	if (d->mCropRatio > 0.) {
-		if (d->mMovingHandle == CH_Top || d->mMovingHandle == CH_Bottom) {
-			// Top or bottom
-			int width = int(d->mRect.height() / d->mCropRatio);
-			d->mRect.setWidth(width);
-		} else if (d->mMovingHandle == CH_Left || d->mMovingHandle == CH_Right) {
-			// Left or right
-			int height = int(d->mRect.width() * d->mCropRatio);
-			d->mRect.setHeight(height);
-		} else if (d->mMovingHandle & CH_Top) {
-			// Top left or top right
-			int height = int(d->mRect.width() * d->mCropRatio);
-			d->mRect.setTop(d->mRect.bottom() - height);
-		} else if (d->mMovingHandle & CH_Bottom) {
-			// Bottom left or bottom right
-			int height = int(d->mRect.width() * d->mCropRatio);
-			d->mRect.setHeight(height);
-		}
-	}
-
-	if (d->mMovingHandle == CH_Content) {
-		QPoint delta = point - d->mLastMouseMovePos;
-		d->mRect.adjust(delta.x(), delta.y(), delta.x(), delta.y());
-		d->mLastMouseMovePos = imageView()->mapToImage(event->pos());
-	}
-
-	d->keepRectInsideImage();
-
-	imageView()->viewport()->update();
-	rectUpdated(d->mRect);
-	updateHudWidgetPosition();
-}
-
-
-void CropTool::mouseReleaseEvent(QMouseEvent* event) {
-	// FIXME: Fade in?
-	//d->mHudWidget->show();
-	d->mMovingHandle = CH_None;
-	d->updateCursor(d->handleAt(event->pos()), false);
-
-	// Update to show handles
-	imageView()->viewport()->update();
-}
-
-
-void CropTool::toolActivated() {
-	imageView()->viewport()->setCursor(Qt::CrossCursor);
-}
-
-
-void CropTool::toolDeactivated() {
-	delete d->mHudWidget;
-}
-
-
-void CropTool::slotCropRequested() {
-	CropImageOperation* op = new CropImageOperation(d->mRect);
-	emit imageOperationRequested(op);
-	emit done();
-}
-
-
-bool CropTool::eventFilter(QObject*, QEvent* event) {
-	if (event->type() == QEvent::Resize) {
-		updateHudWidgetPosition();
-	}
-	return false;
-}
-
-
-void CropTool::moveHudWidget() {
-	const QPoint delta = d->mHudEndPos - d->mHudWidget->pos();
-
-	const double distance = sqrt(pow(double(delta.x()), 2) + pow(double(delta.y()), 2));
-	QPoint pos;
-	if (distance > double(HUD_TIMER_MAX_PIXELS_PER_UPDATE)) {
-		pos = d->mHudWidget->pos() + delta * double(HUD_TIMER_MAX_PIXELS_PER_UPDATE) / distance;
-	} else {
-		pos = d->mHudEndPos;
-		d->mHudTimer->stop();
-	}
-
-	d->mHudWidget->move(pos);
-}
-
-
-void CropTool::updateHudWidgetPosition() {
-	OptimalPosition result = d->computeOptimalHudWidgetPosition();
-	if (d->mHudSide == HS_None) {
-		d->mHudSide = result.second;
-	}
-	if (d->mHudSide == result.second && !d->mHudTimer->isActive()) {
-		// Not changing side and not in an animation, move directly the hud
-		// to the final position to avoid lagging effect
-		d->mHudWidget->move(result.first);
-	} else {
-		d->mHudEndPos = result.first;
-		d->mHudSide = result.second;
-		if (!d->mHudTimer->isActive()) {
-			d->mHudTimer->start();
-		}
-	}
-}
-
+CropTool::CropTool(RasterImageView* view)
+: AbstractRasterImageViewTool(view)
+, d(new CropToolPrivate)
+{
+    d->q = this;
+    d->mCropHandleList << CH_Left << CH_Right << CH_Top << CH_Bottom << CH_TopLeft << CH_TopRight << CH_BottomLeft << CH_BottomRight;
+    d->mMovingHandle = CH_None;
+    const QRect imageRect = QRect(QPoint(0, 0), view->documentSize().toSize());
+    const QRect viewportRect = view->mapToImage(view->rect().toRect());
+    d->mRect = imageRect & viewportRect;
+    d->mCropRatio = 0.;
+
+    d->setupWidget();
+}
+
+CropTool::~CropTool()
+{
+    // mCropWidget is a child of its container not of us, so it is not deleted automatically
+    delete d->mCropWidget;
+    delete d;
+}
+
+void CropTool::setCropRatio(double ratio)
+{
+    d->mCropRatio = ratio;
+}
+
+void CropTool::setRect(const QRect& rect)
+{
+    d->mRect = rect;
+    d->keepRectInsideImage();
+    if (d->mRect != rect) {
+        rectUpdated(d->mRect);
+    }
+    imageView()->update();
+}
+
+QRect CropTool::rect() const
+{
+    return d->mRect;
+}
+
+void CropTool::paint(QPainter* painter)
+{
+    QRect rect = d->viewportCropRect();
+
+    QRect imageRect = imageView()->rect().toRect();
+
+    static const QColor outerColor  = QColor::fromHsvF(0, 0, 0, 0.5);
+    // For some reason nothing gets drawn if borderColor is not fully opaque!
+    //static const QColor borderColor = QColor::fromHsvF(0, 0, 1.0, 0.66);
+    static const QColor borderColor = QColor::fromHsvF(0, 0, 1.0);
+    static const QColor fillColor   = QColor::fromHsvF(0, 0, 0.75, 0.66);
+
+    QRegion outerRegion = QRegion(imageRect) - QRegion(rect);
+    Q_FOREACH(const QRect & outerRect, outerRegion.rects()) {
+        painter->fillRect(outerRect, outerColor);
+    }
+
+    painter->setPen(borderColor);
+
+    rect.adjust(0, 0, -1, -1);
+    painter->drawRect(rect);
+
+    if (d->mMovingHandle == CH_None) {
+        // Only draw handles when user is not resizing
+        painter->setBrush(fillColor);
+        Q_FOREACH(const CropHandle & handle, d->mCropHandleList) {
+            rect = d->handleViewportRect(handle);
+            painter->drawRect(rect);
+        }
+    }
+}
+
+void CropTool::mousePressEvent(QGraphicsSceneMouseEvent* event)
+{
+    event->accept();
+    if (event->buttons() != Qt::LeftButton) {
+        return;
+    }
+    d->mMovingHandle = d->handleAt(event->pos());
+    d->updateCursor(d->mMovingHandle, true /* down */);
+
+    if (d->mMovingHandle == CH_Content) {
+        d->mLastMouseMovePos = imageView()->mapToImage(event->pos().toPoint());
+    }
+
+    // Update to hide handles
+    imageView()->update();
+}
+
+void CropTool::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
+{
+    event->accept();
+    if (event->buttons() != Qt::LeftButton) {
+        return;
+    }
+
+    const QSize imageSize = imageView()->document()->size();
+
+    QPoint point = imageView()->mapToImage(event->pos().toPoint());
+    int posX = qBound(0, point.x(), imageSize.width() - 1);
+    int posY = qBound(0, point.y(), imageSize.height() - 1);
+
+    if (d->mMovingHandle == CH_None) {
+        return;
+    }
+
+    // Adjust edge
+    if (d->mMovingHandle & CH_Top) {
+        d->mRect.setTop(posY);
+    } else if (d->mMovingHandle & CH_Bottom) {
+        d->mRect.setBottom(posY);
+    }
+    if (d->mMovingHandle & CH_Left) {
+        d->mRect.setLeft(posX);
+    } else if (d->mMovingHandle & CH_Right) {
+        d->mRect.setRight(posX);
+    }
+
+    // Normalize rect and handles (this is useful when user drag the right side
+    // of the crop rect to the left of the left side)
+    if (d->mRect.height() < 0) {
+        d->mMovingHandle = d->mMovingHandle ^(CH_Top | CH_Bottom);
+    }
+    if (d->mRect.width() < 0) {
+        d->mMovingHandle = d->mMovingHandle ^(CH_Left | CH_Right);
+    }
+    d->mRect = d->mRect.normalized();
+
+    // Enforce ratio
+    if (d->mCropRatio > 0.) {
+        if (d->mMovingHandle == CH_Top || d->mMovingHandle == CH_Bottom) {
+            // Top or bottom
+            int width = int(d->mRect.height() / d->mCropRatio);
+            d->mRect.setWidth(width);
+        } else if (d->mMovingHandle == CH_Left || d->mMovingHandle == CH_Right) {
+            // Left or right
+            int height = int(d->mRect.width() * d->mCropRatio);
+            d->mRect.setHeight(height);
+        } else if (d->mMovingHandle & CH_Top) {
+            // Top left or top right
+            int height = int(d->mRect.width() * d->mCropRatio);
+            d->mRect.setTop(d->mRect.bottom() - height);
+        } else if (d->mMovingHandle & CH_Bottom) {
+            // Bottom left or bottom right
+            int height = int(d->mRect.width() * d->mCropRatio);
+            d->mRect.setHeight(height);
+        }
+    }
+
+    if (d->mMovingHandle == CH_Content) {
+        d->mRect.translate(point - d->mLastMouseMovePos);
+        d->mLastMouseMovePos = point;
+    }
+
+    d->keepRectInsideImage();
+
+    imageView()->update();
+    rectUpdated(d->mRect);
+}
+
+void CropTool::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
+{
+    event->accept();
+    d->mMovingHandle = CH_None;
+    d->updateCursor(d->handleAt(event->lastPos()), false);
+
+    // Update to show handles
+    imageView()->update();
+}
+
+void CropTool::hoverMoveEvent(QGraphicsSceneHoverEvent* event)
+{
+    event->accept();
+    // Make sure cursor is updated when moving over handles
+    CropHandle handle = d->handleAt(event->lastPos());
+    d->updateCursor(handle, false /* buttonDown */);
+}
+
+void CropTool::toolActivated()
+{
+    imageView()->setCursor(Qt::CrossCursor);
+}
+
+void CropTool::toolDeactivated()
+{
+    //delete d->mHudWidget;
+}
+
+void CropTool::slotCropRequested()
+{
+    CropImageOperation* op = new CropImageOperation(d->mRect);
+    emit imageOperationRequested(op);
+    emit done();
+}
+
+QWidget* CropTool::widget() const
+{
+    return d->mCropWidget;
+}
 
 } // namespace

=== modified file 'lib/crop/croptool.h'
--- lib/crop/croptool.h	2011-07-20 13:46:34 +0000
+++ lib/crop/croptool.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -28,54 +28,53 @@
 // KDE
 
 // Local
-#include <lib/abstractimageviewtool.h>
+#include <lib/documentview/abstractrasterimageviewtool.h>
 
 class QRect;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class AbstractImageOperation;
 class ImageView;
 
 struct CropToolPrivate;
-class GWENVIEWLIB_EXPORT CropTool : public AbstractImageViewTool {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT CropTool : public AbstractRasterImageViewTool
+{
+    Q_OBJECT
 public:
-	CropTool(ImageView* parent);
-	~CropTool();
-
-	void setCropRatio(double ratio);
-
-	void setRect(const QRect&);
-	QRect rect() const;
-
-	virtual void paint(QPainter*);
-
-	virtual void mousePressEvent(QMouseEvent*);
-	virtual void mouseMoveEvent(QMouseEvent*);
-	virtual void mouseReleaseEvent(QMouseEvent*);
-
-	virtual void toolActivated();
-	virtual void toolDeactivated();
+    CropTool(RasterImageView* parent);
+    ~CropTool();
+
+    void setCropRatio(double ratio);
+
+    void setRect(const QRect&);
+    QRect rect() const;
+
+    virtual void paint(QPainter*);
+
+    virtual void mousePressEvent(QGraphicsSceneMouseEvent*);
+    virtual void mouseMoveEvent(QGraphicsSceneMouseEvent*);
+    virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent*);
+    virtual void hoverMoveEvent(QGraphicsSceneHoverEvent*);
+
+    virtual void toolActivated();
+    virtual void toolDeactivated();
+
+    virtual QWidget* widget() const;
 
 Q_SIGNALS:
-	void rectUpdated(const QRect&);
-	void done();
-	void imageOperationRequested(AbstractImageOperation*);
-
-protected:
-	virtual bool eventFilter(QObject*, QEvent*);
+    void rectUpdated(const QRect&);
+    void done();
+    void imageOperationRequested(AbstractImageOperation*);
 
 private Q_SLOTS:
-	void slotCropRequested();
-	void moveHudWidget();
-	void updateHudWidgetPosition();
+    void slotCropRequested();
 
 private:
-	CropToolPrivate* const d;
+    CropToolPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* CROPTOOL_H */

=== modified file 'lib/crop/cropwidget.cpp'
--- lib/crop/cropwidget.cpp	2011-07-20 13:46:34 +0000
+++ lib/crop/cropwidget.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -34,271 +34,271 @@
 #include <klocale.h>
 
 // Local
+#include <lib/documentview/rasterimageview.h>
 #include "croptool.h"
-#include "imageview.h"
 #include "signalblocker.h"
 #include "ui_cropwidget.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 // Euclidean algorithm to compute the greatest common divisor of two integers.
 // Found at:
 // http://en.wikipedia.org/wiki/Euclidean_algorithm
-static int gcd(int a, int b) {
-	return b == 0 ? a : gcd(b, a % b);
-}
-
-
-static QSize screenRatio() {
-	const QRect rect = QApplication::desktop()->screenGeometry();
-	const int width = rect.width();
-	const int height = rect.height();
-	const int divisor = gcd(width, height);
-	return QSize(width / divisor, height / divisor);
-}
-
+static int gcd(int a, int b)
+{
+    return b == 0 ? a : gcd(b, a % b);
+}
+
+static QSize screenRatio()
+{
+    const QRect rect = QApplication::desktop()->screenGeometry();
+    const int width = rect.width();
+    const int height = rect.height();
+    const int divisor = gcd(width, height);
+    return QSize(width / divisor, height / divisor);
+}
 
 struct CropWidgetPrivate : public Ui_CropWidget {
-	CropWidget* that;
-
-	Document::Ptr mDocument;
-	CropTool* mCropTool;
-	bool mUpdatingFromCropTool;
-
-
-	bool ratioIsConstrained() const {
-		return cropRatio() > 0;
-	}
-
-
-	double cropRatio() const {
-		const QStringList lst = ratioComboBox->currentText().split(':');
-		if (lst.size() != 2) {
-			return 0;
-		}
-
-		bool ok;
-		const double width = lst[0].toDouble(&ok);
-		if (!ok) {
-			return 0;
-		}
-		const double height = lst[1].toDouble(&ok);
-		if (!ok) {
-			return 0;
-		}
-
-		return height / width;
-	}
-
-
-	void addRatioToComboBox(const QSize& size, const QString& label = QString()) {
-		QString text = QString("%1:%2").arg(size.width()).arg(size.height());
-		if (!label.isEmpty()) {
-			text += QString(" (%1)").arg(label);
-		}
-		ratioComboBox->addItem(text, QVariant(size));
-	}
-
-
-	void addSeparatorToComboBox() {
-		ratioComboBox->insertSeparator(ratioComboBox->count());
-	}
-
-
-	void initRatioComboBox() {
-		QList<QSize> ratioList;
-		ratioList
-			<< QSize(3, 2)
-			<< QSize(4, 3)
-			<< QSize(5, 4)
-			<< QSize(6, 4)
-			<< QSize(7, 5)
-			<< QSize(10, 8);
-
-		addRatioToComboBox(QSize(1, 1), i18n("Square"));
-		addRatioToComboBox(screenRatio(), i18n("This Screen"));
-		addSeparatorToComboBox();
-
-		Q_FOREACH(const QSize& size, ratioList) {
-			addRatioToComboBox(size);
-		}
-		addSeparatorToComboBox();
-		Q_FOREACH(QSize size, ratioList) {
-			size.transpose();
-			addRatioToComboBox(size);
-		}
-
-		ratioComboBox->setMaxVisibleItems(ratioComboBox->count());
-		ratioComboBox->setEditText(QString());
-
-		KLineEdit* edit = qobject_cast<KLineEdit*>(ratioComboBox->lineEdit());
-		Q_ASSERT(edit);
-		// Do not use i18n("%1:%2") because ':' should not be translated, it is
-		// used to parse the ratio string.
-		edit->setClickMessage(QString("%1:%2").arg(i18n("Width")).arg(i18n("Height")));
-	}
-
-
-	QRect cropRect() const {
-		QRect rect(
-			leftSpinBox->value(),
-			topSpinBox->value(),
-			widthSpinBox->value(),
-			heightSpinBox->value()
-			);
-		return rect;
-	}
-
-
-	void initSpinBoxes() {
-		QSize size = mDocument->size();
-		leftSpinBox->setMaximum(size.width());
-		widthSpinBox->setMaximum(size.width());
-		topSpinBox->setMaximum(size.height());
-		heightSpinBox->setMaximum(size.height());
-	}
-
-
-	void initCropButton() {
-		cropButton->setIcon(KIcon("transform-crop-and-resize"));
-
-		QObject::connect(cropButton, SIGNAL(clicked()),
-			that, SIGNAL(cropRequested()) );
-	}
+    CropWidget* q;
+
+    Document::Ptr mDocument;
+    CropTool* mCropTool;
+    bool mUpdatingFromCropTool;
+
+    bool ratioIsConstrained() const {
+        return cropRatio() > 0;
+    }
+
+    double cropRatio() const {
+        const QStringList lst = ratioComboBox->currentText().split(':');
+        if (lst.size() != 2) {
+            return 0;
+        }
+
+        bool ok;
+        const double width = lst[0].toDouble(&ok);
+        if (!ok) {
+            return 0;
+        }
+        const double height = lst[1].toDouble(&ok);
+        if (!ok) {
+            return 0;
+        }
+
+        return height / width;
+    }
+
+    void addRatioToComboBox(const QSize& size, const QString& label = QString())
+    {
+        QString text = QString("%1:%2").arg(size.width()).arg(size.height());
+        if (!label.isEmpty()) {
+            text += QString(" (%1)").arg(label);
+        }
+        ratioComboBox->addItem(text, QVariant(size));
+    }
+
+    void addSeparatorToComboBox()
+    {
+        ratioComboBox->insertSeparator(ratioComboBox->count());
+    }
+
+    void initRatioComboBox()
+    {
+        QList<QSize> ratioList;
+        ratioList
+                << QSize(3, 2)
+                << QSize(4, 3)
+                << QSize(5, 4)
+                << QSize(6, 4)
+                << QSize(7, 5)
+                << QSize(10, 8);
+
+        addRatioToComboBox(QSize(1, 1), i18n("Square"));
+        addRatioToComboBox(screenRatio(), i18n("This Screen"));
+        addSeparatorToComboBox();
+
+        Q_FOREACH(const QSize & size, ratioList) {
+            addRatioToComboBox(size);
+        }
+        addSeparatorToComboBox();
+        Q_FOREACH(QSize size, ratioList) {
+            size.transpose();
+            addRatioToComboBox(size);
+        }
+
+        ratioComboBox->setMaxVisibleItems(ratioComboBox->count());
+        ratioComboBox->setEditText(QString());
+
+        KLineEdit* edit = qobject_cast<KLineEdit*>(ratioComboBox->lineEdit());
+        Q_ASSERT(edit);
+        // Do not use i18n("%1:%2") because ':' should not be translated, it is
+        // used to parse the ratio string.
+        edit->setClickMessage(QString("%1:%2").arg(i18n("Width")).arg(i18n("Height")));
+    }
+
+    QRect cropRect() const {
+        QRect rect(
+            leftSpinBox->value(),
+            topSpinBox->value(),
+            widthSpinBox->value(),
+            heightSpinBox->value()
+        );
+        return rect;
+    }
+
+    void initSpinBoxes()
+    {
+        QSize size = mDocument->size();
+        leftSpinBox->setMaximum(size.width());
+        widthSpinBox->setMaximum(size.width());
+        topSpinBox->setMaximum(size.height());
+        heightSpinBox->setMaximum(size.height());
+    }
+
+    void initDialogButtonBox()
+    {
+        QPushButton* cropButton = dialogButtonBox->button(QDialogButtonBox::Ok);
+        cropButton->setIcon(KIcon("transform-crop-and-resize"));
+        cropButton->setText(i18n("Crop"));
+
+        QObject::connect(dialogButtonBox, SIGNAL(accepted()),
+                         q, SIGNAL(cropRequested()));
+        QObject::connect(dialogButtonBox, SIGNAL(rejected()),
+                         q, SIGNAL(done()));
+    }
 };
 
-
-CropWidget::CropWidget(QWidget* parent, ImageView* imageView, CropTool* cropTool)
+CropWidget::CropWidget(QWidget* parent, RasterImageView* imageView, CropTool* cropTool)
 : QWidget(parent)
-, d(new CropWidgetPrivate) {
-	setWindowFlags(Qt::Tool);
-	d->that = this;
-	d->mDocument = imageView->document();
-	d->mUpdatingFromCropTool = false;
-	d->mCropTool = cropTool;
-	d->setupUi(this);
-	setFont(KGlobalSettings::smallestReadableFont());
-	layout()->setMargin(KDialog::marginHint());
-	layout()->setSizeConstraint(QLayout::SetFixedSize);
-
-	connect(d->advancedCheckBox, SIGNAL(toggled(bool)),
-		d->advancedWidget, SLOT(setVisible(bool)));
-	d->advancedWidget->setVisible(false);
-	d->advancedWidget->layout()->setMargin(0);
-
-	d->initRatioComboBox();
-
-	connect(d->mCropTool, SIGNAL(rectUpdated(const QRect&)),
-		SLOT(setCropRect(const QRect&)) );
-
-	connect(d->leftSpinBox, SIGNAL(valueChanged(int)),
-		SLOT(slotPositionChanged()) );
-	connect(d->topSpinBox, SIGNAL(valueChanged(int)),
-		SLOT(slotPositionChanged()) );
-	connect(d->widthSpinBox, SIGNAL(valueChanged(int)),
-		SLOT(slotWidthChanged()) );
-	connect(d->heightSpinBox, SIGNAL(valueChanged(int)),
-		SLOT(slotHeightChanged()) );
-
-	d->initCropButton();
-	
-	connect(d->ratioComboBox, SIGNAL(editTextChanged(const QString&)),
-		SLOT(slotRatioComboBoxEditTextChanged()) );
-	connect(d->ratioComboBox, SIGNAL(activated(int)),
-		SLOT(slotRatioComboBoxActivated()) );
-
-	// Don't do this before signals are connected, otherwise the tool won't get
-	// initialized
-	d->initSpinBoxes();
-
-	setCropRect(d->mCropTool->rect());
-}
-
-
-CropWidget::~CropWidget() {
-	delete d;
-}
-
-
-void CropWidget::setCropRect(const QRect& rect) {
-	d->mUpdatingFromCropTool = true;
-	d->leftSpinBox->setValue(rect.left());
-	d->topSpinBox->setValue(rect.top());
-	d->widthSpinBox->setValue(rect.width());
-	d->heightSpinBox->setValue(rect.height());
-	d->mUpdatingFromCropTool = false;
-}
-
-
-void CropWidget::slotPositionChanged() {
-	const QSize size = d->mDocument->size();
-	d->widthSpinBox->setMaximum(size.width() - d->leftSpinBox->value());
-	d->heightSpinBox->setMaximum(size.height() - d->topSpinBox->value());
-
-	if (d->mUpdatingFromCropTool) {
-		return;
-	}
-	d->mCropTool->setRect(d->cropRect());
-}
-
-
-void CropWidget::slotWidthChanged() {
-	d->leftSpinBox->setMaximum(d->mDocument->width() - d->widthSpinBox->value());
-
-	if (d->mUpdatingFromCropTool) {
-		return;
-	}
-	if (d->ratioIsConstrained()) {
-		int height = int(d->widthSpinBox->value() * d->cropRatio());
-		d->heightSpinBox->setValue(height);
-	}
-	d->mCropTool->setRect(d->cropRect());
-}
-
-
-void CropWidget::slotHeightChanged() {
-	d->topSpinBox->setMaximum(d->mDocument->height() - d->heightSpinBox->value());
-
-	if (d->mUpdatingFromCropTool) {
-		return;
-	}
-	if (d->ratioIsConstrained()) {
-		int width = int(d->heightSpinBox->value() / d->cropRatio());
-		d->widthSpinBox->setValue(width);
-	}
-	d->mCropTool->setRect(d->cropRect());
-}
-
-
-void CropWidget::applyRatioConstraint() {
-	double ratio = d->cropRatio();
-	d->mCropTool->setCropRatio(ratio);
-
-	if (!d->ratioIsConstrained()) {
-		return;
-	}
-	QRect rect = d->cropRect();
-	rect.setHeight(int(rect.width() * ratio));
-	d->mCropTool->setRect(rect);
-}
-
-
-void CropWidget::slotRatioComboBoxEditTextChanged() {
-	applyRatioConstraint();
-}
-
-
-void CropWidget::slotRatioComboBoxActivated() {
-	// If the ratioComboBox contains text like this: "w:h (foo bar)", change it
-	// to "w:h" only, so that it's easier to edit for the user.
-	QStringList lst = d->ratioComboBox->currentText().split(' ');
-	if (lst.size() > 1) {
-		SignalBlocker blocker(d->ratioComboBox);
-		d->ratioComboBox->setEditText(lst[0]);
-		applyRatioConstraint();
-	}
-}
-
+, d(new CropWidgetPrivate)
+{
+    setWindowFlags(Qt::Tool);
+    d->q = this;
+    d->mDocument = imageView->document();
+    d->mUpdatingFromCropTool = false;
+    d->mCropTool = cropTool;
+    d->setupUi(this);
+    setFont(KGlobalSettings::smallestReadableFont());
+    layout()->setMargin(KDialog::marginHint());
+    layout()->setSizeConstraint(QLayout::SetFixedSize);
+
+    connect(d->advancedCheckBox, SIGNAL(toggled(bool)),
+            d->advancedWidget, SLOT(setVisible(bool)));
+    d->advancedWidget->setVisible(false);
+    d->advancedWidget->layout()->setMargin(0);
+
+    d->initRatioComboBox();
+
+    connect(d->mCropTool, SIGNAL(rectUpdated(QRect)),
+            SLOT(setCropRect(QRect)));
+
+    connect(d->leftSpinBox, SIGNAL(valueChanged(int)),
+            SLOT(slotPositionChanged()));
+    connect(d->topSpinBox, SIGNAL(valueChanged(int)),
+            SLOT(slotPositionChanged()));
+    connect(d->widthSpinBox, SIGNAL(valueChanged(int)),
+            SLOT(slotWidthChanged()));
+    connect(d->heightSpinBox, SIGNAL(valueChanged(int)),
+            SLOT(slotHeightChanged()));
+
+    d->initDialogButtonBox();
+
+    connect(d->ratioComboBox, SIGNAL(editTextChanged(QString)),
+            SLOT(slotRatioComboBoxEditTextChanged()));
+    connect(d->ratioComboBox, SIGNAL(activated(int)),
+            SLOT(slotRatioComboBoxActivated()));
+
+    // Don't do this before signals are connected, otherwise the tool won't get
+    // initialized
+    d->initSpinBoxes();
+
+    setCropRect(d->mCropTool->rect());
+}
+
+CropWidget::~CropWidget()
+{
+    delete d;
+}
+
+void CropWidget::setCropRect(const QRect& rect)
+{
+    d->mUpdatingFromCropTool = true;
+    d->leftSpinBox->setValue(rect.left());
+    d->topSpinBox->setValue(rect.top());
+    d->widthSpinBox->setValue(rect.width());
+    d->heightSpinBox->setValue(rect.height());
+    d->mUpdatingFromCropTool = false;
+}
+
+void CropWidget::slotPositionChanged()
+{
+    const QSize size = d->mDocument->size();
+    d->widthSpinBox->setMaximum(size.width() - d->leftSpinBox->value());
+    d->heightSpinBox->setMaximum(size.height() - d->topSpinBox->value());
+
+    if (d->mUpdatingFromCropTool) {
+        return;
+    }
+    d->mCropTool->setRect(d->cropRect());
+}
+
+void CropWidget::slotWidthChanged()
+{
+    d->leftSpinBox->setMaximum(d->mDocument->width() - d->widthSpinBox->value());
+
+    if (d->mUpdatingFromCropTool) {
+        return;
+    }
+    if (d->ratioIsConstrained()) {
+        int height = int(d->widthSpinBox->value() * d->cropRatio());
+        d->heightSpinBox->setValue(height);
+    }
+    d->mCropTool->setRect(d->cropRect());
+}
+
+void CropWidget::slotHeightChanged()
+{
+    d->topSpinBox->setMaximum(d->mDocument->height() - d->heightSpinBox->value());
+
+    if (d->mUpdatingFromCropTool) {
+        return;
+    }
+    if (d->ratioIsConstrained()) {
+        int width = int(d->heightSpinBox->value() / d->cropRatio());
+        d->widthSpinBox->setValue(width);
+    }
+    d->mCropTool->setRect(d->cropRect());
+}
+
+void CropWidget::applyRatioConstraint()
+{
+    double ratio = d->cropRatio();
+    d->mCropTool->setCropRatio(ratio);
+
+    if (!d->ratioIsConstrained()) {
+        return;
+    }
+    QRect rect = d->cropRect();
+    rect.setHeight(int(rect.width() * ratio));
+    d->mCropTool->setRect(rect);
+}
+
+void CropWidget::slotRatioComboBoxEditTextChanged()
+{
+    applyRatioConstraint();
+}
+
+void CropWidget::slotRatioComboBoxActivated()
+{
+    // If the ratioComboBox contains text like this: "w:h (foo bar)", change it
+    // to "w:h" only, so that it's easier to edit for the user.
+    QStringList lst = d->ratioComboBox->currentText().split(' ');
+    if (lst.size() > 1) {
+        SignalBlocker blocker(d->ratioComboBox);
+        d->ratioComboBox->setEditText(lst[0]);
+        applyRatioConstraint();
+    }
+}
 
 } // namespace

=== modified file 'lib/crop/cropwidget.h'
--- lib/crop/cropwidget.h	2011-07-20 13:46:34 +0000
+++ lib/crop/cropwidget.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -31,36 +31,38 @@
 // Local
 #include <lib/document/document.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class CropTool;
-class ImageView;
+class RasterImageView;
 
 struct CropWidgetPrivate;
-class GWENVIEWLIB_EXPORT CropWidget : public QWidget {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT CropWidget : public QWidget
+{
+    Q_OBJECT
 public:
-	CropWidget(QWidget* parent, ImageView*, CropTool*);
-	~CropWidget();
+    CropWidget(QWidget* parent, RasterImageView*, CropTool*);
+    ~CropWidget();
 
 Q_SIGNALS:
-	void cropRequested();
+    void cropRequested();
+    void done();
 
 private Q_SLOTS:
-	void slotPositionChanged();
-	void slotWidthChanged();
-	void slotHeightChanged();
-	void setCropRect(const QRect& rect);
+    void slotPositionChanged();
+    void slotWidthChanged();
+    void slotHeightChanged();
+    void setCropRect(const QRect& rect);
 
-	void slotRatioComboBoxEditTextChanged();
-	void slotRatioComboBoxActivated();
-	void applyRatioConstraint();
+    void slotRatioComboBoxEditTextChanged();
+    void slotRatioComboBoxActivated();
+    void applyRatioConstraint();
 
 private:
-	CropWidgetPrivate* const d;
+    CropWidgetPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* CROPWIDGET_H */

=== modified file 'lib/crop/cropwidget.ui'
--- lib/crop/cropwidget.ui	2011-07-20 13:46:34 +0000
+++ lib/crop/cropwidget.ui	2011-12-15 14:17:54 +0000
@@ -6,45 +6,50 @@
    <rect>
     <x>0</x>
     <y>0</y>
-    <width>235</width>
-    <height>143</height>
+    <width>790</width>
+    <height>66</height>
    </rect>
   </property>
+  <property name="sizePolicy">
+   <sizepolicy hsizetype="Expanding" vsizetype="Fixed">
+    <horstretch>0</horstretch>
+    <verstretch>0</verstretch>
+   </sizepolicy>
+  </property>
   <property name="windowTitle">
    <string>Crop</string>
   </property>
-  <layout class="QVBoxLayout" name="verticalLayout">
+  <layout class="QHBoxLayout" name="horizontalLayout_2">
    <item>
-    <layout class="QHBoxLayout" name="horizontalLayout">
-     <item>
-      <widget class="QCheckBox" name="advancedCheckBox">
-       <property name="focusPolicy">
-        <enum>Qt::NoFocus</enum>
-       </property>
-       <property name="text">
-        <string>Advanced settings</string>
-       </property>
-      </widget>
-     </item>
-     <item>
-      <widget class="QToolButton" name="cropButton">
-       <property name="text">
-        <string>Crop</string>
-       </property>
-       <property name="toolButtonStyle">
-        <enum>Qt::ToolButtonTextBesideIcon</enum>
-       </property>
-       <property name="autoRaise">
-        <bool>true</bool>
-       </property>
-      </widget>
-     </item>
-    </layout>
+    <widget class="QCheckBox" name="advancedCheckBox">
+     <property name="focusPolicy">
+      <enum>Qt::NoFocus</enum>
+     </property>
+     <property name="text">
+      <string>Advanced settings</string>
+     </property>
+    </widget>
    </item>
    <item>
     <widget class="QWidget" name="advancedWidget" native="true">
-     <layout class="QGridLayout" name="gridLayout">
-      <item row="0" column="0" rowspan="2">
+     <layout class="QHBoxLayout" name="horizontalLayout">
+      <item>
+       <spacer name="horizontalSpacer_2">
+        <property name="orientation">
+         <enum>Qt::Horizontal</enum>
+        </property>
+        <property name="sizeType">
+         <enum>QSizePolicy::Fixed</enum>
+        </property>
+        <property name="sizeHint" stdset="0">
+         <size>
+          <width>12</width>
+          <height>20</height>
+         </size>
+        </property>
+       </spacer>
+      </item>
+      <item>
        <widget class="QLabel" name="label_6">
         <property name="text">
          <string>Ratio:</string>
@@ -52,9 +57,12 @@
         <property name="alignment">
          <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
         </property>
+        <property name="buddy">
+         <cstring>ratioComboBox</cstring>
+        </property>
        </widget>
       </item>
-      <item row="1" column="1" colspan="2">
+      <item>
        <widget class="KComboBox" name="ratioComboBox">
         <property name="editable">
          <bool>true</bool>
@@ -64,7 +72,7 @@
         </property>
        </widget>
       </item>
-      <item row="2" column="0">
+      <item>
        <widget class="QLabel" name="label">
         <property name="sizePolicy">
          <sizepolicy hsizetype="Preferred" vsizetype="Preferred">
@@ -83,7 +91,7 @@
         </property>
        </widget>
       </item>
-      <item row="2" column="1">
+      <item>
        <widget class="KIntSpinBox" name="leftSpinBox">
         <property name="sizePolicy">
          <sizepolicy hsizetype="Expanding" vsizetype="Fixed">
@@ -93,7 +101,7 @@
         </property>
        </widget>
       </item>
-      <item row="2" column="2">
+      <item>
        <widget class="KIntSpinBox" name="topSpinBox">
         <property name="sizePolicy">
          <sizepolicy hsizetype="Minimum" vsizetype="Fixed">
@@ -103,7 +111,7 @@
         </property>
        </widget>
       </item>
-      <item row="3" column="0">
+      <item>
        <widget class="QLabel" name="label_3">
         <property name="text">
          <string>Size:</string>
@@ -116,7 +124,7 @@
         </property>
        </widget>
       </item>
-      <item row="3" column="1">
+      <item>
        <widget class="KIntSpinBox" name="widthSpinBox">
         <property name="sizePolicy">
          <sizepolicy hsizetype="Minimum" vsizetype="Fixed">
@@ -126,7 +134,7 @@
         </property>
        </widget>
       </item>
-      <item row="3" column="2">
+      <item>
        <widget class="KIntSpinBox" name="heightSpinBox">
         <property name="sizePolicy">
          <sizepolicy hsizetype="Minimum" vsizetype="Fixed">
@@ -139,10 +147,35 @@
      </layout>
     </widget>
    </item>
+   <item>
+    <spacer name="horizontalSpacer">
+     <property name="orientation">
+      <enum>Qt::Horizontal</enum>
+     </property>
+     <property name="sizeHint" stdset="0">
+      <size>
+       <width>0</width>
+       <height>20</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
+   <item>
+    <widget class="KDialogButtonBox" name="dialogButtonBox">
+     <property name="standardButtons">
+      <set>QDialogButtonBox::Cancel|QDialogButtonBox::Ok</set>
+     </property>
+    </widget>
+   </item>
   </layout>
  </widget>
  <customwidgets>
   <customwidget>
+   <class>KDialogButtonBox</class>
+   <extends>QDialogButtonBox</extends>
+   <header>kdialogbuttonbox.h</header>
+  </customwidget>
+  <customwidget>
    <class>KComboBox</class>
    <extends>QComboBox</extends>
    <header>kcombobox.h</header>
@@ -154,7 +187,6 @@
   </customwidget>
  </customwidgets>
  <tabstops>
-  <tabstop>advancedCheckBox</tabstop>
   <tabstop>ratioComboBox</tabstop>
   <tabstop>leftSpinBox</tabstop>
   <tabstop>topSpinBox</tabstop>

=== modified file 'lib/datewidget.cpp'
--- lib/datewidget.cpp	2011-07-20 13:46:34 +0000
+++ lib/datewidget.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -34,112 +34,114 @@
 // Local
 #include <lib/statusbartoolbutton.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct DateWidgetPrivate {
-	DateWidget* that;
-
-	QDate mDate;
-	KDatePicker* mDatePicker;
-	StatusBarToolButton* mPreviousButton;
-	StatusBarToolButton* mDateButton;
-	StatusBarToolButton* mNextButton;
-
-	void setupDatePicker() {
-		mDatePicker = new KDatePicker;
-		/* Use Qt::Tool instead of Qt::Window so that the bubble does not appear in the task bar */
-		//mDatePicker->setWindowFlags(Qt::Tool | Qt::FramelessWindowHint | Qt::WindowStaysOnTopHint);
-		mDatePicker->setWindowFlags(Qt::Popup);
-		mDatePicker->hide();
-		mDatePicker->setFrameStyle(QFrame::StyledPanel | QFrame::Raised);
-
-		QObject::connect(mDatePicker, SIGNAL(dateEntered(const QDate&)),
-			that, SLOT(slotDatePickerModified(const QDate&)));
-		QObject::connect(mDatePicker, SIGNAL(dateSelected(const QDate&)),
-			that, SLOT(slotDatePickerModified(const QDate&)));
-	}
-
-	void updateButton() {
-		mDateButton->setText(KGlobal::locale()->formatDate(mDate, KLocale::ShortDate));
-	}
-
-	void adjustDate(int delta) {
-		mDate = mDate.addDays(delta);
-		updateButton();
-		that->dateChanged(mDate);
-	}
+    DateWidget* q;
+
+    QDate mDate;
+    KDatePicker* mDatePicker;
+    StatusBarToolButton* mPreviousButton;
+    StatusBarToolButton* mDateButton;
+    StatusBarToolButton* mNextButton;
+
+    void setupDatePicker()
+    {
+        mDatePicker = new KDatePicker;
+        /* Use Qt::Tool instead of Qt::Window so that the bubble does not appear in the task bar */
+        //mDatePicker->setWindowFlags(Qt::Tool | Qt::FramelessWindowHint | Qt::WindowStaysOnTopHint);
+        mDatePicker->setWindowFlags(Qt::Popup);
+        mDatePicker->hide();
+        mDatePicker->setFrameStyle(QFrame::StyledPanel | QFrame::Raised);
+
+        QObject::connect(mDatePicker, SIGNAL(dateEntered(QDate)),
+                         q, SLOT(slotDatePickerModified(QDate)));
+        QObject::connect(mDatePicker, SIGNAL(dateSelected(QDate)),
+                         q, SLOT(slotDatePickerModified(QDate)));
+    }
+
+    void updateButton()
+    {
+        mDateButton->setText(KGlobal::locale()->formatDate(mDate, KLocale::ShortDate));
+    }
+
+    void adjustDate(int delta)
+    {
+        mDate = mDate.addDays(delta);
+        updateButton();
+        q->dateChanged(mDate);
+    }
 };
 
-
 DateWidget::DateWidget(QWidget* parent)
 : QWidget(parent)
-, d(new DateWidgetPrivate) {
-	d->that = this;
-
-	d->setupDatePicker();
-
-	d->mPreviousButton = new StatusBarToolButton;
-	d->mPreviousButton->setGroupPosition(StatusBarToolButton::GroupLeft);
-	// FIXME: RTL
-	d->mPreviousButton->setIcon(SmallIcon("go-previous"));
-	connect(d->mPreviousButton, SIGNAL(clicked()), SLOT(goToPrevious()));
-
-	d->mDateButton = new StatusBarToolButton;
-	d->mDateButton->setGroupPosition(StatusBarToolButton::GroupCenter);
-	connect(d->mDateButton, SIGNAL(clicked()), SLOT(showDatePicker()));
-
-	d->mNextButton = new StatusBarToolButton;
-	d->mNextButton->setGroupPosition(StatusBarToolButton::GroupRight);
-	d->mNextButton->setIcon(SmallIcon("go-next"));
-	connect(d->mNextButton, SIGNAL(clicked()), SLOT(goToNext()));
-
-	QHBoxLayout* layout = new QHBoxLayout(this);
-	layout->setMargin(0);
-	layout->setSpacing(0);
-	layout->addWidget(d->mPreviousButton);
-	layout->addWidget(d->mDateButton);
-	layout->addWidget(d->mNextButton);
-}
-
-
-DateWidget::~DateWidget() {
-	delete d->mDatePicker;
-	delete d;
-}
-
-
-QDate DateWidget::date() const {
-	return d->mDate;
-}
-
-
-void DateWidget::showDatePicker() {
-	d->mDatePicker->setDate(d->mDate);
-	d->mDatePicker->adjustSize();
-	const QPoint pos = mapToGlobal(QPoint(0, -d->mDatePicker->height()));
-	d->mDatePicker->move(pos);
-	d->mDatePicker->show();
-}
-
-
-void DateWidget::slotDatePickerModified(const QDate& date) {
-	d->mDatePicker->hide();
-	d->mDate = date;
-	emit dateChanged(date);
-
-	d->updateButton();
-}
-
-
-void DateWidget::goToPrevious() {
-	d->adjustDate(-1);
-}
-
-
-void DateWidget::goToNext() {
-	d->adjustDate(1);
-}
-
+, d(new DateWidgetPrivate)
+{
+    d->q = this;
+
+    d->setupDatePicker();
+
+    d->mPreviousButton = new StatusBarToolButton;
+    d->mPreviousButton->setGroupPosition(StatusBarToolButton::GroupLeft);
+    // FIXME: RTL
+    d->mPreviousButton->setIcon(SmallIcon("go-previous"));
+    connect(d->mPreviousButton, SIGNAL(clicked()), SLOT(goToPrevious()));
+
+    d->mDateButton = new StatusBarToolButton;
+    d->mDateButton->setGroupPosition(StatusBarToolButton::GroupCenter);
+    connect(d->mDateButton, SIGNAL(clicked()), SLOT(showDatePicker()));
+
+    d->mNextButton = new StatusBarToolButton;
+    d->mNextButton->setGroupPosition(StatusBarToolButton::GroupRight);
+    d->mNextButton->setIcon(SmallIcon("go-next"));
+    connect(d->mNextButton, SIGNAL(clicked()), SLOT(goToNext()));
+
+    QHBoxLayout* layout = new QHBoxLayout(this);
+    layout->setMargin(0);
+    layout->setSpacing(0);
+    layout->addWidget(d->mPreviousButton);
+    layout->addWidget(d->mDateButton);
+    layout->addWidget(d->mNextButton);
+}
+
+DateWidget::~DateWidget()
+{
+    delete d->mDatePicker;
+    delete d;
+}
+
+QDate DateWidget::date() const
+{
+    return d->mDate;
+}
+
+void DateWidget::showDatePicker()
+{
+    d->mDatePicker->setDate(d->mDate);
+    d->mDatePicker->adjustSize();
+    const QPoint pos = mapToGlobal(QPoint(0, -d->mDatePicker->height()));
+    d->mDatePicker->move(pos);
+    d->mDatePicker->show();
+}
+
+void DateWidget::slotDatePickerModified(const QDate& date)
+{
+    d->mDatePicker->hide();
+    d->mDate = date;
+    emit dateChanged(date);
+
+    d->updateButton();
+}
+
+void DateWidget::goToPrevious()
+{
+    d->adjustDate(-1);
+}
+
+void DateWidget::goToNext()
+{
+    d->adjustDate(1);
+}
 
 } // namespace

=== modified file 'lib/datewidget.h'
--- lib/datewidget.h	2011-07-20 13:46:34 +0000
+++ lib/datewidget.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,33 +32,33 @@
 
 class QDate;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct DateWidgetPrivate;
-class GWENVIEWLIB_EXPORT DateWidget : public QWidget {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT DateWidget : public QWidget
+{
+    Q_OBJECT
 public:
-	DateWidget(QWidget* parent = 0);
-	~DateWidget();
+    DateWidget(QWidget* parent = 0);
+    ~DateWidget();
 
-	QDate date() const;
+    QDate date() const;
 
 Q_SIGNALS:
-	void dateChanged(const QDate&);
+    void dateChanged(const QDate&);
 
 private Q_SLOTS:
-	void showDatePicker();
-	void slotDatePickerModified(const QDate& date);
-	void goToPrevious();
-	void goToNext();
+    void showDatePicker();
+    void slotDatePickerModified(const QDate& date);
+    void goToPrevious();
+    void goToNext();
 
 private:
-	friend struct DateWidgetPrivate;
-	DateWidgetPrivate* const d;
+    friend struct DateWidgetPrivate;
+    DateWidgetPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* DATEWIDGET_H */

=== modified file 'lib/document/abstractdocumenteditor.h'
--- lib/document/abstractdocumenteditor.h	2011-07-20 13:46:34 +0000
+++ lib/document/abstractdocumenteditor.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,41 +32,39 @@
 
 class QImage;
 
-namespace Gwenview {
-
-
-
+namespace Gwenview
+{
 
 /**
  * An interface which can be returned by some implementations of
  * AbstractDocumentImpl if they support edition.
  */
-class GWENVIEWLIB_EXPORT AbstractDocumentEditor {
+class GWENVIEWLIB_EXPORT AbstractDocumentEditor
+{
 public:
-	virtual ~AbstractDocumentEditor() {}
-
-	/**
-	 * Replaces the current image with image.
-	 * Calling this while the document is loaded won't do anything.
-	 *
-	 * This method should only be called from a subclass of
-	 * AbstractImageOperation and applied through Document::undoStack().
-	 */
-	virtual void setImage(const QImage&) = 0;
-
-	/**
-	 * Apply a transformation to the document image.
-	 *
-	 * Transformations are handled by the Document class because it can be
-	 * done in a lossless way by some Document implementations.
-	 *
-	 * This method should only be called from a subclass of
-	 * AbstractImageOperation and applied through Document::undoStack().
-	 */
-	virtual void applyTransformation(Orientation) = 0;
+    virtual ~AbstractDocumentEditor() {}
+
+    /**
+     * Replaces the current image with image.
+     * Calling this while the document is loaded won't do anything.
+     *
+     * This method should only be called from a subclass of
+     * AbstractImageOperation and applied through Document::undoStack().
+     */
+    virtual void setImage(const QImage&) = 0;
+
+    /**
+     * Apply a transformation to the document image.
+     *
+     * Transformations are handled by the Document class because it can be
+     * done in a lossless way by some Document implementations.
+     *
+     * This method should only be called from a subclass of
+     * AbstractImageOperation and applied through Document::undoStack().
+     */
+    virtual void applyTransformation(Orientation) = 0;
 };
 
-
 } // namespace
 
 #endif /* ABSTRACTDOCUMENTEDITOR_H */

=== modified file 'lib/document/abstractdocumentimpl.cpp'
--- lib/document/abstractdocumentimpl.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/abstractdocumentimpl.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -28,67 +28,67 @@
 // Local
 #include "document.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct AbstractDocumentImplPrivate {
-	Document* mDocument;
+    Document* mDocument;
 };
 
-
 AbstractDocumentImpl::AbstractDocumentImpl(Document* document)
-: d(new AbstractDocumentImplPrivate) {
-	d->mDocument = document;
-}
-
-
-AbstractDocumentImpl::~AbstractDocumentImpl() {
-	delete d;
-}
-
-
-Document* AbstractDocumentImpl::document() const {
-	return d->mDocument;
-}
-
-
-void AbstractDocumentImpl::switchToImpl(AbstractDocumentImpl*  impl) {
-	d->mDocument->switchToImpl(impl);
-}
-
-
-void AbstractDocumentImpl::setDocumentImage(const QImage& image) {
-	d->mDocument->setImageInternal(image);
-}
-
-
-void AbstractDocumentImpl::setDocumentImageSize(const QSize& size) {
-	d->mDocument->setSize(size);
-}
-
-
-void AbstractDocumentImpl::setDocumentFormat(const QByteArray& format) {
-	d->mDocument->setFormat(format);
-}
-
-
-void AbstractDocumentImpl::setDocumentKind(MimeTypeUtils::Kind kind) {
-	d->mDocument->setKind(kind);
-}
-
-
-void AbstractDocumentImpl::setDocumentExiv2Image(Exiv2::Image::AutoPtr image) {
-	d->mDocument->setExiv2Image(image);
-}
-
-
-void AbstractDocumentImpl::setDocumentDownSampledImage(const QImage& image, int invertedZoom) {
-	d->mDocument->setDownSampledImage(image, invertedZoom);
-}
-
-
-void AbstractDocumentImpl::setDocumentErrorString(const QString& string) {
-	d->mDocument->setErrorString(string);
-}
-
+: d(new AbstractDocumentImplPrivate)
+{
+    d->mDocument = document;
+}
+
+AbstractDocumentImpl::~AbstractDocumentImpl()
+{
+    delete d;
+}
+
+Document* AbstractDocumentImpl::document() const
+{
+    return d->mDocument;
+}
+
+void AbstractDocumentImpl::switchToImpl(AbstractDocumentImpl*  impl)
+{
+    d->mDocument->switchToImpl(impl);
+}
+
+void AbstractDocumentImpl::setDocumentImage(const QImage& image)
+{
+    d->mDocument->setImageInternal(image);
+}
+
+void AbstractDocumentImpl::setDocumentImageSize(const QSize& size)
+{
+    d->mDocument->setSize(size);
+}
+
+void AbstractDocumentImpl::setDocumentFormat(const QByteArray& format)
+{
+    d->mDocument->setFormat(format);
+}
+
+void AbstractDocumentImpl::setDocumentKind(MimeTypeUtils::Kind kind)
+{
+    d->mDocument->setKind(kind);
+}
+
+void AbstractDocumentImpl::setDocumentExiv2Image(Exiv2::Image::AutoPtr image)
+{
+    d->mDocument->setExiv2Image(image);
+}
+
+void AbstractDocumentImpl::setDocumentDownSampledImage(const QImage& image, int invertedZoom)
+{
+    d->mDocument->setDownSampledImage(image, invertedZoom);
+}
+
+void AbstractDocumentImpl::setDocumentErrorString(const QString& string)
+{
+    d->mDocument->setErrorString(string);
+}
 
 } // namespace

=== modified file 'lib/document/abstractdocumentimpl.h'
--- lib/document/abstractdocumentimpl.h	2011-07-20 13:46:34 +0000
+++ lib/document/abstractdocumentimpl.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -34,66 +34,81 @@
 class QImage;
 class QRect;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class Document;
 class DocumentJob;
 class AbstractDocumentEditor;
 
 struct AbstractDocumentImplPrivate;
-class AbstractDocumentImpl : public QObject {
-	Q_OBJECT
+class AbstractDocumentImpl : public QObject
+{
+    Q_OBJECT
 public:
-	AbstractDocumentImpl(Document*);
-	virtual ~AbstractDocumentImpl();
-
-	/**
-	 * This method is called by Document::switchToImpl after it has connected
-	 * signals to the object
-	 */
-	virtual void init() = 0;
-
-	virtual Document::LoadingState loadingState() const = 0;
-
-	virtual DocumentJob* save(const KUrl&, const QByteArray& /*format*/) { return 0; }
-
-	virtual AbstractDocumentEditor* editor() { return 0; }
-
-	virtual QByteArray rawData() const { return QByteArray(); }
-
-	virtual bool isEditable() const { return false; }
-
-	virtual bool isAnimated() const { return false; }
-
-	virtual void startAnimation() {}
-
-	virtual void stopAnimation() {}
-
-	Document* document() const;
+    AbstractDocumentImpl(Document*);
+    virtual ~AbstractDocumentImpl();
+
+    /**
+     * This method is called by Document::switchToImpl after it has connected
+     * signals to the object
+     */
+    virtual void init() = 0;
+
+    virtual Document::LoadingState loadingState() const = 0;
+
+    virtual DocumentJob* save(const KUrl&, const QByteArray& /*format*/) {
+        return 0;
+    }
+
+    virtual AbstractDocumentEditor* editor() {
+        return 0;
+    }
+
+    virtual QByteArray rawData() const {
+        return QByteArray();
+    }
+
+    virtual bool isEditable() const {
+        return false;
+    }
+
+    virtual bool isAnimated() const {
+        return false;
+    }
+
+    virtual void startAnimation() {}
+
+    virtual void stopAnimation() {}
+
+    Document* document() const;
+
+    virtual QSvgRenderer* svgRenderer() const {
+        return 0;
+    }
 
 Q_SIGNALS:
-	void imageRectUpdated(const QRect&);
-	void metaInfoLoaded();
-	void loaded();
-	void loadingFailed();
-	void isAnimatedUpdated();
-	void editorUpdated();
+    void imageRectUpdated(const QRect&);
+    void metaInfoLoaded();
+    void loaded();
+    void loadingFailed();
+    void isAnimatedUpdated();
+    void editorUpdated();
 
 protected:
-	void setDocumentImage(const QImage& image);
-	void setDocumentImageSize(const QSize& size);
-	void setDocumentKind(MimeTypeUtils::Kind);
-	void setDocumentFormat(const QByteArray& format);
-	void setDocumentExiv2Image(Exiv2::Image::AutoPtr);
-	void setDocumentDownSampledImage(const QImage&, int invertedZoom);
-	void setDocumentErrorString(const QString&);
-	void switchToImpl(AbstractDocumentImpl*  impl);
+    void setDocumentImage(const QImage& image);
+    void setDocumentImageSize(const QSize& size);
+    void setDocumentKind(MimeTypeUtils::Kind);
+    void setDocumentFormat(const QByteArray& format);
+    void setDocumentExiv2Image(Exiv2::Image::AutoPtr);
+    void setDocumentDownSampledImage(const QImage&, int invertedZoom);
+    void setDocumentErrorString(const QString&);
+    void switchToImpl(AbstractDocumentImpl*  impl);
 
 private:
-	AbstractDocumentImplPrivate* const d;
+    AbstractDocumentImplPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* ABSTRACTDOCUMENTIMPL_H */

=== modified file 'lib/document/animateddocumentloadedimpl.cpp'
--- lib/document/animateddocumentloadedimpl.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/animateddocumentloadedimpl.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -31,82 +31,81 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct AnimatedDocumentLoadedImplPrivate {
-	QByteArray mRawData;
-	QBuffer mMovieBuffer;
-	QMovie mMovie;
+    QByteArray mRawData;
+    QBuffer mMovieBuffer;
+    QMovie mMovie;
 };
 
-
 AnimatedDocumentLoadedImpl::AnimatedDocumentLoadedImpl(Document* document, const QByteArray& rawData)
 : AbstractDocumentImpl(document)
-, d(new AnimatedDocumentLoadedImplPrivate) {
-	d->mRawData = rawData;
-
-	connect(&d->mMovie, SIGNAL(frameChanged(int)), SLOT(slotFrameChanged(int)) );
-
-	d->mMovieBuffer.setBuffer(&d->mRawData);
-	d->mMovieBuffer.open(QIODevice::ReadOnly);
-	d->mMovie.setDevice(&d->mMovieBuffer);
-}
-
-
-AnimatedDocumentLoadedImpl::~AnimatedDocumentLoadedImpl() {
-	delete d;
-}
-
-
-void AnimatedDocumentLoadedImpl::init() {
-	emit isAnimatedUpdated();
-	if (!document()->image().isNull()) {
-		// We may reach this point without an image if the first frame got
-		// downsampled by LoadingDocumentImpl (unlikely for now because the gif
-		// io handler does not support the QImageIOHandler::ScaledSize option)
-		emit imageRectUpdated(document()->image().rect());
-		emit loaded();
-	}
-}
-
-
-Document::LoadingState AnimatedDocumentLoadedImpl::loadingState() const {
-	return Document::Loaded;
-}
-
-
-QByteArray AnimatedDocumentLoadedImpl::rawData() const {
-	return d->mRawData;
-}
-
-
-void AnimatedDocumentLoadedImpl::slotFrameChanged(int /*frameNumber*/) {
-	QImage image = d->mMovie.currentImage();
-	setDocumentImage(image);
-	emit imageRectUpdated(image.rect());
-}
-
-
-bool AnimatedDocumentLoadedImpl::isAnimated() const {
-	return true;
-}
-
-
-void AnimatedDocumentLoadedImpl::startAnimation() {
-	d->mMovie.start();
-	if (d->mMovie.state() == QMovie::NotRunning) {
-		// This is true with qt-copy as of 2008.08.23
-		kDebug() << "QMovie didn't start. This can happen in some cases when starting for the second time.";
-		kDebug() << "Trying to start again, it usually fixes the bug.";
-		d->mMovie.start();
-	}
-}
-
-
-void AnimatedDocumentLoadedImpl::stopAnimation() {
-	d->mMovie.stop();
-}
-
+, d(new AnimatedDocumentLoadedImplPrivate)
+{
+    d->mRawData = rawData;
+
+    connect(&d->mMovie, SIGNAL(frameChanged(int)), SLOT(slotFrameChanged(int)));
+
+    d->mMovieBuffer.setBuffer(&d->mRawData);
+    d->mMovieBuffer.open(QIODevice::ReadOnly);
+    d->mMovie.setDevice(&d->mMovieBuffer);
+}
+
+AnimatedDocumentLoadedImpl::~AnimatedDocumentLoadedImpl()
+{
+    delete d;
+}
+
+void AnimatedDocumentLoadedImpl::init()
+{
+    emit isAnimatedUpdated();
+    if (!document()->image().isNull()) {
+        // We may reach this point without an image if the first frame got
+        // downsampled by LoadingDocumentImpl (unlikely for now because the gif
+        // io handler does not support the QImageIOHandler::ScaledSize option)
+        emit imageRectUpdated(document()->image().rect());
+        emit loaded();
+    }
+}
+
+Document::LoadingState AnimatedDocumentLoadedImpl::loadingState() const
+{
+    return Document::Loaded;
+}
+
+QByteArray AnimatedDocumentLoadedImpl::rawData() const
+{
+    return d->mRawData;
+}
+
+void AnimatedDocumentLoadedImpl::slotFrameChanged(int /*frameNumber*/)
+{
+    QImage image = d->mMovie.currentImage();
+    setDocumentImage(image);
+    emit imageRectUpdated(image.rect());
+}
+
+bool AnimatedDocumentLoadedImpl::isAnimated() const
+{
+    return true;
+}
+
+void AnimatedDocumentLoadedImpl::startAnimation()
+{
+    d->mMovie.start();
+    if (d->mMovie.state() == QMovie::NotRunning) {
+        // This is true with qt-copy as of 2008.08.23
+        kDebug() << "QMovie didn't start. This can happen in some cases when starting for the second time.";
+        kDebug() << "Trying to start again, it usually fixes the bug.";
+        d->mMovie.start();
+    }
+}
+
+void AnimatedDocumentLoadedImpl::stopAnimation()
+{
+    d->mMovie.stop();
+}
 
 } // namespace

=== modified file 'lib/document/animateddocumentloadedimpl.h'
--- lib/document/animateddocumentloadedimpl.h	2011-07-20 13:46:34 +0000
+++ lib/document/animateddocumentloadedimpl.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -28,31 +28,31 @@
 // Local
 #include <lib/document/abstractdocumentimpl.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct AnimatedDocumentLoadedImplPrivate;
-class AnimatedDocumentLoadedImpl : public AbstractDocumentImpl {
-	Q_OBJECT
+class AnimatedDocumentLoadedImpl : public AbstractDocumentImpl
+{
+    Q_OBJECT
 public:
-	AnimatedDocumentLoadedImpl(Document*, const QByteArray&);
-	~AnimatedDocumentLoadedImpl();
+    AnimatedDocumentLoadedImpl(Document*, const QByteArray&);
+    ~AnimatedDocumentLoadedImpl();
 
-	virtual void init();
-	virtual Document::LoadingState loadingState() const;
-	virtual QByteArray rawData() const;
-	virtual bool isAnimated() const;
-	virtual void startAnimation();
-	virtual void stopAnimation();
+    virtual void init();
+    virtual Document::LoadingState loadingState() const;
+    virtual QByteArray rawData() const;
+    virtual bool isAnimated() const;
+    virtual void startAnimation();
+    virtual void stopAnimation();
 
 private Q_SLOTS:
-	void slotFrameChanged(int frameNumber);
+    void slotFrameChanged(int frameNumber);
 
 private:
-	AnimatedDocumentLoadedImplPrivate* const d;
+    AnimatedDocumentLoadedImplPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* ANIMATEDDOCUMENTLOADEDIMPL_H */

=== modified file 'lib/document/document.cpp'
--- lib/document/document.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/document.cpp	2011-12-15 14:17:54 +0000
@@ -40,83 +40,84 @@
 #include "loadingjob.h"
 #include "savejob.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct DocumentPrivate {
-	AbstractDocumentImpl* mImpl;
-	KUrl mUrl;
-	bool mKeepRawData;
-	QQueue<DocumentJob*> mJobQueue;
-
-	/**
-	 * @defgroup imagedata should be reset in reload()
-	 * @{
-	 */
-	QSize mSize;
-	QImage mImage;
-	QMap<int, QImage> mDownSampledImageMap;
-	Exiv2::Image::AutoPtr mExiv2Image;
-	MimeTypeUtils::Kind mKind;
-	QByteArray mFormat;
-	ImageMetaInfoModel mImageMetaInfoModel;
-	QUndoStack mUndoStack;
-	QString mErrorString;
-	/** @} */
-
-	void scheduleImageLoading(int invertedZoom) {
-		LoadingDocumentImpl* impl = qobject_cast<LoadingDocumentImpl*>(mImpl);
-		Q_ASSERT(impl);
-		impl->loadImage(invertedZoom);
-	}
+    AbstractDocumentImpl* mImpl;
+    KUrl mUrl;
+    bool mKeepRawData;
+    QQueue<DocumentJob*> mJobQueue;
+
+    /**
+     * @defgroup imagedata should be reset in reload()
+     * @{
+     */
+    QSize mSize;
+    QImage mImage;
+    QMap<int, QImage> mDownSampledImageMap;
+    Exiv2::Image::AutoPtr mExiv2Image;
+    MimeTypeUtils::Kind mKind;
+    QByteArray mFormat;
+    ImageMetaInfoModel mImageMetaInfoModel;
+    QUndoStack mUndoStack;
+    QString mErrorString;
+    /** @} */
+
+    void scheduleImageLoading(int invertedZoom)
+    {
+        LoadingDocumentImpl* impl = qobject_cast<LoadingDocumentImpl*>(mImpl);
+        Q_ASSERT(impl);
+        impl->loadImage(invertedZoom);
+    }
 };
 
-
-qreal Document::maxDownSampledZoom() {
-	return 0.5;
+qreal Document::maxDownSampledZoom()
+{
+    return 0.5;
 }
 
-
 Document::Document(const KUrl& url)
 : QObject()
-, d(new DocumentPrivate) {
-	d->mImpl = 0;
-	d->mUrl = url;
-	d->mKeepRawData = false;
-	connect(&d->mUndoStack, SIGNAL(indexChanged(int)), SLOT(slotUndoIndexChanged()) );
-
-	reload();
-}
-
-
-Document::~Document() {
-	// We do not want undo stack to emit signals, forcing us to emit signals
-	// ourself while we are being destroyed.
-	disconnect(&d->mUndoStack, 0, this, 0);
-
-	delete d->mImpl;
-	delete d;
-}
-
-
-void Document::reload() {
-	d->mSize = QSize();
-	d->mImage = QImage();
-	d->mDownSampledImageMap.clear();
-	d->mExiv2Image.reset();
-	d->mKind = MimeTypeUtils::KIND_UNKNOWN;
-	d->mFormat = QByteArray();
-	d->mImageMetaInfoModel.setUrl(d->mUrl);
-	d->mUndoStack.clear();
-	d->mErrorString.clear();
-
-	switchToImpl(new LoadingDocumentImpl(this));
-}
-
-
-const QImage& Document::image() const {
-	return d->mImage;
-}
-
+, d(new DocumentPrivate)
+{
+    d->mImpl = 0;
+    d->mUrl = url;
+    d->mKeepRawData = false;
+    connect(&d->mUndoStack, SIGNAL(indexChanged(int)), SLOT(slotUndoIndexChanged()));
+
+    reload();
+}
+
+Document::~Document()
+{
+    // We do not want undo stack to emit signals, forcing us to emit signals
+    // ourself while we are being destroyed.
+    disconnect(&d->mUndoStack, 0, this, 0);
+
+    delete d->mImpl;
+    delete d;
+}
+
+void Document::reload()
+{
+    d->mSize = QSize();
+    d->mImage = QImage();
+    d->mDownSampledImageMap.clear();
+    d->mExiv2Image.reset();
+    d->mKind = MimeTypeUtils::KIND_UNKNOWN;
+    d->mFormat = QByteArray();
+    d->mImageMetaInfoModel.setUrl(d->mUrl);
+    d->mUndoStack.clear();
+    d->mErrorString.clear();
+
+    switchToImpl(new LoadingDocumentImpl(this));
+}
+
+const QImage& Document::image() const
+{
+    return d->mImage;
+}
 
 /**
  * invertedZoom is the biggest power of 2 for which zoom < 1/invertedZoom.
@@ -124,354 +125,363 @@
  * zoom = 0.4 == 1/2.5 => invertedZoom = 2 (1/2.5 < 1/2)
  * zoom = 0.2 == 1/5   => invertedZoom = 4 (1/5   < 1/4)
  */
-inline int invertedZoomForZoom(qreal zoom) {
-	int invertedZoom;
-	for (invertedZoom = 1; zoom < 1./(invertedZoom*2); invertedZoom*=2) {}
-	return invertedZoom;
-}
-
-
-const QImage& Document::downSampledImageForZoom(qreal zoom) const {
-	static const QImage sNullImage;
-
-	int invertedZoom = invertedZoomForZoom(zoom);
-	if (invertedZoom == 1) {
-		return d->mImage;
-	}
-
-	if (!d->mDownSampledImageMap.contains(invertedZoom)) {
-		if (!d->mImage.isNull()) {
-			// Special case: if we have the full image and the down sampled
-			// image would be too small, return the original image.
-			const QSize downSampledSize = d->mImage.size() / invertedZoom;
-			if (downSampledSize.isEmpty()) {
-				return d->mImage;
-			}
-		}
-		return sNullImage;
-	}
-
-	return d->mDownSampledImageMap[invertedZoom];
-}
-
-
-Document::LoadingState Document::loadingState() const {
-	return d->mImpl->loadingState();
-}
-
-
-void Document::switchToImpl(AbstractDocumentImpl* impl) {
-	Q_ASSERT(impl);
-	if (d->mImpl) {
-		d->mImpl->deleteLater();
-	}
-	d->mImpl=impl;
-
-	connect(d->mImpl, SIGNAL(metaInfoLoaded()),
-		this, SLOT(emitMetaInfoLoaded()) );
-	connect(d->mImpl, SIGNAL(loaded()),
-		this, SLOT(emitLoaded()) );
-	connect(d->mImpl, SIGNAL(loadingFailed()),
-		this, SLOT(emitLoadingFailed()) );
-	connect(d->mImpl, SIGNAL(imageRectUpdated(const QRect&)),
-		this, SIGNAL(imageRectUpdated(const QRect&)) );
-	connect(d->mImpl, SIGNAL(isAnimatedUpdated()),
-		this, SIGNAL(isAnimatedUpdated()) );
-	d->mImpl->init();
-}
-
-
-void Document::setImageInternal(const QImage& image) {
-	d->mImage = image;
-	d->mDownSampledImageMap.clear();
-
-	// If we didn't get the image size before decoding the full image, set it
-	// now
-	setSize(d->mImage.size());
-}
-
-
-KUrl Document::url() const {
-	return d->mUrl;
-}
-
-
-QByteArray Document::rawData() const {
-	return d->mImpl->rawData();
-}
-
-
-bool Document::keepRawData() const {
-	return d->mKeepRawData;
-}
-
-
-void Document::setKeepRawData(bool value) {
-	d->mKeepRawData = value;
-}
-
-
-void Document::waitUntilLoaded() {
-	startLoadingFullImage();
-	while (true) {
-		LoadingState state = loadingState();
-		if (state == Loaded || state == LoadingFailed) {
-			return;
-		}
-		qApp->processEvents(QEventLoop::ExcludeUserInputEvents);
-	}
-}
-
-
-DocumentJob* Document::save(const KUrl& url, const QByteArray& format) {
-	waitUntilLoaded();
-	DocumentJob* job = d->mImpl->save(url, format);
-	if (!job) {
-		kWarning() << "Implementation does not support saving!";
-		setErrorString(i18nc("@info", "Gwenview cannot save this kind of documents."));
-		return false;
-	}
-	job->setProperty("oldUrl", d->mUrl);
-	job->setProperty("newUrl", url);
-	connect(job, SIGNAL(result(KJob*)), SLOT(slotSaveResult(KJob*)));
-	enqueueJob(job);
-	return job;
-}
-
-
-void Document::slotSaveResult(KJob* job) {
-	if (job->error()) {
-		setErrorString(job->errorString());
-	} else {
-		d->mUndoStack.setClean();
-		SaveJob* saveJob = static_cast<SaveJob*>(job);
-		d->mUrl = saveJob->newUrl();
-		d->mImageMetaInfoModel.setUrl(d->mUrl);
-		saved(saveJob->oldUrl(), d->mUrl);
-	}
-}
-
-
-QByteArray Document::format() const {
-	return d->mFormat;
-}
-
-
-void Document::setFormat(const QByteArray& format) {
-	d->mFormat = format;
-	emit metaInfoUpdated();
-}
-
-
-MimeTypeUtils::Kind Document::kind() const {
-	return d->mKind;
-}
-
-
-void Document::setKind(MimeTypeUtils::Kind kind) {
-	d->mKind = kind;
-	emit kindDetermined(d->mUrl);
-}
-
-
-QSize Document::size() const {
-	return d->mSize;
-}
-
-
-bool Document::hasAlphaChannel() const {
-	if (d->mImage.isNull()) {
-		return false;
-	} else {
-		return d->mImage.hasAlphaChannel();
-	}
-}
-
-
-int Document::memoryUsage() const {
-	// FIXME: Take undo stack into account
-	int usage = d->mImage.numBytes();
-	usage += rawData().length();
-	return usage;
-}
-
-
-void Document::setSize(const QSize& size) {
-	if (size == d->mSize) {
-		return;
-	}
-	d->mSize = size;
-	d->mImageMetaInfoModel.setImageSize(size);
-	emit metaInfoUpdated();
-}
-
-
-bool Document::isModified() const {
-	return !d->mUndoStack.isClean();
-}
-
-
-AbstractDocumentEditor* Document::editor() {
-	return d->mImpl->editor();
-}
-
-
-void Document::setExiv2Image(Exiv2::Image::AutoPtr image) {
-	d->mExiv2Image = image;
-	d->mImageMetaInfoModel.setExiv2Image(d->mExiv2Image.get());
-	emit metaInfoUpdated();
-}
-
-
-void Document::setDownSampledImage(const QImage& image, int invertedZoom) {
-	Q_ASSERT(!d->mDownSampledImageMap.contains(invertedZoom));
-	d->mDownSampledImageMap[invertedZoom] = image;
-	emit downSampledImageReady();
-}
-
-
-QString Document::errorString() const {
-	return d->mErrorString;
-}
-
-
-void Document::setErrorString(const QString& string) {
-	d->mErrorString = string;
-}
-
-
-ImageMetaInfoModel* Document::metaInfo() const {
-	return &d->mImageMetaInfoModel;
-}
-
-
-void Document::startLoadingFullImage() {
-	LoadingState state = loadingState();
-	if (state <= MetaInfoLoaded) {
-		// Schedule full image loading
-		LoadingJob* job = new LoadingJob;
-		job->uiDelegate()->setAutoWarningHandlingEnabled(false);
-		job->uiDelegate()->setAutoErrorHandlingEnabled(false);
-		enqueueJob(job);
-		d->scheduleImageLoading(1);
-	} else if (state == Loaded) {
-		return;
-	} else if (state == LoadingFailed) {
-		kWarning() << "Can't load full image: loading has already failed";
-	}
-}
-
-
-bool Document::prepareDownSampledImageForZoom(qreal zoom) {
-	if (zoom >= maxDownSampledZoom()) {
-		kWarning() << "No need to call prepareDownSampledImageForZoom if zoom >= " << maxDownSampledZoom();
-		return true;
-	}
-
-	int invertedZoom = invertedZoomForZoom(zoom);
-	if (d->mDownSampledImageMap.contains(invertedZoom)) {
-		return true;
-	}
-
-	if (loadingState() == Loaded) {
-		// Resample image from the full one
-		d->mDownSampledImageMap[invertedZoom] = d->mImage.scaled(d->mImage.size() / invertedZoom, Qt::KeepAspectRatio, Qt::FastTransformation);
-		if (d->mDownSampledImageMap[invertedZoom].size().isEmpty()) {
-			d->mDownSampledImageMap[invertedZoom] = d->mImage;
-			return true;
-		}
-
-		return true;
-	}
-
-	// Schedule down sampled image loading
-	d->scheduleImageLoading(invertedZoom);
-
-	return false;
-}
-
-
-void Document::emitMetaInfoLoaded() {
-	emit metaInfoLoaded(d->mUrl);
-}
-
-
-void Document::emitLoaded() {
-	emit loaded(d->mUrl);
-}
-
-
-void Document::emitLoadingFailed() {
-	emit loadingFailed(d->mUrl);
-}
-
-
-QUndoStack* Document::undoStack() const {
-	return &d->mUndoStack;
-}
-
-
-void Document::slotUndoIndexChanged() {
-	if (d->mUndoStack.isClean()) {
-		// If user just undid all his changes this does not really correspond
-		// to a save, but it's similar enough as far as Document users are
-		// concerned
-		saved(d->mUrl, d->mUrl);
-	} else {
-		modified(d->mUrl);
-	}
-}
-
-
-bool Document::isEditable() const {
-	return d->mImpl->isEditable();
-}
-
-
-bool Document::isAnimated() const {
-	return d->mImpl->isAnimated();
-}
-
-
-void Document::startAnimation() {
-	return d->mImpl->startAnimation();
-}
-
-
-void Document::stopAnimation() {
-	return d->mImpl->stopAnimation();
-}
-
-void Document::enqueueJob(DocumentJob* job) {
-	d->mJobQueue.enqueue(job);
-	job->setDocument(Ptr(this));
-	connect(job, SIGNAL(destroyed(QObject*)),
-		SLOT(slotJobDestroyed(QObject*)));
-	if (d->mJobQueue.size() == 1) {
-		job->start();
-		busyChanged(d->mUrl, true);
-	}
-}
-
-void Document::slotJobDestroyed(QObject* job) {
-	Q_ASSERT(!d->mJobQueue.isEmpty());
-	if (d->mJobQueue.head() != job) {
-		// Job was killed before it even got started, just remove it from the
-		// queue and move along
-		d->mJobQueue.removeAll(static_cast<DocumentJob*>(job));
-		return;
-	}
-	d->mJobQueue.dequeue();
-	if (d->mJobQueue.isEmpty()) {
-		busyChanged(d->mUrl, false);
-		allTasksDone();
-	} else {
-		d->mJobQueue.head()->start();
-	}
-}
-
-bool Document::isBusy() const {
-	return !d->mJobQueue.isEmpty();
+inline int invertedZoomForZoom(qreal zoom)
+{
+    int invertedZoom;
+    for (invertedZoom = 1; zoom < 1. / (invertedZoom * 2); invertedZoom *= 2) {}
+    return invertedZoom;
+}
+
+const QImage& Document::downSampledImageForZoom(qreal zoom) const
+{
+    static const QImage sNullImage;
+
+    int invertedZoom = invertedZoomForZoom(zoom);
+    if (invertedZoom == 1) {
+        return d->mImage;
+    }
+
+    if (!d->mDownSampledImageMap.contains(invertedZoom)) {
+        if (!d->mImage.isNull()) {
+            // Special case: if we have the full image and the down sampled
+            // image would be too small, return the original image.
+            const QSize downSampledSize = d->mImage.size() / invertedZoom;
+            if (downSampledSize.isEmpty()) {
+                return d->mImage;
+            }
+        }
+        return sNullImage;
+    }
+
+    return d->mDownSampledImageMap[invertedZoom];
+}
+
+Document::LoadingState Document::loadingState() const
+{
+    return d->mImpl->loadingState();
+}
+
+void Document::switchToImpl(AbstractDocumentImpl* impl)
+{
+    Q_ASSERT(impl);
+    if (d->mImpl) {
+        d->mImpl->deleteLater();
+    }
+    d->mImpl = impl;
+
+    connect(d->mImpl, SIGNAL(metaInfoLoaded()),
+            this, SLOT(emitMetaInfoLoaded()));
+    connect(d->mImpl, SIGNAL(loaded()),
+            this, SLOT(emitLoaded()));
+    connect(d->mImpl, SIGNAL(loadingFailed()),
+            this, SLOT(emitLoadingFailed()));
+    connect(d->mImpl, SIGNAL(imageRectUpdated(QRect)),
+            this, SIGNAL(imageRectUpdated(QRect)));
+    connect(d->mImpl, SIGNAL(isAnimatedUpdated()),
+            this, SIGNAL(isAnimatedUpdated()));
+    d->mImpl->init();
+}
+
+void Document::setImageInternal(const QImage& image)
+{
+    d->mImage = image;
+    d->mDownSampledImageMap.clear();
+
+    // If we didn't get the image size before decoding the full image, set it
+    // now
+    setSize(d->mImage.size());
+}
+
+KUrl Document::url() const
+{
+    return d->mUrl;
+}
+
+QByteArray Document::rawData() const
+{
+    return d->mImpl->rawData();
+}
+
+bool Document::keepRawData() const
+{
+    return d->mKeepRawData;
+}
+
+void Document::setKeepRawData(bool value)
+{
+    d->mKeepRawData = value;
+}
+
+void Document::waitUntilLoaded()
+{
+    startLoadingFullImage();
+    while (true) {
+        LoadingState state = loadingState();
+        if (state == Loaded || state == LoadingFailed) {
+            return;
+        }
+        qApp->processEvents(QEventLoop::ExcludeUserInputEvents);
+    }
+}
+
+DocumentJob* Document::save(const KUrl& url, const QByteArray& format)
+{
+    waitUntilLoaded();
+    DocumentJob* job = d->mImpl->save(url, format);
+    if (!job) {
+        kWarning() << "Implementation does not support saving!";
+        setErrorString(i18nc("@info", "Gwenview cannot save this kind of documents."));
+        return false;
+    }
+    job->setProperty("oldUrl", d->mUrl);
+    job->setProperty("newUrl", url);
+    connect(job, SIGNAL(result(KJob*)), SLOT(slotSaveResult(KJob*)));
+    enqueueJob(job);
+    return job;
+}
+
+void Document::slotSaveResult(KJob* job)
+{
+    if (job->error()) {
+        setErrorString(job->errorString());
+    } else {
+        d->mUndoStack.setClean();
+        SaveJob* saveJob = static_cast<SaveJob*>(job);
+        d->mUrl = saveJob->newUrl();
+        d->mImageMetaInfoModel.setUrl(d->mUrl);
+        saved(saveJob->oldUrl(), d->mUrl);
+    }
+}
+
+QByteArray Document::format() const
+{
+    return d->mFormat;
+}
+
+void Document::setFormat(const QByteArray& format)
+{
+    d->mFormat = format;
+    emit metaInfoUpdated();
+}
+
+MimeTypeUtils::Kind Document::kind() const
+{
+    return d->mKind;
+}
+
+void Document::setKind(MimeTypeUtils::Kind kind)
+{
+    d->mKind = kind;
+    emit kindDetermined(d->mUrl);
+}
+
+QSize Document::size() const
+{
+    return d->mSize;
+}
+
+bool Document::hasAlphaChannel() const
+{
+    if (d->mImage.isNull()) {
+        return false;
+    } else {
+        return d->mImage.hasAlphaChannel();
+    }
+}
+
+int Document::memoryUsage() const
+{
+    // FIXME: Take undo stack into account
+    int usage = d->mImage.numBytes();
+    usage += rawData().length();
+    return usage;
+}
+
+void Document::setSize(const QSize& size)
+{
+    if (size == d->mSize) {
+        return;
+    }
+    d->mSize = size;
+    d->mImageMetaInfoModel.setImageSize(size);
+    emit metaInfoUpdated();
+}
+
+bool Document::isModified() const
+{
+    return !d->mUndoStack.isClean();
+}
+
+AbstractDocumentEditor* Document::editor()
+{
+    return d->mImpl->editor();
+}
+
+void Document::setExiv2Image(Exiv2::Image::AutoPtr image)
+{
+    d->mExiv2Image = image;
+    d->mImageMetaInfoModel.setExiv2Image(d->mExiv2Image.get());
+    emit metaInfoUpdated();
+}
+
+void Document::setDownSampledImage(const QImage& image, int invertedZoom)
+{
+    Q_ASSERT(!d->mDownSampledImageMap.contains(invertedZoom));
+    d->mDownSampledImageMap[invertedZoom] = image;
+    emit downSampledImageReady();
+}
+
+QString Document::errorString() const
+{
+    return d->mErrorString;
+}
+
+void Document::setErrorString(const QString& string)
+{
+    d->mErrorString = string;
+}
+
+ImageMetaInfoModel* Document::metaInfo() const
+{
+    return &d->mImageMetaInfoModel;
+}
+
+void Document::startLoadingFullImage()
+{
+    LoadingState state = loadingState();
+    if (state <= MetaInfoLoaded) {
+        // Schedule full image loading
+        LoadingJob* job = new LoadingJob;
+        job->uiDelegate()->setAutoWarningHandlingEnabled(false);
+        job->uiDelegate()->setAutoErrorHandlingEnabled(false);
+        enqueueJob(job);
+        d->scheduleImageLoading(1);
+    } else if (state == Loaded) {
+        return;
+    } else if (state == LoadingFailed) {
+        kWarning() << "Can't load full image: loading has already failed";
+    }
+}
+
+bool Document::prepareDownSampledImageForZoom(qreal zoom)
+{
+    if (zoom >= maxDownSampledZoom()) {
+        kWarning() << "No need to call prepareDownSampledImageForZoom if zoom >= " << maxDownSampledZoom();
+        return true;
+    }
+
+    int invertedZoom = invertedZoomForZoom(zoom);
+    if (d->mDownSampledImageMap.contains(invertedZoom)) {
+        return true;
+    }
+
+    if (loadingState() == Loaded) {
+        // Resample image from the full one
+        d->mDownSampledImageMap[invertedZoom] = d->mImage.scaled(d->mImage.size() / invertedZoom, Qt::KeepAspectRatio, Qt::FastTransformation);
+        if (d->mDownSampledImageMap[invertedZoom].size().isEmpty()) {
+            d->mDownSampledImageMap[invertedZoom] = d->mImage;
+            return true;
+        }
+
+        return true;
+    }
+
+    // Schedule down sampled image loading
+    d->scheduleImageLoading(invertedZoom);
+
+    return false;
+}
+
+void Document::emitMetaInfoLoaded()
+{
+    emit metaInfoLoaded(d->mUrl);
+}
+
+void Document::emitLoaded()
+{
+    emit loaded(d->mUrl);
+}
+
+void Document::emitLoadingFailed()
+{
+    emit loadingFailed(d->mUrl);
+}
+
+QUndoStack* Document::undoStack() const
+{
+    return &d->mUndoStack;
+}
+
+void Document::slotUndoIndexChanged()
+{
+    if (d->mUndoStack.isClean()) {
+        // If user just undid all his changes this does not really correspond
+        // to a save, but it's similar enough as far as Document users are
+        // concerned
+        saved(d->mUrl, d->mUrl);
+    } else {
+        modified(d->mUrl);
+    }
+}
+
+bool Document::isEditable() const
+{
+    return d->mImpl->isEditable();
+}
+
+bool Document::isAnimated() const
+{
+    return d->mImpl->isAnimated();
+}
+
+void Document::startAnimation()
+{
+    return d->mImpl->startAnimation();
+}
+
+void Document::stopAnimation()
+{
+    return d->mImpl->stopAnimation();
+}
+
+void Document::enqueueJob(DocumentJob* job)
+{
+    d->mJobQueue.enqueue(job);
+    job->setDocument(Ptr(this));
+    connect(job, SIGNAL(destroyed(QObject*)),
+            SLOT(slotJobDestroyed(QObject*)));
+    if (d->mJobQueue.size() == 1) {
+        job->start();
+        busyChanged(d->mUrl, true);
+    }
+}
+
+void Document::slotJobDestroyed(QObject* job)
+{
+    Q_ASSERT(!d->mJobQueue.isEmpty());
+    if (d->mJobQueue.head() != job) {
+        // Job was killed before it even got started, just remove it from the
+        // queue and move along
+        d->mJobQueue.removeAll(static_cast<DocumentJob*>(job));
+        return;
+    }
+    d->mJobQueue.dequeue();
+    if (d->mJobQueue.isEmpty()) {
+        busyChanged(d->mUrl, false);
+        allTasksDone();
+    } else {
+        d->mJobQueue.head()->start();
+    }
+}
+
+bool Document::isBusy() const
+{
+    return !d->mJobQueue.isEmpty();
+}
+
+QSvgRenderer* Document::svgRenderer() const
+{
+    return d->mImpl->svgRenderer();
 }
 
 } // namespace

=== modified file 'lib/document/document.h'
--- lib/document/document.h	2011-07-20 13:46:34 +0000
+++ lib/document/document.h	2011-12-15 14:17:54 +0000
@@ -39,12 +39,14 @@
 class QImage;
 class QRect;
 class QSize;
+class QSvgRenderer;
 class QUndoStack;
 
 class KJob;
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class AbstractDocumentEditor;
 class AbstractDocumentImpl;
@@ -53,7 +55,6 @@
 struct DocumentPrivate;
 class ImageMetaInfoModel;
 
-
 /**
  * This class represents an image.
  *
@@ -68,163 +69,174 @@
  * To get a Document instance for url, ask for one with
  * DocumentFactory::instance()->load(url);
  */
-class GWENVIEWLIB_EXPORT Document : public QObject, public QSharedData {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT Document : public QObject, public QSharedData
+{
+    Q_OBJECT
 public:
-	/**
-	 * Document won't produce down sampled images for any zoom value higher than maxDownSampledZoom().
-	 *
-	 * Note: We can't use the enum {} trick to declare this constant, that's
-	 * why it's defined as a static method
-	 */
-	static qreal maxDownSampledZoom();
-
-	enum LoadingState {
-		Loading,        ///< Image is loading
-		KindDetermined, ///< Image is still loading, but kind has been determined
-		MetaInfoLoaded, ///< Image is still loading, but meta info has been loaded
-		Loaded,         ///< Full image has been loaded
-		LoadingFailed   ///< Image loading has failed
-	};
-
-	typedef KSharedPtr<Document> Ptr;
-	~Document();
-
-	/**
-	 * Returns a message for the last error which happened
-	 */
-	QString errorString() const;
-
-	void reload();
-
-	void startLoadingFullImage();
-
-	/**
-	 * Prepare a version of the image down sampled to be a bit bigger than
-	 * size() * @a zoom.
-	 * Do not ask for a down sampled image for @a zoom >= to MaxDownSampledZoom.
-	 *
-	 * @return true if the image is ready, false if not. In this case the
-	 * downSampledImageReady() signal will be emitted.
-	 */
-	bool prepareDownSampledImageForZoom(qreal zoom);
-
-	LoadingState loadingState() const;
-
-	MimeTypeUtils::Kind kind() const;
-
-	bool isModified() const;
-
-	const QImage& image() const;
-
-	const QImage& downSampledImageForZoom(qreal zoom) const;
-
-	/**
-	 * Returns an implementation of AbstractDocumentEditor if this document can
-	 * be edited.
-	 */
-	AbstractDocumentEditor* editor();
-
-	KUrl url() const;
-
-	DocumentJob* save(const KUrl& url, const QByteArray& format);
-
-	QByteArray format() const;
-
-	void waitUntilLoaded();
-
-	QSize size() const;
-
-	int width() const { return size().width(); }
-
-	int height() const { return size().height(); }
-
-	bool hasAlphaChannel() const;
-
-	ImageMetaInfoModel* metaInfo() const;
-
-	QUndoStack* undoStack() const;
-
-	void setKeepRawData(bool);
-
-	bool keepRawData() const;
-
-	/**
-	 * Returns how much bytes the document is using
-	 */
-	int memoryUsage() const;
-
-	/**
-	 * Returns the compressed version of the document, if it is still
-	 * available.
-	 */
-	QByteArray rawData() const;
-
-	/**
-	 * Returns true if the image can be edited.
-	 * You must ensure it has been fully loaded with startLoadingFullImage() first.
-	 */
-	bool isEditable() const;
-
-	/**
-	 * Returns true if the image is animated (eg: gif or mng format)
-	 */
-	bool isAnimated() const;
-
-	/**
-	 * Starts animation. Only sensible if isAnimated() returns true.
-	 */
-	void startAnimation();
-
-	/**
-	 * Stops animation. Only sensible if isAnimated() returns true.
-	 */
-	void stopAnimation();
-
-	void enqueueJob(DocumentJob*);
-
-	/**
-	 * Returns true if there are queued tasks for this document.
-	 */
-	bool isBusy() const;
+    /**
+     * Document won't produce down sampled images for any zoom value higher than maxDownSampledZoom().
+     *
+     * Note: We can't use the enum {} trick to declare this constant, that's
+     * why it's defined as a static method
+     */
+    static qreal maxDownSampledZoom();
+
+    enum LoadingState {
+        Loading,        ///< Image is loading
+        KindDetermined, ///< Image is still loading, but kind has been determined
+        MetaInfoLoaded, ///< Image is still loading, but meta info has been loaded
+        Loaded,         ///< Full image has been loaded
+        LoadingFailed   ///< Image loading has failed
+    };
+
+    typedef KSharedPtr<Document> Ptr;
+    ~Document();
+
+    /**
+     * Returns a message for the last error which happened
+     */
+    QString errorString() const;
+
+    void reload();
+
+    void startLoadingFullImage();
+
+    /**
+     * Prepare a version of the image down sampled to be a bit bigger than
+     * size() * @a zoom.
+     * Do not ask for a down sampled image for @a zoom >= to MaxDownSampledZoom.
+     *
+     * @return true if the image is ready, false if not. In this case the
+     * downSampledImageReady() signal will be emitted.
+     */
+    bool prepareDownSampledImageForZoom(qreal zoom);
+
+    LoadingState loadingState() const;
+
+    MimeTypeUtils::Kind kind() const;
+
+    bool isModified() const;
+
+    const QImage& image() const;
+
+    const QImage& downSampledImageForZoom(qreal zoom) const;
+
+    /**
+     * Returns an implementation of AbstractDocumentEditor if this document can
+     * be edited.
+     */
+    AbstractDocumentEditor* editor();
+
+    KUrl url() const;
+
+    DocumentJob* save(const KUrl& url, const QByteArray& format);
+
+    QByteArray format() const;
+
+    void waitUntilLoaded();
+
+    QSize size() const;
+
+    int width() const {
+        return size().width();
+    }
+
+    int height() const {
+        return size().height();
+    }
+
+    bool hasAlphaChannel() const;
+
+    ImageMetaInfoModel* metaInfo() const;
+
+    QUndoStack* undoStack() const;
+
+    void setKeepRawData(bool);
+
+    bool keepRawData() const;
+
+    /**
+     * Returns how much bytes the document is using
+     */
+    int memoryUsage() const;
+
+    /**
+     * Returns the compressed version of the document, if it is still
+     * available.
+     */
+    QByteArray rawData() const;
+
+    /**
+     * Returns a QSvgRenderer which can be used to render this document if it is
+     * an SVG image. Returns a NULL pointer otherwise.
+     */
+    QSvgRenderer* svgRenderer() const;
+
+    /**
+     * Returns true if the image can be edited.
+     * You must ensure it has been fully loaded with startLoadingFullImage() first.
+     */
+    bool isEditable() const;
+
+    /**
+     * Returns true if the image is animated (eg: gif or mng format)
+     */
+    bool isAnimated() const;
+
+    /**
+     * Starts animation. Only sensible if isAnimated() returns true.
+     */
+    void startAnimation();
+
+    /**
+     * Stops animation. Only sensible if isAnimated() returns true.
+     */
+    void stopAnimation();
+
+    void enqueueJob(DocumentJob*);
+
+    /**
+     * Returns true if there are queued tasks for this document.
+     */
+    bool isBusy() const;
 
 Q_SIGNALS:
-	void downSampledImageReady();
-	void imageRectUpdated(const QRect&);
-	void kindDetermined(const KUrl&);
-	void metaInfoLoaded(const KUrl&);
-	void loaded(const KUrl&);
-	void loadingFailed(const KUrl&);
-	void saved(const KUrl& oldUrl, const KUrl& newUrl);
-	void modified(const KUrl&);
-	void metaInfoUpdated();
-	void isAnimatedUpdated();
-	void busyChanged(const KUrl&, bool);
-	void allTasksDone();
+    void downSampledImageReady();
+    void imageRectUpdated(const QRect&);
+    void kindDetermined(const KUrl&);
+    void metaInfoLoaded(const KUrl&);
+    void loaded(const KUrl&);
+    void loadingFailed(const KUrl&);
+    void saved(const KUrl& oldUrl, const KUrl& newUrl);
+    void modified(const KUrl&);
+    void metaInfoUpdated();
+    void isAnimatedUpdated();
+    void busyChanged(const KUrl&, bool);
+    void allTasksDone();
 
 private Q_SLOTS:
-	void emitMetaInfoLoaded();
-	void emitLoaded();
-	void emitLoadingFailed();
-	void slotUndoIndexChanged();
-	void slotSaveResult(KJob*);
-	void slotJobDestroyed(QObject*);
+    void emitMetaInfoLoaded();
+    void emitLoaded();
+    void emitLoadingFailed();
+    void slotUndoIndexChanged();
+    void slotSaveResult(KJob*);
+    void slotJobDestroyed(QObject*);
 
 private:
-	friend class DocumentFactory;
-	friend class AbstractDocumentImpl;
-
-	void setImageInternal(const QImage&);
-	void setKind(MimeTypeUtils::Kind);
-	void setFormat(const QByteArray&);
-	void setSize(const QSize&);
-	void setExiv2Image(Exiv2::Image::AutoPtr);
-	void setDownSampledImage(const QImage&, int invertedZoom);
-	void switchToImpl(AbstractDocumentImpl* impl);
-	void setErrorString(const QString&);
-
-	Document(const KUrl&);
-	DocumentPrivate * const d;
+    friend class DocumentFactory;
+    friend class AbstractDocumentImpl;
+
+    void setImageInternal(const QImage&);
+    void setKind(MimeTypeUtils::Kind);
+    void setFormat(const QByteArray&);
+    void setSize(const QSize&);
+    void setExiv2Image(Exiv2::Image::AutoPtr);
+    void setDownSampledImage(const QImage&, int invertedZoom);
+    void switchToImpl(AbstractDocumentImpl* impl);
+    void setErrorString(const QString&);
+
+    Document(const KUrl&);
+    DocumentPrivate * const d;
 };
 
 } // namespace

=== modified file 'lib/document/documentfactory.cpp'
--- lib/document/documentfactory.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/documentfactory.cpp	2011-12-15 14:17:54 +0000
@@ -29,7 +29,8 @@
 #include <kdebug.h>
 #include <kurl.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -40,16 +41,17 @@
 #define LOG(x) ;
 #endif
 
-inline int getMaxUnreferencedImages() {
-	int defaultValue = 3;
-	QByteArray ba = qgetenv("GWENVIEW_MAX_UNREFERENCED_IMAGES");
-	if (ba.isEmpty()) {
-		return defaultValue;
-	}
-	kDebug() << "Custom value for max unreferenced images:" << ba;
-	bool ok;
-	int value = ba.toInt(&ok);
-	return ok ? value : defaultValue;
+inline int getMaxUnreferencedImages()
+{
+    int defaultValue = 3;
+    QByteArray ba = qgetenv("GWENVIEW_MAX_UNREFERENCED_IMAGES");
+    if (ba.isEmpty()) {
+        return defaultValue;
+    }
+    kDebug() << "Custom value for max unreferenced images:" << ba;
+    bool ok;
+    int value = ba.toInt(&ok);
+    return ok ? value : defaultValue;
 }
 
 static const int MAX_UNREFERENCED_IMAGES = getMaxUnreferencedImages();
@@ -60,8 +62,8 @@
  * documents.
  */
 struct DocumentInfo {
-	Document::Ptr mDocument;
-	QDateTime mLastAccess;
+    Document::Ptr mDocument;
+    QDateTime mLastAccess;
 };
 
 /**
@@ -72,196 +74,200 @@
 typedef QMap<KUrl, DocumentInfo*> DocumentMap;
 
 struct DocumentFactoryPrivate {
-	DocumentMap mDocumentMap;
-	QUndoGroup mUndoGroup;
-
-	/**
-	 * Removes items in a map if they are no longer referenced elsewhere
-	 */
-	void garbageCollect(DocumentMap& map) {
-		// Build a map of all unreferenced images
-		typedef QMap<QDateTime, KUrl> UnreferencedImages;
-		UnreferencedImages unreferencedImages;
-
-		DocumentMap::Iterator
-			it = map.begin(),
-			end = map.end();
-		for (;it!=end; ++it) {
-			DocumentInfo* info = it.value();
-			if (info->mDocument.count() == 1 && !info->mDocument->isModified()) {
-				unreferencedImages[info->mLastAccess] = it.key();
-			}
-		}
-
-		// Remove oldest unreferenced images. Since the map is sorted by key,
-		// the oldest one is always unreferencedImages.begin().
-		for (
-			UnreferencedImages::Iterator unreferencedIt = unreferencedImages.begin();
-			unreferencedImages.count() > MAX_UNREFERENCED_IMAGES;
-			unreferencedIt = unreferencedImages.erase(unreferencedIt))
-		{
-			KUrl url = unreferencedIt.value();
-			LOG("Collecting" << url);
-			it = map.find(url);
-			Q_ASSERT(it != map.end());
-			delete it.value();
-			map.erase(it);
-		}
-
-		#ifdef ENABLE_LOG
-		logDocumentMap(map);
-		#endif
-	}
-
-	void logDocumentMap(const DocumentMap& map) {
-		kDebug() << "map:";
-		DocumentMap::ConstIterator
-			it = map.constBegin(),
-			end = map.constEnd();
-		for(; it!=end; ++it) {
-			kDebug() << "-" << it.key()
-				<< "refCount=" << it.value()->mDocument.count()
-				<< "lastAccess=" << it.value()->mLastAccess;
-		}
-	}
-
-	QList<KUrl> mModifiedDocumentList;
+    DocumentMap mDocumentMap;
+    QUndoGroup mUndoGroup;
+
+    /**
+     * Removes items in a map if they are no longer referenced elsewhere
+     */
+    void garbageCollect(DocumentMap& map)
+    {
+        // Build a map of all unreferenced images
+        typedef QMap<QDateTime, KUrl> UnreferencedImages;
+        UnreferencedImages unreferencedImages;
+
+        DocumentMap::Iterator
+        it = map.begin(),
+        end = map.end();
+        for (; it != end; ++it) {
+            DocumentInfo* info = it.value();
+            if (info->mDocument.count() == 1 && !info->mDocument->isModified()) {
+                unreferencedImages[info->mLastAccess] = it.key();
+            }
+        }
+
+        // Remove oldest unreferenced images. Since the map is sorted by key,
+        // the oldest one is always unreferencedImages.begin().
+        for (
+            UnreferencedImages::Iterator unreferencedIt = unreferencedImages.begin();
+            unreferencedImages.count() > MAX_UNREFERENCED_IMAGES;
+            unreferencedIt = unreferencedImages.erase(unreferencedIt)) {
+            KUrl url = unreferencedIt.value();
+            LOG("Collecting" << url);
+            it = map.find(url);
+            Q_ASSERT(it != map.end());
+            delete it.value();
+            map.erase(it);
+        }
+
+#ifdef ENABLE_LOG
+        logDocumentMap(map);
+#endif
+    }
+
+    void logDocumentMap(const DocumentMap& map)
+    {
+        kDebug() << "map:";
+        DocumentMap::ConstIterator
+        it = map.constBegin(),
+        end = map.constEnd();
+        for (; it != end; ++it) {
+            kDebug() << "-" << it.key()
+                     << "refCount=" << it.value()->mDocument.count()
+                     << "lastAccess=" << it.value()->mLastAccess;
+        }
+    }
+
+    QList<KUrl> mModifiedDocumentList;
 };
 
 DocumentFactory::DocumentFactory()
-: d(new DocumentFactoryPrivate) {
-}
-
-DocumentFactory::~DocumentFactory() {
-	qDeleteAll(d->mDocumentMap);
-	delete d;
-}
-
-DocumentFactory* DocumentFactory::instance() {
-	static DocumentFactory factory;
-	return &factory;
-}
-
-Document::Ptr DocumentFactory::load(const KUrl& url) {
-	DocumentInfo* info = 0;
-
-	DocumentMap::Iterator it = d->mDocumentMap.find(url);
-
-	if (it != d->mDocumentMap.end()) {
-		LOG(url.fileName() << "url in mDocumentMap");
-		info = it.value();
-		info->mLastAccess = QDateTime::currentDateTime();
-		return info->mDocument;
-	}
-
-	// At this point we couldn't find the document in the map
-
-	// Start loading the document
-	LOG(url.fileName() << "loading");
-	Document* doc = new Document(url);
-	connect(doc, SIGNAL(loaded(const KUrl&)),
-		SLOT(slotLoaded(const KUrl&)) );
-	connect(doc, SIGNAL(saved(const KUrl&, const KUrl&)),
-		SLOT(slotSaved(const KUrl&, const KUrl&)) );
-	connect(doc, SIGNAL(modified(const KUrl&)),
-		SLOT(slotModified(const KUrl&)) );
-	connect(doc, SIGNAL(busyChanged(const KUrl&, bool)),
-		SLOT(slotBusyChanged(const KUrl&, bool)) );
-
-	// Create DocumentInfo instance
-	info = new DocumentInfo;
-	Document::Ptr docPtr(doc);
-	info->mDocument = docPtr;
-	info->mLastAccess = QDateTime::currentDateTime();
-
-	// Place DocumentInfo in the map
-	d->mDocumentMap[url] = info;
-
-	d->garbageCollect(d->mDocumentMap);
-
-	return docPtr;
-}
-
-
-QList<KUrl> DocumentFactory::modifiedDocumentList() const {
-	return d->mModifiedDocumentList;
-}
-
-
-bool DocumentFactory::hasUrl(const KUrl& url) const {
-	return d->mDocumentMap.contains(url);
-}
-
-
-void DocumentFactory::clearCache() {
-	qDeleteAll(d->mDocumentMap);
-	d->mDocumentMap.clear();
-	d->mModifiedDocumentList.clear();
-}
-
-
-void DocumentFactory::slotLoaded(const KUrl& url) {
-	if (d->mModifiedDocumentList.contains(url)) {
-		d->mModifiedDocumentList.removeAll(url);
-		emit modifiedDocumentListChanged();
-		emit documentChanged(url);
-	}
-}
-
-
-void DocumentFactory::slotSaved(const KUrl& oldUrl, const KUrl& newUrl) {
-	bool oldIsNew = oldUrl == newUrl;
-	bool oldUrlWasModified = d->mModifiedDocumentList.removeOne(oldUrl);
-	bool newUrlWasModified = false;
-	if (!oldIsNew) {
-		newUrlWasModified = d->mModifiedDocumentList.removeOne(newUrl);
-		DocumentInfo* info = d->mDocumentMap.take(oldUrl);
-		d->mDocumentMap.insert(newUrl, info);
-	}
-	d->garbageCollect(d->mDocumentMap);
-	if (oldUrlWasModified || newUrlWasModified) {
-		emit modifiedDocumentListChanged();
-	}
-	if (oldUrlWasModified) {
-		emit documentChanged(oldUrl);
-	}
-	if (!oldIsNew) {
-		emit documentChanged(newUrl);
-	}
-}
-
-
-void DocumentFactory::slotModified(const KUrl& url) {
-	if (!d->mModifiedDocumentList.contains(url)) {
-		d->mModifiedDocumentList << url;
-		emit modifiedDocumentListChanged();
-	}
-	emit documentChanged(url);
-}
-
-
-void DocumentFactory::slotBusyChanged(const KUrl& url, bool busy) {
-	emit documentBusyStateChanged(url, busy);
-}
-
-
-QUndoGroup* DocumentFactory::undoGroup() {
-	return &d->mUndoGroup;
-}
-
-
-void DocumentFactory::forget(const KUrl& url) {
-	DocumentInfo* info = d->mDocumentMap.take(url);
-	if (!info) {
-		return;
-	}
-	delete info;
-
-	if (d->mModifiedDocumentList.contains(url)) {
-		d->mModifiedDocumentList.removeAll(url);
-		emit modifiedDocumentListChanged();
-	}
-}
-
+: d(new DocumentFactoryPrivate)
+{
+}
+
+DocumentFactory::~DocumentFactory()
+{
+    qDeleteAll(d->mDocumentMap);
+    delete d;
+}
+
+DocumentFactory* DocumentFactory::instance()
+{
+    static DocumentFactory factory;
+    return &factory;
+}
+
+Document::Ptr DocumentFactory::load(const KUrl& url)
+{
+    DocumentInfo* info = 0;
+
+    DocumentMap::Iterator it = d->mDocumentMap.find(url);
+
+    if (it != d->mDocumentMap.end()) {
+        LOG(url.fileName() << "url in mDocumentMap");
+        info = it.value();
+        info->mLastAccess = QDateTime::currentDateTime();
+        return info->mDocument;
+    }
+
+    // At this point we couldn't find the document in the map
+
+    // Start loading the document
+    LOG(url.fileName() << "loading");
+    Document* doc = new Document(url);
+    connect(doc, SIGNAL(loaded(KUrl)),
+            SLOT(slotLoaded(KUrl)));
+    connect(doc, SIGNAL(saved(KUrl, KUrl)),
+            SLOT(slotSaved(KUrl, KUrl)));
+    connect(doc, SIGNAL(modified(KUrl)),
+            SLOT(slotModified(KUrl)));
+    connect(doc, SIGNAL(busyChanged(KUrl, bool)),
+            SLOT(slotBusyChanged(KUrl, bool)));
+
+    // Create DocumentInfo instance
+    info = new DocumentInfo;
+    Document::Ptr docPtr(doc);
+    info->mDocument = docPtr;
+    info->mLastAccess = QDateTime::currentDateTime();
+
+    // Place DocumentInfo in the map
+    d->mDocumentMap[url] = info;
+
+    d->garbageCollect(d->mDocumentMap);
+
+    return docPtr;
+}
+
+QList<KUrl> DocumentFactory::modifiedDocumentList() const
+{
+    return d->mModifiedDocumentList;
+}
+
+bool DocumentFactory::hasUrl(const KUrl& url) const
+{
+    return d->mDocumentMap.contains(url);
+}
+
+void DocumentFactory::clearCache()
+{
+    qDeleteAll(d->mDocumentMap);
+    d->mDocumentMap.clear();
+    d->mModifiedDocumentList.clear();
+}
+
+void DocumentFactory::slotLoaded(const KUrl& url)
+{
+    if (d->mModifiedDocumentList.contains(url)) {
+        d->mModifiedDocumentList.removeAll(url);
+        emit modifiedDocumentListChanged();
+        emit documentChanged(url);
+    }
+}
+
+void DocumentFactory::slotSaved(const KUrl& oldUrl, const KUrl& newUrl)
+{
+    bool oldIsNew = oldUrl == newUrl;
+    bool oldUrlWasModified = d->mModifiedDocumentList.removeOne(oldUrl);
+    bool newUrlWasModified = false;
+    if (!oldIsNew) {
+        newUrlWasModified = d->mModifiedDocumentList.removeOne(newUrl);
+        DocumentInfo* info = d->mDocumentMap.take(oldUrl);
+        d->mDocumentMap.insert(newUrl, info);
+    }
+    d->garbageCollect(d->mDocumentMap);
+    if (oldUrlWasModified || newUrlWasModified) {
+        emit modifiedDocumentListChanged();
+    }
+    if (oldUrlWasModified) {
+        emit documentChanged(oldUrl);
+    }
+    if (!oldIsNew) {
+        emit documentChanged(newUrl);
+    }
+}
+
+void DocumentFactory::slotModified(const KUrl& url)
+{
+    if (!d->mModifiedDocumentList.contains(url)) {
+        d->mModifiedDocumentList << url;
+        emit modifiedDocumentListChanged();
+    }
+    emit documentChanged(url);
+}
+
+void DocumentFactory::slotBusyChanged(const KUrl& url, bool busy)
+{
+    emit documentBusyStateChanged(url, busy);
+}
+
+QUndoGroup* DocumentFactory::undoGroup()
+{
+    return &d->mUndoGroup;
+}
+
+void DocumentFactory::forget(const KUrl& url)
+{
+    DocumentInfo* info = d->mDocumentMap.take(url);
+    if (!info) {
+        return;
+    }
+    delete info;
+
+    if (d->mModifiedDocumentList.contains(url)) {
+        d->mModifiedDocumentList.removeAll(url);
+        emit modifiedDocumentListChanged();
+    }
+}
 
 } // namespace

=== modified file 'lib/document/documentfactory.h'
--- lib/document/documentfactory.h	2011-07-20 13:46:34 +0000
+++ lib/document/documentfactory.h	2011-12-15 14:17:54 +0000
@@ -29,47 +29,49 @@
 
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct DocumentFactoryPrivate;
 
-class GWENVIEWLIB_EXPORT DocumentFactory : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT DocumentFactory : public QObject
+{
+    Q_OBJECT
 public:
-	static DocumentFactory* instance();
-	~DocumentFactory();
-
-	Document::Ptr load(const KUrl&);
-
-	QList<KUrl> modifiedDocumentList() const;
-
-	bool hasUrl(const KUrl&) const;
-
-	void clearCache();
-
-	QUndoGroup* undoGroup();
-
-	/**
-	 * Do not keep document whose url is @url in cache even if it has been
-	 * modified
-	 */
-	void forget(const KUrl& url);
+    static DocumentFactory* instance();
+    ~DocumentFactory();
+
+    Document::Ptr load(const KUrl&);
+
+    QList<KUrl> modifiedDocumentList() const;
+
+    bool hasUrl(const KUrl&) const;
+
+    void clearCache();
+
+    QUndoGroup* undoGroup();
+
+    /**
+     * Do not keep document whose url is @url in cache even if it has been
+     * modified
+     */
+    void forget(const KUrl& url);
 
 Q_SIGNALS:
-	void modifiedDocumentListChanged();
-	void documentChanged(const KUrl&);
-	void documentBusyStateChanged(const KUrl&, bool);
+    void modifiedDocumentListChanged();
+    void documentChanged(const KUrl&);
+    void documentBusyStateChanged(const KUrl&, bool);
 
 private Q_SLOTS:
-	void slotLoaded(const KUrl&);
-	void slotSaved(const KUrl&, const KUrl&);
-	void slotModified(const KUrl&);
-	void slotBusyChanged(const KUrl&, bool);
+    void slotLoaded(const KUrl&);
+    void slotSaved(const KUrl&, const KUrl&);
+    void slotModified(const KUrl&);
+    void slotBusyChanged(const KUrl&, bool);
 
 private:
-	DocumentFactory();
+    DocumentFactory();
 
-	DocumentFactoryPrivate* const d;
+    DocumentFactoryPrivate* const d;
 };
 
 } // namespace

=== modified file 'lib/document/documentjob.cpp'
--- lib/document/documentjob.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/documentjob.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -34,59 +34,59 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct DocumentJobPrivate {
-	Document::Ptr mDoc;
+    Document::Ptr mDoc;
 };
 
-
 DocumentJob::DocumentJob()
 : KCompositeJob(0)
-, d(new DocumentJobPrivate) {
-	KDialogJobUiDelegate* delegate = new KDialogJobUiDelegate;
-	delegate->setWindow(KApplication::kApplication()->activeWindow());
-	delegate->setAutoErrorHandlingEnabled(true);
-	setUiDelegate(delegate);
-}
-
-
-DocumentJob::~DocumentJob() {
-	delete d;
-}
-
-
-Document::Ptr DocumentJob::document() const {
-	return d->mDoc;
-}
-
-
-void DocumentJob::setDocument(const Document::Ptr& doc) {
-	d->mDoc = doc;
-}
-
-
-void DocumentJob::start() {
-	QMetaObject::invokeMethod(this, "doStart", Qt::QueuedConnection);
-}
-
-
-bool DocumentJob::checkDocumentEditor() {
-	if (!document()->editor()) {
-		setError(NoDocumentEditorError);
-		setErrorText(i18nc("@info", "Gwenview cannot edit this kind of image."));
-		return false;
-	}
-	return true;
-}
-
-
-void ThreadedDocumentJob::doStart() {
-	QFuture<void> future = QtConcurrent::run(this, &ThreadedDocumentJob::threadedStart);
-	QFutureWatcher<void>* watcher = new QFutureWatcher<void>(this);
-	watcher->setFuture(future);
-	connect(watcher, SIGNAL(finished()), SLOT(emitResult()));
+, d(new DocumentJobPrivate)
+{
+    KDialogJobUiDelegate* delegate = new KDialogJobUiDelegate;
+    delegate->setWindow(KApplication::kApplication()->activeWindow());
+    delegate->setAutoErrorHandlingEnabled(true);
+    setUiDelegate(delegate);
+}
+
+DocumentJob::~DocumentJob()
+{
+    delete d;
+}
+
+Document::Ptr DocumentJob::document() const
+{
+    return d->mDoc;
+}
+
+void DocumentJob::setDocument(const Document::Ptr& doc)
+{
+    d->mDoc = doc;
+}
+
+void DocumentJob::start()
+{
+    QMetaObject::invokeMethod(this, "doStart", Qt::QueuedConnection);
+}
+
+bool DocumentJob::checkDocumentEditor()
+{
+    if (!document()->editor()) {
+        setError(NoDocumentEditorError);
+        setErrorText(i18nc("@info", "Gwenview cannot edit this kind of image."));
+        return false;
+    }
+    return true;
+}
+
+void ThreadedDocumentJob::doStart()
+{
+    QFuture<void> future = QtConcurrent::run(this, &ThreadedDocumentJob::threadedStart);
+    QFutureWatcher<void>* watcher = new QFutureWatcher<void>(this);
+    watcher->setFuture(future);
+    connect(watcher, SIGNAL(finished()), SLOT(emitResult()));
 }
 
 } // namespace

=== modified file 'lib/document/documentjob.h'
--- lib/document/documentjob.h	2011-07-20 13:46:34 +0000
+++ lib/document/documentjob.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -31,8 +31,8 @@
 // Local
 #include <lib/document/document.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class DocumentJobPrivate;
 
@@ -47,70 +47,69 @@
  * You can of course use threading inside your task implementation to speed it
  * up.
  */
-class GWENVIEWLIB_EXPORT DocumentJob : public KCompositeJob {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT DocumentJob : public KCompositeJob
+{
+    Q_OBJECT
 public:
-	enum {
-		NoDocumentEditorError = UserDefinedError + 1
-	};
-	DocumentJob();
-	~DocumentJob();
-
-	Document::Ptr document() const;
-
-	virtual void start();
+    enum {
+        NoDocumentEditorError = UserDefinedError + 1
+    };
+    DocumentJob();
+    ~DocumentJob();
+
+    Document::Ptr document() const;
+
+    virtual void start();
 
 protected Q_SLOTS:
-	/**
-	 * Implement this method to provide the task behavior.
-	 * You *must* emit the done() signal when your work is finished, but it
-	 * does not have to be finished when run() returns.
-	 * If you are not emitting it from the GUI thread, then use a queued
-	 * connection to emit it.
-	 */
-	virtual void doStart() = 0;
+    /**
+     * Implement this method to provide the task behavior.
+     * You *must* emit the done() signal when your work is finished, but it
+     * does not have to be finished when run() returns.
+     * If you are not emitting it from the GUI thread, then use a queued
+     * connection to emit it.
+     */
+    virtual void doStart() = 0;
 
-	/**
-	 * slot-ification of emitResult()
-	 */
-	void emitResult() {
-		KJob::emitResult();
-	}
+    /**
+     * slot-ification of emitResult()
+     */
+    void emitResult() {
+        KJob::emitResult();
+    }
 
 protected:
-	/**
-	 * Convenience method which checks document()->editor() is valid
-	 * and set the job error properties if it's not.
-	 * @return true if the editor is valid.
-	 */
-	bool checkDocumentEditor();
+    /**
+     * Convenience method which checks document()->editor() is valid
+     * and set the job error properties if it's not.
+     * @return true if the editor is valid.
+     */
+    bool checkDocumentEditor();
 
 private:
-	void setDocument(const Document::Ptr&);
-
-	DocumentJobPrivate* const d;
-
-	friend class Document;
+    void setDocument(const Document::Ptr&);
+
+    DocumentJobPrivate* const d;
+
+    friend class Document;
 };
 
-
 /**
  * A document job whose action is started in a separate thread
  */
-class ThreadedDocumentJob : public DocumentJob {
+class ThreadedDocumentJob : public DocumentJob
+{
 public:
-	/**
-	 * Must be reimplemented to apply the action to the document.
-	 * This method is never called from the GUI thread.
-	 */
-	virtual void threadedStart() = 0;
+    /**
+     * Must be reimplemented to apply the action to the document.
+     * This method is never called from the GUI thread.
+     */
+    virtual void threadedStart() = 0;
 
 protected:
-	virtual void doStart();
+    virtual void doStart();
 };
 
-
-
 } // namespace
 
 #endif /* DOCUMENTJOB_H */

=== modified file 'lib/document/documentloadedimpl.cpp'
--- lib/document/documentloadedimpl.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/documentloadedimpl.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -37,88 +37,87 @@
 #include "imageutils.h"
 #include "savejob.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct DocumentLoadedImplPrivate {
-	QByteArray mRawData;
-	bool mQuietInit;
+    QByteArray mRawData;
+    bool mQuietInit;
 };
 
-
 DocumentLoadedImpl::DocumentLoadedImpl(Document* document, const QByteArray& rawData, bool quietInit)
 : AbstractDocumentImpl(document)
-, d(new DocumentLoadedImplPrivate) {
-	if (document->keepRawData()) {
-		d->mRawData = rawData;
-	}
-	d->mQuietInit = quietInit;
-}
-
-
-DocumentLoadedImpl::~DocumentLoadedImpl() {
-	delete d;
-}
-
-
-void DocumentLoadedImpl::init() {
-	if (!d->mQuietInit) {
-		emit imageRectUpdated(document()->image().rect());
-		emit loaded();
-	}
-}
-
-
-bool DocumentLoadedImpl::isEditable() const {
-	return true;
-}
-
-
-Document::LoadingState DocumentLoadedImpl::loadingState() const {
-	return Document::Loaded;
-}
-
-
-bool DocumentLoadedImpl::saveInternal(QIODevice* device, const QByteArray& format) {
-	QImageWriter writer(device, format);
-	bool ok = writer.write(document()->image());
-	if (ok) {
-		setDocumentFormat(format);
-	} else {
-		setDocumentErrorString(writer.errorString());
-	}
-	return ok;
-}
-
-
-DocumentJob* DocumentLoadedImpl::save(const KUrl& url, const QByteArray& format) {
-	return new SaveJob(this, url, format);
-}
-
-
-AbstractDocumentEditor* DocumentLoadedImpl::editor() {
-	return this;
-}
-
-
-void DocumentLoadedImpl::setImage(const QImage& image) {
-	setDocumentImage(image);
-	imageRectUpdated(image.rect());
-}
-
-
-void DocumentLoadedImpl::applyTransformation(Orientation orientation) {
-	QImage image = document()->image();
-	QMatrix matrix = ImageUtils::transformMatrix(orientation);
-	image = image.transformed(matrix);
-	setDocumentImage(image);
-	imageRectUpdated(image.rect());
-}
-
-
-QByteArray DocumentLoadedImpl::rawData() const {
-	return d->mRawData;
-}
-
+, d(new DocumentLoadedImplPrivate)
+{
+    if (document->keepRawData()) {
+        d->mRawData = rawData;
+    }
+    d->mQuietInit = quietInit;
+}
+
+DocumentLoadedImpl::~DocumentLoadedImpl()
+{
+    delete d;
+}
+
+void DocumentLoadedImpl::init()
+{
+    if (!d->mQuietInit) {
+        emit imageRectUpdated(document()->image().rect());
+        emit loaded();
+    }
+}
+
+bool DocumentLoadedImpl::isEditable() const
+{
+    return true;
+}
+
+Document::LoadingState DocumentLoadedImpl::loadingState() const
+{
+    return Document::Loaded;
+}
+
+bool DocumentLoadedImpl::saveInternal(QIODevice* device, const QByteArray& format)
+{
+    QImageWriter writer(device, format);
+    bool ok = writer.write(document()->image());
+    if (ok) {
+        setDocumentFormat(format);
+    } else {
+        setDocumentErrorString(writer.errorString());
+    }
+    return ok;
+}
+
+DocumentJob* DocumentLoadedImpl::save(const KUrl& url, const QByteArray& format)
+{
+    return new SaveJob(this, url, format);
+}
+
+AbstractDocumentEditor* DocumentLoadedImpl::editor()
+{
+    return this;
+}
+
+void DocumentLoadedImpl::setImage(const QImage& image)
+{
+    setDocumentImage(image);
+    imageRectUpdated(image.rect());
+}
+
+void DocumentLoadedImpl::applyTransformation(Orientation orientation)
+{
+    QImage image = document()->image();
+    QMatrix matrix = ImageUtils::transformMatrix(orientation);
+    image = image.transformed(matrix);
+    setDocumentImage(image);
+    imageRectUpdated(image.rect());
+}
+
+QByteArray DocumentLoadedImpl::rawData() const
+{
+    return d->mRawData;
+}
 
 } // namespace

=== modified file 'lib/document/documentloadedimpl.h'
--- lib/document/documentloadedimpl.h	2011-07-20 13:46:34 +0000
+++ lib/document/documentloadedimpl.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -34,42 +34,43 @@
 
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct DocumentLoadedImplPrivate;
-class DocumentLoadedImpl : public AbstractDocumentImpl, protected AbstractDocumentEditor {
-	Q_OBJECT
+class DocumentLoadedImpl : public AbstractDocumentImpl, protected AbstractDocumentEditor
+{
+    Q_OBJECT
 public:
-	/**
-	 * @param quietInit set to true if init() should not emit any signal
-	 */
-	DocumentLoadedImpl(Document*, const QByteArray&, bool quietInit = false);
-	~DocumentLoadedImpl();
+    /**
+     * @param quietInit set to true if init() should not emit any signal
+     */
+    DocumentLoadedImpl(Document*, const QByteArray&, bool quietInit = false);
+    ~DocumentLoadedImpl();
 
-	// AbstractDocumentImpl
-	virtual void init();
-	virtual Document::LoadingState loadingState() const;
-	virtual DocumentJob* save(const KUrl&, const QByteArray& format);
-	virtual AbstractDocumentEditor* editor();
-	virtual QByteArray rawData() const;
-	virtual bool isEditable() const;
-	//
+    // AbstractDocumentImpl
+    virtual void init();
+    virtual Document::LoadingState loadingState() const;
+    virtual DocumentJob* save(const KUrl&, const QByteArray& format);
+    virtual AbstractDocumentEditor* editor();
+    virtual QByteArray rawData() const;
+    virtual bool isEditable() const;
+    //
 
 protected:
-	virtual bool saveInternal(QIODevice* device, const QByteArray& format);
+    virtual bool saveInternal(QIODevice* device, const QByteArray& format);
 
-	// AbstractDocumentEditor
-	virtual void setImage(const QImage&);
-	virtual void applyTransformation(Orientation orientation);
-	//
+    // AbstractDocumentEditor
+    virtual void setImage(const QImage&);
+    virtual void applyTransformation(Orientation orientation);
+    //
 
 private:
-	DocumentLoadedImplPrivate* const d;
+    DocumentLoadedImplPrivate* const d;
 
-	friend class SaveJob;
+    friend class SaveJob;
 };
 
-
 } // namespace
 
 #endif /* DOCUMENTLOADEDIMPL_H */

=== modified file 'lib/document/emptydocumentimpl.cpp'
--- lib/document/emptydocumentimpl.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/emptydocumentimpl.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -27,24 +27,23 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 EmptyDocumentImpl::EmptyDocumentImpl(Document* document)
 : AbstractDocumentImpl(document)
 {}
 
-
 EmptyDocumentImpl::~EmptyDocumentImpl()
 {}
 
-
-void EmptyDocumentImpl::init() {
-}
-
-
-Document::LoadingState EmptyDocumentImpl::loadingState() const {
-	return Document::LoadingFailed;
-}
-
+void EmptyDocumentImpl::init()
+{
+}
+
+Document::LoadingState EmptyDocumentImpl::loadingState() const
+{
+    return Document::LoadingFailed;
+}
 
 } // namespace

=== modified file 'lib/document/emptydocumentimpl.h'
--- lib/document/emptydocumentimpl.h	2011-07-20 13:46:34 +0000
+++ lib/document/emptydocumentimpl.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -28,18 +28,19 @@
 // Local
 #include <lib/document/abstractdocumentimpl.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-class EmptyDocumentImpl : public AbstractDocumentImpl {
+class EmptyDocumentImpl : public AbstractDocumentImpl
+{
 public:
-	EmptyDocumentImpl(Document*);
-	~EmptyDocumentImpl();
+    EmptyDocumentImpl(Document*);
+    ~EmptyDocumentImpl();
 
-	virtual void init();
-	virtual Document::LoadingState loadingState() const;
+    virtual void init();
+    virtual Document::LoadingState loadingState() const;
 };
 
-
 } // namespace
 
 #endif /* EMPTYDOCUMENTIMPL_H */

=== modified file 'lib/document/jpegdocumentloadedimpl.cpp'
--- lib/document/jpegdocumentloadedimpl.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/jpegdocumentloadedimpl.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -30,62 +30,61 @@
 // Local
 #include "jpegcontent.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct JpegDocumentLoadedImplPrivate {
-	JpegContent* mJpegContent;
+    JpegContent* mJpegContent;
 };
 
-
 JpegDocumentLoadedImpl::JpegDocumentLoadedImpl(Document* doc, JpegContent* jpegContent)
 : DocumentLoadedImpl(doc, QByteArray() /* rawData */)
-, d(new JpegDocumentLoadedImplPrivate) {
-	Q_ASSERT(jpegContent);
-	d->mJpegContent = jpegContent;
-}
-
-
-JpegDocumentLoadedImpl::~JpegDocumentLoadedImpl() {
-	delete d->mJpegContent;
-	delete d;
-}
-
-
-bool JpegDocumentLoadedImpl::saveInternal(QIODevice* device, const QByteArray& format) {
-	if (format == "jpeg") {
-		d->mJpegContent->resetOrientation();
-		if (!d->mJpegContent->thumbnail().isNull()) {
-			QImage thumbnail = document()->image().scaled(128, 128, Qt::KeepAspectRatio);
-			d->mJpegContent->setThumbnail(thumbnail);
-		}
-
-		bool ok = d->mJpegContent->save(device);
-		if (!ok) {
-			setDocumentErrorString(d->mJpegContent->errorString());
-		}
-		return ok;
-	} else {
-		return DocumentLoadedImpl::saveInternal(device, format);
-	}
-}
-
-
-void JpegDocumentLoadedImpl::setImage(const QImage& image) {
-	d->mJpegContent->setImage(image);
-	DocumentLoadedImpl::setImage(image);
-}
-
-
-void JpegDocumentLoadedImpl::applyTransformation(Orientation orientation) {
-	DocumentLoadedImpl::applyTransformation(orientation);
-	d->mJpegContent->transform(orientation);
-}
-
-
-QByteArray JpegDocumentLoadedImpl::rawData() const {
-	return d->mJpegContent->rawData();
-}
-
+, d(new JpegDocumentLoadedImplPrivate)
+{
+    Q_ASSERT(jpegContent);
+    d->mJpegContent = jpegContent;
+}
+
+JpegDocumentLoadedImpl::~JpegDocumentLoadedImpl()
+{
+    delete d->mJpegContent;
+    delete d;
+}
+
+bool JpegDocumentLoadedImpl::saveInternal(QIODevice* device, const QByteArray& format)
+{
+    if (format == "jpeg") {
+        d->mJpegContent->resetOrientation();
+        if (!d->mJpegContent->thumbnail().isNull()) {
+            QImage thumbnail = document()->image().scaled(128, 128, Qt::KeepAspectRatio);
+            d->mJpegContent->setThumbnail(thumbnail);
+        }
+
+        bool ok = d->mJpegContent->save(device);
+        if (!ok) {
+            setDocumentErrorString(d->mJpegContent->errorString());
+        }
+        return ok;
+    } else {
+        return DocumentLoadedImpl::saveInternal(device, format);
+    }
+}
+
+void JpegDocumentLoadedImpl::setImage(const QImage& image)
+{
+    d->mJpegContent->setImage(image);
+    DocumentLoadedImpl::setImage(image);
+}
+
+void JpegDocumentLoadedImpl::applyTransformation(Orientation orientation)
+{
+    DocumentLoadedImpl::applyTransformation(orientation);
+    d->mJpegContent->transform(orientation);
+}
+
+QByteArray JpegDocumentLoadedImpl::rawData() const
+{
+    return d->mJpegContent->rawData();
+}
 
 } // namespace

=== modified file 'lib/document/jpegdocumentloadedimpl.h'
--- lib/document/jpegdocumentloadedimpl.h	2011-07-20 13:46:34 +0000
+++ lib/document/jpegdocumentloadedimpl.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -30,31 +30,32 @@
 
 class QByteArray;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class JpegContent;
 
 struct JpegDocumentLoadedImplPrivate;
-class JpegDocumentLoadedImpl : public DocumentLoadedImpl {
-	Q_OBJECT
+class JpegDocumentLoadedImpl : public DocumentLoadedImpl
+{
+    Q_OBJECT
 public:
-	JpegDocumentLoadedImpl(Document*, JpegContent*);
-	~JpegDocumentLoadedImpl();
-	virtual QByteArray rawData() const;
+    JpegDocumentLoadedImpl(Document*, JpegContent*);
+    ~JpegDocumentLoadedImpl();
+    virtual QByteArray rawData() const;
 
 protected:
-	virtual bool saveInternal(QIODevice* device, const QByteArray& format);
+    virtual bool saveInternal(QIODevice* device, const QByteArray& format);
 
-	// AbstractDocumentEditor
-	virtual void setImage(const QImage&);
-	virtual void applyTransformation(Orientation orientation);
-	//
+    // AbstractDocumentEditor
+    virtual void setImage(const QImage&);
+    virtual void applyTransformation(Orientation orientation);
+    //
 
 private:
-	JpegDocumentLoadedImplPrivate* const d;
+    JpegDocumentLoadedImplPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* JPEGDOCUMENTLOADEDIMPL_H */

=== modified file 'lib/document/loadingdocumentimpl.cpp'
--- lib/document/loadingdocumentimpl.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/loadingdocumentimpl.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -58,7 +58,8 @@
 #include "urlutils.h"
 #include "videodocumentloadedimpl.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -72,388 +73,390 @@
 const int HEADER_SIZE = 256;
 
 struct LoadingDocumentImplPrivate {
-	LoadingDocumentImpl* mImpl;
-	QPointer<KIO::TransferJob> mTransferJob;
-	QFuture<bool> mMetaInfoFuture;
-	QFutureWatcher<bool> mMetaInfoFutureWatcher;
-	QFuture<void> mImageDataFuture;
-	QFutureWatcher<void> mImageDataFutureWatcher;
-
-	// If != 0, this means we need to load an image at zoom =
-	// 1/mImageDataInvertedZoom
-	int mImageDataInvertedZoom;
-
-	bool mMetaInfoLoaded;
-	bool mAnimated;
-	bool mDownSampledImageLoaded;
-	QByteArray mData;
-	QByteArray mFormat;
-	QSize mImageSize;
-	Exiv2::Image::AutoPtr mExiv2Image;
-	std::auto_ptr<JpegContent> mJpegContent;
-	QImage mImage;
-
-
-	/**
-	 * Determine kind of document and switch to an implementation if it is not
-	 * necessary to download more data.
-	 * @return true if switched to another implementation.
-	 */
-	bool determineKind() {
-		QString mimeType;
-		const KUrl& url = mImpl->document()->url();
-		if (KProtocolInfo::determineMimetypeFromExtension(url.protocol())) {
-			mimeType = KMimeType::findByNameAndContent(url.fileName(), mData)->name();
-		} else {
-			mimeType = KMimeType::findByContent(mData)->name();
-		}
-		MimeTypeUtils::Kind kind = MimeTypeUtils::mimeTypeKind(mimeType);
-		LOG("mimeType:" << mimeType);
-		LOG("kind:" << kind);
-		mImpl->setDocumentKind(kind);
-
-		switch (kind) {
-		case MimeTypeUtils::KIND_RASTER_IMAGE:
-		case MimeTypeUtils::KIND_SVG_IMAGE:
-			return false;
-
-		case MimeTypeUtils::KIND_VIDEO:
-			mImpl->switchToImpl(new VideoDocumentLoadedImpl(mImpl->document()));
-			return true;
-
-		default:
-			mImpl->setDocumentErrorString(
-				i18nc("@info", "Gwenview cannot display documents of type %1.", mimeType)
-				);
-			emit mImpl->loadingFailed();
-			mImpl->switchToImpl(new EmptyDocumentImpl(mImpl->document()));
-			return true;
-		}
-	}
-
-
-	void startLoading() {
-		Q_ASSERT(!mMetaInfoLoaded);
-
-		switch (mImpl->document()->kind()) {
-		case MimeTypeUtils::KIND_RASTER_IMAGE:
-			mMetaInfoFuture = QtConcurrent::run(this, &LoadingDocumentImplPrivate::loadMetaInfo);
-			mMetaInfoFutureWatcher.setFuture(mMetaInfoFuture);
-			break;
-
-		case MimeTypeUtils::KIND_SVG_IMAGE:
-			mImpl->switchToImpl(new SvgDocumentLoadedImpl(mImpl->document(), mData));
-			break;
-
-		case MimeTypeUtils::KIND_VIDEO:
-			break;
-
-		default:
-			kWarning() << "We should not reach this point!";
-			break;
-		}
-	}
-
-	void startImageDataLoading() {
-		LOG("");
-		Q_ASSERT(mMetaInfoLoaded);
-		Q_ASSERT(mImageDataInvertedZoom != 0);
-		Q_ASSERT(!mImageDataFuture.isRunning());
-		mImageDataFuture = QtConcurrent::run(this, &LoadingDocumentImplPrivate::loadImageData);
-		mImageDataFutureWatcher.setFuture(mImageDataFuture);
-	}
-
-	bool loadMetaInfo() {
-		QBuffer buffer;
-		buffer.setBuffer(&mData);
-		buffer.open(QIODevice::ReadOnly);
-		QImageReader reader(&buffer);
-		mFormat = reader.format();
-		if (mFormat.isEmpty()) {
-			return false;
-		}
-
-		Exiv2ImageLoader loader;
-		if (loader.load(mData)) {
-			mExiv2Image = loader.popImage();
-		}
-
-		if (mFormat == "jpeg" && mExiv2Image.get()) {
-			mJpegContent.reset(new JpegContent());
-			if (!mJpegContent->loadFromData(mData, mExiv2Image.get())) {
-				return false;
-			}
-
-			// Use the size from JpegContent, as its correctly transposed if the
-			// image has been rotated
-			mImageSize = mJpegContent->size();
-		} else {
-			mImageSize = reader.size();
-		}
-		LOG("mImageSize" << mImageSize);
-
-		return true;
-	}
-
-	void loadImageData() {
-		QBuffer buffer;
-		buffer.setBuffer(&mData);
-		buffer.open(QIODevice::ReadOnly);
-		QImageReader reader(&buffer);
-
-		LOG("mImageDataInvertedZoom=" << mImageDataInvertedZoom);
-		if (mImageSize.isValid()
-			&& mImageDataInvertedZoom != 1
-			&& reader.supportsOption(QImageIOHandler::ScaledSize)
-			)
-		{
-			// Do not use mImageSize here: QImageReader needs a non-transposed
-			// image size
-			QSize size = reader.size() / mImageDataInvertedZoom;
-			if (!size.isEmpty()) {
-				LOG("Setting scaled size to" << size);
-				reader.setScaledSize(size);
-			} else {
-				LOG("Not setting scaled size as it is empty" << size);
-			}
-		}
-
-		bool ok = reader.read(&mImage);
-		if (!ok) {
-			LOG("QImageReader::read() failed");
-			return;
-		}
-
-		if (mJpegContent.get()) {
-			Gwenview::Orientation orientation = mJpegContent->orientation();
-			QMatrix matrix = ImageUtils::transformMatrix(orientation);
-			mImage = mImage.transformed(matrix);
-		}
-
-		if (reader.supportsAnimation()
-			&& reader.nextImageDelay() > 0 // Assume delay == 0 <=> only one frame
-		) {
-			/*
-			 * QImageReader is not really helpful to detect animated gif:
-			 * - QImageReader::imageCount() returns 0
-			 * - QImageReader::nextImageDelay() may return something > 0 if the
-			 *   image consists of only one frame but includes a "Graphic
-			 *   Control Extension" (usually only present if we have an
-			 *   animation) (Bug #185523)
-			 *
-			 * Decoding the next frame is the only reliable way I found to
-			 * detect an animated gif
-			 */
-			LOG("May be an animated image. delay:" << reader.nextImageDelay());
-			QImage nextImage;
-			if (reader.read(&nextImage)) {
-				LOG("Really an animated image (more than one frame)");
-				mAnimated = true;
-			} else {
-				kWarning() << mImpl->document()->url() << "is not really an animated image (only one frame)";
-			}
-		}
-	}
+    LoadingDocumentImpl* q;
+    QPointer<KIO::TransferJob> mTransferJob;
+    QFuture<bool> mMetaInfoFuture;
+    QFutureWatcher<bool> mMetaInfoFutureWatcher;
+    QFuture<void> mImageDataFuture;
+    QFutureWatcher<void> mImageDataFutureWatcher;
+
+    // If != 0, this means we need to load an image at zoom =
+    // 1/mImageDataInvertedZoom
+    int mImageDataInvertedZoom;
+
+    bool mMetaInfoLoaded;
+    bool mAnimated;
+    bool mDownSampledImageLoaded;
+    QByteArray mData;
+    QByteArray mFormat;
+    QSize mImageSize;
+    Exiv2::Image::AutoPtr mExiv2Image;
+    std::auto_ptr<JpegContent> mJpegContent;
+    QImage mImage;
+
+    /**
+     * Determine kind of document and switch to an implementation if it is not
+     * necessary to download more data.
+     * @return true if switched to another implementation.
+     */
+    bool determineKind()
+    {
+        QString mimeType;
+        const KUrl& url = q->document()->url();
+        if (KProtocolInfo::determineMimetypeFromExtension(url.protocol())) {
+            mimeType = KMimeType::findByNameAndContent(url.fileName(), mData)->name();
+        } else {
+            mimeType = KMimeType::findByContent(mData)->name();
+        }
+        MimeTypeUtils::Kind kind = MimeTypeUtils::mimeTypeKind(mimeType);
+        LOG("mimeType:" << mimeType);
+        LOG("kind:" << kind);
+        q->setDocumentKind(kind);
+
+        switch (kind) {
+        case MimeTypeUtils::KIND_RASTER_IMAGE:
+        case MimeTypeUtils::KIND_SVG_IMAGE:
+            return false;
+
+        case MimeTypeUtils::KIND_VIDEO:
+            q->switchToImpl(new VideoDocumentLoadedImpl(q->document()));
+            return true;
+
+        default:
+            q->setDocumentErrorString(
+                i18nc("@info", "Gwenview cannot display documents of type %1.", mimeType)
+            );
+            emit q->loadingFailed();
+            q->switchToImpl(new EmptyDocumentImpl(q->document()));
+            return true;
+        }
+    }
+
+    void startLoading()
+    {
+        Q_ASSERT(!mMetaInfoLoaded);
+
+        switch (q->document()->kind()) {
+        case MimeTypeUtils::KIND_RASTER_IMAGE:
+            mMetaInfoFuture = QtConcurrent::run(this, &LoadingDocumentImplPrivate::loadMetaInfo);
+            mMetaInfoFutureWatcher.setFuture(mMetaInfoFuture);
+            break;
+
+        case MimeTypeUtils::KIND_SVG_IMAGE:
+            q->switchToImpl(new SvgDocumentLoadedImpl(q->document(), mData));
+            break;
+
+        case MimeTypeUtils::KIND_VIDEO:
+            break;
+
+        default:
+            kWarning() << "We should not reach this point!";
+            break;
+        }
+    }
+
+    void startImageDataLoading()
+    {
+        LOG("");
+        Q_ASSERT(mMetaInfoLoaded);
+        Q_ASSERT(mImageDataInvertedZoom != 0);
+        Q_ASSERT(!mImageDataFuture.isRunning());
+        mImageDataFuture = QtConcurrent::run(this, &LoadingDocumentImplPrivate::loadImageData);
+        mImageDataFutureWatcher.setFuture(mImageDataFuture);
+    }
+
+    bool loadMetaInfo()
+    {
+        QBuffer buffer;
+        buffer.setBuffer(&mData);
+        buffer.open(QIODevice::ReadOnly);
+        QImageReader reader(&buffer);
+        mFormat = reader.format();
+        if (mFormat.isEmpty()) {
+            return false;
+        }
+
+        Exiv2ImageLoader loader;
+        if (loader.load(mData)) {
+            mExiv2Image = loader.popImage();
+        }
+
+        if (mFormat == "jpeg" && mExiv2Image.get()) {
+            mJpegContent.reset(new JpegContent());
+            if (!mJpegContent->loadFromData(mData, mExiv2Image.get())) {
+                return false;
+            }
+
+            // Use the size from JpegContent, as its correctly transposed if the
+            // image has been rotated
+            mImageSize = mJpegContent->size();
+        } else {
+            mImageSize = reader.size();
+        }
+        LOG("mImageSize" << mImageSize);
+
+        return true;
+    }
+
+    void loadImageData()
+    {
+        QBuffer buffer;
+        buffer.setBuffer(&mData);
+        buffer.open(QIODevice::ReadOnly);
+        QImageReader reader(&buffer);
+
+        LOG("mImageDataInvertedZoom=" << mImageDataInvertedZoom);
+        if (mImageSize.isValid()
+                && mImageDataInvertedZoom != 1
+                && reader.supportsOption(QImageIOHandler::ScaledSize)
+           ) {
+            // Do not use mImageSize here: QImageReader needs a non-transposed
+            // image size
+            QSize size = reader.size() / mImageDataInvertedZoom;
+            if (!size.isEmpty()) {
+                LOG("Setting scaled size to" << size);
+                reader.setScaledSize(size);
+            } else {
+                LOG("Not setting scaled size as it is empty" << size);
+            }
+        }
+
+        bool ok = reader.read(&mImage);
+        if (!ok) {
+            LOG("QImageReader::read() failed");
+            return;
+        }
+
+        if (mJpegContent.get()) {
+            Gwenview::Orientation orientation = mJpegContent->orientation();
+            QMatrix matrix = ImageUtils::transformMatrix(orientation);
+            mImage = mImage.transformed(matrix);
+        }
+
+        if (reader.supportsAnimation()
+                && reader.nextImageDelay() > 0 // Assume delay == 0 <=> only one frame
+           ) {
+            /*
+             * QImageReader is not really helpful to detect animated gif:
+             * - QImageReader::imageCount() returns 0
+             * - QImageReader::nextImageDelay() may return something > 0 if the
+             *   image consists of only one frame but includes a "Graphic
+             *   Control Extension" (usually only present if we have an
+             *   animation) (Bug #185523)
+             *
+             * Decoding the next frame is the only reliable way I found to
+             * detect an animated gif
+             */
+            LOG("May be an animated image. delay:" << reader.nextImageDelay());
+            QImage nextImage;
+            if (reader.read(&nextImage)) {
+                LOG("Really an animated image (more than one frame)");
+                mAnimated = true;
+            } else {
+                kWarning() << q->document()->url() << "is not really an animated image (only one frame)";
+            }
+        }
+    }
 };
 
-
 LoadingDocumentImpl::LoadingDocumentImpl(Document* document)
 : AbstractDocumentImpl(document)
-, d(new LoadingDocumentImplPrivate) {
-	d->mImpl = this;
-	d->mMetaInfoLoaded = false;
-	d->mAnimated = false;
-	d->mDownSampledImageLoaded = false;
-	d->mImageDataInvertedZoom = 0;
-
-	connect(&d->mMetaInfoFutureWatcher, SIGNAL(finished()),
-		SLOT(slotMetaInfoLoaded()) );
-
-	connect(&d->mImageDataFutureWatcher, SIGNAL(finished()),
-		SLOT(slotImageLoaded()) );
-}
-
-
-LoadingDocumentImpl::~LoadingDocumentImpl() {
-	LOG("");
-	// Disconnect watchers to make sure they do not trigger further work
-	d->mMetaInfoFutureWatcher.disconnect();
-	d->mImageDataFutureWatcher.disconnect();
-
-	d->mMetaInfoFutureWatcher.waitForFinished();
-	d->mImageDataFutureWatcher.waitForFinished();
-
-	if (d->mTransferJob) {
-		d->mTransferJob->kill();
-	}
-	delete d;
-}
-
-void LoadingDocumentImpl::init() {
-	KUrl url = document()->url();
-
-	if (UrlUtils::urlIsFastLocalFile(url)) {
-		// Load file content directly
-		QFile file(url.toLocalFile());
-		if (!file.open(QIODevice::ReadOnly)) {
-			setDocumentErrorString(i18nc("@info", "Could not open file %1", url.toLocalFile()));
-			emit loadingFailed();
-			switchToImpl(new EmptyDocumentImpl(document()));
-			return;
-		}
-		d->mData = file.read(HEADER_SIZE);
-		if (d->determineKind()) {
-			return;
-		}
-		d->mData += file.readAll();
-		d->startLoading();
-	} else {
-		// Transfer file via KIO
-		d->mTransferJob = KIO::get(document()->url());
-		connect(d->mTransferJob, SIGNAL(data(KIO::Job*, const QByteArray&)),
-			SLOT(slotDataReceived(KIO::Job*, const QByteArray&)) );
-		connect(d->mTransferJob, SIGNAL(result(KJob*)),
-			SLOT(slotTransferFinished(KJob*)) );
-		d->mTransferJob->start();
-	}
-}
-
-
-void LoadingDocumentImpl::loadImage(int invertedZoom) {
-	if (d->mImageDataInvertedZoom == invertedZoom) {
-		LOG("Already loading an image at invertedZoom=" << invertedZoom);
-		return;
-	}
-	if (d->mImageDataInvertedZoom == 1) {
-		LOG("Ignoring request: we are loading a full image");
-		return;
-	}
-	d->mImageDataFutureWatcher.waitForFinished();
-	d->mImageDataInvertedZoom = invertedZoom;
-
-	if (d->mMetaInfoLoaded) {
-		// Do not test on mMetaInfoFuture.isRunning() here: it might not have
-		// started if we are downloading the image from a remote url
-		d->startImageDataLoading();
-	}
-}
-
-
-void LoadingDocumentImpl::slotDataReceived(KIO::Job* job, const QByteArray& chunk) {
-	d->mData.append(chunk);
-	if (document()->kind() == MimeTypeUtils::KIND_UNKNOWN && d->mData.length() >= HEADER_SIZE) {
-		if (d->determineKind()) {
-			job->kill();
-			return;
-		}
-	}
-}
-
-
-void LoadingDocumentImpl::slotTransferFinished(KJob* job) {
-	if (job->error()) {
-		setDocumentErrorString(job->errorString());
-		emit loadingFailed();
-		switchToImpl(new EmptyDocumentImpl(document()));
-		return;
-	}
-	d->startLoading();
-}
-
-
-bool LoadingDocumentImpl::isEditable() const {
-	return d->mDownSampledImageLoaded;
-}
-
-
-Document::LoadingState LoadingDocumentImpl::loadingState() const {
-	if (!document()->image().isNull()) {
-		return Document::Loaded;
-	} else if (d->mMetaInfoLoaded) {
-		return Document::MetaInfoLoaded;
-	} else if (document()->kind() != MimeTypeUtils::KIND_UNKNOWN) {
-		return Document::KindDetermined;
-	} else {
-		return Document::Loading;
-	}
-}
-
-
-void LoadingDocumentImpl::slotMetaInfoLoaded() {
-	LOG("");
-	Q_ASSERT(!d->mMetaInfoFuture.isRunning());
-	if (!d->mMetaInfoFuture.result()) {
-		setDocumentErrorString(
-			i18nc("@info", "Loading meta information failed.")
-			);
-		emit loadingFailed();
-		switchToImpl(new EmptyDocumentImpl(document()));
-		return;
-	}
-
-	setDocumentFormat(d->mFormat);
-	setDocumentImageSize(d->mImageSize);
-	setDocumentExiv2Image(d->mExiv2Image);
-
-	d->mMetaInfoLoaded = true;
-	emit metaInfoLoaded();
-
-	// Start image loading if necessary
-	// We test if mImageDataFuture is not already running because code connected to
-	// metaInfoLoaded() signal could have called loadImage()
-	if (!d->mImageDataFuture.isRunning() && d->mImageDataInvertedZoom != 0) {
-		d->startImageDataLoading();
-	}
-}
-
-
-void LoadingDocumentImpl::slotImageLoaded() {
-	LOG("");
-	if (d->mImage.isNull()) {
-		setDocumentErrorString(
-			i18nc("@info", "Loading image failed.")
-			);
-		emit loadingFailed();
-		switchToImpl(new EmptyDocumentImpl(document()));
-		return;
-	}
-
-	if (d->mAnimated) {
-		if (d->mImage.size() == d->mImageSize) {
-			// We already decoded the first frame at the right size, let's show
-			// it
-			setDocumentImage(d->mImage);
-		}
-
-		switchToImpl(new AnimatedDocumentLoadedImpl(
-			document(),
-			d->mData));
-
-		return;
-	}
-
-	if (d->mImageDataInvertedZoom != 1 && d->mImage.size() != d->mImageSize) {
-		LOG("Loaded a down sampled image");
-		d->mDownSampledImageLoaded = true;
-		// We loaded a down sampled image
-		setDocumentDownSampledImage(d->mImage, d->mImageDataInvertedZoom);
-		return;
-	}
-
-	LOG("Loaded a full image");
-	setDocumentImage(d->mImage);
-	DocumentLoadedImpl* impl;
-	if (d->mJpegContent.get()) {
-		impl = new JpegDocumentLoadedImpl(
-			document(),
-			d->mJpegContent.release());
-	} else {
-		impl = new DocumentLoadedImpl(
-			document(),
-			d->mData);
-	}
-	switchToImpl(impl);
-}
-
+, d(new LoadingDocumentImplPrivate)
+{
+    d->q = this;
+    d->mMetaInfoLoaded = false;
+    d->mAnimated = false;
+    d->mDownSampledImageLoaded = false;
+    d->mImageDataInvertedZoom = 0;
+
+    connect(&d->mMetaInfoFutureWatcher, SIGNAL(finished()),
+            SLOT(slotMetaInfoLoaded()));
+
+    connect(&d->mImageDataFutureWatcher, SIGNAL(finished()),
+            SLOT(slotImageLoaded()));
+}
+
+LoadingDocumentImpl::~LoadingDocumentImpl()
+{
+    LOG("");
+    // Disconnect watchers to make sure they do not trigger further work
+    d->mMetaInfoFutureWatcher.disconnect();
+    d->mImageDataFutureWatcher.disconnect();
+
+    d->mMetaInfoFutureWatcher.waitForFinished();
+    d->mImageDataFutureWatcher.waitForFinished();
+
+    if (d->mTransferJob) {
+        d->mTransferJob->kill();
+    }
+    delete d;
+}
+
+void LoadingDocumentImpl::init()
+{
+    KUrl url = document()->url();
+
+    if (UrlUtils::urlIsFastLocalFile(url)) {
+        // Load file content directly
+        QFile file(url.toLocalFile());
+        if (!file.open(QIODevice::ReadOnly)) {
+            setDocumentErrorString(i18nc("@info", "Could not open file %1", url.toLocalFile()));
+            emit loadingFailed();
+            switchToImpl(new EmptyDocumentImpl(document()));
+            return;
+        }
+        d->mData = file.read(HEADER_SIZE);
+        if (d->determineKind()) {
+            return;
+        }
+        d->mData += file.readAll();
+        d->startLoading();
+    } else {
+        // Transfer file via KIO
+        d->mTransferJob = KIO::get(document()->url());
+        connect(d->mTransferJob, SIGNAL(data(KIO::Job*, QByteArray)),
+                SLOT(slotDataReceived(KIO::Job*, QByteArray)));
+        connect(d->mTransferJob, SIGNAL(result(KJob*)),
+                SLOT(slotTransferFinished(KJob*)));
+        d->mTransferJob->start();
+    }
+}
+
+void LoadingDocumentImpl::loadImage(int invertedZoom)
+{
+    if (d->mImageDataInvertedZoom == invertedZoom) {
+        LOG("Already loading an image at invertedZoom=" << invertedZoom);
+        return;
+    }
+    if (d->mImageDataInvertedZoom == 1) {
+        LOG("Ignoring request: we are loading a full image");
+        return;
+    }
+    d->mImageDataFutureWatcher.waitForFinished();
+    d->mImageDataInvertedZoom = invertedZoom;
+
+    if (d->mMetaInfoLoaded) {
+        // Do not test on mMetaInfoFuture.isRunning() here: it might not have
+        // started if we are downloading the image from a remote url
+        d->startImageDataLoading();
+    }
+}
+
+void LoadingDocumentImpl::slotDataReceived(KIO::Job* job, const QByteArray& chunk)
+{
+    d->mData.append(chunk);
+    if (document()->kind() == MimeTypeUtils::KIND_UNKNOWN && d->mData.length() >= HEADER_SIZE) {
+        if (d->determineKind()) {
+            job->kill();
+            return;
+        }
+    }
+}
+
+void LoadingDocumentImpl::slotTransferFinished(KJob* job)
+{
+    if (job->error()) {
+        setDocumentErrorString(job->errorString());
+        emit loadingFailed();
+        switchToImpl(new EmptyDocumentImpl(document()));
+        return;
+    }
+    d->startLoading();
+}
+
+bool LoadingDocumentImpl::isEditable() const
+{
+    return d->mDownSampledImageLoaded;
+}
+
+Document::LoadingState LoadingDocumentImpl::loadingState() const
+{
+    if (!document()->image().isNull()) {
+        return Document::Loaded;
+    } else if (d->mMetaInfoLoaded) {
+        return Document::MetaInfoLoaded;
+    } else if (document()->kind() != MimeTypeUtils::KIND_UNKNOWN) {
+        return Document::KindDetermined;
+    } else {
+        return Document::Loading;
+    }
+}
+
+void LoadingDocumentImpl::slotMetaInfoLoaded()
+{
+    LOG("");
+    Q_ASSERT(!d->mMetaInfoFuture.isRunning());
+    if (!d->mMetaInfoFuture.result()) {
+        setDocumentErrorString(
+            i18nc("@info", "Loading meta information failed.")
+        );
+        emit loadingFailed();
+        switchToImpl(new EmptyDocumentImpl(document()));
+        return;
+    }
+
+    setDocumentFormat(d->mFormat);
+    setDocumentImageSize(d->mImageSize);
+    setDocumentExiv2Image(d->mExiv2Image);
+
+    d->mMetaInfoLoaded = true;
+    emit metaInfoLoaded();
+
+    // Start image loading if necessary
+    // We test if mImageDataFuture is not already running because code connected to
+    // metaInfoLoaded() signal could have called loadImage()
+    if (!d->mImageDataFuture.isRunning() && d->mImageDataInvertedZoom != 0) {
+        d->startImageDataLoading();
+    }
+}
+
+void LoadingDocumentImpl::slotImageLoaded()
+{
+    LOG("");
+    if (d->mImage.isNull()) {
+        setDocumentErrorString(
+            i18nc("@info", "Loading image failed.")
+        );
+        emit loadingFailed();
+        switchToImpl(new EmptyDocumentImpl(document()));
+        return;
+    }
+
+    if (d->mAnimated) {
+        if (d->mImage.size() == d->mImageSize) {
+            // We already decoded the first frame at the right size, let's show
+            // it
+            setDocumentImage(d->mImage);
+        }
+
+        switchToImpl(new AnimatedDocumentLoadedImpl(
+                         document(),
+                         d->mData));
+
+        return;
+    }
+
+    if (d->mImageDataInvertedZoom != 1 && d->mImage.size() != d->mImageSize) {
+        LOG("Loaded a down sampled image");
+        d->mDownSampledImageLoaded = true;
+        // We loaded a down sampled image
+        setDocumentDownSampledImage(d->mImage, d->mImageDataInvertedZoom);
+        return;
+    }
+
+    LOG("Loaded a full image");
+    setDocumentImage(d->mImage);
+    DocumentLoadedImpl* impl;
+    if (d->mJpegContent.get()) {
+        impl = new JpegDocumentLoadedImpl(
+            document(),
+            d->mJpegContent.release());
+    } else {
+        impl = new DocumentLoadedImpl(
+            document(),
+            d->mData);
+    }
+    switchToImpl(impl);
+}
 
 } // namespace

=== modified file 'lib/document/loadingdocumentimpl.h'
--- lib/document/loadingdocumentimpl.h	2011-07-20 13:46:34 +0000
+++ lib/document/loadingdocumentimpl.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -29,36 +29,39 @@
 #include <lib/document/abstractdocumentimpl.h>
 
 class KJob;
-namespace KIO { class Job; }
-
-namespace Gwenview {
-
+namespace KIO
+{
+class Job;
+}
+
+namespace Gwenview
+{
 
 struct LoadingDocumentImplPrivate;
-class LoadingDocumentImpl : public AbstractDocumentImpl {
-	Q_OBJECT
+class LoadingDocumentImpl : public AbstractDocumentImpl
+{
+    Q_OBJECT
 public:
-	LoadingDocumentImpl(Document*);
-	~LoadingDocumentImpl();
-
-	virtual void init();
-	virtual Document::LoadingState loadingState() const;
-	virtual bool isEditable() const;
-
-	void loadImage(int invertedZoom);
+    LoadingDocumentImpl(Document*);
+    ~LoadingDocumentImpl();
+
+    virtual void init();
+    virtual Document::LoadingState loadingState() const;
+    virtual bool isEditable() const;
+
+    void loadImage(int invertedZoom);
 
 private Q_SLOTS:
-	void slotMetaInfoLoaded();
-	void slotImageLoaded();
-	void slotDataReceived(KIO::Job*, const QByteArray&);
-	void slotTransferFinished(KJob*);
+    void slotMetaInfoLoaded();
+    void slotImageLoaded();
+    void slotDataReceived(KIO::Job*, const QByteArray&);
+    void slotTransferFinished(KJob*);
 
 private:
-	LoadingDocumentImplPrivate* const d;
-	friend struct LoadingDocumentImplPrivate;
+    LoadingDocumentImplPrivate* const d;
+    friend struct LoadingDocumentImplPrivate;
 };
 
-
 } // namespace
 
 #endif /* LOADINGDOCUMENTIMPL_H */

=== modified file 'lib/document/loadingjob.cpp'
--- lib/document/loadingjob.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/loadingjob.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -30,32 +30,32 @@
 
 // Local
 
-namespace Gwenview {
-
-
-void LoadingJob::doStart() {
-	Document::LoadingState state = document()->loadingState();
-	if (state == Document::Loaded || state == Document::LoadingFailed) {
-		setError(NoError);
-		emitResult();
-	} else {
-		connect(document().data(), SIGNAL(loaded(const KUrl&)), SLOT(slotLoaded()));
-		connect(document().data(), SIGNAL(loadingFailed(const KUrl&)), SLOT(slotLoadingFailed()));
-	}
-}
-
-
-void LoadingJob::slotLoaded() {
-	setError(NoError);
-	emitResult();
-}
-
-
-void LoadingJob::slotLoadingFailed() {
-	setError(UserDefinedError + 1);
-	setErrorText(i18n("Could not load document %1", document()->url().pathOrUrl()));
-	emitResult();
-}
-
+namespace Gwenview
+{
+
+void LoadingJob::doStart()
+{
+    Document::LoadingState state = document()->loadingState();
+    if (state == Document::Loaded || state == Document::LoadingFailed) {
+        setError(NoError);
+        emitResult();
+    } else {
+        connect(document().data(), SIGNAL(loaded(KUrl)), SLOT(slotLoaded()));
+        connect(document().data(), SIGNAL(loadingFailed(KUrl)), SLOT(slotLoadingFailed()));
+    }
+}
+
+void LoadingJob::slotLoaded()
+{
+    setError(NoError);
+    emitResult();
+}
+
+void LoadingJob::slotLoadingFailed()
+{
+    setError(UserDefinedError + 1);
+    setErrorText(i18n("Could not load document %1", document()->url().pathOrUrl()));
+    emitResult();
+}
 
 } // namespace

=== modified file 'lib/document/loadingjob.h'
--- lib/document/loadingjob.h	2011-07-20 13:46:34 +0000
+++ lib/document/loadingjob.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -28,20 +28,20 @@
 // Local
 #include <lib/document/documentjob.h>
 
-namespace Gwenview {
-
-
-class LoadingJob : public DocumentJob {
-	Q_OBJECT
+namespace Gwenview
+{
+
+class LoadingJob : public DocumentJob
+{
+    Q_OBJECT
 protected:
-	void doStart();
+    void doStart();
 
 private Q_SLOTS:
-	void slotLoaded();
-	void slotLoadingFailed();
+    void slotLoaded();
+    void slotLoadingFailed();
 };
 
-
 } // namespace
 
 #endif /* LOADINGJOB_H */

=== modified file 'lib/document/savejob.cpp'
--- lib/document/savejob.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/savejob.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -39,132 +39,131 @@
 // Local
 #include "documentloadedimpl.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct SaveJobPrivate {
-	DocumentLoadedImpl* mImpl;
-	KUrl mOldUrl;
-	KUrl mNewUrl;
-	QByteArray mFormat;
-	QScopedPointer<KTemporaryFile> mTemporaryFile;
-	QScopedPointer<KSaveFile> mSaveFile;
-	QScopedPointer<QFutureWatcher<void> > mInternalSaveWatcher;
+    DocumentLoadedImpl* mImpl;
+    KUrl mOldUrl;
+    KUrl mNewUrl;
+    QByteArray mFormat;
+    QScopedPointer<KTemporaryFile> mTemporaryFile;
+    QScopedPointer<KSaveFile> mSaveFile;
+    QScopedPointer<QFutureWatcher<void> > mInternalSaveWatcher;
 
-	bool mKillReceived;
+    bool mKillReceived;
 };
 
-
 SaveJob::SaveJob(DocumentLoadedImpl* impl, const KUrl& url, const QByteArray& format)
-: d(new SaveJobPrivate) {
-	d->mImpl = impl;
-	d->mOldUrl = impl->document()->url();
-	d->mNewUrl = url;
-	d->mFormat = format;
-	d->mKillReceived = false;
-	setCapabilities(Killable);
-}
-
-
-SaveJob::~SaveJob() {
-	delete d;
-}
-
-
-void SaveJob::saveInternal() {
-	if (!d->mImpl->saveInternal(d->mSaveFile.data(), d->mFormat)) {
-		d->mSaveFile->abort();
-		setError(UserDefinedError + 2);
-		setErrorText(d->mImpl->document()->errorString());
-	}
-}
-
-
-void SaveJob::doStart() {
-	if (d->mKillReceived) {
-		return;
-	}
-	QString fileName;
-
-	if (d->mNewUrl.isLocalFile()) {
-		fileName = d->mNewUrl.toLocalFile();
-	} else {
-		d->mTemporaryFile.reset(new KTemporaryFile);
-		d->mTemporaryFile->setAutoRemove(true);
-		d->mTemporaryFile->open();
-		fileName = d->mTemporaryFile->fileName();
-	}
-
-	d->mSaveFile.reset(new KSaveFile(fileName));
-
-	if (!d->mSaveFile->open()) {
-		KUrl dirUrl = d->mNewUrl;
-		dirUrl.setFileName(QString());
-		setError(UserDefinedError + 1);
-		setErrorText(i18nc("@info", "Could not open file for writing, check that you have the necessary rights in <filename>%1</filename>.", dirUrl.pathOrUrl()));
-		emitResult();
-		return;
-	}
-
-	QFuture<void> future = QtConcurrent::run(this, &SaveJob::saveInternal);
-	d->mInternalSaveWatcher.reset(new QFutureWatcher<void>(this));
-	d->mInternalSaveWatcher->setFuture(future);
-	connect(d->mInternalSaveWatcher.data(), SIGNAL(finished()), SLOT(finishSave()));
-}
-
-
-void SaveJob::finishSave() {
-	d->mInternalSaveWatcher.reset(0);
-	if (d->mKillReceived) {
-		return;
-	}
-
-	if (error()) {
-		emitResult();
-		return;
-	}
-
-	if (!d->mSaveFile->finalize()) {
-		setErrorText(i18nc("@info", "Could not overwrite file, check that you have the necessary rights to write in <filename>%1</filename>.", d->mNewUrl.pathOrUrl()));
-		setError(UserDefinedError + 3);
-		return;
-	}
-
-	if (d->mNewUrl.isLocalFile()) {
-		emitResult();
-	} else {
-		KIO::Job* job = KIO::copy(KUrl::fromPath(d->mTemporaryFile->fileName()), d->mNewUrl);
-		job->ui()->setWindow(KApplication::kApplication()->activeWindow());
-		addSubjob(job);
-	}
-}
-
-
-void SaveJob::slotResult(KJob* job) {
-	DocumentJob::slotResult(job);
-	if (!error()) {
-		emitResult();
-	}
-}
-
-
-KUrl SaveJob::oldUrl() const {
-	return d->mOldUrl;
-}
-
-
-KUrl SaveJob::newUrl() const {
-	return d->mNewUrl;
-}
-
-
-bool SaveJob::doKill() {
-	d->mKillReceived = true;
-	if (d->mInternalSaveWatcher) {
-		d->mInternalSaveWatcher->waitForFinished();
-	}
-	return true;
-}
-
+: d(new SaveJobPrivate)
+{
+    d->mImpl = impl;
+    d->mOldUrl = impl->document()->url();
+    d->mNewUrl = url;
+    d->mFormat = format;
+    d->mKillReceived = false;
+    setCapabilities(Killable);
+}
+
+SaveJob::~SaveJob()
+{
+    delete d;
+}
+
+void SaveJob::saveInternal()
+{
+    if (!d->mImpl->saveInternal(d->mSaveFile.data(), d->mFormat)) {
+        d->mSaveFile->abort();
+        setError(UserDefinedError + 2);
+        setErrorText(d->mImpl->document()->errorString());
+    }
+}
+
+void SaveJob::doStart()
+{
+    if (d->mKillReceived) {
+        return;
+    }
+    QString fileName;
+
+    if (d->mNewUrl.isLocalFile()) {
+        fileName = d->mNewUrl.toLocalFile();
+    } else {
+        d->mTemporaryFile.reset(new KTemporaryFile);
+        d->mTemporaryFile->setAutoRemove(true);
+        d->mTemporaryFile->open();
+        fileName = d->mTemporaryFile->fileName();
+    }
+
+    d->mSaveFile.reset(new KSaveFile(fileName));
+
+    if (!d->mSaveFile->open()) {
+        KUrl dirUrl = d->mNewUrl;
+        dirUrl.setFileName(QString());
+        setError(UserDefinedError + 1);
+        setErrorText(i18nc("@info", "Could not open file for writing, check that you have the necessary rights in <filename>%1</filename>.", dirUrl.pathOrUrl()));
+        emitResult();
+        return;
+    }
+
+    QFuture<void> future = QtConcurrent::run(this, &SaveJob::saveInternal);
+    d->mInternalSaveWatcher.reset(new QFutureWatcher<void>(this));
+    d->mInternalSaveWatcher->setFuture(future);
+    connect(d->mInternalSaveWatcher.data(), SIGNAL(finished()), SLOT(finishSave()));
+}
+
+void SaveJob::finishSave()
+{
+    d->mInternalSaveWatcher.reset(0);
+    if (d->mKillReceived) {
+        return;
+    }
+
+    if (error()) {
+        emitResult();
+        return;
+    }
+
+    if (!d->mSaveFile->finalize()) {
+        setErrorText(i18nc("@info", "Could not overwrite file, check that you have the necessary rights to write in <filename>%1</filename>.", d->mNewUrl.pathOrUrl()));
+        setError(UserDefinedError + 3);
+        return;
+    }
+
+    if (d->mNewUrl.isLocalFile()) {
+        emitResult();
+    } else {
+        KIO::Job* job = KIO::copy(KUrl::fromPath(d->mTemporaryFile->fileName()), d->mNewUrl);
+        job->ui()->setWindow(KApplication::kApplication()->activeWindow());
+        addSubjob(job);
+    }
+}
+
+void SaveJob::slotResult(KJob* job)
+{
+    DocumentJob::slotResult(job);
+    if (!error()) {
+        emitResult();
+    }
+}
+
+KUrl SaveJob::oldUrl() const
+{
+    return d->mOldUrl;
+}
+
+KUrl SaveJob::newUrl() const
+{
+    return d->mNewUrl;
+}
+
+bool SaveJob::doKill()
+{
+    d->mKillReceived = true;
+    if (d->mInternalSaveWatcher) {
+        d->mInternalSaveWatcher->waitForFinished();
+    }
+    return true;
+}
 
 } // namespace

=== modified file 'lib/document/savejob.h'
--- lib/document/savejob.h	2011-07-20 13:46:34 +0000
+++ lib/document/savejob.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -33,36 +33,37 @@
 class QByteArray;
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class DocumentLoadedImpl;
 
 class SaveJobPrivate;
-class GWENVIEWLIB_EXPORT SaveJob : public DocumentJob {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT SaveJob : public DocumentJob
+{
+    Q_OBJECT
 public:
-	SaveJob(DocumentLoadedImpl* impl, const KUrl& url, const QByteArray& format);
-	~SaveJob();
-	void saveInternal();
+    SaveJob(DocumentLoadedImpl* impl, const KUrl& url, const QByteArray& format);
+    ~SaveJob();
+    void saveInternal();
 
-	KUrl oldUrl() const;
-	KUrl newUrl() const;
+    KUrl oldUrl() const;
+    KUrl newUrl() const;
 
 protected Q_SLOTS:
-	virtual void doStart();
-	virtual void slotResult(KJob*);
+    virtual void doStart();
+    virtual void slotResult(KJob*);
 
 protected:
-	virtual bool doKill();
+    virtual bool doKill();
 
 private Q_SLOTS:
-	void finishSave();
+    void finishSave();
 
 private:
-	SaveJobPrivate* const d;
+    SaveJobPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* SAVEJOB_H */

=== modified file 'lib/document/svgdocumentloadedimpl.cpp'
--- lib/document/svgdocumentloadedimpl.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/svgdocumentloadedimpl.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -22,50 +22,59 @@
 #include "svgdocumentloadedimpl.moc"
 
 // Qt
+#include <QSvgRenderer>
 
 // KDE
 #include <kdebug.h>
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct SvgDocumentLoadedImplPrivate {
-	QByteArray mRawData;
+    QByteArray mRawData;
+    QSvgRenderer* mRenderer;
 };
 
-
 SvgDocumentLoadedImpl::SvgDocumentLoadedImpl(Document* document, const QByteArray& data)
 : AbstractDocumentImpl(document)
-, d(new SvgDocumentLoadedImplPrivate) {
-	d->mRawData = data;
-}
-
-
-SvgDocumentLoadedImpl::~SvgDocumentLoadedImpl() {
-	delete d;
-}
-
-
-void SvgDocumentLoadedImpl::init() {
-	emit loaded();
-}
-
-
-Document::LoadingState SvgDocumentLoadedImpl::loadingState() const {
-	return Document::Loaded;
-}
-
-
-void SvgDocumentLoadedImpl::setImage(const QImage&) {
-	kWarning() << "Should not be called";
-}
-
-
-QByteArray SvgDocumentLoadedImpl::rawData() const {
-	return d->mRawData;
-}
-
+, d(new SvgDocumentLoadedImplPrivate)
+{
+    d->mRawData = data;
+    d->mRenderer = new QSvgRenderer(this);
+}
+
+SvgDocumentLoadedImpl::~SvgDocumentLoadedImpl()
+{
+    delete d;
+}
+
+void SvgDocumentLoadedImpl::init()
+{
+    d->mRenderer->load(d->mRawData);
+    setDocumentImageSize(d->mRenderer->defaultSize());
+    emit loaded();
+}
+
+Document::LoadingState SvgDocumentLoadedImpl::loadingState() const
+{
+    return Document::Loaded;
+}
+
+void SvgDocumentLoadedImpl::setImage(const QImage&)
+{
+    kWarning() << "Should not be called";
+}
+
+QByteArray SvgDocumentLoadedImpl::rawData() const
+{
+    return d->mRawData;
+}
+
+QSvgRenderer* SvgDocumentLoadedImpl::svgRenderer() const
+{
+    return d->mRenderer;
+}
 
 } // namespace

=== modified file 'lib/document/svgdocumentloadedimpl.h'
--- lib/document/svgdocumentloadedimpl.h	2011-07-20 13:46:34 +0000
+++ lib/document/svgdocumentloadedimpl.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -28,29 +28,31 @@
 // Local
 #include <lib/document/abstractdocumentimpl.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct SvgDocumentLoadedImplPrivate;
-class SvgDocumentLoadedImpl : public AbstractDocumentImpl {
-	Q_OBJECT
+class SvgDocumentLoadedImpl : public AbstractDocumentImpl
+{
+    Q_OBJECT
 public:
-	SvgDocumentLoadedImpl(Document*, const QByteArray&);
-	~SvgDocumentLoadedImpl();
-
-	virtual void init();
-
-	virtual Document::LoadingState loadingState() const;
-
-	virtual void setImage(const QImage&);
-
-	QByteArray rawData() const;
+    SvgDocumentLoadedImpl(Document*, const QByteArray&);
+    ~SvgDocumentLoadedImpl();
+
+    virtual void init();
+
+    virtual Document::LoadingState loadingState() const;
+
+    virtual void setImage(const QImage&);
+
+    QByteArray rawData() const;
+
+    QSvgRenderer* svgRenderer() const;
 
 private:
-	SvgDocumentLoadedImplPrivate* const d;
+    SvgDocumentLoadedImplPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* SVGDOCUMENTLOADEDIMPL_H */

=== modified file 'lib/document/videodocumentloadedimpl.cpp'
--- lib/document/videodocumentloadedimpl.cpp	2011-07-20 13:46:34 +0000
+++ lib/document/videodocumentloadedimpl.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -28,37 +28,36 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct VideoDocumentLoadedImplPrivate {
 };
 
-
 VideoDocumentLoadedImpl::VideoDocumentLoadedImpl(Document* document)
 : AbstractDocumentImpl(document)
-, d(new VideoDocumentLoadedImplPrivate) {
-}
-
-
-VideoDocumentLoadedImpl::~VideoDocumentLoadedImpl() {
-	delete d;
-}
-
-
-void VideoDocumentLoadedImpl::init() {
-	emit loaded();
-}
-
-
-Document::LoadingState VideoDocumentLoadedImpl::loadingState() const {
-	return Document::Loaded;
-}
-
-
-void VideoDocumentLoadedImpl::setImage(const QImage&) {
-	kWarning() << "Should not be called";
-}
-
+, d(new VideoDocumentLoadedImplPrivate)
+{
+}
+
+VideoDocumentLoadedImpl::~VideoDocumentLoadedImpl()
+{
+    delete d;
+}
+
+void VideoDocumentLoadedImpl::init()
+{
+    emit loaded();
+}
+
+Document::LoadingState VideoDocumentLoadedImpl::loadingState() const
+{
+    return Document::Loaded;
+}
+
+void VideoDocumentLoadedImpl::setImage(const QImage&)
+{
+    kWarning() << "Should not be called";
+}
 
 } // namespace

=== modified file 'lib/document/videodocumentloadedimpl.h'
--- lib/document/videodocumentloadedimpl.h	2011-07-20 13:46:34 +0000
+++ lib/document/videodocumentloadedimpl.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -28,27 +28,27 @@
 // Local
 #include <lib/document/abstractdocumentimpl.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct VideoDocumentLoadedImplPrivate;
-class VideoDocumentLoadedImpl : public AbstractDocumentImpl {
-	Q_OBJECT
+class VideoDocumentLoadedImpl : public AbstractDocumentImpl
+{
+    Q_OBJECT
 public:
-	VideoDocumentLoadedImpl(Document*);
-	~VideoDocumentLoadedImpl();
-
-	virtual void init();
-
-	virtual Document::LoadingState loadingState() const;
-
-	virtual void setImage(const QImage&);
+    VideoDocumentLoadedImpl(Document*);
+    ~VideoDocumentLoadedImpl();
+
+    virtual void init();
+
+    virtual Document::LoadingState loadingState() const;
+
+    virtual void setImage(const QImage&);
 
 private:
-	VideoDocumentLoadedImplPrivate* const d;
+    VideoDocumentLoadedImplPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* VIDEODOCUMENTLOADEDIMPL_H */

=== modified file 'lib/documentview/abstractdocumentviewadapter.cpp'
--- lib/documentview/abstractdocumentviewadapter.cpp	2011-07-20 13:46:34 +0000
+++ lib/documentview/abstractdocumentviewadapter.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -22,36 +22,41 @@
 #include "abstractdocumentviewadapter.moc"
 
 // Qt
-#include <QWidget>
+#include <QCursor>
+#include <QGraphicsWidget>
 
 // KDE
 
 // Local
 
-namespace Gwenview {
-
-
-AbstractDocumentViewAdapter::AbstractDocumentViewAdapter(QWidget* parent)
-: QObject(parent)
-, mWidget(0) {
+namespace Gwenview
+{
+
+AbstractDocumentViewAdapter::AbstractDocumentViewAdapter()
+: mWidget(0)
+{
 }
 
-
 AbstractDocumentViewAdapter::~AbstractDocumentViewAdapter()
 {
-	delete mWidget;
-}
-
-
-QCursor AbstractDocumentViewAdapter::cursor() const {
-	return mWidget ? mWidget->cursor() : QCursor();
-}
-
-
-void AbstractDocumentViewAdapter::setCursor(const QCursor& cursor) {
-	if (mWidget) {
-		mWidget->setCursor(cursor);
-	}
+    delete mWidget;
+}
+
+QCursor AbstractDocumentViewAdapter::cursor() const
+{
+    return mWidget ? mWidget->cursor() : QCursor();
+}
+
+void AbstractDocumentViewAdapter::setCursor(const QCursor& cursor)
+{
+    if (mWidget) {
+        mWidget->setCursor(cursor);
+    }
+}
+
+EmptyAdapter::EmptyAdapter()
+{
+    setWidget(new QGraphicsWidget);
 }
 
 } // namespace

=== modified file 'lib/documentview/abstractdocumentviewadapter.h'
--- lib/documentview/abstractdocumentviewadapter.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/abstractdocumentviewadapter.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -33,94 +33,120 @@
 #include <lib/document/document.h>
 
 class QCursor;
-class QWidget;
-
-
-namespace Gwenview {
-
+class QGraphicsWidget;
+
+namespace Gwenview
+{
 
 class ImageView;
-
+class RasterImageView;
 
 /**
  * Classes inherit from this class so that they can be used inside the
  * DocumentPanel.
  */
-class GWENVIEWLIB_EXPORT AbstractDocumentViewAdapter : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT AbstractDocumentViewAdapter : public QObject
+{
+    Q_OBJECT
 public:
-	AbstractDocumentViewAdapter(QWidget*);
-	virtual ~AbstractDocumentViewAdapter();
-
-	QWidget* widget() const { return mWidget; }
-
-	virtual MimeTypeUtils::Kind kind() const = 0;
-
-	virtual ImageView* imageView() const { return 0; }
-
-	virtual void installEventFilterOnViewWidgets(QObject*) = 0;
-
-	virtual QCursor cursor() const;
-
-	virtual void setCursor(const QCursor&);
-
-	/**
-	 * @defgroup zooming functions
-	 * @{
-	 */
-	virtual bool canZoom() const { return false; }
-
-	// Implementation must emit zoomToFitChanged()
-	virtual void setZoomToFit(bool) {}
-
-	virtual bool zoomToFit() const { return false; }
-
-	virtual qreal zoom() const { return 0; }
-
-	virtual void setZoom(qreal /*zoom*/, const QPoint& /*center*/ = QPoint(-1, -1)) {}
-
-	virtual qreal computeZoomToFit() const { return 1.; }
-	virtual qreal computeZoomToFitWidth() const { return 1.; }
-	virtual qreal computeZoomToFitHeight() const { return 1.; }
-	/** @} */
-
-	virtual Document::Ptr document() const = 0;
-	virtual void setDocument(Document::Ptr) = 0;
-
-	virtual void loadConfig() {}
+    AbstractDocumentViewAdapter();
+    virtual ~AbstractDocumentViewAdapter();
+
+    QGraphicsWidget* widget() const {
+        return mWidget;
+    }
+
+    virtual MimeTypeUtils::Kind kind() const = 0;
+
+    virtual ImageView* imageView() const {
+        return 0;
+    }
+
+    virtual RasterImageView* rasterImageView() const {
+        return 0;
+    }
+
+    virtual QCursor cursor() const;
+
+    virtual void setCursor(const QCursor&);
+
+    /**
+     * @defgroup zooming functions
+     * @{
+     */
+    virtual bool canZoom() const {
+        return false;
+    }
+
+    // Implementation must emit zoomToFitChanged()
+    virtual void setZoomToFit(bool) {}
+
+    virtual bool zoomToFit() const {
+        return false;
+    }
+
+    virtual qreal zoom() const {
+        return 0;
+    }
+
+    virtual void setZoom(qreal /*zoom*/, const QPointF& /*center*/ = QPointF(-1, -1)) {}
+
+    virtual qreal computeZoomToFit() const {
+        return 1.;
+    }
+    /** @} */
+
+    virtual Document::Ptr document() const = 0;
+    virtual void setDocument(Document::Ptr) = 0;
+
+    virtual void loadConfig() {}
+
+    virtual QPointF scrollPos() const {
+        return QPointF(0, 0);
+    }
+    virtual void setScrollPos(const QPointF& /*pos*/) {}
 
 protected:
-	void setWidget(QWidget* widget) { mWidget = widget; }
+    void setWidget(QGraphicsWidget* widget) {
+        mWidget = widget;
+    }
 
 Q_SIGNALS:
-	void previousImageRequested();
-	void nextImageRequested();
-
-	/**
-	 * @addgroup zooming functions
-	 * @{
-	 */
-	void zoomChanged(qreal);
-
-	void zoomToFitChanged(bool);
-
-	/**
-	 * Emitted when the ui would like to zoom in at a particular point.
-	 * @param center the zoom point in widget coordinates
-	 */
-	void zoomInRequested(const QPoint& center);
-
-	/**
-	 * Emitted when the ui would like to zoom out from a particular point.
-	 * @param center the zoom point in widget coordinates
-	 */
-	void zoomOutRequested(const QPoint& center);
-	/** @} */
+    /**
+     * @addgroup zooming functions
+     * @{
+     */
+    void zoomChanged(qreal);
+
+    void zoomToFitChanged(bool);
+
+    void zoomInRequested(const QPointF&);
+
+    void zoomOutRequested(const QPointF&);
+    /** @} */
+
+    void scrollPosChanged();
 
 private:
-	QWidget* mWidget;
+    QGraphicsWidget* mWidget;
 };
 
+/**
+ * An empty adapter, used when no document is displayed
+ */
+class EmptyAdapter : public AbstractDocumentViewAdapter
+{
+    Q_OBJECT
+public:
+    EmptyAdapter();
+    virtual MimeTypeUtils::Kind kind() const {
+        return MimeTypeUtils::KIND_UNKNOWN;
+    }
+    virtual Document::Ptr document() const {
+        return Document::Ptr();
+    }
+    virtual void setDocument(Document::Ptr) {}
+};
 
 } // namespace
 

=== added file 'lib/documentview/abstractimageview.cpp'
--- lib/documentview/abstractimageview.cpp	1970-01-01 00:00:00 +0000
+++ lib/documentview/abstractimageview.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,461 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "abstractimageview.moc"
+
+// Local
+
+// KDE
+#include <kdebug.h>
+#include <kmodifierkeyinfo.h>
+#include <kstandarddirs.h>
+#include <kurl.h>
+
+// Qt
+#include <QCursor>
+#include <QGraphicsSceneMouseEvent>
+
+namespace Gwenview
+{
+
+static const int UNIT_STEP = 16;
+
+struct AbstractImageViewPrivate {
+    enum Verbosity {
+        Silent,
+        Notify
+    };
+    AbstractImageView* q;
+    KModifierKeyInfo* mModifierKeyInfo;
+    QCursor mZoomCursor;
+    Document::Ptr mDocument;
+
+    bool mEnlargeSmallerImages;
+
+    qreal mZoom;
+    bool mZoomToFit;
+    QPointF mImageOffset;
+    QPointF mScrollPos;
+    QPointF mLastDragPos;
+
+    void adjustImageOffset(Verbosity verbosity = Notify)
+    {
+        QSizeF zoomedDocSize = q->documentSize() * mZoom;
+        QSizeF viewSize = q->boundingRect().size();
+        QPointF offset(
+            qMax((viewSize.width() - zoomedDocSize.width()) / 2, 0.),
+            qMax((viewSize.height() - zoomedDocSize.height()) / 2, 0.)
+        );
+        if (offset != mImageOffset) {
+            mImageOffset = offset;
+            if (verbosity == Notify) {
+                q->onImageOffsetChanged();
+            }
+        }
+    }
+
+    void adjustScrollPos(Verbosity verbosity = Notify)
+    {
+        setScrollPos(mScrollPos, verbosity);
+    }
+
+    void setScrollPos(const QPointF& _newPos, Verbosity verbosity = Notify)
+    {
+        QSizeF zoomedDocSize = q->documentSize() * mZoom;
+        QSizeF viewSize = q->boundingRect().size();
+        QPointF newPos(
+            qBound(0., _newPos.x(), zoomedDocSize.width() - viewSize.width()),
+            qBound(0., _newPos.y(), zoomedDocSize.height() - viewSize.height())
+        );
+        if (newPos != mScrollPos) {
+            QPointF oldPos = mScrollPos;
+            mScrollPos = newPos;
+            if (verbosity == Notify) {
+                q->onScrollPosChanged(oldPos);
+            }
+            // No verbosity test: we always notify the outside world about
+            // scrollPos changes
+            QMetaObject::invokeMethod(q, "scrollPosChanged");
+        }
+    }
+
+    void setupZoomCursor()
+    {
+        QString path = KStandardDirs::locate("appdata", "cursors/zoom.png");
+        QPixmap cursorPixmap = QPixmap(path);
+        mZoomCursor = QCursor(cursorPixmap, 11, 11);
+    }
+};
+
+AbstractImageView::AbstractImageView(QGraphicsItem* parent)
+: QGraphicsWidget(parent)
+, d(new AbstractImageViewPrivate)
+{
+    d->q = this;
+    d->mEnlargeSmallerImages = false;
+    d->mZoom = 1;
+    d->mZoomToFit = true;
+    d->mImageOffset = QPointF(0, 0);
+    d->mScrollPos = QPointF(0, 0);
+    d->mModifierKeyInfo = new KModifierKeyInfo(this);
+    connect(d->mModifierKeyInfo, SIGNAL(keyPressed(Qt::Key, bool)), SLOT(updateCursor()));
+    setFocusPolicy(Qt::WheelFocus);
+    setFlag(ItemIsSelectable);
+    d->setupZoomCursor();
+    updateCursor();
+}
+
+AbstractImageView::~AbstractImageView()
+{
+    delete d;
+}
+
+Document::Ptr AbstractImageView::document() const
+{
+    return d->mDocument;
+}
+
+void AbstractImageView::setDocument(Document::Ptr doc)
+{
+    d->mDocument = doc;
+    loadFromDocument();
+    if (d->mZoomToFit) {
+        setZoom(computeZoomToFit());
+    }
+}
+
+QSizeF AbstractImageView::documentSize() const
+{
+    return d->mDocument ? d->mDocument->size() : QSizeF();
+}
+
+qreal AbstractImageView::zoom() const
+{
+    return d->mZoom;
+}
+
+void AbstractImageView::setZoom(qreal zoom, const QPointF& _center, AbstractImageView::UpdateType updateType)
+{
+    if (updateType == UpdateIfNecessary && qFuzzyCompare(zoom, d->mZoom)) {
+        return;
+    }
+    qreal oldZoom = d->mZoom;
+    d->mZoom = zoom;
+
+    QPointF center;
+    if (_center == QPointF(-1, -1)) {
+        center = boundingRect().center();
+    } else {
+        center = _center;
+    }
+
+    /*
+    We want to keep the point at viewport coordinates "center" at the same
+    position after zooming. The coordinates of this point in image coordinates
+    can be expressed like this:
+
+                          oldScroll + center
+    imagePointAtOldZoom = ------------------
+                               oldZoom
+
+                       scroll + center
+    imagePointAtZoom = ---------------
+                            zoom
+
+    So we want:
+
+        imagePointAtOldZoom = imagePointAtZoom
+
+        oldScroll + center   scroll + center
+    <=> ------------------ = ---------------
+              oldZoom             zoom
+
+                  zoom
+    <=> scroll = ------- (oldScroll + center) - center
+                 oldZoom
+    */
+
+    /*
+    Compute oldScroll
+    It's useless to take the new offset in consideration because if a direction
+    of the new offset is not 0, we won't be able to center on a specific point
+    in that direction.
+    */
+    QPointF oldScroll = scrollPos() - imageOffset();
+
+    QPointF scroll = (zoom / oldZoom) * (oldScroll + center) - center;
+
+    d->adjustImageOffset(AbstractImageViewPrivate::Silent);
+    d->setScrollPos(scroll, AbstractImageViewPrivate::Silent);
+    onZoomChanged();
+    zoomChanged(d->mZoom);
+}
+
+bool AbstractImageView::zoomToFit() const
+{
+    return d->mZoomToFit;
+}
+
+void AbstractImageView::setZoomToFit(bool on)
+{
+    d->mZoomToFit = on;
+    if (on) {
+        setZoom(computeZoomToFit());
+    }
+    // We do not set zoom to 1 if zoomToFit is off, this is up to the code
+    // calling us. It may went to zoom to some other level and/or to zoom on
+    // a particular position
+    zoomToFitChanged(d->mZoomToFit);
+}
+
+void AbstractImageView::resizeEvent(QGraphicsSceneResizeEvent* event)
+{
+    QGraphicsWidget::resizeEvent(event);
+    if (d->mZoomToFit) {
+        // Set zoom calls adjustImageOffset(), but only if the zoom changes.
+        // If the view is resized but does not cause a zoom change we want the
+        // offset to be adjusted so we call adjustImageOffset() from there as
+        // well.
+        d->adjustImageOffset(AbstractImageViewPrivate::Silent);
+        setZoom(computeZoomToFit());
+    } else {
+        d->adjustImageOffset();
+        d->adjustScrollPos();
+    }
+}
+
+qreal AbstractImageView::computeZoomToFit() const
+{
+    QSizeF docSize = documentSize();
+    if (docSize.isEmpty()) {
+        return 1;
+    }
+    QSizeF viewSize = boundingRect().size();
+    qreal fitWidth = viewSize.width() / docSize.width();
+    qreal fitHeight = viewSize.height() / docSize.height();
+    qreal fit = qMin(fitWidth, fitHeight);
+    if (!d->mEnlargeSmallerImages) {
+        fit = qMin(fit, 1.);
+    }
+    return fit;
+}
+
+void AbstractImageView::mousePressEvent(QGraphicsSceneMouseEvent* event)
+{
+    QGraphicsItem::mousePressEvent(event);
+    if (event->button() == Qt::MiddleButton) {
+        bool value = !zoomToFit();
+        setZoomToFit(value);
+        if (!value) {
+            setZoom(1.);
+        }
+        return;
+    }
+
+    if (event->modifiers() & Qt::ControlModifier) {
+        if (event->button() == Qt::LeftButton) {
+            zoomInRequested(event->pos());
+            return;
+        } else if (event->button() == Qt::RightButton) {
+            zoomOutRequested(event->pos());
+            return;
+        }
+    }
+
+    d->mLastDragPos = event->pos();
+    updateCursor();
+}
+
+void AbstractImageView::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
+{
+    QGraphicsItem::mouseMoveEvent(event);
+
+    QPointF mousePos = event->pos();
+    QPointF newScrollPos = d->mScrollPos + d->mLastDragPos - mousePos;
+
+    // Wrap mouse pos
+    qreal maxWidth = boundingRect().width();
+    qreal maxHeight = boundingRect().height();
+    // We need a margin because if the window is maximized, the mouse may not
+    // be able to go past the bounding rect.
+    // The mouse get placed 1 pixel before/after the margin to avoid getting
+    // considered as needing to wrap the other way in next mouseMoveEvent
+    // (because we don't check the move vector)
+    const int margin = 5;
+    if (mousePos.x() <= margin) {
+        mousePos.setX(maxWidth - margin - 1);
+    } else if (mousePos.x() >= maxWidth - margin) {
+        mousePos.setX(margin + 1);
+    }
+    if (mousePos.y() <= margin) {
+        mousePos.setY(maxHeight - margin - 1);
+    } else if (mousePos.y() >= maxHeight - margin) {
+        mousePos.setY(margin + 1);
+    }
+
+    // Set mouse pos (Hackish translation to screen coords!)
+    QPointF screenDelta = event->screenPos() - event->pos();
+    QCursor::setPos((mousePos + screenDelta).toPoint());
+
+    d->mLastDragPos = mousePos;
+    d->setScrollPos(newScrollPos);
+
+}
+
+void AbstractImageView::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
+{
+    QGraphicsItem::mouseReleaseEvent(event);
+    if (!d->mLastDragPos.isNull()) {
+        d->mLastDragPos = QPointF();
+    }
+    updateCursor();
+}
+
+void AbstractImageView::keyPressEvent(QKeyEvent* event)
+{
+    QPointF delta(0, 0);
+    qreal pageStep = boundingRect().height();
+    qreal unitStep;
+    if (event->modifiers() & Qt::ShiftModifier) {
+        unitStep = pageStep / 2;
+    } else {
+        unitStep = UNIT_STEP;
+    }
+    switch (event->key()) {
+    case Qt::Key_Left:
+        delta.setX(-unitStep);
+        break;
+    case Qt::Key_Right:
+        delta.setX(unitStep);
+        break;
+    case Qt::Key_Up:
+        delta.setY(-unitStep);
+        break;
+    case Qt::Key_Down:
+        delta.setY(unitStep);
+        break;
+    case Qt::Key_PageUp:
+        delta.setY(-pageStep);
+        break;
+    case Qt::Key_PageDown:
+        delta.setY(pageStep);
+        break;
+    case Qt::Key_Home:
+        d->setScrollPos(QPointF(d->mScrollPos.x(), 0));
+        return;
+    case Qt::Key_End:
+        d->setScrollPos(QPointF(d->mScrollPos.x(), documentSize().height() * zoom()));
+        return;
+    default:
+        return;
+    }
+    d->setScrollPos(d->mScrollPos + delta);
+}
+
+QPointF AbstractImageView::imageOffset() const
+{
+    return d->mImageOffset;
+}
+
+QPointF AbstractImageView::scrollPos() const
+{
+    return d->mScrollPos;
+}
+
+void AbstractImageView::setScrollPos(const QPointF& pos)
+{
+    d->setScrollPos(pos);
+}
+
+QPointF AbstractImageView::mapToView(const QPointF& imagePos) const
+{
+    return imagePos * d->mZoom + d->mImageOffset - d->mScrollPos;
+}
+
+QPoint AbstractImageView::mapToView(const QPoint& imagePos) const
+{
+    return mapToView(QPointF(imagePos)).toPoint();
+}
+
+QRectF AbstractImageView::mapToView(const QRectF& imageRect) const
+{
+    return QRectF(
+               mapToView(imageRect.topLeft()),
+               imageRect.size() * zoom()
+           );
+}
+
+QRect AbstractImageView::mapToView(const QRect& imageRect) const
+{
+    return QRect(
+               mapToView(imageRect.topLeft()),
+               imageRect.size() * zoom()
+           );
+}
+
+QPointF AbstractImageView::mapToImage(const QPointF& viewPos) const
+{
+    return (viewPos - d->mImageOffset + d->mScrollPos) / d->mZoom;
+}
+
+QPoint AbstractImageView::mapToImage(const QPoint& viewPos) const
+{
+    return mapToImage(QPointF(viewPos)).toPoint();
+}
+
+QRectF AbstractImageView::mapToImage(const QRectF& viewRect) const
+{
+    return QRectF(
+               mapToImage(viewRect.topLeft()),
+               viewRect.size() / zoom()
+           );
+}
+
+QRect AbstractImageView::mapToImage(const QRect& viewRect) const
+{
+    return QRect(
+               mapToImage(viewRect.topLeft()),
+               viewRect.size() / zoom()
+           );
+}
+
+void AbstractImageView::setEnlargeSmallerImages(bool value)
+{
+    d->mEnlargeSmallerImages = value;
+    if (zoomToFit()) {
+        setZoom(computeZoomToFit());
+    }
+}
+
+void AbstractImageView::updateCursor()
+{
+    if (d->mModifierKeyInfo->isKeyPressed(Qt::Key_Control)) {
+        setCursor(d->mZoomCursor);
+    } else {
+        if (d->mLastDragPos.isNull()) {
+            setCursor(Qt::OpenHandCursor);
+        } else {
+            setCursor(Qt::ClosedHandCursor);
+        }
+    }
+}
+
+} // namespace

=== added file 'lib/documentview/abstractimageview.h'
--- lib/documentview/abstractimageview.h	1970-01-01 00:00:00 +0000
+++ lib/documentview/abstractimageview.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,133 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef ABSTRACTIMAGEVIEW_H
+#define ABSTRACTIMAGEVIEW_H
+
+// Local
+#include <lib/document/document.h>
+
+// KDE
+
+// Qt
+#include <QGraphicsWidget>
+
+namespace Gwenview
+{
+
+class AbstractImageViewPrivate;
+/**
+ *
+ */
+class AbstractImageView : public QGraphicsWidget
+{
+    Q_OBJECT
+public:
+    enum UpdateType {
+        UpdateIfNecessary,
+        ForceUpdate
+    };
+    AbstractImageView(QGraphicsItem* parent);
+    ~AbstractImageView();
+
+    qreal zoom() const;
+
+    virtual void setZoom(qreal zoom, const QPointF& center = QPointF(-1, -1), UpdateType updateType = UpdateIfNecessary);
+
+    bool zoomToFit() const;
+
+    virtual void setZoomToFit(bool value);
+
+    virtual void setDocument(Document::Ptr doc);
+
+    Document::Ptr document() const;
+
+    qreal computeZoomToFit() const;
+
+    QSizeF documentSize() const;
+
+    QSizeF visibleImageSize() const;
+
+    /**
+     * If the image is smaller than the view, imageOffset is the distance from
+     * the topleft corner of the view to the topleft corner of the image.
+     * Neither x nor y can be negative.
+     */
+    QPointF imageOffset() const;
+
+    /**
+     * The scroll position, in zoomed image coordinates.
+     * x and y are always between 0 and (docsize * zoom - viewsize)
+     */
+    QPointF scrollPos() const;
+    void setScrollPos(const QPointF& pos);
+
+    QPointF mapToView(const QPointF& imagePos) const;
+    QPoint mapToView(const QPoint& imagePos) const;
+    QRectF mapToView(const QRectF& imageRect) const;
+    QRect mapToView(const QRect& imageRect) const;
+
+    QPointF mapToImage(const QPointF& viewPos) const;
+    QPoint mapToImage(const QPoint& viewPos) const;
+    QRectF mapToImage(const QRectF& viewRect) const;
+    QRect mapToImage(const QRect& viewRect) const;
+
+    void setEnlargeSmallerImages(bool value);
+
+public Q_SLOTS:
+    void updateCursor();
+
+Q_SIGNALS:
+    void zoomToFitChanged(bool);
+    void zoomChanged(qreal);
+    void zoomInRequested(const QPointF&);
+    void zoomOutRequested(const QPointF&);
+    void scrollPosChanged();
+
+protected:
+    void setChildItem(QGraphicsItem*);
+    virtual void loadFromDocument() = 0;
+    virtual void onZoomChanged() = 0;
+    /**
+     * Called when the offset changes.
+     * Note: to avoid multiple adjustments, this is not called if zoom changes!
+     */
+    virtual void onImageOffsetChanged() = 0;
+    /**
+     * Called when the scrollPos changes.
+     * Note: to avoid multiple adjustments, this is not called if zoom changes!
+     */
+    virtual void onScrollPosChanged(const QPointF& oldPos) = 0;
+
+    void resizeEvent(QGraphicsSceneResizeEvent* event);
+
+    void keyPressEvent(QKeyEvent* event);
+    void mousePressEvent(QGraphicsSceneMouseEvent* event);
+    void mouseMoveEvent(QGraphicsSceneMouseEvent* event);
+    void mouseReleaseEvent(QGraphicsSceneMouseEvent* event);
+
+private:
+    friend class AbstractImageViewPrivate;
+    AbstractImageViewPrivate* const d;
+};
+
+} // namespace
+
+#endif /* ABSTRACTIMAGEVIEW_H */

=== added file 'lib/documentview/abstractrasterimageviewtool.cpp'
--- lib/documentview/abstractrasterimageviewtool.cpp	1970-01-01 00:00:00 +0000
+++ lib/documentview/abstractrasterimageviewtool.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,55 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+
+*/
+// Self
+#include "abstractrasterimageviewtool.h"
+
+// Qt
+
+// KDE
+
+// Local
+#include "rasterimageview.h"
+
+namespace Gwenview
+{
+
+struct AbstractRasterImageViewToolPrivate {
+    RasterImageView* mRasterImageView;
+};
+
+AbstractRasterImageViewTool::AbstractRasterImageViewTool(RasterImageView* view)
+: QObject(view)
+, d(new AbstractRasterImageViewToolPrivate)
+{
+    d->mRasterImageView = view;
+}
+
+AbstractRasterImageViewTool::~AbstractRasterImageViewTool()
+{
+    delete d;
+}
+
+RasterImageView* AbstractRasterImageViewTool::imageView() const
+{
+    return d->mRasterImageView;
+}
+
+} // namespace

=== added file 'lib/documentview/abstractrasterimageviewtool.h'
--- lib/documentview/abstractrasterimageviewtool.h	1970-01-01 00:00:00 +0000
+++ lib/documentview/abstractrasterimageviewtool.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,76 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+
+*/
+#ifndef ABSTRACTRASTERIMAGEVIEWTOOL_H
+#define ABSTRACTRASTERIMAGEVIEWTOOL_H
+
+#include <lib/gwenviewlib_export.h>
+
+// Qt
+#include <QObject>
+
+// KDE
+
+// Local
+
+class QKeyEvent;
+class QGraphicsSceneHoverEvent;
+class QGraphicsSceneMouseEvent;
+class QGraphicsSceneWheelEvent;
+class QPainter;
+
+namespace Gwenview
+{
+
+class RasterImageView;
+
+struct AbstractRasterImageViewToolPrivate;
+class GWENVIEWLIB_EXPORT AbstractRasterImageViewTool : public QObject
+{
+public:
+    AbstractRasterImageViewTool(RasterImageView* view);
+    virtual ~AbstractRasterImageViewTool();
+
+    RasterImageView* imageView() const;
+
+    virtual void paint(QPainter*) {}
+
+    virtual void mousePressEvent(QGraphicsSceneMouseEvent*) {}
+    virtual void mouseMoveEvent(QGraphicsSceneMouseEvent*) {}
+    virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent*) {}
+    virtual void hoverMoveEvent(QGraphicsSceneHoverEvent*) {}
+    virtual void wheelEvent(QGraphicsSceneWheelEvent*) {}
+    virtual void keyPressEvent(QKeyEvent*) {}
+    virtual void keyReleaseEvent(QKeyEvent*) {}
+
+    virtual void toolActivated() {}
+    virtual void toolDeactivated() {}
+
+    virtual QWidget* widget() const {
+        return 0;
+    }
+
+private:
+    AbstractRasterImageViewToolPrivate * const d;
+};
+
+} // namespace
+
+#endif /* ABSTRACTRASTERIMAGEVIEWTOOL_H */

=== added file 'lib/documentview/birdeyeview.cpp'
--- lib/documentview/birdeyeview.cpp	1970-01-01 00:00:00 +0000
+++ lib/documentview/birdeyeview.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,157 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "birdeyeview.moc"
+
+// Local
+#include <lib/document/document.h>
+#include <lib/documentview/documentview.h>
+
+// KDE
+#include <kdebug.h>
+
+// Qt
+#include <QCursor>
+#include <QGraphicsSceneEvent>
+#include <QPainter>
+
+namespace Gwenview
+{
+
+static qreal MAX_SIZE = 96;
+static qreal VIEW_OFFSET = MAX_SIZE / 4;
+static qreal Y_POSITION_PERCENT = 1 / 3.;
+
+struct BirdEyeViewPrivate {
+    BirdEyeView* q;
+    DocumentView* mDocView;
+    QRectF mVisibleRect;
+    QPointF mLastDragPos;
+};
+
+BirdEyeView::BirdEyeView(DocumentView* docView)
+: QGraphicsWidget(docView)
+, d(new BirdEyeViewPrivate)
+{
+    setFlag(ItemIsSelectable);
+    d->q = this;
+    d->mDocView = docView;
+    adjustGeometry();
+
+    connect(docView->document().data(), SIGNAL(metaInfoUpdated()), SLOT(adjustGeometry()));
+    connect(docView, SIGNAL(zoomChanged(qreal)), SLOT(adjustGeometry()));
+    connect(docView, SIGNAL(zoomToFitChanged(bool)), SLOT(adjustGeometry()));
+    connect(docView, SIGNAL(positionChanged()), SLOT(adjustVisibleRect()));
+}
+
+BirdEyeView::~BirdEyeView()
+{
+    delete d;
+}
+
+void BirdEyeView::adjustGeometry()
+{
+    if (d->mDocView->zoomToFit()) {
+        hide();
+        return;
+    }
+    show();
+    QSize size = d->mDocView->document()->size();
+    size.scale(MAX_SIZE, MAX_SIZE, Qt::KeepAspectRatio);
+    QRectF rect = d->mDocView->boundingRect();
+    setGeometry(
+        QRectF(
+            rect.right() - VIEW_OFFSET - size.width(),
+            qMax(rect.top() + rect.height() * Y_POSITION_PERCENT - size.height(), 0.),
+            size.width(),
+            size.height()
+        ));
+    adjustVisibleRect();
+    setVisible(d->mVisibleRect != boundingRect());
+}
+
+void BirdEyeView::adjustVisibleRect()
+{
+    QSizeF docSize = d->mDocView->document()->size();
+    qreal viewZoom = d->mDocView->zoom();
+    qreal bevZoom = size().width() / docSize.width();
+    if (qFuzzyIsNull(viewZoom) || qFuzzyIsNull(bevZoom)) {
+        // Prevent divide-by-zero crashes
+        return;
+    }
+
+    d->mVisibleRect = QRectF(
+                          QPointF(d->mDocView->position()) / viewZoom * bevZoom,
+                          (d->mDocView->size() / viewZoom).boundedTo(docSize) * bevZoom);
+    update();
+}
+
+inline void drawTransparentRect(QPainter* painter, const QRectF& rect, const QColor& color)
+{
+    QColor bg = color;
+    bg.setAlphaF(.33);
+    QColor fg = color;
+    fg.setAlphaF(.66);
+    painter->setPen(fg);
+    painter->setBrush(bg);
+    painter->drawRect(rect.adjusted(0, 0, -1, -1));
+}
+
+void BirdEyeView::paint(QPainter* painter, const QStyleOptionGraphicsItem*, QWidget*)
+{
+    drawTransparentRect(painter, boundingRect(), Qt::black);
+    drawTransparentRect(painter, d->mVisibleRect, Qt::white);
+}
+
+void BirdEyeView::mousePressEvent(QGraphicsSceneMouseEvent* event)
+{
+    if (d->mVisibleRect.contains(event->pos())) {
+        setCursor(Qt::ClosedHandCursor);
+        d->mLastDragPos = event->pos();
+    }
+}
+
+void BirdEyeView::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
+{
+    QGraphicsItem::mouseMoveEvent(event);
+    if (d->mLastDragPos.isNull()) {
+        return;
+    }
+    qreal ratio = d->mDocView->boundingRect().width() / d->mVisibleRect.width();
+
+    QPointF mousePos = event->pos();
+    QPointF viewPos = d->mDocView->position() + (mousePos - d->mLastDragPos) * ratio;
+
+    d->mLastDragPos = mousePos;
+    d->mDocView->setPosition(viewPos.toPoint());
+}
+
+void BirdEyeView::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
+{
+    QGraphicsItem::mouseReleaseEvent(event);
+    if (d->mLastDragPos.isNull()) {
+        return;
+    }
+    setCursor(Qt::OpenHandCursor);
+    d->mLastDragPos = QPointF();
+}
+
+} // namespace

=== added file 'lib/documentview/birdeyeview.h'
--- lib/documentview/birdeyeview.h	1970-01-01 00:00:00 +0000
+++ lib/documentview/birdeyeview.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,67 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef BIRDEYEVIEW_H
+#define BIRDEYEVIEW_H
+
+// Local
+
+// KDE
+
+// Qt
+#include <QGraphicsWidget>
+
+namespace Gwenview
+{
+
+class DocumentView;
+
+class BirdEyeViewPrivate;
+/**
+ * Shows a bird-eye view of the current document. Makes it possible to scroll
+ * through the document.
+ */
+class BirdEyeView : public QGraphicsWidget
+{
+    Q_OBJECT
+public:
+    BirdEyeView(DocumentView* docView);
+    ~BirdEyeView();
+
+    void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget = 0); // reimp
+
+public Q_SLOTS:
+    void adjustGeometry();
+
+protected:
+    void mousePressEvent(QGraphicsSceneMouseEvent* event);
+    void mouseMoveEvent(QGraphicsSceneMouseEvent* event);
+    void mouseReleaseEvent(QGraphicsSceneMouseEvent* event);
+
+private Q_SLOTS:
+    void adjustVisibleRect();
+
+private:
+    BirdEyeViewPrivate* const d;
+};
+
+} // namespace
+
+#endif /* BIRDEYEVIEW_H */

=== modified file 'lib/documentview/documentview.cpp'
--- lib/documentview/documentview.cpp	2011-07-20 13:46:34 +0000
+++ lib/documentview/documentview.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -23,35 +23,43 @@
 
 // Qt
 #include <QAbstractScrollArea>
+#include <QGraphicsProxyWidget>
+#include <QGraphicsScene>
+#include <QGraphicsSceneMouseEvent>
+#include <QGraphicsSceneWheelEvent>
 #include <QMouseEvent>
 #include <QPainter>
+#include <QPropertyAnimation>
 #include <QScrollBar>
 #include <QToolButton>
 #include <QVBoxLayout>
+#include <QWeakPointer>
 
 // KDE
-#include <kaction.h>
 #include <kdebug.h>
+#include <kiconloader.h>
 #include <klocale.h>
-#include <kmodifierkeyinfo.h>
-#include <kpixmapsequence.h>
-#include <kpixmapsequencewidget.h>
-#include <kstandarddirs.h>
 #include <kurl.h>
 
 // Local
 #include <lib/document/document.h>
 #include <lib/document/documentfactory.h>
+#include <lib/documentview/abstractrasterimageviewtool.h>
+#include <lib/documentview/birdeyeview.h>
+#include <lib/documentview/loadingindicator.h>
+#include <lib/documentview/imageviewadapter.h>
 #include <lib/documentview/messageviewadapter.h>
-#include <lib/documentview/imageviewadapter.h>
+#include <lib/documentview/rasterimageview.h>
 #include <lib/documentview/svgviewadapter.h>
 #include <lib/documentview/videoviewadapter.h>
+#include <lib/graphicshudwidget.h>
+#include <lib/graphicswidgetfloater.h>
 #include <lib/gwenviewconfig.h>
 #include <lib/mimetypeutils.h>
 #include <lib/signalblocker.h>
-#include <lib/widgetfloater.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -65,585 +73,640 @@
 static const qreal REAL_DELTA = 0.001;
 static const qreal MAXIMUM_ZOOM_VALUE = qreal(DocumentView::MaximumZoom);
 
+static const int COMPARE_MARGIN = 4;
 
 struct DocumentViewPrivate {
-	DocumentView* that;
-	KActionCollection* mActionCollection;
-	KModifierKeyInfo* mModifierKeyInfo;
-	QCursor mZoomCursor;
-	QCursor mPreviousCursor;
-
-	KPixmapSequenceWidget* mLoadingIndicator;
-
-	AbstractDocumentViewAdapter* mAdapter;
-	QList<qreal> mZoomSnapValues;
-	Document::Ptr mDocument;
-	bool mCurrent;
-
-
-	void setCurrentAdapter(AbstractDocumentViewAdapter* adapter) {
-		Q_ASSERT(adapter);
-		delete mAdapter;
-		mAdapter = adapter;
-
-		mAdapter->loadConfig();
-
-		QObject::connect(mAdapter, SIGNAL(previousImageRequested()),
-			that, SIGNAL(previousImageRequested()) );
-		QObject::connect(mAdapter, SIGNAL(nextImageRequested()),
-			that, SIGNAL(nextImageRequested()) );
-		QObject::connect(mAdapter, SIGNAL(zoomInRequested(const QPoint&)),
-			that, SLOT(zoomIn(const QPoint&)) );
-		QObject::connect(mAdapter, SIGNAL(zoomOutRequested(const QPoint&)),
-			that, SLOT(zoomOut(const QPoint&)) );
-
-		that->layout()->addWidget(mAdapter->widget());
-
-		if (mAdapter->canZoom()) {
-			QObject::connect(mAdapter, SIGNAL(zoomChanged(qreal)),
-				that, SLOT(slotZoomChanged(qreal)) );
-			QObject::connect(mAdapter, SIGNAL(zoomToFitChanged(bool)),
-				that, SIGNAL(zoomToFitChanged(bool)) );
-		}
-		mAdapter->installEventFilterOnViewWidgets(that);
-
-		QAbstractScrollArea* area = qobject_cast<QAbstractScrollArea*>(mAdapter->widget());
-		if (area) {
-			QObject::connect(area->horizontalScrollBar(), SIGNAL(valueChanged(int)),
-				that, SIGNAL(positionChanged()));
-			QObject::connect(area->verticalScrollBar(), SIGNAL(valueChanged(int)),
-				that, SIGNAL(positionChanged()));
-		}
-
-		that->adapterChanged();
-		that->positionChanged();
-		if (mAdapter->canZoom()) {
-			that->zoomToFitChanged(mAdapter->zoomToFit());
-		}
-	}
-
-	void setupZoomCursor() {
-		QString path = KStandardDirs::locate("appdata", "cursors/zoom.png");
-		QPixmap cursorPixmap = QPixmap(path);
-		mZoomCursor = QCursor(cursorPixmap);
-	}
-
-	void setZoomCursor() {
-		QCursor currentCursor = mAdapter->cursor();
-		if (currentCursor.pixmap().cacheKey() == mZoomCursor.pixmap().cacheKey()) {
-			return;
-		}
-		mPreviousCursor = currentCursor;
-		mAdapter->setCursor(mZoomCursor);
-	}
-
-	void restoreCursor() {
-		mAdapter->setCursor(mPreviousCursor);
-	}
-
-	void setupLoadingIndicator() {
-		KPixmapSequence sequence("process-working", 22);
-		mLoadingIndicator = new KPixmapSequenceWidget;
-		mLoadingIndicator->setSequence(sequence);
-		mLoadingIndicator->setInterval(100);
-
-		WidgetFloater* floater = new WidgetFloater(that);
-		floater->setChildWidget(mLoadingIndicator);
-	}
-
-	void updateCaption() {
-		QString caption;
-		if (!mAdapter) {
-			emit that->captionUpdateRequested(caption);
-			return;
-		}
-
-		Document::Ptr doc = mAdapter->document();
-		if (!doc) {
-			emit that->captionUpdateRequested(caption);
-			return;
-		}
-
-		caption = doc->url().fileName();
-		QSize size = doc->size();
-		if (size.isValid()) {
-			caption +=
-				QString(" - %1x%2")
-					.arg(size.width())
-					.arg(size.height());
-			if (mAdapter->canZoom()) {
-				int intZoom = qRound(mAdapter->zoom() * 100);
-				caption += QString(" - %1%")
-					.arg(intZoom);
-			}
-		}
-		emit that->captionUpdateRequested(caption);
-	}
-
-
-	void uncheckZoomToFit() {
-		if (mAdapter->zoomToFit()) {
-			mAdapter->setZoomToFit(false);
-		}
-	}
-
-
-	void setZoom(qreal zoom, const QPoint& center = QPoint(-1, -1)) {
-		uncheckZoomToFit();
-		zoom = qBound(that->minimumZoom(), zoom, MAXIMUM_ZOOM_VALUE);
-		mAdapter->setZoom(zoom, center);
-	}
-
-
-	void updateZoomSnapValues() {
-		qreal min = that->minimumZoom();
-
-		mZoomSnapValues.clear();
-		if (min < 1.) {
-			mZoomSnapValues << min;
-			for (qreal invZoom = 16.; invZoom > 1.; invZoom /= 2.) {
-				qreal zoom = 1. / invZoom;
-				if (zoom > min) {
-					mZoomSnapValues << zoom;
-				}
-			}
-		}
-		for (qreal zoom = 1; zoom <= MAXIMUM_ZOOM_VALUE ; zoom += 1.) {
-			mZoomSnapValues << zoom;
-		}
-
-		that->minimumZoomChanged(min);
-	}
-
-
-	void showLoadingIndicator() {
-		if (!mLoadingIndicator) {
-			setupLoadingIndicator();
-		}
-		mLoadingIndicator->show();
-		mLoadingIndicator->raise();
-	}
-
-
-	void hideLoadingIndicator() {
-		if (!mLoadingIndicator) {
-			return;
-		}
-		mLoadingIndicator->hide();
-	}
-
-
-	bool adapterMousePressEventFilter(QMouseEvent* event) {
-		if (mAdapter->canZoom()) {
-			if (event->modifiers() == Qt::ControlModifier) {
-				// Ctrl + Left or right button => zoom in or out
-				if (event->button() == Qt::LeftButton) {
-					that->zoomIn(event->pos());
-				} else if (event->button() == Qt::RightButton) {
-					that->zoomOut(event->pos());
-				}
-				return true;
-			} else if (event->button() == Qt::MidButton) {
-				// Middle click => toggle zoom to fit
-				that->setZoomToFit(!mAdapter->zoomToFit());
-				return true;
-			}
-		}
-		return false;
-	}
-
-	bool adapterMouseReleaseEventFilter(QMouseEvent* event) {
-		if (mAdapter->canZoom() && event->modifiers() == Qt::ControlModifier) {
-			// Eat the mouse release so that the svg view does not restore its
-			// drag cursor on release: we want the zoom cursor to stay as long
-			// as Control is held down.
-			return true;
-		}
-		return false;
-	}
-
-	bool adapterMouseDoubleClickEventFilter(QMouseEvent* event) {
-		if (event->modifiers() == Qt::NoModifier) {
-			that->toggleFullScreenRequested();
-			return true;
-		}
-		return false;
-	}
-
-
-	bool adapterWheelEventFilter(QWheelEvent* event) {
-		if (mAdapter->canZoom() && event->modifiers() & Qt::ControlModifier) {
-			// Ctrl + wheel => zoom in or out
-			if (event->delta() > 0) {
-				that->zoomIn(event->pos());
-			} else {
-				that->zoomOut(event->pos());
-			}
-			return true;
-		}
-		if (event->modifiers() == Qt::NoModifier
-			&& GwenviewConfig::mouseWheelBehavior() == MouseWheelBehavior::Browse
-			) {
-			// Browse with mouse wheel
-			if (event->delta() > 0) {
-				that->previousImageRequested();
-			} else {
-				that->nextImageRequested();
-			}
-			return true;
-		}
-		return false;
-	}
-
-
-	bool adapterContextMenuEventFilter(QContextMenuEvent* event) {
-		// Filter out context menu if Ctrl is down to avoid showing it when
-		// zooming out with Ctrl + Right button
-		if (event->modifiers() == Qt::ControlModifier) {
-			return true;
-		}
-		return false;
-	}
+    DocumentView* q;
+    GraphicsHudWidget* mHud;
+    BirdEyeView* mBirdEyeView;
+    QWeakPointer<QPropertyAnimation> mMoveAnimation;
+    QWeakPointer<QPropertyAnimation> mFadeAnimation;
+
+    LoadingIndicator* mLoadingIndicator;
+
+    QScopedPointer<AbstractDocumentViewAdapter> mAdapter;
+    QList<qreal> mZoomSnapValues;
+    Document::Ptr mDocument;
+    bool mCurrent;
+    bool mCompareMode;
+
+    void setCurrentAdapter(AbstractDocumentViewAdapter* adapter)
+    {
+        Q_ASSERT(adapter);
+        mAdapter.reset(adapter);
+
+        adapter->widget()->setParentItem(q);
+        resizeAdapterWidget();
+
+        if (adapter->canZoom()) {
+            QObject::connect(adapter, SIGNAL(zoomChanged(qreal)),
+                             q, SLOT(slotZoomChanged(qreal)));
+            QObject::connect(adapter, SIGNAL(zoomInRequested(QPointF)),
+                             q, SLOT(zoomIn(QPointF)));
+            QObject::connect(adapter, SIGNAL(zoomOutRequested(QPointF)),
+                             q, SLOT(zoomOut(QPointF)));
+            QObject::connect(adapter, SIGNAL(zoomToFitChanged(bool)),
+                             q, SIGNAL(zoomToFitChanged(bool)));
+        }
+
+        QObject::connect(adapter, SIGNAL(scrollPosChanged()),
+                         q, SIGNAL(positionChanged()));
+
+        adapter->loadConfig();
+
+        adapter->widget()->installSceneEventFilter(q);
+        if (mCurrent) {
+            adapter->widget()->setFocus();
+        }
+
+        q->adapterChanged();
+        q->positionChanged();
+        if (adapter->canZoom()) {
+            q->zoomToFitChanged(adapter->zoomToFit());
+        }
+        if (adapter->rasterImageView()) {
+            QObject::connect(adapter->rasterImageView(), SIGNAL(currentToolChanged(AbstractRasterImageViewTool*)),
+                             q, SIGNAL(currentToolChanged(AbstractRasterImageViewTool*)));
+        }
+    }
+
+    void setupLoadingIndicator()
+    {
+        mLoadingIndicator = new LoadingIndicator(q);
+        GraphicsWidgetFloater* floater = new GraphicsWidgetFloater(q);
+        floater->setChildWidget(mLoadingIndicator);
+    }
+
+    QToolButton* createHudButton(const QString& text, const char* iconName, bool showText)
+    {
+        QToolButton* button = new QToolButton;
+        if (showText) {
+            button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
+            button->setText(text);
+        } else {
+            button->setToolTip(text);
+        }
+        button->setIcon(SmallIcon(iconName));
+        return button;
+    }
+
+    void setupHud()
+    {
+        QToolButton* trashButton = createHudButton(i18n("Trash"), "user-trash", false);
+        QToolButton* deselectButton = createHudButton(i18n("Deselect"), "list-remove", true);
+
+        QWidget* content = new QWidget;
+        QHBoxLayout* layout = new QHBoxLayout(content);
+        layout->setMargin(0);
+        layout->setSpacing(4);
+        layout->addWidget(trashButton);
+        layout->addWidget(deselectButton);
+
+        mHud = new GraphicsHudWidget(q);
+        mHud->init(content, GraphicsHudWidget::OptionNone);
+        GraphicsWidgetFloater* floater = new GraphicsWidgetFloater(q);
+        floater->setChildWidget(mHud);
+        floater->setAlignment(Qt::AlignBottom | Qt::AlignHCenter);
+
+        QObject::connect(trashButton, SIGNAL(clicked()), q, SLOT(emitHudTrashClicked()));
+        QObject::connect(deselectButton, SIGNAL(clicked()), q, SLOT(emitHudDeselectClicked()));
+
+        mHud->hide();
+    }
+
+    void setupBirdEyeView()
+    {
+        if (mBirdEyeView) {
+            delete mBirdEyeView;
+        }
+        mBirdEyeView = new BirdEyeView(q);
+    }
+
+    void updateCaption()
+    {
+        QString caption;
+
+        Document::Ptr doc = mAdapter->document();
+        if (!doc) {
+            emit q->captionUpdateRequested(caption);
+            return;
+        }
+
+        caption = doc->url().fileName();
+        QSize size = doc->size();
+        if (size.isValid()) {
+            caption +=
+                QString(" - %1x%2")
+                .arg(size.width())
+                .arg(size.height());
+            if (mAdapter->canZoom()) {
+                int intZoom = qRound(mAdapter->zoom() * 100);
+                caption += QString(" - %1%")
+                           .arg(intZoom);
+            }
+        }
+        emit q->captionUpdateRequested(caption);
+    }
+
+    void uncheckZoomToFit()
+    {
+        if (mAdapter->zoomToFit()) {
+            mAdapter->setZoomToFit(false);
+        }
+    }
+
+    void setZoom(qreal zoom, const QPointF& center = QPointF(-1, -1))
+    {
+        uncheckZoomToFit();
+        zoom = qBound(q->minimumZoom(), zoom, MAXIMUM_ZOOM_VALUE);
+        mAdapter->setZoom(zoom, center);
+    }
+
+    void updateZoomSnapValues()
+    {
+        qreal min = q->minimumZoom();
+
+        mZoomSnapValues.clear();
+        if (min < 1.) {
+            mZoomSnapValues << min;
+            for (qreal invZoom = 16.; invZoom > 1.; invZoom /= 2.) {
+                qreal zoom = 1. / invZoom;
+                if (zoom > min) {
+                    mZoomSnapValues << zoom;
+                }
+            }
+        }
+        for (qreal zoom = 1; zoom <= MAXIMUM_ZOOM_VALUE ; zoom += 1.) {
+            mZoomSnapValues << zoom;
+        }
+
+        q->minimumZoomChanged(min);
+    }
+
+    void showLoadingIndicator()
+    {
+        if (!mLoadingIndicator) {
+            setupLoadingIndicator();
+        }
+        mLoadingIndicator->show();
+        mLoadingIndicator->setZValue(1);
+    }
+
+    void hideLoadingIndicator()
+    {
+        if (!mLoadingIndicator) {
+            return;
+        }
+        mLoadingIndicator->hide();
+    }
+
+    void animate(QPropertyAnimation* anim)
+    {
+        QObject::connect(anim, SIGNAL(finished()),
+                         q, SLOT(slotAnimationFinished()));
+        anim->setDuration(500);
+        // FIXME: If anim is not started with a QueuedConnection, then this fails:
+        // - Start Gwenview
+        // - Browse a folder
+        // - Click an image => nothing appears!
+        QMetaObject::invokeMethod(anim, "start", Qt::QueuedConnection);
+    }
+
+    void resizeAdapterWidget()
+    {
+        QRectF rect = QRectF(QPointF(0, 0), q->boundingRect().size());
+        if (mCompareMode) {
+            rect.adjust(COMPARE_MARGIN, COMPARE_MARGIN, -COMPARE_MARGIN, -COMPARE_MARGIN);
+        }
+        mAdapter->widget()->setGeometry(rect);
+    }
+
+    void fadeTo(qreal value)
+    {
+        if (mFadeAnimation.data()) {
+            // Reuse existing fade animation
+            mFadeAnimation.data()->stop();
+            mFadeAnimation.data()->setStartValue(q->opacity());
+            mFadeAnimation.data()->setEndValue(value);
+            mFadeAnimation.data()->start();
+            return;
+        }
+        // Create a new fade animation
+        QPropertyAnimation* anim = new QPropertyAnimation(q, "opacity");
+        anim->setStartValue(q->opacity());
+        anim->setEndValue(value);
+        animate(anim);
+        mFadeAnimation = anim;
+    }
 };
 
-
-DocumentView::DocumentView(QWidget* parent, KActionCollection* actionCollection)
-: QWidget(parent)
-, d(new DocumentViewPrivate) {
-	d->that = this;
-	d->mActionCollection = actionCollection;
-	d->mModifierKeyInfo = new KModifierKeyInfo(this);
-	connect(d->mModifierKeyInfo, SIGNAL(keyPressed(Qt::Key, bool)), SLOT(slotKeyPressed(Qt::Key, bool)));
-	d->mLoadingIndicator = 0;
-	QVBoxLayout* layout = new QVBoxLayout(this);
-	layout->setMargin(0);
-	d->mAdapter = 0;
-	d->setupZoomCursor();
-	d->setCurrentAdapter(new MessageViewAdapter(this));
-	d->mCurrent = false;
-}
-
-
-DocumentView::~DocumentView() {
-	delete d;
-}
-
-
-AbstractDocumentViewAdapter* DocumentView::adapter() const {
-	return d->mAdapter;
-}
-
-
-void DocumentView::createAdapterForDocument() {
-	Q_ASSERT(d->mAdapter);
-	const MimeTypeUtils::Kind documentKind = d->mDocument->kind();
-	if (documentKind != MimeTypeUtils::KIND_UNKNOWN && documentKind == d->mAdapter->kind()) {
-		// Do not reuse for KIND_UNKNOWN: we may need to change the message
-		LOG("Reusing current adapter");
-		return;
-	}
-	AbstractDocumentViewAdapter* adapter = 0;
-	switch (documentKind) {
-	case MimeTypeUtils::KIND_RASTER_IMAGE:
-		adapter = new ImageViewAdapter(this);
-		break;
-	case MimeTypeUtils::KIND_SVG_IMAGE:
-		adapter = new SvgViewAdapter(this);
-		break;
-	case MimeTypeUtils::KIND_VIDEO:
-		adapter = new VideoViewAdapter(this);
-		connect(adapter, SIGNAL(videoFinished()),
-			SIGNAL(videoFinished()));
-		break;
-	case MimeTypeUtils::KIND_UNKNOWN:
-		adapter = new MessageViewAdapter(this);
-		static_cast<MessageViewAdapter*>(adapter)->setErrorMessage(i18n("Gwenview does not know how to display this kind of document"));
-		break;
-	default:
-		kWarning() << "should not be called for documentKind=" << documentKind;
-		adapter = new MessageViewAdapter(this);
-		break;
-	}
-
-	d->setCurrentAdapter(adapter);
-}
-
-
-void DocumentView::openUrl(const KUrl& url) {
-	if (d->mDocument) {
-		disconnect(d->mDocument.data(), 0, this, 0);
-	}
-	d->mDocument = DocumentFactory::instance()->load(url);
-	connect(d->mDocument.data(), SIGNAL(busyChanged(const KUrl&, bool)), SLOT(slotBusyChanged(const KUrl&, bool)));
-
-	if (d->mDocument->loadingState() < Document::KindDetermined) {
-		MessageViewAdapter* messageViewAdapter = qobject_cast<MessageViewAdapter*>(d->mAdapter);
-		if (messageViewAdapter) {
-			messageViewAdapter->setInfoMessage(QString());
-		}
-		d->showLoadingIndicator();
-		connect(d->mDocument.data(), SIGNAL(kindDetermined(const KUrl&)),
-			SLOT(finishOpenUrl()));
-	} else {
-		finishOpenUrl();
-	}
-}
-
-
-void DocumentView::finishOpenUrl() {
-	disconnect(d->mDocument.data(), SIGNAL(kindDetermined(const KUrl&)),
-		this, SLOT(finishOpenUrl()));
-	if (d->mDocument->loadingState() < Document::KindDetermined) {
-		kWarning() << "d->mDocument->loadingState() < Document::KindDetermined, this should not happen!";
-		return;
-	}
-
-	if (d->mDocument->loadingState() == Document::LoadingFailed) {
-		slotLoadingFailed();
-		return;
-	}
-	createAdapterForDocument();
-
-	connect(d->mDocument.data(), SIGNAL(downSampledImageReady()),
-		SLOT(slotLoaded()) );
-	connect(d->mDocument.data(), SIGNAL(loaded(const KUrl&)),
-		SLOT(slotLoaded()) );
-	connect(d->mDocument.data(), SIGNAL(loadingFailed(const KUrl&)),
-		SLOT(slotLoadingFailed()) );
-	d->mAdapter->setDocument(d->mDocument);
-	d->updateCaption();
-
-	if (d->mDocument->loadingState() == Document::Loaded) {
-		slotLoaded();
-	}
-}
-
-
-void DocumentView::reset() {
-	d->hideLoadingIndicator();
-	if (d->mDocument) {
-		disconnect(d->mDocument.data(), 0, this, 0);
-		d->mDocument = 0;
-	}
-	d->setCurrentAdapter(new MessageViewAdapter(this));
-}
-
-
-bool DocumentView::isEmpty() const {
-	return d->mAdapter->kind() == MimeTypeUtils::KIND_UNKNOWN;
-}
-
-
-void DocumentView::slotLoaded() {
-	d->hideLoadingIndicator();
-	d->updateCaption();
-	d->updateZoomSnapValues();
-	if (!d->mAdapter->zoomToFit()) {
-		qreal min = minimumZoom();
-		if (d->mAdapter->zoom() < min) {
-			d->mAdapter->setZoom(min);
-		}
-	}
-	emit completed();
-}
-
-
-void DocumentView::slotLoadingFailed() {
-	d->hideLoadingIndicator();
-	MessageViewAdapter* adapter = new MessageViewAdapter(this);
-	adapter->setDocument(d->mDocument);
-	QString message = i18n("Loading <filename>%1</filename> failed", d->mDocument->url().fileName());
-	adapter->setErrorMessage(message, d->mDocument->errorString());
-	d->setCurrentAdapter(adapter);
-	emit completed();
-}
-
-
-void DocumentView::setZoomToFit(bool on) {
-	if (on == d->mAdapter->zoomToFit()) {
-		return;
-	}
-	d->mAdapter->setZoomToFit(on);
-	if (!on) {
-		d->mAdapter->setZoom(1.);
-	}
-}
-
-
-bool DocumentView::zoomToFit() const {
-	return d->mAdapter->zoomToFit();
-}
-
-
-void DocumentView::zoomActualSize() {
-	d->uncheckZoomToFit();
-	d->mAdapter->setZoom(1.);
-}
-
-
-void DocumentView::zoomIn(const QPoint& center) {
-	qreal currentZoom = d->mAdapter->zoom();
-
-	Q_FOREACH(qreal zoom, d->mZoomSnapValues) {
-		if (zoom > currentZoom + REAL_DELTA) {
-			d->setZoom(zoom, center);
-			return;
-		}
-	}
-}
-
-
-void DocumentView::zoomOut(const QPoint& center) {
-	qreal currentZoom = d->mAdapter->zoom();
-
-	QListIterator<qreal> it(d->mZoomSnapValues);
-	it.toBack();
-	while (it.hasPrevious()) {
-		qreal zoom = it.previous();
-		if (zoom < currentZoom - REAL_DELTA) {
-			d->setZoom(zoom, center);
-			return;
-		}
-	}
-}
-
-
-void DocumentView::slotZoomChanged(qreal zoom) {
-	d->updateCaption();
-	zoomChanged(zoom);
-}
-
-
-void DocumentView::setZoom(qreal zoom) {
-	d->setZoom(zoom);
-}
-
-
-qreal DocumentView::zoom() const {
-	return d->mAdapter->zoom();
-}
-
-
-bool DocumentView::eventFilter(QObject*, QEvent* event) {
-	switch (event->type()) {
-	case QEvent::MouseButtonPress:
-		return d->adapterMousePressEventFilter(static_cast<QMouseEvent*>(event));
-	case QEvent::MouseButtonRelease:
-		return d->adapterMouseReleaseEventFilter(static_cast<QMouseEvent*>(event));
-	case QEvent::Resize:
-		d->updateZoomSnapValues();
-		break;
-	case QEvent::MouseButtonDblClick:
-		return d->adapterMouseDoubleClickEventFilter(static_cast<QMouseEvent*>(event));
-	case QEvent::Wheel:
-		return d->adapterWheelEventFilter(static_cast<QWheelEvent*>(event));
-	case QEvent::ContextMenu:
-		return d->adapterContextMenuEventFilter(static_cast<QContextMenuEvent*>(event));
-	case QEvent::FocusIn:
-		focused(this);
-		break;
-	default:
-		break;
-	}
-
-	return false;
-}
-
-
-void DocumentView::paintEvent(QPaintEvent* event) {
-	QWidget::paintEvent(event);
-	if (layout()->margin() == 0) {
-		return;
-	}
-	QPainter painter(this);
-	if (d->mCurrent) {
-		painter.setBrush(Qt::NoBrush);
-		painter.setPen(QPen(palette().highlight().color(), 2));
-		painter.setRenderHint(QPainter::Antialiasing);
-		QRectF selectionRect = QRectF(rect()).adjusted(2, 2, -2, -2);
-		painter.drawRoundedRect(selectionRect, 3, 3);
-	}
-}
-
-
-void DocumentView::slotBusyChanged(const KUrl&, bool busy) {
-	if (busy) {
-		d->showLoadingIndicator();
-	} else {
-		d->hideLoadingIndicator();
-	}
-}
-
-
-qreal DocumentView::minimumZoom() const {
-	// There is no point zooming out less than zoomToFit, but make sure it does
-	// not get too small either
-	return qMax(0.001, qMin(double(d->mAdapter->computeZoomToFit()), 1.));
-}
-
-
-void DocumentView::setCompareMode(bool compare) {
-	layout()->setMargin(compare ? 4 : 0);
-}
-
-
-void DocumentView::setCurrent(bool value) {
-	d->mCurrent = value;
-	if (value) {
-		d->mAdapter->widget()->setFocus();
-	}
-	update();
-}
-
-
-bool DocumentView::isCurrent() const {
-	return d->mCurrent;
-}
-
-
-QPoint DocumentView::position() const {
-	QAbstractScrollArea* area = qobject_cast<QAbstractScrollArea*>(d->mAdapter->widget());
-	if (!area) {
-		return QPoint();
-	}
-	return QPoint(
-		area->horizontalScrollBar()->value(),
-		area->verticalScrollBar()->value()
-		);
-}
-
-
-void DocumentView::setPosition(const QPoint& pos) {
-	QAbstractScrollArea* area = qobject_cast<QAbstractScrollArea*>(d->mAdapter->widget());
-	if (!area) {
-		return;
-	}
-	area->horizontalScrollBar()->setValue(pos.x());
-	area->verticalScrollBar()->setValue(pos.y());
-}
-
-
-void DocumentView::slotKeyPressed(Qt::Key key, bool pressed)
-{
-	if (key == Qt::Key_Control) {
-		if (pressed) {
-			d->setZoomCursor();
-		} else {
-			d->restoreCursor();
-		}
-	}
-}
-
-
-Document::Ptr DocumentView::document() const {
-	return d->mDocument;
-}
-
-
-KUrl DocumentView::url() const {
-	Document::Ptr doc = d->mDocument;
-	return doc ? doc->url() : KUrl();
-}
-
+DocumentView::DocumentView(QGraphicsScene* scene)
+: d(new DocumentViewPrivate)
+{
+    setFlag(ItemIsFocusable);
+    setFlag(ItemIsSelectable);
+    setFlag(ItemClipsChildrenToShape);
+
+    d->q = this;
+    d->mLoadingIndicator = 0;
+    d->mBirdEyeView = 0;
+    d->mCurrent = false;
+    d->mCompareMode = false;
+
+    setOpacity(0);
+
+    scene->addItem(this);
+
+    d->setupHud();
+    d->setCurrentAdapter(new MessageViewAdapter);
+}
+
+DocumentView::~DocumentView()
+{
+    delete d;
+}
+
+void DocumentView::createAdapterForDocument()
+{
+    const MimeTypeUtils::Kind documentKind = d->mDocument->kind();
+    if (d->mAdapter && documentKind == d->mAdapter->kind() && documentKind != MimeTypeUtils::KIND_UNKNOWN) {
+        // Do not reuse for KIND_UNKNOWN: we may need to change the message
+        LOG("Reusing current adapter");
+        return;
+    }
+    AbstractDocumentViewAdapter* adapter = 0;
+    switch (documentKind) {
+    case MimeTypeUtils::KIND_RASTER_IMAGE:
+        adapter = new ImageViewAdapter;
+        break;
+    case MimeTypeUtils::KIND_SVG_IMAGE:
+        adapter = new SvgViewAdapter;
+        break;
+    case MimeTypeUtils::KIND_VIDEO:
+        adapter = new VideoViewAdapter;
+        connect(adapter, SIGNAL(videoFinished()),
+                SIGNAL(videoFinished()));
+        break;
+    case MimeTypeUtils::KIND_UNKNOWN:
+        adapter = new MessageViewAdapter;
+        static_cast<MessageViewAdapter*>(adapter)->setErrorMessage(i18n("Gwenview does not know how to display this kind of document"));
+        break;
+    default:
+        kWarning() << "should not be called for documentKind=" << documentKind;
+        adapter = new MessageViewAdapter;
+        break;
+    }
+
+    d->setCurrentAdapter(adapter);
+}
+
+void DocumentView::openUrl(const KUrl& url)
+{
+    if (d->mDocument) {
+        disconnect(d->mDocument.data(), 0, this, 0);
+    }
+    d->mDocument = DocumentFactory::instance()->load(url);
+    connect(d->mDocument.data(), SIGNAL(busyChanged(KUrl, bool)), SLOT(slotBusyChanged(KUrl, bool)));
+
+    if (d->mDocument->loadingState() < Document::KindDetermined) {
+        MessageViewAdapter* messageViewAdapter = qobject_cast<MessageViewAdapter*>(d->mAdapter.data());
+        if (messageViewAdapter) {
+            messageViewAdapter->setInfoMessage(QString());
+        }
+        d->showLoadingIndicator();
+        connect(d->mDocument.data(), SIGNAL(kindDetermined(KUrl)),
+                SLOT(finishOpenUrl()));
+    } else {
+        finishOpenUrl();
+    }
+    d->setupBirdEyeView();
+}
+
+void DocumentView::finishOpenUrl()
+{
+    disconnect(d->mDocument.data(), SIGNAL(kindDetermined(KUrl)),
+               this, SLOT(finishOpenUrl()));
+    if (d->mDocument->loadingState() < Document::KindDetermined) {
+        kWarning() << "d->mDocument->loadingState() < Document::KindDetermined, this should not happen!";
+        return;
+    }
+
+    if (d->mDocument->loadingState() == Document::LoadingFailed) {
+        slotLoadingFailed();
+        return;
+    }
+    createAdapterForDocument();
+
+    connect(d->mDocument.data(), SIGNAL(downSampledImageReady()),
+            SLOT(slotLoaded()));
+    connect(d->mDocument.data(), SIGNAL(loaded(KUrl)),
+            SLOT(slotLoaded()));
+    connect(d->mDocument.data(), SIGNAL(loadingFailed(KUrl)),
+            SLOT(slotLoadingFailed()));
+    d->mAdapter->setDocument(d->mDocument);
+    d->updateCaption();
+
+    if (d->mDocument->loadingState() == Document::Loaded) {
+        slotLoaded();
+    }
+}
+
+bool DocumentView::isEmpty() const
+{
+    return qobject_cast<EmptyAdapter*>(d->mAdapter.data());
+}
+
+void DocumentView::loadAdapterConfig()
+{
+    d->mAdapter->loadConfig();
+}
+
+RasterImageView* DocumentView::imageView() const
+{
+    return d->mAdapter->rasterImageView();
+}
+
+void DocumentView::slotLoaded()
+{
+    d->hideLoadingIndicator();
+    d->updateCaption();
+    d->updateZoomSnapValues();
+    if (!d->mAdapter->zoomToFit()) {
+        qreal min = minimumZoom();
+        if (d->mAdapter->zoom() < min) {
+            d->mAdapter->setZoom(min);
+        }
+    }
+    emit completed();
+}
+
+void DocumentView::slotLoadingFailed()
+{
+    d->hideLoadingIndicator();
+    MessageViewAdapter* adapter = new MessageViewAdapter;
+    adapter->setDocument(d->mDocument);
+    QString message = i18n("Loading <filename>%1</filename> failed", d->mDocument->url().fileName());
+    adapter->setErrorMessage(message, d->mDocument->errorString());
+    d->setCurrentAdapter(adapter);
+    emit completed();
+}
+
+bool DocumentView::canZoom() const
+{
+    return d->mAdapter->canZoom();
+}
+
+void DocumentView::setZoomToFit(bool on)
+{
+    if (on == d->mAdapter->zoomToFit()) {
+        return;
+    }
+    d->mAdapter->setZoomToFit(on);
+    if (!on) {
+        d->mAdapter->setZoom(1.);
+    }
+}
+
+bool DocumentView::zoomToFit() const
+{
+    return d->mAdapter->zoomToFit();
+}
+
+void DocumentView::zoomActualSize()
+{
+    d->uncheckZoomToFit();
+    d->mAdapter->setZoom(1.);
+}
+
+void DocumentView::zoomIn(const QPointF& center)
+{
+    qreal currentZoom = d->mAdapter->zoom();
+
+    Q_FOREACH(qreal zoom, d->mZoomSnapValues) {
+        if (zoom > currentZoom + REAL_DELTA) {
+            d->setZoom(zoom, center);
+            return;
+        }
+    }
+}
+
+void DocumentView::zoomOut(const QPointF& center)
+{
+    qreal currentZoom = d->mAdapter->zoom();
+
+    QListIterator<qreal> it(d->mZoomSnapValues);
+    it.toBack();
+    while (it.hasPrevious()) {
+        qreal zoom = it.previous();
+        if (zoom < currentZoom - REAL_DELTA) {
+            d->setZoom(zoom, center);
+            return;
+        }
+    }
+}
+
+void DocumentView::slotZoomChanged(qreal zoom)
+{
+    d->updateCaption();
+    zoomChanged(zoom);
+}
+
+void DocumentView::setZoom(qreal zoom)
+{
+    d->setZoom(zoom);
+}
+
+qreal DocumentView::zoom() const
+{
+    return d->mAdapter->zoom();
+}
+
+void DocumentView::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
+{
+    if (event->modifiers() == Qt::NoModifier) {
+        toggleFullScreenRequested();
+    }
+}
+
+void DocumentView::wheelEvent(QGraphicsSceneWheelEvent* event)
+{
+    if (d->mAdapter->canZoom() && event->modifiers() & Qt::ControlModifier) {
+        // Ctrl + wheel => zoom in or out
+        if (event->delta() > 0) {
+            zoomIn(event->pos());
+        } else {
+            zoomOut(event->pos());
+        }
+        return;
+    }
+    if (event->modifiers() == Qt::NoModifier
+            && GwenviewConfig::mouseWheelBehavior() == MouseWheelBehavior::Browse
+       ) {
+        // Browse with mouse wheel
+        if (event->delta() > 0) {
+            previousImageRequested();
+        } else {
+            nextImageRequested();
+        }
+    }
+}
+
+void DocumentView::contextMenuEvent(QGraphicsSceneContextMenuEvent* event)
+{
+    // Filter out context menu if Ctrl is down to avoid showing it when
+    // zooming out with Ctrl + Right button
+    if (event->modifiers() != Qt::ControlModifier) {
+        contextMenuRequested();
+    }
+}
+
+void DocumentView::paint(QPainter* painter, const QStyleOptionGraphicsItem* /*option*/, QWidget* /*widget*/)
+{
+    if (!d->mCompareMode) {
+        return;
+    }
+    if (d->mCurrent) {
+        painter->save();
+        painter->setBrush(Qt::NoBrush);
+        painter->setPen(QPen(palette().highlight().color(), 2));
+        painter->setRenderHint(QPainter::Antialiasing);
+        QRectF selectionRect = boundingRect().adjusted(2, 2, -2, -2);
+        painter->drawRoundedRect(selectionRect, 3, 3);
+        painter->restore();
+    }
+}
+
+void DocumentView::slotBusyChanged(const KUrl&, bool busy)
+{
+    if (busy) {
+        d->showLoadingIndicator();
+    } else {
+        d->hideLoadingIndicator();
+    }
+}
+
+qreal DocumentView::minimumZoom() const
+{
+    // There is no point zooming out less than zoomToFit, but make sure it does
+    // not get too small either
+    return qMax(0.001, qMin(double(d->mAdapter->computeZoomToFit()), 1.));
+}
+
+void DocumentView::setCompareMode(bool compare)
+{
+    d->mCompareMode = compare;
+    d->resizeAdapterWidget();
+    if (compare) {
+        d->mHud->show();
+        d->mHud->setZValue(1);
+    } else {
+        d->mHud->hide();
+    }
+}
+
+void DocumentView::setCurrent(bool value)
+{
+    d->mCurrent = value;
+    if (value) {
+        d->mAdapter->widget()->setFocus();
+    }
+    update();
+}
+
+bool DocumentView::isCurrent() const
+{
+    return d->mCurrent;
+}
+
+QPoint DocumentView::position() const
+{
+    return d->mAdapter->scrollPos().toPoint();
+}
+
+void DocumentView::setPosition(const QPoint& pos)
+{
+    d->mAdapter->setScrollPos(pos);
+}
+
+Document::Ptr DocumentView::document() const
+{
+    return d->mDocument;
+}
+
+KUrl DocumentView::url() const
+{
+    Document::Ptr doc = d->mDocument;
+    return doc ? doc->url() : KUrl();
+}
+
+void DocumentView::emitHudDeselectClicked()
+{
+    hudDeselectClicked(this);
+}
+
+void DocumentView::emitHudTrashClicked()
+{
+    hudTrashClicked(this);
+}
+
+void DocumentView::emitFocused()
+{
+    focused(this);
+}
+
+void DocumentView::setGeometry(const QRectF& rect)
+{
+    QGraphicsWidget::setGeometry(rect);
+    d->resizeAdapterWidget();
+    if (d->mBirdEyeView) {
+        d->mBirdEyeView->adjustGeometry();
+    }
+}
+
+void DocumentView::moveTo(const QRect& rect)
+{
+    if (d->mMoveAnimation) {
+        d->mMoveAnimation.data()->setEndValue(rect);
+    } else {
+        setGeometry(rect);
+    }
+}
+
+void DocumentView::moveToAnimated(const QRect& rect)
+{
+    QPropertyAnimation* anim = new QPropertyAnimation(this, "geometry");
+    anim->setStartValue(geometry());
+    anim->setEndValue(rect);
+    d->animate(anim);
+    d->mMoveAnimation = anim;
+}
+
+void DocumentView::fadeIn()
+{
+    d->fadeTo(1);
+}
+
+void DocumentView::fadeOut()
+{
+    d->fadeTo(0);
+}
+
+void DocumentView::slotAnimationFinished()
+{
+    animationFinished(this);
+}
+
+bool DocumentView::sceneEventFilter(QGraphicsItem*, QEvent* event)
+{
+    if (event->type() == QEvent::GraphicsSceneMousePress) {
+        QMetaObject::invokeMethod(this, "emitFocused", Qt::QueuedConnection);
+    }
+    return false;
+}
+
+AbstractRasterImageViewTool* DocumentView::currentTool() const
+{
+    return imageView() ? imageView()->currentTool() : 0;
+}
 
 } // namespace

=== modified file 'lib/documentview/documentview.h'
--- lib/documentview/documentview.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/documentview.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -24,7 +24,7 @@
 #include <lib/gwenviewlib_export.h>
 
 // Qt
-#include <QWidget>
+#include <QGraphicsWidget>
 
 // KDE
 #include <kactioncollection.h>
@@ -34,9 +34,11 @@
 
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-class AbstractDocumentViewAdapter;
+class AbstractRasterImageViewTool;
+class RasterImageView;
 class SlideShow;
 class ZoomWidget;
 
@@ -46,108 +48,151 @@
  * This widget can display various documents, using an instance of
  * AbstractDocumentViewAdapter
  */
-class GWENVIEWLIB_EXPORT DocumentView : public QWidget {
-	Q_OBJECT
-	Q_PROPERTY(qreal zoom READ zoom WRITE setZoom NOTIFY zoomChanged)
-	Q_PROPERTY(bool zoomToFit READ zoomToFit WRITE setZoomToFit NOTIFY zoomToFitChanged)
-	Q_PROPERTY(QPoint position READ position WRITE setPosition NOTIFY positionChanged)
+class GWENVIEWLIB_EXPORT DocumentView : public QGraphicsWidget
+{
+    Q_OBJECT
+    Q_PROPERTY(qreal zoom READ zoom WRITE setZoom NOTIFY zoomChanged)
+    Q_PROPERTY(bool zoomToFit READ zoomToFit WRITE setZoomToFit NOTIFY zoomToFitChanged)
+    Q_PROPERTY(QPoint position READ position WRITE setPosition NOTIFY positionChanged)
 public:
-	enum {
-		MaximumZoom = 16
-	};
-	DocumentView(QWidget* parent, KActionCollection*);
-	~DocumentView();
-
-	AbstractDocumentViewAdapter* adapter() const;
-
-	Document::Ptr document() const;
-
-	KUrl url() const;
-
-	void openUrl(const KUrl&);
-
-	void reset();
-
-	bool isEmpty() const;
-
-	qreal minimumZoom() const;
-
-	qreal zoom() const;
-
-	bool isCurrent() const;
-
-	void setCurrent(bool);
-
-	void setCompareMode(bool);
-
-	bool zoomToFit() const;
-
-	QPoint position() const;
+    enum {
+        MaximumZoom = 16
+    };
+
+    /**
+     * Create a new view attached to scene. We need the scene to be able to
+     * install scene event filters.
+     */
+    DocumentView(QGraphicsScene* scene);
+    ~DocumentView();
+
+    Document::Ptr document() const;
+
+    KUrl url() const;
+
+    void openUrl(const KUrl&);
+
+    /**
+     * Tells the current adapter to load its config. Used when the user changed
+     * the config while the view was visible.
+     */
+    void loadAdapterConfig();
+
+    /**
+     * Returns true if an adapter is loaded (note: adapters are also used to
+     * display error messages!)
+     */
+    bool isEmpty() const;
+
+    bool canZoom() const;
+
+    qreal minimumZoom() const;
+
+    qreal zoom() const;
+
+    bool isCurrent() const;
+
+    void setCurrent(bool);
+
+    void setCompareMode(bool);
+
+    bool zoomToFit() const;
+
+    QPoint position() const;
+
+    /**
+     * Returns the RasterImageView of the current adapter, if it has one
+     */
+    RasterImageView* imageView() const;
+
+    AbstractRasterImageViewTool* currentTool() const;
+
+    void moveTo(const QRect&);
+    void moveToAnimated(const QRect&);
+    void fadeIn();
+    void fadeOut();
+
+    void setGeometry(const QRectF& rect); // reimp
 
 public Q_SLOTS:
-	void setZoom(qreal);
-
-	void setZoomToFit(bool);
-
-	void setPosition(const QPoint&);
+    void setZoom(qreal);
+
+    void setZoomToFit(bool);
+
+    void setPosition(const QPoint&);
 
 Q_SIGNALS:
-	/**
-	 * Emitted when the part has finished loading
-	 */
-	void completed();
-
-	void previousImageRequested();
-
-	void nextImageRequested();
-
-	void captionUpdateRequested(const QString&);
-
-	void toggleFullScreenRequested();
-
-	void videoFinished();
-
-	void minimumZoomChanged(qreal);
-
-	void zoomChanged(qreal);
-
-	void adapterChanged();
-
-	void focused(DocumentView*);
-
-	void zoomToFitChanged(bool);
-
-	void positionChanged();
+    /**
+     * Emitted when the part has finished loading
+     */
+    void completed();
+
+    void previousImageRequested();
+
+    void nextImageRequested();
+
+    void captionUpdateRequested(const QString&);
+
+    void toggleFullScreenRequested();
+
+    void videoFinished();
+
+    void minimumZoomChanged(qreal);
+
+    void zoomChanged(qreal);
+
+    void adapterChanged();
+
+    void focused(DocumentView*);
+
+    void zoomToFitChanged(bool);
+
+    void positionChanged();
+
+    void hudTrashClicked(DocumentView*);
+    void hudDeselectClicked(DocumentView*);
+
+    void animationFinished(DocumentView*);
+
+    void contextMenuRequested();
+
+    void currentToolChanged(AbstractRasterImageViewTool*);
 
 protected:
-	virtual bool eventFilter(QObject*, QEvent* event);
+    void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget = 0);
 
-	virtual void paintEvent(QPaintEvent*);
+    void mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event);
+    void wheelEvent(QGraphicsSceneWheelEvent* event);
+    void contextMenuEvent(QGraphicsSceneContextMenuEvent* event);
+    bool sceneEventFilter(QGraphicsItem*, QEvent*);
 
 private Q_SLOTS:
-	void finishOpenUrl();
-	void slotLoaded();
-	void slotLoadingFailed();
-
-	void zoomActualSize();
-
-	void zoomIn(const QPoint& center = QPoint(-1,-1));
-	void zoomOut(const QPoint& center = QPoint(-1,-1));
-
-	void slotZoomChanged(qreal);
-
-	void slotBusyChanged(const KUrl&, bool);
-
-	void slotKeyPressed(Qt::Key key, bool pressed);
+    void finishOpenUrl();
+    void slotLoaded();
+    void slotLoadingFailed();
+
+    void zoomActualSize();
+
+    void zoomIn(const QPointF& center = QPointF(-1, -1));
+    void zoomOut(const QPointF& center = QPointF(-1, -1));
+
+    void slotZoomChanged(qreal);
+
+    void slotBusyChanged(const KUrl&, bool);
+
+    void emitHudTrashClicked();
+    void emitHudDeselectClicked();
+    void emitFocused();
+
+    void slotAnimationFinished();
 
 private:
-	friend struct DocumentViewPrivate;
-	DocumentViewPrivate* const d;
+    friend struct DocumentViewPrivate;
+    DocumentViewPrivate* const d;
 
-	void createAdapterForDocument();
+    void createAdapterForDocument();
 };
 
-
 } // namespace
 
 #endif /* DOCUMENTVIEW_H */

=== modified file 'lib/documentview/documentviewcontainer.cpp'
--- lib/documentview/documentviewcontainer.cpp	2011-07-20 13:46:34 +0000
+++ lib/documentview/documentviewcontainer.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2011 Aurélien Gâteau <agateau@kde.org>
@@ -26,131 +26,211 @@
 
 // KDE
 #include <kdebug.h>
+#include <kurl.h>
 
 // Qt
 #include <QEvent>
-#include <QPropertyAnimation>
-#include <QWidget>
+#include <QGLWidget>
+#include <QGraphicsScene>
+#include <QTimer>
+
+// libc
 #include <qmath.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-//typedef QList<DocumentView*> Row;
+typedef QSet<DocumentView*> DocumentViewSet;
 
 struct DocumentViewContainerPrivate {
-	DocumentViewContainer* q;
-	QList<DocumentView*> mItems;
+    DocumentViewContainer* q;
+    QGraphicsScene* mScene;
+    DocumentViewSet mViews;
+    DocumentViewSet mAddedViews;
+    DocumentViewSet mRemovedViews;
+    QTimer* mLayoutUpdateTimer;
+
+    void scheduleLayoutUpdate()
+    {
+        mLayoutUpdateTimer->start();
+    }
+
+    /**
+     * Remove view from set, move it to mRemovedViews so that it is later
+     * deleted.
+     */
+    bool removeFromSet(DocumentView* view, DocumentViewSet* set)
+    {
+        DocumentViewSet::Iterator it = set->find(view);
+        if (it == set->end()) {
+            return false;
+        }
+        set->erase(it);
+        mRemovedViews << view;
+        scheduleLayoutUpdate();
+        return true;
+    }
+
+    void resetSet(DocumentViewSet* set)
+    {
+        qDeleteAll(*set);
+        set->clear();
+    }
 };
 
-
 DocumentViewContainer::DocumentViewContainer(QWidget* parent)
-: QWidget(parent)
-, d(new DocumentViewContainerPrivate) {
-	d->q = this;
-	setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
-}
-
-
-DocumentViewContainer::~DocumentViewContainer() {
-	delete d;
-}
-
-
-void DocumentViewContainer::addView(DocumentView* view) {
-	d->mItems << view;
-	view->setParent(this);
-	view->installEventFilter(this);
-}
-
-
-bool DocumentViewContainer::eventFilter(QObject*, QEvent* event) {
-	switch (event->type()) {
-	case QEvent::Show:
-	case QEvent::Hide:
-		updateLayout();
-		break;
-	default:
-		break;
-	}
-	return false;
-}
-
-
-void DocumentViewContainer::showEvent(QShowEvent* event) {
-	QWidget::showEvent(event);
-	updateLayout();
-}
-
-
-void DocumentViewContainer::resizeEvent(QResizeEvent* event) {
-	QWidget::resizeEvent(event);
-	updateLayout();
-}
-
-
-
-
-void DocumentViewContainer::updateLayout() {
-	// List visible views
-	QList<DocumentView*> visibleViews;
-	Q_FOREACH(DocumentView* view, d->mItems) {
-		if (!view->isEmpty()) {
-			visibleViews << view;
-		}
-	}
-	if (visibleViews.isEmpty()) {
-		return;
-	}
-
-	// Compute column count
-	int colCount;
-	switch (visibleViews.count()) {
-	case 1:
-		colCount = 1;
-		break;
-	case 2:
-		colCount = 2;
-		break;
-	case 3:
-		colCount = 3;
-		break;
-	case 4:
-		colCount = 2;
-		break;
-	case 5:
-		colCount = 3;
-		break;
-	case 6:
-		colCount = 3;
-		break;
-	default:
-		colCount = 3;
-		break;
-	}
-
-	int rowCount = qCeil(visibleViews.count() / qreal(colCount));
-	Q_ASSERT(rowCount > 0);
-	int viewWidth = width() / colCount;
-	int viewHeight = height() / rowCount;
-
-	int col = 0;
-	int row = 0;
-
-	Q_FOREACH(DocumentView* view, visibleViews) {
-		QRect rect;
-		rect.setLeft(col * viewWidth);
-		rect.setTop(row * viewHeight);
-		rect.setWidth(viewWidth);
-		rect.setHeight(viewHeight);
-
-		view->setGeometry(rect);
-
-		++col;
-		if (col == colCount) {
-			col = 0;
-			++row;
-		}
-	}
+: QGraphicsView(parent)
+, d(new DocumentViewContainerPrivate)
+{
+    d->q = this;
+    d->mScene = new QGraphicsScene(this);
+    setViewport(new QGLWidget);
+    setScene(d->mScene);
+    setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
+
+    setFrameStyle(QFrame::NoFrame);
+    setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
+    setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
+
+    d->mLayoutUpdateTimer = new QTimer(this);
+    d->mLayoutUpdateTimer->setInterval(0);
+    d->mLayoutUpdateTimer->setSingleShot(true);
+    connect(d->mLayoutUpdateTimer, SIGNAL(timeout()), SLOT(updateLayout()));
+}
+
+DocumentViewContainer::~DocumentViewContainer()
+{
+    delete d;
+}
+
+DocumentView* DocumentViewContainer::createView()
+{
+    DocumentView* view = new DocumentView(d->mScene);
+    d->mAddedViews << view;
+    view->show();
+    connect(view, SIGNAL(animationFinished(DocumentView*)),
+            SLOT(slotViewAnimationFinished(DocumentView*)));
+    d->scheduleLayoutUpdate();
+    return view;
+}
+
+void DocumentViewContainer::deleteView(DocumentView* view)
+{
+    if (d->removeFromSet(view, &d->mViews)) {
+        return;
+    }
+    d->removeFromSet(view, &d->mAddedViews);
+}
+
+void DocumentViewContainer::reset()
+{
+    d->resetSet(&d->mViews);
+    d->resetSet(&d->mAddedViews);
+    d->resetSet(&d->mRemovedViews);
+}
+
+void DocumentViewContainer::showEvent(QShowEvent* event)
+{
+    QWidget::showEvent(event);
+    updateLayout();
+}
+
+void DocumentViewContainer::resizeEvent(QResizeEvent* event)
+{
+    QWidget::resizeEvent(event);
+    d->mScene->setSceneRect(rect());
+    updateLayout();
+}
+
+void DocumentViewContainer::updateLayout()
+{
+    // Stop update timer: this is useful if updateLayout() is called directly
+    // and not through scheduleLayoutUpdate()
+    d->mLayoutUpdateTimer->stop();
+    DocumentViewSet views = d->mViews | d->mAddedViews;
+
+    if (!views.isEmpty()) {
+        // Compute column count
+        int colCount;
+        switch (views.count()) {
+        case 1:
+            colCount = 1;
+            break;
+        case 2:
+            colCount = 2;
+            break;
+        case 3:
+            colCount = 3;
+            break;
+        case 4:
+            colCount = 2;
+            break;
+        case 5:
+            colCount = 3;
+            break;
+        case 6:
+            colCount = 3;
+            break;
+        default:
+            colCount = 3;
+            break;
+        }
+
+        int rowCount = qCeil(views.count() / qreal(colCount));
+        Q_ASSERT(rowCount > 0);
+        int viewWidth = width() / colCount;
+        int viewHeight = height() / rowCount;
+
+        int col = 0;
+        int row = 0;
+
+        Q_FOREACH(DocumentView * view, views) {
+            QRect rect;
+            rect.setLeft(col * viewWidth);
+            rect.setTop(row * viewHeight);
+            rect.setWidth(viewWidth);
+            rect.setHeight(viewHeight);
+
+            if (d->mViews.contains(view)) {
+                if (rect != view->geometry()) {
+                    if (d->mAddedViews.isEmpty() && d->mRemovedViews.isEmpty()) {
+                        // View moves because of a resize
+                        view->moveTo(rect);
+                    } else {
+                        // View moves because the number of views changed,
+                        // animate the change
+                        view->moveToAnimated(rect);
+                    }
+                }
+            } else {
+                view->setGeometry(rect);
+                view->fadeIn();
+            }
+
+            ++col;
+            if (col == colCount) {
+                col = 0;
+                ++row;
+            }
+        }
+    }
+
+    Q_FOREACH(DocumentView * view, d->mRemovedViews) {
+        view->fadeOut();
+    }
+}
+
+void DocumentViewContainer::slotViewAnimationFinished(DocumentView* view)
+{
+    if (d->mRemovedViews.contains(view)) {
+        d->mRemovedViews.remove(view);
+        delete view;
+        return;
+    }
+    if (d->mAddedViews.contains(view)) {
+        d->mAddedViews.remove(view);
+        d->mViews.insert(view);
+    }
 }
 
 } // namespace

=== modified file 'lib/documentview/documentviewcontainer.h'
--- lib/documentview/documentviewcontainer.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/documentviewcontainer.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2011 Aurélien Gâteau <agateau@kde.org>
@@ -28,9 +28,10 @@
 // KDE
 
 // Qt
-#include <QWidget>
+#include <QGraphicsView>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class DocumentView;
 
@@ -39,27 +40,44 @@
  * A container for DocumentViews which will arrange them to make best use of
  * available space.
  */
-class GWENVIEWLIB_EXPORT DocumentViewContainer : public QWidget {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT DocumentViewContainer : public QGraphicsView
+{
+    Q_OBJECT
 public:
-	DocumentViewContainer(QWidget* parent=0);
-	~DocumentViewContainer();
-
-	void addView(DocumentView* view);
+    DocumentViewContainer(QWidget* parent = 0);
+    ~DocumentViewContainer();
+
+    /**
+     * Create a DocumentView in the DocumentViewContainer scene
+     */
+    DocumentView* createView();
+
+    /**
+     * Delete view. Note that the view will first be faded to black before
+     * being destroyed.
+     */
+    void deleteView(DocumentView* view);
+
+    /**
+     * Immediately delete all views
+     */
+    void reset();
+
+public Q_SLOTS:
+    void updateLayout();
 
 protected:
-	bool eventFilter(QObject*, QEvent*);
-	void showEvent(QShowEvent*);
-	void resizeEvent(QResizeEvent*);
+    void showEvent(QShowEvent*);
+    void resizeEvent(QResizeEvent*);
+
+private:
+    friend class ViewItem;
+    DocumentViewContainerPrivate* const d;
 
 private Q_SLOTS:
-	void updateLayout();
-
-private:
-	DocumentViewContainerPrivate* const d;
+    void slotViewAnimationFinished(DocumentView*);
 };
 
-
 } // namespace
 
 #endif /* DOCUMENTVIEWCONTAINER_H */

=== modified file 'lib/documentview/documentviewcontroller.cpp'
--- lib/documentview/documentviewcontroller.cpp	2011-12-08 21:34:25 +0000
+++ lib/documentview/documentviewcontroller.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2011 Aurélien Gâteau <agateau@kde.org>
@@ -24,7 +24,9 @@
 // Local
 #include "abstractdocumentviewadapter.h"
 #include "documentview.h"
+#include <lib/documentview/abstractrasterimageviewtool.h>
 #include <lib/signalblocker.h>
+#include <lib/slidecontainer.h>
 #include <lib/zoomwidget.h>
 
 // KDE
@@ -36,180 +38,227 @@
 // Qt
 #include <QAction>
 #include <QEvent>
-
-namespace Gwenview {
-
+#include <QHBoxLayout>
+
+namespace Gwenview
+{
+
+/**
+ * A simple container which:
+ * - Horizontally center the tool widget
+ * - Provide a darker background
+ */
+class ToolContainerContent : public QWidget
+{
+public:
+    ToolContainerContent(QWidget* parent = 0)
+    : QWidget(parent)
+    , mLayout(new QHBoxLayout(this))
+    {
+        mLayout->setMargin(0);
+        setAutoFillBackground(true);
+        QPalette pal = palette();
+        pal.setColor(QPalette::Window, pal.color(QPalette::Window).dark(120));
+        setPalette(pal);
+    }
+
+    void setToolWidget(QWidget* widget)
+    {
+        mLayout->addWidget(widget, 0, Qt::AlignCenter);
+        setFixedHeight(widget->sizeHint().height());
+    }
+
+private:
+    QHBoxLayout* mLayout;
+};
 
 struct DocumentViewControllerPrivate {
-	DocumentViewController* q;
-	KActionCollection* mActionCollection;
-	DocumentView* mView;
-	ZoomWidget* mZoomWidget;
-
-	KAction* mZoomToFitAction;
-	KAction* mActualSizeAction;
-	KAction* mZoomInAction;
-	KAction* mZoomOutAction;
-	QList<KAction*> mActions;
-
-	void setupActions() {
-		KActionCategory* view = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface","View"), mActionCollection);
-
-		mZoomToFitAction = view->addAction("view_zoom_to_fit");
-		mZoomToFitAction->setCheckable(true);
-		mZoomToFitAction->setChecked(true);
-		mZoomToFitAction->setText(i18n("Zoom to Fit"));
-		mZoomToFitAction->setIcon(KIcon("zoom-fit-best"));
-		mZoomToFitAction->setIconText(i18nc("@action:button Zoom to fit, shown in status bar, keep it short please", "Fit"));
-
-		mActualSizeAction = view->addAction(KStandardAction::ActualSize);
-		mActualSizeAction->setIcon(KIcon("zoom-original"));
-		mActualSizeAction->setIconText(i18nc("@action:button Zoom to original size, shown in status bar, keep it short please", "100%"));
-
-		mZoomInAction = view->addAction(KStandardAction::ZoomIn);
-		mZoomOutAction = view->addAction(KStandardAction::ZoomOut);
-
-		mActions << mZoomToFitAction << mActualSizeAction << mZoomInAction << mZoomOutAction;
-	}
-
-	void connectZoomWidget() {
-		if (!mZoomWidget || !mView) {
-			return;
-		}
-
-		QObject::connect(mZoomWidget, SIGNAL(zoomChanged(qreal)),
-			mView, SLOT(setZoom(qreal)));
-
-		QObject::connect(mView, SIGNAL(minimumZoomChanged(qreal)),
-			mZoomWidget, SLOT(setMinimumZoom(qreal)));
-		QObject::connect(mView, SIGNAL(zoomChanged(qreal)),
-			mZoomWidget, SLOT(setZoom(qreal)));
-
-		mZoomWidget->setMinimumZoom(mView->minimumZoom());
-		mZoomWidget->setZoom(mView->zoom());
-	}
-
-	void updateZoomWidgetVisibility() {
-		if (!mZoomWidget) {
-			return;
-		}
-		mZoomWidget->setVisible(mView && mView->adapter()->canZoom());
-	}
-
-	void updateActions() {
-		const bool enabled = mView && mView->isVisible() && mView->adapter()->canZoom();
-		Q_FOREACH(QAction* action, mActions) {
-			action->setEnabled(enabled);
-		}
-	}
+    DocumentViewController* q;
+    KActionCollection* mActionCollection;
+    DocumentView* mView;
+    ZoomWidget* mZoomWidget;
+    SlideContainer* mToolContainer;
+    ToolContainerContent* mToolContainerContent;
+
+    KAction* mZoomToFitAction;
+    KAction* mActualSizeAction;
+    KAction* mZoomInAction;
+    KAction* mZoomOutAction;
+    QList<KAction*> mActions;
+
+    void setupActions()
+    {
+        KActionCategory* view = new KActionCategory(i18nc("@title actions category - means actions changing smth in interface", "View"), mActionCollection);
+
+        mZoomToFitAction = view->addAction("view_zoom_to_fit");
+        mZoomToFitAction->setCheckable(true);
+        mZoomToFitAction->setChecked(true);
+        mZoomToFitAction->setText(i18n("Zoom to Fit"));
+        mZoomToFitAction->setIcon(KIcon("zoom-fit-best"));
+        mZoomToFitAction->setIconText(i18nc("@action:button Zoom to fit, shown in status bar, keep it short please", "Fit"));
+
+        mActualSizeAction = view->addAction(KStandardAction::ActualSize);
+        mActualSizeAction->setIcon(KIcon("zoom-original"));
+        mActualSizeAction->setIconText(i18nc("@action:button Zoom to original size, shown in status bar, keep it short please", "100%"));
+
+        mZoomInAction = view->addAction(KStandardAction::ZoomIn);
+        mZoomOutAction = view->addAction(KStandardAction::ZoomOut);
+
+        mActions << mZoomToFitAction << mActualSizeAction << mZoomInAction << mZoomOutAction;
+    }
+
+    void connectZoomWidget()
+    {
+        if (!mZoomWidget || !mView) {
+            return;
+        }
+
+        QObject::connect(mZoomWidget, SIGNAL(zoomChanged(qreal)),
+                         mView, SLOT(setZoom(qreal)));
+
+        QObject::connect(mView, SIGNAL(minimumZoomChanged(qreal)),
+                         mZoomWidget, SLOT(setMinimumZoom(qreal)));
+        QObject::connect(mView, SIGNAL(zoomChanged(qreal)),
+                         mZoomWidget, SLOT(setZoom(qreal)));
+
+        mZoomWidget->setMinimumZoom(mView->minimumZoom());
+        mZoomWidget->setZoom(mView->zoom());
+    }
+
+    void updateZoomWidgetVisibility()
+    {
+        if (!mZoomWidget) {
+            return;
+        }
+        mZoomWidget->setVisible(mView && mView->canZoom());
+    }
+
+    void updateActions()
+    {
+        const bool enabled = mView && mView->isVisible() && mView->canZoom();
+        Q_FOREACH(QAction * action, mActions) {
+            action->setEnabled(enabled);
+        }
+    }
 };
 
-
 DocumentViewController::DocumentViewController(KActionCollection* actionCollection, QObject* parent)
 : QObject(parent)
-, d(new DocumentViewControllerPrivate) {
-	d->q = this;
-	d->mActionCollection = actionCollection;
-	d->mView = 0;
-	d->mZoomWidget = 0;
-
-	d->setupActions();
-}
-
-
-DocumentViewController::~DocumentViewController() {
-	delete d;
-}
-
-
-void DocumentViewController::setView(DocumentView* view) {
-	Q_ASSERT(view);
-	// Forget old view
-	if (d->mView) {
-		d->mView->removeEventFilter(this);
-		disconnect(d->mView, 0, this, 0);
-		disconnect(d->mView->adapter(), 0, this, 0);
-		Q_FOREACH(QAction* action, d->mActions) {
-			disconnect(action, 0, d->mView, 0);
-		}
-		disconnect(d->mZoomWidget, 0, d->mView, 0);
-	}
-
-	// Connect new view
-	d->mView = view;
-	d->mView->installEventFilter(this);
-	connect(d->mView, SIGNAL(adapterChanged()),
-		SLOT(slotAdapterChanged()));
-
-	connect(d->mView, SIGNAL(zoomToFitChanged(bool)),
-		SLOT(updateZoomToFitActionFromView()));
-
-	connect(d->mZoomToFitAction, SIGNAL(toggled(bool)),
-		d->mView, SLOT(setZoomToFit(bool)));
-	connect(d->mActualSizeAction, SIGNAL(triggered()),
-		d->mView, SLOT(zoomActualSize()));
-	connect(d->mZoomInAction, SIGNAL(triggered()),
-		d->mView, SLOT(zoomIn()));
-	connect(d->mZoomOutAction, SIGNAL(triggered()),
-		d->mView, SLOT(zoomOut()));
-
-	d->updateActions();
-	updateZoomToFitActionFromView();
-
-	// Sync zoom widget
-	d->connectZoomWidget();
-	d->updateZoomWidgetVisibility();
-}
-
-DocumentView* DocumentViewController::view() const {
-	return d->mView;
-}
-
-void DocumentViewController::setZoomWidget(ZoomWidget* widget) {
-	d->mZoomWidget = widget;
-
-	d->mZoomWidget->setActions(
-		d->mZoomToFitAction,
-		d->mActualSizeAction,
-		d->mZoomInAction,
-		d->mZoomOutAction
-		);
-
-	d->mZoomWidget->setMaximumZoom(qreal(DocumentView::MaximumZoom));
-
-	d->connectZoomWidget();
-	d->updateZoomWidgetVisibility();
-}
-
-
-ZoomWidget* DocumentViewController::zoomWidget() const {
-	return d->mZoomWidget;
-}
-
-
-void DocumentViewController::slotAdapterChanged() {
-	d->updateActions();
-	d->updateZoomWidgetVisibility();
-}
-
-
-bool DocumentViewController::eventFilter(QObject*, QEvent* event) {
-	switch (event->type()) {
-	case QEvent::Show:
-	case QEvent::Hide:
-		d->updateActions();
-		break;
-	default:
-		break;
-	}
-	return false;
-}
-
-
-void DocumentViewController::updateZoomToFitActionFromView() {
-	SignalBlocker blocker(d->mZoomToFitAction);
-	d->mZoomToFitAction->setChecked(d->mView->zoomToFit());
-}
-
+, d(new DocumentViewControllerPrivate)
+{
+    d->q = this;
+    d->mActionCollection = actionCollection;
+    d->mView = 0;
+    d->mZoomWidget = 0;
+    d->mToolContainer = 0;
+    d->mToolContainerContent = new ToolContainerContent;
+
+    d->setupActions();
+}
+
+DocumentViewController::~DocumentViewController()
+{
+    delete d;
+}
+
+void DocumentViewController::setView(DocumentView* view)
+{
+    // Forget old view
+    if (d->mView) {
+        disconnect(d->mView, 0, this, 0);
+        Q_FOREACH(QAction * action, d->mActions) {
+            disconnect(action, 0, d->mView, 0);
+        }
+        disconnect(d->mZoomWidget, 0, d->mView, 0);
+    }
+
+    // Connect new view
+    d->mView = view;
+    if (!d->mView) {
+        return;
+    }
+    connect(d->mView, SIGNAL(adapterChanged()),
+            SLOT(slotAdapterChanged()));
+    connect(d->mView, SIGNAL(zoomToFitChanged(bool)),
+            SLOT(updateZoomToFitActionFromView()));
+    connect(d->mView, SIGNAL(currentToolChanged(AbstractRasterImageViewTool*)),
+            SLOT(updateTool()));
+
+    connect(d->mZoomToFitAction, SIGNAL(toggled(bool)),
+            d->mView, SLOT(setZoomToFit(bool)));
+    connect(d->mActualSizeAction, SIGNAL(triggered()),
+            d->mView, SLOT(zoomActualSize()));
+    connect(d->mZoomInAction, SIGNAL(triggered()),
+            d->mView, SLOT(zoomIn()));
+    connect(d->mZoomOutAction, SIGNAL(triggered()),
+            d->mView, SLOT(zoomOut()));
+
+    d->updateActions();
+    updateZoomToFitActionFromView();
+    updateTool();
+
+    // Sync zoom widget
+    d->connectZoomWidget();
+    d->updateZoomWidgetVisibility();
+}
+
+DocumentView* DocumentViewController::view() const
+{
+    return d->mView;
+}
+
+void DocumentViewController::setZoomWidget(ZoomWidget* widget)
+{
+    d->mZoomWidget = widget;
+
+    d->mZoomWidget->setActions(
+        d->mZoomToFitAction,
+        d->mActualSizeAction,
+        d->mZoomInAction,
+        d->mZoomOutAction
+    );
+
+    d->mZoomWidget->setMaximumZoom(qreal(DocumentView::MaximumZoom));
+
+    d->connectZoomWidget();
+    d->updateZoomWidgetVisibility();
+}
+
+ZoomWidget* DocumentViewController::zoomWidget() const
+{
+    return d->mZoomWidget;
+}
+
+void DocumentViewController::slotAdapterChanged()
+{
+    d->updateActions();
+    d->updateZoomWidgetVisibility();
+}
+
+void DocumentViewController::updateZoomToFitActionFromView()
+{
+    SignalBlocker blocker(d->mZoomToFitAction);
+    d->mZoomToFitAction->setChecked(d->mView->zoomToFit());
+}
+
+void DocumentViewController::updateTool()
+{
+    if (!d->mToolContainer) {
+        return;
+    }
+    AbstractRasterImageViewTool* tool = d->mView->currentTool();
+    if (tool && tool->widget()) {
+        d->mToolContainerContent->setToolWidget(tool->widget());
+        d->mToolContainer->slideIn();
+    } else {
+        d->mToolContainer->slideOut();
+    }
+}
+
+void DocumentViewController::setToolContainer(SlideContainer* container)
+{
+    d->mToolContainer = container;
+    container->setContent(d->mToolContainerContent);
+}
 
 } // namespace

=== modified file 'lib/documentview/documentviewcontroller.h'
--- lib/documentview/documentviewcontroller.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/documentviewcontroller.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2011 Aurélien Gâteau <agateau@kde.org>
@@ -32,9 +32,11 @@
 
 class KActionCollection;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class DocumentView;
+class SlideContainer;
 class ZoomWidget;
 
 class DocumentViewControllerPrivate;
@@ -43,30 +45,30 @@
  * Handles all DocumentView specific actions like zooming. Calls the
  * corresponding code on its view, if any.
  */
-class GWENVIEWLIB_EXPORT DocumentViewController : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT DocumentViewController : public QObject
+{
+    Q_OBJECT
 public:
-	DocumentViewController(KActionCollection*, QObject* parent=0);
-	~DocumentViewController();
-
-	DocumentView* view() const;
-	ZoomWidget* zoomWidget() const;
-
-	void setView(DocumentView*);
-	void setZoomWidget(ZoomWidget* widget);
-
-protected:
-	bool eventFilter(QObject*, QEvent*);
+    DocumentViewController(KActionCollection*, QObject* parent = 0);
+    ~DocumentViewController();
+
+    DocumentView* view() const;
+    ZoomWidget* zoomWidget() const;
+
+    void setView(DocumentView*);
+    void setZoomWidget(ZoomWidget* widget);
+
+    void setToolContainer(SlideContainer* container);
 
 private Q_SLOTS:
-	void slotAdapterChanged();
-	void updateZoomToFitActionFromView();
+    void slotAdapterChanged();
+    void updateZoomToFitActionFromView();
+    void updateTool();
 
 private:
-	DocumentViewControllerPrivate* const d;
+    DocumentViewControllerPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* DOCUMENTVIEWCONTROLLER_H */

=== modified file 'lib/documentview/documentviewsynchronizer.cpp'
--- lib/documentview/documentviewsynchronizer.cpp	2011-07-20 13:46:34 +0000
+++ lib/documentview/documentviewsynchronizer.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2011 Aurélien Gâteau <agateau@kde.org>
@@ -28,113 +28,120 @@
 
 // Qt
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 typedef QList<DocumentView*> ViewList;
 
 struct DocumentViewSynchronizerPrivate {
-	DocumentViewSynchronizer* q;
-	ViewList mViews;
-	DocumentView* mCurrentView;
-	bool mActive;
-	QPoint mOldPosition;
-
-	void updateConnections() {
-		Q_FOREACH(DocumentView* view, mViews) {
-			QObject::disconnect(view, 0, q, 0);
-		}
-
-		if (!mCurrentView || !mActive) {
-			return;
-		}
-
-		QObject::connect(mCurrentView, SIGNAL(zoomChanged(qreal)),
-			q, SLOT(setZoom(qreal)));
-		QObject::connect(mCurrentView, SIGNAL(zoomToFitChanged(bool)),
-			q, SLOT(setZoomToFit(bool)));
-		QObject::connect(mCurrentView, SIGNAL(positionChanged()),
-			q, SLOT(updatePosition()));
-
-		Q_FOREACH(DocumentView* view, mViews) {
-			if (view == mCurrentView) {
-				continue;
-			}
-			view->setZoom(mCurrentView->zoom());
-			view->setZoomToFit(mCurrentView->zoomToFit());
-		}
-	}
-
-	void updateOldPosition() {
-		if (!mCurrentView || !mActive) {
-			return;
-		}
-		mOldPosition = mCurrentView->position();
-	}
+    DocumentViewSynchronizer* q;
+    ViewList mViews;
+    DocumentView* mCurrentView;
+    bool mActive;
+    QPoint mOldPosition;
+
+    void updateConnections()
+    {
+        Q_FOREACH(DocumentView * view, mViews) {
+            QObject::disconnect(view, 0, q, 0);
+        }
+
+        if (!mCurrentView || !mActive) {
+            return;
+        }
+
+        QObject::connect(mCurrentView, SIGNAL(zoomChanged(qreal)),
+                         q, SLOT(setZoom(qreal)));
+        QObject::connect(mCurrentView, SIGNAL(zoomToFitChanged(bool)),
+                         q, SLOT(setZoomToFit(bool)));
+        QObject::connect(mCurrentView, SIGNAL(positionChanged()),
+                         q, SLOT(updatePosition()));
+
+        Q_FOREACH(DocumentView * view, mViews) {
+            if (view == mCurrentView) {
+                continue;
+            }
+            view->setZoom(mCurrentView->zoom());
+            view->setZoomToFit(mCurrentView->zoomToFit());
+        }
+    }
+
+    void updateOldPosition()
+    {
+        if (!mCurrentView || !mActive) {
+            return;
+        }
+        mOldPosition = mCurrentView->position();
+    }
 };
 
-
 DocumentViewSynchronizer::DocumentViewSynchronizer(QObject* parent)
 : QObject(parent)
-, d(new DocumentViewSynchronizerPrivate) {
-	d->q = this;
-	d->mCurrentView = 0;
-	d->mActive = false;
-}
-
-
-DocumentViewSynchronizer::~DocumentViewSynchronizer() {
-	delete d;
-}
-
-
-void DocumentViewSynchronizer::setDocumentViews(QList< DocumentView* > views) {
-	d->mViews = views;
-	d->updateConnections();
-}
-
-void DocumentViewSynchronizer::setCurrentView(DocumentView* view) {
-	d->mCurrentView = view;
-	d->updateOldPosition();
-	d->updateConnections();
-}
-
-void DocumentViewSynchronizer::setActive(bool active) {
-	d->mActive = active;
-	d->updateOldPosition();
-	d->updateConnections();
-}
-
-void DocumentViewSynchronizer::setZoom(qreal zoom) {
-	Q_FOREACH(DocumentView* view, d->mViews) {
-		if (view == d->mCurrentView) {
-			continue;
-		}
-		view->setZoom(zoom);
-	}
-	d->updateOldPosition();
-}
-
-void DocumentViewSynchronizer::setZoomToFit(bool fit) {
-	Q_FOREACH(DocumentView* view, d->mViews) {
-		if (view == d->mCurrentView) {
-			continue;
-		}
-		view->setZoomToFit(fit);
-	}
-	d->updateOldPosition();
-}
-
-void DocumentViewSynchronizer::updatePosition() {
-	QPoint pos = d->mCurrentView->position();
-	QPoint delta = pos - d->mOldPosition;
-	d->mOldPosition = pos;
-	Q_FOREACH(DocumentView* view, d->mViews) {
-		if (view == d->mCurrentView) {
-			continue;
-		}
-		view->setPosition(view->position() + delta);
-	}
+, d(new DocumentViewSynchronizerPrivate)
+{
+    d->q = this;
+    d->mCurrentView = 0;
+    d->mActive = false;
+}
+
+DocumentViewSynchronizer::~DocumentViewSynchronizer()
+{
+    delete d;
+}
+
+void DocumentViewSynchronizer::setDocumentViews(QList< DocumentView* > views)
+{
+    d->mViews = views;
+    d->updateConnections();
+}
+
+void DocumentViewSynchronizer::setCurrentView(DocumentView* view)
+{
+    d->mCurrentView = view;
+    d->updateOldPosition();
+    d->updateConnections();
+}
+
+void DocumentViewSynchronizer::setActive(bool active)
+{
+    d->mActive = active;
+    d->updateOldPosition();
+    d->updateConnections();
+}
+
+void DocumentViewSynchronizer::setZoom(qreal zoom)
+{
+    Q_FOREACH(DocumentView * view, d->mViews) {
+        if (view == d->mCurrentView) {
+            continue;
+        }
+        view->setZoom(zoom);
+    }
+    d->updateOldPosition();
+}
+
+void DocumentViewSynchronizer::setZoomToFit(bool fit)
+{
+    Q_FOREACH(DocumentView * view, d->mViews) {
+        if (view == d->mCurrentView) {
+            continue;
+        }
+        view->setZoomToFit(fit);
+    }
+    d->updateOldPosition();
+}
+
+void DocumentViewSynchronizer::updatePosition()
+{
+    QPoint pos = d->mCurrentView->position();
+    QPoint delta = pos - d->mOldPosition;
+    d->mOldPosition = pos;
+    Q_FOREACH(DocumentView * view, d->mViews) {
+        if (view == d->mCurrentView) {
+            continue;
+        }
+        view->setPosition(view->position() + delta);
+    }
 }
 
 } // namespace

=== modified file 'lib/documentview/documentviewsynchronizer.h'
--- lib/documentview/documentviewsynchronizer.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/documentviewsynchronizer.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2011 Aurélien Gâteau <agateau@kde.org>
@@ -32,7 +32,8 @@
 
 class QPoint;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class DocumentView;
 
@@ -40,29 +41,29 @@
 /**
  * A class to synchronize zoom and scroll of two DocumentView
  */
-class GWENVIEWLIB_EXPORT DocumentViewSynchronizer : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT DocumentViewSynchronizer : public QObject
+{
+    Q_OBJECT
 public:
-	DocumentViewSynchronizer(QObject* parent=0);
-	~DocumentViewSynchronizer();
-
-	void setDocumentViews(QList<DocumentView*> views);
-
-	void setCurrentView(DocumentView* view);
+    DocumentViewSynchronizer(QObject* parent = 0);
+    ~DocumentViewSynchronizer();
+
+    void setDocumentViews(QList<DocumentView*> views);
+
+    void setCurrentView(DocumentView* view);
 
 public Q_SLOTS:
-	void setActive(bool);
+    void setActive(bool);
 
 private Q_SLOTS:
-	void setZoom(qreal zoom);
-	void setZoomToFit(bool);
-	void updatePosition();
+    void setZoom(qreal zoom);
+    void setZoomToFit(bool);
+    void updatePosition();
 
 private:
-	DocumentViewSynchronizerPrivate* const d;
+    DocumentViewSynchronizerPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* DOCUMENTVIEWSYNCHRONIZER_H */

=== modified file 'lib/documentview/imageviewadapter.cpp'
--- lib/documentview/imageviewadapter.cpp	2011-07-20 13:46:34 +0000
+++ lib/documentview/imageviewadapter.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -21,142 +21,118 @@
 // Self
 #include "imageviewadapter.moc"
 
-// Qt
+// Local
+#include <lib/document/documentfactory.h>
+#include <lib/documentview/rasterimageview.h>
+#include <lib/gwenviewconfig.h>
 
 // KDE
 #include <kurl.h>
 
-// Local
-#include <lib/gwenviewconfig.h>
-#include <lib/imageview.h>
-#include <lib/scrolltool.h>
-#include <lib/document/documentfactory.h>
-
-namespace Gwenview {
-
-
+// Qt
+
+namespace Gwenview
+{
+
+//// ImageViewAdapter ////
 struct ImageViewAdapterPrivate {
-	ImageViewAdapter* that;
-	ImageView* mView;
-	ScrollTool* mScrollTool;
-
-	void setupScrollTool() {
-		mScrollTool = new ScrollTool(mView);
-		mView->setDefaultTool(mScrollTool);
-		QObject::connect(mScrollTool, SIGNAL(previousImageRequested()),
-			that, SIGNAL(previousImageRequested()) );
-		QObject::connect(mScrollTool, SIGNAL(nextImageRequested()),
-			that, SIGNAL(nextImageRequested()) );
-		QObject::connect(mScrollTool, SIGNAL(zoomInRequested(const QPoint&)),
-			that, SIGNAL(zoomInRequested(const QPoint&)) );
-		QObject::connect(mScrollTool, SIGNAL(zoomOutRequested(const QPoint&)),
-			that, SIGNAL(zoomOutRequested(const QPoint&)) );
-	}
+    ImageViewAdapter* q;
+    RasterImageView* mView;
 };
 
-
-ImageViewAdapter::ImageViewAdapter(QWidget* parent)
-: AbstractDocumentViewAdapter(parent)
-, d(new ImageViewAdapterPrivate) {
-	d->that = this;
-	d->mView = new ImageView(parent);
-	setWidget(d->mView);
-	d->setupScrollTool();
-
-	connect(d->mView, SIGNAL(zoomChanged(qreal)), SIGNAL(zoomChanged(qreal)) );
-}
-
-
-void ImageViewAdapter::installEventFilterOnViewWidgets(QObject* object) {
-	d->mView->viewport()->installEventFilter(object);
-	// Necessary to receive key{Press,Release} events
-	d->mView->installEventFilter(object);
-}
-
-
-ImageViewAdapter::~ImageViewAdapter() {
-	delete d;
-}
-
-
-ImageView* ImageViewAdapter::imageView() const {
-	return d->mView;
-}
-
-
-QCursor ImageViewAdapter::cursor() const {
-	return d->mView->viewport()->cursor();
-}
-
-
-void ImageViewAdapter::setCursor(const QCursor& cursor) {
-	d->mView->viewport()->setCursor(cursor);
-}
-
-
-void ImageViewAdapter::setDocument(Document::Ptr doc) {
-	d->mView->setDocument(doc);
-
-	connect(doc.data(), SIGNAL(loadingFailed(const KUrl&)), SLOT(slotLoadingFailed()) );
-	if (doc->loadingState() == Document::LoadingFailed) {
-		slotLoadingFailed();
-	}
-}
-
-
-qreal ImageViewAdapter::zoom() const {
-	return d->mView->zoom();
-}
-
-
-void ImageViewAdapter::setZoomToFit(bool on) {
-	if (d->mView->zoomToFit() != on) {
-		d->mView->setZoomToFit(on);
-		zoomToFitChanged(on);
-	}
-}
-
-
-bool ImageViewAdapter::zoomToFit() const {
-	return d->mView->zoomToFit();
-}
-
-
-void ImageViewAdapter::setZoom(qreal zoom, const QPoint& center) {
-	d->mView->setZoom(zoom, center);
-}
-
-
-qreal ImageViewAdapter::computeZoomToFit() const {
-	return d->mView->computeZoomToFit();
-}
-
-
-qreal ImageViewAdapter::computeZoomToFitWidth() const {
-	return d->mView->computeZoomToFitWidth();
-}
-
-
-qreal ImageViewAdapter::computeZoomToFitHeight() const {
-	return d->mView->computeZoomToFitHeight();
-}
-
-
-Document::Ptr ImageViewAdapter::document() const {
-	return d->mView->document();
-}
-
-
-void ImageViewAdapter::slotLoadingFailed() {
-	d->mView->setDocument(Document::Ptr());
-}
-
-
-void ImageViewAdapter::loadConfig() {
-	d->mView->setAlphaBackgroundMode(GwenviewConfig::alphaBackgroundMode());
-	d->mView->setAlphaBackgroundColor(GwenviewConfig::alphaBackgroundColor());
-	d->mView->setEnlargeSmallerImages(GwenviewConfig::enlargeSmallerImages());
-}
-
+ImageViewAdapter::ImageViewAdapter()
+: d(new ImageViewAdapterPrivate)
+{
+    d->q = this;
+    d->mView = new RasterImageView;
+    connect(d->mView, SIGNAL(zoomChanged(qreal)), SIGNAL(zoomChanged(qreal)));
+    connect(d->mView, SIGNAL(zoomToFitChanged(bool)), SIGNAL(zoomToFitChanged(bool)));
+    connect(d->mView, SIGNAL(zoomInRequested(QPointF)), SIGNAL(zoomInRequested(QPointF)));
+    connect(d->mView, SIGNAL(zoomOutRequested(QPointF)), SIGNAL(zoomOutRequested(QPointF)));
+    connect(d->mView, SIGNAL(scrollPosChanged()), SIGNAL(scrollPosChanged()));
+    setWidget(d->mView);
+}
+
+ImageViewAdapter::~ImageViewAdapter()
+{
+    delete d;
+}
+
+QCursor ImageViewAdapter::cursor() const
+{
+    return d->mView->cursor();
+}
+
+void ImageViewAdapter::setCursor(const QCursor& cursor)
+{
+    d->mView->setCursor(cursor);
+}
+
+void ImageViewAdapter::setDocument(Document::Ptr doc)
+{
+    d->mView->setDocument(doc);
+
+    connect(doc.data(), SIGNAL(loadingFailed(KUrl)), SLOT(slotLoadingFailed()));
+    if (doc->loadingState() == Document::LoadingFailed) {
+        slotLoadingFailed();
+    }
+}
+
+qreal ImageViewAdapter::zoom() const
+{
+    return d->mView->zoom();
+}
+
+void ImageViewAdapter::setZoomToFit(bool on)
+{
+    d->mView->setZoomToFit(on);
+}
+
+bool ImageViewAdapter::zoomToFit() const
+{
+    return d->mView->zoomToFit();
+}
+
+void ImageViewAdapter::setZoom(qreal zoom, const QPointF& center)
+{
+    d->mView->setZoom(zoom, center);
+}
+
+qreal ImageViewAdapter::computeZoomToFit() const
+{
+    return d->mView->computeZoomToFit();
+}
+
+Document::Ptr ImageViewAdapter::document() const
+{
+    return d->mView->document();
+}
+
+void ImageViewAdapter::slotLoadingFailed()
+{
+    d->mView->setDocument(Document::Ptr());
+}
+
+void ImageViewAdapter::loadConfig()
+{
+    d->mView->setAlphaBackgroundMode(GwenviewConfig::alphaBackgroundMode());
+    d->mView->setAlphaBackgroundColor(GwenviewConfig::alphaBackgroundColor());
+    d->mView->setEnlargeSmallerImages(GwenviewConfig::enlargeSmallerImages());
+}
+
+RasterImageView* ImageViewAdapter::rasterImageView() const
+{
+    return d->mView;
+}
+
+QPointF ImageViewAdapter::scrollPos() const
+{
+    return d->mView->scrollPos();
+}
+
+void ImageViewAdapter::setScrollPos(const QPointF& pos)
+{
+    d->mView->setScrollPos(pos);
+}
 
 } // namespace

=== modified file 'lib/documentview/imageviewadapter.h'
--- lib/documentview/imageviewadapter.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/imageviewadapter.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,56 +30,57 @@
 // Local
 #include <lib/documentview/abstractdocumentviewadapter.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ImageViewAdapterPrivate;
-class GWENVIEWLIB_EXPORT ImageViewAdapter : public AbstractDocumentViewAdapter {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ImageViewAdapter : public AbstractDocumentViewAdapter
+{
+    Q_OBJECT
 public:
-	ImageViewAdapter(QWidget*);
-	~ImageViewAdapter();
-
-	virtual void installEventFilterOnViewWidgets(QObject*);
-
-	virtual QCursor cursor() const;
-
-	virtual void setCursor(const QCursor&);
-
-	virtual MimeTypeUtils::Kind kind() const { return MimeTypeUtils::KIND_RASTER_IMAGE; }
-
-	virtual bool canZoom() const { return true; }
-
-	virtual void setZoomToFit(bool);
-
-	virtual bool zoomToFit() const;
-
-	virtual qreal zoom() const;
-
-	virtual void setZoom(qreal zoom, const QPoint& center);
-
-	virtual qreal computeZoomToFit() const;
-
-	virtual qreal computeZoomToFitWidth() const;
-
-	virtual qreal computeZoomToFitHeight() const;
-
-	virtual Document::Ptr document() const;
-
-	virtual void setDocument(Document::Ptr);
-
-	virtual ImageView* imageView() const;
-
-	virtual void loadConfig();
+    ImageViewAdapter();
+    ~ImageViewAdapter();
+
+    virtual QCursor cursor() const;
+
+    virtual void setCursor(const QCursor&);
+
+    virtual MimeTypeUtils::Kind kind() const {
+        return MimeTypeUtils::KIND_RASTER_IMAGE;
+    }
+
+    virtual bool canZoom() const {
+        return true;
+    }
+
+    virtual void setZoomToFit(bool);
+
+    virtual bool zoomToFit() const;
+
+    virtual qreal zoom() const;
+
+    virtual void setZoom(qreal zoom, const QPointF& center);
+
+    virtual qreal computeZoomToFit() const;
+
+    virtual Document::Ptr document() const;
+
+    virtual void setDocument(Document::Ptr);
+
+    virtual void loadConfig();
+
+    virtual RasterImageView* rasterImageView() const;
+
+    virtual QPointF scrollPos() const;
+    virtual void setScrollPos(const QPointF& pos);
 
 private Q_SLOTS:
-	void slotLoadingFailed();
+    void slotLoadingFailed();
 
 private:
-	ImageViewAdapterPrivate* const d;
+    ImageViewAdapterPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* IMAGEVIEWADAPTER_H */

=== added file 'lib/documentview/loadingindicator.cpp'
--- lib/documentview/loadingindicator.cpp	1970-01-01 00:00:00 +0000
+++ lib/documentview/loadingindicator.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,92 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "loadingindicator.moc"
+
+// Local
+
+// KDE
+#include <kdebug.h>
+#include <kpixmapsequence.h>
+
+// Qt
+#include <QPainter>
+#include <QTimer>
+
+namespace Gwenview
+{
+
+struct LoadingIndicatorPrivate {
+    LoadingIndicator* q;
+    KPixmapSequence mSequence;
+    int mIndex;
+    QTimer* mTimer;
+
+    LoadingIndicatorPrivate(LoadingIndicator* qq)
+        : q(qq)
+        , mSequence("process-working", 22)
+        , mIndex(0)
+        , mTimer(new QTimer(qq)) {
+        mTimer->setInterval(100);
+        QObject::connect(mTimer, SIGNAL(timeout()), q, SLOT(showNextFrame()));
+    }
+};
+
+LoadingIndicator::LoadingIndicator(QGraphicsItem* parent)
+: QGraphicsWidget(parent)
+, d(new LoadingIndicatorPrivate(this))
+{
+}
+
+LoadingIndicator::~LoadingIndicator()
+{
+    delete d;
+}
+
+QRectF LoadingIndicator::boundingRect() const
+{
+    return QRectF(QPointF(0, 0), d->mSequence.frameSize());
+}
+
+void LoadingIndicator::paint(QPainter* painter, const QStyleOptionGraphicsItem*, QWidget*)
+{
+    painter->drawPixmap(0, 0, d->mSequence.frameAt(d->mIndex));
+}
+
+void LoadingIndicator::showNextFrame()
+{
+    d->mIndex = (d->mIndex + 1) % d->mSequence.frameCount();
+    update();
+}
+
+QVariant LoadingIndicator::itemChange(GraphicsItemChange change, const QVariant& value)
+{
+    if (change == QGraphicsItem::ItemVisibleHasChanged) {
+        if (value.toBool()) {
+            d->mTimer->start();
+        } else {
+            d->mTimer->stop();
+        }
+    }
+    return QGraphicsWidget::itemChange(change, value);
+}
+
+} // namespace

=== added file 'lib/documentview/loadingindicator.h'
--- lib/documentview/loadingindicator.h	1970-01-01 00:00:00 +0000
+++ lib/documentview/loadingindicator.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,64 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef LOADINGINDICATOR_H
+#define LOADINGINDICATOR_H
+
+// Local
+
+// KDE
+
+// Qt
+#include <QGraphicsWidget>
+
+namespace Gwenview
+{
+
+class LoadingIndicatorPrivate;
+/**
+ * A graphics widget which shows a spinner
+ */
+class LoadingIndicator : public QGraphicsWidget
+{
+    Q_OBJECT
+public:
+    LoadingIndicator(QGraphicsItem* parent = 0);
+    ~LoadingIndicator();
+
+    // reimp
+    void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget = 0);
+
+    // reimp
+    QRectF boundingRect() const;
+
+private Q_SLOTS:
+    void showNextFrame();
+
+protected:
+    // reimp
+    QVariant itemChange(GraphicsItemChange change, const QVariant &value);
+
+private:
+    LoadingIndicatorPrivate* const d;
+};
+
+} // namespace
+
+#endif /* LOADINGINDICATOR_H */

=== modified file 'lib/documentview/messageviewadapter.cpp'
--- lib/documentview/messageviewadapter.cpp	2011-07-20 13:46:34 +0000
+++ lib/documentview/messageviewadapter.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -22,6 +22,7 @@
 #include "messageviewadapter.moc"
 
 // Qt
+#include <QGraphicsProxyWidget>
 
 // KDE
 #include <klocale.h>
@@ -30,68 +31,63 @@
 #include <lib/document/document.h>
 #include <lib/ui_messageview.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct MessageViewAdapterPrivate : Ui_MessageView {
-	Document::Ptr mDocument;
+    Document::Ptr mDocument;
 };
 
-
-MessageViewAdapter::MessageViewAdapter(QWidget* parent)
-: AbstractDocumentViewAdapter(parent)
-, d(new MessageViewAdapterPrivate) {
-	QWidget* widget = new QWidget(parent);
-	d->setupUi(widget);
-	d->mMessageWidget->setCloseButtonVisible(false);
-	d->mMessageWidget->setWordWrap(true);
-
-	setInfoMessage(i18n("No document selected"));
-
-	widget->setAutoFillBackground(true);
-	widget->setBackgroundRole(QPalette::Base);
-	widget->setForegroundRole(QPalette::Text);
-
-	setWidget(widget);
-}
-
-
-MessageViewAdapter::~MessageViewAdapter() {
-	delete d;
-}
-
-
-void MessageViewAdapter::setErrorMessage(const QString& main, const QString& detail) {
-	d->mMessageWidget->setMessageType(KMessageWidget::Error);
-	QString message;
-	if (detail.isEmpty()) {
-		message = main;
-	} else {
-		message = QString("<b>%1</b><br>%2").arg(main).arg(detail);
-	}
-	d->mMessageWidget->setText(message);
-}
-
-
-void MessageViewAdapter::setInfoMessage(const QString& message) {
-	d->mMessageWidget->setMessageType(KMessageWidget::Information);
-	d->mMessageWidget->setText(message);
-}
-
-
-void MessageViewAdapter::installEventFilterOnViewWidgets(QObject* object) {
-	widget()->installEventFilter(object);
-}
-
-
-Document::Ptr MessageViewAdapter::document() const {
-	return d->mDocument;
-}
-
-
-void MessageViewAdapter::setDocument(Document::Ptr doc) {
-	d->mDocument = doc;
-}
-
+MessageViewAdapter::MessageViewAdapter()
+: d(new MessageViewAdapterPrivate)
+{
+    QWidget* widget = new QWidget;
+    d->setupUi(widget);
+    d->mMessageWidget->setCloseButtonVisible(false);
+    d->mMessageWidget->setWordWrap(true);
+
+    setInfoMessage(i18n("No document selected"));
+
+    widget->setAutoFillBackground(true);
+    widget->setBackgroundRole(QPalette::Base);
+    widget->setForegroundRole(QPalette::Text);
+
+    QGraphicsProxyWidget* proxy = new QGraphicsProxyWidget;
+    proxy->setWidget(widget);
+    setWidget(proxy);
+}
+
+MessageViewAdapter::~MessageViewAdapter()
+{
+    delete d;
+}
+
+void MessageViewAdapter::setErrorMessage(const QString& main, const QString& detail)
+{
+    d->mMessageWidget->setMessageType(KMessageWidget::Error);
+    QString message;
+    if (detail.isEmpty()) {
+        message = main;
+    } else {
+        message = QString("<b>%1</b><br>%2").arg(main).arg(detail);
+    }
+    d->mMessageWidget->setText(message);
+}
+
+void MessageViewAdapter::setInfoMessage(const QString& message)
+{
+    d->mMessageWidget->setMessageType(KMessageWidget::Information);
+    d->mMessageWidget->setText(message);
+}
+
+Document::Ptr MessageViewAdapter::document() const
+{
+    return d->mDocument;
+}
+
+void MessageViewAdapter::setDocument(Document::Ptr doc)
+{
+    d->mDocument = doc;
+}
 
 } // namespace

=== modified file 'lib/documentview/messageviewadapter.h'
--- lib/documentview/messageviewadapter.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/messageviewadapter.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -28,33 +28,33 @@
 // Local
 #include <lib/documentview/abstractdocumentviewadapter.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct MessageViewAdapterPrivate;
-class MessageViewAdapter : public AbstractDocumentViewAdapter {
-	Q_OBJECT
+class MessageViewAdapter : public AbstractDocumentViewAdapter
+{
+    Q_OBJECT
 public:
-	MessageViewAdapter(QWidget* parent);
-	~MessageViewAdapter();
-
-	virtual void installEventFilterOnViewWidgets(QObject*);
-
-	virtual MimeTypeUtils::Kind kind() const { return MimeTypeUtils::KIND_UNKNOWN; }
-
-	virtual Document::Ptr document() const;
-
-	virtual void setDocument(Document::Ptr);
-
-	void setInfoMessage(const QString&);
-
-	void setErrorMessage(const QString& main, const QString& detail = QString());
+    MessageViewAdapter();
+    ~MessageViewAdapter();
+
+    virtual MimeTypeUtils::Kind kind() const {
+        return MimeTypeUtils::KIND_UNKNOWN;
+    }
+
+    virtual Document::Ptr document() const;
+
+    virtual void setDocument(Document::Ptr);
+
+    void setInfoMessage(const QString&);
+
+    void setErrorMessage(const QString& main, const QString& detail = QString());
 
 private:
-	MessageViewAdapterPrivate* const d;
+    MessageViewAdapterPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* MESSAGEVIEWADAPTER_H */

=== added file 'lib/documentview/rasterimageview.cpp'
--- lib/documentview/rasterimageview.cpp	1970-01-01 00:00:00 +0000
+++ lib/documentview/rasterimageview.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,493 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "rasterimageview.moc"
+
+// Local
+#include <lib/documentview/abstractrasterimageviewtool.h>
+#include <lib/imagescaler.h>
+
+// KDE
+#include <kdebug.h>
+
+// Qt
+#include <QGraphicsSceneMouseEvent>
+#include <QPainter>
+#include <QTimer>
+#include <QWeakPointer>
+
+namespace Gwenview
+{
+
+struct RasterImageViewPrivate {
+    RasterImageView* q;
+    ImageScaler* mScaler;
+    QPixmap mBackgroundTexture;
+
+    // Config
+    RasterImageView::AlphaBackgroundMode mAlphaBackgroundMode;
+    QColor mAlphaBackgroundColor;
+    bool mEnlargeSmallerImages;
+    // /Config
+
+    bool mBufferIsEmpty;
+    QPixmap mCurrentBuffer;
+    // The alternate buffer is useful when scrolling: existing content is copied
+    // to mAlternateBuffer and buffers are swapped. This avoids allocating a new
+    // QPixmap everytime the image is scrolled.
+    QPixmap mAlternateBuffer;
+
+    QTimer* mUpdateTimer;
+
+    QWeakPointer<AbstractRasterImageViewTool> mTool;
+
+    void createBackgroundTexture()
+    {
+        mBackgroundTexture = QPixmap(32, 32);
+        QPainter painter(&mBackgroundTexture);
+        painter.fillRect(mBackgroundTexture.rect(), QColor(128, 128, 128));
+        QColor light = QColor(192, 192, 192);
+        painter.fillRect(0, 0, 16, 16, light);
+        painter.fillRect(16, 16, 16, 16, light);
+    }
+
+    void setupUpdateTimer()
+    {
+        mUpdateTimer = new QTimer(q);
+        mUpdateTimer->setInterval(500);
+        mUpdateTimer->setSingleShot(true);
+        QObject::connect(mUpdateTimer, SIGNAL(timeout()),
+                         q, SLOT(updateBuffer()));
+    }
+
+    void startAnimationIfNecessary()
+    {
+        if (q->document() && q->isVisible()) {
+            q->document()->startAnimation();
+        }
+    }
+
+    QSizeF visibleImageSize() const {
+        if (!q->document()) {
+            return QSizeF();
+        }
+        qreal zoom;
+        if (q->zoomToFit()) {
+            zoom = q->computeZoomToFit();
+        } else {
+            zoom = q->zoom();
+        }
+
+        QSizeF size = q->documentSize() * zoom;
+        return size.boundedTo(q->boundingRect().size());
+    }
+
+    QRectF mapViewportToZoomedImage(const QRectF& viewportRect) const {
+        return QRectF(
+                   viewportRect.topLeft() - q->imageOffset() + q->scrollPos(),
+                   viewportRect.size()
+               );
+    }
+
+    void setScalerRegionToVisibleRect()
+    {
+        QRectF rect = mapViewportToZoomedImage(q->boundingRect());
+        mScaler->setDestinationRegion(QRegion(rect.toRect()));
+    }
+
+    void createBuffer()
+    {
+        QSize size = visibleImageSize().toSize();
+        if (size == mCurrentBuffer.size()) {
+            return;
+        }
+        if (!size.isValid()) {
+            mAlternateBuffer = QPixmap();
+            mCurrentBuffer = QPixmap();
+            return;
+        }
+
+        mAlternateBuffer = QPixmap(size);
+        mAlternateBuffer.fill(Qt::transparent);
+        {
+            QPainter painter(&mAlternateBuffer);
+            painter.drawPixmap(0, 0, mCurrentBuffer);
+        }
+        qSwap(mAlternateBuffer, mCurrentBuffer);
+
+        mAlternateBuffer = QPixmap();
+    }
+
+    void drawAlphaBackground(QPainter* painter, const QRect& viewportRect, const QPoint& zoomedImageTopLeft)
+    {
+        if (mAlphaBackgroundMode == RasterImageView::AlphaBackgroundCheckBoard) {
+            QPoint textureOffset(
+                zoomedImageTopLeft.x() % mBackgroundTexture.width(),
+                zoomedImageTopLeft.y() % mBackgroundTexture.height()
+            );
+            painter->drawTiledPixmap(
+                viewportRect,
+                mBackgroundTexture,
+                textureOffset);
+        } else {
+            painter->fillRect(viewportRect, mAlphaBackgroundColor);
+        }
+    }
+};
+
+RasterImageView::RasterImageView(QGraphicsItem* parent)
+: AbstractImageView(parent)
+, d(new RasterImageViewPrivate)
+{
+    d->q = this;
+
+    d->mAlphaBackgroundMode = AlphaBackgroundCheckBoard;
+    d->mAlphaBackgroundColor = Qt::black;
+    d->mEnlargeSmallerImages = false;
+
+    d->mBufferIsEmpty = true;
+    d->mScaler = new ImageScaler(this);
+    connect(d->mScaler, SIGNAL(scaledRect(int, int, QImage)),
+            SLOT(updateFromScaler(int, int, QImage)));
+    setAcceptHoverEvents(true);
+
+    d->createBackgroundTexture();
+    d->setupUpdateTimer();
+}
+
+RasterImageView::~RasterImageView()
+{
+    delete d;
+}
+
+void RasterImageView::setAlphaBackgroundMode(AlphaBackgroundMode mode)
+{
+    d->mAlphaBackgroundMode = mode;
+    if (document() && document()->hasAlphaChannel()) {
+        d->mCurrentBuffer = QPixmap();
+        updateBuffer();
+    }
+}
+
+void RasterImageView::setAlphaBackgroundColor(const QColor& color)
+{
+    d->mAlphaBackgroundColor = color;
+    if (document() && document()->hasAlphaChannel()) {
+        d->mCurrentBuffer = QPixmap();
+        updateBuffer();
+    }
+}
+
+void RasterImageView::loadFromDocument()
+{
+    Document::Ptr doc = document();
+    connect(doc.data(), SIGNAL(metaInfoLoaded(KUrl)),
+            SLOT(slotDocumentMetaInfoLoaded()));
+    connect(doc.data(), SIGNAL(isAnimatedUpdated()),
+            SLOT(slotDocumentIsAnimatedUpdated()));
+
+    const Document::LoadingState state = doc->loadingState();
+    if (state == Document::MetaInfoLoaded || state == Document::Loaded) {
+        slotDocumentMetaInfoLoaded();
+    }
+}
+
+void RasterImageView::slotDocumentMetaInfoLoaded()
+{
+    if (document()->size().isValid()) {
+        finishSetDocument();
+    } else {
+        // Could not retrieve image size from meta info, we need to load the
+        // full image now.
+        connect(document().data(), SIGNAL(loaded(KUrl)),
+                SLOT(finishSetDocument()));
+        document()->startLoadingFullImage();
+    }
+}
+
+void RasterImageView::finishSetDocument()
+{
+    if (!document()->size().isValid()) {
+        kError() << "No valid image size available, this should not happen!";
+        return;
+    }
+
+    d->createBuffer();
+    d->mScaler->setDocument(document());
+
+    connect(document().data(), SIGNAL(imageRectUpdated(QRect)),
+            SLOT(updateImageRect(QRect)));
+
+    if (zoomToFit()) {
+        // Force the update otherwise if computeZoomToFit() returns 1, setZoom()
+        // will think zoom has not changed and won't update the image
+        setZoom(computeZoomToFit(), QPointF(-1, -1), ForceUpdate);
+    } else {
+        QRect rect(QPoint(0, 0), document()->size());
+        updateImageRect(rect);
+    }
+
+    d->startAnimationIfNecessary();
+    update();
+}
+
+void RasterImageView::updateImageRect(const QRect& imageRect)
+{
+    QRectF viewRect = mapToView(imageRect);
+    if (!viewRect.intersects(boundingRect())) {
+        return;
+    }
+
+    if (zoomToFit()) {
+        setZoom(computeZoomToFit());
+    }
+    d->setScalerRegionToVisibleRect();
+    update();
+}
+
+void RasterImageView::slotDocumentIsAnimatedUpdated()
+{
+    d->startAnimationIfNecessary();
+}
+
+void RasterImageView::updateFromScaler(int zoomedImageLeft, int zoomedImageTop, const QImage& image)
+{
+    int viewportLeft = zoomedImageLeft - scrollPos().x();
+    int viewportTop = zoomedImageTop - scrollPos().y();
+    d->mBufferIsEmpty = false;
+    {
+        QPainter painter(&d->mCurrentBuffer);
+        if (document()->hasAlphaChannel()) {
+            d->drawAlphaBackground(
+                &painter, QRect(viewportLeft, viewportTop, image.width(), image.height()),
+                QPoint(zoomedImageLeft, zoomedImageTop)
+            );
+        } else {
+            painter.setCompositionMode(QPainter::CompositionMode_Source);
+        }
+        painter.drawImage(viewportLeft, viewportTop, image);
+    }
+    update();
+}
+
+void RasterImageView::onZoomChanged()
+{
+    // If we zoom more than twice, then assume the user wants to see the real
+    // pixels, for example to fine tune a crop operation
+    if (zoom() < 2.) {
+        d->mScaler->setTransformationMode(Qt::SmoothTransformation);
+    } else {
+        d->mScaler->setTransformationMode(Qt::FastTransformation);
+    }
+    if (!d->mUpdateTimer->isActive()) {
+        updateBuffer();
+    }
+}
+
+void RasterImageView::onImageOffsetChanged()
+{
+    update();
+}
+
+void RasterImageView::onScrollPosChanged(const QPointF& oldPos)
+{
+    QPointF delta = scrollPos() - oldPos;
+
+    // Scroll existing
+    {
+        if (d->mAlternateBuffer.size() != d->mCurrentBuffer.size()) {
+            d->mAlternateBuffer = QPixmap(d->mCurrentBuffer.size());
+        }
+        QPainter painter(&d->mAlternateBuffer);
+        painter.drawPixmap(-delta, d->mCurrentBuffer);
+    }
+    qSwap(d->mCurrentBuffer, d->mAlternateBuffer);
+
+    // Scale missing parts
+    QRegion bufferRegion = QRegion(d->mCurrentBuffer.rect().translated(scrollPos().toPoint()));
+    QRegion updateRegion = bufferRegion - bufferRegion.translated(-delta.toPoint());
+    updateBuffer(updateRegion);
+    update();
+}
+
+void RasterImageView::paint(QPainter* painter, const QStyleOptionGraphicsItem* /*option*/, QWidget* /*widget*/)
+{
+    QSize bufferSize = d->mCurrentBuffer.size();
+
+    QSizeF paintSize;
+    if (zoomToFit()) {
+        paintSize = documentSize() * computeZoomToFit();
+    } else {
+        paintSize = bufferSize;
+    }
+    painter->drawPixmap(
+        (boundingRect().width() - paintSize.width()) / 2,
+        (boundingRect().height() - paintSize.height()) / 2,
+        paintSize.width(),
+        paintSize.height(),
+        d->mCurrentBuffer);
+
+    if (d->mTool) {
+        d->mTool.data()->paint(painter);
+    }
+
+    // Debug
+#if 0
+    QPointF topLeft = imageOffset();
+    QSizeF visibleSize = documentSize() * zoom();
+    painter->setPen(Qt::red);
+    painter->drawRect(topLeft.x(), topLeft.y(), visibleSize.width() - 1, visibleSize.height() - 1);
+
+    painter->setPen(Qt::blue);
+    painter->drawRect(topLeft.x(), topLeft.y(), d->mCurrentBuffer.width() - 1, d->mCurrentBuffer.height() - 1);
+#endif
+}
+
+void RasterImageView::resizeEvent(QGraphicsSceneResizeEvent* event)
+{
+    // If we are in zoomToFit mode and have something in our buffer, delay the
+    // update: paint() will paint a scaled version of the buffer until resizing
+    // is done. This is much faster than rescaling the whole image for each
+    // resize event we receive.
+    // mUpdateTimer must be start before calling AbstractImageView::resizeEvent()
+    // because AbstractImageView::resizeEvent() will call onZoomChanged(), which
+    // will trigger an immediate update unless the mUpdateTimer is active.
+    if (zoomToFit() && !d->mBufferIsEmpty) {
+        d->mUpdateTimer->start();
+    }
+    AbstractImageView::resizeEvent(event);
+    if (!zoomToFit()) {
+        // Only update buffer if we are not in zoomToFit mode: if we are
+        // onZoomChanged() will have already updated the buffer.
+        updateBuffer();
+    }
+}
+
+void RasterImageView::updateBuffer(const QRegion& region)
+{
+    d->mUpdateTimer->stop();
+    d->createBuffer();
+    d->mScaler->setZoom(zoom());
+    if (region.isEmpty()) {
+        d->setScalerRegionToVisibleRect();
+    } else {
+        d->mScaler->setDestinationRegion(region);
+    }
+}
+
+void RasterImageView::setCurrentTool(AbstractRasterImageViewTool* tool)
+{
+    if (d->mTool) {
+        d->mTool.data()->toolDeactivated();
+        d->mTool.data()->deleteLater();
+    }
+    d->mTool = tool;
+    if (d->mTool) {
+        d->mTool.data()->toolActivated();
+    }
+    updateCursor();
+    currentToolChanged(tool);
+    update();
+}
+
+AbstractRasterImageViewTool* RasterImageView::currentTool() const
+{
+    return d->mTool.data();
+}
+
+void RasterImageView::mousePressEvent(QGraphicsSceneMouseEvent* event)
+{
+    if (d->mTool) {
+        d->mTool.data()->mousePressEvent(event);
+        if (event->isAccepted()) {
+            return;
+        }
+    }
+    AbstractImageView::mousePressEvent(event);
+}
+
+void RasterImageView::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
+{
+    if (d->mTool) {
+        d->mTool.data()->mouseMoveEvent(event);
+        if (event->isAccepted()) {
+            return;
+        }
+    }
+    AbstractImageView::mouseMoveEvent(event);
+}
+
+void RasterImageView::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
+{
+    if (d->mTool) {
+        d->mTool.data()->mouseReleaseEvent(event);
+        if (event->isAccepted()) {
+            return;
+        }
+    }
+    AbstractImageView::mouseReleaseEvent(event);
+}
+
+void RasterImageView::wheelEvent(QGraphicsSceneWheelEvent* event)
+{
+    if (d->mTool) {
+        d->mTool.data()->wheelEvent(event);
+        if (event->isAccepted()) {
+            return;
+        }
+    }
+    AbstractImageView::wheelEvent(event);
+}
+
+void RasterImageView::keyPressEvent(QKeyEvent* event)
+{
+    if (d->mTool) {
+        d->mTool.data()->keyPressEvent(event);
+        if (event->isAccepted()) {
+            return;
+        }
+    }
+    AbstractImageView::keyPressEvent(event);
+}
+
+void RasterImageView::keyReleaseEvent(QKeyEvent* event)
+{
+    if (d->mTool) {
+        d->mTool.data()->keyReleaseEvent(event);
+        if (event->isAccepted()) {
+            return;
+        }
+    }
+    AbstractImageView::keyReleaseEvent(event);
+}
+
+void RasterImageView::hoverMoveEvent(QGraphicsSceneHoverEvent* event)
+{
+    if (d->mTool) {
+        d->mTool.data()->hoverMoveEvent(event);
+        if (event->isAccepted()) {
+            return;
+        }
+    }
+    AbstractImageView::hoverMoveEvent(event);
+}
+
+} // namespace

=== added file 'lib/documentview/rasterimageview.h'
--- lib/documentview/rasterimageview.h	1970-01-01 00:00:00 +0000
+++ lib/documentview/rasterimageview.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,90 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef RASTERIMAGEVIEW_H
+#define RASTERIMAGEVIEW_H
+
+#include <lib/gwenviewlib_export.h>
+
+// Local
+#include <lib/documentview/abstractimageview.h>
+
+// KDE
+
+class QGraphicsSceneHoverEvent;
+
+namespace Gwenview
+{
+
+class AbstractRasterImageViewTool;
+
+class RasterImageViewPrivate;
+class GWENVIEWLIB_EXPORT RasterImageView : public AbstractImageView
+{
+    Q_OBJECT
+public:
+    enum AlphaBackgroundMode {
+        AlphaBackgroundCheckBoard,
+        AlphaBackgroundSolid
+    };
+
+    RasterImageView(QGraphicsItem* parent = 0);
+    ~RasterImageView();
+
+    void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget);
+
+    void setCurrentTool(AbstractRasterImageViewTool* tool);
+    AbstractRasterImageViewTool* currentTool() const;
+
+    void setAlphaBackgroundMode(AlphaBackgroundMode mode);
+    void setAlphaBackgroundColor(const QColor& color);
+
+Q_SIGNALS:
+    void currentToolChanged(AbstractRasterImageViewTool*);
+
+protected:
+    void loadFromDocument();
+    void onZoomChanged();
+    void onImageOffsetChanged();
+    void onScrollPosChanged(const QPointF& oldPos);
+    void resizeEvent(QGraphicsSceneResizeEvent* event);
+    void mousePressEvent(QGraphicsSceneMouseEvent* event);
+    void mouseMoveEvent(QGraphicsSceneMouseEvent* event);
+    void mouseReleaseEvent(QGraphicsSceneMouseEvent* event);
+    void wheelEvent(QGraphicsSceneWheelEvent* event);
+    void keyPressEvent(QKeyEvent* event);
+    void keyReleaseEvent(QKeyEvent* event);
+    void hoverMoveEvent(QGraphicsSceneHoverEvent*);
+
+private Q_SLOTS:
+    void slotDocumentMetaInfoLoaded();
+    void slotDocumentIsAnimatedUpdated();
+    void finishSetDocument();
+    void updateFromScaler(int, int, const QImage&);
+    void updateImageRect(const QRect& imageRect);
+    void updateBuffer(const QRegion& region = QRegion());
+
+private:
+    RasterImageViewPrivate* const d;
+};
+
+} // namespace
+
+#endif /* RASTERIMAGEVIEW_H */

=== modified file 'lib/documentview/svgviewadapter.cpp'
--- lib/documentview/svgviewadapter.cpp	2011-07-20 13:46:34 +0000
+++ lib/documentview/svgviewadapter.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -22,10 +22,12 @@
 #include "svgviewadapter.moc"
 
 // Qt
+#include <QCursor>
 #include <QEvent>
-#include <QGraphicsScene>
 #include <QGraphicsSvgItem>
-#include <QGraphicsView>
+#include <QGraphicsTextItem>
+#include <QGraphicsWidget>
+#include <QPainter>
 #include <QSvgRenderer>
 
 // KDE
@@ -33,146 +35,122 @@
 
 // Local
 #include "document/documentfactory.h"
-
-namespace Gwenview {
-
-
+#include <qgraphicssceneevent.h>
+
+namespace Gwenview
+{
+
+/// SvgImageView ////
+SvgImageView::SvgImageView(QGraphicsItem* parent)
+: AbstractImageView(parent)
+, mSvgItem(new QGraphicsSvgItem(this))
+{
+}
+
+void SvgImageView::loadFromDocument()
+{
+    QSvgRenderer* renderer = document()->svgRenderer();
+    if (!renderer) {
+        kWarning() << "No SVG renderer. This should not happen!";
+        return;
+    }
+    mSvgItem->setSharedRenderer(renderer);
+}
+
+void SvgImageView::onZoomChanged()
+{
+    mSvgItem->setScale(zoom());
+    adjustItemPos();
+}
+
+void SvgImageView::onImageOffsetChanged()
+{
+    adjustItemPos();
+}
+
+void SvgImageView::onScrollPosChanged(const QPointF& /* oldPos */)
+{
+    adjustItemPos();
+}
+
+void SvgImageView::adjustItemPos()
+{
+    mSvgItem->setPos(imageOffset() - scrollPos());
+}
+
+//// SvgViewAdapter ////
 struct SvgViewAdapterPrivate {
-	QSvgRenderer* mRenderer;
-	QGraphicsScene* mScene;
-	QGraphicsView* mView;
-
-	Document::Ptr mDocument;
-	QGraphicsSvgItem* mItem;
-	bool mZoomToFit;
+    SvgImageView* mView;
 };
 
-
-SvgViewAdapter::SvgViewAdapter(QWidget* parent)
-: AbstractDocumentViewAdapter(parent)
-, d(new SvgViewAdapterPrivate) {
-	d->mRenderer = new QSvgRenderer(this);
-	d->mScene = new QGraphicsScene(this);
-	d->mView = new QGraphicsView(d->mScene, parent);
-	d->mView->setFrameStyle(QFrame::NoFrame);
-	d->mView->setDragMode(QGraphicsView::ScrollHandDrag);
-	d->mView->viewport()->installEventFilter(this);
-
-	d->mItem = 0;
-	d->mZoomToFit = true;
-
-	setWidget(d->mView);
-}
-
-
-void SvgViewAdapter::installEventFilterOnViewWidgets(QObject* object) {
-	d->mView->viewport()->installEventFilter(object);
-	// Necessary to receive key{Press,Release} events
-	d->mView->installEventFilter(object);
-}
-
-
-SvgViewAdapter::~SvgViewAdapter() {
-	delete d;
-}
-
-
-QCursor SvgViewAdapter::cursor() const {
-	return d->mView->viewport()->cursor();
-}
-
-
-void SvgViewAdapter::setCursor(const QCursor& cursor) {
-	d->mView->viewport()->setCursor(cursor);
-}
-
-
-void SvgViewAdapter::setDocument(Document::Ptr doc) {
-	d->mDocument = doc;
-	connect(d->mDocument.data(), SIGNAL(loaded(const KUrl&)),
-		SLOT(loadFromDocument()));
-	loadFromDocument();
-}
-
-
-void SvgViewAdapter::loadFromDocument() {
-	delete d->mItem;
-	d->mItem = 0;
-
-	if (!d->mRenderer->load(d->mDocument->rawData())) {
-		kWarning() << "Decoding SVG failed";
-		return;
-	}
-	d->mItem = new QGraphicsSvgItem();
-	d->mItem->setSharedRenderer(d->mRenderer);
-	d->mScene->addItem(d->mItem);
-
-	if (d->mZoomToFit) {
-		setZoom(computeZoomToFit());
-	}
-}
-
-
-Document::Ptr SvgViewAdapter::document() const {
-	return d->mDocument;
-}
-
-
-void SvgViewAdapter::setZoomToFit(bool on) {
-	if (d->mZoomToFit == on) {
-		return;
-	}
-	d->mZoomToFit = on;
-	if (d->mZoomToFit) {
-		setZoom(computeZoomToFit());
-	}
-	zoomToFitChanged(on);
-}
-
-
-bool SvgViewAdapter::zoomToFit() const {
-	return d->mZoomToFit;
-}
-
-
-qreal SvgViewAdapter::zoom() const {
-	return d->mView->matrix().m11();
-}
-
-
-void SvgViewAdapter::setZoom(qreal zoom, const QPoint& /*center*/) {
-	QMatrix matrix;
-	matrix.scale(zoom, zoom);
-	d->mView->setMatrix(matrix);
-	emit zoomChanged(zoom);
-}
-
-
-qreal SvgViewAdapter::computeZoomToFit() const {
-	return qMin(computeZoomToFitWidth(), computeZoomToFitHeight());
-}
-
-
-qreal SvgViewAdapter::computeZoomToFitWidth() const {
-	int width = d->mScene->width();
-	return width != 0 ? (qreal(d->mView->viewport()->width()) / width) : 1;
-}
-
-
-qreal SvgViewAdapter::computeZoomToFitHeight() const {
-	int height = d->mScene->height();
-	return height != 0 ? (qreal(d->mView->viewport()->height()) / height) : 1;
-}
-
-
-bool SvgViewAdapter::eventFilter(QObject*, QEvent* event) {
-	if (event->type() == QEvent::Resize) {
-		if (d->mZoomToFit) {
-			setZoom(computeZoomToFit());
-		}
-	}
-	return false;
-}
-
+SvgViewAdapter::SvgViewAdapter()
+: d(new SvgViewAdapterPrivate)
+{
+    d->mView = new SvgImageView;
+    setWidget(d->mView);
+    connect(d->mView, SIGNAL(zoomChanged(qreal)), SIGNAL(zoomChanged(qreal)));
+    connect(d->mView, SIGNAL(zoomToFitChanged(bool)), SIGNAL(zoomToFitChanged(bool)));
+    connect(d->mView, SIGNAL(scrollPosChanged()), SIGNAL(scrollPosChanged()));
+}
+
+SvgViewAdapter::~SvgViewAdapter()
+{
+    delete d;
+}
+
+QCursor SvgViewAdapter::cursor() const
+{
+    return widget()->cursor();
+}
+
+void SvgViewAdapter::setCursor(const QCursor& cursor)
+{
+    widget()->setCursor(cursor);
+}
+
+void SvgViewAdapter::setDocument(Document::Ptr doc)
+{
+    d->mView->setDocument(doc);
+}
+
+Document::Ptr SvgViewAdapter::document() const
+{
+    return d->mView->document();
+}
+
+void SvgViewAdapter::setZoomToFit(bool on)
+{
+    d->mView->setZoomToFit(on);
+}
+
+bool SvgViewAdapter::zoomToFit() const
+{
+    return d->mView->zoomToFit();
+}
+
+qreal SvgViewAdapter::zoom() const
+{
+    return d->mView->zoom();
+}
+
+void SvgViewAdapter::setZoom(qreal zoom, const QPointF& center)
+{
+    d->mView->setZoom(zoom, center);
+}
+
+qreal SvgViewAdapter::computeZoomToFit() const
+{
+    return d->mView->computeZoomToFit();
+}
+
+QPointF SvgViewAdapter::scrollPos() const
+{
+    return d->mView->scrollPos();
+}
+
+void SvgViewAdapter::setScrollPos(const QPointF& pos)
+{
+    d->mView->setScrollPos(pos);
+}
 
 } // namespace

=== modified file 'lib/documentview/svgviewadapter.h'
--- lib/documentview/svgviewadapter.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/svgviewadapter.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -24,59 +24,77 @@
 #include <lib/gwenviewlib_export.h>
 
 // Qt
+#include <QGraphicsWidget>
 
 // KDE
 
 // Local
+#include <lib/documentview/abstractimageview.h>
 #include <lib/documentview/abstractdocumentviewadapter.h>
 
-namespace Gwenview {
-
+class QGraphicsSvgItem;
+
+namespace Gwenview
+{
+
+class SvgImageView : public AbstractImageView
+{
+    Q_OBJECT
+public:
+    SvgImageView(QGraphicsItem* parent = 0);
+
+protected:
+    void loadFromDocument();
+    void onZoomChanged();
+    void onImageOffsetChanged();
+    void onScrollPosChanged(const QPointF& oldPos);
+
+private:
+    QGraphicsSvgItem* mSvgItem;
+    void adjustItemPos();
+};
 
 struct SvgViewAdapterPrivate;
-class GWENVIEWLIB_EXPORT SvgViewAdapter : public AbstractDocumentViewAdapter {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT SvgViewAdapter : public AbstractDocumentViewAdapter
+{
+    Q_OBJECT
 public:
-	SvgViewAdapter(QWidget*);
-	~SvgViewAdapter();
-
-	virtual void installEventFilterOnViewWidgets(QObject*);
-
-	virtual QCursor cursor() const;
-
-	virtual void setCursor(const QCursor&);
-
-	virtual void setDocument(Document::Ptr);
-
-	virtual Document::Ptr document() const;
-
-	virtual MimeTypeUtils::Kind kind() const { return MimeTypeUtils::KIND_SVG_IMAGE; }
-
-	virtual bool canZoom() const { return true; }
-
-	virtual void setZoomToFit(bool);
-
-	virtual bool zoomToFit() const;
-
-	virtual qreal zoom() const;
-
-	virtual void setZoom(qreal /*zoom*/, const QPoint& /*center*/ = QPoint(-1, -1));
-
-	virtual qreal computeZoomToFit() const;
-	virtual qreal computeZoomToFitWidth() const;
-	virtual qreal computeZoomToFitHeight() const;
-
-protected:
-	virtual bool eventFilter(QObject*, QEvent*);
-
-private Q_SLOTS:
-	void loadFromDocument();
+    SvgViewAdapter();
+    ~SvgViewAdapter();
+
+    virtual QCursor cursor() const;
+
+    virtual void setCursor(const QCursor&);
+
+    virtual void setDocument(Document::Ptr);
+
+    virtual Document::Ptr document() const;
+
+    virtual MimeTypeUtils::Kind kind() const {
+        return MimeTypeUtils::KIND_SVG_IMAGE;
+    }
+
+    virtual bool canZoom() const {
+        return true;
+    }
+
+    virtual void setZoomToFit(bool);
+
+    virtual bool zoomToFit() const;
+
+    virtual qreal zoom() const;
+
+    virtual void setZoom(qreal /*zoom*/, const QPointF& /*center*/ = QPointF(-1, -1));
+
+    virtual qreal computeZoomToFit() const;
+
+    virtual QPointF scrollPos() const;
+    virtual void setScrollPos(const QPointF& pos);
 
 private:
-	SvgViewAdapterPrivate* const d;
+    SvgViewAdapterPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* SVGVIEWADAPTER_H */

=== modified file 'lib/documentview/videoviewadapter.cpp'
--- lib/documentview/videoviewadapter.cpp	2011-07-20 13:46:34 +0000
+++ lib/documentview/videoviewadapter.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -28,6 +28,7 @@
 #include <Phonon/SeekSlider>
 #include <Phonon/VideoWidget>
 #include <Phonon/VolumeSlider>
+#include <QGraphicsProxyWidget>
 #include <QHBoxLayout>
 #include <QMouseEvent>
 #include <QToolButton>
@@ -41,152 +42,147 @@
 #include "hudwidget.h"
 #include "widgetfloater.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct VideoViewAdapterPrivate {
-	VideoViewAdapter* q;
-	Phonon::MediaObject* mMediaObject;
-	Phonon::VideoWidget* mVideoWidget;
-	Phonon::AudioOutput* mAudioOutput;
-	HudWidget* mHud;
-	WidgetFloater* mFloater;
-	QToolButton* mPlayPauseButton;
-
-	Document::Ptr mDocument;
-
-	void setupHud(QWidget* parent) {
-		// Create hud content
-		QWidget* widget = new QWidget;
-		QHBoxLayout* layout = new QHBoxLayout(widget);
-
-		mPlayPauseButton = new QToolButton;
-		mPlayPauseButton->setAutoRaise(true);
-		q->updatePlayPauseButton();
-		QObject::connect(mPlayPauseButton, SIGNAL(clicked()),
-			q, SLOT(slotPlayPauseClicked()));
-		QObject::connect(mMediaObject, SIGNAL(stateChanged(Phonon::State, Phonon::State)),
-			q, SLOT(updatePlayPauseButton()));
-
-		Phonon::SeekSlider* seekSlider = new Phonon::SeekSlider;
-		seekSlider->setTracking(false);
-		seekSlider->setIconVisible(false);
-		seekSlider->setMediaObject(mMediaObject);
-
-		Phonon::VolumeSlider* volumeSlider = new Phonon::VolumeSlider;
-		volumeSlider->setAudioOutput(mAudioOutput);
-		volumeSlider->setMinimumWidth(100);
-
-		layout->addWidget(mPlayPauseButton);
-		layout->addWidget(seekSlider, 5 /* stretch */);
-		layout->addWidget(volumeSlider, 1 /* stretch */);
-		widget->adjustSize();
-
-		// Create hud
-		mHud = new HudWidget;
-		mHud->setAutoFillBackground(true);
-		mHud->init(widget, HudWidget::OptionDoNotFollowChildSize | HudWidget::OptionOpaque);
-
-		// Init floater
-		mFloater = new WidgetFloater(parent);
-		mFloater->setChildWidget(mHud);
-		mFloater->setAlignment(Qt::AlignJustify | Qt::AlignBottom);
-
-		mVideoWidget->installEventFilter(q);
-	}
-
-
-	bool isPlaying() const {
-		switch (mMediaObject->state()) {
-		case Phonon::StoppedState:
-		case Phonon::PausedState:
-			return false;
-		default:
-			return true;
-		}
-	}
-
-
-	void updateHudVisibility(int yPos) {
-		const int floaterY = mVideoWidget->height() - mFloater->verticalMargin() - mHud->sizeHint().height() * 3 / 2;
-		if (mHud->isVisible() && yPos < floaterY) {
-			mHud->hide();
-		} else if (!mHud->isVisible() && yPos >= floaterY) {
-			mHud->show();
-		}
-	}
+    VideoViewAdapter* q;
+    Phonon::MediaObject* mMediaObject;
+    Phonon::VideoWidget* mVideoWidget;
+    Phonon::AudioOutput* mAudioOutput;
+    HudWidget* mHud;
+    WidgetFloater* mFloater;
+    QToolButton* mPlayPauseButton;
+
+    Document::Ptr mDocument;
+
+    void setupHud(QWidget* parent)
+    {
+        // Create hud content
+        QWidget* widget = new QWidget;
+        QHBoxLayout* layout = new QHBoxLayout(widget);
+
+        mPlayPauseButton = new QToolButton;
+        mPlayPauseButton->setAutoRaise(true);
+        q->updatePlayPauseButton();
+        QObject::connect(mPlayPauseButton, SIGNAL(clicked()),
+                         q, SLOT(slotPlayPauseClicked()));
+        QObject::connect(mMediaObject, SIGNAL(stateChanged(Phonon::State, Phonon::State)),
+                         q, SLOT(updatePlayPauseButton()));
+
+        Phonon::SeekSlider* seekSlider = new Phonon::SeekSlider;
+        seekSlider->setTracking(false);
+        seekSlider->setIconVisible(false);
+        seekSlider->setMediaObject(mMediaObject);
+
+        Phonon::VolumeSlider* volumeSlider = new Phonon::VolumeSlider;
+        volumeSlider->setAudioOutput(mAudioOutput);
+        volumeSlider->setMinimumWidth(100);
+
+        layout->addWidget(mPlayPauseButton);
+        layout->addWidget(seekSlider, 5 /* stretch */);
+        layout->addWidget(volumeSlider, 1 /* stretch */);
+        widget->adjustSize();
+
+        // Create hud
+        mHud = new HudWidget;
+        mHud->setAutoFillBackground(true);
+        mHud->init(widget, HudWidget::OptionDoNotFollowChildSize | HudWidget::OptionOpaque);
+
+        // Init floater
+        mFloater = new WidgetFloater(parent);
+        mFloater->setChildWidget(mHud);
+        mFloater->setAlignment(Qt::AlignJustify | Qt::AlignBottom);
+
+        mVideoWidget->installEventFilter(q);
+    }
+
+    bool isPlaying() const {
+        switch (mMediaObject->state()) {
+        case Phonon::StoppedState:
+        case Phonon::PausedState:
+            return false;
+        default:
+            return true;
+        }
+    }
+
+    void updateHudVisibility(int yPos)
+    {
+        const int floaterY = mVideoWidget->height() - mFloater->verticalMargin() - mHud->sizeHint().height() * 3 / 2;
+        if (mHud->isVisible() && yPos < floaterY) {
+            mHud->hide();
+        } else if (!mHud->isVisible() && yPos >= floaterY) {
+            mHud->show();
+        }
+    }
 };
 
-
-VideoViewAdapter::VideoViewAdapter(QWidget* parent)
-: AbstractDocumentViewAdapter(parent)
-, d(new VideoViewAdapterPrivate) {
-	d->q = this;
-	d->mMediaObject = new Phonon::MediaObject(this);
-	connect(d->mMediaObject, SIGNAL(finished()), SIGNAL(videoFinished()));
-
-	d->mVideoWidget = new Phonon::VideoWidget(parent);
-	d->mVideoWidget->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
-	d->mVideoWidget->setAttribute(Qt::WA_Hover);
-
-	Phonon::createPath(d->mMediaObject, d->mVideoWidget);
-
-	d->mAudioOutput = new Phonon::AudioOutput(Phonon::VideoCategory, this);
-	Phonon::createPath(d->mMediaObject, d->mAudioOutput);
-
-	d->setupHud(d->mVideoWidget);
-
-	setWidget(d->mVideoWidget);
-}
-
-
-void VideoViewAdapter::installEventFilterOnViewWidgets(QObject* object) {
-	d->mVideoWidget->installEventFilter(object);
-}
-
-
-VideoViewAdapter::~VideoViewAdapter() {
-	delete d;
-}
-
-
-void VideoViewAdapter::setDocument(Document::Ptr doc) {
-	d->mHud->show();
-	d->mDocument = doc;
-	d->mMediaObject->setCurrentSource(d->mDocument->url());
-	d->mMediaObject->play();
-}
-
-
-Document::Ptr VideoViewAdapter::document() const {
-	return d->mDocument;
-}
-
-
-void VideoViewAdapter::slotPlayPauseClicked() {
-	if (d->isPlaying()) {
-		d->mMediaObject->pause();
-	} else {
-		d->mMediaObject->play();
-	}
-}
-
-
-bool VideoViewAdapter::eventFilter(QObject*, QEvent* event) {
-	if (event->type() == QEvent::MouseMove) {
-		d->updateHudVisibility(static_cast<QMouseEvent*>(event)->y());
-	}
-	return false;
-}
-
-
-void VideoViewAdapter::updatePlayPauseButton() {
-	if (d->isPlaying()) {
-		d->mPlayPauseButton->setIcon(KIcon("media-playback-pause"));
-	} else {
-		d->mPlayPauseButton->setIcon(KIcon("media-playback-start"));
-	}
-}
-
+VideoViewAdapter::VideoViewAdapter()
+: d(new VideoViewAdapterPrivate)
+{
+    d->q = this;
+    d->mMediaObject = new Phonon::MediaObject(this);
+    connect(d->mMediaObject, SIGNAL(finished()), SIGNAL(videoFinished()));
+
+    d->mVideoWidget = new Phonon::VideoWidget;
+    d->mVideoWidget->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
+    d->mVideoWidget->setAttribute(Qt::WA_Hover);
+
+    Phonon::createPath(d->mMediaObject, d->mVideoWidget);
+
+    d->mAudioOutput = new Phonon::AudioOutput(Phonon::VideoCategory, this);
+    Phonon::createPath(d->mMediaObject, d->mAudioOutput);
+
+    d->setupHud(d->mVideoWidget);
+
+    QGraphicsProxyWidget* proxy = new QGraphicsProxyWidget;
+    proxy->setWidget(d->mVideoWidget);
+    setWidget(proxy);
+}
+
+VideoViewAdapter::~VideoViewAdapter()
+{
+    delete d;
+}
+
+void VideoViewAdapter::setDocument(Document::Ptr doc)
+{
+    d->mHud->show();
+    d->mDocument = doc;
+    d->mMediaObject->setCurrentSource(d->mDocument->url());
+    d->mMediaObject->play();
+}
+
+Document::Ptr VideoViewAdapter::document() const
+{
+    return d->mDocument;
+}
+
+void VideoViewAdapter::slotPlayPauseClicked()
+{
+    if (d->isPlaying()) {
+        d->mMediaObject->pause();
+    } else {
+        d->mMediaObject->play();
+    }
+}
+
+bool VideoViewAdapter::eventFilter(QObject*, QEvent* event)
+{
+    if (event->type() == QEvent::MouseMove) {
+        d->updateHudVisibility(static_cast<QMouseEvent*>(event)->y());
+    }
+    return false;
+}
+
+void VideoViewAdapter::updatePlayPauseButton()
+{
+    if (d->isPlaying()) {
+        d->mPlayPauseButton->setIcon(KIcon("media-playback-pause"));
+    } else {
+        d->mPlayPauseButton->setIcon(KIcon("media-playback-start"));
+    }
+}
 
 } // namespace

=== modified file 'lib/documentview/videoviewadapter.h'
--- lib/documentview/videoviewadapter.h	2011-07-20 13:46:34 +0000
+++ lib/documentview/videoviewadapter.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -30,40 +30,40 @@
 // Local
 #include <lib/documentview/abstractdocumentviewadapter.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct VideoViewAdapterPrivate;
-class GWENVIEWLIB_EXPORT VideoViewAdapter : public AbstractDocumentViewAdapter {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT VideoViewAdapter : public AbstractDocumentViewAdapter
+{
+    Q_OBJECT
 public:
-	VideoViewAdapter(QWidget*);
-	~VideoViewAdapter();
-
-	virtual void installEventFilterOnViewWidgets(QObject*);
-
-	virtual MimeTypeUtils::Kind kind() const { return MimeTypeUtils::KIND_VIDEO; }
-
-	virtual Document::Ptr document() const;
-
-	virtual void setDocument(Document::Ptr);
+    VideoViewAdapter();
+    ~VideoViewAdapter();
+
+    virtual MimeTypeUtils::Kind kind() const {
+        return MimeTypeUtils::KIND_VIDEO;
+    }
+
+    virtual Document::Ptr document() const;
+
+    virtual void setDocument(Document::Ptr);
 
 Q_SIGNALS:
-	void videoFinished();
+    void videoFinished();
 
 protected:
-	bool eventFilter(QObject*, QEvent*);
+    bool eventFilter(QObject*, QEvent*);
 
 private Q_SLOTS:
-	void slotPlayPauseClicked();
-	void updatePlayPauseButton();
+    void slotPlayPauseClicked();
+    void updatePlayPauseButton();
 
 private:
-	friend struct VideoViewAdapterPrivate;
-	VideoViewAdapterPrivate* const d;
+    friend struct VideoViewAdapterPrivate;
+    VideoViewAdapterPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* VIDEOVIEWADAPTER_H */

=== modified file 'lib/eventwatcher.cpp'
--- lib/eventwatcher.cpp	2011-07-20 13:46:34 +0000
+++ lib/eventwatcher.cpp	2011-12-15 14:17:54 +0000
@@ -19,36 +19,37 @@
 */
 #include "eventwatcher.moc"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 EventWatcher::EventWatcher(QObject* watched, const QList<QEvent::Type>& eventTypes)
 : QObject(watched)
-, mEventTypes(eventTypes) {
-	Q_ASSERT(watched);
-	watched->installEventFilter(this);
-}
-
-
-EventWatcher* EventWatcher::install(QObject* watched, const QList<QEvent::Type>& eventTypes, QObject* receiver, const char* slot) {
-	EventWatcher* watcher = new EventWatcher(watched, eventTypes);
-	connect(watcher, SIGNAL(eventTriggered(QEvent*)), receiver, slot);
-	return watcher;
-}
-
-
-EventWatcher* EventWatcher::install(QObject* watched, QEvent::Type eventType, QObject* receiver, const char* slot) {
-	EventWatcher* watcher = new EventWatcher(watched, QList<QEvent::Type>() << eventType);
-	connect(watcher, SIGNAL(eventTriggered(QEvent*)), receiver, slot);
-	return watcher;
-}
-
-
-bool EventWatcher::eventFilter(QObject*, QEvent* event) {
-	if (mEventTypes.contains(event->type())) {
-		eventTriggered(event);
-	}
-	return false;
-}
-
+, mEventTypes(eventTypes)
+{
+    Q_ASSERT(watched);
+    watched->installEventFilter(this);
+}
+
+EventWatcher* EventWatcher::install(QObject* watched, const QList<QEvent::Type>& eventTypes, QObject* receiver, const char* slot)
+{
+    EventWatcher* watcher = new EventWatcher(watched, eventTypes);
+    connect(watcher, SIGNAL(eventTriggered(QEvent*)), receiver, slot);
+    return watcher;
+}
+
+EventWatcher* EventWatcher::install(QObject* watched, QEvent::Type eventType, QObject* receiver, const char* slot)
+{
+    EventWatcher* watcher = new EventWatcher(watched, QList<QEvent::Type>() << eventType);
+    connect(watcher, SIGNAL(eventTriggered(QEvent*)), receiver, slot);
+    return watcher;
+}
+
+bool EventWatcher::eventFilter(QObject*, QEvent* event)
+{
+    if (mEventTypes.contains(event->type())) {
+        eventTriggered(event);
+    }
+    return false;
+}
 
 } // namespace

=== modified file 'lib/eventwatcher.h'
--- lib/eventwatcher.h	2011-07-20 13:46:34 +0000
+++ lib/eventwatcher.h	2011-12-15 14:17:54 +0000
@@ -28,30 +28,31 @@
 // Local
 #include "gwenviewlib_export.h"
 
-
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * This class emits a signal when some events are triggered on a watched
  * object.
  */
-class GWENVIEWLIB_EXPORT EventWatcher : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT EventWatcher : public QObject
+{
+    Q_OBJECT
 public:
-	EventWatcher(QObject* watched, const QList<QEvent::Type>& eventTypes);
-
-	static EventWatcher* install(QObject* watched, const QList<QEvent::Type>& eventTypes, QObject* receiver, const char* slot);
-
-	static EventWatcher* install(QObject* watched, QEvent::Type eventType, QObject* receiver, const char* slot);
+    EventWatcher(QObject* watched, const QList<QEvent::Type>& eventTypes);
+
+    static EventWatcher* install(QObject* watched, const QList<QEvent::Type>& eventTypes, QObject* receiver, const char* slot);
+
+    static EventWatcher* install(QObject* watched, QEvent::Type eventType, QObject* receiver, const char* slot);
 
 Q_SIGNALS:
-	void eventTriggered(QEvent*);
+    void eventTriggered(QEvent*);
 
 protected:
-	virtual bool eventFilter(QObject*, QEvent* event);
+    virtual bool eventFilter(QObject*, QEvent* event);
 
 private:
-	QList<QEvent::Type> mEventTypes;
+    QList<QEvent::Type> mEventTypes;
 };
 
 }

=== modified file 'lib/exiv2imageloader.cpp'
--- lib/exiv2imageloader.cpp	2011-07-20 13:46:34 +0000
+++ lib/exiv2imageloader.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -33,54 +33,53 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct Exiv2ImageLoaderPrivate {
-	Exiv2::Image::AutoPtr mImage;
-	QString mErrorMessage;
+    Exiv2::Image::AutoPtr mImage;
+    QString mErrorMessage;
 };
 
-
 Exiv2ImageLoader::Exiv2ImageLoader()
-: d(new Exiv2ImageLoaderPrivate) {
-}
-
-
-Exiv2ImageLoader::~Exiv2ImageLoader() {
-	delete d;
-}
-
-
-bool Exiv2ImageLoader::load(const QByteArray& data) {
-	try {
-		d->mImage = Exiv2::ImageFactory::open((unsigned char*)data.constData(), data.size());
-		d->mImage->readMetadata();
+: d(new Exiv2ImageLoaderPrivate)
+{
+}
+
+Exiv2ImageLoader::~Exiv2ImageLoader()
+{
+    delete d;
+}
+
+bool Exiv2ImageLoader::load(const QByteArray& data)
+{
+    try {
+        d->mImage = Exiv2::ImageFactory::open((unsigned char*)data.constData(), data.size());
+        d->mImage->readMetadata();
 #if EXIV2_VERSION >= EXIV2_MAKE_VERSION(0, 14, 0)
-	// For some unknown reason, trying to catch Exiv2::Error fails with Exiv2
-	// >=0.14. For now, just catch std::exception. I would welcome any
-	// explanation.
-	} catch (const std::exception& error) {
-		d->mErrorMessage = error.what();
+        // For some unknown reason, trying to catch Exiv2::Error fails with Exiv2
+        // >=0.14. For now, just catch std::exception. I would welcome any
+        // explanation.
+    } catch (const std::exception& error) {
+        d->mErrorMessage = error.what();
 #else
-	// In libexiv2 0.12, Exiv2::Error::what() returns an std::string.
-	} catch (const Exiv2::Error& error) {
-		d->mErrorMessage = error.what().c_str();
+        // In libexiv2 0.12, Exiv2::Error::what() returns an std::string.
+    } catch (const Exiv2::Error& error) {
+        d->mErrorMessage = error.what().c_str();
 #endif
-		return false;
-	}
-	return true;
-}
-
-
-QString Exiv2ImageLoader::errorMessage() const {
-	return d->mErrorMessage;
-}
-
-
-Exiv2::Image::AutoPtr Exiv2ImageLoader::popImage() {
-	return d->mImage;
-}
-
+        return false;
+    }
+    return true;
+}
+
+QString Exiv2ImageLoader::errorMessage() const
+{
+    return d->mErrorMessage;
+}
+
+Exiv2::Image::AutoPtr Exiv2ImageLoader::popImage()
+{
+    return d->mImage;
+}
 
 } // namespace

=== modified file 'lib/exiv2imageloader.h'
--- lib/exiv2imageloader.h	2011-07-20 13:46:34 +0000
+++ lib/exiv2imageloader.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -34,8 +34,8 @@
 class QByteArray;
 class QString;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct Exiv2ImageLoaderPrivate;
 
@@ -43,20 +43,20 @@
  * This helper class loads image using libexiv2, and takes care of exception
  * handling for the different versions of libexiv2.
  */
-class Exiv2ImageLoader {
+class Exiv2ImageLoader
+{
 public:
-	Exiv2ImageLoader();
-	~Exiv2ImageLoader();
+    Exiv2ImageLoader();
+    ~Exiv2ImageLoader();
 
-	bool load(const QByteArray&);
-	QString errorMessage() const;
-	Exiv2::Image::AutoPtr popImage();
+    bool load(const QByteArray&);
+    QString errorMessage() const;
+    Exiv2::Image::AutoPtr popImage();
 
 private:
-	Exiv2ImageLoaderPrivate* const d;
+    Exiv2ImageLoaderPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* EXIV2IMAGELOADER_H */

=== modified file 'lib/flowlayout.cpp'
--- lib/flowlayout.cpp	2011-07-20 13:46:34 +0000
+++ lib/flowlayout.cpp	2011-12-15 14:17:54 +0000
@@ -40,7 +40,7 @@
 #include <QLayout>
 
 FlowLayout::FlowLayout(QWidget *parent, int margin, int spacing)
-    : QLayout(parent)
+: QLayout(parent)
 {
     setMargin(margin);
     setSpacing(spacing);
@@ -112,10 +112,10 @@
 {
     QSize size;
     QLayoutItem *item;
-    foreach (item, itemList)
-        size = size.expandedTo(item->minimumSize());
+    foreach(item, itemList)
+    size = size.expandedTo(item->minimumSize());
 
-    size += QSize(2*margin(), 2*margin());
+    size += QSize(2 * margin(), 2 * margin());
     return size;
 }
 
@@ -126,7 +126,7 @@
     int lineHeight = 0;
 
     QLayoutItem *item;
-    foreach (item, itemList) {
+    foreach(item, itemList) {
         int nextX = x + item->sizeHint().width() + spacing();
         if (nextX - spacing() > rect.right() && lineHeight > 0) {
             x = rect.x();

=== modified file 'lib/fullscreenbar.cpp'
--- lib/fullscreenbar.cpp	2011-09-08 12:26:41 +0000
+++ lib/fullscreenbar.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -40,8 +40,8 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 static const int SLIDE_DURATION = 150;
 static const int AUTO_HIDE_CURSOR_TIMEOUT = 1000;
@@ -54,216 +54,219 @@
 static const int EXTRA_BAR_HEIGHT = 20;
 
 struct FullScreenBarPrivate {
-	FullScreenBar* that;
-	QTimeLine* mTimeLine;
-	QTimer* mAutoHideCursorTimer;
-	bool mAutoHidingEnabled;
-	QTimer* mInitialHideTimer;
-
-	void startTimeLine() {
-		if (mTimeLine->state() != QTimeLine::Running) {
-			mTimeLine->start();
-		}
-	}
-
-	void hideCursor() {
-		QBitmap empty(32, 32);
-		empty.clear();
-		QCursor blankCursor(empty, empty);
-		QApplication::setOverrideCursor(blankCursor);
-	}
-
-	/**
-	 * Returns the rectangle in which the mouse must enter to trigger bar
-	 * sliding. The rectangle is in global coords.
-	 */
-	QRect slideInTriggerRect() const {
-		QRect rect = QApplication::desktop()->screenGeometry(QApplication::desktop()->screenNumber(that->parentWidget()));
-		// Take parent widget position into account because it may not be at
-		// the top of the screen, for example when the save bar warning is
-		// shown.
-		rect.setHeight(that->parentWidget()->y() + that->height() + EXTRA_BAR_HEIGHT);
-		return rect;
-	}
-
-	bool shouldHide() const {
-		Q_ASSERT(that->parentWidget());
-
-		if (!mAutoHidingEnabled) {
-			return false;
-		}
-		if (slideInTriggerRect().contains(QCursor::pos())) {
-			return false;
-		}
-		if (QApplication::activePopupWidget()) {
-			return false;
-		}
-		// Do not hide if a button is down, which can happen when we are
-		// using a scroll bar.
-		if (QApplication::mouseButtons() != Qt::NoButton) {
-			return false;
-		}
-		return true;
-	}
+    FullScreenBar* q;
+    QTimeLine* mTimeLine;
+    QTimer* mAutoHideCursorTimer;
+    bool mAutoHidingEnabled;
+    QTimer* mInitialHideTimer;
+
+    void startTimeLine()
+    {
+        if (mTimeLine->state() != QTimeLine::Running) {
+            mTimeLine->start();
+        }
+    }
+
+    void hideCursor()
+    {
+        QBitmap empty(32, 32);
+        empty.clear();
+        QCursor blankCursor(empty, empty);
+        QApplication::setOverrideCursor(blankCursor);
+    }
+
+    /**
+     * Returns the rectangle in which the mouse must enter to trigger bar
+     * sliding. The rectangle is in global coords.
+     */
+    QRect slideInTriggerRect() const {
+        QRect rect = QApplication::desktop()->screenGeometry(QApplication::desktop()->screenNumber(q->parentWidget()));
+        // Take parent widget position into account because it may not be at
+        // the top of the screen, for example when the save bar warning is
+        // shown.
+        rect.setHeight(q->parentWidget()->y() + q->height() + EXTRA_BAR_HEIGHT);
+        return rect;
+    }
+
+    bool shouldHide() const {
+        Q_ASSERT(q->parentWidget());
+
+        if (!mAutoHidingEnabled) {
+            return false;
+        }
+        if (slideInTriggerRect().contains(QCursor::pos())) {
+            return false;
+        }
+        if (QApplication::activePopupWidget()) {
+            return false;
+        }
+        // Do not hide if a button is down, which can happen when we are
+        // using a scroll bar.
+        if (QApplication::mouseButtons() != Qt::NoButton) {
+            return false;
+        }
+        return true;
+    }
 };
 
-
 FullScreenBar::FullScreenBar(QWidget* parent)
 : QFrame(parent)
-, d(new FullScreenBarPrivate) {
-	d->that = this;
-	d->mAutoHidingEnabled = true;
-	setObjectName( QLatin1String("fullScreenBar" ));
-
-	d->mTimeLine = new QTimeLine(SLIDE_DURATION, this);
-	connect(d->mTimeLine, SIGNAL(valueChanged(qreal)), SLOT(moveBar(qreal)) );
-
-	d->mAutoHideCursorTimer = new QTimer(this);
-	d->mAutoHideCursorTimer->setInterval(AUTO_HIDE_CURSOR_TIMEOUT);
-	d->mAutoHideCursorTimer->setSingleShot(true);
-	connect(d->mAutoHideCursorTimer, SIGNAL(timeout()), SLOT(slotAutoHideCursorTimeout()) );
-
-	d->mInitialHideTimer = new QTimer(this);
-	d->mInitialHideTimer->setInterval(INITIAL_HIDE_TIMEOUT);
-	d->mInitialHideTimer->setSingleShot(true);
-	connect(d->mInitialHideTimer, SIGNAL(timeout()), SLOT(slideOut()));
-
-	hide();
-}
-
-
-FullScreenBar::~FullScreenBar() {
-	delete d;
-}
-
-QSize FullScreenBar::sizeHint() const {
-	QSize sh = QFrame::sizeHint();
-	if (!layout()) {
-		return sh;
-	}
-
-	if (layout()->expandingDirections() & Qt::Horizontal) {
-		int width = QApplication::desktop()->screenGeometry(window()).width();
-		sh.setWidth(width);
-	}
-	return sh;
-}
-
-void FullScreenBar::moveBar(qreal value) {
-	move(0, -height() + int(value * height()) );
-
-	// For some reason, if Gwenview is started with command line options to
-	// start a slideshow, the bar might end up below the view. Calling raise()
-	// here fixes it.
-	raise();
-}
-
-
-void FullScreenBar::setActivated(bool activated) {
-	if (activated) {
-		// Delay installation of event filter because switching to fullscreen
-		// cause a few window adjustments, which seems to generate unwanted
-		// mouse events, which cause the bar to slide in.
-		QTimer::singleShot(500, this, SLOT(delayedInstallEventFilter()));
-
-		adjustSize();
-
-		// Make sure the widget is visible on start
-		move(0, 0);
-		raise();
-		show();
-	} else {
-		qApp->removeEventFilter(this);
-		hide();
-		d->mAutoHideCursorTimer->stop();
-		QApplication::restoreOverrideCursor();
-	}
-}
-
-
-void FullScreenBar::delayedInstallEventFilter() {
-	qApp->installEventFilter(this);
-	if (d->shouldHide()) {
-		d->mInitialHideTimer->start();
-		d->hideCursor();
-	}
-}
-
-
-void FullScreenBar::slotAutoHideCursorTimeout() {
-	if (d->shouldHide()) {
-		d->hideCursor();
-	} else {
-		d->mAutoHideCursorTimer->start();
-	}
-}
-
-
-void FullScreenBar::slideOut() {
-	d->mInitialHideTimer->stop();
-	d->mTimeLine->setDirection(QTimeLine::Backward);
-	d->startTimeLine();
-}
-
-
-void FullScreenBar::slideIn() {
-	d->mInitialHideTimer->stop();
-	d->mTimeLine->setDirection(QTimeLine::Forward);
-	d->startTimeLine();
-}
-
-
-bool FullScreenBar::eventFilter(QObject* object, QEvent* event) {
-	if (event->type() == QEvent::MouseMove) {
-		QApplication::restoreOverrideCursor();
-		d->mAutoHideCursorTimer->start();
-		if (y() == 0) {
-			if (d->shouldHide()) {
-				slideOut();
-			}
-		} else {
-			QMouseEvent* mouseEvent = static_cast<QMouseEvent *>(event);
-			if (mouseEvent->buttons() == 0 && d->slideInTriggerRect().contains(QCursor::pos())) {
-				slideIn();
-			}
-		}
-		return false;
-	}
-
-	if (event->type() == QEvent::MouseButtonRelease) {
-		// This can happen if user released the mouse after using a scrollbar
-		// in the content (the bar does not hide while a button is down)
-		if (y() == 0 && d->shouldHide()) {
-			slideOut();
-		}
-		return false;
-	}
-
-	// Filtering message on tooltip text for CJK to remove accelerators.
-	// Quoting ktoolbar.cpp:
-	// """
-	// CJK languages use more verbose accelerator marker: they add a Latin
-	// letter in parenthesis, and put accelerator on that. Hence, the default
-	// removal of ampersand only may not be enough there, instead the whole
-	// parenthesis construct should be removed. Use KLocale's method to do this.
-	// """
-	if (event->type() == QEvent::Show || event->type() == QEvent::Paint) {
-		QToolButton* button = qobject_cast<QToolButton*>(object);
-		if (button && !button->actions().isEmpty()) {
-			QAction* action = button->actions().first();
-			QString toolTip = KGlobal::locale()->removeAcceleratorMarker(action->toolTip());
-			// Filtering message requested by translators (scripting).
-			button->setToolTip(i18nc("@info:tooltip of custom toolbar button", "%1", toolTip));
-		}
-	}
-
-	return false;
-}
-
-
-void FullScreenBar::setAutoHidingEnabled(bool value) {
-	d->mAutoHidingEnabled = value;
-}
-
+, d(new FullScreenBarPrivate)
+{
+    d->q = this;
+    d->mAutoHidingEnabled = true;
+    setObjectName(QLatin1String("fullScreenBar"));
+
+    d->mTimeLine = new QTimeLine(SLIDE_DURATION, this);
+    connect(d->mTimeLine, SIGNAL(valueChanged(qreal)), SLOT(moveBar(qreal)));
+
+    d->mAutoHideCursorTimer = new QTimer(this);
+    d->mAutoHideCursorTimer->setInterval(AUTO_HIDE_CURSOR_TIMEOUT);
+    d->mAutoHideCursorTimer->setSingleShot(true);
+    connect(d->mAutoHideCursorTimer, SIGNAL(timeout()), SLOT(slotAutoHideCursorTimeout()));
+
+    d->mInitialHideTimer = new QTimer(this);
+    d->mInitialHideTimer->setInterval(INITIAL_HIDE_TIMEOUT);
+    d->mInitialHideTimer->setSingleShot(true);
+    connect(d->mInitialHideTimer, SIGNAL(timeout()), SLOT(slideOut()));
+
+    hide();
+}
+
+FullScreenBar::~FullScreenBar()
+{
+    delete d;
+}
+
+QSize FullScreenBar::sizeHint() const
+{
+    QSize sh = QFrame::sizeHint();
+    if (!layout()) {
+        return sh;
+    }
+
+    if (layout()->expandingDirections() & Qt::Horizontal) {
+        int width = QApplication::desktop()->screenGeometry(window()).width();
+        sh.setWidth(width);
+    }
+    return sh;
+}
+
+void FullScreenBar::moveBar(qreal value)
+{
+    move(0, -height() + int(value * height()));
+
+    // For some reason, if Gwenview is started with command line options to
+    // start a slideshow, the bar might end up below the view. Calling raise()
+    // here fixes it.
+    raise();
+}
+
+void FullScreenBar::setActivated(bool activated)
+{
+    if (activated) {
+        // Delay installation of event filter because switching to fullscreen
+        // cause a few window adjustments, which seems to generate unwanted
+        // mouse events, which cause the bar to slide in.
+        QTimer::singleShot(500, this, SLOT(delayedInstallEventFilter()));
+
+        adjustSize();
+
+        // Make sure the widget is visible on start
+        move(0, 0);
+        raise();
+        show();
+    } else {
+        qApp->removeEventFilter(this);
+        hide();
+        d->mAutoHideCursorTimer->stop();
+        QApplication::restoreOverrideCursor();
+    }
+}
+
+void FullScreenBar::delayedInstallEventFilter()
+{
+    qApp->installEventFilter(this);
+    if (d->shouldHide()) {
+        d->mInitialHideTimer->start();
+        d->hideCursor();
+    }
+}
+
+void FullScreenBar::slotAutoHideCursorTimeout()
+{
+    if (d->shouldHide()) {
+        d->hideCursor();
+    } else {
+        d->mAutoHideCursorTimer->start();
+    }
+}
+
+void FullScreenBar::slideOut()
+{
+    d->mInitialHideTimer->stop();
+    d->mTimeLine->setDirection(QTimeLine::Backward);
+    d->startTimeLine();
+}
+
+void FullScreenBar::slideIn()
+{
+    d->mInitialHideTimer->stop();
+    d->mTimeLine->setDirection(QTimeLine::Forward);
+    d->startTimeLine();
+}
+
+bool FullScreenBar::eventFilter(QObject* object, QEvent* event)
+{
+    if (event->type() == QEvent::MouseMove) {
+        QApplication::restoreOverrideCursor();
+        d->mAutoHideCursorTimer->start();
+        if (y() == 0) {
+            if (d->shouldHide()) {
+                slideOut();
+            }
+        } else {
+            QMouseEvent* mouseEvent = static_cast<QMouseEvent *>(event);
+            if (mouseEvent->buttons() == 0 && d->slideInTriggerRect().contains(QCursor::pos())) {
+                slideIn();
+            }
+        }
+        return false;
+    }
+
+    if (event->type() == QEvent::MouseButtonRelease) {
+        // This can happen if user released the mouse after using a scrollbar
+        // in the content (the bar does not hide while a button is down)
+        if (y() == 0 && d->shouldHide()) {
+            slideOut();
+        }
+        return false;
+    }
+
+    // Filtering message on tooltip text for CJK to remove accelerators.
+    // Quoting ktoolbar.cpp:
+    // """
+    // CJK languages use more verbose accelerator marker: they add a Latin
+    // letter in parenthesis, and put accelerator on that. Hence, the default
+    // removal of ampersand only may not be enough there, instead the whole
+    // parenthesis construct should be removed. Use KLocale's method to do this.
+    // """
+    if (event->type() == QEvent::Show || event->type() == QEvent::Paint) {
+        QToolButton* button = qobject_cast<QToolButton*>(object);
+        if (button && !button->actions().isEmpty()) {
+            QAction* action = button->actions().first();
+            QString toolTip = KGlobal::locale()->removeAcceleratorMarker(action->toolTip());
+            // Filtering message requested by translators (scripting).
+            button->setToolTip(i18nc("@info:tooltip of custom toolbar button", "%1", toolTip));
+        }
+    }
+
+    return false;
+}
+
+void FullScreenBar::setAutoHidingEnabled(bool value)
+{
+    d->mAutoHidingEnabled = value;
+}
 
 } // namespace

=== modified file 'lib/fullscreenbar.h'
--- lib/fullscreenbar.h	2011-07-20 13:46:34 +0000
+++ lib/fullscreenbar.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -32,39 +32,39 @@
 
 class QEvent;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct FullScreenBarPrivate;
-class GWENVIEWLIB_EXPORT FullScreenBar : public QFrame {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT FullScreenBar : public QFrame
+{
+    Q_OBJECT
 public:
-	FullScreenBar(QWidget* parent);
-	~FullScreenBar();
-
-	void setActivated(bool);
-
-	void setAutoHidingEnabled(bool);
-
-	virtual QSize sizeHint() const;
+    FullScreenBar(QWidget* parent);
+    ~FullScreenBar();
+
+    void setActivated(bool);
+
+    void setAutoHidingEnabled(bool);
+
+    virtual QSize sizeHint() const;
 
 public Q_SLOTS:
-	void slideIn();
-	void slideOut();
+    void slideIn();
+    void slideOut();
 
 private Q_SLOTS:
-	void slotAutoHideCursorTimeout();
-	void moveBar(qreal);
-	void delayedInstallEventFilter();
+    void slotAutoHideCursorTimeout();
+    void moveBar(qreal);
+    void delayedInstallEventFilter();
 
 protected:
-	virtual bool eventFilter(QObject*, QEvent*);
+    virtual bool eventFilter(QObject*, QEvent*);
 
 private:
-	FullScreenBarPrivate* const d;
+    FullScreenBarPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* FULLSCREENBAR_H */

=== modified file 'lib/fullscreentheme.cpp'
--- lib/fullscreentheme.cpp	2011-07-20 13:46:34 +0000
+++ lib/fullscreentheme.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -35,85 +35,89 @@
 // Local
 #include <lib/gwenviewconfig.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 static const char* THEME_BASE_DIR = "fullscreenthemes/";
 
-
 struct FullScreenThemePrivate {
-	QString mThemeDir;
-	QString mStyleSheet;
+    QString mThemeDir;
+    QString mStyleSheet;
 };
 
-
 FullScreenTheme::FullScreenTheme(const QString& themeName)
-: d(new FullScreenThemePrivate) {
-	// Get theme dir
-	d->mThemeDir = KStandardDirs::locate("appdata", THEME_BASE_DIR + themeName + '/');
-	if (d->mThemeDir.isEmpty()) {
-		kWarning() << "Couldn't find fullscreen theme" << themeName;
-		return;
-	}
-
-	// Read css file
-	QString styleSheetPath = d->mThemeDir + "/style.css";
-	QFile file(styleSheetPath);
-	if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) {
-		kWarning() << "Couldn't open" << styleSheetPath;
-		return;
-	}
-	QString styleSheet = QString::fromUtf8(file.readAll());
-
-	d->mStyleSheet = replaceThemeVars(styleSheet);
-}
-
-
-FullScreenTheme::~FullScreenTheme() {
-	delete d;
-}
-
-
-QString FullScreenTheme::styleSheet() const {
-	return d->mStyleSheet;
-}
-
-
-QString FullScreenTheme::replaceThemeVars(const QString& styleSheet) {
-	QHash<QString, QString> macros;
-	macros["themeDir"] = d->mThemeDir;
-	return KMacroExpander::expandMacros(styleSheet, macros, QLatin1Char('$'));
-}
-
-
-QString FullScreenTheme::currentThemeName() {
-	return GwenviewConfig::fullScreenTheme();
-}
-
-
-void FullScreenTheme::setCurrentThemeName(const QString& name) {
-	GwenviewConfig::setFullScreenTheme(name);
-}
-
-
-static bool themeNameLessThan(const QString& s1, const QString& s2) {
-	return KStringHandler::naturalCompare(s1.toLower(), s2.toLower()) < 0;
-}
-
-
-QStringList FullScreenTheme::themeNameList() {
-	QStringList list;
-	const QStringList themeBaseDirs =
-		KGlobal::mainComponent().dirs()
-		->findDirs("appdata", THEME_BASE_DIR);
-	Q_FOREACH(const QString& themeBaseDir, themeBaseDirs) {
-		QDir dir(themeBaseDir);
-		list += dir.entryList(QDir::Dirs | QDir::NoDotAndDotDot);
-	}
-	qSort(list.begin(), list.end(), themeNameLessThan);
-
-	return list;
-}
-
+: d(new FullScreenThemePrivate)
+{
+    // Get theme dir
+    d->mThemeDir = KStandardDirs::locate("appdata", THEME_BASE_DIR + themeName + '/');
+    if (d->mThemeDir.isEmpty()) {
+        kWarning() << "Couldn't find fullscreen theme" << themeName;
+        return;
+    }
+
+    // Read css file
+    QString styleSheetPath = d->mThemeDir + "/style.css";
+    QFile file(styleSheetPath);
+    if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) {
+        kWarning() << "Couldn't open" << styleSheetPath;
+        return;
+    }
+    QString styleSheet = QString::fromUtf8(file.readAll());
+
+    d->mStyleSheet = replaceThemeVars(styleSheet);
+}
+
+FullScreenTheme::~FullScreenTheme()
+{
+    delete d;
+}
+
+QString FullScreenTheme::styleSheet() const
+{
+    return d->mStyleSheet;
+}
+
+QString FullScreenTheme::replaceThemeVars(const QString& styleSheet)
+{
+    QHash<QString, QString> macros;
+    macros["themeDir"] = d->mThemeDir;
+    return KMacroExpander::expandMacros(styleSheet, macros, QLatin1Char('$'));
+}
+
+QString FullScreenTheme::currentThemeName()
+{
+    return GwenviewConfig::fullScreenTheme();
+}
+
+void FullScreenTheme::setCurrentThemeName(const QString& name)
+{
+    GwenviewConfig::setFullScreenTheme(name);
+}
+
+static bool themeNameLessThan(const QString& s1, const QString& s2)
+{
+    return KStringHandler::naturalCompare(s1.toLower(), s2.toLower()) < 0;
+}
+
+QStringList FullScreenTheme::themeNameList()
+{
+    QStringList list;
+    const QStringList themeBaseDirs =
+        KGlobal::mainComponent().dirs()
+        ->findDirs("appdata", THEME_BASE_DIR);
+    Q_FOREACH(const QString & themeBaseDir, themeBaseDirs) {
+        QDir dir(themeBaseDir);
+        list += dir.entryList(QDir::Dirs | QDir::NoDotAndDotDot);
+    }
+    qSort(list.begin(), list.end(), themeNameLessThan);
+
+    return list;
+}
+
+QPalette FullScreenTheme::palette()
+{
+    static QPalette pal = QPalette(QColor::fromHsvF(0, 0, 0, 0.6));
+    return pal;
+}
 
 } // namespace

=== modified file 'lib/fullscreentheme.h'
--- lib/fullscreentheme.h	2011-07-20 13:46:34 +0000
+++ lib/fullscreentheme.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,30 +29,33 @@
 
 // Local
 
+class QPalette;
 class QString;
 class QStringList;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct FullScreenThemePrivate;
-class GWENVIEWLIB_EXPORT FullScreenTheme {
+class GWENVIEWLIB_EXPORT FullScreenTheme
+{
 public:
-	FullScreenTheme(const QString& themeName);
-	QString styleSheet() const;
-	QString replaceThemeVars(const QString& styleSheet);
-
-	~FullScreenTheme();
-
-	static QStringList themeNameList();
-	static QString currentThemeName();
-	static void setCurrentThemeName(const QString&);
+    FullScreenTheme(const QString& themeName);
+    QString styleSheet() const;
+    QString replaceThemeVars(const QString& styleSheet);
+
+    ~FullScreenTheme();
+
+    static QStringList themeNameList();
+    static QString currentThemeName();
+    static void setCurrentThemeName(const QString&);
+
+    static QPalette palette();
 
 private:
-	FullScreenThemePrivate* const d;
+    FullScreenThemePrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* FULLSCREENTHEME_H */

=== added file 'lib/graphicshudwidget.cpp'
--- lib/graphicshudwidget.cpp	1970-01-01 00:00:00 +0000
+++ lib/graphicshudwidget.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,124 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "graphicshudwidget.moc"
+
+// Qt
+#include <QGraphicsProxyWidget>
+#include <QGraphicsLinearLayout>
+#include <QLayout>
+#include <QPainter>
+#include <QToolButton>
+
+// KDE
+#include <kiconloader.h>
+
+// Local
+#include "fullscreentheme.h"
+
+namespace Gwenview
+{
+
+static const int CORNER_RADIUS = 5;
+
+struct GraphicsHudWidgetPrivate {
+    QWidget* mMainWidget;
+    QToolButton* mCloseButton;
+};
+
+GraphicsHudWidget::GraphicsHudWidget(QGraphicsWidget* parent)
+: QGraphicsWidget(parent)
+, d(new GraphicsHudWidgetPrivate)
+{
+    d->mMainWidget = 0;
+    d->mCloseButton = 0;
+}
+
+GraphicsHudWidget::~GraphicsHudWidget()
+{
+    delete d;
+}
+
+void GraphicsHudWidget::init(QWidget* mainWidget, Options options)
+{
+    if (options & OptionOpaque) {
+        setProperty("opaque", QVariant(true));
+    }
+
+    QPalette pal = FullScreenTheme::palette();
+
+    QGraphicsLinearLayout* layout = new QGraphicsLinearLayout(this);
+    layout->setContentsMargins(4, 4, 4, 4);
+    d->mMainWidget = mainWidget;
+    if (d->mMainWidget) {
+        d->mMainWidget->setPalette(pal);
+        if (d->mMainWidget->layout()) {
+            d->mMainWidget->layout()->setMargin(0);
+        }
+        QGraphicsProxyWidget* proxy = new QGraphicsProxyWidget(this);
+        proxy->setWidget(d->mMainWidget);
+        layout->addItem(proxy);
+    }
+    // FIXME: QGV
+    /*
+    if (options & OptionDoNotFollowChildSize) {
+        adjustSize();
+    } else {
+        layout->setSizeConstraint(QLayout::SetFixedSize);
+    }
+    */
+
+    if (options & OptionCloseButton) {
+        d->mCloseButton = new QToolButton;
+        d->mCloseButton->setAutoRaise(true);
+        d->mCloseButton->setIcon(SmallIcon("window-close"));
+        d->mCloseButton->setPalette(pal);
+
+        QGraphicsProxyWidget* proxy = new QGraphicsProxyWidget(this);
+        proxy->setWidget(d->mCloseButton);
+        layout->addItem(proxy);
+        layout->setAlignment(proxy, Qt::AlignTop | Qt::AlignHCenter);
+
+        connect(d->mCloseButton, SIGNAL(clicked()), SLOT(slotCloseButtonClicked()));
+    }
+}
+
+QWidget* GraphicsHudWidget::mainWidget() const
+{
+    return d->mMainWidget;
+}
+
+void GraphicsHudWidget::slotCloseButtonClicked()
+{
+    close();
+    closed();
+}
+
+void GraphicsHudWidget::paint(QPainter* painter, const QStyleOptionGraphicsItem*, QWidget*)
+{
+    QPalette pal = FullScreenTheme::palette();
+    painter->setPen(pal.midlight().color());
+    painter->setRenderHint(QPainter::Antialiasing);
+    painter->setBrush(pal.window());
+    painter->drawRoundedRect(boundingRect().adjusted(.5, .5, -.5, -.5), CORNER_RADIUS, CORNER_RADIUS);
+}
+
+} // namespace

=== added file 'lib/graphicshudwidget.h'
--- lib/graphicshudwidget.h	1970-01-01 00:00:00 +0000
+++ lib/graphicshudwidget.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,74 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef GRAPHICSHUDWIDGET_H
+#define GRAPHICSHUDWIDGET_H
+
+#include <lib/gwenviewlib_export.h>
+
+// Qt
+#include <QGraphicsWidget>
+#include <QWidget>
+
+// KDE
+
+// Local
+
+namespace Gwenview
+{
+
+struct GraphicsHudWidgetPrivate;
+class GWENVIEWLIB_EXPORT GraphicsHudWidget : public QGraphicsWidget
+{
+    Q_OBJECT
+public:
+    enum Option {
+        OptionNone                 = 0,
+        OptionCloseButton          = 1 << 1,
+        // FIXME: Ugly
+        OptionDoNotFollowChildSize = 1 << 2, /// Make it possible to resize the graphicshudwidget independently of child size
+        OptionOpaque               = 1 << 3
+    };
+    Q_DECLARE_FLAGS(Options, Option)
+
+    GraphicsHudWidget(QGraphicsWidget* parent = 0);
+    ~GraphicsHudWidget();
+
+    void init(QWidget*, Options options);
+
+    QWidget* mainWidget() const;
+
+    void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget);
+
+Q_SIGNALS:
+    void closed();
+
+private Q_SLOTS:
+    void slotCloseButtonClicked();
+
+private:
+    GraphicsHudWidgetPrivate* const d;
+};
+
+} // namespace
+
+Q_DECLARE_OPERATORS_FOR_FLAGS(Gwenview::GraphicsHudWidget::Options)
+
+#endif /* GRAPHICSHUDWIDGET_H */

=== added file 'lib/graphicswidgetfloater.cpp'
--- lib/graphicswidgetfloater.cpp	1970-01-01 00:00:00 +0000
+++ lib/graphicswidgetfloater.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,172 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "graphicswidgetfloater.moc"
+
+// Qt
+#include <QEvent>
+#include <QGraphicsWidget>
+#include <QPointer>
+
+// KDE
+#include <kdebug.h>
+#include <kdialog.h>
+
+// Local
+
+namespace Gwenview
+{
+
+struct GraphicsWidgetFloaterPrivate {
+    QGraphicsWidget* mParent;
+    QPointer<QGraphicsWidget> mChild;
+    Qt::Alignment mAlignment;
+
+    int mHorizontalMargin;
+    int mVerticalMargin;
+    bool mInsideUpdateChildGeometry;
+
+    void updateChildGeometry()
+    {
+        if (!mChild) {
+            return;
+        }
+        if (mInsideUpdateChildGeometry) {
+            return;
+        }
+        mInsideUpdateChildGeometry = true;
+
+        qreal posX, posY;
+        qreal childWidth, childHeight;
+        qreal parentWidth, parentHeight;
+
+        childWidth = mChild->size().width();
+        childHeight = mChild->size().height();
+
+        parentWidth = mParent->size().width();
+        parentHeight = mParent->size().height();
+
+        if (mAlignment & Qt::AlignLeft) {
+            posX = mHorizontalMargin;
+        } else if (mAlignment & Qt::AlignHCenter) {
+            posX = (parentWidth - childWidth) / 2;
+        } else if (mAlignment & Qt::AlignJustify) {
+            posX = mHorizontalMargin;
+            childWidth = parentWidth - 2 * mHorizontalMargin;
+            QRectF childGeometry = mChild->geometry();
+            childGeometry.setWidth(childWidth);
+            mChild->setGeometry(childGeometry);
+        } else {
+            posX = parentWidth - childWidth - mHorizontalMargin;
+        }
+
+        if (mAlignment & Qt::AlignTop) {
+            posY = mVerticalMargin;
+        } else if (mAlignment & Qt::AlignVCenter) {
+            posY = (parentHeight - childHeight) / 2;
+        } else {
+            posY = parentHeight - childHeight - mVerticalMargin;
+        }
+
+        mChild->setGeometry(posX, posY, childWidth, childHeight);
+
+        mInsideUpdateChildGeometry = false;
+    }
+};
+
+GraphicsWidgetFloater::GraphicsWidgetFloater(QGraphicsWidget* parent)
+: QObject(parent)
+, d(new GraphicsWidgetFloaterPrivate)
+{
+    Q_ASSERT(parent);
+    d->mParent = parent;
+    d->mParent->installEventFilter(this);
+    d->mChild = 0;
+    d->mAlignment = Qt::AlignCenter;
+    d->mHorizontalMargin = KDialog::marginHint();
+    d->mVerticalMargin = KDialog::marginHint();
+    d->mInsideUpdateChildGeometry = false;
+}
+
+GraphicsWidgetFloater::~GraphicsWidgetFloater()
+{
+    delete d;
+}
+
+void GraphicsWidgetFloater::setChildWidget(QGraphicsWidget* child)
+{
+    if (d->mChild) {
+        d->mChild->removeEventFilter(this);
+        disconnect(d->mChild, 0, this, 0);
+    }
+    d->mChild = child;
+    d->mChild->setParent(d->mParent);
+    d->mChild->installEventFilter(this);
+    connect(d->mChild, SIGNAL(visibleChanged()), SLOT(slotChildVisibilityChanged()));
+    d->updateChildGeometry();
+    //d->mChild->raise();
+    d->mChild->show();
+}
+
+void GraphicsWidgetFloater::setAlignment(Qt::Alignment alignment)
+{
+    d->mAlignment = alignment;
+    d->updateChildGeometry();
+}
+
+bool GraphicsWidgetFloater::eventFilter(QObject*, QEvent* event)
+{
+    if (event->type() == QEvent::GraphicsSceneResize) {
+        d->updateChildGeometry();
+    }
+    return false;
+}
+
+void GraphicsWidgetFloater::slotChildVisibilityChanged()
+{
+    if (d->mChild->isVisible()) {
+        d->updateChildGeometry();
+    }
+}
+
+void GraphicsWidgetFloater::setHorizontalMargin(int value)
+{
+    d->mHorizontalMargin = value;
+    d->updateChildGeometry();
+}
+
+int GraphicsWidgetFloater::horizontalMargin() const
+{
+    return d->mHorizontalMargin;
+}
+
+void GraphicsWidgetFloater::setVerticalMargin(int value)
+{
+    d->mVerticalMargin = value;
+    d->updateChildGeometry();
+}
+
+int GraphicsWidgetFloater::verticalMargin() const
+{
+    return d->mVerticalMargin;
+}
+
+} // namespace

=== added file 'lib/graphicswidgetfloater.h'
--- lib/graphicswidgetfloater.h	1970-01-01 00:00:00 +0000
+++ lib/graphicswidgetfloater.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,74 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef GRAPHICSWIDGETFLOATER_H
+#define GRAPHICSWIDGETFLOATER_H
+
+#include <lib/gwenviewlib_export.h>
+
+// Qt
+#include <QObject>
+
+// KDE
+
+// Local
+
+class QGraphicsWidget;
+
+namespace Gwenview
+{
+
+struct GraphicsWidgetFloaterPrivate;
+
+/**
+ * This helper object makes it possible to place a widget (the child) over
+ * another (the parent), ensuring the child remains aligned as specified by
+ * setAlignment() whenever either widget get resized.
+ */
+class GWENVIEWLIB_EXPORT GraphicsWidgetFloater : public QObject
+{
+    Q_OBJECT
+public:
+    GraphicsWidgetFloater(QGraphicsWidget* parent);
+    ~GraphicsWidgetFloater();
+
+    void setChildWidget(QGraphicsWidget*);
+
+    void setAlignment(Qt::Alignment);
+
+    void setHorizontalMargin(int);
+    int horizontalMargin() const;
+
+    void setVerticalMargin(int);
+    int verticalMargin() const;
+
+protected:
+    bool eventFilter(QObject*, QEvent*);
+
+private Q_SLOTS:
+    void slotChildVisibilityChanged();
+
+private:
+    GraphicsWidgetFloaterPrivate* const d;
+};
+
+} // namespace
+
+#endif /* GRAPHICSWIDGETFLOATER_H */

=== modified file 'lib/gwenviewconfig.kcfg'
--- lib/gwenviewconfig.kcfg	2011-07-20 13:46:34 +0000
+++ lib/gwenviewconfig.kcfg	2011-12-15 14:17:54 +0000
@@ -7,7 +7,7 @@
 	<kcfgfile name="gwenviewrc"/>
 	<include>lib/sorting.h</include>
 	<include>lib/mousewheelbehavior.h</include>
-	<include>lib/imageview.h</include>
+	<include>lib/documentview/rasterimageview.h</include>
 	<include>lib/print/printoptionspage.h</include>
 	<group name="SideBar">
 		<entry name="PreferredMetaInfoKeyList" type="StringList">
@@ -90,11 +90,11 @@
 
 	<group name="ImageView">
 		<entry name="AlphaBackgroundMode" type="Enum">
-			<choices name="Gwenview::ImageView::AlphaBackgroundMode">
-				<choice name="ImageView::AlphaBackgroundCheckBoard"/>
-				<choice name="ImageView::AlphaBackgroundSolid"/>
+			<choices name="Gwenview::RasterImageView::AlphaBackgroundMode">
+				<choice name="RasterImageView::AlphaBackgroundCheckBoard"/>
+				<choice name="RasterImageView::AlphaBackgroundSolid"/>
 			</choices>
-			<default>ImageView::AlphaBackgroundCheckBoard</default>
+			<default>RasterImageView::AlphaBackgroundCheckBoard</default>
 		</entry>
 		<entry name="AlphaBackgroundColor" type="Color">
 			<default>#ffffff</default>

=== modified file 'lib/gwenviewlib_export.h'
--- lib/gwenviewlib_export.h	2011-07-20 13:46:34 +0000
+++ lib/gwenviewlib_export.h	2011-12-15 14:17:54 +0000
@@ -25,10 +25,10 @@
 
 #ifndef GWENVIEWLIB_EXPORT
 # if defined(MAKE_GWENVIEWLIB_LIB)
-   /* We are building this library */ 
+/* We are building this library */
 #  define GWENVIEWLIB_EXPORT KDE_EXPORT
 # else
-   /* We are using this library */ 
+/* We are using this library */
 #  define GWENVIEWLIB_EXPORT KDE_IMPORT
 # endif
 #endif

=== modified file 'lib/historymodel.cpp'
--- lib/historymodel.cpp	2011-07-20 13:46:34 +0000
+++ lib/historymodel.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -42,194 +42,197 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct HistoryItem : public QStandardItem {
-	void save() const {
-		KConfig config(mConfigPath, KConfig::SimpleConfig);
-		KConfigGroup group(&config, "general");
-		group.writeEntry("url", mUrl);
-		group.writeEntry("dateTime", mDateTime.toString(Qt::ISODate));
-		config.sync();
-	}
-
-	static HistoryItem* create(const KUrl& url, const QDateTime& dateTime, const QString& storageDir) {
-		if (!KStandardDirs::makeDir(storageDir, 0600)) {
-			kError() << "Could not create history dir" << storageDir;
-			return 0;
-		}
-		KTemporaryFile file;
-		file.setAutoRemove(false);
-		file.setPrefix(storageDir);
-		file.setSuffix("rc");
-		if (!file.open()) {
-			kError() << "Could not create history file";
-			return 0;
-		}
-
-		HistoryItem* item = new HistoryItem(url, dateTime, file.fileName());
-		item->save();
-		return item;
-	}
-
-	static HistoryItem* load(const QString& fileName) {
-		KConfig config(fileName, KConfig::SimpleConfig);
-		KConfigGroup group(&config, "general");
-
-		KUrl url(group.readEntry("url"));
-		if (!url.isValid()) {
-			kError() << "Invalid url" << url;
-			return 0;
-		}
-		QDateTime dateTime = QDateTime::fromString(group.readEntry("dateTime"), Qt::ISODate);
-		if (!dateTime.isValid()) {
-			kError() << "Invalid dateTime" << dateTime;
-			return 0;
-		}
-
-		return new HistoryItem(url, dateTime, fileName);
-	}
-
-	KUrl url() const {
-		return mUrl;
-	}
-
-	QDateTime dateTime() const {
-		return mDateTime;
-	}
-
-	void setDateTime(const QDateTime& dateTime) {
-		if (mDateTime != dateTime) {
-			mDateTime = dateTime;
-			save();
-		}
-	}
-
-	void unlink() {
-		QFile::remove(mConfigPath);
-	}
+    void save() const
+    {
+        KConfig config(mConfigPath, KConfig::SimpleConfig);
+        KConfigGroup group(&config, "general");
+        group.writeEntry("url", mUrl);
+        group.writeEntry("dateTime", mDateTime.toString(Qt::ISODate));
+        config.sync();
+    }
+
+    static HistoryItem* create(const KUrl& url, const QDateTime& dateTime, const QString& storageDir) {
+        if (!KStandardDirs::makeDir(storageDir, 0600)) {
+            kError() << "Could not create history dir" << storageDir;
+            return 0;
+        }
+        KTemporaryFile file;
+        file.setAutoRemove(false);
+        file.setPrefix(storageDir);
+        file.setSuffix("rc");
+        if (!file.open()) {
+            kError() << "Could not create history file";
+            return 0;
+        }
+
+        HistoryItem* item = new HistoryItem(url, dateTime, file.fileName());
+        item->save();
+        return item;
+    }
+
+    static HistoryItem* load(const QString& fileName) {
+        KConfig config(fileName, KConfig::SimpleConfig);
+        KConfigGroup group(&config, "general");
+
+        KUrl url(group.readEntry("url"));
+        if (!url.isValid()) {
+            kError() << "Invalid url" << url;
+            return 0;
+        }
+        QDateTime dateTime = QDateTime::fromString(group.readEntry("dateTime"), Qt::ISODate);
+        if (!dateTime.isValid()) {
+            kError() << "Invalid dateTime" << dateTime;
+            return 0;
+        }
+
+        return new HistoryItem(url, dateTime, fileName);
+    }
+
+    KUrl url() const {
+        return mUrl;
+    }
+
+    QDateTime dateTime() const {
+        return mDateTime;
+    }
+
+    void setDateTime(const QDateTime& dateTime)
+    {
+        if (mDateTime != dateTime) {
+            mDateTime = dateTime;
+            save();
+        }
+    }
+
+    void unlink()
+    {
+        QFile::remove(mConfigPath);
+    }
 
 private:
-	KUrl mUrl;
-	QDateTime mDateTime;
-	QString mConfigPath;
-
-	HistoryItem(const KUrl& url, const QDateTime& dateTime, const QString& configPath)
-	: mUrl(url)
-	, mDateTime(dateTime)
-	, mConfigPath(configPath)
-	{
-		mUrl.cleanPath();
-		mUrl.adjustPath(KUrl::RemoveTrailingSlash);
-		setText(mUrl.pathOrUrl());
-
-		QString iconName = KMimeType::iconNameForUrl(mUrl);
-		setIcon(KIcon(iconName));
-
-		setData(QVariant(mUrl), KFilePlacesModel::UrlRole);
-
-		KFileItem fileItem(KFileItem::Unknown, KFileItem::Unknown, mUrl);
-		setData(QVariant(fileItem), KDirModel::FileItemRole);
-
-		QString date = KGlobal::locale()->formatDateTime(mDateTime, KLocale::FancyLongDate);
-		setData(QVariant(i18n("Last visited: %1", date)), Qt::ToolTipRole);
-	}
-
-	bool operator<(const QStandardItem& other) const {
-		return mDateTime > static_cast<const HistoryItem*>(&other)->mDateTime;
-	}
+    KUrl mUrl;
+    QDateTime mDateTime;
+    QString mConfigPath;
+
+    HistoryItem(const KUrl& url, const QDateTime& dateTime, const QString& configPath)
+        : mUrl(url)
+        , mDateTime(dateTime)
+        , mConfigPath(configPath) {
+        mUrl.cleanPath();
+        mUrl.adjustPath(KUrl::RemoveTrailingSlash);
+        setText(mUrl.pathOrUrl());
+
+        QString iconName = KMimeType::iconNameForUrl(mUrl);
+        setIcon(KIcon(iconName));
+
+        setData(QVariant(mUrl), KFilePlacesModel::UrlRole);
+
+        KFileItem fileItem(KFileItem::Unknown, KFileItem::Unknown, mUrl);
+        setData(QVariant(fileItem), KDirModel::FileItemRole);
+
+        QString date = KGlobal::locale()->formatDateTime(mDateTime, KLocale::FancyLongDate);
+        setData(QVariant(i18n("Last visited: %1", date)), Qt::ToolTipRole);
+    }
+
+    bool operator<(const QStandardItem& other) const {
+        return mDateTime > static_cast<const HistoryItem*>(&other)->mDateTime;
+    }
 };
 
-
 struct HistoryModelPrivate {
-	HistoryModel* q;
-	QString mStorageDir;
-	int mMaxCount;
-
-	QMap<KUrl, HistoryItem*> mHistoryItemForUrl;
-
-	void load() {
-		QDir dir(mStorageDir);
-		if (!dir.exists()) {
-			return;
-		}
-		Q_FOREACH(const QString& name, dir.entryList(QStringList() << "*rc")) {
-			HistoryItem* item = HistoryItem::load(dir.filePath(name));
-			if (!item) {
-				continue;
-			}
-			HistoryItem* existingItem = mHistoryItemForUrl.value(item->url());
-			if (existingItem) {
-				// We already know this url(!) update existing item dateTime
-				// and get rid of duplicate
-				if (existingItem->dateTime() < item->dateTime()) {
-					existingItem->setDateTime(item->dateTime());
-				}
-				item->unlink();
-				delete item;
-			} else {
-				mHistoryItemForUrl.insert(item->url(), item);
-				q->appendRow(item);
-			}
-		}
-		q->sort(0);
-	}
-
-	void garbageCollect() {
-		while (q->rowCount() > mMaxCount) {
-			HistoryItem* item = static_cast<HistoryItem*>(q->takeRow(q->rowCount() - 1).at(0));
-			mHistoryItemForUrl.remove(item->url());
-			item->unlink();
-			delete item;
-		}
-	}
+    HistoryModel* q;
+    QString mStorageDir;
+    int mMaxCount;
+
+    QMap<KUrl, HistoryItem*> mHistoryItemForUrl;
+
+    void load()
+    {
+        QDir dir(mStorageDir);
+        if (!dir.exists()) {
+            return;
+        }
+        Q_FOREACH(const QString & name, dir.entryList(QStringList() << "*rc")) {
+            HistoryItem* item = HistoryItem::load(dir.filePath(name));
+            if (!item) {
+                continue;
+            }
+            HistoryItem* existingItem = mHistoryItemForUrl.value(item->url());
+            if (existingItem) {
+                // We already know this url(!) update existing item dateTime
+                // and get rid of duplicate
+                if (existingItem->dateTime() < item->dateTime()) {
+                    existingItem->setDateTime(item->dateTime());
+                }
+                item->unlink();
+                delete item;
+            } else {
+                mHistoryItemForUrl.insert(item->url(), item);
+                q->appendRow(item);
+            }
+        }
+        q->sort(0);
+    }
+
+    void garbageCollect()
+    {
+        while (q->rowCount() > mMaxCount) {
+            HistoryItem* item = static_cast<HistoryItem*>(q->takeRow(q->rowCount() - 1).at(0));
+            mHistoryItemForUrl.remove(item->url());
+            item->unlink();
+            delete item;
+        }
+    }
 };
 
-
 HistoryModel::HistoryModel(QObject* parent, const QString& storageDir, int maxCount)
 : QStandardItemModel(parent)
-, d(new HistoryModelPrivate) {
-	d->q = this;
-	d->mStorageDir = storageDir;
-	d->mMaxCount = maxCount;
-	d->load();
-}
-
-
-HistoryModel::~HistoryModel() {
-	delete d;
-}
-
-
-void HistoryModel::addUrl(const KUrl& url, const QDateTime& _dateTime) {
-	QDateTime dateTime = _dateTime.isValid() ? _dateTime : QDateTime::currentDateTime();
-	HistoryItem* historyItem = d->mHistoryItemForUrl.value(url);
-	if (historyItem) {
-		historyItem->setDateTime(dateTime);
-		sort(0);
-	} else {
-		historyItem = HistoryItem::create(url, dateTime, d->mStorageDir);
-		if (!historyItem) {
-			kError() << "Could not save history for url" << url;
-			return;
-		}
-		appendRow(historyItem);
-		sort(0);
-		d->garbageCollect();
-	}
-}
-
-
-bool HistoryModel::removeRows(int start, int count, const QModelIndex& parent) {
-	Q_ASSERT(!parent.isValid());
-	for (int row=start + count - 1; row >= start ; --row) {
-		HistoryItem* historyItem = static_cast<HistoryItem*>(item(row, 0));
-		Q_ASSERT(historyItem);
-		d->mHistoryItemForUrl.remove(historyItem->url());
-		historyItem->unlink();
-	}
-	return QStandardItemModel::removeRows(start, count, parent);
-}
-
+, d(new HistoryModelPrivate)
+{
+    d->q = this;
+    d->mStorageDir = storageDir;
+    d->mMaxCount = maxCount;
+    d->load();
+}
+
+HistoryModel::~HistoryModel()
+{
+    delete d;
+}
+
+void HistoryModel::addUrl(const KUrl& url, const QDateTime& _dateTime)
+{
+    QDateTime dateTime = _dateTime.isValid() ? _dateTime : QDateTime::currentDateTime();
+    HistoryItem* historyItem = d->mHistoryItemForUrl.value(url);
+    if (historyItem) {
+        historyItem->setDateTime(dateTime);
+        sort(0);
+    } else {
+        historyItem = HistoryItem::create(url, dateTime, d->mStorageDir);
+        if (!historyItem) {
+            kError() << "Could not save history for url" << url;
+            return;
+        }
+        appendRow(historyItem);
+        sort(0);
+        d->garbageCollect();
+    }
+}
+
+bool HistoryModel::removeRows(int start, int count, const QModelIndex& parent)
+{
+    Q_ASSERT(!parent.isValid());
+    for (int row = start + count - 1; row >= start ; --row) {
+        HistoryItem* historyItem = static_cast<HistoryItem*>(item(row, 0));
+        Q_ASSERT(historyItem);
+        d->mHistoryItemForUrl.remove(historyItem->url());
+        historyItem->unlink();
+    }
+    return QStandardItemModel::removeRows(start, count, parent);
+}
 
 } // namespace

=== modified file 'lib/historymodel.h'
--- lib/historymodel.h	2011-07-20 13:46:34 +0000
+++ lib/historymodel.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -32,8 +32,8 @@
 
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct HistoryModelPrivate;
 /**
@@ -41,21 +41,21 @@
  * storageDir parameter of its ctor.
  * Each url is stored in a separate KConfig file to avoid concurrency issues.
  */
-class GWENVIEWLIB_EXPORT HistoryModel : public QStandardItemModel {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT HistoryModel : public QStandardItemModel
+{
+    Q_OBJECT
 public:
-	HistoryModel(QObject* parent, const QString& storageDir, int maxCount = 20);
-	~HistoryModel();
-
-	void addUrl(const KUrl&, const QDateTime& dateTime = QDateTime());
-
-	virtual bool removeRows(int row, int count, const QModelIndex& parent = QModelIndex());
+    HistoryModel(QObject* parent, const QString& storageDir, int maxCount = 20);
+    ~HistoryModel();
+
+    void addUrl(const KUrl&, const QDateTime& dateTime = QDateTime());
+
+    virtual bool removeRows(int row, int count, const QModelIndex& parent = QModelIndex());
 
 private:
-	HistoryModelPrivate* const d;
+    HistoryModelPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* HISTORYMODEL_H */

=== modified file 'lib/hudwidget.cpp'
--- lib/hudwidget.cpp	2011-07-20 13:46:34 +0000
+++ lib/hudwidget.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,75 +32,74 @@
 // Local
 #include "fullscreentheme.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct HudWidgetPrivate {
-	QWidget* mMainWidget;
-	QToolButton* mCloseButton;
+    QWidget* mMainWidget;
+    QToolButton* mCloseButton;
 };
 
-
 HudWidget::HudWidget(QWidget* parent)
 : QFrame(parent)
-, d(new HudWidgetPrivate) {
-	d->mMainWidget = 0;
-	d->mCloseButton = 0;
-}
-
-
-HudWidget::~HudWidget() {
-	delete d;
-}
-
-
-void HudWidget::init(QWidget* mainWidget, Options options) {
-	d->mMainWidget = mainWidget;
-	if (d->mMainWidget) {
-		d->mMainWidget->setParent(this);
-		if (d->mMainWidget->layout()) {
-			d->mMainWidget->layout()->setMargin(0);
-		}
-	}
-
-	if (options & OptionOpaque) {
-		setProperty("opaque", QVariant(true));
-	}
-
-	FullScreenTheme theme(FullScreenTheme::currentThemeName());
-	setStyleSheet(theme.styleSheet());
-
-	QHBoxLayout* layout = new QHBoxLayout(this);
-	layout->setMargin(4);
-	if (d->mMainWidget) {
-		layout->addWidget(d->mMainWidget);
-	}
-	if (options & OptionDoNotFollowChildSize) {
-		adjustSize();
-	} else {
-		layout->setSizeConstraint(QLayout::SetFixedSize);
-	}
-
-	if (options & OptionCloseButton) {
-		d->mCloseButton = new QToolButton(this);
-		d->mCloseButton->setAutoRaise(true);
-		d->mCloseButton->setIcon(SmallIcon("window-close"));
-		layout->addWidget(d->mCloseButton, 0, Qt::AlignTop | Qt::AlignHCenter);
-
-		connect(d->mCloseButton, SIGNAL(clicked()), SLOT(slotCloseButtonClicked()));
-	}
-}
-
-
-QWidget* HudWidget::mainWidget() const {
-	return d->mMainWidget;
-}
-
-
-void HudWidget::slotCloseButtonClicked() {
-	close();
-	closed();
-}
-
+, d(new HudWidgetPrivate)
+{
+    d->mMainWidget = 0;
+    d->mCloseButton = 0;
+}
+
+HudWidget::~HudWidget()
+{
+    delete d;
+}
+
+void HudWidget::init(QWidget* mainWidget, Options options)
+{
+    d->mMainWidget = mainWidget;
+    if (d->mMainWidget) {
+        d->mMainWidget->setParent(this);
+        if (d->mMainWidget->layout()) {
+            d->mMainWidget->layout()->setMargin(0);
+        }
+    }
+
+    if (options & OptionOpaque) {
+        setProperty("opaque", QVariant(true));
+    }
+
+    FullScreenTheme theme(FullScreenTheme::currentThemeName());
+    setStyleSheet(theme.styleSheet());
+
+    QHBoxLayout* layout = new QHBoxLayout(this);
+    layout->setMargin(4);
+    if (d->mMainWidget) {
+        layout->addWidget(d->mMainWidget);
+    }
+    if (options & OptionDoNotFollowChildSize) {
+        adjustSize();
+    } else {
+        layout->setSizeConstraint(QLayout::SetFixedSize);
+    }
+
+    if (options & OptionCloseButton) {
+        d->mCloseButton = new QToolButton(this);
+        d->mCloseButton->setAutoRaise(true);
+        d->mCloseButton->setIcon(SmallIcon("window-close"));
+        layout->addWidget(d->mCloseButton, 0, Qt::AlignTop | Qt::AlignHCenter);
+
+        connect(d->mCloseButton, SIGNAL(clicked()), SLOT(slotCloseButtonClicked()));
+    }
+}
+
+QWidget* HudWidget::mainWidget() const
+{
+    return d->mMainWidget;
+}
+
+void HudWidget::slotCloseButtonClicked()
+{
+    close();
+    closed();
+}
 
 } // namespace

=== modified file 'lib/hudwidget.h'
--- lib/hudwidget.h	2011-07-20 13:46:34 +0000
+++ lib/hudwidget.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,41 +30,40 @@
 
 // Local
 
-
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct HudWidgetPrivate;
-class GWENVIEWLIB_EXPORT HudWidget : public QFrame {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT HudWidget : public QFrame
+{
+    Q_OBJECT
 public:
-	enum Option {
-		OptionNone                 = 0,
-		OptionCloseButton          = 1 << 1,
-		// FIXME: Ugly
-		OptionDoNotFollowChildSize = 1 << 2, /// Make it possible to resize the hudwidget independently of child size
-		OptionOpaque               = 1 << 3
-	};
-	Q_DECLARE_FLAGS(Options, Option)
-
-	HudWidget(QWidget* parent = 0);
-	~HudWidget();
-
-	void init(QWidget*, Options options);
-
-	QWidget* mainWidget() const;
+    enum Option {
+        OptionNone                 = 0,
+        OptionCloseButton          = 1 << 1,
+        // FIXME: Ugly
+        OptionDoNotFollowChildSize = 1 << 2, /// Make it possible to resize the hudwidget independently of child size
+        OptionOpaque               = 1 << 3
+    };
+    Q_DECLARE_FLAGS(Options, Option)
+
+    HudWidget(QWidget* parent = 0);
+    ~HudWidget();
+
+    void init(QWidget*, Options options);
+
+    QWidget* mainWidget() const;
 
 Q_SIGNALS:
-	void closed();
+    void closed();
 
 private Q_SLOTS:
-	void slotCloseButtonClicked();
+    void slotCloseButtonClicked();
 
 private:
-	HudWidgetPrivate* const d;
+    HudWidgetPrivate* const d;
 };
 
-
 } // namespace
 
 Q_DECLARE_OPERATORS_FOR_FLAGS(Gwenview::HudWidget::Options)

=== modified file 'lib/imageformats/imageformats.cpp'
--- lib/imageformats/imageformats.cpp	2011-07-20 13:46:34 +0000
+++ lib/imageformats/imageformats.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,19 +32,22 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 QObject* qt_plugin_instance_JpegPlugin();
 
-namespace ImageFormats {
+namespace ImageFormats
+{
 
 static bool sPluginsRegistered = false;
-void registerPlugins() {
-	if (sPluginsRegistered) {
-		return;
-	}
-	sPluginsRegistered = true;
-	qRegisterStaticPluginInstanceFunction(qt_plugin_instance_JpegPlugin);
+void registerPlugins()
+{
+    if (sPluginsRegistered) {
+        return;
+    }
+    sPluginsRegistered = true;
+    qRegisterStaticPluginInstanceFunction(qt_plugin_instance_JpegPlugin);
 }
 
 } // namespace

=== modified file 'lib/imageformats/imageformats.h'
--- lib/imageformats/imageformats.h	2011-07-20 13:46:34 +0000
+++ lib/imageformats/imageformats.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,9 +29,11 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace ImageFormats {
+namespace ImageFormats
+{
 
 GWENVIEWLIB_EXPORT void registerPlugins();
 

=== modified file 'lib/imageformats/jpeghandler.cpp'
--- lib/imageformats/jpeghandler.cpp	2011-07-20 13:46:34 +0000
+++ lib/imageformats/jpeghandler.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -44,7 +44,8 @@
 // Local
 #include "../iodevicejpegsourcemanager.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -55,157 +56,156 @@
 #define LOG(x) ;
 #endif
 
-
 struct JpegFatalError : public jpeg_error_mgr {
-	jmp_buf mJmpBuffer;
+    jmp_buf mJmpBuffer;
 
-	static void handler(j_common_ptr cinfo) {
-		JpegFatalError* error=static_cast<JpegFatalError*>(cinfo->err);
-		(error->output_message)(cinfo);
-		longjmp(error->mJmpBuffer,1);
-	}
+    static void handler(j_common_ptr cinfo)
+    {
+        JpegFatalError* error = static_cast<JpegFatalError*>(cinfo->err);
+        (error->output_message)(cinfo);
+        longjmp(error->mJmpBuffer, 1);
+    }
 };
 
-
-static void expand24to32bpp(QImage* image) {
-	for (int j = 0; j < image->height(); ++j) {
-		uchar *in = image->scanLine(j) + (image->width() - 1)*3;
-		QRgb *out = (QRgb*)( image->scanLine(j) ) + image->width() - 1;
-
-		for (int i=image->width() - 1; i>=0; --i, --out, in -= 3) {
-			*out = qRgb(in[0], in[1], in[2]);
-		}
-	}
-}
-
-
-static void convertCmykToRgb(QImage* image) {
-	for (int j = 0; j < image->height(); ++j) {
-		uchar *in = image->scanLine(j) + image->width() * 4;
-		QRgb *out = (QRgb*)image->scanLine(j);
-
-		for (int i = image->width() - 1; i>=0; --i) {
-			in-=4;
-			int k = in[3];
-			out[i] = qRgb(k * in[0] / 255, k * in[1] / 255, k * in[2] / 255);
-		}
-	}
-}
-
-
-static QSize getJpegSize(QIODevice* ioDevice) {
-	struct jpeg_decompress_struct cinfo;
-	QSize size;
-
-	// Error handling
-	struct JpegFatalError jerr;
-	cinfo.err = jpeg_std_error(&jerr);
-	cinfo.err->error_exit = JpegFatalError::handler;
-	if (setjmp(jerr.mJmpBuffer)) {
-		jpeg_destroy_decompress(&cinfo);
-		return size;
-	}
-
-	// Init decompression
-	jpeg_create_decompress(&cinfo);
-	Gwenview::IODeviceJpegSourceManager::setup(&cinfo, ioDevice);
-	jpeg_read_header(&cinfo, true);
-
-	size = QSize(cinfo.image_width, cinfo.image_height);
-	jpeg_destroy_decompress(&cinfo);
-	return size;
-}
-
-
-static bool loadJpeg(QImage* image, QIODevice* ioDevice, QSize scaledSize) {
-	struct jpeg_decompress_struct cinfo;
-
-	// Error handling
-	struct JpegFatalError jerr;
-	cinfo.err = jpeg_std_error(&jerr);
-	cinfo.err->error_exit = JpegFatalError::handler;
-	if (setjmp(jerr.mJmpBuffer)) {
-		jpeg_destroy_decompress(&cinfo);
-		return false;
-	}
-
-	// Init decompression
-	jpeg_create_decompress(&cinfo);
-	Gwenview::IODeviceJpegSourceManager::setup(&cinfo, ioDevice);
-	jpeg_read_header(&cinfo, true);
-
-	// Compute scale value
-	cinfo.scale_num=1;
-	if (!scaledSize.isEmpty()) {
-		// Use !scaledSize.isEmpty(), not scaledSize.isValid() because
-		// isValid() returns true if both the width and height is equal to or
-		// greater than 0, so it is possible to get a division by 0.
-		cinfo.scale_denom = qMin(cinfo.image_width / scaledSize.width(),
-								cinfo.image_height / scaledSize.height());
-		if (cinfo.scale_denom < 2) {
-			cinfo.scale_denom = 1;
-		} else if (cinfo.scale_denom < 4) {
-			cinfo.scale_denom = 2;
-		} else if (cinfo.scale_denom < 8) {
-			cinfo.scale_denom = 4;
-		} else {
-			cinfo.scale_denom = 8;
-		}
-	} else {
-		cinfo.scale_denom = 1;
-	}
-	LOG("cinfo.scale_denom=" << cinfo.scale_denom);
-
-	// Init image
-	jpeg_start_decompress(&cinfo);
-	switch(cinfo.output_components) {
-	case 3:
-	case 4:
-		*image = QImage(cinfo.output_width, cinfo.output_height, QImage::Format_RGB32);
-		break;
-	case 1: // B&W image
-		*image = QImage(cinfo.output_width, cinfo.output_height, QImage::Format_Indexed8);
-		image->setNumColors(256);
-		for (int i=0; i<256; ++i) {
-			image->setColor(i, qRgba(i, i, i, 255));
-		}
-		break;
-	default:
-		jpeg_destroy_decompress(&cinfo);
-		return false;
-	}
-
-	while (cinfo.output_scanline < cinfo.output_height) {
-		uchar *line = image->scanLine(cinfo.output_scanline);
-		jpeg_read_scanlines(&cinfo, &line, 1);
-	}
-
-	switch (cinfo.out_color_space) {
-	case JCS_CMYK:
-		convertCmykToRgb(image);
-		break;
-	case JCS_RGB:
-	case JCS_GRAYSCALE:
-		break;
-	default:
-		kWarning() << "Unhandled JPEG colorspace" << cinfo.out_color_space;
-		break;
-	}
-
-	if ( cinfo.output_components == 3 ) {
-		expand24to32bpp(image);
-	}
-
-	if (scaledSize.isValid()) {
-		*image = image->scaled(scaledSize, Qt::KeepAspectRatio, Qt::SmoothTransformation);
-	}
-
-	jpeg_finish_decompress(&cinfo);
-	jpeg_destroy_decompress(&cinfo);
-
-	return true;
-}
-
+static void expand24to32bpp(QImage* image)
+{
+    for (int j = 0; j < image->height(); ++j) {
+        uchar *in = image->scanLine(j) + (image->width() - 1) * 3;
+        QRgb *out = (QRgb*)(image->scanLine(j)) + image->width() - 1;
+
+        for (int i = image->width() - 1; i >= 0; --i, --out, in -= 3) {
+            *out = qRgb(in[0], in[1], in[2]);
+        }
+    }
+}
+
+static void convertCmykToRgb(QImage* image)
+{
+    for (int j = 0; j < image->height(); ++j) {
+        uchar *in = image->scanLine(j) + image->width() * 4;
+        QRgb *out = (QRgb*)image->scanLine(j);
+
+        for (int i = image->width() - 1; i >= 0; --i) {
+            in -= 4;
+            int k = in[3];
+            out[i] = qRgb(k * in[0] / 255, k * in[1] / 255, k * in[2] / 255);
+        }
+    }
+}
+
+static QSize getJpegSize(QIODevice* ioDevice)
+{
+    struct jpeg_decompress_struct cinfo;
+    QSize size;
+
+    // Error handling
+    struct JpegFatalError jerr;
+    cinfo.err = jpeg_std_error(&jerr);
+    cinfo.err->error_exit = JpegFatalError::handler;
+    if (setjmp(jerr.mJmpBuffer)) {
+        jpeg_destroy_decompress(&cinfo);
+        return size;
+    }
+
+    // Init decompression
+    jpeg_create_decompress(&cinfo);
+    Gwenview::IODeviceJpegSourceManager::setup(&cinfo, ioDevice);
+    jpeg_read_header(&cinfo, true);
+
+    size = QSize(cinfo.image_width, cinfo.image_height);
+    jpeg_destroy_decompress(&cinfo);
+    return size;
+}
+
+static bool loadJpeg(QImage* image, QIODevice* ioDevice, QSize scaledSize)
+{
+    struct jpeg_decompress_struct cinfo;
+
+    // Error handling
+    struct JpegFatalError jerr;
+    cinfo.err = jpeg_std_error(&jerr);
+    cinfo.err->error_exit = JpegFatalError::handler;
+    if (setjmp(jerr.mJmpBuffer)) {
+        jpeg_destroy_decompress(&cinfo);
+        return false;
+    }
+
+    // Init decompression
+    jpeg_create_decompress(&cinfo);
+    Gwenview::IODeviceJpegSourceManager::setup(&cinfo, ioDevice);
+    jpeg_read_header(&cinfo, true);
+
+    // Compute scale value
+    cinfo.scale_num = 1;
+    if (!scaledSize.isEmpty()) {
+        // Use !scaledSize.isEmpty(), not scaledSize.isValid() because
+        // isValid() returns true if both the width and height is equal to or
+        // greater than 0, so it is possible to get a division by 0.
+        cinfo.scale_denom = qMin(cinfo.image_width / scaledSize.width(),
+                                 cinfo.image_height / scaledSize.height());
+        if (cinfo.scale_denom < 2) {
+            cinfo.scale_denom = 1;
+        } else if (cinfo.scale_denom < 4) {
+            cinfo.scale_denom = 2;
+        } else if (cinfo.scale_denom < 8) {
+            cinfo.scale_denom = 4;
+        } else {
+            cinfo.scale_denom = 8;
+        }
+    } else {
+        cinfo.scale_denom = 1;
+    }
+    LOG("cinfo.scale_denom=" << cinfo.scale_denom);
+
+    // Init image
+    jpeg_start_decompress(&cinfo);
+    switch (cinfo.output_components) {
+    case 3:
+    case 4:
+        *image = QImage(cinfo.output_width, cinfo.output_height, QImage::Format_RGB32);
+        break;
+    case 1: // B&W image
+        *image = QImage(cinfo.output_width, cinfo.output_height, QImage::Format_Indexed8);
+        image->setNumColors(256);
+        for (int i = 0; i < 256; ++i) {
+            image->setColor(i, qRgba(i, i, i, 255));
+        }
+        break;
+    default:
+        jpeg_destroy_decompress(&cinfo);
+        return false;
+    }
+
+    while (cinfo.output_scanline < cinfo.output_height) {
+        uchar *line = image->scanLine(cinfo.output_scanline);
+        jpeg_read_scanlines(&cinfo, &line, 1);
+    }
+
+    switch (cinfo.out_color_space) {
+    case JCS_CMYK:
+        convertCmykToRgb(image);
+        break;
+    case JCS_RGB:
+    case JCS_GRAYSCALE:
+        break;
+    default:
+        kWarning() << "Unhandled JPEG colorspace" << cinfo.out_color_space;
+        break;
+    }
+
+    if (cinfo.output_components == 3) {
+        expand24to32bpp(image);
+    }
+
+    if (scaledSize.isValid()) {
+        *image = image->scaled(scaledSize, Qt::KeepAspectRatio, Qt::SmoothTransformation);
+    }
+
+    jpeg_finish_decompress(&cinfo);
+    jpeg_destroy_decompress(&cinfo);
+
+    return true;
+}
 
 /****************************************************************************
 This code is a copy of qjpeghandler.cpp because I can't find a way to fallback
@@ -220,20 +220,19 @@
 extern "C" {
 #endif
 
-static void my_error_exit (j_common_ptr cinfo)
-{
-    my_error_mgr* myerr = (my_error_mgr*) cinfo->err;
-    char buffer[JMSG_LENGTH_MAX];
-    (*cinfo->err->format_message)(cinfo, buffer);
-    qWarning("%s", buffer);
-    longjmp(myerr->setjmp_buffer, 1);
-}
+    static void my_error_exit(j_common_ptr cinfo)
+    {
+        my_error_mgr* myerr = (my_error_mgr*) cinfo->err;
+        char buffer[JMSG_LENGTH_MAX];
+        (*cinfo->err->format_message)(cinfo, buffer);
+        qWarning("%s", buffer);
+        longjmp(myerr->setjmp_buffer, 1);
+    }
 
 #if defined(Q_C_CALLBACKS)
 }
 #endif
 
-
 static const int max_buf = 4096;
 
 struct my_jpeg_destination_mgr : public jpeg_destination_mgr {
@@ -245,42 +244,41 @@
     my_jpeg_destination_mgr(QIODevice *);
 };
 
-
 #if defined(Q_C_CALLBACKS)
 extern "C" {
 #endif
 
-static void qt_init_destination(j_compress_ptr)
-{
-}
-
-static boolean qt_empty_output_buffer(j_compress_ptr cinfo)
-{
-    my_jpeg_destination_mgr* dest = (my_jpeg_destination_mgr*)cinfo->dest;
-
-    int written = dest->device->write((char*)dest->buffer, max_buf);
-    if (written == -1)
-        (*cinfo->err->error_exit)((j_common_ptr)cinfo);
-
-    dest->next_output_byte = dest->buffer;
-    dest->free_in_buffer = max_buf;
+    static void qt_init_destination(j_compress_ptr)
+    {
+    }
+
+    static boolean qt_empty_output_buffer(j_compress_ptr cinfo)
+    {
+        my_jpeg_destination_mgr* dest = (my_jpeg_destination_mgr*)cinfo->dest;
+
+        int written = dest->device->write((char*)dest->buffer, max_buf);
+        if (written == -1)
+            (*cinfo->err->error_exit)((j_common_ptr)cinfo);
+
+        dest->next_output_byte = dest->buffer;
+        dest->free_in_buffer = max_buf;
 
 #if defined(Q_OS_UNIXWARE)
-    return B_TRUE;
+        return B_TRUE;
 #else
-    return true;
+        return true;
 #endif
-}
-
-static void qt_term_destination(j_compress_ptr cinfo)
-{
-    my_jpeg_destination_mgr* dest = (my_jpeg_destination_mgr*)cinfo->dest;
-    qint64 n = max_buf - dest->free_in_buffer;
-
-    qint64 written = dest->device->write((char*)dest->buffer, n);
-    if (written == -1)
-        (*cinfo->err->error_exit)((j_common_ptr)cinfo);
-}
+    }
+
+    static void qt_term_destination(j_compress_ptr cinfo)
+    {
+        my_jpeg_destination_mgr* dest = (my_jpeg_destination_mgr*)cinfo->dest;
+        qint64 n = max_buf - dest->free_in_buffer;
+
+        qint64 written = dest->device->write((char*)dest->buffer, n);
+        if (written == -1)
+            (*cinfo->err->error_exit)((j_common_ptr)cinfo);
+    }
 
 #if defined(Q_C_CALLBACKS)
 }
@@ -296,7 +294,6 @@
     free_in_buffer = max_buf;
 }
 
-
 static bool write_jpeg_image(const QImage &sourceImage, QIODevice *device, int sourceQuality)
 {
     bool success = false;
@@ -325,7 +322,7 @@
         cinfo.image_width = image.width();
         cinfo.image_height = image.height();
 
-        bool gray=false;
+        bool gray = false;
         switch (image.depth()) {
         case 1:
         case 8:
@@ -344,22 +341,21 @@
 
         jpeg_set_defaults(&cinfo);
 
-        qreal diffInch = qAbs(image.dotsPerMeterX()*2.54/100. - qRound(image.dotsPerMeterX()*2.54/100.))
-                         + qAbs(image.dotsPerMeterY()*2.54/100. - qRound(image.dotsPerMeterY()*2.54/100.));
-        qreal diffCm = (qAbs(image.dotsPerMeterX()/100. - qRound(image.dotsPerMeterX()/100.))
-                        + qAbs(image.dotsPerMeterY()/100. - qRound(image.dotsPerMeterY()/100.)))*2.54;
+        qreal diffInch = qAbs(image.dotsPerMeterX() * 2.54 / 100. - qRound(image.dotsPerMeterX() * 2.54 / 100.))
+                         + qAbs(image.dotsPerMeterY() * 2.54 / 100. - qRound(image.dotsPerMeterY() * 2.54 / 100.));
+        qreal diffCm = (qAbs(image.dotsPerMeterX() / 100. - qRound(image.dotsPerMeterX() / 100.))
+                        + qAbs(image.dotsPerMeterY() / 100. - qRound(image.dotsPerMeterY() / 100.))) * 2.54;
         if (diffInch < diffCm) {
             cinfo.density_unit = 1; // dots/inch
-            cinfo.X_density = qRound(image.dotsPerMeterX()*2.54/100.);
-            cinfo.Y_density = qRound(image.dotsPerMeterY()*2.54/100.);
+            cinfo.X_density = qRound(image.dotsPerMeterX() * 2.54 / 100.);
+            cinfo.Y_density = qRound(image.dotsPerMeterY() * 2.54 / 100.);
         } else {
             cinfo.density_unit = 2; // dots/cm
-            cinfo.X_density = (image.dotsPerMeterX()+50) / 100;
-            cinfo.Y_density = (image.dotsPerMeterY()+50) / 100;
+            cinfo.X_density = (image.dotsPerMeterX() + 50) / 100;
+            cinfo.Y_density = (image.dotsPerMeterY() + 50) / 100;
         }
 
-
-        int quality = sourceQuality >= 0 ? qMin(sourceQuality,100) : 75;
+        int quality = sourceQuality >= 0 ? qMin(sourceQuality, 100) : 75;
 #if defined(Q_OS_UNIXWARE)
         jpeg_set_quality(&cinfo, quality, B_TRUE /* limit to baseline-JPEG values */);
         jpeg_start_compress(&cinfo, B_TRUE);
@@ -368,7 +364,7 @@
         jpeg_start_compress(&cinfo, true);
 #endif
 
-        row_pointer[0] = new uchar[cinfo.image_width*cinfo.input_components];
+        row_pointer[0] = new uchar[cinfo.image_width * cinfo.input_components];
         int w = cinfo.image_width;
         while (cinfo.next_scanline < cinfo.image_height) {
             uchar *row = row_pointer[0];
@@ -377,28 +373,28 @@
                 if (gray) {
                     const uchar* data = image.scanLine(cinfo.next_scanline);
                     if (image.format() == QImage::Format_MonoLSB) {
-                        for (int i=0; i<w; i++) {
+                        for (int i = 0; i < w; i++) {
                             bool bit = !!(*(data + (i >> 3)) & (1 << (i & 7)));
                             row[i] = qRed(cmap[bit]);
                         }
                     } else {
-                        for (int i=0; i<w; i++) {
-                            bool bit = !!(*(data + (i >> 3)) & (1 << (7 -(i & 7))));
+                        for (int i = 0; i < w; i++) {
+                            bool bit = !!(*(data + (i >> 3)) & (1 << (7 - (i & 7))));
                             row[i] = qRed(cmap[bit]);
                         }
                     }
                 } else {
                     const uchar* data = image.scanLine(cinfo.next_scanline);
                     if (image.format() == QImage::Format_MonoLSB) {
-                        for (int i=0; i<w; i++) {
+                        for (int i = 0; i < w; i++) {
                             bool bit = !!(*(data + (i >> 3)) & (1 << (i & 7)));
                             *row++ = qRed(cmap[bit]);
                             *row++ = qGreen(cmap[bit]);
                             *row++ = qBlue(cmap[bit]);
                         }
                     } else {
-                        for (int i=0; i<w; i++) {
-                            bool bit = !!(*(data + (i >> 3)) & (1 << (7 -(i & 7))));
+                        for (int i = 0; i < w; i++) {
+                            bool bit = !!(*(data + (i >> 3)) & (1 << (7 - (i & 7))));
                             *row++ = qRed(cmap[bit]);
                             *row++ = qGreen(cmap[bit]);
                             *row++ = qBlue(cmap[bit]);
@@ -409,13 +405,13 @@
             case 8:
                 if (gray) {
                     const uchar* pix = image.scanLine(cinfo.next_scanline);
-                    for (int i=0; i<w; i++) {
+                    for (int i = 0; i < w; i++) {
                         *row = qRed(cmap[*pix]);
                         ++row; ++pix;
                     }
                 } else {
                     const uchar* pix = image.scanLine(cinfo.next_scanline);
-                    for (int i=0; i<w; i++) {
+                    for (int i = 0; i < w; i++) {
                         *row++ = qRed(cmap[*pix]);
                         *row++ = qGreen(cmap[*pix]);
                         *row++ = qBlue(cmap[*pix]);
@@ -425,7 +421,7 @@
                 break;
             case 32: {
                 QRgb* rgb = (QRgb*)image.scanLine(cinfo.next_scanline);
-                for (int i=0; i<w; i++) {
+                for (int i = 0; i < w; i++) {
                     *row++ = qRed(*rgb);
                     *row++ = qGreen(*rgb);
                     *row++ = qBlue(*rgb);
@@ -452,88 +448,85 @@
 END_COPY
 ****************************************************************************/
 
-
-
 struct JpegHandlerPrivate {
-	QSize mScaledSize;
-	int mQuality;
+    QSize mScaledSize;
+    int mQuality;
 };
 
-
 JpegHandler::JpegHandler()
-: d(new JpegHandlerPrivate) {
-	d->mQuality = 75;
-}
-
-
-JpegHandler::~JpegHandler() {
-	delete d;
-}
-
-
-bool JpegHandler::canRead() const {
-	if (canRead(device())) {
-		setFormat("jpeg");
-		return true;
-	}
-	return false;
-}
-
-
-bool JpegHandler::canRead(QIODevice* device) {
-	if (!device) {
-		kWarning() << "called with no device";
-		return false;
-	}
-
-	return device->peek(2) == "\xFF\xD8";
-}
-
-
-bool JpegHandler::read(QImage* image) {
-	LOG("");
-	if (!canRead()) {
-		return false;
-	}
-	return loadJpeg(image, device(), d->mScaledSize);
-}
-
-
-bool JpegHandler::write(const QImage& image) {
-	LOG("");
-	return write_jpeg_image(image, device(), d->mQuality);
-}
-
-
-bool JpegHandler::supportsOption(ImageOption option) const {
+: d(new JpegHandlerPrivate)
+{
+    d->mQuality = 75;
+}
+
+JpegHandler::~JpegHandler()
+{
+    delete d;
+}
+
+bool JpegHandler::canRead() const
+{
+    if (canRead(device())) {
+        setFormat("jpeg");
+        return true;
+    }
+    return false;
+}
+
+bool JpegHandler::canRead(QIODevice* device)
+{
+    if (!device) {
+        kWarning() << "called with no device";
+        return false;
+    }
+
+    return device->peek(2) == "\xFF\xD8";
+}
+
+bool JpegHandler::read(QImage* image)
+{
+    LOG("");
+    if (!canRead()) {
+        return false;
+    }
+    return loadJpeg(image, device(), d->mScaledSize);
+}
+
+bool JpegHandler::write(const QImage& image)
+{
+    LOG("");
+    return write_jpeg_image(image, device(), d->mQuality);
+}
+
+bool JpegHandler::supportsOption(ImageOption option) const
+{
     return option == ScaledSize || option == Size || option == Quality;
 }
 
-
-QVariant JpegHandler::option(ImageOption option) const {
-	if (option == ScaledSize) {
-		return d->mScaledSize;
-	} else if (option == Size) {
-		if (canRead() && !device()->isSequential()) {
-			qint64 pos = device()->pos();
-			QSize size = getJpegSize(device());
-			device()->seek(pos);
-			return size;
-		}
-	} else if (option == Quality) {
-		return d->mQuality;
-	}
-	return QVariant();
-}
-
-
-void JpegHandler::setOption(ImageOption option, const QVariant &value) {
-	if (option == ScaledSize) {
-		d->mScaledSize = value.toSize();
-	} else if (option == Quality) {
-		d->mQuality = value.toInt();
-	}
-}
-
+QVariant JpegHandler::option(ImageOption option) const
+{
+    if (option == ScaledSize) {
+        return d->mScaledSize;
+    } else if (option == Size) {
+        if (canRead() && !device()->isSequential()) {
+            qint64 pos = device()->pos();
+            QSize size = getJpegSize(device());
+            device()->seek(pos);
+            return size;
+        }
+    } else if (option == Quality) {
+        return d->mQuality;
+    }
+    return QVariant();
+}
+
+void JpegHandler::setOption(ImageOption option, const QVariant &value)
+{
+    if (option == ScaledSize) {
+        d->mScaledSize = value.toSize();
+    } else if (option == Quality) {
+        d->mQuality = value.toInt();
+    }
+}
 
 } // namespace

=== modified file 'lib/imageformats/jpeghandler.h'
--- lib/imageformats/jpeghandler.h	2011-07-20 13:46:34 +0000
+++ lib/imageformats/jpeghandler.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -28,33 +28,33 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct JpegHandlerPrivate;
 /**
  * A Jpeg handler which is more aggressive when loading down sampled images.
  */
-class JpegHandler : public QImageIOHandler {
+class JpegHandler : public QImageIOHandler
+{
 public:
-	JpegHandler();
-	~JpegHandler();
-
-	bool canRead() const;
-	bool read(QImage *image);
-	bool write(const QImage& image);
-
-	static bool canRead(QIODevice *device);
-
-	QVariant option(ImageOption option) const;
-	void setOption(ImageOption option, const QVariant &value);
-	bool supportsOption(ImageOption option) const;
+    JpegHandler();
+    ~JpegHandler();
+
+    bool canRead() const;
+    bool read(QImage *image);
+    bool write(const QImage& image);
+
+    static bool canRead(QIODevice *device);
+
+    QVariant option(ImageOption option) const;
+    void setOption(ImageOption option, const QVariant &value);
+    bool supportsOption(ImageOption option) const;
 
 private:
-	JpegHandlerPrivate* const d;
+    JpegHandlerPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* JPEGHANDLER_H */

=== modified file 'lib/imageformats/jpegplugin.cpp'
--- lib/imageformats/jpegplugin.cpp	2011-07-20 13:46:34 +0000
+++ lib/imageformats/jpegplugin.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,43 +29,44 @@
 // Local
 #include "jpeghandler.h"
 
-namespace Gwenview {
-
-
-QStringList JpegPlugin::keys() const {
-	return QStringList() << QLatin1String("jpeg") << QLatin1String("jpg");
-}
-
-
-QImageIOPlugin::Capabilities JpegPlugin::capabilities(QIODevice *device, const QByteArray &format) const {
-	if (format == "jpeg" || format == "jpg") {
-		return Capabilities(CanRead | CanWrite);
-	}
-	if (!format.isEmpty()) {
-		return 0;
-	}
-	if (!device->isOpen()) {
-		return 0;
-	}
-
-	Capabilities cap;
-	if (device->isReadable() && JpegHandler::canRead(device)) {
-		cap |= CanRead;
-	}
-	if (device->isWritable()) {
-		cap |= CanWrite;
-	}
-	return cap;
-}
-
-QImageIOHandler *JpegPlugin::create(QIODevice *device, const QByteArray &format) const {
-	QImageIOHandler *handler = new JpegHandler;
-	handler->setDevice(device);
-	handler->setFormat(format);
-	return handler;
+namespace Gwenview
+{
+
+QStringList JpegPlugin::keys() const
+{
+    return QStringList() << QLatin1String("jpeg") << QLatin1String("jpg");
+}
+
+QImageIOPlugin::Capabilities JpegPlugin::capabilities(QIODevice *device, const QByteArray &format) const
+{
+    if (format == "jpeg" || format == "jpg") {
+        return Capabilities(CanRead | CanWrite);
+    }
+    if (!format.isEmpty()) {
+        return 0;
+    }
+    if (!device->isOpen()) {
+        return 0;
+    }
+
+    Capabilities cap;
+    if (device->isReadable() && JpegHandler::canRead(device)) {
+        cap |= CanRead;
+    }
+    if (device->isWritable()) {
+        cap |= CanWrite;
+    }
+    return cap;
+}
+
+QImageIOHandler *JpegPlugin::create(QIODevice *device, const QByteArray &format) const
+{
+    QImageIOHandler *handler = new JpegHandler;
+    handler->setDevice(device);
+    handler->setFormat(format);
+    return handler;
 }
 
 Q_EXPORT_STATIC_PLUGIN(JpegPlugin)
 
-
 } // namespace

=== modified file 'lib/imageformats/jpegplugin.h'
--- lib/imageformats/jpegplugin.h	2011-07-20 13:46:34 +0000
+++ lib/imageformats/jpegplugin.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,14 +29,15 @@
 class QIODevice;
 class QStringList;
 
-namespace Gwenview {
-
-
-class JpegPlugin : public QImageIOPlugin {
+namespace Gwenview
+{
+
+class JpegPlugin : public QImageIOPlugin
+{
 public:
-	QStringList keys() const;
-	Capabilities capabilities(QIODevice *device, const QByteArray &format) const;
-	QImageIOHandler *create(QIODevice *device, const QByteArray &format = QByteArray()) const;
+    QStringList keys() const;
+    Capabilities capabilities(QIODevice *device, const QByteArray &format) const;
+    QImageIOHandler *create(QIODevice *device, const QByteArray &format = QByteArray()) const;
 };
 
 } // namespace

=== modified file 'lib/imagemetainfomodel.cpp'
--- lib/imagemetainfomodel.cpp	2011-07-20 13:46:34 +0000
+++ lib/imagemetainfomodel.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -36,439 +36,442 @@
 
 // Local
 
-
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 enum GroupRow {
-	NoGroupSpace= -2,
-	NoGroup = -1,
-	GeneralGroup,
-	ExifGroup,
-	IptcGroup,
-	XmpGroup
+    NoGroupSpace = -2,
+    NoGroup = -1,
+    GeneralGroup,
+    ExifGroup,
+    IptcGroup,
+    XmpGroup
 };
 
-
-class MetaInfoGroup {
+class MetaInfoGroup
+{
 public:
-	enum {
-		InvalidRow = -1
-	};
-
-	class Entry {
-	public:
-		Entry(const QString& key, const QString& label, const QString& value)
-		: mKey(key), mLabel(label.trimmed()), mValue(value.trimmed())
-		{}
-
-		QString key() const { return mKey; }
-		QString label() const { return mLabel; }
-
-		QString value() const { return mValue; }
-		void setValue(const QString& value) { mValue = value.trimmed(); }
-
-		void appendValue(const QString& value) {
-			if (mValue.length() > 0) {
-				mValue += '\n';
-			}
-			mValue += value.trimmed();
-		}
-
-	private:
-		QString mKey;
-		QString mLabel;
-		QString mValue;
-	};
-
-	MetaInfoGroup(const QString& label)
-	: mLabel(label) {}
-
-
-	~MetaInfoGroup() {
-		qDeleteAll(mList);
-	}
-
-
-	void clear() {
-		qDeleteAll(mList);
-		mList.clear();
-		mRowForKey.clear();
-	}
-
-
-	void addEntry(const QString& key, const QString& label, const QString& value) {
-		addEntry(new Entry(key, label, value));
-	}
-
-
-	void addEntry(Entry* entry) {
-		mList << entry;
-		mRowForKey[entry->key()] = mList.size() - 1;
-	}
-
-
-	void getInfoForKey(const QString& key, QString* label, QString* value) const {
-		Entry* entry = getEntryForKey(key);
-		if (entry) {
-			*label = entry->label();
-			*value = entry->value();
-		}
-	}
-
-
-	QString getKeyAt(int row) const {
-		Q_ASSERT(row < mList.size());
-		return mList[row]->key();
-	}
-
-
-	QString getLabelForKeyAt(int row) const {
-		Q_ASSERT(row < mList.size());
-		return mList[row]->label();
-	}
-
-
-	QString getValueForKeyAt(int row) const {
-		Q_ASSERT(row < mList.size());
-		return mList[row]->value();
-	}
-
-
-	void setValueForKeyAt(int row, const QString& value) {
-		Q_ASSERT(row < mList.size());
-		mList[row]->setValue(value);
-	}
-
-
-	int getRowForKey(const QString& key) const {
-		return mRowForKey.value(key, InvalidRow);
-	}
-
-
-	int size() const {
-		return mList.size();
-	}
-
-
-	QString label() const {
-		return mLabel;
-	}
-
-	const QList<Entry*>& entryList() const {
-		return mList;
-	}
+    enum {
+        InvalidRow = -1
+    };
+
+    class Entry
+    {
+    public:
+        Entry(const QString& key, const QString& label, const QString& value)
+            : mKey(key), mLabel(label.trimmed()), mValue(value.trimmed())
+        {}
+
+        QString key() const {
+            return mKey;
+        }
+        QString label() const {
+            return mLabel;
+        }
+
+        QString value() const {
+            return mValue;
+        }
+        void setValue(const QString& value)
+    {
+            mValue = value.trimmed();
+        }
+
+        void appendValue(const QString& value)
+    {
+            if (mValue.length() > 0) {
+                mValue += '\n';
+            }
+            mValue += value.trimmed();
+        }
+
+    private:
+        QString mKey;
+        QString mLabel;
+        QString mValue;
+    };
+
+    MetaInfoGroup(const QString& label)
+        : mLabel(label) {}
+
+    ~MetaInfoGroup() {
+        qDeleteAll(mList);
+    }
+
+    void clear()
+    {
+        qDeleteAll(mList);
+        mList.clear();
+        mRowForKey.clear();
+    }
+
+    void addEntry(const QString& key, const QString& label, const QString& value)
+    {
+        addEntry(new Entry(key, label, value));
+    }
+
+    void addEntry(Entry* entry)
+    {
+        mList << entry;
+        mRowForKey[entry->key()] = mList.size() - 1;
+    }
+
+    void getInfoForKey(const QString& key, QString* label, QString* value) const
+    {
+        Entry* entry = getEntryForKey(key);
+        if (entry) {
+            *label = entry->label();
+            *value = entry->value();
+        }
+    }
+
+    QString getKeyAt(int row) const {
+        Q_ASSERT(row < mList.size());
+        return mList[row]->key();
+    }
+
+    QString getLabelForKeyAt(int row) const {
+        Q_ASSERT(row < mList.size());
+        return mList[row]->label();
+    }
+
+    QString getValueForKeyAt(int row) const {
+        Q_ASSERT(row < mList.size());
+        return mList[row]->value();
+    }
+
+    void setValueForKeyAt(int row, const QString& value)
+    {
+        Q_ASSERT(row < mList.size());
+        mList[row]->setValue(value);
+    }
+
+    int getRowForKey(const QString& key) const {
+        return mRowForKey.value(key, InvalidRow);
+    }
+
+    int size() const {
+        return mList.size();
+    }
+
+    QString label() const {
+        return mLabel;
+    }
+
+    const QList<Entry*>& entryList() const {
+        return mList;
+    }
 
 private:
-	Entry* getEntryForKey(const QString& key) const {
-		int row = getRowForKey(key);
-		if (row == InvalidRow) {
-			return 0;
-		}
-		return mList[row];
-	}
+    Entry* getEntryForKey(const QString& key) const {
+        int row = getRowForKey(key);
+        if (row == InvalidRow) {
+            return 0;
+        }
+        return mList[row];
+    }
 
-	QList<Entry*> mList;
-	QHash<QString, int> mRowForKey;
-	QString mLabel;
+    QList<Entry*> mList;
+    QHash<QString, int> mRowForKey;
+    QString mLabel;
 };
 
-
 struct ImageMetaInfoModelPrivate {
-	QVector<MetaInfoGroup*> mMetaInfoGroupVector;
-	ImageMetaInfoModel* mModel;
-
-
-	void clearGroup(MetaInfoGroup* group, const QModelIndex& parent) {
-		if (group->size() > 0) {
-			mModel->beginRemoveRows(parent, 0, group->size() - 1);
-			group->clear();
-			mModel->endRemoveRows();
-		}
-	}
-
-
-	void setGroupEntryValue(GroupRow groupRow, const QString& key, const QString& value) {
-		MetaInfoGroup* group = mMetaInfoGroupVector[groupRow];
-		int entryRow = group->getRowForKey(key);
-		if (entryRow == MetaInfoGroup::InvalidRow) {
-			kWarning() << "No row for key" << key;
-			return;
-		}
-		group->setValueForKeyAt(entryRow, value);
-		QModelIndex groupIndex = mModel->index(groupRow, 0);
-		QModelIndex entryIndex = mModel->index(entryRow, 1, groupIndex);
-		emit mModel->dataChanged(entryIndex, entryIndex);
-	}
-
-
-	QVariant displayData(const QModelIndex& index) const {
-		if (index.internalId() == NoGroup) {
-			if (index.column() != 0) {
-				return QVariant();
-			}
-			QString label = mMetaInfoGroupVector[index.row()]->label();
-			return QVariant(label);
-		}
-
-		if (index.internalId() == NoGroupSpace) {
-			return QVariant(QString());
-		}
-
-		MetaInfoGroup* group = mMetaInfoGroupVector[index.internalId()];
-		if (index.column() == 0) {
-			return group->getLabelForKeyAt(index.row());
-		} else {
-			return group->getValueForKeyAt(index.row());
-		}
-	}
-
-
-	void initGeneralGroup() {
-		MetaInfoGroup* group = mMetaInfoGroupVector[GeneralGroup];
-		group->addEntry("General.Name", i18nc("@item:intable Image file name", "Name"), QString());
-		group->addEntry("General.Size", i18nc("@item:intable", "File Size"), QString());
-		group->addEntry("General.Time", i18nc("@item:intable", "File Time"), QString());
-		group->addEntry("General.ImageSize", i18nc("@item:intable", "Image Size"), QString());
-	}
-
-
-	template <class Container, class Iterator>
-	void fillExivGroup(const QModelIndex& parent, MetaInfoGroup* group, const Container& container) {
-		// key aren't always unique (for example, "Iptc.Application2.Keywords"
-		// may appear multiple times) so we can't know how many rows we will
-		// insert before going through them. That's why we create a hash
-		// before.
-		typedef QHash<QString, MetaInfoGroup::Entry*> EntryHash;
-		EntryHash hash;
-
-		Iterator
-			it = container.begin(),
-			end = container.end();
-
-		if (it == end) {
-			return;
-		}
-
-		for (;it != end; ++it) {
-			QString key = QString::fromUtf8(it->key().c_str());
-			QString label = QString::fromLocal8Bit(it->tagLabel().c_str());
-			std::ostringstream stream;
-			stream << *it;
-			QString value = QString::fromLocal8Bit(stream.str().c_str());
-
-			EntryHash::iterator hashIt = hash.find(key);
-			if (hashIt != hash.end()) {
-				hashIt.value()->appendValue(value);
-			} else {
-				hash.insert(key, new MetaInfoGroup::Entry(key, label, value));
-			}
-		}
-
-		mModel->beginInsertRows(parent, 0, hash.size() - 1);
-		Q_FOREACH(MetaInfoGroup::Entry* entry, hash) {
-			group->addEntry(entry);
-		}
-		mModel->endInsertRows();
-	}
+    QVector<MetaInfoGroup*> mMetaInfoGroupVector;
+    ImageMetaInfoModel* q;
+
+    void clearGroup(MetaInfoGroup* group, const QModelIndex& parent)
+    {
+        if (group->size() > 0) {
+            q->beginRemoveRows(parent, 0, group->size() - 1);
+            group->clear();
+            q->endRemoveRows();
+        }
+    }
+
+    void setGroupEntryValue(GroupRow groupRow, const QString& key, const QString& value)
+    {
+        MetaInfoGroup* group = mMetaInfoGroupVector[groupRow];
+        int entryRow = group->getRowForKey(key);
+        if (entryRow == MetaInfoGroup::InvalidRow) {
+            kWarning() << "No row for key" << key;
+            return;
+        }
+        group->setValueForKeyAt(entryRow, value);
+        QModelIndex groupIndex = q->index(groupRow, 0);
+        QModelIndex entryIndex = q->index(entryRow, 1, groupIndex);
+        emit q->dataChanged(entryIndex, entryIndex);
+    }
+
+    QVariant displayData(const QModelIndex& index) const {
+        if (index.internalId() == NoGroup) {
+            if (index.column() != 0) {
+                return QVariant();
+            }
+            QString label = mMetaInfoGroupVector[index.row()]->label();
+            return QVariant(label);
+        }
+
+        if (index.internalId() == NoGroupSpace) {
+            return QVariant(QString());
+        }
+
+        MetaInfoGroup* group = mMetaInfoGroupVector[index.internalId()];
+        if (index.column() == 0) {
+            return group->getLabelForKeyAt(index.row());
+        } else {
+            return group->getValueForKeyAt(index.row());
+        }
+    }
+
+    void initGeneralGroup()
+    {
+        MetaInfoGroup* group = mMetaInfoGroupVector[GeneralGroup];
+        group->addEntry("General.Name", i18nc("@item:intable Image file name", "Name"), QString());
+        group->addEntry("General.Size", i18nc("@item:intable", "File Size"), QString());
+        group->addEntry("General.Time", i18nc("@item:intable", "File Time"), QString());
+        group->addEntry("General.ImageSize", i18nc("@item:intable", "Image Size"), QString());
+        group->addEntry("General.Comment", i18nc("@item:intable", "Comment"), QString());
+    }
+
+    template <class Container, class Iterator>
+    void fillExivGroup(const QModelIndex& parent, MetaInfoGroup* group, const Container& container)
+    {
+        // key aren't always unique (for example, "Iptc.Application2.Keywords"
+        // may appear multiple times) so we can't know how many rows we will
+        // insert before going through them. That's why we create a hash
+        // before.
+        typedef QHash<QString, MetaInfoGroup::Entry*> EntryHash;
+        EntryHash hash;
+
+        Iterator
+        it = container.begin(),
+        end = container.end();
+
+        if (it == end) {
+            return;
+        }
+
+        for (; it != end; ++it) {
+            QString key = QString::fromUtf8(it->key().c_str());
+            QString label = QString::fromLocal8Bit(it->tagLabel().c_str());
+            std::ostringstream stream;
+            stream << *it;
+            QString value = QString::fromLocal8Bit(stream.str().c_str());
+
+            EntryHash::iterator hashIt = hash.find(key);
+            if (hashIt != hash.end()) {
+                hashIt.value()->appendValue(value);
+            } else {
+                hash.insert(key, new MetaInfoGroup::Entry(key, label, value));
+            }
+        }
+
+        q->beginInsertRows(parent, 0, hash.size() - 1);
+        Q_FOREACH(MetaInfoGroup::Entry * entry, hash) {
+            group->addEntry(entry);
+        }
+        q->endInsertRows();
+    }
 };
 
-
 ImageMetaInfoModel::ImageMetaInfoModel()
-: d(new ImageMetaInfoModelPrivate) {
-	d->mModel = this;
-	d->mMetaInfoGroupVector.resize(4);
-	d->mMetaInfoGroupVector[GeneralGroup] = new MetaInfoGroup(i18nc("@title:group General info about the image", "General"));
-	d->mMetaInfoGroupVector[ExifGroup] = new MetaInfoGroup("EXIF");
-	d->mMetaInfoGroupVector[IptcGroup] = new MetaInfoGroup("IPTC");
-	d->mMetaInfoGroupVector[XmpGroup]  = new MetaInfoGroup("XMP");
-	d->initGeneralGroup();
-}
-
-
-ImageMetaInfoModel::~ImageMetaInfoModel() {
-	qDeleteAll(d->mMetaInfoGroupVector);
-	delete d;
-}
-
-
-void ImageMetaInfoModel::setUrl(const KUrl& url) {
-	KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
-	QString sizeString = KGlobal::locale()->formatByteSize(item.size());
-
-	d->setGroupEntryValue(GeneralGroup, "General.Name", item.name());
-	d->setGroupEntryValue(GeneralGroup, "General.Size", sizeString);
-	d->setGroupEntryValue(GeneralGroup, "General.Time", item.timeString());
-}
-
-
-void ImageMetaInfoModel::setImageSize(const QSize& size) {
-	QString imageSize;
-	if (size.isValid()) {
-		imageSize = i18nc(
-			"@item:intable %1 is image width, %2 is image height",
-			"%1x%2", size.width(), size.height());
-
-		double megaPixels = size.width() * size.height() / 1000000.;
-		if (megaPixels > 0.1) {
-			QString megaPixelsString = QString::number(megaPixels, 'f', 1);
-			imageSize += ' ';
-			imageSize += i18nc(
-				"@item:intable %1 is number of millions of pixels in image",
-				"(%1MP)", megaPixelsString);
-		}
-	} else {
-		imageSize = "-";
-	}
-	d->setGroupEntryValue(GeneralGroup, "General.ImageSize", imageSize);
-}
-
-
-void ImageMetaInfoModel::setExiv2Image(const Exiv2::Image* image) {
-	MetaInfoGroup* exifGroup = d->mMetaInfoGroupVector[ExifGroup];
-	MetaInfoGroup* iptcGroup = d->mMetaInfoGroupVector[IptcGroup];
-	MetaInfoGroup* xmpGroup  = d->mMetaInfoGroupVector[XmpGroup];
-	QModelIndex exifIndex = index(ExifGroup, 0);
-	QModelIndex iptcIndex = index(IptcGroup, 0);
-	QModelIndex xmpIndex  = index(XmpGroup, 0);
-	d->clearGroup(exifGroup, exifIndex);
-	d->clearGroup(iptcGroup, iptcIndex);
-	d->clearGroup(xmpGroup,  xmpIndex);
-
-	if (!image) {
-		return;
-	}
-
-	if (image->checkMode(Exiv2::mdExif) & Exiv2::amRead) {
-		const Exiv2::ExifData& exifData = image->exifData();
-		d->fillExivGroup<Exiv2::ExifData, Exiv2::ExifData::const_iterator>(exifIndex, exifGroup, exifData);
-	}
-
-	if (image->checkMode(Exiv2::mdIptc) & Exiv2::amRead) {
-		const Exiv2::IptcData& iptcData = image->iptcData();
-		d->fillExivGroup<Exiv2::IptcData, Exiv2::IptcData::const_iterator>(iptcIndex, iptcGroup, iptcData);
-	}
-
-	if (image->checkMode(Exiv2::mdXmp) & Exiv2::amRead) {
-		const Exiv2::XmpData& xmpData = image->xmpData();
-		d->fillExivGroup<Exiv2::XmpData, Exiv2::XmpData::const_iterator>(xmpIndex, xmpGroup, xmpData);
-	}
-}
-
-
-void ImageMetaInfoModel::getInfoForKey(const QString& key, QString* label, QString* value) const {
-	MetaInfoGroup* group;
-	if (key.startsWith(QLatin1String("General"))) {
-		group = d->mMetaInfoGroupVector[GeneralGroup];
-	} else if (key.startsWith(QLatin1String("Exif"))) {
-		group = d->mMetaInfoGroupVector[ExifGroup];
-	} else if (key.startsWith(QLatin1String("Iptc"))) {
-		group = d->mMetaInfoGroupVector[IptcGroup];
-	} else if (key.startsWith(QLatin1String("Xmp"))) {
-		group = d->mMetaInfoGroupVector[XmpGroup];
-	} else {
-		kWarning() << "Unknown metainfo key" << key;
-		return;
-	}
-	group->getInfoForKey(key, label, value);
-}
-
-
-QString ImageMetaInfoModel::getValueForKey(const QString& key) const {
-	QString label, value;
-	getInfoForKey(key, &label, &value);
-	return value;
-}
-
-
-QString ImageMetaInfoModel::keyForIndex(const QModelIndex& index) const {
-	if (index.internalId() == NoGroup) {
-		return QString();
-	}
-	MetaInfoGroup* group = d->mMetaInfoGroupVector[index.internalId()];
-	return group->getKeyAt(index.row());
-}
-
-
-QModelIndex ImageMetaInfoModel::index(int row, int col, const QModelIndex& parent) const {
-	if (col < 0 || col > 1) {
-		return QModelIndex();
-	}
-	if (!parent.isValid()) {
-		// This is a group
-		if (row < 0 || row >= d->mMetaInfoGroupVector.size()) {
-			return QModelIndex();
-		}
-		return createIndex(row, col, col == 0 ? NoGroup : NoGroupSpace);
-	} else {
-		// This is an entry
-		int group = parent.row();
-		if (row < 0 || row >= d->mMetaInfoGroupVector[group]->size()) {
-			return QModelIndex();
-		}
-		return createIndex(row, col, group);
-	}
-}
-
-
-QModelIndex ImageMetaInfoModel::parent(const QModelIndex& index) const {
-	if (!index.isValid()) {
-		return QModelIndex();
-	}
-	if (index.internalId() == NoGroup || index.internalId() == NoGroupSpace) {
-		return QModelIndex();
-	} else {
-		return createIndex(index.internalId(), 0, NoGroup);
-	}
-}
-
-
-int ImageMetaInfoModel::rowCount(const QModelIndex& parent) const {
-	if (!parent.isValid()) {
-		return d->mMetaInfoGroupVector.size();
-	} else if (parent.internalId() == NoGroup) {
-		return d->mMetaInfoGroupVector[parent.row()]->size();
-	} else {
-		return 0;
-	}
-}
-
-
-int ImageMetaInfoModel::columnCount(const QModelIndex& /*parent*/) const {
-	return 2;
-}
-
-
-QVariant ImageMetaInfoModel::data(const QModelIndex& index, int role) const {
-	if (!index.isValid()) {
-		return QVariant();
-	}
-
-	switch (role) {
-	case Qt::DisplayRole:
-		return d->displayData(index);
-	default:
-		return QVariant();
-	}
-}
-
-
-QVariant ImageMetaInfoModel::headerData(int section, Qt::Orientation orientation, int role) const {
-	if (orientation == Qt::Vertical || role != Qt::DisplayRole) {
-		return QVariant();
-	}
-
-	QString caption;
-	if (section == 0) {
-		caption = i18nc("@title:column", "Property");
-	} else if (section == 1) {
-		caption = i18nc("@title:column", "Value");
-	} else {
-		kWarning() << "Unknown section" << section;
-	}
-
-	return QVariant(caption);
-}
-
+: d(new ImageMetaInfoModelPrivate)
+{
+    d->q = this;
+    d->mMetaInfoGroupVector.resize(4);
+    d->mMetaInfoGroupVector[GeneralGroup] = new MetaInfoGroup(i18nc("@title:group General info about the image", "General"));
+    d->mMetaInfoGroupVector[ExifGroup] = new MetaInfoGroup("EXIF");
+    d->mMetaInfoGroupVector[IptcGroup] = new MetaInfoGroup("IPTC");
+    d->mMetaInfoGroupVector[XmpGroup]  = new MetaInfoGroup("XMP");
+    d->initGeneralGroup();
+}
+
+ImageMetaInfoModel::~ImageMetaInfoModel()
+{
+    qDeleteAll(d->mMetaInfoGroupVector);
+    delete d;
+}
+
+void ImageMetaInfoModel::setUrl(const KUrl& url)
+{
+    KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
+    QString sizeString = KGlobal::locale()->formatByteSize(item.size());
+
+    d->setGroupEntryValue(GeneralGroup, "General.Name", item.name());
+    d->setGroupEntryValue(GeneralGroup, "General.Size", sizeString);
+    d->setGroupEntryValue(GeneralGroup, "General.Time", item.timeString());
+}
+
+void ImageMetaInfoModel::setImageSize(const QSize& size)
+{
+    QString imageSize;
+    if (size.isValid()) {
+        imageSize = i18nc(
+                        "@item:intable %1 is image width, %2 is image height",
+                        "%1x%2", size.width(), size.height());
+
+        double megaPixels = size.width() * size.height() / 1000000.;
+        if (megaPixels > 0.1) {
+            QString megaPixelsString = QString::number(megaPixels, 'f', 1);
+            imageSize += ' ';
+            imageSize += i18nc(
+                             "@item:intable %1 is number of millions of pixels in image",
+                             "(%1MP)", megaPixelsString);
+        }
+    } else {
+        imageSize = "-";
+    }
+    d->setGroupEntryValue(GeneralGroup, "General.ImageSize", imageSize);
+}
+
+void ImageMetaInfoModel::setExiv2Image(const Exiv2::Image* image)
+{
+    MetaInfoGroup* exifGroup = d->mMetaInfoGroupVector[ExifGroup];
+    MetaInfoGroup* iptcGroup = d->mMetaInfoGroupVector[IptcGroup];
+    MetaInfoGroup* xmpGroup  = d->mMetaInfoGroupVector[XmpGroup];
+    QModelIndex exifIndex = index(ExifGroup, 0);
+    QModelIndex iptcIndex = index(IptcGroup, 0);
+    QModelIndex xmpIndex  = index(XmpGroup, 0);
+    d->clearGroup(exifGroup, exifIndex);
+    d->clearGroup(iptcGroup, iptcIndex);
+    d->clearGroup(xmpGroup,  xmpIndex);
+
+    if (!image) {
+        return;
+    }
+
+    d->setGroupEntryValue(GeneralGroup, "General.Comment", QString::fromUtf8(image->comment().c_str()));
+
+    if (image->checkMode(Exiv2::mdExif) & Exiv2::amRead) {
+        const Exiv2::ExifData& exifData = image->exifData();
+        d->fillExivGroup<Exiv2::ExifData, Exiv2::ExifData::const_iterator>(exifIndex, exifGroup, exifData);
+    }
+
+    if (image->checkMode(Exiv2::mdIptc) & Exiv2::amRead) {
+        const Exiv2::IptcData& iptcData = image->iptcData();
+        d->fillExivGroup<Exiv2::IptcData, Exiv2::IptcData::const_iterator>(iptcIndex, iptcGroup, iptcData);
+    }
+
+    if (image->checkMode(Exiv2::mdXmp) & Exiv2::amRead) {
+        const Exiv2::XmpData& xmpData = image->xmpData();
+        d->fillExivGroup<Exiv2::XmpData, Exiv2::XmpData::const_iterator>(xmpIndex, xmpGroup, xmpData);
+    }
+}
+
+void ImageMetaInfoModel::getInfoForKey(const QString& key, QString* label, QString* value) const
+{
+    MetaInfoGroup* group;
+    if (key.startsWith(QLatin1String("General"))) {
+        group = d->mMetaInfoGroupVector[GeneralGroup];
+    } else if (key.startsWith(QLatin1String("Exif"))) {
+        group = d->mMetaInfoGroupVector[ExifGroup];
+    } else if (key.startsWith(QLatin1String("Iptc"))) {
+        group = d->mMetaInfoGroupVector[IptcGroup];
+    } else if (key.startsWith(QLatin1String("Xmp"))) {
+        group = d->mMetaInfoGroupVector[XmpGroup];
+    } else {
+        kWarning() << "Unknown metainfo key" << key;
+        return;
+    }
+    group->getInfoForKey(key, label, value);
+}
+
+QString ImageMetaInfoModel::getValueForKey(const QString& key) const
+{
+    QString label, value;
+    getInfoForKey(key, &label, &value);
+    return value;
+}
+
+QString ImageMetaInfoModel::keyForIndex(const QModelIndex& index) const
+{
+    if (index.internalId() == NoGroup) {
+        return QString();
+    }
+    MetaInfoGroup* group = d->mMetaInfoGroupVector[index.internalId()];
+    return group->getKeyAt(index.row());
+}
+
+QModelIndex ImageMetaInfoModel::index(int row, int col, const QModelIndex& parent) const
+{
+    if (col < 0 || col > 1) {
+        return QModelIndex();
+    }
+    if (!parent.isValid()) {
+        // This is a group
+        if (row < 0 || row >= d->mMetaInfoGroupVector.size()) {
+            return QModelIndex();
+        }
+        return createIndex(row, col, col == 0 ? NoGroup : NoGroupSpace);
+    } else {
+        // This is an entry
+        int group = parent.row();
+        if (row < 0 || row >= d->mMetaInfoGroupVector[group]->size()) {
+            return QModelIndex();
+        }
+        return createIndex(row, col, group);
+    }
+}
+
+QModelIndex ImageMetaInfoModel::parent(const QModelIndex& index) const
+{
+    if (!index.isValid()) {
+        return QModelIndex();
+    }
+    if (index.internalId() == NoGroup || index.internalId() == NoGroupSpace) {
+        return QModelIndex();
+    } else {
+        return createIndex(index.internalId(), 0, NoGroup);
+    }
+}
+
+int ImageMetaInfoModel::rowCount(const QModelIndex& parent) const
+{
+    if (!parent.isValid()) {
+        return d->mMetaInfoGroupVector.size();
+    } else if (parent.internalId() == NoGroup) {
+        return d->mMetaInfoGroupVector[parent.row()]->size();
+    } else {
+        return 0;
+    }
+}
+
+int ImageMetaInfoModel::columnCount(const QModelIndex& /*parent*/) const
+{
+    return 2;
+}
+
+QVariant ImageMetaInfoModel::data(const QModelIndex& index, int role) const
+{
+    if (!index.isValid()) {
+        return QVariant();
+    }
+
+    switch (role) {
+    case Qt::DisplayRole:
+        return d->displayData(index);
+    default:
+        return QVariant();
+    }
+}
+
+QVariant ImageMetaInfoModel::headerData(int section, Qt::Orientation orientation, int role) const
+{
+    if (orientation == Qt::Vertical || role != Qt::DisplayRole) {
+        return QVariant();
+    }
+
+    QString caption;
+    if (section == 0) {
+        caption = i18nc("@title:column", "Property");
+    } else if (section == 1) {
+        caption = i18nc("@title:column", "Value");
+    } else {
+        kWarning() << "Unknown section" << section;
+    }
+
+    return QVariant(caption);
+}
 
 } // namespace

=== modified file 'lib/imagemetainfomodel.h'
--- lib/imagemetainfomodel.h	2011-07-20 13:46:34 +0000
+++ lib/imagemetainfomodel.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -32,39 +32,42 @@
 
 class KUrl;
 
-namespace Exiv2 { class Image; }
-
-namespace Gwenview {
-
+namespace Exiv2
+{
+class Image;
+}
+
+namespace Gwenview
+{
 
 struct ImageMetaInfoModelPrivate;
-class GWENVIEWLIB_EXPORT ImageMetaInfoModel : public QAbstractItemModel {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ImageMetaInfoModel : public QAbstractItemModel
+{
+    Q_OBJECT
 public:
-	ImageMetaInfoModel();
-	~ImageMetaInfoModel();
-
-	void setUrl(const KUrl&);
-	void setImageSize(const QSize&);
-	void setExiv2Image(const Exiv2::Image*);
-
-	QString keyForIndex(const QModelIndex&) const;
-	void getInfoForKey(const QString& key, QString* label, QString* value) const;
-	QString getValueForKey(const QString& key) const;
-
-	virtual QModelIndex index(int row, int col, const QModelIndex& parent = QModelIndex()) const;
-	virtual QModelIndex parent(const QModelIndex&) const;
-	virtual int rowCount(const QModelIndex& = QModelIndex()) const;
-	virtual int columnCount(const QModelIndex& = QModelIndex()) const;
-	virtual QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
-	virtual QVariant data(const QModelIndex&, int role = Qt::DisplayRole) const;
+    ImageMetaInfoModel();
+    ~ImageMetaInfoModel();
+
+    void setUrl(const KUrl&);
+    void setImageSize(const QSize&);
+    void setExiv2Image(const Exiv2::Image*);
+
+    QString keyForIndex(const QModelIndex&) const;
+    void getInfoForKey(const QString& key, QString* label, QString* value) const;
+    QString getValueForKey(const QString& key) const;
+
+    virtual QModelIndex index(int row, int col, const QModelIndex& parent = QModelIndex()) const;
+    virtual QModelIndex parent(const QModelIndex&) const;
+    virtual int rowCount(const QModelIndex& = QModelIndex()) const;
+    virtual int columnCount(const QModelIndex& = QModelIndex()) const;
+    virtual QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
+    virtual QVariant data(const QModelIndex&, int role = Qt::DisplayRole) const;
 
 private:
-	ImageMetaInfoModelPrivate* const d;
-	friend struct ImageMetaInfoModelPrivate;
+    ImageMetaInfoModelPrivate* const d;
+    friend struct ImageMetaInfoModelPrivate;
 };
 
-
 } // namespace
 
 #endif /* IMAGEMETAINFO_H */

=== modified file 'lib/imagescaler.cpp'
--- lib/imagescaler.cpp	2011-07-20 13:46:34 +0000
+++ lib/imagescaler.cpp	2011-12-15 14:17:54 +0000
@@ -39,164 +39,171 @@
 #define LOG(x) ;
 #endif
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 // Amount of pixels to keep so that smooth scale is correct
 static const int SMOOTH_MARGIN = 3;
 
 struct ImageScalerPrivate {
-	Qt::TransformationMode mTransformationMode;
-	Document::Ptr mDocument;
-	qreal mZoom;
-	QRegion mRegion;
+    Qt::TransformationMode mTransformationMode;
+    Document::Ptr mDocument;
+    qreal mZoom;
+    QRegion mRegion;
 };
 
 ImageScaler::ImageScaler(QObject* parent)
 : QObject(parent)
-, d(new ImageScalerPrivate) {
-	d->mTransformationMode = Qt::FastTransformation;
-	d->mZoom = 0;
-}
-
-ImageScaler::~ImageScaler() {
-	delete d;
-}
-
-void ImageScaler::setDocument(Document::Ptr document) {
-	if (d->mDocument) {
-		disconnect(d->mDocument.data(), 0, this, 0);
-	}
-	d->mDocument = document;
-	connect(d->mDocument.data(), SIGNAL(downSampledImageReady()),
-		SLOT(doScale()) );
-}
-
-void ImageScaler::setZoom(qreal zoom) {
-	d->mZoom = zoom;
-}
-
-void ImageScaler::setTransformationMode(Qt::TransformationMode mode) {
-	d->mTransformationMode = mode;
-}
-
-void ImageScaler::setDestinationRegion(const QRegion& region) {
-	LOG(region);
-	d->mRegion = region;
-	if (d->mRegion.isEmpty()) {
-		return;
-	}
-
-	if (d->mDocument && d->mZoom > 0) {
-		doScale();
-	}
-}
-
-
-void ImageScaler::doScale() {
-	if (d->mZoom < Document::maxDownSampledZoom()) {
-		if (!d->mDocument->prepareDownSampledImageForZoom(d->mZoom)) {
-			LOG("Asked for a down sampled image");
-			return;
-		}
-	} else if (d->mDocument->image().isNull()) {
-		LOG("Asked for the full image");
-		d->mDocument->startLoadingFullImage();
-		return;
-	}
-
-	LOG("Starting");
-	Q_FOREACH(const QRect& rect, d->mRegion.rects()) {
-		LOG(rect);
-		scaleRect(rect);
-	}
-	LOG("Done");
-}
-
-
-void ImageScaler::scaleRect(const QRect& rect) {
-	const qreal REAL_DELTA = 0.001;
-	if (qAbs(d->mZoom - 1.0) < REAL_DELTA) {
-		QImage tmp = d->mDocument->image().copy(rect);
-		tmp.convertToFormat(QImage::Format_ARGB32_Premultiplied);
-		scaledRect(rect.left(), rect.top(), tmp);
-		return;
-	}
-
-	QImage image;
-	qreal zoom;
-	if (d->mZoom < Document::maxDownSampledZoom()) {
-		image = d->mDocument->downSampledImageForZoom(d->mZoom);
-		Q_ASSERT(!image.isNull());
-		qreal zoom1 = qreal(image.width()) / d->mDocument->width();
-		zoom = d->mZoom / zoom1;
-	} else {
-		image = d->mDocument->image();
-		zoom = d->mZoom;
-	}
-	// If rect contains "half" pixels, make sure sourceRect includes them
-	QRectF sourceRectF(
-		rect.left() / zoom,
-		rect.top() / zoom,
-		rect.width() / zoom,
-		rect.height() / zoom);
-
-	sourceRectF = sourceRectF.intersected(image.rect());
-	QRect sourceRect = PaintUtils::containingRect(sourceRectF);
-	if (sourceRect.isEmpty()) {
-		return;
-	}
-
-	// Compute smooth margin
-	bool needsSmoothMargins = d->mTransformationMode == Qt::SmoothTransformation;
-
-	int sourceLeftMargin, sourceRightMargin, sourceTopMargin, sourceBottomMargin;
-	int destLeftMargin, destRightMargin, destTopMargin, destBottomMargin;
-	if (needsSmoothMargins) {
-		sourceLeftMargin = qMin(sourceRect.left(), SMOOTH_MARGIN);
-		sourceTopMargin = qMin(sourceRect.top(), SMOOTH_MARGIN);
-		sourceRightMargin = qMin(image.rect().right() - sourceRect.right(), SMOOTH_MARGIN);
-		sourceBottomMargin = qMin(image.rect().bottom() - sourceRect.bottom(), SMOOTH_MARGIN);
-		sourceRect.adjust(
-			-sourceLeftMargin,
-			-sourceTopMargin,
-			sourceRightMargin,
-			sourceBottomMargin);
-		destLeftMargin = int(sourceLeftMargin * zoom);
-		destTopMargin = int(sourceTopMargin * zoom);
-		destRightMargin = int(sourceRightMargin * zoom);
-		destBottomMargin = int(sourceBottomMargin * zoom);
-	} else {
-		sourceLeftMargin = sourceRightMargin = sourceTopMargin = sourceBottomMargin = 0;
-		destLeftMargin = destRightMargin = destTopMargin = destBottomMargin = 0;
-	}
-
-	// destRect is almost like rect, but it contains only "full" pixels
-	QRectF destRectF = QRectF(
-		sourceRect.left() * zoom,
-		sourceRect.top() * zoom,
-		sourceRect.width() * zoom,
-		sourceRect.height() * zoom
-		);
-	QRect destRect = PaintUtils::containingRect(destRectF);
-
-	QImage tmp;
-	tmp = image.copy(sourceRect);
-	tmp.convertToFormat(QImage::Format_ARGB32_Premultiplied);
-	tmp = tmp.scaled(
-		destRect.width(),
-		destRect.height(),
-		Qt::IgnoreAspectRatio, // Do not use KeepAspectRatio, it can lead to skipped rows or columns
-		d->mTransformationMode);
-
-	if (needsSmoothMargins) {
-		tmp = tmp.copy(
-			destLeftMargin, destTopMargin,
-			destRect.width() - (destLeftMargin + destRightMargin),
-			destRect.height() - (destTopMargin + destBottomMargin)
-			);
-	}
-
-	scaledRect(destRect.left() + destLeftMargin, destRect.top() + destTopMargin, tmp);
+, d(new ImageScalerPrivate)
+{
+    d->mTransformationMode = Qt::FastTransformation;
+    d->mZoom = 0;
+}
+
+ImageScaler::~ImageScaler()
+{
+    delete d;
+}
+
+void ImageScaler::setDocument(Document::Ptr document)
+{
+    if (d->mDocument) {
+        disconnect(d->mDocument.data(), 0, this, 0);
+    }
+    d->mDocument = document;
+    connect(d->mDocument.data(), SIGNAL(downSampledImageReady()),
+            SLOT(doScale()));
+}
+
+void ImageScaler::setZoom(qreal zoom)
+{
+    d->mZoom = zoom;
+}
+
+void ImageScaler::setTransformationMode(Qt::TransformationMode mode)
+{
+    d->mTransformationMode = mode;
+}
+
+void ImageScaler::setDestinationRegion(const QRegion& region)
+{
+    LOG(region);
+    d->mRegion = region;
+    if (d->mRegion.isEmpty()) {
+        return;
+    }
+
+    if (d->mDocument && d->mZoom > 0) {
+        doScale();
+    }
+}
+
+void ImageScaler::doScale()
+{
+    if (d->mZoom < Document::maxDownSampledZoom()) {
+        if (!d->mDocument->prepareDownSampledImageForZoom(d->mZoom)) {
+            LOG("Asked for a down sampled image");
+            return;
+        }
+    } else if (d->mDocument->image().isNull()) {
+        LOG("Asked for the full image");
+        d->mDocument->startLoadingFullImage();
+        return;
+    }
+
+    LOG("Starting");
+    Q_FOREACH(const QRect & rect, d->mRegion.rects()) {
+        LOG(rect);
+        scaleRect(rect);
+    }
+    LOG("Done");
+}
+
+void ImageScaler::scaleRect(const QRect& rect)
+{
+    const qreal REAL_DELTA = 0.001;
+    if (qAbs(d->mZoom - 1.0) < REAL_DELTA) {
+        QImage tmp = d->mDocument->image().copy(rect);
+        tmp.convertToFormat(QImage::Format_ARGB32_Premultiplied);
+        scaledRect(rect.left(), rect.top(), tmp);
+        return;
+    }
+
+    QImage image;
+    qreal zoom;
+    if (d->mZoom < Document::maxDownSampledZoom()) {
+        image = d->mDocument->downSampledImageForZoom(d->mZoom);
+        Q_ASSERT(!image.isNull());
+        qreal zoom1 = qreal(image.width()) / d->mDocument->width();
+        zoom = d->mZoom / zoom1;
+    } else {
+        image = d->mDocument->image();
+        zoom = d->mZoom;
+    }
+    // If rect contains "half" pixels, make sure sourceRect includes them
+    QRectF sourceRectF(
+        rect.left() / zoom,
+        rect.top() / zoom,
+        rect.width() / zoom,
+        rect.height() / zoom);
+
+    sourceRectF = sourceRectF.intersected(image.rect());
+    QRect sourceRect = PaintUtils::containingRect(sourceRectF);
+    if (sourceRect.isEmpty()) {
+        return;
+    }
+
+    // Compute smooth margin
+    bool needsSmoothMargins = d->mTransformationMode == Qt::SmoothTransformation;
+
+    int sourceLeftMargin, sourceRightMargin, sourceTopMargin, sourceBottomMargin;
+    int destLeftMargin, destRightMargin, destTopMargin, destBottomMargin;
+    if (needsSmoothMargins) {
+        sourceLeftMargin = qMin(sourceRect.left(), SMOOTH_MARGIN);
+        sourceTopMargin = qMin(sourceRect.top(), SMOOTH_MARGIN);
+        sourceRightMargin = qMin(image.rect().right() - sourceRect.right(), SMOOTH_MARGIN);
+        sourceBottomMargin = qMin(image.rect().bottom() - sourceRect.bottom(), SMOOTH_MARGIN);
+        sourceRect.adjust(
+            -sourceLeftMargin,
+            -sourceTopMargin,
+            sourceRightMargin,
+            sourceBottomMargin);
+        destLeftMargin = int(sourceLeftMargin * zoom);
+        destTopMargin = int(sourceTopMargin * zoom);
+        destRightMargin = int(sourceRightMargin * zoom);
+        destBottomMargin = int(sourceBottomMargin * zoom);
+    } else {
+        sourceLeftMargin = sourceRightMargin = sourceTopMargin = sourceBottomMargin = 0;
+        destLeftMargin = destRightMargin = destTopMargin = destBottomMargin = 0;
+    }
+
+    // destRect is almost like rect, but it contains only "full" pixels
+    QRectF destRectF = QRectF(
+                           sourceRect.left() * zoom,
+                           sourceRect.top() * zoom,
+                           sourceRect.width() * zoom,
+                           sourceRect.height() * zoom
+                       );
+    QRect destRect = PaintUtils::containingRect(destRectF);
+
+    QImage tmp;
+    tmp = image.copy(sourceRect);
+    tmp.convertToFormat(QImage::Format_ARGB32_Premultiplied);
+    tmp = tmp.scaled(
+              destRect.width(),
+              destRect.height(),
+              Qt::IgnoreAspectRatio, // Do not use KeepAspectRatio, it can lead to skipped rows or columns
+              d->mTransformationMode);
+
+    if (needsSmoothMargins) {
+        tmp = tmp.copy(
+                  destLeftMargin, destTopMargin,
+                  destRect.width() - (destLeftMargin + destRightMargin),
+                  destRect.height() - (destTopMargin + destBottomMargin)
+              );
+    }
+
+    scaledRect(destRect.left() + destLeftMargin, destRect.top() + destTopMargin, tmp);
 }
 
 } // namespace

=== modified file 'lib/imagescaler.h'
--- lib/imagescaler.h	2011-07-20 13:46:34 +0000
+++ lib/imagescaler.h	2011-12-15 14:17:54 +0000
@@ -32,34 +32,35 @@
 class QRect;
 class QRegion;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class Document;
 
 struct ImageScalerPrivate;
-class GWENVIEWLIB_EXPORT ImageScaler : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ImageScaler : public QObject
+{
+    Q_OBJECT
 public:
-	ImageScaler(QObject* parent=0);
-	~ImageScaler();
-	void setDocument(KSharedPtr<Document>);
-	void setZoom(qreal);
-	void setDestinationRegion(const QRegion&);
+    ImageScaler(QObject* parent = 0);
+    ~ImageScaler();
+    void setDocument(KSharedPtr<Document>);
+    void setZoom(qreal);
+    void setDestinationRegion(const QRegion&);
 
-	void setTransformationMode(Qt::TransformationMode);
+    void setTransformationMode(Qt::TransformationMode);
 
 Q_SIGNALS:
-	void scaledRect(int left, int top, const QImage&);
+    void scaledRect(int left, int top, const QImage&);
 
 private:
-	ImageScalerPrivate * const d;
-	void scaleRect(const QRect&);
+    ImageScalerPrivate * const d;
+    void scaleRect(const QRect&);
 
 private Q_SLOTS:
-	void doScale();
+    void doScale();
 };
 
 } // namespace
 
-
 #endif /* IMAGESCALER_H */

=== modified file 'lib/imageutils.cpp'
--- lib/imageutils.cpp	2011-07-20 13:46:34 +0000
+++ lib/imageutils.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -23,50 +23,51 @@
 // Qt
 #include <QMatrix>
 
-
-namespace Gwenview {
-namespace ImageUtils {
-
-
-QMatrix transformMatrix(Orientation orientation) {
-	QMatrix matrix;
-	switch (orientation) {
-	case NOT_AVAILABLE:
-	case NORMAL:
-		break;
-
-	case HFLIP:
-		matrix.scale(-1,1);
-		break;
-
-	case ROT_180:
-		matrix.rotate(180);
-		break;
-
-	case VFLIP:
-		matrix.scale(1,-1);
-		break;
-	
-	case TRANSPOSE:
-		matrix.scale(-1,1);
-		matrix.rotate(90);
-		break;
-		
-	case ROT_90:		
-		matrix.rotate(90);
-		break;
-	
-	case TRANSVERSE:
-		matrix.scale(1,-1);
-		matrix.rotate(90);
-		break;
-		
-	case ROT_270:		
-		matrix.rotate(270);
-		break;
-	}
-
-	return matrix;
+namespace Gwenview
+{
+namespace ImageUtils
+{
+
+QMatrix transformMatrix(Orientation orientation)
+{
+    QMatrix matrix;
+    switch (orientation) {
+    case NOT_AVAILABLE:
+    case NORMAL:
+        break;
+
+    case HFLIP:
+        matrix.scale(-1, 1);
+        break;
+
+    case ROT_180:
+        matrix.rotate(180);
+        break;
+
+    case VFLIP:
+        matrix.scale(1, -1);
+        break;
+
+    case TRANSPOSE:
+        matrix.scale(-1, 1);
+        matrix.rotate(90);
+        break;
+
+    case ROT_90:
+        matrix.rotate(90);
+        break;
+
+    case TRANSVERSE:
+        matrix.scale(1, -1);
+        matrix.rotate(90);
+        break;
+
+    case ROT_270:
+        matrix.rotate(270);
+        break;
+    }
+
+    return matrix;
 }
 
 } // namespace

=== modified file 'lib/imageutils.h'
--- lib/imageutils.h	2011-07-20 13:46:34 +0000
+++ lib/imageutils.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -26,8 +26,10 @@
 
 class QMatrix;
 
-namespace Gwenview {
-namespace ImageUtils {
+namespace Gwenview
+{
+namespace ImageUtils
+{
 
 GWENVIEWLIB_EXPORT QMatrix transformMatrix(Orientation);
 

=== removed file 'lib/imageview.cpp'
--- lib/imageview.cpp	2011-07-20 13:46:34 +0000
+++ lib/imageview.cpp	1970-01-01 00:00:00 +0000
@@ -1,772 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "imageview.moc"
-
-// Qt
-#include <QApplication>
-#include <QPainter>
-#include <QPaintEvent>
-#include <QPointer>
-#include <QScrollBar>
-
-// KDE
-#include <kdebug.h>
-
-// Local
-#include "abstractimageviewtool.h"
-#include "imagescaler.h"
-
-
-namespace Gwenview {
-
-#undef ENABLE_LOG
-#undef LOG
-//#define ENABLE_LOG
-#ifdef ENABLE_LOG
-#define LOG(x) kDebug() << x
-#else
-#define LOG(x) ;
-#endif
-
-struct ImageViewPrivate {
-	ImageView* mView;
-	QPixmap mBackgroundTexture;
-	QWidget* mViewport;
-	ImageView::AlphaBackgroundMode mAlphaBackgroundMode;
-	QColor mAlphaBackgroundColor;
-	bool mEnlargeSmallerImages;
-	Document::Ptr mDocument;
-	qreal mZoom;
-	bool mZoomToFit;
-	QPixmap mCurrentBuffer;
-	QPixmap mAlternateBuffer;
-	ImageScaler* mScaler;
-	QPointer<AbstractImageViewTool> mTool;
-	QPointer<AbstractImageViewTool> mDefaultTool;
-	bool mInsideSetZoom;
-
-
-	void createBackgroundTexture() {
-		mBackgroundTexture = QPixmap(32, 32);
-		QPainter painter(&mBackgroundTexture);
-		painter.fillRect(mBackgroundTexture.rect(), QColor(128, 128, 128));
-		QColor light = QColor(192, 192, 192);
-		painter.fillRect(0, 0, 16, 16, light);
-		painter.fillRect(16, 16, 16, 16, light);
-	}
-
-
-	QSize visibleImageSize() const {
-		if (!mDocument) {
-			return QSize();
-		}
-		QSize size;
-		qreal zoom;
-		if (mZoomToFit) {
-			zoom = mView->computeZoomToFit();
-		} else {
-			zoom = mZoom;
-		}
-
-		size = mDocument->size() * zoom;
-		size = size.boundedTo(mViewport->size());
-
-		return size;
-	}
-
-
-	void drawAlphaBackground(QPainter* painter, const QRect& viewportRect, const QPoint& zoomedImageTopLeft) {
-		if (mAlphaBackgroundMode == ImageView::AlphaBackgroundCheckBoard) {
-			QPoint textureOffset(
-				zoomedImageTopLeft.x() % mBackgroundTexture.width(),
-				zoomedImageTopLeft.y() % mBackgroundTexture.height()
-				);
-			painter->drawTiledPixmap(
-				viewportRect,
-				mBackgroundTexture,
-				textureOffset);
-		} else {
-			painter->fillRect(viewportRect, mAlphaBackgroundColor);
-		}
-	}
-
-	void createBuffer() {
-		QSize size = mView->size();
-		if (size == mCurrentBuffer.size()) {
-			return;
-		}
-		if (!size.isValid()) {
-			mAlternateBuffer = QPixmap();
-			mCurrentBuffer = QPixmap();
-			return;
-		}
-
-		mAlternateBuffer = QPixmap(size);
-		QPainter painter(&mAlternateBuffer);
-		QColor bgColor = mViewport->palette().color(mViewport->backgroundRole());
-		painter.fillRect(mAlternateBuffer.rect(), bgColor);
-		painter.drawPixmap(0, 0, mCurrentBuffer);
-		qSwap(mAlternateBuffer, mCurrentBuffer);
-
-		mAlternateBuffer = QPixmap();
-	}
-
-
-	int hScroll() const {
-		if (mZoomToFit) {
-			return 0;
-		} else {
-			return mView->horizontalScrollBar()->value();
-		}
-	}
-
-	int vScroll() const {
-		if (mZoomToFit) {
-			return 0;
-		} else {
-			return mView->verticalScrollBar()->value();
-		}
-	}
-
-	QRect mapViewportToZoomedImage(const QRect& viewportRect) {
-		QPoint offset = mView->imageOffset();
-		QRect rect = QRect(
-			viewportRect.x() + hScroll() - offset.x(),
-			viewportRect.y() + vScroll() - offset.y(),
-			viewportRect.width(),
-			viewportRect.height()
-		);
-
-		return rect;
-	}
-
-
-	void setScalerRegionToVisibleRect() {
-		QRect rect = mapViewportToZoomedImage(mViewport->rect());
-		mScaler->setDestinationRegion(QRegion(rect));
-	}
-
-
-	void forceBufferRecreation() {
-		mCurrentBuffer = QPixmap();
-		createBuffer();
-		setScalerRegionToVisibleRect();
-	}
-
-
-	void startAnimationIfNecessary() {
-		if (mDocument && mView->isVisible()) {
-			mDocument->startAnimation();
-		}
-	}
-
-
-	// At least gcc 3.4.6 on FreeBSD requires a default constructor.
-	ImageViewPrivate() { }
-};
-
-
-ImageView::ImageView(QWidget* parent)
-: QAbstractScrollArea(parent)
-, d(new ImageViewPrivate)
-{
-	d->mAlphaBackgroundMode = AlphaBackgroundCheckBoard;
-	d->mAlphaBackgroundColor = Qt::black;
-
-	d->mView = this;
-	d->mZoom = 1.;
-	d->mZoomToFit = true;
-	d->createBackgroundTexture();
-	setFrameShape(QFrame::NoFrame);
-	setBackgroundRole(QPalette::Base);
-	d->mViewport = new QWidget();
-	setViewport(d->mViewport);
-	d->mViewport->setMouseTracking(true);
-	horizontalScrollBar()->setSingleStep(16);
-	verticalScrollBar()->setSingleStep(16);
-	d->mScaler = new ImageScaler(this);
-	d->mInsideSetZoom = false;
-
-	if (QApplication::isRightToLeft()) {
-		// Ensure we don't get weird behavior in RightToleft mode
-		// See bug #210058
-		horizontalScrollBar()->setLayoutDirection(Qt::LeftToRight);
-	}
-	connect(d->mScaler, SIGNAL(scaledRect(int, int, const QImage&)), 
-		SLOT(updateFromScaler(int, int, const QImage&)) );
-}
-
-ImageView::~ImageView() {
-	delete d;
-}
-
-
-void ImageView::setAlphaBackgroundMode(AlphaBackgroundMode mode) {
-	d->mAlphaBackgroundMode = mode;
-	if (d->mDocument && d->mDocument->hasAlphaChannel()) {
-		d->forceBufferRecreation();
-	}
-}
-
-
-void ImageView::setAlphaBackgroundColor(const QColor& color) {
-	d->mAlphaBackgroundColor = color;
-	if (d->mDocument && d->mDocument->hasAlphaChannel()) {
-		d->forceBufferRecreation();
-	}
-}
-
-
-void ImageView::setEnlargeSmallerImages(bool value) {
-	d->mEnlargeSmallerImages = value;
-	if (d->mZoomToFit) {
-		setZoom(computeZoomToFit());
-	}
-}
-
-
-void ImageView::setDocument(Document::Ptr document) {
-	if (d->mDocument) {
-		d->mDocument->stopAnimation();
-		disconnect(d->mDocument.data(), 0, this, 0);
-	}
-	d->mDocument = document;
-	if (!document) {
-		d->mViewport->update();
-		return;
-	}
-
-	connect(d->mDocument.data(), SIGNAL(metaInfoLoaded(const KUrl&)),
-		SLOT(slotDocumentMetaInfoLoaded()) );
-	connect(d->mDocument.data(), SIGNAL(isAnimatedUpdated()),
-		SLOT(slotDocumentIsAnimatedUpdated()) );
-
-	const Document::LoadingState state = d->mDocument->loadingState();
-	if (state == Document::MetaInfoLoaded || state == Document::Loaded) {
-		slotDocumentMetaInfoLoaded();
-	}
-}
-
-
-void ImageView::slotDocumentMetaInfoLoaded() {
-	if (d->mDocument->size().isValid()) {
-		finishSetDocument();
-	} else {
-		// Could not retrieve image size from meta info, we need to load the
-		// full image now.
-		connect(d->mDocument.data(), SIGNAL(loaded(const KUrl&)),
-			SLOT(finishSetDocument()) );
-		d->mDocument->startLoadingFullImage();
-	}
-}
-
-
-void ImageView::finishSetDocument() {
-	if (!d->mDocument->size().isValid()) {
-		kError() << "No valid image size available, this should not happen!";
-		return;
-	}
-
-	d->createBuffer();
-	d->mScaler->setDocument(d->mDocument);
-
-	connect(d->mDocument.data(), SIGNAL(imageRectUpdated(const QRect&)),
-		SLOT(updateImageRect(const QRect&)) );
-
-	if (d->mZoomToFit) {
-		// Set the zoom to an invalid value to make sure setZoom() does not
-		// return early because the new zoom is the same as the old zoom.
-		d->mZoom = -1;
-		setZoom(computeZoomToFit());
-	} else {
-		QRect rect(QPoint(0, 0), d->mDocument->size());
-		updateImageRect(rect);
-		updateScrollBars();
-	}
-
-	d->startAnimationIfNecessary();
-	d->mViewport->update();
-}
-
-
-Document::Ptr ImageView::document() const {
-	return d->mDocument;
-}
-
-
-void ImageView::slotDocumentIsAnimatedUpdated() {
-	d->startAnimationIfNecessary();
-}
-
-
-void ImageView::updateImageRect(const QRect& imageRect) {
-	LOG("imageRect" << imageRect);
-	QRect viewportRect = mapToViewport(imageRect);
-	viewportRect = viewportRect.intersected(d->mViewport->rect());
-	if (viewportRect.isEmpty()) {
-		return;
-	}
-
-	if (d->mZoomToFit) {
-		setZoom(computeZoomToFit());
-	}
-	d->setScalerRegionToVisibleRect();
-	d->mViewport->update();
-}
-
-
-void ImageView::paintEvent(QPaintEvent* event) {
-	QPainter painter(d->mViewport);
-	painter.setClipRect(event->rect());
-
-	painter.setCompositionMode(QPainter::CompositionMode_Source);
-	painter.drawPixmap(0, 0, d->mCurrentBuffer);
-
-	painter.setCompositionMode(QPainter::CompositionMode_SourceOver);
-	if (d->mTool) {
-		d->mTool->paint(&painter);
-	}
-}
-
-void ImageView::resizeEvent(QResizeEvent*) {
-	if (d->mZoomToFit) {
-		// Bypass "same zoom" test: even if the zoom is the same we want a new
-		// buffer of the correct size (and if switching from/to fullscreen, using
-		// the correct background) to be created
-		d->mZoom = -1;
-		setZoom(computeZoomToFit());
-		// Make sure one can't use mousewheel in zoom-to-fit mode
-		horizontalScrollBar()->setRange(0, 0);
-		verticalScrollBar()->setRange(0, 0);
-	} else {
-		d->createBuffer();
-		updateScrollBars();
-		d->setScalerRegionToVisibleRect();
-	}
-}
-
-QPoint ImageView::imageOffset() const {
-	QSize size = d->visibleImageSize();
-	int left = qMax( (d->mViewport->width() - size.width()) / 2, 0);
-	int top = qMax( (d->mViewport->height() - size.height()) / 2, 0);
-
-	return QPoint(left, top);
-}
-
-
-void ImageView::setZoom(qreal zoom, const QPoint& _center) {
-	if (!d->mDocument) {
-		return;
-	}
-
-	qreal oldZoom = d->mZoom;
-	if (qAbs(zoom - oldZoom) < 0.001) {
-		return;
-	}
-	// Get offset *before* setting mZoom, otherwise we get the new offset
-	QPoint oldOffset = imageOffset();
-	d->mZoom = zoom;
-
-	QPoint center;
-	if (_center == QPoint(-1, -1)) {
-		center = QPoint(d->mViewport->width() / 2, d->mViewport->height() / 2);
-	} else {
-		center = _center;
-	}
-
-	// If we zoom more than twice, then assume the user wants to see the real
-	// pixels, for example to fine tune a crop operation
-	if (d->mZoom < 2.) {
-		d->mScaler->setTransformationMode(Qt::SmoothTransformation);
-	} else {
-		d->mScaler->setTransformationMode(Qt::FastTransformation);
-	}
-
-	d->createBuffer();
-	d->mInsideSetZoom = true;
-
-	/*
-	We want to keep the point at viewport coordinates "center" at the same
-	position after zooming. The coordinates of this point in image coordinates
-	can be expressed like this:
-
-	                      oldScroll + center
-	imagePointAtOldZoom = ------------------
-	                           oldZoom
-
-	                   scroll + center
-	imagePointAtZoom = ---------------
-	                        zoom
-
-	So we want:
-
-	    imagePointAtOldZoom = imagePointAtZoom
-
-	    oldScroll + center   scroll + center
-	<=> ------------------ = ---------------
-	          oldZoom             zoom
-
-	              zoom
-	<=> scroll = ------- (oldScroll + center) - center
-	             oldZoom
-	*/
-
-	/*
-	Compute oldScroll
-	It's useless to take the new offset in consideration because if a direction
-	of the new offset is not 0, we won't be able to center on a specific point
-	in that direction.
-	*/
-	QPointF oldScroll = QPointF(d->hScroll(), d->vScroll()) - oldOffset;
-
-	QPointF scroll = (zoom / oldZoom) * (oldScroll + center) - center;
-
-	updateScrollBars();
-	horizontalScrollBar()->setValue(int(scroll.x()));
-	verticalScrollBar()->setValue(int(scroll.y()));
-	d->mInsideSetZoom = false;
-
-	d->mScaler->setZoom(d->mZoom);
-	d->setScalerRegionToVisibleRect();
-	emit zoomChanged(d->mZoom);
-}
-
-qreal ImageView::zoom() const {
-	return d->mZoom;
-}
-
-bool ImageView::zoomToFit() const {
-	return d->mZoomToFit;
-}
-
-void ImageView::setZoomToFit(bool on) {
-	d->mZoomToFit = on;
-	if (d->mZoomToFit) {
-		setZoom(computeZoomToFit());
-	}
-}
-
-void ImageView::updateScrollBars() {
-	if (!d->mDocument || d->mZoomToFit) {
-		setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
-		setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
-		return;
-	}
-	setHorizontalScrollBarPolicy(Qt::ScrollBarAsNeeded);
-	setVerticalScrollBarPolicy(Qt::ScrollBarAsNeeded);
-
-	int max;
-	int width = d->mViewport->width();
-	int height = d->mViewport->height();
-
-	max = qMax(0, int(d->mDocument->width() * d->mZoom) - width);
-	horizontalScrollBar()->setRange(0, max);
-	horizontalScrollBar()->setPageStep(width);
-
-	max = qMax(0, int(d->mDocument->height() * d->mZoom) - height);
-	verticalScrollBar()->setRange(0, max);
-	verticalScrollBar()->setPageStep(height);
-}
-
-
-void ImageView::scrollContentsBy(int dx, int dy) {
-	if (d->mInsideSetZoom) {
-		// Do not scroll anything: since we are zooming the whole viewport will
-		// eventually be repainted
-		return;
-	}
-	// Scroll existing
-	{
-		if (d->mAlternateBuffer.size() != d->mCurrentBuffer.size()) {
-			d->mAlternateBuffer = QPixmap(d->mCurrentBuffer.size());
-		}
-		QPainter painter(&d->mAlternateBuffer);
-		painter.drawPixmap(dx, dy, d->mCurrentBuffer);
-	}
-	qSwap(d->mCurrentBuffer, d->mAlternateBuffer);
-
-	// Scale missing parts
-	QRegion region;
-	int posX = d->hScroll();
-	int posY = d->vScroll();
-	int width = d->mViewport->width();
-	int height = d->mViewport->height();
-
-	QRect rect;
-	if (dx > 0) {
-		rect = QRect(posX, posY, dx, height);
-	} else {
-		rect = QRect(posX + width + dx, posY, -dx, height);
-	}
-	region |= rect;
-
-	if (dy > 0) {
-		rect = QRect(posX, posY, width, dy);
-	} else {
-		rect = QRect(posX, posY + height + dy, width, -dy);
-	}
-	region |= rect;
-
-	d->mScaler->setDestinationRegion(region);
-	d->mViewport->update();
-}
-
-
-void ImageView::updateFromScaler(int zoomedImageLeft, int zoomedImageTop, const QImage& image) {
-	LOG("");
-	QPoint offset = imageOffset();
-	int viewportLeft = offset.x() + zoomedImageLeft - d->hScroll();
-	int viewportTop = offset.y() + zoomedImageTop - d->vScroll();
-
-	{
-		QPainter painter(&d->mCurrentBuffer);
-		if (d->mDocument->hasAlphaChannel()) {
-			d->drawAlphaBackground(
-				&painter, QRect(viewportLeft, viewportTop, image.width(), image.height()),
-				QPoint(zoomedImageLeft, zoomedImageTop)
-				);
-		} else {
-			painter.setCompositionMode(QPainter::CompositionMode_Source);
-		}
-		painter.drawImage(viewportLeft, viewportTop, image);
-
-		// Clear borders. We do it here which is quite late, but this way we ensure
-		// borders are not cleared until the new image is ready. Meanwhile we
-		// continue to show the previous image. If we cleared the borders earlier
-		// we could end up clearing the borders on the previous image, leading to
-		// a temporary cropped result
-		QColor bgColor = d->mViewport->palette().color(d->mViewport->backgroundRole());
-		QRegion region = d->mCurrentBuffer.rect();
-		region -= QRect(imageOffset(), d->mDocument->size() * d->mZoom);
-		Q_FOREACH(const QRect& rect, region.rects()) {
-			painter.fillRect(rect, bgColor);
-		}
-		/*
-		// Debug rects
-		QPen pen(Qt::red);
-		pen.setStyle(Qt::DotLine);
-		painter.setPen(pen);
-		painter.drawRect(viewportLeft, viewportTop, image.width() - 1, image.height() - 1);
-		*/
-	}
-	d->mViewport->update();
-}
-
-
-void ImageView::setCurrentTool(AbstractImageViewTool* tool) {
-	if (d->mTool) {
-		d->mTool->toolDeactivated();
-	}
-	d->mTool = tool ? QPointer<AbstractImageViewTool>(tool) : d->mDefaultTool;
-	if (d->mTool) {
-		d->mTool->toolActivated();
-	}
-	d->mViewport->update();
-}
-
-
-AbstractImageViewTool* ImageView::currentTool() const {
-	return d->mTool;
-}
-
-
-void ImageView::setDefaultTool(AbstractImageViewTool* tool) {
-	d->mDefaultTool = tool;
-	if (!d->mTool && tool) {
-		setCurrentTool(tool);
-	}
-}
-
-
-AbstractImageViewTool* ImageView::defaultTool() const {
-	return d->mDefaultTool;
-}
-
-
-QPoint ImageView::mapToViewport(const QPoint& src) const {
-	QPoint dst(int(src.x() * d->mZoom), int(src.y() * d->mZoom));
-
-	dst += imageOffset();
-
-	dst.rx() -= d->hScroll();
-	dst.ry() -= d->vScroll();
-
-	return dst;
-}
-
-
-QPointF ImageView::mapToViewportF(const QPointF& src) const {
-	QPointF dst(src.x() * d->mZoom, src.y() * d->mZoom);
-
-	dst += imageOffset();
-
-	dst.rx() -= d->hScroll();
-	dst.ry() -= d->vScroll();
-
-	return dst;
-}
-
-
-QRect ImageView::mapToViewport(const QRect& src) const {
-	QRect dst(
-		mapToViewport(src.topLeft()),
-		mapToViewport(src.bottomRight())
-	);
-	return dst;
-}
-
-
-QRectF ImageView::mapToViewportF(const QRectF& src) const {
-	QRectF dst(
-		mapToViewportF(src.topLeft()),
-		mapToViewportF(src.bottomRight())
-	);
-	return dst;
-}
-
-
-QPoint ImageView::mapToImage(const QPoint& src) const {
-	QPoint dst = src;
-	
-	dst.rx() += d->hScroll();
-	dst.ry() += d->vScroll();
-
-	dst -= imageOffset();
-
-	return QPoint(int(dst.x() / d->mZoom), int(dst.y() / d->mZoom));
-}
-
-
-QPointF ImageView::mapToImageF(const QPointF& src) const {
-	QPointF dst = src;
-
-	dst.rx() += d->hScroll();
-	dst.ry() += d->vScroll();
-
-	dst -= imageOffset();
-
-	return dst / d->mZoom;
-}
-
-
-QRect ImageView::mapToImage(const QRect& src) const {
-	QRect dst(
-		mapToImage(src.topLeft()),
-		mapToImage(src.bottomRight())
-	);
-	return dst;
-}
-
-
-QRectF ImageView::mapToImageF(const QRectF& src) const {
-	QRectF dst(
-		mapToImageF(src.topLeft()),
-		mapToImageF(src.bottomRight())
-	);
-	return dst;
-}
-
-
-qreal ImageView::computeZoomToFit() const {
-	qreal zoom = qMin(computeZoomToFitWidth(), computeZoomToFitHeight());
-
-	if (!d->mEnlargeSmallerImages) {
-		zoom = qMin(zoom, qreal(1.0));
-	}
-
-	return zoom;
-}
-
-
-qreal ImageView::computeZoomToFitWidth() const {
-	if (!d->mDocument || !d->mDocument->size().isValid()) {
-		return 1.;
-	}
-	return qreal(d->mViewport->width()) / d->mDocument->width();
-}
-
-
-qreal ImageView::computeZoomToFitHeight() const {
-	if (!d->mDocument || !d->mDocument->size().isValid()) {
-		return 1.;
-	}
-	return qreal(d->mViewport->height()) / d->mDocument->height();
-}
-
-
-void ImageView::showEvent(QShowEvent* event) {
-	QAbstractScrollArea::showEvent(event);
-	d->startAnimationIfNecessary();
-}
-
-
-void ImageView::hideEvent(QHideEvent* event) {
-	QAbstractScrollArea::hideEvent(event);
-	if (d->mDocument) {
-		d->mDocument->stopAnimation();
-	}
-}
-
-
-void ImageView::mousePressEvent(QMouseEvent* event) {
-	if (d->mTool) {
-		d->mTool->mousePressEvent(event);
-	}
-}
-
-
-void ImageView::mouseMoveEvent(QMouseEvent* event) {
-	if (d->mTool) {
-		d->mTool->mouseMoveEvent(event);
-	}
-}
-
-
-void ImageView::mouseReleaseEvent(QMouseEvent* event) {
-	if (d->mTool) {
-		d->mTool->mouseReleaseEvent(event);
-	}
-}
-
-
-void ImageView::wheelEvent(QWheelEvent* event) {
-	if (d->mTool) {
-		d->mTool->wheelEvent(event);
-	}
-}
-
-
-void ImageView::keyPressEvent(QKeyEvent* event) {
-	if (d->mTool) {
-		d->mTool->keyPressEvent(event);
-	}
-	QAbstractScrollArea::keyPressEvent(event);
-}
-
-
-void ImageView::keyReleaseEvent(QKeyEvent* event) {
-	if (d->mTool) {
-		d->mTool->keyReleaseEvent(event);
-	}
-	QAbstractScrollArea::keyReleaseEvent(event);
-}
-
-
-} // namespace

=== removed file 'lib/imageview.h'
--- lib/imageview.h	2011-07-20 13:46:34 +0000
+++ lib/imageview.h	1970-01-01 00:00:00 +0000
@@ -1,147 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef IMAGEVIEW_H
-#define IMAGEVIEW_H
-
-#include <lib/gwenviewlib_export.h>
-
-// Qt
-#include <QAbstractScrollArea>
-
-// Local
-#include <lib/document/document.h>
-
-namespace Gwenview {
-
-class AbstractImageViewTool;
-
-struct ImageViewPrivate;
-class GWENVIEWLIB_EXPORT ImageView : public QAbstractScrollArea {
-	Q_OBJECT
-public:
-	enum AlphaBackgroundMode {
-		AlphaBackgroundCheckBoard,
-		AlphaBackgroundSolid
-	};
-
-	ImageView(QWidget* parent);
-	~ImageView();
-
-	/**
-	 * Defines the tool to display on the view. if @p tool is 0, fallback to
-	 * the default tool.
-	 * @see setDefaultTool
-	 */
-	void setCurrentTool(AbstractImageViewTool* tool);
-	AbstractImageViewTool* currentTool() const;
-
-	/**
-	 * This is the tool which the view will fallback to if one calls
-	 * setCurrentTool(0)
-	 */
-	void setDefaultTool(AbstractImageViewTool*);
-	AbstractImageViewTool* defaultTool() const;
-
-	void setAlphaBackgroundMode(AlphaBackgroundMode mode);
-
-	void setAlphaBackgroundColor(const QColor& color);
-
-	void setEnlargeSmallerImages(bool value);
-
-	void setDocument(Document::Ptr document);
-
-	Document::Ptr document() const;
-
-	/**
-	 * Change zoom level, making sure the point at @p center stays at the
-	 * same position after zooming, if possible.
-	 * @param zoom the zoom level
-	 * @param center the center point, in viewport coordinates
-	 */
-	void setZoom(qreal zoom, const QPoint& center = QPoint(-1, -1));
-
-	qreal zoom() const;
-
-	bool zoomToFit() const;
-
-	QPoint imageOffset() const;
-
-	QPoint mapToViewport(const QPoint& src) const;
-	QPoint mapToImage(const QPoint& src) const;
-
-	QRect mapToViewport(const QRect& src) const;
-	QRect mapToImage(const QRect& src) const;
-
-	QPointF mapToViewportF(const QPointF& src) const;
-	QPointF mapToImageF(const QPointF& src) const;
-
-	QRectF mapToViewportF(const QRectF& src) const;
-	QRectF mapToImageF(const QRectF& src) const;
-
-	qreal computeZoomToFit() const;
-	qreal computeZoomToFitWidth() const;
-	qreal computeZoomToFitHeight() const;
-
-Q_SIGNALS:
-	void zoomChanged(qreal);
-
-public Q_SLOTS:
-	void setZoomToFit(bool on);
-
-protected:
-	virtual void paintEvent(QPaintEvent*);
-
-	virtual void resizeEvent(QResizeEvent*);
-
-	virtual void scrollContentsBy(int dx, int dy);
-
-	virtual void showEvent(QShowEvent*);
-	virtual void hideEvent(QHideEvent*);
-
-	virtual void mousePressEvent(QMouseEvent*);
-	virtual void mouseMoveEvent(QMouseEvent*);
-	virtual void mouseReleaseEvent(QMouseEvent*);
-	virtual void wheelEvent(QWheelEvent*);
-	virtual void keyPressEvent(QKeyEvent*);
-	virtual void keyReleaseEvent(QKeyEvent*);
-
-private Q_SLOTS:
-	void slotDocumentMetaInfoLoaded();
-	void slotDocumentIsAnimatedUpdated();
-
-	/**
-	 * This method performs the necessary adjustments to get the view ready to
-	 * display the document set with setDocument(). It needs to be postponed
-	 * because setDocument() can be called with a document which has not been
-	 * loaded yet and whose size is unknown.
-	 */
-	void finishSetDocument();
-	void updateFromScaler(int left, int top, const QImage& image);
-	void updateImageRect(const QRect&);
-
-private:
-	void updateScrollBars();
-
-	ImageViewPrivate* const d;
-};
-
-} // namespace
-
-#endif /* IMAGEVIEW_H */

=== modified file 'lib/invisiblebuttongroup.cpp'
--- lib/invisiblebuttongroup.cpp	2011-07-20 13:46:34 +0000
+++ lib/invisiblebuttongroup.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,50 +30,49 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct InvisibleButtonGroupPrivate {
-	QButtonGroup* mGroup;
+    QButtonGroup* mGroup;
 };
 
-
 InvisibleButtonGroup::InvisibleButtonGroup(QWidget* parent)
 : QWidget(parent)
-, d(new InvisibleButtonGroupPrivate) {
-	hide();
-	d->mGroup = new QButtonGroup(this);
-	d->mGroup->setExclusive(true);
-	connect(d->mGroup, SIGNAL(buttonClicked(int)), SIGNAL(selectionChanged(int)) );
-	const QString name = metaObject()->className();
-	if (!KConfigDialogManager::propertyMap()->contains(name)) {
-		KConfigDialogManager::propertyMap()->insert(name, "current");
-		KConfigDialogManager::changedMap()->insert(name, SIGNAL(selectionChanged(int)));
-	}
-}
-
-
-InvisibleButtonGroup::~InvisibleButtonGroup() {
-	delete d;
-}
-
-
-int InvisibleButtonGroup::selected() const {
-	return d->mGroup->checkedId();
-}
-
-
-void InvisibleButtonGroup::addButton(QAbstractButton* button, int id) {
-	d->mGroup->addButton(button, id);
-}
-
-
-void InvisibleButtonGroup::setSelected(int id) {
-	QAbstractButton* button = d->mGroup->button(id);
-	if (button) {
-		button->setChecked(true);
-	}
-}
-
+, d(new InvisibleButtonGroupPrivate)
+{
+    hide();
+    d->mGroup = new QButtonGroup(this);
+    d->mGroup->setExclusive(true);
+    connect(d->mGroup, SIGNAL(buttonClicked(int)), SIGNAL(selectionChanged(int)));
+    const QString name = metaObject()->className();
+    if (!KConfigDialogManager::propertyMap()->contains(name)) {
+        KConfigDialogManager::propertyMap()->insert(name, "current");
+        KConfigDialogManager::changedMap()->insert(name, SIGNAL(selectionChanged(int)));
+    }
+}
+
+InvisibleButtonGroup::~InvisibleButtonGroup()
+{
+    delete d;
+}
+
+int InvisibleButtonGroup::selected() const
+{
+    return d->mGroup->checkedId();
+}
+
+void InvisibleButtonGroup::addButton(QAbstractButton* button, int id)
+{
+    d->mGroup->addButton(button, id);
+}
+
+void InvisibleButtonGroup::setSelected(int id)
+{
+    QAbstractButton* button = d->mGroup->button(id);
+    if (button) {
+        button->setChecked(true);
+    }
+}
 
 } // namespace

=== modified file 'lib/invisiblebuttongroup.h'
--- lib/invisiblebuttongroup.h	2011-07-20 13:46:34 +0000
+++ lib/invisiblebuttongroup.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,8 +32,8 @@
 
 class QAbstractButton;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct InvisibleButtonGroupPrivate;
 /**
@@ -75,28 +75,28 @@
  * group->addButton(ui->detailRadioButton, 2);
  * @endcode
  */
-class GWENVIEWLIB_EXPORT InvisibleButtonGroup : public QWidget {
-	Q_OBJECT
-	Q_PROPERTY(int current READ selected WRITE setSelected)
+class GWENVIEWLIB_EXPORT InvisibleButtonGroup : public QWidget
+{
+    Q_OBJECT
+    Q_PROPERTY(int current READ selected WRITE setSelected)
 public:
-	explicit InvisibleButtonGroup(QWidget* parent = 0);
-	~InvisibleButtonGroup();
-
-	int selected() const;
-
-	void addButton(QAbstractButton* button, int id);
+    explicit InvisibleButtonGroup(QWidget* parent = 0);
+    ~InvisibleButtonGroup();
+
+    int selected() const;
+
+    void addButton(QAbstractButton* button, int id);
 
 public Q_SLOTS:
-	void setSelected(int id);
+    void setSelected(int id);
 
 Q_SIGNALS:
-	void selectionChanged(int id);
+    void selectionChanged(int id);
 
 private:
-	InvisibleButtonGroupPrivate* const d;
+    InvisibleButtonGroupPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* INVISIBLEBUTTONGROUP_H */

=== modified file 'lib/iodevicejpegsourcemanager.cpp'
--- lib/iodevicejpegsourcemanager.cpp	2011-07-20 13:46:34 +0000
+++ lib/iodevicejpegsourcemanager.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -36,78 +36,79 @@
 
 // Local
 
-namespace Gwenview {
-namespace IODeviceJpegSourceManager {
+namespace Gwenview
+{
+namespace IODeviceJpegSourceManager
+{
 
 #define SOURCE_MANAGER_BUFFER_SIZE 4096
 struct IODeviceJpegSourceManager : public jpeg_source_mgr {
-	QIODevice* mIODevice;
-	JOCTET mBuffer[SOURCE_MANAGER_BUFFER_SIZE];
+    QIODevice* mIODevice;
+    JOCTET mBuffer[SOURCE_MANAGER_BUFFER_SIZE];
 };
 
-
-static boolean fill_input_buffer(j_decompress_ptr cinfo) {
-	IODeviceJpegSourceManager* src = static_cast<IODeviceJpegSourceManager*>(cinfo->src);
-	Q_ASSERT(src->mIODevice);
-	int readSize = src->mIODevice->read((char*)src->mBuffer, SOURCE_MANAGER_BUFFER_SIZE);
-	if (readSize > 0) {
-		src->next_input_byte = src->mBuffer;
-		src->bytes_in_buffer = readSize;
-	} else {
-		/**
-		 * JPEG file is broken. We feed the decoder with fake EOI, as specified
-		 * in the libjpeg documentation.
-		 */
-		static JOCTET fakeEOI[2] = { JOCTET(0xFF), JOCTET(JPEG_EOI)};
-		kWarning() << "Image is incomplete";
-		cinfo->src->next_input_byte = fakeEOI;
-		cinfo->src->bytes_in_buffer = 2;
-	}
-	return true;
-}
-
-
-static void init_source(j_decompress_ptr cinfo) {
-	fill_input_buffer(cinfo);
-}
-
-
-static void skip_input_data(j_decompress_ptr cinfo, long num_bytes) {
-	if (num_bytes > 0) {
-		while (num_bytes > (long) cinfo->src->bytes_in_buffer) {
-			num_bytes -= (long) cinfo->src->bytes_in_buffer;
-			fill_input_buffer(cinfo);
-			/**
-			 * we assume that fill_input_buffer will never return FALSE, so
-			 * suspension need not be handled.
-			 */
-		}
-		cinfo->src->next_input_byte += (size_t) num_bytes;
-		cinfo->src->bytes_in_buffer -= (size_t) num_bytes;
-	}
-}
-
-
-static void term_source(j_decompress_ptr) {
-}
-
-
-void setup(j_decompress_ptr cinfo, QIODevice* ioDevice) {
-	Q_ASSERT(!cinfo->src);
-	IODeviceJpegSourceManager* src = (IODeviceJpegSourceManager*)
-		(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
-									sizeof(IODeviceJpegSourceManager));
-	cinfo->src = src;
-
-	src->init_source = init_source;
-	src->fill_input_buffer = fill_input_buffer;
-	src->skip_input_data = skip_input_data;
-	src->resync_to_restart = jpeg_resync_to_restart;
-	src->term_source = term_source;
-
-	src->mIODevice = ioDevice;
-}
-
+static boolean fill_input_buffer(j_decompress_ptr cinfo)
+{
+    IODeviceJpegSourceManager* src = static_cast<IODeviceJpegSourceManager*>(cinfo->src);
+    Q_ASSERT(src->mIODevice);
+    int readSize = src->mIODevice->read((char*)src->mBuffer, SOURCE_MANAGER_BUFFER_SIZE);
+    if (readSize > 0) {
+        src->next_input_byte = src->mBuffer;
+        src->bytes_in_buffer = readSize;
+    } else {
+        /**
+         * JPEG file is broken. We feed the decoder with fake EOI, as specified
+         * in the libjpeg documentation.
+         */
+        static JOCTET fakeEOI[2] = { JOCTET(0xFF), JOCTET(JPEG_EOI)};
+        kWarning() << "Image is incomplete";
+        cinfo->src->next_input_byte = fakeEOI;
+        cinfo->src->bytes_in_buffer = 2;
+    }
+    return true;
+}
+
+static void init_source(j_decompress_ptr cinfo)
+{
+    fill_input_buffer(cinfo);
+}
+
+static void skip_input_data(j_decompress_ptr cinfo, long num_bytes)
+{
+    if (num_bytes > 0) {
+        while (num_bytes > (long) cinfo->src->bytes_in_buffer) {
+            num_bytes -= (long) cinfo->src->bytes_in_buffer;
+            fill_input_buffer(cinfo);
+            /**
+             * we assume that fill_input_buffer will never return FALSE, so
+             * suspension need not be handled.
+             */
+        }
+        cinfo->src->next_input_byte += (size_t) num_bytes;
+        cinfo->src->bytes_in_buffer -= (size_t) num_bytes;
+    }
+}
+
+static void term_source(j_decompress_ptr)
+{
+}
+
+void setup(j_decompress_ptr cinfo, QIODevice* ioDevice)
+{
+    Q_ASSERT(!cinfo->src);
+    IODeviceJpegSourceManager* src = (IODeviceJpegSourceManager*)
+                                     (*cinfo->mem->alloc_small)((j_common_ptr) cinfo, JPOOL_PERMANENT,
+                                             sizeof(IODeviceJpegSourceManager));
+    cinfo->src = src;
+
+    src->init_source = init_source;
+    src->fill_input_buffer = fill_input_buffer;
+    src->skip_input_data = skip_input_data;
+    src->resync_to_restart = jpeg_resync_to_restart;
+    src->term_source = term_source;
+
+    src->mIODevice = ioDevice;
+}
 
 } // IODeviceJpegSourceManager namespace
 } // Gwenview namespace

=== modified file 'lib/iodevicejpegsourcemanager.h'
--- lib/iodevicejpegsourcemanager.h	2011-07-20 13:46:34 +0000
+++ lib/iodevicejpegsourcemanager.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,7 +30,8 @@
 class QIODevice;
 struct jpeg_decompress_struct;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * This namespace provides a function which makes it possible to decode JPEG
@@ -39,7 +40,8 @@
  * To use it, simply call setup() to initialize your jpeg_decompress_struct
  * with QIODevice-ready callbacks. The device should be opened for reading.
  */
-namespace IODeviceJpegSourceManager {
+namespace IODeviceJpegSourceManager
+{
 
 void setup(jpeg_decompress_struct* cinfo, QIODevice* ioDevice);
 

=== modified file 'lib/jpegcontent.cpp'
--- lib/jpegcontent.cpp	2011-07-20 13:46:34 +0000
+++ lib/jpegcontent.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -50,10 +50,10 @@
 #include "iodevicejpegsourcemanager.h"
 #include "exiv2imageloader.h"
 
-namespace Gwenview {
-
-const int INMEM_DST_DELTA=4096;
-
+namespace Gwenview
+{
+
+const int INMEM_DST_DELTA = 4096;
 
 //-----------------------------------------------
 //
@@ -61,41 +61,44 @@
 //
 //-----------------------------------------------
 struct inmem_dest_mgr : public jpeg_destination_mgr {
-	QByteArray* mOutput;
+    QByteArray* mOutput;
 
-	void dump() {
-		kDebug() << "dest_mgr:\n";
-		kDebug() << "- next_output_byte: " << next_output_byte;
-		kDebug() << "- free_in_buffer: " << free_in_buffer;
-		kDebug() << "- output size: " << mOutput->size();
-	}
+    void dump()
+    {
+        kDebug() << "dest_mgr:\n";
+        kDebug() << "- next_output_byte: " << next_output_byte;
+        kDebug() << "- free_in_buffer: " << free_in_buffer;
+        kDebug() << "- output size: " << mOutput->size();
+    }
 };
 
-void inmem_init_destination(j_compress_ptr cinfo) {
-	inmem_dest_mgr* dest=(inmem_dest_mgr*)(cinfo->dest);
-	if (dest->mOutput->size()==0) {
-		dest->mOutput->resize(INMEM_DST_DELTA);
-	}
-	dest->free_in_buffer=dest->mOutput->size();
-	dest->next_output_byte=(JOCTET*)(dest->mOutput->data() );
-}
-
-boolean inmem_empty_output_buffer(j_compress_ptr cinfo) {
-	inmem_dest_mgr* dest=(inmem_dest_mgr*)(cinfo->dest);
-	dest->mOutput->resize(dest->mOutput->size() + INMEM_DST_DELTA);
-	dest->next_output_byte=(JOCTET*)( dest->mOutput->data() + dest->mOutput->size() - INMEM_DST_DELTA );
-	dest->free_in_buffer=INMEM_DST_DELTA;
-
-	return true;
-}
-
-void inmem_term_destination(j_compress_ptr cinfo) {
-	inmem_dest_mgr* dest=(inmem_dest_mgr*)(cinfo->dest);
-	int finalSize=dest->next_output_byte - (JOCTET*)(dest->mOutput->data());
-	Q_ASSERT(finalSize>=0);
-	dest->mOutput->resize(finalSize);
-}
-
+void inmem_init_destination(j_compress_ptr cinfo)
+{
+    inmem_dest_mgr* dest = (inmem_dest_mgr*)(cinfo->dest);
+    if (dest->mOutput->size() == 0) {
+        dest->mOutput->resize(INMEM_DST_DELTA);
+    }
+    dest->free_in_buffer = dest->mOutput->size();
+    dest->next_output_byte = (JOCTET*)(dest->mOutput->data());
+}
+
+boolean inmem_empty_output_buffer(j_compress_ptr cinfo)
+{
+    inmem_dest_mgr* dest = (inmem_dest_mgr*)(cinfo->dest);
+    dest->mOutput->resize(dest->mOutput->size() + INMEM_DST_DELTA);
+    dest->next_output_byte = (JOCTET*)(dest->mOutput->data() + dest->mOutput->size() - INMEM_DST_DELTA);
+    dest->free_in_buffer = INMEM_DST_DELTA;
+
+    return true;
+}
+
+void inmem_term_destination(j_compress_ptr cinfo)
+{
+    inmem_dest_mgr* dest = (inmem_dest_mgr*)(cinfo->dest);
+    int finalSize = dest->next_output_byte - (JOCTET*)(dest->mOutput->data());
+    Q_ASSERT(finalSize >= 0);
+    dest->mOutput->resize(finalSize);
+}
 
 //---------------------
 //
@@ -103,523 +106,522 @@
 //
 //---------------------
 struct JpegContent::Private {
-	// JpegContent usually stores the image pixels as compressed JPEG data in
-	// mRawData. However if the image is set with setImage() because the user
-	// performed a lossy image manipulation, mRawData is cleared and the image
-	// pixels are kept in mImage until updateRawDataFromImage() is called.
-	QImage mImage;
-	QByteArray mRawData;
-	QSize mSize;
-	QString mComment;
-	bool mPendingTransformation;
-	QMatrix mTransformMatrix;
-	Exiv2::ExifData mExifData;
-	QString mErrorString;
-
-	Private() {
-		mPendingTransformation = false;
-	}
-
-
-	void setupInmemDestination(j_compress_ptr cinfo, QByteArray* outputData) {
-		Q_ASSERT(!cinfo->dest);
-		inmem_dest_mgr* dest = (inmem_dest_mgr*)
-			(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
-										sizeof(inmem_dest_mgr));
-		cinfo->dest=(struct jpeg_destination_mgr*)(dest);
-
-		dest->init_destination=inmem_init_destination;
-		dest->empty_output_buffer=inmem_empty_output_buffer;
-		dest->term_destination=inmem_term_destination;
-
-		dest->mOutput=outputData;
-	}
-	bool readSize() {
-		struct jpeg_decompress_struct srcinfo;
-		
-		// Init JPEG structs 
-		JPEGErrorManager errorManager;
-
-		// Initialize the JPEG decompression object
-		srcinfo.err = &errorManager;
-		jpeg_create_decompress(&srcinfo);
-		if (setjmp(errorManager.jmp_buffer)) {
-			kError() << "libjpeg fatal error\n";
-			return false;
-		}
-
-		// Specify data source for decompression
-		QBuffer buffer(&mRawData);
-		buffer.open(QIODevice::ReadOnly);
-		IODeviceJpegSourceManager::setup(&srcinfo, &buffer);
-
-		// Read the header
-		jcopy_markers_setup(&srcinfo, JCOPYOPT_ALL);
-		int result=jpeg_read_header(&srcinfo, true);
-		if (result!=JPEG_HEADER_OK) {
-			kError() << "Could not read jpeg header\n";
-			jpeg_destroy_decompress(&srcinfo);
-			return false;
-		}
-		mSize=QSize(srcinfo.image_width, srcinfo.image_height);
-		
-		jpeg_destroy_decompress(&srcinfo);
-		return true;
-	}
-
-
-	bool updateRawDataFromImage() {
-		QBuffer buffer;
-		QImageWriter writer(&buffer, "jpeg");
-		if (!writer.write(mImage)) {
-			mErrorString = writer.errorString();
-			return false;
-		}
-		mRawData = buffer.data();
-		mImage = QImage();
-		return true;
-	}
+    // JpegContent usually stores the image pixels as compressed JPEG data in
+    // mRawData. However if the image is set with setImage() because the user
+    // performed a lossy image manipulation, mRawData is cleared and the image
+    // pixels are kept in mImage until updateRawDataFromImage() is called.
+    QImage mImage;
+    QByteArray mRawData;
+    QSize mSize;
+    QString mComment;
+    bool mPendingTransformation;
+    QMatrix mTransformMatrix;
+    Exiv2::ExifData mExifData;
+    QString mErrorString;
+
+    Private() {
+        mPendingTransformation = false;
+    }
+
+    void setupInmemDestination(j_compress_ptr cinfo, QByteArray* outputData)
+    {
+        Q_ASSERT(!cinfo->dest);
+        inmem_dest_mgr* dest = (inmem_dest_mgr*)
+                               (*cinfo->mem->alloc_small)((j_common_ptr) cinfo, JPOOL_PERMANENT,
+                                       sizeof(inmem_dest_mgr));
+        cinfo->dest = (struct jpeg_destination_mgr*)(dest);
+
+        dest->init_destination = inmem_init_destination;
+        dest->empty_output_buffer = inmem_empty_output_buffer;
+        dest->term_destination = inmem_term_destination;
+
+        dest->mOutput = outputData;
+    }
+    bool readSize()
+    {
+        struct jpeg_decompress_struct srcinfo;
+
+        // Init JPEG structs
+        JPEGErrorManager errorManager;
+
+        // Initialize the JPEG decompression object
+        srcinfo.err = &errorManager;
+        jpeg_create_decompress(&srcinfo);
+        if (setjmp(errorManager.jmp_buffer)) {
+            kError() << "libjpeg fatal error\n";
+            return false;
+        }
+
+        // Specify data source for decompression
+        QBuffer buffer(&mRawData);
+        buffer.open(QIODevice::ReadOnly);
+        IODeviceJpegSourceManager::setup(&srcinfo, &buffer);
+
+        // Read the header
+        jcopy_markers_setup(&srcinfo, JCOPYOPT_ALL);
+        int result = jpeg_read_header(&srcinfo, true);
+        if (result != JPEG_HEADER_OK) {
+            kError() << "Could not read jpeg header\n";
+            jpeg_destroy_decompress(&srcinfo);
+            return false;
+        }
+        mSize = QSize(srcinfo.image_width, srcinfo.image_height);
+
+        jpeg_destroy_decompress(&srcinfo);
+        return true;
+    }
+
+    bool updateRawDataFromImage()
+    {
+        QBuffer buffer;
+        QImageWriter writer(&buffer, "jpeg");
+        if (!writer.write(mImage)) {
+            mErrorString = writer.errorString();
+            return false;
+        }
+        mRawData = buffer.data();
+        mImage = QImage();
+        return true;
+    }
 };
 
-
 //------------
 //
 // JpegContent
 //
 //------------
-JpegContent::JpegContent() {
-	d=new JpegContent::Private();
-}
-
-
-JpegContent::~JpegContent() {
-	delete d;
-}
-
-
-bool JpegContent::load(const QString& path) {
-	QFile file(path);
-	if (!file.open(QIODevice::ReadOnly)) {
-		kError() << "Could not open '" << path << "' for reading\n";
-		return false;
-	}
-	return loadFromData(file.readAll());
-}
-
-
-bool JpegContent::loadFromData(const QByteArray& data) {
-	Exiv2::Image::AutoPtr image;
-	Exiv2ImageLoader loader;
-	if (!loader.load(data)) {
-		kError() << "Could not load image with Exiv2, reported error:" << loader.errorMessage();
-	}
-	image = loader.popImage();
-
-	return loadFromData(data, image.get());
-}
-
-
-bool JpegContent::loadFromData(const QByteArray& data, Exiv2::Image* exiv2Image) {
-	d->mPendingTransformation = false;
-	d->mTransformMatrix.reset();
-
-	d->mRawData = data;
-	if (d->mRawData.size()==0) {
-		kError() << "No data\n";
-		return false;
-	}
-
-	if (!d->readSize()) return false;
-
-	d->mExifData = exiv2Image->exifData();
-	d->mComment = QString::fromUtf8( exiv2Image->comment().c_str() );
-
-	// Adjust the size according to the orientation
-	switch (orientation()) {
-	case TRANSPOSE:
-	case ROT_90:
-	case TRANSVERSE:
-	case ROT_270:
-		d->mSize.transpose();
-		break;
-	default:
-		break;
-	}
-
-	return true;
-}
-
-
-QByteArray JpegContent::rawData() const {
-	return d->mRawData;
-}
-
-
-Orientation JpegContent::orientation() const {
-	Exiv2::ExifKey key("Exif.Image.Orientation");
-	Exiv2::ExifData::iterator it = d->mExifData.findKey(key);
-	if (it == d->mExifData.end()) {
-		return NOT_AVAILABLE;
-	}
-	return Orientation( it->toLong() );
-}
-
-
-int JpegContent::dotsPerMeterX() const {
-	return dotsPerMeter("XResolution");
-}
-
-
-int JpegContent::dotsPerMeterY() const {
-	return dotsPerMeter("YResolution");
-}
-
-
-int JpegContent::dotsPerMeter(const QString& keyName) const {
-	Exiv2::ExifKey keyResUnit("Exif.Image.ResolutionUnit");
-	Exiv2::ExifData::iterator it = d->mExifData.findKey(keyResUnit);
-	if (it == d->mExifData.end()) {
-		return 0;
-	}
-	int res = it->toLong();
-	QString keyVal = "Exif.Image." + keyName;
-	Exiv2::ExifKey keyResolution(keyVal.toAscii().data());
-	it = d->mExifData.findKey(keyResolution);
-	if (it == d->mExifData.end()) {
-		return 0;
-	}
-	// The unit for measuring XResolution and YResolution. The same unit is used for both XResolution and YResolution.
-	//     If the image resolution in unknown, 2 (inches) is designated.
-	//         Default = 2
-	//         2 = inches
-	//         3 = centimeters
-	//         Other = reserved
-	const float INCHESPERMETER = (100. / 2.54); 
-	switch (res) {
-	case 3:  // dots per cm
-		return int(it->toLong() * 100);
-	default:  // dots per inch
-		return int(it->toLong() * INCHESPERMETER);
-	}
-
-	return 0;
-}
-
-
-void JpegContent::resetOrientation() {
-	Exiv2::ExifKey key("Exif.Image.Orientation");
-	Exiv2::ExifData::iterator it = d->mExifData.findKey(key);
-	if (it == d->mExifData.end()) {
-		return;
-	}
-
-	*it = uint16_t(NORMAL);
-}
-
-
-QSize JpegContent::size() const {
-	return d->mSize;
-}
-
-
-QString JpegContent::comment() const {
-	return d->mComment;
-}
-
-
-void JpegContent::setComment(const QString& comment) {
-	d->mComment = comment;
-}
-
-
-static QMatrix createRotMatrix(int angle) {
-	QMatrix matrix;
-	matrix.rotate(angle);
-	return matrix;
-}
-
-
-static QMatrix createScaleMatrix(int dx, int dy) {
-	QMatrix matrix;
-	matrix.scale(dx, dy);
-	return matrix;
-}
-
-
+JpegContent::JpegContent()
+{
+    d = new JpegContent::Private();
+}
+
+JpegContent::~JpegContent()
+{
+    delete d;
+}
+
+bool JpegContent::load(const QString& path)
+{
+    QFile file(path);
+    if (!file.open(QIODevice::ReadOnly)) {
+        kError() << "Could not open '" << path << "' for reading\n";
+        return false;
+    }
+    return loadFromData(file.readAll());
+}
+
+bool JpegContent::loadFromData(const QByteArray& data)
+{
+    Exiv2::Image::AutoPtr image;
+    Exiv2ImageLoader loader;
+    if (!loader.load(data)) {
+        kError() << "Could not load image with Exiv2, reported error:" << loader.errorMessage();
+    }
+    image = loader.popImage();
+
+    return loadFromData(data, image.get());
+}
+
+bool JpegContent::loadFromData(const QByteArray& data, Exiv2::Image* exiv2Image)
+{
+    d->mPendingTransformation = false;
+    d->mTransformMatrix.reset();
+
+    d->mRawData = data;
+    if (d->mRawData.size() == 0) {
+        kError() << "No data\n";
+        return false;
+    }
+
+    if (!d->readSize()) return false;
+
+    d->mExifData = exiv2Image->exifData();
+    d->mComment = QString::fromUtf8(exiv2Image->comment().c_str());
+
+    // Adjust the size according to the orientation
+    switch (orientation()) {
+    case TRANSPOSE:
+    case ROT_90:
+    case TRANSVERSE:
+    case ROT_270:
+        d->mSize.transpose();
+        break;
+    default:
+        break;
+    }
+
+    return true;
+}
+
+QByteArray JpegContent::rawData() const
+{
+    return d->mRawData;
+}
+
+Orientation JpegContent::orientation() const
+{
+    Exiv2::ExifKey key("Exif.Image.Orientation");
+    Exiv2::ExifData::iterator it = d->mExifData.findKey(key);
+    if (it == d->mExifData.end()) {
+        return NOT_AVAILABLE;
+    }
+    return Orientation(it->toLong());
+}
+
+int JpegContent::dotsPerMeterX() const
+{
+    return dotsPerMeter("XResolution");
+}
+
+int JpegContent::dotsPerMeterY() const
+{
+    return dotsPerMeter("YResolution");
+}
+
+int JpegContent::dotsPerMeter(const QString& keyName) const
+{
+    Exiv2::ExifKey keyResUnit("Exif.Image.ResolutionUnit");
+    Exiv2::ExifData::iterator it = d->mExifData.findKey(keyResUnit);
+    if (it == d->mExifData.end()) {
+        return 0;
+    }
+    int res = it->toLong();
+    QString keyVal = "Exif.Image." + keyName;
+    Exiv2::ExifKey keyResolution(keyVal.toAscii().data());
+    it = d->mExifData.findKey(keyResolution);
+    if (it == d->mExifData.end()) {
+        return 0;
+    }
+    // The unit for measuring XResolution and YResolution. The same unit is used for both XResolution and YResolution.
+    //     If the image resolution in unknown, 2 (inches) is designated.
+    //         Default = 2
+    //         2 = inches
+    //         3 = centimeters
+    //         Other = reserved
+    const float INCHESPERMETER = (100. / 2.54);
+    switch (res) {
+    case 3:  // dots per cm
+        return int(it->toLong() * 100);
+    default:  // dots per inch
+        return int(it->toLong() * INCHESPERMETER);
+    }
+
+    return 0;
+}
+
+void JpegContent::resetOrientation()
+{
+    Exiv2::ExifKey key("Exif.Image.Orientation");
+    Exiv2::ExifData::iterator it = d->mExifData.findKey(key);
+    if (it == d->mExifData.end()) {
+        return;
+    }
+
+    *it = uint16_t(NORMAL);
+}
+
+QSize JpegContent::size() const
+{
+    return d->mSize;
+}
+
+QString JpegContent::comment() const
+{
+    return d->mComment;
+}
+
+void JpegContent::setComment(const QString& comment)
+{
+    d->mComment = comment;
+}
+
+static QMatrix createRotMatrix(int angle)
+{
+    QMatrix matrix;
+    matrix.rotate(angle);
+    return matrix;
+}
+
+static QMatrix createScaleMatrix(int dx, int dy)
+{
+    QMatrix matrix;
+    matrix.scale(dx, dy);
+    return matrix;
+}
 
 struct OrientationInfo {
-	OrientationInfo() {}
-	OrientationInfo(Orientation o, QMatrix m, JXFORM_CODE j)
-	: orientation(o), matrix(m), jxform(j) {}
+    OrientationInfo() {}
+    OrientationInfo(Orientation o, QMatrix m, JXFORM_CODE j)
+        : orientation(o), matrix(m), jxform(j) {}
 
-	Orientation orientation;
-	QMatrix matrix;
-	JXFORM_CODE jxform;
+    Orientation orientation;
+    QMatrix matrix;
+    JXFORM_CODE jxform;
 };
 typedef QList<OrientationInfo> OrientationInfoList;
 
-static const OrientationInfoList& orientationInfoList() {
-	static OrientationInfoList list;
-	if (list.size() == 0) {
-		QMatrix rot90 = createRotMatrix(90);
-		QMatrix hflip = createScaleMatrix(-1, 1);
-		QMatrix vflip = createScaleMatrix(1, -1);
-
-		list
-			<< OrientationInfo(NOT_AVAILABLE, QMatrix(), JXFORM_NONE)
-			<< OrientationInfo(NORMAL, QMatrix(), JXFORM_NONE)
-			<< OrientationInfo(HFLIP, hflip, JXFORM_FLIP_H)
-			<< OrientationInfo(ROT_180, createRotMatrix(180), JXFORM_ROT_180)
-			<< OrientationInfo(VFLIP, vflip, JXFORM_FLIP_V)
-			<< OrientationInfo(TRANSPOSE, hflip * rot90, JXFORM_TRANSPOSE)
-			<< OrientationInfo(ROT_90, rot90, JXFORM_ROT_90)
-			<< OrientationInfo(TRANSVERSE, vflip * rot90, JXFORM_TRANSVERSE)
-			<< OrientationInfo(ROT_270, createRotMatrix(270), JXFORM_ROT_270)
-			;
-	}
-	return list;
-}
-
-
-void JpegContent::transform(Orientation orientation) {
-	if (orientation != NOT_AVAILABLE && orientation != NORMAL) {
-		d->mPendingTransformation = true;
-		OrientationInfoList::ConstIterator it(orientationInfoList().begin()), end(orientationInfoList().end());
-		for (; it!=end; ++it) {
-			if ( (*it).orientation == orientation ) {
-				d->mTransformMatrix = (*it).matrix * d->mTransformMatrix;
-				break;
-			}
-		}
-		if (it == end) {
-			kWarning() << "Could not find matrix for orientation\n";
-		}
-	}
-}
-
+static const OrientationInfoList& orientationInfoList()
+{
+    static OrientationInfoList list;
+    if (list.size() == 0) {
+        QMatrix rot90 = createRotMatrix(90);
+        QMatrix hflip = createScaleMatrix(-1, 1);
+        QMatrix vflip = createScaleMatrix(1, -1);
+
+        list
+                << OrientationInfo(NOT_AVAILABLE, QMatrix(), JXFORM_NONE)
+                << OrientationInfo(NORMAL, QMatrix(), JXFORM_NONE)
+                << OrientationInfo(HFLIP, hflip, JXFORM_FLIP_H)
+                << OrientationInfo(ROT_180, createRotMatrix(180), JXFORM_ROT_180)
+                << OrientationInfo(VFLIP, vflip, JXFORM_FLIP_V)
+                << OrientationInfo(TRANSPOSE, hflip * rot90, JXFORM_TRANSPOSE)
+                << OrientationInfo(ROT_90, rot90, JXFORM_ROT_90)
+                << OrientationInfo(TRANSVERSE, vflip * rot90, JXFORM_TRANSVERSE)
+                << OrientationInfo(ROT_270, createRotMatrix(270), JXFORM_ROT_270)
+                ;
+    }
+    return list;
+}
+
+void JpegContent::transform(Orientation orientation)
+{
+    if (orientation != NOT_AVAILABLE && orientation != NORMAL) {
+        d->mPendingTransformation = true;
+        OrientationInfoList::ConstIterator it(orientationInfoList().begin()), end(orientationInfoList().end());
+        for (; it != end; ++it) {
+            if ((*it).orientation == orientation) {
+                d->mTransformMatrix = (*it).matrix * d->mTransformMatrix;
+                break;
+            }
+        }
+        if (it == end) {
+            kWarning() << "Could not find matrix for orientation\n";
+        }
+    }
+}
 
 #if 0
-static void dumpMatrix(const QMatrix& matrix) {
-	kDebug() << "matrix | " << matrix.m11() << ", " << matrix.m12() << " |\n";
-	kDebug() << "       | " << matrix.m21() << ", " << matrix.m22() << " |\n";
-	kDebug() << "       ( " << matrix.dx()  << ", " << matrix.dy()  << " )\n";
+static void dumpMatrix(const QMatrix& matrix)
+{
+    kDebug() << "matrix | " << matrix.m11() << ", " << matrix.m12() << " |\n";
+    kDebug() << "       | " << matrix.m21() << ", " << matrix.m22() << " |\n";
+    kDebug() << "       ( " << matrix.dx()  << ", " << matrix.dy()  << " )\n";
 }
 #endif
 
-
-static bool matricesAreSame(const QMatrix& m1, const QMatrix& m2, double tolerance) {
-	return fabs( m1.m11() - m2.m11() ) < tolerance
-		&& fabs( m1.m12() - m2.m12() ) < tolerance
-		&& fabs( m1.m21() - m2.m21() ) < tolerance
-		&& fabs( m1.m22() - m2.m22() ) < tolerance
-		&& fabs( m1.dx()  - m2.dx()  ) < tolerance
-		&& fabs( m1.dy()  - m2.dy()  ) < tolerance;
-}
-
-
-static JXFORM_CODE findJxform(const QMatrix& matrix) {
-	OrientationInfoList::ConstIterator it(orientationInfoList().begin()), end(orientationInfoList().end());
-	for (; it!=end; ++it) {
-		if ( matricesAreSame( (*it).matrix, matrix, 0.001) ) {
-			return (*it).jxform;
-		}
-	}
-	kWarning() << "findJxform: failed\n";
-	return JXFORM_NONE;
-}
-
-
-void JpegContent::applyPendingTransformation() {
-	if (d->mRawData.size()==0) {
-		kError() << "No data loaded\n";
-		return;
-	}
-
-	// The following code is inspired by jpegtran.c from the libjpeg
-
-	// Init JPEG structs 
-	struct jpeg_decompress_struct srcinfo;
-	struct jpeg_compress_struct dstinfo;
-	jvirt_barray_ptr * src_coef_arrays;
-	jvirt_barray_ptr * dst_coef_arrays;
-
-	// Initialize the JPEG decompression object
-	JPEGErrorManager srcErrorManager;
-	srcinfo.err = &srcErrorManager;
-	jpeg_create_decompress(&srcinfo);
-	if (setjmp(srcErrorManager.jmp_buffer)) {
-		kError() << "libjpeg error in src\n";
-		return;
-	}
-
-	// Initialize the JPEG compression object
-	JPEGErrorManager dstErrorManager;
-	dstinfo.err = &dstErrorManager;
-	jpeg_create_compress(&dstinfo);
-	if (setjmp(dstErrorManager.jmp_buffer)) {
-		kError() << "libjpeg error in dst\n";
-		return;
-	}
-
-	// Specify data source for decompression
-	QBuffer buffer(&d->mRawData);
-	buffer.open(QIODevice::ReadOnly);
-	IODeviceJpegSourceManager::setup(&srcinfo, &buffer);
-
-	// Enable saving of extra markers that we want to copy
-	jcopy_markers_setup(&srcinfo, JCOPYOPT_ALL);
-
-	(void) jpeg_read_header(&srcinfo, true);
-
-	// Init transformation
-	jpeg_transform_info transformoption;
-	memset(&transformoption, 0, sizeof(jpeg_transform_info));
-	transformoption.transform = findJxform(d->mTransformMatrix);
-	jtransform_request_workspace(&srcinfo, &transformoption);
-
-	/* Read source file as DCT coefficients */
-	src_coef_arrays = jpeg_read_coefficients(&srcinfo);
-
-	/* Initialize destination compression parameters from source values */
-	jpeg_copy_critical_parameters(&srcinfo, &dstinfo);
-
-	/* Adjust destination parameters if required by transform options;
-	* also find out which set of coefficient arrays will hold the output.
-	*/
-	dst_coef_arrays = jtransform_adjust_parameters(&srcinfo, &dstinfo,
-		src_coef_arrays,
-		&transformoption);
-
-	/* Specify data destination for compression */
-	QByteArray output;
-	output.resize(d->mRawData.size());
-	d->setupInmemDestination(&dstinfo, &output);
-
-	/* Start compressor (note no image data is actually written here) */
-	jpeg_write_coefficients(&dstinfo, dst_coef_arrays);
-	
-	/* Copy to the output file any extra markers that we want to preserve */
-	jcopy_markers_execute(&srcinfo, &dstinfo, JCOPYOPT_ALL);
-
-	/* Execute image transformation, if any */
-	jtransform_execute_transformation(&srcinfo, &dstinfo,
-		src_coef_arrays,
-		&transformoption);
-
-	/* Finish compression and release memory */
-	jpeg_finish_compress(&dstinfo);
-	jpeg_destroy_compress(&dstinfo);
-	(void) jpeg_finish_decompress(&srcinfo);
-	jpeg_destroy_decompress(&srcinfo);
-
-	// Set rawData to our new JPEG 
-	d->mRawData = output;
-}
-
-
-QImage JpegContent::thumbnail() const {
-	QImage image;
-	if (!d->mExifData.empty()) {
+static bool matricesAreSame(const QMatrix& m1, const QMatrix& m2, double tolerance)
+{
+    return fabs(m1.m11() - m2.m11()) < tolerance
+           && fabs(m1.m12() - m2.m12()) < tolerance
+           && fabs(m1.m21() - m2.m21()) < tolerance
+           && fabs(m1.m22() - m2.m22()) < tolerance
+           && fabs(m1.dx()  - m2.dx()) < tolerance
+           && fabs(m1.dy()  - m2.dy()) < tolerance;
+}
+
+static JXFORM_CODE findJxform(const QMatrix& matrix)
+{
+    OrientationInfoList::ConstIterator it(orientationInfoList().begin()), end(orientationInfoList().end());
+    for (; it != end; ++it) {
+        if (matricesAreSame((*it).matrix, matrix, 0.001)) {
+            return (*it).jxform;
+        }
+    }
+    kWarning() << "findJxform: failed\n";
+    return JXFORM_NONE;
+}
+
+void JpegContent::applyPendingTransformation()
+{
+    if (d->mRawData.size() == 0) {
+        kError() << "No data loaded\n";
+        return;
+    }
+
+    // The following code is inspired by jpegtran.c from the libjpeg
+
+    // Init JPEG structs
+    struct jpeg_decompress_struct srcinfo;
+    struct jpeg_compress_struct dstinfo;
+    jvirt_barray_ptr * src_coef_arrays;
+    jvirt_barray_ptr * dst_coef_arrays;
+
+    // Initialize the JPEG decompression object
+    JPEGErrorManager srcErrorManager;
+    srcinfo.err = &srcErrorManager;
+    jpeg_create_decompress(&srcinfo);
+    if (setjmp(srcErrorManager.jmp_buffer)) {
+        kError() << "libjpeg error in src\n";
+        return;
+    }
+
+    // Initialize the JPEG compression object
+    JPEGErrorManager dstErrorManager;
+    dstinfo.err = &dstErrorManager;
+    jpeg_create_compress(&dstinfo);
+    if (setjmp(dstErrorManager.jmp_buffer)) {
+        kError() << "libjpeg error in dst\n";
+        return;
+    }
+
+    // Specify data source for decompression
+    QBuffer buffer(&d->mRawData);
+    buffer.open(QIODevice::ReadOnly);
+    IODeviceJpegSourceManager::setup(&srcinfo, &buffer);
+
+    // Enable saving of extra markers that we want to copy
+    jcopy_markers_setup(&srcinfo, JCOPYOPT_ALL);
+
+    (void) jpeg_read_header(&srcinfo, true);
+
+    // Init transformation
+    jpeg_transform_info transformoption;
+    memset(&transformoption, 0, sizeof(jpeg_transform_info));
+    transformoption.transform = findJxform(d->mTransformMatrix);
+    jtransform_request_workspace(&srcinfo, &transformoption);
+
+    /* Read source file as DCT coefficients */
+    src_coef_arrays = jpeg_read_coefficients(&srcinfo);
+
+    /* Initialize destination compression parameters from source values */
+    jpeg_copy_critical_parameters(&srcinfo, &dstinfo);
+
+    /* Adjust destination parameters if required by transform options;
+    * also find out which set of coefficient arrays will hold the output.
+    */
+    dst_coef_arrays = jtransform_adjust_parameters(&srcinfo, &dstinfo,
+                      src_coef_arrays,
+                      &transformoption);
+
+    /* Specify data destination for compression */
+    QByteArray output;
+    output.resize(d->mRawData.size());
+    d->setupInmemDestination(&dstinfo, &output);
+
+    /* Start compressor (note no image data is actually written here) */
+    jpeg_write_coefficients(&dstinfo, dst_coef_arrays);
+
+    /* Copy to the output file any extra markers that we want to preserve */
+    jcopy_markers_execute(&srcinfo, &dstinfo, JCOPYOPT_ALL);
+
+    /* Execute image transformation, if any */
+    jtransform_execute_transformation(&srcinfo, &dstinfo,
+                                      src_coef_arrays,
+                                      &transformoption);
+
+    /* Finish compression and release memory */
+    jpeg_finish_compress(&dstinfo);
+    jpeg_destroy_compress(&dstinfo);
+    (void) jpeg_finish_decompress(&srcinfo);
+    jpeg_destroy_decompress(&srcinfo);
+
+    // Set rawData to our new JPEG
+    d->mRawData = output;
+}
+
+QImage JpegContent::thumbnail() const
+{
+    QImage image;
+    if (!d->mExifData.empty()) {
 #if(EXIV2_TEST_VERSION(0,17,91))
         Exiv2::ExifThumbC thumb(d->mExifData);
         Exiv2::DataBuf thumbnail = thumb.copy();
 #else
-		Exiv2::DataBuf thumbnail = d->mExifData.copyThumbnail();
+        Exiv2::DataBuf thumbnail = d->mExifData.copyThumbnail();
 #endif
-		image.loadFromData(thumbnail.pData_, thumbnail.size_);
-	}
-	return image;
+        image.loadFromData(thumbnail.pData_, thumbnail.size_);
+    }
+    return image;
 }
 
-
-void JpegContent::setThumbnail(const QImage& thumbnail) {
-	if (d->mExifData.empty()) {
-		return;
-	}
-	
-	QByteArray array;
-	QBuffer buffer(&array);
-	buffer.open(QIODevice::WriteOnly);
-	QImageWriter writer(&buffer, "JPEG");
-	if (!writer.write(thumbnail)) {
-		kError() << "Could not write thumbnail\n";
-		return;
-	}
-	
+void JpegContent::setThumbnail(const QImage& thumbnail)
+{
+    if (d->mExifData.empty()) {
+        return;
+    }
+
+    QByteArray array;
+    QBuffer buffer(&array);
+    buffer.open(QIODevice::WriteOnly);
+    QImageWriter writer(&buffer, "JPEG");
+    if (!writer.write(thumbnail)) {
+        kError() << "Could not write thumbnail\n";
+        return;
+    }
+
 #if (EXIV2_TEST_VERSION(0,17,91))
     Exiv2::ExifThumb thumb(d->mExifData);
     thumb.setJpegThumbnail((unsigned char*)array.data(), array.size());
 #else
-	d->mExifData.setJpegThumbnail((unsigned char*)array.data(), array.size());
+    d->mExifData.setJpegThumbnail((unsigned char*)array.data(), array.size());
 #endif
 }
 
-
-bool JpegContent::save(const QString& path) {
-	QFile file(path);
-	if (!file.open(QIODevice::WriteOnly)) {
-		d->mErrorString = i18nc("@info", "Could not open file for writing.");
-		return false;
-	}
-
-	return save(&file);
-}
-
-
-bool JpegContent::save(QIODevice* device) {
-	if (!d->mImage.isNull()) {
-		if (!d->updateRawDataFromImage()) {
-			return false;
-		}
-	}
-
-	if (d->mRawData.size()==0) {
-		d->mErrorString = i18nc("@info", "No data to store.");
-		return false;
-	}
-
-	if (d->mPendingTransformation) {
-		applyPendingTransformation();
-		d->mPendingTransformation = false;
-	}
-
-	Exiv2::Image::AutoPtr image = Exiv2::ImageFactory::open((unsigned char*)d->mRawData.data(), d->mRawData.size());
-
-	// Store Exif info
-	image->setExifData(d->mExifData);
-	image->setComment(d->mComment.toUtf8().data());
-	image->writeMetadata();
-	
-	// Update mRawData
-	Exiv2::BasicIo& io = image->io();
-	d->mRawData.resize(io.size());
-	io.read((unsigned char*)d->mRawData.data(), io.size());
-	
-	QDataStream stream(device);
-	stream.writeRawData(d->mRawData.data(), d->mRawData.size());
-
-	// Make sure we are up to date
-	loadFromData(d->mRawData);
-	return true;
-}
-
-
-QString JpegContent::errorString() const {
-	return d->mErrorString;
-}
-
-
-void JpegContent::setImage(const QImage& image) {
-	d->mRawData.clear();
-	d->mImage = image;
-	d->mSize = image.size();
-	d->mExifData["Exif.Photo.PixelXDimension"] = image.width();
-	d->mExifData["Exif.Photo.PixelYDimension"] = image.height();
-	resetOrientation();
-
-	d->mPendingTransformation = false;
-	d->mTransformMatrix = QMatrix();
-}
-
+bool JpegContent::save(const QString& path)
+{
+    QFile file(path);
+    if (!file.open(QIODevice::WriteOnly)) {
+        d->mErrorString = i18nc("@info", "Could not open file for writing.");
+        return false;
+    }
+
+    return save(&file);
+}
+
+bool JpegContent::save(QIODevice* device)
+{
+    if (!d->mImage.isNull()) {
+        if (!d->updateRawDataFromImage()) {
+            return false;
+        }
+    }
+
+    if (d->mRawData.size() == 0) {
+        d->mErrorString = i18nc("@info", "No data to store.");
+        return false;
+    }
+
+    if (d->mPendingTransformation) {
+        applyPendingTransformation();
+        d->mPendingTransformation = false;
+    }
+
+    Exiv2::Image::AutoPtr image = Exiv2::ImageFactory::open((unsigned char*)d->mRawData.data(), d->mRawData.size());
+
+    // Store Exif info
+    image->setExifData(d->mExifData);
+    image->setComment(d->mComment.toUtf8().data());
+    image->writeMetadata();
+
+    // Update mRawData
+    Exiv2::BasicIo& io = image->io();
+    d->mRawData.resize(io.size());
+    io.read((unsigned char*)d->mRawData.data(), io.size());
+
+    QDataStream stream(device);
+    stream.writeRawData(d->mRawData.data(), d->mRawData.size());
+
+    // Make sure we are up to date
+    loadFromData(d->mRawData);
+    return true;
+}
+
+QString JpegContent::errorString() const
+{
+    return d->mErrorString;
+}
+
+void JpegContent::setImage(const QImage& image)
+{
+    d->mRawData.clear();
+    d->mImage = image;
+    d->mSize = image.size();
+    d->mExifData["Exif.Photo.PixelXDimension"] = image.width();
+    d->mExifData["Exif.Photo.PixelYDimension"] = image.height();
+    resetOrientation();
+
+    d->mPendingTransformation = false;
+    d->mTransformMatrix = QMatrix();
+}
 
 } // namespace

=== modified file 'lib/jpegcontent.h'
--- lib/jpegcontent.h	2011-07-20 13:46:34 +0000
+++ lib/jpegcontent.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab
+// vim: set tabstop=4 shiftwidth=4 expandtab
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -30,61 +30,63 @@
 class QString;
 class QIODevice;
 
-namespace Exiv2 { class Image; }
-
-namespace Gwenview {
-
-
-class GWENVIEWLIB_EXPORT JpegContent {
+namespace Exiv2
+{
+class Image;
+}
+
+namespace Gwenview
+{
+
+class GWENVIEWLIB_EXPORT JpegContent
+{
 public:
-	JpegContent();
-	~JpegContent();
-	
-	Orientation orientation() const;
-	void resetOrientation();
-
-	int dotsPerMeterX() const;
-	int dotsPerMeterY() const;
-
-	QSize size() const;
-
-	QString comment() const;
-	void setComment(const QString&);
-	
-	void transform(Orientation);
-
-	QImage thumbnail() const;
-	void setThumbnail(const QImage&);
-
-	// Recreate raw data to represent image
-	// Note: thumbnail must be updated separately
-	void setImage(const QImage& image);
-
-	bool load(const QString& file);
-	bool loadFromData(const QByteArray& rawData);
-	/**
-	 * Use this version of loadFromData if you already have an Exiv2::Image*
-	 */
-	bool loadFromData(const QByteArray& rawData, Exiv2::Image*);
-	bool save(const QString& file);
-	bool save(QIODevice*);
-
-	QByteArray rawData() const;
-
-	QString errorString() const;
+    JpegContent();
+    ~JpegContent();
+
+    Orientation orientation() const;
+    void resetOrientation();
+
+    int dotsPerMeterX() const;
+    int dotsPerMeterY() const;
+
+    QSize size() const;
+
+    QString comment() const;
+    void setComment(const QString&);
+
+    void transform(Orientation);
+
+    QImage thumbnail() const;
+    void setThumbnail(const QImage&);
+
+    // Recreate raw data to represent image
+    // Note: thumbnail must be updated separately
+    void setImage(const QImage& image);
+
+    bool load(const QString& file);
+    bool loadFromData(const QByteArray& rawData);
+    /**
+     * Use this version of loadFromData if you already have an Exiv2::Image*
+     */
+    bool loadFromData(const QByteArray& rawData, Exiv2::Image*);
+    bool save(const QString& file);
+    bool save(QIODevice*);
+
+    QByteArray rawData() const;
+
+    QString errorString() const;
 
 private:
-	struct Private;
-	Private *d;
+    struct Private;
+    Private *d;
 
-	JpegContent(const JpegContent&);
-	void operator=(const JpegContent&);
-	void applyPendingTransformation();
-	int dotsPerMeter(const QString& keyName) const;
+    JpegContent(const JpegContent&);
+    void operator=(const JpegContent&);
+    void applyPendingTransformation();
+    int dotsPerMeter(const QString& keyName) const;
 };
 
-
 } // namespace
 
-
 #endif /* JPEGCONTENT_H */

=== modified file 'lib/jpegerrormanager.h'
--- lib/jpegerrormanager.h	2011-07-20 13:46:34 +0000
+++ lib/jpegerrormanager.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab
+// vim: set tabstop=4 shiftwidth=4 expandtab
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -29,7 +29,8 @@
 #undef const
 }
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * A simple error manager which overrides jpeg_error_mgr.error_exit to avoid
@@ -40,20 +41,20 @@
  * then call setjmp(errorManager.jmp_buffer)
  */
 struct JPEGErrorManager : public jpeg_error_mgr {
-	JPEGErrorManager() : jpeg_error_mgr() {
-		jpeg_std_error(this);
-		error_exit=errorExitCallBack;
-	}
-
-	jmp_buf jmp_buffer;
-
-	static void errorExitCallBack (j_common_ptr cinfo) {
-		JPEGErrorManager* myerr = static_cast<JPEGErrorManager*>(cinfo->err);
-		char buffer[JMSG_LENGTH_MAX];
-		(*cinfo->err->format_message)(cinfo, buffer);
-		kWarning() << buffer ;
-		longjmp(myerr->jmp_buffer, 1);
-	}
+    JPEGErrorManager() : jpeg_error_mgr() {
+        jpeg_std_error(this);
+        error_exit = errorExitCallBack;
+    }
+
+    jmp_buf jmp_buffer;
+
+    static void errorExitCallBack(j_common_ptr cinfo) {
+        JPEGErrorManager* myerr = static_cast<JPEGErrorManager*>(cinfo->err);
+        char buffer[JMSG_LENGTH_MAX];
+        (*cinfo->err->format_message)(cinfo, buffer);
+        kWarning() << buffer ;
+        longjmp(myerr->jmp_buffer, 1);
+    }
 };
 
 } // namespace

=== modified file 'lib/libjpeg-62/jinclude.h'
--- lib/libjpeg-62/jinclude.h	2011-07-20 13:46:34 +0000
+++ lib/libjpeg-62/jinclude.h	2011-12-15 14:17:54 +0000
@@ -14,11 +14,10 @@
  * JPEG library.  Most applications need only include jpeglib.h.
  */
 
-
 /* Include auto-config file to find out which system include files we need. */
 
-#include "jconfig.h"		/* auto configuration options */
-#define JCONFIG_INCLUDED	/* so that jpeglib.h doesn't do it again */
+#include "jconfig.h"        /* auto configuration options */
+#define JCONFIG_INCLUDED    /* so that jpeglib.h doesn't do it again */
 
 /*
  * We need the NULL macro and size_t typedef.
@@ -58,14 +57,14 @@
 #ifdef NEED_BSD_STRINGS
 
 #include <strings.h>
-#define MEMZERO(target,size)	bzero((void *)(target), (size_t)(size))
-#define MEMCOPY(dest,src,size)	bcopy((const void *)(src), (void *)(dest), (size_t)(size))
+#define MEMZERO(target,size)    bzero((void *)(target), (size_t)(size))
+#define MEMCOPY(dest,src,size)  bcopy((const void *)(src), (void *)(dest), (size_t)(size))
 
 #else /* not BSD, assume ANSI/SysV string lib */
 
 #include <string.h>
-#define MEMZERO(target,size)	memset((void *)(target), 0, (size_t)(size))
-#define MEMCOPY(dest,src,size)	memcpy((void *)(dest), (const void *)(src), (size_t)(size))
+#define MEMZERO(target,size)    memset((void *)(target), 0, (size_t)(size))
+#define MEMCOPY(dest,src,size)  memcpy((void *)(dest), (const void *)(src), (size_t)(size))
 
 #endif
 
@@ -77,7 +76,7 @@
  * we always use this SIZEOF() macro in place of using sizeof() directly.
  */
 
-#define SIZEOF(object)	((size_t) sizeof(object))
+#define SIZEOF(object)  ((size_t) sizeof(object))
 
 /*
  * The modules that use fread() and fwrite() always invoke them through
@@ -86,6 +85,6 @@
  */
 
 #define JFREAD(file,buf,sizeofbuf)  \
-  ((size_t) fread((void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))
+    ((size_t) fread((void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))
 #define JFWRITE(file,buf,sizeofbuf)  \
-  ((size_t) fwrite((const void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))
+    ((size_t) fwrite((const void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))

=== modified file 'lib/libjpeg-62/jpegint.h'
--- lib/libjpeg-62/jpegint.h	2011-07-20 13:46:34 +0000
+++ lib/libjpeg-62/jpegint.h	2011-12-15 14:17:54 +0000
@@ -10,264 +10,259 @@
  * applications using the library shouldn't need to include this file.
  */
 
-
 /* Declarations for both compression & decompression */
 
-typedef enum {			/* Operating modes for buffer controllers */
-	JBUF_PASS_THRU,		/* Plain stripwise operation */
-	/* Remaining modes require a full-image buffer to have been created */
-	JBUF_SAVE_SOURCE,	/* Run source subobject only, save output */
-	JBUF_CRANK_DEST,	/* Run dest subobject only, using saved data */
-	JBUF_SAVE_AND_PASS	/* Run both subobjects, save output */
+typedef enum {          /* Operating modes for buffer controllers */
+    JBUF_PASS_THRU,     /* Plain stripwise operation */
+    /* Remaining modes require a full-image buffer to have been created */
+    JBUF_SAVE_SOURCE,   /* Run source subobject only, save output */
+    JBUF_CRANK_DEST,    /* Run dest subobject only, using saved data */
+    JBUF_SAVE_AND_PASS  /* Run both subobjects, save output */
 } J_BUF_MODE;
 
 /* Values of global_state field (jdapi.c has some dependencies on ordering!) */
-#define CSTATE_START	100	/* after create_compress */
-#define CSTATE_SCANNING	101	/* start_compress done, write_scanlines OK */
-#define CSTATE_RAW_OK	102	/* start_compress done, write_raw_data OK */
-#define CSTATE_WRCOEFS	103	/* jpeg_write_coefficients done */
-#define DSTATE_START	200	/* after create_decompress */
-#define DSTATE_INHEADER	201	/* reading header markers, no SOS yet */
-#define DSTATE_READY	202	/* found SOS, ready for start_decompress */
-#define DSTATE_PRELOAD	203	/* reading multiscan file in start_decompress*/
-#define DSTATE_PRESCAN	204	/* performing dummy pass for 2-pass quant */
-#define DSTATE_SCANNING	205	/* start_decompress done, read_scanlines OK */
-#define DSTATE_RAW_OK	206	/* start_decompress done, read_raw_data OK */
-#define DSTATE_BUFIMAGE	207	/* expecting jpeg_start_output */
-#define DSTATE_BUFPOST	208	/* looking for SOS/EOI in jpeg_finish_output */
-#define DSTATE_RDCOEFS	209	/* reading file in jpeg_read_coefficients */
-#define DSTATE_STOPPING	210	/* looking for EOI in jpeg_finish_decompress */
-
+#define CSTATE_START    100 /* after create_compress */
+#define CSTATE_SCANNING 101 /* start_compress done, write_scanlines OK */
+#define CSTATE_RAW_OK   102 /* start_compress done, write_raw_data OK */
+#define CSTATE_WRCOEFS  103 /* jpeg_write_coefficients done */
+#define DSTATE_START    200 /* after create_decompress */
+#define DSTATE_INHEADER 201 /* reading header markers, no SOS yet */
+#define DSTATE_READY    202 /* found SOS, ready for start_decompress */
+#define DSTATE_PRELOAD  203 /* reading multiscan file in start_decompress*/
+#define DSTATE_PRESCAN  204 /* performing dummy pass for 2-pass quant */
+#define DSTATE_SCANNING 205 /* start_decompress done, read_scanlines OK */
+#define DSTATE_RAW_OK   206 /* start_decompress done, read_raw_data OK */
+#define DSTATE_BUFIMAGE 207 /* expecting jpeg_start_output */
+#define DSTATE_BUFPOST  208 /* looking for SOS/EOI in jpeg_finish_output */
+#define DSTATE_RDCOEFS  209 /* reading file in jpeg_read_coefficients */
+#define DSTATE_STOPPING 210 /* looking for EOI in jpeg_finish_decompress */
 
 /* Declarations for compression modules */
 
 /* Master control module */
 struct jpeg_comp_master {
-  JMETHOD(void, prepare_for_pass, (j_compress_ptr cinfo));
-  JMETHOD(void, pass_startup, (j_compress_ptr cinfo));
-  JMETHOD(void, finish_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, prepare_for_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, pass_startup, (j_compress_ptr cinfo));
+    JMETHOD(void, finish_pass, (j_compress_ptr cinfo));
 
-  /* State variables made visible to other modules */
-  boolean call_pass_startup;	/* True if pass_startup must be called */
-  boolean is_last_pass;		/* True during last pass */
+    /* State variables made visible to other modules */
+    boolean call_pass_startup;    /* True if pass_startup must be called */
+    boolean is_last_pass;     /* True during last pass */
 };
 
 /* Main buffer control (downsampled-data buffer) */
 struct jpeg_c_main_controller {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(void, process_data, (j_compress_ptr cinfo,
-			       JSAMPARRAY input_buf, JDIMENSION *in_row_ctr,
-			       JDIMENSION in_rows_avail));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(void, process_data, (j_compress_ptr cinfo,
+                                 JSAMPARRAY input_buf, JDIMENSION *in_row_ctr,
+                                 JDIMENSION in_rows_avail));
 };
 
 /* Compression preprocessing (downsampling input buffer control) */
 struct jpeg_c_prep_controller {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(void, pre_process_data, (j_compress_ptr cinfo,
-				   JSAMPARRAY input_buf,
-				   JDIMENSION *in_row_ctr,
-				   JDIMENSION in_rows_avail,
-				   JSAMPIMAGE output_buf,
-				   JDIMENSION *out_row_group_ctr,
-				   JDIMENSION out_row_groups_avail));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(void, pre_process_data, (j_compress_ptr cinfo,
+                                     JSAMPARRAY input_buf,
+                                     JDIMENSION *in_row_ctr,
+                                     JDIMENSION in_rows_avail,
+                                     JSAMPIMAGE output_buf,
+                                     JDIMENSION *out_row_group_ctr,
+                                     JDIMENSION out_row_groups_avail));
 };
 
 /* Coefficient buffer control */
 struct jpeg_c_coef_controller {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(boolean, compress_data, (j_compress_ptr cinfo,
-				   JSAMPIMAGE input_buf));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(boolean, compress_data, (j_compress_ptr cinfo,
+                                     JSAMPIMAGE input_buf));
 };
 
 /* Colorspace conversion */
 struct jpeg_color_converter {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo));
-  JMETHOD(void, color_convert, (j_compress_ptr cinfo,
-				JSAMPARRAY input_buf, JSAMPIMAGE output_buf,
-				JDIMENSION output_row, int num_rows));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, color_convert, (j_compress_ptr cinfo,
+                                  JSAMPARRAY input_buf, JSAMPIMAGE output_buf,
+                                  JDIMENSION output_row, int num_rows));
 };
 
 /* Downsampling */
 struct jpeg_downsampler {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo));
-  JMETHOD(void, downsample, (j_compress_ptr cinfo,
-			     JSAMPIMAGE input_buf, JDIMENSION in_row_index,
-			     JSAMPIMAGE output_buf,
-			     JDIMENSION out_row_group_index));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, downsample, (j_compress_ptr cinfo,
+                               JSAMPIMAGE input_buf, JDIMENSION in_row_index,
+                               JSAMPIMAGE output_buf,
+                               JDIMENSION out_row_group_index));
 
-  boolean need_context_rows;	/* TRUE if need rows above & below */
+    boolean need_context_rows;    /* TRUE if need rows above & below */
 };
 
 /* Forward DCT (also controls coefficient quantization) */
 struct jpeg_forward_dct {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo));
-  /* perhaps this should be an array??? */
-  JMETHOD(void, forward_DCT, (j_compress_ptr cinfo,
-			      jpeg_component_info * compptr,
-			      JSAMPARRAY sample_data, JBLOCKROW coef_blocks,
-			      JDIMENSION start_row, JDIMENSION start_col,
-			      JDIMENSION num_blocks));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo));
+    /* perhaps this should be an array??? */
+    JMETHOD(void, forward_DCT, (j_compress_ptr cinfo,
+                                jpeg_component_info * compptr,
+                                JSAMPARRAY sample_data, JBLOCKROW coef_blocks,
+                                JDIMENSION start_row, JDIMENSION start_col,
+                                JDIMENSION num_blocks));
 };
 
 /* Entropy encoding */
 struct jpeg_entropy_encoder {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo, boolean gather_statistics));
-  JMETHOD(boolean, encode_mcu, (j_compress_ptr cinfo, JBLOCKROW *MCU_data));
-  JMETHOD(void, finish_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo, boolean gather_statistics));
+    JMETHOD(boolean, encode_mcu, (j_compress_ptr cinfo, JBLOCKROW *MCU_data));
+    JMETHOD(void, finish_pass, (j_compress_ptr cinfo));
 };
 
 /* Marker writing */
 struct jpeg_marker_writer {
-  JMETHOD(void, write_file_header, (j_compress_ptr cinfo));
-  JMETHOD(void, write_frame_header, (j_compress_ptr cinfo));
-  JMETHOD(void, write_scan_header, (j_compress_ptr cinfo));
-  JMETHOD(void, write_file_trailer, (j_compress_ptr cinfo));
-  JMETHOD(void, write_tables_only, (j_compress_ptr cinfo));
-  /* These routines are exported to allow insertion of extra markers */
-  /* Probably only COM and APPn markers should be written this way */
-  JMETHOD(void, write_marker_header, (j_compress_ptr cinfo, int marker,
-				      unsigned int datalen));
-  JMETHOD(void, write_marker_byte, (j_compress_ptr cinfo, int val));
+    JMETHOD(void, write_file_header, (j_compress_ptr cinfo));
+    JMETHOD(void, write_frame_header, (j_compress_ptr cinfo));
+    JMETHOD(void, write_scan_header, (j_compress_ptr cinfo));
+    JMETHOD(void, write_file_trailer, (j_compress_ptr cinfo));
+    JMETHOD(void, write_tables_only, (j_compress_ptr cinfo));
+    /* These routines are exported to allow insertion of extra markers */
+    /* Probably only COM and APPn markers should be written this way */
+    JMETHOD(void, write_marker_header, (j_compress_ptr cinfo, int marker,
+                                        unsigned int datalen));
+    JMETHOD(void, write_marker_byte, (j_compress_ptr cinfo, int val));
 };
 
-
 /* Declarations for decompression modules */
 
 /* Master control module */
 struct jpeg_decomp_master {
-  JMETHOD(void, prepare_for_output_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, finish_output_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, prepare_for_output_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, finish_output_pass, (j_decompress_ptr cinfo));
 
-  /* State variables made visible to other modules */
-  boolean is_dummy_pass;	/* True during 1st pass for 2-pass quant */
+    /* State variables made visible to other modules */
+    boolean is_dummy_pass;    /* True during 1st pass for 2-pass quant */
 };
 
 /* Input control module */
 struct jpeg_input_controller {
-  JMETHOD(int, consume_input, (j_decompress_ptr cinfo));
-  JMETHOD(void, reset_input_controller, (j_decompress_ptr cinfo));
-  JMETHOD(void, start_input_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, finish_input_pass, (j_decompress_ptr cinfo));
+    JMETHOD(int, consume_input, (j_decompress_ptr cinfo));
+    JMETHOD(void, reset_input_controller, (j_decompress_ptr cinfo));
+    JMETHOD(void, start_input_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, finish_input_pass, (j_decompress_ptr cinfo));
 
-  /* State variables made visible to other modules */
-  boolean has_multiple_scans;	/* True if file has multiple scans */
-  boolean eoi_reached;		/* True when EOI has been consumed */
+    /* State variables made visible to other modules */
+    boolean has_multiple_scans;   /* True if file has multiple scans */
+    boolean eoi_reached;      /* True when EOI has been consumed */
 };
 
 /* Main buffer control (downsampled-data buffer) */
 struct jpeg_d_main_controller {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(void, process_data, (j_decompress_ptr cinfo,
-			       JSAMPARRAY output_buf, JDIMENSION *out_row_ctr,
-			       JDIMENSION out_rows_avail));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(void, process_data, (j_decompress_ptr cinfo,
+                                 JSAMPARRAY output_buf, JDIMENSION *out_row_ctr,
+                                 JDIMENSION out_rows_avail));
 };
 
 /* Coefficient buffer control */
 struct jpeg_d_coef_controller {
-  JMETHOD(void, start_input_pass, (j_decompress_ptr cinfo));
-  JMETHOD(int, consume_data, (j_decompress_ptr cinfo));
-  JMETHOD(void, start_output_pass, (j_decompress_ptr cinfo));
-  JMETHOD(int, decompress_data, (j_decompress_ptr cinfo,
-				 JSAMPIMAGE output_buf));
-  /* Pointer to array of coefficient virtual arrays, or NULL if none */
-  jvirt_barray_ptr *coef_arrays;
+    JMETHOD(void, start_input_pass, (j_decompress_ptr cinfo));
+    JMETHOD(int, consume_data, (j_decompress_ptr cinfo));
+    JMETHOD(void, start_output_pass, (j_decompress_ptr cinfo));
+    JMETHOD(int, decompress_data, (j_decompress_ptr cinfo,
+                                   JSAMPIMAGE output_buf));
+    /* Pointer to array of coefficient virtual arrays, or NULL if none */
+    jvirt_barray_ptr *coef_arrays;
 };
 
 /* Decompression postprocessing (color quantization buffer control) */
 struct jpeg_d_post_controller {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(void, post_process_data, (j_decompress_ptr cinfo,
-				    JSAMPIMAGE input_buf,
-				    JDIMENSION *in_row_group_ctr,
-				    JDIMENSION in_row_groups_avail,
-				    JSAMPARRAY output_buf,
-				    JDIMENSION *out_row_ctr,
-				    JDIMENSION out_rows_avail));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(void, post_process_data, (j_decompress_ptr cinfo,
+                                      JSAMPIMAGE input_buf,
+                                      JDIMENSION *in_row_group_ctr,
+                                      JDIMENSION in_row_groups_avail,
+                                      JSAMPARRAY output_buf,
+                                      JDIMENSION *out_row_ctr,
+                                      JDIMENSION out_rows_avail));
 };
 
 /* Marker reading & parsing */
 struct jpeg_marker_reader {
-  JMETHOD(void, reset_marker_reader, (j_decompress_ptr cinfo));
-  /* Read markers until SOS or EOI.
-   * Returns same codes as are defined for jpeg_consume_input:
-   * JPEG_SUSPENDED, JPEG_REACHED_SOS, or JPEG_REACHED_EOI.
-   */
-  JMETHOD(int, read_markers, (j_decompress_ptr cinfo));
-  /* Read a restart marker --- exported for use by entropy decoder only */
-  jpeg_marker_parser_method read_restart_marker;
+    JMETHOD(void, reset_marker_reader, (j_decompress_ptr cinfo));
+    /* Read markers until SOS or EOI.
+     * Returns same codes as are defined for jpeg_consume_input:
+     * JPEG_SUSPENDED, JPEG_REACHED_SOS, or JPEG_REACHED_EOI.
+     */
+    JMETHOD(int, read_markers, (j_decompress_ptr cinfo));
+    /* Read a restart marker --- exported for use by entropy decoder only */
+    jpeg_marker_parser_method read_restart_marker;
 
-  /* State of marker reader --- nominally internal, but applications
-   * supplying COM or APPn handlers might like to know the state.
-   */
-  boolean saw_SOI;		/* found SOI? */
-  boolean saw_SOF;		/* found SOF? */
-  int next_restart_num;		/* next restart number expected (0-7) */
-  unsigned int discarded_bytes;	/* # of bytes skipped looking for a marker */
+    /* State of marker reader --- nominally internal, but applications
+     * supplying COM or APPn handlers might like to know the state.
+     */
+    boolean saw_SOI;      /* found SOI? */
+    boolean saw_SOF;      /* found SOF? */
+    int next_restart_num;     /* next restart number expected (0-7) */
+    unsigned int discarded_bytes; /* # of bytes skipped looking for a marker */
 };
 
 /* Entropy decoding */
 struct jpeg_entropy_decoder {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
-  JMETHOD(boolean, decode_mcu, (j_decompress_ptr cinfo,
-				JBLOCKROW *MCU_data));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
+    JMETHOD(boolean, decode_mcu, (j_decompress_ptr cinfo,
+                                  JBLOCKROW *MCU_data));
 
-  /* This is here to share code between baseline and progressive decoders; */
-  /* other modules probably should not use it */
-  boolean insufficient_data;	/* set TRUE after emitting warning */
+    /* This is here to share code between baseline and progressive decoders; */
+    /* other modules probably should not use it */
+    boolean insufficient_data;    /* set TRUE after emitting warning */
 };
 
 /* Inverse DCT (also performs dequantization) */
 typedef JMETHOD(void, inverse_DCT_method_ptr,
-		(j_decompress_ptr cinfo, jpeg_component_info * compptr,
-		 JCOEFPTR coef_block,
-		 JSAMPARRAY output_buf, JDIMENSION output_col));
+                (j_decompress_ptr cinfo, jpeg_component_info * compptr,
+                 JCOEFPTR coef_block,
+                 JSAMPARRAY output_buf, JDIMENSION output_col));
 
 struct jpeg_inverse_dct {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
-  /* It is useful to allow each component to have a separate IDCT method. */
-  inverse_DCT_method_ptr inverse_DCT[MAX_COMPONENTS];
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
+    /* It is useful to allow each component to have a separate IDCT method. */
+    inverse_DCT_method_ptr inverse_DCT[MAX_COMPONENTS];
 };
 
 /* Upsampling (note that upsampler must also call color converter) */
 struct jpeg_upsampler {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, upsample, (j_decompress_ptr cinfo,
-			   JSAMPIMAGE input_buf,
-			   JDIMENSION *in_row_group_ctr,
-			   JDIMENSION in_row_groups_avail,
-			   JSAMPARRAY output_buf,
-			   JDIMENSION *out_row_ctr,
-			   JDIMENSION out_rows_avail));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, upsample, (j_decompress_ptr cinfo,
+                             JSAMPIMAGE input_buf,
+                             JDIMENSION *in_row_group_ctr,
+                             JDIMENSION in_row_groups_avail,
+                             JSAMPARRAY output_buf,
+                             JDIMENSION *out_row_ctr,
+                             JDIMENSION out_rows_avail));
 
-  boolean need_context_rows;	/* TRUE if need rows above & below */
+    boolean need_context_rows;    /* TRUE if need rows above & below */
 };
 
 /* Colorspace conversion */
 struct jpeg_color_deconverter {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, color_convert, (j_decompress_ptr cinfo,
-				JSAMPIMAGE input_buf, JDIMENSION input_row,
-				JSAMPARRAY output_buf, int num_rows));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, color_convert, (j_decompress_ptr cinfo,
+                                  JSAMPIMAGE input_buf, JDIMENSION input_row,
+                                  JSAMPARRAY output_buf, int num_rows));
 };
 
 /* Color quantization or color precision reduction */
 struct jpeg_color_quantizer {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo, boolean is_pre_scan));
-  JMETHOD(void, color_quantize, (j_decompress_ptr cinfo,
-				 JSAMPARRAY input_buf, JSAMPARRAY output_buf,
-				 int num_rows));
-  JMETHOD(void, finish_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, new_color_map, (j_decompress_ptr cinfo));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo, boolean is_pre_scan));
+    JMETHOD(void, color_quantize, (j_decompress_ptr cinfo,
+                                   JSAMPARRAY input_buf, JSAMPARRAY output_buf,
+                                   int num_rows));
+    JMETHOD(void, finish_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, new_color_map, (j_decompress_ptr cinfo));
 };
 
-
 /* Miscellaneous useful macros */
 
 #undef MAX
-#define MAX(a,b)	((a) > (b) ? (a) : (b))
+#define MAX(a,b)    ((a) > (b) ? (a) : (b))
 #undef MIN
-#define MIN(a,b)	((a) < (b) ? (a) : (b))
-
+#define MIN(a,b)    ((a) < (b) ? (a) : (b))
 
 /* We assume that right shift corresponds to signed division by 2 with
  * rounding towards minus infinity.  This is correct for typical "arithmetic
@@ -280,66 +275,64 @@
  */
 
 #ifdef RIGHT_SHIFT_IS_UNSIGNED
-#define SHIFT_TEMPS	INT32 shift_temp;
+#define SHIFT_TEMPS INT32 shift_temp;
 #define RIGHT_SHIFT(x,shft)  \
-	((shift_temp = (x)) < 0 ? \
-	 (shift_temp >> (shft)) | ((~((INT32) 0)) << (32-(shft))) : \
-	 (shift_temp >> (shft)))
+    ((shift_temp = (x)) < 0 ? \
+     (shift_temp >> (shft)) | ((~((INT32) 0)) << (32-(shft))) : \
+     (shift_temp >> (shft)))
 #else
 #define SHIFT_TEMPS
-#define RIGHT_SHIFT(x,shft)	((x) >> (shft))
+#define RIGHT_SHIFT(x,shft) ((x) >> (shft))
 #endif
 
-
 /* Short forms of external names for systems with brain-damaged linkers. */
 
 #ifdef NEED_SHORT_EXTERNAL_NAMES
-#define jinit_compress_master	jICompress
-#define jinit_c_master_control	jICMaster
-#define jinit_c_main_controller	jICMainC
-#define jinit_c_prep_controller	jICPrepC
-#define jinit_c_coef_controller	jICCoefC
-#define jinit_color_converter	jICColor
-#define jinit_downsampler	jIDownsampler
-#define jinit_forward_dct	jIFDCT
-#define jinit_huff_encoder	jIHEncoder
-#define jinit_phuff_encoder	jIPHEncoder
-#define jinit_marker_writer	jIMWriter
-#define jinit_master_decompress	jIDMaster
-#define jinit_d_main_controller	jIDMainC
-#define jinit_d_coef_controller	jIDCoefC
-#define jinit_d_post_controller	jIDPostC
-#define jinit_input_controller	jIInCtlr
-#define jinit_marker_reader	jIMReader
-#define jinit_huff_decoder	jIHDecoder
-#define jinit_phuff_decoder	jIPHDecoder
-#define jinit_inverse_dct	jIIDCT
-#define jinit_upsampler		jIUpsampler
-#define jinit_color_deconverter	jIDColor
-#define jinit_1pass_quantizer	jI1Quant
-#define jinit_2pass_quantizer	jI2Quant
-#define jinit_merged_upsampler	jIMUpsampler
-#define jinit_memory_mgr	jIMemMgr
-#define jdiv_round_up		jDivRound
-#define jround_up		jRound
-#define jcopy_sample_rows	jCopySamples
-#define jcopy_block_row		jCopyBlocks
-#define jzero_far		jZeroFar
-#define jpeg_zigzag_order	jZIGTable
-#define jpeg_natural_order	jZAGTable
+#define jinit_compress_master   jICompress
+#define jinit_c_master_control  jICMaster
+#define jinit_c_main_controller jICMainC
+#define jinit_c_prep_controller jICPrepC
+#define jinit_c_coef_controller jICCoefC
+#define jinit_color_converter   jICColor
+#define jinit_downsampler   jIDownsampler
+#define jinit_forward_dct   jIFDCT
+#define jinit_huff_encoder  jIHEncoder
+#define jinit_phuff_encoder jIPHEncoder
+#define jinit_marker_writer jIMWriter
+#define jinit_master_decompress jIDMaster
+#define jinit_d_main_controller jIDMainC
+#define jinit_d_coef_controller jIDCoefC
+#define jinit_d_post_controller jIDPostC
+#define jinit_input_controller  jIInCtlr
+#define jinit_marker_reader jIMReader
+#define jinit_huff_decoder  jIHDecoder
+#define jinit_phuff_decoder jIPHDecoder
+#define jinit_inverse_dct   jIIDCT
+#define jinit_upsampler     jIUpsampler
+#define jinit_color_deconverter jIDColor
+#define jinit_1pass_quantizer   jI1Quant
+#define jinit_2pass_quantizer   jI2Quant
+#define jinit_merged_upsampler  jIMUpsampler
+#define jinit_memory_mgr    jIMemMgr
+#define jdiv_round_up       jDivRound
+#define jround_up       jRound
+#define jcopy_sample_rows   jCopySamples
+#define jcopy_block_row     jCopyBlocks
+#define jzero_far       jZeroFar
+#define jpeg_zigzag_order   jZIGTable
+#define jpeg_natural_order  jZAGTable
 #endif /* NEED_SHORT_EXTERNAL_NAMES */
 
-
 /* Compression module initialization routines */
 EXTERN(void) jinit_compress_master JPP((j_compress_ptr cinfo));
 EXTERN(void) jinit_c_master_control JPP((j_compress_ptr cinfo,
-					 boolean transcode_only));
+                                        boolean transcode_only));
 EXTERN(void) jinit_c_main_controller JPP((j_compress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_c_prep_controller JPP((j_compress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_c_coef_controller JPP((j_compress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_color_converter JPP((j_compress_ptr cinfo));
 EXTERN(void) jinit_downsampler JPP((j_compress_ptr cinfo));
 EXTERN(void) jinit_forward_dct JPP((j_compress_ptr cinfo));
@@ -349,11 +342,11 @@
 /* Decompression module initialization routines */
 EXTERN(void) jinit_master_decompress JPP((j_decompress_ptr cinfo));
 EXTERN(void) jinit_d_main_controller JPP((j_decompress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_d_coef_controller JPP((j_decompress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_d_post_controller JPP((j_decompress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_input_controller JPP((j_decompress_ptr cinfo));
 EXTERN(void) jinit_marker_reader JPP((j_decompress_ptr cinfo));
 EXTERN(void) jinit_huff_decoder JPP((j_decompress_ptr cinfo));
@@ -371,13 +364,13 @@
 EXTERN(long) jdiv_round_up JPP((long a, long b));
 EXTERN(long) jround_up JPP((long a, long b));
 EXTERN(void) jcopy_sample_rows JPP((JSAMPARRAY input_array, int source_row,
-				    JSAMPARRAY output_array, int dest_row,
-				    int num_rows, JDIMENSION num_cols));
+                                    JSAMPARRAY output_array, int dest_row,
+                                    int num_rows, JDIMENSION num_cols));
 EXTERN(void) jcopy_block_row JPP((JBLOCKROW input_row, JBLOCKROW output_row,
-				  JDIMENSION num_blocks));
+                                  JDIMENSION num_blocks));
 EXTERN(void) jzero_far JPP((void FAR * target, size_t bytestozero));
 /* Constant tables in jutils.c */
-#if 0				/* This table is not actually needed in v6a */
+#if 0               /* This table is not actually needed in v6a */
 extern const int jpeg_zigzag_order[]; /* natural coef order to zigzag order */
 #endif
 extern const int jpeg_natural_order[]; /* zigzag coef order to natural order */
@@ -385,8 +378,12 @@
 /* Suppress undefined-structure complaints if necessary. */
 
 #ifdef INCOMPLETE_TYPES_BROKEN
-#ifndef AM_MEMORY_MANAGER	/* only jmemmgr.c defines these */
-struct jvirt_sarray_control { long dummy; };
-struct jvirt_barray_control { long dummy; };
+#ifndef AM_MEMORY_MANAGER   /* only jmemmgr.c defines these */
+struct jvirt_sarray_control {
+    long dummy;
+};
+struct jvirt_barray_control {
+    long dummy;
+};
 #endif
 #endif /* INCOMPLETE_TYPES_BROKEN */

=== modified file 'lib/libjpeg-62/transupp.h'
--- lib/libjpeg-62/transupp.h	2011-07-20 13:46:34 +0000
+++ lib/libjpeg-62/transupp.h	2011-12-15 14:17:54 +0000
@@ -22,33 +22,32 @@
 
 /* If you happen not to want the image transform support, disable it here */
 #ifndef TRANSFORMS_SUPPORTED
-#define TRANSFORMS_SUPPORTED 1		/* 0 disables transform code */
+#define TRANSFORMS_SUPPORTED 1      /* 0 disables transform code */
 #endif
 
 /* Short forms of external names for systems with brain-damaged linkers. */
 
 #ifdef NEED_SHORT_EXTERNAL_NAMES
-#define jtransform_request_workspace		jTrRequest
-#define jtransform_adjust_parameters		jTrAdjust
-#define jtransform_execute_transformation	jTrExec
-#define jcopy_markers_setup			jCMrkSetup
-#define jcopy_markers_execute			jCMrkExec
+#define jtransform_request_workspace        jTrRequest
+#define jtransform_adjust_parameters        jTrAdjust
+#define jtransform_execute_transformation   jTrExec
+#define jcopy_markers_setup         jCMrkSetup
+#define jcopy_markers_execute           jCMrkExec
 #endif /* NEED_SHORT_EXTERNAL_NAMES */
 
-
 /*
  * Codes for supported types of image transformations.
  */
 
 typedef enum {
-	JXFORM_NONE,		/* no transformation */
-	JXFORM_FLIP_H,		/* horizontal flip */
-	JXFORM_FLIP_V,		/* vertical flip */
-	JXFORM_TRANSPOSE,	/* transpose across UL-to-LR axis */
-	JXFORM_TRANSVERSE,	/* transpose across UR-to-LL axis */
-	JXFORM_ROT_90,		/* 90-degree clockwise rotation */
-	JXFORM_ROT_180,		/* 180-degree rotation */
-	JXFORM_ROT_270		/* 270-degree clockwise (or 90 ccw) */
+    JXFORM_NONE,        /* no transformation */
+    JXFORM_FLIP_H,      /* horizontal flip */
+    JXFORM_FLIP_V,      /* vertical flip */
+    JXFORM_TRANSPOSE,   /* transpose across UL-to-LR axis */
+    JXFORM_TRANSVERSE,  /* transpose across UR-to-LL axis */
+    JXFORM_ROT_90,      /* 90-degree clockwise rotation */
+    JXFORM_ROT_180,     /* 180-degree rotation */
+    JXFORM_ROT_270      /* 270-degree clockwise (or 90 ccw) */
 } JXFORM_CODE;
 
 /*
@@ -87,55 +86,53 @@
  */
 
 typedef struct {
-  /* Options: set by caller */
-  JXFORM_CODE transform;	/* image transform operator */
-  boolean trim;			/* if TRUE, trim partial MCUs as needed */
-  boolean force_grayscale;	/* if TRUE, convert color image to grayscale */
+    /* Options: set by caller */
+    JXFORM_CODE transform;    /* image transform operator */
+    boolean trim;         /* if TRUE, trim partial MCUs as needed */
+    boolean force_grayscale;  /* if TRUE, convert color image to grayscale */
 
-  /* Internal workspace: caller should not touch these */
-  int num_components;		/* # of components in workspace */
-  jvirt_barray_ptr * workspace_coef_arrays; /* workspace for transformations */
+    /* Internal workspace: caller should not touch these */
+    int num_components;       /* # of components in workspace */
+    jvirt_barray_ptr * workspace_coef_arrays; /* workspace for transformations */
 } jpeg_transform_info;
 
-
 #if TRANSFORMS_SUPPORTED
 
 /* Request any required workspace */
 EXTERN(void) jtransform_request_workspace
-	JPP((j_decompress_ptr srcinfo, jpeg_transform_info *info));
+JPP((j_decompress_ptr srcinfo, jpeg_transform_info *info));
 /* Adjust output image parameters */
 EXTERN(jvirt_barray_ptr *) jtransform_adjust_parameters
-	JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
-	     jvirt_barray_ptr *src_coef_arrays,
-	     jpeg_transform_info *info));
+JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
+     jvirt_barray_ptr *src_coef_arrays,
+     jpeg_transform_info *info));
 /* Execute the actual transformation, if any */
 EXTERN(void) jtransform_execute_transformation
-	JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
-	     jvirt_barray_ptr *src_coef_arrays,
-	     jpeg_transform_info *info));
+JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
+     jvirt_barray_ptr *src_coef_arrays,
+     jpeg_transform_info *info));
 
 #endif /* TRANSFORMS_SUPPORTED */
 
-
 /*
  * Support for copying optional markers from source to destination file.
  */
 
 typedef enum {
-	JCOPYOPT_NONE,		/* copy no optional markers */
-	JCOPYOPT_COMMENTS,	/* copy only comment (COM) markers */
-	JCOPYOPT_ALL		/* copy all optional markers */
+    JCOPYOPT_NONE,      /* copy no optional markers */
+    JCOPYOPT_COMMENTS,  /* copy only comment (COM) markers */
+    JCOPYOPT_ALL        /* copy all optional markers */
 } JCOPY_OPTION;
 
-#define JCOPYOPT_DEFAULT  JCOPYOPT_COMMENTS	/* recommended default */
+#define JCOPYOPT_DEFAULT  JCOPYOPT_COMMENTS /* recommended default */
 
 /* Setup decompression object to save desired markers in memory */
 EXTERN(void) jcopy_markers_setup
-	JPP((j_decompress_ptr srcinfo, JCOPY_OPTION option));
+JPP((j_decompress_ptr srcinfo, JCOPY_OPTION option));
 /* Copy markers saved in the given source object to the destination object */
 EXTERN(void) jcopy_markers_execute
-	JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
-	     JCOPY_OPTION option));
+JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
+     JCOPY_OPTION option));
 
 #endif
 

=== modified file 'lib/libjpeg-80/jinclude.h'
--- lib/libjpeg-80/jinclude.h	2011-07-20 13:46:34 +0000
+++ lib/libjpeg-80/jinclude.h	2011-12-15 14:17:54 +0000
@@ -14,11 +14,10 @@
  * JPEG library.  Most applications need only include jpeglib.h.
  */
 
-
 /* Include auto-config file to find out which system include files we need. */
 
-#include "jconfig.h"		/* auto configuration options */
-#define JCONFIG_INCLUDED	/* so that jpeglib.h doesn't do it again */
+#include "jconfig.h"        /* auto configuration options */
+#define JCONFIG_INCLUDED    /* so that jpeglib.h doesn't do it again */
 
 /*
  * We need the NULL macro and size_t typedef.
@@ -58,14 +57,14 @@
 #ifdef NEED_BSD_STRINGS
 
 #include <strings.h>
-#define MEMZERO(target,size)	bzero((void *)(target), (size_t)(size))
-#define MEMCOPY(dest,src,size)	bcopy((const void *)(src), (void *)(dest), (size_t)(size))
+#define MEMZERO(target,size)    bzero((void *)(target), (size_t)(size))
+#define MEMCOPY(dest,src,size)  bcopy((const void *)(src), (void *)(dest), (size_t)(size))
 
 #else /* not BSD, assume ANSI/SysV string lib */
 
 #include <string.h>
-#define MEMZERO(target,size)	memset((void *)(target), 0, (size_t)(size))
-#define MEMCOPY(dest,src,size)	memcpy((void *)(dest), (const void *)(src), (size_t)(size))
+#define MEMZERO(target,size)    memset((void *)(target), 0, (size_t)(size))
+#define MEMCOPY(dest,src,size)  memcpy((void *)(dest), (const void *)(src), (size_t)(size))
 
 #endif
 
@@ -77,7 +76,7 @@
  * we always use this SIZEOF() macro in place of using sizeof() directly.
  */
 
-#define SIZEOF(object)	((size_t) sizeof(object))
+#define SIZEOF(object)  ((size_t) sizeof(object))
 
 /*
  * The modules that use fread() and fwrite() always invoke them through
@@ -86,6 +85,6 @@
  */
 
 #define JFREAD(file,buf,sizeofbuf)  \
-  ((size_t) fread((void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))
+    ((size_t) fread((void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))
 #define JFWRITE(file,buf,sizeofbuf)  \
-  ((size_t) fwrite((const void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))
+    ((size_t) fwrite((const void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))

=== modified file 'lib/libjpeg-80/jpegint.h'
--- lib/libjpeg-80/jpegint.h	2011-07-20 13:46:34 +0000
+++ lib/libjpeg-80/jpegint.h	2011-12-15 14:17:54 +0000
@@ -11,262 +11,257 @@
  * applications using the library shouldn't need to include this file.
  */
 
-
 /* Declarations for both compression & decompression */
 
-typedef enum {			/* Operating modes for buffer controllers */
-	JBUF_PASS_THRU,		/* Plain stripwise operation */
-	/* Remaining modes require a full-image buffer to have been created */
-	JBUF_SAVE_SOURCE,	/* Run source subobject only, save output */
-	JBUF_CRANK_DEST,	/* Run dest subobject only, using saved data */
-	JBUF_SAVE_AND_PASS	/* Run both subobjects, save output */
+typedef enum {          /* Operating modes for buffer controllers */
+    JBUF_PASS_THRU,     /* Plain stripwise operation */
+    /* Remaining modes require a full-image buffer to have been created */
+    JBUF_SAVE_SOURCE,   /* Run source subobject only, save output */
+    JBUF_CRANK_DEST,    /* Run dest subobject only, using saved data */
+    JBUF_SAVE_AND_PASS  /* Run both subobjects, save output */
 } J_BUF_MODE;
 
 /* Values of global_state field (jdapi.c has some dependencies on ordering!) */
-#define CSTATE_START	100	/* after create_compress */
-#define CSTATE_SCANNING	101	/* start_compress done, write_scanlines OK */
-#define CSTATE_RAW_OK	102	/* start_compress done, write_raw_data OK */
-#define CSTATE_WRCOEFS	103	/* jpeg_write_coefficients done */
-#define DSTATE_START	200	/* after create_decompress */
-#define DSTATE_INHEADER	201	/* reading header markers, no SOS yet */
-#define DSTATE_READY	202	/* found SOS, ready for start_decompress */
-#define DSTATE_PRELOAD	203	/* reading multiscan file in start_decompress*/
-#define DSTATE_PRESCAN	204	/* performing dummy pass for 2-pass quant */
-#define DSTATE_SCANNING	205	/* start_decompress done, read_scanlines OK */
-#define DSTATE_RAW_OK	206	/* start_decompress done, read_raw_data OK */
-#define DSTATE_BUFIMAGE	207	/* expecting jpeg_start_output */
-#define DSTATE_BUFPOST	208	/* looking for SOS/EOI in jpeg_finish_output */
-#define DSTATE_RDCOEFS	209	/* reading file in jpeg_read_coefficients */
-#define DSTATE_STOPPING	210	/* looking for EOI in jpeg_finish_decompress */
-
+#define CSTATE_START    100 /* after create_compress */
+#define CSTATE_SCANNING 101 /* start_compress done, write_scanlines OK */
+#define CSTATE_RAW_OK   102 /* start_compress done, write_raw_data OK */
+#define CSTATE_WRCOEFS  103 /* jpeg_write_coefficients done */
+#define DSTATE_START    200 /* after create_decompress */
+#define DSTATE_INHEADER 201 /* reading header markers, no SOS yet */
+#define DSTATE_READY    202 /* found SOS, ready for start_decompress */
+#define DSTATE_PRELOAD  203 /* reading multiscan file in start_decompress*/
+#define DSTATE_PRESCAN  204 /* performing dummy pass for 2-pass quant */
+#define DSTATE_SCANNING 205 /* start_decompress done, read_scanlines OK */
+#define DSTATE_RAW_OK   206 /* start_decompress done, read_raw_data OK */
+#define DSTATE_BUFIMAGE 207 /* expecting jpeg_start_output */
+#define DSTATE_BUFPOST  208 /* looking for SOS/EOI in jpeg_finish_output */
+#define DSTATE_RDCOEFS  209 /* reading file in jpeg_read_coefficients */
+#define DSTATE_STOPPING 210 /* looking for EOI in jpeg_finish_decompress */
 
 /* Declarations for compression modules */
 
 /* Master control module */
 struct jpeg_comp_master {
-  JMETHOD(void, prepare_for_pass, (j_compress_ptr cinfo));
-  JMETHOD(void, pass_startup, (j_compress_ptr cinfo));
-  JMETHOD(void, finish_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, prepare_for_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, pass_startup, (j_compress_ptr cinfo));
+    JMETHOD(void, finish_pass, (j_compress_ptr cinfo));
 
-  /* State variables made visible to other modules */
-  boolean call_pass_startup;	/* True if pass_startup must be called */
-  boolean is_last_pass;		/* True during last pass */
+    /* State variables made visible to other modules */
+    boolean call_pass_startup;    /* True if pass_startup must be called */
+    boolean is_last_pass;     /* True during last pass */
 };
 
 /* Main buffer control (downsampled-data buffer) */
 struct jpeg_c_main_controller {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(void, process_data, (j_compress_ptr cinfo,
-			       JSAMPARRAY input_buf, JDIMENSION *in_row_ctr,
-			       JDIMENSION in_rows_avail));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(void, process_data, (j_compress_ptr cinfo,
+                                 JSAMPARRAY input_buf, JDIMENSION *in_row_ctr,
+                                 JDIMENSION in_rows_avail));
 };
 
 /* Compression preprocessing (downsampling input buffer control) */
 struct jpeg_c_prep_controller {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(void, pre_process_data, (j_compress_ptr cinfo,
-				   JSAMPARRAY input_buf,
-				   JDIMENSION *in_row_ctr,
-				   JDIMENSION in_rows_avail,
-				   JSAMPIMAGE output_buf,
-				   JDIMENSION *out_row_group_ctr,
-				   JDIMENSION out_row_groups_avail));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(void, pre_process_data, (j_compress_ptr cinfo,
+                                     JSAMPARRAY input_buf,
+                                     JDIMENSION *in_row_ctr,
+                                     JDIMENSION in_rows_avail,
+                                     JSAMPIMAGE output_buf,
+                                     JDIMENSION *out_row_group_ctr,
+                                     JDIMENSION out_row_groups_avail));
 };
 
 /* Coefficient buffer control */
 struct jpeg_c_coef_controller {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(boolean, compress_data, (j_compress_ptr cinfo,
-				   JSAMPIMAGE input_buf));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(boolean, compress_data, (j_compress_ptr cinfo,
+                                     JSAMPIMAGE input_buf));
 };
 
 /* Colorspace conversion */
 struct jpeg_color_converter {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo));
-  JMETHOD(void, color_convert, (j_compress_ptr cinfo,
-				JSAMPARRAY input_buf, JSAMPIMAGE output_buf,
-				JDIMENSION output_row, int num_rows));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, color_convert, (j_compress_ptr cinfo,
+                                  JSAMPARRAY input_buf, JSAMPIMAGE output_buf,
+                                  JDIMENSION output_row, int num_rows));
 };
 
 /* Downsampling */
 struct jpeg_downsampler {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo));
-  JMETHOD(void, downsample, (j_compress_ptr cinfo,
-			     JSAMPIMAGE input_buf, JDIMENSION in_row_index,
-			     JSAMPIMAGE output_buf,
-			     JDIMENSION out_row_group_index));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, downsample, (j_compress_ptr cinfo,
+                               JSAMPIMAGE input_buf, JDIMENSION in_row_index,
+                               JSAMPIMAGE output_buf,
+                               JDIMENSION out_row_group_index));
 
-  boolean need_context_rows;	/* TRUE if need rows above & below */
+    boolean need_context_rows;    /* TRUE if need rows above & below */
 };
 
 /* Forward DCT (also controls coefficient quantization) */
 typedef JMETHOD(void, forward_DCT_ptr,
-		(j_compress_ptr cinfo, jpeg_component_info * compptr,
-		 JSAMPARRAY sample_data, JBLOCKROW coef_blocks,
-		 JDIMENSION start_row, JDIMENSION start_col,
-		 JDIMENSION num_blocks));
+                (j_compress_ptr cinfo, jpeg_component_info * compptr,
+                 JSAMPARRAY sample_data, JBLOCKROW coef_blocks,
+                 JDIMENSION start_row, JDIMENSION start_col,
+                 JDIMENSION num_blocks));
 
 struct jpeg_forward_dct {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo));
-  /* It is useful to allow each component to have a separate FDCT method. */
-  forward_DCT_ptr forward_DCT[MAX_COMPONENTS];
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo));
+    /* It is useful to allow each component to have a separate FDCT method. */
+    forward_DCT_ptr forward_DCT[MAX_COMPONENTS];
 };
 
 /* Entropy encoding */
 struct jpeg_entropy_encoder {
-  JMETHOD(void, start_pass, (j_compress_ptr cinfo, boolean gather_statistics));
-  JMETHOD(boolean, encode_mcu, (j_compress_ptr cinfo, JBLOCKROW *MCU_data));
-  JMETHOD(void, finish_pass, (j_compress_ptr cinfo));
+    JMETHOD(void, start_pass, (j_compress_ptr cinfo, boolean gather_statistics));
+    JMETHOD(boolean, encode_mcu, (j_compress_ptr cinfo, JBLOCKROW *MCU_data));
+    JMETHOD(void, finish_pass, (j_compress_ptr cinfo));
 };
 
 /* Marker writing */
 struct jpeg_marker_writer {
-  JMETHOD(void, write_file_header, (j_compress_ptr cinfo));
-  JMETHOD(void, write_frame_header, (j_compress_ptr cinfo));
-  JMETHOD(void, write_scan_header, (j_compress_ptr cinfo));
-  JMETHOD(void, write_file_trailer, (j_compress_ptr cinfo));
-  JMETHOD(void, write_tables_only, (j_compress_ptr cinfo));
-  /* These routines are exported to allow insertion of extra markers */
-  /* Probably only COM and APPn markers should be written this way */
-  JMETHOD(void, write_marker_header, (j_compress_ptr cinfo, int marker,
-				      unsigned int datalen));
-  JMETHOD(void, write_marker_byte, (j_compress_ptr cinfo, int val));
+    JMETHOD(void, write_file_header, (j_compress_ptr cinfo));
+    JMETHOD(void, write_frame_header, (j_compress_ptr cinfo));
+    JMETHOD(void, write_scan_header, (j_compress_ptr cinfo));
+    JMETHOD(void, write_file_trailer, (j_compress_ptr cinfo));
+    JMETHOD(void, write_tables_only, (j_compress_ptr cinfo));
+    /* These routines are exported to allow insertion of extra markers */
+    /* Probably only COM and APPn markers should be written this way */
+    JMETHOD(void, write_marker_header, (j_compress_ptr cinfo, int marker,
+                                        unsigned int datalen));
+    JMETHOD(void, write_marker_byte, (j_compress_ptr cinfo, int val));
 };
 
-
 /* Declarations for decompression modules */
 
 /* Master control module */
 struct jpeg_decomp_master {
-  JMETHOD(void, prepare_for_output_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, finish_output_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, prepare_for_output_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, finish_output_pass, (j_decompress_ptr cinfo));
 
-  /* State variables made visible to other modules */
-  boolean is_dummy_pass;	/* True during 1st pass for 2-pass quant */
+    /* State variables made visible to other modules */
+    boolean is_dummy_pass;    /* True during 1st pass for 2-pass quant */
 };
 
 /* Input control module */
 struct jpeg_input_controller {
-  JMETHOD(int, consume_input, (j_decompress_ptr cinfo));
-  JMETHOD(void, reset_input_controller, (j_decompress_ptr cinfo));
-  JMETHOD(void, start_input_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, finish_input_pass, (j_decompress_ptr cinfo));
+    JMETHOD(int, consume_input, (j_decompress_ptr cinfo));
+    JMETHOD(void, reset_input_controller, (j_decompress_ptr cinfo));
+    JMETHOD(void, start_input_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, finish_input_pass, (j_decompress_ptr cinfo));
 
-  /* State variables made visible to other modules */
-  boolean has_multiple_scans;	/* True if file has multiple scans */
-  boolean eoi_reached;		/* True when EOI has been consumed */
+    /* State variables made visible to other modules */
+    boolean has_multiple_scans;   /* True if file has multiple scans */
+    boolean eoi_reached;      /* True when EOI has been consumed */
 };
 
 /* Main buffer control (downsampled-data buffer) */
 struct jpeg_d_main_controller {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(void, process_data, (j_decompress_ptr cinfo,
-			       JSAMPARRAY output_buf, JDIMENSION *out_row_ctr,
-			       JDIMENSION out_rows_avail));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(void, process_data, (j_decompress_ptr cinfo,
+                                 JSAMPARRAY output_buf, JDIMENSION *out_row_ctr,
+                                 JDIMENSION out_rows_avail));
 };
 
 /* Coefficient buffer control */
 struct jpeg_d_coef_controller {
-  JMETHOD(void, start_input_pass, (j_decompress_ptr cinfo));
-  JMETHOD(int, consume_data, (j_decompress_ptr cinfo));
-  JMETHOD(void, start_output_pass, (j_decompress_ptr cinfo));
-  JMETHOD(int, decompress_data, (j_decompress_ptr cinfo,
-				 JSAMPIMAGE output_buf));
-  /* Pointer to array of coefficient virtual arrays, or NULL if none */
-  jvirt_barray_ptr *coef_arrays;
+    JMETHOD(void, start_input_pass, (j_decompress_ptr cinfo));
+    JMETHOD(int, consume_data, (j_decompress_ptr cinfo));
+    JMETHOD(void, start_output_pass, (j_decompress_ptr cinfo));
+    JMETHOD(int, decompress_data, (j_decompress_ptr cinfo,
+                                   JSAMPIMAGE output_buf));
+    /* Pointer to array of coefficient virtual arrays, or NULL if none */
+    jvirt_barray_ptr *coef_arrays;
 };
 
 /* Decompression postprocessing (color quantization buffer control) */
 struct jpeg_d_post_controller {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo, J_BUF_MODE pass_mode));
-  JMETHOD(void, post_process_data, (j_decompress_ptr cinfo,
-				    JSAMPIMAGE input_buf,
-				    JDIMENSION *in_row_group_ctr,
-				    JDIMENSION in_row_groups_avail,
-				    JSAMPARRAY output_buf,
-				    JDIMENSION *out_row_ctr,
-				    JDIMENSION out_rows_avail));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo, J_BUF_MODE pass_mode));
+    JMETHOD(void, post_process_data, (j_decompress_ptr cinfo,
+                                      JSAMPIMAGE input_buf,
+                                      JDIMENSION *in_row_group_ctr,
+                                      JDIMENSION in_row_groups_avail,
+                                      JSAMPARRAY output_buf,
+                                      JDIMENSION *out_row_ctr,
+                                      JDIMENSION out_rows_avail));
 };
 
 /* Marker reading & parsing */
 struct jpeg_marker_reader {
-  JMETHOD(void, reset_marker_reader, (j_decompress_ptr cinfo));
-  /* Read markers until SOS or EOI.
-   * Returns same codes as are defined for jpeg_consume_input:
-   * JPEG_SUSPENDED, JPEG_REACHED_SOS, or JPEG_REACHED_EOI.
-   */
-  JMETHOD(int, read_markers, (j_decompress_ptr cinfo));
-  /* Read a restart marker --- exported for use by entropy decoder only */
-  jpeg_marker_parser_method read_restart_marker;
+    JMETHOD(void, reset_marker_reader, (j_decompress_ptr cinfo));
+    /* Read markers until SOS or EOI.
+     * Returns same codes as are defined for jpeg_consume_input:
+     * JPEG_SUSPENDED, JPEG_REACHED_SOS, or JPEG_REACHED_EOI.
+     */
+    JMETHOD(int, read_markers, (j_decompress_ptr cinfo));
+    /* Read a restart marker --- exported for use by entropy decoder only */
+    jpeg_marker_parser_method read_restart_marker;
 
-  /* State of marker reader --- nominally internal, but applications
-   * supplying COM or APPn handlers might like to know the state.
-   */
-  boolean saw_SOI;		/* found SOI? */
-  boolean saw_SOF;		/* found SOF? */
-  int next_restart_num;		/* next restart number expected (0-7) */
-  unsigned int discarded_bytes;	/* # of bytes skipped looking for a marker */
+    /* State of marker reader --- nominally internal, but applications
+     * supplying COM or APPn handlers might like to know the state.
+     */
+    boolean saw_SOI;      /* found SOI? */
+    boolean saw_SOF;      /* found SOF? */
+    int next_restart_num;     /* next restart number expected (0-7) */
+    unsigned int discarded_bytes; /* # of bytes skipped looking for a marker */
 };
 
 /* Entropy decoding */
 struct jpeg_entropy_decoder {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
-  JMETHOD(boolean, decode_mcu, (j_decompress_ptr cinfo,
-				JBLOCKROW *MCU_data));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
+    JMETHOD(boolean, decode_mcu, (j_decompress_ptr cinfo,
+                                  JBLOCKROW *MCU_data));
 };
 
 /* Inverse DCT (also performs dequantization) */
 typedef JMETHOD(void, inverse_DCT_method_ptr,
-		(j_decompress_ptr cinfo, jpeg_component_info * compptr,
-		 JCOEFPTR coef_block,
-		 JSAMPARRAY output_buf, JDIMENSION output_col));
+                (j_decompress_ptr cinfo, jpeg_component_info * compptr,
+                 JCOEFPTR coef_block,
+                 JSAMPARRAY output_buf, JDIMENSION output_col));
 
 struct jpeg_inverse_dct {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
-  /* It is useful to allow each component to have a separate IDCT method. */
-  inverse_DCT_method_ptr inverse_DCT[MAX_COMPONENTS];
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
+    /* It is useful to allow each component to have a separate IDCT method. */
+    inverse_DCT_method_ptr inverse_DCT[MAX_COMPONENTS];
 };
 
 /* Upsampling (note that upsampler must also call color converter) */
 struct jpeg_upsampler {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, upsample, (j_decompress_ptr cinfo,
-			   JSAMPIMAGE input_buf,
-			   JDIMENSION *in_row_group_ctr,
-			   JDIMENSION in_row_groups_avail,
-			   JSAMPARRAY output_buf,
-			   JDIMENSION *out_row_ctr,
-			   JDIMENSION out_rows_avail));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, upsample, (j_decompress_ptr cinfo,
+                             JSAMPIMAGE input_buf,
+                             JDIMENSION *in_row_group_ctr,
+                             JDIMENSION in_row_groups_avail,
+                             JSAMPARRAY output_buf,
+                             JDIMENSION *out_row_ctr,
+                             JDIMENSION out_rows_avail));
 
-  boolean need_context_rows;	/* TRUE if need rows above & below */
+    boolean need_context_rows;    /* TRUE if need rows above & below */
 };
 
 /* Colorspace conversion */
 struct jpeg_color_deconverter {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, color_convert, (j_decompress_ptr cinfo,
-				JSAMPIMAGE input_buf, JDIMENSION input_row,
-				JSAMPARRAY output_buf, int num_rows));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, color_convert, (j_decompress_ptr cinfo,
+                                  JSAMPIMAGE input_buf, JDIMENSION input_row,
+                                  JSAMPARRAY output_buf, int num_rows));
 };
 
 /* Color quantization or color precision reduction */
 struct jpeg_color_quantizer {
-  JMETHOD(void, start_pass, (j_decompress_ptr cinfo, boolean is_pre_scan));
-  JMETHOD(void, color_quantize, (j_decompress_ptr cinfo,
-				 JSAMPARRAY input_buf, JSAMPARRAY output_buf,
-				 int num_rows));
-  JMETHOD(void, finish_pass, (j_decompress_ptr cinfo));
-  JMETHOD(void, new_color_map, (j_decompress_ptr cinfo));
+    JMETHOD(void, start_pass, (j_decompress_ptr cinfo, boolean is_pre_scan));
+    JMETHOD(void, color_quantize, (j_decompress_ptr cinfo,
+                                   JSAMPARRAY input_buf, JSAMPARRAY output_buf,
+                                   int num_rows));
+    JMETHOD(void, finish_pass, (j_decompress_ptr cinfo));
+    JMETHOD(void, new_color_map, (j_decompress_ptr cinfo));
 };
 
-
 /* Miscellaneous useful macros */
 
 #undef MAX
-#define MAX(a,b)	((a) > (b) ? (a) : (b))
+#define MAX(a,b)    ((a) > (b) ? (a) : (b))
 #undef MIN
-#define MIN(a,b)	((a) < (b) ? (a) : (b))
-
+#define MIN(a,b)    ((a) < (b) ? (a) : (b))
 
 /* We assume that right shift corresponds to signed division by 2 with
  * rounding towards minus infinity.  This is correct for typical "arithmetic
@@ -279,73 +274,71 @@
  */
 
 #ifdef RIGHT_SHIFT_IS_UNSIGNED
-#define SHIFT_TEMPS	INT32 shift_temp;
+#define SHIFT_TEMPS INT32 shift_temp;
 #define RIGHT_SHIFT(x,shft)  \
-	((shift_temp = (x)) < 0 ? \
-	 (shift_temp >> (shft)) | ((~((INT32) 0)) << (32-(shft))) : \
-	 (shift_temp >> (shft)))
+    ((shift_temp = (x)) < 0 ? \
+     (shift_temp >> (shft)) | ((~((INT32) 0)) << (32-(shft))) : \
+     (shift_temp >> (shft)))
 #else
 #define SHIFT_TEMPS
-#define RIGHT_SHIFT(x,shft)	((x) >> (shft))
+#define RIGHT_SHIFT(x,shft) ((x) >> (shft))
 #endif
 
-
 /* Short forms of external names for systems with brain-damaged linkers. */
 
 #ifdef NEED_SHORT_EXTERNAL_NAMES
-#define jinit_compress_master	jICompress
-#define jinit_c_master_control	jICMaster
-#define jinit_c_main_controller	jICMainC
-#define jinit_c_prep_controller	jICPrepC
-#define jinit_c_coef_controller	jICCoefC
-#define jinit_color_converter	jICColor
-#define jinit_downsampler	jIDownsampler
-#define jinit_forward_dct	jIFDCT
-#define jinit_huff_encoder	jIHEncoder
-#define jinit_arith_encoder	jIAEncoder
-#define jinit_marker_writer	jIMWriter
-#define jinit_master_decompress	jIDMaster
-#define jinit_d_main_controller	jIDMainC
-#define jinit_d_coef_controller	jIDCoefC
-#define jinit_d_post_controller	jIDPostC
-#define jinit_input_controller	jIInCtlr
-#define jinit_marker_reader	jIMReader
-#define jinit_huff_decoder	jIHDecoder
-#define jinit_arith_decoder	jIADecoder
-#define jinit_inverse_dct	jIIDCT
-#define jinit_upsampler		jIUpsampler
-#define jinit_color_deconverter	jIDColor
-#define jinit_1pass_quantizer	jI1Quant
-#define jinit_2pass_quantizer	jI2Quant
-#define jinit_merged_upsampler	jIMUpsampler
-#define jinit_memory_mgr	jIMemMgr
-#define jdiv_round_up		jDivRound
-#define jround_up		jRound
-#define jcopy_sample_rows	jCopySamples
-#define jcopy_block_row		jCopyBlocks
-#define jzero_far		jZeroFar
-#define jpeg_zigzag_order	jZIGTable
-#define jpeg_natural_order	jZAGTable
-#define jpeg_natural_order7	jZAGTable7
-#define jpeg_natural_order6	jZAGTable6
-#define jpeg_natural_order5	jZAGTable5
-#define jpeg_natural_order4	jZAGTable4
-#define jpeg_natural_order3	jZAGTable3
-#define jpeg_natural_order2	jZAGTable2
-#define jpeg_aritab		jAriTab
+#define jinit_compress_master   jICompress
+#define jinit_c_master_control  jICMaster
+#define jinit_c_main_controller jICMainC
+#define jinit_c_prep_controller jICPrepC
+#define jinit_c_coef_controller jICCoefC
+#define jinit_color_converter   jICColor
+#define jinit_downsampler   jIDownsampler
+#define jinit_forward_dct   jIFDCT
+#define jinit_huff_encoder  jIHEncoder
+#define jinit_arith_encoder jIAEncoder
+#define jinit_marker_writer jIMWriter
+#define jinit_master_decompress jIDMaster
+#define jinit_d_main_controller jIDMainC
+#define jinit_d_coef_controller jIDCoefC
+#define jinit_d_post_controller jIDPostC
+#define jinit_input_controller  jIInCtlr
+#define jinit_marker_reader jIMReader
+#define jinit_huff_decoder  jIHDecoder
+#define jinit_arith_decoder jIADecoder
+#define jinit_inverse_dct   jIIDCT
+#define jinit_upsampler     jIUpsampler
+#define jinit_color_deconverter jIDColor
+#define jinit_1pass_quantizer   jI1Quant
+#define jinit_2pass_quantizer   jI2Quant
+#define jinit_merged_upsampler  jIMUpsampler
+#define jinit_memory_mgr    jIMemMgr
+#define jdiv_round_up       jDivRound
+#define jround_up       jRound
+#define jcopy_sample_rows   jCopySamples
+#define jcopy_block_row     jCopyBlocks
+#define jzero_far       jZeroFar
+#define jpeg_zigzag_order   jZIGTable
+#define jpeg_natural_order  jZAGTable
+#define jpeg_natural_order7 jZAGTable7
+#define jpeg_natural_order6 jZAGTable6
+#define jpeg_natural_order5 jZAGTable5
+#define jpeg_natural_order4 jZAGTable4
+#define jpeg_natural_order3 jZAGTable3
+#define jpeg_natural_order2 jZAGTable2
+#define jpeg_aritab     jAriTab
 #endif /* NEED_SHORT_EXTERNAL_NAMES */
 
-
 /* Compression module initialization routines */
 EXTERN(void) jinit_compress_master JPP((j_compress_ptr cinfo));
 EXTERN(void) jinit_c_master_control JPP((j_compress_ptr cinfo,
-					 boolean transcode_only));
+                                        boolean transcode_only));
 EXTERN(void) jinit_c_main_controller JPP((j_compress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_c_prep_controller JPP((j_compress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_c_coef_controller JPP((j_compress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_color_converter JPP((j_compress_ptr cinfo));
 EXTERN(void) jinit_downsampler JPP((j_compress_ptr cinfo));
 EXTERN(void) jinit_forward_dct JPP((j_compress_ptr cinfo));
@@ -355,11 +348,11 @@
 /* Decompression module initialization routines */
 EXTERN(void) jinit_master_decompress JPP((j_decompress_ptr cinfo));
 EXTERN(void) jinit_d_main_controller JPP((j_decompress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_d_coef_controller JPP((j_decompress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_d_post_controller JPP((j_decompress_ptr cinfo,
-					  boolean need_full_buffer));
+        boolean need_full_buffer));
 EXTERN(void) jinit_input_controller JPP((j_decompress_ptr cinfo));
 EXTERN(void) jinit_marker_reader JPP((j_decompress_ptr cinfo));
 EXTERN(void) jinit_huff_decoder JPP((j_decompress_ptr cinfo));
@@ -377,13 +370,13 @@
 EXTERN(long) jdiv_round_up JPP((long a, long b));
 EXTERN(long) jround_up JPP((long a, long b));
 EXTERN(void) jcopy_sample_rows JPP((JSAMPARRAY input_array, int source_row,
-				    JSAMPARRAY output_array, int dest_row,
-				    int num_rows, JDIMENSION num_cols));
+                                    JSAMPARRAY output_array, int dest_row,
+                                    int num_rows, JDIMENSION num_cols));
 EXTERN(void) jcopy_block_row JPP((JBLOCKROW input_row, JBLOCKROW output_row,
-				  JDIMENSION num_blocks));
+                                  JDIMENSION num_blocks));
 EXTERN(void) jzero_far JPP((void FAR * target, size_t bytestozero));
 /* Constant tables in jutils.c */
-#if 0				/* This table is not actually needed in v6a */
+#if 0               /* This table is not actually needed in v6a */
 extern const int jpeg_zigzag_order[]; /* natural coef order to zigzag order */
 #endif
 extern const int jpeg_natural_order[]; /* zigzag coef order to natural order */
@@ -400,8 +393,12 @@
 /* Suppress undefined-structure complaints if necessary. */
 
 #ifdef INCOMPLETE_TYPES_BROKEN
-#ifndef AM_MEMORY_MANAGER	/* only jmemmgr.c defines these */
-struct jvirt_sarray_control { long dummy; };
-struct jvirt_barray_control { long dummy; };
+#ifndef AM_MEMORY_MANAGER   /* only jmemmgr.c defines these */
+struct jvirt_sarray_control {
+    long dummy;
+};
+struct jvirt_barray_control {
+    long dummy;
+};
 #endif
 #endif /* INCOMPLETE_TYPES_BROKEN */

=== modified file 'lib/libjpeg-80/transupp.h'
--- lib/libjpeg-80/transupp.h	2011-07-20 13:46:34 +0000
+++ lib/libjpeg-80/transupp.h	2011-12-15 14:17:54 +0000
@@ -19,7 +19,7 @@
 
 /* If you happen not to want the image transform support, disable it here */
 #ifndef TRANSFORMS_SUPPORTED
-#define TRANSFORMS_SUPPORTED 1		/* 0 disables transform code */
+#define TRANSFORMS_SUPPORTED 1      /* 0 disables transform code */
 #endif
 
 /*
@@ -75,33 +75,31 @@
  * be aware of the option to know how many components to work on.
  */
 
-
 /* Short forms of external names for systems with brain-damaged linkers. */
 
 #ifdef NEED_SHORT_EXTERNAL_NAMES
-#define jtransform_parse_crop_spec	jTrParCrop
-#define jtransform_request_workspace	jTrRequest
-#define jtransform_adjust_parameters	jTrAdjust
-#define jtransform_execute_transform	jTrExec
-#define jtransform_perfect_transform	jTrPerfect
-#define jcopy_markers_setup		jCMrkSetup
-#define jcopy_markers_execute		jCMrkExec
+#define jtransform_parse_crop_spec  jTrParCrop
+#define jtransform_request_workspace    jTrRequest
+#define jtransform_adjust_parameters    jTrAdjust
+#define jtransform_execute_transform    jTrExec
+#define jtransform_perfect_transform    jTrPerfect
+#define jcopy_markers_setup     jCMrkSetup
+#define jcopy_markers_execute       jCMrkExec
 #endif /* NEED_SHORT_EXTERNAL_NAMES */
 
-
 /*
  * Codes for supported types of image transformations.
  */
 
 typedef enum {
-	JXFORM_NONE,		/* no transformation */
-	JXFORM_FLIP_H,		/* horizontal flip */
-	JXFORM_FLIP_V,		/* vertical flip */
-	JXFORM_TRANSPOSE,	/* transpose across UL-to-LR axis */
-	JXFORM_TRANSVERSE,	/* transpose across UR-to-LL axis */
-	JXFORM_ROT_90,		/* 90-degree clockwise rotation */
-	JXFORM_ROT_180,		/* 180-degree rotation */
-	JXFORM_ROT_270		/* 270-degree clockwise (or 90 ccw) */
+    JXFORM_NONE,        /* no transformation */
+    JXFORM_FLIP_H,      /* horizontal flip */
+    JXFORM_FLIP_V,      /* vertical flip */
+    JXFORM_TRANSPOSE,   /* transpose across UL-to-LR axis */
+    JXFORM_TRANSVERSE,  /* transpose across UR-to-LL axis */
+    JXFORM_ROT_90,      /* 90-degree clockwise rotation */
+    JXFORM_ROT_180,     /* 180-degree rotation */
+    JXFORM_ROT_270      /* 270-degree clockwise (or 90 ccw) */
 } JXFORM_CODE;
 
 /*
@@ -110,9 +108,9 @@
  */
 
 typedef enum {
-	JCROP_UNSET,
-	JCROP_POS,
-	JCROP_NEG
+    JCROP_UNSET,
+    JCROP_POS,
+    JCROP_NEG
 } JCROP_CODE;
 
 /*
@@ -122,89 +120,87 @@
  */
 
 typedef struct {
-  /* Options: set by caller */
-  JXFORM_CODE transform;	/* image transform operator */
-  boolean perfect;		/* if TRUE, fail if partial MCUs are requested */
-  boolean trim;			/* if TRUE, trim partial MCUs as needed */
-  boolean force_grayscale;	/* if TRUE, convert color image to grayscale */
-  boolean crop;			/* if TRUE, crop source image */
-
-  /* Crop parameters: application need not set these unless crop is TRUE.
-   * These can be filled in by jtransform_parse_crop_spec().
-   */
-  JDIMENSION crop_width;	/* Width of selected region */
-  JCROP_CODE crop_width_set;
-  JDIMENSION crop_height;	/* Height of selected region */
-  JCROP_CODE crop_height_set;
-  JDIMENSION crop_xoffset;	/* X offset of selected region */
-  JCROP_CODE crop_xoffset_set;	/* (negative measures from right edge) */
-  JDIMENSION crop_yoffset;	/* Y offset of selected region */
-  JCROP_CODE crop_yoffset_set;	/* (negative measures from bottom edge) */
-
-  /* Internal workspace: caller should not touch these */
-  int num_components;		/* # of components in workspace */
-  jvirt_barray_ptr * workspace_coef_arrays; /* workspace for transformations */
-  JDIMENSION output_width;	/* cropped destination dimensions */
-  JDIMENSION output_height;
-  JDIMENSION x_crop_offset;	/* destination crop offsets measured in iMCUs */
-  JDIMENSION y_crop_offset;
-  int iMCU_sample_width;	/* destination iMCU size */
-  int iMCU_sample_height;
+    /* Options: set by caller */
+    JXFORM_CODE transform;    /* image transform operator */
+    boolean perfect;      /* if TRUE, fail if partial MCUs are requested */
+    boolean trim;         /* if TRUE, trim partial MCUs as needed */
+    boolean force_grayscale;  /* if TRUE, convert color image to grayscale */
+    boolean crop;         /* if TRUE, crop source image */
+
+    /* Crop parameters: application need not set these unless crop is TRUE.
+     * These can be filled in by jtransform_parse_crop_spec().
+     */
+    JDIMENSION crop_width;    /* Width of selected region */
+    JCROP_CODE crop_width_set;
+    JDIMENSION crop_height;   /* Height of selected region */
+    JCROP_CODE crop_height_set;
+    JDIMENSION crop_xoffset;  /* X offset of selected region */
+    JCROP_CODE crop_xoffset_set;  /* (negative measures from right edge) */
+    JDIMENSION crop_yoffset;  /* Y offset of selected region */
+    JCROP_CODE crop_yoffset_set;  /* (negative measures from bottom edge) */
+
+    /* Internal workspace: caller should not touch these */
+    int num_components;       /* # of components in workspace */
+    jvirt_barray_ptr * workspace_coef_arrays; /* workspace for transformations */
+    JDIMENSION output_width;  /* cropped destination dimensions */
+    JDIMENSION output_height;
+    JDIMENSION x_crop_offset; /* destination crop offsets measured in iMCUs */
+    JDIMENSION y_crop_offset;
+    int iMCU_sample_width;    /* destination iMCU size */
+    int iMCU_sample_height;
 } jpeg_transform_info;
 
-
 #if TRANSFORMS_SUPPORTED
 
 /* Parse a crop specification (written in X11 geometry style) */
 EXTERN(boolean) jtransform_parse_crop_spec
-	JPP((jpeg_transform_info *info, const char *spec));
+JPP((jpeg_transform_info *info, const char *spec));
 /* Request any required workspace */
 EXTERN(boolean) jtransform_request_workspace
-	JPP((j_decompress_ptr srcinfo, jpeg_transform_info *info));
+JPP((j_decompress_ptr srcinfo, jpeg_transform_info *info));
 /* Adjust output image parameters */
 EXTERN(jvirt_barray_ptr *) jtransform_adjust_parameters
-	JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
-	     jvirt_barray_ptr *src_coef_arrays,
-	     jpeg_transform_info *info));
+JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
+     jvirt_barray_ptr *src_coef_arrays,
+     jpeg_transform_info *info));
 /* Execute the actual transformation, if any */
 EXTERN(void) jtransform_execute_transform
-	JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
-	     jvirt_barray_ptr *src_coef_arrays,
-	     jpeg_transform_info *info));
+JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
+     jvirt_barray_ptr *src_coef_arrays,
+     jpeg_transform_info *info));
 /* Determine whether lossless transformation is perfectly
  * possible for a specified image and transformation.
  */
 EXTERN(boolean) jtransform_perfect_transform
-	JPP((JDIMENSION image_width, JDIMENSION image_height,
-	     int MCU_width, int MCU_height,
-	     JXFORM_CODE transform));
+JPP((JDIMENSION image_width, JDIMENSION image_height,
+     int MCU_width, int MCU_height,
+     JXFORM_CODE transform));
 
 /* jtransform_execute_transform used to be called
  * jtransform_execute_transformation, but some compilers complain about
  * routine names that long.  This macro is here to avoid breaking any
  * old source code that uses the original name...
  */
-#define jtransform_execute_transformation	jtransform_execute_transform
+#define jtransform_execute_transformation   jtransform_execute_transform
 
 #endif /* TRANSFORMS_SUPPORTED */
 
-
 /*
  * Support for copying optional markers from source to destination file.
  */
 
 typedef enum {
-	JCOPYOPT_NONE,		/* copy no optional markers */
-	JCOPYOPT_COMMENTS,	/* copy only comment (COM) markers */
-	JCOPYOPT_ALL		/* copy all optional markers */
+    JCOPYOPT_NONE,      /* copy no optional markers */
+    JCOPYOPT_COMMENTS,  /* copy only comment (COM) markers */
+    JCOPYOPT_ALL        /* copy all optional markers */
 } JCOPY_OPTION;
 
-#define JCOPYOPT_DEFAULT  JCOPYOPT_COMMENTS	/* recommended default */
+#define JCOPYOPT_DEFAULT  JCOPYOPT_COMMENTS /* recommended default */
 
 /* Setup decompression object to save desired markers in memory */
 EXTERN(void) jcopy_markers_setup
-	JPP((j_decompress_ptr srcinfo, JCOPY_OPTION option));
+JPP((j_decompress_ptr srcinfo, JCOPY_OPTION option));
 /* Copy markers saved in the given source object to the destination object */
 EXTERN(void) jcopy_markers_execute
-	JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
-	     JCOPY_OPTION option));
+JPP((j_decompress_ptr srcinfo, j_compress_ptr dstinfo,
+     JCOPY_OPTION option));

=== modified file 'lib/memoryutils.cpp'
--- lib/memoryutils.cpp	2011-07-20 13:46:34 +0000
+++ lib/memoryutils.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -38,113 +38,110 @@
 #include <vm/vm_param.h>
 #endif
 
-namespace Gwenview {
-
-
-namespace MemoryUtils {
+namespace Gwenview
+{
+
+namespace MemoryUtils
+{
 
 // This code has been copied from okular/core/document.cpp
-qulonglong getTotalMemory() {
+qulonglong getTotalMemory()
+{
     static qulonglong cachedValue = 0;
-    if ( cachedValue )
+    if (cachedValue)
         return cachedValue;
 
 #if defined(Q_OS_LINUX)
     // if /proc/meminfo doesn't exist, return 128MB
-    QFile memFile( "/proc/meminfo" );
-    if ( !memFile.open( QIODevice::ReadOnly ) )
+    QFile memFile("/proc/meminfo");
+    if (!memFile.open(QIODevice::ReadOnly))
         return (cachedValue = 134217728);
 
     // read /proc/meminfo and sum up the contents of 'MemFree', 'Buffers'
     // and 'Cached' fields. consider swapped memory as used memory.
-    QTextStream readStream( &memFile );
-     while ( true )
-    {
+    QTextStream readStream(&memFile);
+    while (true) {
         QString entry = readStream.readLine();
-        if ( entry.isNull() ) break;
-        if ( entry.startsWith( "MemTotal:" ) )
-            return (cachedValue = (Q_UINT64_C(1024) * entry.section( ' ', -2, -2 ).toULongLong()));
+        if (entry.isNull()) break;
+        if (entry.startsWith("MemTotal:"))
+            return (cachedValue = (Q_UINT64_C(1024) * entry.section(' ', -2, -2).toULongLong()));
     }
 #elif defined(Q_OS_FREEBSD)
     qulonglong physmem;
     int mib[] = {CTL_HW, HW_PHYSMEM};
-    size_t len = sizeof( physmem );
-    if ( sysctl( mib, 2, &physmem, &len, NULL, 0 ) == 0 )
+    size_t len = sizeof(physmem);
+    if (sysctl(mib, 2, &physmem, &len, NULL, 0) == 0)
         return (cachedValue = physmem);
 #elif defined(Q_OS_WIN)
     MEMORYSTATUSEX stat;
     stat.dwLength = sizeof(stat);
-    GlobalMemoryStatusEx (&stat);
+    GlobalMemoryStatusEx(&stat);
 
-    return ( cachedValue = stat.ullTotalPhys );
+    return (cachedValue = stat.ullTotalPhys);
 #endif
     return (cachedValue = 134217728);
 }
 
-
-qulonglong getFreeMemory() {
+qulonglong getFreeMemory()
+{
     static QTime lastUpdate = QTime::currentTime();
     static qulonglong cachedValue = 0;
 
-    if ( lastUpdate.secsTo( QTime::currentTime() ) <= 2 )
+    if (lastUpdate.secsTo(QTime::currentTime()) <= 2)
         return cachedValue;
 
 #if defined(Q_OS_LINUX)
     // if /proc/meminfo doesn't exist, return MEMORY FULL
-    QFile memFile( "/proc/meminfo" );
-    if ( !memFile.open( QIODevice::ReadOnly ) )
+    QFile memFile("/proc/meminfo");
+    if (!memFile.open(QIODevice::ReadOnly))
         return 0;
 
     // read /proc/meminfo and sum up the contents of 'MemFree', 'Buffers'
     // and 'Cached' fields. consider swapped memory as used memory.
     qulonglong memoryFree = 0;
     QString entry;
-    QTextStream readStream( &memFile );
-    while ( true )
-    {
+    QTextStream readStream(&memFile);
+    while (true) {
         entry = readStream.readLine();
-        if ( entry.isNull() ) break;
-        if ( entry.startsWith( "MemFree:" ) ||
-                entry.startsWith( "Buffers:" ) ||
-                entry.startsWith( "Cached:" ) ||
-                entry.startsWith( "SwapFree:" ) )
-            memoryFree += entry.section( ' ', -2, -2 ).toULongLong();
-        if ( entry.startsWith( "SwapTotal:" ) )
-            memoryFree -= entry.section( ' ', -2, -2 ).toULongLong();
+        if (entry.isNull()) break;
+        if (entry.startsWith("MemFree:") ||
+                entry.startsWith("Buffers:") ||
+                entry.startsWith("Cached:") ||
+                entry.startsWith("SwapFree:"))
+            memoryFree += entry.section(' ', -2, -2).toULongLong();
+        if (entry.startsWith("SwapTotal:"))
+            memoryFree -= entry.section(' ', -2, -2).toULongLong();
     }
     memFile.close();
 
     lastUpdate = QTime::currentTime();
 
-    return ( cachedValue = (Q_UINT64_C(1024) * memoryFree) );
+    return (cachedValue = (Q_UINT64_C(1024) * memoryFree));
 #elif defined(Q_OS_FREEBSD)
     qulonglong cache, inact, free, psize;
     size_t cachelen, inactlen, freelen, psizelen;
-    cachelen = sizeof( cache );
-    inactlen = sizeof( inact );
-    freelen = sizeof( free );
-    psizelen = sizeof( psize );
+    cachelen = sizeof(cache);
+    inactlen = sizeof(inact);
+    freelen = sizeof(free);
+    psizelen = sizeof(psize);
     // sum up inactive, cached and free memory
-    if ( sysctlbyname( "vm.stats.vm.v_cache_count", &cache, &cachelen, NULL, 0 ) == 0 &&
-            sysctlbyname( "vm.stats.vm.v_inactive_count", &inact, &inactlen, NULL, 0 ) == 0 &&
-            sysctlbyname( "vm.stats.vm.v_free_count", &free, &freelen, NULL, 0 ) == 0 &&
-            sysctlbyname( "vm.stats.vm.v_page_size", &psize, &psizelen, NULL, 0 ) == 0 )
-    {
+    if (sysctlbyname("vm.stats.vm.v_cache_count", &cache, &cachelen, NULL, 0) == 0 &&
+            sysctlbyname("vm.stats.vm.v_inactive_count", &inact, &inactlen, NULL, 0) == 0 &&
+            sysctlbyname("vm.stats.vm.v_free_count", &free, &freelen, NULL, 0) == 0 &&
+            sysctlbyname("vm.stats.vm.v_page_size", &psize, &psizelen, NULL, 0) == 0) {
         lastUpdate = QTime::currentTime();
         return (cachedValue = (cache + inact + free) * psize);
-    }
-    else
-    {
+    } else {
         return 0;
     }
 #elif defined(Q_OS_WIN)
     MEMORYSTATUSEX stat;
     stat.dwLength = sizeof(stat);
-    GlobalMemoryStatusEx (&stat);
+    GlobalMemoryStatusEx(&stat);
 
     lastUpdate = QTime::currentTime();
 
-    return ( cachedValue = stat.ullAvailPhys );
+    return (cachedValue = stat.ullAvailPhys);
 #else
     // tell the memory is full.. will act as in LOW profile
     return 0;

=== modified file 'lib/memoryutils.h'
--- lib/memoryutils.h	2011-07-20 13:46:34 +0000
+++ lib/memoryutils.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,10 +30,11 @@
 
 // Local
 
-namespace Gwenview {
-
-
-namespace MemoryUtils {
+namespace Gwenview
+{
+
+namespace MemoryUtils
+{
 
 /**
  * This function returns the amount of total memory installed on the system
@@ -50,7 +51,6 @@
 
 } // namespace
 
-
 } // namespace
 
 #endif /* MEMORYUTILS_H */

=== modified file 'lib/messagebubble.cpp'
--- lib/messagebubble.cpp	2011-07-20 13:46:34 +0000
+++ lib/messagebubble.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -34,112 +34,113 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 static const int TIMEOUT = 10000;
 
-class PieWidget : public QWidget {
+class PieWidget : public QWidget
+{
 public:
-	PieWidget(QWidget* parent=0)
-	: QWidget(parent)
-	, mValue(0)
-	{
-		setMinimumSize(16, 16);
-	}
-
-	void setValue(qreal value) {
-		mValue = value;
-		update();
-	}
-
-	int heightForWidth(int width) const {
-		return width;
-	}
+    PieWidget(QWidget* parent = 0)
+        : QWidget(parent)
+        , mValue(0) {
+        setMinimumSize(16, 16);
+    }
+
+    void setValue(qreal value)
+    {
+        mValue = value;
+        update();
+    }
+
+    int heightForWidth(int width) const {
+        return width;
+    }
 
 protected:
-	void paintEvent(QPaintEvent*) {
-		QPainter painter(this);
-		painter.setRenderHint(QPainter::Antialiasing);
-		const int circle = 5760;
-		const int start = circle / 4; // Start at 12h, not 3h
-		const int end = int(circle * mValue);
-		painter.setBrush(palette().dark());
-		painter.setPen(palette().light().color());
+    void paintEvent(QPaintEvent*)
+    {
+        QPainter painter(this);
+        painter.setRenderHint(QPainter::Antialiasing);
+        const int circle = 5760;
+        const int start = circle / 4; // Start at 12h, not 3h
+        const int end = int(circle * mValue);
+        painter.setBrush(palette().dark());
+        painter.setPen(palette().light().color());
 
-		QRectF square = QRectF(rect()).adjusted(.5, .5, -.5, -.5);
-		qreal width = square.width();
-		qreal height= square.height();
-		if (width < height) {
-			square.setHeight(width);
-			square.moveTop((height - width) / 2);
-		} else {
-			square.setWidth(height);
-			square.moveLeft((width - height) / 2);
-		}
-		painter.drawPie(square, start, end);
-	}
+        QRectF square = QRectF(rect()).adjusted(.5, .5, -.5, -.5);
+        qreal width = square.width();
+        qreal height = square.height();
+        if (width < height) {
+            square.setHeight(width);
+            square.moveTop((height - width) / 2);
+        } else {
+            square.setWidth(height);
+            square.moveLeft((width - height) / 2);
+        }
+        painter.drawPie(square, start, end);
+    }
 
 private:
-	qreal mValue;
+    qreal mValue;
 };
 
-
 struct MessageBubblePrivate {
-	PieWidget* mCountDownWidget;
-	QWidget* mWidget;
-	QLabel* mLabel;
+    PieWidget* mCountDownWidget;
+    QWidget* mWidget;
+    QLabel* mLabel;
 };
 
-
 MessageBubble::MessageBubble(QWidget* parent)
 : HudWidget(parent)
-, d(new MessageBubblePrivate) {
-	d->mWidget = new QWidget;
-	d->mCountDownWidget = new PieWidget;
-	d->mCountDownWidget->setValue(1);
-	d->mLabel = new QLabel;
-
-	QTimeLine* timeLine = new QTimeLine(TIMEOUT, this);
-	connect(timeLine, SIGNAL(valueChanged(qreal)),
-		SLOT(slotTimeLineChanged(qreal)));
-	connect(timeLine, SIGNAL(finished()),
-		SLOT(deleteLater()));
-	timeLine->start();
-
-	QHBoxLayout* layout = new QHBoxLayout(d->mWidget);
-	layout->setMargin(0);
-	layout->addWidget(d->mCountDownWidget);
-	layout->addWidget(d->mLabel);
-
-	init(d->mWidget, HudWidget::OptionCloseButton);
-}
-
-
-MessageBubble::~MessageBubble() {
-	delete d;
-}
-
-
-void MessageBubble::setText(const QString& text) {
-	d->mLabel->setText(text);
-	adjustSize();
-}
-
-
-QToolButton* MessageBubble::addButton(const KGuiItem& guiItem) {
-	QToolButton* button = new QToolButton;
-	button->setText(guiItem.text());
-	button->setIcon(guiItem.icon());
-	button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
-	d->mWidget->layout()->addWidget(button);
-	adjustSize();
-	return button;
-}
-
-
-void MessageBubble::slotTimeLineChanged(qreal value) {
-	d->mCountDownWidget->setValue(1 - value);
-}
-
+, d(new MessageBubblePrivate)
+{
+    d->mWidget = new QWidget;
+    d->mCountDownWidget = new PieWidget;
+    d->mCountDownWidget->setValue(1);
+    d->mLabel = new QLabel;
+
+    QTimeLine* timeLine = new QTimeLine(TIMEOUT, this);
+    connect(timeLine, SIGNAL(valueChanged(qreal)),
+            SLOT(slotTimeLineChanged(qreal)));
+    connect(timeLine, SIGNAL(finished()),
+            SLOT(deleteLater()));
+    timeLine->start();
+
+    QHBoxLayout* layout = new QHBoxLayout(d->mWidget);
+    layout->setMargin(0);
+    layout->addWidget(d->mCountDownWidget);
+    layout->addWidget(d->mLabel);
+
+    init(d->mWidget, HudWidget::OptionCloseButton);
+}
+
+MessageBubble::~MessageBubble()
+{
+    delete d;
+}
+
+void MessageBubble::setText(const QString& text)
+{
+    d->mLabel->setText(text);
+    adjustSize();
+}
+
+QToolButton* MessageBubble::addButton(const KGuiItem& guiItem)
+{
+    QToolButton* button = new QToolButton;
+    button->setText(guiItem.text());
+    button->setIcon(guiItem.icon());
+    button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
+    d->mWidget->layout()->addWidget(button);
+    adjustSize();
+    return button;
+}
+
+void MessageBubble::slotTimeLineChanged(qreal value)
+{
+    d->mCountDownWidget->setValue(1 - value);
+}
 
 } // namespace

=== modified file 'lib/messagebubble.h'
--- lib/messagebubble.h	2011-07-20 13:46:34 +0000
+++ lib/messagebubble.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -34,32 +34,32 @@
 
 class KGuiItem;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct MessageBubblePrivate;
 /**
  * Shows a bubble with a QLabel and optional buttons.
  * Automatically goes away after a while.
  */
-class GWENVIEWLIB_EXPORT MessageBubble : public HudWidget {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT MessageBubble : public HudWidget
+{
+    Q_OBJECT
 public:
-	MessageBubble(QWidget* parent = 0);
-	~MessageBubble();
-
-	void setText(const QString& text);
-
-	QToolButton* addButton(const KGuiItem&);
+    MessageBubble(QWidget* parent = 0);
+    ~MessageBubble();
+
+    void setText(const QString& text);
+
+    QToolButton* addButton(const KGuiItem&);
 
 private Q_SLOTS:
-	void slotTimeLineChanged(qreal);
+    void slotTimeLineChanged(qreal);
 
 private:
-	MessageBubblePrivate* const d;
+    MessageBubblePrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* MESSAGEBUBBLE_H */

=== modified file 'lib/mimetypeutils.cpp'
--- lib/mimetypeutils.cpp	2011-07-20 13:46:34 +0000
+++ lib/mimetypeutils.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab
+// vim: set tabstop=4 shiftwidth=4 expandtab
 /*
 Gwenview - A simple image viewer for KDE
 Copyright 2006 Aurelien Gateau <agateau@kde.org>
@@ -40,134 +40,136 @@
 // Local
 #include <archiveutils.h>
 
-namespace Gwenview {
-
-namespace MimeTypeUtils {
-
-static inline QString resolveAlias(const QString& name) {
-	KMimeType::Ptr ptr = KMimeType::mimeType(name, KMimeType::ResolveAliases);
-	return ptr.isNull() ? name : ptr->name();
-}
-
-static void resolveAliasInList(QStringList* list) {
-	QStringList::Iterator
-		it = list->begin(),
-		end = list->end();
-	for (; it != end; ++it) {
-		*it = resolveAlias(*it);
-	}
-}
-
-
-const QStringList& rasterImageMimeTypes() {
-	static QStringList list;
-	if (list.isEmpty()) {
-		list = KImageIO::mimeTypes(KImageIO::Reading);
-		resolveAliasInList(&list);
-	}
-	return list;
-}
-
-
-const QStringList& svgImageMimeTypes() {
-	static QStringList list;
-	if (list.isEmpty()) {
-		list << "image/svg+xml" << "image/svg+xml-compressed";
-		resolveAliasInList(&list);
-	}
-	return list;
-}
-
-
-const QStringList& imageMimeTypes() {
-	static QStringList list;
-	if (list.isEmpty()) {
-		list = rasterImageMimeTypes();
-		list += svgImageMimeTypes();
-	}
-
-	return list;
-}
-
-
-QString urlMimeType(const KUrl& url) {
-	// Try a simple guess, using extension for remote urls
-	QString mimeType = KMimeType::findByUrl(url)->name();
-	if (mimeType == "application/octet-stream") {
-		// No luck, look deeper. This can happens with http urls if the filename
-		// does not provide any extension.
-		mimeType = KIO::NetAccess::mimetype(url, KApplication::kApplication()->activeWindow());
-	}
-	return mimeType;
-}
-
-
-QString urlMimeTypeByContent(const KUrl& url) {
-	const int HEADER_SIZE = 30;
-	if (url.isLocalFile()) {
-		return KMimeType::findByFileContent(url.toLocalFile())->name();
-	}
-
-	KIO::TransferJob* job = KIO::get(url);
-	DataAccumulator accumulator(job);
-	while (!accumulator.finished() && accumulator.data().size() < HEADER_SIZE) {
-		qApp->processEvents(QEventLoop::ExcludeUserInputEvents);
-	}
-	return KMimeType::findByContent(accumulator.data())->name();
-}
-
-
-Kind mimeTypeKind(const QString& mimeType) {
-	if (rasterImageMimeTypes().contains(mimeType)) {
-		return KIND_RASTER_IMAGE;
-	}
-	if (svgImageMimeTypes().contains(mimeType)) {
-		return KIND_SVG_IMAGE;
-	}
-	if (mimeType.startsWith(QLatin1String("video/"))) {
-		return KIND_VIDEO;
-	}
-	if (mimeType.startsWith(QLatin1String("inode/directory"))) {
-		return KIND_DIR;
-	}
-	if (!ArchiveUtils::protocolForMimeType(mimeType).isEmpty()) {
-		return KIND_ARCHIVE;
-	}
-
-	return KIND_FILE;
-}
-
-
-Kind fileItemKind(const KFileItem& item) {
-	return mimeTypeKind(item.mimetype());
-}
-
-
-Kind urlKind(const KUrl& url) {
-	return mimeTypeKind(urlMimeType(url));
-}
-
+namespace Gwenview
+{
+
+namespace MimeTypeUtils
+{
+
+static inline QString resolveAlias(const QString& name)
+{
+    KMimeType::Ptr ptr = KMimeType::mimeType(name, KMimeType::ResolveAliases);
+    return ptr.isNull() ? name : ptr->name();
+}
+
+static void resolveAliasInList(QStringList* list)
+{
+    QStringList::Iterator
+    it = list->begin(),
+    end = list->end();
+    for (; it != end; ++it) {
+        *it = resolveAlias(*it);
+    }
+}
+
+const QStringList& rasterImageMimeTypes()
+{
+    static QStringList list;
+    if (list.isEmpty()) {
+        list = KImageIO::mimeTypes(KImageIO::Reading);
+        resolveAliasInList(&list);
+    }
+    return list;
+}
+
+const QStringList& svgImageMimeTypes()
+{
+    static QStringList list;
+    if (list.isEmpty()) {
+        list << "image/svg+xml" << "image/svg+xml-compressed";
+        resolveAliasInList(&list);
+    }
+    return list;
+}
+
+const QStringList& imageMimeTypes()
+{
+    static QStringList list;
+    if (list.isEmpty()) {
+        list = rasterImageMimeTypes();
+        list += svgImageMimeTypes();
+    }
+
+    return list;
+}
+
+QString urlMimeType(const KUrl& url)
+{
+    // Try a simple guess, using extension for remote urls
+    QString mimeType = KMimeType::findByUrl(url)->name();
+    if (mimeType == "application/octet-stream") {
+        // No luck, look deeper. This can happens with http urls if the filename
+        // does not provide any extension.
+        mimeType = KIO::NetAccess::mimetype(url, KApplication::kApplication()->activeWindow());
+    }
+    return mimeType;
+}
+
+QString urlMimeTypeByContent(const KUrl& url)
+{
+    const int HEADER_SIZE = 30;
+    if (url.isLocalFile()) {
+        return KMimeType::findByFileContent(url.toLocalFile())->name();
+    }
+
+    KIO::TransferJob* job = KIO::get(url);
+    DataAccumulator accumulator(job);
+    while (!accumulator.finished() && accumulator.data().size() < HEADER_SIZE) {
+        qApp->processEvents(QEventLoop::ExcludeUserInputEvents);
+    }
+    return KMimeType::findByContent(accumulator.data())->name();
+}
+
+Kind mimeTypeKind(const QString& mimeType)
+{
+    if (rasterImageMimeTypes().contains(mimeType)) {
+        return KIND_RASTER_IMAGE;
+    }
+    if (svgImageMimeTypes().contains(mimeType)) {
+        return KIND_SVG_IMAGE;
+    }
+    if (mimeType.startsWith(QLatin1String("video/"))) {
+        return KIND_VIDEO;
+    }
+    if (mimeType.startsWith(QLatin1String("inode/directory"))) {
+        return KIND_DIR;
+    }
+    if (!ArchiveUtils::protocolForMimeType(mimeType).isEmpty()) {
+        return KIND_ARCHIVE;
+    }
+
+    return KIND_FILE;
+}
+
+Kind fileItemKind(const KFileItem& item)
+{
+    return mimeTypeKind(item.mimetype());
+}
+
+Kind urlKind(const KUrl& url)
+{
+    return mimeTypeKind(urlMimeType(url));
+}
 
 DataAccumulator::DataAccumulator(KIO::TransferJob* job)
 : QObject()
 , mFinished(false)
 {
-	connect(job, SIGNAL(data(KIO::Job*, const QByteArray&)),
-		SLOT(slotDataReceived(KIO::Job*, const QByteArray&)) );
-	connect(job, SIGNAL(result(KJob*)),
-		SLOT(slotFinished()) );
-}
-
-
-void DataAccumulator::slotDataReceived(KIO::Job*, const QByteArray& data) {
-	mData += data;
-}
-
-
-void DataAccumulator::slotFinished() {
-	mFinished = true;
-}
-
+    connect(job, SIGNAL(data(KIO::Job*, QByteArray)),
+            SLOT(slotDataReceived(KIO::Job*, QByteArray)));
+    connect(job, SIGNAL(result(KJob*)),
+            SLOT(slotFinished()));
+}
+
+void DataAccumulator::slotDataReceived(KIO::Job*, const QByteArray& data)
+{
+    mData += data;
+}
+
+void DataAccumulator::slotFinished()
+{
+    mFinished = true;
+}
 
 } // namespace MimeTypeUtils
 } // namespace Gwenview

=== modified file 'lib/mimetypeutils.h'
--- lib/mimetypeutils.h	2011-07-20 13:46:34 +0000
+++ lib/mimetypeutils.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab
+// vim: set tabstop=4 shiftwidth=4 expandtab
 /*
 Gwenview - A simple image viewer for KDE
 Copyright 2006 Aurelien Gateau <agateau@kde.org>
@@ -29,9 +29,11 @@
 class KFileItem;
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace MimeTypeUtils {
+namespace MimeTypeUtils
+{
 
 GWENVIEWLIB_EXPORT const QStringList& rasterImageMimeTypes();
 GWENVIEWLIB_EXPORT const QStringList& svgImageMimeTypes();
@@ -45,13 +47,13 @@
 GWENVIEWLIB_EXPORT QString urlMimeTypeByContent(const KUrl&);
 
 enum Kind {
-	KIND_UNKNOWN      = 0,
-	KIND_DIR          = 1,
-	KIND_ARCHIVE      = 1 << 2,
-	KIND_FILE         = 1 << 3,
-	KIND_RASTER_IMAGE = 1 << 4,
-	KIND_SVG_IMAGE    = 1 << 5,
-	KIND_VIDEO        = 1 << 6
+    KIND_UNKNOWN      = 0,
+    KIND_DIR          = 1,
+    KIND_ARCHIVE      = 1 << 2,
+    KIND_FILE         = 1 << 3,
+    KIND_RASTER_IMAGE = 1 << 4,
+    KIND_SVG_IMAGE    = 1 << 5,
+    KIND_VIDEO        = 1 << 6
 };
 Q_DECLARE_FLAGS(Kinds, Kind)
 

=== modified file 'lib/mimetypeutils_p.h'
--- lib/mimetypeutils_p.h	2011-07-20 13:46:34 +0000
+++ lib/mimetypeutils_p.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -25,35 +25,42 @@
 #include <QByteArray>
 #include <QObject>
 
-namespace KIO { class Job; class TransferJob; }
-
-namespace Gwenview {
-
-namespace MimeTypeUtils {
+namespace KIO
+{
+class Job;
+class TransferJob;
+}
+
+namespace Gwenview
+{
+
+namespace MimeTypeUtils
+{
 /**
  * A simple helper class used to determine mime type in some extreme cases
  * where we need to download the url header
  */
-class DataAccumulator : public QObject {
-	Q_OBJECT
+class DataAccumulator : public QObject
+{
+    Q_OBJECT
 public:
-	DataAccumulator(KIO::TransferJob* job);
-
-	const QByteArray& data() const {
-		return mData;
-	}
-
-	bool finished() const {
-		return mFinished;
-	}
+    DataAccumulator(KIO::TransferJob* job);
+
+    const QByteArray& data() const {
+        return mData;
+    }
+
+    bool finished() const {
+        return mFinished;
+    }
 
 private Q_SLOTS:
-	void slotDataReceived(KIO::Job*, const QByteArray& data);
-	void slotFinished();
+    void slotDataReceived(KIO::Job*, const QByteArray& data);
+    void slotFinished();
 
 private:
-	QByteArray mData;
-	bool mFinished;
+    QByteArray mData;
+    bool mFinished;
 };
 
 } // namespace MimeTypeUtils

=== modified file 'lib/mousewheelbehavior.h'
--- lib/mousewheelbehavior.h	2011-07-20 13:46:34 +0000
+++ lib/mousewheelbehavior.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -27,13 +27,15 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace MouseWheelBehavior {
-	enum Enum {
-		Scroll,
-		Browse
-	};
+namespace MouseWheelBehavior
+{
+enum Enum {
+    Scroll,
+    Browse
+};
 
 } // namespace MouseWheelBehavior
 

=== modified file 'lib/orientation.h'
--- lib/orientation.h	2011-07-20 13:46:34 +0000
+++ lib/orientation.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab
+// vim: set tabstop=4 shiftwidth=4 expandtab
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -21,14 +21,14 @@
 #ifndef ORIENTATION_H
 #define ORIENTATION_H
 
-
-namespace Gwenview {
+namespace Gwenview
+{
 
 /* Explanation extracted from http://sylvana.net/jpegcrop/exif_orientation.html
 
    For convenience, here is what the letter F would look like if it were tagged
 correctly and displayed by a program that ignores the orientation tag (thus
-showing the stored image): 
+showing the stored image):
 
   1        2       3      4         5            6           7          8
 
@@ -41,18 +41,17 @@
 */
 
 enum Orientation {
-	NOT_AVAILABLE=0,
-	NORMAL=1,
-	HFLIP=2,
-	ROT_180=3,
-	VFLIP=4,
-	TRANSPOSE=5,
-	ROT_90=6,
-	TRANSVERSE=7,
-	ROT_270=8
+    NOT_AVAILABLE = 0,
+    NORMAL = 1,
+    HFLIP = 2,
+    ROT_180 = 3,
+    VFLIP = 4,
+    TRANSPOSE = 5,
+    ROT_90 = 6,
+    TRANSVERSE = 7,
+    ROT_270 = 8
 };
 
 }
 
-
 #endif

=== modified file 'lib/paintutils.cpp'
--- lib/paintutils.cpp	2011-07-20 13:46:34 +0000
+++ lib/paintutils.cpp	2011-12-15 14:17:54 +0000
@@ -27,126 +27,129 @@
 #include <QPixmap>
 #include <QRectF>
 
-namespace Gwenview {
-
-namespace PaintUtils {
-
+namespace Gwenview
+{
+
+namespace PaintUtils
+{
 
 // Copied from KFileItemDelegate
-QPainterPath roundedRectangle(const QRectF &rect, qreal radius) {
-	QPainterPath path(QPointF(rect.left(), rect.top() + radius));
-	path.quadTo(rect.left(), rect.top(), rect.left() + radius, rect.top());         // Top left corner
-	path.lineTo(rect.right() - radius, rect.top());                                 // Top side
-	path.quadTo(rect.right(), rect.top(), rect.right(), rect.top() + radius);       // Top right corner
-	path.lineTo(rect.right(), rect.bottom() - radius);                              // Right side
-	path.quadTo(rect.right(), rect.bottom(), rect.right() - radius, rect.bottom()); // Bottom right corner
-	path.lineTo(rect.left() + radius, rect.bottom());                               // Bottom side
-	path.quadTo(rect.left(), rect.bottom(), rect.left(), rect.bottom() - radius);   // Bottom left corner
-	path.closeSubpath();
-
-	return path;
-}
-
-
-QPixmap generateFuzzyRect(const QSize& size, const QColor& color, int radius) {
-	QPixmap pix(size);
-	const QColor transparent(0, 0, 0, 0);
-	pix.fill(transparent);
-
-	QPainter painter(&pix);
-	painter.setRenderHint(QPainter::Antialiasing, true);
-
-	// Fill middle
-	painter.fillRect(pix.rect().adjusted(radius, radius, -radius, -radius), color);
-
-	// Corners
-	QRadialGradient gradient;
-	gradient.setColorAt(0, color);
-	gradient.setColorAt(1, transparent);
-	gradient.setRadius(radius);
-	QPoint center;
-
-	// Top Left
-	center = QPoint(radius, radius);
-	gradient.setCenter(center);
-	gradient.setFocalPoint(center);
-	painter.fillRect(0, 0, radius, radius, gradient);
-
-	// Top right
-	center = QPoint(size.width() - radius, radius);
-	gradient.setCenter(center);
-	gradient.setFocalPoint(center);
-	painter.fillRect(center.x(), 0, radius, radius, gradient);
-
-	// Bottom left
-	center = QPoint(radius, size.height() - radius);
-	gradient.setCenter(center);
-	gradient.setFocalPoint(center);
-	painter.fillRect(0, center.y(), radius, radius, gradient);
-
-	// Bottom right
-	center = QPoint(size.width() - radius, size.height() - radius);
-	gradient.setCenter(center);
-	gradient.setFocalPoint(center);
-	painter.fillRect(center.x(), center.y(), radius, radius, gradient);
-
-	// Borders
-	QLinearGradient linearGradient;
-	linearGradient.setColorAt(0, color);
-	linearGradient.setColorAt(1, transparent);
-
-	// Top
-	linearGradient.setStart(0, radius);
-	linearGradient.setFinalStop(0, 0);
-	painter.fillRect(radius, 0, size.width() - 2*radius, radius, linearGradient);
-
-	// Bottom
-	linearGradient.setStart(0, size.height() - radius);
-	linearGradient.setFinalStop(0, size.height());
-	painter.fillRect(radius, int(linearGradient.start().y()), size.width() - 2*radius, radius, linearGradient);
-
-	// Left
-	linearGradient.setStart(radius, 0);
-	linearGradient.setFinalStop(0, 0);
-	painter.fillRect(0, radius, radius, size.height() - 2*radius, linearGradient);
-
-	// Right
-	linearGradient.setStart(size.width() - radius, 0);
-	linearGradient.setFinalStop(size.width(), 0);
-	painter.fillRect(int(linearGradient.start().x()), radius, radius, size.height() - 2*radius, linearGradient);
-	return pix;
-}
-
-
-QColor adjustedHsv(const QColor& color, int deltaH, int deltaS, int deltaV) {
-	int hue, saturation, value;
-	color.getHsv(&hue, &saturation, &value);
-	return QColor::fromHsv(
-		qBound(0, hue + deltaH, 359),
-		qBound(0, saturation + deltaS, 255),
-		qBound(0, value + deltaV, 255)
-		);
-}
-
-
-QColor alphaAdjustedF(const QColor& color, qreal alphaF) {
-	QColor tmp = color;
-	tmp.setAlphaF(alphaF);
-	return tmp;
-}
-
-QRect containingRect(const QRectF& rectF) {
-	return QRect(
-		QPoint(
-			qRound(floor(rectF.left())),
-			qRound(floor(rectF.top()))
-			),
-		QPoint(
-			qRound(ceil(rectF.right() - 1.)),
-			qRound(ceil(rectF.bottom() - 1.))
-			)
-		);
-	// Note: QRect::right = left + width - 1, while QRectF::right = left + width
+QPainterPath roundedRectangle(const QRectF &rect, qreal radius)
+{
+    QPainterPath path(QPointF(rect.left(), rect.top() + radius));
+    path.quadTo(rect.left(), rect.top(), rect.left() + radius, rect.top());         // Top left corner
+    path.lineTo(rect.right() - radius, rect.top());                                 // Top side
+    path.quadTo(rect.right(), rect.top(), rect.right(), rect.top() + radius);       // Top right corner
+    path.lineTo(rect.right(), rect.bottom() - radius);                              // Right side
+    path.quadTo(rect.right(), rect.bottom(), rect.right() - radius, rect.bottom()); // Bottom right corner
+    path.lineTo(rect.left() + radius, rect.bottom());                               // Bottom side
+    path.quadTo(rect.left(), rect.bottom(), rect.left(), rect.bottom() - radius);   // Bottom left corner
+    path.closeSubpath();
+
+    return path;
+}
+
+QPixmap generateFuzzyRect(const QSize& size, const QColor& color, int radius)
+{
+    QPixmap pix(size);
+    const QColor transparent(0, 0, 0, 0);
+    pix.fill(transparent);
+
+    QPainter painter(&pix);
+    painter.setRenderHint(QPainter::Antialiasing, true);
+
+    // Fill middle
+    painter.fillRect(pix.rect().adjusted(radius, radius, -radius, -radius), color);
+
+    // Corners
+    QRadialGradient gradient;
+    gradient.setColorAt(0, color);
+    gradient.setColorAt(1, transparent);
+    gradient.setRadius(radius);
+    QPoint center;
+
+    // Top Left
+    center = QPoint(radius, radius);
+    gradient.setCenter(center);
+    gradient.setFocalPoint(center);
+    painter.fillRect(0, 0, radius, radius, gradient);
+
+    // Top right
+    center = QPoint(size.width() - radius, radius);
+    gradient.setCenter(center);
+    gradient.setFocalPoint(center);
+    painter.fillRect(center.x(), 0, radius, radius, gradient);
+
+    // Bottom left
+    center = QPoint(radius, size.height() - radius);
+    gradient.setCenter(center);
+    gradient.setFocalPoint(center);
+    painter.fillRect(0, center.y(), radius, radius, gradient);
+
+    // Bottom right
+    center = QPoint(size.width() - radius, size.height() - radius);
+    gradient.setCenter(center);
+    gradient.setFocalPoint(center);
+    painter.fillRect(center.x(), center.y(), radius, radius, gradient);
+
+    // Borders
+    QLinearGradient linearGradient;
+    linearGradient.setColorAt(0, color);
+    linearGradient.setColorAt(1, transparent);
+
+    // Top
+    linearGradient.setStart(0, radius);
+    linearGradient.setFinalStop(0, 0);
+    painter.fillRect(radius, 0, size.width() - 2 * radius, radius, linearGradient);
+
+    // Bottom
+    linearGradient.setStart(0, size.height() - radius);
+    linearGradient.setFinalStop(0, size.height());
+    painter.fillRect(radius, int(linearGradient.start().y()), size.width() - 2 * radius, radius, linearGradient);
+
+    // Left
+    linearGradient.setStart(radius, 0);
+    linearGradient.setFinalStop(0, 0);
+    painter.fillRect(0, radius, radius, size.height() - 2 * radius, linearGradient);
+
+    // Right
+    linearGradient.setStart(size.width() - radius, 0);
+    linearGradient.setFinalStop(size.width(), 0);
+    painter.fillRect(int(linearGradient.start().x()), radius, radius, size.height() - 2 * radius, linearGradient);
+    return pix;
+}
+
+QColor adjustedHsv(const QColor& color, int deltaH, int deltaS, int deltaV)
+{
+    int hue, saturation, value;
+    color.getHsv(&hue, &saturation, &value);
+    return QColor::fromHsv(
+               qBound(0, hue + deltaH, 359),
+               qBound(0, saturation + deltaS, 255),
+               qBound(0, value + deltaV, 255)
+           );
+}
+
+QColor alphaAdjustedF(const QColor& color, qreal alphaF)
+{
+    QColor tmp = color;
+    tmp.setAlphaF(alphaF);
+    return tmp;
+}
+
+QRect containingRect(const QRectF& rectF)
+{
+    return QRect(
+               QPoint(
+                   qRound(floor(rectF.left())),
+                   qRound(floor(rectF.top()))
+               ),
+               QPoint(
+                   qRound(ceil(rectF.right() - 1.)),
+                   qRound(ceil(rectF.bottom() - 1.))
+               )
+           );
+    // Note: QRect::right = left + width - 1, while QRectF::right = left + width
 }
 
 } // namespace

=== modified file 'lib/paintutils.h'
--- lib/paintutils.h	2011-07-20 13:46:34 +0000
+++ lib/paintutils.h	2011-12-15 14:17:54 +0000
@@ -22,7 +22,6 @@
 
 #include <lib/gwenviewlib_export.h>
 
-
 class QColor;
 class QPainterPath;
 class QPixmap;
@@ -30,12 +29,14 @@
 class QRectF;
 class QSize;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * A collection of independent painting functions
  */
-namespace PaintUtils {
+namespace PaintUtils
+{
 
 /**
  * Returns a rounded-corner version of @rect. Corner radius is @p radius.

=== modified file 'lib/placetreemodel.cpp'
--- lib/placetreemodel.cpp	2011-07-20 13:46:34 +0000
+++ lib/placetreemodel.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -31,7 +31,8 @@
 // Local
 #include <lib/semanticinfo/sorteddirmodel.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * Here is how the mapping work:
@@ -55,322 +56,316 @@
  */
 
 struct Node {
-	Node()
-	: model(0)
-	{}
-
-	Node(SortedDirModel* _model, const KUrl& _parentUrl)
-	: model(_model)
-	, parentUrl(_parentUrl)
-	{}
-
-	SortedDirModel* model;
-	KUrl parentUrl;
-
-	bool isPlace() const {
-		return !parentUrl.isValid();
-	}
+    Node()
+        : model(0)
+    {}
+
+    Node(SortedDirModel* _model, const KUrl& _parentUrl)
+        : model(_model)
+        , parentUrl(_parentUrl)
+    {}
+
+    SortedDirModel* model;
+    KUrl parentUrl;
+
+    bool isPlace() const {
+        return !parentUrl.isValid();
+    }
 };
 
 typedef QHash<KUrl, Node*> NodeHash;
 typedef QMap<SortedDirModel*, NodeHash*> NodeHashMap;
 
 struct PlaceTreeModelPrivate {
-	PlaceTreeModel* q;
-	KFilePlacesModel* mPlacesModel;
-	QList<SortedDirModel*> mDirModels;
-	mutable NodeHashMap mNodes;
-
-	Node nodeForIndex(const QModelIndex& index) const {
-		Q_ASSERT(index.isValid());
-		Q_ASSERT(index.internalPointer());
-		return *static_cast<Node*>(index.internalPointer());
-	}
-
-
-	Node* createNode(SortedDirModel* dirModel, const KUrl& parentUrl) const {
-		NodeHashMap::iterator nhmIt = mNodes.find(dirModel);
-		if (nhmIt == mNodes.end()) {
-			nhmIt = mNodes.insert(dirModel, new NodeHash);
-		}
-		NodeHash* nodeHash = nhmIt.value();
-
-		NodeHash::iterator nhIt = nodeHash->find(parentUrl);
-		if (nhIt == nodeHash->end()) {
-			nhIt = nodeHash->insert(parentUrl, new Node(dirModel, parentUrl));
-		}
-		return nhIt.value();
-	}
-
-
-	QModelIndex createIndexForDir(SortedDirModel* dirModel, const KUrl& url) const {
-		QModelIndex dirIndex = dirModel->indexForUrl(url);
-		QModelIndex parentDirIndex = dirIndex.parent();
-		KUrl parentUrl;
-		if (parentDirIndex.isValid()) {
-			parentUrl = dirModel->urlForIndex(parentDirIndex);
-		} else {
-			parentUrl = dirModel->dirLister()->url();
-		}
-		return createIndexForDirChild(dirModel, parentUrl, dirIndex.row(), dirIndex.column());
-	}
-
-
-	QModelIndex createIndexForDirChild(SortedDirModel* dirModel, const KUrl& parentUrl, int row, int column) const {
-		Q_ASSERT(parentUrl.isValid());
-		Node* node = createNode(dirModel, parentUrl);
-		return q->createIndex(row, column, node);
-	}
-
-
-	QModelIndex createIndexForPlace(SortedDirModel* dirModel) const {
-		int row = mDirModels.indexOf(dirModel);
-		Q_ASSERT(row != -1);
-		Node* node = createNode(dirModel, KUrl());
-		return q->createIndex(row, 0, node);
-	}
-
-
-	QModelIndex dirIndexForNode(const Node& node, const QModelIndex& index) const {
-		if (node.isPlace()) {
-			return QModelIndex();
-		}
-		Q_ASSERT(node.parentUrl.isValid());
-		const QModelIndex parentDirIndex = node.model->indexForUrl(node.parentUrl);
-		return node.model->index(index.row(), index.column(), parentDirIndex);
-	}
+    PlaceTreeModel* q;
+    KFilePlacesModel* mPlacesModel;
+    QList<SortedDirModel*> mDirModels;
+    mutable NodeHashMap mNodes;
+
+    Node nodeForIndex(const QModelIndex& index) const {
+        Q_ASSERT(index.isValid());
+        Q_ASSERT(index.internalPointer());
+        return *static_cast<Node*>(index.internalPointer());
+    }
+
+    Node* createNode(SortedDirModel* dirModel, const KUrl& parentUrl) const {
+        NodeHashMap::iterator nhmIt = mNodes.find(dirModel);
+        if (nhmIt == mNodes.end()) {
+            nhmIt = mNodes.insert(dirModel, new NodeHash);
+        }
+        NodeHash* nodeHash = nhmIt.value();
+
+        NodeHash::iterator nhIt = nodeHash->find(parentUrl);
+        if (nhIt == nodeHash->end()) {
+            nhIt = nodeHash->insert(parentUrl, new Node(dirModel, parentUrl));
+        }
+        return nhIt.value();
+    }
+
+    QModelIndex createIndexForDir(SortedDirModel* dirModel, const KUrl& url) const {
+        QModelIndex dirIndex = dirModel->indexForUrl(url);
+        QModelIndex parentDirIndex = dirIndex.parent();
+        KUrl parentUrl;
+        if (parentDirIndex.isValid()) {
+            parentUrl = dirModel->urlForIndex(parentDirIndex);
+        } else {
+            parentUrl = dirModel->dirLister()->url();
+        }
+        return createIndexForDirChild(dirModel, parentUrl, dirIndex.row(), dirIndex.column());
+    }
+
+    QModelIndex createIndexForDirChild(SortedDirModel* dirModel, const KUrl& parentUrl, int row, int column) const {
+        Q_ASSERT(parentUrl.isValid());
+        Node* node = createNode(dirModel, parentUrl);
+        return q->createIndex(row, column, node);
+    }
+
+    QModelIndex createIndexForPlace(SortedDirModel* dirModel) const {
+        int row = mDirModels.indexOf(dirModel);
+        Q_ASSERT(row != -1);
+        Node* node = createNode(dirModel, KUrl());
+        return q->createIndex(row, 0, node);
+    }
+
+    QModelIndex dirIndexForNode(const Node& node, const QModelIndex& index) const {
+        if (node.isPlace()) {
+            return QModelIndex();
+        }
+        Q_ASSERT(node.parentUrl.isValid());
+        const QModelIndex parentDirIndex = node.model->indexForUrl(node.parentUrl);
+        return node.model->index(index.row(), index.column(), parentDirIndex);
+    }
 };
 
-
 PlaceTreeModel::PlaceTreeModel(QObject* parent)
 : QAbstractItemModel(parent)
-, d(new PlaceTreeModelPrivate) {
-	d->q = this;
-
-	d->mPlacesModel = new KFilePlacesModel(this);
-	connect(d->mPlacesModel, SIGNAL(rowsInserted(const QModelIndex&, int, int)),
-		SLOT(slotPlacesRowsInserted(const QModelIndex&, int, int)));
-	connect(d->mPlacesModel, SIGNAL(rowsAboutToBeRemoved(const QModelIndex&, int, int)),
-		SLOT(slotPlacesRowsAboutToBeRemoved(const QModelIndex&, int, int)));
-
-	// Bootstrap
-	slotPlacesRowsInserted(QModelIndex(), 0, d->mPlacesModel->rowCount() - 1);
-}
-
-
-PlaceTreeModel::~PlaceTreeModel() {
-	Q_FOREACH(NodeHash* nodeHash, d->mNodes) {
-		qDeleteAll(*nodeHash);
-	}
-	qDeleteAll(d->mNodes);
-	delete d;
-}
-
-
-int PlaceTreeModel::columnCount(const QModelIndex&) const {
-	return 1;
-}
-
-
-QVariant PlaceTreeModel::data(const QModelIndex& index, int role) const {
-	if (!index.isValid()) {
-		return QVariant();
-	}
-	QVariant value;
-	const Node node = d->nodeForIndex(index);
-	if (node.isPlace()) {
-		const QModelIndex placesIndex = d->mPlacesModel->index(index.row(), index.column());
-		value = d->mPlacesModel->data(placesIndex, role);
-	} else {
-		const QModelIndex dirIndex = d->dirIndexForNode(node, index);
-		value = node.model->data(dirIndex, role);
-	}
-	return value;
-}
-
-
-QModelIndex PlaceTreeModel::index(int row, int column, const QModelIndex& parent) const {
-	if (column != 0) {
-		return QModelIndex();
-	}
-	if (!parent.isValid()) {
-		// User wants to create a places index
-		if (0 <= row && row < d->mDirModels.size()) {
-			SortedDirModel* dirModel = d->mDirModels[row];
-			return d->createIndexForPlace(dirModel);
-		} else {
-			return QModelIndex();
-		}
-	}
-
-	Node parentNode = d->nodeForIndex(parent);
-	QModelIndex parentDirIndex = d->dirIndexForNode(parentNode, parent);
-
-	SortedDirModel* dirModel = parentNode.model;
-	KUrl parentUrl = dirModel->urlForIndex(parentDirIndex);
-	if (!parentUrl.isValid()) {
-		// parent is a place
-		parentUrl = dirModel->dirLister()->url();
-		if (!parentUrl.isValid()) {
-			return QModelIndex();
-		}
-	}
-	return d->createIndexForDirChild(dirModel, parentUrl, row, column);
-}
-
-
-QModelIndex PlaceTreeModel::parent(const QModelIndex& index) const {
-	if (!index.isValid()) {
-		return QModelIndex();
-	}
-	const Node node = d->nodeForIndex(index);
-	if (node.isPlace()) {
-		return QModelIndex();
-	}
-	if (node.parentUrl == node.model->dirLister()->url()) {
-		// index is a direct child of a place
-		return d->createIndexForPlace(node.model);
-	}
-	return d->createIndexForDir(node.model, node.parentUrl);
-}
-
-
-int PlaceTreeModel::rowCount(const QModelIndex& index) const {
-	if (!index.isValid()) {
-		// index is the invisible root item
-		return d->mDirModels.size();
-	}
-
-	// index is a place or a dir
-	const Node node = d->nodeForIndex(index);
-	const QModelIndex dirIndex = d->dirIndexForNode(node, index);
-	return node.model->rowCount(dirIndex);
-}
-
-
-bool PlaceTreeModel::hasChildren(const QModelIndex& index) const {
-	if (!index.isValid()) {
-		return true;
-	}
-	const Node node = d->nodeForIndex(index);
-	if (node.isPlace()) {
-		return true;
-	}
-	const QModelIndex dirIndex = d->dirIndexForNode(node, index);
-	return node.model->hasChildren(dirIndex);
-}
-
-
-bool PlaceTreeModel::canFetchMore(const QModelIndex& parent) const {
-	if (!parent.isValid()) {
-		return d->mPlacesModel->canFetchMore(QModelIndex());
-	}
-	const Node node = d->nodeForIndex(parent);
-	if (!node.model->dirLister()->url().isValid()) {
-		// Special case to avoid calling openUrl on all places at startup
-		return true;
-	}
-	const QModelIndex dirIndex = d->dirIndexForNode(node, parent);
-	return node.model->canFetchMore(dirIndex);
-}
-
-
-void PlaceTreeModel::fetchMore(const QModelIndex& parent) {
-	if (!parent.isValid()) {
-		d->mPlacesModel->fetchMore(QModelIndex());
-		return;
-	}
-	const Node node = d->nodeForIndex(parent);
-	if (!node.model->dirLister()->url().isValid()) {
-		QModelIndex placeIndex = d->mPlacesModel->index(parent.row(), parent.column());
-		KUrl url = d->mPlacesModel->url(placeIndex);
-		node.model->dirLister()->openUrl(url, KDirLister::Keep);
-		return;
-	}
-	const QModelIndex dirIndex = d->dirIndexForNode(node, parent);
-	node.model->fetchMore(dirIndex);
-}
-
-
-void PlaceTreeModel::slotPlacesRowsInserted(const QModelIndex& /*parent*/, int start, int end) {
-	beginInsertRows(QModelIndex(), start, end);
-	for (int row=start; row<=end; ++row) {
-		SortedDirModel* dirModel = new SortedDirModel(this);
-		connect(dirModel, SIGNAL(rowsAboutToBeInserted(const QModelIndex&, int, int)),
-			SLOT(slotDirRowsAboutToBeInserted(const QModelIndex&, int, int)));
-		connect(dirModel, SIGNAL(rowsInserted(const QModelIndex&, int, int)),
-			SLOT(slotDirRowsInserted(const QModelIndex&, int, int)));
-		connect(dirModel, SIGNAL(rowsAboutToBeRemoved(const QModelIndex&, int, int)),
-			SLOT(slotDirRowsAboutToBeRemoved(const QModelIndex&, int, int)));
-		connect(dirModel, SIGNAL(rowsAboutToBeRemoved(const QModelIndex&, int, int)),
-			SLOT(slotDirRowsRemoved(const QModelIndex&, int, int)));
-
-		d->mDirModels.insert(row, dirModel);
-		KDirLister* lister = dirModel->dirLister();
-		lister->setDirOnlyMode(true);
-	}
-	endInsertRows();
-}
-
-
-void PlaceTreeModel::slotPlacesRowsAboutToBeRemoved(const QModelIndex&, int start, int end) {
-	beginRemoveRows(QModelIndex(), start, end);
-	for (int row=end; row>=start; --row) {
-		SortedDirModel* dirModel = d->mDirModels.takeAt(row);
-		delete d->mNodes.take(dirModel);
-		delete dirModel;
-	}
-	endRemoveRows();
-}
-
-
-void PlaceTreeModel::slotDirRowsAboutToBeInserted(const QModelIndex& parentDirIndex, int start, int end) {
-	SortedDirModel* dirModel = static_cast<SortedDirModel*>(sender());
-	QModelIndex parentIndex;
-	if (parentDirIndex.isValid()) {
-		KUrl url = dirModel->urlForIndex(parentDirIndex);
-		parentIndex = d->createIndexForDir(dirModel, url);
-	} else {
-		parentIndex = d->createIndexForPlace(dirModel);
-	}
-	beginInsertRows(parentIndex, start, end);
-}
-
-
-void PlaceTreeModel::slotDirRowsInserted(const QModelIndex&, int, int) {
-	endInsertRows();
-}
-
-
-void PlaceTreeModel::slotDirRowsAboutToBeRemoved(const QModelIndex& parentDirIndex, int start, int end) {
-	SortedDirModel* dirModel = static_cast<SortedDirModel*>(sender());
-	QModelIndex parentIndex;
-	if (parentDirIndex.isValid()) {
-		KUrl url = dirModel->urlForIndex(parentDirIndex);
-		parentIndex = d->createIndexForDir(dirModel, url);
-	} else {
-		parentIndex = d->createIndexForPlace(dirModel);
-	}
-	beginRemoveRows(parentIndex, start, end);
-}
-
-
-void PlaceTreeModel::slotDirRowsRemoved(const QModelIndex&, int, int) {
-	endRemoveRows();
-}
-
-
-KUrl PlaceTreeModel::urlForIndex(const QModelIndex& index) const {
-	const Node node = d->nodeForIndex(index);
-	if (node.isPlace()) {
-		QModelIndex placeIndex = d->mPlacesModel->index(index.row(), 0);
-		return d->mPlacesModel->url(placeIndex);
-	}
-
-	const QModelIndex parentDirIndex = node.model->indexForUrl(node.parentUrl);
-	const QModelIndex dirIndex = node.model->index(index.row(), index.column(), parentDirIndex);
-	return node.model->urlForIndex(dirIndex);
-}
-
+, d(new PlaceTreeModelPrivate)
+{
+    d->q = this;
+
+    d->mPlacesModel = new KFilePlacesModel(this);
+    connect(d->mPlacesModel, SIGNAL(rowsInserted(QModelIndex, int, int)),
+            SLOT(slotPlacesRowsInserted(QModelIndex, int, int)));
+    connect(d->mPlacesModel, SIGNAL(rowsAboutToBeRemoved(QModelIndex, int, int)),
+            SLOT(slotPlacesRowsAboutToBeRemoved(QModelIndex, int, int)));
+
+    // Bootstrap
+    slotPlacesRowsInserted(QModelIndex(), 0, d->mPlacesModel->rowCount() - 1);
+}
+
+PlaceTreeModel::~PlaceTreeModel()
+{
+    Q_FOREACH(NodeHash * nodeHash, d->mNodes) {
+        qDeleteAll(*nodeHash);
+    }
+    qDeleteAll(d->mNodes);
+    delete d;
+}
+
+int PlaceTreeModel::columnCount(const QModelIndex&) const
+{
+    return 1;
+}
+
+QVariant PlaceTreeModel::data(const QModelIndex& index, int role) const
+{
+    if (!index.isValid()) {
+        return QVariant();
+    }
+    QVariant value;
+    const Node node = d->nodeForIndex(index);
+    if (node.isPlace()) {
+        const QModelIndex placesIndex = d->mPlacesModel->index(index.row(), index.column());
+        value = d->mPlacesModel->data(placesIndex, role);
+    } else {
+        const QModelIndex dirIndex = d->dirIndexForNode(node, index);
+        value = node.model->data(dirIndex, role);
+    }
+    return value;
+}
+
+QModelIndex PlaceTreeModel::index(int row, int column, const QModelIndex& parent) const
+{
+    if (column != 0) {
+        return QModelIndex();
+    }
+    if (!parent.isValid()) {
+        // User wants to create a places index
+        if (0 <= row && row < d->mDirModels.size()) {
+            SortedDirModel* dirModel = d->mDirModels[row];
+            return d->createIndexForPlace(dirModel);
+        } else {
+            return QModelIndex();
+        }
+    }
+
+    Node parentNode = d->nodeForIndex(parent);
+    QModelIndex parentDirIndex = d->dirIndexForNode(parentNode, parent);
+
+    SortedDirModel* dirModel = parentNode.model;
+    KUrl parentUrl = dirModel->urlForIndex(parentDirIndex);
+    if (!parentUrl.isValid()) {
+        // parent is a place
+        parentUrl = dirModel->dirLister()->url();
+        if (!parentUrl.isValid()) {
+            return QModelIndex();
+        }
+    }
+    return d->createIndexForDirChild(dirModel, parentUrl, row, column);
+}
+
+QModelIndex PlaceTreeModel::parent(const QModelIndex& index) const
+{
+    if (!index.isValid()) {
+        return QModelIndex();
+    }
+    const Node node = d->nodeForIndex(index);
+    if (node.isPlace()) {
+        return QModelIndex();
+    }
+    if (node.parentUrl == node.model->dirLister()->url()) {
+        // index is a direct child of a place
+        return d->createIndexForPlace(node.model);
+    }
+    return d->createIndexForDir(node.model, node.parentUrl);
+}
+
+int PlaceTreeModel::rowCount(const QModelIndex& index) const
+{
+    if (!index.isValid()) {
+        // index is the invisible root item
+        return d->mDirModels.size();
+    }
+
+    // index is a place or a dir
+    const Node node = d->nodeForIndex(index);
+    const QModelIndex dirIndex = d->dirIndexForNode(node, index);
+    return node.model->rowCount(dirIndex);
+}
+
+bool PlaceTreeModel::hasChildren(const QModelIndex& index) const
+{
+    if (!index.isValid()) {
+        return true;
+    }
+    const Node node = d->nodeForIndex(index);
+    if (node.isPlace()) {
+        return true;
+    }
+    const QModelIndex dirIndex = d->dirIndexForNode(node, index);
+    return node.model->hasChildren(dirIndex);
+}
+
+bool PlaceTreeModel::canFetchMore(const QModelIndex& parent) const
+{
+    if (!parent.isValid()) {
+        return d->mPlacesModel->canFetchMore(QModelIndex());
+    }
+    const Node node = d->nodeForIndex(parent);
+    if (!node.model->dirLister()->url().isValid()) {
+        // Special case to avoid calling openUrl on all places at startup
+        return true;
+    }
+    const QModelIndex dirIndex = d->dirIndexForNode(node, parent);
+    return node.model->canFetchMore(dirIndex);
+}
+
+void PlaceTreeModel::fetchMore(const QModelIndex& parent)
+{
+    if (!parent.isValid()) {
+        d->mPlacesModel->fetchMore(QModelIndex());
+        return;
+    }
+    const Node node = d->nodeForIndex(parent);
+    if (!node.model->dirLister()->url().isValid()) {
+        QModelIndex placeIndex = d->mPlacesModel->index(parent.row(), parent.column());
+        KUrl url = d->mPlacesModel->url(placeIndex);
+        node.model->dirLister()->openUrl(url, KDirLister::Keep);
+        return;
+    }
+    const QModelIndex dirIndex = d->dirIndexForNode(node, parent);
+    node.model->fetchMore(dirIndex);
+}
+
+void PlaceTreeModel::slotPlacesRowsInserted(const QModelIndex& /*parent*/, int start, int end)
+{
+    beginInsertRows(QModelIndex(), start, end);
+    for (int row = start; row <= end; ++row) {
+        SortedDirModel* dirModel = new SortedDirModel(this);
+        connect(dirModel, SIGNAL(rowsAboutToBeInserted(QModelIndex, int, int)),
+                SLOT(slotDirRowsAboutToBeInserted(QModelIndex, int, int)));
+        connect(dirModel, SIGNAL(rowsInserted(QModelIndex, int, int)),
+                SLOT(slotDirRowsInserted(QModelIndex, int, int)));
+        connect(dirModel, SIGNAL(rowsAboutToBeRemoved(QModelIndex, int, int)),
+                SLOT(slotDirRowsAboutToBeRemoved(QModelIndex, int, int)));
+        connect(dirModel, SIGNAL(rowsAboutToBeRemoved(QModelIndex, int, int)),
+                SLOT(slotDirRowsRemoved(QModelIndex, int, int)));
+
+        d->mDirModels.insert(row, dirModel);
+        KDirLister* lister = dirModel->dirLister();
+        lister->setDirOnlyMode(true);
+    }
+    endInsertRows();
+}
+
+void PlaceTreeModel::slotPlacesRowsAboutToBeRemoved(const QModelIndex&, int start, int end)
+{
+    beginRemoveRows(QModelIndex(), start, end);
+    for (int row = end; row >= start; --row) {
+        SortedDirModel* dirModel = d->mDirModels.takeAt(row);
+        delete d->mNodes.take(dirModel);
+        delete dirModel;
+    }
+    endRemoveRows();
+}
+
+void PlaceTreeModel::slotDirRowsAboutToBeInserted(const QModelIndex& parentDirIndex, int start, int end)
+{
+    SortedDirModel* dirModel = static_cast<SortedDirModel*>(sender());
+    QModelIndex parentIndex;
+    if (parentDirIndex.isValid()) {
+        KUrl url = dirModel->urlForIndex(parentDirIndex);
+        parentIndex = d->createIndexForDir(dirModel, url);
+    } else {
+        parentIndex = d->createIndexForPlace(dirModel);
+    }
+    beginInsertRows(parentIndex, start, end);
+}
+
+void PlaceTreeModel::slotDirRowsInserted(const QModelIndex&, int, int)
+{
+    endInsertRows();
+}
+
+void PlaceTreeModel::slotDirRowsAboutToBeRemoved(const QModelIndex& parentDirIndex, int start, int end)
+{
+    SortedDirModel* dirModel = static_cast<SortedDirModel*>(sender());
+    QModelIndex parentIndex;
+    if (parentDirIndex.isValid()) {
+        KUrl url = dirModel->urlForIndex(parentDirIndex);
+        parentIndex = d->createIndexForDir(dirModel, url);
+    } else {
+        parentIndex = d->createIndexForPlace(dirModel);
+    }
+    beginRemoveRows(parentIndex, start, end);
+}
+
+void PlaceTreeModel::slotDirRowsRemoved(const QModelIndex&, int, int)
+{
+    endRemoveRows();
+}
+
+KUrl PlaceTreeModel::urlForIndex(const QModelIndex& index) const
+{
+    const Node node = d->nodeForIndex(index);
+    if (node.isPlace()) {
+        QModelIndex placeIndex = d->mPlacesModel->index(index.row(), 0);
+        return d->mPlacesModel->url(placeIndex);
+    }
+
+    const QModelIndex parentDirIndex = node.model->indexForUrl(node.parentUrl);
+    const QModelIndex dirIndex = node.model->index(index.row(), index.column(), parentDirIndex);
+    return node.model->urlForIndex(dirIndex);
+}
 
 } // namespace

=== modified file 'lib/placetreemodel.h'
--- lib/placetreemodel.h	2011-07-20 13:46:34 +0000
+++ lib/placetreemodel.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -32,41 +32,41 @@
 
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct PlaceTreeModelPrivate;
-class GWENVIEWLIB_EXPORT PlaceTreeModel : public QAbstractItemModel {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT PlaceTreeModel : public QAbstractItemModel
+{
+    Q_OBJECT
 public:
-	PlaceTreeModel(QObject*);
-	~PlaceTreeModel();
-
-	virtual int columnCount(const QModelIndex& parent = QModelIndex()) const;
-	virtual QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
-	virtual QModelIndex index(int row, int column, const QModelIndex& parent = QModelIndex()) const;
-	virtual QModelIndex parent(const QModelIndex& index) const;
-	virtual int rowCount(const QModelIndex& parent = QModelIndex()) const;
-	virtual bool hasChildren(const QModelIndex& parent) const;
-	virtual bool canFetchMore(const QModelIndex& parent) const;
-	virtual void fetchMore(const QModelIndex& parent);
-
-	KUrl urlForIndex(const QModelIndex&) const;
+    PlaceTreeModel(QObject*);
+    ~PlaceTreeModel();
+
+    virtual int columnCount(const QModelIndex& parent = QModelIndex()) const;
+    virtual QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
+    virtual QModelIndex index(int row, int column, const QModelIndex& parent = QModelIndex()) const;
+    virtual QModelIndex parent(const QModelIndex& index) const;
+    virtual int rowCount(const QModelIndex& parent = QModelIndex()) const;
+    virtual bool hasChildren(const QModelIndex& parent) const;
+    virtual bool canFetchMore(const QModelIndex& parent) const;
+    virtual void fetchMore(const QModelIndex& parent);
+
+    KUrl urlForIndex(const QModelIndex&) const;
 
 private Q_SLOTS:
-	void slotPlacesRowsInserted(const QModelIndex&, int start, int end);
-	void slotPlacesRowsAboutToBeRemoved(const QModelIndex&, int start, int end);
-	void slotDirRowsAboutToBeInserted(const QModelIndex&, int start, int end);
-	void slotDirRowsInserted(const QModelIndex&, int start, int end);
-	void slotDirRowsAboutToBeRemoved(const QModelIndex&, int start, int end);
-	void slotDirRowsRemoved(const QModelIndex&, int start, int end);
+    void slotPlacesRowsInserted(const QModelIndex&, int start, int end);
+    void slotPlacesRowsAboutToBeRemoved(const QModelIndex&, int start, int end);
+    void slotDirRowsAboutToBeInserted(const QModelIndex&, int start, int end);
+    void slotDirRowsInserted(const QModelIndex&, int start, int end);
+    void slotDirRowsAboutToBeRemoved(const QModelIndex&, int start, int end);
+    void slotDirRowsRemoved(const QModelIndex&, int start, int end);
 
 private:
-	friend struct PlaceTreeModelPrivate;
-	PlaceTreeModelPrivate* const d;
+    friend struct PlaceTreeModelPrivate;
+    PlaceTreeModelPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* PLACETREEMODEL_H */

=== modified file 'lib/preferredimagemetainfomodel.cpp'
--- lib/preferredimagemetainfomodel.cpp	2011-07-20 13:46:34 +0000
+++ lib/preferredimagemetainfomodel.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -27,105 +27,102 @@
 // KDE
 #include <kdebug.h>
 
-
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct PreferredImageMetaInfoModelPrivate {
-	const ImageMetaInfoModel* mModel;
-	QStringList mPreferredMetaInfoKeyList;
-
-
-	QVariant checkStateData(const QModelIndex& sourceIndex) const {
-		if (sourceIndex.parent().isValid() && sourceIndex.column() == 0) {
-			QString key = mModel->keyForIndex(sourceIndex);
-			bool checked = mPreferredMetaInfoKeyList.contains(key);
-			return QVariant(checked ? Qt::Checked: Qt::Unchecked);
-		} else {
-			return QVariant();
-		}
-	}
-
-
-	void sortPreferredMetaInfoKeyList() {
-		QStringList sortedList;
-		int groupCount = mModel->rowCount();
-		for (int groupRow = 0; groupRow < groupCount; ++groupRow) {
-			QModelIndex groupIndex = mModel->index(groupRow, 0);
-			int keyCount = mModel->rowCount(groupIndex);
-			for (int keyRow = 0; keyRow < keyCount; ++keyRow) {
-				QModelIndex keyIndex = mModel->index(keyRow, 0, groupIndex);
-				QString key = mModel->keyForIndex(keyIndex);
-				if (mPreferredMetaInfoKeyList.contains(key)) {
-					sortedList << key;
-				}
-			}
-		}
-		mPreferredMetaInfoKeyList = sortedList;
-	}
+    const ImageMetaInfoModel* mModel;
+    QStringList mPreferredMetaInfoKeyList;
+
+    QVariant checkStateData(const QModelIndex& sourceIndex) const {
+        if (sourceIndex.parent().isValid() && sourceIndex.column() == 0) {
+            QString key = mModel->keyForIndex(sourceIndex);
+            bool checked = mPreferredMetaInfoKeyList.contains(key);
+            return QVariant(checked ? Qt::Checked : Qt::Unchecked);
+        } else {
+            return QVariant();
+        }
+    }
+
+    void sortPreferredMetaInfoKeyList()
+    {
+        QStringList sortedList;
+        int groupCount = mModel->rowCount();
+        for (int groupRow = 0; groupRow < groupCount; ++groupRow) {
+            QModelIndex groupIndex = mModel->index(groupRow, 0);
+            int keyCount = mModel->rowCount(groupIndex);
+            for (int keyRow = 0; keyRow < keyCount; ++keyRow) {
+                QModelIndex keyIndex = mModel->index(keyRow, 0, groupIndex);
+                QString key = mModel->keyForIndex(keyIndex);
+                if (mPreferredMetaInfoKeyList.contains(key)) {
+                    sortedList << key;
+                }
+            }
+        }
+        mPreferredMetaInfoKeyList = sortedList;
+    }
 };
 
-
 PreferredImageMetaInfoModel::PreferredImageMetaInfoModel(ImageMetaInfoModel* model, const QStringList& list)
-: d(new PreferredImageMetaInfoModelPrivate) {
-	d->mModel = model;
-	setSourceModel(model);
-	d->mPreferredMetaInfoKeyList = list;
-}
-
-
-PreferredImageMetaInfoModel::~PreferredImageMetaInfoModel() {
-	delete d;
-}
-
-
-Qt::ItemFlags PreferredImageMetaInfoModel::flags(const QModelIndex& index) const {
-	QModelIndex sourceIndex = mapToSource(index);
-	Qt::ItemFlags fl = d->mModel->flags(sourceIndex);
-	if (sourceIndex.parent().isValid() && sourceIndex.column() == 0) {
-		fl |= Qt::ItemIsUserCheckable;
-	}
-	return fl;
-}
-
-
-QVariant PreferredImageMetaInfoModel::data(const QModelIndex& index, int role) const {
-	QModelIndex sourceIndex = mapToSource(index);
-	if (!sourceIndex.isValid()) {
-		return QVariant();
-	}
-
-	switch (role) {
-	case Qt::CheckStateRole:
-		return d->checkStateData(sourceIndex);
-
-	default:
-		return d->mModel->data(sourceIndex, role);
-	}
-}
-
-
-bool PreferredImageMetaInfoModel::setData(const QModelIndex& index, const QVariant& value, int role) {
-	QModelIndex sourceIndex = mapToSource(index);
-	if (role != Qt::CheckStateRole) {
-		return false;
-	}
-
-	if (!sourceIndex.parent().isValid()) {
-		return false;
-	}
-
-	QString key = d->mModel->keyForIndex(sourceIndex);
-	if (value == Qt::Checked) {
-		d->mPreferredMetaInfoKeyList << key;
-		d->sortPreferredMetaInfoKeyList();
-	} else {
-		d->mPreferredMetaInfoKeyList.removeAll(key);
-	}
-	emit preferredMetaInfoKeyListChanged(d->mPreferredMetaInfoKeyList);
-	emit dataChanged(index, index);
-	return true;
-}
-
+: d(new PreferredImageMetaInfoModelPrivate)
+{
+    d->mModel = model;
+    setSourceModel(model);
+    d->mPreferredMetaInfoKeyList = list;
+}
+
+PreferredImageMetaInfoModel::~PreferredImageMetaInfoModel()
+{
+    delete d;
+}
+
+Qt::ItemFlags PreferredImageMetaInfoModel::flags(const QModelIndex& index) const
+{
+    QModelIndex sourceIndex = mapToSource(index);
+    Qt::ItemFlags fl = d->mModel->flags(sourceIndex);
+    if (sourceIndex.parent().isValid() && sourceIndex.column() == 0) {
+        fl |= Qt::ItemIsUserCheckable;
+    }
+    return fl;
+}
+
+QVariant PreferredImageMetaInfoModel::data(const QModelIndex& index, int role) const
+{
+    QModelIndex sourceIndex = mapToSource(index);
+    if (!sourceIndex.isValid()) {
+        return QVariant();
+    }
+
+    switch (role) {
+    case Qt::CheckStateRole:
+        return d->checkStateData(sourceIndex);
+
+    default:
+        return d->mModel->data(sourceIndex, role);
+    }
+}
+
+bool PreferredImageMetaInfoModel::setData(const QModelIndex& index, const QVariant& value, int role)
+{
+    QModelIndex sourceIndex = mapToSource(index);
+    if (role != Qt::CheckStateRole) {
+        return false;
+    }
+
+    if (!sourceIndex.parent().isValid()) {
+        return false;
+    }
+
+    QString key = d->mModel->keyForIndex(sourceIndex);
+    if (value == Qt::Checked) {
+        d->mPreferredMetaInfoKeyList << key;
+        d->sortPreferredMetaInfoKeyList();
+    } else {
+        d->mPreferredMetaInfoKeyList.removeAll(key);
+    }
+    emit preferredMetaInfoKeyListChanged(d->mPreferredMetaInfoKeyList);
+    emit dataChanged(index, index);
+    return true;
+}
 
 } // namespace

=== modified file 'lib/preferredimagemetainfomodel.h'
--- lib/preferredimagemetainfomodel.h	2011-07-20 13:46:34 +0000
+++ lib/preferredimagemetainfomodel.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,33 +29,33 @@
 // Local
 #include <lib/imagemetainfomodel.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 /**
  * This model uses an instance of ImageMetaInfoModel to make it possible to
  * select your preferred image metainfo keys by checking them.
  */
 struct PreferredImageMetaInfoModelPrivate;
-class GWENVIEWLIB_EXPORT PreferredImageMetaInfoModel : public QSortFilterProxyModel {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT PreferredImageMetaInfoModel : public QSortFilterProxyModel
+{
+    Q_OBJECT
 public:
-	PreferredImageMetaInfoModel(ImageMetaInfoModel* model, const QStringList& list);
-	~PreferredImageMetaInfoModel();
+    PreferredImageMetaInfoModel(ImageMetaInfoModel* model, const QStringList& list);
+    ~PreferredImageMetaInfoModel();
 
-	virtual QVariant data(const QModelIndex&, int role = Qt::DisplayRole) const;
-	virtual bool setData(const QModelIndex& index, const QVariant& value, int role);
-	virtual Qt::ItemFlags flags(const QModelIndex& index) const;
+    virtual QVariant data(const QModelIndex&, int role = Qt::DisplayRole) const;
+    virtual bool setData(const QModelIndex& index, const QVariant& value, int role);
+    virtual Qt::ItemFlags flags(const QModelIndex& index) const;
 
 Q_SIGNALS:
-	void preferredMetaInfoKeyListChanged(const QStringList&);
+    void preferredMetaInfoKeyListChanged(const QStringList&);
 
 private:
-	PreferredImageMetaInfoModelPrivate* const d;
-	friend struct PreferredImageMetaInfoModelPrivate;
+    PreferredImageMetaInfoModelPrivate* const d;
+    friend struct PreferredImageMetaInfoModelPrivate;
 };
 
-
 } // namespace
 
 #endif /* PREFERREDIMAGEMETAINFOMODEL_H */

=== modified file 'lib/print/printhelper.cpp'
--- lib/print/printhelper.cpp	2011-07-20 13:46:34 +0000
+++ lib/print/printhelper.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -37,113 +37,113 @@
 // Local
 #include "printoptionspage.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct PrintHelperPrivate {
-	QWidget* mParent;
-
-	QSize adjustSize(PrintOptionsPage* optionsPage, Document::Ptr doc, int printerResolution, const QSize & viewportSize) {
-		QSize size = doc->size();
-		PrintOptionsPage::ScaleMode scaleMode = optionsPage->scaleMode();
-		if (scaleMode == PrintOptionsPage::ScaleToPage) {
-			bool imageBiggerThanPaper =
-				size.width() > viewportSize.width()
-				|| size.height() > viewportSize.height();
-
-			if (imageBiggerThanPaper || optionsPage->enlargeSmallerImages()) {
-				size.scale(viewportSize, Qt::KeepAspectRatio);
-			}
-
-		} else if (scaleMode == PrintOptionsPage::ScaleToCustomSize) {
-			double wImg = optionsPage->scaleWidth();
-			double hImg = optionsPage->scaleHeight();
-			size.setWidth( int(wImg * printerResolution) );
-			size.setHeight( int(hImg * printerResolution) );
-
-		} else {
-			// No scale
-			const double INCHES_PER_METER = 100. / 2.54;
-			int dpmX = doc->image().dotsPerMeterX();
-			int dpmY = doc->image().dotsPerMeterY();
-			if (dpmX > 0 && dpmY > 0) {
-				double wImg = double(size.width()) / double(dpmX) * INCHES_PER_METER;
-				double hImg = double(size.height()) / double(dpmY) * INCHES_PER_METER;
-				size.setWidth( int(wImg * printerResolution) );
-				size.setHeight( int(hImg * printerResolution) );
-			}
-		}
-		return size;
-	}
-
-
-	QPoint adjustPosition(PrintOptionsPage* optionsPage, const QSize& imageSize, const QSize & viewportSize) {
-		Qt::Alignment alignment = optionsPage->alignment();
-		int posX, posY;
-
-		if (alignment & Qt::AlignLeft) {
-			posX = 0;
-		} else if (alignment & Qt::AlignHCenter) {
-			posX = (viewportSize.width() - imageSize.width()) / 2;
-		} else {
-			posX = viewportSize.width() - imageSize.width();
-		}
-
-		if (alignment & Qt::AlignTop) {
-			posY = 0;
-		} else if (alignment & Qt::AlignVCenter) {
-			posY = (viewportSize.height() - imageSize.height()) / 2;
-		} else {
-			posY = viewportSize.height() - imageSize.height();
-		}
-
-		return QPoint(posX, posY);
-	}
+    QWidget* mParent;
+
+    QSize adjustSize(PrintOptionsPage* optionsPage, Document::Ptr doc, int printerResolution, const QSize & viewportSize)
+    {
+        QSize size = doc->size();
+        PrintOptionsPage::ScaleMode scaleMode = optionsPage->scaleMode();
+        if (scaleMode == PrintOptionsPage::ScaleToPage) {
+            bool imageBiggerThanPaper =
+                size.width() > viewportSize.width()
+                || size.height() > viewportSize.height();
+
+            if (imageBiggerThanPaper || optionsPage->enlargeSmallerImages()) {
+                size.scale(viewportSize, Qt::KeepAspectRatio);
+            }
+
+        } else if (scaleMode == PrintOptionsPage::ScaleToCustomSize) {
+            double wImg = optionsPage->scaleWidth();
+            double hImg = optionsPage->scaleHeight();
+            size.setWidth(int(wImg * printerResolution));
+            size.setHeight(int(hImg * printerResolution));
+
+        } else {
+            // No scale
+            const double INCHES_PER_METER = 100. / 2.54;
+            int dpmX = doc->image().dotsPerMeterX();
+            int dpmY = doc->image().dotsPerMeterY();
+            if (dpmX > 0 && dpmY > 0) {
+                double wImg = double(size.width()) / double(dpmX) * INCHES_PER_METER;
+                double hImg = double(size.height()) / double(dpmY) * INCHES_PER_METER;
+                size.setWidth(int(wImg * printerResolution));
+                size.setHeight(int(hImg * printerResolution));
+            }
+        }
+        return size;
+    }
+
+    QPoint adjustPosition(PrintOptionsPage* optionsPage, const QSize& imageSize, const QSize & viewportSize)
+    {
+        Qt::Alignment alignment = optionsPage->alignment();
+        int posX, posY;
+
+        if (alignment & Qt::AlignLeft) {
+            posX = 0;
+        } else if (alignment & Qt::AlignHCenter) {
+            posX = (viewportSize.width() - imageSize.width()) / 2;
+        } else {
+            posX = viewportSize.width() - imageSize.width();
+        }
+
+        if (alignment & Qt::AlignTop) {
+            posY = 0;
+        } else if (alignment & Qt::AlignVCenter) {
+            posY = (viewportSize.height() - imageSize.height()) / 2;
+        } else {
+            posY = viewportSize.height() - imageSize.height();
+        }
+
+        return QPoint(posX, posY);
+    }
 };
 
-
 PrintHelper::PrintHelper(QWidget* parent)
-: d(new PrintHelperPrivate) {
-	d->mParent = parent;
-}
-
-
-PrintHelper::~PrintHelper() {
-	delete d;
-}
-
-
-void PrintHelper::print(Document::Ptr doc) {
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-	QPrinter printer;
-
-	PrintOptionsPage* optionsPage = new PrintOptionsPage(doc->size());
-	optionsPage->loadConfig();
-
-	std::auto_ptr<QPrintDialog> dialog(
-		KdePrint::createPrintDialog(&printer,
-			QList<QWidget*>() << optionsPage,
-			d->mParent)
-		);
-	dialog->setWindowTitle(i18n("Print Image"));
-	bool wantToPrint = dialog->exec();
-
-	optionsPage->saveConfig();
-	if (!wantToPrint) {
-		return;
-	}
-
-	QPainter painter(&printer);
-	QRect rect = painter.viewport();
-	QSize size = d->adjustSize(optionsPage, doc, printer.resolution(), rect.size());
-	QPoint pos = d->adjustPosition(optionsPage, size, rect.size());
-	painter.setViewport(pos.x(), pos.y(), size.width(), size.height());
-
-	QImage image = doc->image();
-	painter.setWindow(image.rect());
-	painter.drawImage(0, 0, image);
-}
-
+: d(new PrintHelperPrivate)
+{
+    d->mParent = parent;
+}
+
+PrintHelper::~PrintHelper()
+{
+    delete d;
+}
+
+void PrintHelper::print(Document::Ptr doc)
+{
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+    QPrinter printer;
+
+    PrintOptionsPage* optionsPage = new PrintOptionsPage(doc->size());
+    optionsPage->loadConfig();
+
+    std::auto_ptr<QPrintDialog> dialog(
+        KdePrint::createPrintDialog(&printer,
+                                    QList<QWidget*>() << optionsPage,
+                                    d->mParent)
+    );
+    dialog->setWindowTitle(i18n("Print Image"));
+    bool wantToPrint = dialog->exec();
+
+    optionsPage->saveConfig();
+    if (!wantToPrint) {
+        return;
+    }
+
+    QPainter painter(&printer);
+    QRect rect = painter.viewport();
+    QSize size = d->adjustSize(optionsPage, doc, printer.resolution(), rect.size());
+    QPoint pos = d->adjustPosition(optionsPage, size, rect.size());
+    painter.setViewport(pos.x(), pos.y(), size.width(), size.height());
+
+    QImage image = doc->image();
+    painter.setWindow(image.rect());
+    painter.drawImage(0, 0, image);
+}
 
 } // namespace

=== modified file 'lib/print/printhelper.h'
--- lib/print/printhelper.h	2011-07-20 13:46:34 +0000
+++ lib/print/printhelper.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -32,22 +32,22 @@
 
 class QWidget;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct PrintHelperPrivate;
-class GWENVIEWLIB_EXPORT PrintHelper {
+class GWENVIEWLIB_EXPORT PrintHelper
+{
 public:
-	PrintHelper(QWidget* parent);
-	~PrintHelper();
+    PrintHelper(QWidget* parent);
+    ~PrintHelper();
 
-	void print(Document::Ptr);
+    void print(Document::Ptr);
 
 private:
-	PrintHelperPrivate* const d;
+    PrintHelperPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* PRINTHELPER_H */

=== modified file 'lib/print/printoptionspage.cpp'
--- lib/print/printoptionspage.cpp	2011-07-20 13:46:34 +0000
+++ lib/print/printoptionspage.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -34,197 +34,197 @@
 #include <signalblocker.h>
 #include <ui_printoptionspage.h>
 
-namespace Gwenview {
-
-
-static inline double unitToInches(PrintOptionsPage::Unit unit) {
-	if (unit == PrintOptionsPage::Inches) {
-		return 1.;
-	} else if (unit == PrintOptionsPage::Centimeters) {
-		return 1/2.54;
-	} else { // Millimeters
-		return 1/25.4;
-	}
+namespace Gwenview
+{
+
+static inline double unitToInches(PrintOptionsPage::Unit unit)
+{
+    if (unit == PrintOptionsPage::Inches) {
+        return 1.;
+    } else if (unit == PrintOptionsPage::Centimeters) {
+        return 1 / 2.54;
+    } else { // Millimeters
+        return 1 / 25.4;
+    }
 }
 
-
 struct PrintOptionsPagePrivate : public Ui_PrintOptionsPage {
-	QSize mImageSize;
-	QButtonGroup mScaleGroup;
-	QButtonGroup mPositionGroup;
-	KConfigDialogManager* mConfigDialogManager;
-
-	void initPositionFrame() {
-		mPositionFrame->setStyleSheet(
-			"QFrame {"
-			"	background-color: palette(mid);"
-			"	border: 1px solid palette(dark);"
-			"}"
-			"QToolButton {"
-			"	border: none;"
-			"	background: palette(base);"
-			"}"
-			"QToolButton:hover {"
-			"	background: palette(alternate-base);"
-			"	border: 1px solid palette(highlight);"
-			"}"
-			"QToolButton:checked {"
-			"	background-color: palette(highlight);"
-			"}"
-			);
-
-		QGridLayout* layout = new QGridLayout(mPositionFrame);
-		layout->setMargin(0);
-		layout->setSpacing(1);
-		for (int row = 0; row < 3; ++row) {
-			for (int col = 0; col < 3; ++col) {
-				QToolButton* button = new QToolButton(mPositionFrame);
-				button->setFixedSize(40, 40);
-				button->setCheckable(true);
-				layout->addWidget(button, row, col);
-
-				Qt::Alignment alignment;
-				if (row == 0) {
-					alignment = Qt::AlignTop;
-				} else if (row == 1) {
-					alignment = Qt::AlignVCenter;
-				} else {
-					alignment = Qt::AlignBottom;
-				}
-				if (col == 0) {
-					alignment |= Qt::AlignLeft;
-				} else if (col == 1) {
-					alignment |= Qt::AlignHCenter;
-				} else {
-					alignment |= Qt::AlignRight;
-				}
-
-				mPositionGroup.addButton(button, int(alignment));
-			}
-		}
-	}
+    QSize mImageSize;
+    QButtonGroup mScaleGroup;
+    QButtonGroup mPositionGroup;
+    KConfigDialogManager* mConfigDialogManager;
+
+    void initPositionFrame()
+    {
+        mPositionFrame->setStyleSheet(
+            "QFrame {"
+            "	background-color: palette(mid);"
+            "	border: 1px solid palette(dark);"
+            "}"
+            "QToolButton {"
+            "	border: none;"
+            "	background: palette(base);"
+            "}"
+            "QToolButton:hover {"
+            "	background: palette(alternate-base);"
+            "	border: 1px solid palette(highlight);"
+            "}"
+            "QToolButton:checked {"
+            "	background-color: palette(highlight);"
+            "}"
+        );
+
+        QGridLayout* layout = new QGridLayout(mPositionFrame);
+        layout->setMargin(0);
+        layout->setSpacing(1);
+        for (int row = 0; row < 3; ++row) {
+            for (int col = 0; col < 3; ++col) {
+                QToolButton* button = new QToolButton(mPositionFrame);
+                button->setFixedSize(40, 40);
+                button->setCheckable(true);
+                layout->addWidget(button, row, col);
+
+                Qt::Alignment alignment;
+                if (row == 0) {
+                    alignment = Qt::AlignTop;
+                } else if (row == 1) {
+                    alignment = Qt::AlignVCenter;
+                } else {
+                    alignment = Qt::AlignBottom;
+                }
+                if (col == 0) {
+                    alignment |= Qt::AlignLeft;
+                } else if (col == 1) {
+                    alignment |= Qt::AlignHCenter;
+                } else {
+                    alignment |= Qt::AlignRight;
+                }
+
+                mPositionGroup.addButton(button, int(alignment));
+            }
+        }
+    }
 };
 
-
 PrintOptionsPage::PrintOptionsPage(const QSize& imageSize)
 : QWidget()
-, d(new PrintOptionsPagePrivate) {
-	d->setupUi(this);
-	d->mImageSize = imageSize;
-	d->mConfigDialogManager = new KConfigDialogManager(this, GwenviewConfig::self());
-
-	d->initPositionFrame();
-
-	d->mScaleGroup.addButton(d->mNoScale, NoScale);
-	d->mScaleGroup.addButton(d->mScaleToPage, ScaleToPage);
-	d->mScaleGroup.addButton(d->mScaleTo, ScaleToCustomSize);
-
-	connect(d->kcfg_PrintWidth, SIGNAL(valueChanged(double)),
-		SLOT(adjustHeightToRatio()) );
-
-	connect(d->kcfg_PrintHeight, SIGNAL(valueChanged(double)),
-		SLOT(adjustWidthToRatio()) );
-
-	connect(d->kcfg_PrintKeepRatio, SIGNAL(toggled(bool)),
-		SLOT(adjustHeightToRatio()) );
-}
-
-
-PrintOptionsPage::~PrintOptionsPage() {
-	delete d;
-}
-
-
-Qt::Alignment PrintOptionsPage::alignment() const {
-	int id = d->mPositionGroup.checkedId();
-	kWarning() << "alignment=" << id;
-	return Qt::Alignment(id);
-}
-
-
-PrintOptionsPage::ScaleMode PrintOptionsPage::scaleMode() const {
-	return PrintOptionsPage::ScaleMode( d->mScaleGroup.checkedId() );
-}
-
-
-bool PrintOptionsPage::enlargeSmallerImages() const {
-	return d->kcfg_PrintEnlargeSmallerImages->isChecked();
-}
-
-
-PrintOptionsPage::Unit PrintOptionsPage::scaleUnit() const {
-	return PrintOptionsPage::Unit(d->kcfg_PrintUnit->currentIndex());
-}
-
-
-double PrintOptionsPage::scaleWidth() const {
-	return d->kcfg_PrintWidth->value() * unitToInches(scaleUnit());
-}
-
-
-double PrintOptionsPage::scaleHeight() const {
-	return d->kcfg_PrintHeight->value() * unitToInches(scaleUnit());
-}
-
-
-void PrintOptionsPage::adjustWidthToRatio() {
-	if (!d->kcfg_PrintKeepRatio->isChecked()) {
-		return;
-	}
-	double width = d->mImageSize.width() * d->kcfg_PrintHeight->value() / d->mImageSize.height();
-
-	SignalBlocker blocker(d->kcfg_PrintWidth);
-	d->kcfg_PrintWidth->setValue(width ? width : 1.);
-}
-
-
-void PrintOptionsPage::adjustHeightToRatio() {
-	if (!d->kcfg_PrintKeepRatio->isChecked()) {
-		return;
-	}
-	double height = d->mImageSize.height() * d->kcfg_PrintWidth->value() / d->mImageSize.width();
-
-	SignalBlocker blocker(d->kcfg_PrintHeight);
-	d->kcfg_PrintHeight->setValue(height ? height : 1.);
-}
-
-
-void PrintOptionsPage::loadConfig() {
-	QAbstractButton* button;
-
-	button = d->mPositionGroup.button(GwenviewConfig::printPosition());
-	if (button) {
-		button->setChecked(true);
-	} else {
-		kWarning() << "Unknown button for position group";
-	}
-
-	button = d->mScaleGroup.button(GwenviewConfig::printScaleMode());
-	if (button) {
-		button->setChecked(true);
-	} else {
-		kWarning() << "Unknown button for scale group";
-	}
-
-	d->mConfigDialogManager->updateWidgets();
-
-	if (d->kcfg_PrintKeepRatio->isChecked()) {
-		adjustHeightToRatio();
-	}
-}
-
-
-void PrintOptionsPage::saveConfig() {
-	int position = d->mPositionGroup.checkedId();
-	GwenviewConfig::setPrintPosition(position);
-
-	ScaleMode scaleMode = ScaleMode( d->mScaleGroup.checkedId() );
-	GwenviewConfig::setPrintScaleMode(scaleMode);
-
-	d->mConfigDialogManager->updateSettings();
-
-	GwenviewConfig::self()->writeConfig();
-}
-
+, d(new PrintOptionsPagePrivate)
+{
+    d->setupUi(this);
+    d->mImageSize = imageSize;
+    d->mConfigDialogManager = new KConfigDialogManager(this, GwenviewConfig::self());
+
+    d->initPositionFrame();
+
+    d->mScaleGroup.addButton(d->mNoScale, NoScale);
+    d->mScaleGroup.addButton(d->mScaleToPage, ScaleToPage);
+    d->mScaleGroup.addButton(d->mScaleTo, ScaleToCustomSize);
+
+    connect(d->kcfg_PrintWidth, SIGNAL(valueChanged(double)),
+            SLOT(adjustHeightToRatio()));
+
+    connect(d->kcfg_PrintHeight, SIGNAL(valueChanged(double)),
+            SLOT(adjustWidthToRatio()));
+
+    connect(d->kcfg_PrintKeepRatio, SIGNAL(toggled(bool)),
+            SLOT(adjustHeightToRatio()));
+}
+
+PrintOptionsPage::~PrintOptionsPage()
+{
+    delete d;
+}
+
+Qt::Alignment PrintOptionsPage::alignment() const
+{
+    int id = d->mPositionGroup.checkedId();
+    kWarning() << "alignment=" << id;
+    return Qt::Alignment(id);
+}
+
+PrintOptionsPage::ScaleMode PrintOptionsPage::scaleMode() const
+{
+    return PrintOptionsPage::ScaleMode(d->mScaleGroup.checkedId());
+}
+
+bool PrintOptionsPage::enlargeSmallerImages() const
+{
+    return d->kcfg_PrintEnlargeSmallerImages->isChecked();
+}
+
+PrintOptionsPage::Unit PrintOptionsPage::scaleUnit() const
+{
+    return PrintOptionsPage::Unit(d->kcfg_PrintUnit->currentIndex());
+}
+
+double PrintOptionsPage::scaleWidth() const
+{
+    return d->kcfg_PrintWidth->value() * unitToInches(scaleUnit());
+}
+
+double PrintOptionsPage::scaleHeight() const
+{
+    return d->kcfg_PrintHeight->value() * unitToInches(scaleUnit());
+}
+
+void PrintOptionsPage::adjustWidthToRatio()
+{
+    if (!d->kcfg_PrintKeepRatio->isChecked()) {
+        return;
+    }
+    double width = d->mImageSize.width() * d->kcfg_PrintHeight->value() / d->mImageSize.height();
+
+    SignalBlocker blocker(d->kcfg_PrintWidth);
+    d->kcfg_PrintWidth->setValue(width ? width : 1.);
+}
+
+void PrintOptionsPage::adjustHeightToRatio()
+{
+    if (!d->kcfg_PrintKeepRatio->isChecked()) {
+        return;
+    }
+    double height = d->mImageSize.height() * d->kcfg_PrintWidth->value() / d->mImageSize.width();
+
+    SignalBlocker blocker(d->kcfg_PrintHeight);
+    d->kcfg_PrintHeight->setValue(height ? height : 1.);
+}
+
+void PrintOptionsPage::loadConfig()
+{
+    QAbstractButton* button;
+
+    button = d->mPositionGroup.button(GwenviewConfig::printPosition());
+    if (button) {
+        button->setChecked(true);
+    } else {
+        kWarning() << "Unknown button for position group";
+    }
+
+    button = d->mScaleGroup.button(GwenviewConfig::printScaleMode());
+    if (button) {
+        button->setChecked(true);
+    } else {
+        kWarning() << "Unknown button for scale group";
+    }
+
+    d->mConfigDialogManager->updateWidgets();
+
+    if (d->kcfg_PrintKeepRatio->isChecked()) {
+        adjustHeightToRatio();
+    }
+}
+
+void PrintOptionsPage::saveConfig()
+{
+    int position = d->mPositionGroup.checkedId();
+    GwenviewConfig::setPrintPosition(position);
+
+    ScaleMode scaleMode = ScaleMode(d->mScaleGroup.checkedId());
+    GwenviewConfig::setPrintScaleMode(scaleMode);
+
+    d->mConfigDialogManager->updateSettings();
+
+    GwenviewConfig::self()->writeConfig();
+}
 
 } // namespace

=== modified file 'lib/print/printoptionspage.h'
--- lib/print/printoptionspage.h	2011-07-20 13:46:34 +0000
+++ lib/print/printoptionspage.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -28,48 +28,48 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct PrintOptionsPagePrivate;
-class PrintOptionsPage : public QWidget {
-	Q_OBJECT
+class PrintOptionsPage : public QWidget
+{
+    Q_OBJECT
 public:
-	enum ScaleMode {
-		NoScale,
-		ScaleToPage,
-		ScaleToCustomSize
-	};
-
-	// Order should match the content of the unit combbox in the ui file
-	enum Unit {
-		Millimeters,
-		Centimeters,
-		Inches
-	};
-
-	PrintOptionsPage(const QSize& imageSize);
-	~PrintOptionsPage();
-
-	Qt::Alignment alignment() const;
-	ScaleMode scaleMode() const;
-	bool enlargeSmallerImages() const;
-	Unit scaleUnit() const;
-	double scaleWidth() const;
-	double scaleHeight() const;
-
-	void loadConfig();
-	void saveConfig();
+    enum ScaleMode {
+        NoScale,
+        ScaleToPage,
+        ScaleToCustomSize
+    };
+
+    // Order should match the content of the unit combbox in the ui file
+    enum Unit {
+        Millimeters,
+        Centimeters,
+        Inches
+    };
+
+    PrintOptionsPage(const QSize& imageSize);
+    ~PrintOptionsPage();
+
+    Qt::Alignment alignment() const;
+    ScaleMode scaleMode() const;
+    bool enlargeSmallerImages() const;
+    Unit scaleUnit() const;
+    double scaleWidth() const;
+    double scaleHeight() const;
+
+    void loadConfig();
+    void saveConfig();
 
 private Q_SLOTS:
-	void adjustWidthToRatio();
-	void adjustHeightToRatio();
+    void adjustWidthToRatio();
+    void adjustHeightToRatio();
 
 private:
-	PrintOptionsPagePrivate* const d;
+    PrintOptionsPagePrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* PRINTOPTIONSPAGE_H */

=== modified file 'lib/ramp.h'
--- lib/ramp.h	2011-07-20 13:46:34 +0000
+++ lib/ramp.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -21,7 +21,8 @@
 #ifndef RAMP_H
 #define RAMP_H
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * This class maps values on a linear ramp.
@@ -33,29 +34,29 @@
  *
  * Note that y1 can be greater than y2 if necessary
  */
-class Ramp {
+class Ramp
+{
 public:
-	Ramp(qreal x1, qreal x2, qreal y1, qreal y2)
-	: mX1(x1)
-	, mX2(x2)
-	, mY1(y1)
-	, mY2(y2)
-	{
-		mK = (y2 - y1) / (x2 - x1);
-	}
+    Ramp(qreal x1, qreal x2, qreal y1, qreal y2)
+        : mX1(x1)
+        , mX2(x2)
+        , mY1(y1)
+        , mY2(y2) {
+        mK = (y2 - y1) / (x2 - x1);
+    }
 
-	qreal operator()(qreal x) const {
-		if (x < mX1) {
-			return mY1;
-		}
-		if (x > mX2) {
-			return mY2;
-		}
-		return mY1 + (x - mX1) * mK;
-	}
+    qreal operator()(qreal x) const {
+        if (x < mX1) {
+            return mY1;
+        }
+        if (x > mX2) {
+            return mY2;
+        }
+        return mY1 + (x - mX1) * mK;
+    }
 
 private:
-	qreal mX1, mX2, mY1, mY2, mK;
+    qreal mX1, mX2, mY1, mY2, mK;
 };
 
 } // namespace

=== removed file 'lib/redeyereduction/redeyereductionhud.ui'
--- lib/redeyereduction/redeyereductionhud.ui	2011-07-20 13:46:34 +0000
+++ lib/redeyereduction/redeyereductionhud.ui	1970-01-01 00:00:00 +0000
@@ -1,94 +0,0 @@
-<ui version="4.0" >
- <class>RedEyeReductionHud</class>
- <widget class="QWidget" name="RedEyeReductionHud" >
-  <property name="geometry" >
-   <rect>
-    <x>0</x>
-    <y>0</y>
-    <width>253</width>
-    <height>37</height>
-   </rect>
-  </property>
-  <layout class="QHBoxLayout" name="horizontalLayout" >
-   <item>
-    <widget class="QLabel" name="label" >
-     <property name="text" >
-      <string>Size</string>
-     </property>
-    </widget>
-   </item>
-   <item>
-    <widget class="QSlider" name="diameterSlider" >
-     <property name="minimum" >
-      <number>2</number>
-     </property>
-     <property name="maximum" >
-      <number>40</number>
-     </property>
-     <property name="orientation" >
-      <enum>Qt::Horizontal</enum>
-     </property>
-    </widget>
-   </item>
-   <item>
-    <widget class="KIntSpinBox" name="diameterSpinBox" >
-     <property name="minimum" >
-      <number>2</number>
-     </property>
-    </widget>
-   </item>
-   <item>
-    <widget class="QToolButton" name="applyButton" >
-     <property name="text" >
-      <string>Apply</string>
-     </property>
-     <property name="autoRaise" >
-      <bool>true</bool>
-     </property>
-    </widget>
-   </item>
-  </layout>
- </widget>
- <customwidgets>
-  <customwidget>
-   <class>KIntSpinBox</class>
-   <extends>QSpinBox</extends>
-   <header>knuminput.h</header>
-  </customwidget>
- </customwidgets>
- <resources/>
- <connections>
-  <connection>
-   <sender>diameterSlider</sender>
-   <signal>sliderMoved(int)</signal>
-   <receiver>diameterSpinBox</receiver>
-   <slot>setValue(int)</slot>
-   <hints>
-    <hint type="sourcelabel" >
-     <x>120</x>
-     <y>22</y>
-    </hint>
-    <hint type="destinationlabel" >
-     <x>175</x>
-     <y>21</y>
-    </hint>
-   </hints>
-  </connection>
-  <connection>
-   <sender>diameterSpinBox</sender>
-   <signal>valueChanged(int)</signal>
-   <receiver>diameterSlider</receiver>
-   <slot>setValue(int)</slot>
-   <hints>
-    <hint type="sourcelabel" >
-     <x>153</x>
-     <y>7</y>
-    </hint>
-    <hint type="destinationlabel" >
-     <x>124</x>
-     <y>7</y>
-    </hint>
-   </hints>
-  </connection>
- </connections>
-</ui>

=== modified file 'lib/redeyereduction/redeyereductionimageoperation.cpp'
--- lib/redeyereduction/redeyereductionimageoperation.cpp	2011-07-20 13:46:34 +0000
+++ lib/redeyereduction/redeyereductionimageoperation.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -39,125 +39,125 @@
 #include "document/abstractdocumenteditor.h"
 #include "paintutils.h"
 
-namespace Gwenview {
-
-
-class RedEyeReductionJob : public ThreadedDocumentJob {
+namespace Gwenview
+{
+
+class RedEyeReductionJob : public ThreadedDocumentJob
+{
 public:
-	RedEyeReductionJob(const QRectF& rectF)
-	: mRectF(rectF)
-	{}
+    RedEyeReductionJob(const QRectF& rectF)
+        : mRectF(rectF)
+    {}
 
-	void threadedStart() {
-		if (!checkDocumentEditor()) {
-			return;
-		}
-		QImage img = document()->image();
-		RedEyeReductionImageOperation::apply(&img, mRectF);
-		document()->editor()->setImage(img);
-		setError(NoError);
-	}
+    void threadedStart()
+    {
+        if (!checkDocumentEditor()) {
+            return;
+        }
+        QImage img = document()->image();
+        RedEyeReductionImageOperation::apply(&img, mRectF);
+        document()->editor()->setImage(img);
+        setError(NoError);
+    }
 
 private:
-	QRectF mRectF;
+    QRectF mRectF;
 };
 
-
 struct RedEyeReductionImageOperationPrivate {
-	QRectF mRectF;
-	QImage mOriginalImage;
+    QRectF mRectF;
+    QImage mOriginalImage;
 };
 
-
 RedEyeReductionImageOperation::RedEyeReductionImageOperation(const QRectF& rectF)
-: d(new RedEyeReductionImageOperationPrivate) {
-	d->mRectF = rectF;
-	setText(i18n("RedEyeReduction"));
-}
-
-
-RedEyeReductionImageOperation::~RedEyeReductionImageOperation() {
-	delete d;
-}
-
-
-void RedEyeReductionImageOperation::redo() {
-	QImage img = document()->image();
-	QRect rect = PaintUtils::containingRect(d->mRectF);
-	d->mOriginalImage = img.copy(rect);
-	redoAsDocumentJob(new RedEyeReductionJob(d->mRectF));
-}
-
-
-void RedEyeReductionImageOperation::undo() {
-	if (!document()->editor()) {
-		kWarning() << "!document->editor()";
-		return;
-	}
-	QImage img = document()->image();
-	{
-		QPainter painter(&img);
-		painter.setCompositionMode(QPainter::CompositionMode_Source);
-		QRect rect = PaintUtils::containingRect(d->mRectF);
-		painter.drawImage(rect.topLeft(), d->mOriginalImage);
-	}
-	document()->editor()->setImage(img);
-}
-
+: d(new RedEyeReductionImageOperationPrivate)
+{
+    d->mRectF = rectF;
+    setText(i18n("RedEyeReduction"));
+}
+
+RedEyeReductionImageOperation::~RedEyeReductionImageOperation()
+{
+    delete d;
+}
+
+void RedEyeReductionImageOperation::redo()
+{
+    QImage img = document()->image();
+    QRect rect = PaintUtils::containingRect(d->mRectF);
+    d->mOriginalImage = img.copy(rect);
+    redoAsDocumentJob(new RedEyeReductionJob(d->mRectF));
+}
+
+void RedEyeReductionImageOperation::undo()
+{
+    if (!document()->editor()) {
+        kWarning() << "!document->editor()";
+        return;
+    }
+    QImage img = document()->image();
+    {
+        QPainter painter(&img);
+        painter.setCompositionMode(QPainter::CompositionMode_Source);
+        QRect rect = PaintUtils::containingRect(d->mRectF);
+        painter.drawImage(rect.topLeft(), d->mOriginalImage);
+    }
+    document()->editor()->setImage(img);
+}
 
 /**
  * This code is inspired from code found in a Paint.net plugin:
  * http://paintdotnet.forumer.com/viewtopic.php?f=27&t=26193&p=205954&hilit=red+eye#p205954
  */
-inline qreal computeRedEyeAlpha(const QColor& src) {
-	int hue, sat, value;
-	src.getHsv(&hue, &sat, &value);
-
-	qreal axs = 1.0;
-	if (hue > 259) {
-		static const Ramp ramp(30, 35, 0., 1.);
-		axs = ramp(sat);
-	} else {
-		const Ramp ramp(hue * 2 + 29, hue * 2 + 40, 0., 1.);
-		axs = ramp(sat);
-	}
-
-	return qBound(0., double(src.alphaF()) * axs, 1.);
-}
-
-
-void RedEyeReductionImageOperation::apply(QImage* img, const QRectF& rectF) {
-	const QRect rect = PaintUtils::containingRect(rectF);
-	const qreal radius = rectF.width() / 2;
-	const qreal centerX = rectF.x() + radius;
-	const qreal centerY = rectF.y() + radius;
-	const Ramp radiusRamp(qMin(double(radius * 0.7), double(radius - 1)), radius, 1., 0.);
-
-	uchar* line = img->scanLine(rect.top()) + rect.left() * 4;
-	for (int y = rect.top(); y < rect.bottom(); ++y, line += img->bytesPerLine()) {
-		QRgb* ptr = (QRgb*)line;
-
-		for (int x = rect.left(); x < rect.right(); ++x, ++ptr) {
-			const qreal currentRadius = sqrt(pow(y - centerY, 2) + pow(x - centerX, 2));
-			qreal alpha = radiusRamp(currentRadius);
-			if (qFuzzyCompare(alpha, 0)) {
-				continue;
-			}
-
-			const QColor src(*ptr);
-			alpha *= computeRedEyeAlpha(src);
-			int r = src.red();
-			int g = src.green();
-			int b = src.blue();
-			QColor dst;
-			// Replace red with green, and blend according to alpha
-			dst.setRed  (int((1 - alpha) * r + alpha * g));
-			dst.setGreen(int((1 - alpha) * g + alpha * g));
-			dst.setBlue (int((1 - alpha) * b + alpha * b));
-			*ptr = dst.rgba();
-		}
-	}
-}
-
+inline qreal computeRedEyeAlpha(const QColor& src)
+{
+    int hue, sat, value;
+    src.getHsv(&hue, &sat, &value);
+
+    qreal axs = 1.0;
+    if (hue > 259) {
+        static const Ramp ramp(30, 35, 0., 1.);
+        axs = ramp(sat);
+    } else {
+        const Ramp ramp(hue * 2 + 29, hue * 2 + 40, 0., 1.);
+        axs = ramp(sat);
+    }
+
+    return qBound(0., double(src.alphaF()) * axs, 1.);
+}
+
+void RedEyeReductionImageOperation::apply(QImage* img, const QRectF& rectF)
+{
+    const QRect rect = PaintUtils::containingRect(rectF);
+    const qreal radius = rectF.width() / 2;
+    const qreal centerX = rectF.x() + radius;
+    const qreal centerY = rectF.y() + radius;
+    const Ramp radiusRamp(qMin(double(radius * 0.7), double(radius - 1)), radius, 1., 0.);
+
+    uchar* line = img->scanLine(rect.top()) + rect.left() * 4;
+    for (int y = rect.top(); y < rect.bottom(); ++y, line += img->bytesPerLine()) {
+        QRgb* ptr = (QRgb*)line;
+
+        for (int x = rect.left(); x < rect.right(); ++x, ++ptr) {
+            const qreal currentRadius = sqrt(pow(y - centerY, 2) + pow(x - centerX, 2));
+            qreal alpha = radiusRamp(currentRadius);
+            if (qFuzzyCompare(alpha, 0)) {
+                continue;
+            }
+
+            const QColor src(*ptr);
+            alpha *= computeRedEyeAlpha(src);
+            int r = src.red();
+            int g = src.green();
+            int b = src.blue();
+            QColor dst;
+            // Replace red with green, and blend according to alpha
+            dst.setRed(int((1 - alpha) * r + alpha * g));
+            dst.setGreen(int((1 - alpha) * g + alpha * g));
+            dst.setBlue(int((1 - alpha) * b + alpha * b));
+            *ptr = dst.rgba();
+        }
+    }
+}
 
 } // namespace

=== modified file 'lib/redeyereduction/redeyereductionimageoperation.h'
--- lib/redeyereduction/redeyereductionimageoperation.h	2011-07-20 13:46:34 +0000
+++ lib/redeyereduction/redeyereductionimageoperation.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -32,25 +32,25 @@
 
 class QRectF;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct RedEyeReductionImageOperationPrivate;
-class GWENVIEWLIB_EXPORT RedEyeReductionImageOperation : public AbstractImageOperation {
+class GWENVIEWLIB_EXPORT RedEyeReductionImageOperation : public AbstractImageOperation
+{
 public:
-	RedEyeReductionImageOperation(const QRectF&);
-	~RedEyeReductionImageOperation();
-
-	virtual void redo();
-	virtual void undo();
-
-	static void apply(QImage* img, const QRectF& rectF);
+    RedEyeReductionImageOperation(const QRectF&);
+    ~RedEyeReductionImageOperation();
+
+    virtual void redo();
+    virtual void undo();
+
+    static void apply(QImage* img, const QRectF& rectF);
 
 private:
-	RedEyeReductionImageOperationPrivate* const d;
+    RedEyeReductionImageOperationPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* REDEYEREDUCTIONIMAGEOPERATION_H */

=== modified file 'lib/redeyereduction/redeyereductiontool.cpp'
--- lib/redeyereduction/redeyereductiontool.cpp	2011-07-20 13:46:34 +0000
+++ lib/redeyereduction/redeyereductiontool.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -22,10 +22,9 @@
 #include "redeyereductiontool.moc"
 
 // Qt
-#include <QMouseEvent>
+#include <QGraphicsSceneMouseEvent>
 #include <QPainter>
-#include <QStyle>
-#include <QToolButton>
+#include <QPushButton>
 #include <QRect>
 
 // KDE
@@ -33,180 +32,160 @@
 #include <klocale.h>
 
 // Local
-#include <lib/hudwidget.h>
+#include <lib/documentview/rasterimageview.h>
 #include "gwenviewconfig.h"
-#include "imageview.h"
 #include "paintutils.h"
 #include "redeyereductionimageoperation.h"
-#include "ui_redeyereductionhud.h"
-#include "widgetfloater.h"
-
-
-namespace Gwenview {
-
-
-struct RedEyeReductionHud : public QWidget, public Ui_RedEyeReductionHud {
-	RedEyeReductionHud() {
-		setupUi(this);
-		setCursor(Qt::ArrowCursor);
-	}
-};
-
-
-struct RedEyeReductionToolPrivate {
-	RedEyeReductionTool* mRedEyeReductionTool;
-	RedEyeReductionTool::Status mStatus;
-	QPointF mCenter;
-	int mDiameter;
-	RedEyeReductionHud* mHud;
-	HudWidget* mHudWidget;
-	WidgetFloater* mFloater;
-
-
-	void showNotSetHudWidget() {
-		mHud->deleteLater();
-		mHud = 0;
-		QLabel* label = new QLabel(i18n("Click on the red eye you want to fix."));
-		label->show();
-		label->adjustSize();
-		createHudWidgetForWidget(label);
-	}
-
-
-	void showAdjustingHudWidget() {
-		mHud = new RedEyeReductionHud();
-
-		mHud->diameterSpinBox->setValue(mDiameter);
-		QObject::connect(mHud->applyButton, SIGNAL(clicked()),
-			mRedEyeReductionTool, SLOT(slotApplyClicked()));
-		QObject::connect(mHud->diameterSpinBox, SIGNAL(valueChanged(int)),
-			mRedEyeReductionTool, SLOT(setDiameter(int)));
-
-		createHudWidgetForWidget(mHud);
-	}
-
-
-	void createHudWidgetForWidget(QWidget* widget) {
-		mHudWidget->deleteLater();
-		mHudWidget = new HudWidget();
-		mHudWidget->init(widget, HudWidget::OptionCloseButton);
-		mHudWidget->adjustSize();
-		QObject::connect(mHudWidget, SIGNAL(closed()),
-			mRedEyeReductionTool, SIGNAL(done()) );
-		mFloater->setChildWidget(mHudWidget);
-	}
-
-
-	void hideHud() {
-		mHudWidget->hide();
-	}
-
-
-	QRectF rectF() const {
-		if (mStatus == RedEyeReductionTool::NotSet) {
-			return QRectF();
-		}
-		return QRectF(mCenter.x() - mDiameter / 2, mCenter.y() - mDiameter / 2, mDiameter, mDiameter);
-	}
-};
-
-
-RedEyeReductionTool::RedEyeReductionTool(ImageView* view)
-: AbstractImageViewTool(view)
-, d(new RedEyeReductionToolPrivate) {
-	d->mRedEyeReductionTool = this;
-	d->mDiameter = GwenviewConfig::redEyeReductionDiameter();
-	d->mStatus = NotSet;
-	d->mHud = 0;
-	d->mHudWidget = 0;
-
-	d->mFloater = new WidgetFloater(imageView());
-	d->mFloater->setAlignment(Qt::AlignHCenter | Qt::AlignBottom);
-	d->mFloater->setVerticalMargin(
-		KDialog::marginHint()
-		+ imageView()->style()->pixelMetric(QStyle::PM_ScrollBarExtent)
-		);
-	d->showNotSetHudWidget();
-
-	view->document()->startLoadingFullImage();
-}
-
-
-RedEyeReductionTool::~RedEyeReductionTool() {
-	GwenviewConfig::setRedEyeReductionDiameter(d->mDiameter);
-	delete d;
-}
-
-
-void RedEyeReductionTool::paint(QPainter* painter) {
-	if (d->mStatus == NotSet) {
-		return;
-	}
-	QRectF docRectF = d->rectF();
-	imageView()->document()->waitUntilLoaded();
-
-	QRect docRect = PaintUtils::containingRect(docRectF);
-	QImage img = imageView()->document()->image().copy(docRect);
-	QRectF imgRectF(
-		docRectF.left() - docRect.left(),
-		docRectF.top()  - docRect.top(),
-		docRectF.width(),
-		docRectF.height()
-		);
-	RedEyeReductionImageOperation::apply(&img, imgRectF);
-
-	const QRectF viewRectF = imageView()->mapToViewportF(docRectF);
-	painter->drawImage(viewRectF, img, imgRectF);
-}
-
-
-void RedEyeReductionTool::mousePressEvent(QMouseEvent* event) {
-	if (d->mStatus == NotSet) {
-		d->showAdjustingHudWidget();
-		d->mStatus = Adjusting;
-	}
-	d->mCenter = imageView()->mapToImageF(event->pos());
-	imageView()->viewport()->update();
-}
-
-
-void RedEyeReductionTool::mouseMoveEvent(QMouseEvent* event) {
-	if (event->buttons() == Qt::NoButton) {
-		return;
-	}
-	d->mCenter = imageView()->mapToImageF(event->pos());
-	imageView()->viewport()->update();
-}
-
-
-void RedEyeReductionTool::toolActivated() {
-	imageView()->viewport()->setCursor(Qt::CrossCursor);
-}
-
-
-void RedEyeReductionTool::toolDeactivated() {
-	d->mHudWidget->deleteLater();
-}
-
-
-void RedEyeReductionTool::slotApplyClicked() {
-	QRectF docRectF = d->rectF();
-	if (!docRectF.isValid()) {
-		kWarning() << "invalid rect";
-		return;
-	}
-	RedEyeReductionImageOperation* op = new RedEyeReductionImageOperation(docRectF);
-	emit imageOperationRequested(op);
-
-	d->mStatus = NotSet;
-	d->showNotSetHudWidget();
-}
-
-
-void RedEyeReductionTool::setDiameter(int value) {
-	d->mDiameter = value;
-	imageView()->viewport()->update();
-}
-
+#include "ui_redeyereductionwidget.h"
+
+namespace Gwenview
+{
+
+struct RedEyeReductionWidget : public QWidget, public Ui_RedEyeReductionWidget
+{
+    RedEyeReductionWidget()
+    {
+        setupUi(this);
+    }
+
+    void showNotSetPage()
+    {
+        dialogButtonBox->button(QDialogButtonBox::Ok)->hide();
+        stackedWidget->setCurrentWidget(notSetPage);
+    }
+
+    void showMainPage()
+    {
+        dialogButtonBox->button(QDialogButtonBox::Ok)->show();
+        stackedWidget->setCurrentWidget(mainPage);
+    }
+};
+
+struct RedEyeReductionToolPrivate
+{
+    RedEyeReductionTool* q;
+    RedEyeReductionTool::Status mStatus;
+    QPointF mCenter;
+    int mDiameter;
+    RedEyeReductionWidget* mToolWidget;
+
+    void setupToolWidget()
+    {
+        mToolWidget = new RedEyeReductionWidget;
+        mToolWidget->showNotSetPage();
+        QObject::connect(mToolWidget->diameterSpinBox, SIGNAL(valueChanged(int)),
+                         q, SLOT(setDiameter(int)));
+        QObject::connect(mToolWidget->dialogButtonBox, SIGNAL(accepted()),
+                         q, SLOT(slotApplyClicked()));
+        QObject::connect(mToolWidget->dialogButtonBox, SIGNAL(rejected()),
+                         q, SIGNAL(done()));
+    }
+
+    QRectF rectF() const {
+        if (mStatus == RedEyeReductionTool::NotSet) {
+            return QRectF();
+        }
+        return QRectF(mCenter.x() - mDiameter / 2, mCenter.y() - mDiameter / 2, mDiameter, mDiameter);
+    }
+};
+
+RedEyeReductionTool::RedEyeReductionTool(RasterImageView* view)
+: AbstractRasterImageViewTool(view)
+, d(new RedEyeReductionToolPrivate)
+{
+    d->q = this;
+    d->mDiameter = GwenviewConfig::redEyeReductionDiameter();
+    d->mStatus = NotSet;
+    d->setupToolWidget();
+
+    view->document()->startLoadingFullImage();
+}
+
+RedEyeReductionTool::~RedEyeReductionTool()
+{
+    GwenviewConfig::setRedEyeReductionDiameter(d->mDiameter);
+    delete d->mToolWidget;
+    delete d;
+}
+
+void RedEyeReductionTool::paint(QPainter* painter)
+{
+    if (d->mStatus == NotSet) {
+        return;
+    }
+    QRectF docRectF = d->rectF();
+    imageView()->document()->waitUntilLoaded();
+
+    QRect docRect = PaintUtils::containingRect(docRectF);
+    QImage img = imageView()->document()->image().copy(docRect);
+    QRectF imgRectF(
+        docRectF.left() - docRect.left(),
+        docRectF.top()  - docRect.top(),
+        docRectF.width(),
+        docRectF.height()
+    );
+    RedEyeReductionImageOperation::apply(&img, imgRectF);
+
+    const QRectF viewRectF = imageView()->mapToView(docRectF);
+    painter->drawImage(viewRectF, img, imgRectF);
+}
+
+void RedEyeReductionTool::mousePressEvent(QGraphicsSceneMouseEvent* event)
+{
+    event->accept();
+    if (d->mStatus == NotSet) {
+        d->mToolWidget->diameterSpinBox->setValue(d->mDiameter);
+        d->mToolWidget->showMainPage();
+        d->mStatus = Adjusting;
+    }
+    d->mCenter = imageView()->mapToImage(event->pos());
+    imageView()->update();
+}
+
+void RedEyeReductionTool::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
+{
+    event->accept();
+    if (event->buttons() == Qt::NoButton) {
+        return;
+    }
+    d->mCenter = imageView()->mapToImage(event->pos());
+    imageView()->update();
+}
+
+void RedEyeReductionTool::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
+{
+    // Just prevent the event from reaching the image view
+    event->accept();
+}
+
+void RedEyeReductionTool::toolActivated()
+{
+    imageView()->setCursor(Qt::CrossCursor);
+}
+
+void RedEyeReductionTool::slotApplyClicked()
+{
+    QRectF docRectF = d->rectF();
+    if (!docRectF.isValid()) {
+        kWarning() << "invalid rect";
+        return;
+    }
+    RedEyeReductionImageOperation* op = new RedEyeReductionImageOperation(docRectF);
+    emit imageOperationRequested(op);
+
+    d->mStatus = NotSet;
+    d->mToolWidget->showNotSetPage();
+}
+
+void RedEyeReductionTool::setDiameter(int value)
+{
+    d->mDiameter = value;
+    imageView()->update();
+}
+
+QWidget* RedEyeReductionTool::widget() const
+{
+    return d->mToolWidget;
+}
 
 } // namespace

=== modified file 'lib/redeyereduction/redeyereductiontool.h'
--- lib/redeyereduction/redeyereductiontool.h	2011-07-20 13:46:34 +0000
+++ lib/redeyereduction/redeyereductiontool.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -28,46 +28,49 @@
 // KDE
 
 // Local
-#include <lib/abstractimageviewtool.h>
+#include <lib/documentview/abstractrasterimageviewtool.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class AbstractImageOperation;
-class ImageView;
+class RasterImageView;
 
 struct RedEyeReductionToolPrivate;
-class GWENVIEWLIB_EXPORT RedEyeReductionTool : public AbstractImageViewTool {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT RedEyeReductionTool : public AbstractRasterImageViewTool
+{
+    Q_OBJECT
 public:
-	enum Status {
-		NotSet,
-		Adjusting
-	};
-
-	RedEyeReductionTool(ImageView* parent);
-	~RedEyeReductionTool();
-
-	virtual void paint(QPainter*);
-
-	virtual void mousePressEvent(QMouseEvent*);
-	virtual void mouseMoveEvent(QMouseEvent*);
-
-	virtual void toolActivated();
-	virtual void toolDeactivated();
+    enum Status {
+        NotSet,
+        Adjusting
+    };
+
+    RedEyeReductionTool(RasterImageView* parent);
+    ~RedEyeReductionTool();
+
+    virtual void paint(QPainter*);
+
+    virtual void mousePressEvent(QGraphicsSceneMouseEvent*);
+    virtual void mouseMoveEvent(QGraphicsSceneMouseEvent*);
+    virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent*);
+
+    virtual void toolActivated();
+
+    QWidget* widget() const;
 
 Q_SIGNALS:
-	void done();
-	void imageOperationRequested(AbstractImageOperation*);
+    void done();
+    void imageOperationRequested(AbstractImageOperation*);
 
 private Q_SLOTS:
-	void setDiameter(int);
-	void slotApplyClicked();
+    void setDiameter(int);
+    void slotApplyClicked();
 
 private:
-	RedEyeReductionToolPrivate* const d;
+    RedEyeReductionToolPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* REDEYEREDUCTIONTOOL_H */

=== added file 'lib/redeyereduction/redeyereductionwidget.ui'
--- lib/redeyereduction/redeyereductionwidget.ui	1970-01-01 00:00:00 +0000
+++ lib/redeyereduction/redeyereductionwidget.ui	2011-12-15 14:17:54 +0000
@@ -0,0 +1,127 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>RedEyeReductionWidget</class>
+ <widget class="QWidget" name="RedEyeReductionWidget">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>372</width>
+    <height>51</height>
+   </rect>
+  </property>
+  <layout class="QHBoxLayout" name="horizontalLayout">
+   <item>
+    <widget class="QStackedWidget" name="stackedWidget">
+     <property name="currentIndex">
+      <number>0</number>
+     </property>
+     <widget class="QWidget" name="mainPage">
+      <layout class="QHBoxLayout" name="horizontalLayout_2">
+       <item>
+        <widget class="QLabel" name="label">
+         <property name="text">
+          <string>Size</string>
+         </property>
+         <property name="buddy">
+          <cstring>diameterSlider</cstring>
+         </property>
+        </widget>
+       </item>
+       <item>
+        <widget class="QSlider" name="diameterSlider">
+         <property name="minimum">
+          <number>2</number>
+         </property>
+         <property name="maximum">
+          <number>40</number>
+         </property>
+         <property name="orientation">
+          <enum>Qt::Horizontal</enum>
+         </property>
+        </widget>
+       </item>
+       <item>
+        <widget class="KIntSpinBox" name="diameterSpinBox">
+         <property name="minimum">
+          <number>2</number>
+         </property>
+        </widget>
+       </item>
+      </layout>
+      <zorder>diameterSpinBox</zorder>
+      <zorder>diameterSlider</zorder>
+      <zorder>diameterSpinBox</zorder>
+      <zorder>label</zorder>
+      <zorder>diameterSlider</zorder>
+     </widget>
+     <widget class="QWidget" name="notSetPage">
+      <layout class="QHBoxLayout" name="horizontalLayout_3">
+       <item>
+        <widget class="QLabel" name="label_2">
+         <property name="text">
+          <string>Click on the red eye you want to fix</string>
+         </property>
+        </widget>
+       </item>
+      </layout>
+     </widget>
+    </widget>
+   </item>
+   <item>
+    <widget class="KDialogButtonBox" name="dialogButtonBox">
+     <property name="standardButtons">
+      <set>QDialogButtonBox::Close|QDialogButtonBox::Ok</set>
+     </property>
+    </widget>
+   </item>
+  </layout>
+ </widget>
+ <customwidgets>
+  <customwidget>
+   <class>KDialogButtonBox</class>
+   <extends>QDialogButtonBox</extends>
+   <header>kdialogbuttonbox.h</header>
+  </customwidget>
+  <customwidget>
+   <class>KIntSpinBox</class>
+   <extends>QSpinBox</extends>
+   <header>knuminput.h</header>
+  </customwidget>
+ </customwidgets>
+ <resources/>
+ <connections>
+  <connection>
+   <sender>diameterSlider</sender>
+   <signal>sliderMoved(int)</signal>
+   <receiver>diameterSpinBox</receiver>
+   <slot>setValue(int)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>120</x>
+     <y>22</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>175</x>
+     <y>21</y>
+    </hint>
+   </hints>
+  </connection>
+  <connection>
+   <sender>diameterSpinBox</sender>
+   <signal>valueChanged(int)</signal>
+   <receiver>diameterSlider</receiver>
+   <slot>setValue(int)</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>153</x>
+     <y>7</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>124</x>
+     <y>7</y>
+    </hint>
+   </hints>
+  </connection>
+ </connections>
+</ui>

=== modified file 'lib/resize/resizeimagedialog.cpp'
--- lib/resize/resizeimagedialog.cpp	2011-07-20 13:46:34 +0000
+++ lib/resize/resizeimagedialog.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -28,87 +28,87 @@
 // Local
 #include <ui_resizeimagewidget.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ResizeImageDialogPrivate : public Ui_ResizeImageWidget {
-	bool mUpdateFromRatio;
-	QSize mOriginalSize;
+    bool mUpdateFromRatio;
+    QSize mOriginalSize;
 };
 
-
 ResizeImageDialog::ResizeImageDialog(QWidget* parent)
 : KDialog(parent)
-, d(new ResizeImageDialogPrivate) {
-	d->mUpdateFromRatio = false;
-
-	QWidget* content = new QWidget(this);
-	d->setupUi(content);
-	content->layout()->setMargin(0);
-	setMainWidget(content);
-	showButtonSeparator(true);
-	setButtonGuiItem(Ok, KGuiItem(i18n("Resize"), "transform-scale"));
-	setWindowTitle(content->windowTitle());
-	d->mWidthSpinBox->setFocus();
-
-	connect(d->mWidthSpinBox, SIGNAL(valueChanged(int)), SLOT(slotWidthChanged(int)));
-	connect(d->mHeightSpinBox, SIGNAL(valueChanged(int)), SLOT(slotHeightChanged(int)));
-	connect(d->mKeepAspectCheckBox, SIGNAL(toggled(bool)), SLOT(slotKeepAspectChanged(bool)));
-}
-
-
-ResizeImageDialog::~ResizeImageDialog() {
-	delete d;
-}
-
-
-void ResizeImageDialog::setOriginalSize(const QSize& size) {
-	d->mOriginalSize = size;
-	d->mOriginalWidthLabel->setText(QString::number(size.width()));
-	d->mOriginalHeightLabel->setText(QString::number(size.height()));
-	d->mWidthSpinBox->setValue(size.width());
-	d->mHeightSpinBox->setValue(size.height());
-}
-
-
-QSize ResizeImageDialog::size() const {
-	return QSize(
-		d->mWidthSpinBox->value(),
-		d->mHeightSpinBox->value()
-	);
-}
-
-
-void ResizeImageDialog::slotWidthChanged(int width) {
-	if (!d->mKeepAspectCheckBox->isChecked()) {
-		return;
-	}
-	if (d->mUpdateFromRatio) {
-		return;
-	}
-	d->mUpdateFromRatio = true;
-	d->mHeightSpinBox->setValue(d->mOriginalSize.height() * width / d->mOriginalSize.width());
-	d->mUpdateFromRatio = false;
-}
-
-
-void ResizeImageDialog::slotHeightChanged(int height) {
-	if (!d->mKeepAspectCheckBox->isChecked()) {
-		return;
-	}
-	if (d->mUpdateFromRatio) {
-		return;
-	}
-	d->mUpdateFromRatio = true;
-	d->mWidthSpinBox->setValue(d->mOriginalSize.width() * height / d->mOriginalSize.height());
-	d->mUpdateFromRatio = false;
-}
-
-
-void ResizeImageDialog::slotKeepAspectChanged(bool value) {
-	if (value) {
-		slotWidthChanged(d->mWidthSpinBox->value());
-	}
+, d(new ResizeImageDialogPrivate)
+{
+    d->mUpdateFromRatio = false;
+
+    QWidget* content = new QWidget(this);
+    d->setupUi(content);
+    content->layout()->setMargin(0);
+    setMainWidget(content);
+    showButtonSeparator(true);
+    setButtonGuiItem(Ok, KGuiItem(i18n("Resize"), "transform-scale"));
+    setWindowTitle(content->windowTitle());
+    d->mWidthSpinBox->setFocus();
+
+    connect(d->mWidthSpinBox, SIGNAL(valueChanged(int)), SLOT(slotWidthChanged(int)));
+    connect(d->mHeightSpinBox, SIGNAL(valueChanged(int)), SLOT(slotHeightChanged(int)));
+    connect(d->mKeepAspectCheckBox, SIGNAL(toggled(bool)), SLOT(slotKeepAspectChanged(bool)));
+}
+
+ResizeImageDialog::~ResizeImageDialog()
+{
+    delete d;
+}
+
+void ResizeImageDialog::setOriginalSize(const QSize& size)
+{
+    d->mOriginalSize = size;
+    d->mOriginalWidthLabel->setText(QString::number(size.width()));
+    d->mOriginalHeightLabel->setText(QString::number(size.height()));
+    d->mWidthSpinBox->setValue(size.width());
+    d->mHeightSpinBox->setValue(size.height());
+}
+
+QSize ResizeImageDialog::size() const
+{
+    return QSize(
+               d->mWidthSpinBox->value(),
+               d->mHeightSpinBox->value()
+           );
+}
+
+void ResizeImageDialog::slotWidthChanged(int width)
+{
+    if (!d->mKeepAspectCheckBox->isChecked()) {
+        return;
+    }
+    if (d->mUpdateFromRatio) {
+        return;
+    }
+    d->mUpdateFromRatio = true;
+    d->mHeightSpinBox->setValue(d->mOriginalSize.height() * width / d->mOriginalSize.width());
+    d->mUpdateFromRatio = false;
+}
+
+void ResizeImageDialog::slotHeightChanged(int height)
+{
+    if (!d->mKeepAspectCheckBox->isChecked()) {
+        return;
+    }
+    if (d->mUpdateFromRatio) {
+        return;
+    }
+    d->mUpdateFromRatio = true;
+    d->mWidthSpinBox->setValue(d->mOriginalSize.width() * height / d->mOriginalSize.height());
+    d->mUpdateFromRatio = false;
+}
+
+void ResizeImageDialog::slotKeepAspectChanged(bool value)
+{
+    if (value) {
+        slotWidthChanged(d->mWidthSpinBox->value());
+    }
 }
 
 } // namespace

=== modified file 'lib/resize/resizeimagedialog.h'
--- lib/resize/resizeimagedialog.h	2011-07-20 13:46:34 +0000
+++ lib/resize/resizeimagedialog.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -30,29 +30,29 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class ResizeImageDialogPrivate;
-class GWENVIEWLIB_EXPORT ResizeImageDialog : public KDialog {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ResizeImageDialog : public KDialog
+{
+    Q_OBJECT
 public:
-	ResizeImageDialog(QWidget *parent);
-	~ResizeImageDialog();
+    ResizeImageDialog(QWidget *parent);
+    ~ResizeImageDialog();
 
-	void setOriginalSize(const QSize&);
-	QSize size() const;
+    void setOriginalSize(const QSize&);
+    QSize size() const;
 
 private Q_SLOTS:
-	void slotWidthChanged(int);
-	void slotHeightChanged(int);
-	void slotKeepAspectChanged(bool);
+    void slotWidthChanged(int);
+    void slotHeightChanged(int);
+    void slotKeepAspectChanged(bool);
 
 private:
-	ResizeImageDialogPrivate* const d;
+    ResizeImageDialogPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* RESIZEIMAGEDIALOG_H */

=== modified file 'lib/resize/resizeimageoperation.cpp'
--- lib/resize/resizeimageoperation.cpp	2011-07-20 13:46:34 +0000
+++ lib/resize/resizeimageoperation.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -33,61 +33,61 @@
 #include "document/document.h"
 #include "document/documentjob.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ResizeImageOperationPrivate {
-	QSize mSize;
-	QImage mOriginalImage;
+    QSize mSize;
+    QImage mOriginalImage;
 };
 
-
-class ResizeJob : public ThreadedDocumentJob {
+class ResizeJob : public ThreadedDocumentJob
+{
 public:
-	ResizeJob(const QSize& size)
-	: mSize(size)
-	{}
+    ResizeJob(const QSize& size)
+        : mSize(size)
+    {}
 
-	virtual void threadedStart() {
-		if (!checkDocumentEditor()) {
-			return;
-		}
-		QImage image = document()->image();
-		image = image.scaled(mSize, Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
-		document()->editor()->setImage(image);
-		setError(NoError);
-	}
+    virtual void threadedStart()
+    {
+        if (!checkDocumentEditor()) {
+            return;
+        }
+        QImage image = document()->image();
+        image = image.scaled(mSize, Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
+        document()->editor()->setImage(image);
+        setError(NoError);
+    }
 
 private:
-	QSize mSize;
+    QSize mSize;
 };
 
-
 ResizeImageOperation::ResizeImageOperation(const QSize& size)
-: d(new ResizeImageOperationPrivate) {
-	d->mSize = size;
-	setText(i18nc("(qtundo-format)", "Resize"));
-}
-
-
-ResizeImageOperation::~ResizeImageOperation() {
-	delete d;
-}
-
-
-void ResizeImageOperation::redo() {
-	d->mOriginalImage = document()->image();
-	redoAsDocumentJob(new ResizeJob(d->mSize));
-}
-
-
-void ResizeImageOperation::undo() {
-	if (!document()->editor()) {
-		kWarning() << "!document->editor()";
-		return;
-	}
-	document()->editor()->setImage(d->mOriginalImage);
-}
-
+: d(new ResizeImageOperationPrivate)
+{
+    d->mSize = size;
+    setText(i18nc("(qtundo-format)", "Resize"));
+}
+
+ResizeImageOperation::~ResizeImageOperation()
+{
+    delete d;
+}
+
+void ResizeImageOperation::redo()
+{
+    d->mOriginalImage = document()->image();
+    redoAsDocumentJob(new ResizeJob(d->mSize));
+}
+
+void ResizeImageOperation::undo()
+{
+    if (!document()->editor()) {
+        kWarning() << "!document->editor()";
+        return;
+    }
+    document()->editor()->setImage(d->mOriginalImage);
+}
 
 } // namespace

=== modified file 'lib/resize/resizeimageoperation.h'
--- lib/resize/resizeimageoperation.h	2011-07-20 13:46:34 +0000
+++ lib/resize/resizeimageoperation.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -30,23 +30,23 @@
 // Local
 #include <lib/abstractimageoperation.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ResizeImageOperationPrivate;
-class GWENVIEWLIB_EXPORT ResizeImageOperation : public AbstractImageOperation {
+class GWENVIEWLIB_EXPORT ResizeImageOperation : public AbstractImageOperation
+{
 public:
-	ResizeImageOperation(const QSize& size);
-	~ResizeImageOperation();
+    ResizeImageOperation(const QSize& size);
+    ~ResizeImageOperation();
 
-	virtual void redo();
-	virtual void undo();
+    virtual void redo();
+    virtual void undo();
 
 private:
-	ResizeImageOperationPrivate* const d;
+    ResizeImageOperationPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* RESIZEIMAGEOPERATION_H */

=== removed file 'lib/scrolltool.cpp'
--- lib/scrolltool.cpp	2011-07-20 13:46:34 +0000
+++ lib/scrolltool.cpp	1970-01-01 00:00:00 +0000
@@ -1,147 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-
-*/
-// Self
-#include "scrolltool.moc"
-
-// Qt
-#include <QApplication>
-#include <QMouseEvent>
-#include <QScrollBar>
-
-// KDE
-#include <kdebug.h>
-
-// Local
-#include "imageview.h"
-
-namespace Gwenview {
-
-enum State { StateNone, StateZooming, StateDragging };
-
-struct ScrollToolPrivate {
-	int mScrollStartX;
-	int mScrollStartY;
-	State mState;
-};
-
-
-ScrollTool::ScrollTool(ImageView* view)
-: AbstractImageViewTool(view)
-, d(new ScrollToolPrivate) {
-	d->mState = StateNone;
-}
-
-
-ScrollTool::~ScrollTool() {
-	delete d;
-}
-
-
-void ScrollTool::mousePressEvent(QMouseEvent* event) {
-	if (imageView()->zoomToFit()) {
-		return;
-	}
-
-	if (event->button() != Qt::LeftButton) {
-		return;
-	}
-
-	d->mScrollStartY = event->y();
-	d->mScrollStartX = event->x();
-	d->mState = StateDragging;
-	imageView()->viewport()->setCursor(Qt::ClosedHandCursor);
-}
-
-
-void ScrollTool::mouseMoveEvent(QMouseEvent* event) {
-	if (d->mState != StateDragging) {
-		return;
-	}
-
-	QScrollBar* hScrollBar = imageView()->horizontalScrollBar();
-	QScrollBar* vScrollBar = imageView()->verticalScrollBar();
-	int width = imageView()->width();
-	int height = imageView()->height();
-
-	QPoint mousePos = event->pos();
-
-	int deltaX = d->mScrollStartX - mousePos.x();
-	int deltaY = d->mScrollStartY - mousePos.y();
-
-	if (mousePos.y() <= 4 && vScrollBar->value() < vScrollBar->maximum() - 10) {
-		// wrap mouse from top to bottom
-		mousePos.setY(height - 5);
-	} else if (mousePos.y() >= height - 4 && vScrollBar->value() > 10) {
-		// wrap mouse from bottom to top
-		mousePos.setY(5);
-	}
-
-	if (mousePos.x() <= 4 && hScrollBar->value() < hScrollBar->maximum() - 10) {
-		// wrap mouse from left to right
-		mousePos.setX(width - 5);
-	} else if (mousePos.x() >= width - 4 && hScrollBar->value() > 10) {
-		// wrap mouse from right to left
-		mousePos.setX(5);
-	}
-
-	if (mousePos != event->pos()) {
-		QCursor::setPos(imageView()->mapToGlobal(mousePos));
-	}
-
-	d->mScrollStartX = mousePos.x();
-	d->mScrollStartY = mousePos.y();
-	hScrollBar->setValue(hScrollBar->value() + deltaX);
-	vScrollBar->setValue(vScrollBar->value() + deltaY);
-}
-
-
-void ScrollTool::mouseReleaseEvent(QMouseEvent* /*event*/) {
-	if (d->mState != StateDragging) {
-		return;
-	}
-
-	d->mState = StateNone;
-	imageView()->viewport()->setCursor(Qt::OpenHandCursor);
-}
-
-
-void ScrollTool::wheelEvent(QWheelEvent* event) {
-	// Forward events to the scrollbars, like QAbstractScrollArea::wheelEvent()
-	// does.
-	if (event->orientation() == Qt::Horizontal) {
-		QApplication::sendEvent(imageView()->horizontalScrollBar(), event);
-	} else {
-		QApplication::sendEvent(imageView()->verticalScrollBar(), event);
-	}
-}
-
-
-void ScrollTool::toolActivated() {
-	imageView()->viewport()->setCursor(Qt::OpenHandCursor);
-}
-
-
-void ScrollTool::toolDeactivated() {
-	imageView()->viewport()->setCursor(Qt::ArrowCursor);
-}
-
-
-} // namespace

=== removed file 'lib/scrolltool.h'
--- lib/scrolltool.h	2011-07-20 13:46:34 +0000
+++ lib/scrolltool.h	1970-01-01 00:00:00 +0000
@@ -1,71 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-
-*/
-#ifndef SCROLLTOOL_H
-#define SCROLLTOOL_H
-
-#include <lib/gwenviewlib_export.h>
-
-// Qt
-
-// KDE
-
-// Local
-#include <lib/abstractimageviewtool.h>
-
-class QPoint;
-
-namespace Gwenview {
-
-
-struct ScrollToolPrivate;
-class GWENVIEWLIB_EXPORT ScrollTool : public AbstractImageViewTool {
-	Q_OBJECT
-public:
-	enum MouseWheelBehavior {
-		MouseWheelScroll,
-		MouseWheelBrowse
-	};
-
-	ScrollTool(ImageView* view);
-	~ScrollTool();
-
-	virtual void mousePressEvent(QMouseEvent*);
-	virtual void mouseMoveEvent(QMouseEvent*);
-	virtual void mouseReleaseEvent(QMouseEvent*);
-	virtual void wheelEvent(QWheelEvent*);
-
-	virtual void toolActivated();
-	virtual void toolDeactivated();
-
-Q_SIGNALS:
-	void zoomInRequested(const QPoint&);
-	void zoomOutRequested(const QPoint&);
-	void previousImageRequested();
-	void nextImageRequested();
-
-private:
-	ScrollToolPrivate* const d;
-};
-
-
-} // namespace
-
-#endif /* SCROLLTOOL_H */

=== modified file 'lib/semanticinfo/abstractsemanticinfobackend.cpp'
--- lib/semanticinfo/abstractsemanticinfobackend.cpp	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/abstractsemanticinfobackend.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,8 +29,8 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 TagSet::TagSet()
 : QSet<SemanticInfoTag>() {}
@@ -38,23 +38,22 @@
 TagSet::TagSet(const QSet<SemanticInfoTag>& set)
 : QSet<QString>(set) {}
 
-
-QVariant TagSet::toVariant() const {
-	QStringList lst = toList();
-	return QVariant(lst);
-}
-
-
-TagSet TagSet::fromVariant(const QVariant& variant) {
-	QStringList lst = variant.toStringList();
-	return TagSet::fromList(lst);
-}
-
+QVariant TagSet::toVariant() const
+{
+    QStringList lst = toList();
+    return QVariant(lst);
+}
+
+TagSet TagSet::fromVariant(const QVariant& variant)
+{
+    QStringList lst = variant.toStringList();
+    return TagSet::fromList(lst);
+}
 
 AbstractSemanticInfoBackEnd::AbstractSemanticInfoBackEnd(QObject* parent)
-: QObject(parent) {
-	qRegisterMetaType<SemanticInfo>("SemanticInfo");
+: QObject(parent)
+{
+    qRegisterMetaType<SemanticInfo>("SemanticInfo");
 }
 
-
 } // namespace

=== modified file 'lib/semanticinfo/abstractsemanticinfobackend.h'
--- lib/semanticinfo/abstractsemanticinfobackend.h	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/abstractsemanticinfobackend.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -33,73 +33,71 @@
 
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 typedef QString SemanticInfoTag;
 
-
 /**
  * This class represents the set of tags associated to an url.
  *
  * It provides convenience methods to convert to and from QVariant, which are
  * useful to communicate with SemanticInfoDirModel.
  */
-class GWENVIEWLIB_EXPORT TagSet : public QSet<SemanticInfoTag> {
+class GWENVIEWLIB_EXPORT TagSet : public QSet<SemanticInfoTag>
+{
 public:
-	TagSet();
-	TagSet(const QSet<SemanticInfoTag>&);
+    TagSet();
+    TagSet(const QSet<SemanticInfoTag>&);
 
-	QVariant toVariant() const;
-	static TagSet fromVariant(const QVariant&);
+    QVariant toVariant() const;
+    static TagSet fromVariant(const QVariant&);
 };
 
-
 /**
  * A POD struct used by AbstractSemanticInfoBackEnd to store the metadata
  * associated to an url.
  */
 struct SemanticInfo {
-	int mRating;
-	QString mDescription;
-	TagSet mTags;
+    int mRating;
+    QString mDescription;
+    TagSet mTags;
 };
 
-
 /**
  * An abstract class, used by SemanticInfoDirModel to store and retrieve metadata.
  */
-class AbstractSemanticInfoBackEnd : public QObject {
-	Q_OBJECT
+class AbstractSemanticInfoBackEnd : public QObject
+{
+    Q_OBJECT
 public:
-	AbstractSemanticInfoBackEnd(QObject* parent);
-
-	virtual TagSet allTags() const = 0;
-
-	virtual void refreshAllTags() = 0;
-
-	virtual void storeSemanticInfo(const KUrl&, const SemanticInfo&) = 0;
-
-	virtual void retrieveSemanticInfo(const KUrl&) = 0;
-
-	virtual QString labelForTag(const SemanticInfoTag&) const = 0;
-
-	/**
-	 * Return a tag for a label. Will emit tagAdded() if the tag had to be
-	 * created.
-	 */
-	virtual SemanticInfoTag tagForLabel(const QString&) = 0;
+    AbstractSemanticInfoBackEnd(QObject* parent);
+
+    virtual TagSet allTags() const = 0;
+
+    virtual void refreshAllTags() = 0;
+
+    virtual void storeSemanticInfo(const KUrl&, const SemanticInfo&) = 0;
+
+    virtual void retrieveSemanticInfo(const KUrl&) = 0;
+
+    virtual QString labelForTag(const SemanticInfoTag&) const = 0;
+
+    /**
+     * Return a tag for a label. Will emit tagAdded() if the tag had to be
+     * created.
+     */
+    virtual SemanticInfoTag tagForLabel(const QString&) = 0;
 
 Q_SIGNALS:
-	void semanticInfoRetrieved(const KUrl&, const SemanticInfo&);
+    void semanticInfoRetrieved(const KUrl&, const SemanticInfo&);
 
-	/**
-	 * Emitted whenever a new tag is added to allTags()
-	 */
-	void tagAdded(const SemanticInfoTag&, const QString& label);
+    /**
+     * Emitted whenever a new tag is added to allTags()
+     */
+    void tagAdded(const SemanticInfoTag&, const QString& label);
 };
 
-
 } // namespace
 
 #endif /* ABSTRACTSEMANTICINFOBACKEND_H */

=== modified file 'lib/semanticinfo/fakesemanticinfobackend.cpp'
--- lib/semanticinfo/fakesemanticinfobackend.cpp	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/fakesemanticinfobackend.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -29,77 +29,77 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 FakeSemanticInfoBackEnd::FakeSemanticInfoBackEnd(QObject* parent, InitializeMode mode)
 : AbstractSemanticInfoBackEnd(parent)
-, mInitializeMode(mode) {
-	mAllTags
-		<< tagForLabel("beach")
-		<< tagForLabel("mountains")
-		<< tagForLabel("wallpaper")
-		;
-}
-
-
-void FakeSemanticInfoBackEnd::storeSemanticInfo(const KUrl& url, const SemanticInfo& semanticInfo) {
-	mSemanticInfoForUrl[url] = semanticInfo;
-	mergeTagsWithAllTags(semanticInfo.mTags);
-}
-
-
-void FakeSemanticInfoBackEnd::mergeTagsWithAllTags(const TagSet& set) {
-	int size = mAllTags.size();
-	mAllTags |= set;
-	if (mAllTags.size() > size) {
-		//emit allTagsUpdated();
-	}
-}
-
-
-TagSet FakeSemanticInfoBackEnd::allTags() const {
-	return mAllTags;
-}
-
-
-void FakeSemanticInfoBackEnd::refreshAllTags() {
-}
-
-
-void FakeSemanticInfoBackEnd::retrieveSemanticInfo(const KUrl& url) {
-	if (!mSemanticInfoForUrl.contains(url)) {
-		QString urlString = url.url();
-		SemanticInfo semanticInfo;
-		if (mInitializeMode == InitializeRandom) {
-			semanticInfo.mRating = int(urlString.length()) % 6;
-			semanticInfo.mDescription = url.fileName();
-			QStringList lst = url.path().split('/');
-			Q_FOREACH(const QString& token, lst) {
-				if (!token.isEmpty()) {
-					semanticInfo.mTags << '#' + token.toLower();
-				}
-			}
-			semanticInfo.mTags << QString("#length-%1").arg(url.fileName().length());
-
-			mergeTagsWithAllTags(semanticInfo.mTags);
-		} else {
-			semanticInfo.mRating = 0;
-		}
-		mSemanticInfoForUrl[url] = semanticInfo;
-	}
-	emit semanticInfoRetrieved(url, mSemanticInfoForUrl.value(url));
-}
-
-
-QString FakeSemanticInfoBackEnd::labelForTag(const SemanticInfoTag& tag) const {
-	return tag[1].toUpper() + tag.mid(2);
-}
-
-
-SemanticInfoTag FakeSemanticInfoBackEnd::tagForLabel(const QString& label) {
-	return '#' + label.toLower();
-}
-
+, mInitializeMode(mode)
+{
+    mAllTags
+            << tagForLabel("beach")
+            << tagForLabel("mountains")
+            << tagForLabel("wallpaper")
+            ;
+}
+
+void FakeSemanticInfoBackEnd::storeSemanticInfo(const KUrl& url, const SemanticInfo& semanticInfo)
+{
+    mSemanticInfoForUrl[url] = semanticInfo;
+    mergeTagsWithAllTags(semanticInfo.mTags);
+}
+
+void FakeSemanticInfoBackEnd::mergeTagsWithAllTags(const TagSet& set)
+{
+    int size = mAllTags.size();
+    mAllTags |= set;
+    if (mAllTags.size() > size) {
+        //emit allTagsUpdated();
+    }
+}
+
+TagSet FakeSemanticInfoBackEnd::allTags() const
+{
+    return mAllTags;
+}
+
+void FakeSemanticInfoBackEnd::refreshAllTags()
+{
+}
+
+void FakeSemanticInfoBackEnd::retrieveSemanticInfo(const KUrl& url)
+{
+    if (!mSemanticInfoForUrl.contains(url)) {
+        QString urlString = url.url();
+        SemanticInfo semanticInfo;
+        if (mInitializeMode == InitializeRandom) {
+            semanticInfo.mRating = int(urlString.length()) % 6;
+            semanticInfo.mDescription = url.fileName();
+            QStringList lst = url.path().split('/');
+            Q_FOREACH(const QString & token, lst) {
+                if (!token.isEmpty()) {
+                    semanticInfo.mTags << '#' + token.toLower();
+                }
+            }
+            semanticInfo.mTags << QString("#length-%1").arg(url.fileName().length());
+
+            mergeTagsWithAllTags(semanticInfo.mTags);
+        } else {
+            semanticInfo.mRating = 0;
+        }
+        mSemanticInfoForUrl[url] = semanticInfo;
+    }
+    emit semanticInfoRetrieved(url, mSemanticInfoForUrl.value(url));
+}
+
+QString FakeSemanticInfoBackEnd::labelForTag(const SemanticInfoTag& tag) const
+{
+    return tag[1].toUpper() + tag.mid(2);
+}
+
+SemanticInfoTag FakeSemanticInfoBackEnd::tagForLabel(const QString& label)
+{
+    return '#' + label.toLower();
+}
 
 } // namespace

=== modified file 'lib/semanticinfo/fakesemanticinfobackend.h'
--- lib/semanticinfo/fakesemanticinfobackend.h	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/fakesemanticinfobackend.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,40 +32,40 @@
 // Local
 #include "abstractsemanticinfobackend.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 /**
  * A fake metadata backend, useful to test the ui layer.
  * It provides fake rating values based on the image url.
  */
-class GWENVIEWLIB_EXPORT FakeSemanticInfoBackEnd : public AbstractSemanticInfoBackEnd {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT FakeSemanticInfoBackEnd : public AbstractSemanticInfoBackEnd
+{
+    Q_OBJECT
 public:
-	enum InitializeMode { InitializeEmpty, InitializeRandom };
-	FakeSemanticInfoBackEnd(QObject* parent, InitializeMode initializeMode);
-
-	virtual TagSet allTags() const;
-
-	virtual void refreshAllTags();
-
-	virtual void storeSemanticInfo(const KUrl&, const SemanticInfo&);
-
-	virtual void retrieveSemanticInfo(const KUrl&);
-
-	virtual QString labelForTag(const SemanticInfoTag&) const;
-
-	virtual SemanticInfoTag tagForLabel(const QString&);
+    enum InitializeMode { InitializeEmpty, InitializeRandom };
+    FakeSemanticInfoBackEnd(QObject* parent, InitializeMode initializeMode);
+
+    virtual TagSet allTags() const;
+
+    virtual void refreshAllTags();
+
+    virtual void storeSemanticInfo(const KUrl&, const SemanticInfo&);
+
+    virtual void retrieveSemanticInfo(const KUrl&);
+
+    virtual QString labelForTag(const SemanticInfoTag&) const;
+
+    virtual SemanticInfoTag tagForLabel(const QString&);
 
 private:
-	void mergeTagsWithAllTags(const TagSet&);
+    void mergeTagsWithAllTags(const TagSet&);
 
-	QHash<KUrl, SemanticInfo> mSemanticInfoForUrl;
-	InitializeMode mInitializeMode;
-	TagSet mAllTags;
+    QHash<KUrl, SemanticInfo> mSemanticInfoForUrl;
+    InitializeMode mInitializeMode;
+    TagSet mAllTags;
 };
 
-
 } // namespace
 
 #endif /* FAKESEMANTICINFOBACKEND_H */

=== modified file 'lib/semanticinfo/nepomuksemanticinfobackend.cpp'
--- lib/semanticinfo/nepomuksemanticinfobackend.cpp	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/nepomuksemanticinfobackend.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -40,196 +40,194 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct Task {
-	Task(const KUrl& url): mUrl(url) {}
-	virtual ~Task() {}
-	virtual void execute() = 0;
+    Task(const KUrl& url): mUrl(url) {}
+    virtual ~Task() {}
+    virtual void execute() = 0;
 
-	KUrl mUrl;
+    KUrl mUrl;
 };
 
-
 struct RetrieveTask : public Task {
-	RetrieveTask(NepomukSemanticInfoBackEnd* backEnd, const KUrl& url)
-	: Task(url), mBackEnd(backEnd) {}
-
-	virtual void execute() {
-		Nepomuk::Resource resource(mUrl);
-
-		SemanticInfo semanticInfo;
-		semanticInfo.mRating = resource.rating();
-		semanticInfo.mDescription = resource.description();
-		Q_FOREACH(const Nepomuk::Tag& tag, resource.tags()) {
-			semanticInfo.mTags << KUrl(tag.resourceUri()).url();
-		}
-		mBackEnd->emitSemanticInfoRetrieved(mUrl, semanticInfo);
-	}
-
-	NepomukSemanticInfoBackEnd* mBackEnd;
+    RetrieveTask(NepomukSemanticInfoBackEnd* backEnd, const KUrl& url)
+        : Task(url), mBackEnd(backEnd) {}
+
+    virtual void execute()
+    {
+        Nepomuk::Resource resource(mUrl);
+
+        SemanticInfo semanticInfo;
+        semanticInfo.mRating = resource.rating();
+        semanticInfo.mDescription = resource.description();
+        Q_FOREACH(const Nepomuk::Tag & tag, resource.tags()) {
+            semanticInfo.mTags << KUrl(tag.resourceUri()).url();
+        }
+        mBackEnd->emitSemanticInfoRetrieved(mUrl, semanticInfo);
+    }
+
+    NepomukSemanticInfoBackEnd* mBackEnd;
 };
 
-
 struct StoreTask : public Task {
-	StoreTask(const KUrl& url, const SemanticInfo& semanticInfo)
-	: Task(url), mSemanticInfo(semanticInfo) {}
-
-	virtual void execute() {
-		Nepomuk::Resource resource(mUrl);
-		resource.setRating(mSemanticInfo.mRating);
-		resource.setDescription(mSemanticInfo.mDescription);
-		QList<Nepomuk::Tag> tags;
-		Q_FOREACH(const SemanticInfoTag& uri, mSemanticInfo.mTags) {
-			tags << Nepomuk::Tag(KUrl(uri));
-		}
-		resource.setTags(tags);
-	}
-
-	SemanticInfo mSemanticInfo;
+    StoreTask(const KUrl& url, const SemanticInfo& semanticInfo)
+        : Task(url), mSemanticInfo(semanticInfo) {}
+
+    virtual void execute()
+    {
+        Nepomuk::Resource resource(mUrl);
+        resource.setRating(mSemanticInfo.mRating);
+        resource.setDescription(mSemanticInfo.mDescription);
+        QList<Nepomuk::Tag> tags;
+        Q_FOREACH(const SemanticInfoTag & uri, mSemanticInfo.mTags) {
+            tags << Nepomuk::Tag(KUrl(uri));
+        }
+        resource.setTags(tags);
+    }
+
+    SemanticInfo mSemanticInfo;
 };
 
-
 typedef QQueue<Task*> TaskQueue;
 
-class SemanticInfoThread : public QThread {
+class SemanticInfoThread : public QThread
+{
 public:
-	SemanticInfoThread()
-	: mDeleting(false)
-	{}
-
-	~SemanticInfoThread() {
-		{
-			QMutexLocker locker(&mMutex);
-			mDeleting = true;
-		}
-		// Notify the thread so that it doesn't stay blocked waiting for mQueueNotEmpty
-		mQueueNotEmpty.wakeAll();
-
-		wait();
-		qDeleteAll(mTaskQueue);
-	}
-
-
-	void enqueueTask(Task* task) {
-		{
-			QMutexLocker locker(&mMutex);
-			mTaskQueue.enqueue(task);
-		}
-		if (!isRunning()) {
-			start();
-		}
-		mQueueNotEmpty.wakeAll();
-	}
-
-
-	virtual void run() {
-		while (true) {
-			Task* task;
-			{
-				QMutexLocker locker(&mMutex);
-				if (mDeleting) {
-					return;
-				}
-				if (mTaskQueue.isEmpty()) {
-					mQueueNotEmpty.wait(&mMutex);
-				}
-				if (mDeleting) {
-					return;
-				}
-				task = mTaskQueue.dequeue();
-			}
-			task->execute();
-			delete task;
-		}
-	}
-
+    SemanticInfoThread()
+        : mDeleting(false)
+    {}
+
+    ~SemanticInfoThread() {
+        {
+            QMutexLocker locker(&mMutex);
+            mDeleting = true;
+        }
+        // Notify the thread so that it doesn't stay blocked waiting for mQueueNotEmpty
+        mQueueNotEmpty.wakeAll();
+
+        wait();
+        qDeleteAll(mTaskQueue);
+    }
+
+    void enqueueTask(Task* task)
+    {
+        {
+            QMutexLocker locker(&mMutex);
+            mTaskQueue.enqueue(task);
+        }
+        if (!isRunning()) {
+            start();
+        }
+        mQueueNotEmpty.wakeAll();
+    }
+
+    virtual void run()
+    {
+        while (true) {
+            Task* task;
+            {
+                QMutexLocker locker(&mMutex);
+                if (mDeleting) {
+                    return;
+                }
+                if (mTaskQueue.isEmpty()) {
+                    mQueueNotEmpty.wait(&mMutex);
+                }
+                if (mDeleting) {
+                    return;
+                }
+                task = mTaskQueue.dequeue();
+            }
+            task->execute();
+            delete task;
+        }
+    }
 
 private:
-	TaskQueue mTaskQueue;
-	QMutex mMutex;
-	QWaitCondition mQueueNotEmpty;
-	bool mDeleting;
+    TaskQueue mTaskQueue;
+    QMutex mMutex;
+    QWaitCondition mQueueNotEmpty;
+    bool mDeleting;
 };
 
-
 struct NepomukSemanticInfoBackEndPrivate {
-	SemanticInfoThread mThread;
-	TagSet mAllTags;
+    SemanticInfoThread mThread;
+    TagSet mAllTags;
 };
 
-
 NepomukSemanticInfoBackEnd::NepomukSemanticInfoBackEnd(QObject* parent)
 : AbstractSemanticInfoBackEnd(parent)
-, d(new NepomukSemanticInfoBackEndPrivate) {
-	// FIXME: Check it returns 0
-	Nepomuk::ResourceManager::instance()->init();
-}
-
-
-NepomukSemanticInfoBackEnd::~NepomukSemanticInfoBackEnd() {
-	delete d;
-}
-
-
-TagSet NepomukSemanticInfoBackEnd::allTags() const {
-	if (d->mAllTags.empty()) {
-		const_cast<NepomukSemanticInfoBackEnd*>(this)->refreshAllTags();
-	}
-	return d->mAllTags;
-}
-
-
-void NepomukSemanticInfoBackEnd::refreshAllTags() {
-	d->mAllTags.clear();
-	Q_FOREACH(const Nepomuk::Tag& tag, Nepomuk::Tag::allTags()) {
-		d->mAllTags << KUrl(tag.resourceUri()).url();
-	}
-}
-
-
-void NepomukSemanticInfoBackEnd::storeSemanticInfo(const KUrl& url, const SemanticInfo& semanticInfo) {
-	StoreTask* task = new StoreTask(url, semanticInfo);
-	d->mThread.enqueueTask(task);
-}
-
-
-void NepomukSemanticInfoBackEnd::retrieveSemanticInfo(const KUrl& url) {
-	RetrieveTask* task = new RetrieveTask(this, url);
-	d->mThread.enqueueTask(task);
-}
-
-
-void NepomukSemanticInfoBackEnd::emitSemanticInfoRetrieved(const KUrl& url, const SemanticInfo& semanticInfo) {
-	emit semanticInfoRetrieved(url, semanticInfo);
-}
-
-
-QString NepomukSemanticInfoBackEnd::labelForTag(const SemanticInfoTag& uriString) const {
+, d(new NepomukSemanticInfoBackEndPrivate)
+{
+    // FIXME: Check it returns 0
+    Nepomuk::ResourceManager::instance()->init();
+}
+
+NepomukSemanticInfoBackEnd::~NepomukSemanticInfoBackEnd()
+{
+    delete d;
+}
+
+TagSet NepomukSemanticInfoBackEnd::allTags() const
+{
+    if (d->mAllTags.empty()) {
+        const_cast<NepomukSemanticInfoBackEnd*>(this)->refreshAllTags();
+    }
+    return d->mAllTags;
+}
+
+void NepomukSemanticInfoBackEnd::refreshAllTags()
+{
+    d->mAllTags.clear();
+    Q_FOREACH(const Nepomuk::Tag & tag, Nepomuk::Tag::allTags()) {
+        d->mAllTags << KUrl(tag.resourceUri()).url();
+    }
+}
+
+void NepomukSemanticInfoBackEnd::storeSemanticInfo(const KUrl& url, const SemanticInfo& semanticInfo)
+{
+    StoreTask* task = new StoreTask(url, semanticInfo);
+    d->mThread.enqueueTask(task);
+}
+
+void NepomukSemanticInfoBackEnd::retrieveSemanticInfo(const KUrl& url)
+{
+    RetrieveTask* task = new RetrieveTask(this, url);
+    d->mThread.enqueueTask(task);
+}
+
+void NepomukSemanticInfoBackEnd::emitSemanticInfoRetrieved(const KUrl& url, const SemanticInfo& semanticInfo)
+{
+    emit semanticInfoRetrieved(url, semanticInfo);
+}
+
+QString NepomukSemanticInfoBackEnd::labelForTag(const SemanticInfoTag& uriString) const
+{
     KUrl uri(uriString);
-	Nepomuk::Tag tag(uri);
-	if (!tag.exists()) {
-		kError() << "No tag for uri" << uri << ". This should not happen!";
-		return QString();
-	}
-	return tag.label();
-}
-
-
-SemanticInfoTag NepomukSemanticInfoBackEnd::tagForLabel(const QString& label) {
-	Nepomuk::Tag tag(label);
-	SemanticInfoTag uri;
-	if (tag.exists()) {
-		uri = KUrl(tag.resourceUri()).url();
-	} else {
-		// Not found, create the tag
-		tag.setLabel(label);
-		uri = KUrl(tag.resourceUri()).url();
-		d->mAllTags << uri;
-		emit tagAdded(uri, label);
-	}
-	return uri;
-}
-
+    Nepomuk::Tag tag(uri);
+    if (!tag.exists()) {
+        kError() << "No tag for uri" << uri << ". This should not happen!";
+        return QString();
+    }
+    return tag.label();
+}
+
+SemanticInfoTag NepomukSemanticInfoBackEnd::tagForLabel(const QString& label)
+{
+    Nepomuk::Tag tag(label);
+    SemanticInfoTag uri;
+    if (tag.exists()) {
+        uri = KUrl(tag.resourceUri()).url();
+    } else {
+        // Not found, create the tag
+        tag.setLabel(label);
+        uri = KUrl(tag.resourceUri()).url();
+        d->mAllTags << uri;
+        emit tagAdded(uri, label);
+    }
+    return uri;
+}
 
 } // namespace

=== modified file 'lib/semanticinfo/nepomuksemanticinfobackend.h'
--- lib/semanticinfo/nepomuksemanticinfobackend.h	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/nepomuksemanticinfobackend.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,40 +30,39 @@
 // Local
 #include "abstractsemanticinfobackend.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct NepomukSemanticInfoBackEndPrivate;
 
-
 /**
  * A real metadata backend using Nepomuk to store and retrieve metadata.
  */
-class GWENVIEWLIB_EXPORT NepomukSemanticInfoBackEnd : public AbstractSemanticInfoBackEnd {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT NepomukSemanticInfoBackEnd : public AbstractSemanticInfoBackEnd
+{
+    Q_OBJECT
 public:
-	NepomukSemanticInfoBackEnd(QObject* parent);
-	~NepomukSemanticInfoBackEnd();
-
-	virtual TagSet allTags() const;
-
-	virtual void refreshAllTags();
-
-	virtual void storeSemanticInfo(const KUrl&, const SemanticInfo&);
-
-	virtual void retrieveSemanticInfo(const KUrl&);
-
-	virtual QString labelForTag(const SemanticInfoTag&) const;
-
-	virtual SemanticInfoTag tagForLabel(const QString&);
-
-	void emitSemanticInfoRetrieved(const KUrl&, const SemanticInfo&);
+    NepomukSemanticInfoBackEnd(QObject* parent);
+    ~NepomukSemanticInfoBackEnd();
+
+    virtual TagSet allTags() const;
+
+    virtual void refreshAllTags();
+
+    virtual void storeSemanticInfo(const KUrl&, const SemanticInfo&);
+
+    virtual void retrieveSemanticInfo(const KUrl&);
+
+    virtual QString labelForTag(const SemanticInfoTag&) const;
+
+    virtual SemanticInfoTag tagForLabel(const QString&);
+
+    void emitSemanticInfoRetrieved(const KUrl&, const SemanticInfo&);
 
 private:
-	NepomukSemanticInfoBackEndPrivate* const d;
+    NepomukSemanticInfoBackEndPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* NEPOMUKSEMANTICINFOBACKEND_H */

=== modified file 'lib/semanticinfo/semanticinfodirmodel.cpp'
--- lib/semanticinfo/semanticinfodirmodel.cpp	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/semanticinfodirmodel.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -40,217 +40,216 @@
 
 #else
 #ifdef __GNUC__
-	#error No metadata backend defined
+#error No metadata backend defined
 #endif
 #endif
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct SemanticInfoCacheItem {
-	SemanticInfoCacheItem()
-	: mValid(false) {}
-	QPersistentModelIndex mIndex;
-	bool mValid;
-	SemanticInfo mInfo;
+    SemanticInfoCacheItem()
+        : mValid(false) {}
+    QPersistentModelIndex mIndex;
+    bool mValid;
+    SemanticInfo mInfo;
 };
 
-
 typedef QHash<KUrl, SemanticInfoCacheItem> SemanticInfoCache;
 
 struct SemanticInfoDirModelPrivate {
-	SemanticInfoCache mSemanticInfoCache;
-	AbstractSemanticInfoBackEnd* mBackEnd;
+    SemanticInfoCache mSemanticInfoCache;
+    AbstractSemanticInfoBackEnd* mBackEnd;
 };
 
-
 SemanticInfoDirModel::SemanticInfoDirModel(QObject* parent)
 : KDirModel(parent)
-, d(new SemanticInfoDirModelPrivate) {
+, d(new SemanticInfoDirModelPrivate)
+{
 #ifdef GWENVIEW_SEMANTICINFO_BACKEND_FAKE
-	d->mBackEnd = new FakeSemanticInfoBackEnd(this, FakeSemanticInfoBackEnd::InitializeRandom);
+    d->mBackEnd = new FakeSemanticInfoBackEnd(this, FakeSemanticInfoBackEnd::InitializeRandom);
 #elif defined(GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK)
-	d->mBackEnd = new NepomukSemanticInfoBackEnd(this);
+    d->mBackEnd = new NepomukSemanticInfoBackEnd(this);
 #endif
 
-	connect(d->mBackEnd, SIGNAL(semanticInfoRetrieved(const KUrl&, const SemanticInfo&)),
-		SLOT(slotSemanticInfoRetrieved(const KUrl&, const SemanticInfo&)),
-		Qt::QueuedConnection);
-
-	connect(this, SIGNAL(modelAboutToBeReset()),
-		SLOT(slotModelAboutToBeReset()) );
-
-	connect(this, SIGNAL(rowsAboutToBeRemoved(const QModelIndex&, int, int)),
-		SLOT(slotRowsAboutToBeRemoved(const QModelIndex&, int, int)) );
-}
-
-
-SemanticInfoDirModel::~SemanticInfoDirModel() {
-	delete d;
-}
-
-
-void SemanticInfoDirModel::clearSemanticInfoCache() {
-	d->mSemanticInfoCache.clear();
-}
-
-
-bool SemanticInfoDirModel::semanticInfoAvailableForIndex(const QModelIndex& index) const {
-	if (!index.isValid()) {
-		return false;
-	}
-	KFileItem item = itemForIndex(index);
-	if (item.isNull()) {
-		return false;
-	}
-	SemanticInfoCache::const_iterator it = d->mSemanticInfoCache.constFind(item.targetUrl());
-	if (it == d->mSemanticInfoCache.constEnd()) {
-		return false;
-	}
-	return it.value().mValid;
-}
-
-
-SemanticInfo SemanticInfoDirModel::semanticInfoForIndex(const QModelIndex& index) const {
-	if (!index.isValid()) {
-		kWarning() << "invalid index";
-		return SemanticInfo();
-	}
-	KFileItem item = itemForIndex(index);
-	if (item.isNull()) {
-		kWarning() << "no item for index";
-		return SemanticInfo();
-	}
-	return d->mSemanticInfoCache.value(item.targetUrl()).mInfo;
-}
-
-
-void SemanticInfoDirModel::retrieveSemanticInfoForIndex(const QModelIndex& index) {
-	if (!index.isValid()) {
-		return;
-	}
-	KFileItem item = itemForIndex(index);
-	if (item.isNull()) {
-		kWarning() << "invalid item";
-		return;
-	}
-	if (ArchiveUtils::fileItemIsDirOrArchive(item)) {
-		return;
-	}
-	SemanticInfoCacheItem cacheItem;
-	cacheItem.mIndex = QPersistentModelIndex(index);
-	d->mSemanticInfoCache[item.targetUrl()] = cacheItem;
-	d->mBackEnd->retrieveSemanticInfo(item.targetUrl());
-}
-
-
-QVariant SemanticInfoDirModel::data(const QModelIndex& index, int role) const {
-	if (role == RatingRole || role == DescriptionRole || role == TagsRole) {
-		KFileItem item = itemForIndex(index);
-		if (item.isNull()) {
-			return QVariant();
-		}
-		SemanticInfoCache::ConstIterator it = d->mSemanticInfoCache.constFind(item.targetUrl());
-		if (it != d->mSemanticInfoCache.constEnd()) {
-			if (!it.value().mValid) {
-				return QVariant();
-			}
-			const SemanticInfo& info = it.value().mInfo;
-			if (role == RatingRole) {
-				return info.mRating;
-			} else if (role == DescriptionRole) {
-				return info.mDescription;
-			} else if (role == TagsRole) {
-				return info.mTags.toVariant();
-			} else {
-				// We should never reach this part
-				Q_ASSERT(0);
-				return QVariant();
-			}
-		} else {
-			const_cast<SemanticInfoDirModel*>(this)->retrieveSemanticInfoForIndex(index);
-			return QVariant();
-		}
-	} else {
-		return KDirModel::data(index, role);
-	}
-}
-
-
-bool SemanticInfoDirModel::setData(const QModelIndex& index, const QVariant& data, int role) {
-	if (role == RatingRole || role == DescriptionRole || role == TagsRole) {
-		KFileItem item = itemForIndex(index);
-		if (item.isNull()) {
-			kWarning() << "no item found for this index";
-			return false;
-		}
-		KUrl url = item.targetUrl();
-		SemanticInfoCache::iterator it = d->mSemanticInfoCache.find(url);
-		if (it == d->mSemanticInfoCache.end()) {
-			kWarning() << "No index for" << url;
-			return false;
-		}
-		if (!it.value().mValid) {
-			kWarning() << "Semantic info cache for" << url << "is invalid";
-			return false;
-		}
-		SemanticInfo& semanticInfo = it.value().mInfo;
-		if (role == RatingRole) {
-			semanticInfo.mRating = data.toInt();
-		} else if (role == DescriptionRole) {
-			semanticInfo.mDescription = data.toString();
-		} else if (role == TagsRole) {
-			semanticInfo.mTags = TagSet::fromVariant(data);
-		} else {
-			// We should never reach this part
-			Q_ASSERT(0);
-		}
-		emit dataChanged(index, index);
-
-		d->mBackEnd->storeSemanticInfo(url, semanticInfo);
-		return true;
-	} else {
-		return KDirModel::setData(index, data, role);
-	}
-}
-
-
-void SemanticInfoDirModel::slotSemanticInfoRetrieved(const KUrl& url, const SemanticInfo& semanticInfo) {
-	SemanticInfoCache::iterator it = d->mSemanticInfoCache.find(url);
-	if (it == d->mSemanticInfoCache.end()) {
-		kWarning() << "No index for" << url;
-		return;
-	}
-	SemanticInfoCacheItem& cacheItem = it.value();
-	if (!cacheItem.mIndex.isValid()) {
-		kWarning() << "Index for" << url << "is invalid";
-		return;
-	}
-	cacheItem.mInfo = semanticInfo;
-	cacheItem.mValid = true;
-	emit dataChanged(cacheItem.mIndex, cacheItem.mIndex);
-}
-
-
-void SemanticInfoDirModel::slotRowsAboutToBeRemoved(const QModelIndex& parent, int start, int end) {
-	for (int pos = start; pos <= end; ++pos) {
-		QModelIndex idx = index(pos, 0, parent);
-		KFileItem item = itemForIndex(idx);
-		if (item.isNull()) {
-			continue;
-		}
-		d->mSemanticInfoCache.remove(item.targetUrl());
-	}
-}
-
-
-void SemanticInfoDirModel::slotModelAboutToBeReset() {
-	d->mSemanticInfoCache.clear();
-}
-
-
-AbstractSemanticInfoBackEnd* SemanticInfoDirModel::semanticInfoBackEnd() const {
-	return d->mBackEnd;
-}
-
+    connect(d->mBackEnd, SIGNAL(semanticInfoRetrieved(KUrl, SemanticInfo)),
+            SLOT(slotSemanticInfoRetrieved(KUrl, SemanticInfo)),
+            Qt::QueuedConnection);
+
+    connect(this, SIGNAL(modelAboutToBeReset()),
+            SLOT(slotModelAboutToBeReset()));
+
+    connect(this, SIGNAL(rowsAboutToBeRemoved(QModelIndex, int, int)),
+            SLOT(slotRowsAboutToBeRemoved(QModelIndex, int, int)));
+}
+
+SemanticInfoDirModel::~SemanticInfoDirModel()
+{
+    delete d;
+}
+
+void SemanticInfoDirModel::clearSemanticInfoCache()
+{
+    d->mSemanticInfoCache.clear();
+}
+
+bool SemanticInfoDirModel::semanticInfoAvailableForIndex(const QModelIndex& index) const
+{
+    if (!index.isValid()) {
+        return false;
+    }
+    KFileItem item = itemForIndex(index);
+    if (item.isNull()) {
+        return false;
+    }
+    SemanticInfoCache::const_iterator it = d->mSemanticInfoCache.constFind(item.targetUrl());
+    if (it == d->mSemanticInfoCache.constEnd()) {
+        return false;
+    }
+    return it.value().mValid;
+}
+
+SemanticInfo SemanticInfoDirModel::semanticInfoForIndex(const QModelIndex& index) const
+{
+    if (!index.isValid()) {
+        kWarning() << "invalid index";
+        return SemanticInfo();
+    }
+    KFileItem item = itemForIndex(index);
+    if (item.isNull()) {
+        kWarning() << "no item for index";
+        return SemanticInfo();
+    }
+    return d->mSemanticInfoCache.value(item.targetUrl()).mInfo;
+}
+
+void SemanticInfoDirModel::retrieveSemanticInfoForIndex(const QModelIndex& index)
+{
+    if (!index.isValid()) {
+        return;
+    }
+    KFileItem item = itemForIndex(index);
+    if (item.isNull()) {
+        kWarning() << "invalid item";
+        return;
+    }
+    if (ArchiveUtils::fileItemIsDirOrArchive(item)) {
+        return;
+    }
+    SemanticInfoCacheItem cacheItem;
+    cacheItem.mIndex = QPersistentModelIndex(index);
+    d->mSemanticInfoCache[item.targetUrl()] = cacheItem;
+    d->mBackEnd->retrieveSemanticInfo(item.targetUrl());
+}
+
+QVariant SemanticInfoDirModel::data(const QModelIndex& index, int role) const
+{
+    if (role == RatingRole || role == DescriptionRole || role == TagsRole) {
+        KFileItem item = itemForIndex(index);
+        if (item.isNull()) {
+            return QVariant();
+        }
+        SemanticInfoCache::ConstIterator it = d->mSemanticInfoCache.constFind(item.targetUrl());
+        if (it != d->mSemanticInfoCache.constEnd()) {
+            if (!it.value().mValid) {
+                return QVariant();
+            }
+            const SemanticInfo& info = it.value().mInfo;
+            if (role == RatingRole) {
+                return info.mRating;
+            } else if (role == DescriptionRole) {
+                return info.mDescription;
+            } else if (role == TagsRole) {
+                return info.mTags.toVariant();
+            } else {
+                // We should never reach this part
+                Q_ASSERT(0);
+                return QVariant();
+            }
+        } else {
+            const_cast<SemanticInfoDirModel*>(this)->retrieveSemanticInfoForIndex(index);
+            return QVariant();
+        }
+    } else {
+        return KDirModel::data(index, role);
+    }
+}
+
+bool SemanticInfoDirModel::setData(const QModelIndex& index, const QVariant& data, int role)
+{
+    if (role == RatingRole || role == DescriptionRole || role == TagsRole) {
+        KFileItem item = itemForIndex(index);
+        if (item.isNull()) {
+            kWarning() << "no item found for this index";
+            return false;
+        }
+        KUrl url = item.targetUrl();
+        SemanticInfoCache::iterator it = d->mSemanticInfoCache.find(url);
+        if (it == d->mSemanticInfoCache.end()) {
+            kWarning() << "No index for" << url;
+            return false;
+        }
+        if (!it.value().mValid) {
+            kWarning() << "Semantic info cache for" << url << "is invalid";
+            return false;
+        }
+        SemanticInfo& semanticInfo = it.value().mInfo;
+        if (role == RatingRole) {
+            semanticInfo.mRating = data.toInt();
+        } else if (role == DescriptionRole) {
+            semanticInfo.mDescription = data.toString();
+        } else if (role == TagsRole) {
+            semanticInfo.mTags = TagSet::fromVariant(data);
+        } else {
+            // We should never reach this part
+            Q_ASSERT(0);
+        }
+        emit dataChanged(index, index);
+
+        d->mBackEnd->storeSemanticInfo(url, semanticInfo);
+        return true;
+    } else {
+        return KDirModel::setData(index, data, role);
+    }
+}
+
+void SemanticInfoDirModel::slotSemanticInfoRetrieved(const KUrl& url, const SemanticInfo& semanticInfo)
+{
+    SemanticInfoCache::iterator it = d->mSemanticInfoCache.find(url);
+    if (it == d->mSemanticInfoCache.end()) {
+        kWarning() << "No index for" << url;
+        return;
+    }
+    SemanticInfoCacheItem& cacheItem = it.value();
+    if (!cacheItem.mIndex.isValid()) {
+        kWarning() << "Index for" << url << "is invalid";
+        return;
+    }
+    cacheItem.mInfo = semanticInfo;
+    cacheItem.mValid = true;
+    emit dataChanged(cacheItem.mIndex, cacheItem.mIndex);
+}
+
+void SemanticInfoDirModel::slotRowsAboutToBeRemoved(const QModelIndex& parent, int start, int end)
+{
+    for (int pos = start; pos <= end; ++pos) {
+        QModelIndex idx = index(pos, 0, parent);
+        KFileItem item = itemForIndex(idx);
+        if (item.isNull()) {
+            continue;
+        }
+        d->mSemanticInfoCache.remove(item.targetUrl());
+    }
+}
+
+void SemanticInfoDirModel::slotModelAboutToBeReset()
+{
+    d->mSemanticInfoCache.clear();
+}
+
+AbstractSemanticInfoBackEnd* SemanticInfoDirModel::semanticInfoBackEnd() const
+{
+    return d->mBackEnd;
+}
 
 } // namespace

=== modified file 'lib/semanticinfo/semanticinfodirmodel.h'
--- lib/semanticinfo/semanticinfodirmodel.h	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/semanticinfodirmodel.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,8 +30,8 @@
 
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class AbstractSemanticInfoBackEnd;
 struct SemanticInfo;
@@ -40,45 +40,45 @@
  * Extends KDirModel by providing read/write access to image metadata such as
  * rating, tags and descriptions.
  */
-class SemanticInfoDirModel : public KDirModel {
-	Q_OBJECT
+class SemanticInfoDirModel : public KDirModel
+{
+    Q_OBJECT
 public:
-	enum {
-		RatingRole = 0x21a43a51,
-		DescriptionRole = 0x26FB33FA,
-		TagsRole = 0x0462F0A8
-	};
-	SemanticInfoDirModel(QObject* parent);
-	~SemanticInfoDirModel();
-
-	void clearSemanticInfoCache();
-
-	bool semanticInfoAvailableForIndex(const QModelIndex&) const;
-
-	void retrieveSemanticInfoForIndex(const QModelIndex&);
-
-	SemanticInfo semanticInfoForIndex(const QModelIndex&) const;
-
-	virtual QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
-
-	bool setData(const QModelIndex& index, const QVariant& data, int role = Qt::EditRole);
-
-	AbstractSemanticInfoBackEnd* semanticInfoBackEnd() const;
+    enum {
+        RatingRole = 0x21a43a51,
+        DescriptionRole = 0x26FB33FA,
+        TagsRole = 0x0462F0A8
+    };
+    SemanticInfoDirModel(QObject* parent);
+    ~SemanticInfoDirModel();
+
+    void clearSemanticInfoCache();
+
+    bool semanticInfoAvailableForIndex(const QModelIndex&) const;
+
+    void retrieveSemanticInfoForIndex(const QModelIndex&);
+
+    SemanticInfo semanticInfoForIndex(const QModelIndex&) const;
+
+    virtual QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
+
+    bool setData(const QModelIndex& index, const QVariant& data, int role = Qt::EditRole);
+
+    AbstractSemanticInfoBackEnd* semanticInfoBackEnd() const;
 
 Q_SIGNALS:
-	void semanticInfoRetrieved(const KUrl&, const SemanticInfo&);
+    void semanticInfoRetrieved(const KUrl&, const SemanticInfo&);
 
 private:
-	SemanticInfoDirModelPrivate* const d;
+    SemanticInfoDirModelPrivate* const d;
 
 private Q_SLOTS:
-	void slotSemanticInfoRetrieved(const KUrl& url, const SemanticInfo&);
+    void slotSemanticInfoRetrieved(const KUrl& url, const SemanticInfo&);
 
-	void slotRowsAboutToBeRemoved(const QModelIndex&, int, int);
-	void slotModelAboutToBeReset();
+    void slotRowsAboutToBeRemoved(const QModelIndex&, int, int);
+    void slotModelAboutToBeReset();
 };
 
-
 } // namespace
 
 #endif /* SEMANTICINFODIRMODEL_H */

=== modified file 'lib/semanticinfo/sorteddirmodel.cpp'
--- lib/semanticinfo/sorteddirmodel.cpp	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/sorteddirmodel.cpp	2011-12-15 14:17:54 +0000
@@ -37,261 +37,258 @@
 #include "semanticinfodirmodel.h"
 #endif
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 AbstractSortedDirModelFilter::AbstractSortedDirModelFilter(SortedDirModel* model)
 : QObject(model)
 , mModel(model)
 {
-	if (mModel) {
-		mModel->addFilter(this);
-	}
+    if (mModel) {
+        mModel->addFilter(this);
+    }
 }
 
 AbstractSortedDirModelFilter::~AbstractSortedDirModelFilter()
 {
-	if (mModel) {
-		mModel->removeFilter(this);
-	}
+    if (mModel) {
+        mModel->removeFilter(this);
+    }
 }
 
-
 struct SortedDirModelPrivate {
 #ifdef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	KDirModel* mSourceModel;
+    KDirModel* mSourceModel;
 #else
-	SemanticInfoDirModel* mSourceModel;
+    SemanticInfoDirModel* mSourceModel;
 #endif
-	QStringList mBlackListedExtensions;
-	QList<AbstractSortedDirModelFilter*> mFilters;
-	QTimer mDelayedApplyFiltersTimer;
-	MimeTypeUtils::Kinds mKindFilter;
+    QStringList mBlackListedExtensions;
+    QList<AbstractSortedDirModelFilter*> mFilters;
+    QTimer mDelayedApplyFiltersTimer;
+    MimeTypeUtils::Kinds mKindFilter;
 };
 
-
 SortedDirModel::SortedDirModel(QObject* parent)
 : KDirSortFilterProxyModel(parent)
 , d(new SortedDirModelPrivate)
 {
 #ifdef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	d->mSourceModel = new KDirModel(this);
+    d->mSourceModel = new KDirModel(this);
 #else
-	d->mSourceModel = new SemanticInfoDirModel(this);
-#endif
-	setSourceModel(d->mSourceModel);
-	d->mDelayedApplyFiltersTimer.setInterval(0);
-	d->mDelayedApplyFiltersTimer.setSingleShot(true);
-	connect(&d->mDelayedApplyFiltersTimer, SIGNAL(timeout()), SLOT(doApplyFilters()));
-}
-
-
-SortedDirModel::~SortedDirModel() {
-	delete d;
-}
-
-
-MimeTypeUtils::Kinds SortedDirModel::kindFilter() const {
-	return d->mKindFilter;
-}
-
-
-void SortedDirModel::setKindFilter(MimeTypeUtils::Kinds kindFilter) {
-	if (d->mKindFilter == kindFilter) {
-		return;
-	}
-	d->mKindFilter = kindFilter;
-	applyFilters();
-}
-
-
-void SortedDirModel::adjustKindFilter(MimeTypeUtils::Kinds kinds, bool set) {
-	MimeTypeUtils::Kinds kindFilter = d->mKindFilter;
-	if (set) {
-		kindFilter |= kinds;
-	} else {
-		kindFilter &= ~kinds;
-	}
-	setKindFilter(kindFilter);
-}
-
-
-void SortedDirModel::addFilter(AbstractSortedDirModelFilter* filter) {
-	d->mFilters << filter;
-	applyFilters();
-}
-
-
-void SortedDirModel::removeFilter(AbstractSortedDirModelFilter* filter) {
-	d->mFilters.removeAll(filter);
-	applyFilters();
-}
-
-
-KDirLister* SortedDirModel::dirLister() const {
-	return d->mSourceModel->dirLister();
-}
-
-
-void SortedDirModel::reload() {
-	#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	d->mSourceModel->clearSemanticInfoCache();
-	#endif
-	dirLister()->updateDirectory(dirLister()->url());
-}
-
-
-void SortedDirModel::setBlackListedExtensions(const QStringList& list) {
-	d->mBlackListedExtensions = list;
-}
-
-
-KFileItem SortedDirModel::itemForIndex(const QModelIndex& index) const {
-	if (!index.isValid()) {
-		return KFileItem();
-	}
-
-	QModelIndex sourceIndex = mapToSource(index);
-	return d->mSourceModel->itemForIndex(sourceIndex);
-}
-
-
-KUrl SortedDirModel::urlForIndex(const QModelIndex& index) const {
+    d->mSourceModel = new SemanticInfoDirModel(this);
+#endif
+    setSourceModel(d->mSourceModel);
+    d->mDelayedApplyFiltersTimer.setInterval(0);
+    d->mDelayedApplyFiltersTimer.setSingleShot(true);
+    connect(&d->mDelayedApplyFiltersTimer, SIGNAL(timeout()), SLOT(doApplyFilters()));
+}
+
+SortedDirModel::~SortedDirModel()
+{
+    delete d;
+}
+
+MimeTypeUtils::Kinds SortedDirModel::kindFilter() const
+{
+    return d->mKindFilter;
+}
+
+void SortedDirModel::setKindFilter(MimeTypeUtils::Kinds kindFilter)
+{
+    if (d->mKindFilter == kindFilter) {
+        return;
+    }
+    d->mKindFilter = kindFilter;
+    applyFilters();
+}
+
+void SortedDirModel::adjustKindFilter(MimeTypeUtils::Kinds kinds, bool set)
+{
+    MimeTypeUtils::Kinds kindFilter = d->mKindFilter;
+    if (set) {
+        kindFilter |= kinds;
+    } else {
+        kindFilter &= ~kinds;
+    }
+    setKindFilter(kindFilter);
+}
+
+void SortedDirModel::addFilter(AbstractSortedDirModelFilter* filter)
+{
+    d->mFilters << filter;
+    applyFilters();
+}
+
+void SortedDirModel::removeFilter(AbstractSortedDirModelFilter* filter)
+{
+    d->mFilters.removeAll(filter);
+    applyFilters();
+}
+
+KDirLister* SortedDirModel::dirLister() const
+{
+    return d->mSourceModel->dirLister();
+}
+
+void SortedDirModel::reload()
+{
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+    d->mSourceModel->clearSemanticInfoCache();
+#endif
+    dirLister()->updateDirectory(dirLister()->url());
+}
+
+void SortedDirModel::setBlackListedExtensions(const QStringList& list)
+{
+    d->mBlackListedExtensions = list;
+}
+
+KFileItem SortedDirModel::itemForIndex(const QModelIndex& index) const
+{
+    if (!index.isValid()) {
+        return KFileItem();
+    }
+
+    QModelIndex sourceIndex = mapToSource(index);
+    return d->mSourceModel->itemForIndex(sourceIndex);
+}
+
+KUrl SortedDirModel::urlForIndex(const QModelIndex& index) const
+{
     KFileItem item = itemForIndex(index);
     return item.isNull() ? KUrl() : item.url();
 }
 
-
-KFileItem SortedDirModel::itemForSourceIndex(const QModelIndex& sourceIndex) const {
-	if (!sourceIndex.isValid()) {
-		return KFileItem();
-	}
-	return d->mSourceModel->itemForIndex(sourceIndex);
-}
-
-
-QModelIndex SortedDirModel::indexForItem(const KFileItem& item) const {
-	if (item.isNull()) {
-		return QModelIndex();
-	}
-
-	QModelIndex sourceIndex = d->mSourceModel->indexForItem(item);
-	return mapFromSource(sourceIndex);
-}
-
-
-QModelIndex SortedDirModel::indexForUrl(const KUrl& url) const {
-	if (!url.isValid()) {
-		return QModelIndex();
-	}
-	QModelIndex sourceIndex = d->mSourceModel->indexForUrl(url);
-	return mapFromSource(sourceIndex);
-}
-
-
-bool SortedDirModel::filterAcceptsRow(int row, const QModelIndex& parent) const {
-	QModelIndex index = d->mSourceModel->index(row, 0, parent);
-	KFileItem fileItem = d->mSourceModel->itemForIndex(index);
-
-	MimeTypeUtils::Kinds kind = MimeTypeUtils::fileItemKind(fileItem);
-	if (d->mKindFilter != MimeTypeUtils::Kinds() && !(d->mKindFilter & kind)) {
-		return false;
-	}
-
-	if (kind != MimeTypeUtils::KIND_DIR && kind != MimeTypeUtils::KIND_ARCHIVE) {
-		int dotPos = fileItem.name().lastIndexOf('.');
-		if (dotPos >= 1) {
-			QString extension = fileItem.name().mid(dotPos + 1).toLower();
-			if (d->mBlackListedExtensions.contains(extension)) {
-				return false;
-			}
-		}
+KFileItem SortedDirModel::itemForSourceIndex(const QModelIndex& sourceIndex) const
+{
+    if (!sourceIndex.isValid()) {
+        return KFileItem();
+    }
+    return d->mSourceModel->itemForIndex(sourceIndex);
+}
+
+QModelIndex SortedDirModel::indexForItem(const KFileItem& item) const
+{
+    if (item.isNull()) {
+        return QModelIndex();
+    }
+
+    QModelIndex sourceIndex = d->mSourceModel->indexForItem(item);
+    return mapFromSource(sourceIndex);
+}
+
+QModelIndex SortedDirModel::indexForUrl(const KUrl& url) const
+{
+    if (!url.isValid()) {
+        return QModelIndex();
+    }
+    QModelIndex sourceIndex = d->mSourceModel->indexForUrl(url);
+    return mapFromSource(sourceIndex);
+}
+
+bool SortedDirModel::filterAcceptsRow(int row, const QModelIndex& parent) const
+{
+    QModelIndex index = d->mSourceModel->index(row, 0, parent);
+    KFileItem fileItem = d->mSourceModel->itemForIndex(index);
+
+    MimeTypeUtils::Kinds kind = MimeTypeUtils::fileItemKind(fileItem);
+    if (d->mKindFilter != MimeTypeUtils::Kinds() && !(d->mKindFilter & kind)) {
+        return false;
+    }
+
+    if (kind != MimeTypeUtils::KIND_DIR && kind != MimeTypeUtils::KIND_ARCHIVE) {
+        int dotPos = fileItem.name().lastIndexOf('.');
+        if (dotPos >= 1) {
+            QString extension = fileItem.name().mid(dotPos + 1).toLower();
+            if (d->mBlackListedExtensions.contains(extension)) {
+                return false;
+            }
+        }
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		if (!d->mSourceModel->semanticInfoAvailableForIndex(index)) {
-			Q_FOREACH(const AbstractSortedDirModelFilter* filter, d->mFilters) {
-				// Make sure we have semanticinfo, otherwise retrieve it and
-				// return false, we will be called again later when it is
-				// there.
-				if (filter->needsSemanticInfo()) {
-					d->mSourceModel->retrieveSemanticInfoForIndex(index);
-					return false;
-				}
-			}
-		}
+        if (!d->mSourceModel->semanticInfoAvailableForIndex(index)) {
+            Q_FOREACH(const AbstractSortedDirModelFilter * filter, d->mFilters) {
+                // Make sure we have semanticinfo, otherwise retrieve it and
+                // return false, we will be called again later when it is
+                // there.
+                if (filter->needsSemanticInfo()) {
+                    d->mSourceModel->retrieveSemanticInfoForIndex(index);
+                    return false;
+                }
+            }
+        }
 #endif
 
-		Q_FOREACH(const AbstractSortedDirModelFilter* filter, d->mFilters) {
-			if (!filter->acceptsIndex(index)) {
-				return false;
-			}
-		}
-	}
-	return KDirSortFilterProxyModel::filterAcceptsRow(row, parent);
+        Q_FOREACH(const AbstractSortedDirModelFilter * filter, d->mFilters) {
+            if (!filter->acceptsIndex(index)) {
+                return false;
+            }
+        }
+    }
+    return KDirSortFilterProxyModel::filterAcceptsRow(row, parent);
 }
 
-
-AbstractSemanticInfoBackEnd* SortedDirModel::semanticInfoBackEnd() const {
+AbstractSemanticInfoBackEnd* SortedDirModel::semanticInfoBackEnd() const
+{
 #ifdef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	return 0;
+    return 0;
 #else
-	return d->mSourceModel->semanticInfoBackEnd();
+    return d->mSourceModel->semanticInfoBackEnd();
 #endif
 }
 
-
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-SemanticInfo SortedDirModel::semanticInfoForSourceIndex(const QModelIndex& sourceIndex) const {
-	return d->mSourceModel->semanticInfoForIndex(sourceIndex);
+SemanticInfo SortedDirModel::semanticInfoForSourceIndex(const QModelIndex& sourceIndex) const
+{
+    return d->mSourceModel->semanticInfoForIndex(sourceIndex);
 }
 #endif
 
-
-void SortedDirModel::applyFilters() {
-	d->mDelayedApplyFiltersTimer.start();
-}
-
-
-void SortedDirModel::doApplyFilters() {
-	QSortFilterProxyModel::invalidateFilter();
-}
-
-
-bool SortedDirModel::lessThan(const QModelIndex& left, const QModelIndex& right) const {
-	const KFileItem leftItem = itemForSourceIndex(left);
-	const KFileItem rightItem = itemForSourceIndex(right);
-
-	const bool leftIsDirOrArchive = ArchiveUtils::fileItemIsDirOrArchive(leftItem);
-	const bool rightIsDirOrArchive = ArchiveUtils::fileItemIsDirOrArchive(rightItem);
-
-	if (leftIsDirOrArchive != rightIsDirOrArchive) {
-		return leftIsDirOrArchive;
-	}
-
-	if (sortRole() != KDirModel::ModifiedTime) {
-		return KDirSortFilterProxyModel::lessThan(left, right);
-	}
-
-	const KDateTime leftDate = TimeUtils::dateTimeForFileItem(leftItem);
-	const KDateTime rightDate = TimeUtils::dateTimeForFileItem(rightItem);
-
-	return leftDate < rightDate;
-}
-
+void SortedDirModel::applyFilters()
+{
+    d->mDelayedApplyFiltersTimer.start();
+}
+
+void SortedDirModel::doApplyFilters()
+{
+    QSortFilterProxyModel::invalidateFilter();
+}
+
+bool SortedDirModel::lessThan(const QModelIndex& left, const QModelIndex& right) const
+{
+    const KFileItem leftItem = itemForSourceIndex(left);
+    const KFileItem rightItem = itemForSourceIndex(right);
+
+    const bool leftIsDirOrArchive = ArchiveUtils::fileItemIsDirOrArchive(leftItem);
+    const bool rightIsDirOrArchive = ArchiveUtils::fileItemIsDirOrArchive(rightItem);
+
+    if (leftIsDirOrArchive != rightIsDirOrArchive) {
+        return leftIsDirOrArchive;
+    }
+
+    if (sortRole() != KDirModel::ModifiedTime) {
+        return KDirSortFilterProxyModel::lessThan(left, right);
+    }
+
+    const KDateTime leftDate = TimeUtils::dateTimeForFileItem(leftItem);
+    const KDateTime rightDate = TimeUtils::dateTimeForFileItem(rightItem);
+
+    return leftDate < rightDate;
+}
 
 bool SortedDirModel::hasDocuments() const
 {
-	const int count = rowCount();
-	if (count == 0) {
-		return false;
-	}
-	for (int row = 0; row < count; ++row) {
-		const QModelIndex idx = index(row, 0);
-		const KFileItem item = itemForIndex(idx);
-		if (!ArchiveUtils::fileItemIsDirOrArchive(item)) {
-			return true;
-		}
-	}
-	return false;
+    const int count = rowCount();
+    if (count == 0) {
+        return false;
+    }
+    for (int row = 0; row < count; ++row) {
+        const QModelIndex idx = index(row, 0);
+        const KFileItem item = itemForIndex(idx);
+        if (!ArchiveUtils::fileItemIsDirOrArchive(item)) {
+            return true;
+        }
+    }
+    return false;
 }
 
-
 } //namespace

=== modified file 'lib/semanticinfo/sorteddirmodel.h'
--- lib/semanticinfo/sorteddirmodel.h	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/sorteddirmodel.h	2011-12-15 14:17:54 +0000
@@ -32,12 +32,12 @@
 #include <lib/gwenviewlib_export.h>
 #include <lib/mimetypeutils.h>
 
-
 class KDirLister;
 class KFileItem;
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class AbstractSemanticInfoBackEnd;
 struct SortedDirModelPrivate;
@@ -47,76 +47,80 @@
 #endif
 
 class SortedDirModel;
-class GWENVIEWLIB_EXPORT AbstractSortedDirModelFilter : public QObject {
+class GWENVIEWLIB_EXPORT AbstractSortedDirModelFilter : public QObject
+{
 public:
-	AbstractSortedDirModelFilter(SortedDirModel* model);
-	~AbstractSortedDirModelFilter();
-	SortedDirModel* model() const { return mModel; }
+    AbstractSortedDirModelFilter(SortedDirModel* model);
+    ~AbstractSortedDirModelFilter();
+    SortedDirModel* model() const {
+        return mModel;
+    }
 
-	virtual bool needsSemanticInfo() const = 0;
-	/**
-	 * Returns true if index should be accepted.
-	 * Warning: index is a source index of SortedDirModel
-	 */
-	virtual bool acceptsIndex(const QModelIndex& index) const = 0;
+    virtual bool needsSemanticInfo() const = 0;
+    /**
+     * Returns true if index should be accepted.
+     * Warning: index is a source index of SortedDirModel
+     */
+    virtual bool acceptsIndex(const QModelIndex& index) const = 0;
 
 private:
-	QPointer<SortedDirModel> mModel;
+    QPointer<SortedDirModel> mModel;
 };
 
 /**
  * This model makes it possible to show all images in a folder.
  * It can filter images based on name and metadata.
  */
-class GWENVIEWLIB_EXPORT SortedDirModel : public KDirSortFilterProxyModel {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT SortedDirModel : public KDirSortFilterProxyModel
+{
+    Q_OBJECT
 public:
-	SortedDirModel(QObject* parent=0);
-	~SortedDirModel();
-	KDirLister* dirLister() const;
-	KFileItem itemForIndex(const QModelIndex& index) const;
-	KUrl urlForIndex(const QModelIndex& index) const;
-	KFileItem itemForSourceIndex(const QModelIndex& sourceIndex) const;
-	QModelIndex indexForItem(const KFileItem& item) const;
-	QModelIndex indexForUrl(const KUrl& url) const;
-
-	void setKindFilter(MimeTypeUtils::Kinds);
-	MimeTypeUtils::Kinds kindFilter() const;
-
-	void adjustKindFilter(MimeTypeUtils::Kinds, bool set);
-
-	/**
-	 * A list of file extensions we should skip
-	 */
-	void setBlackListedExtensions(const QStringList& list);
-
-	void addFilter(AbstractSortedDirModelFilter*);
-
-	void removeFilter(AbstractSortedDirModelFilter*);
-
-	void reload();
-
-	AbstractSemanticInfoBackEnd* semanticInfoBackEnd() const;
+    SortedDirModel(QObject* parent = 0);
+    ~SortedDirModel();
+    KDirLister* dirLister() const;
+    KFileItem itemForIndex(const QModelIndex& index) const;
+    KUrl urlForIndex(const QModelIndex& index) const;
+    KFileItem itemForSourceIndex(const QModelIndex& sourceIndex) const;
+    QModelIndex indexForItem(const KFileItem& item) const;
+    QModelIndex indexForUrl(const KUrl& url) const;
+
+    void setKindFilter(MimeTypeUtils::Kinds);
+    MimeTypeUtils::Kinds kindFilter() const;
+
+    void adjustKindFilter(MimeTypeUtils::Kinds, bool set);
+
+    /**
+     * A list of file extensions we should skip
+     */
+    void setBlackListedExtensions(const QStringList& list);
+
+    void addFilter(AbstractSortedDirModelFilter*);
+
+    void removeFilter(AbstractSortedDirModelFilter*);
+
+    void reload();
+
+    AbstractSemanticInfoBackEnd* semanticInfoBackEnd() const;
 
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	SemanticInfo semanticInfoForSourceIndex(const QModelIndex& sourceIndex) const;
+    SemanticInfo semanticInfoForSourceIndex(const QModelIndex& sourceIndex) const;
 #endif
 
-	bool hasDocuments() const;
+    bool hasDocuments() const;
 
 public Q_SLOTS:
     void applyFilters();
 
 protected:
-	bool filterAcceptsRow(int row, const QModelIndex& parent) const;
-	bool lessThan(const QModelIndex& left, const QModelIndex& right) const;
+    bool filterAcceptsRow(int row, const QModelIndex& parent) const;
+    bool lessThan(const QModelIndex& left, const QModelIndex& right) const;
 
 private Q_SLOTS:
-	void doApplyFilters();
+    void doApplyFilters();
 
 private:
-	friend struct SortedDirModelPrivate;
-	SortedDirModelPrivate * const d;
+    friend struct SortedDirModelPrivate;
+    SortedDirModelPrivate * const d;
 };
 
 } // namespace

=== modified file 'lib/semanticinfo/tagitemdelegate.cpp'
--- lib/semanticinfo/tagitemdelegate.cpp	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/tagitemdelegate.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -35,117 +35,117 @@
 // Local
 #include <lib/semanticinfo/tagmodel.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 TagItemDelegate::TagItemDelegate(QAbstractItemView* view)
 : KWidgetItemDelegate(view, view)
 {
-	#define pm(x) view->style()->pixelMetric(QStyle::x)
-	mMargin     = pm(PM_ToolBarItemMargin);
-	mSpacing    = pm(PM_ToolBarItemSpacing);
-	#undef pm
-	const int iconSize = KIconLoader::global()->currentSize(KIconLoader::Toolbar);
-	const QSize sz = view->style()->sizeFromContents(QStyle::CT_ToolButton, 0, QSize(iconSize, iconSize));
-	mButtonSize = qMax(sz.width(), sz.height());
-}
-
-
-QList<QWidget*> TagItemDelegate::createItemWidgets() const {
-
-	#define initButton(x) \
-		(x)->setAutoRaise(true); \
-		setBlockedEventTypes((x), QList<QEvent::Type>() \
-			<< QEvent::MouseButtonPress \
-			<< QEvent::MouseButtonRelease \
-			<< QEvent::MouseButtonDblClick);
-
-	QToolButton* assignToAllButton = new QToolButton;
-	initButton(assignToAllButton);
-	assignToAllButton->setIcon(KIcon("fill-color")); /* FIXME: Probably not the appropriate icon */
-	assignToAllButton->setToolTip(i18n("Assign this tag to all selected images"));
-	connect(assignToAllButton, SIGNAL(clicked()), SLOT(slotAssignToAllButtonClicked()));
-
-	QToolButton* removeButton = new QToolButton;
-	initButton(removeButton);
-	removeButton->setIcon(KIcon("list-remove"));
-	connect(removeButton, SIGNAL(clicked()), SLOT(slotRemoveButtonClicked()));
-
-	#undef initButton
-
-	return QList<QWidget*>() << removeButton << assignToAllButton;
-}
-
-
-void TagItemDelegate::updateItemWidgets(const QList<QWidget*> widgets, const QStyleOptionViewItem& option, const QPersistentModelIndex& index) const {
-	const bool fullyAssigned = index.data(TagModel::AssignmentStatusRole).toInt() == int(TagModel::FullyAssigned);
-
-	QToolButton* removeButton = static_cast<QToolButton*>(widgets[0]);
-	QToolButton* assignToAllButton = static_cast<QToolButton*>(widgets[1]);
-
-	QSize buttonSize(mButtonSize, option.rect.height() - 2 * mMargin);
-
-	removeButton->resize(buttonSize);
-	assignToAllButton->resize(buttonSize);
-
-	removeButton->move(option.rect.width() - mButtonSize - mMargin, mMargin);
-
-	if (fullyAssigned) {
-		assignToAllButton->hide();
-	} else {
-		assignToAllButton->move(removeButton->x() - mButtonSize - mSpacing, mMargin);
-	}
-}
-
-
-void TagItemDelegate::paint(QPainter* painter, const QStyleOptionViewItem& option, const QModelIndex& index) const {
-	if (!index.isValid()) {
-		return;
-	}
-	const bool selected = option.state & QStyle::State_Selected;
-	const bool fullyAssigned = index.data(TagModel::AssignmentStatusRole).toInt() == int(TagModel::FullyAssigned);
-
-	itemView()->style()->drawPrimitive(QStyle::PE_PanelItemViewItem, &option, painter, 0);
-
-	QRect textRect = option.rect;
-	textRect.setLeft(textRect.left() + mMargin);
-	textRect.setWidth(textRect.width() - mButtonSize - mMargin - mSpacing);
-	if (!fullyAssigned) {
-		textRect.setWidth(textRect.width() - mButtonSize - mSpacing);
-	}
-
-	painter->setPen(option.palette.color(QPalette::Normal,
-		selected
-		? QPalette::HighlightedText
-		: QPalette::Text));
-	painter->drawText(textRect, Qt::AlignLeft | Qt::AlignVCenter, index.data().toString());
-}
-
-
-QSize TagItemDelegate::sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const {
-	const int width  = option.fontMetrics.width(index.data().toString());
-	const int height = qMax(mButtonSize, option.fontMetrics.height());
-	return QSize(width + 2 * mMargin, height + 2 * mMargin);
-}
-
-
-void TagItemDelegate::slotRemoveButtonClicked() {
-	const QModelIndex index = focusedIndex();
-	if (!index.isValid()) {
-		kWarning() << "!index.isValid()";
-		return;
-	}
-	emit removeTagRequested(index.data(TagModel::TagRole).toString());
-}
-
-
-void TagItemDelegate::slotAssignToAllButtonClicked() {
-	const QModelIndex index = focusedIndex();
-	if (!index.isValid()) {
-		kWarning() << "!index.isValid()";
-		return;
-	}
-	emit assignTagToAllRequested(index.data(TagModel::TagRole).toString());
-}
-
+#define pm(x) view->style()->pixelMetric(QStyle::x)
+    mMargin     = pm(PM_ToolBarItemMargin);
+    mSpacing    = pm(PM_ToolBarItemSpacing);
+#undef pm
+    const int iconSize = KIconLoader::global()->currentSize(KIconLoader::Toolbar);
+    const QSize sz = view->style()->sizeFromContents(QStyle::CT_ToolButton, 0, QSize(iconSize, iconSize));
+    mButtonSize = qMax(sz.width(), sz.height());
+}
+
+QList<QWidget*> TagItemDelegate::createItemWidgets() const
+{
+
+#define initButton(x) \
+    (x)->setAutoRaise(true); \
+    setBlockedEventTypes((x), QList<QEvent::Type>() \
+                         << QEvent::MouseButtonPress \
+                         << QEvent::MouseButtonRelease \
+                         << QEvent::MouseButtonDblClick);
+
+    QToolButton* assignToAllButton = new QToolButton;
+    initButton(assignToAllButton);
+    assignToAllButton->setIcon(KIcon("fill-color")); /* FIXME: Probably not the appropriate icon */
+    assignToAllButton->setToolTip(i18n("Assign this tag to all selected images"));
+    connect(assignToAllButton, SIGNAL(clicked()), SLOT(slotAssignToAllButtonClicked()));
+
+    QToolButton* removeButton = new QToolButton;
+    initButton(removeButton);
+    removeButton->setIcon(KIcon("list-remove"));
+    connect(removeButton, SIGNAL(clicked()), SLOT(slotRemoveButtonClicked()));
+
+#undef initButton
+
+    return QList<QWidget*>() << removeButton << assignToAllButton;
+}
+
+void TagItemDelegate::updateItemWidgets(const QList<QWidget*> widgets, const QStyleOptionViewItem& option, const QPersistentModelIndex& index) const
+{
+    const bool fullyAssigned = index.data(TagModel::AssignmentStatusRole).toInt() == int(TagModel::FullyAssigned);
+
+    QToolButton* removeButton = static_cast<QToolButton*>(widgets[0]);
+    QToolButton* assignToAllButton = static_cast<QToolButton*>(widgets[1]);
+
+    QSize buttonSize(mButtonSize, option.rect.height() - 2 * mMargin);
+
+    removeButton->resize(buttonSize);
+    assignToAllButton->resize(buttonSize);
+
+    removeButton->move(option.rect.width() - mButtonSize - mMargin, mMargin);
+
+    if (fullyAssigned) {
+        assignToAllButton->hide();
+    } else {
+        assignToAllButton->move(removeButton->x() - mButtonSize - mSpacing, mMargin);
+    }
+}
+
+void TagItemDelegate::paint(QPainter* painter, const QStyleOptionViewItem& option, const QModelIndex& index) const
+{
+    if (!index.isValid()) {
+        return;
+    }
+    const bool selected = option.state & QStyle::State_Selected;
+    const bool fullyAssigned = index.data(TagModel::AssignmentStatusRole).toInt() == int(TagModel::FullyAssigned);
+
+    itemView()->style()->drawPrimitive(QStyle::PE_PanelItemViewItem, &option, painter, 0);
+
+    QRect textRect = option.rect;
+    textRect.setLeft(textRect.left() + mMargin);
+    textRect.setWidth(textRect.width() - mButtonSize - mMargin - mSpacing);
+    if (!fullyAssigned) {
+        textRect.setWidth(textRect.width() - mButtonSize - mSpacing);
+    }
+
+    painter->setPen(option.palette.color(QPalette::Normal,
+                                         selected
+                                         ? QPalette::HighlightedText
+                                         : QPalette::Text));
+    painter->drawText(textRect, Qt::AlignLeft | Qt::AlignVCenter, index.data().toString());
+}
+
+QSize TagItemDelegate::sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const
+{
+    const int width  = option.fontMetrics.width(index.data().toString());
+    const int height = qMax(mButtonSize, option.fontMetrics.height());
+    return QSize(width + 2 * mMargin, height + 2 * mMargin);
+}
+
+void TagItemDelegate::slotRemoveButtonClicked()
+{
+    const QModelIndex index = focusedIndex();
+    if (!index.isValid()) {
+        kWarning() << "!index.isValid()";
+        return;
+    }
+    emit removeTagRequested(index.data(TagModel::TagRole).toString());
+}
+
+void TagItemDelegate::slotAssignToAllButtonClicked()
+{
+    const QModelIndex index = focusedIndex();
+    if (!index.isValid()) {
+        kWarning() << "!index.isValid()";
+        return;
+    }
+    emit assignTagToAllRequested(index.data(TagModel::TagRole).toString());
+}
 
 } // namespace

=== modified file 'lib/semanticinfo/tagitemdelegate.h'
--- lib/semanticinfo/tagitemdelegate.h	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/tagitemdelegate.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -24,40 +24,42 @@
 // KDE
 #include <kwidgetitemdelegate.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 typedef QString SemanticInfoTag;
 
-class TagItemDelegate : public KWidgetItemDelegate {
-	Q_OBJECT
+class TagItemDelegate : public KWidgetItemDelegate
+{
+    Q_OBJECT
 public:
-	TagItemDelegate(QAbstractItemView* view);
+    TagItemDelegate(QAbstractItemView* view);
 
 protected:
-	virtual QList<QWidget*> createItemWidgets() const;
-
-	virtual void updateItemWidgets(const QList<QWidget*> widgets,
-		const QStyleOptionViewItem& option,
-		const QPersistentModelIndex& /*index*/) const;
-
-	virtual void paint(QPainter *painter, const QStyleOptionViewItem &option,
-		const QModelIndex &index) const;
-
-	virtual QSize sizeHint(const QStyleOptionViewItem &/*option*/,
-		const QModelIndex &/*index*/) const;
+    virtual QList<QWidget*> createItemWidgets() const;
+
+    virtual void updateItemWidgets(const QList<QWidget*> widgets,
+                                   const QStyleOptionViewItem& option,
+                                   const QPersistentModelIndex& /*index*/) const;
+
+    virtual void paint(QPainter *painter, const QStyleOptionViewItem &option,
+                       const QModelIndex &index) const;
+
+    virtual QSize sizeHint(const QStyleOptionViewItem &/*option*/,
+                           const QModelIndex &/*index*/) const;
 
 Q_SIGNALS:
-	void removeTagRequested(const SemanticInfoTag& tag);
-	void assignTagToAllRequested(const SemanticInfoTag& tag);
+    void removeTagRequested(const SemanticInfoTag& tag);
+    void assignTagToAllRequested(const SemanticInfoTag& tag);
 
 private Q_SLOTS:
-	void slotRemoveButtonClicked();
-	void slotAssignToAllButtonClicked();
+    void slotRemoveButtonClicked();
+    void slotAssignToAllButtonClicked();
 
 private:
-	int mButtonSize;
-	int mMargin;
-	int mSpacing;
+    int mButtonSize;
+    int mMargin;
+    int mSpacing;
 };
 
 } // namespace

=== modified file 'lib/semanticinfo/tagmodel.cpp'
--- lib/semanticinfo/tagmodel.cpp	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/tagmodel.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,99 +30,98 @@
 // Local
 #include "abstractsemanticinfobackend.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct TagModelPrivate {
-	AbstractSemanticInfoBackEnd* mBackEnd;
+    AbstractSemanticInfoBackEnd* mBackEnd;
 };
 
-
-static QStandardItem* createItem(const SemanticInfoTag& tag, const QString& label, TagModel::AssignmentStatus status) {
-	QStandardItem* item = new QStandardItem(label);
-	item->setData(tag, TagModel::TagRole);
-	item->setData(label.toLower(), TagModel::SortRole);
-	item->setData(status, TagModel::AssignmentStatusRole);
-	item->setData(KIcon("mail-tagged.png"), Qt::DecorationRole);
-	return item;
+static QStandardItem* createItem(const SemanticInfoTag& tag, const QString& label, TagModel::AssignmentStatus status)
+{
+    QStandardItem* item = new QStandardItem(label);
+    item->setData(tag, TagModel::TagRole);
+    item->setData(label.toLower(), TagModel::SortRole);
+    item->setData(status, TagModel::AssignmentStatusRole);
+    item->setData(KIcon("mail-tagged.png"), Qt::DecorationRole);
+    return item;
 }
 
-
 TagModel::TagModel(QObject* parent)
 : QStandardItemModel(parent)
-, d(new TagModelPrivate) {
-	d->mBackEnd = 0;
-	setSortRole(SortRole);
-}
-
-
-TagModel::~TagModel() {
-	delete d;
-}
-
-
-void TagModel::setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd* backEnd) {
-	d->mBackEnd = backEnd;
-}
-
-
-void TagModel::setTagSet(const TagSet& set) {
-	clear();
-	Q_FOREACH(const SemanticInfoTag& tag, set) {
-		QString label = d->mBackEnd->labelForTag(tag);
-		QStandardItem* item = createItem(tag, label, TagModel::FullyAssigned);
-		appendRow(item);
-	}
-	sort(0);
-}
-
-
-void TagModel::addTag(const SemanticInfoTag& tag, const QString& _label, TagModel::AssignmentStatus status) {
-	int row;
-	QString label = _label.isEmpty() ? d->mBackEnd->labelForTag(tag) : _label;
-
-	const QString sortLabel = label.toLower();
-	// This is not optimal, implement dichotomic search if necessary
-	for (row=0; row < rowCount(); ++row) {
-		const QModelIndex idx = index(row, 0);
-		if (idx.data(SortRole).toString().compare(sortLabel) > 0) {
-			break;
-		}
-	}
-	if (row > 0) {
-		QStandardItem* _item = item(row - 1);
-		Q_ASSERT(_item);
-		if (_item->data(TagRole).toString() == tag) {
-			// Update, do not add
-			_item->setData(label.toLower(), SortRole);
-			_item->setData(status, AssignmentStatusRole);
-			return;
-		}
-	}
-	QStandardItem* _item = createItem(tag, label, status);
-	insertRow(row, _item);
-}
-
-
-void TagModel::removeTag(const SemanticInfoTag& tag) {
-	// This is not optimal, implement dichotomic search if necessary
-	for (int row=0; row < rowCount(); ++row) {
-		if (index(row, 0).data(TagRole).toString() == tag) {
-			removeRow(row);
-			return;
-		}
-	}
-}
-
-
-TagModel* TagModel::createAllTagsModel(QObject* parent, AbstractSemanticInfoBackEnd* backEnd) {
-	TagModel* tagModel = new TagModel(parent);
-	tagModel->setSemanticInfoBackEnd(backEnd);
-	tagModel->setTagSet(backEnd->allTags());
-	connect(backEnd, SIGNAL(tagAdded(const SemanticInfoTag&, const QString&)),
-		tagModel, SLOT(addTag(const SemanticInfoTag&, const QString&)));
-	return tagModel;
-}
-
+, d(new TagModelPrivate)
+{
+    d->mBackEnd = 0;
+    setSortRole(SortRole);
+}
+
+TagModel::~TagModel()
+{
+    delete d;
+}
+
+void TagModel::setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd* backEnd)
+{
+    d->mBackEnd = backEnd;
+}
+
+void TagModel::setTagSet(const TagSet& set)
+{
+    clear();
+    Q_FOREACH(const SemanticInfoTag & tag, set) {
+        QString label = d->mBackEnd->labelForTag(tag);
+        QStandardItem* item = createItem(tag, label, TagModel::FullyAssigned);
+        appendRow(item);
+    }
+    sort(0);
+}
+
+void TagModel::addTag(const SemanticInfoTag& tag, const QString& _label, TagModel::AssignmentStatus status)
+{
+    int row;
+    QString label = _label.isEmpty() ? d->mBackEnd->labelForTag(tag) : _label;
+
+    const QString sortLabel = label.toLower();
+    // This is not optimal, implement dichotomic search if necessary
+    for (row = 0; row < rowCount(); ++row) {
+        const QModelIndex idx = index(row, 0);
+        if (idx.data(SortRole).toString().compare(sortLabel) > 0) {
+            break;
+        }
+    }
+    if (row > 0) {
+        QStandardItem* _item = item(row - 1);
+        Q_ASSERT(_item);
+        if (_item->data(TagRole).toString() == tag) {
+            // Update, do not add
+            _item->setData(label.toLower(), SortRole);
+            _item->setData(status, AssignmentStatusRole);
+            return;
+        }
+    }
+    QStandardItem* _item = createItem(tag, label, status);
+    insertRow(row, _item);
+}
+
+void TagModel::removeTag(const SemanticInfoTag& tag)
+{
+    // This is not optimal, implement dichotomic search if necessary
+    for (int row = 0; row < rowCount(); ++row) {
+        if (index(row, 0).data(TagRole).toString() == tag) {
+            removeRow(row);
+            return;
+        }
+    }
+}
+
+TagModel* TagModel::createAllTagsModel(QObject* parent, AbstractSemanticInfoBackEnd* backEnd)
+{
+    TagModel* tagModel = new TagModel(parent);
+    tagModel->setSemanticInfoBackEnd(backEnd);
+    tagModel->setTagSet(backEnd->allTags());
+    connect(backEnd, SIGNAL(tagAdded(SemanticInfoTag, QString)),
+            tagModel, SLOT(addTag(SemanticInfoTag, QString)));
+    return tagModel;
+}
 
 } // namespace

=== modified file 'lib/semanticinfo/tagmodel.h'
--- lib/semanticinfo/tagmodel.h	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/tagmodel.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,54 +30,54 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 typedef QString SemanticInfoTag;
 
 class AbstractSemanticInfoBackEnd;
 class TagSet;
 
-
 struct TagModelPrivate;
-class GWENVIEWLIB_EXPORT TagModel : public QStandardItemModel {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT TagModel : public QStandardItemModel
+{
+    Q_OBJECT
 public:
-	TagModel(QObject*);
-	~TagModel();
-
-	enum {
-		TagRole = Qt::UserRole,
-		SortRole,
-		AssignmentStatusRole
-	};
-
-	enum AssignmentStatus {
-		PartiallyAssigned,
-		FullyAssigned
-	};
-
-	void setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd*);
-	void setTagSet(const TagSet& set);
-
-	/**
-	 * Convenience method to create a TagModel showing all tags available in
-	 * AbstractSemanticInfoBackEnd
-	 */
-	static TagModel* createAllTagsModel(QObject* parent, AbstractSemanticInfoBackEnd*);
+    TagModel(QObject*);
+    ~TagModel();
+
+    enum {
+        TagRole = Qt::UserRole,
+        SortRole,
+        AssignmentStatusRole
+    };
+
+    enum AssignmentStatus {
+        PartiallyAssigned,
+        FullyAssigned
+    };
+
+    void setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd*);
+    void setTagSet(const TagSet& set);
+
+    /**
+     * Convenience method to create a TagModel showing all tags available in
+     * AbstractSemanticInfoBackEnd
+     */
+    static TagModel* createAllTagsModel(QObject* parent, AbstractSemanticInfoBackEnd*);
 
 public Q_SLOTS:
-	/**
-	 * Add a new tag. If label is empty, backend will be queried for it
-	 */
-	void addTag(const SemanticInfoTag& tag, const QString& label = QString(), AssignmentStatus status = FullyAssigned);
+    /**
+     * Add a new tag. If label is empty, backend will be queried for it
+     */
+    void addTag(const SemanticInfoTag& tag, const QString& label = QString(), AssignmentStatus status = FullyAssigned);
 
-	void removeTag(const SemanticInfoTag& tag);
+    void removeTag(const SemanticInfoTag& tag);
 
 private:
-	TagModelPrivate* const d;
+    TagModelPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* TAGMODEL_H */

=== modified file 'lib/semanticinfo/tagwidget.cpp'
--- lib/semanticinfo/tagwidget.cpp	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/tagwidget.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -40,215 +40,212 @@
 #include <lib/semanticinfo/tagitemdelegate.h>
 #include <lib/semanticinfo/tagmodel.h>
 
-namespace Gwenview {
-
-
-class TagCompleterModel : public QSortFilterProxyModel {
+namespace Gwenview
+{
+
+class TagCompleterModel : public QSortFilterProxyModel
+{
 public:
-	TagCompleterModel(QObject* parent)
-	: QSortFilterProxyModel(parent)
-	{
-	}
-
-
-	void setTagInfo(const TagInfo& tagInfo) {
-		mExcludedTagSet.clear();
-		TagInfo::ConstIterator
-			it = tagInfo.begin(),
-			end = tagInfo.end();
-		for(; it!=end; ++it) {
-			if (it.value()) {
-				mExcludedTagSet << it.key();
-			}
-		}
-		invalidate();
-	}
-
-
-	void setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd* backEnd) {
-		setSourceModel(TagModel::createAllTagsModel(this, backEnd));
-	}
-
+    TagCompleterModel(QObject* parent)
+        : QSortFilterProxyModel(parent) {
+    }
+
+    void setTagInfo(const TagInfo& tagInfo)
+    {
+        mExcludedTagSet.clear();
+        TagInfo::ConstIterator
+        it = tagInfo.begin(),
+        end = tagInfo.end();
+        for (; it != end; ++it) {
+            if (it.value()) {
+                mExcludedTagSet << it.key();
+            }
+        }
+        invalidate();
+    }
+
+    void setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd* backEnd)
+    {
+        setSourceModel(TagModel::createAllTagsModel(this, backEnd));
+    }
 
 protected:
-	virtual bool filterAcceptsRow(int sourceRow, const QModelIndex& sourceParent) const {
-		QModelIndex sourceIndex = sourceModel()->index(sourceRow, 0, sourceParent);
-		SemanticInfoTag tag = sourceIndex.data(TagModel::TagRole).toString();
-		return !mExcludedTagSet.contains(tag);
-	}
-
+    virtual bool filterAcceptsRow(int sourceRow, const QModelIndex& sourceParent) const {
+        QModelIndex sourceIndex = sourceModel()->index(sourceRow, 0, sourceParent);
+        SemanticInfoTag tag = sourceIndex.data(TagModel::TagRole).toString();
+        return !mExcludedTagSet.contains(tag);
+    }
 
 private:
-	TagSet mExcludedTagSet;
+    TagSet mExcludedTagSet;
 };
 
-
 /**
  * A simple class to eat return keys. We use it to avoid propagating the return
  * key from our KLineEdit to a dialog using TagWidget.
  * We can't use KLineEdit::setTrapReturnKey() because it does not play well
  * with QCompleter, it only deals with KCompletion.
  */
-class ReturnKeyEater : public QObject {
+class ReturnKeyEater : public QObject
+{
 public:
-	ReturnKeyEater(QObject* parent = 0)
-	: QObject(parent)
-	{}
+    ReturnKeyEater(QObject* parent = 0)
+        : QObject(parent)
+    {}
 
 protected:
-	virtual bool eventFilter(QObject*, QEvent* event) {
-		if (event->type() == QEvent::KeyPress || event->type() == QEvent::KeyRelease) {
-			QKeyEvent* keyEvent = static_cast<QKeyEvent*>(event);
-			switch (keyEvent->key()) {
-			case Qt::Key_Return:
-			case Qt::Key_Enter:
-				return true;
-			default:
-				return false;
-			}
-		}
-		return false;
-	}
+    virtual bool eventFilter(QObject*, QEvent* event) {
+        if (event->type() == QEvent::KeyPress || event->type() == QEvent::KeyRelease) {
+            QKeyEvent* keyEvent = static_cast<QKeyEvent*>(event);
+            switch (keyEvent->key()) {
+            case Qt::Key_Return:
+            case Qt::Key_Enter:
+                return true;
+            default:
+                return false;
+            }
+        }
+        return false;
+    }
 };
 
 struct TagWidgetPrivate {
-	TagWidget* that;
-	TagInfo mTagInfo;
-	QListView* mListView;
-	QComboBox* mComboBox;
-	KPushButton* mAddButton;
-	AbstractSemanticInfoBackEnd* mBackEnd;
-	TagCompleterModel* mTagCompleterModel;
-	TagModel* mAssignedTagModel;
-
-
-	void setupWidgets() {
-		mListView = new QListView;
-		TagItemDelegate* delegate = new TagItemDelegate(mListView);
-		QObject::connect(delegate, SIGNAL(removeTagRequested(const SemanticInfoTag&)),
-			that, SLOT(removeTag(const SemanticInfoTag&)));
-		QObject::connect(delegate, SIGNAL(assignTagToAllRequested(const SemanticInfoTag&)),
-			that, SLOT(assignTag(const SemanticInfoTag&)));
-		mListView->setItemDelegate(delegate);
-		mListView->setModel(mAssignedTagModel);
-
-		mComboBox = new QComboBox;
-		mComboBox->setEditable(true);
-		mComboBox->setInsertPolicy(QComboBox::NoInsert);
-
-		mTagCompleterModel = new TagCompleterModel(that);
-		QCompleter* completer = new QCompleter(that);
-		completer->setCaseSensitivity(Qt::CaseInsensitive);
-		completer->setModel(mTagCompleterModel);
-		mComboBox->setCompleter(completer);
-
-		mComboBox->setModel(mTagCompleterModel);
-
-		mAddButton = new KPushButton;
-		mAddButton->setIcon(KIcon("list-add"));
-		mAddButton->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
-		QObject::connect(mAddButton, SIGNAL(clicked()),
-			that, SLOT(addTagFromComboBox()));
-
-		QVBoxLayout* layout = new QVBoxLayout(that);
-		layout->setMargin(0);
-		layout->addWidget(mListView);
-
-		QHBoxLayout* hLayout = new QHBoxLayout;
-		hLayout->addWidget(mComboBox);
-		hLayout->addWidget(mAddButton);
-		layout->addLayout(hLayout);
-
-		that->setTabOrder(mComboBox, mListView);
-	}
-
-
-	void fillTagModel() {
-		Q_ASSERT(mBackEnd);
-
-		mAssignedTagModel->clear();
-		TagInfo::ConstIterator
-			it = mTagInfo.constBegin(),
-			end = mTagInfo.constEnd();
-		for(; it!=end; ++it) {
-			mAssignedTagModel->addTag(
-				it.key(),
-				QString(),
-				it.value() ? TagModel::FullyAssigned : TagModel::PartiallyAssigned);
-		}
-	}
-
-
-	void updateCompleterModel() {
-		mTagCompleterModel->setTagInfo(mTagInfo);
-	}
+    TagWidget* q;
+    TagInfo mTagInfo;
+    QListView* mListView;
+    QComboBox* mComboBox;
+    KPushButton* mAddButton;
+    AbstractSemanticInfoBackEnd* mBackEnd;
+    TagCompleterModel* mTagCompleterModel;
+    TagModel* mAssignedTagModel;
+
+    void setupWidgets()
+    {
+        mListView = new QListView;
+        TagItemDelegate* delegate = new TagItemDelegate(mListView);
+        QObject::connect(delegate, SIGNAL(removeTagRequested(SemanticInfoTag)),
+                         q, SLOT(removeTag(SemanticInfoTag)));
+        QObject::connect(delegate, SIGNAL(assignTagToAllRequested(SemanticInfoTag)),
+                         q, SLOT(assignTag(SemanticInfoTag)));
+        mListView->setItemDelegate(delegate);
+        mListView->setModel(mAssignedTagModel);
+
+        mComboBox = new QComboBox;
+        mComboBox->setEditable(true);
+        mComboBox->setInsertPolicy(QComboBox::NoInsert);
+
+        mTagCompleterModel = new TagCompleterModel(q);
+        QCompleter* completer = new QCompleter(q);
+        completer->setCaseSensitivity(Qt::CaseInsensitive);
+        completer->setModel(mTagCompleterModel);
+        mComboBox->setCompleter(completer);
+
+        mComboBox->setModel(mTagCompleterModel);
+
+        mAddButton = new KPushButton;
+        mAddButton->setIcon(KIcon("list-add"));
+        mAddButton->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
+        QObject::connect(mAddButton, SIGNAL(clicked()),
+                         q, SLOT(addTagFromComboBox()));
+
+        QVBoxLayout* layout = new QVBoxLayout(q);
+        layout->setMargin(0);
+        layout->addWidget(mListView);
+
+        QHBoxLayout* hLayout = new QHBoxLayout;
+        hLayout->addWidget(mComboBox);
+        hLayout->addWidget(mAddButton);
+        layout->addLayout(hLayout);
+
+        q->setTabOrder(mComboBox, mListView);
+    }
+
+    void fillTagModel()
+    {
+        Q_ASSERT(mBackEnd);
+
+        mAssignedTagModel->clear();
+        TagInfo::ConstIterator
+        it = mTagInfo.constBegin(),
+        end = mTagInfo.constEnd();
+        for (; it != end; ++it) {
+            mAssignedTagModel->addTag(
+                it.key(),
+                QString(),
+                it.value() ? TagModel::FullyAssigned : TagModel::PartiallyAssigned);
+        }
+    }
+
+    void updateCompleterModel()
+    {
+        mTagCompleterModel->setTagInfo(mTagInfo);
+    }
 };
 
-
 TagWidget::TagWidget(QWidget* parent)
 : QWidget(parent)
-, d(new TagWidgetPrivate) {
-	d->that = this;
-	d->mBackEnd = 0;
-	d->mAssignedTagModel = new TagModel(this);
-	d->setupWidgets();
-	installEventFilter(new ReturnKeyEater(this));
-
-	connect(d->mComboBox->lineEdit(), SIGNAL(returnPressed()),
-		SLOT(addTagFromComboBox()) );
-}
-
-
-TagWidget::~TagWidget() {
-	delete d;
-}
-
-
-void TagWidget::setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd* backEnd) {
-	d->mBackEnd = backEnd;
-	d->mAssignedTagModel->setSemanticInfoBackEnd(backEnd);
-	d->mTagCompleterModel->setSemanticInfoBackEnd(backEnd);
-}
-
-
-void TagWidget::setTagInfo(const TagInfo& tagInfo) {
-	d->mTagInfo = tagInfo;
-	d->fillTagModel();
-	d->updateCompleterModel();
-}
-
-
-void TagWidget::addTagFromComboBox() {
-	Q_ASSERT(d->mBackEnd);
-	QString label = d->mComboBox->currentText();
-	if (label.isEmpty()) {
-		return;
-	}
-	assignTag(d->mBackEnd->tagForLabel(label.trimmed()));
-
-	// Use a QTimer because if the tag is new, it will be inserted in the model
-	// and QComboBox will sometimes select it. At least it does so when the
-	// model is empty.
-	QTimer::singleShot(0, d->mComboBox, SLOT(clearEditText()));
-}
-
-
-void TagWidget::assignTag(const SemanticInfoTag& tag) {
-	d->mTagInfo[tag] = true;
-	d->mAssignedTagModel->addTag(tag);
-	d->updateCompleterModel();
-
-	emit tagAssigned(tag);
-}
-
-
-void TagWidget::removeTag(const SemanticInfoTag& tag) {
-	d->mTagInfo.remove(tag);
-	d->mAssignedTagModel->removeTag(tag);
-	d->updateCompleterModel();
-
-	emit tagRemoved(tag);
-}
-
+, d(new TagWidgetPrivate)
+{
+    d->q = this;
+    d->mBackEnd = 0;
+    d->mAssignedTagModel = new TagModel(this);
+    d->setupWidgets();
+    installEventFilter(new ReturnKeyEater(this));
+
+    connect(d->mComboBox->lineEdit(), SIGNAL(returnPressed()),
+            SLOT(addTagFromComboBox()));
+}
+
+TagWidget::~TagWidget()
+{
+    delete d;
+}
+
+void TagWidget::setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd* backEnd)
+{
+    d->mBackEnd = backEnd;
+    d->mAssignedTagModel->setSemanticInfoBackEnd(backEnd);
+    d->mTagCompleterModel->setSemanticInfoBackEnd(backEnd);
+}
+
+void TagWidget::setTagInfo(const TagInfo& tagInfo)
+{
+    d->mTagInfo = tagInfo;
+    d->fillTagModel();
+    d->updateCompleterModel();
+}
+
+void TagWidget::addTagFromComboBox()
+{
+    Q_ASSERT(d->mBackEnd);
+    QString label = d->mComboBox->currentText();
+    if (label.isEmpty()) {
+        return;
+    }
+    assignTag(d->mBackEnd->tagForLabel(label.trimmed()));
+
+    // Use a QTimer because if the tag is new, it will be inserted in the model
+    // and QComboBox will sometimes select it. At least it does so when the
+    // model is empty.
+    QTimer::singleShot(0, d->mComboBox, SLOT(clearEditText()));
+}
+
+void TagWidget::assignTag(const SemanticInfoTag& tag)
+{
+    d->mTagInfo[tag] = true;
+    d->mAssignedTagModel->addTag(tag);
+    d->updateCompleterModel();
+
+    emit tagAssigned(tag);
+}
+
+void TagWidget::removeTag(const SemanticInfoTag& tag)
+{
+    d->mTagInfo.remove(tag);
+    d->mAssignedTagModel->removeTag(tag);
+    d->updateCompleterModel();
+
+    emit tagRemoved(tag);
+}
 
 } // namespace

=== modified file 'lib/semanticinfo/tagwidget.h'
--- lib/semanticinfo/tagwidget.h	2011-07-20 13:46:34 +0000
+++ lib/semanticinfo/tagwidget.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,34 +32,34 @@
 // Local
 #include <lib/semanticinfo/abstractsemanticinfobackend.h>
 
-
-namespace Gwenview {
+namespace Gwenview
+{
 
 typedef QMap<SemanticInfoTag, bool> TagInfo;
 
 struct TagWidgetPrivate;
-class GWENVIEWLIB_EXPORT TagWidget : public QWidget {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT TagWidget : public QWidget
+{
+    Q_OBJECT
 public:
-	TagWidget(QWidget* parent = 0);
-	~TagWidget();
-	void setTagInfo(const TagInfo&);
-	void setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd*);
+    TagWidget(QWidget* parent = 0);
+    ~TagWidget();
+    void setTagInfo(const TagInfo&);
+    void setSemanticInfoBackEnd(AbstractSemanticInfoBackEnd*);
 
 Q_SIGNALS:
-	void tagAssigned(const SemanticInfoTag&);
-	void tagRemoved(const SemanticInfoTag&);
+    void tagAssigned(const SemanticInfoTag&);
+    void tagRemoved(const SemanticInfoTag&);
 
 private Q_SLOTS:
-	void addTagFromComboBox();
-	void assignTag(const SemanticInfoTag& tag);
-	void removeTag(const SemanticInfoTag&);
+    void addTagFromComboBox();
+    void assignTag(const SemanticInfoTag& tag);
+    void removeTag(const SemanticInfoTag&);
 
 private:
-	TagWidgetPrivate* const d;
+    TagWidgetPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* TAGWIDGET_H */

=== modified file 'lib/signalblocker.h'
--- lib/signalblocker.h	2011-07-20 13:46:34 +0000
+++ lib/signalblocker.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -23,31 +23,29 @@
 
 #include <QObject>
 
-
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 /**
  * An RAII class to block and unblock signals from a QObject instance
  */
-class SignalBlocker {
+class SignalBlocker
+{
 public:
-	SignalBlocker(QObject* object) {
-		mObject = object;
-		mWasBlocked = object->blockSignals(true);
-	}
+    SignalBlocker(QObject* object) {
+        mObject = object;
+        mWasBlocked = object->blockSignals(true);
+    }
 
-	~SignalBlocker() {
-		mObject->blockSignals(mWasBlocked);
-	}
+    ~SignalBlocker() {
+        mObject->blockSignals(mWasBlocked);
+    }
 
 private:
-	QObject* mObject;
-	bool mWasBlocked;
+    QObject* mObject;
+    bool mWasBlocked;
 };
 
-
 } // namespace
 
-
 #endif /* SIGNALBLOCKER_H */

=== modified file 'lib/slidecontainer.cpp'
--- lib/slidecontainer.cpp	2011-07-20 13:46:34 +0000
+++ lib/slidecontainer.cpp	2011-12-15 14:17:54 +0000
@@ -20,105 +20,137 @@
 // Self
 #include "slidecontainer.moc"
 
+// KDE
+#include <kdebug.h>
+
 // Qt
 #include <QEvent>
-
-namespace Gwenview {
-
+#include <QPropertyAnimation>
+#include <QResizeEvent>
+
+namespace Gwenview
+{
+
+static const int SLIDE_DURATION = 250;
 
 SlideContainer::SlideContainer(QWidget* parent)
-: QFrame(parent) {
-	mContent = 0;
-	mTimeLine = new QTimeLine(500, this);
-	connect(mTimeLine, SIGNAL(valueChanged(qreal)), SLOT(slotTimeLineChanged(qreal)) );
-	connect(mTimeLine, SIGNAL(finished()), SLOT(slotTimeLineFinished()) );
-	hide();
-}
-
-
-QWidget* SlideContainer::content() const {
-	return mContent;
-}
-
-
-void SlideContainer::setContent(QWidget* content) {
-	if (mContent) {
-		mContent->setParent(0);
-	}
-	mContent = content;
-	mContent->setParent(this);
-	mContent->hide();
-	mContent->installEventFilter(this);
-}
-
-
-void SlideContainer::slideIn() {
-	mContent->adjustSize();
-	if (mTimeLine->direction() == QTimeLine::Backward) {
-		mTimeLine->setDirection(QTimeLine::Forward);
-	}
-	if (!isVisible() && mTimeLine->state() == QTimeLine::NotRunning) {
-		show();
-		mTimeLine->start();
-	}
-}
-
-
-void SlideContainer::slideOut() {
-	if (mTimeLine->direction() == QTimeLine::Forward) {
-		mTimeLine->setDirection(QTimeLine::Backward);
-	}
-	if (mTimeLine->state() == QTimeLine::NotRunning) {
-		mTimeLine->start();
-	}
-}
-
-
-void SlideContainer::slotTimeLineChanged(qreal value) {
-	int posY = int( (value - 1.0) * height() );
-	mContent->setGeometry(0, posY, width(), height());
-	mContent->show();
-}
-
-
-void SlideContainer::slotTimeLineFinished() {
-	if (mTimeLine->direction() == QTimeLine::Backward) {
-		hide();
-	}
-}
-
-
-QSize SlideContainer::sizeHint() const {
-	if (mContent) {
-		return mContent->sizeHint();
-	} else {
-		return QSize();
-	}
-}
-
-
-QSize SlideContainer::minimumSizeHint() const {
-	if (mContent) {
-		return mContent->minimumSizeHint();
-	} else {
-		return QSize();
-	}
-}
-
-
-void SlideContainer::resizeEvent(QResizeEvent*) {
-	if (mContent) {
-		mContent->resize(size());
-	}
-}
-
-
-bool SlideContainer::eventFilter(QObject*, QEvent* event) {
-	if (event->type() == QEvent::Resize) {
-		mContent->resize(width(), mContent->height());
-	}
-	return false;
-}
-
+: QFrame(parent)
+{
+    mContent = 0;
+    mSlidingOut = false;
+    setFixedHeight(0);
+}
+
+QWidget* SlideContainer::content() const
+{
+    return mContent;
+}
+
+void SlideContainer::setContent(QWidget* content)
+{
+    if (mContent) {
+        mContent->setParent(0);
+        mContent->removeEventFilter(this);
+    }
+    mContent = content;
+    if (mContent) {
+        mContent->setParent(this);
+        mContent->installEventFilter(this);
+        mContent->hide();
+    }
+}
+
+void SlideContainer::animTo(int newHeight)
+{
+    delete mAnim.data();
+    QPropertyAnimation* anim = new QPropertyAnimation(this, "slideHeight", this);
+    anim->setDuration(SLIDE_DURATION);
+    anim->setStartValue(slideHeight());
+    anim->setEndValue(newHeight);
+    anim->start(QAbstractAnimation::DeleteWhenStopped);
+    mAnim = anim;
+}
+
+void SlideContainer::slideIn()
+{
+    mSlidingOut = false;
+    mContent->show();
+    mContent->adjustSize();
+    delete mAnim.data();
+    if (height() == mContent->height()) {
+        return;
+    }
+    animTo(mContent->height());
+}
+
+void SlideContainer::slideOut()
+{
+    if (height() == 0) {
+        return;
+    }
+    mSlidingOut = true;
+    animTo(0);
+    connect(mAnim.data(), SIGNAL(finished()), SLOT(slotSlidedOut()));
+}
+
+void SlideContainer::slotSlidedOut()
+{
+    mSlidingOut = false;
+}
+
+QSize SlideContainer::sizeHint() const
+{
+    if (mContent) {
+        return mContent->sizeHint();
+    } else {
+        return QSize();
+    }
+}
+
+QSize SlideContainer::minimumSizeHint() const
+{
+    if (mContent) {
+        return mContent->minimumSizeHint();
+    } else {
+        return QSize();
+    }
+}
+
+void SlideContainer::resizeEvent(QResizeEvent* event)
+{
+    if (mContent) {
+        if (event->oldSize().width() != width()) {
+            adjustContentGeometry();
+        }
+    }
+}
+
+void SlideContainer::adjustContentGeometry()
+{
+    if (mContent) {
+        mContent->setGeometry(0, height() - mContent->height(), width(), mContent->height());
+    }
+}
+
+bool SlideContainer::eventFilter(QObject*, QEvent* event)
+{
+    if (event->type() == QEvent::Resize) {
+        if (!mSlidingOut && height() != 0) {
+            animTo(mContent->height());
+        }
+    }
+    return false;
+}
+
+int SlideContainer::slideHeight() const
+{
+    return isVisible() ? height() : 0;
+}
+
+void SlideContainer::setSlideHeight(int value)
+{
+    setFixedHeight(value);
+    adjustContentGeometry();
+}
 
 } // namespace

=== modified file 'lib/slidecontainer.h'
--- lib/slidecontainer.h	2011-07-20 13:46:34 +0000
+++ lib/slidecontainer.h	2011-12-15 14:17:54 +0000
@@ -21,66 +21,76 @@
 #define SLIDECONTAINER_H
 
 // Qt
+#include <QWeakPointer>
 #include <QFrame>
-#include <QTimeLine>
 
 #include <lib/gwenviewlib_export.h>
 
-namespace Gwenview {
+class QPropertyAnimation;
 
+namespace Gwenview
+{
 
 /**
  * This widget is design to contain one child widget, the "content" widget.
  * It will start hidden by default. Calling slideIn() will slide in the content
  * widget from the top border. Calling slideOut() will slide it out.
  */
-class GWENVIEWLIB_EXPORT SlideContainer : public QFrame {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT SlideContainer : public QFrame
+{
+    Q_OBJECT
+    Q_PROPERTY(int slideHeight READ slideHeight WRITE setSlideHeight)
 public:
-	SlideContainer(QWidget* parent = 0);
-
-	/**
-	 * Returns the content widget
-	 */
-	QWidget* content() const;
-
-	/**
-	 * Defines the content widget
-	 */
-	void setContent(QWidget* content);
-
-	virtual QSize sizeHint() const;
-
-	virtual QSize minimumSizeHint() const;
+    SlideContainer(QWidget* parent = 0);
+
+    /**
+     * Returns the content widget
+     */
+    QWidget* content() const;
+
+    /**
+     * Defines the content widget
+     */
+    void setContent(QWidget* content);
+
+    virtual QSize sizeHint() const;
+
+    virtual QSize minimumSizeHint() const;
+
+    int slideHeight() const;
+
+    Q_INVOKABLE void setSlideHeight(int height);
 
 public Q_SLOTS:
-	/**
-	 * Slides the content widget in.
-	 * Calling it multiple times won't cause the animation to be replayed.
-	 */
-	void slideIn();
+    /**
+     * Slides the content widget in.
+     * Calling it multiple times won't cause the animation to be replayed.
+     */
+    void slideIn();
 
-	/**
-	 * Slides the content widget out.
-	 * Calling it multiple times won't cause the animation to be replayed.
-	 */
-	void slideOut();
+    /**
+     * Slides the content widget out.
+     * Calling it multiple times won't cause the animation to be replayed.
+     */
+    void slideOut();
 
 protected:
-	void resizeEvent(QResizeEvent*);
-	bool eventFilter(QObject*, QEvent*);
+    void resizeEvent(QResizeEvent*);
+    bool eventFilter(QObject*, QEvent* event);
 
 private Q_SLOTS:
-	void slotTimeLineChanged(qreal value);
-	void slotTimeLineFinished();
+    void slotSlidedOut();
 
 private:
-	QWidget* mContent;
-	QTimeLine* mTimeLine;
+    QWidget* mContent;
+    QWeakPointer<QPropertyAnimation> mAnim;
+    bool mSlidingOut;
+
+    void adjustContentGeometry();
+
+    void animTo(int height);
 };
 
-
 } /* namespace */
 
-
 #endif /* SLIDECONTAINER_H */

=== modified file 'lib/slideshow.cpp'
--- lib/slideshow.cpp	2011-07-20 13:46:34 +0000
+++ lib/slideshow.cpp	2011-12-15 14:17:54 +0000
@@ -38,7 +38,8 @@
 // Local
 #include <gwenviewconfig.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -50,256 +51,257 @@
 #endif
 
 enum State {
-	Stopped,
-	Started,
-	WaitForEndOfUrl
+    Stopped,
+    Started,
+    WaitForEndOfUrl
 };
 
 /**
  * This class generate random numbers which are not the same between two runs
  * of Gwenview. See bug #132334
  */
-class RandomNumberGenerator {
+class RandomNumberGenerator
+{
 public:
-	RandomNumberGenerator()
-	: mSeed(time(0)) {
-	}
+    RandomNumberGenerator()
+    : mSeed(time(0))
+    {
+    }
 
-	int operator()(int n) {
-		return rand_r(&mSeed) % n;
-	}
+    int operator()(int n)
+    {
+        return rand_r(&mSeed) % n;
+    }
 
 private:
-	unsigned int mSeed;
+    unsigned int mSeed;
 };
 
 struct SlideShowPrivate {
-	QTimer* mTimer;
-	State mState;
-	QVector<KUrl> mUrls;
-	QVector<KUrl> mShuffledUrls;
-	QVector<KUrl>::ConstIterator mStartIt;
-	KUrl mCurrentUrl;
-	KUrl mLastShuffledUrl;
-
-	QAction* mLoopAction;
-	QAction* mRandomAction;
-
-	KUrl findNextUrl() {
-		if (GwenviewConfig::random()) {
-			return findNextRandomUrl();
-		} else {
-			return findNextOrderedUrl();
-		}
-	}
-
-
-	KUrl findNextOrderedUrl() {
-		QVector<KUrl>::ConstIterator it = qFind(mUrls.constBegin(), mUrls.constEnd(), mCurrentUrl);
-		if (it == mUrls.constEnd()) {
-			kWarning() << "Current url not found in list. This should not happen.\n";
-			return KUrl();
-		}
-
-		++it;
-		if (GwenviewConfig::loop()) {
-			// Looping, if we reach the end, start again
-			if (it == mUrls.constEnd()) {
-				it = mUrls.constBegin();
-			}
-		} else {
-			// Not looping, have we reached the end?
-			// FIXME: stopAtEnd
-			if (/*(it==mUrls.end() && GwenviewConfig::stopAtEnd()) ||*/ it == mStartIt) {
-				it = mUrls.constEnd();
-			}
-		}
-
-		if (it != mUrls.constEnd()) {
-			return *it;
-		} else {
-			return KUrl();
-		}
-	}
-
-
-	void initShuffledUrls() {
-		mShuffledUrls = mUrls;
-		RandomNumberGenerator generator;
-		std::random_shuffle(mShuffledUrls.begin(), mShuffledUrls.end(), generator);
-		// Ensure the first url is different from the previous last one, so that
-		// last url does not stay visible twice longer than usual
-		if (mLastShuffledUrl == mShuffledUrls.first() && mShuffledUrls.count() > 1) {
-			qSwap(mShuffledUrls[0], mShuffledUrls[1]);
-		}
-		mLastShuffledUrl = mShuffledUrls.last();
-	}
-
-
-	KUrl findNextRandomUrl() {
-		if (mShuffledUrls.empty()) {
-			if (GwenviewConfig::loop()) {
-				initShuffledUrls();
-			} else {
-				return KUrl();
-			}
-		}
-
-		KUrl url = mShuffledUrls.last();
-		mShuffledUrls.pop_back();
-
-		return url;
-	}
-
-
-	void updateTimerInterval() {
-		mTimer->setInterval(int(GwenviewConfig::interval() * 1000));
-	}
-
-
-	void doStart() {
-		if (MimeTypeUtils::urlKind(mCurrentUrl) == MimeTypeUtils::KIND_VIDEO) {
-			LOG("mState = WaitForEndOfUrl");
-			// Just in case
-			mTimer->stop();
-			mState = WaitForEndOfUrl;
-		} else {
-			LOG("mState = Started");
-			mTimer->start();
-			mState = Started;
-		}
-	}
+    QTimer* mTimer;
+    State mState;
+    QVector<KUrl> mUrls;
+    QVector<KUrl> mShuffledUrls;
+    QVector<KUrl>::ConstIterator mStartIt;
+    KUrl mCurrentUrl;
+    KUrl mLastShuffledUrl;
+
+    QAction* mLoopAction;
+    QAction* mRandomAction;
+
+    KUrl findNextUrl()
+    {
+        if (GwenviewConfig::random()) {
+            return findNextRandomUrl();
+        } else {
+            return findNextOrderedUrl();
+        }
+    }
+
+    KUrl findNextOrderedUrl()
+    {
+        QVector<KUrl>::ConstIterator it = qFind(mUrls.constBegin(), mUrls.constEnd(), mCurrentUrl);
+        if (it == mUrls.constEnd()) {
+            kWarning() << "Current url not found in list. This should not happen.\n";
+            return KUrl();
+        }
+
+        ++it;
+        if (GwenviewConfig::loop()) {
+            // Looping, if we reach the end, start again
+            if (it == mUrls.constEnd()) {
+                it = mUrls.constBegin();
+            }
+        } else {
+            // Not looping, have we reached the end?
+            // FIXME: stopAtEnd
+            if (/*(it==mUrls.end() && GwenviewConfig::stopAtEnd()) ||*/ it == mStartIt) {
+                it = mUrls.constEnd();
+            }
+        }
+
+        if (it != mUrls.constEnd()) {
+            return *it;
+        } else {
+            return KUrl();
+        }
+    }
+
+    void initShuffledUrls()
+    {
+        mShuffledUrls = mUrls;
+        RandomNumberGenerator generator;
+        std::random_shuffle(mShuffledUrls.begin(), mShuffledUrls.end(), generator);
+        // Ensure the first url is different from the previous last one, so that
+        // last url does not stay visible twice longer than usual
+        if (mLastShuffledUrl == mShuffledUrls.first() && mShuffledUrls.count() > 1) {
+            qSwap(mShuffledUrls[0], mShuffledUrls[1]);
+        }
+        mLastShuffledUrl = mShuffledUrls.last();
+    }
+
+    KUrl findNextRandomUrl()
+    {
+        if (mShuffledUrls.empty()) {
+            if (GwenviewConfig::loop()) {
+                initShuffledUrls();
+            } else {
+                return KUrl();
+            }
+        }
+
+        KUrl url = mShuffledUrls.last();
+        mShuffledUrls.pop_back();
+
+        return url;
+    }
+
+    void updateTimerInterval()
+    {
+        mTimer->setInterval(int(GwenviewConfig::interval() * 1000));
+    }
+
+    void doStart()
+    {
+        if (MimeTypeUtils::urlKind(mCurrentUrl) == MimeTypeUtils::KIND_VIDEO) {
+            LOG("mState = WaitForEndOfUrl");
+            // Just in case
+            mTimer->stop();
+            mState = WaitForEndOfUrl;
+        } else {
+            LOG("mState = Started");
+            mTimer->start();
+            mState = Started;
+        }
+    }
 };
 
-
-
-
 SlideShow::SlideShow(QObject* parent)
 : QObject(parent)
-, d(new SlideShowPrivate) {
-	d->mState = Stopped;
-
-	d->mTimer = new QTimer(this);
-	connect(d->mTimer, SIGNAL(timeout()),
-			this, SLOT(goToNextUrl()) );
-
-	d->mLoopAction = new QAction(this);
-	d->mLoopAction->setText(i18nc("@item:inmenu toggle loop in slideshow", "Loop"));
-	d->mLoopAction->setCheckable(true);
-	connect(d->mLoopAction, SIGNAL(triggered()), SLOT(updateConfig()) );
-
-	d->mRandomAction = new QAction(this);
-	d->mRandomAction->setText(i18nc("@item:inmenu toggle random order in slideshow", "Random"));
-	d->mRandomAction->setCheckable(true);
-	connect(d->mRandomAction, SIGNAL(toggled(bool)), SLOT(slotRandomActionToggled(bool)) );
-	connect(d->mRandomAction, SIGNAL(triggered()), SLOT(updateConfig()) );
-
-	d->mLoopAction->setChecked(GwenviewConfig::loop());
-	d->mRandomAction->setChecked(GwenviewConfig::random());
-}
-
-
-SlideShow::~SlideShow() {
-	GwenviewConfig::self()->writeConfig();
-	delete d;
-}
-
-
-QAction* SlideShow::loopAction() const {
-	return d->mLoopAction;
-}
-
-
-QAction* SlideShow::randomAction() const {
-	return d->mRandomAction;
-}
-
-
-void SlideShow::start(const QList<KUrl>& urls) {
-	d->mUrls.resize(urls.size());
-	qCopy(urls.begin(), urls.end(), d->mUrls.begin());
-
-	d->mStartIt=qFind(d->mUrls.constBegin(), d->mUrls.constEnd(), d->mCurrentUrl);
-	if (d->mStartIt==d->mUrls.constEnd()) {
-		kWarning() << "Current url not found in list, aborting.\n";
-		return;
-	}
-
-	if (GwenviewConfig::random()) {
-		d->initShuffledUrls();
-	}
-	
-	d->updateTimerInterval();
-	d->mTimer->setSingleShot(false);
-	d->doStart();
-	stateChanged(true);
-}
-
-
-void SlideShow::setInterval(int intervalInSeconds) {
-	GwenviewConfig::setInterval(double(intervalInSeconds));
-	d->updateTimerInterval();
-}
-
-
-void SlideShow::stop() {
-	LOG("Stopping timer");
-	d->mTimer->stop();
-	d->mState = Stopped;
-	stateChanged(false);
-}
-
-
-void SlideShow::resumeAndGoToNextUrl() {
-	LOG("");
-	if (d->mState == WaitForEndOfUrl) {
-		goToNextUrl();
-	}
-}
-
-
-void SlideShow::goToNextUrl() {
-	LOG("");
-	KUrl url = d->findNextUrl();
-	LOG("url:" << url);
-	if (!url.isValid()) {
-		stop();
-		return;
-	}
-	goToUrl(url);
-}
-
-
-void SlideShow::setCurrentUrl(const KUrl& url) {
-	LOG(url);
-	if (d->mCurrentUrl == url) {
-		return;
-	}
-	d->mCurrentUrl = url;
-	// Restart timer to avoid showing new url for the remaining time of the old
-	// url
-	if (d->mState != Stopped) {
-		d->doStart();
-	}
-}
-
-
-bool SlideShow::isRunning() const {
-	return d->mState != Stopped;
-}
-
-
-void SlideShow::updateConfig() {
-	GwenviewConfig::setLoop(d->mLoopAction->isChecked());
-	GwenviewConfig::setRandom(d->mRandomAction->isChecked());
-}
-
-
-void SlideShow::slotRandomActionToggled(bool on) {
-	if (on && d->mState != Stopped) {
-		d->initShuffledUrls();
-	}
-}
-
+, d(new SlideShowPrivate)
+{
+    d->mState = Stopped;
+
+    d->mTimer = new QTimer(this);
+    connect(d->mTimer, SIGNAL(timeout()),
+            this, SLOT(goToNextUrl()));
+
+    d->mLoopAction = new QAction(this);
+    d->mLoopAction->setText(i18nc("@item:inmenu toggle loop in slideshow", "Loop"));
+    d->mLoopAction->setCheckable(true);
+    connect(d->mLoopAction, SIGNAL(triggered()), SLOT(updateConfig()));
+
+    d->mRandomAction = new QAction(this);
+    d->mRandomAction->setText(i18nc("@item:inmenu toggle random order in slideshow", "Random"));
+    d->mRandomAction->setCheckable(true);
+    connect(d->mRandomAction, SIGNAL(toggled(bool)), SLOT(slotRandomActionToggled(bool)));
+    connect(d->mRandomAction, SIGNAL(triggered()), SLOT(updateConfig()));
+
+    d->mLoopAction->setChecked(GwenviewConfig::loop());
+    d->mRandomAction->setChecked(GwenviewConfig::random());
+}
+
+SlideShow::~SlideShow()
+{
+    GwenviewConfig::self()->writeConfig();
+    delete d;
+}
+
+QAction* SlideShow::loopAction() const
+{
+    return d->mLoopAction;
+}
+
+QAction* SlideShow::randomAction() const
+{
+    return d->mRandomAction;
+}
+
+void SlideShow::start(const QList<KUrl>& urls)
+{
+    d->mUrls.resize(urls.size());
+    qCopy(urls.begin(), urls.end(), d->mUrls.begin());
+
+    d->mStartIt = qFind(d->mUrls.constBegin(), d->mUrls.constEnd(), d->mCurrentUrl);
+    if (d->mStartIt == d->mUrls.constEnd()) {
+        kWarning() << "Current url not found in list, aborting.\n";
+        return;
+    }
+
+    if (GwenviewConfig::random()) {
+        d->initShuffledUrls();
+    }
+
+    d->updateTimerInterval();
+    d->mTimer->setSingleShot(false);
+    d->doStart();
+    stateChanged(true);
+}
+
+void SlideShow::setInterval(int intervalInSeconds)
+{
+    GwenviewConfig::setInterval(double(intervalInSeconds));
+    d->updateTimerInterval();
+}
+
+void SlideShow::stop()
+{
+    LOG("Stopping timer");
+    d->mTimer->stop();
+    d->mState = Stopped;
+    stateChanged(false);
+}
+
+void SlideShow::resumeAndGoToNextUrl()
+{
+    LOG("");
+    if (d->mState == WaitForEndOfUrl) {
+        goToNextUrl();
+    }
+}
+
+void SlideShow::goToNextUrl()
+{
+    LOG("");
+    KUrl url = d->findNextUrl();
+    LOG("url:" << url);
+    if (!url.isValid()) {
+        stop();
+        return;
+    }
+    goToUrl(url);
+}
+
+void SlideShow::setCurrentUrl(const KUrl& url)
+{
+    LOG(url);
+    if (d->mCurrentUrl == url) {
+        return;
+    }
+    d->mCurrentUrl = url;
+    // Restart timer to avoid showing new url for the remaining time of the old
+    // url
+    if (d->mState != Stopped) {
+        d->doStart();
+    }
+}
+
+bool SlideShow::isRunning() const
+{
+    return d->mState != Stopped;
+}
+
+void SlideShow::updateConfig()
+{
+    GwenviewConfig::setLoop(d->mLoopAction->isChecked());
+    GwenviewConfig::setRandom(d->mRandomAction->isChecked());
+}
+
+void SlideShow::slotRandomActionToggled(bool on)
+{
+    if (on && d->mState != Stopped) {
+        d->initShuffledUrls();
+    }
+}
 
 } // namespace

=== modified file 'lib/slideshow.h'
--- lib/slideshow.h	2011-07-20 13:46:34 +0000
+++ lib/slideshow.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -31,48 +31,50 @@
 
 class QAction;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct SlideShowPrivate;
-class GWENVIEWLIB_EXPORT SlideShow : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT SlideShow : public QObject
+{
+    Q_OBJECT
 public:
-	SlideShow(QObject* parent);
-	virtual ~SlideShow();
-
-	void start(const QList<KUrl>& urls);
-	void stop();
-
-	QAction* loopAction() const;
-	QAction* randomAction() const;
-
-	/** @return true if the slideshow is running */
-	bool isRunning() const;
-
-	void setCurrentUrl(const KUrl& url);
+    SlideShow(QObject* parent);
+    virtual ~SlideShow();
+
+    void start(const QList<KUrl>& urls);
+    void stop();
+
+    QAction* loopAction() const;
+    QAction* randomAction() const;
+
+    /** @return true if the slideshow is running */
+    bool isRunning() const;
+
+    void setCurrentUrl(const KUrl& url);
 
 public Q_SLOTS:
-	void setInterval(int);
+    void setInterval(int);
 
-	/**
-	 * Resume slideshow and go to next url.
-	 */
-	void resumeAndGoToNextUrl();
+    /**
+     * Resume slideshow and go to next url.
+     */
+    void resumeAndGoToNextUrl();
 
 Q_SIGNALS:
-	void goToUrl( const KUrl& );
-	/**
-	 * Slideshow has been started or stopped
-	 */
-	void stateChanged(bool running);
+    void goToUrl(const KUrl&);
+    /**
+     * Slideshow has been started or stopped
+     */
+    void stateChanged(bool running);
 
 private Q_SLOTS:
-	void goToNextUrl();
-	void updateConfig();
-	void slotRandomActionToggled(bool on);
+    void goToNextUrl();
+    void updateConfig();
+    void slotRandomActionToggled(bool on);
 
 private:
-	SlideShowPrivate* const d;
+    SlideShowPrivate* const d;
 };
 
 } // namespace

=== modified file 'lib/sorting.h'
--- lib/sorting.h	2011-07-20 13:46:34 +0000
+++ lib/sorting.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -27,19 +27,21 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace Sorting {
-	/**
-	 * This enum represents the different sorting orders.
-	 * For now it maps with KDirModel::ModelColumns, but in the future it may
-	 * be possible to add custom sort orders like Rating.
-	 */
-	enum Enum {
-		Name,
-		Size,
-		Date
-	};
+namespace Sorting
+{
+/**
+ * This enum represents the different sorting orders.
+ * For now it maps with KDirModel::ModelColumns, but in the future it may
+ * be possible to add custom sort orders like Rating.
+ */
+enum Enum {
+    Name,
+    Size,
+    Date
+};
 
 } // namespace Sorting
 

=== removed file 'lib/splittercollapser.cpp'
--- lib/splittercollapser.cpp	2011-07-20 13:46:34 +0000
+++ lib/splittercollapser.cpp	1970-01-01 00:00:00 +0000
@@ -1,269 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2009-2010 Aurélien Gâteau <agateau@kde.org>
-
-This library is free software; you can redistribute it and/or
-modify it under the terms of the GNU Lesser General Public
-License as published by the Free Software Foundation; either
-version 2.1 of the License, or (at your option) version 3, or any
-later version accepted by the membership of KDE e.V. (or its
-successor approved by the membership of KDE e.V.), which shall
-act as a proxy defined in Section 6 of version 3 of the license.
-
-This library is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-Lesser General Public License for more details.
-
-You should have received a copy of the GNU Lesser General Public
-License along with this program.  If not, see <http://www.gnu.org/licenses/>.
-
-*/
-// Self
-#include "splittercollapser.h"
-
-// Qt
-#include <QApplication>
-#include <QEvent>
-#include <QMouseEvent>
-#include <QSplitter>
-#include <QStyleOptionToolButton>
-#include <QStylePainter>
-#include <QTimeLine>
-
-// KDE
-#include <kdebug.h>
-
-// Local
-
-namespace Gwenview {
-
-
-enum Direction {
-	LTR      = 1 << 0,
-	RTL      = 1 << 1,
-	Vertical = 1 << 2,
-	TTB      = Vertical + (1 << 0),
-	BTT      = Vertical + (1 << 1)
-};
-
-const int TIMELINE_DURATION = 500;
-
-const qreal MINIMUM_OPACITY = 0.3;
-
-struct ArrowTypes {
-	ArrowTypes() {}
-
-	ArrowTypes(Qt::ArrowType t1, Qt::ArrowType t2)
-	: visible(t1), notVisible(t2) {}
-
-	Qt::ArrowType visible,
-	notVisible;
-
-	Qt::ArrowType get(bool isVisible) {
-		return isVisible ? visible : notVisible;
-	}
-};
-
-
-struct SplitterCollapserPrivate {
-	SplitterCollapser* q;
-	QSplitter* mSplitter;
-	QWidget* mWidget;
-	Direction mDirection;
-	QTimeLine* mOpacityTimeLine;
-
-	bool isVertical() const {
-		return mDirection & Vertical;
-	}
-
-	void updatePosition() {
-		int x, y;
-		QRect widgetRect = mWidget->geometry();
-		int splitterWidth = mSplitter->width();
-		int handleWidth = mSplitter->handleWidth();
-		int width = q->width();
-
-		if (!isVertical()) {
-			// FIXME: Make this configurable
-			y = 60;
-			if (mDirection == LTR) {
-				if (mWidget->isVisible()) {
-					x = widgetRect.right() + handleWidth;
-				} else {
-					x = 0;
-				}
-			} else { // RTL
-				if (mWidget->isVisible()) {
-					x = widgetRect.left() - handleWidth - width;
-				} else {
-					x = splitterWidth - handleWidth - width;
-				}
-			}
-		} else {
-			// FIXME
-			x = 0;
-			y = 0;
-		}
-		q->move(x, y);
-	}
-
-
-	void updateArrow() {
-		static QMap<Direction, ArrowTypes> arrowForDirection;
-		if (arrowForDirection.isEmpty()) {
-			arrowForDirection[LTR] = ArrowTypes(Qt::LeftArrow,  Qt::RightArrow);
-			arrowForDirection[RTL] = ArrowTypes(Qt::RightArrow, Qt::LeftArrow);
-			arrowForDirection[TTB] = ArrowTypes(Qt::UpArrow,    Qt::DownArrow);
-			arrowForDirection[BTT] = ArrowTypes(Qt::DownArrow,  Qt::UpArrow);
-		}
-		q->setArrowType(arrowForDirection[mDirection].get(mWidget->isVisible()));
-	}
-
-
-	void fadeIn() {
-		mOpacityTimeLine->setDirection(QTimeLine::Forward);
-		startTimeLine();
-	}
-
-
-	void fadeOut() {
-		mOpacityTimeLine->setDirection(QTimeLine::Backward);
-		startTimeLine();
-	}
-
-
-	void startTimeLine() {
-		if (mOpacityTimeLine->state() != QTimeLine::Running) {
-			mOpacityTimeLine->start();
-		}
-	}
-};
-
-
-SplitterCollapser::SplitterCollapser(QSplitter* splitter, QWidget* widget)
-: QToolButton()
-, d(new SplitterCollapserPrivate) {
-	d->q = this;
-
-	// We do not want our collapser to be added as a regular widget in the
-	// splitter!
-	setAttribute(Qt::WA_NoChildEventsForParent);
-
-	// Get QHoverEvents
-	setAttribute(Qt::WA_Hover);
-
-	// We do not want to get the focused, otherwise user might trigger
-	// it while pressing space to browse through images
-	setFocusPolicy(Qt::NoFocus);
-
-	d->mOpacityTimeLine = new QTimeLine(TIMELINE_DURATION, this);
-	d->mOpacityTimeLine->setFrameRange(int(MINIMUM_OPACITY * 1000), 1000);
-	connect(d->mOpacityTimeLine, SIGNAL(valueChanged(qreal)),
-		SLOT(update()));
-
-	d->mWidget = widget;
-	d->mWidget->installEventFilter(this);
-
-	d->mSplitter = splitter;
-	setParent(d->mSplitter);
-
-	if (splitter->indexOf(widget) < splitter->count() / 2) {
-		d->mDirection = LTR;
-	} else {
-		d->mDirection = RTL;
-	}
-	if (splitter->orientation() == Qt::Vertical) {
-		// FIXME: Ugly!
-		d->mDirection = static_cast<Direction>(int(d->mDirection) + int(TTB));
-	}
-
-	connect(this, SIGNAL(clicked()), SLOT(slotClicked()));
-
-	d->updatePosition();
-
-	show();
-}
-
-
-SplitterCollapser::~SplitterCollapser() {
-	delete d;
-}
-
-
-bool SplitterCollapser::eventFilter(QObject*, QEvent* event) {
-	switch (event->type()) {
-	case QEvent::Resize:
-		d->updatePosition();
-		break;
-
-	case QEvent::Show:
-	case QEvent::Hide:
-		d->updatePosition();
-		d->updateArrow();
-		break;
-
-	default:
-		break;
-	}
-	return false;
-}
-
-
-QSize SplitterCollapser::sizeHint() const {
-	int extent = style()->pixelMetric(QStyle::PM_ScrollBarExtent);
-	QSize sh(extent * 3 / 4, extent * 240 / 100);
-	if (d->isVertical()) {
-		sh.transpose();
-	}
-	return sh;
-}
-
-
-void SplitterCollapser::slotClicked() {
-	d->mWidget->setVisible(!d->mWidget->isVisible());
-}
-
-
-bool SplitterCollapser::event(QEvent* event) {
-	switch (event->type()) {
-	case QEvent::HoverEnter:
-		d->fadeIn();
-		break;
-	case QEvent::HoverLeave:
-		d->fadeOut();
-		break;
-	default:
-		break;
-	}
-	return QToolButton::event(event);
-}
-
-
-void SplitterCollapser::paintEvent(QPaintEvent*) {
-	QStylePainter painter(this);
-	qreal opacity = d->mOpacityTimeLine->currentFrame() / 1000.;
-	painter.setOpacity(opacity);
-
-	QStyleOptionToolButton opt;
-	initStyleOption(&opt);
-	if (d->mDirection == LTR) {
-		opt.rect.setLeft(-width());
-	} else {
-		opt.rect.setWidth(width() * 2);
-	}
-	painter.drawPrimitive(QStyle::PE_PanelButtonTool, opt);
-
-	QStyleOptionToolButton opt2;
-	initStyleOption(&opt2);
-	painter.drawControl(QStyle::CE_ToolButtonLabel, opt2);
-}
-
-
-void SplitterCollapser::showEvent(QShowEvent*) {
-	d->updateArrow();
-}
-
-
-} // namespace

=== removed file 'lib/splittercollapser.h'
--- lib/splittercollapser.h	2011-07-20 13:46:34 +0000
+++ lib/splittercollapser.h	1970-01-01 00:00:00 +0000
@@ -1,69 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2009-2010 Aurélien Gâteau <agateau@kde.org>
-
-This library is free software; you can redistribute it and/or
-modify it under the terms of the GNU Lesser General Public
-License as published by the Free Software Foundation; either
-version 2.1 of the License, or (at your option) version 3, or any
-later version accepted by the membership of KDE e.V. (or its
-successor approved by the membership of KDE e.V.), which shall
-act as a proxy defined in Section 6 of version 3 of the license.
-
-This library is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-Lesser General Public License for more details.
-
-You should have received a copy of the GNU Lesser General Public
-License along with this program.  If not, see <http://www.gnu.org/licenses/>.
-
-*/
-#ifndef SPLITTERCOLLAPSER_H
-#define SPLITTERCOLLAPSER_H
-
-// Qt
-#include <QToolButton>
-
-// KDE
-
-// Local
-#include <lib/gwenviewlib_export.h>
-
-class QSplitter;
-
-namespace Gwenview {
-
-
-struct SplitterCollapserPrivate;
-/**
- * A button which appears on the side of a splitter handle and allows easy
- * collapsing of the widget on the opposite side
- */
-class GWENVIEWLIB_EXPORT SplitterCollapser : public QToolButton {
-	Q_OBJECT
-public:
-	SplitterCollapser(QSplitter*, QWidget* widget);
-	~SplitterCollapser();
-
-	virtual QSize sizeHint() const;
-
-protected:
-	virtual bool eventFilter(QObject*, QEvent*);
-
-	virtual bool event(QEvent* event);
-	virtual void paintEvent(QPaintEvent*);
-	virtual void showEvent(QShowEvent*);
-
-private:
-	SplitterCollapserPrivate* const d;
-
-private Q_SLOTS:
-	void slotClicked();
-};
-
-
-} // namespace
-
-#endif /* SPLITTERCOLLAPSER_H */

=== modified file 'lib/statusbartoolbutton.cpp'
--- lib/statusbartoolbutton.cpp	2011-07-20 13:46:34 +0000
+++ lib/statusbartoolbutton.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -30,94 +30,94 @@
 // KDE
 #include <klocale.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 StatusBarToolButton::StatusBarToolButton(QWidget* parent)
 : QToolButton(parent)
-, mGroupPosition(NotGrouped) {
-	setToolButtonStyle(Qt::ToolButtonTextOnly);
-	setFocusPolicy(Qt::NoFocus);
-	setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Minimum);
-}
-
-
-QSize StatusBarToolButton::minimumSizeHint() const {
-	return sizeHint();
-}
-
-
-QSize StatusBarToolButton::sizeHint() const {
-	QSize sh = QToolButton::sizeHint();
-	sh.setHeight(fontMetrics().height());
-	return sh;
-}
-
-
-void StatusBarToolButton::setGroupPosition(StatusBarToolButton::GroupPosition groupPosition) {
-	mGroupPosition = groupPosition;
-}
-
-
-void StatusBarToolButton::paintEvent(QPaintEvent* event) {
-	if (mGroupPosition == NotGrouped) {
-		QToolButton::paintEvent(event);
-		return;
-	}
-	QStylePainter painter(this);
-	QStyleOptionToolButton opt;
-	initStyleOption(&opt);
-	QStyleOptionToolButton panelOpt = opt;
-
-	// Panel
-	QRect& panelRect = panelOpt.rect;
-	switch (mGroupPosition) {
-	case GroupLeft:
-		panelRect.setWidth(panelRect.width() * 2);
-		break;
-	case GroupCenter:
-		panelRect.setLeft(panelRect.left() - panelRect.width());
-		panelRect.setWidth(panelRect.width() * 3);
-		break;
-	case GroupRight:
-		panelRect.setLeft(panelRect.left() - panelRect.width());
-		break;
-	case NotGrouped:
-		Q_ASSERT(0);
-	}
-	painter.drawPrimitive(QStyle::PE_PanelButtonTool, panelOpt);
-
-	// Separator
-	const int y1 = opt.rect.top() + 6;
-	const int y2 = opt.rect.bottom() - 6;
-	if (mGroupPosition & GroupRight) {
-		const int x = opt.rect.left();
-		painter.setPen(opt.palette.color(QPalette::Light));
-		painter.drawLine(x, y1, x, y2);
-	}
-	if (mGroupPosition & GroupLeft) {
-		const int x = opt.rect.right();
-		painter.setPen(opt.palette.color(QPalette::Mid));
-		painter.drawLine(x, y1, x, y2);
-	}
-
-	// Text
-	painter.drawControl(QStyle::CE_ToolButtonLabel, opt);
-
-	// Filtering message on tooltip text for CJK to remove accelerators.
-	// Quoting ktoolbar.cpp:
-	// """
-	// CJK languages use more verbose accelerator marker: they add a Latin
-	// letter in parenthesis, and put accelerator on that. Hence, the default
-	// removal of ampersand only may not be enough there, instead the whole
-	// parenthesis construct should be removed. Provide these filtering i18n
-	// messages so that translators can use Transcript for custom removal.
-	// """
-	if (!actions().isEmpty()) {
-		QAction* action = actions().first();
-		setToolTip(i18nc("@info:tooltip of custom toolbar button", "%1", action->toolTip()));
-	}
-}
-
+, mGroupPosition(NotGrouped)
+{
+    setToolButtonStyle(Qt::ToolButtonTextOnly);
+    setFocusPolicy(Qt::NoFocus);
+    setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Minimum);
+}
+
+QSize StatusBarToolButton::minimumSizeHint() const
+{
+    return sizeHint();
+}
+
+QSize StatusBarToolButton::sizeHint() const
+{
+    QSize sh = QToolButton::sizeHint();
+    sh.setHeight(fontMetrics().height());
+    return sh;
+}
+
+void StatusBarToolButton::setGroupPosition(StatusBarToolButton::GroupPosition groupPosition)
+{
+    mGroupPosition = groupPosition;
+}
+
+void StatusBarToolButton::paintEvent(QPaintEvent* event)
+{
+    if (mGroupPosition == NotGrouped) {
+        QToolButton::paintEvent(event);
+        return;
+    }
+    QStylePainter painter(this);
+    QStyleOptionToolButton opt;
+    initStyleOption(&opt);
+    QStyleOptionToolButton panelOpt = opt;
+
+    // Panel
+    QRect& panelRect = panelOpt.rect;
+    switch (mGroupPosition) {
+    case GroupLeft:
+        panelRect.setWidth(panelRect.width() * 2);
+        break;
+    case GroupCenter:
+        panelRect.setLeft(panelRect.left() - panelRect.width());
+        panelRect.setWidth(panelRect.width() * 3);
+        break;
+    case GroupRight:
+        panelRect.setLeft(panelRect.left() - panelRect.width());
+        break;
+    case NotGrouped:
+        Q_ASSERT(0);
+    }
+    painter.drawPrimitive(QStyle::PE_PanelButtonTool, panelOpt);
+
+    // Separator
+    const int y1 = opt.rect.top() + 6;
+    const int y2 = opt.rect.bottom() - 6;
+    if (mGroupPosition & GroupRight) {
+        const int x = opt.rect.left();
+        painter.setPen(opt.palette.color(QPalette::Light));
+        painter.drawLine(x, y1, x, y2);
+    }
+    if (mGroupPosition & GroupLeft) {
+        const int x = opt.rect.right();
+        painter.setPen(opt.palette.color(QPalette::Mid));
+        painter.drawLine(x, y1, x, y2);
+    }
+
+    // Text
+    painter.drawControl(QStyle::CE_ToolButtonLabel, opt);
+
+    // Filtering message on tooltip text for CJK to remove accelerators.
+    // Quoting ktoolbar.cpp:
+    // """
+    // CJK languages use more verbose accelerator marker: they add a Latin
+    // letter in parenthesis, and put accelerator on that. Hence, the default
+    // removal of ampersand only may not be enough there, instead the whole
+    // parenthesis construct should be removed. Provide these filtering i18n
+    // messages so that translators can use Transcript for custom removal.
+    // """
+    if (!actions().isEmpty()) {
+        QAction* action = actions().first();
+        setToolTip(i18nc("@info:tooltip of custom toolbar button", "%1", action->toolTip()));
+    }
+}
 
 } // namespace

=== modified file 'lib/statusbartoolbutton.h'
--- lib/statusbartoolbutton.h	2011-07-20 13:46:34 +0000
+++ lib/statusbartoolbutton.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -26,7 +26,8 @@
 // Qt
 #include <QToolButton>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * A thin tool button which can be grouped with another and look like one solid
@@ -34,29 +35,30 @@
  *
  * ( button1 | button2 )
  */
-class GWENVIEWLIB_EXPORT StatusBarToolButton : public QToolButton {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT StatusBarToolButton : public QToolButton
+{
+    Q_OBJECT
 public:
-	enum GroupPosition {
-		NotGrouped = 0,
-		GroupLeft = 1,
-		GroupRight = 2,
-		GroupCenter = 3
-	};
-
-	StatusBarToolButton(QWidget* parent=0);
-
-	virtual QSize minimumSizeHint() const;
-
-	virtual QSize sizeHint() const;
-
-	void setGroupPosition(StatusBarToolButton::GroupPosition groupPosition);
+    enum GroupPosition {
+        NotGrouped = 0,
+        GroupLeft = 1,
+        GroupRight = 2,
+        GroupCenter = 3
+    };
+
+    StatusBarToolButton(QWidget* parent = 0);
+
+    virtual QSize minimumSizeHint() const;
+
+    virtual QSize sizeHint() const;
+
+    void setGroupPosition(StatusBarToolButton::GroupPosition groupPosition);
 
 protected:
-	virtual void paintEvent(QPaintEvent* event);
+    virtual void paintEvent(QPaintEvent* event);
 
 private:
-	GroupPosition mGroupPosition;
+    GroupPosition mGroupPosition;
 };
 
 } // namespace

=== modified file 'lib/thumbnailgroup.h'
--- lib/thumbnailgroup.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailgroup.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -27,29 +27,33 @@
 
 // Local
 
-namespace Gwenview {
-
-namespace ThumbnailGroup {
-	enum Enum {
-		Normal,
-		Large
-	};
-
-	inline int pixelSize(Enum value) {
-		if (value == Normal) {
-			return 128;
-		} else {
-			return 256;
-		}
-	}
-
-	inline Enum fromPixelSize(int value) {
-		if (value <= 128) {
-			return Normal;
-		} else {
-			return Large;
-		}
-	}
+namespace Gwenview
+{
+
+namespace ThumbnailGroup
+{
+enum Enum {
+    Normal,
+    Large
+};
+
+inline int pixelSize(Enum value)
+{
+    if (value == Normal) {
+        return 128;
+    } else {
+        return 256;
+    }
+}
+
+inline Enum fromPixelSize(int value)
+{
+    if (value <= 128) {
+        return Normal;
+    } else {
+        return Large;
+    }
+}
 } // namespace ThumbnailGroup
 
 } // namespace Gwenview

=== modified file 'lib/thumbnailloadjob.cpp'
--- lib/thumbnailloadjob.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailloadjob.cpp	2011-12-15 14:17:54 +0000
@@ -1,25 +1,25 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*	Gwenview - A simple image viewer for KDE
-	Copyright 2000-2007 Aurélien Gâteau <agateau@kde.org>
-	This class is based on the ImagePreviewJob class from Konqueror.
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*  Gwenview - A simple image viewer for KDE
+    Copyright 2000-2007 Aurélien Gâteau <agateau@kde.org>
+    This class is based on the ImagePreviewJob class from Konqueror.
 */
-/*	This file is part of the KDE project
-	Copyright (C) 2000 David Faure <faure@kde.org>
-				  2000 Carsten Pfeiffer <pfeiffer@kde.org>
-
-	This program is free software; you can redistribute it and/or modify
-	it under the terms of the GNU General Public License as published by
-	the Free Software Foundation; either version 2 of the License, or
-	(at your option) any later version.
-
-	This program is distributed in the hope that it will be useful,
-	but WITHOUT ANY WARRANTY; without even the implied warranty of
-	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-	GNU General Public License for more details.
-
-	You should have received a copy of the GNU General Public License
-	along with this program; if not, write to the Free Software
-	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+/*  This file is part of the KDE project
+    Copyright (C) 2000 David Faure <faure@kde.org>
+                  2000 Carsten Pfeiffer <pfeiffer@kde.org>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
 #include "thumbnailloadjob.moc"
 
@@ -54,7 +54,8 @@
 #include "imageutils.h"
 #include "urlutils.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -65,19 +66,19 @@
 #define LOG(x) ;
 #endif
 
-
-static QString generateOriginalUri(const KUrl& url_) {
-	KUrl url = url_;
-	// Don't include the password if any
-	url.setPass(QString::null);	//krazy:exclude=nullstrassign for old broken gcc
-	return url.url();
+static QString generateOriginalUri(const KUrl& url_)
+{
+    KUrl url = url_;
+    // Don't include the password if any
+    url.setPass(QString::null); //krazy:exclude=nullstrassign for old broken gcc
+    return url.url();
 }
 
-
-static QString generateThumbnailPath(const QString& uri, ThumbnailGroup::Enum group) {
-	KMD5 md5( QFile::encodeName(uri) );
-	QString baseDir=ThumbnailLoadJob::thumbnailBaseDir(group);
-	return baseDir + QString(QFile::encodeName( md5.hexDigest())) + ".png";
+static QString generateThumbnailPath(const QString& uri, ThumbnailGroup::Enum group)
+{
+    KMD5 md5(QFile::encodeName(uri));
+    QString baseDir = ThumbnailLoadJob::thumbnailBaseDir(group);
+    return baseDir + QString(QFile::encodeName(md5.hexDigest())) + ".png";
 }
 
 //------------------------------------------------------------------------
@@ -87,60 +88,62 @@
 //------------------------------------------------------------------------
 K_GLOBAL_STATIC(ThumbnailCache, sThumbnailCache)
 
-
-static void storeThumbnailToDiskCache(const QString& path, const QImage& image) {
-	LOG(path);
-	KTemporaryFile tmp;
-	tmp.setPrefix(path + ".gwenview.tmp");
-	tmp.setSuffix(".png");
-	if (!tmp.open()) {
-		kWarning() << "Could not create a temporary file.";
-		return;
-	}
-
-	if (!image.save(tmp.fileName(), "png")) {
-		kWarning() << "Could not save thumbnail";
-		return;
-	}
-
-	KDE_rename(QFile::encodeName(tmp.fileName()), QFile::encodeName(path));
-}
-
-
-void ThumbnailCache::queueThumbnail(const QString& path, const QImage& image) {
-	LOG(path);
-	QMutexLocker locker(&mMutex);
-	mCache.insert(path, image);
-}
-
-void ThumbnailCache::run() {
-	QMutexLocker locker(&mMutex);
-	while (!mCache.isEmpty()) {
-		Cache::ConstIterator it = mCache.constBegin();
-		const QString path = it.key();
-		const QImage image = it.value();
-
-		// This part of the thread is the most time consuming but it does not
-		// depend on mCache so we can unlock here. This way other thumbnails
-		// can be added or queried
-		locker.unlock();
-		storeThumbnailToDiskCache(path, image);
-		locker.relock();
-
-		mCache.remove(path);
-	}
-}
-
-QImage ThumbnailCache::value(const QString& path) const {
-	QMutexLocker locker(&mMutex);
-	return mCache.value(path);
-}
-
-bool ThumbnailCache::isEmpty() const {
-	QMutexLocker locker(&mMutex);
-	return mCache.isEmpty();
-}
-
+static void storeThumbnailToDiskCache(const QString& path, const QImage& image)
+{
+    LOG(path);
+    KTemporaryFile tmp;
+    tmp.setPrefix(path + ".gwenview.tmp");
+    tmp.setSuffix(".png");
+    if (!tmp.open()) {
+        kWarning() << "Could not create a temporary file.";
+        return;
+    }
+
+    if (!image.save(tmp.fileName(), "png")) {
+        kWarning() << "Could not save thumbnail";
+        return;
+    }
+
+    KDE_rename(QFile::encodeName(tmp.fileName()), QFile::encodeName(path));
+}
+
+void ThumbnailCache::queueThumbnail(const QString& path, const QImage& image)
+{
+    LOG(path);
+    QMutexLocker locker(&mMutex);
+    mCache.insert(path, image);
+}
+
+void ThumbnailCache::run()
+{
+    QMutexLocker locker(&mMutex);
+    while (!mCache.isEmpty()) {
+        Cache::ConstIterator it = mCache.constBegin();
+        const QString path = it.key();
+        const QImage image = it.value();
+
+        // This part of the thread is the most time consuming but it does not
+        // depend on mCache so we can unlock here. This way other thumbnails
+        // can be added or queried
+        locker.unlock();
+        storeThumbnailToDiskCache(path, image);
+        locker.relock();
+
+        mCache.remove(path);
+    }
+}
+
+QImage ThumbnailCache::value(const QString& path) const
+{
+    QMutexLocker locker(&mMutex);
+    return mCache.value(path);
+}
+
+bool ThumbnailCache::isEmpty() const
+{
+    QMutexLocker locker(&mMutex);
+    return mCache.isEmpty();
+}
 
 //------------------------------------------------------------------------
 //
@@ -151,166 +154,169 @@
 : mCancel(false) {}
 
 void ThumbnailThread::load(
-	const QString& originalUri, time_t originalTime, int originalSize, const QString& originalMimeType,
-	const QString& pixPath,
-	const QString& thumbnailPath,
-	ThumbnailGroup::Enum group)
-{
-	QMutexLocker lock( &mMutex );
-	assert( mPixPath.isNull());
-
-	mOriginalUri = originalUri;
-	mOriginalTime = originalTime;
-	mOriginalSize = originalSize;
-	mOriginalMimeType = originalMimeType;
-	mPixPath = pixPath;
-	mThumbnailPath = thumbnailPath;
-	mThumbnailGroup = group;
-	if(!isRunning()) start();
-	mCond.wakeOne();
-}
-
-bool ThumbnailThread::testCancel() {
-	QMutexLocker lock( &mMutex );
-	return mCancel;
-}
-
-void ThumbnailThread::cancel() {
-	QMutexLocker lock( &mMutex );
-	mCancel = true;
-	mCond.wakeOne();
-}
-
-void ThumbnailThread::run() {
-	LOG("");
-	while( !testCancel()) {
-		{
-			QMutexLocker lock(&mMutex);
-			// empty mPixPath means nothing to do
-			LOG("Waiting for mPixPath");
-			if (mPixPath.isNull()) {
-				LOG("mPixPath.isNull");
-				mCond.wait(&mMutex);
-			}
-		}
-		if(testCancel()) {
-			return;
-		}
-		{
-			QMutexLocker lock(&mMutex);
-			Q_ASSERT(!mPixPath.isNull());
-			LOG("Loading" << mPixPath);
-			bool needCaching;
-			bool ok = loadThumbnail(&needCaching);
-			if (ok && needCaching) {
-				cacheThumbnail();
-			}
-			mPixPath.clear(); // done, ready for next
-		}
-		if(testCancel()) {
-			return;
-		}
-		{
-			QSize size(mOriginalWidth, mOriginalHeight);
-			LOG("emitting done signal, size=" << size);
-			QMutexLocker lock(&mMutex);
-			done(mImage, size);
-			LOG("Done");
-		}
-	}
-	LOG("Ending thread");
-}
-
-bool ThumbnailThread::loadThumbnail(bool* needCaching) {
-	mImage = QImage();
-	*needCaching = true;
-	int pixelSize = ThumbnailGroup::pixelSize(mThumbnailGroup);
-	Orientation orientation = NORMAL;
-
-	QImageReader reader(mPixPath);
-	// If it's a Jpeg, try to load an embedded thumbnail, if available
-	if (reader.format() == "jpeg") {
-		JpegContent content;
-		content.load(mPixPath);
-		QImage thumbnail = content.thumbnail();
-		orientation = content.orientation();
-
-		if (qMax(thumbnail.width(), thumbnail.height()) >= pixelSize) {
-			mImage = thumbnail;
-			if (orientation != NORMAL && orientation != NOT_AVAILABLE) {
-				QMatrix matrix = ImageUtils::transformMatrix(orientation);
-				mImage = mImage.transformed(matrix);
-			}
-			mOriginalWidth = content.size().width();
-			mOriginalHeight = content.size().height();
-			return true;
-		}
-	}
-
-	// Generate thumbnail from full image
-	QSize originalSize = reader.size();
-	if (originalSize.isValid() && reader.supportsOption(QImageIOHandler::ScaledSize)) {
-		int scale;
-		const int maxSize = qMax(originalSize.width(), originalSize.height());
-		for (scale=1; pixelSize*scale*2 <= maxSize && scale <= 8; scale *= 2) {}
-		const QSize scaledSize = originalSize / scale;
-		if (!scaledSize.isEmpty()) {
-			reader.setScaledSize(scaledSize);
-		}
-	}
-
-	QImage originalImage;
-	// format() is empty after QImageReader::read() is called
-	QByteArray format = reader.format();
-	if (!reader.read(&originalImage)) {
-		kWarning() << "Could not generate thumbnail for file" << mOriginalUri;
-		return false;
-	}
-	if (!originalSize.isValid()) {
-		originalSize = originalImage.size();
-	}
-	mOriginalWidth = originalSize.width();
-	mOriginalHeight = originalSize.height();
-
-	if (qMax(mOriginalWidth, mOriginalHeight)<=pixelSize) {
-		mImage = originalImage;
-		*needCaching = format != "png";
-	} else {
-		mImage = originalImage.scaled(pixelSize, pixelSize, Qt::KeepAspectRatio);
-	}
-
-	// Rotate if necessary
-	if (orientation != NORMAL && orientation != NOT_AVAILABLE) {
-		QMatrix matrix = ImageUtils::transformMatrix(orientation);
-		mImage = mImage.transformed(matrix);
-
-		switch (orientation) {
-		case TRANSPOSE:
-		case ROT_90:
-		case TRANSVERSE:
-		case ROT_270:
-			qSwap(mOriginalWidth, mOriginalHeight);
-			break;
-		default:
-			break;
-		}
-	}
-	return true;
-}
-
-
-void ThumbnailThread::cacheThumbnail() {
-	mImage.setText("Thumb::Uri"          , 0, mOriginalUri);
-	mImage.setText("Thumb::MTime"        , 0, QString::number(mOriginalTime));
-	mImage.setText("Thumb::Size"         , 0, QString::number(mOriginalSize));
-	mImage.setText("Thumb::Mimetype"     , 0, mOriginalMimeType);
-	mImage.setText("Thumb::Image::Width" , 0, QString::number(mOriginalWidth));
-	mImage.setText("Thumb::Image::Height", 0, QString::number(mOriginalHeight));
-	mImage.setText("Software"            , 0, "Gwenview");
-
-	emit thumbnailReadyToBeCached(mThumbnailPath, mImage);
-}
-
+    const QString& originalUri, time_t originalTime, int originalSize, const QString& originalMimeType,
+    const QString& pixPath,
+    const QString& thumbnailPath,
+    ThumbnailGroup::Enum group)
+{
+    QMutexLocker lock(&mMutex);
+    assert(mPixPath.isNull());
+
+    mOriginalUri = originalUri;
+    mOriginalTime = originalTime;
+    mOriginalSize = originalSize;
+    mOriginalMimeType = originalMimeType;
+    mPixPath = pixPath;
+    mThumbnailPath = thumbnailPath;
+    mThumbnailGroup = group;
+    if (!isRunning()) start();
+    mCond.wakeOne();
+}
+
+bool ThumbnailThread::testCancel()
+{
+    QMutexLocker lock(&mMutex);
+    return mCancel;
+}
+
+void ThumbnailThread::cancel()
+{
+    QMutexLocker lock(&mMutex);
+    mCancel = true;
+    mCond.wakeOne();
+}
+
+void ThumbnailThread::run()
+{
+    LOG("");
+    while (!testCancel()) {
+        {
+            QMutexLocker lock(&mMutex);
+            // empty mPixPath means nothing to do
+            LOG("Waiting for mPixPath");
+            if (mPixPath.isNull()) {
+                LOG("mPixPath.isNull");
+                mCond.wait(&mMutex);
+            }
+        }
+        if (testCancel()) {
+            return;
+        }
+        {
+            QMutexLocker lock(&mMutex);
+            Q_ASSERT(!mPixPath.isNull());
+            LOG("Loading" << mPixPath);
+            bool needCaching;
+            bool ok = loadThumbnail(&needCaching);
+            if (ok && needCaching) {
+                cacheThumbnail();
+            }
+            mPixPath.clear(); // done, ready for next
+        }
+        if (testCancel()) {
+            return;
+        }
+        {
+            QSize size(mOriginalWidth, mOriginalHeight);
+            LOG("emitting done signal, size=" << size);
+            QMutexLocker lock(&mMutex);
+            done(mImage, size);
+            LOG("Done");
+        }
+    }
+    LOG("Ending thread");
+}
+
+bool ThumbnailThread::loadThumbnail(bool* needCaching)
+{
+    mImage = QImage();
+    *needCaching = true;
+    int pixelSize = ThumbnailGroup::pixelSize(mThumbnailGroup);
+    Orientation orientation = NORMAL;
+
+    QImageReader reader(mPixPath);
+    // If it's a Jpeg, try to load an embedded thumbnail, if available
+    if (reader.format() == "jpeg") {
+        JpegContent content;
+        content.load(mPixPath);
+        QImage thumbnail = content.thumbnail();
+        orientation = content.orientation();
+
+        if (qMax(thumbnail.width(), thumbnail.height()) >= pixelSize) {
+            mImage = thumbnail;
+            if (orientation != NORMAL && orientation != NOT_AVAILABLE) {
+                QMatrix matrix = ImageUtils::transformMatrix(orientation);
+                mImage = mImage.transformed(matrix);
+            }
+            mOriginalWidth = content.size().width();
+            mOriginalHeight = content.size().height();
+            return true;
+        }
+    }
+
+    // Generate thumbnail from full image
+    QSize originalSize = reader.size();
+    if (originalSize.isValid() && reader.supportsOption(QImageIOHandler::ScaledSize)) {
+        int scale;
+        const int maxSize = qMax(originalSize.width(), originalSize.height());
+        for (scale = 1; pixelSize*scale * 2 <= maxSize && scale <= 8; scale *= 2) {}
+        const QSize scaledSize = originalSize / scale;
+        if (!scaledSize.isEmpty()) {
+            reader.setScaledSize(scaledSize);
+        }
+    }
+
+    QImage originalImage;
+    // format() is empty after QImageReader::read() is called
+    QByteArray format = reader.format();
+    if (!reader.read(&originalImage)) {
+        kWarning() << "Could not generate thumbnail for file" << mOriginalUri;
+        return false;
+    }
+    if (!originalSize.isValid()) {
+        originalSize = originalImage.size();
+    }
+    mOriginalWidth = originalSize.width();
+    mOriginalHeight = originalSize.height();
+
+    if (qMax(mOriginalWidth, mOriginalHeight) <= pixelSize) {
+        mImage = originalImage;
+        *needCaching = format != "png";
+    } else {
+        mImage = originalImage.scaled(pixelSize, pixelSize, Qt::KeepAspectRatio);
+    }
+
+    // Rotate if necessary
+    if (orientation != NORMAL && orientation != NOT_AVAILABLE) {
+        QMatrix matrix = ImageUtils::transformMatrix(orientation);
+        mImage = mImage.transformed(matrix);
+
+        switch (orientation) {
+        case TRANSPOSE:
+        case ROT_90:
+        case TRANSVERSE:
+        case ROT_270:
+            qSwap(mOriginalWidth, mOriginalHeight);
+            break;
+        default:
+            break;
+        }
+    }
+    return true;
+}
+
+void ThumbnailThread::cacheThumbnail()
+{
+    mImage.setText("Thumb::Uri"          , 0, mOriginalUri);
+    mImage.setText("Thumb::MTime"        , 0, QString::number(mOriginalTime));
+    mImage.setText("Thumb::Size"         , 0, QString::number(mOriginalSize));
+    mImage.setText("Thumb::Mimetype"     , 0, mOriginalMimeType);
+    mImage.setText("Thumb::Image::Width" , 0, QString::number(mOriginalWidth));
+    mImage.setText("Thumb::Image::Height", 0, QString::number(mOriginalHeight));
+    mImage.setText("Software"            , 0, "Gwenview");
+
+    emit thumbnailReadyToBeCached(mThumbnailPath, mImage);
+}
 
 //------------------------------------------------------------------------
 //
@@ -318,59 +324,60 @@
 //
 //------------------------------------------------------------------------
 static QString sThumbnailBaseDir;
-QString ThumbnailLoadJob::thumbnailBaseDir() {
-	if (sThumbnailBaseDir.isEmpty()) {
-		sThumbnailBaseDir = QDir::homePath() + "/.thumbnails/";
-	}
-	return sThumbnailBaseDir;
-}
-
-
-void ThumbnailLoadJob::setThumbnailBaseDir(const QString& dir) {
-	sThumbnailBaseDir = dir;
-}
-
-
-QString ThumbnailLoadJob::thumbnailBaseDir(ThumbnailGroup::Enum group) {
-	QString dir = thumbnailBaseDir();
-	switch (group) {
-	case ThumbnailGroup::Normal:
-		dir += "normal/";
-		break;
-	case ThumbnailGroup::Large:
-		dir += "large/";
-		break;
-	}
-	return dir;
-}
-
-
-void ThumbnailLoadJob::deleteImageThumbnail(const KUrl& url) {
-	QString uri=generateOriginalUri(url);
-	QFile::remove(generateThumbnailPath(uri, ThumbnailGroup::Normal));
-	QFile::remove(generateThumbnailPath(uri, ThumbnailGroup::Large));
-}
-
-
-static void moveThumbnailHelper(const QString& oldUri, const QString& newUri, ThumbnailGroup::Enum group) {
-	QString oldPath = generateThumbnailPath(oldUri, group);
-	QString newPath = generateThumbnailPath(newUri, group);
-	QImage thumb;
-	if (!thumb.load(oldPath)) {
-		return;
-	}
-	thumb.setText("Thumb::Uri", 0, newUri);
-	thumb.save(newPath, "png");
-	QFile::remove(QFile::encodeName(oldPath));
-}
-
-void ThumbnailLoadJob::moveThumbnail(const KUrl& oldUrl, const KUrl& newUrl) {
-	QString oldUri = generateOriginalUri(oldUrl);
-	QString newUri = generateOriginalUri(newUrl);
-	moveThumbnailHelper(oldUri, newUri, ThumbnailGroup::Normal);
-	moveThumbnailHelper(oldUri, newUri, ThumbnailGroup::Large);
-}
-
+QString ThumbnailLoadJob::thumbnailBaseDir()
+{
+    if (sThumbnailBaseDir.isEmpty()) {
+        sThumbnailBaseDir = QDir::homePath() + "/.thumbnails/";
+    }
+    return sThumbnailBaseDir;
+}
+
+void ThumbnailLoadJob::setThumbnailBaseDir(const QString& dir)
+{
+    sThumbnailBaseDir = dir;
+}
+
+QString ThumbnailLoadJob::thumbnailBaseDir(ThumbnailGroup::Enum group)
+{
+    QString dir = thumbnailBaseDir();
+    switch (group) {
+    case ThumbnailGroup::Normal:
+        dir += "normal/";
+        break;
+    case ThumbnailGroup::Large:
+        dir += "large/";
+        break;
+    }
+    return dir;
+}
+
+void ThumbnailLoadJob::deleteImageThumbnail(const KUrl& url)
+{
+    QString uri = generateOriginalUri(url);
+    QFile::remove(generateThumbnailPath(uri, ThumbnailGroup::Normal));
+    QFile::remove(generateThumbnailPath(uri, ThumbnailGroup::Large));
+}
+
+static void moveThumbnailHelper(const QString& oldUri, const QString& newUri, ThumbnailGroup::Enum group)
+{
+    QString oldPath = generateThumbnailPath(oldUri, group);
+    QString newPath = generateThumbnailPath(newUri, group);
+    QImage thumb;
+    if (!thumb.load(oldPath)) {
+        return;
+    }
+    thumb.setText("Thumb::Uri", 0, newUri);
+    thumb.save(newPath, "png");
+    QFile::remove(QFile::encodeName(oldPath));
+}
+
+void ThumbnailLoadJob::moveThumbnail(const KUrl& oldUrl, const KUrl& newUrl)
+{
+    QString oldUri = generateOriginalUri(oldUrl);
+    QString newUri = generateOriginalUri(newUrl);
+    moveThumbnailHelper(oldUri, newUri, ThumbnailGroup::Normal);
+    moveThumbnailHelper(oldUri, newUri, ThumbnailGroup::Large);
+}
 
 //------------------------------------------------------------------------
 //
@@ -379,334 +386,337 @@
 //------------------------------------------------------------------------
 ThumbnailLoadJob::ThumbnailLoadJob(const KFileItemList& items, ThumbnailGroup::Enum group)
 : KIO::Job()
-, mState( STATE_NEXTTHUMB )
+, mState(STATE_NEXTTHUMB)
 , mThumbnailGroup(group)
 {
-	LOG(this);
-
-	// Make sure we have a place to store our thumbnails
-	QString thumbnailDir = ThumbnailLoadJob::thumbnailBaseDir(mThumbnailGroup);
-	KStandardDirs::makeDir(thumbnailDir, 0700);
-
-	// Look for images and store the items in our todo list
-	Q_ASSERT(!items.empty());
-	mItems = items;
-	mCurrentItem = KFileItem();
-
-	connect(&mThumbnailThread, SIGNAL(done(const QImage&, const QSize&)),
-		SLOT(thumbnailReady(const QImage&, const QSize&)),
-		Qt::QueuedConnection);
-
-	connect(&mThumbnailThread, SIGNAL(thumbnailReadyToBeCached(const QString&, const QImage&)),
-		sThumbnailCache, SLOT(queueThumbnail(const QString&, const QImage&)),
-		Qt::QueuedConnection);
-}
-
-
-ThumbnailLoadJob::~ThumbnailLoadJob() {
-	LOG(this);
-	if (hasSubjobs()) {
-		LOG("Killing subjob");
-		KJob* job = subjobs().first();
-		job->kill();
-		removeSubjob(job);
-	}
-	mThumbnailThread.cancel();
-	mThumbnailThread.wait();
-	if (!sThumbnailCache->isRunning()) {
-		sThumbnailCache->start();
-	}
-}
-
-
-void ThumbnailLoadJob::start() {
-	if (mItems.isEmpty()) {
-		LOG("Nothing to do");
-		emitResult();
-		delete this;
-		return;
-	}
-
-	determineNextIcon();
-}
-
-
-const KFileItemList& ThumbnailLoadJob::pendingItems() const {
-	return mItems;
-}
-
-
-void ThumbnailLoadJob::setThumbnailGroup(ThumbnailGroup::Enum group) {
-	mThumbnailGroup = group;
-}
-
+    LOG(this);
+
+    // Make sure we have a place to store our thumbnails
+    QString thumbnailDir = ThumbnailLoadJob::thumbnailBaseDir(mThumbnailGroup);
+    KStandardDirs::makeDir(thumbnailDir, 0700);
+
+    // Look for images and store the items in our todo list
+    Q_ASSERT(!items.empty());
+    mItems = items;
+    mCurrentItem = KFileItem();
+
+    connect(&mThumbnailThread, SIGNAL(done(QImage, QSize)),
+            SLOT(thumbnailReady(QImage, QSize)),
+            Qt::QueuedConnection);
+
+    connect(&mThumbnailThread, SIGNAL(thumbnailReadyToBeCached(QString, QImage)),
+            sThumbnailCache, SLOT(queueThumbnail(QString, QImage)),
+            Qt::QueuedConnection);
+}
+
+ThumbnailLoadJob::~ThumbnailLoadJob()
+{
+    LOG(this);
+    if (hasSubjobs()) {
+        LOG("Killing subjob");
+        KJob* job = subjobs().first();
+        job->kill();
+        removeSubjob(job);
+    }
+    mThumbnailThread.cancel();
+    mThumbnailThread.wait();
+    if (!sThumbnailCache->isRunning()) {
+        sThumbnailCache->start();
+    }
+}
+
+void ThumbnailLoadJob::start()
+{
+    if (mItems.isEmpty()) {
+        LOG("Nothing to do");
+        emitResult();
+        delete this;
+        return;
+    }
+
+    determineNextIcon();
+}
+
+const KFileItemList& ThumbnailLoadJob::pendingItems() const
+{
+    return mItems;
+}
+
+void ThumbnailLoadJob::setThumbnailGroup(ThumbnailGroup::Enum group)
+{
+    mThumbnailGroup = group;
+}
 
 //-Internal--------------------------------------------------------------
-void ThumbnailLoadJob::appendItem(const KFileItem& item) {
-	if (!mItems.contains(item)) {
-		mItems.append(item);
-	}
-}
-
-
-void ThumbnailLoadJob::removeItems(const KFileItemList& itemList) {
-	Q_FOREACH(const KFileItem& item, itemList) {
-		// If we are removing the next item, update to be the item after or the
-		// first if we removed the last item
-		mItems.removeAll( item );
-
-		if (item == mCurrentItem) {
-			// Abort current item
-			mCurrentItem = KFileItem();
-			if (hasSubjobs()) {
-				KJob* job = subjobs().first();
-				job->kill();
-				removeSubjob(job);
-			}
-		}
-	}
-
-	// No more current item, carry on to the next remaining item
-	if (mCurrentItem.isNull()) {
-		determineNextIcon();
-	}
-}
-
-
-void ThumbnailLoadJob::determineNextIcon() {
-	LOG(this);
-	mState = STATE_NEXTTHUMB;
-
-	// No more items ?
-	if (mItems.isEmpty()) {
-		// Done
-		LOG("emitting result");
-		emitResult();
-		delete this;
-		return;
-	}
-
-	mCurrentItem = mItems.first();
-	mItems.pop_front();
-	LOG("mCurrentItem.url=" << mCurrentItem.url());
-
-	// First, stat the orig file
-	mState = STATE_STATORIG;
-	mCurrentUrl = mCurrentItem.url();
-	mCurrentUrl.cleanPath();
-
-	// Do direct stat instead of using KIO if the file is local (faster)
-	bool directStatOk = false;
-	if (UrlUtils::urlIsFastLocalFile(mCurrentUrl)) {
-		KDE_struct_stat buff;
-		if ( KDE::stat( mCurrentUrl.toLocalFile(), &buff ) == 0 )  {
-			directStatOk = true;
-			mOriginalTime = buff.st_mtime;
-			QTimer::singleShot( 0, this, SLOT( checkThumbnail()));
-		}
-	}
-	if (!directStatOk) {
-		KIO::Job* job = KIO::stat(mCurrentUrl, KIO::HideProgressInfo);
-		job->ui()->setWindow(KApplication::kApplication()->activeWindow());
-		LOG( "KIO::stat orig" << mCurrentUrl.url() );
-		addSubjob(job);
-	}
-	LOG("/determineNextIcon" << this);
-}
-
-
-void ThumbnailLoadJob::slotResult(KJob * job) {
-	LOG(mState);
-	removeSubjob(job);
-	Q_ASSERT(subjobs().isEmpty()); // We should have only one job at a time
-
-	switch (mState) {
-	case STATE_NEXTTHUMB:
-		Q_ASSERT(false);
-		determineNextIcon();
-		return;
-
-	case STATE_STATORIG: {
-		// Could not stat original, drop this one and move on to the next one
-		if (job->error()) {
-			emitThumbnailLoadingFailed();
-			determineNextIcon();
-			return;
-		}
-
-		// Get modification time of the original file
-		KIO::UDSEntry entry = static_cast<KIO::StatJob*>(job)->statResult();
-		mOriginalTime = entry.numberValue(KIO::UDSEntry::UDS_MODIFICATION_TIME, -1);
-		checkThumbnail();
-		return;
-	}
-
-	case STATE_DOWNLOADORIG:
-		if (job->error()) {
-			emitThumbnailLoadingFailed();
-			LOG("Delete temp file" << mTempPath);
-			QFile::remove(mTempPath);
-			mTempPath.clear();
-			determineNextIcon();
-		} else {
-			startCreatingThumbnail(mTempPath);
-		}
-		return;
-
-	case STATE_PREVIEWJOB:
-		determineNextIcon();
-		return;
-	}
-}
-
-
-void ThumbnailLoadJob::thumbnailReady( const QImage& _img, const QSize& _size) {
-	QImage img = _img;
-	QSize size = _size;
-	if ( !img.isNull()) {
-		emitThumbnailLoaded(img, size);
-	} else {
-		emitThumbnailLoadingFailed();
-	}
-	if( !mTempPath.isEmpty()) {
-		LOG("Delete temp file" << mTempPath);
-		QFile::remove(mTempPath);
-		mTempPath.clear();
-	}
-	determineNextIcon();
-}
-
-QImage ThumbnailLoadJob::loadThumbnailFromCache() const {
-	QImage image = sThumbnailCache->value(mThumbnailPath);
-	if (!image.isNull()) {
-		return image;
-	}
-	return QImage(mThumbnailPath);
-}
-
-void ThumbnailLoadJob::checkThumbnail() {
-	// If we are in the thumbnail dir, just load the file
-	if (mCurrentUrl.isLocalFile()
-		&& mCurrentUrl.directory().startsWith(thumbnailBaseDir()) )
-	{
-		QImage image(mCurrentUrl.toLocalFile());
-		emitThumbnailLoaded(image, image.size());
-		determineNextIcon();
-		return;
-	}
-	QSize imagesize;
-
-	mOriginalUri=generateOriginalUri(mCurrentUrl);
-	mThumbnailPath=generateThumbnailPath(mOriginalUri, mThumbnailGroup);
-
-	LOG("Stat thumb" << mThumbnailPath);
-
-	QImage thumb = loadThumbnailFromCache();
-	if (!thumb.isNull()) {
-		if (thumb.text("Thumb::Uri", 0) == mOriginalUri &&
-			thumb.text("Thumb::MTime", 0).toInt() == mOriginalTime )
-		{
-			int width=0, height=0;
-			QSize size;
-			bool ok;
-
-			width=thumb.text("Thumb::Image::Width", 0).toInt(&ok);
-			if (ok) height=thumb.text("Thumb::Image::Height", 0).toInt(&ok);
-			if (ok) {
-				size=QSize(width, height);
-			} else {
-				LOG("Thumbnail for" << mOriginalUri << "does not contain correct image size information");
-				KFileMetaInfo fmi(mCurrentUrl);
-				if (fmi.isValid()) {
-					KFileMetaInfoItem item=fmi.item("Dimensions");
-					if (item.isValid()) {
-						size=item.value().toSize();
-					} else {
-						LOG("KFileMetaInfoItem for" << mOriginalUri << "did not get image size information");
-					}
-				} else {
-					LOG("Could not get a valid KFileMetaInfo instance for" << mOriginalUri);
-				}
-			}
-			emitThumbnailLoaded(thumb, size);
-			determineNextIcon();
-			return;
-		}
-	}
-
-	// Thumbnail not found or not valid
-	if (MimeTypeUtils::fileItemKind(mCurrentItem) == MimeTypeUtils::KIND_RASTER_IMAGE) {
-		if (mCurrentUrl.isLocalFile()) {
-			// Original is a local file, create the thumbnail
-			startCreatingThumbnail(mCurrentUrl.toLocalFile());
-		} else {
-			// Original is remote, download it
-			mState=STATE_DOWNLOADORIG;
-			
-			KTemporaryFile tempFile;
-			tempFile.setAutoRemove(false);
-			if (!tempFile.open()) {
-				kWarning() << "Couldn't create temp file to download " << mCurrentUrl.prettyUrl();
-				emitThumbnailLoadingFailed();
-				determineNextIcon();
-				return;
-			}
-			mTempPath = tempFile.fileName();
-
-			KUrl url;
-			url.setPath(mTempPath);
-			KIO::Job* job=KIO::file_copy(mCurrentUrl, url,-1, KIO::Overwrite | KIO::HideProgressInfo);
-			job->ui()->setWindow(KApplication::kApplication()->activeWindow());
-			LOG("Download remote file" << mCurrentUrl.prettyUrl() << "to" << url.pathOrUrl());
-			addSubjob(job);
-		}
-	} else {
-		// Not a raster image, use a KPreviewJob
-		LOG("Starting a KPreviewJob for" << mCurrentItem.url());
-		mState=STATE_PREVIEWJOB;
-		KFileItemList list;
-		list.append(mCurrentItem);
-		const int pixelSize = ThumbnailGroup::pixelSize(mThumbnailGroup);
-		KIO::Job* job = KIO::filePreview(list, QSize(pixelSize, pixelSize));
-		//job->ui()->setWindow(KApplication::kApplication()->activeWindow());
-		connect(job, SIGNAL(gotPreview(const KFileItem&, const QPixmap&)),
-			this, SLOT(slotGotPreview(const KFileItem&, const QPixmap&)) );
-		connect(job, SIGNAL(failed(const KFileItem&)),
-			this, SLOT(emitThumbnailLoadingFailed()) );
-		addSubjob(job);
-	}
-}
-
-void ThumbnailLoadJob::startCreatingThumbnail(const QString& pixPath) {
-	LOG("Creating thumbnail from" << pixPath);
-	mThumbnailThread.load( mOriginalUri, mOriginalTime, mCurrentItem.size(),
-		mCurrentItem.mimetype(), pixPath, mThumbnailPath, mThumbnailGroup);
-}
-
-
-void ThumbnailLoadJob::slotGotPreview(const KFileItem& item, const QPixmap& pixmap) {
-	LOG(mCurrentItem.url());
-	QSize size;
-	emit thumbnailLoaded(item, pixmap, size);
-}
-
-
-void ThumbnailLoadJob::emitThumbnailLoaded(const QImage& img, const QSize& size) {
-	LOG(mCurrentItem.url());
-	QPixmap thumb = QPixmap::fromImage(img);
-	emit thumbnailLoaded(mCurrentItem, thumb, size);
-}
-
-
-void ThumbnailLoadJob::emitThumbnailLoadingFailed() {
-	LOG(mCurrentItem.url());
-	emit thumbnailLoadingFailed(mCurrentItem);
-}
-
-
-bool ThumbnailLoadJob::isPendingThumbnailCacheEmpty() {
-	return sThumbnailCache->isEmpty();
-}
-
+void ThumbnailLoadJob::appendItem(const KFileItem& item)
+{
+    if (!mItems.contains(item)) {
+        mItems.append(item);
+    }
+}
+
+void ThumbnailLoadJob::removeItems(const KFileItemList& itemList)
+{
+    Q_FOREACH(const KFileItem & item, itemList) {
+        // If we are removing the next item, update to be the item after or the
+        // first if we removed the last item
+        mItems.removeAll(item);
+
+        if (item == mCurrentItem) {
+            // Abort current item
+            mCurrentItem = KFileItem();
+            if (hasSubjobs()) {
+                KJob* job = subjobs().first();
+                job->kill();
+                removeSubjob(job);
+            }
+        }
+    }
+
+    // No more current item, carry on to the next remaining item
+    if (mCurrentItem.isNull()) {
+        determineNextIcon();
+    }
+}
+
+void ThumbnailLoadJob::determineNextIcon()
+{
+    LOG(this);
+    mState = STATE_NEXTTHUMB;
+
+    // No more items ?
+    if (mItems.isEmpty()) {
+        // Done
+        LOG("emitting result");
+        emitResult();
+        delete this;
+        return;
+    }
+
+    mCurrentItem = mItems.first();
+    mItems.pop_front();
+    LOG("mCurrentItem.url=" << mCurrentItem.url());
+
+    // First, stat the orig file
+    mState = STATE_STATORIG;
+    mCurrentUrl = mCurrentItem.url();
+    mCurrentUrl.cleanPath();
+
+    // Do direct stat instead of using KIO if the file is local (faster)
+    bool directStatOk = false;
+    if (UrlUtils::urlIsFastLocalFile(mCurrentUrl)) {
+        KDE_struct_stat buff;
+        if (KDE::stat(mCurrentUrl.toLocalFile(), &buff) == 0)  {
+            directStatOk = true;
+            mOriginalTime = buff.st_mtime;
+            QTimer::singleShot(0, this, SLOT(checkThumbnail()));
+        }
+    }
+    if (!directStatOk) {
+        KIO::Job* job = KIO::stat(mCurrentUrl, KIO::HideProgressInfo);
+        job->ui()->setWindow(KApplication::kApplication()->activeWindow());
+        LOG("KIO::stat orig" << mCurrentUrl.url());
+        addSubjob(job);
+    }
+    LOG("/determineNextIcon" << this);
+}
+
+void ThumbnailLoadJob::slotResult(KJob * job)
+{
+    LOG(mState);
+    removeSubjob(job);
+    Q_ASSERT(subjobs().isEmpty()); // We should have only one job at a time
+
+    switch (mState) {
+    case STATE_NEXTTHUMB:
+        Q_ASSERT(false);
+        determineNextIcon();
+        return;
+
+    case STATE_STATORIG: {
+        // Could not stat original, drop this one and move on to the next one
+        if (job->error()) {
+            emitThumbnailLoadingFailed();
+            determineNextIcon();
+            return;
+        }
+
+        // Get modification time of the original file
+        KIO::UDSEntry entry = static_cast<KIO::StatJob*>(job)->statResult();
+        mOriginalTime = entry.numberValue(KIO::UDSEntry::UDS_MODIFICATION_TIME, -1);
+        checkThumbnail();
+        return;
+    }
+
+    case STATE_DOWNLOADORIG:
+        if (job->error()) {
+            emitThumbnailLoadingFailed();
+            LOG("Delete temp file" << mTempPath);
+            QFile::remove(mTempPath);
+            mTempPath.clear();
+            determineNextIcon();
+        } else {
+            startCreatingThumbnail(mTempPath);
+        }
+        return;
+
+    case STATE_PREVIEWJOB:
+        determineNextIcon();
+        return;
+    }
+}
+
+void ThumbnailLoadJob::thumbnailReady(const QImage& _img, const QSize& _size)
+{
+    QImage img = _img;
+    QSize size = _size;
+    if (!img.isNull()) {
+        emitThumbnailLoaded(img, size);
+    } else {
+        emitThumbnailLoadingFailed();
+    }
+    if (!mTempPath.isEmpty()) {
+        LOG("Delete temp file" << mTempPath);
+        QFile::remove(mTempPath);
+        mTempPath.clear();
+    }
+    determineNextIcon();
+}
+
+QImage ThumbnailLoadJob::loadThumbnailFromCache() const
+{
+    QImage image = sThumbnailCache->value(mThumbnailPath);
+    if (!image.isNull()) {
+        return image;
+    }
+    return QImage(mThumbnailPath);
+}
+
+void ThumbnailLoadJob::checkThumbnail()
+{
+    // If we are in the thumbnail dir, just load the file
+    if (mCurrentUrl.isLocalFile()
+            && mCurrentUrl.directory().startsWith(thumbnailBaseDir())) {
+        QImage image(mCurrentUrl.toLocalFile());
+        emitThumbnailLoaded(image, image.size());
+        determineNextIcon();
+        return;
+    }
+    QSize imagesize;
+
+    mOriginalUri = generateOriginalUri(mCurrentUrl);
+    mThumbnailPath = generateThumbnailPath(mOriginalUri, mThumbnailGroup);
+
+    LOG("Stat thumb" << mThumbnailPath);
+
+    QImage thumb = loadThumbnailFromCache();
+    if (!thumb.isNull()) {
+        if (thumb.text("Thumb::Uri", 0) == mOriginalUri &&
+                thumb.text("Thumb::MTime", 0).toInt() == mOriginalTime) {
+            int width = 0, height = 0;
+            QSize size;
+            bool ok;
+
+            width = thumb.text("Thumb::Image::Width", 0).toInt(&ok);
+            if (ok) height = thumb.text("Thumb::Image::Height", 0).toInt(&ok);
+            if (ok) {
+                size = QSize(width, height);
+            } else {
+                LOG("Thumbnail for" << mOriginalUri << "does not contain correct image size information");
+                KFileMetaInfo fmi(mCurrentUrl);
+                if (fmi.isValid()) {
+                    KFileMetaInfoItem item = fmi.item("Dimensions");
+                    if (item.isValid()) {
+                        size = item.value().toSize();
+                    } else {
+                        LOG("KFileMetaInfoItem for" << mOriginalUri << "did not get image size information");
+                    }
+                } else {
+                    LOG("Could not get a valid KFileMetaInfo instance for" << mOriginalUri);
+                }
+            }
+            emitThumbnailLoaded(thumb, size);
+            determineNextIcon();
+            return;
+        }
+    }
+
+    // Thumbnail not found or not valid
+    if (MimeTypeUtils::fileItemKind(mCurrentItem) == MimeTypeUtils::KIND_RASTER_IMAGE) {
+        if (mCurrentUrl.isLocalFile()) {
+            // Original is a local file, create the thumbnail
+            startCreatingThumbnail(mCurrentUrl.toLocalFile());
+        } else {
+            // Original is remote, download it
+            mState = STATE_DOWNLOADORIG;
+
+            KTemporaryFile tempFile;
+            tempFile.setAutoRemove(false);
+            if (!tempFile.open()) {
+                kWarning() << "Couldn't create temp file to download " << mCurrentUrl.prettyUrl();
+                emitThumbnailLoadingFailed();
+                determineNextIcon();
+                return;
+            }
+            mTempPath = tempFile.fileName();
+
+            KUrl url;
+            url.setPath(mTempPath);
+            KIO::Job* job = KIO::file_copy(mCurrentUrl, url, -1, KIO::Overwrite | KIO::HideProgressInfo);
+            job->ui()->setWindow(KApplication::kApplication()->activeWindow());
+            LOG("Download remote file" << mCurrentUrl.prettyUrl() << "to" << url.pathOrUrl());
+            addSubjob(job);
+        }
+    } else {
+        // Not a raster image, use a KPreviewJob
+        LOG("Starting a KPreviewJob for" << mCurrentItem.url());
+        mState = STATE_PREVIEWJOB;
+        KFileItemList list;
+        list.append(mCurrentItem);
+        const int pixelSize = ThumbnailGroup::pixelSize(mThumbnailGroup);
+        if (mPreviewPlugins.isEmpty()) {
+            mPreviewPlugins = KIO::PreviewJob::availablePlugins();
+        }
+        KIO::Job* job = KIO::filePreview(list, QSize(pixelSize, pixelSize), &mPreviewPlugins);
+        //job->ui()->setWindow(KApplication::kApplication()->activeWindow());
+        connect(job, SIGNAL(gotPreview(KFileItem, QPixmap)),
+                this, SLOT(slotGotPreview(KFileItem, QPixmap)));
+        connect(job, SIGNAL(failed(KFileItem)),
+                this, SLOT(emitThumbnailLoadingFailed()));
+        addSubjob(job);
+    }
+}
+
+void ThumbnailLoadJob::startCreatingThumbnail(const QString& pixPath)
+{
+    LOG("Creating thumbnail from" << pixPath);
+    mThumbnailThread.load(mOriginalUri, mOriginalTime, mCurrentItem.size(),
+                          mCurrentItem.mimetype(), pixPath, mThumbnailPath, mThumbnailGroup);
+}
+
+void ThumbnailLoadJob::slotGotPreview(const KFileItem& item, const QPixmap& pixmap)
+{
+    LOG(mCurrentItem.url());
+    QSize size;
+    emit thumbnailLoaded(item, pixmap, size);
+}
+
+void ThumbnailLoadJob::emitThumbnailLoaded(const QImage& img, const QSize& size)
+{
+    LOG(mCurrentItem.url());
+    QPixmap thumb = QPixmap::fromImage(img);
+    emit thumbnailLoaded(mCurrentItem, thumb, size);
+}
+
+void ThumbnailLoadJob::emitThumbnailLoadingFailed()
+{
+    LOG(mCurrentItem.url());
+    emit thumbnailLoadingFailed(mCurrentItem);
+}
+
+bool ThumbnailLoadJob::isPendingThumbnailCacheEmpty()
+{
+    return sThumbnailCache->isEmpty();
+}
 
 } // namespace

=== modified file 'lib/thumbnailloadjob.h'
--- lib/thumbnailloadjob.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailloadjob.h	2011-12-15 14:17:54 +0000
@@ -1,24 +1,24 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab
-/*	Gwenview - A simple image viewer for KDE
-	Copyright 2000-2004 Aurélien Gâteau <agateau@kde.org>
-	This class is based on the ImagePreviewJob class from Konqueror.
+// vim: set tabstop=4 shiftwidth=4 expandtab
+/*  Gwenview - A simple image viewer for KDE
+    Copyright 2000-2004 Aurélien Gâteau <agateau@kde.org>
+    This class is based on the ImagePreviewJob class from Konqueror.
 */
-/*	This file is part of the KDE project
-	Copyright (C) 2000 David Faure <faure@kde.org>
-
-	This program is free software; you can redistribute it and/or modify
-	it under the terms of the GNU General Public License as published by
-	the Free Software Foundation; either version 2 of the License, or
-	(at your option) any later version.
-
-	This program is distributed in the hope that it will be useful,
-	but WITHOUT ANY WARRANTY; without even the implied warranty of
-	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-	GNU General Public License for more details.
-
-	You should have received a copy of the GNU General Public License
-	along with this program; if not, write to the Free Software
-	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+/*  This file is part of the KDE project
+    Copyright (C) 2000 David Faure <faure@kde.org>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
 
 #ifndef THUMBNAILLOADJOB_H
@@ -40,190 +40,195 @@
 // Local
 #include <lib/thumbnailgroup.h>
 
-namespace Gwenview {
-class ThumbnailThread : public QThread {
-Q_OBJECT
+namespace Gwenview
+{
+class ThumbnailThread : public QThread
+{
+    Q_OBJECT
 public:
-	ThumbnailThread();
-
-	void load(
-		const QString& originalUri,
-		time_t originalTime,
-		int originalSize,
-		const QString& originalMimeType,
-		const QString& pixPath,
-		const QString& thumbnailPath,
-		ThumbnailGroup::Enum group);
-
-	void cancel();
+    ThumbnailThread();
+
+    void load(
+        const QString& originalUri,
+        time_t originalTime,
+        int originalSize,
+        const QString& originalMimeType,
+        const QString& pixPath,
+        const QString& thumbnailPath,
+        ThumbnailGroup::Enum group);
+
+    void cancel();
 
 protected:
-	virtual void run();
+    virtual void run();
 
 Q_SIGNALS:
-	void done( const QImage&, const QSize&);
-	void thumbnailReadyToBeCached(const QString& thumbnailPath, const QImage&);
+    void done(const QImage&, const QSize&);
+    void thumbnailReadyToBeCached(const QString& thumbnailPath, const QImage&);
 
 private:
-	bool testCancel();
-	bool loadThumbnail(bool* needCaching);
-	void cacheThumbnail();
-	QImage mImage;
-	QString mPixPath;
-	QString mThumbnailPath;
-	QString mOriginalUri;
-	time_t mOriginalTime;
-	int mOriginalSize;
-	QString mOriginalMimeType;
-	int mOriginalWidth;
-	int mOriginalHeight;
-	QMutex mMutex;
-	QWaitCondition mCond;
-	ThumbnailGroup::Enum mThumbnailGroup;
-	bool mCancel;
+    bool testCancel();
+    bool loadThumbnail(bool* needCaching);
+    void cacheThumbnail();
+    QImage mImage;
+    QString mPixPath;
+    QString mThumbnailPath;
+    QString mOriginalUri;
+    time_t mOriginalTime;
+    int mOriginalSize;
+    QString mOriginalMimeType;
+    int mOriginalWidth;
+    int mOriginalHeight;
+    QMutex mMutex;
+    QWaitCondition mCond;
+    ThumbnailGroup::Enum mThumbnailGroup;
+    bool mCancel;
 };
 
 /**
  * Store thumbnails to disk when done generating them
  */
-class ThumbnailCache : public QThread {
-Q_OBJECT
+class ThumbnailCache : public QThread
+{
+    Q_OBJECT
 public:
-	// Return thumbnail if it has still not been stored
-	QImage value(const QString&) const;
+    // Return thumbnail if it has still not been stored
+    QImage value(const QString&) const;
 
-	bool isEmpty() const;
+    bool isEmpty() const;
 
 public Q_SLOTS:
-	void queueThumbnail(const QString&, const QImage&);
+    void queueThumbnail(const QString&, const QImage&);
 
 protected:
-	void run();
+    void run();
 
 private:
-	typedef QHash<QString, QImage> Cache;
-	Cache mCache;
-	mutable QMutex mMutex;
+    typedef QHash<QString, QImage> Cache;
+    Cache mCache;
+    mutable QMutex mMutex;
 };
 
 /**
  * A job that determines the thumbnails for the images in the current directory
  */
-class GWENVIEWLIB_EXPORT ThumbnailLoadJob : public KIO::Job {
-Q_OBJECT
+class GWENVIEWLIB_EXPORT ThumbnailLoadJob : public KIO::Job
+{
+    Q_OBJECT
 public:
-	/**
-	 * Create a job for determining the pixmaps of the images in the @p itemList
-	 */
-	ThumbnailLoadJob(const KFileItemList& itemList, ThumbnailGroup::Enum);
-	virtual ~ThumbnailLoadJob();
-
-	/**
-	 * Call this to get started
-	 */
-	void start();
-
-	/**
-	 * To be called whenever items are removed from the view
-	 */
-	void removeItems(const KFileItemList& itemList);
-
-	/**
-	 * Returns the list of items waiting for a thumbnail
-	 */
-	const KFileItemList& pendingItems() const;
-
-	/**
-	 * Add an item to a running job
-	 */
-	void appendItem(const KFileItem& item);
-
-	/**
-	 * Defines size of thumbnails to generate
-	 */
-	void setThumbnailGroup(ThumbnailGroup::Enum);
-
-	/**
-	 * Returns the thumbnail base dir, independent of the thumbnail size
-	 */
-	static QString thumbnailBaseDir();
-
-	/**
-	 * Sets the thumbnail base dir, useful for unit-testing
-	 */
-	static void setThumbnailBaseDir(const QString&);
-
-	/**
-	 * Returns the thumbnail base dir, for the @p group
-	 */
-	static QString thumbnailBaseDir(ThumbnailGroup::Enum group);
-
-
-	/**
-	 * Delete the thumbnail for the @p url
-	 */
-	static void deleteImageThumbnail(const KUrl& url);
-
-	/**
-	 * Move a thumbnail to match a file move
-	 */
-	static void moveThumbnail(const KUrl& oldUrl, const KUrl& newUrl);
-
-	/**
-	 * Returns true if all thumbnails have been written to disk. Useful for
-	 * unit-testing.
-	 */
-	static bool isPendingThumbnailCacheEmpty();
+    /**
+     * Create a job for determining the pixmaps of the images in the @p itemList
+     */
+    ThumbnailLoadJob(const KFileItemList& itemList, ThumbnailGroup::Enum);
+    virtual ~ThumbnailLoadJob();
+
+    /**
+     * Call this to get started
+     */
+    void start();
+
+    /**
+     * To be called whenever items are removed from the view
+     */
+    void removeItems(const KFileItemList& itemList);
+
+    /**
+     * Returns the list of items waiting for a thumbnail
+     */
+    const KFileItemList& pendingItems() const;
+
+    /**
+     * Add an item to a running job
+     */
+    void appendItem(const KFileItem& item);
+
+    /**
+     * Defines size of thumbnails to generate
+     */
+    void setThumbnailGroup(ThumbnailGroup::Enum);
+
+    /**
+     * Returns the thumbnail base dir, independent of the thumbnail size
+     */
+    static QString thumbnailBaseDir();
+
+    /**
+     * Sets the thumbnail base dir, useful for unit-testing
+     */
+    static void setThumbnailBaseDir(const QString&);
+
+    /**
+     * Returns the thumbnail base dir, for the @p group
+     */
+    static QString thumbnailBaseDir(ThumbnailGroup::Enum group);
+
+    /**
+     * Delete the thumbnail for the @p url
+     */
+    static void deleteImageThumbnail(const KUrl& url);
+
+    /**
+     * Move a thumbnail to match a file move
+     */
+    static void moveThumbnail(const KUrl& oldUrl, const KUrl& newUrl);
+
+    /**
+     * Returns true if all thumbnails have been written to disk. Useful for
+     * unit-testing.
+     */
+    static bool isPendingThumbnailCacheEmpty();
 
 Q_SIGNALS:
-	/**
-	 * Emitted when the thumbnail for the @p item has been loaded
-	 */
-	void thumbnailLoaded(const KFileItem& item, const QPixmap&, const QSize&);
+    /**
+     * Emitted when the thumbnail for the @p item has been loaded
+     */
+    void thumbnailLoaded(const KFileItem& item, const QPixmap&, const QSize&);
 
-	void thumbnailLoadingFailed(const KFileItem& item);
+    void thumbnailLoadingFailed(const KFileItem& item);
 
 protected:
-	virtual void slotResult( KJob *job );
+    virtual void slotResult(KJob *job);
 
 private Q_SLOTS:
-	void slotGotPreview(const KFileItem&, const QPixmap&);
-	void checkThumbnail();
-	void thumbnailReady(const QImage& im, const QSize&);
-	void emitThumbnailLoadingFailed();
+    void slotGotPreview(const KFileItem&, const QPixmap&);
+    void checkThumbnail();
+    void thumbnailReady(const QImage& im, const QSize&);
+    void emitThumbnailLoadingFailed();
 
 private:
-	enum { STATE_STATORIG, STATE_DOWNLOADORIG, STATE_PREVIEWJOB, STATE_NEXTTHUMB } mState;
-
-	KFileItemList mItems;
-	KFileItem mCurrentItem;
-
-	// The Url of the current item (always equivalent to m_items.first()->item()->url())
-	KUrl mCurrentUrl;
-
-	// The Uri of the original image (might be different from mCurrentUrl.url())
-	QString mOriginalUri;
-
-	// The modification time of the original image
-	time_t mOriginalTime;
-
-	// The thumbnail path
-	QString mThumbnailPath;
-
-	// The temporary path for remote urls
-	QString mTempPath;
-
-	// Thumbnail group
-	ThumbnailGroup::Enum mThumbnailGroup;
-
-	ThumbnailThread mThumbnailThread;
-
-	void determineNextIcon();
-	void startCreatingThumbnail(const QString& path);
-
-	void emitThumbnailLoaded(const QImage& img, const QSize& size);
-
-	QImage loadThumbnailFromCache() const;
+    enum { STATE_STATORIG, STATE_DOWNLOADORIG, STATE_PREVIEWJOB, STATE_NEXTTHUMB } mState;
+
+    KFileItemList mItems;
+    KFileItem mCurrentItem;
+
+    // The Url of the current item (always equivalent to m_items.first()->item()->url())
+    KUrl mCurrentUrl;
+
+    // The Uri of the original image (might be different from mCurrentUrl.url())
+    QString mOriginalUri;
+
+    // The modification time of the original image
+    time_t mOriginalTime;
+
+    // The thumbnail path
+    QString mThumbnailPath;
+
+    // The temporary path for remote urls
+    QString mTempPath;
+
+    // Thumbnail group
+    ThumbnailGroup::Enum mThumbnailGroup;
+
+    ThumbnailThread mThumbnailThread;
+
+    QStringList mPreviewPlugins;
+
+    void determineNextIcon();
+    void startCreatingThumbnail(const QString& path);
+
+    void emitThumbnailLoaded(const QImage& img, const QSize& size);
+
+    QImage loadThumbnailFromCache() const;
 };
 
 } // namespace

=== modified file 'lib/thumbnailview/abstractdocumentinfoprovider.cpp'
--- lib/thumbnailview/abstractdocumentinfoprovider.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/abstractdocumentinfoprovider.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -27,13 +27,12 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 AbstractDocumentInfoProvider::AbstractDocumentInfoProvider(QObject* parent)
 : QObject(parent)
 {
 }
 
-
 } // namespace

=== modified file 'lib/thumbnailview/abstractdocumentinfoprovider.h'
--- lib/thumbnailview/abstractdocumentinfoprovider.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/abstractdocumentinfoprovider.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -37,30 +37,30 @@
 
 class KUrl;
 
-namespace Gwenview {
-
-
-class GWENVIEWLIB_EXPORT AbstractDocumentInfoProvider : public QObject {
-	Q_OBJECT
+namespace Gwenview
+{
+
+class GWENVIEWLIB_EXPORT AbstractDocumentInfoProvider : public QObject
+{
+    Q_OBJECT
 public:
-	AbstractDocumentInfoProvider(QObject* parent=0);
-
-	/**
-	 * Returns true if the document is currently busy (loading, saving,
-	 * rotating...)
-	 */
-	virtual bool isBusy(const KUrl& url) = 0;
-
-	virtual bool isModified(const KUrl& url) = 0;
-
-	virtual void thumbnailForDocument(const KUrl& url, ThumbnailGroup::Enum, QPixmap* outPix, QSize* outFullSize) const = 0;
+    AbstractDocumentInfoProvider(QObject* parent = 0);
+
+    /**
+     * Returns true if the document is currently busy (loading, saving,
+     * rotating...)
+     */
+    virtual bool isBusy(const KUrl& url) = 0;
+
+    virtual bool isModified(const KUrl& url) = 0;
+
+    virtual void thumbnailForDocument(const KUrl& url, ThumbnailGroup::Enum, QPixmap* outPix, QSize* outFullSize) const = 0;
 
 Q_SIGNALS:
-	void busyStateChanged(const QModelIndex&, bool);
-	void documentChanged(const QModelIndex&);
+    void busyStateChanged(const QModelIndex&, bool);
+    void documentChanged(const QModelIndex&);
 };
 
-
 } // namespace
 
 #endif /* ABSTRACTDOCUMENTINFOPROVIDER_H */

=== modified file 'lib/thumbnailview/abstractthumbnailviewhelper.cpp'
--- lib/thumbnailview/abstractthumbnailviewhelper.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/abstractthumbnailviewhelper.cpp	2011-12-15 14:17:54 +0000
@@ -19,16 +19,16 @@
 */
 #include "abstractthumbnailviewhelper.moc"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 AbstractThumbnailViewHelper::AbstractThumbnailViewHelper(QObject* parent)
-: QObject(parent) {
-}
-
-
-AbstractThumbnailViewHelper::~AbstractThumbnailViewHelper() {
-}
-
+: QObject(parent)
+{
+}
+
+AbstractThumbnailViewHelper::~AbstractThumbnailViewHelper()
+{
+}
 
 } // namespace

=== modified file 'lib/thumbnailview/abstractthumbnailviewhelper.h'
--- lib/thumbnailview/abstractthumbnailviewhelper.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/abstractthumbnailviewhelper.h	2011-12-15 14:17:54 +0000
@@ -30,22 +30,24 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * This class is used by the ThumbnailView to request various things.
  */
-class GWENVIEWLIB_EXPORT AbstractThumbnailViewHelper : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT AbstractThumbnailViewHelper : public QObject
+{
+    Q_OBJECT
 public:
-	AbstractThumbnailViewHelper(QObject* parent);
-	virtual ~AbstractThumbnailViewHelper();
-
-	virtual void showContextMenu(QWidget* parent) = 0;
-
-	virtual void showMenuForUrlDroppedOnViewport(QWidget* parent, const KUrl::List&) = 0;
-
-	virtual void showMenuForUrlDroppedOnDir(QWidget* parent, const KUrl::List&, const KUrl&) = 0;
+    AbstractThumbnailViewHelper(QObject* parent);
+    virtual ~AbstractThumbnailViewHelper();
+
+    virtual void showContextMenu(QWidget* parent) = 0;
+
+    virtual void showMenuForUrlDroppedOnViewport(QWidget* parent, const KUrl::List&) = 0;
+
+    virtual void showMenuForUrlDroppedOnDir(QWidget* parent, const KUrl::List&, const KUrl&) = 0;
 };
 
 } // namespace

=== modified file 'lib/thumbnailview/contextbarbutton.cpp'
--- lib/thumbnailview/contextbarbutton.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/contextbarbutton.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2011 Aurélien Gâteau <agateau@kde.org>
@@ -31,8 +31,8 @@
 #include <QStyleOptionToolButton>
 #include <QStylePainter>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 /** How lighter is the border of context bar buttons */
 const int CONTEXTBAR_BORDER_LIGHTNESS = 140;
@@ -46,64 +46,62 @@
 /** Radius of ContextBarButtons */
 const int CONTEXTBAR_RADIUS = 5;
 
-
 struct ContextBarButtonPrivate {
 };
 
-
 ContextBarButton::ContextBarButton(const QString& iconName, QWidget* parent)
 : QToolButton(parent)
-, d(new ContextBarButtonPrivate) {
-	const int size = KIconLoader::global()->currentSize(KIconLoader::Small);
-	setIconSize(QSize(size, size));
-	setAutoRaise(true);
-	setIcon(SmallIcon(iconName));
-}
-
-
-ContextBarButton::~ContextBarButton() {
-	delete d;
-}
-
-
-void Gwenview::ContextBarButton::paintEvent(QPaintEvent*) {
-	QStylePainter painter(this);
-	painter.setRenderHint(QPainter::Antialiasing);
-	QStyleOptionToolButton opt;
-	initStyleOption(&opt);
-
-	const QColor bgColor = palette().color(backgroundRole());
-	QColor color = bgColor.dark(CONTEXTBAR_BACKGROUND_DARKNESS);
-	QColor borderColor = bgColor.light(CONTEXTBAR_BORDER_LIGHTNESS);
-
-	if (opt.state & QStyle::State_MouseOver && opt.state & QStyle::State_Enabled) {
-		color = color.light(CONTEXTBAR_MOUSEOVER_LIGHTNESS);
-		borderColor = borderColor.light(CONTEXTBAR_MOUSEOVER_LIGHTNESS);
-	}
-
-	const QRectF rectF = QRectF(opt.rect).adjusted(0.5, 0.5, -0.5, -0.5);
-	const QPainterPath path = PaintUtils::roundedRectangle(rectF, CONTEXTBAR_RADIUS);
-
-	// Background
-	painter.fillPath(path, color);
-
-	// Top shadow
-	QLinearGradient gradient(rectF.topLeft(), rectF.topLeft() + QPoint(0, 5));
-	gradient.setColorAt(0, QColor::fromHsvF(0, 0, 0, .3));
-	gradient.setColorAt(1, Qt::transparent);
-	painter.fillPath(path, gradient);
-
-	// Left shadow
-	gradient.setFinalStop(rectF.topLeft() + QPoint(5, 0));
-	painter.fillPath(path, gradient);
-
-	// Border
-	painter.setPen(borderColor);
-	painter.drawPath(path);
-
-	// Content
-	painter.drawControl(QStyle::CE_ToolButtonLabel, opt);
-}
-
+, d(new ContextBarButtonPrivate)
+{
+    const int size = KIconLoader::global()->currentSize(KIconLoader::Small);
+    setIconSize(QSize(size, size));
+    setAutoRaise(true);
+    setIcon(SmallIcon(iconName));
+}
+
+ContextBarButton::~ContextBarButton()
+{
+    delete d;
+}
+
+void Gwenview::ContextBarButton::paintEvent(QPaintEvent*)
+{
+    QStylePainter painter(this);
+    painter.setRenderHint(QPainter::Antialiasing);
+    QStyleOptionToolButton opt;
+    initStyleOption(&opt);
+
+    const QColor bgColor = palette().color(backgroundRole());
+    QColor color = bgColor.dark(CONTEXTBAR_BACKGROUND_DARKNESS);
+    QColor borderColor = bgColor.light(CONTEXTBAR_BORDER_LIGHTNESS);
+
+    if (opt.state & QStyle::State_MouseOver && opt.state & QStyle::State_Enabled) {
+        color = color.light(CONTEXTBAR_MOUSEOVER_LIGHTNESS);
+        borderColor = borderColor.light(CONTEXTBAR_MOUSEOVER_LIGHTNESS);
+    }
+
+    const QRectF rectF = QRectF(opt.rect).adjusted(0.5, 0.5, -0.5, -0.5);
+    const QPainterPath path = PaintUtils::roundedRectangle(rectF, CONTEXTBAR_RADIUS);
+
+    // Background
+    painter.fillPath(path, color);
+
+    // Top shadow
+    QLinearGradient gradient(rectF.topLeft(), rectF.topLeft() + QPoint(0, 5));
+    gradient.setColorAt(0, QColor::fromHsvF(0, 0, 0, .3));
+    gradient.setColorAt(1, Qt::transparent);
+    painter.fillPath(path, gradient);
+
+    // Left shadow
+    gradient.setFinalStop(rectF.topLeft() + QPoint(5, 0));
+    painter.fillPath(path, gradient);
+
+    // Border
+    painter.setPen(borderColor);
+    painter.drawPath(path);
+
+    // Content
+    painter.drawControl(QStyle::CE_ToolButtonLabel, opt);
+}
 
 } // namespace

=== modified file 'lib/thumbnailview/contextbarbutton.h'
--- lib/thumbnailview/contextbarbutton.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/contextbarbutton.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2011 Aurélien Gâteau <agateau@kde.org>
@@ -28,27 +28,27 @@
 // Qt
 #include <QToolButton>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class ContextBarButtonPrivate;
 /**
  * A button with a special look, appears when hovering over thumbnails
  */
-class ContextBarButton : public QToolButton {
-	Q_OBJECT
+class ContextBarButton : public QToolButton
+{
+    Q_OBJECT
 public:
-	ContextBarButton(const QString& iconName, QWidget* parent=0);
-	~ContextBarButton();
+    ContextBarButton(const QString& iconName, QWidget* parent = 0);
+    ~ContextBarButton();
 
 protected:
-	void paintEvent(QPaintEvent*);
+    void paintEvent(QPaintEvent*);
 
 private:
-	ContextBarButtonPrivate* const d;
+    ContextBarButtonPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* CONTEXTBARBUTTON_H */

=== modified file 'lib/thumbnailview/itemeditor.cpp'
--- lib/thumbnailview/itemeditor.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/itemeditor.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -30,58 +30,56 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ItemEditorPrivate {
-	QPoint mCenter;
+    QPoint mCenter;
 };
 
-
 ItemEditor::ItemEditor(QWidget* parent)
 : KLineEdit(parent)
-, d(new ItemEditorPrivate) {
-	connect(this, SIGNAL(textChanged(QString)), SLOT(resizeToContents()));
-	setTrapReturnKey(true);
-}
-
-
-ItemEditor::~ItemEditor() {
-	delete d;
-}
-
-
-void ItemEditor::showEvent(QShowEvent* event) {
+, d(new ItemEditorPrivate)
+{
+    connect(this, SIGNAL(textChanged(QString)), SLOT(resizeToContents()));
+    setTrapReturnKey(true);
+}
+
+ItemEditor::~ItemEditor()
+{
+    delete d;
+}
+
+void ItemEditor::showEvent(QShowEvent* event)
+{
     // We can't do this in PreviewItemDelegate::updateEditorGeometry() because QAbstractItemView outsmarts us by calling selectAll() on the editor if it is a QLineEdit
-	const QString extension = KMimeType::extractKnownExtension(text());
-	if (!extension.isEmpty()) {
-		// The filename contains an extension. Assure that only the filename
-		// gets selected.
-		const int selectionLength = text().length() - extension.length() - 1;
-		setSelection(0, selectionLength);
-    }
-	KLineEdit::showEvent(event);
-}
-
-
-void ItemEditor::resizeToContents() {
-	if (d->mCenter.isNull()) {
-		d->mCenter = geometry().center();
-	}
-	int textWidth = fontMetrics().width("  " + text() + "  ");
-	QRect rect = geometry();
-	rect.setWidth(textWidth);
-	rect.moveCenter(d->mCenter);
-	if (rect.right() > parentWidget()->width()) {
-		rect.setRight(parentWidget()->width());
-	}
-	if (rect.left() < 0) {
-		rect.setLeft(0);
-	}
-	setGeometry(rect);
-
-}
-
-
+    const QString extension = KMimeType::extractKnownExtension(text());
+    if (!extension.isEmpty()) {
+        // The filename contains an extension. Assure that only the filename
+        // gets selected.
+        const int selectionLength = text().length() - extension.length() - 1;
+        setSelection(0, selectionLength);
+    }
+    KLineEdit::showEvent(event);
+}
+
+void ItemEditor::resizeToContents()
+{
+    if (d->mCenter.isNull()) {
+        d->mCenter = geometry().center();
+    }
+    int textWidth = fontMetrics().width("  " + text() + "  ");
+    QRect rect = geometry();
+    rect.setWidth(textWidth);
+    rect.moveCenter(d->mCenter);
+    if (rect.right() > parentWidget()->width()) {
+        rect.setRight(parentWidget()->width());
+    }
+    if (rect.left() < 0) {
+        rect.setLeft(0);
+    }
+    setGeometry(rect);
+
+}
 
 } // namespace

=== modified file 'lib/thumbnailview/itemeditor.h'
--- lib/thumbnailview/itemeditor.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/itemeditor.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -28,27 +28,27 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class ItemEditorPrivate;
-class ItemEditor : public KLineEdit {
-	Q_OBJECT
+class ItemEditor : public KLineEdit
+{
+    Q_OBJECT
 public:
-	ItemEditor(QWidget* parent = 0);
-	~ItemEditor();
+    ItemEditor(QWidget* parent = 0);
+    ~ItemEditor();
 
 protected:
-	virtual void showEvent(QShowEvent*);
+    virtual void showEvent(QShowEvent*);
 
 private Q_SLOTS:
-	void resizeToContents();
+    void resizeToContents();
 
 private:
-	ItemEditorPrivate* const d;
+    ItemEditorPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* ITEMEDITOR_H */

=== modified file 'lib/thumbnailview/previewitemdelegate.cpp'
--- lib/thumbnailview/previewitemdelegate.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/previewitemdelegate.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -65,7 +65,8 @@
 #include <QSettings>
 #endif
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * Space between the item outer rect and the content, and between the
@@ -88,839 +89,843 @@
 /** How many pixels around the thumbnail are shadowed */
 const int SHADOW_SIZE = 4;
 
-
-static KFileItem fileItemForIndex(const QModelIndex& index) {
-	Q_ASSERT(index.isValid());
-	QVariant data = index.data(KDirModel::FileItemRole);
-	return qvariant_cast<KFileItem>(data);
-}
-
-
-static KUrl urlForIndex(const QModelIndex& index) {
-	KFileItem item = fileItemForIndex(index);
-	return item.url();
-}
-
+static KFileItem fileItemForIndex(const QModelIndex& index)
+{
+    Q_ASSERT(index.isValid());
+    QVariant data = index.data(KDirModel::FileItemRole);
+    return qvariant_cast<KFileItem>(data);
+}
+
+static KUrl urlForIndex(const QModelIndex& index)
+{
+    KFileItem item = fileItemForIndex(index);
+    return item.url();
+}
 
 struct PreviewItemDelegatePrivate {
-	/**
-	 * Maps full text to elided text.
-	 */
-	mutable QHash<QString, QString> mElidedTextCache;
-
-	// Key is height * 1000 + width
-	typedef QHash<int, QPixmap> ShadowCache;
-	mutable ShadowCache mShadowCache;
-
-	PreviewItemDelegate* that;
-	ThumbnailView* mView;
-	QWidget* mContextBar;
-	QToolButton* mSaveButton;
-	QPixmap mSaveButtonPixmap;
-
-	QToolButton* mToggleSelectionButton;
-	QToolButton* mFullScreenButton;
-	QToolButton* mRotateLeftButton;
-	QToolButton* mRotateRightButton;
-#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	KRatingPainter mRatingPainter;
-#endif
-
-	QModelIndex mIndexUnderCursor;
-	int mThumbnailSize;
-	PreviewItemDelegate::ThumbnailDetails mDetails;
-	PreviewItemDelegate::ContextBarMode mContextBarMode;
-	Qt::TextElideMode mTextElideMode;
-
-	QPointer<ToolTipWidget> mToolTip;
-	QScopedPointer<QAbstractAnimation> mToolTipAnimation;
-
-
-	void initSaveButtonPixmap() {
-		if (!mSaveButtonPixmap.isNull()) {
-			return;
-		}
-		// Necessary otherwise we won't see the save button itself
-		mSaveButton->adjustSize();
-
-		mSaveButtonPixmap = QPixmap(mSaveButton->sizeHint());
-		mSaveButtonPixmap.fill(Qt::transparent);
-		mSaveButton->render(&mSaveButtonPixmap, QPoint(), QRegion(), QWidget::DrawChildren);
-	}
-
-
-	void showContextBar(const QRect& rect, const QPixmap& thumbnailPix) {
-		if (mContextBarMode == PreviewItemDelegate::NoContextBar) {
-			return;
-		}
-		mContextBar->adjustSize();
-		// Center bar in FullContextBar mode, left align in
-		// SelectionOnlyContextBar mode
-		const int posX = mContextBarMode == PreviewItemDelegate::FullContextBar
-			? (rect.width() - mContextBar->width()) / 2
-			: 0;
-		const int posY = qMax(CONTEXTBAR_MARGIN, mThumbnailSize - thumbnailPix.height() - mContextBar->height());
-		mContextBar->move(rect.topLeft() + QPoint(posX, posY));
-		mContextBar->show();
-	}
-
-
-	void initToolTip() {
-		mToolTip = new ToolTipWidget(mView->viewport());
-		mToolTip->setOpacity(0);
-		mToolTip->show();
-	}
-
-
-	bool hoverEventFilter(QHoverEvent* event) {
-		QModelIndex index = mView->indexAt(event->pos());
-		if (index != mIndexUnderCursor) {
-			updateHoverUi(index);
-		} else {
-			// Same index, nothing to do, but repaint anyway in case we are
-			// over the rating row
-			mView->update(mIndexUnderCursor);
-		}
-		return false;
-	}
-
-
-	void updateHoverUi(const QModelIndex& index) {
-		QModelIndex oldIndex = mIndexUnderCursor;
-		mIndexUnderCursor = index;
-		mView->update(oldIndex);
-
-		if (KGlobalSettings::singleClick() && KGlobalSettings::changeCursorOverIcon()) {
-			mView->setCursor(mIndexUnderCursor.isValid() ? Qt::PointingHandCursor : Qt::ArrowCursor);
-		}
-
-		if (mIndexUnderCursor.isValid()) {
-			updateToggleSelectionButton();
-			updateImageButtons();
-
-			const QRect rect = mView->visualRect(mIndexUnderCursor);
-			const QPixmap thumbnailPix = mView->thumbnailForIndex(index);
-			showContextBar(rect, thumbnailPix);
-			if (mView->isModified(mIndexUnderCursor)) {
-				showSaveButton(rect);
-			} else {
-				mSaveButton->hide();
-			}
-
-			showToolTip(index);
-			mView->update(mIndexUnderCursor);
-
-		} else {
-			mContextBar->hide();
-			mSaveButton->hide();
-			hideToolTip();
-		}
-	}
-
-	QRect ratingRectFromIndexRect(const QRect& rect) const {
-		return QRect(
-			rect.left(),
-			rect.bottom() - ratingRowHeight() - ITEM_MARGIN,
-			rect.width(),
-			ratingRowHeight());
-	}
-
-#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	int ratingFromCursorPosition(const QRect& ratingRect) const {
-		const QPoint pos = mView->viewport()->mapFromGlobal(QCursor::pos());
-		return mRatingPainter.ratingFromPosition(ratingRect, pos);
-	}
-#endif
-
-	bool mouseButtonEventFilter(QEvent::Type type) {
-	#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		const QRect rect = ratingRectFromIndexRect(mView->visualRect(mIndexUnderCursor));
-		const int rating = ratingFromCursorPosition(rect);
-		if (rating == -1) {
-			return false;
-		}
-		if (type == QEvent::MouseButtonRelease) {
-			that->setDocumentRatingRequested(urlForIndex(mIndexUnderCursor) , rating);
-		}
-		return true;
-	#else
-		return false;
-	#endif
-	}
-
-
-	QPoint saveButtonPosition(const QRect& itemRect) const {
-		QSize buttonSize = mSaveButton->sizeHint();
-		int posX = itemRect.right() - buttonSize.width();
-		int posY = itemRect.top() + mThumbnailSize + 2 * ITEM_MARGIN - buttonSize.height();
-
-		return QPoint(posX, posY);
-	}
-
-
-	void showSaveButton(const QRect& itemRect) const {
-		mSaveButton->move(saveButtonPosition(itemRect));
-		mSaveButton->show();
-	}
-
-
-	void drawBackground(QPainter* painter, const QRect& rect, const QColor& bgColor, const QColor& borderColor) const {
-		int bgH, bgS, bgV;
-		int borderH, borderS, borderV, borderMargin;
-	#ifdef FINETUNE_SELECTION_BACKGROUND
-		QSettings settings(QDir::homePath() + "/colors.ini", QSettings::IniFormat);
-		bgH = settings.value("bg/h").toInt();
-		bgS = settings.value("bg/s").toInt();
-		bgV = settings.value("bg/v").toInt();
-		borderH = settings.value("border/h").toInt();
-		borderS = settings.value("border/s").toInt();
-		borderV = settings.value("border/v").toInt();
-		borderMargin = settings.value("border/margin").toInt();
-	#else
-		bgH = 0;
-		bgS = -20;
-		bgV = 43;
-		borderH = 0;
-		borderS = -100;
-		borderV = 60;
-		borderMargin = 1;
-	#endif
-		painter->setRenderHint(QPainter::Antialiasing);
-
-		QRectF rectF = QRectF(rect).adjusted(0.5, 0.5, -0.5, -0.5);
-
-		QPainterPath path = PaintUtils::roundedRectangle(rectF, SELECTION_RADIUS);
-
-		QLinearGradient gradient(rectF.topLeft(), rectF.bottomLeft());
-		gradient.setColorAt(0, PaintUtils::adjustedHsv(bgColor, bgH, bgS, bgV));
-		gradient.setColorAt(1, bgColor);
-		painter->fillPath(path, gradient);
-
-		painter->setPen(borderColor);
-		painter->drawPath(path);
-
-		painter->setPen(PaintUtils::adjustedHsv(borderColor, borderH, borderS, borderV));
-		rectF = rectF.adjusted(borderMargin, borderMargin, -borderMargin, -borderMargin);
-		path = PaintUtils::roundedRectangle(rectF, SELECTION_RADIUS);
-		painter->drawPath(path);
-	}
-
-
-	void drawShadow(QPainter* painter, const QRect& rect) const {
-		const QPoint shadowOffset(-SHADOW_SIZE, -SHADOW_SIZE + 1);
-
-		int key = rect.height() * 1000 + rect.width();
-
-		ShadowCache::Iterator it = mShadowCache.find(key);
-		if (it == mShadowCache.end()) {
-			QSize size = QSize(rect.width() + 2*SHADOW_SIZE, rect.height() + 2*SHADOW_SIZE);
-			QColor color(0, 0, 0, SHADOW_STRENGTH);
-			QPixmap shadow = PaintUtils::generateFuzzyRect(size, color, SHADOW_SIZE);
-			it = mShadowCache.insert(key, shadow);
-		}
-		painter->drawPixmap(rect.topLeft() + shadowOffset, it.value());
-	}
-
-
-	void drawText(QPainter* painter, const QRect& rect, const QColor& fgColor, const QString& fullText) const {
-		QFontMetrics fm = mView->fontMetrics();
-
-		// Elide text
-		QString text;
-		QHash<QString, QString>::const_iterator it = mElidedTextCache.constFind(fullText);
-		if (it == mElidedTextCache.constEnd()) {
-			text = fm.elidedText(fullText, mTextElideMode, rect.width());
-			mElidedTextCache[fullText] = text;
-		} else {
-			text = it.value();
-		}
-
-		// Compute x pos
-		int posX;
-		if (text.length() == fullText.length()) {
-			// Not elided, center text
-			posX = (rect.width() - fm.width(text)) / 2;
-		} else {
-			// Elided, left align
-			posX = 0;
-		}
-
-		// Draw text
-		painter->setPen(fgColor);
-		painter->drawText(rect.left() + posX, rect.top() + fm.ascent(), text);
-	}
-
-
-	void drawRating(QPainter* painter, const QRect& rect, const QVariant& value) {
-	#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		const int rating = value.toInt();
-		const QRect ratingRect = ratingRectFromIndexRect(rect);
-		const int hoverRating = ratingFromCursorPosition(ratingRect);
-		mRatingPainter.paint(painter, ratingRect, rating, hoverRating);
-	#endif
-	}
-
-
-	bool isTextElided(const QString& text) const {
-		QHash<QString, QString>::const_iterator it = mElidedTextCache.constFind(text);
-		if (it == mElidedTextCache.constEnd()) {
-			return false;
-		}
-		return it.value().length() < text.length();
-	}
-
-
-	/**
-	 * Show a tooltip only if the item has been elided.
-	 * This function places the tooltip over the item text.
-	 */
-	void showToolTip(const QModelIndex& index) {
-		if (mDetails == 0 || mDetails == PreviewItemDelegate::RatingDetail) {
-			// No text to display
-			return;
-		}
-
-		// Gather tip text
-		QStringList textList;
-		bool elided = false;
-		if (mDetails & PreviewItemDelegate::FileNameDetail) {
-			const QString text = index.data().toString();
-			elided |= isTextElided(text);
-			textList << text;
-		}
-
-		// FIXME: Duplicated from drawText
-		const KFileItem fileItem = fileItemForIndex(index);
-		const bool isDirOrArchive = ArchiveUtils::fileItemIsDirOrArchive(fileItem);
-		if (mDetails & PreviewItemDelegate::DateDetail) {
-			if (!ArchiveUtils::fileItemIsDirOrArchive(fileItem)) {
-				const KDateTime dt = TimeUtils::dateTimeForFileItem(fileItem);
-				const QString text = KGlobal::locale()->formatDateTime(dt);
-				elided |= isTextElided(text);
-				textList << text;
-			}
-		}
-
-		if (!isDirOrArchive && (mDetails & PreviewItemDelegate::ImageSizeDetail)) {
-			QSize fullSize;
-			QPixmap thumbnailPix = mView->thumbnailForIndex(index, &fullSize);
-			if (fullSize.isValid()) {
-				const QString text = QString("%1x%2").arg(fullSize.width()).arg(fullSize.height());
-				elided |= isTextElided(text);
-				textList << text;
-			}
-		}
-
-		if (!isDirOrArchive && (mDetails & PreviewItemDelegate::FileSizeDetail)) {
-			const KIO::filesize_t size = fileItem.size();
-			if (size > 0) {
-				const QString text = KIO::convertSize(size);
-				elided |= isTextElided(text);
-				textList << text;
-			}
-		}
-
-		if (!elided) {
-			hideToolTip();
-			return;
-		}
-
-		bool newTipLabel = !mToolTip;
-		if (!mToolTip) {
-			initToolTip();
-		}
-		mToolTip->setText(textList.join("\n"));
-		QSize tipSize = mToolTip->sizeHint();
-
-		// Compute tip position
-		QRect rect = mView->visualRect(index);
-		const int textY = ITEM_MARGIN + mThumbnailSize + ITEM_MARGIN;
-		const int spacing = 1;
-		QRect geometry(
-			QPoint(rect.topLeft() + QPoint((rect.width() - tipSize.width()) / 2, textY + spacing)),
-			tipSize
-			);
-		if (geometry.left() < 0) {
-			geometry.moveLeft(0);
-		} else if (geometry.right() > mView->viewport()->width()) {
-			geometry.moveRight(mView->viewport()->width());
-		}
-
-		// Show tip
-		QParallelAnimationGroup* anim = new QParallelAnimationGroup();
-		QPropertyAnimation* fadeIn = new QPropertyAnimation(mToolTip, "opacity");
-		fadeIn->setStartValue(mToolTip->opacity());
-		fadeIn->setEndValue(1.);
-		anim->addAnimation(fadeIn);
-
-		if (newTipLabel) {
-			mToolTip->setGeometry(geometry);
-		} else {
-			QPropertyAnimation* move = new QPropertyAnimation(mToolTip, "geometry");
-			move->setStartValue(mToolTip->geometry());
-			move->setEndValue(geometry);
-			anim->addAnimation(move);
-		}
-
-		mToolTipAnimation.reset(anim);
-		mToolTipAnimation->start();
-	}
-
-	void hideToolTip() {
-		if (!mToolTip) {
-			return;
-		}
-		QSequentialAnimationGroup* anim = new QSequentialAnimationGroup();
-		anim->addPause(500);
-		QPropertyAnimation* fadeOut = new QPropertyAnimation(mToolTip, "opacity");
-		fadeOut->setStartValue(mToolTip->opacity());
-		fadeOut->setEndValue(0.);
-		anim->addAnimation(fadeOut);
-		mToolTipAnimation.reset(anim);
-		mToolTipAnimation->start();
-		QObject::connect(anim, SIGNAL(finished()), mToolTip, SLOT(deleteLater()));
-	}
-
-	int itemWidth() const {
-		return mThumbnailSize + 2 * ITEM_MARGIN;
-	}
-
-	int ratingRowHeight() const {
-#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		return mView->fontMetrics().ascent();
-#endif
-		return 0;
-	}
-
-	int itemHeight() const {
-		const int lineHeight = mView->fontMetrics().height();
-		int textHeight = 0;
-		if (mDetails & PreviewItemDelegate::FileNameDetail) {
-			textHeight += lineHeight;
-		}
-		if (mDetails & PreviewItemDelegate::DateDetail) {
-			textHeight += lineHeight;
-		}
-		if (mDetails & PreviewItemDelegate::ImageSizeDetail) {
-			textHeight += lineHeight;
-		}
-		if (mDetails & PreviewItemDelegate::FileSizeDetail) {
-			textHeight += lineHeight;
-		}
-		if (mDetails & PreviewItemDelegate::RatingDetail) {
-			textHeight += ratingRowHeight();
-		}
-		if (textHeight == 0) {
-			// Keep at least one row of text, so that we can show folder names
-			textHeight = lineHeight;
-		}
-		return mThumbnailSize + textHeight + 3*ITEM_MARGIN;
-	}
-
-	void selectIndexUnderCursorIfNoMultiSelection() {
-		if (mView->selectionModel()->selectedIndexes().size() <= 1) {
-			mView->setCurrentIndex(mIndexUnderCursor);
-		}
-	}
-
-	void updateToggleSelectionButton() {
-		mToggleSelectionButton->setIcon(SmallIcon(
-			mView->selectionModel()->isSelected(mIndexUnderCursor) ? "list-remove" : "list-add"
-			));
-	}
-
-	void updateImageButtons() {
-		const KFileItem item = fileItemForIndex(mIndexUnderCursor);
-		const bool isImage = !ArchiveUtils::fileItemIsDirOrArchive(item);
-		mFullScreenButton->setEnabled(isImage);
-		mRotateLeftButton->setEnabled(isImage);
-		mRotateRightButton->setEnabled(isImage);
-	}
-
-	void updateContextBar() {
-		if (mContextBarMode == PreviewItemDelegate::NoContextBar) {
-			mContextBar->hide();
-			return;
-		}
-		const int width = itemWidth();
-		const int buttonWidth = mRotateRightButton->sizeHint().width();
-		bool full = mContextBarMode == PreviewItemDelegate::FullContextBar;
-		mFullScreenButton->setVisible(full);
-		mRotateLeftButton->setVisible(full && width >= 3 * buttonWidth);
-		mRotateRightButton->setVisible(full && width >= 4 * buttonWidth);
-		mContextBar->adjustSize();
-	}
-
-	void updateViewGridSize() {
-		mView->setGridSize(QSize(itemWidth(), itemHeight()));
-	}
+    /**
+     * Maps full text to elided text.
+     */
+    mutable QHash<QString, QString> mElidedTextCache;
+
+    // Key is height * 1000 + width
+    typedef QHash<int, QPixmap> ShadowCache;
+    mutable ShadowCache mShadowCache;
+
+    PreviewItemDelegate* q;
+    ThumbnailView* mView;
+    QWidget* mContextBar;
+    QToolButton* mSaveButton;
+    QPixmap mSaveButtonPixmap;
+
+    QToolButton* mToggleSelectionButton;
+    QToolButton* mFullScreenButton;
+    QToolButton* mRotateLeftButton;
+    QToolButton* mRotateRightButton;
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+    KRatingPainter mRatingPainter;
+#endif
+
+    QModelIndex mIndexUnderCursor;
+    int mThumbnailSize;
+    PreviewItemDelegate::ThumbnailDetails mDetails;
+    PreviewItemDelegate::ContextBarMode mContextBarMode;
+    Qt::TextElideMode mTextElideMode;
+
+    QPointer<ToolTipWidget> mToolTip;
+    QScopedPointer<QAbstractAnimation> mToolTipAnimation;
+
+    void initSaveButtonPixmap()
+    {
+        if (!mSaveButtonPixmap.isNull()) {
+            return;
+        }
+        // Necessary otherwise we won't see the save button itself
+        mSaveButton->adjustSize();
+
+        mSaveButtonPixmap = QPixmap(mSaveButton->sizeHint());
+        mSaveButtonPixmap.fill(Qt::transparent);
+        mSaveButton->render(&mSaveButtonPixmap, QPoint(), QRegion(), QWidget::DrawChildren);
+    }
+
+    void showContextBar(const QRect& rect, const QPixmap& thumbnailPix)
+    {
+        if (mContextBarMode == PreviewItemDelegate::NoContextBar) {
+            return;
+        }
+        mContextBar->adjustSize();
+        // Center bar in FullContextBar mode, left align in
+        // SelectionOnlyContextBar mode
+        const int posX = mContextBarMode == PreviewItemDelegate::FullContextBar
+                         ? (rect.width() - mContextBar->width()) / 2
+                         : 0;
+        const int posY = qMax(CONTEXTBAR_MARGIN, mThumbnailSize - thumbnailPix.height() - mContextBar->height());
+        mContextBar->move(rect.topLeft() + QPoint(posX, posY));
+        mContextBar->show();
+    }
+
+    void initToolTip()
+    {
+        mToolTip = new ToolTipWidget(mView->viewport());
+        mToolTip->setOpacity(0);
+        mToolTip->show();
+    }
+
+    bool hoverEventFilter(QHoverEvent* event)
+    {
+        QModelIndex index = mView->indexAt(event->pos());
+        if (index != mIndexUnderCursor) {
+            updateHoverUi(index);
+        } else {
+            // Same index, nothing to do, but repaint anyway in case we are
+            // over the rating row
+            mView->update(mIndexUnderCursor);
+        }
+        return false;
+    }
+
+    void updateHoverUi(const QModelIndex& index)
+    {
+        QModelIndex oldIndex = mIndexUnderCursor;
+        mIndexUnderCursor = index;
+        mView->update(oldIndex);
+
+        if (KGlobalSettings::singleClick() && KGlobalSettings::changeCursorOverIcon()) {
+            mView->setCursor(mIndexUnderCursor.isValid() ? Qt::PointingHandCursor : Qt::ArrowCursor);
+        }
+
+        if (mIndexUnderCursor.isValid()) {
+            updateToggleSelectionButton();
+            updateImageButtons();
+
+            const QRect rect = mView->visualRect(mIndexUnderCursor);
+            const QPixmap thumbnailPix = mView->thumbnailForIndex(index);
+            showContextBar(rect, thumbnailPix);
+            if (mView->isModified(mIndexUnderCursor)) {
+                showSaveButton(rect);
+            } else {
+                mSaveButton->hide();
+            }
+
+            showToolTip(index);
+            mView->update(mIndexUnderCursor);
+
+        } else {
+            mContextBar->hide();
+            mSaveButton->hide();
+            hideToolTip();
+        }
+    }
+
+    QRect ratingRectFromIndexRect(const QRect& rect) const {
+        return QRect(
+                   rect.left(),
+                   rect.bottom() - ratingRowHeight() - ITEM_MARGIN,
+                   rect.width(),
+                   ratingRowHeight());
+    }
+
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+    int ratingFromCursorPosition(const QRect& ratingRect) const {
+        const QPoint pos = mView->viewport()->mapFromGlobal(QCursor::pos());
+        return mRatingPainter.ratingFromPosition(ratingRect, pos);
+    }
+#endif
+
+    bool mouseButtonEventFilter(QEvent::Type type)
+    {
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+        const QRect rect = ratingRectFromIndexRect(mView->visualRect(mIndexUnderCursor));
+        const int rating = ratingFromCursorPosition(rect);
+        if (rating == -1) {
+            return false;
+        }
+        if (type == QEvent::MouseButtonRelease) {
+            q->setDocumentRatingRequested(urlForIndex(mIndexUnderCursor) , rating);
+        }
+        return true;
+#else
+        return false;
+#endif
+    }
+
+    QPoint saveButtonPosition(const QRect& itemRect) const {
+        QSize buttonSize = mSaveButton->sizeHint();
+        int posX = itemRect.right() - buttonSize.width();
+        int posY = itemRect.top() + mThumbnailSize + 2 * ITEM_MARGIN - buttonSize.height();
+
+        return QPoint(posX, posY);
+    }
+
+    void showSaveButton(const QRect& itemRect) const
+    {
+        mSaveButton->move(saveButtonPosition(itemRect));
+        mSaveButton->show();
+    }
+
+    void drawBackground(QPainter* painter, const QRect& rect, const QColor& bgColor, const QColor& borderColor) const
+    {
+        int bgH, bgS, bgV;
+        int borderH, borderS, borderV, borderMargin;
+#ifdef FINETUNE_SELECTION_BACKGROUND
+        QSettings settings(QDir::homePath() + "/colors.ini", QSettings::IniFormat);
+        bgH = settings.value("bg/h").toInt();
+        bgS = settings.value("bg/s").toInt();
+        bgV = settings.value("bg/v").toInt();
+        borderH = settings.value("border/h").toInt();
+        borderS = settings.value("border/s").toInt();
+        borderV = settings.value("border/v").toInt();
+        borderMargin = settings.value("border/margin").toInt();
+#else
+        bgH = 0;
+        bgS = -20;
+        bgV = 43;
+        borderH = 0;
+        borderS = -100;
+        borderV = 60;
+        borderMargin = 1;
+#endif
+        painter->setRenderHint(QPainter::Antialiasing);
+
+        QRectF rectF = QRectF(rect).adjusted(0.5, 0.5, -0.5, -0.5);
+
+        QPainterPath path = PaintUtils::roundedRectangle(rectF, SELECTION_RADIUS);
+
+        QLinearGradient gradient(rectF.topLeft(), rectF.bottomLeft());
+        gradient.setColorAt(0, PaintUtils::adjustedHsv(bgColor, bgH, bgS, bgV));
+        gradient.setColorAt(1, bgColor);
+        painter->fillPath(path, gradient);
+
+        painter->setPen(borderColor);
+        painter->drawPath(path);
+
+        painter->setPen(PaintUtils::adjustedHsv(borderColor, borderH, borderS, borderV));
+        rectF = rectF.adjusted(borderMargin, borderMargin, -borderMargin, -borderMargin);
+        path = PaintUtils::roundedRectangle(rectF, SELECTION_RADIUS);
+        painter->drawPath(path);
+    }
+
+    void drawShadow(QPainter* painter, const QRect& rect) const
+    {
+        const QPoint shadowOffset(-SHADOW_SIZE, -SHADOW_SIZE + 1);
+
+        int key = rect.height() * 1000 + rect.width();
+
+        ShadowCache::Iterator it = mShadowCache.find(key);
+        if (it == mShadowCache.end()) {
+            QSize size = QSize(rect.width() + 2 * SHADOW_SIZE, rect.height() + 2 * SHADOW_SIZE);
+            QColor color(0, 0, 0, SHADOW_STRENGTH);
+            QPixmap shadow = PaintUtils::generateFuzzyRect(size, color, SHADOW_SIZE);
+            it = mShadowCache.insert(key, shadow);
+        }
+        painter->drawPixmap(rect.topLeft() + shadowOffset, it.value());
+    }
+
+    void drawText(QPainter* painter, const QRect& rect, const QColor& fgColor, const QString& fullText) const
+    {
+        QFontMetrics fm = mView->fontMetrics();
+
+        // Elide text
+        QString text;
+        QHash<QString, QString>::const_iterator it = mElidedTextCache.constFind(fullText);
+        if (it == mElidedTextCache.constEnd()) {
+            text = fm.elidedText(fullText, mTextElideMode, rect.width());
+            mElidedTextCache[fullText] = text;
+        } else {
+            text = it.value();
+        }
+
+        // Compute x pos
+        int posX;
+        if (text.length() == fullText.length()) {
+            // Not elided, center text
+            posX = (rect.width() - fm.width(text)) / 2;
+        } else {
+            // Elided, left align
+            posX = 0;
+        }
+
+        // Draw text
+        painter->setPen(fgColor);
+        painter->drawText(rect.left() + posX, rect.top() + fm.ascent(), text);
+    }
+
+    void drawRating(QPainter* painter, const QRect& rect, const QVariant& value)
+    {
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+        const int rating = value.toInt();
+        const QRect ratingRect = ratingRectFromIndexRect(rect);
+        const int hoverRating = ratingFromCursorPosition(ratingRect);
+        mRatingPainter.paint(painter, ratingRect, rating, hoverRating);
+#endif
+    }
+
+    bool isTextElided(const QString& text) const {
+        QHash<QString, QString>::const_iterator it = mElidedTextCache.constFind(text);
+        if (it == mElidedTextCache.constEnd()) {
+            return false;
+        }
+        return it.value().length() < text.length();
+    }
+
+    /**
+     * Show a tooltip only if the item has been elided.
+     * This function places the tooltip over the item text.
+     */
+    void showToolTip(const QModelIndex& index)
+    {
+        if (mDetails == 0 || mDetails == PreviewItemDelegate::RatingDetail) {
+            // No text to display
+            return;
+        }
+
+        // Gather tip text
+        QStringList textList;
+        bool elided = false;
+        if (mDetails & PreviewItemDelegate::FileNameDetail) {
+            const QString text = index.data().toString();
+            elided |= isTextElided(text);
+            textList << text;
+        }
+
+        // FIXME: Duplicated from drawText
+        const KFileItem fileItem = fileItemForIndex(index);
+        const bool isDirOrArchive = ArchiveUtils::fileItemIsDirOrArchive(fileItem);
+        if (mDetails & PreviewItemDelegate::DateDetail) {
+            if (!ArchiveUtils::fileItemIsDirOrArchive(fileItem)) {
+                const KDateTime dt = TimeUtils::dateTimeForFileItem(fileItem);
+                const QString text = KGlobal::locale()->formatDateTime(dt);
+                elided |= isTextElided(text);
+                textList << text;
+            }
+        }
+
+        if (!isDirOrArchive && (mDetails & PreviewItemDelegate::ImageSizeDetail)) {
+            QSize fullSize;
+            QPixmap thumbnailPix = mView->thumbnailForIndex(index, &fullSize);
+            if (fullSize.isValid()) {
+                const QString text = QString("%1x%2").arg(fullSize.width()).arg(fullSize.height());
+                elided |= isTextElided(text);
+                textList << text;
+            }
+        }
+
+        if (!isDirOrArchive && (mDetails & PreviewItemDelegate::FileSizeDetail)) {
+            const KIO::filesize_t size = fileItem.size();
+            if (size > 0) {
+                const QString text = KIO::convertSize(size);
+                elided |= isTextElided(text);
+                textList << text;
+            }
+        }
+
+        if (!elided) {
+            hideToolTip();
+            return;
+        }
+
+        bool newTipLabel = !mToolTip;
+        if (!mToolTip) {
+            initToolTip();
+        }
+        mToolTip->setText(textList.join("\n"));
+        QSize tipSize = mToolTip->sizeHint();
+
+        // Compute tip position
+        QRect rect = mView->visualRect(index);
+        const int textY = ITEM_MARGIN + mThumbnailSize + ITEM_MARGIN;
+        const int spacing = 1;
+        QRect geometry(
+            QPoint(rect.topLeft() + QPoint((rect.width() - tipSize.width()) / 2, textY + spacing)),
+            tipSize
+        );
+        if (geometry.left() < 0) {
+            geometry.moveLeft(0);
+        } else if (geometry.right() > mView->viewport()->width()) {
+            geometry.moveRight(mView->viewport()->width());
+        }
+
+        // Show tip
+        QParallelAnimationGroup* anim = new QParallelAnimationGroup();
+        QPropertyAnimation* fadeIn = new QPropertyAnimation(mToolTip, "opacity");
+        fadeIn->setStartValue(mToolTip->opacity());
+        fadeIn->setEndValue(1.);
+        anim->addAnimation(fadeIn);
+
+        if (newTipLabel) {
+            mToolTip->setGeometry(geometry);
+        } else {
+            QPropertyAnimation* move = new QPropertyAnimation(mToolTip, "geometry");
+            move->setStartValue(mToolTip->geometry());
+            move->setEndValue(geometry);
+            anim->addAnimation(move);
+        }
+
+        mToolTipAnimation.reset(anim);
+        mToolTipAnimation->start();
+    }
+
+    void hideToolTip()
+    {
+        if (!mToolTip) {
+            return;
+        }
+        QSequentialAnimationGroup* anim = new QSequentialAnimationGroup();
+        anim->addPause(500);
+        QPropertyAnimation* fadeOut = new QPropertyAnimation(mToolTip, "opacity");
+        fadeOut->setStartValue(mToolTip->opacity());
+        fadeOut->setEndValue(0.);
+        anim->addAnimation(fadeOut);
+        mToolTipAnimation.reset(anim);
+        mToolTipAnimation->start();
+        QObject::connect(anim, SIGNAL(finished()), mToolTip, SLOT(deleteLater()));
+    }
+
+    int itemWidth() const {
+        return mThumbnailSize + 2 * ITEM_MARGIN;
+    }
+
+    int ratingRowHeight() const {
+#ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
+        return mView->fontMetrics().ascent();
+#endif
+        return 0;
+    }
+
+    int itemHeight() const {
+        const int lineHeight = mView->fontMetrics().height();
+        int textHeight = 0;
+        if (mDetails & PreviewItemDelegate::FileNameDetail) {
+            textHeight += lineHeight;
+        }
+        if (mDetails & PreviewItemDelegate::DateDetail) {
+            textHeight += lineHeight;
+        }
+        if (mDetails & PreviewItemDelegate::ImageSizeDetail) {
+            textHeight += lineHeight;
+        }
+        if (mDetails & PreviewItemDelegate::FileSizeDetail) {
+            textHeight += lineHeight;
+        }
+        if (mDetails & PreviewItemDelegate::RatingDetail) {
+            textHeight += ratingRowHeight();
+        }
+        if (textHeight == 0) {
+            // Keep at least one row of text, so that we can show folder names
+            textHeight = lineHeight;
+        }
+        return mThumbnailSize + textHeight + 3 * ITEM_MARGIN;
+    }
+
+    void selectIndexUnderCursorIfNoMultiSelection()
+    {
+        if (mView->selectionModel()->selectedIndexes().size() <= 1) {
+            mView->setCurrentIndex(mIndexUnderCursor);
+        }
+    }
+
+    void updateToggleSelectionButton()
+    {
+        mToggleSelectionButton->setIcon(SmallIcon(
+                                            mView->selectionModel()->isSelected(mIndexUnderCursor) ? "list-remove" : "list-add"
+                                        ));
+    }
+
+    void updateImageButtons()
+    {
+        const KFileItem item = fileItemForIndex(mIndexUnderCursor);
+        const bool isImage = !ArchiveUtils::fileItemIsDirOrArchive(item);
+        mFullScreenButton->setEnabled(isImage);
+        mRotateLeftButton->setEnabled(isImage);
+        mRotateRightButton->setEnabled(isImage);
+    }
+
+    void updateContextBar()
+    {
+        if (mContextBarMode == PreviewItemDelegate::NoContextBar) {
+            mContextBar->hide();
+            return;
+        }
+        const int width = itemWidth();
+        const int buttonWidth = mRotateRightButton->sizeHint().width();
+        bool full = mContextBarMode == PreviewItemDelegate::FullContextBar;
+        mFullScreenButton->setVisible(full);
+        mRotateLeftButton->setVisible(full && width >= 3 * buttonWidth);
+        mRotateRightButton->setVisible(full && width >= 4 * buttonWidth);
+        mContextBar->adjustSize();
+    }
+
+    void updateViewGridSize()
+    {
+        mView->setGridSize(QSize(itemWidth(), itemHeight()));
+    }
 };
 
-
 PreviewItemDelegate::PreviewItemDelegate(ThumbnailView* view)
 : QItemDelegate(view)
-, d(new PreviewItemDelegatePrivate) {
-	d->that = this;
-	d->mView = view;
-	view->viewport()->installEventFilter(this);
-	d->mThumbnailSize = view->thumbnailSize();
-	d->mDetails = FileNameDetail;
-	d->mContextBarMode = FullContextBar;
-	d->mTextElideMode = Qt::ElideRight;
+, d(new PreviewItemDelegatePrivate)
+{
+    d->q = this;
+    d->mView = view;
+    view->viewport()->installEventFilter(this);
+    d->mThumbnailSize = view->thumbnailSize();
+    d->mDetails = FileNameDetail;
+    d->mContextBarMode = FullContextBar;
+    d->mTextElideMode = Qt::ElideRight;
 
-	connect(view, SIGNAL(rowsRemovedSignal(const QModelIndex&, int, int)),
-		SLOT(slotRowsChanged()));
-	connect(view, SIGNAL(rowsInsertedSignal(const QModelIndex&, int, int)),
-		SLOT(slotRowsChanged()));
+    connect(view, SIGNAL(rowsRemovedSignal(QModelIndex, int, int)),
+            SLOT(slotRowsChanged()));
+    connect(view, SIGNAL(rowsInsertedSignal(QModelIndex, int, int)),
+            SLOT(slotRowsChanged()));
 
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-	d->mRatingPainter.setAlignment(Qt::AlignHCenter | Qt::AlignBottom);
-	d->mRatingPainter.setLayoutDirection(view->layoutDirection());
-	d->mRatingPainter.setMaxRating(10);
+    d->mRatingPainter.setAlignment(Qt::AlignHCenter | Qt::AlignBottom);
+    d->mRatingPainter.setLayoutDirection(view->layoutDirection());
+    d->mRatingPainter.setMaxRating(10);
 #endif
 
-	connect(view, SIGNAL(thumbnailSizeChanged(int)),
-		SLOT(setThumbnailSize(int)) );
-
-	// Button frame
-	d->mContextBar = new QWidget(d->mView->viewport());
-	d->mContextBar->hide();
-
-	d->mToggleSelectionButton = new ContextBarButton("list-add");
-	connect(d->mToggleSelectionButton, SIGNAL(clicked()),
-		SLOT(slotToggleSelectionClicked()));
-
-	d->mFullScreenButton = new ContextBarButton("view-fullscreen");
-	connect(d->mFullScreenButton, SIGNAL(clicked()),
-		SLOT(slotFullScreenClicked()) );
-
-	d->mRotateLeftButton = new ContextBarButton("object-rotate-left");
-	connect(d->mRotateLeftButton, SIGNAL(clicked()),
-		SLOT(slotRotateLeftClicked()) );
-
-	d->mRotateRightButton = new ContextBarButton("object-rotate-right");
-	connect(d->mRotateRightButton, SIGNAL(clicked()),
-		SLOT(slotRotateRightClicked()) );
-
-	QHBoxLayout* layout = new QHBoxLayout(d->mContextBar);
-	layout->setMargin(2);
-	layout->setSpacing(2);
-	layout->addWidget(d->mToggleSelectionButton);
-	layout->addWidget(d->mFullScreenButton);
-	layout->addWidget(d->mRotateLeftButton);
-	layout->addWidget(d->mRotateRightButton);
-
-	// Save button
-	d->mSaveButton = new ContextBarButton("document-save", d->mView->viewport());
-	d->mSaveButton->hide();
-	connect(d->mSaveButton, SIGNAL(clicked()),
-		SLOT(slotSaveClicked()) );
-}
-
-
-PreviewItemDelegate::~PreviewItemDelegate() {
-	delete d;
-}
-
-
-QSize PreviewItemDelegate::sizeHint( const QStyleOptionViewItem & /*option*/, const QModelIndex & /*index*/ ) const {
-	return d->mView->gridSize();
-}
-
-
-bool PreviewItemDelegate::eventFilter(QObject* object, QEvent* event) {
-	if (object == d->mView->viewport()) {
-		switch (event->type()) {
-		case QEvent::ToolTip:
-			return true;
-
-		case QEvent::HoverMove:
-		case QEvent::HoverLeave:
-			return d->hoverEventFilter(static_cast<QHoverEvent*>(event));
-
-		case QEvent::MouseButtonPress:
-		case QEvent::MouseButtonRelease:
-			return d->mouseButtonEventFilter(event->type());
-
-		default:
-			return false;
-		}
-	} else {
-		// Necessary for the item editor to work correctly (especially closing
-		// the editor with the Escape key)
-		return QItemDelegate::eventFilter(object, event);
-	}
-}
-
-
-void PreviewItemDelegate::paint( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const {
-	int thumbnailSize = d->mThumbnailSize;
-	QSize fullSize;
-	QPixmap thumbnailPix = d->mView->thumbnailForIndex(index, &fullSize);
-	const KFileItem fileItem = fileItemForIndex(index);
-	const bool opaque = !thumbnailPix.hasAlphaChannel();
-	const bool isDirOrArchive = ArchiveUtils::fileItemIsDirOrArchive(fileItem);
-	QRect rect = option.rect;
-	const bool selected = option.state & QStyle::State_Selected;
-	const bool underMouse = option.state & QStyle::State_MouseOver;
-	const QWidget* viewport = d->mView->viewport();
+    connect(view, SIGNAL(thumbnailSizeChanged(int)),
+            SLOT(setThumbnailSize(int)));
+
+    // Button frame
+    d->mContextBar = new QWidget(d->mView->viewport());
+    d->mContextBar->hide();
+
+    d->mToggleSelectionButton = new ContextBarButton("list-add");
+    connect(d->mToggleSelectionButton, SIGNAL(clicked()),
+            SLOT(slotToggleSelectionClicked()));
+
+    d->mFullScreenButton = new ContextBarButton("view-fullscreen");
+    connect(d->mFullScreenButton, SIGNAL(clicked()),
+            SLOT(slotFullScreenClicked()));
+
+    d->mRotateLeftButton = new ContextBarButton("object-rotate-left");
+    connect(d->mRotateLeftButton, SIGNAL(clicked()),
+            SLOT(slotRotateLeftClicked()));
+
+    d->mRotateRightButton = new ContextBarButton("object-rotate-right");
+    connect(d->mRotateRightButton, SIGNAL(clicked()),
+            SLOT(slotRotateRightClicked()));
+
+    QHBoxLayout* layout = new QHBoxLayout(d->mContextBar);
+    layout->setMargin(2);
+    layout->setSpacing(2);
+    layout->addWidget(d->mToggleSelectionButton);
+    layout->addWidget(d->mFullScreenButton);
+    layout->addWidget(d->mRotateLeftButton);
+    layout->addWidget(d->mRotateRightButton);
+
+    // Save button
+    d->mSaveButton = new ContextBarButton("document-save", d->mView->viewport());
+    d->mSaveButton->hide();
+    connect(d->mSaveButton, SIGNAL(clicked()),
+            SLOT(slotSaveClicked()));
+}
+
+PreviewItemDelegate::~PreviewItemDelegate()
+{
+    delete d;
+}
+
+QSize PreviewItemDelegate::sizeHint(const QStyleOptionViewItem & /*option*/, const QModelIndex & /*index*/) const
+{
+    return d->mView->gridSize();
+}
+
+bool PreviewItemDelegate::eventFilter(QObject* object, QEvent* event)
+{
+    if (object == d->mView->viewport()) {
+        switch (event->type()) {
+        case QEvent::ToolTip:
+            return true;
+
+        case QEvent::HoverMove:
+        case QEvent::HoverLeave:
+            return d->hoverEventFilter(static_cast<QHoverEvent*>(event));
+
+        case QEvent::MouseButtonPress:
+        case QEvent::MouseButtonRelease:
+            return d->mouseButtonEventFilter(event->type());
+
+        default:
+            return false;
+        }
+    } else {
+        // Necessary for the item editor to work correctly (especially closing
+        // the editor with the Escape key)
+        return QItemDelegate::eventFilter(object, event);
+    }
+}
+
+void PreviewItemDelegate::paint(QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index) const
+{
+    int thumbnailSize = d->mThumbnailSize;
+    QSize fullSize;
+    QPixmap thumbnailPix = d->mView->thumbnailForIndex(index, &fullSize);
+    const KFileItem fileItem = fileItemForIndex(index);
+    const bool opaque = !thumbnailPix.hasAlphaChannel();
+    const bool isDirOrArchive = ArchiveUtils::fileItemIsDirOrArchive(fileItem);
+    QRect rect = option.rect;
+    const bool selected = option.state & QStyle::State_Selected;
+    const bool underMouse = option.state & QStyle::State_MouseOver;
+    const QWidget* viewport = d->mView->viewport();
 
 #ifdef DEBUG_RECT
-	painter->setPen(Qt::red);
-	painter->setBrush(Qt::NoBrush);
-	painter->drawRect(rect);
+    painter->setPen(Qt::red);
+    painter->setBrush(Qt::NoBrush);
+    painter->drawRect(rect);
 #endif
 
-	// Select color group
-	QPalette::ColorGroup cg;
-
-	if ( (option.state & QStyle::State_Enabled) && (option.state & QStyle::State_Active) ) {
-		cg = QPalette::Normal;
-	} else if ( (option.state & QStyle::State_Enabled)) {
-		cg = QPalette::Inactive;
-	} else {
-		cg = QPalette::Disabled;
-	}
-
-	// Select colors
-	QColor bgColor, borderColor, fgColor;
-	if (selected || underMouse) {
-		bgColor = option.palette.color(cg, QPalette::Highlight);
-		borderColor = bgColor.dark(SELECTION_BORDER_DARKNESS);
-	} else {
-		bgColor = viewport->palette().color(viewport->backgroundRole());
-		borderColor = bgColor.light(200);
-	}
-	fgColor = viewport->palette().color(viewport->foregroundRole());
-
-	// Compute thumbnailRect
-	QRect thumbnailRect = QRect(
-		rect.left() + (rect.width() - thumbnailPix.width())/2,
-		rect.top() + (thumbnailSize - thumbnailPix.height()) + ITEM_MARGIN,
-		thumbnailPix.width(),
-		thumbnailPix.height());
-
-	// Draw background
-	const QRect backgroundRect = thumbnailRect.adjusted(-ITEM_MARGIN, -ITEM_MARGIN, ITEM_MARGIN, ITEM_MARGIN);
-	if (selected) {
-		d->drawBackground(painter, backgroundRect, bgColor, borderColor);
-	} else if (underMouse) {
-		painter->setOpacity(0.2);
-		d->drawBackground(painter, backgroundRect, bgColor, borderColor);
-		painter->setOpacity(1.);
-	} else if (opaque) {
-		d->drawShadow(painter, thumbnailRect);
-	}
-
-	// Draw thumbnail
-	if (opaque) {
-		painter->setPen(borderColor);
-		painter->setRenderHint(QPainter::Antialiasing, false);
-		QRect borderRect = thumbnailRect.adjusted(-1, -1, 0, 0);
-		painter->drawRect(borderRect);
-	}
-	painter->drawPixmap(thumbnailRect.left(), thumbnailRect.top(), thumbnailPix);
-
-	// Draw modified indicator
-	bool isModified = d->mView->isModified(index);
-	if (isModified) {
-		// Draws a pixmap of the save button frame, as an indicator that
-		// the image has been modified
-		QPoint framePosition = d->saveButtonPosition(rect);
-		d->initSaveButtonPixmap();
-		painter->drawPixmap(framePosition, d->mSaveButtonPixmap);
-	}
-
-	// Draw busy indicator
-	if (d->mView->isBusy(index)) {
-		QPixmap pix = d->mView->busySequenceCurrentPixmap();
-		painter->drawPixmap(
-			thumbnailRect.left() + (thumbnailRect.width() - pix.width()) / 2,
-			thumbnailRect.top() + (thumbnailRect.height() - pix.height()) / 2,
-			pix);
-	}
-
-	if (index == d->mIndexUnderCursor) {
-		// Show bar again: if the thumbnail has changed, we may need to update
-		// its position. Don't do it if we are over rotate buttons, though: it
-		// would not be nice to move the button now, the user may want to
-		// rotate the image one more time.
-		// The button will get moved when the mouse leaves.
-		if (!d->mRotateLeftButton->underMouse() && !d->mRotateRightButton->underMouse()) {
-			d->showContextBar(rect, thumbnailPix);
-		}
-		if (isModified) {
-			// If we just rotated the image with the buttons from the
-			// button frame, we need to show the save button frame right now.
-			d->showSaveButton(rect);
-		} else {
-			d->mSaveButton->hide();
-		}
-	}
-
-	QRect textRect(
-		rect.left() + ITEM_MARGIN,
-		rect.top() + 2 * ITEM_MARGIN + thumbnailSize,
-		rect.width() - 2 * ITEM_MARGIN,
-		d->mView->fontMetrics().height());
-	if (isDirOrArchive || (d->mDetails & PreviewItemDelegate::FileNameDetail)) {
-		d->drawText(painter, textRect, fgColor, index.data().toString());
-		textRect.moveTop(textRect.bottom());
-	}
-
-	if (!isDirOrArchive && (d->mDetails & PreviewItemDelegate::DateDetail)) {
-		const KDateTime dt = TimeUtils::dateTimeForFileItem(fileItem);
-		d->drawText(painter, textRect, fgColor, KGlobal::locale()->formatDateTime(dt));
-		textRect.moveTop(textRect.bottom());
-	}
-
-	if (!isDirOrArchive && (d->mDetails & PreviewItemDelegate::ImageSizeDetail)) {
-		if (fullSize.isValid()) {
-			const QString text = QString("%1x%2").arg(fullSize.width()).arg(fullSize.height());
-			d->drawText(painter, textRect, fgColor, text);
-			textRect.moveTop(textRect.bottom());
-		}
-	}
-
-	if (!isDirOrArchive && (d->mDetails & PreviewItemDelegate::FileSizeDetail)) {
-		const KIO::filesize_t size = fileItem.size();
-		if (size > 0) {
-			const QString st = KIO::convertSize(size);
-			d->drawText(painter, textRect, fgColor, st);
-			textRect.moveTop(textRect.bottom());
-		}
-	}
-
-	if (!isDirOrArchive && (d->mDetails & PreviewItemDelegate::RatingDetail)) {
+    // Select color group
+    QPalette::ColorGroup cg;
+
+    if ((option.state & QStyle::State_Enabled) && (option.state & QStyle::State_Active)) {
+        cg = QPalette::Normal;
+    } else if ((option.state & QStyle::State_Enabled)) {
+        cg = QPalette::Inactive;
+    } else {
+        cg = QPalette::Disabled;
+    }
+
+    // Select colors
+    QColor bgColor, borderColor, fgColor;
+    if (selected || underMouse) {
+        bgColor = option.palette.color(cg, QPalette::Highlight);
+        borderColor = bgColor.dark(SELECTION_BORDER_DARKNESS);
+    } else {
+        bgColor = viewport->palette().color(viewport->backgroundRole());
+        borderColor = bgColor.light(200);
+    }
+    fgColor = viewport->palette().color(viewport->foregroundRole());
+
+    // Compute thumbnailRect
+    QRect thumbnailRect = QRect(
+                              rect.left() + (rect.width() - thumbnailPix.width()) / 2,
+                              rect.top() + (thumbnailSize - thumbnailPix.height()) + ITEM_MARGIN,
+                              thumbnailPix.width(),
+                              thumbnailPix.height());
+
+    // Draw background
+    const QRect backgroundRect = thumbnailRect.adjusted(-ITEM_MARGIN, -ITEM_MARGIN, ITEM_MARGIN, ITEM_MARGIN);
+    if (selected) {
+        d->drawBackground(painter, backgroundRect, bgColor, borderColor);
+    } else if (underMouse) {
+        painter->setOpacity(0.2);
+        d->drawBackground(painter, backgroundRect, bgColor, borderColor);
+        painter->setOpacity(1.);
+    } else if (opaque) {
+        d->drawShadow(painter, thumbnailRect);
+    }
+
+    // Draw thumbnail
+    if (opaque) {
+        painter->setPen(borderColor);
+        painter->setRenderHint(QPainter::Antialiasing, false);
+        QRect borderRect = thumbnailRect.adjusted(-1, -1, 0, 0);
+        painter->drawRect(borderRect);
+    }
+    painter->drawPixmap(thumbnailRect.left(), thumbnailRect.top(), thumbnailPix);
+
+    // Draw modified indicator
+    bool isModified = d->mView->isModified(index);
+    if (isModified) {
+        // Draws a pixmap of the save button frame, as an indicator that
+        // the image has been modified
+        QPoint framePosition = d->saveButtonPosition(rect);
+        d->initSaveButtonPixmap();
+        painter->drawPixmap(framePosition, d->mSaveButtonPixmap);
+    }
+
+    // Draw busy indicator
+    if (d->mView->isBusy(index)) {
+        QPixmap pix = d->mView->busySequenceCurrentPixmap();
+        painter->drawPixmap(
+            thumbnailRect.left() + (thumbnailRect.width() - pix.width()) / 2,
+            thumbnailRect.top() + (thumbnailRect.height() - pix.height()) / 2,
+            pix);
+    }
+
+    if (index == d->mIndexUnderCursor) {
+        // Show bar again: if the thumbnail has changed, we may need to update
+        // its position. Don't do it if we are over rotate buttons, though: it
+        // would not be nice to move the button now, the user may want to
+        // rotate the image one more time.
+        // The button will get moved when the mouse leaves.
+        if (!d->mRotateLeftButton->underMouse() && !d->mRotateRightButton->underMouse()) {
+            d->showContextBar(rect, thumbnailPix);
+        }
+        if (isModified) {
+            // If we just rotated the image with the buttons from the
+            // button frame, we need to show the save button frame right now.
+            d->showSaveButton(rect);
+        } else {
+            d->mSaveButton->hide();
+        }
+    }
+
+    QRect textRect(
+        rect.left() + ITEM_MARGIN,
+        rect.top() + 2 * ITEM_MARGIN + thumbnailSize,
+        rect.width() - 2 * ITEM_MARGIN,
+        d->mView->fontMetrics().height());
+    if (isDirOrArchive || (d->mDetails & PreviewItemDelegate::FileNameDetail)) {
+        d->drawText(painter, textRect, fgColor, index.data().toString());
+        textRect.moveTop(textRect.bottom());
+    }
+
+    if (!isDirOrArchive && (d->mDetails & PreviewItemDelegate::DateDetail)) {
+        const KDateTime dt = TimeUtils::dateTimeForFileItem(fileItem);
+        d->drawText(painter, textRect, fgColor, KGlobal::locale()->formatDateTime(dt));
+        textRect.moveTop(textRect.bottom());
+    }
+
+    if (!isDirOrArchive && (d->mDetails & PreviewItemDelegate::ImageSizeDetail)) {
+        if (fullSize.isValid()) {
+            const QString text = QString("%1x%2").arg(fullSize.width()).arg(fullSize.height());
+            d->drawText(painter, textRect, fgColor, text);
+            textRect.moveTop(textRect.bottom());
+        }
+    }
+
+    if (!isDirOrArchive && (d->mDetails & PreviewItemDelegate::FileSizeDetail)) {
+        const KIO::filesize_t size = fileItem.size();
+        if (size > 0) {
+            const QString st = KIO::convertSize(size);
+            d->drawText(painter, textRect, fgColor, st);
+            textRect.moveTop(textRect.bottom());
+        }
+    }
+
+    if (!isDirOrArchive && (d->mDetails & PreviewItemDelegate::RatingDetail)) {
 #ifndef GWENVIEW_SEMANTICINFO_BACKEND_NONE
-		d->drawRating(painter, rect, index.data(SemanticInfoDirModel::RatingRole));
+        d->drawRating(painter, rect, index.data(SemanticInfoDirModel::RatingRole));
 #endif
-	}
-}
-
-
-void PreviewItemDelegate::setThumbnailSize(int value) {
-	d->mThumbnailSize = value;
-	d->updateViewGridSize();
-	d->updateContextBar();
-	d->mElidedTextCache.clear();
-}
-
-
-void PreviewItemDelegate::slotSaveClicked() {
-	saveDocumentRequested(urlForIndex(d->mIndexUnderCursor));
-}
-
-
-void PreviewItemDelegate::slotRotateLeftClicked() {
-	d->selectIndexUnderCursorIfNoMultiSelection();
-	rotateDocumentLeftRequested(urlForIndex(d->mIndexUnderCursor));
-}
-
-
-void PreviewItemDelegate::slotRotateRightClicked() {
-	d->selectIndexUnderCursorIfNoMultiSelection();
-	rotateDocumentRightRequested(urlForIndex(d->mIndexUnderCursor));
-}
-
-
-void PreviewItemDelegate::slotFullScreenClicked() {
-	showDocumentInFullScreenRequested(urlForIndex(d->mIndexUnderCursor));
-}
-
-
-void PreviewItemDelegate::slotToggleSelectionClicked() {
-	d->mView->selectionModel()->select(d->mIndexUnderCursor, QItemSelectionModel::Toggle);
-	d->updateToggleSelectionButton();
-}
-
-
-PreviewItemDelegate::ThumbnailDetails PreviewItemDelegate::thumbnailDetails() const {
-	return d->mDetails;
-}
-
-
-void PreviewItemDelegate::setThumbnailDetails(PreviewItemDelegate::ThumbnailDetails details) {
-	d->mDetails = details;
-	d->updateViewGridSize();
-	d->mView->scheduleDelayedItemsLayout();
-}
-
-
-PreviewItemDelegate::ContextBarMode PreviewItemDelegate::contextBarMode() const {
-	return d->mContextBarMode;
-}
-
-
-void PreviewItemDelegate::setContextBarMode(PreviewItemDelegate::ContextBarMode mode) {
-	d->mContextBarMode = mode;
-	d->updateContextBar();
-}
-
-
-Qt::TextElideMode PreviewItemDelegate::textElideMode() const {
-	return d->mTextElideMode;
-}
-
-
-void PreviewItemDelegate::setTextElideMode(Qt::TextElideMode mode) {
-	if (d->mTextElideMode == mode) {
-		return;
-	}
-	d->mTextElideMode = mode;
-	d->mElidedTextCache.clear();
-	d->mView->viewport()->update();
-}
-
-
-void PreviewItemDelegate::slotRowsChanged() {
-	// We need to update hover ui because the current index may have
-	// disappeared: for example if the current image is removed with "del".
-	QPoint pos = d->mView->viewport()->mapFromGlobal(QCursor::pos());
-	QModelIndex index = d->mView->indexAt(pos);
-	d->updateHoverUi(index);
-}
-
-
-QWidget * PreviewItemDelegate::createEditor(QWidget* parent, const QStyleOptionViewItem& /*option*/, const QModelIndex& /*index*/) const {
-	return new ItemEditor(parent);
-}
-
-
-void PreviewItemDelegate::setEditorData(QWidget* widget, const QModelIndex& index) const {
-	ItemEditor* edit = qobject_cast<ItemEditor*>(widget);
-	if (!edit) {
-		return;
-	}
-	edit->setText(index.data().toString());
-}
-
-
-void PreviewItemDelegate::updateEditorGeometry(QWidget* widget, const QStyleOptionViewItem& option, const QModelIndex& index) const {
-	ItemEditor* edit = qobject_cast<ItemEditor*>(widget);
-	if (!edit) {
-		return;
-	}
-	QString text = index.data().toString();
-	int textWidth = edit->fontMetrics().width("  " + text + "  ");
-	QRect textRect(
-		option.rect.left() + (option.rect.width() - textWidth) / 2,
-		option.rect.top() + 2 * ITEM_MARGIN + d->mThumbnailSize,
-		textWidth,
-		edit->sizeHint().height());
-
-	edit->setGeometry(textRect);
-}
-
-
-void PreviewItemDelegate::setModelData(QWidget* widget, QAbstractItemModel* model, const QModelIndex& index) const {
-	ItemEditor* edit = qobject_cast<ItemEditor*>(widget);
-	if (!edit) {
-		return;
-	}
-	if (index.data().toString() != edit->text()) {
-		model->setData(index, edit->text(), Qt::EditRole);
-	}
+    }
+}
+
+void PreviewItemDelegate::setThumbnailSize(int value)
+{
+    d->mThumbnailSize = value;
+    d->updateViewGridSize();
+    d->updateContextBar();
+    d->mElidedTextCache.clear();
+}
+
+void PreviewItemDelegate::slotSaveClicked()
+{
+    saveDocumentRequested(urlForIndex(d->mIndexUnderCursor));
+}
+
+void PreviewItemDelegate::slotRotateLeftClicked()
+{
+    d->selectIndexUnderCursorIfNoMultiSelection();
+    rotateDocumentLeftRequested(urlForIndex(d->mIndexUnderCursor));
+}
+
+void PreviewItemDelegate::slotRotateRightClicked()
+{
+    d->selectIndexUnderCursorIfNoMultiSelection();
+    rotateDocumentRightRequested(urlForIndex(d->mIndexUnderCursor));
+}
+
+void PreviewItemDelegate::slotFullScreenClicked()
+{
+    showDocumentInFullScreenRequested(urlForIndex(d->mIndexUnderCursor));
+}
+
+void PreviewItemDelegate::slotToggleSelectionClicked()
+{
+    d->mView->selectionModel()->select(d->mIndexUnderCursor, QItemSelectionModel::Toggle);
+    d->updateToggleSelectionButton();
+}
+
+PreviewItemDelegate::ThumbnailDetails PreviewItemDelegate::thumbnailDetails() const
+{
+    return d->mDetails;
+}
+
+void PreviewItemDelegate::setThumbnailDetails(PreviewItemDelegate::ThumbnailDetails details)
+{
+    d->mDetails = details;
+    d->updateViewGridSize();
+    d->mView->scheduleDelayedItemsLayout();
+}
+
+PreviewItemDelegate::ContextBarMode PreviewItemDelegate::contextBarMode() const
+{
+    return d->mContextBarMode;
+}
+
+void PreviewItemDelegate::setContextBarMode(PreviewItemDelegate::ContextBarMode mode)
+{
+    d->mContextBarMode = mode;
+    d->updateContextBar();
+}
+
+Qt::TextElideMode PreviewItemDelegate::textElideMode() const
+{
+    return d->mTextElideMode;
+}
+
+void PreviewItemDelegate::setTextElideMode(Qt::TextElideMode mode)
+{
+    if (d->mTextElideMode == mode) {
+        return;
+    }
+    d->mTextElideMode = mode;
+    d->mElidedTextCache.clear();
+    d->mView->viewport()->update();
+}
+
+void PreviewItemDelegate::slotRowsChanged()
+{
+    // We need to update hover ui because the current index may have
+    // disappeared: for example if the current image is removed with "del".
+    QPoint pos = d->mView->viewport()->mapFromGlobal(QCursor::pos());
+    QModelIndex index = d->mView->indexAt(pos);
+    d->updateHoverUi(index);
+}
+
+QWidget * PreviewItemDelegate::createEditor(QWidget* parent, const QStyleOptionViewItem& /*option*/, const QModelIndex& /*index*/) const
+{
+    return new ItemEditor(parent);
+}
+
+void PreviewItemDelegate::setEditorData(QWidget* widget, const QModelIndex& index) const
+{
+    ItemEditor* edit = qobject_cast<ItemEditor*>(widget);
+    if (!edit) {
+        return;
+    }
+    edit->setText(index.data().toString());
+}
+
+void PreviewItemDelegate::updateEditorGeometry(QWidget* widget, const QStyleOptionViewItem& option, const QModelIndex& index) const
+{
+    ItemEditor* edit = qobject_cast<ItemEditor*>(widget);
+    if (!edit) {
+        return;
+    }
+    QString text = index.data().toString();
+    int textWidth = edit->fontMetrics().width("  " + text + "  ");
+    QRect textRect(
+        option.rect.left() + (option.rect.width() - textWidth) / 2,
+        option.rect.top() + 2 * ITEM_MARGIN + d->mThumbnailSize,
+        textWidth,
+        edit->sizeHint().height());
+
+    edit->setGeometry(textRect);
+}
+
+void PreviewItemDelegate::setModelData(QWidget* widget, QAbstractItemModel* model, const QModelIndex& index) const
+{
+    ItemEditor* edit = qobject_cast<ItemEditor*>(widget);
+    if (!edit) {
+        return;
+    }
+    if (index.data().toString() != edit->text()) {
+        model->setData(index, edit->text(), Qt::EditRole);
+    }
 }
 
 } // namespace

=== modified file 'lib/thumbnailview/previewitemdelegate.h'
--- lib/thumbnailview/previewitemdelegate.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/previewitemdelegate.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,90 +32,89 @@
 
 class KUrl;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class ThumbnailView;
 
-
 struct PreviewItemDelegatePrivate;
 
 /**
  * An ItemDelegate which generates thumbnails for images. It also makes sure
  * all items are of the same size.
  */
-class GWENVIEWLIB_EXPORT PreviewItemDelegate : public QItemDelegate {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT PreviewItemDelegate : public QItemDelegate
+{
+    Q_OBJECT
 public:
-	PreviewItemDelegate(ThumbnailView*);
-	~PreviewItemDelegate();
-
-	enum ContextBarMode {
-		NoContextBar,            /** Do not show context bar at all */
-		SelectionOnlyContextBar, /** Only show the +/- button */
-		FullContextBar           /** Show all buttons, provided there is enough room */
-	};
-
-	enum ThumbnailDetail {
-		FileNameDetail  = 1,
-		DateDetail      = 2,
-		RatingDetail    = 4,
-		ImageSizeDetail = 8,
-		FileSizeDetail  = 16
-	};
-	// FIXME: Find out why this cause problems with Qt::Alignment in
-	// PreviewItemDelegate!
-	Q_DECLARE_FLAGS(ThumbnailDetails, ThumbnailDetail)
-
-	/**
-	 * Returns which thumbnail details are shown
-	 */
-	ThumbnailDetails thumbnailDetails() const;
-
-	void setThumbnailDetails(ThumbnailDetails);
-
-	ContextBarMode contextBarMode() const;
-
-	void setContextBarMode(ContextBarMode);
-
-	Qt::TextElideMode textElideMode() const;
-
-	void setTextElideMode(Qt::TextElideMode);
-
-	virtual QWidget* createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index ) const;
-	virtual void setEditorData(QWidget* editor, const QModelIndex& index) const;
-	virtual void setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const;
-	virtual void updateEditorGeometry(QWidget* editor, const QStyleOptionViewItem& option, const QModelIndex& index) const;
-
-	virtual void paint( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const;
-	virtual QSize sizeHint( const QStyleOptionViewItem & /*option*/, const QModelIndex & /*index*/ ) const;
+    PreviewItemDelegate(ThumbnailView*);
+    ~PreviewItemDelegate();
+
+    enum ContextBarMode {
+        NoContextBar,            /** Do not show context bar at all */
+        SelectionOnlyContextBar, /** Only show the +/- button */
+        FullContextBar           /** Show all buttons, provided there is enough room */
+    };
+
+    enum ThumbnailDetail {
+        FileNameDetail  = 1,
+        DateDetail      = 2,
+        RatingDetail    = 4,
+        ImageSizeDetail = 8,
+        FileSizeDetail  = 16
+    };
+    // FIXME: Find out why this cause problems with Qt::Alignment in
+    // PreviewItemDelegate!
+    Q_DECLARE_FLAGS(ThumbnailDetails, ThumbnailDetail)
+
+    /**
+     * Returns which thumbnail details are shown
+     */
+    ThumbnailDetails thumbnailDetails() const;
+
+    void setThumbnailDetails(ThumbnailDetails);
+
+    ContextBarMode contextBarMode() const;
+
+    void setContextBarMode(ContextBarMode);
+
+    Qt::TextElideMode textElideMode() const;
+
+    void setTextElideMode(Qt::TextElideMode);
+
+    virtual QWidget* createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const;
+    virtual void setEditorData(QWidget* editor, const QModelIndex& index) const;
+    virtual void setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const;
+    virtual void updateEditorGeometry(QWidget* editor, const QStyleOptionViewItem& option, const QModelIndex& index) const;
+
+    virtual void paint(QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index) const;
+    virtual QSize sizeHint(const QStyleOptionViewItem & /*option*/, const QModelIndex & /*index*/) const;
 
 Q_SIGNALS:
-	void saveDocumentRequested(const KUrl&);
-	void rotateDocumentLeftRequested(const KUrl&);
-	void rotateDocumentRightRequested(const KUrl&);
-	void showDocumentInFullScreenRequested(const KUrl&);
-	void setDocumentRatingRequested(const KUrl&, int rating);
+    void saveDocumentRequested(const KUrl&);
+    void rotateDocumentLeftRequested(const KUrl&);
+    void rotateDocumentRightRequested(const KUrl&);
+    void showDocumentInFullScreenRequested(const KUrl&);
+    void setDocumentRatingRequested(const KUrl&, int rating);
 
 private Q_SLOTS:
-	void setThumbnailSize(int);
+    void setThumbnailSize(int);
 
-	void slotSaveClicked();
-	void slotRotateLeftClicked();
-	void slotRotateRightClicked();
-	void slotFullScreenClicked();
-	void slotToggleSelectionClicked();
-	void slotRowsChanged();
+    void slotSaveClicked();
+    void slotRotateLeftClicked();
+    void slotRotateRightClicked();
+    void slotFullScreenClicked();
+    void slotToggleSelectionClicked();
+    void slotRowsChanged();
 
 protected:
-	virtual bool eventFilter(QObject*, QEvent*);
+    virtual bool eventFilter(QObject*, QEvent*);
 
 private:
-	PreviewItemDelegatePrivate* const d;
-	friend struct PreviewItemDelegatePrivate;
+    PreviewItemDelegatePrivate* const d;
+    friend struct PreviewItemDelegatePrivate;
 };
 
-
 } // namespace
 
 // See upper

=== modified file 'lib/thumbnailview/thumbnailbarview.cpp'
--- lib/thumbnailview/thumbnailbarview.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/thumbnailbarview.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -42,7 +42,8 @@
 #include "lib/thumbnailview/abstractthumbnailviewhelper.h"
 #include "lib/thumbnailview/contextbarbutton.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 /**
  * Duration in ms of the smooth scroll
@@ -61,424 +62,430 @@
 /** How many pixels around the thumbnail are shadowed */
 const int SHADOW_SIZE = 4;
 
-
 struct ThumbnailBarItemDelegatePrivate {
-	// Key is height * 1000 + width
-	typedef QMap<int, QPixmap> ShadowCache;
-	mutable ShadowCache mShadowCache;
-
-	ThumbnailBarItemDelegate* mDelegate;
-	ThumbnailView* mView;
-	ContextBarButton* mToggleSelectionButton;
-
-	QColor mBorderColor;
-	QModelIndex mIndexUnderCursor;
-
-	void setupToggleSelectionButton() {
-		mToggleSelectionButton = new ContextBarButton("list-add", mView->viewport());
-		mToggleSelectionButton->hide();
-		QObject::connect(mToggleSelectionButton, SIGNAL(clicked(bool)), mDelegate, SLOT(toggleSelection()));
-	}
-
-	void showToolTip(QHelpEvent* helpEvent) {
-		QModelIndex index = mView->indexAt(helpEvent->pos());
-		if (!index.isValid()) {
-			return;
-		}
-		QString fullText = index.data().toString();
-		QPoint pos = QCursor::pos();
-		QToolTip::showText(pos, fullText, mView);
-	}
-
-	void drawShadow(QPainter* painter, const QRect& rect) const {
-		const QPoint shadowOffset(-SHADOW_SIZE, -SHADOW_SIZE + 1);
-
-		int key = rect.height() * 1000 + rect.width();
-
-		ShadowCache::Iterator it = mShadowCache.find(key);
-		if (it == mShadowCache.end()) {
-			QSize size = QSize(rect.width() + 2*SHADOW_SIZE, rect.height() + 2*SHADOW_SIZE);
-			QColor color(0, 0, 0, SHADOW_STRENGTH);
-			QPixmap shadow = PaintUtils::generateFuzzyRect(size, color, SHADOW_SIZE);
-			it = mShadowCache.insert(key, shadow);
-		}
-		painter->drawPixmap(rect.topLeft() + shadowOffset, it.value());
-	}
-
-	bool hoverEventFilter(QHoverEvent* event) {
-		QModelIndex index = mView->indexAt(event->pos());
-		if (index != mIndexUnderCursor) {
-			updateHoverUi(index);
-		}
-		return false;
-	}
-
-	void updateHoverUi(const QModelIndex& index) {
-		QModelIndex oldIndex = mIndexUnderCursor;
-		mIndexUnderCursor = index;
-
-		if (mIndexUnderCursor.isValid()) {
-			updateToggleSelectionButton();
-
-			const QRect rect = mView->visualRect(mIndexUnderCursor);
-			mToggleSelectionButton->move(rect.topLeft() + QPoint(2, 2));
-			mToggleSelectionButton->show();
-		} else {
-			mToggleSelectionButton->hide();
-		}
-	}
-
-	void updateToggleSelectionButton() {
-		bool isSelected = mView->selectionModel()->isSelected(mIndexUnderCursor);
-		mToggleSelectionButton->setIcon(SmallIcon(isSelected ? "list-remove" : "list-add"));
-	}
+    // Key is height * 1000 + width
+    typedef QMap<int, QPixmap> ShadowCache;
+    mutable ShadowCache mShadowCache;
+
+    ThumbnailBarItemDelegate* q;
+    ThumbnailView* mView;
+    ContextBarButton* mToggleSelectionButton;
+
+    QColor mBorderColor;
+    QModelIndex mIndexUnderCursor;
+
+    void setupToggleSelectionButton()
+    {
+        mToggleSelectionButton = new ContextBarButton("list-add", mView->viewport());
+        mToggleSelectionButton->hide();
+        QObject::connect(mToggleSelectionButton, SIGNAL(clicked(bool)), q, SLOT(toggleSelection()));
+    }
+
+    void showToolTip(QHelpEvent* helpEvent)
+    {
+        QModelIndex index = mView->indexAt(helpEvent->pos());
+        if (!index.isValid()) {
+            return;
+        }
+        QString fullText = index.data().toString();
+        QPoint pos = QCursor::pos();
+        QToolTip::showText(pos, fullText, mView);
+    }
+
+    void drawShadow(QPainter* painter, const QRect& rect) const
+    {
+        const QPoint shadowOffset(-SHADOW_SIZE, -SHADOW_SIZE + 1);
+
+        int key = rect.height() * 1000 + rect.width();
+
+        ShadowCache::Iterator it = mShadowCache.find(key);
+        if (it == mShadowCache.end()) {
+            QSize size = QSize(rect.width() + 2 * SHADOW_SIZE, rect.height() + 2 * SHADOW_SIZE);
+            QColor color(0, 0, 0, SHADOW_STRENGTH);
+            QPixmap shadow = PaintUtils::generateFuzzyRect(size, color, SHADOW_SIZE);
+            it = mShadowCache.insert(key, shadow);
+        }
+        painter->drawPixmap(rect.topLeft() + shadowOffset, it.value());
+    }
+
+    bool hoverEventFilter(QHoverEvent* event)
+    {
+        QModelIndex index = mView->indexAt(event->pos());
+        if (index != mIndexUnderCursor) {
+            updateHoverUi(index);
+        }
+        return false;
+    }
+
+    void updateHoverUi(const QModelIndex& index)
+    {
+        QModelIndex oldIndex = mIndexUnderCursor;
+        mIndexUnderCursor = index;
+
+        if (mIndexUnderCursor.isValid()) {
+            updateToggleSelectionButton();
+
+            const QRect rect = mView->visualRect(mIndexUnderCursor);
+            mToggleSelectionButton->move(rect.topLeft() + QPoint(2, 2));
+            mToggleSelectionButton->show();
+        } else {
+            mToggleSelectionButton->hide();
+        }
+    }
+
+    void updateToggleSelectionButton()
+    {
+        bool isSelected = mView->selectionModel()->isSelected(mIndexUnderCursor);
+        mToggleSelectionButton->setIcon(SmallIcon(isSelected ? "list-remove" : "list-add"));
+    }
 };
 
-
 ThumbnailBarItemDelegate::ThumbnailBarItemDelegate(ThumbnailView* view)
 : QAbstractItemDelegate(view)
-, d(new ThumbnailBarItemDelegatePrivate) {
-	d->mDelegate = this;
-	d->mView = view;
-	d->setupToggleSelectionButton();
-	view->viewport()->installEventFilter(this);
-
-	d->mBorderColor = PaintUtils::alphaAdjustedF(QColor(Qt::white), 0.65);
-}
-
-
-QSize ThumbnailBarItemDelegate::sizeHint( const QStyleOptionViewItem & /*option*/, const QModelIndex & /*index*/) const {
-	return d->mView->gridSize();
-}
-
-
-bool ThumbnailBarItemDelegate::eventFilter(QObject*, QEvent* event) {
-	switch (event->type()) {
-	case QEvent::ToolTip:
-		d->showToolTip(static_cast<QHelpEvent*>(event));
-		return true;
-	case QEvent::HoverMove:
-	case QEvent::HoverLeave:
-		return d->hoverEventFilter(static_cast<QHoverEvent*>(event));
-	default:
-		break;
-	}
-
-	return false;
-}
-
-
-void ThumbnailBarItemDelegate::paint( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const {
-	bool isSelected = option.state & QStyle::State_Selected;
-	bool isCurrent = d->mView->selectionModel()->currentIndex() == index;
-	QPixmap thumbnailPix = d->mView->thumbnailForIndex(index);
-	QRect rect = option.rect;
-
-	QStyleOptionViewItemV4 opt = option;
-	const QWidget* widget = opt.widget;
-	QStyle* style = widget ? widget->style() : QApplication::style();
-	if (isSelected && !isCurrent) {
-		// Draw selected but not current item backgrounds with some transparency
-		// so that the current item stands out.
-		painter->setOpacity(.33);
-	}
-	style->drawControl(QStyle::CE_ItemViewItem, &opt, painter, widget);
-	painter->setOpacity(1);
-
-	// Draw thumbnail
-	if (!thumbnailPix.isNull()) {
-		QRect thumbnailRect = QRect(
-			rect.left() + (rect.width() - thumbnailPix.width())/2,
-			rect.top() + (rect.height() - thumbnailPix.height())/2 - 1,
-			thumbnailPix.width(),
-			thumbnailPix.height());
-
-		if (!thumbnailPix.hasAlphaChannel()) {
-			d->drawShadow(painter, thumbnailRect);
-			painter->setPen(d->mBorderColor);
-			painter->setRenderHint(QPainter::Antialiasing, false);
-			QRect borderRect = thumbnailRect.adjusted(-1, -1, 0, 0);
-			painter->drawRect(borderRect);
-		}
-		painter->drawPixmap(thumbnailRect.left(), thumbnailRect.top(), thumbnailPix);
-
-		// Draw busy indicator
-		if (d->mView->isBusy(index)) {
-			QPixmap pix = d->mView->busySequenceCurrentPixmap();
-			painter->drawPixmap(
-				thumbnailRect.left() + (thumbnailRect.width() - pix.width()) / 2,
-				thumbnailRect.top() + (thumbnailRect.height() - pix.height()) / 2,
-				pix);
-		}
-	}
-}
-
-
-void ThumbnailBarItemDelegate::toggleSelection() {
-	d->mView->selectionModel()->select(d->mIndexUnderCursor, QItemSelectionModel::Toggle);
-	d->updateToggleSelectionButton();
-}
-
-
-ThumbnailBarItemDelegate::~ThumbnailBarItemDelegate() {
-	delete d;
-}
-
+, d(new ThumbnailBarItemDelegatePrivate)
+{
+    d->q = this;
+    d->mView = view;
+    d->setupToggleSelectionButton();
+    view->viewport()->installEventFilter(this);
+
+    d->mBorderColor = PaintUtils::alphaAdjustedF(QColor(Qt::white), 0.65);
+}
+
+QSize ThumbnailBarItemDelegate::sizeHint(const QStyleOptionViewItem & /*option*/, const QModelIndex & /*index*/) const
+{
+    return d->mView->gridSize();
+}
+
+bool ThumbnailBarItemDelegate::eventFilter(QObject*, QEvent* event)
+{
+    switch (event->type()) {
+    case QEvent::ToolTip:
+        d->showToolTip(static_cast<QHelpEvent*>(event));
+        return true;
+    case QEvent::HoverMove:
+    case QEvent::HoverLeave:
+        return d->hoverEventFilter(static_cast<QHoverEvent*>(event));
+    default:
+        break;
+    }
+
+    return false;
+}
+
+void ThumbnailBarItemDelegate::paint(QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index) const
+{
+    bool isSelected = option.state & QStyle::State_Selected;
+    bool isCurrent = d->mView->selectionModel()->currentIndex() == index;
+    QPixmap thumbnailPix = d->mView->thumbnailForIndex(index);
+    QRect rect = option.rect;
+
+    QStyleOptionViewItemV4 opt = option;
+    const QWidget* widget = opt.widget;
+    QStyle* style = widget ? widget->style() : QApplication::style();
+    if (isSelected && !isCurrent) {
+        // Draw selected but not current item backgrounds with some transparency
+        // so that the current item stands out.
+        painter->setOpacity(.33);
+    }
+    style->drawControl(QStyle::CE_ItemViewItem, &opt, painter, widget);
+    painter->setOpacity(1);
+
+    // Draw thumbnail
+    if (!thumbnailPix.isNull()) {
+        QRect thumbnailRect = QRect(
+                                  rect.left() + (rect.width() - thumbnailPix.width()) / 2,
+                                  rect.top() + (rect.height() - thumbnailPix.height()) / 2 - 1,
+                                  thumbnailPix.width(),
+                                  thumbnailPix.height());
+
+        if (!thumbnailPix.hasAlphaChannel()) {
+            d->drawShadow(painter, thumbnailRect);
+            painter->setPen(d->mBorderColor);
+            painter->setRenderHint(QPainter::Antialiasing, false);
+            QRect borderRect = thumbnailRect.adjusted(-1, -1, 0, 0);
+            painter->drawRect(borderRect);
+        }
+        painter->drawPixmap(thumbnailRect.left(), thumbnailRect.top(), thumbnailPix);
+
+        // Draw busy indicator
+        if (d->mView->isBusy(index)) {
+            QPixmap pix = d->mView->busySequenceCurrentPixmap();
+            painter->drawPixmap(
+                thumbnailRect.left() + (thumbnailRect.width() - pix.width()) / 2,
+                thumbnailRect.top() + (thumbnailRect.height() - pix.height()) / 2,
+                pix);
+        }
+    }
+}
+
+void ThumbnailBarItemDelegate::toggleSelection()
+{
+    d->mView->selectionModel()->select(d->mIndexUnderCursor, QItemSelectionModel::Toggle);
+    d->updateToggleSelectionButton();
+}
+
+ThumbnailBarItemDelegate::~ThumbnailBarItemDelegate()
+{
+    delete d;
+}
 
 /**
  * This proxy style makes it possible to override the value returned by
  * styleHint() which leads to not-so-nice results with some styles.
  */
-class ProxyStyle : public QWindowsStyle {
+class ProxyStyle : public QWindowsStyle
+{
 public:
-	ProxyStyle(QStyle* baseStyle) : QWindowsStyle() {
-		mBaseStyle = baseStyle;
-	}
-
-	void drawPrimitive(PrimitiveElement pe, const QStyleOption *opt, QPainter *p, const QWidget *w = 0) const {
-		mBaseStyle->drawPrimitive(pe, opt, p, w);
-	}
-
-	void drawControl(ControlElement element, const QStyleOption *opt, QPainter *p, const QWidget *w = 0) const {
-		mBaseStyle->drawControl(element, opt, p, w);
-	}
-
-	void drawComplexControl(ComplexControl cc, const QStyleOptionComplex *opt, QPainter *p, const QWidget *w = 0) const {
-		mBaseStyle->drawComplexControl(cc, opt, p, w);
-	}
-
-	int styleHint(StyleHint sh, const QStyleOption *opt = 0, const QWidget *w = 0, QStyleHintReturn *shret = 0) const {
-		switch (sh) {
-		case SH_ItemView_ShowDecorationSelected:
-			return true;
-		case SH_ScrollView_FrameOnlyAroundContents:
-			return false;
-		default:
-			return QWindowsStyle::styleHint(sh, opt, w, shret);
-		}
-	}
-
-	void polish(QApplication* application) {
-		mBaseStyle->polish(application);
-	}
-
-	void polish(QPalette& palette) {
-		mBaseStyle->polish(palette);
-	}
-
-	void polish(QWidget* widget) {
-		mBaseStyle->polish(widget);
-	}
-
-	void unpolish(QWidget* widget) {
-		mBaseStyle->unpolish(widget);
-	}
-
-	void unpolish(QApplication* application) {
-		mBaseStyle->unpolish(application);
-	}
-
-	int pixelMetric(PixelMetric pm, const QStyleOption* opt, const QWidget* widget) const {
-		switch (pm) {
-		case PM_MaximumDragDistance:
-			return -1;
-		default:
-			return QWindowsStyle::pixelMetric(pm, opt, widget);
-		}
-	}
+    ProxyStyle(QStyle* baseStyle) : QWindowsStyle() {
+        mBaseStyle = baseStyle;
+    }
+
+    void drawPrimitive(PrimitiveElement pe, const QStyleOption *opt, QPainter *p, const QWidget *w = 0) const
+    {
+        mBaseStyle->drawPrimitive(pe, opt, p, w);
+    }
+
+    void drawControl(ControlElement element, const QStyleOption *opt, QPainter *p, const QWidget *w = 0) const
+    {
+        mBaseStyle->drawControl(element, opt, p, w);
+    }
+
+    void drawComplexControl(ComplexControl cc, const QStyleOptionComplex *opt, QPainter *p, const QWidget *w = 0) const
+    {
+        mBaseStyle->drawComplexControl(cc, opt, p, w);
+    }
+
+    int styleHint(StyleHint sh, const QStyleOption *opt = 0, const QWidget *w = 0, QStyleHintReturn *shret = 0) const {
+        switch (sh) {
+        case SH_ItemView_ShowDecorationSelected:
+            return true;
+        case SH_ScrollView_FrameOnlyAroundContents:
+            return false;
+        default:
+            return QWindowsStyle::styleHint(sh, opt, w, shret);
+        }
+    }
+
+    void polish(QApplication* application)
+    {
+        mBaseStyle->polish(application);
+    }
+
+    void polish(QPalette& palette)
+    {
+        mBaseStyle->polish(palette);
+    }
+
+    void polish(QWidget* widget)
+    {
+        mBaseStyle->polish(widget);
+    }
+
+    void unpolish(QWidget* widget)
+    {
+        mBaseStyle->unpolish(widget);
+    }
+
+    void unpolish(QApplication* application)
+    {
+        mBaseStyle->unpolish(application);
+    }
+
+    int pixelMetric(PixelMetric pm, const QStyleOption* opt, const QWidget* widget) const {
+        switch (pm) {
+        case PM_MaximumDragDistance:
+            return -1;
+        default:
+            return QWindowsStyle::pixelMetric(pm, opt, widget);
+        }
+    }
 
 private:
-	QStyle* mBaseStyle;
+    QStyle* mBaseStyle;
 };
 
-
-
 typedef int (QSize::*QSizeDimension)() const;
 
 struct ThumbnailBarViewPrivate {
-	ThumbnailBarView* q;
-	QStyle* mStyle;
-	QTimeLine* mTimeLine;
-
-	Qt::Orientation mOrientation;
-	int mRowCount;
-
-
-	QScrollBar* scrollBar() const {
-		return mOrientation == Qt::Horizontal ? q->horizontalScrollBar() : q->verticalScrollBar();
-	}
-
-
-	QSizeDimension mainDimension() const {
-		return mOrientation == Qt::Horizontal ? &QSize::width : &QSize::height;
-	}
-
-
-	QSizeDimension oppositeDimension() const {
-		return mOrientation == Qt::Horizontal ? &QSize::height : &QSize::width;
-	}
-
-
-	void smoothScrollTo(const QModelIndex& index) {
-		if (!index.isValid()) {
-			return;
-		}
-
-		const QRect rect = q->visualRect(index);
-
-		int oldValue = scrollBar()->value();
-		int newValue = scrollToValue(rect);
-		if (mTimeLine->state() == QTimeLine::Running) {
-			mTimeLine->stop();
-		}
-		mTimeLine->setFrameRange(oldValue, newValue);
-		mTimeLine->start();
-	}
-
-
-	int scrollToValue(const QRect& rect) {
-		// This code is a much simplified version of
-		// QListViewPrivate::horizontalScrollToValue()
-		const QRect area = q->viewport()->rect();
-		int value = scrollBar()->value();
-
-		if (mOrientation == Qt::Horizontal) {
-			if (q->isRightToLeft()) {
-				value += (area.width() - rect.width()) / 2 - rect.left();
-			} else {
-				value += rect.left() - (area.width()- rect.width()) / 2;
-			}
-		} else {
-			value += rect.top() - (area.height() - rect.height()) / 2;
-		}
-		return value;
-	}
-
-
-	void updateMinMaxSizes() {
-		QSizeDimension dimension = oppositeDimension();
-		int scrollBarSize = (scrollBar()->sizeHint().*dimension)();
-		QSize minSize(0, mRowCount * 48 + scrollBarSize);
-		QSize maxSize(QWIDGETSIZE_MAX, mRowCount * 256 + scrollBarSize);
-		if (mOrientation == Qt::Vertical) {
-			minSize.transpose();
-			maxSize.transpose();
-		}
-		q->setMinimumSize(minSize);
-		q->setMaximumSize(maxSize);
-	}
-
-
-	void updateThumbnailSize() {
-		QSizeDimension dimension = oppositeDimension();
-		int scrollBarSize = (scrollBar()->sizeHint().*dimension)();
-		int widgetSize = (q->size().*dimension)();
-
-		if (mRowCount > 1) {
-			// Decrease widgetSize because otherwise the view sometimes wraps at
-			// mRowCount-1 instead of mRowCount. Probably because gridSize *
-			// mRowCount is too close to widgetSize.
-			--widgetSize;
-		}
-
-		int gridSize = (widgetSize - scrollBarSize - 2 * q->frameWidth()) / mRowCount;
-
-		q->setGridSize(QSize(gridSize, gridSize));
-		q->setThumbnailSize(gridSize - ITEM_MARGIN * 2);
-	}
+    ThumbnailBarView* q;
+    QStyle* mStyle;
+    QTimeLine* mTimeLine;
+
+    Qt::Orientation mOrientation;
+    int mRowCount;
+
+    QScrollBar* scrollBar() const {
+        return mOrientation == Qt::Horizontal ? q->horizontalScrollBar() : q->verticalScrollBar();
+    }
+
+    QSizeDimension mainDimension() const {
+        return mOrientation == Qt::Horizontal ? &QSize::width : &QSize::height;
+    }
+
+    QSizeDimension oppositeDimension() const {
+        return mOrientation == Qt::Horizontal ? &QSize::height : &QSize::width;
+    }
+
+    void smoothScrollTo(const QModelIndex& index)
+    {
+        if (!index.isValid()) {
+            return;
+        }
+
+        const QRect rect = q->visualRect(index);
+
+        int oldValue = scrollBar()->value();
+        int newValue = scrollToValue(rect);
+        if (mTimeLine->state() == QTimeLine::Running) {
+            mTimeLine->stop();
+        }
+        mTimeLine->setFrameRange(oldValue, newValue);
+        mTimeLine->start();
+    }
+
+    int scrollToValue(const QRect& rect)
+    {
+        // This code is a much simplified version of
+        // QListViewPrivate::horizontalScrollToValue()
+        const QRect area = q->viewport()->rect();
+        int value = scrollBar()->value();
+
+        if (mOrientation == Qt::Horizontal) {
+            if (q->isRightToLeft()) {
+                value += (area.width() - rect.width()) / 2 - rect.left();
+            } else {
+                value += rect.left() - (area.width() - rect.width()) / 2;
+            }
+        } else {
+            value += rect.top() - (area.height() - rect.height()) / 2;
+        }
+        return value;
+    }
+
+    void updateMinMaxSizes()
+    {
+        QSizeDimension dimension = oppositeDimension();
+        int scrollBarSize = (scrollBar()->sizeHint().*dimension)();
+        QSize minSize(0, mRowCount * 48 + scrollBarSize);
+        QSize maxSize(QWIDGETSIZE_MAX, mRowCount * 256 + scrollBarSize);
+        if (mOrientation == Qt::Vertical) {
+            minSize.transpose();
+            maxSize.transpose();
+        }
+        q->setMinimumSize(minSize);
+        q->setMaximumSize(maxSize);
+    }
+
+    void updateThumbnailSize()
+    {
+        QSizeDimension dimension = oppositeDimension();
+        int scrollBarSize = (scrollBar()->sizeHint().*dimension)();
+        int widgetSize = (q->size().*dimension)();
+
+        if (mRowCount > 1) {
+            // Decrease widgetSize because otherwise the view sometimes wraps at
+            // mRowCount-1 instead of mRowCount. Probably because gridSize *
+            // mRowCount is too close to widgetSize.
+            --widgetSize;
+        }
+
+        int gridSize = (widgetSize - scrollBarSize - 2 * q->frameWidth()) / mRowCount;
+
+        q->setGridSize(QSize(gridSize, gridSize));
+        q->setThumbnailSize(gridSize - ITEM_MARGIN * 2);
+    }
 };
 
-
-
 ThumbnailBarView::ThumbnailBarView(QWidget* parent)
 : ThumbnailView(parent)
-, d(new ThumbnailBarViewPrivate) {
-	d->q = this;
-	d->mTimeLine = new QTimeLine(SMOOTH_SCROLL_DURATION, this);
-	connect(d->mTimeLine, SIGNAL(frameChanged(int)),
-		SLOT(slotFrameChanged(int)));
-
-	d->mRowCount = 1;
-	d->mOrientation = Qt::Vertical; // To pass value-has-changed check in setOrientation()
-	setOrientation(Qt::Horizontal);
-
-	setObjectName( QLatin1String("thumbnailBarView" ));
-	setUniformItemSizes(true);
-	setWrapping(true);
-
-	d->mStyle = new ProxyStyle(style());
-	setStyle(d->mStyle);
-}
-
-
-ThumbnailBarView::~ThumbnailBarView() {
-	delete d->mStyle;
-	delete d;
-}
-
-
-Qt::Orientation ThumbnailBarView::orientation() const {
-	return d->mOrientation;
-}
-
-
-void ThumbnailBarView::setOrientation(Qt::Orientation orientation) {
-	if (d->mOrientation == orientation) {
-		return;
-	}
-	d->mOrientation = orientation;
-
-	if (d->mOrientation == Qt::Vertical) {
-		setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
-		setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
-		setFlow(LeftToRight);
-	} else {
-		setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
-		setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
-		setFlow(TopToBottom);
-	}
-
-	d->updateMinMaxSizes();
-}
-
-
-void ThumbnailBarView::slotFrameChanged(int value) {
-	d->scrollBar()->setValue(value);
-}
-
-
-void ThumbnailBarView::resizeEvent(QResizeEvent *event) {
-	ThumbnailView::resizeEvent(event);
-	d->updateThumbnailSize();
-}
-
-
-void ThumbnailBarView::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected) {
-	QListView::selectionChanged(selected, deselected);
-
-	QModelIndexList list = selected.indexes();
-	if (list.count() == 1 && isVisible()) {
-		d->smoothScrollTo(list.first());
-	}
-}
-
-
-void ThumbnailBarView::wheelEvent(QWheelEvent* event) {
-	d->scrollBar()->setValue(d->scrollBar()->value() - event->delta());
-}
-
-
-int ThumbnailBarView::rowCount() const {
-	return d->mRowCount;
-}
-
-
-void ThumbnailBarView::setRowCount(int rowCount) {
-	Q_ASSERT(rowCount > 0);
-	d->mRowCount = rowCount;
-	d->updateMinMaxSizes();
-	d->updateThumbnailSize();
-}
-
+, d(new ThumbnailBarViewPrivate)
+{
+    d->q = this;
+    d->mTimeLine = new QTimeLine(SMOOTH_SCROLL_DURATION, this);
+    connect(d->mTimeLine, SIGNAL(frameChanged(int)),
+            SLOT(slotFrameChanged(int)));
+
+    d->mRowCount = 1;
+    d->mOrientation = Qt::Vertical; // To pass value-has-changed check in setOrientation()
+    setOrientation(Qt::Horizontal);
+
+    setObjectName(QLatin1String("thumbnailBarView"));
+    setUniformItemSizes(true);
+    setWrapping(true);
+
+    d->mStyle = new ProxyStyle(style());
+    setStyle(d->mStyle);
+}
+
+ThumbnailBarView::~ThumbnailBarView()
+{
+    delete d->mStyle;
+    delete d;
+}
+
+Qt::Orientation ThumbnailBarView::orientation() const
+{
+    return d->mOrientation;
+}
+
+void ThumbnailBarView::setOrientation(Qt::Orientation orientation)
+{
+    if (d->mOrientation == orientation) {
+        return;
+    }
+    d->mOrientation = orientation;
+
+    if (d->mOrientation == Qt::Vertical) {
+        setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
+        setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
+        setFlow(LeftToRight);
+    } else {
+        setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
+        setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
+        setFlow(TopToBottom);
+    }
+
+    d->updateMinMaxSizes();
+}
+
+void ThumbnailBarView::slotFrameChanged(int value)
+{
+    d->scrollBar()->setValue(value);
+}
+
+void ThumbnailBarView::resizeEvent(QResizeEvent *event)
+{
+    ThumbnailView::resizeEvent(event);
+    d->updateThumbnailSize();
+}
+
+void ThumbnailBarView::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
+{
+    QListView::selectionChanged(selected, deselected);
+
+    QModelIndexList list = selected.indexes();
+    if (list.count() == 1 && isVisible()) {
+        d->smoothScrollTo(list.first());
+    }
+}
+
+void ThumbnailBarView::wheelEvent(QWheelEvent* event)
+{
+    d->scrollBar()->setValue(d->scrollBar()->value() - event->delta());
+}
+
+int ThumbnailBarView::rowCount() const
+{
+    return d->mRowCount;
+}
+
+void ThumbnailBarView::setRowCount(int rowCount)
+{
+    Q_ASSERT(rowCount > 0);
+    d->mRowCount = rowCount;
+    d->updateMinMaxSizes();
+    d->updateThumbnailSize();
+}
 
 } // namespace

=== modified file 'lib/thumbnailview/thumbnailbarview.h'
--- lib/thumbnailview/thumbnailbarview.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/thumbnailbarview.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,59 +32,58 @@
 // Local
 #include <lib/thumbnailview/thumbnailview.h>
 
-
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ThumbnailBarItemDelegatePrivate;
 
-class GWENVIEWLIB_EXPORT ThumbnailBarItemDelegate : public QAbstractItemDelegate {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ThumbnailBarItemDelegate : public QAbstractItemDelegate
+{
+    Q_OBJECT
 public:
-	ThumbnailBarItemDelegate(ThumbnailView*);
-	~ThumbnailBarItemDelegate();
+    ThumbnailBarItemDelegate(ThumbnailView*);
+    ~ThumbnailBarItemDelegate();
 
-	virtual void paint( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const;
-	virtual QSize sizeHint( const QStyleOptionViewItem & /*option*/, const QModelIndex & /*index*/ ) const;
+    virtual void paint(QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index) const;
+    virtual QSize sizeHint(const QStyleOptionViewItem & /*option*/, const QModelIndex & /*index*/) const;
 
 protected:
-	virtual bool eventFilter(QObject*, QEvent*);
+    virtual bool eventFilter(QObject*, QEvent*);
 
 private Q_SLOTS:
-	void toggleSelection();
+    void toggleSelection();
 
 private:
-	ThumbnailBarItemDelegatePrivate* const d;
-	friend struct ThumbnailBarItemDelegatePrivate;
+    ThumbnailBarItemDelegatePrivate* const d;
+    friend struct ThumbnailBarItemDelegatePrivate;
 };
 
-
 struct ThumbnailBarViewPrivate;
-class GWENVIEWLIB_EXPORT ThumbnailBarView : public ThumbnailView {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ThumbnailBarView : public ThumbnailView
+{
+    Q_OBJECT
 public:
-	ThumbnailBarView(QWidget* = 0);
-	~ThumbnailBarView();
-
-	Qt::Orientation orientation() const;
-	void setOrientation(Qt::Orientation);
-
-	int rowCount() const;
-	void setRowCount(int);
+    ThumbnailBarView(QWidget* = 0);
+    ~ThumbnailBarView();
+
+    Qt::Orientation orientation() const;
+    void setOrientation(Qt::Orientation);
+
+    int rowCount() const;
+    void setRowCount(int);
 
 protected:
-	virtual void resizeEvent(QResizeEvent * event);
-	virtual void wheelEvent(QWheelEvent* event);
-	virtual void selectionChanged(const QItemSelection& selected, const QItemSelection& deselected);
+    virtual void resizeEvent(QResizeEvent * event);
+    virtual void wheelEvent(QWheelEvent* event);
+    virtual void selectionChanged(const QItemSelection& selected, const QItemSelection& deselected);
 
 private Q_SLOTS:
-	void slotFrameChanged(int);
+    void slotFrameChanged(int);
 
 private:
-	ThumbnailBarViewPrivate* const d;
+    ThumbnailBarViewPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* THUMBNAILBARVIEW_H */

=== modified file 'lib/thumbnailview/thumbnailslider.cpp'
--- lib/thumbnailview/thumbnailslider.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/thumbnailslider.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -30,46 +30,44 @@
 
 // KDE
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ThumbnailSliderPrivate {
 };
 
-
 ThumbnailSlider::ThumbnailSlider(QWidget* parent)
 : ZoomSlider(parent)
-, d(new ThumbnailSliderPrivate) {
-	connect(slider(), SIGNAL(actionTriggered(int)),
-		SLOT(slotActionTriggered(int)) );
-	slider()->setRange(ThumbnailView::MinThumbnailSize, ThumbnailView::MaxThumbnailSize);
-}
-
-
-ThumbnailSlider::~ThumbnailSlider() {
-	delete d;
-}
-
-
-void ThumbnailSlider::slotActionTriggered(int actionTriggered) {
-	updateToolTip();
-
-	if (actionTriggered != QAbstractSlider::SliderNoAction) {
-		// If we are updating because of a direct action on the slider, show
-		// the tooltip immediatly.
-		const QPoint pos = slider()->mapToGlobal(QPoint(0, slider()->height() / 2));
-		QToolTip::showText(pos, slider()->toolTip(), slider());
-	}
-}
-
-
-void ThumbnailSlider::updateToolTip() {
-	// FIXME: i18n?
-	const int size = slider()->sliderPosition();
-	const QString text = QString("%1 x %2").arg(size).arg(size);
-	slider()->setToolTip(text);
-}
-
-
+, d(new ThumbnailSliderPrivate)
+{
+    connect(slider(), SIGNAL(actionTriggered(int)),
+            SLOT(slotActionTriggered(int)));
+    slider()->setRange(ThumbnailView::MinThumbnailSize, ThumbnailView::MaxThumbnailSize);
+}
+
+ThumbnailSlider::~ThumbnailSlider()
+{
+    delete d;
+}
+
+void ThumbnailSlider::slotActionTriggered(int actionTriggered)
+{
+    updateToolTip();
+
+    if (actionTriggered != QAbstractSlider::SliderNoAction) {
+        // If we are updating because of a direct action on the slider, show
+        // the tooltip immediatly.
+        const QPoint pos = slider()->mapToGlobal(QPoint(0, slider()->height() / 2));
+        QToolTip::showText(pos, slider()->toolTip(), slider());
+    }
+}
+
+void ThumbnailSlider::updateToolTip()
+{
+    // FIXME: i18n?
+    const int size = slider()->sliderPosition();
+    const QString text = QString("%1 x %2").arg(size).arg(size);
+    slider()->setToolTip(text);
+}
 
 } // namespace

=== modified file 'lib/thumbnailview/thumbnailslider.h'
--- lib/thumbnailview/thumbnailslider.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/thumbnailslider.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -31,30 +31,30 @@
 // Local
 #include <lib/zoomslider.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ThumbnailSliderPrivate;
 /**
  * A zoom slider which shows the thumbnail size as a tooltip when it is
  * adjusted
  */
-class GWENVIEWLIB_EXPORT ThumbnailSlider : public ZoomSlider {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ThumbnailSlider : public ZoomSlider
+{
+    Q_OBJECT
 public:
-	ThumbnailSlider(QWidget* parent=0);
-	~ThumbnailSlider();
+    ThumbnailSlider(QWidget* parent = 0);
+    ~ThumbnailSlider();
 
-	void updateToolTip();
+    void updateToolTip();
 
 private Q_SLOTS:
-	void slotActionTriggered(int actionTriggered);
+    void slotActionTriggered(int actionTriggered);
 
 private:
-	ThumbnailSliderPrivate* const d;
+    ThumbnailSliderPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* THUMBNAILSLIDER_H */

=== modified file 'lib/thumbnailview/thumbnailview.cpp'
--- lib/thumbnailview/thumbnailview.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/thumbnailview.cpp	2011-12-15 14:17:54 +0000
@@ -49,7 +49,8 @@
 #include "mimetypeutils.h"
 #include "thumbnailloadjob.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 #undef ENABLE_LOG
 #undef LOG
@@ -68,84 +69,87 @@
 
 const int WHEEL_ZOOM_MULTIPLIER = 4;
 
-static KFileItem fileItemForIndex(const QModelIndex& index) {
-	if (!index.isValid()) {
-		LOG("Invalid index");
-		return KFileItem();
-	}
-	QVariant data = index.data(KDirModel::FileItemRole);
-	return qvariant_cast<KFileItem>(data);
+static KFileItem fileItemForIndex(const QModelIndex& index)
+{
+    if (!index.isValid()) {
+        LOG("Invalid index");
+        return KFileItem();
+    }
+    QVariant data = index.data(KDirModel::FileItemRole);
+    return qvariant_cast<KFileItem>(data);
 }
 
-
-static KUrl urlForIndex(const QModelIndex& index) {
-	KFileItem item = fileItemForIndex(index);
-	return item.isNull() ? KUrl() : item.url();
+static KUrl urlForIndex(const QModelIndex& index)
+{
+    KFileItem item = fileItemForIndex(index);
+    return item.isNull() ? KUrl() : item.url();
 }
 
 struct Thumbnail {
-	Thumbnail(const QPersistentModelIndex& index_, const KDateTime& mtime)
-	: mIndex(index_)
-	, mModificationTime(mtime)
-	, mRough(true)
-	, mWaitingForThumbnail(true) {}
-
-	Thumbnail()
-	: mRough(true)
-	, mWaitingForThumbnail(true) {}
-
-	/**
-	 * Init the thumbnail based on a icon
-	 */
-	void initAsIcon(const QPixmap& pix) {
-		mGroupPix = pix;
-		int largeGroupSize = ThumbnailGroup::pixelSize(ThumbnailGroup::Large);
-		mFullSize = QSize(largeGroupSize, largeGroupSize);
-	}
-
-	bool isGroupPixAdaptedForSize(int size) const {
-		if (mWaitingForThumbnail) {
-			return false;
-		}
-		if (mGroupPix.isNull()) {
-			return false;
-		}
-		const int groupSize = qMax(mGroupPix.width(), mGroupPix.height());
-		if (groupSize >= size) {
-			return true;
-		}
-
-		// groupSize is less than size, but this may be because the full image
-		// is the same size as groupSize
-		return groupSize == qMax(mFullSize.width(), mFullSize.height());
-	}
-
-	void prepareForRefresh(const KDateTime& mtime) {
-		mModificationTime = mtime;
-		mGroupPix = QPixmap();
-		mAdjustedPix = QPixmap();
-		mFullSize = QSize();
-		mRealFullSize = QSize();
-		mRough = true;
-		mWaitingForThumbnail = true;
-	}
-
-	QPersistentModelIndex mIndex;
-	KDateTime mModificationTime;
-	/// The pix loaded from .thumbnails/{large,normal}
-	QPixmap mGroupPix;
-	/// Scaled version of mGroupPix, adjusted to ThumbnailView::thumbnailSize
-	QPixmap mAdjustedPix;
-	/// Size of the full image
-	QSize mFullSize;
-	/// Real size of the full image, invalid unless the thumbnail
-	/// represents a raster image (not an icon)
-	QSize mRealFullSize;
-	/// Whether mAdjustedPix represents has been scaled using fast or smooth
-	//transformation
-	bool mRough;
-	/// Set to true if mGroupPix should be replaced with a real thumbnail
-	bool mWaitingForThumbnail;
+    Thumbnail(const QPersistentModelIndex& index_, const KDateTime& mtime)
+        : mIndex(index_)
+        , mModificationTime(mtime)
+        , mRough(true)
+        , mWaitingForThumbnail(true) {}
+
+    Thumbnail()
+        : mRough(true)
+        , mWaitingForThumbnail(true) {}
+
+    /**
+     * Init the thumbnail based on a icon
+     */
+    void initAsIcon(const QPixmap& pix)
+    {
+        mGroupPix = pix;
+        int largeGroupSize = ThumbnailGroup::pixelSize(ThumbnailGroup::Large);
+        mFullSize = QSize(largeGroupSize, largeGroupSize);
+    }
+
+    bool isGroupPixAdaptedForSize(int size) const {
+        if (mWaitingForThumbnail) {
+            return false;
+        }
+        if (mGroupPix.isNull()) {
+            return false;
+        }
+        const int groupSize = qMax(mGroupPix.width(), mGroupPix.height());
+        if (groupSize >= size) {
+            return true;
+        }
+
+        // groupSize is less than size, but this may be because the full image
+        // is the same size as groupSize
+        return groupSize == qMax(mFullSize.width(), mFullSize.height());
+    }
+
+    void prepareForRefresh(const KDateTime& mtime)
+    {
+        mModificationTime = mtime;
+        mGroupPix = QPixmap();
+        mAdjustedPix = QPixmap();
+        mFullSize = QSize();
+        mRealFullSize = QSize();
+        mRough = true;
+        mWaitingForThumbnail = true;
+    }
+
+    QPersistentModelIndex mIndex;
+    KDateTime mModificationTime;
+    /// The pix loaded from .thumbnails/{large,normal}
+    QPixmap mGroupPix;
+    /// Scaled version of mGroupPix, adjusted to ThumbnailView::thumbnailSize
+    QPixmap mAdjustedPix;
+    /// Size of the full image
+    QSize mFullSize;
+    /// Real size of the full image, invalid unless the thumbnail
+    /// represents a raster image (not an icon)
+    QSize mRealFullSize;
+    /// Whether mAdjustedPix represents has been scaled using fast or smooth
+    //transformation
+    bool mRough;
+    /// Set to true if mGroupPix should be replaced with a real thumbnail
+    bool mWaitingForThumbnail;
 };
 
 typedef QHash<QUrl, Thumbnail> ThumbnailForUrl;
@@ -153,766 +157,773 @@
 typedef QSet<QPersistentModelIndex> PersistentModelIndexSet;
 
 struct ThumbnailViewPrivate {
-	ThumbnailView* that;
-	int mThumbnailSize;
-	AbstractDocumentInfoProvider* mDocumentInfoProvider;
-	AbstractThumbnailViewHelper* mThumbnailViewHelper;
-	ThumbnailForUrl mThumbnailForUrl;
-	QTimer mScheduledThumbnailGenerationTimer;
-
-	UrlQueue mSmoothThumbnailQueue;
-	QTimer mSmoothThumbnailTimer;
-
-	QPixmap mWaitingThumbnail;
-	QPointer<ThumbnailLoadJob> mThumbnailLoadJob;
-
-	PersistentModelIndexSet mBusyIndexSet;
-	KPixmapSequence mBusySequence;
-	QTimeLine* mBusyAnimationTimeLine;
-
-	void setupBusyAnimation() {
-		mBusySequence = KPixmapSequence("process-working", 22);
-		mBusyAnimationTimeLine = new QTimeLine(100 * mBusySequence.frameCount(), that);
-		mBusyAnimationTimeLine->setCurveShape(QTimeLine::LinearCurve);
-		mBusyAnimationTimeLine->setEndFrame(mBusySequence.frameCount() - 1);
-		mBusyAnimationTimeLine->setLoopCount(0);
-		QObject::connect(mBusyAnimationTimeLine, SIGNAL(frameChanged(int)),
-			that, SLOT(updateBusyIndexes()));
-	}
-
-	void scheduleThumbnailGenerationForVisibleItems() {
-		if (mThumbnailLoadJob) {
-			mThumbnailLoadJob->removeItems(mThumbnailLoadJob->pendingItems());
-		}
-		mSmoothThumbnailQueue.clear();
-		mScheduledThumbnailGenerationTimer.start();
-	}
-
-	void updateThumbnailForModifiedDocument(const QModelIndex& index) {
-		Q_ASSERT(mDocumentInfoProvider);
-		KFileItem item = fileItemForIndex(index);
-		KUrl url = item.url();
-		ThumbnailGroup::Enum group = ThumbnailGroup::fromPixelSize(mThumbnailSize);
-		QPixmap pix;
-		QSize fullSize;
-		mDocumentInfoProvider->thumbnailForDocument(url, group, &pix, &fullSize);
-		mThumbnailForUrl[url] = Thumbnail(QPersistentModelIndex(index), KDateTime::currentLocalDateTime());
-		that->setThumbnail(item, pix, fullSize);
-	}
-
-	void generateThumbnailsForItems(const KFileItemList& list) {
-		ThumbnailGroup::Enum group = ThumbnailGroup::fromPixelSize(mThumbnailSize);
-		if (!mThumbnailLoadJob) {
-			mThumbnailLoadJob = new ThumbnailLoadJob(list, group);
-			QObject::connect(mThumbnailLoadJob, SIGNAL(thumbnailLoaded(const KFileItem&, const QPixmap&, const QSize&)),
-				that, SLOT(setThumbnail(const KFileItem&, const QPixmap&, const QSize&)));
-			QObject::connect(mThumbnailLoadJob, SIGNAL(thumbnailLoadingFailed(const KFileItem&)),
-				that, SLOT(setBrokenThumbnail(const KFileItem&)));
-			mThumbnailLoadJob->start();
-		} else {
-			mThumbnailLoadJob->setThumbnailGroup(group);
-			Q_FOREACH(const KFileItem& item, list) {
-				mThumbnailLoadJob->appendItem(item);
-			}
-		}
-	}
-
-	void roughAdjustThumbnail(Thumbnail* thumbnail) {
-		const QPixmap& mGroupPix = thumbnail->mGroupPix;
-		const int groupSize = qMax(mGroupPix.width(), mGroupPix.height());
-		const int fullSize = qMax(thumbnail->mFullSize.width(), thumbnail->mFullSize.height());
-		if (fullSize == groupSize && groupSize <= mThumbnailSize) {
-			thumbnail->mAdjustedPix = mGroupPix;
-			thumbnail->mRough = false;
-		} else {
-			thumbnail->mAdjustedPix = mGroupPix.scaled(mThumbnailSize, mThumbnailSize, Qt::KeepAspectRatio);
-			thumbnail->mRough = true;
-		}
-	}
-
-	QPixmap dragPixmapForIndex(const QModelIndex& index) const {
-		KUrl url = urlForIndex(index);
-		QPixmap pix = mThumbnailForUrl.value(url).mAdjustedPix;
-		if (qMax(pix.width(), pix.height()) > DRAG_THUMB_SIZE) {
-			return pix.scaled(DRAG_THUMB_SIZE, DRAG_THUMB_SIZE, Qt::KeepAspectRatio, Qt::SmoothTransformation);
-		} else {
-			return pix;
-		}
-	}
-
-	QPixmap createDragPixmap(const QModelIndexList& indexes) {
-		const int MAX_THUMBS = 3;
-
-		int thumbCount;
-		bool more;
-		if (indexes.count() > MAX_THUMBS) {
-			thumbCount = MAX_THUMBS;
-			more = true;
-		} else {
-			thumbCount = indexes.count();
-			more = false;
-		}
-		QList<QPixmap> thumbs;
-		int width = 0;
-		int height = 0;
-		for (int row=0; row<thumbCount; ++row) {
-			QModelIndex index;
-			if (row == thumbCount-1 && more) {
-				QString text = "(...)";
-				QPixmap pix(that->fontMetrics().boundingRect(text).size());
-				pix.fill(Qt::transparent);
-				{
-					QPainter painter(&pix);
-					painter.drawText(pix.rect(), Qt::AlignHCenter | Qt::AlignBottom, text);
-				}
-				index = indexes.last();
-				width += pix.width();
-				thumbs << pix;
-			} else {
-				index = indexes[row];
-			}
-			QPixmap thumb = dragPixmapForIndex(index);
-			height = qMax(height, thumb.height());
-			width += thumb.width();
-			thumbs << thumb;
-		}
-
-		QPixmap pix(
-			width + (thumbs.count() + 1) * DRAG_THUMB_SPACING,
-			height + 2 * DRAG_THUMB_SPACING
-			);
-		pix.fill(QToolTip::palette().color(QPalette::Inactive, QPalette::ToolTipBase));
-		QPainter painter(&pix);
-
-		int x = DRAG_THUMB_SPACING;
-		Q_FOREACH(const QPixmap& thumb, thumbs) {
-			painter.drawPixmap(x, (pix.height() - thumb.height()) / 2, thumb);
-			x += thumb.width() + DRAG_THUMB_SPACING;
-		}
-		return pix;
-	}
+    ThumbnailView* q;
+    int mThumbnailSize;
+    AbstractDocumentInfoProvider* mDocumentInfoProvider;
+    AbstractThumbnailViewHelper* mThumbnailViewHelper;
+    ThumbnailForUrl mThumbnailForUrl;
+    QTimer mScheduledThumbnailGenerationTimer;
+
+    UrlQueue mSmoothThumbnailQueue;
+    QTimer mSmoothThumbnailTimer;
+
+    QPixmap mWaitingThumbnail;
+    QPointer<ThumbnailLoadJob> mThumbnailLoadJob;
+
+    PersistentModelIndexSet mBusyIndexSet;
+    KPixmapSequence mBusySequence;
+    QTimeLine* mBusyAnimationTimeLine;
+
+    void setupBusyAnimation()
+    {
+        mBusySequence = KPixmapSequence("process-working", 22);
+        mBusyAnimationTimeLine = new QTimeLine(100 * mBusySequence.frameCount(), q);
+        mBusyAnimationTimeLine->setCurveShape(QTimeLine::LinearCurve);
+        mBusyAnimationTimeLine->setEndFrame(mBusySequence.frameCount() - 1);
+        mBusyAnimationTimeLine->setLoopCount(0);
+        QObject::connect(mBusyAnimationTimeLine, SIGNAL(frameChanged(int)),
+                         q, SLOT(updateBusyIndexes()));
+    }
+
+    void scheduleThumbnailGenerationForVisibleItems()
+    {
+        if (mThumbnailLoadJob) {
+            mThumbnailLoadJob->removeItems(mThumbnailLoadJob->pendingItems());
+        }
+        mSmoothThumbnailQueue.clear();
+        mScheduledThumbnailGenerationTimer.start();
+    }
+
+    void updateThumbnailForModifiedDocument(const QModelIndex& index)
+    {
+        Q_ASSERT(mDocumentInfoProvider);
+        KFileItem item = fileItemForIndex(index);
+        KUrl url = item.url();
+        ThumbnailGroup::Enum group = ThumbnailGroup::fromPixelSize(mThumbnailSize);
+        QPixmap pix;
+        QSize fullSize;
+        mDocumentInfoProvider->thumbnailForDocument(url, group, &pix, &fullSize);
+        mThumbnailForUrl[url] = Thumbnail(QPersistentModelIndex(index), KDateTime::currentLocalDateTime());
+        q->setThumbnail(item, pix, fullSize);
+    }
+
+    void generateThumbnailsForItems(const KFileItemList& list)
+    {
+        ThumbnailGroup::Enum group = ThumbnailGroup::fromPixelSize(mThumbnailSize);
+        if (!mThumbnailLoadJob) {
+            mThumbnailLoadJob = new ThumbnailLoadJob(list, group);
+            QObject::connect(mThumbnailLoadJob, SIGNAL(thumbnailLoaded(KFileItem, QPixmap, QSize)),
+                             q, SLOT(setThumbnail(KFileItem, QPixmap, QSize)));
+            QObject::connect(mThumbnailLoadJob, SIGNAL(thumbnailLoadingFailed(KFileItem)),
+                             q, SLOT(setBrokenThumbnail(KFileItem)));
+            mThumbnailLoadJob->start();
+        } else {
+            mThumbnailLoadJob->setThumbnailGroup(group);
+            Q_FOREACH(const KFileItem & item, list) {
+                mThumbnailLoadJob->appendItem(item);
+            }
+        }
+    }
+
+    void roughAdjustThumbnail(Thumbnail* thumbnail)
+    {
+        const QPixmap& mGroupPix = thumbnail->mGroupPix;
+        const int groupSize = qMax(mGroupPix.width(), mGroupPix.height());
+        const int fullSize = qMax(thumbnail->mFullSize.width(), thumbnail->mFullSize.height());
+        if (fullSize == groupSize && groupSize <= mThumbnailSize) {
+            thumbnail->mAdjustedPix = mGroupPix;
+            thumbnail->mRough = false;
+        } else {
+            thumbnail->mAdjustedPix = mGroupPix.scaled(mThumbnailSize, mThumbnailSize, Qt::KeepAspectRatio);
+            thumbnail->mRough = true;
+        }
+    }
+
+    QPixmap dragPixmapForIndex(const QModelIndex& index) const {
+        KUrl url = urlForIndex(index);
+        QPixmap pix = mThumbnailForUrl.value(url).mAdjustedPix;
+        if (qMax(pix.width(), pix.height()) > DRAG_THUMB_SIZE) {
+            return pix.scaled(DRAG_THUMB_SIZE, DRAG_THUMB_SIZE, Qt::KeepAspectRatio, Qt::SmoothTransformation);
+        } else {
+            return pix;
+        }
+    }
+
+    QPixmap createDragPixmap(const QModelIndexList& indexes)
+    {
+        const int MAX_THUMBS = 3;
+
+        int thumbCount;
+        bool more;
+        if (indexes.count() > MAX_THUMBS) {
+            thumbCount = MAX_THUMBS;
+            more = true;
+        } else {
+            thumbCount = indexes.count();
+            more = false;
+        }
+        QList<QPixmap> thumbs;
+        int width = 0;
+        int height = 0;
+        for (int row = 0; row < thumbCount; ++row) {
+            QModelIndex index;
+            if (row == thumbCount - 1 && more) {
+                QString text = "(...)";
+                QPixmap pix(q->fontMetrics().boundingRect(text).size());
+                pix.fill(Qt::transparent);
+                {
+                    QPainter painter(&pix);
+                    painter.drawText(pix.rect(), Qt::AlignHCenter | Qt::AlignBottom, text);
+                }
+                index = indexes.last();
+                width += pix.width();
+                thumbs << pix;
+            } else {
+                index = indexes[row];
+            }
+            QPixmap thumb = dragPixmapForIndex(index);
+            height = qMax(height, thumb.height());
+            width += thumb.width();
+            thumbs << thumb;
+        }
+
+        QPixmap pix(
+            width + (thumbs.count() + 1) * DRAG_THUMB_SPACING,
+            height + 2 * DRAG_THUMB_SPACING
+        );
+        pix.fill(QToolTip::palette().color(QPalette::Inactive, QPalette::ToolTipBase));
+        QPainter painter(&pix);
+
+        int x = DRAG_THUMB_SPACING;
+        Q_FOREACH(const QPixmap & thumb, thumbs) {
+            painter.drawPixmap(x, (pix.height() - thumb.height()) / 2, thumb);
+            x += thumb.width() + DRAG_THUMB_SPACING;
+        }
+        return pix;
+    }
 };
 
-
 ThumbnailView::ThumbnailView(QWidget* parent)
 : QListView(parent)
-, d(new ThumbnailViewPrivate) {
-	d->that = this;
-	d->mThumbnailViewHelper = 0;
-	d->mDocumentInfoProvider = 0;
-	// Init to some stupid value so that the first call to setThumbnailSize()
-	// is not ignored (do not use 0 in case someone try to divide by
-	// mThumbnailSize...)
-	d->mThumbnailSize = 1;
-
-	setFrameShape(QFrame::NoFrame);
-	setViewMode(QListView::IconMode);
-	setResizeMode(QListView::Adjust);
-	setDragEnabled(true);
-	setAcceptDrops(true);
-	setDropIndicatorShown(true);
-	setUniformItemSizes(true);
-	setEditTriggers(QAbstractItemView::EditKeyPressed);
-
-	d->setupBusyAnimation();
-
-	viewport()->setMouseTracking(true);
-	// Set this attribute, otherwise the item delegate won't get the
-	// State_MouseOver state
-	viewport()->setAttribute(Qt::WA_Hover);
-
-	setVerticalScrollMode(ScrollPerPixel);
-	setHorizontalScrollMode(ScrollPerPixel);
-
-	d->mScheduledThumbnailGenerationTimer.setSingleShot(true);
-	d->mScheduledThumbnailGenerationTimer.setInterval(500);
-	connect(&d->mScheduledThumbnailGenerationTimer, SIGNAL(timeout()),
-		SLOT(generateThumbnailsForVisibleItems()) );
-
-	d->mSmoothThumbnailTimer.setSingleShot(true);
-	connect(&d->mSmoothThumbnailTimer, SIGNAL(timeout()),
-		SLOT(smoothNextThumbnail()) );
-
-	setContextMenuPolicy(Qt::CustomContextMenu);
-	connect(this, SIGNAL(customContextMenuRequested(const QPoint&)),
-		SLOT(showContextMenu()) );
-
-	if (KGlobalSettings::singleClick()) {
-		connect(this, SIGNAL(clicked(const QModelIndex&)),
-			SLOT(emitIndexActivatedIfNoModifiers(const QModelIndex&)) );
-	} else {
-		connect(this, SIGNAL(doubleClicked(const QModelIndex&)),
-			SLOT(emitIndexActivatedIfNoModifiers(const QModelIndex&)) );
-	}
-}
-
-
-ThumbnailView::~ThumbnailView() {
-	delete d;
-}
-
-
-void ThumbnailView::setModel(QAbstractItemModel* newModel) {
-	if (model()) {
-		disconnect(model(), 0, this, 0);
-	}
-	QListView::setModel(newModel);
-	connect(model(), SIGNAL(rowsRemoved(const QModelIndex&, int, int)),
-		SIGNAL(rowsRemovedSignal(const QModelIndex&, int, int)));
-}
-
-
-void ThumbnailView::setThumbnailSize(int value) {
-	if (d->mThumbnailSize == value) {
-		return;
-	}
-	d->mThumbnailSize = value;
-
-	// mWaitingThumbnail
-	int waitingThumbnailSize;
-	if (value > 64) {
-		waitingThumbnailSize = 48;
-	} else {
-		waitingThumbnailSize = 32;
-	}
-	if (d->mWaitingThumbnail.width() != waitingThumbnailSize) {
-		QPixmap icon = DesktopIcon("chronometer", waitingThumbnailSize);
-		QPixmap pix(icon.size());
-		pix.fill(Qt::transparent);
-		QPainter painter(&pix);
-		painter.setOpacity(0.5);
-		painter.drawPixmap(0, 0, icon);
-		painter.end();
-		d->mWaitingThumbnail = pix;
-	}
-
-	// Stop smoothing
-	d->mSmoothThumbnailTimer.stop();
-	d->mSmoothThumbnailQueue.clear();
-
-	// Clear adjustedPixes
-	ThumbnailForUrl::iterator
-		it = d->mThumbnailForUrl.begin(),
-		end = d->mThumbnailForUrl.end();
-	for (; it!=end; ++it) {
-		it.value().mAdjustedPix = QPixmap();
-	}
-
-	thumbnailSizeChanged(value);
-	d->scheduleThumbnailGenerationForVisibleItems();
-}
-
-
-int ThumbnailView::thumbnailSize() const {
-	return d->mThumbnailSize;
-}
-
-
-void ThumbnailView::setThumbnailViewHelper(AbstractThumbnailViewHelper* helper) {
-	d->mThumbnailViewHelper = helper;
-}
-
-AbstractThumbnailViewHelper* ThumbnailView::thumbnailViewHelper() const {
-	return d->mThumbnailViewHelper;
-}
-
-
-void ThumbnailView::setDocumentInfoProvider(AbstractDocumentInfoProvider* provider) {
-	d->mDocumentInfoProvider = provider;
-	if (provider) {
-		connect(provider, SIGNAL(busyStateChanged(const QModelIndex&, bool)),
-			SLOT(updateThumbnailBusyState(const QModelIndex&, bool)));
-		connect(provider, SIGNAL(documentChanged(const QModelIndex&)),
-			SLOT(updateThumbnail(const QModelIndex&)));
-	}
-}
-
-AbstractDocumentInfoProvider* ThumbnailView::documentInfoProvider() const {
-	return d->mDocumentInfoProvider;
-}
-
-
-void ThumbnailView::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int end) {
-	QListView::rowsAboutToBeRemoved(parent, start, end);
-
-	// Remove references to removed items
-	KFileItemList itemList;
-	for (int pos=start; pos<=end; ++pos) {
-		QModelIndex index = model()->index(pos, 0, parent);
-		KFileItem item = fileItemForIndex(index);
-		if (item.isNull()) {
-			kDebug() << "Skipping invalid item!" << index.data().toString();
-			continue;
-		}
-
-		QUrl url = item.url();
-		d->mThumbnailForUrl.remove(url);
-		d->mSmoothThumbnailQueue.removeAll(url);
-
-		itemList.append(item);
-	}
-
-	if (d->mThumbnailLoadJob) {
-		d->mThumbnailLoadJob->removeItems(itemList);
-	}
-
-	// Update current index if it is among the deleted rows
-	const int row = currentIndex().row();
-	if (start <= row && row <= end) {
-		QModelIndex index;
-		if (end < model()->rowCount() - 1) {
-			index = model()->index(end + 1, 0);
-		} else if (start > 0) {
-			index = model()->index(start - 1, 0);
-		}
-		setCurrentIndex(index);
-	}
-
-	// Removing rows might make new images visible, make sure their thumbnail
-	// is generated
-	d->mScheduledThumbnailGenerationTimer.start();
-}
-
-
-void ThumbnailView::rowsInserted(const QModelIndex& parent, int start, int end) {
-	QListView::rowsInserted(parent, start, end);
-	d->mScheduledThumbnailGenerationTimer.start();
-	rowsInsertedSignal(parent, start, end);
-}
-
-
-void ThumbnailView::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight) {
-	QListView::dataChanged(topLeft, bottomRight);
-	bool thumbnailsNeedRefresh = false;
-	for (int row = topLeft.row(); row <= bottomRight.row(); ++row) {
-		QModelIndex index = model()->index(row, 0);
-		KFileItem item = fileItemForIndex(index);
-		if (item.isNull()) {
-			kWarning() << "Invalid item for index" << index << ". This should not happen!";
-			continue;
-		}
-
-		ThumbnailForUrl::Iterator it = d->mThumbnailForUrl.find(item.url());
-		if (it != d->mThumbnailForUrl.end()) {
-			// All thumbnail views are connected to the model, so
-			// ThumbnailView::dataChanged() is called for all of them. As a
-			// result this method will also be called for views which are not
-			// currently visible, and do not yet have a thumbnail for the
-			// modified url.
-			KDateTime mtime = item.time(KFileItem::ModificationTime);
-			if (it->mModificationTime != mtime) {
-				// dataChanged() is called when the file changes but also when
-				// the model fetched additional data such as semantic info. To
-				// avoid needless refreshes, we only trigger a refresh if the
-				// modification time changes.
-				thumbnailsNeedRefresh = true;
-				it->prepareForRefresh(mtime);
-			}
-		}
-	}
-	if (thumbnailsNeedRefresh) {
-		d->mScheduledThumbnailGenerationTimer.start();
-	}
-}
-
-
-void ThumbnailView::showContextMenu() {
-	d->mThumbnailViewHelper->showContextMenu(this);
-}
-
-
-void ThumbnailView::emitIndexActivatedIfNoModifiers(const QModelIndex& index) {
-	if (QApplication::keyboardModifiers() == Qt::NoModifier) {
-		emit indexActivated(index);
-	}
-}
-
-
-void ThumbnailView::setThumbnail(const KFileItem& item, const QPixmap& pixmap, const QSize& size) {
-	ThumbnailForUrl::iterator it = d->mThumbnailForUrl.find(item.url());
-	if (it == d->mThumbnailForUrl.end()) {
-		return;
-	}
-	Thumbnail& thumbnail = it.value();
-	thumbnail.mGroupPix = pixmap;
-	thumbnail.mAdjustedPix = QPixmap();
-	int largeGroupSize = ThumbnailGroup::pixelSize(ThumbnailGroup::Large);
-	thumbnail.mFullSize = size.isValid() ? size : QSize(largeGroupSize, largeGroupSize);
-	thumbnail.mRealFullSize = size;
-	thumbnail.mWaitingForThumbnail = false;
-
-	update(thumbnail.mIndex);
-}
-
-
-void ThumbnailView::setBrokenThumbnail(const KFileItem& item) {
-	ThumbnailForUrl::iterator it = d->mThumbnailForUrl.find(item.url());
-	if (it == d->mThumbnailForUrl.end()) {
-		return;
-	}
-	Thumbnail& thumbnail = it.value();
-	MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
-	if (kind == MimeTypeUtils::KIND_VIDEO) {
-		// Special case for videos because our kde install may come without
-		// support for video thumbnails so we show the mimetype icon instead of
-		// a broken image icon
-		ThumbnailGroup::Enum group = ThumbnailGroup::fromPixelSize(d->mThumbnailSize);
-		QPixmap pix = item.pixmap(ThumbnailGroup::pixelSize(group));
-		thumbnail.initAsIcon(pix);
-	} else if (kind == MimeTypeUtils::KIND_DIR) {
-		// Special case for folders because ThumbnailLoadJob does not return a
-		// thumbnail if there is no images
-		thumbnail.mWaitingForThumbnail = false;
-		return;
-	} else {
-		thumbnail.initAsIcon(DesktopIcon("image-missing", 48));
-		thumbnail.mFullSize = thumbnail.mGroupPix.size();
-	}
-	update(thumbnail.mIndex);
-}
-
-
-QPixmap ThumbnailView::thumbnailForIndex(const QModelIndex& index, QSize* fullSize) {
-	KFileItem item = fileItemForIndex(index);
-	if (item.isNull()) {
-		LOG("Invalid item");
-		if (fullSize) {
-			*fullSize = QSize();
-		}
-		return QPixmap();
-	}
-	KUrl url = item.url();
-
-	// Find or create Thumbnail instance
-	ThumbnailForUrl::Iterator it = d->mThumbnailForUrl.find(url);
-	if (it == d->mThumbnailForUrl.end()) {
-		Thumbnail thumbnail = Thumbnail(QPersistentModelIndex(index), item.time(KFileItem::ModificationTime));
-		it = d->mThumbnailForUrl.insert(url, thumbnail);
-	}
-	Thumbnail& thumbnail = it.value();
-
-	// If dir or archive, generate a thumbnail from fileitem pixmap
-	MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
-	if (kind == MimeTypeUtils::KIND_ARCHIVE || kind == MimeTypeUtils::KIND_DIR) {
-		int groupSize = ThumbnailGroup::pixelSize(ThumbnailGroup::fromPixelSize(d->mThumbnailSize));
-		if (thumbnail.mGroupPix.isNull() || thumbnail.mGroupPix.width() < groupSize) {
-			QPixmap pix = item.pixmap(groupSize);
-			thumbnail.initAsIcon(pix);
-			if (kind == MimeTypeUtils::KIND_ARCHIVE) {
-				// No thumbnails for archives
-				thumbnail.mWaitingForThumbnail = false;
-			} else {
-				// set mWaitingForThumbnail to true (necessary in the case
-				// 'thumbnail' already existed before, but with a too small
-				// mGroupPix)
-				thumbnail.mWaitingForThumbnail = true;
-			}
-		}
-	}
-
-	if (thumbnail.mGroupPix.isNull()) {
-		if (fullSize) {
-			*fullSize = QSize();
-		}
-		return d->mWaitingThumbnail;
-	}
-
-	// Adjust thumbnail
-	if (thumbnail.mAdjustedPix.isNull()) {
-		d->roughAdjustThumbnail(&thumbnail);
-	}
-	if (thumbnail.mRough && !d->mSmoothThumbnailQueue.contains(url)) {
-		d->mSmoothThumbnailQueue.enqueue(url);
-		if (!d->mSmoothThumbnailTimer.isActive()) {
-			d->mSmoothThumbnailTimer.start(SMOOTH_DELAY);
-		}
-	}
-	if (fullSize) {
-		*fullSize = thumbnail.mRealFullSize;
-	}
-	return thumbnail.mAdjustedPix;
-}
-
-
-bool ThumbnailView::isModified(const QModelIndex& index) const {
-	if (!d->mDocumentInfoProvider) {
-		return false;
-	}
-	KUrl url = urlForIndex(index);
-	return d->mDocumentInfoProvider->isModified(url);
-}
-
-
-bool ThumbnailView::isBusy(const QModelIndex& index) const {
-	if (!d->mDocumentInfoProvider) {
-		return false;
-	}
-	KUrl url = urlForIndex(index);
-	return d->mDocumentInfoProvider->isBusy(url);
-}
-
-
-void ThumbnailView::startDrag(Qt::DropActions supportedActions) {
-	QModelIndexList indexes = selectionModel()->selectedIndexes();
-	if (indexes.isEmpty()) {
-		return;
-	}
-	QDrag* drag = new QDrag(this);
-	drag->setMimeData(model()->mimeData(indexes));
-	QPixmap pix = d->createDragPixmap(indexes);
-	drag->setPixmap(pix);
-	drag->exec(supportedActions, Qt::CopyAction);
-}
-
-
-void ThumbnailView::dragEnterEvent(QDragEnterEvent* event) {
-	QAbstractItemView::dragEnterEvent(event);
-	if (event->mimeData()->hasUrls()) {
-		event->acceptProposedAction();
-	}
-}
-
-
-void ThumbnailView::dragMoveEvent(QDragMoveEvent* event) {
-	// Necessary, otherwise we don't reach dropEvent()
-	QAbstractItemView::dragMoveEvent(event);
-	event->acceptProposedAction();
-}
-
-
-void ThumbnailView::dropEvent(QDropEvent* event) {
-	const KUrl::List urlList = KUrl::List::fromMimeData(event->mimeData());
-	if (urlList.isEmpty()) {
-		return;
-	}
-
-	QModelIndex destIndex = indexAt(event->pos());
-	if (destIndex.isValid()) {
-		KFileItem item = fileItemForIndex(destIndex);
-		if (item.isDir()) {
-			KUrl destUrl = item.url();
-			d->mThumbnailViewHelper->showMenuForUrlDroppedOnDir(this, urlList, destUrl);
-			return;
-		}
-	}
-
-	d->mThumbnailViewHelper->showMenuForUrlDroppedOnViewport(this, urlList);
-
-	event->acceptProposedAction();
-}
-
-
-void ThumbnailView::keyPressEvent(QKeyEvent* event) {
-	QListView::keyPressEvent(event);
-	if (event->key() == Qt::Key_Return) {
-		const QModelIndex index = selectionModel()->currentIndex();
-		if (index.isValid() && selectionModel()->selectedIndexes().count() == 1) {
-			emit indexActivated(index);
-		}
-	}
-}
-
-
-void ThumbnailView::resizeEvent(QResizeEvent* event) {
-	QListView::resizeEvent(event);
-	d->scheduleThumbnailGenerationForVisibleItems();
-}
-
-
-void ThumbnailView::showEvent(QShowEvent* event) {
-	QListView::showEvent(event);
-	d->scheduleThumbnailGenerationForVisibleItems();
-	QTimer::singleShot(0, this, SLOT(scrollToSelectedIndex()));
-}
-
-
-void ThumbnailView::wheelEvent(QWheelEvent* event) {
-	// If we don't adjust the single step, the wheel scroll exactly one item up
-	// and down, giving the impression that the items do not move but only
-	// their label changes.
-	// For some reason it is necessary to set the step here: setting it in
-	// setThumbnailSize() does not work
-	//verticalScrollBar()->setSingleStep(d->mThumbnailSize / 5);
-	if (event->modifiers() == Qt::ControlModifier) {
-		int size = d->mThumbnailSize + (event->delta() > 0 ? 1 : -1) * WHEEL_ZOOM_MULTIPLIER;
-		size = qMax(int(MinThumbnailSize), qMin(size, int(MaxThumbnailSize)));
-		setThumbnailSize(size);
-	} else {
-		QListView::wheelEvent(event);
-	}
-}
-
-
-void ThumbnailView::scrollToSelectedIndex() {
-	QModelIndexList list = selectedIndexes();
-	if (list.count() >= 1) {
-		scrollTo(list.first(), PositionAtCenter);
-	}
-}
-
-
-void ThumbnailView::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected) {
-	QListView::selectionChanged(selected, deselected);
-	emit selectionChangedSignal(selected, deselected);
-}
-
-
-void ThumbnailView::scrollContentsBy(int dx, int dy) {
-	QListView::scrollContentsBy(dx, dy);
-	d->scheduleThumbnailGenerationForVisibleItems();
-}
-
-
-void ThumbnailView::generateThumbnailsForVisibleItems() {
-	if (!isVisible() || !model()) {
-		return;
-	}
-	KFileItemList list;
-	QRect visibleRect = viewport()->rect();
-	// Adjust visibleRect so that next invisible rows of thumbnails
-	// get generated too
-	if (isWrapping()) {
-		visibleRect.adjust(0, 0, 0, d->mThumbnailSize * 2);
-	} else {
-		visibleRect.adjust(0, 0, visibleRect.width() / 2, 0);
-	}
-
-	for (int row=0; row < model()->rowCount(); ++row) {
-		QModelIndex index = model()->index(row, 0);
-		KFileItem item = fileItemForIndex(index);
-		QUrl url = item.url();
-
-		// Filter out invisible items
-		QRect rect = visualRect(index);
-		if (!visibleRect.intersects(rect)) {
-			continue;
-		}
-
-		// Filter out archives
-		MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
-		if (kind == MimeTypeUtils::KIND_ARCHIVE) {
-			continue;
-		}
-
-		// Immediately update modified items
-		if (d->mDocumentInfoProvider && d->mDocumentInfoProvider->isModified(url)) {
-			d->updateThumbnailForModifiedDocument(index);
-			continue;
-		}
-
-		// Filter out items which already have a thumbnail
-		ThumbnailForUrl::ConstIterator it = d->mThumbnailForUrl.constFind(url);
-		if (it != d->mThumbnailForUrl.constEnd() && it.value().isGroupPixAdaptedForSize(d->mThumbnailSize)) {
-			continue;
-		}
-
-		// Add the item to our list
-		list << item;
-
-		// Insert the thumbnail in mThumbnailForUrl, so that
-		// setThumbnail() can find the item to update
-		if (it == d->mThumbnailForUrl.constEnd()) {
-			Thumbnail thumbnail = Thumbnail(QPersistentModelIndex(index), item.time(KFileItem::ModificationTime));
-			d->mThumbnailForUrl.insert(url, thumbnail);
-		}
-	}
-
-	if (!list.empty()) {
-		d->generateThumbnailsForItems(list);
-	}
-}
-
-
-void ThumbnailView::updateThumbnail(const QModelIndex& index) {
-	KFileItem item = fileItemForIndex(index);
-	KUrl url = item.url();
-	if (d->mDocumentInfoProvider && d->mDocumentInfoProvider->isModified(url)) {
-		d->updateThumbnailForModifiedDocument(index);
-	} else {
-		KFileItemList list;
-		list << item;
-		d->generateThumbnailsForItems(list);
-	}
-}
-
-
-void ThumbnailView::updateThumbnailBusyState(const QModelIndex& _index, bool busy) {
-	QPersistentModelIndex index(_index);
-	if (busy && !d->mBusyIndexSet.contains(index)) {
-		d->mBusyIndexSet << index;
-		update(index);
-		if (d->mBusyAnimationTimeLine->state() != QTimeLine::Running) {
-			d->mBusyAnimationTimeLine->start();
-		}
-	} else if (!busy && d->mBusyIndexSet.remove(index)) {
-		update(index);
-		if (d->mBusyIndexSet.isEmpty()) {
-			d->mBusyAnimationTimeLine->stop();
-		}
-	}
-}
-
-
-void ThumbnailView::updateBusyIndexes() {
-	Q_FOREACH(const QPersistentModelIndex& index, d->mBusyIndexSet) {
-		update(index);
-	}
-}
-
-
-QPixmap ThumbnailView::busySequenceCurrentPixmap() const {
-	return d->mBusySequence.frameAt(d->mBusyAnimationTimeLine->currentFrame());
-}
-
-
-void ThumbnailView::smoothNextThumbnail() {
-	if (d->mSmoothThumbnailQueue.isEmpty()) {
-		return;
-	}
-
-	if (d->mThumbnailLoadJob) {
-		// give mThumbnailLoadJob priority over smoothing
-		d->mSmoothThumbnailTimer.start(SMOOTH_DELAY);
-		return;
-	}
-
-	KUrl url = d->mSmoothThumbnailQueue.dequeue();
-	ThumbnailForUrl::Iterator it = d->mThumbnailForUrl.find(url);
-	if (it == d->mThumbnailForUrl.end()) {
-		kWarning() <<  url << " not in mThumbnailForUrl. This should not happen!";
-		return;
-	}
-
-	Thumbnail& thumbnail = it.value();
-	thumbnail.mAdjustedPix = thumbnail.mGroupPix.scaled(d->mThumbnailSize, d->mThumbnailSize, Qt::KeepAspectRatio, Qt::SmoothTransformation);
-	thumbnail.mRough = false;
-
-	if (thumbnail.mIndex.isValid()) {
-		update(thumbnail.mIndex);
-	} else {
-		kWarning() << "index for" << url << "is invalid. This should not happen!";
-	}
-
-	if (!d->mSmoothThumbnailQueue.isEmpty()) {
-		d->mSmoothThumbnailTimer.start(0);
-	}
-}
-
-
-void ThumbnailView::reloadThumbnail(const QModelIndex& index) {
-	KUrl url = urlForIndex(index);
-	if (!url.isValid()) {
-		kWarning() << "Invalid url for index" << index;
-		return;
-	}
-	ThumbnailLoadJob::deleteImageThumbnail(url);
-	ThumbnailForUrl::Iterator it = d->mThumbnailForUrl.find(url);
-	if (it == d->mThumbnailForUrl.end()) {
-		return;
-	}
-	d->mThumbnailForUrl.erase(it);
-	generateThumbnailsForVisibleItems();
-}
-
+, d(new ThumbnailViewPrivate)
+{
+    d->q = this;
+    d->mThumbnailViewHelper = 0;
+    d->mDocumentInfoProvider = 0;
+    // Init to some stupid value so that the first call to setThumbnailSize()
+    // is not ignored (do not use 0 in case someone try to divide by
+    // mThumbnailSize...)
+    d->mThumbnailSize = 1;
+
+    setFrameShape(QFrame::NoFrame);
+    setViewMode(QListView::IconMode);
+    setResizeMode(QListView::Adjust);
+    setDragEnabled(true);
+    setAcceptDrops(true);
+    setDropIndicatorShown(true);
+    setUniformItemSizes(true);
+    setEditTriggers(QAbstractItemView::EditKeyPressed);
+
+    d->setupBusyAnimation();
+
+    viewport()->setMouseTracking(true);
+    // Set this attribute, otherwise the item delegate won't get the
+    // State_MouseOver state
+    viewport()->setAttribute(Qt::WA_Hover);
+
+    setVerticalScrollMode(ScrollPerPixel);
+    setHorizontalScrollMode(ScrollPerPixel);
+
+    d->mScheduledThumbnailGenerationTimer.setSingleShot(true);
+    d->mScheduledThumbnailGenerationTimer.setInterval(500);
+    connect(&d->mScheduledThumbnailGenerationTimer, SIGNAL(timeout()),
+            SLOT(generateThumbnailsForVisibleItems()));
+
+    d->mSmoothThumbnailTimer.setSingleShot(true);
+    connect(&d->mSmoothThumbnailTimer, SIGNAL(timeout()),
+            SLOT(smoothNextThumbnail()));
+
+    setContextMenuPolicy(Qt::CustomContextMenu);
+    connect(this, SIGNAL(customContextMenuRequested(QPoint)),
+            SLOT(showContextMenu()));
+
+    if (KGlobalSettings::singleClick()) {
+        connect(this, SIGNAL(clicked(QModelIndex)),
+                SLOT(emitIndexActivatedIfNoModifiers(QModelIndex)));
+    } else {
+        connect(this, SIGNAL(doubleClicked(QModelIndex)),
+                SLOT(emitIndexActivatedIfNoModifiers(QModelIndex)));
+    }
+}
+
+ThumbnailView::~ThumbnailView()
+{
+    delete d;
+}
+
+void ThumbnailView::setModel(QAbstractItemModel* newModel)
+{
+    if (model()) {
+        disconnect(model(), 0, this, 0);
+    }
+    QListView::setModel(newModel);
+    connect(model(), SIGNAL(rowsRemoved(QModelIndex, int, int)),
+            SIGNAL(rowsRemovedSignal(QModelIndex, int, int)));
+}
+
+void ThumbnailView::setThumbnailSize(int value)
+{
+    if (d->mThumbnailSize == value) {
+        return;
+    }
+    d->mThumbnailSize = value;
+
+    // mWaitingThumbnail
+    int waitingThumbnailSize;
+    if (value > 64) {
+        waitingThumbnailSize = 48;
+    } else {
+        waitingThumbnailSize = 32;
+    }
+    if (d->mWaitingThumbnail.width() != waitingThumbnailSize) {
+        QPixmap icon = DesktopIcon("chronometer", waitingThumbnailSize);
+        QPixmap pix(icon.size());
+        pix.fill(Qt::transparent);
+        QPainter painter(&pix);
+        painter.setOpacity(0.5);
+        painter.drawPixmap(0, 0, icon);
+        painter.end();
+        d->mWaitingThumbnail = pix;
+    }
+
+    // Stop smoothing
+    d->mSmoothThumbnailTimer.stop();
+    d->mSmoothThumbnailQueue.clear();
+
+    // Clear adjustedPixes
+    ThumbnailForUrl::iterator
+    it = d->mThumbnailForUrl.begin(),
+    end = d->mThumbnailForUrl.end();
+    for (; it != end; ++it) {
+        it.value().mAdjustedPix = QPixmap();
+    }
+
+    thumbnailSizeChanged(value);
+    d->scheduleThumbnailGenerationForVisibleItems();
+}
+
+int ThumbnailView::thumbnailSize() const
+{
+    return d->mThumbnailSize;
+}
+
+void ThumbnailView::setThumbnailViewHelper(AbstractThumbnailViewHelper* helper)
+{
+    d->mThumbnailViewHelper = helper;
+}
+
+AbstractThumbnailViewHelper* ThumbnailView::thumbnailViewHelper() const
+{
+    return d->mThumbnailViewHelper;
+}
+
+void ThumbnailView::setDocumentInfoProvider(AbstractDocumentInfoProvider* provider)
+{
+    d->mDocumentInfoProvider = provider;
+    if (provider) {
+        connect(provider, SIGNAL(busyStateChanged(QModelIndex, bool)),
+                SLOT(updateThumbnailBusyState(QModelIndex, bool)));
+        connect(provider, SIGNAL(documentChanged(QModelIndex)),
+                SLOT(updateThumbnail(QModelIndex)));
+    }
+}
+
+AbstractDocumentInfoProvider* ThumbnailView::documentInfoProvider() const
+{
+    return d->mDocumentInfoProvider;
+}
+
+void ThumbnailView::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int end)
+{
+    QListView::rowsAboutToBeRemoved(parent, start, end);
+
+    // Remove references to removed items
+    KFileItemList itemList;
+    for (int pos = start; pos <= end; ++pos) {
+        QModelIndex index = model()->index(pos, 0, parent);
+        KFileItem item = fileItemForIndex(index);
+        if (item.isNull()) {
+            kDebug() << "Skipping invalid item!" << index.data().toString();
+            continue;
+        }
+
+        QUrl url = item.url();
+        d->mThumbnailForUrl.remove(url);
+        d->mSmoothThumbnailQueue.removeAll(url);
+
+        itemList.append(item);
+    }
+
+    if (d->mThumbnailLoadJob) {
+        d->mThumbnailLoadJob->removeItems(itemList);
+    }
+
+    // Update current index if it is among the deleted rows
+    const int row = currentIndex().row();
+    if (start <= row && row <= end) {
+        QModelIndex index;
+        if (end < model()->rowCount() - 1) {
+            index = model()->index(end + 1, 0);
+        } else if (start > 0) {
+            index = model()->index(start - 1, 0);
+        }
+        setCurrentIndex(index);
+    }
+
+    // Removing rows might make new images visible, make sure their thumbnail
+    // is generated
+    d->mScheduledThumbnailGenerationTimer.start();
+}
+
+void ThumbnailView::rowsInserted(const QModelIndex& parent, int start, int end)
+{
+    QListView::rowsInserted(parent, start, end);
+    d->mScheduledThumbnailGenerationTimer.start();
+    rowsInsertedSignal(parent, start, end);
+}
+
+void ThumbnailView::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
+{
+    QListView::dataChanged(topLeft, bottomRight);
+    bool thumbnailsNeedRefresh = false;
+    for (int row = topLeft.row(); row <= bottomRight.row(); ++row) {
+        QModelIndex index = model()->index(row, 0);
+        KFileItem item = fileItemForIndex(index);
+        if (item.isNull()) {
+            kWarning() << "Invalid item for index" << index << ". This should not happen!";
+            continue;
+        }
+
+        ThumbnailForUrl::Iterator it = d->mThumbnailForUrl.find(item.url());
+        if (it != d->mThumbnailForUrl.end()) {
+            // All thumbnail views are connected to the model, so
+            // ThumbnailView::dataChanged() is called for all of them. As a
+            // result this method will also be called for views which are not
+            // currently visible, and do not yet have a thumbnail for the
+            // modified url.
+            KDateTime mtime = item.time(KFileItem::ModificationTime);
+            if (it->mModificationTime != mtime) {
+                // dataChanged() is called when the file changes but also when
+                // the model fetched additional data such as semantic info. To
+                // avoid needless refreshes, we only trigger a refresh if the
+                // modification time changes.
+                thumbnailsNeedRefresh = true;
+                it->prepareForRefresh(mtime);
+            }
+        }
+    }
+    if (thumbnailsNeedRefresh) {
+        d->mScheduledThumbnailGenerationTimer.start();
+    }
+}
+
+void ThumbnailView::showContextMenu()
+{
+    d->mThumbnailViewHelper->showContextMenu(this);
+}
+
+void ThumbnailView::emitIndexActivatedIfNoModifiers(const QModelIndex& index)
+{
+    if (QApplication::keyboardModifiers() == Qt::NoModifier) {
+        emit indexActivated(index);
+    }
+}
+
+void ThumbnailView::setThumbnail(const KFileItem& item, const QPixmap& pixmap, const QSize& size)
+{
+    ThumbnailForUrl::iterator it = d->mThumbnailForUrl.find(item.url());
+    if (it == d->mThumbnailForUrl.end()) {
+        return;
+    }
+    Thumbnail& thumbnail = it.value();
+    thumbnail.mGroupPix = pixmap;
+    thumbnail.mAdjustedPix = QPixmap();
+    int largeGroupSize = ThumbnailGroup::pixelSize(ThumbnailGroup::Large);
+    thumbnail.mFullSize = size.isValid() ? size : QSize(largeGroupSize, largeGroupSize);
+    thumbnail.mRealFullSize = size;
+    thumbnail.mWaitingForThumbnail = false;
+
+    update(thumbnail.mIndex);
+}
+
+void ThumbnailView::setBrokenThumbnail(const KFileItem& item)
+{
+    ThumbnailForUrl::iterator it = d->mThumbnailForUrl.find(item.url());
+    if (it == d->mThumbnailForUrl.end()) {
+        return;
+    }
+    Thumbnail& thumbnail = it.value();
+    MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
+    if (kind == MimeTypeUtils::KIND_VIDEO) {
+        // Special case for videos because our kde install may come without
+        // support for video thumbnails so we show the mimetype icon instead of
+        // a broken image icon
+        ThumbnailGroup::Enum group = ThumbnailGroup::fromPixelSize(d->mThumbnailSize);
+        QPixmap pix = item.pixmap(ThumbnailGroup::pixelSize(group));
+        thumbnail.initAsIcon(pix);
+    } else if (kind == MimeTypeUtils::KIND_DIR) {
+        // Special case for folders because ThumbnailLoadJob does not return a
+        // thumbnail if there is no images
+        thumbnail.mWaitingForThumbnail = false;
+        return;
+    } else {
+        thumbnail.initAsIcon(DesktopIcon("image-missing", 48));
+        thumbnail.mFullSize = thumbnail.mGroupPix.size();
+    }
+    update(thumbnail.mIndex);
+}
+
+QPixmap ThumbnailView::thumbnailForIndex(const QModelIndex& index, QSize* fullSize)
+{
+    KFileItem item = fileItemForIndex(index);
+    if (item.isNull()) {
+        LOG("Invalid item");
+        if (fullSize) {
+            *fullSize = QSize();
+        }
+        return QPixmap();
+    }
+    KUrl url = item.url();
+
+    // Find or create Thumbnail instance
+    ThumbnailForUrl::Iterator it = d->mThumbnailForUrl.find(url);
+    if (it == d->mThumbnailForUrl.end()) {
+        Thumbnail thumbnail = Thumbnail(QPersistentModelIndex(index), item.time(KFileItem::ModificationTime));
+        it = d->mThumbnailForUrl.insert(url, thumbnail);
+    }
+    Thumbnail& thumbnail = it.value();
+
+    // If dir or archive, generate a thumbnail from fileitem pixmap
+    MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
+    if (kind == MimeTypeUtils::KIND_ARCHIVE || kind == MimeTypeUtils::KIND_DIR) {
+        int groupSize = ThumbnailGroup::pixelSize(ThumbnailGroup::fromPixelSize(d->mThumbnailSize));
+        if (thumbnail.mGroupPix.isNull() || thumbnail.mGroupPix.width() < groupSize) {
+            QPixmap pix = item.pixmap(groupSize);
+            thumbnail.initAsIcon(pix);
+            if (kind == MimeTypeUtils::KIND_ARCHIVE) {
+                // No thumbnails for archives
+                thumbnail.mWaitingForThumbnail = false;
+            } else {
+                // set mWaitingForThumbnail to true (necessary in the case
+                // 'thumbnail' already existed before, but with a too small
+                // mGroupPix)
+                thumbnail.mWaitingForThumbnail = true;
+            }
+        }
+    }
+
+    if (thumbnail.mGroupPix.isNull()) {
+        if (fullSize) {
+            *fullSize = QSize();
+        }
+        return d->mWaitingThumbnail;
+    }
+
+    // Adjust thumbnail
+    if (thumbnail.mAdjustedPix.isNull()) {
+        d->roughAdjustThumbnail(&thumbnail);
+    }
+    if (thumbnail.mRough && !d->mSmoothThumbnailQueue.contains(url)) {
+        d->mSmoothThumbnailQueue.enqueue(url);
+        if (!d->mSmoothThumbnailTimer.isActive()) {
+            d->mSmoothThumbnailTimer.start(SMOOTH_DELAY);
+        }
+    }
+    if (fullSize) {
+        *fullSize = thumbnail.mRealFullSize;
+    }
+    return thumbnail.mAdjustedPix;
+}
+
+bool ThumbnailView::isModified(const QModelIndex& index) const
+{
+    if (!d->mDocumentInfoProvider) {
+        return false;
+    }
+    KUrl url = urlForIndex(index);
+    return d->mDocumentInfoProvider->isModified(url);
+}
+
+bool ThumbnailView::isBusy(const QModelIndex& index) const
+{
+    if (!d->mDocumentInfoProvider) {
+        return false;
+    }
+    KUrl url = urlForIndex(index);
+    return d->mDocumentInfoProvider->isBusy(url);
+}
+
+void ThumbnailView::startDrag(Qt::DropActions supportedActions)
+{
+    QModelIndexList indexes = selectionModel()->selectedIndexes();
+    if (indexes.isEmpty()) {
+        return;
+    }
+    QDrag* drag = new QDrag(this);
+    drag->setMimeData(model()->mimeData(indexes));
+    QPixmap pix = d->createDragPixmap(indexes);
+    drag->setPixmap(pix);
+    drag->exec(supportedActions, Qt::CopyAction);
+}
+
+void ThumbnailView::dragEnterEvent(QDragEnterEvent* event)
+{
+    QAbstractItemView::dragEnterEvent(event);
+    if (event->mimeData()->hasUrls()) {
+        event->acceptProposedAction();
+    }
+}
+
+void ThumbnailView::dragMoveEvent(QDragMoveEvent* event)
+{
+    // Necessary, otherwise we don't reach dropEvent()
+    QAbstractItemView::dragMoveEvent(event);
+    event->acceptProposedAction();
+}
+
+void ThumbnailView::dropEvent(QDropEvent* event)
+{
+    const KUrl::List urlList = KUrl::List::fromMimeData(event->mimeData());
+    if (urlList.isEmpty()) {
+        return;
+    }
+
+    QModelIndex destIndex = indexAt(event->pos());
+    if (destIndex.isValid()) {
+        KFileItem item = fileItemForIndex(destIndex);
+        if (item.isDir()) {
+            KUrl destUrl = item.url();
+            d->mThumbnailViewHelper->showMenuForUrlDroppedOnDir(this, urlList, destUrl);
+            return;
+        }
+    }
+
+    d->mThumbnailViewHelper->showMenuForUrlDroppedOnViewport(this, urlList);
+
+    event->acceptProposedAction();
+}
+
+void ThumbnailView::keyPressEvent(QKeyEvent* event)
+{
+    QListView::keyPressEvent(event);
+    if (event->key() == Qt::Key_Return) {
+        const QModelIndex index = selectionModel()->currentIndex();
+        if (index.isValid() && selectionModel()->selectedIndexes().count() == 1) {
+            emit indexActivated(index);
+        }
+    }
+}
+
+void ThumbnailView::resizeEvent(QResizeEvent* event)
+{
+    QListView::resizeEvent(event);
+    d->scheduleThumbnailGenerationForVisibleItems();
+}
+
+void ThumbnailView::showEvent(QShowEvent* event)
+{
+    QListView::showEvent(event);
+    d->scheduleThumbnailGenerationForVisibleItems();
+    QTimer::singleShot(0, this, SLOT(scrollToSelectedIndex()));
+}
+
+void ThumbnailView::wheelEvent(QWheelEvent* event)
+{
+    // If we don't adjust the single step, the wheel scroll exactly one item up
+    // and down, giving the impression that the items do not move but only
+    // their label changes.
+    // For some reason it is necessary to set the step here: setting it in
+    // setThumbnailSize() does not work
+    //verticalScrollBar()->setSingleStep(d->mThumbnailSize / 5);
+    if (event->modifiers() == Qt::ControlModifier) {
+        int size = d->mThumbnailSize + (event->delta() > 0 ? 1 : -1) * WHEEL_ZOOM_MULTIPLIER;
+        size = qMax(int(MinThumbnailSize), qMin(size, int(MaxThumbnailSize)));
+        setThumbnailSize(size);
+    } else {
+        QListView::wheelEvent(event);
+    }
+}
+
+void ThumbnailView::scrollToSelectedIndex()
+{
+    QModelIndexList list = selectedIndexes();
+    if (list.count() >= 1) {
+        scrollTo(list.first(), PositionAtCenter);
+    }
+}
+
+void ThumbnailView::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
+{
+    QListView::selectionChanged(selected, deselected);
+    emit selectionChangedSignal(selected, deselected);
+}
+
+void ThumbnailView::scrollContentsBy(int dx, int dy)
+{
+    QListView::scrollContentsBy(dx, dy);
+    d->scheduleThumbnailGenerationForVisibleItems();
+}
+
+void ThumbnailView::generateThumbnailsForVisibleItems()
+{
+    if (!isVisible() || !model()) {
+        return;
+    }
+    KFileItemList list;
+    QRect visibleRect = viewport()->rect();
+    // Adjust visibleRect so that next thumbnail page|row
+    // get generated too
+    if (isWrapping()) {
+        visibleRect.setHeight(visibleRect.height() * 2);
+    } else {
+        visibleRect.setWidth(visibleRect.width() * 2);
+    }
+
+    for (int row = 0; row < model()->rowCount(); ++row) {
+        QModelIndex index = model()->index(row, 0);
+        KFileItem item = fileItemForIndex(index);
+        QUrl url = item.url();
+
+        // Filter out invisible items
+        QRect rect = visualRect(index);
+        if (!visibleRect.intersects(rect)) {
+            continue;
+        }
+
+        // Filter out archives
+        MimeTypeUtils::Kind kind = MimeTypeUtils::fileItemKind(item);
+        if (kind == MimeTypeUtils::KIND_ARCHIVE) {
+            continue;
+        }
+
+        // Immediately update modified items
+        if (d->mDocumentInfoProvider && d->mDocumentInfoProvider->isModified(url)) {
+            d->updateThumbnailForModifiedDocument(index);
+            continue;
+        }
+
+        // Filter out items which already have a thumbnail
+        ThumbnailForUrl::ConstIterator it = d->mThumbnailForUrl.constFind(url);
+        if (it != d->mThumbnailForUrl.constEnd() && it.value().isGroupPixAdaptedForSize(d->mThumbnailSize)) {
+            continue;
+        }
+
+        // Add the item to our list
+        list << item;
+
+        // Insert the thumbnail in mThumbnailForUrl, so that
+        // setThumbnail() can find the item to update
+        if (it == d->mThumbnailForUrl.constEnd()) {
+            Thumbnail thumbnail = Thumbnail(QPersistentModelIndex(index), item.time(KFileItem::ModificationTime));
+            d->mThumbnailForUrl.insert(url, thumbnail);
+        }
+    }
+
+    if (!list.empty()) {
+        d->generateThumbnailsForItems(list);
+    }
+}
+
+void ThumbnailView::updateThumbnail(const QModelIndex& index)
+{
+    KFileItem item = fileItemForIndex(index);
+    KUrl url = item.url();
+    if (d->mDocumentInfoProvider && d->mDocumentInfoProvider->isModified(url)) {
+        d->updateThumbnailForModifiedDocument(index);
+    } else {
+        KFileItemList list;
+        list << item;
+        d->generateThumbnailsForItems(list);
+    }
+}
+
+void ThumbnailView::updateThumbnailBusyState(const QModelIndex& _index, bool busy)
+{
+    QPersistentModelIndex index(_index);
+    if (busy && !d->mBusyIndexSet.contains(index)) {
+        d->mBusyIndexSet << index;
+        update(index);
+        if (d->mBusyAnimationTimeLine->state() != QTimeLine::Running) {
+            d->mBusyAnimationTimeLine->start();
+        }
+    } else if (!busy && d->mBusyIndexSet.remove(index)) {
+        update(index);
+        if (d->mBusyIndexSet.isEmpty()) {
+            d->mBusyAnimationTimeLine->stop();
+        }
+    }
+}
+
+void ThumbnailView::updateBusyIndexes()
+{
+    Q_FOREACH(const QPersistentModelIndex & index, d->mBusyIndexSet) {
+        update(index);
+    }
+}
+
+QPixmap ThumbnailView::busySequenceCurrentPixmap() const
+{
+    return d->mBusySequence.frameAt(d->mBusyAnimationTimeLine->currentFrame());
+}
+
+void ThumbnailView::smoothNextThumbnail()
+{
+    if (d->mSmoothThumbnailQueue.isEmpty()) {
+        return;
+    }
+
+    if (d->mThumbnailLoadJob) {
+        // give mThumbnailLoadJob priority over smoothing
+        d->mSmoothThumbnailTimer.start(SMOOTH_DELAY);
+        return;
+    }
+
+    KUrl url = d->mSmoothThumbnailQueue.dequeue();
+    ThumbnailForUrl::Iterator it = d->mThumbnailForUrl.find(url);
+    if (it == d->mThumbnailForUrl.end()) {
+        kWarning() <<  url << " not in mThumbnailForUrl. This should not happen!";
+        return;
+    }
+
+    Thumbnail& thumbnail = it.value();
+    thumbnail.mAdjustedPix = thumbnail.mGroupPix.scaled(d->mThumbnailSize, d->mThumbnailSize, Qt::KeepAspectRatio, Qt::SmoothTransformation);
+    thumbnail.mRough = false;
+
+    if (thumbnail.mIndex.isValid()) {
+        update(thumbnail.mIndex);
+    } else {
+        kWarning() << "index for" << url << "is invalid. This should not happen!";
+    }
+
+    if (!d->mSmoothThumbnailQueue.isEmpty()) {
+        d->mSmoothThumbnailTimer.start(0);
+    }
+}
+
+void ThumbnailView::reloadThumbnail(const QModelIndex& index)
+{
+    KUrl url = urlForIndex(index);
+    if (!url.isValid()) {
+        kWarning() << "Invalid url for index" << index;
+        return;
+    }
+    ThumbnailLoadJob::deleteImageThumbnail(url);
+    ThumbnailForUrl::Iterator it = d->mThumbnailForUrl.find(url);
+    if (it == d->mThumbnailForUrl.end()) {
+        return;
+    }
+    d->mThumbnailForUrl.erase(it);
+    generateThumbnailsForVisibleItems();
+}
 
 } // namespace

=== modified file 'lib/thumbnailview/thumbnailview.h'
--- lib/thumbnailview/thumbnailview.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/thumbnailview.h	2011-12-15 14:17:54 +0000
@@ -34,149 +34,150 @@
 class QDropEvent;
 class QPixmap;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 class AbstractDocumentInfoProvider;
 class AbstractThumbnailViewHelper;
 
 struct ThumbnailViewPrivate;
-class GWENVIEWLIB_EXPORT ThumbnailView : public QListView {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ThumbnailView : public QListView
+{
+    Q_OBJECT
 public:
-	enum {
-		MinThumbnailSize = 48,
-		MaxThumbnailSize = 256
-	};
-	ThumbnailView(QWidget* parent);
-	~ThumbnailView();
-
-	void setThumbnailViewHelper(AbstractThumbnailViewHelper* helper);
-
-	AbstractThumbnailViewHelper* thumbnailViewHelper() const;
-
-	void setDocumentInfoProvider(AbstractDocumentInfoProvider* provider);
-
-	AbstractDocumentInfoProvider* documentInfoProvider() const;
-
-	/**
-	 * Returns the thumbnail size.
-	 */
-	int thumbnailSize() const;
-
-	QPixmap thumbnailForIndex(const QModelIndex&, QSize* fullSize = 0);
-
-	/**
-	 * Returns true if the document pointed by the index has been modified
-	 * inside Gwenview.
-	 */
-	bool isModified(const QModelIndex&) const;
-
-	/**
-	 * Returns true if the document pointed by the index is currently busy
-	 * (loading, saving, rotating...)
-	 */
-	bool isBusy(const QModelIndex& index) const;
-
-	virtual void setModel(QAbstractItemModel* model);
-
-	/**
-	 * Publish this method so that delegates can call it.
-	 */
-	using QListView::scheduleDelayedItemsLayout;
-
-	/**
-	 * Returns the current pixmap to paint when drawing a busy index.
-	 */
-	QPixmap busySequenceCurrentPixmap() const;
-
-	void reloadThumbnail(const QModelIndex&);
+    enum {
+        MinThumbnailSize = 48,
+        MaxThumbnailSize = 256
+    };
+    ThumbnailView(QWidget* parent);
+    ~ThumbnailView();
+
+    void setThumbnailViewHelper(AbstractThumbnailViewHelper* helper);
+
+    AbstractThumbnailViewHelper* thumbnailViewHelper() const;
+
+    void setDocumentInfoProvider(AbstractDocumentInfoProvider* provider);
+
+    AbstractDocumentInfoProvider* documentInfoProvider() const;
+
+    /**
+     * Returns the thumbnail size.
+     */
+    int thumbnailSize() const;
+
+    QPixmap thumbnailForIndex(const QModelIndex&, QSize* fullSize = 0);
+
+    /**
+     * Returns true if the document pointed by the index has been modified
+     * inside Gwenview.
+     */
+    bool isModified(const QModelIndex&) const;
+
+    /**
+     * Returns true if the document pointed by the index is currently busy
+     * (loading, saving, rotating...)
+     */
+    bool isBusy(const QModelIndex& index) const;
+
+    virtual void setModel(QAbstractItemModel* model);
+
+    /**
+     * Publish this method so that delegates can call it.
+     */
+    using QListView::scheduleDelayedItemsLayout;
+
+    /**
+     * Returns the current pixmap to paint when drawing a busy index.
+     */
+    QPixmap busySequenceCurrentPixmap() const;
+
+    void reloadThumbnail(const QModelIndex&);
 
 Q_SIGNALS:
-	/**
-	 * It seems we can't use the 'activated()' signal for now because it does
-	 * not know about KDE single vs doubleclick settings. The indexActivated()
-	 * signal replaces it.
-	 */
-	void indexActivated(const QModelIndex&);
-	void urlListDropped(const KUrl::List& lst, const KUrl& destination);
-
-	void thumbnailSizeChanged(int);
-
-	/**
-	 * Emitted whenever selectionChanged() is called.
-	 * This signal is suffixed with "Signal" because
-	 * QAbstractItemView::selectionChanged() is a slot.
-	 */
-	void selectionChangedSignal(const QItemSelection&, const QItemSelection&);
-
-	/**
-	 * Forward some signals from model, so that the delegate can use them
-	 */
-	void rowsRemovedSignal(const QModelIndex& parent, int start, int end);
-
-	void rowsInsertedSignal(const QModelIndex& parent, int start, int end);
-
+    /**
+     * It seems we can't use the 'activated()' signal for now because it does
+     * not know about KDE single vs doubleclick settings. The indexActivated()
+     * signal replaces it.
+     */
+    void indexActivated(const QModelIndex&);
+    void urlListDropped(const KUrl::List& lst, const KUrl& destination);
+
+    void thumbnailSizeChanged(int);
+
+    /**
+     * Emitted whenever selectionChanged() is called.
+     * This signal is suffixed with "Signal" because
+     * QAbstractItemView::selectionChanged() is a slot.
+     */
+    void selectionChangedSignal(const QItemSelection&, const QItemSelection&);
+
+    /**
+     * Forward some signals from model, so that the delegate can use them
+     */
+    void rowsRemovedSignal(const QModelIndex& parent, int start, int end);
+
+    void rowsInsertedSignal(const QModelIndex& parent, int start, int end);
 
 public Q_SLOTS:
-	/**
-	 * Sets the thumbnail size, in pixels.
-	 */
-	void setThumbnailSize(int pixel);
+    /**
+     * Sets the thumbnail size, in pixels.
+     */
+    void setThumbnailSize(int pixel);
 
-	void scrollToSelectedIndex();
+    void scrollToSelectedIndex();
 
 protected:
-	virtual void dragEnterEvent(QDragEnterEvent*);
-
-	virtual void dragMoveEvent(QDragMoveEvent*);
-
-	virtual void dropEvent(QDropEvent*);
-
-	virtual void keyPressEvent(QKeyEvent*);
-
-	virtual void resizeEvent(QResizeEvent*);
-
-	virtual void scrollContentsBy(int dx, int dy);
-
-	virtual void showEvent(QShowEvent*);
-
-	virtual void wheelEvent(QWheelEvent*);
-
-	virtual void startDrag(Qt::DropActions);
+    virtual void dragEnterEvent(QDragEnterEvent*);
+
+    virtual void dragMoveEvent(QDragMoveEvent*);
+
+    virtual void dropEvent(QDropEvent*);
+
+    virtual void keyPressEvent(QKeyEvent*);
+
+    virtual void resizeEvent(QResizeEvent*);
+
+    virtual void scrollContentsBy(int dx, int dy);
+
+    virtual void showEvent(QShowEvent*);
+
+    virtual void wheelEvent(QWheelEvent*);
+
+    virtual void startDrag(Qt::DropActions);
 
 protected Q_SLOTS:
-	virtual void rowsAboutToBeRemoved(const QModelIndex& parent, int start, int end);
-	virtual void rowsInserted(const QModelIndex& parent, int start, int end);
-	virtual void selectionChanged(const QItemSelection& selected, const QItemSelection& deselected);
-	virtual void dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight);
+    virtual void rowsAboutToBeRemoved(const QModelIndex& parent, int start, int end);
+    virtual void rowsInserted(const QModelIndex& parent, int start, int end);
+    virtual void selectionChanged(const QItemSelection& selected, const QItemSelection& deselected);
+    virtual void dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight);
 
 private Q_SLOTS:
-	void showContextMenu();
-	void emitIndexActivatedIfNoModifiers(const QModelIndex&);
-	void setThumbnail(const KFileItem&, const QPixmap&, const QSize&);
-	void setBrokenThumbnail(const KFileItem&);
-
-	/**
-	 * Generate thumbnail for @a index.
-	 */
-	void updateThumbnail(const QModelIndex& index);
-
-	/**
-	 * Tells the view the busy state of the document pointed by the index has changed.
-	 */
-	void updateThumbnailBusyState(const QModelIndex& index, bool);
-
-	/*
-	 * Cause a repaint of all busy indexes
-	 */
-	void updateBusyIndexes();
-
-	void generateThumbnailsForVisibleItems();
-	void smoothNextThumbnail();
+    void showContextMenu();
+    void emitIndexActivatedIfNoModifiers(const QModelIndex&);
+    void setThumbnail(const KFileItem&, const QPixmap&, const QSize&);
+    void setBrokenThumbnail(const KFileItem&);
+
+    /**
+     * Generate thumbnail for @a index.
+     */
+    void updateThumbnail(const QModelIndex& index);
+
+    /**
+     * Tells the view the busy state of the document pointed by the index has changed.
+     */
+    void updateThumbnailBusyState(const QModelIndex& index, bool);
+
+    /*
+     * Cause a repaint of all busy indexes
+     */
+    void updateBusyIndexes();
+
+    void generateThumbnailsForVisibleItems();
+    void smoothNextThumbnail();
 
 private:
-	friend struct ThumbnailViewPrivate;
-	ThumbnailViewPrivate * const d;
+    friend struct ThumbnailViewPrivate;
+    ThumbnailViewPrivate * const d;
 };
 
 } // namespace

=== modified file 'lib/thumbnailview/tooltipwidget.cpp'
--- lib/thumbnailview/tooltipwidget.cpp	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/tooltipwidget.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -36,72 +36,71 @@
 static const int RADIUS = 5;
 static const int HMARGIN = 2;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ToolTipWidgetPrivate {
-	QString mText;
-	qreal mOpacity;
+    QString mText;
+    qreal mOpacity;
 };
 
-
 ToolTipWidget::ToolTipWidget(QWidget* parent)
 : QWidget(parent)
-, d(new ToolTipWidgetPrivate) {
-	d->mOpacity = 1.;
-	setAutoFillBackground(true);
-}
-
-
-ToolTipWidget::~ToolTipWidget() {
-	delete d;
-}
-
-
-qreal ToolTipWidget::opacity() const {
-	return d->mOpacity;
-}
-
-
-void ToolTipWidget::setOpacity(qreal opacity) {
-	d->mOpacity = opacity;
-	update();
-}
-
-
-QString ToolTipWidget::text() const {
-	return d->mText;
-}
-
-
-void ToolTipWidget::setText(const QString& text) {
-	d->mText = text;
-	update();
-}
-
-
-QSize ToolTipWidget::sizeHint() const {
-	QSize sh = fontMetrics().size(0 /* flags */, d->mText);
-	return QSize(sh.width() + 2 * HMARGIN, sh.height());
-}
-
-
-void ToolTipWidget::paintEvent(QPaintEvent*) {
-	QColor bg2Color = QToolTip::palette().color(QPalette::ToolTipBase);
-	QColor bg1Color = KColorScheme::shade(bg2Color, KColorScheme::LightShade, 0.2);
-
-	QLinearGradient gradient(QPointF(0.0, 0.0), QPointF(0.0, height()));
-	gradient.setColorAt(0.0, bg1Color);
-	gradient.setColorAt(1.0, bg2Color);
-
-	QPainter painter(this);
-	painter.setRenderHint(QPainter::Antialiasing);
-	painter.setOpacity(d->mOpacity);
-	QPainterPath path = PaintUtils::roundedRectangle(rect(), RADIUS);
-	painter.fillPath(path, gradient);
-	painter.setPen(palette().color(QPalette::ToolTipText));
-	painter.drawText(rect().adjusted(HMARGIN, 0, -HMARGIN, 0), 0 /* flags */, d->mText);
-}
-
+, d(new ToolTipWidgetPrivate)
+{
+    d->mOpacity = 1.;
+    setAutoFillBackground(true);
+}
+
+ToolTipWidget::~ToolTipWidget()
+{
+    delete d;
+}
+
+qreal ToolTipWidget::opacity() const
+{
+    return d->mOpacity;
+}
+
+void ToolTipWidget::setOpacity(qreal opacity)
+{
+    d->mOpacity = opacity;
+    update();
+}
+
+QString ToolTipWidget::text() const
+{
+    return d->mText;
+}
+
+void ToolTipWidget::setText(const QString& text)
+{
+    d->mText = text;
+    update();
+}
+
+QSize ToolTipWidget::sizeHint() const
+{
+    QSize sh = fontMetrics().size(0 /* flags */, d->mText);
+    return QSize(sh.width() + 2 * HMARGIN, sh.height());
+}
+
+void ToolTipWidget::paintEvent(QPaintEvent*)
+{
+    QColor bg2Color = QToolTip::palette().color(QPalette::ToolTipBase);
+    QColor bg1Color = KColorScheme::shade(bg2Color, KColorScheme::LightShade, 0.2);
+
+    QLinearGradient gradient(QPointF(0.0, 0.0), QPointF(0.0, height()));
+    gradient.setColorAt(0.0, bg1Color);
+    gradient.setColorAt(1.0, bg2Color);
+
+    QPainter painter(this);
+    painter.setRenderHint(QPainter::Antialiasing);
+    painter.setOpacity(d->mOpacity);
+    QPainterPath path = PaintUtils::roundedRectangle(rect(), RADIUS);
+    painter.fillPath(path, gradient);
+    painter.setPen(palette().color(QPalette::ToolTipText));
+    painter.drawText(rect().adjusted(HMARGIN, 0, -HMARGIN, 0), 0 /* flags */, d->mText);
+}
 
 } // namespace

=== modified file 'lib/thumbnailview/tooltipwidget.h'
--- lib/thumbnailview/tooltipwidget.h	2011-07-20 13:46:34 +0000
+++ lib/thumbnailview/tooltipwidget.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -28,37 +28,37 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ToolTipWidgetPrivate;
 
 /**
  * A label which uses tooltip colors and can be faded
  */
-class ToolTipWidget : public QWidget {
-	Q_OBJECT
-	Q_PROPERTY(qreal opacity READ opacity WRITE setOpacity)
+class ToolTipWidget : public QWidget
+{
+    Q_OBJECT
+    Q_PROPERTY(qreal opacity READ opacity WRITE setOpacity)
 public:
-	ToolTipWidget(QWidget* parent = 0);
-	~ToolTipWidget();
-
-	qreal opacity() const;
-	void setOpacity(qreal);
-
-	QString text() const;
-	void setText(const QString& text);
-
-	virtual QSize sizeHint() const;
+    ToolTipWidget(QWidget* parent = 0);
+    ~ToolTipWidget();
+
+    qreal opacity() const;
+    void setOpacity(qreal);
+
+    QString text() const;
+    void setText(const QString& text);
+
+    virtual QSize sizeHint() const;
 
 protected:
-	virtual void paintEvent(QPaintEvent*);
+    virtual void paintEvent(QPaintEvent*);
 
 private:
-	ToolTipWidgetPrivate* const d;
+    ToolTipWidgetPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* TOOLTIPWIDGET_H */

=== modified file 'lib/timeutils.cpp'
--- lib/timeutils.cpp	2011-07-20 13:46:34 +0000
+++ lib/timeutils.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -31,48 +31,52 @@
 #include <kfilemetainfo.h>
 #include <kfilemetainfoitem.h>
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace TimeUtils {
+namespace TimeUtils
+{
 
 struct CacheItem {
-	KDateTime fileMTime;
-	KDateTime realTime;
-
-	void update(const KFileItem& fileItem) {
-		KDateTime time = fileItem.time(KFileItem::ModificationTime);
-		if (fileMTime == time) {
-			return;
-		}
-
-		fileMTime = time;
-		const KFileMetaInfo info = fileItem.metaInfo();
-		if (info.isValid()) {
-			const KFileMetaInfoItem& mii = info.item("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentCreated");
-			KDateTime dt(mii.value().toDateTime(), KDateTime::LocalZone);
-			if (dt.isValid()) {
-				realTime = dt;
-				return;
-			}
-		}
-
-		realTime = time;
-	}
+    KDateTime fileMTime;
+    KDateTime realTime;
+
+    void update(const KFileItem& fileItem)
+    {
+        KDateTime time = fileItem.time(KFileItem::ModificationTime);
+        if (fileMTime == time) {
+            return;
+        }
+
+        fileMTime = time;
+        const KFileMetaInfo info = fileItem.metaInfo();
+        if (info.isValid()) {
+            const KFileMetaInfoItem& mii = info.item("http://www.semanticdesktop.org/ontologies/2007/01/19/nie#contentCreated");
+            KDateTime dt(mii.value().toDateTime(), KDateTime::LocalZone);
+            if (dt.isValid()) {
+                realTime = dt;
+                return;
+            }
+        }
+
+        realTime = time;
+    }
 };
 
 typedef QHash<KUrl, CacheItem> Cache;
 
-KDateTime dateTimeForFileItem(const KFileItem& fileItem) {
-	static Cache cache;
-	const KUrl url = fileItem.targetUrl();
-
-	Cache::iterator it = cache.find(url);
-	if (it == cache.end()) {
-		it = cache.insert(url, CacheItem());
-	}
-
-	it.value().update(fileItem);
-	return it.value().realTime;
+KDateTime dateTimeForFileItem(const KFileItem& fileItem)
+{
+    static Cache cache;
+    const KUrl url = fileItem.targetUrl();
+
+    Cache::iterator it = cache.find(url);
+    if (it == cache.end()) {
+        it = cache.insert(url, CacheItem());
+    }
+
+    it.value().update(fileItem);
+    return it.value().realTime;
 }
 
 } // namespace

=== modified file 'lib/timeutils.h'
--- lib/timeutils.h	2011-07-20 13:46:34 +0000
+++ lib/timeutils.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -27,9 +27,11 @@
 class KFileItem;
 class KDateTime;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace TimeUtils {
+namespace TimeUtils
+{
 
 GWENVIEWLIB_EXPORT KDateTime dateTimeForFileItem(const KFileItem&);
 

=== modified file 'lib/transformimageoperation.cpp'
--- lib/transformimageoperation.cpp	2011-07-20 13:46:34 +0000
+++ lib/transformimageoperation.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -31,83 +31,83 @@
 #include "document/abstractdocumenteditor.h"
 #include "document/documentjob.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct TransformImageOperationPrivate {
-	Orientation mOrientation;
+    Orientation mOrientation;
 };
 
-
-class TransformJob : public ThreadedDocumentJob {
+class TransformJob : public ThreadedDocumentJob
+{
 public:
-	TransformJob(Orientation orientation)
-	: mOrientation(orientation)
-	{}
+    TransformJob(Orientation orientation)
+        : mOrientation(orientation)
+    {}
 
-	virtual void threadedStart() {
-		if (!checkDocumentEditor()) {
-			return;
-		}
-		document()->editor()->applyTransformation(mOrientation);
-		setError(NoError);
-	}
+    virtual void threadedStart()
+    {
+        if (!checkDocumentEditor()) {
+            return;
+        }
+        document()->editor()->applyTransformation(mOrientation);
+        setError(NoError);
+    }
 
 private:
-	Orientation mOrientation;
+    Orientation mOrientation;
 };
 
-
 TransformImageOperation::TransformImageOperation(Orientation orientation)
-: d(new TransformImageOperationPrivate) {
-	d->mOrientation = orientation;
-	switch (d->mOrientation) {
-	case ROT_90:
-		setText(i18nc("(qtundo-format)", "Rotate Right"));
-		break;
-	case ROT_270:
-		setText(i18nc("(qtundo-format)", "Rotate Left"));
-		break;
-	case HFLIP:
-		setText(i18nc("(qtundo-format)", "Mirror"));
-		break;
-	case VFLIP:
-		setText(i18nc("(qtundo-format)", "Flip"));
-		break;
-	default:
-		// We should not get there because the transformations listed above are
-		// the only one available from the UI. Define a default text nevertheless.
-		setText(i18nc("(qtundo-format)", "Transform"));
-		break;
-	}
-}
-
-
-TransformImageOperation::~TransformImageOperation() {
-	delete d;
-}
-
-
-void TransformImageOperation::redo() {
-	redoAsDocumentJob(new TransformJob(d->mOrientation));
-}
-
-
-void TransformImageOperation::undo() {
-	Orientation orientation;
-	switch (d->mOrientation) {
-	case ROT_90:
-		orientation = ROT_270;
-		break;
-	case ROT_270:
-		orientation = ROT_90;
-		break;
-	default:
-		orientation = d->mOrientation;
-		break;
-	}
-	document()->enqueueJob(new TransformJob(orientation));
-}
-
+: d(new TransformImageOperationPrivate)
+{
+    d->mOrientation = orientation;
+    switch (d->mOrientation) {
+    case ROT_90:
+        setText(i18nc("(qtundo-format)", "Rotate Right"));
+        break;
+    case ROT_270:
+        setText(i18nc("(qtundo-format)", "Rotate Left"));
+        break;
+    case HFLIP:
+        setText(i18nc("(qtundo-format)", "Mirror"));
+        break;
+    case VFLIP:
+        setText(i18nc("(qtundo-format)", "Flip"));
+        break;
+    default:
+        // We should not get there because the transformations listed above are
+        // the only one available from the UI. Define a default text nevertheless.
+        setText(i18nc("(qtundo-format)", "Transform"));
+        break;
+    }
+}
+
+TransformImageOperation::~TransformImageOperation()
+{
+    delete d;
+}
+
+void TransformImageOperation::redo()
+{
+    redoAsDocumentJob(new TransformJob(d->mOrientation));
+}
+
+void TransformImageOperation::undo()
+{
+    Orientation orientation;
+    switch (d->mOrientation) {
+    case ROT_90:
+        orientation = ROT_270;
+        break;
+    case ROT_270:
+        orientation = ROT_90;
+        break;
+    default:
+        orientation = d->mOrientation;
+        break;
+    }
+    document()->enqueueJob(new TransformJob(orientation));
+}
 
 } // namespace

=== modified file 'lib/transformimageoperation.h'
--- lib/transformimageoperation.h	2011-07-20 13:46:34 +0000
+++ lib/transformimageoperation.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -32,23 +32,23 @@
 
 #include <lib/orientation.h>
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct TransformImageOperationPrivate;
-class GWENVIEWLIB_EXPORT TransformImageOperation : public AbstractImageOperation {
+class GWENVIEWLIB_EXPORT TransformImageOperation : public AbstractImageOperation
+{
 public:
-	TransformImageOperation(Orientation);
-	~TransformImageOperation();
+    TransformImageOperation(Orientation);
+    ~TransformImageOperation();
 
-	virtual void redo();
-	virtual void undo();
+    virtual void redo();
+    virtual void undo();
 
 private:
-	TransformImageOperationPrivate* const d;
+    TransformImageOperationPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* TRANSFORMIMAGEOPERATION_H */

=== modified file 'lib/urlutils.cpp'
--- lib/urlutils.cpp	2011-07-20 13:46:34 +0000
+++ lib/urlutils.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -37,73 +37,75 @@
 #include <archiveutils.h>
 #include <mimetypeutils.h>
 
-namespace Gwenview {
-
-namespace UrlUtils {
-
-bool urlIsFastLocalFile(const KUrl& url) {
-	if (!url.isLocalFile()) {
-		return false;
-	}
-
-	KMountPoint::List list = KMountPoint::currentMountPoints();
-	KMountPoint::Ptr mountPoint = list.findByPath(url.toLocalFile());
-	if (!mountPoint) {
-		// We couldn't find a mount point for the url. We are probably in a
-		// chroot. Assume everything is fast then.
-		return true;
-	}
-
-	return !mountPoint->probablySlow();
-}
-
-
-bool urlIsDirectory(const KUrl& url) {
-	if( url.fileName(KUrl::ObeyTrailingSlash).isEmpty()) {
-		return true; // file:/somewhere/<nothing here>
-	}
-
-	// Do direct stat instead of using KIO if the file is local (faster)
-	if (UrlUtils::urlIsFastLocalFile(url)) {
-		KDE_struct_stat buff;
-		if ( KDE_stat( QFile::encodeName(url.toLocalFile()), &buff ) == 0 )  {
-			return S_ISDIR( buff.st_mode );
-		}
-	}
-
-	QWidgetList list = QApplication::topLevelWidgets();
-	QWidget* parent;
-	if (list.count() > 0) {
-		parent = list[0];
-	} else {
-		parent = 0;
-	}
-	KIO::UDSEntry entry;
-	if( KIO::NetAccess::stat( url, entry, parent)) {
-		return entry.isDir();
-	}
-	return false;
-}
-
-
-KUrl fixUserEnteredUrl(const KUrl& in) {
-	if (!in.isRelative() && !in.isLocalFile()) {
-		return in;
-	}
-
-	QFileInfo info(in.toLocalFile());
-	QString path = info.absoluteFilePath();
-
-	KUrl out = KUrl::fromPath(path);
-	QString mimeType = MimeTypeUtils::urlMimeType(out);
-
-	const QString protocol = ArchiveUtils::protocolForMimeType(mimeType);
-	if (!protocol.isEmpty()) {
-		out.setProtocol(protocol);
-	}
-	return out;
-}
-
+namespace Gwenview
+{
+
+namespace UrlUtils
+{
+
+bool urlIsFastLocalFile(const KUrl& url)
+{
+    if (!url.isLocalFile()) {
+        return false;
+    }
+
+    KMountPoint::List list = KMountPoint::currentMountPoints();
+    KMountPoint::Ptr mountPoint = list.findByPath(url.toLocalFile());
+    if (!mountPoint) {
+        // We couldn't find a mount point for the url. We are probably in a
+        // chroot. Assume everything is fast then.
+        return true;
+    }
+
+    return !mountPoint->probablySlow();
+}
+
+bool urlIsDirectory(const KUrl& url)
+{
+    if (url.fileName(KUrl::ObeyTrailingSlash).isEmpty()) {
+        return true; // file:/somewhere/<nothing here>
+    }
+
+    // Do direct stat instead of using KIO if the file is local (faster)
+    if (UrlUtils::urlIsFastLocalFile(url)) {
+        KDE_struct_stat buff;
+        if (KDE_stat(QFile::encodeName(url.toLocalFile()), &buff) == 0)  {
+            return S_ISDIR(buff.st_mode);
+        }
+    }
+
+    QWidgetList list = QApplication::topLevelWidgets();
+    QWidget* parent;
+    if (list.count() > 0) {
+        parent = list[0];
+    } else {
+        parent = 0;
+    }
+    KIO::UDSEntry entry;
+    if (KIO::NetAccess::stat(url, entry, parent)) {
+        return entry.isDir();
+    }
+    return false;
+}
+
+KUrl fixUserEnteredUrl(const KUrl& in)
+{
+    if (!in.isRelative() && !in.isLocalFile()) {
+        return in;
+    }
+
+    QFileInfo info(in.toLocalFile());
+    QString path = info.absoluteFilePath();
+
+    KUrl out = KUrl::fromPath(path);
+    QString mimeType = MimeTypeUtils::urlMimeType(out);
+
+    const QString protocol = ArchiveUtils::protocolForMimeType(mimeType);
+    if (!protocol.isEmpty()) {
+        out.setProtocol(protocol);
+    }
+    return out;
+}
 
 } // namespace
 

=== modified file 'lib/urlutils.h'
--- lib/urlutils.h	2011-07-20 13:46:34 +0000
+++ lib/urlutils.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -31,9 +31,11 @@
 
 class KUrl;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
-namespace UrlUtils {
+namespace UrlUtils
+{
 
 /**
  * Returns whether the url is a local file, and it's not on a slow device like

=== modified file 'lib/version.h'
--- lib/version.h	2011-10-15 11:10:08 +0000
+++ lib/version.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2010 Aurélien Gâteau <agateau@kde.org>
@@ -21,6 +21,6 @@
 #ifndef VERSION_H
 #define VERSION_H
 
-#define GWENVIEW_VERSION "2.7.2"
+#define GWENVIEW_VERSION "2.7.0"
 
 #endif /* VERSION_H */

=== modified file 'lib/widgetfloater.cpp'
--- lib/widgetfloater.cpp	2011-07-20 13:46:34 +0000
+++ lib/widgetfloater.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -32,136 +32,137 @@
 
 // Local
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct WidgetFloaterPrivate {
-	QWidget* mParent;
-	QPointer<QWidget> mChild;
-	Qt::Alignment mAlignment;
-
-	int mHorizontalMargin;
-	int mVerticalMargin;
-	bool mInsideUpdateChildGeometry;
-
-	void updateChildGeometry() {
-		if (!mChild) {
-			return;
-		}
-		if (mInsideUpdateChildGeometry) {
-			return;
-		}
-		mInsideUpdateChildGeometry = true;
-
-		int posX, posY;
-		int childWidth, childHeight;
-		int parentWidth, parentHeight;
-
-		childWidth = mChild->width();
-		childHeight = mChild->height();
-
-		parentWidth = mParent->width();
-		parentHeight = mParent->height();
-
-		if (mAlignment & Qt::AlignLeft) {
-			posX = mHorizontalMargin;
-		} else if (mAlignment & Qt::AlignHCenter) {
-			posX = (parentWidth - childWidth) / 2;
-		} else if (mAlignment & Qt::AlignJustify) {
-			posX = mHorizontalMargin;
-			childWidth = parentWidth - 2 * mHorizontalMargin;
-			QRect childGeometry = mChild->geometry();
-			childGeometry.setWidth(childWidth);
-			mChild->setGeometry(childGeometry);
-		} else {
-			posX = parentWidth - childWidth - mHorizontalMargin;
-		}
-
-		if (mAlignment & Qt::AlignTop) {
-			posY = mVerticalMargin;
-		} else if (mAlignment & Qt::AlignVCenter) {
-			posY = (parentHeight - childHeight) / 2;
-		} else {
-			posY = parentHeight - childHeight - mVerticalMargin;
-		}
-
-		mChild->move(posX, posY);
-
-		mInsideUpdateChildGeometry = false;
-	}
+    QWidget* mParent;
+    QPointer<QWidget> mChild;
+    Qt::Alignment mAlignment;
+
+    int mHorizontalMargin;
+    int mVerticalMargin;
+    bool mInsideUpdateChildGeometry;
+
+    void updateChildGeometry()
+    {
+        if (!mChild) {
+            return;
+        }
+        if (mInsideUpdateChildGeometry) {
+            return;
+        }
+        mInsideUpdateChildGeometry = true;
+
+        int posX, posY;
+        int childWidth, childHeight;
+        int parentWidth, parentHeight;
+
+        childWidth = mChild->width();
+        childHeight = mChild->height();
+
+        parentWidth = mParent->width();
+        parentHeight = mParent->height();
+
+        if (mAlignment & Qt::AlignLeft) {
+            posX = mHorizontalMargin;
+        } else if (mAlignment & Qt::AlignHCenter) {
+            posX = (parentWidth - childWidth) / 2;
+        } else if (mAlignment & Qt::AlignJustify) {
+            posX = mHorizontalMargin;
+            childWidth = parentWidth - 2 * mHorizontalMargin;
+            QRect childGeometry = mChild->geometry();
+            childGeometry.setWidth(childWidth);
+            mChild->setGeometry(childGeometry);
+        } else {
+            posX = parentWidth - childWidth - mHorizontalMargin;
+        }
+
+        if (mAlignment & Qt::AlignTop) {
+            posY = mVerticalMargin;
+        } else if (mAlignment & Qt::AlignVCenter) {
+            posY = (parentHeight - childHeight) / 2;
+        } else {
+            posY = parentHeight - childHeight - mVerticalMargin;
+        }
+
+        mChild->move(posX, posY);
+
+        mInsideUpdateChildGeometry = false;
+    }
 };
 
-
 WidgetFloater::WidgetFloater(QWidget* parent)
 : QObject(parent)
-, d(new WidgetFloaterPrivate) {
-	Q_ASSERT(parent);
-	d->mParent = parent;
-	d->mParent->installEventFilter(this);
-	d->mChild = 0;
-	d->mAlignment = Qt::AlignCenter;
-	d->mHorizontalMargin = KDialog::marginHint();
-	d->mVerticalMargin = KDialog::marginHint();
-	d->mInsideUpdateChildGeometry = false;
-}
-
-
-WidgetFloater::~WidgetFloater() {
-	delete d;
-}
-
-
-void WidgetFloater::setChildWidget(QWidget* child) {
-	if (d->mChild) {
-		d->mChild->removeEventFilter(this);
-	}
-	d->mChild = child;
-	d->mChild->setParent(d->mParent);
-	d->mChild->installEventFilter(this);
-	d->updateChildGeometry();
-	d->mChild->raise();
-	d->mChild->show();
-}
-
-
-void WidgetFloater::setAlignment(Qt::Alignment alignment) {
-	d->mAlignment = alignment;
-	d->updateChildGeometry();
-}
-
-
-bool WidgetFloater::eventFilter(QObject*, QEvent* event) {
-	switch (event->type()) {
-	case QEvent::Resize:
-	case QEvent::Show:
-		d->updateChildGeometry();
-		break;
-	default:
-		break;
-	}
-	return false;
-}
-
-
-void WidgetFloater::setHorizontalMargin(int value) {
-	d->mHorizontalMargin = value;
-	d->updateChildGeometry();
-}
-
-
-int WidgetFloater::horizontalMargin() const {
-	return d->mHorizontalMargin;
-}
-
-
-void WidgetFloater::setVerticalMargin(int value) {
-	d->mVerticalMargin = value;
-	d->updateChildGeometry();
-}
-
-
-int WidgetFloater::verticalMargin() const {
-	return d->mVerticalMargin;
-}
-
+, d(new WidgetFloaterPrivate)
+{
+    Q_ASSERT(parent);
+    d->mParent = parent;
+    d->mParent->installEventFilter(this);
+    d->mChild = 0;
+    d->mAlignment = Qt::AlignCenter;
+    d->mHorizontalMargin = KDialog::marginHint();
+    d->mVerticalMargin = KDialog::marginHint();
+    d->mInsideUpdateChildGeometry = false;
+}
+
+WidgetFloater::~WidgetFloater()
+{
+    delete d;
+}
+
+void WidgetFloater::setChildWidget(QWidget* child)
+{
+    if (d->mChild) {
+        d->mChild->removeEventFilter(this);
+    }
+    d->mChild = child;
+    d->mChild->setParent(d->mParent);
+    d->mChild->installEventFilter(this);
+    d->updateChildGeometry();
+    d->mChild->raise();
+    d->mChild->show();
+}
+
+void WidgetFloater::setAlignment(Qt::Alignment alignment)
+{
+    d->mAlignment = alignment;
+    d->updateChildGeometry();
+}
+
+bool WidgetFloater::eventFilter(QObject*, QEvent* event)
+{
+    switch (event->type()) {
+    case QEvent::Resize:
+    case QEvent::Show:
+        d->updateChildGeometry();
+        break;
+    default:
+        break;
+    }
+    return false;
+}
+
+void WidgetFloater::setHorizontalMargin(int value)
+{
+    d->mHorizontalMargin = value;
+    d->updateChildGeometry();
+}
+
+int WidgetFloater::horizontalMargin() const
+{
+    return d->mHorizontalMargin;
+}
+
+void WidgetFloater::setVerticalMargin(int value)
+{
+    d->mVerticalMargin = value;
+    d->updateChildGeometry();
+}
+
+int WidgetFloater::verticalMargin() const
+{
+    return d->mVerticalMargin;
+}
 
 } // namespace

=== modified file 'lib/widgetfloater.h'
--- lib/widgetfloater.h	2011-07-20 13:46:34 +0000
+++ lib/widgetfloater.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,8 +30,8 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct WidgetFloaterPrivate;
 
@@ -40,30 +40,30 @@
  * another (the parent), ensuring the child remains aligned as specified by
  * setAlignment() whenever either widget get resized.
  */
-class GWENVIEWLIB_EXPORT WidgetFloater : public QObject {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT WidgetFloater : public QObject
+{
+    Q_OBJECT
 public:
-	WidgetFloater(QWidget* parent);
-	~WidgetFloater();
-
-	void setChildWidget(QWidget*);
-
-	void setAlignment(Qt::Alignment);
-
-	void setHorizontalMargin(int);
-	int horizontalMargin() const;
-
-	void setVerticalMargin(int);
-	int verticalMargin() const;
+    WidgetFloater(QWidget* parent);
+    ~WidgetFloater();
+
+    void setChildWidget(QWidget*);
+
+    void setAlignment(Qt::Alignment);
+
+    void setHorizontalMargin(int);
+    int horizontalMargin() const;
+
+    void setVerticalMargin(int);
+    int verticalMargin() const;
 
 protected:
-	bool eventFilter(QObject*, QEvent*);
+    bool eventFilter(QObject*, QEvent*);
 
 private:
-	WidgetFloaterPrivate* const d;
+    WidgetFloaterPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* WIDGETFLOATER_H */

=== modified file 'lib/zoomslider.cpp'
--- lib/zoomslider.cpp	2011-07-20 13:46:34 +0000
+++ lib/zoomslider.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -33,124 +33,126 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ZoomSliderPrivate {
-	QToolButton* mZoomOutButton;
-	QToolButton* mZoomInButton;
-	QSlider* mSlider;
-	QAction* mZoomInAction;
-	QAction* mZoomOutAction;
+    QToolButton* mZoomOutButton;
+    QToolButton* mZoomInButton;
+    QSlider* mSlider;
+    QAction* mZoomInAction;
+    QAction* mZoomOutAction;
 
-	void updateButtons() {
-		mZoomOutButton->setEnabled(mSlider->value() > mSlider->minimum());
-		mZoomInButton->setEnabled(mSlider->value() < mSlider->maximum());
-	}
+    void updateButtons()
+    {
+        mZoomOutButton->setEnabled(mSlider->value() > mSlider->minimum());
+        mZoomInButton->setEnabled(mSlider->value() < mSlider->maximum());
+    }
 };
 
-static QToolButton* createZoomButton(const char* iconName) {
-	QToolButton* button = new QToolButton;
-	button->setIcon(KIcon(iconName));
-	button->setAutoRaise(true);
-	button->setAutoRepeat(true);
-	return button;
+static QToolButton* createZoomButton(const char* iconName)
+{
+    QToolButton* button = new QToolButton;
+    button->setIcon(KIcon(iconName));
+    button->setAutoRaise(true);
+    button->setAutoRepeat(true);
+    return button;
 }
 
 ZoomSlider::ZoomSlider(QWidget* parent)
 : QWidget(parent)
-, d(new ZoomSliderPrivate) {
-	d->mZoomInButton = createZoomButton("zoom-in");
-	d->mZoomOutButton = createZoomButton("zoom-out");
-	d->mZoomInAction = 0;
-	d->mZoomOutAction = 0;
-
-	d->mSlider = new QSlider;
-	d->mSlider->setOrientation(Qt::Horizontal);
-
-	QHBoxLayout* layout = new QHBoxLayout(this);
-	layout->setMargin(0);
-	layout->setSpacing(0);
-	layout->addWidget(d->mZoomOutButton);
-	layout->addWidget(d->mSlider);
-	layout->addWidget(d->mZoomInButton);
-
-	connect(d->mSlider, SIGNAL(actionTriggered(int)),
-		SLOT(slotActionTriggered(int)) );
-	connect(d->mSlider, SIGNAL(valueChanged(int)),
-		SIGNAL(valueChanged(int)));
-
-	connect(d->mZoomOutButton, SIGNAL(clicked()),
-		SLOT(zoomOut()));
-	connect(d->mZoomInButton, SIGNAL(clicked()),
-		SLOT(zoomIn()));
-}
-
-
-ZoomSlider::~ZoomSlider() {
-	delete d;
-}
-
-
-int ZoomSlider::value() const {
-	return d->mSlider->value();
-}
-
-
-void ZoomSlider::setValue(int value) {
-	d->mSlider->setValue(value);
-	d->updateButtons();
-}
-
-
-void ZoomSlider::setMinimum(int value) {
-	d->mSlider->setMinimum(value);
-	d->updateButtons();
-}
-
-
-void ZoomSlider::setMaximum(int value) {
-	d->mSlider->setMaximum(value);
-	d->updateButtons();
-}
-
-
-void ZoomSlider::setZoomInAction(QAction* action) {
-	d->mZoomInAction = action;
-}
-
-
-void ZoomSlider::setZoomOutAction(QAction* action) {
-	d->mZoomOutAction = action;
-}
-
-
-void ZoomSlider::slotActionTriggered(int) {
-	d->updateButtons();
-}
-
-
-void ZoomSlider::zoomOut() {
-	if (d->mZoomOutAction) {
-		d->mZoomOutAction->trigger();
-	} else {
-		d->mSlider->triggerAction(QAbstractSlider::SliderPageStepSub);
-	}
-}
-
-
-void ZoomSlider::zoomIn() {
-	if (d->mZoomInAction) {
-		d->mZoomInAction->trigger();
-	} else {
-		d->mSlider->triggerAction(QAbstractSlider::SliderPageStepAdd);
-	}
-}
-
-
-QSlider* ZoomSlider::slider() const {
-	return d->mSlider;
-}
-
+, d(new ZoomSliderPrivate)
+{
+    d->mZoomInButton = createZoomButton("zoom-in");
+    d->mZoomOutButton = createZoomButton("zoom-out");
+    d->mZoomInAction = 0;
+    d->mZoomOutAction = 0;
+
+    d->mSlider = new QSlider;
+    d->mSlider->setOrientation(Qt::Horizontal);
+
+    QHBoxLayout* layout = new QHBoxLayout(this);
+    layout->setMargin(0);
+    layout->setSpacing(0);
+    layout->addWidget(d->mZoomOutButton);
+    layout->addWidget(d->mSlider);
+    layout->addWidget(d->mZoomInButton);
+
+    connect(d->mSlider, SIGNAL(actionTriggered(int)),
+            SLOT(slotActionTriggered(int)));
+    connect(d->mSlider, SIGNAL(valueChanged(int)),
+            SIGNAL(valueChanged(int)));
+
+    connect(d->mZoomOutButton, SIGNAL(clicked()),
+            SLOT(zoomOut()));
+    connect(d->mZoomInButton, SIGNAL(clicked()),
+            SLOT(zoomIn()));
+}
+
+ZoomSlider::~ZoomSlider()
+{
+    delete d;
+}
+
+int ZoomSlider::value() const
+{
+    return d->mSlider->value();
+}
+
+void ZoomSlider::setValue(int value)
+{
+    d->mSlider->setValue(value);
+    d->updateButtons();
+}
+
+void ZoomSlider::setMinimum(int value)
+{
+    d->mSlider->setMinimum(value);
+    d->updateButtons();
+}
+
+void ZoomSlider::setMaximum(int value)
+{
+    d->mSlider->setMaximum(value);
+    d->updateButtons();
+}
+
+void ZoomSlider::setZoomInAction(QAction* action)
+{
+    d->mZoomInAction = action;
+}
+
+void ZoomSlider::setZoomOutAction(QAction* action)
+{
+    d->mZoomOutAction = action;
+}
+
+void ZoomSlider::slotActionTriggered(int)
+{
+    d->updateButtons();
+}
+
+void ZoomSlider::zoomOut()
+{
+    if (d->mZoomOutAction) {
+        d->mZoomOutAction->trigger();
+    } else {
+        d->mSlider->triggerAction(QAbstractSlider::SliderPageStepSub);
+    }
+}
+
+void ZoomSlider::zoomIn()
+{
+    if (d->mZoomInAction) {
+        d->mZoomInAction->trigger();
+    } else {
+        d->mSlider->triggerAction(QAbstractSlider::SliderPageStepAdd);
+    }
+}
+
+QSlider* ZoomSlider::slider() const
+{
+    return d->mSlider;
+}
 
 } // namespace

=== modified file 'lib/zoomslider.h'
--- lib/zoomslider.h	2011-07-20 13:46:34 +0000
+++ lib/zoomslider.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2009 Aurélien Gâteau <agateau@kde.org>
@@ -33,7 +33,8 @@
 class QAction;
 class QSlider;
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 struct ZoomSliderPrivate;
 /**
@@ -42,40 +43,40 @@
  * Their behavior can be changed with setZoomInAction() and
  * setZoomOutAction().
  */
-class GWENVIEWLIB_EXPORT ZoomSlider : public QWidget {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ZoomSlider : public QWidget
+{
+    Q_OBJECT
 public:
-	ZoomSlider(QWidget* parent=0);
-	~ZoomSlider();
-
-	int value() const;
-
-	QSlider* slider() const;
-
-	void setZoomInAction(QAction*);
-
-	void setZoomOutAction(QAction*);
+    ZoomSlider(QWidget* parent = 0);
+    ~ZoomSlider();
+
+    int value() const;
+
+    QSlider* slider() const;
+
+    void setZoomInAction(QAction*);
+
+    void setZoomOutAction(QAction*);
 
 public Q_SLOTS:
-	void setValue(int);
-
-	void setMinimum(int);
-
-	void setMaximum(int);
+    void setValue(int);
+
+    void setMinimum(int);
+
+    void setMaximum(int);
 
 Q_SIGNALS:
-	int valueChanged(int);
+    int valueChanged(int);
 
 private Q_SLOTS:
-	void slotActionTriggered(int actionTriggered);
-	void zoomOut();
-	void zoomIn();
+    void slotActionTriggered(int actionTriggered);
+    void zoomOut();
+    void zoomIn();
 
 private:
-	ZoomSliderPrivate* const d;
+    ZoomSliderPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* ZOOMSLIDER_H */

=== modified file 'lib/zoomwidget.cpp'
--- lib/zoomwidget.cpp	2011-07-20 13:46:34 +0000
+++ lib/zoomwidget.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -39,145 +39,144 @@
 #include "signalblocker.h"
 #include "statusbartoolbutton.h"
 
-namespace Gwenview {
+namespace Gwenview
+{
 
 static const qreal MAGIC_K = 1.04;
 static const qreal MAGIC_OFFSET = 16.;
 static const qreal PRECISION = 100.;
-inline int sliderValueForZoom(qreal zoom) {
-	return int( PRECISION * (log(zoom) / log(MAGIC_K) + MAGIC_OFFSET) );
-}
-
-
-inline qreal zoomForSliderValue(int sliderValue) {
-	return pow(MAGIC_K, sliderValue / PRECISION - MAGIC_OFFSET);
-}
-
-
-
+inline int sliderValueForZoom(qreal zoom)
+{
+    return int(PRECISION * (log(zoom) / log(MAGIC_K) + MAGIC_OFFSET));
+}
+
+inline qreal zoomForSliderValue(int sliderValue)
+{
+    return pow(MAGIC_K, sliderValue / PRECISION - MAGIC_OFFSET);
+}
 
 struct ZoomWidgetPrivate {
-	ZoomWidget* that;
-
-	StatusBarToolButton* mZoomToFitButton;
-	StatusBarToolButton* mActualSizeButton;
-	QLabel* mZoomLabel;
-	ZoomSlider* mZoomSlider;
-	QAction* mZoomToFitAction;
-	QAction* mActualSizeAction;
-
-	bool mZoomUpdatedBySlider;
-
-	void emitZoomChanged() {
-		// Use QSlider::sliderPosition(), not QSlider::value() because when we are
-		// called from slotZoomSliderActionTriggered(), QSlider::value() has not
-		// been updated yet.
-		qreal zoom = zoomForSliderValue(mZoomSlider->slider()->sliderPosition());
-		mZoomUpdatedBySlider = true;
-		emit that->zoomChanged(zoom);
-		mZoomUpdatedBySlider = false;
-	}
+    ZoomWidget* q;
+
+    StatusBarToolButton* mZoomToFitButton;
+    StatusBarToolButton* mActualSizeButton;
+    QLabel* mZoomLabel;
+    ZoomSlider* mZoomSlider;
+    QAction* mZoomToFitAction;
+    QAction* mActualSizeAction;
+
+    bool mZoomUpdatedBySlider;
+
+    void emitZoomChanged()
+    {
+        // Use QSlider::sliderPosition(), not QSlider::value() because when we are
+        // called from slotZoomSliderActionTriggered(), QSlider::value() has not
+        // been updated yet.
+        qreal zoom = zoomForSliderValue(mZoomSlider->slider()->sliderPosition());
+        mZoomUpdatedBySlider = true;
+        emit q->zoomChanged(zoom);
+        mZoomUpdatedBySlider = false;
+    }
 };
 
-
 ZoomWidget::ZoomWidget(QWidget* parent)
 : QFrame(parent)
-, d(new ZoomWidgetPrivate) {
-	d->that = this;
-	d->mZoomUpdatedBySlider = false;
-
-	setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Minimum);
-
-	d->mZoomToFitButton = new StatusBarToolButton;
-	d->mActualSizeButton = new StatusBarToolButton;
-
-	if (QApplication::isLeftToRight()) {
-		d->mZoomToFitButton->setGroupPosition(StatusBarToolButton::GroupLeft);
-		d->mActualSizeButton->setGroupPosition(StatusBarToolButton::GroupRight);
-	} else {
-		d->mActualSizeButton->setGroupPosition(StatusBarToolButton::GroupLeft);
-		d->mZoomToFitButton->setGroupPosition(StatusBarToolButton::GroupRight);
-	}
-
-	d->mZoomLabel = new QLabel;
-	d->mZoomLabel->setFixedWidth(d->mZoomLabel->fontMetrics().width(" 1000% "));
-	d->mZoomLabel->setAlignment(Qt::AlignCenter);
-
-	d->mZoomSlider = new ZoomSlider;
-	d->mZoomSlider->setMinimumWidth(150);
-	d->mZoomSlider->slider()->setSingleStep(int(PRECISION));
-	d->mZoomSlider->slider()->setPageStep(3 * int(PRECISION));
-	connect(d->mZoomSlider->slider(), SIGNAL(actionTriggered(int)), SLOT(slotZoomSliderActionTriggered()) );
-
-	// Layout
-	QHBoxLayout* layout = new QHBoxLayout(this);
-	layout->setMargin(0);
-	layout->setSpacing(0);
-	layout->addWidget(d->mZoomToFitButton);
-	layout->addWidget(d->mActualSizeButton);
-	layout->addWidget(d->mZoomSlider);
-	layout->addWidget(d->mZoomLabel);
-}
-
-
-ZoomWidget::~ZoomWidget() {
-	delete d;
-}
-
-
-void ZoomWidget::setActions(QAction* zoomToFitAction, QAction* actualSizeAction, QAction* zoomInAction, QAction* zoomOutAction) {
-	d->mZoomToFitAction = zoomToFitAction;
-	d->mActualSizeAction = actualSizeAction;
-
-	d->mZoomToFitButton->setDefaultAction(zoomToFitAction);
-	d->mActualSizeButton->setDefaultAction(actualSizeAction);
-
-	d->mZoomSlider->setZoomInAction(zoomInAction);
-	d->mZoomSlider->setZoomOutAction(zoomOutAction);
-
-	// Adjust sizes
-	int width = qMax(d->mZoomToFitButton->sizeHint().width(), d->mActualSizeButton->sizeHint().width());
-	d->mZoomToFitButton->setFixedWidth(width);
-	d->mActualSizeButton->setFixedWidth(width);
-}
-
-
-void ZoomWidget::slotZoomSliderActionTriggered() {
-	// The slider value changed because of the user (not because of range
-	// changes). In this case disable zoom and apply slider value.
-	d->emitZoomChanged();
-}
-
-
-void ZoomWidget::setZoom(qreal zoom) {
-	int intZoom = qRound(zoom * 100);
-	d->mZoomLabel->setText(QString("%1%").arg(intZoom));
-
-	// Don't change slider value if we come here because the slider change,
-	// avoids choppy sliding scroll.
-	if (!d->mZoomUpdatedBySlider) {
-		QSlider* slider = d->mZoomSlider->slider();
-		SignalBlocker blocker(slider);
-		int value = sliderValueForZoom(zoom);
-
-		if (value < slider->minimum()) {
-			// It is possible that we are called *before* setMinimumZoom() as
-			// been called. In this case, define the minimum ourself.
-			d->mZoomSlider->setMinimum(value);
-		}
-		d->mZoomSlider->setValue(value);
-	}
-}
-
-
-void ZoomWidget::setMinimumZoom(qreal minimumZoom) {
-	d->mZoomSlider->setMinimum(sliderValueForZoom(minimumZoom));
-}
-
-
-void ZoomWidget::setMaximumZoom(qreal zoom) {
-	d->mZoomSlider->setMaximum(sliderValueForZoom(zoom));
-}
-
+, d(new ZoomWidgetPrivate)
+{
+    d->q = this;
+    d->mZoomUpdatedBySlider = false;
+
+    setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Minimum);
+
+    d->mZoomToFitButton = new StatusBarToolButton;
+    d->mActualSizeButton = new StatusBarToolButton;
+
+    if (QApplication::isLeftToRight()) {
+        d->mZoomToFitButton->setGroupPosition(StatusBarToolButton::GroupLeft);
+        d->mActualSizeButton->setGroupPosition(StatusBarToolButton::GroupRight);
+    } else {
+        d->mActualSizeButton->setGroupPosition(StatusBarToolButton::GroupLeft);
+        d->mZoomToFitButton->setGroupPosition(StatusBarToolButton::GroupRight);
+    }
+
+    d->mZoomLabel = new QLabel;
+    d->mZoomLabel->setFixedWidth(d->mZoomLabel->fontMetrics().width(" 1000% "));
+    d->mZoomLabel->setAlignment(Qt::AlignCenter);
+
+    d->mZoomSlider = new ZoomSlider;
+    d->mZoomSlider->setMinimumWidth(150);
+    d->mZoomSlider->slider()->setSingleStep(int(PRECISION));
+    d->mZoomSlider->slider()->setPageStep(3 * int(PRECISION));
+    connect(d->mZoomSlider->slider(), SIGNAL(actionTriggered(int)), SLOT(slotZoomSliderActionTriggered()));
+
+    // Layout
+    QHBoxLayout* layout = new QHBoxLayout(this);
+    layout->setMargin(0);
+    layout->setSpacing(0);
+    layout->addWidget(d->mZoomToFitButton);
+    layout->addWidget(d->mActualSizeButton);
+    layout->addWidget(d->mZoomSlider);
+    layout->addWidget(d->mZoomLabel);
+}
+
+ZoomWidget::~ZoomWidget()
+{
+    delete d;
+}
+
+void ZoomWidget::setActions(QAction* zoomToFitAction, QAction* actualSizeAction, QAction* zoomInAction, QAction* zoomOutAction)
+{
+    d->mZoomToFitAction = zoomToFitAction;
+    d->mActualSizeAction = actualSizeAction;
+
+    d->mZoomToFitButton->setDefaultAction(zoomToFitAction);
+    d->mActualSizeButton->setDefaultAction(actualSizeAction);
+
+    d->mZoomSlider->setZoomInAction(zoomInAction);
+    d->mZoomSlider->setZoomOutAction(zoomOutAction);
+
+    // Adjust sizes
+    int width = qMax(d->mZoomToFitButton->sizeHint().width(), d->mActualSizeButton->sizeHint().width());
+    d->mZoomToFitButton->setFixedWidth(width);
+    d->mActualSizeButton->setFixedWidth(width);
+}
+
+void ZoomWidget::slotZoomSliderActionTriggered()
+{
+    // The slider value changed because of the user (not because of range
+    // changes). In this case disable zoom and apply slider value.
+    d->emitZoomChanged();
+}
+
+void ZoomWidget::setZoom(qreal zoom)
+{
+    int intZoom = qRound(zoom * 100);
+    d->mZoomLabel->setText(QString("%1%").arg(intZoom));
+
+    // Don't change slider value if we come here because the slider change,
+    // avoids choppy sliding scroll.
+    if (!d->mZoomUpdatedBySlider) {
+        QSlider* slider = d->mZoomSlider->slider();
+        SignalBlocker blocker(slider);
+        int value = sliderValueForZoom(zoom);
+
+        if (value < slider->minimum()) {
+            // It is possible that we are called *before* setMinimumZoom() as
+            // been called. In this case, define the minimum ourself.
+            d->mZoomSlider->setMinimum(value);
+        }
+        d->mZoomSlider->setValue(value);
+    }
+}
+
+void ZoomWidget::setMinimumZoom(qreal minimumZoom)
+{
+    d->mZoomSlider->setMinimum(sliderValueForZoom(minimumZoom));
+}
+
+void ZoomWidget::setMaximumZoom(qreal zoom)
+{
+    d->mZoomSlider->setMaximum(sliderValueForZoom(zoom));
+}
 
 } // namespace

=== modified file 'lib/zoomwidget.h'
--- lib/zoomwidget.h	2011-07-20 13:46:34 +0000
+++ lib/zoomwidget.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -30,40 +30,38 @@
 
 // Local
 
-
-
 class QAction;
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct ZoomWidgetPrivate;
-class GWENVIEWLIB_EXPORT ZoomWidget : public QFrame {
-	Q_OBJECT
+class GWENVIEWLIB_EXPORT ZoomWidget : public QFrame
+{
+    Q_OBJECT
 public:
-	ZoomWidget(QWidget* parent = 0);
-	~ZoomWidget();
+    ZoomWidget(QWidget* parent = 0);
+    ~ZoomWidget();
 
-	void setActions(QAction* zoomToFitAction, QAction* actualSizeAction, QAction* zoomInAction, QAction* zoomOutAction);
+    void setActions(QAction* zoomToFitAction, QAction* actualSizeAction, QAction* zoomInAction, QAction* zoomOutAction);
 
 public Q_SLOTS:
-	void setZoom(qreal zoom);
+    void setZoom(qreal zoom);
 
-	void setMinimumZoom(qreal zoom);
-	void setMaximumZoom(qreal zoom);
+    void setMinimumZoom(qreal zoom);
+    void setMaximumZoom(qreal zoom);
 
 Q_SIGNALS:
-	void zoomChanged(qreal);
+    void zoomChanged(qreal);
 
 private Q_SLOTS:
-	void slotZoomSliderActionTriggered();
+    void slotZoomSliderActionTriggered();
 
 private:
-	friend struct ZoomWidgetPrivate;
-	ZoomWidgetPrivate* const d;
+    friend struct ZoomWidgetPrivate;
+    ZoomWidgetPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* ZOOMWIDGET_H */

=== modified file 'part/gvbrowserextension.cpp'
--- part/gvbrowserextension.cpp	2011-07-20 13:46:34 +0000
+++ part/gvbrowserextension.cpp	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2007 Aurélien Gâteau <agateau@kde.org>
@@ -31,33 +31,33 @@
 #include "../lib/document/documentfactory.h"
 #include "../lib/print/printhelper.h"
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 struct GVBrowserExtensionPrivate {
-	KParts::ReadOnlyPart* mPart;
+    KParts::ReadOnlyPart* mPart;
 };
 
-
 GVBrowserExtension::GVBrowserExtension(KParts::ReadOnlyPart* part)
 : KParts::BrowserExtension(part)
-, d(new GVBrowserExtensionPrivate) {
-	d->mPart = part;
-	emit enableAction("print", true);
-	QString iconPath = KIconLoader::global()->iconPath("image-x-generic", KIconLoader::SizeSmall);
-	emit setIconUrl(KUrl::fromPath(iconPath));
-}
-
-
-GVBrowserExtension::~GVBrowserExtension() {
-	delete d;
-}
-
-
-void GVBrowserExtension::print() {
-	Document::Ptr doc = DocumentFactory::instance()->load(d->mPart->url());
-	PrintHelper printHelper(d->mPart->widget());
-	printHelper.print(doc);
+, d(new GVBrowserExtensionPrivate)
+{
+    d->mPart = part;
+    emit enableAction("print", true);
+    QString iconPath = KIconLoader::global()->iconPath("image-x-generic", KIconLoader::SizeSmall);
+    emit setIconUrl(KUrl::fromPath(iconPath));
+}
+
+GVBrowserExtension::~GVBrowserExtension()
+{
+    delete d;
+}
+
+void GVBrowserExtension::print()
+{
+    Document::Ptr doc = DocumentFactory::instance()->load(d->mPart->url());
+    PrintHelper printHelper(d->mPart->widget());
+    printHelper.print(doc);
 }
 
 } // namespace

=== modified file 'part/gvbrowserextension.h'
--- part/gvbrowserextension.h	2011-07-20 13:46:34 +0000
+++ part/gvbrowserextension.h	2011-12-15 14:17:54 +0000
@@ -1,4 +1,4 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
+// vim: set tabstop=4 shiftwidth=4 expandtab:
 /*
 Gwenview: an image viewer
 Copyright 2008 Aurélien Gâteau <agateau@kde.org>
@@ -28,24 +28,24 @@
 
 // Local
 
-namespace Gwenview {
-
+namespace Gwenview
+{
 
 class GVBrowserExtensionPrivate;
-class GVBrowserExtension : public KParts::BrowserExtension {
-	Q_OBJECT
+class GVBrowserExtension : public KParts::BrowserExtension
+{
+    Q_OBJECT
 public:
-	GVBrowserExtension(KParts::ReadOnlyPart*);
-	~GVBrowserExtension();
+    GVBrowserExtension(KParts::ReadOnlyPart*);
+    ~GVBrowserExtension();
 
 private Q_SLOTS:
-	void print();
+    void print();
 
 private:
-	GVBrowserExtensionPrivate* const d;
+    GVBrowserExtensionPrivate* const d;
 };
 
-
 } // namespace
 
 #endif /* GVBROWSEREXTENSION_H */

=== modified file 'part/gvpart.cpp'
--- part/gvpart.cpp	2011-12-08 21:34:25 +0000
+++ part/gvpart.cpp	2011-12-15 14:17:54 +0000
@@ -41,6 +41,7 @@
 #include "../lib/document/document.h"
 #include "../lib/document/documentfactory.h"
 #include "../lib/documentview/documentview.h"
+#include "../lib/documentview/documentviewcontainer.h"
 #include "../lib/documentview/documentviewcontroller.h"
 #include "../lib/imageformats/imageformats.h"
 #include "../lib/urlutils.h"
@@ -48,147 +49,145 @@
 #include "../lib/zoomwidget.h"
 #include "gvbrowserextension.h"
 
-
 //Factory Code
 K_PLUGIN_FACTORY(GVPartFactory, registerPlugin<Gwenview::GVPart>();)
-K_EXPORT_PLUGIN(GVPartFactory )
-
-namespace Gwenview {
-
-
-GVPart::GVPart(QWidget* parentWidget, QObject* parent, const QVariantList& /*args*/)
+K_EXPORT_PLUGIN(GVPartFactory)
+
+namespace Gwenview
+{
+
+GVPart::GVPart(QWidget* /*parentWidget*/, QObject* parent, const QVariantList& /*args*/)
 : KParts::ReadOnlyPart(parent)
 {
-        KGlobal::locale()->insertCatalog("gwenview");
-	mDocumentView = new DocumentView(parentWidget, actionCollection());
-	setWidget(mDocumentView);
-
-	connect(mDocumentView, SIGNAL(captionUpdateRequested(const QString&)),
-		SIGNAL(setWindowCaption(const QString&)));
-	connect(mDocumentView, SIGNAL(completed()),
-		SIGNAL(completed()));
-
-	mDocumentView->setContextMenuPolicy(Qt::CustomContextMenu);
-	connect(mDocumentView, SIGNAL(customContextMenuRequested(const QPoint&)),
-		SLOT(showContextMenu()) );
-
-	// Necessary to have zoom actions
-	DocumentViewController* documentViewController = new DocumentViewController(actionCollection(), this);
-	documentViewController->setView(mDocumentView);
-
-	KAction* action = new KAction(actionCollection());
-	action->setText(i18nc("@action", "Properties"));
-	connect(action, SIGNAL(triggered()), SLOT(showProperties()));
-	actionCollection()->addAction("file_show_properties", action);
-
-	KStandardAction::saveAs(this, SLOT(saveAs()), actionCollection());
-
-	Gwenview::ImageFormats::registerPlugins();
-	new GVBrowserExtension(this);
-
-	setXMLFile("gvpart/gvpart.rc");
-}
-
-
-void GVPart::showProperties() {
-	KPropertiesDialog::showDialog(url(), mDocumentView);
-}
-
-
-bool GVPart::openFile() {
-	return false;
-}
-
-
-bool GVPart::openUrl(const KUrl& url) {
-	if (!url.isValid()) {
-		return false;
-	}
-	setUrl(url);
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	if (arguments().reload()) {
-		doc->reload();
-	}
-	if (!UrlUtils::urlIsFastLocalFile(url)) {
-		// Keep raw data of remote files to avoid downloading them again in
-		// saveAs()
-		doc->setKeepRawData(true);
-	}
-	mDocumentView->openUrl(url);
-	return true;
-}
-
-
-KAboutData* GVPart::createAboutData() {
-	KAboutData* aboutData = new KAboutData(
-		"gvpart",                /* appname */
-		"gwenview",              /* catalogName */
-		ki18n("Gwenview KPart"), /* programName */
-		GWENVIEW_VERSION);       /* version */
-	aboutData->setShortDescription(ki18n("An Image Viewer"));
-	aboutData->setLicense(KAboutData::License_GPL);
-	aboutData->setCopyrightStatement(ki18n("Copyright 2000-2010 Aurélien Gâteau"));
-	aboutData->addAuthor(
-		ki18n("Aurélien Gâteau"),
-		ki18n("Main developer"),
-		"agateau@kde.org");
-	return aboutData;
-}
-
-
-inline void addActionToMenu(KMenu* menu, KActionCollection* actionCollection, const char* name) {
-	QAction* action = actionCollection->action(name);
-	if (action) {
-		menu->addAction(action);
-	}
-}
-
-
-void GVPart::showContextMenu() {
-	KMenu menu(mDocumentView);
-	addActionToMenu(&menu, actionCollection(), "file_save_as");
-	menu.addSeparator();
-	addActionToMenu(&menu, actionCollection(), "view_actual_size");
-	addActionToMenu(&menu, actionCollection(), "view_zoom_to_fit");
-	addActionToMenu(&menu, actionCollection(), "view_zoom_in");
-	addActionToMenu(&menu, actionCollection(), "view_zoom_out");
-	menu.addSeparator();
-	addActionToMenu(&menu, actionCollection(), "file_show_properties");
-	menu.exec(QCursor::pos());
-}
-
-
-void GVPart::saveAs() {
-	KUrl srcUrl = url();
-	KUrl dstUrl = KFileDialog::getSaveUrl(srcUrl.fileName(), QString(), widget());
-	if (!dstUrl.isValid()) {
-		return;
-	}
-
-	KIO::Job* job;
-	Document::Ptr doc = DocumentFactory::instance()->load(srcUrl);
-	QByteArray rawData = doc->rawData();
-	if (rawData.length() > 0) {
-		job = KIO::storedPut(rawData, dstUrl, -1);
-	} else {
-		job = KIO::file_copy(srcUrl, dstUrl);
-	}
-	connect(job, SIGNAL(result(KJob*)),
-		this, SLOT(showJobError(KJob*)) );
-}
-
-
-void GVPart::showJobError(KJob* job) {
-	if (job->error() != 0) {
-		KIO::JobUiDelegate* ui = static_cast<KIO::Job*>(job)->ui();
-		if (!ui) {
-			kError() << "Saving failed. job->ui() is null.";
-			return;
-		}
-		ui->setWindow(widget());
-		ui->showErrorMessage();
-	}
-}
-
+    KGlobal::locale()->insertCatalog("gwenview");
+    DocumentViewContainer* container = new DocumentViewContainer;
+    setWidget(container);
+    mDocumentView = container->createView();
+
+    connect(mDocumentView, SIGNAL(captionUpdateRequested(QString)),
+            SIGNAL(setWindowCaption(QString)));
+    connect(mDocumentView, SIGNAL(completed()),
+            SIGNAL(completed()));
+
+    connect(mDocumentView, SIGNAL(contextMenuRequested()),
+            SLOT(showContextMenu()));
+
+    // Necessary to have zoom actions
+    DocumentViewController* documentViewController = new DocumentViewController(actionCollection(), this);
+    documentViewController->setView(mDocumentView);
+
+    KAction* action = new KAction(actionCollection());
+    action->setText(i18nc("@action", "Properties"));
+    connect(action, SIGNAL(triggered()), SLOT(showProperties()));
+    actionCollection()->addAction("file_show_properties", action);
+
+    KStandardAction::saveAs(this, SLOT(saveAs()), actionCollection());
+
+    Gwenview::ImageFormats::registerPlugins();
+    new GVBrowserExtension(this);
+
+    setXMLFile("gvpart/gvpart.rc");
+}
+
+void GVPart::showProperties()
+{
+    KPropertiesDialog::showDialog(url(), widget());
+}
+
+bool GVPart::openFile()
+{
+    return false;
+}
+
+bool GVPart::openUrl(const KUrl& url)
+{
+    if (!url.isValid()) {
+        return false;
+    }
+    setUrl(url);
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    if (arguments().reload()) {
+        doc->reload();
+    }
+    if (!UrlUtils::urlIsFastLocalFile(url)) {
+        // Keep raw data of remote files to avoid downloading them again in
+        // saveAs()
+        doc->setKeepRawData(true);
+    }
+    mDocumentView->openUrl(url);
+    return true;
+}
+
+KAboutData* GVPart::createAboutData()
+{
+    KAboutData* aboutData = new KAboutData(
+        "gvpart",                /* appname */
+        "gwenview",              /* catalogName */
+        ki18n("Gwenview KPart"), /* programName */
+        GWENVIEW_VERSION);       /* version */
+    aboutData->setShortDescription(ki18n("An Image Viewer"));
+    aboutData->setLicense(KAboutData::License_GPL);
+    aboutData->setCopyrightStatement(ki18n("Copyright 2000-2010 Aurélien Gâteau"));
+    aboutData->addAuthor(
+        ki18n("Aurélien Gâteau"),
+        ki18n("Main developer"),
+        "agateau@kde.org");
+    return aboutData;
+}
+
+inline void addActionToMenu(KMenu* menu, KActionCollection* actionCollection, const char* name)
+{
+    QAction* action = actionCollection->action(name);
+    if (action) {
+        menu->addAction(action);
+    }
+}
+
+void GVPart::showContextMenu()
+{
+    KMenu menu(widget());
+    addActionToMenu(&menu, actionCollection(), "file_save_as");
+    menu.addSeparator();
+    addActionToMenu(&menu, actionCollection(), "view_actual_size");
+    addActionToMenu(&menu, actionCollection(), "view_zoom_to_fit");
+    addActionToMenu(&menu, actionCollection(), "view_zoom_in");
+    addActionToMenu(&menu, actionCollection(), "view_zoom_out");
+    menu.addSeparator();
+    addActionToMenu(&menu, actionCollection(), "file_show_properties");
+    menu.exec(QCursor::pos());
+}
+
+void GVPart::saveAs()
+{
+    KUrl srcUrl = url();
+    KUrl dstUrl = KFileDialog::getSaveUrl(srcUrl.fileName(), QString(), widget());
+    if (!dstUrl.isValid()) {
+        return;
+    }
+
+    KIO::Job* job;
+    Document::Ptr doc = DocumentFactory::instance()->load(srcUrl);
+    QByteArray rawData = doc->rawData();
+    if (rawData.length() > 0) {
+        job = KIO::storedPut(rawData, dstUrl, -1);
+    } else {
+        job = KIO::file_copy(srcUrl, dstUrl);
+    }
+    connect(job, SIGNAL(result(KJob*)),
+            this, SLOT(showJobError(KJob*)));
+}
+
+void GVPart::showJobError(KJob* job)
+{
+    if (job->error() != 0) {
+        KIO::JobUiDelegate* ui = static_cast<KIO::Job*>(job)->ui();
+        if (!ui) {
+            kError() << "Saving failed. job->ui() is null.";
+            return;
+        }
+        ui->setWindow(widget());
+        ui->showErrorMessage();
+    }
+}
 
 } // namespace

=== modified file 'part/gvpart.desktop'
--- part/gvpart.desktop	2011-12-08 21:34:25 +0000
+++ part/gvpart.desktop	2011-12-15 14:17:54 +0000
@@ -45,6 +45,7 @@
 Name[pt_BR]=Visualizador de imagens do Gwenview
 Name[ro]=Vizualizator de imagini KView
 Name[ru]=Просмотр изображений в Gwenview
+Name[si]=Gwenview පිංතූර දසුන
 Name[sk]=Prehliadač obrázkov Gwenview
 Name[sl]=Pregledovalnik slik Gwenview
 Name[sr]=Гвенвју приказивач слика
@@ -54,7 +55,6 @@
 Name[sv]=Gwenview bildvisare
 Name[th]=เกวนวิว - เครื่องมือแสดงภาพ
 Name[tr]=Gwenview Resim Gösterici
-Name[ug]=Gwenview سۈرەت كۆرگۈ
 Name[uk]=Переглядач зображень Gwenview
 Name[vi]=Bộ xem ảnh Gwenview
 Name[x-test]=xxGwenview Image Viewerxx

=== modified file 'part/gvpart.h'
--- part/gvpart.h	2011-07-20 13:46:34 +0000
+++ part/gvpart.h	2011-12-15 14:17:54 +0000
@@ -31,33 +31,33 @@
 
 class KAboutData;
 
-
-namespace Gwenview {
+namespace Gwenview
+{
 
 class DocumentView;
 
-class GVPart : public KParts::ReadOnlyPart {
-	Q_OBJECT
+class GVPart : public KParts::ReadOnlyPart
+{
+    Q_OBJECT
 public:
-	GVPart(QWidget* parentWidget, QObject* parent, const QVariantList&);
+    GVPart(QWidget* parentWidget, QObject* parent, const QVariantList&);
 
-	static KAboutData* createAboutData();
+    static KAboutData* createAboutData();
 
 protected:
-	virtual bool openFile();
-	virtual bool openUrl(const KUrl&);
+    virtual bool openFile();
+    virtual bool openUrl(const KUrl&);
 
 private Q_SLOTS:
-	void showContextMenu();
-	void showProperties();
-	void saveAs();
-	void showJobError(KJob*);
+    void showContextMenu();
+    void showProperties();
+    void saveAs();
+    void showJobError(KJob*);
 
 private:
-	DocumentView* mDocumentView;
+    DocumentView* mDocumentView;
 };
 
 } // namespace
 
-
 #endif /* GVPART_H */

=== removed file 'tests/160216_no_size_before_decoding.eps'
--- tests/160216_no_size_before_decoding.eps	2011-07-20 13:46:34 +0000
+++ tests/160216_no_size_before_decoding.eps	1970-01-01 00:00:00 +0000
@@ -1,338 +0,0 @@
-%!PS-Adobe-3.0 EPSF-3.0
-%%Creator: GIMP PostScript file plugin V 1.17 by Peter Kirchgessner
-%%Title: GwenviewCrashSample.eps
-%%CreationDate: Tue Apr  1 11:29:17 2008
-%%DocumentData: Clean7Bit
-%%LanguageLevel: 2
-%%Pages: 1
-%%BoundingBox: 14 14 115 115
-%%EndComments
-%%BeginProlog
-% Use own dictionary to avoid conflicts
-10 dict begin
-%%EndProlog
-%%Page: 1 1
-% Translate for offset
-14.173228346456694 14.173228346456694 translate
-% Translate to begin of first scanline
-0 99.999999999999986 translate
-99.999999999999986 -99.999999999999986 scale
-% Image geometry
-100 100 8
-% Transformation matrix
-[ 100 0 0 100 0 0 ]
-% Strings to hold RGB-samples per scanline
-/rstr 100 string def
-/gstr 100 string def
-/bstr 100 string def
-{currentfile /ASCII85Decode filter /RunLengthDecode filter rstr readstring pop}
-{currentfile /ASCII85Decode filter /RunLengthDecode filter gstr readstring pop}
-{currentfile /ASCII85Decode filter /RunLengthDecode filter bstr readstring pop}
-true 3
-%%BeginData:         2111 ASCII Bytes
-colorimage
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-SH+0~>
-SH+0~>
-Sc=3~>
-%%EndData
-showpage
-%%Trailer
-end
-%%EOF

=== removed file 'tests/160382_corrupted.jpeg'
Binary files tests/160382_corrupted.jpeg and tests/160382_corrupted.jpeg differ
=== removed file 'tests/185523_1frame_with_graphic_control_extension.gif'
Binary files tests/185523_1frame_with_graphic_control_extension.gif and tests/185523_1frame_with_graphic_control_extension.gif differ
=== removed file 'tests/188191_does_not_load.tga'
Binary files tests/188191_does_not_load.tga and tests/188191_does_not_load.tga differ
=== removed file 'tests/1frame.gif'
Binary files tests/1frame.gif and tests/1frame.gif differ
=== removed file 'tests/1x10k.jpg'
Binary files tests/1x10k.jpg and tests/1x10k.jpg differ
=== removed file 'tests/1x10k.png'
Binary files tests/1x10k.png and tests/1x10k.png differ
=== removed file 'tests/40frames.gif'
Binary files tests/40frames.gif and tests/40frames.gif differ
=== removed file 'tests/4frames.gif'
Binary files tests/4frames.gif and tests/4frames.gif differ
=== modified file 'tests/CMakeLists.txt'
--- tests/CMakeLists.txt	2011-07-20 13:46:34 +0000
+++ tests/CMakeLists.txt	2011-12-15 14:17:54 +0000
@@ -1,69 +1,5 @@
-macro(gv_add_unit_test _test)
-	set(_src ${_test}.cpp ${ARGN})
-	qt4_automoc(${_src})
-	kde4_add_unit_test(${_test} ${_src})
-	target_link_libraries(${_test}
-		${NEPOMUK_LIBRARIES}
-		${KDE4_KIO_LIBS}
-		${KDE4_KDEUI_LIBS}
-		${KDE4_KDECORE_LIBS}
-		${QT_QTTEST_LIBRARY}
-		${QT_QTCORE_LIBRARY}
-		${QT_QTGUI_LIBRARY}
-		gwenviewlib)
-endmacro(gv_add_unit_test)
-
-include_directories(
-	${CMAKE_CURRENT_SOURCE_DIR}/..
-	${CMAKE_CURRENT_SOURCE_DIR}/../importer
-	)
-
-# For config-gwenview.h
-include_directories(
-	${CMAKE_CURRENT_BINARY_DIR}/..
-	)
-
-set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )
-
-gv_add_unit_test(imagescalertest)
-gv_add_unit_test(paintutilstest)
-gv_add_unit_test(documenttest testutils.cpp)
-gv_add_unit_test(transformimageoperationtest)
-gv_add_unit_test(jpegcontenttest)
-gv_add_unit_test(thumbnailloadjobtest testutils.cpp)
-if (NOT GWENVIEW_SEMANTICINFO_BACKEND_NONE)
-gv_add_unit_test(semanticinfobackendtest)
-endif (NOT GWENVIEW_SEMANTICINFO_BACKEND_NONE)
-gv_add_unit_test(timeutilstest)
-gv_add_unit_test(placetreemodeltest)
-gv_add_unit_test(urlutilstest)
-gv_add_unit_test(historymodeltest)
-gv_add_unit_test(importertest
-	${CMAKE_CURRENT_SOURCE_DIR}/../importer/importer.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/../importer/fileutils.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/../importer/filenameformater.cpp
-	)
-gv_add_unit_test(sorteddirmodeltest testutils.cpp)
-
-### Manual tests
-
-# SlideContainer
-set(slidecontainertest_SRCS
-	slidecontainertest.cpp
-	)
-
-kde4_add_executable(slidecontainertest TEST ${slidecontainertest_SRCS})
-
-target_link_libraries(slidecontainertest ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} gwenviewlib)
-
-# imageloadbench
-set(imageloadbench_SRCS
-	imageloadbench.cpp
-	)
-
-kde4_add_executable(imageloadbench TEST ${imageloadbench_SRCS})
-
-target_link_libraries(imageloadbench ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} gwenviewlib)
+add_subdirectory(auto)
+add_subdirectory(manual)
 
 add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --verbose)
 add_dependencies(check buildtests)

=== added directory 'tests/auto'
=== added file 'tests/auto/CMakeLists.txt'
--- tests/auto/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ tests/auto/CMakeLists.txt	2011-12-15 14:17:54 +0000
@@ -0,0 +1,47 @@
+macro(gv_add_unit_test _test)
+	set(_src ${_test}.cpp ${ARGN})
+	qt4_automoc(${_src})
+	kde4_add_unit_test(${_test} ${_src})
+	target_link_libraries(${_test}
+		${NEPOMUK_LIBRARIES}
+		${KDE4_KIO_LIBS}
+		${KDE4_KDEUI_LIBS}
+		${KDE4_KDECORE_LIBS}
+		${QT_QTTEST_LIBRARY}
+		${QT_QTCORE_LIBRARY}
+		${QT_QTGUI_LIBRARY}
+		gwenviewlib)
+endmacro(gv_add_unit_test)
+
+include_directories(
+	${gwenview_SOURCE_DIR}
+	${importer_SOURCE_DIR}
+	)
+
+# For config-gwenview.h
+include_directories(
+	${gwenview_BINARY_DIR}
+	)
+
+set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )
+
+gv_add_unit_test(imagescalertest)
+gv_add_unit_test(paintutilstest)
+gv_add_unit_test(documenttest testutils.cpp)
+gv_add_unit_test(transformimageoperationtest)
+gv_add_unit_test(jpegcontenttest)
+gv_add_unit_test(thumbnailloadjobtest testutils.cpp)
+if (NOT GWENVIEW_SEMANTICINFO_BACKEND_NONE)
+gv_add_unit_test(semanticinfobackendtest)
+endif (NOT GWENVIEW_SEMANTICINFO_BACKEND_NONE)
+gv_add_unit_test(timeutilstest)
+gv_add_unit_test(placetreemodeltest)
+gv_add_unit_test(urlutilstest)
+gv_add_unit_test(historymodeltest)
+gv_add_unit_test(importertest
+	${importer_SOURCE_DIR}/importer.cpp
+	${importer_SOURCE_DIR}/fileutils.cpp
+	${importer_SOURCE_DIR}/filenameformater.cpp
+	)
+gv_add_unit_test(sorteddirmodeltest testutils.cpp)
+gv_add_unit_test(slidecontainerautotest slidecontainerautotest.cpp)

=== added file 'tests/auto/documenttest.cpp'
--- tests/auto/documenttest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/documenttest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,772 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+// Qt
+#include <QConicalGradient>
+#include <QImage>
+#include <QPainter>
+
+// KDE
+#include <kdebug.h>
+#include <kjobuidelegate.h>
+#include <kio/netaccess.h>
+#include <qtest_kde.h>
+
+// Local
+#include "../lib/abstractimageoperation.h"
+#include "../lib/document/abstractdocumenteditor.h"
+#include "../lib/document/documentjob.h"
+#include "../lib/document/documentfactory.h"
+#include "../lib/imagemetainfomodel.h"
+#include "../lib/imageutils.h"
+#include "../lib/transformimageoperation.h"
+#include "testutils.h"
+
+#include <exiv2/exif.hpp>
+
+#include "documenttest.moc"
+
+QTEST_KDEMAIN(DocumentTest, GUI)
+
+using namespace Gwenview;
+
+static void waitUntilMetaInfoLoaded(Document::Ptr doc)
+{
+    while (doc->loadingState() < Document::MetaInfoLoaded) {
+        QTest::qWait(100);
+    }
+}
+
+static bool waitUntilJobIsDone(DocumentJob* job)
+{
+    JobWatcher watcher(job);
+    watcher.wait();
+    return watcher.error() == KJob::NoError;
+}
+
+void DocumentTest::initTestCase()
+{
+    qRegisterMetaType<KUrl>("KUrl");
+}
+
+void DocumentTest::init()
+{
+    DocumentFactory::instance()->clearCache();
+}
+
+void DocumentTest::testLoad()
+{
+    QFETCH(QString, fileName);
+    QFETCH(QByteArray, expectedFormat);
+    QFETCH(int, expectedKindInt);
+    QFETCH(bool, expectedIsAnimated);
+    QFETCH(QImage, expectedImage);
+    MimeTypeUtils::Kind expectedKind = MimeTypeUtils::Kind(expectedKindInt);
+
+    KUrl url = urlForTestFile(fileName);
+    if (expectedKind != MimeTypeUtils::KIND_SVG_IMAGE) {
+        QVERIFY2(!expectedImage.isNull(), "Could not load test image");
+    }
+
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    QSignalSpy spy(doc.data(), SIGNAL(isAnimatedUpdated()));
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+    QCOMPARE(doc->loadingState(), Document::Loaded);
+
+    QCOMPARE(expectedKind, doc->kind());
+    QCOMPARE(expectedIsAnimated, doc->isAnimated());
+    QCOMPARE(spy.count(), doc->isAnimated() ? 1 : 0);
+    if (doc->kind() == MimeTypeUtils::KIND_RASTER_IMAGE) {
+        QCOMPARE(expectedImage, doc->image());
+        QCOMPARE(expectedFormat, doc->format());
+    }
+}
+
+#define NEW_ROW(fileName, format, kind, isAnimated) QTest::newRow(fileName) << fileName << QByteArray(format) << int(kind) << isAnimated << QImage(pathForTestFile(fileName))
+void DocumentTest::testLoad_data()
+{
+    QTest::addColumn<QString>("fileName");
+    QTest::addColumn<QByteArray>("expectedFormat");
+    QTest::addColumn<int>("expectedKindInt");
+    QTest::addColumn<bool>("expectedIsAnimated");
+    QTest::addColumn<QImage>("expectedImage");
+
+    NEW_ROW("test.png",
+            "png", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+    NEW_ROW("160216_no_size_before_decoding.eps",
+            "eps", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+    NEW_ROW("160382_corrupted.jpeg",
+            "jpeg", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+    NEW_ROW("test.svg",
+            "", MimeTypeUtils::KIND_SVG_IMAGE, false);
+    // FIXME: Test svgz
+    NEW_ROW("1x10k.png",
+            "png", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+    NEW_ROW("1x10k.jpg",
+            "jpeg", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+    NEW_ROW("4frames.gif",
+            "gif", MimeTypeUtils::KIND_RASTER_IMAGE, true);
+    NEW_ROW("1frame.gif",
+            "gif", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+    NEW_ROW("185523_1frame_with_graphic_control_extension.gif",
+            "gif", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+    NEW_ROW("test.xcf",
+            "xcf", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+    NEW_ROW("188191_does_not_load.tga",
+            "tga", MimeTypeUtils::KIND_RASTER_IMAGE, false);
+}
+#undef NEW_ROW
+
+void DocumentTest::testLoadTwoPasses()
+{
+    KUrl url = urlForTestFile("test.png");
+    QImage image;
+    bool ok = image.load(url.toLocalFile());
+    QVERIFY2(ok, "Could not load 'test.png'");
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    waitUntilMetaInfoLoaded(doc);
+    QVERIFY2(doc->image().isNull(), "Image shouldn't have been loaded at this time");
+    QCOMPARE(doc->format().data(), "png");
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+    QCOMPARE(image, doc->image());
+}
+
+void DocumentTest::testLoadEmpty()
+{
+    KUrl url = urlForTestFile("empty.png");
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    while (doc->loadingState() <= Document::KindDetermined) {
+        QTest::qWait(100);
+    }
+    QCOMPARE(doc->loadingState(), Document::LoadingFailed);
+}
+
+#define NEW_ROW(fileName) QTest::newRow(fileName) << fileName
+void DocumentTest::testLoadDownSampled_data()
+{
+    QTest::addColumn<QString>("fileName");
+
+    NEW_ROW("orient6.jpg");
+    NEW_ROW("1x10k.jpg");
+}
+#undef NEW_ROW
+
+void DocumentTest::testLoadDownSampled()
+{
+    // Note: for now we only support down sampling on jpeg, do not use test.png
+    // here
+    QFETCH(QString, fileName);
+    KUrl url = urlForTestFile(fileName);
+    QImage image;
+    bool ok = image.load(url.toLocalFile());
+    QVERIFY2(ok, "Could not load test image");
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+
+    QSignalSpy downSampledImageReadySpy(doc.data(), SIGNAL(downSampledImageReady()));
+    QSignalSpy loadingFailedSpy(doc.data(), SIGNAL(loadingFailed(KUrl)));
+    QSignalSpy loadedSpy(doc.data(), SIGNAL(loaded(KUrl)));
+    bool ready = doc->prepareDownSampledImageForZoom(0.2);
+    QVERIFY2(!ready, "There should not be a down sampled image at this point");
+
+    while (downSampledImageReadySpy.count() == 0 && loadingFailedSpy.count() == 0 && loadedSpy.count() == 0) {
+        QTest::qWait(100);
+    }
+    QImage downSampledImage = doc->downSampledImageForZoom(0.2);
+    QVERIFY2(!downSampledImage.isNull(), "Down sampled image should not be null");
+
+    QSize expectedSize = doc->size() / 4;
+    if (expectedSize.isEmpty()) {
+        expectedSize = image.size();
+    }
+    QCOMPARE(downSampledImage.size(), expectedSize);
+}
+
+/**
+ * Down sampling is not supported on png. We should get a complete image
+ * instead.
+ */
+void DocumentTest::testLoadDownSampledPng()
+{
+    KUrl url = urlForTestFile("test.png");
+    QImage image;
+    bool ok = image.load(url.toLocalFile());
+    QVERIFY2(ok, "Could not load test image");
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+
+    LoadingStateSpy stateSpy(doc);
+    connect(doc.data(), SIGNAL(loaded(KUrl)), &stateSpy, SLOT(readState()));
+
+    bool ready = doc->prepareDownSampledImageForZoom(0.2);
+    QVERIFY2(!ready, "There should not be a down sampled image at this point");
+
+    doc->waitUntilLoaded();
+
+    QCOMPARE(stateSpy.mCallCount, 1);
+    QCOMPARE(stateSpy.mState, Document::Loaded);
+}
+
+void DocumentTest::testLoadRemote()
+{
+    KUrl url = setUpRemoteTestDir("test.png");
+    if (!url.isValid()) {
+        return;
+    }
+    url.addPath("test.png");
+
+    QVERIFY2(KIO::NetAccess::exists(url, KIO::NetAccess::SourceSide, 0), "test url not found");
+
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+    QImage image = doc->image();
+    QCOMPARE(image.width(), 150);
+    QCOMPARE(image.height(), 100);
+}
+
+void DocumentTest::testLoadAnimated()
+{
+    KUrl srcUrl = urlForTestFile("40frames.gif");
+    Document::Ptr doc = DocumentFactory::instance()->load(srcUrl);
+    QSignalSpy spy(doc.data(), SIGNAL(imageRectUpdated(QRect)));
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+    QVERIFY(doc->isAnimated());
+
+    // Test we receive only one imageRectUpdated() until animation is started
+    // (the imageRectUpdated() is triggered by the loading of the first image)
+    QTest::qWait(1000);
+    QCOMPARE(spy.count(), 1);
+
+    // Test we now receive some imageRectUpdated()
+    doc->startAnimation();
+    QTest::qWait(1000);
+    int count = spy.count();
+    doc->stopAnimation();
+    QVERIFY2(count > 0, "No imageRectUpdated() signal received");
+
+    // Test we do not receive imageRectUpdated() anymore
+    QTest::qWait(1000);
+    QCOMPARE(count, spy.count());
+
+    // Start again, we should receive imageRectUpdated() again
+    doc->startAnimation();
+    QTest::qWait(1000);
+    QVERIFY2(spy.count() > count, "No imageRectUpdated() signal received after restarting");
+}
+
+void DocumentTest::testSaveRemote()
+{
+    KUrl dstUrl = setUpRemoteTestDir();
+    if (!dstUrl.isValid()) {
+        return;
+    }
+
+    KUrl srcUrl = urlForTestFile("test.png");
+    Document::Ptr doc = DocumentFactory::instance()->load(srcUrl);
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+
+    dstUrl.addPath("testSaveRemote.png");
+    QVERIFY(waitUntilJobIsDone(doc->save(dstUrl, "png")));
+}
+
+/**
+ * Check that deleting a document while it is loading does not crash
+ */
+void DocumentTest::testDeleteWhileLoading()
+{
+    {
+        KUrl url = urlForTestFile("test.png");
+        QImage image;
+        bool ok = image.load(url.toLocalFile());
+        QVERIFY2(ok, "Could not load 'test.png'");
+        Document::Ptr doc = DocumentFactory::instance()->load(url);
+    }
+    DocumentFactory::instance()->clearCache();
+    // Wait two seconds. If the test fails we will get a segfault while waiting
+    QTest::qWait(2000);
+}
+
+void DocumentTest::testLoadRotated()
+{
+    KUrl url = urlForTestFile("orient6.jpg");
+    QImage image;
+    bool ok = image.load(url.toLocalFile());
+    QVERIFY2(ok, "Could not load 'orient6.jpg'");
+    QMatrix matrix = ImageUtils::transformMatrix(ROT_90);
+    image = image.transformed(matrix);
+
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+    QCOMPARE(image, doc->image());
+}
+
+/**
+ * Checks that asking the DocumentFactory the same document twice in a row does
+ * not load it twice
+ */
+void DocumentTest::testMultipleLoads()
+{
+    KUrl url = urlForTestFile("orient6.jpg");
+    Document::Ptr doc1 = DocumentFactory::instance()->load(url);
+    Document::Ptr doc2 = DocumentFactory::instance()->load(url);
+
+    QCOMPARE(doc1.data(), doc2.data());
+}
+
+void DocumentTest::testSaveAs()
+{
+    KUrl url = urlForTestFile("orient6.jpg");
+    DocumentFactory* factory = DocumentFactory::instance();
+    Document::Ptr doc = factory->load(url);
+    QSignalSpy savedSpy(doc.data(), SIGNAL(saved(KUrl, KUrl)));
+    QSignalSpy modifiedDocumentListChangedSpy(factory, SIGNAL(modifiedDocumentListChanged()));
+    QSignalSpy documentChangedSpy(factory, SIGNAL(documentChanged(KUrl)));
+    doc->startLoadingFullImage();
+
+    KUrl destUrl = urlForTestOutputFile("result.png");
+    QVERIFY(waitUntilJobIsDone(doc->save(destUrl, "png")));
+    QCOMPARE(doc->format().data(), "png");
+    QCOMPARE(doc->url(), destUrl);
+    QCOMPARE(doc->metaInfo()->getValueForKey("General.Name"), destUrl.fileName());
+
+    QVERIFY2(doc->loadingState() == Document::Loaded,
+             "Document is supposed to finish loading before saving"
+            );
+
+    QTest::qWait(100); // saved() is emitted asynchronously
+    QCOMPARE(savedSpy.count(), 1);
+    QVariantList args = savedSpy.takeFirst();
+    QCOMPARE(args.at(0).value<KUrl>(), url);
+    QCOMPARE(args.at(1).value<KUrl>(), destUrl);
+
+    QImage image("result.png", "png");
+    QCOMPARE(doc->image(), image);
+
+    QVERIFY(!DocumentFactory::instance()->hasUrl(url));
+    QVERIFY(DocumentFactory::instance()->hasUrl(destUrl));
+
+    QCOMPARE(modifiedDocumentListChangedSpy.count(), 0); // No changes were made
+
+    QCOMPARE(documentChangedSpy.count(), 1);
+    args = documentChangedSpy.takeFirst();
+    QCOMPARE(args.at(0).value<KUrl>(), destUrl);
+}
+
+void DocumentTest::testLosslessSave()
+{
+    KUrl url1 = urlForTestFile("orient6.jpg");
+    Document::Ptr doc = DocumentFactory::instance()->load(url1);
+    doc->startLoadingFullImage();
+
+    KUrl url2 = urlForTestOutputFile("orient1.jpg");
+    QVERIFY(waitUntilJobIsDone(doc->save(url2, "jpeg")));
+
+    QImage image1;
+    QVERIFY(image1.load(url1.toLocalFile()));
+
+    QImage image2;
+    QVERIFY(image2.load(url2.toLocalFile()));
+
+    QCOMPARE(image1, image2);
+}
+
+void DocumentTest::testLosslessRotate()
+{
+    // Generate test image
+    QImage image1(200, 96, QImage::Format_RGB32);
+    {
+        QPainter painter(&image1);
+        QConicalGradient gradient(QPointF(100, 48), 100);
+        gradient.setColorAt(0, Qt::white);
+        gradient.setColorAt(1, Qt::blue);
+        painter.fillRect(image1.rect(), gradient);
+    }
+
+    KUrl url1 = urlForTestOutputFile("lossless1.jpg");
+    QVERIFY(image1.save(url1.toLocalFile(), "jpeg"));
+
+    // Load it as a Gwenview document
+    Document::Ptr doc = DocumentFactory::instance()->load(url1);
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+
+    // Rotate one time
+    QVERIFY(doc->editor());
+    doc->editor()->applyTransformation(ROT_90);
+
+    // Save it
+    KUrl url2 = urlForTestOutputFile("lossless2.jpg");
+    waitUntilJobIsDone(doc->save(url2, "jpeg"));
+
+    // Load the saved image
+    doc = DocumentFactory::instance()->load(url2);
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+
+    // Rotate the other way
+    QVERIFY(doc->editor());
+    doc->editor()->applyTransformation(ROT_270);
+    waitUntilJobIsDone(doc->save(url2, "jpeg"));
+
+    // Compare the saved images
+    QVERIFY(image1.load(url1.toLocalFile()));
+    QImage image2;
+    QVERIFY(image2.load(url2.toLocalFile()));
+
+    QCOMPARE(image1, image2);
+}
+
+void DocumentTest::testModifyAndSaveAs()
+{
+    QVariantList args;
+    class TestOperation : public AbstractImageOperation
+    {
+    public:
+        void redo()
+    {
+            QImage image(10, 10, QImage::Format_ARGB32);
+            image.fill(QColor(Qt::white).rgb());
+            document()->editor()->setImage(image);
+            finish(true);
+        }
+    };
+    KUrl url = urlForTestFile("orient6.jpg");
+    DocumentFactory* factory = DocumentFactory::instance();
+    Document::Ptr doc = factory->load(url);
+
+    QSignalSpy savedSpy(doc.data(), SIGNAL(saved(KUrl, KUrl)));
+    QSignalSpy modifiedDocumentListChangedSpy(factory, SIGNAL(modifiedDocumentListChanged()));
+    QSignalSpy documentChangedSpy(factory, SIGNAL(documentChanged(KUrl)));
+
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+    QVERIFY(!doc->isModified());
+    QCOMPARE(modifiedDocumentListChangedSpy.count(), 0);
+
+    // Modify image
+    QVERIFY(doc->editor());
+    TestOperation* op = new TestOperation;
+    op->applyToDocument(doc);
+    QVERIFY(doc->isModified());
+    QCOMPARE(modifiedDocumentListChangedSpy.count(), 1);
+    modifiedDocumentListChangedSpy.clear();
+    QList<KUrl> lst = factory->modifiedDocumentList();
+    QCOMPARE(lst.count(), 1);
+    QCOMPARE(lst.first(), url);
+    QCOMPARE(documentChangedSpy.count(), 1);
+    args = documentChangedSpy.takeFirst();
+    QCOMPARE(args.at(0).value<KUrl>(), url);
+
+    // Save it under a new name
+    KUrl destUrl = urlForTestOutputFile("modify.png");
+    QVERIFY(waitUntilJobIsDone(doc->save(destUrl, "png")));
+
+    // Wait a bit because save() will clear the undo stack when back to the
+    // event loop
+    QTest::qWait(100);
+    QVERIFY(!doc->isModified());
+
+    QVERIFY(!factory->hasUrl(url));
+    QVERIFY(factory->hasUrl(destUrl));
+    QCOMPARE(modifiedDocumentListChangedSpy.count(), 1);
+    QVERIFY(DocumentFactory::instance()->modifiedDocumentList().isEmpty());
+
+    QCOMPARE(documentChangedSpy.count(), 2);
+    KUrl::List modifiedUrls = KUrl::List() << url << destUrl;
+    QVERIFY(modifiedUrls.contains(url));
+    QVERIFY(modifiedUrls.contains(destUrl));
+}
+
+void DocumentTest::testMetaInfoJpeg()
+{
+    KUrl url = urlForTestFile("orient6.jpg");
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+
+    // We cleared the cache, so the document should not be loaded
+    Q_ASSERT(doc->loadingState() <= Document::KindDetermined);
+
+    // Wait until we receive the metaInfoUpdated() signal
+    QSignalSpy metaInfoUpdatedSpy(doc.data(), SIGNAL(metaInfoUpdated()));
+    while (metaInfoUpdatedSpy.count() == 0) {
+        QTest::qWait(100);
+    }
+
+    // Extract an exif key
+    QString value = doc->metaInfo()->getValueForKey("Exif.Image.Make");
+    QCOMPARE(value, QString::fromUtf8("Canon"));
+}
+
+void DocumentTest::testMetaInfoBmp()
+{
+    KUrl url = urlForTestOutputFile("metadata.bmp");
+    const int width = 200;
+    const int height = 100;
+    QImage image(width, height, QImage::Format_ARGB32);
+    image.fill(Qt::black);
+    image.save(url.toLocalFile(), "BMP");
+
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    QSignalSpy metaInfoUpdatedSpy(doc.data(), SIGNAL(metaInfoUpdated()));
+    waitUntilMetaInfoLoaded(doc);
+
+    Q_ASSERT(metaInfoUpdatedSpy.count() >= 1);
+
+    QString value = doc->metaInfo()->getValueForKey("General.ImageSize");
+    QString expectedValue = QString("%1x%2").arg(width).arg(height);
+    QCOMPARE(value, expectedValue);
+}
+
+void DocumentTest::testForgetModifiedDocument()
+{
+    QSignalSpy spy(DocumentFactory::instance(), SIGNAL(modifiedDocumentListChanged()));
+    DocumentFactory::instance()->forget(KUrl("file://does/not/exist.png"));
+    QCOMPARE(spy.count(), 0);
+
+    // Generate test image
+    QImage image1(200, 96, QImage::Format_RGB32);
+    {
+        QPainter painter(&image1);
+        QConicalGradient gradient(QPointF(100, 48), 100);
+        gradient.setColorAt(0, Qt::white);
+        gradient.setColorAt(1, Qt::blue);
+        painter.fillRect(image1.rect(), gradient);
+    }
+
+    KUrl url = urlForTestOutputFile("testForgetModifiedDocument.png");
+    QVERIFY(image1.save(url.toLocalFile(), "png"));
+
+    // Load it as a Gwenview document
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+
+    // Modify it
+    TransformImageOperation* op = new TransformImageOperation(ROT_90);
+    op->applyToDocument(doc);
+    QTest::qWait(100);
+
+    QCOMPARE(spy.count(), 1);
+
+    QList<KUrl> lst = DocumentFactory::instance()->modifiedDocumentList();
+    QCOMPARE(lst.length(), 1);
+    QCOMPARE(lst.first(), url);
+
+    // Forget it
+    DocumentFactory::instance()->forget(url);
+
+    QCOMPARE(spy.count(), 2);
+    lst = DocumentFactory::instance()->modifiedDocumentList();
+    QVERIFY(lst.isEmpty());
+}
+
+void DocumentTest::testModifiedAndSavedSignals()
+{
+    TransformImageOperation* op;
+
+    KUrl url = urlForTestFile("orient6.jpg");
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    QSignalSpy modifiedSpy(doc.data(), SIGNAL(modified(KUrl)));
+    QSignalSpy savedSpy(doc.data(), SIGNAL(saved(KUrl, KUrl)));
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+
+    QCOMPARE(modifiedSpy.count(), 0);
+    QCOMPARE(savedSpy.count(), 0);
+
+    op = new TransformImageOperation(ROT_90);
+    op->applyToDocument(doc);
+    QTest::qWait(100);
+    QCOMPARE(modifiedSpy.count(), 1);
+
+    op = new TransformImageOperation(ROT_90);
+    op->applyToDocument(doc);
+    QTest::qWait(100);
+    QCOMPARE(modifiedSpy.count(), 2);
+
+    doc->undoStack()->undo();
+    QCOMPARE(modifiedSpy.count(), 3);
+
+    doc->undoStack()->undo();
+    QCOMPARE(savedSpy.count(), 1);
+}
+
+class TestJob : public DocumentJob
+{
+public:
+    TestJob(QString* str, char ch)
+        : mStr(str)
+        , mCh(ch)
+    {}
+
+protected:
+    virtual void doStart()
+    {
+        *mStr += mCh;
+        emitResult();
+    }
+
+private:
+    QString* mStr;
+    char mCh;
+};
+
+void DocumentTest::testJobQueue()
+{
+    KUrl url = urlForTestFile("orient6.jpg");
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+    QSignalSpy spy(doc.data(), SIGNAL(busyChanged(KUrl, bool)));
+
+    QString str;
+    doc->enqueueJob(new TestJob(&str, 'a'));
+    doc->enqueueJob(new TestJob(&str, 'b'));
+    doc->enqueueJob(new TestJob(&str, 'c'));
+    QVERIFY(doc->isBusy());
+    QEventLoop loop;
+    connect(doc.data(), SIGNAL(allTasksDone()),
+            &loop, SLOT(quit()));
+    loop.exec();
+    QVERIFY(!doc->isBusy());
+    QCOMPARE(spy.count(), 2);
+    QVariantList row = spy.takeFirst();
+    QCOMPARE(row.at(0).value<KUrl>(), url);
+    QVERIFY(row.at(1).toBool());
+    row = spy.takeFirst();
+    QCOMPARE(row.at(0).value<KUrl>(), url);
+    QVERIFY(!row.at(1).toBool());
+    QCOMPARE(str, QString("abc"));
+}
+
+class TestCheckDocumentEditorJob : public DocumentJob
+{
+public:
+    TestCheckDocumentEditorJob(int* hasEditor)
+        : mHasEditor(hasEditor) {
+        *mHasEditor = -1;
+    }
+
+protected:
+    virtual void doStart()
+    {
+        document()->waitUntilLoaded();
+        *mHasEditor = checkDocumentEditor() ? 1 : 0;
+        emitResult();
+    }
+
+private:
+    int* mHasEditor;
+};
+
+class TestUiDelegate : public KJobUiDelegate
+{
+public:
+    TestUiDelegate(bool* showErrorMessageCalled)
+        : mShowErrorMessageCalled(showErrorMessageCalled) {
+        setAutoErrorHandlingEnabled(true);
+        *mShowErrorMessageCalled = false;
+    }
+
+    virtual void showErrorMessage()
+    {
+        kDebug();
+        *mShowErrorMessageCalled = true;
+    }
+
+private:
+    bool* mShowErrorMessageCalled;
+};
+
+/**
+ * Test that an error is reported when a DocumentJob fails because there is no
+ * document editor available
+ */
+void DocumentTest::testCheckDocumentEditor()
+{
+    int hasEditor;
+    bool showErrorMessageCalled;
+    QEventLoop loop;
+    Document::Ptr doc;
+    TestCheckDocumentEditorJob* job;
+
+    doc = DocumentFactory::instance()->load(urlForTestFile("orient6.jpg"));
+
+    job = new TestCheckDocumentEditorJob(&hasEditor);
+    job->setUiDelegate(new TestUiDelegate(&showErrorMessageCalled));
+    doc->enqueueJob(job);
+    connect(doc.data(), SIGNAL(allTasksDone()), &loop, SLOT(quit()));
+    loop.exec();
+    QVERIFY(!showErrorMessageCalled);
+    QCOMPARE(hasEditor, 1);
+
+    doc = DocumentFactory::instance()->load(urlForTestFile("test.svg"));
+
+    job = new TestCheckDocumentEditorJob(&hasEditor);
+    job->setUiDelegate(new TestUiDelegate(&showErrorMessageCalled));
+    doc->enqueueJob(job);
+    connect(doc.data(), SIGNAL(allTasksDone()), &loop, SLOT(quit()));
+    loop.exec();
+    QVERIFY(showErrorMessageCalled);
+    QCOMPARE(hasEditor, 0);
+}
+
+/**
+ * An operation should only pushed to the document undo stack if it succeed
+ */
+void DocumentTest::testUndoStackPush()
+{
+    class SuccessOperation : public AbstractImageOperation
+    {
+    protected:
+        virtual void redo()
+    {
+            QMetaObject::invokeMethod(this, "finish", Qt::QueuedConnection, Q_ARG(bool, true));
+        }
+    };
+
+    class FailureOperation : public AbstractImageOperation
+    {
+    protected:
+        virtual void redo()
+    {
+            QMetaObject::invokeMethod(this, "finish", Qt::QueuedConnection, Q_ARG(bool, false));
+        }
+    };
+
+    AbstractImageOperation* op;
+    Document::Ptr doc = DocumentFactory::instance()->load(urlForTestFile("orient6.jpg"));
+
+    // A successful operation should be added to the undo stack
+    op = new SuccessOperation;
+    op->applyToDocument(doc);
+    QTest::qWait(100);
+    QVERIFY(!doc->undoStack()->isClean());
+
+    // Reset
+    doc->undoStack()->undo();
+    QVERIFY(doc->undoStack()->isClean());
+
+    // A failed operation should not be added to the undo stack
+    op = new FailureOperation;
+    op->applyToDocument(doc);
+    QTest::qWait(100);
+    QVERIFY(doc->undoStack()->isClean());
+}

=== added file 'tests/auto/documenttest.h'
--- tests/auto/documenttest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/documenttest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,129 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef DOCUMENTTEST_H
+#define DOCUMENTTEST_H
+
+// Qt
+#include <QObject>
+
+// KDE
+#include <kjob.h>
+
+// Local
+#include "../lib/document/document.h"
+
+class LoadingStateSpy : public QObject
+{
+    Q_OBJECT
+public:
+    LoadingStateSpy(const Gwenview::Document::Ptr& doc)
+        : mDocument(doc)
+        , mCallCount(0) {
+    }
+
+public Q_SLOTS:
+    void readState() {
+        mCallCount++;
+        mState = mDocument->loadingState();
+    }
+
+public:
+    Gwenview::Document::Ptr mDocument;
+    int mCallCount;
+    Gwenview::Document::LoadingState mState;
+};
+
+class JobWatcher : public QObject
+{
+    Q_OBJECT
+public:
+    JobWatcher(KJob* job)
+        : mJob(job)
+        , mDone(false)
+        , mError(0) {
+        connect(job, SIGNAL(result(KJob*)),
+                SLOT(slotResult(KJob*)));
+        connect(job, SIGNAL(destroyed(QObject*)),
+                SLOT(slotDestroyed()));
+    }
+
+    void wait() {
+        while (!mDone) {
+            QApplication::processEvents();
+        }
+    }
+
+    int error() const {
+        return mError;
+    }
+
+private Q_SLOTS:
+    void slotResult(KJob* job) {
+        mError = job->error();
+        mDone = true;
+    }
+
+    void slotDestroyed() {
+        kWarning() << "Destroyed";
+        mError = -1;
+        mDone = true;
+    }
+
+private:
+    KJob* mJob;
+    bool mDone;
+    int mError;
+};
+
+class DocumentTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void testLoad();
+    void testLoad_data();
+    void testLoadTwoPasses();
+    void testLoadEmpty();
+    void testLoadDownSampled();
+    void testLoadDownSampled_data();
+    void testLoadDownSampledPng();
+    void testLoadRemote();
+    void testLoadAnimated();
+    void testDeleteWhileLoading();
+    void testLoadRotated();
+    void testMultipleLoads();
+    void testSaveAs();
+    void testSaveRemote();
+    void testLosslessSave();
+    void testLosslessRotate();
+    void testModifyAndSaveAs();
+    void testMetaInfoJpeg();
+    void testMetaInfoBmp();
+    void testForgetModifiedDocument();
+    void testModifiedAndSavedSignals();
+    void testJobQueue();
+    void testCheckDocumentEditor();
+    void testUndoStackPush();
+
+    void initTestCase();
+    void init();
+};
+
+#endif // DOCUMENTTEST_H

=== added file 'tests/auto/historymodeltest.cpp'
--- tests/auto/historymodeltest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/historymodeltest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,119 @@
+/*
+Gwenview: an image viewer
+Copyright 2009 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include "historymodeltest.moc"
+
+// Qt
+#include <QDir>
+
+// KDE
+#include <kdebug.h>
+#include <kfileplacesmodel.h>
+#include <ktempdir.h>
+#include <qtest_kde.h>
+
+// Local
+#include "../lib/historymodel.h"
+
+QTEST_KDEMAIN(HistoryModelTest, GUI)
+
+using namespace Gwenview;
+
+void testModel(const HistoryModel& model, const KUrl& u1, const KUrl& u2)
+{
+    QModelIndex index;
+    KUrl url;
+    QCOMPARE(model.rowCount(), 2);
+
+    index = model.index(0, 0);
+    QVERIFY(index.isValid());
+    url = model.data(index, KFilePlacesModel::UrlRole).value<QUrl>();
+    QCOMPARE(url, u1);
+
+    index = model.index(1, 0);
+    QVERIFY(index.isValid());
+    url = model.data(index, KFilePlacesModel::UrlRole).value<QUrl>();
+    QCOMPARE(url, u2);
+
+}
+
+void HistoryModelTest::testAddUrl()
+{
+    KUrl u1 = KUrl::fromPath("/home");
+    QDateTime d1 = QDateTime::fromString("2008-02-03T12:34:56", Qt::ISODate);
+    KUrl u2 = KUrl::fromPath("/root");
+    QDateTime d2 = QDateTime::fromString("2009-01-29T23:01:47", Qt::ISODate);
+    KTempDir dir;
+    {
+        HistoryModel model(0, dir.name());
+        model.addUrl(u1, d1);
+        model.addUrl(u2, d2);
+        testModel(model, u2, u1);
+    }
+
+    HistoryModel model(0, dir.name());
+    testModel(model, u2, u1);
+
+    // Make u1 the most recent
+    QDateTime d3 = QDateTime::fromString("2009-03-24T22:42:15", Qt::ISODate);
+    model.addUrl(u1, d3);
+    testModel(model, u1, u2);
+}
+
+void HistoryModelTest::testGarbageCollect()
+{
+    KUrl u1 = KUrl::fromPath("/home");
+    QDateTime d1 = QDateTime::fromString("2008-02-03T12:34:56", Qt::ISODate);
+    KUrl u2 = KUrl::fromPath("/root");
+    QDateTime d2 = QDateTime::fromString("2009-01-29T23:01:47", Qt::ISODate);
+    KUrl u3 = KUrl::fromPath("/usr");
+    QDateTime d3 = QDateTime::fromString("2009-03-24T22:42:15", Qt::ISODate);
+
+    KTempDir dir;
+    {
+        HistoryModel model(0, dir.name(), 2);
+        model.addUrl(u1, d1);
+        model.addUrl(u2, d2);
+        testModel(model, u2, u1);
+        model.addUrl(u3, d3);
+    }
+
+    // Create a model with a larger history so that if garbage collecting fails
+    // to remove the collected url, the size of the model won't pass
+    // testModel()
+    HistoryModel model(0, dir.name(), 10);
+    testModel(model, u3, u2);
+}
+
+void HistoryModelTest::testRemoveRows()
+{
+    KUrl u1 = KUrl::fromPath("/home");
+    QDateTime d1 = QDateTime::fromString("2008-02-03T12:34:56", Qt::ISODate);
+    KUrl u2 = KUrl::fromPath("/root");
+    QDateTime d2 = QDateTime::fromString("2009-01-29T23:01:47", Qt::ISODate);
+
+    KTempDir dir;
+    HistoryModel model(0, dir.name(), 2);
+    model.addUrl(u1, d1);
+    model.addUrl(u2, d2);
+    model.removeRows(0, 1);
+    QCOMPARE(model.rowCount(), 1);
+    QDir qDir(dir.name());
+    QCOMPARE(qDir.entryList(QDir::Files | QDir::NoDotAndDotDot).count(), 1);
+}

=== added file 'tests/auto/historymodeltest.h'
--- tests/auto/historymodeltest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/historymodeltest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,36 @@
+/*
+Gwenview: an image viewer
+Copyright 2009 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef HISTORYMODELTEST_H
+#define HISTORYMODELTEST_H
+
+// Qt
+#include <QObject>
+
+class HistoryModelTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void testAddUrl();
+    void testGarbageCollect();
+    void testRemoveRows();
+};
+
+#endif /* HISTORYMODELTEST_H */

=== added file 'tests/auto/imagescalertest.cpp'
--- tests/auto/imagescalertest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/imagescalertest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,214 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include <qtest_kde.h>
+
+#include "imagescalertest.moc"
+
+#include "../lib/imagescaler.h"
+#include "../lib/document/documentfactory.h"
+
+#include "testutils.h"
+
+QTEST_KDEMAIN(ImageScalerTest, GUI)
+
+using namespace Gwenview;
+
+static void waitUntilMetaInfoLoaded(Document::Ptr doc)
+{
+    while (doc->loadingState() < Document::MetaInfoLoaded) {
+        QTest::qWait(100);
+    }
+}
+
+/**
+ * Scale whole image in one pass
+ */
+void ImageScalerTest::testScaleFullImage()
+{
+    const qreal zoom = 2;
+    KUrl url = urlForTestFile("test.png");
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+
+    ImageScaler scaler;
+    ImageScalerClient client(&scaler);
+    scaler.setDocument(doc);
+    scaler.setZoom(zoom);
+
+    // FIXME: Load full image for now, because ImageScalerClient does not wait
+    // when ImageScaler request a full image to be loaded asynchronously.
+    doc->startLoadingFullImage();
+    doc->waitUntilLoaded();
+
+    scaler.setDestinationRegion(QRect(QPoint(0, 0), doc->size() * zoom));
+
+    QImage scaledImage = client.createFullImage();
+    QCOMPARE(doc->loadingState(), Document::Loaded);
+
+    QImage expectedImage = doc->image().scaled(doc->size() * zoom);
+    QCOMPARE(scaledImage, expectedImage);
+}
+
+#if 0
+/**
+ * Scale parts of an image
+ * In this test, the result image should be missing its bottom-right corner
+ */
+void ImageScalerTest::testScalePartialImage()
+{
+    QImage image(10, 10, QImage::Format_ARGB32);
+    const int zoom = 2;
+    {
+        QPainter painter(&image);
+        painter.fillRect(image.rect(), Qt::white);
+        painter.drawText(0, image.height(), "X");
+    }
+
+    Gwenview::ImageScaler scaler;
+    ImageScalerClient client(&scaler);
+    scaler.setImage(&image);
+    scaler.setZoom(zoom);
+    QRegion region;
+    region |= QRect(
+                  0, 0,
+                  image.width() * zoom / 2, image.height() * zoom);
+
+    region |= QRect(
+                  0, 0,
+                  image.width() * zoom, image.height() * zoom / 2);
+    scaler.setDestinationRegion(region);
+
+    QImage expectedImage(image.size() * zoom, image.format());
+    expectedImage.fill(0);
+    {
+        QPainter painter(&expectedImage);
+        QImage tmp;
+        tmp = image.copy(0, 0,
+                         expectedImage.width() / zoom / 2,
+                         expectedImage.height() / zoom);
+        painter.drawImage(0, 0, tmp.scaled(tmp.size() * zoom));
+        tmp = image.copy(0, 0,
+                         expectedImage.width() / zoom,
+                         expectedImage.height() / zoom / 2);
+        painter.drawImage(0, 0, tmp.scaled(tmp.size() * zoom));
+    }
+
+    QImage scaledImage = client.createFullImage();
+
+    QCOMPARE(scaledImage, expectedImage);
+}
+
+/**
+ * Scale whole image in two passes, not using exact pixel boundaries
+ */
+void ImageScalerTest::testScaleFullImageTwoPasses()
+{
+    QFETCH(qreal, zoom);
+    QImage image(10, 10, QImage::Format_ARGB32);
+    {
+        QPainter painter(&image);
+        painter.fillRect(image.rect(), Qt::white);
+        painter.drawLine(0, 0, image.width(), image.height());
+    }
+
+    Gwenview::ImageScaler scaler;
+    ImageScalerClient client(&scaler);
+
+    scaler.setImage(&image);
+    scaler.setZoom(zoom);
+    int zWidth = int(image.width() * zoom);
+    int zHeight = int(image.width() * zoom);
+    int partialZWidth = zWidth / 3;
+    scaler.setDestinationRegion(
+        QRect(
+            0, 0,
+            partialZWidth, zHeight)
+    );
+
+    scaler.setDestinationRegion(
+        QRect(
+            partialZWidth, 0,
+            zWidth - partialZWidth, zHeight)
+    );
+
+    QImage expectedImage = image.scaled(image.size() * zoom);
+
+    QImage scaledImage = client.createFullImage();
+    QCOMPARE(expectedImage, scaledImage);
+}
+
+void ImageScalerTest::testScaleFullImageTwoPasses_data()
+{
+    QTest::addColumn<qreal>("zoom");
+
+    QTest::newRow("0.5") << 0.5;
+    QTest::newRow("2.0") << 2.0;
+    QTest::newRow("4.0") << 4.0;
+}
+
+/**
+ * When zooming out, make sure that we don't crash when scaling an area which
+ * have one dimension smaller than one pixel in the destination.
+ */
+void ImageScalerTest::testScaleThinArea()
+{
+    QImage image(10, 10, QImage::Format_ARGB32);
+    image.fill(0);
+
+    Gwenview::ImageScaler scaler;
+
+    const qreal zoom = 0.25;
+    scaler.setImage(&image);
+    scaler.setZoom(zoom);
+    scaler.setDestinationRegion(QRect(0, 0, image.width(), 2));
+}
+
+/**
+ * Test instantiating a scaler without setting an image won't crash
+ */
+void ImageScalerTest::testDontCrashWithoutImage()
+{
+    Gwenview::ImageScaler scaler;
+    scaler.setZoom(1.0);
+    scaler.setDestinationRegion(QRect(0, 0, 10, 10));
+}
+
+/**
+ * Test that scaling down a big image (==bigger than MAX_CHUNK_AREA) does not
+ * produce any gap
+ */
+void ImageScalerTest::testScaleDownBigImage()
+{
+    QImage image(1704, 2272, QImage::Format_RGB32);
+    image.fill(255);
+
+    Gwenview::ImageScaler scaler;
+    ImageScalerClient client(&scaler);
+
+    const qreal zoom = 0.28125;
+    scaler.setImage(&image);
+    scaler.setZoom(zoom);
+    scaler.setDestinationRegion(QRect(QPoint(0, 0), image.size() * zoom));
+
+    QImage scaledImage = client.createFullImage();
+
+    QImage expectedImage = image.scaled(scaledImage.size());
+    QCOMPARE(expectedImage, scaledImage);
+}
+#endif

=== added file 'tests/auto/imagescalertest.h'
--- tests/auto/imagescalertest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/imagescalertest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,100 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef IMAGESCALERTEST_H
+#define IMAGESCALERTEST_H
+
+#include "../lib/imagescaler.h"
+
+// Qt
+#include <QImage>
+#include <QPainter>
+
+// KDE
+#include <kdebug.h>
+
+class ImageScalerClient : public QObject
+{
+    Q_OBJECT
+public:
+    ImageScalerClient(Gwenview::ImageScaler* scaler) {
+        connect(scaler, SIGNAL(scaledRect(int, int, const QImage&)),
+                SLOT(slotScaledRect(int, int, const QImage&)));
+    }
+
+    struct ImageInfo {
+        int left;
+        int top;
+        QImage image;
+    };
+    QVector<ImageInfo> mImageInfoList;
+
+    QImage createFullImage() {
+        Q_ASSERT(mImageInfoList.size() > 0);
+        QImage::Format format = mImageInfoList[0].image.format();
+
+        int imageWidth = 0;
+        int imageHeight = 0;
+        Q_FOREACH(const ImageInfo & info, mImageInfoList) {
+            int right = info.left + info.image.width();
+            int bottom = info.top + info.image.height();
+            imageWidth = qMax(imageWidth, right);
+            imageHeight = qMax(imageHeight, bottom);
+        }
+
+        QImage image(imageWidth, imageHeight, format);
+        image.fill(0);
+        QPainter painter(&image);
+        Q_FOREACH(const ImageInfo & info, mImageInfoList) {
+            painter.drawImage(info.left, info.top, info.image);
+        }
+        return image;
+    }
+
+public Q_SLOTS:
+    void slotScaledRect(int left, int top, const QImage& image) {
+        ImageInfo info;
+        info.left = left;
+        info.top = top;
+        info.image = image;
+
+        mImageInfoList.append(info);
+    }
+};
+
+class ImageScalerTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void testScaleFullImage();
+
+    // FIXME Disabled for now, does not compile since ImageScaler::setImage() has
+    // been replaced with ImageScaler::setDocument()
+#if 0
+    void testScalePartialImage();
+    void testScaleFullImageTwoPasses();
+    void testScaleFullImageTwoPasses_data();
+    void testScaleThinArea();
+    void testDontCrashWithoutImage();
+    void testScaleDownBigImage();
+#endif
+};
+
+#endif // IMAGESCALERTEST_H

=== added file 'tests/auto/importertest.cpp'
--- tests/auto/importertest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/importertest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,247 @@
+/*
+Gwenview: an image viewer
+Copyright 2009 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include "importertest.moc"
+
+// stdlib
+#include <sys/stat.h>
+
+// Qt
+#include <QSignalSpy>
+
+// KDE
+#include <kdatetime.h>
+#include <kdebug.h>
+#include <qtest_kde.h>
+
+// Local
+#include "../importer/fileutils.h"
+#include "../importer/importer.h"
+#include "../importer/filenameformater.h"
+#include "testutils.h"
+
+QTEST_KDEMAIN(ImporterTest, GUI)
+
+using namespace Gwenview;
+
+void ImporterTest::init()
+{
+    mDocumentList = KUrl::List()
+                    << urlForTestFile("import/pict0001.jpg")
+                    << urlForTestFile("import/pict0002.jpg")
+                    << urlForTestFile("import/pict0003.jpg")
+                    ;
+
+    mTempDir.reset(new KTempDir());
+}
+
+void ImporterTest::testContentsAreIdentical()
+{
+    QVERIFY(!FileUtils::contentsAreIdentical(mDocumentList[0], mDocumentList[1]));
+    QVERIFY(FileUtils::contentsAreIdentical(mDocumentList[0], mDocumentList[0]));
+
+    KUrl url1 = mDocumentList[0];
+    KUrl url2 = urlForTestOutputFile("foo");
+
+    // Test on a copy of a file
+    QFile::remove(url2.toLocalFile());
+    QFile::copy(url1.toLocalFile(), url2.toLocalFile());
+
+    QVERIFY(FileUtils::contentsAreIdentical(url1, url2));
+
+    // Alter one byte of the copy and test again
+    QFile file(url2.toLocalFile());
+    QVERIFY(file.open(QIODevice::ReadOnly));
+    QByteArray data = file.readAll();
+    file.close();
+    data[data.size() / 2] = 255 - data[data.size() / 2];
+
+    file.open(QIODevice::WriteOnly);
+    file.write(data);
+    file.close();
+
+    QVERIFY(!FileUtils::contentsAreIdentical(url1, url2));
+}
+
+void ImporterTest::testSuccessfulImport()
+{
+    KUrl destUrl = KUrl::fromPath(mTempDir->name() + "/foo");
+
+    Importer importer(0);
+    QSignalSpy maximumChangedSpy(&importer, SIGNAL(maximumChanged(int)));
+    QSignalSpy errorSpy(&importer, SIGNAL(error(QString)));
+
+    KUrl::List list = mDocumentList;
+
+    QEventLoop loop;
+    connect(&importer, SIGNAL(importFinished()), &loop, SLOT(quit()));
+    importer.start(list, destUrl);
+    loop.exec();
+
+    QCOMPARE(maximumChangedSpy.count(), 1);
+    QCOMPARE(maximumChangedSpy.takeFirst().at(0).toInt(), list.count() * 100);
+    QCOMPARE(errorSpy.count(), 0);
+
+    QCOMPARE(importer.importedUrlList().count(), list.count());
+    QCOMPARE(importer.importedUrlList(), list);
+    QCOMPARE(importer.skippedUrlList().count(), 0);
+    QCOMPARE(importer.renamedCount(), 0);
+
+    Q_FOREACH(const KUrl & src, list) {
+        KUrl dst = destUrl;
+        dst.addPath(src.fileName());
+        QVERIFY(FileUtils::contentsAreIdentical(src, dst));
+    }
+}
+
+void ImporterTest::testSkippedUrlList()
+{
+    KUrl destUrl = KUrl::fromPath(mTempDir->name() + "/foo");
+
+    Importer importer(0);
+
+    KUrl::List list = mDocumentList.mid(0, 1);
+
+    QEventLoop loop;
+    connect(&importer, SIGNAL(importFinished()), &loop, SLOT(quit()));
+    importer.start(list, destUrl);
+    loop.exec();
+
+    QCOMPARE(importer.importedUrlList().count(), 1);
+    QCOMPARE(importer.importedUrlList(), list);
+
+    list = mDocumentList;
+    KUrl::List expectedImportedList = mDocumentList.mid(1);
+    KUrl::List expectedSkippedList = mDocumentList.mid(0, 1);
+    importer.start(list, destUrl);
+    loop.exec();
+
+    QCOMPARE(importer.importedUrlList().count(), 2);
+    QCOMPARE(importer.importedUrlList(), expectedImportedList);
+    QCOMPARE(importer.skippedUrlList(), expectedSkippedList);
+    QCOMPARE(importer.renamedCount(), 0);
+}
+
+void ImporterTest::testRenamedCount()
+{
+    KUrl destUrl = KUrl::fromPath(mTempDir->name() + "/foo");
+
+    Importer importer(0);
+
+    KUrl::List list;
+    list << mDocumentList.first();
+
+    QEventLoop loop;
+    connect(&importer, SIGNAL(importFinished()), &loop, SLOT(quit()));
+    importer.start(list, destUrl);
+    loop.exec();
+
+    QCOMPARE(importer.importedUrlList().count(), 1);
+    QCOMPARE(importer.importedUrlList(), list);
+
+    // Modify imported document so that next import does not skip it
+    {
+        KUrl url = destUrl;
+        url.addPath(mDocumentList.first().fileName());
+        QFile file(url.toLocalFile());
+        QVERIFY(file.open(QIODevice::Append));
+        file.write("foo");
+    }
+
+    list = mDocumentList;
+    importer.start(list, destUrl);
+    loop.exec();
+
+    QCOMPARE(importer.importedUrlList().count(), 3);
+    QCOMPARE(importer.importedUrlList(), mDocumentList);
+    QCOMPARE(importer.skippedUrlList().count(), 0);
+    QCOMPARE(importer.renamedCount(), 1);
+}
+
+void ImporterTest::testFileNameFormater()
+{
+    QFETCH(QString, fileName);
+    QFETCH(QString, dateTime);
+    QFETCH(QString, format);
+    QFETCH(QString, expected);
+
+    KUrl url = KUrl("file://foo/bar/" + fileName);
+    FileNameFormater fileNameFormater(format);
+    QCOMPARE(fileNameFormater.format(url, KDateTime::fromString(dateTime)), expected);
+}
+
+#define NEW_ROW(fileName, dateTime, format, expected) QTest::newRow(fileName) << fileName << dateTime << format << expected
+void ImporterTest::testFileNameFormater_data()
+{
+    QTest::addColumn<QString>("fileName");
+    QTest::addColumn<QString>("dateTime");
+    QTest::addColumn<QString>("format");
+    QTest::addColumn<QString>("expected");
+
+    NEW_ROW("PICT0001.JPG", "20091024T225049", "{date}_{time}.{ext}", "2009-10-24_22-50-49.JPG");
+    NEW_ROW("PICT0001.JPG", "20091024T225049", "{date}_{time}.{ext.lower}", "2009-10-24_22-50-49.jpg");
+    NEW_ROW("PICT0001.JPG", "20091024T225049", "{name}.{ext}", "PICT0001.JPG");
+    NEW_ROW("PICT0001.JPG", "20091024T225049", "{name.lower}.{ext.lower}", "pict0001.jpg");
+    NEW_ROW("iLikeCurlies", "20091024T225049", "{{{name}}", "{iLikeCurlies}");
+    NEW_ROW("UnknownKeyword", "20091024T225049", "foo{unknown}bar", "foobar");
+    NEW_ROW("MissingClosingCurly", "20091024T225049", "foo{date", "foo");
+}
+
+void ImporterTest::testAutoRenameFormat()
+{
+    QStringList dates = QStringList()
+                        << "1979-02-23_10-20-00"
+                        << "2006-04-01_11-30-15"
+                        << "2009-10-01_21-15-27";
+    QCOMPARE(dates.count(), mDocumentList.count());
+
+    KUrl destUrl = KUrl::fromPath(mTempDir->name() + "foo");
+
+    Importer importer(0);
+    importer.setAutoRenameFormat("{date}_{time}.{ext}");
+    KUrl::List list = mDocumentList;
+
+    QEventLoop loop;
+    connect(&importer, SIGNAL(importFinished()), &loop, SLOT(quit()));
+    importer.start(list, destUrl);
+    loop.exec();
+
+    QCOMPARE(importer.importedUrlList().count(), list.count());
+    QCOMPARE(importer.importedUrlList(), list);
+
+    for (int pos = 0; pos < dates.count(); ++pos) {
+        KUrl src = list[pos];
+        KUrl dst = destUrl;
+        dst.addPath(dates[pos] + ".jpg");
+        QVERIFY(FileUtils::contentsAreIdentical(src, dst));
+    }
+}
+
+void ImporterTest::testReadOnlyDestination()
+{
+    KUrl destUrl = KUrl::fromPath(mTempDir->name() + "/foo");
+    chmod(QFile::encodeName(mTempDir->name()), 0555);
+
+    Importer importer(0);
+    QSignalSpy errorSpy(&importer, SIGNAL(error(QString)));
+    importer.start(mDocumentList, destUrl);
+
+    QCOMPARE(errorSpy.count(), 1);
+    QVERIFY(importer.importedUrlList().isEmpty());
+}

=== added file 'tests/auto/importertest.h'
--- tests/auto/importertest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/importertest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,53 @@
+/*
+Gwenview: an image viewer
+Copyright 2009 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef IMPORTERTEST_H
+#define IMPORTERTEST_H
+
+// stdc++
+#include <memory>
+
+// Qt
+#include <QObject>
+
+// KDE
+#include <ktempdir.h>
+#include <kurl.h>
+
+class ImporterTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void init();
+    void testContentsAreIdentical();
+    void testSuccessfulImport();
+    void testAutoRenameFormat();
+    void testReadOnlyDestination();
+    void testFileNameFormater();
+    void testFileNameFormater_data();
+    void testSkippedUrlList();
+    void testRenamedCount();
+
+private:
+    std::auto_ptr<KTempDir> mTempDir;
+    KUrl::List mDocumentList;
+};
+
+#endif /* IMPORTERTEST_H */

=== added file 'tests/auto/jpegcontenttest.cpp'
--- tests/auto/jpegcontenttest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/jpegcontenttest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,303 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include "jpegcontenttest.moc"
+#include <iostream>
+
+// Qt
+#include <QDir>
+#include <QFile>
+#include <QImage>
+#include <QString>
+
+// KDE
+#include <qtest_kde.h>
+#include <kdebug.h>
+#include <kfilemetainfo.h>
+
+// Local
+#include "../lib/orientation.h"
+#include "../lib/jpegcontent.h"
+#include "testutils.h"
+
+using namespace std;
+
+const char* ORIENT6_FILE = "orient6.jpg";
+const char* ORIENT1_VFLIP_FILE = "orient1_vflip.jpg";
+const char* CUT_FILE = "cut.jpg";
+const char* TMP_FILE = "tmp.jpg";
+const char* THUMBNAIL_FILE = "test_thumbnail.jpg";
+
+const int ORIENT6_WIDTH = 128; // This size is the size *after* orientation
+const int ORIENT6_HEIGHT = 256; // has been applied
+const QString ORIENT6_COMMENT = "a comment";
+
+QTEST_KDEMAIN(JpegContentTest, GUI)
+
+void JpegContentTest::initTestCase()
+{
+    bool result;
+    QFile in(pathForTestFile(ORIENT6_FILE));
+    result = in.open(QIODevice::ReadOnly);
+    QVERIFY(result);
+
+    QFileInfo info(in);
+    int size = info.size() / 2;
+
+    char* data = new char[size];
+    int readSize = in.read(data, size);
+    QCOMPARE(size, readSize);
+
+    QFile out(CUT_FILE);
+    result = out.open(QIODevice::WriteOnly);
+    QVERIFY(result);
+
+    int wroteSize = out.write(data, size);
+    QCOMPARE(size, wroteSize);
+    delete []data;
+}
+
+void JpegContentTest::cleanupTestCase()
+{
+    QDir::current().remove(CUT_FILE);
+}
+
+typedef QMap<QString, QString> MetaInfoMap;
+
+MetaInfoMap getMetaInfo(const QString& path)
+{
+    KFileMetaInfo fmi(path);
+    QStringList list = fmi.supportedKeys();
+    QStringList::ConstIterator it = list.constBegin();
+    MetaInfoMap map;
+
+    for (; it != list.constEnd(); ++it) {
+        KFileMetaInfoItem item = fmi.item(*it);
+        map[*it] = item.value().toString();
+    }
+
+    return map;
+}
+
+void compareMetaInfo(const QString& path1, const QString& path2, const QStringList& ignoredKeys)
+{
+    MetaInfoMap mim1 = getMetaInfo(path1);
+    MetaInfoMap mim2 = getMetaInfo(path2);
+
+    QCOMPARE(mim1.keys(), mim2.keys());
+    QList<QString> keys = mim1.keys();
+    QList<QString>::ConstIterator it = keys.constBegin();
+    for (; it != keys.constEnd(); ++it) {
+        QString key = *it;
+        if (ignoredKeys.contains(key)) continue;
+
+        QString msg =
+            QString("Meta info differs for key '%1': v1=%2 v2=%3")
+            .arg(key)
+            .arg(mim1[key])
+            .arg(mim2[key]);
+
+        QVERIFY2(mim1[key] == mim2[key], msg.toUtf8());
+    }
+}
+
+void JpegContentTest::testResetOrientation()
+{
+    Gwenview::JpegContent content;
+    bool result;
+
+    // Test resetOrientation without transform
+    result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+
+    content.resetOrientation();
+
+    result = content.save(TMP_FILE);
+    QVERIFY(result);
+
+    result = content.load(TMP_FILE);
+    QVERIFY(result);
+    QCOMPARE(content.orientation(), Gwenview::NORMAL);
+
+    // Test resetOrientation with transform
+    result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+
+    content.resetOrientation();
+    content.transform(Gwenview::ROT_90);
+
+    result = content.save(TMP_FILE);
+    QVERIFY(result);
+
+    result = content.load(TMP_FILE);
+    QVERIFY(result);
+    QCOMPARE(content.orientation(), Gwenview::NORMAL);
+}
+
+/**
+ * This function tests JpegContent::transform() by applying a ROT_90
+ * transformation, saving, reloading and applying a ROT_270 to undo the ROT_90.
+ * Saving and reloading are necessary because lossless transformation only
+ * happens in JpegContent::save()
+ */
+void JpegContentTest::testTransform()
+{
+    bool result;
+    QImage finalImage, expectedImage;
+
+    Gwenview::JpegContent content;
+    result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+
+    content.transform(Gwenview::ROT_90);
+    result = content.save(TMP_FILE);
+    QVERIFY(result);
+
+    result = content.load(TMP_FILE);
+    QVERIFY(result);
+    content.transform(Gwenview::ROT_270);
+    result = content.save(TMP_FILE);
+    QVERIFY(result);
+
+    result = finalImage.load(TMP_FILE);
+    QVERIFY(result);
+
+    result = expectedImage.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+
+    QCOMPARE(finalImage , expectedImage);
+}
+
+void JpegContentTest::testSetComment()
+{
+    QString comment = "test comment";
+    Gwenview::JpegContent content;
+    bool result;
+    result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+
+    content.setComment(comment);
+    QCOMPARE(content.comment() , comment);
+    result = content.save(TMP_FILE);
+    QVERIFY(result);
+
+    result = content.load(TMP_FILE);
+    QVERIFY(result);
+    QCOMPARE(content.comment() , comment);
+}
+
+void JpegContentTest::testReadInfo()
+{
+    Gwenview::JpegContent content;
+    bool result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+    QCOMPARE(int(content.orientation()), 6);
+    QCOMPARE(content.comment() , ORIENT6_COMMENT);
+    QCOMPARE(content.size() , QSize(ORIENT6_WIDTH, ORIENT6_HEIGHT));
+}
+
+void JpegContentTest::testThumbnail()
+{
+    Gwenview::JpegContent content;
+    bool result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+    QImage thumbnail = content.thumbnail();
+    result = thumbnail.save(THUMBNAIL_FILE, "JPEG");
+    QVERIFY(result);
+}
+
+void JpegContentTest::testMultipleRotations()
+{
+    // Test that rotating a file a lot of times does not cause findJxform() to fail
+    Gwenview::JpegContent content;
+    bool result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+    result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+
+    // 12*4 + 1 is the same as 1, since rotating four times brings you back
+    for (int loop = 0; loop < 12 * 4 + 1; ++loop) {
+        content.transform(Gwenview::ROT_90);
+    }
+    result = content.save(TMP_FILE);
+    QVERIFY(result);
+
+    result = content.load(TMP_FILE);
+    QVERIFY(result);
+
+    QCOMPARE(content.size() , QSize(ORIENT6_HEIGHT, ORIENT6_WIDTH));
+
+    // Check the other meta info are still here
+    QStringList ignoredKeys;
+    ignoredKeys << "Orientation" << "Comment";
+    compareMetaInfo(pathForTestFile(ORIENT6_FILE), pathForTestFile(ORIENT1_VFLIP_FILE), ignoredKeys);
+}
+
+void JpegContentTest::testLoadTruncated()
+{
+    // Test that loading and manipulating a truncated file does not crash
+    Gwenview::JpegContent content;
+    bool result = content.load(CUT_FILE);
+    QVERIFY(result);
+    QCOMPARE(int(content.orientation()), 6);
+    QCOMPARE(content.comment() , ORIENT6_COMMENT);
+    content.transform(Gwenview::VFLIP);
+    kWarning() << "# Next function should output errors about incomplete image" ;
+    content.save(TMP_FILE);
+    kWarning() << "#" ;
+}
+
+void JpegContentTest::testRawData()
+{
+    Gwenview::JpegContent content;
+    bool result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+
+    QByteArray fileData;
+    QFile file(pathForTestFile(ORIENT6_FILE));
+    result = file.open(QIODevice::ReadOnly);
+    QVERIFY(result);
+    fileData = file.readAll();
+
+    QCOMPARE(content.rawData(), fileData);
+}
+
+void JpegContentTest::testSetImage()
+{
+    Gwenview::JpegContent content;
+    bool result = content.load(pathForTestFile(ORIENT6_FILE));
+    QVERIFY(result);
+
+    QImage image = QImage(400, 300, QImage::Format_RGB32);
+    image.fill(Qt::red);
+
+    content.setImage(image);
+
+    result = content.save(TMP_FILE);
+    QVERIFY(result);
+
+    result = content.load(TMP_FILE);
+    QVERIFY(result);
+
+    QCOMPARE(content.size(), image.size());
+
+    QStringList ignoredKeys;
+    ignoredKeys << "Orientation";
+    compareMetaInfo(pathForTestFile(ORIENT6_FILE), pathForTestFile(TMP_FILE), ignoredKeys);
+}

=== added file 'tests/auto/jpegcontenttest.h'
--- tests/auto/jpegcontenttest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/jpegcontenttest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,44 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef JPEGCONTENTTEST_H
+#define JPEGCONTENTTEST_H
+
+// Qt
+#include <QObject>
+
+class JpegContentTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void initTestCase();
+    void cleanupTestCase();
+    void testReadInfo();
+    void testThumbnail();
+    void testResetOrientation();
+    void testTransform();
+    void testSetComment();
+    void testMultipleRotations();
+    void testLoadTruncated();
+    void testRawData();
+    void testSetImage();
+};
+
+#endif // JPEGCONTENTTEST_H

=== added file 'tests/auto/paintutilstest.cpp'
--- tests/auto/paintutilstest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/paintutilstest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,43 @@
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include <qtest_kde.h>
+
+#include "../lib/paintutils.h"
+
+#include "paintutilstest.moc"
+
+QTEST_KDEMAIN(PaintUtilsTest, GUI)
+
+void PaintUtilsTest::testScaledRect_data()
+{
+    QTest::addColumn<QRectF>("input");
+    QTest::addColumn<QRect>("expected");
+
+    QTest::newRow("overflow right") << QRectF(1.0, 1.0, 2.7, 3.2) << QRect(1, 1, 3, 4);
+    QTest::newRow("overflow left")  << QRectF(0.5, 1.0, 2.0, 3.2) << QRect(0, 1, 3, 4);
+    QTest::newRow("overflow both")  << QRectF(0.5, 1.0, 2.6, 3.2) << QRect(0, 1, 4, 4);
+}
+
+void PaintUtilsTest::testScaledRect()
+{
+    QFETCH(QRectF, input);
+    QFETCH(QRect,  expected);
+    QCOMPARE(Gwenview::PaintUtils::containingRect(input), expected);
+}

=== added file 'tests/auto/paintutilstest.h'
--- tests/auto/paintutilstest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/paintutilstest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,36 @@
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef PAINTUTILSTEST_H
+#define PAINTUTILSTEST_H
+
+// Qt
+
+// KDE
+
+class PaintUtilsTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void testScaledRect();
+    void testScaledRect_data();
+};
+
+#endif // PAINTUTILSTEST_H

=== added file 'tests/auto/placetreemodeltest.cpp'
--- tests/auto/placetreemodeltest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/placetreemodeltest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,140 @@
+/*
+Gwenview: an image viewer
+Copyright 2009 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include "placetreemodeltest.moc"
+
+// Qt
+#include <QDir>
+#include <QFile>
+
+// KDE
+#include <kdebug.h>
+#include <kstandarddirs.h>
+#include <qtest_kde.h>
+
+// Local
+#include "../lib/placetreemodel.h"
+
+#define KEEP_TEMP_DIR
+
+QTEST_KDEMAIN(PlaceTreeModelTest, GUI)
+
+using namespace Gwenview;
+
+const char* BOOKMARKS_XML =
+    "<?xml version='1.0' encoding='UTF-8'?>"
+    "<!DOCTYPE xbel>"
+    "<xbel xmlns:bookmark='http://www.freedesktop.org/standards/desktop-bookmarks' xmlns:mime='http://www.freedesktop.org/standards/shared-mime-info' xmlns:kdepriv='http://www.kde.org/kdepriv' dbusName='kfilePlaces' >"
+    " <bookmark href='%1' >"
+    "  <title>url1</title>"
+    "  <info>"
+    "   <metadata owner='http://freedesktop.org' >"
+    "    <bookmark:icon name='user-home' />"
+    "   </metadata>"
+    "   <metadata owner='http://www.kde.org' >"
+    "    <ID>1214343736/0</ID>"
+    "    <isSystemItem>true</isSystemItem>"
+    "   </metadata>"
+    "  </info>"
+    " </bookmark>"
+    " <bookmark href='%2' >"
+    "  <title>url2</title>"
+    "  <info>"
+    "   <metadata owner='http://freedesktop.org' >"
+    "    <bookmark:icon name='user-home' />"
+    "   </metadata>"
+    "   <metadata owner='http://www.kde.org' >"
+    "    <ID>1214343736/1</ID>"
+    "    <isSystemItem>true</isSystemItem>"
+    "   </metadata>"
+    "  </info>"
+    " </bookmark>"
+    "</xbel>";
+
+void PlaceTreeModelTest::initTestCase()
+{
+    Q_ASSERT(mTempDir.exists());
+    QDir dir(mTempDir.name());
+
+    Q_ASSERT(dir.mkdir("url1"));
+    mUrl1 = KUrl::fromPath(dir.filePath("url1"));
+
+    Q_ASSERT(dir.mkdir("url2"));
+    mUrl2 = KUrl::fromPath(dir.filePath("url2"));
+
+    mUrl1Dirs << "aaa" << "zzz" << "bbb";
+    Q_FOREACH(const QString & dirName, mUrl1Dirs) {
+        dir.mkdir("url1/" + dirName);
+    }
+
+    QFile bookmark(KStandardDirs::locateLocal("data", "kfileplaces/bookmarks.xml"));
+    Q_ASSERT(bookmark.open(QIODevice::WriteOnly));
+
+    QString xml = QString(BOOKMARKS_XML)
+                  .arg(mUrl1.toLocalFile())
+                  .arg(mUrl2.toLocalFile())
+                  ;
+    bookmark.write(xml.toUtf8());
+
+#ifdef KEEP_TEMP_DIR
+    mTempDir.setAutoRemove(false);
+    kDebug() << "mTempDir:" << mTempDir.name();
+#endif
+}
+
+void PlaceTreeModelTest::testListPlaces()
+{
+    PlaceTreeModel model(0);
+    QCOMPARE(model.rowCount(), 2);
+
+    QModelIndex index;
+    index = model.index(0, 0);
+    QCOMPARE(model.urlForIndex(index), mUrl1);
+    index = model.index(1, 0);
+    QCOMPARE(model.urlForIndex(index), mUrl2);
+}
+
+void PlaceTreeModelTest::testListUrl1()
+{
+    PlaceTreeModel model(0);
+
+    QModelIndex index = model.index(0, 0);
+    QCOMPARE(model.urlForIndex(index), mUrl1);
+
+    // We should not have fetched content yet
+    QCOMPARE(model.rowCount(index), 0);
+    QVERIFY(model.canFetchMore(index));
+
+    while (model.canFetchMore(index)) {
+        model.fetchMore(index);
+    }
+    QTest::qWait(1000);
+    QCOMPARE(model.rowCount(index), mUrl1Dirs.length());
+
+    QStringList dirs = mUrl1Dirs;
+    dirs.sort();
+
+    for (int row = 0; row < dirs.count(); ++row) {
+        QModelIndex subIndex = model.index(row, 0, index);
+        QVERIFY(subIndex.isValid());
+
+        QString dirName = model.data(subIndex).toString();
+        QCOMPARE(dirName, dirs.value(row));
+    }
+}

=== added file 'tests/auto/placetreemodeltest.h'
--- tests/auto/placetreemodeltest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/placetreemodeltest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,46 @@
+/*
+Gwenview: an image viewer
+Copyright 2009 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef PLACETREEMODELTEST_H
+#define PLACETREEMODELTEST_H
+
+// Qt
+#include <QObject>
+#include <QStringList>
+
+// KDE
+#include <ktempdir.h>
+#include <kurl.h>
+
+class PlaceTreeModelTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void initTestCase();
+    void testListPlaces();
+    void testListUrl1();
+
+private:
+    KUrl mUrl1, mUrl2;
+    QStringList mUrl1Dirs;
+    KTempDir mTempDir;
+};
+
+#endif /* PLACETREEMODELTEST_H */

=== added file 'tests/auto/semanticinfobackendtest.cpp'
--- tests/auto/semanticinfobackendtest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/semanticinfobackendtest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,139 @@
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+// Local
+#include "semanticinfobackendtest.moc"
+
+// Qt
+#include <QSignalSpy>
+
+// KDE
+#include <kdebug.h>
+#include <krandom.h>
+#include <ktemporaryfile.h>
+#include <qtest_kde.h>
+
+// Local
+#include "testutils.h"
+#include <config-gwenview.h>
+
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_FAKE
+#include <lib/semanticinfo/fakesemanticinfobackend.h>
+
+#elif defined(GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK)
+#include <nepomuk/resourcemanager.h>
+#include <lib/semanticinfo/nepomuksemanticinfobackend.h>
+
+#else
+#ifdef __GNUC__
+#error No metadata backend defined
+#endif
+#endif
+
+QTEST_KDEMAIN(Gwenview::SemanticInfoBackEndTest, GUI)
+
+namespace Gwenview
+{
+
+SemanticInfoBackEndClient::SemanticInfoBackEndClient(AbstractSemanticInfoBackEnd* backEnd)
+: mBackEnd(backEnd)
+{
+    connect(backEnd, SIGNAL(semanticInfoRetrieved(KUrl, SemanticInfo)),
+            SLOT(slotSemanticInfoRetrieved(KUrl, SemanticInfo)));
+}
+
+void SemanticInfoBackEndClient::slotSemanticInfoRetrieved(const KUrl& url, const SemanticInfo& semanticInfo)
+{
+    mSemanticInfoForUrl[url] = semanticInfo;
+}
+
+void SemanticInfoBackEndTest::initTestCase()
+{
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
+    if (Nepomuk::ResourceManager::instance()->init() != 0) {
+        QSKIP("This test needs Nepomuk", SkipAll);
+    }
+#endif
+    qRegisterMetaType<KUrl>("KUrl");
+    qRegisterMetaType<QString>("SemanticInfoTag");
+}
+
+void SemanticInfoBackEndTest::init()
+{
+#ifdef GWENVIEW_SEMANTICINFO_BACKEND_FAKE
+    mBackEnd = new FakeSemanticInfoBackEnd(0, FakeSemanticInfoBackEnd::InitializeEmpty);
+#elif defined(GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK)
+    mBackEnd = new NepomukSemanticInfoBackEnd(0);
+#endif
+}
+
+void SemanticInfoBackEndTest::cleanup()
+{
+    delete mBackEnd;
+    mBackEnd = 0;
+}
+
+/**
+ * Get and set the rating of a temp file
+ */
+void SemanticInfoBackEndTest::testRating()
+{
+    KTemporaryFile temp;
+    temp.setSuffix(".metadatabackendtest");
+    QVERIFY(temp.open());
+
+    KUrl url;
+    url.setPath(temp.fileName());
+
+    SemanticInfoBackEndClient client(mBackEnd);
+    QSignalSpy spy(mBackEnd, SIGNAL(semanticInfoRetrieved(KUrl, SemanticInfo)));
+    mBackEnd->retrieveSemanticInfo(url);
+    QVERIFY(waitForSignal(spy));
+
+    SemanticInfo semanticInfo = client.semanticInfoForUrl(url);
+    QCOMPARE(semanticInfo.mRating, 0);
+
+    semanticInfo.mRating = 5;
+    mBackEnd->storeSemanticInfo(url, semanticInfo);
+}
+
+void SemanticInfoBackEndTest::testTagForLabel()
+{
+    QSignalSpy spy(mBackEnd, SIGNAL(tagAdded(SemanticInfoTag, QString)));
+
+    TagSet oldAllTags = mBackEnd->allTags();
+    QString label = "testTagForLabel-" + KRandom::randomString(5);
+    SemanticInfoTag tag1 = mBackEnd->tagForLabel(label);
+    QVERIFY(!tag1.isEmpty());
+    QVERIFY(!oldAllTags.contains(tag1));
+    QVERIFY(mBackEnd->allTags().contains(tag1));
+
+    // This is a new tag, we should receive a signal
+    QCOMPARE(spy.count(), 1);
+
+    SemanticInfoTag tag2 = mBackEnd->tagForLabel(label);
+    QCOMPARE(tag1, tag2);
+    // This is not a new tag, we should not receive a signal
+    QCOMPARE(spy.count(), 1);
+
+    QString label2 = mBackEnd->labelForTag(tag2);
+    QCOMPARE(label, label2);
+}
+
+} // namespace

=== added file 'tests/auto/semanticinfobackendtest.h'
--- tests/auto/semanticinfobackendtest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/semanticinfobackendtest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,75 @@
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef SEMANTICINFOBACKENDTEST_H
+#define SEMANTICINFOBACKENDTEST_H
+
+// Qt
+#include <QHash>
+#include <QObject>
+
+// KDE
+#include <kurl.h>
+
+// Local
+#include <lib/semanticinfo/abstractsemanticinfobackend.h>
+
+namespace Gwenview
+{
+
+/**
+ * Helper class which gathers the metadata retrieved when
+ * AbstractSemanticInfoBackEnd::retrieveSemanticInfo() is called.
+ */
+class SemanticInfoBackEndClient : public QObject
+{
+    Q_OBJECT
+public:
+    SemanticInfoBackEndClient(AbstractSemanticInfoBackEnd*);
+
+    SemanticInfo semanticInfoForUrl(const KUrl& url) const {
+        return mSemanticInfoForUrl.value(url);
+    }
+
+private Q_SLOTS:
+    void slotSemanticInfoRetrieved(const KUrl&, const SemanticInfo&);
+
+private:
+    QHash<KUrl, SemanticInfo> mSemanticInfoForUrl;
+    AbstractSemanticInfoBackEnd* mBackEnd;
+};
+
+class SemanticInfoBackEndTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void initTestCase();
+    void init();
+    void cleanup();
+    void testRating();
+    void testTagForLabel();
+
+private:
+    AbstractSemanticInfoBackEnd* mBackEnd;
+};
+
+} // namespace
+
+#endif // SEMANTICINFOBACKENDTEST_H

=== added file 'tests/auto/slidecontainerautotest.cpp'
--- tests/auto/slidecontainerautotest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/slidecontainerautotest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,135 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Self
+#include "slidecontainerautotest.moc"
+
+// Local
+#include <lib/slidecontainer.h>
+
+// KDE
+#include <qtest_kde.h>
+#include <kdebug.h>
+
+// Qt
+#include <QTextEdit>
+#include <QVBoxLayout>
+
+QTEST_KDEMAIN(SlideContainerAutoTest, GUI)
+
+using namespace Gwenview;
+
+struct TestWindow : public QWidget {
+    explicit TestWindow(QWidget* parent = 0)
+        : QWidget(parent)
+        , mContainer(new SlideContainer)
+        , mContent(0) {
+        createContent();
+
+        mMainWidget = new QTextEdit();
+        QVBoxLayout* layout = new QVBoxLayout(this);
+        layout->setSpacing(0);
+        layout->setMargin(0);
+        layout->addWidget(mMainWidget);
+        layout->addWidget(mContainer);
+    }
+
+    void createContent()
+    {
+        mContent = new QTextEdit;
+        mContent->setFixedSize(100, 40);
+        mContainer->setContent(mContent);
+    }
+
+    SlideContainer* mContainer;
+    QWidget* mMainWidget;
+    QWidget* mContent;
+};
+
+void SlideContainerAutoTest::testInit()
+{
+    // Even with content, a SlideContainer should be invisible until slideIn()
+    // is called
+    TestWindow window;
+    window.show();
+
+    QTest::qWait(500);
+    QCOMPARE(window.mMainWidget->height(), window.height());
+}
+
+void SlideContainerAutoTest::testSlideIn()
+{
+    TestWindow window;
+    window.show();
+
+    window.mContainer->slideIn();
+    while (window.mContainer->slideHeight() != window.mContent->height()) {
+        QTest::qWait(100);
+    }
+    QCOMPARE(window.mContainer->height(), window.mContent->height());
+}
+
+void SlideContainerAutoTest::testSlideOut()
+{
+    TestWindow window;
+    window.show();
+
+    window.mContainer->slideIn();
+    while (window.mContainer->slideHeight() != window.mContent->height()) {
+        QTest::qWait(100);
+    }
+    window.mContainer->slideOut();
+    while (window.mContainer->slideHeight() != 0) {
+        QTest::qWait(100);
+    }
+    QCOMPARE(window.mContainer->height(), 0);
+}
+
+void SlideContainerAutoTest::testSlideInDeleteSlideOut()
+{
+    // If content is deleted while visible, slideOut() should still produce an
+    // animation
+    TestWindow window;
+    window.show();
+
+    window.mContainer->slideIn();
+    while (window.mContainer->slideHeight() != window.mContent->height()) {
+        QTest::qWait(100);
+    }
+    window.mContent->deleteLater();
+    window.mContainer->slideOut();
+    while (window.mContainer->slideHeight() != 0) {
+        QTest::qWait(100);
+    }
+    QCOMPARE(window.mContainer->height(), 0);
+}
+
+void SlideContainerAutoTest::testHiddenContentResize()
+{
+    // Resizing content should not trigger a slide if it is not visible.
+    TestWindow window;
+    window.show();
+    QTest::qWaitForWindowShown(&window);
+
+    window.mContent->show();
+    window.mContent->setFixedSize(150, 80);
+    QTest::qWait(500);
+    QCOMPARE(window.mContainer->height(), 0);
+}
\ No newline at end of file

=== added file 'tests/auto/slidecontainerautotest.h'
--- tests/auto/slidecontainerautotest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/slidecontainerautotest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,42 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+#ifndef SLIDECONTAINERAUTOTEST_H
+#define SLIDECONTAINERAUTOTEST_H
+
+// Local
+
+// KDE
+
+// Qt
+#include <QObject>
+
+class SlideContainerAutoTest : public QObject
+{
+    Q_OBJECT
+private Q_SLOTS:
+    void testInit();
+    void testSlideIn();
+    void testSlideOut();
+    void testSlideInDeleteSlideOut();
+    void testHiddenContentResize();
+};
+
+#endif /* SLIDECONTAINERAUTOTEST_H */

=== added file 'tests/auto/sorteddirmodeltest.cpp'
--- tests/auto/sorteddirmodeltest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/sorteddirmodeltest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,77 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+// Self
+#include <sorteddirmodeltest.moc>
+
+// Local
+#include <testutils.h>
+#include <lib/semanticinfo/sorteddirmodel.h>
+
+// Qt
+
+// KDE
+#include <qtest_kde.h>
+#include <kdirlister.h>
+#include <ktempdir.h>
+
+using namespace Gwenview;
+
+QTEST_KDEMAIN(SortedDirModelTest, GUI)
+
+void SortedDirModelTest::initTestCase()
+{
+    mSandBoxDir.mkdir("empty_dir");
+    mSandBoxDir.mkdir("dirs_only");
+    mSandBoxDir.mkdir("dirs_only/dir1");
+    mSandBoxDir.mkdir("dirs_only/dir2");
+    mSandBoxDir.mkdir("dirs_and_docs");
+    mSandBoxDir.mkdir("dirs_and_docs/dir");
+    createEmptyFile(mSandBoxDir.absoluteFilePath("dirs_and_docs/file.png"));
+    mSandBoxDir.mkdir("docs_only");
+    createEmptyFile(mSandBoxDir.absoluteFilePath("docs_only/file.png"));
+}
+
+void SortedDirModelTest::testHasDocuments_data()
+{
+    QTest::addColumn<QString>("dir");
+    QTest::addColumn<bool>("hasDocuments");
+#define NEW_ROW(dir, hasDocuments) \
+    QTest::newRow(QString(dir).toLocal8Bit().data()) << mSandBoxDir.absoluteFilePath(dir) << hasDocuments
+    NEW_ROW("empty_dir", false);
+    NEW_ROW("dirs_only", false);
+    NEW_ROW("dirs_and_docs", true);
+    NEW_ROW("docs_only", true);
+#undef NEW_ROW
+}
+
+void SortedDirModelTest::testHasDocuments()
+{
+    QFETCH(QString, dir);
+    QFETCH(bool, hasDocuments);
+    KUrl url = KUrl::fromPath(dir);
+
+    SortedDirModel model;
+    QEventLoop loop;
+    connect(model.dirLister(), SIGNAL(completed()), &loop, SLOT(quit()));
+    model.dirLister()->openUrl(url);
+    loop.exec();
+    QCOMPARE(model.hasDocuments(), hasDocuments);
+}

=== added file 'tests/auto/sorteddirmodeltest.h'
--- tests/auto/sorteddirmodeltest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/sorteddirmodeltest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,45 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2011 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef SORTEDDIRMODELTEST_H
+#define SORTEDDIRMODELTEST_H
+
+// Local
+#include <testutils.h>
+
+// Qt
+#include <QObject>
+
+// std c++
+#include <memory>
+
+class SortedDirModelTest : public QObject
+{
+    Q_OBJECT
+private Q_SLOTS:
+    void initTestCase();
+    void testHasDocuments_data();
+    void testHasDocuments();
+
+private:
+    SandBoxDir mSandBoxDir;
+};
+
+#endif /* SORTEDDIRMODELTEST_H */

=== added file 'tests/auto/testutils.cpp'
--- tests/auto/testutils.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/testutils.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,80 @@
+/*
+Gwenview: an image viewer
+Copyright 2010 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include "testutils.h"
+
+// KDE
+#include <kdebug.h>
+#include <kio/deletejob.h>
+#include <kio/netaccess.h>
+#include <kio/job.h>
+
+static void rm_rf(const QString& pathOrUrl)
+{
+    KIO::Job* job = KIO::del(pathOrUrl, KIO::HideProgressInfo);
+    job->setUiDelegate(0);
+    KIO::NetAccess::synchronousRun(job, 0);
+}
+
+static bool mkdir(const QString& pathOrUrl)
+{
+    KIO::Job* job = KIO::mkdir(pathOrUrl, -1);
+    job->setUiDelegate(0);
+    return KIO::NetAccess::synchronousRun(job, 0);
+}
+
+static bool cp(const QString& src, const QString& _dst)
+{
+    KIO::Job* job = KIO::file_copy(src, _dst, -1, KIO::Overwrite | KIO::HideProgressInfo);
+    job->setUiDelegate(0);
+    return KIO::NetAccess::synchronousRun(job, 0);
+}
+
+KUrl setUpRemoteTestDir(const QString& testFile)
+{
+    if (!qgetenv("NO_REMOTE_TESTS").isEmpty()) {
+        kWarning() << "Remote tests disabled";
+        return KUrl();
+    }
+
+    QString testDir("/tmp/gwenview-remote-tests/");
+    rm_rf(testDir);
+
+    if (!mkdir(testDir)) {
+        kFatal() << "Could not create dir" << testDir;
+        return KUrl();
+    }
+
+    if (!testFile.isEmpty()) {
+        if (!cp(pathForTestFile(testFile), testDir + testFile)) {
+            kFatal() << "Could not copy" << testFile << "to" << testDir;
+            return KUrl();
+        }
+    }
+
+    return KUrl("sftp://localhost" + testDir);
+}
+
+void createEmptyFile(const QString& path)
+{
+    Q_ASSERT(!QFile::exists(path));
+    QFile file(path);
+    bool ok = file.open(QIODevice::WriteOnly);
+    Q_ASSERT(ok);
+}
\ No newline at end of file

=== added file 'tests/auto/testutils.h'
--- tests/auto/testutils.h	1970-01-01 00:00:00 +0000
+++ tests/auto/testutils.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,118 @@
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef TESTUTILS_H
+#define TESTUTILS_H
+
+#include <math.h>
+
+// Qt
+#include <QDir>
+#include <QImage>
+#include <QSignalSpy>
+#include <QTest>
+
+// KDE
+#include <kdebug.h>
+#include <ktempdir.h>
+#include <kurl.h>
+
+class SandBoxDir : public QDir
+{
+public:
+    SandBoxDir()
+        : mTempDir(QDir::currentPath() + "/sandbox-") {
+        setPath(mTempDir.name());
+    }
+
+private:
+    KTempDir mTempDir;
+};
+
+/*
+ * This file contains simple helpers to access test files
+ */
+
+inline QString pathForTestFile(const QString& name)
+{
+    return QDir::cleanPath(QString("%1/../data/%2").arg(KDESRCDIR).arg(name));
+}
+
+inline KUrl urlForTestFile(const QString& name)
+{
+    KUrl url;
+    url.setPath(pathForTestFile(name));
+    return url;
+}
+
+inline QString pathForTestOutputFile(const QString& name)
+{
+    return QString("%1/%2").arg(QDir::currentPath()).arg(name);
+}
+
+inline KUrl urlForTestOutputFile(const QString& name)
+{
+    KUrl url;
+    url.setPath(pathForTestOutputFile(name));
+    return url;
+}
+
+inline bool waitForSignal(const QSignalSpy& spy, int timeout = 5)
+{
+    for (int x = 0; x < timeout; ++x) {
+        if (spy.count() > 0) {
+            return true;
+        }
+        QTest::qWait(1000);
+    }
+    return false;
+}
+
+inline bool fuzzyImageCompare(const QImage& img1, const QImage& img2)
+{
+    if (img1.size() != img2.size()) {
+        kWarning() << "Different sizes" << img1.size() << img2.size();
+        return false;
+    }
+    if (img1.format() != img2.format()) {
+        kWarning() << "Different formats" << img1.format() << img2.format();
+        return false;
+    }
+
+    for (int posY = 0; posY < img1.height(); ++posY) {
+        for (int posX = 0; posX < img2.width(); ++posX) {
+            if (!(int)abs((double)img1.pixel(posX, posY) - img2.pixel(posX, posY)) > 2) {
+                kWarning() << "Different at" << QPoint(posX, posY);
+                return false;
+            }
+        }
+    }
+    return true;
+}
+
+void createEmptyFile(const QString& path);
+
+/**
+ * Returns the url of the remote url dir if remote test dir was successfully
+ * set up.
+ * If testFile is valid, it is copied into the test dir.
+ */
+KUrl setUpRemoteTestDir(const QString& testFile = QString());
+
+#endif /* TESTUTILS_H */

=== added file 'tests/auto/thumbnailloadjobtest.cpp'
--- tests/auto/thumbnailloadjobtest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/thumbnailloadjobtest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,222 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include "thumbnailloadjobtest.moc"
+
+// Qt
+#include <QDir>
+#include <QImage>
+#include <QPainter>
+
+// KDE
+#include <qtest_kde.h>
+#include <kdebug.h>
+#include <kio/copyjob.h>
+#include <kio/deletejob.h>
+
+// Local
+#include "../lib/imageformats/imageformats.h"
+#include "../lib/thumbnailloadjob.h"
+#include "testutils.h"
+
+using namespace Gwenview;
+
+QTEST_KDEMAIN(ThumbnailLoadJobTest, GUI)
+
+SandBox::SandBox()
+: mPath(QDir::currentPath() + "/sandbox")
+{}
+
+void SandBox::initDir()
+{
+    KIO::Job* job;
+    QDir dir(mPath);
+    if (dir.exists()) {
+        KUrl sandBoxUrl("file://" + mPath);
+        job = KIO::del(sandBoxUrl);
+        QVERIFY2(job->exec(), "Couldn't delete sandbox");
+    }
+    dir.mkpath(".");
+}
+
+void SandBox::fill()
+{
+    initDir();
+    createTestImage("red.png", 300, 200, Qt::red);
+    createTestImage("blue.png", 200, 300, Qt::blue);
+    createTestImage("small.png", 50, 50, Qt::green);
+
+    copyTestImage("orient6.jpg", 128, 256);
+    copyTestImage("orient6-small.jpg", 32, 64);
+}
+
+void SandBox::copyTestImage(const QString& testFileName, int width, int height)
+{
+    QString testPath = pathForTestFile(testFileName);
+    KIO::Job* job = KIO::copy(testPath, KUrl(mPath + '/' + testFileName));
+    QVERIFY2(job->exec(), "Couldn't copy test image");
+    mSizeHash.insert(testFileName, QSize(width, height));
+}
+
+static QImage createColoredImage(int width, int height, const QColor& color)
+{
+    QImage image(width, height, QImage::Format_RGB32);
+    QPainter painter(&image);
+    painter.fillRect(image.rect(), color);
+    return image;
+}
+
+void SandBox::createTestImage(const QString& name, int width, int height, const QColor& color)
+{
+    QImage image = createColoredImage(width, height, color);
+    image.save(mPath + '/' + name, "png");
+    mSizeHash.insert(name, QSize(width, height));
+}
+
+void ThumbnailLoadJobTest::initTestCase()
+{
+    qRegisterMetaType<KFileItem>("KFileItem");
+    Gwenview::ImageFormats::registerPlugins();
+}
+
+void ThumbnailLoadJobTest::init()
+{
+    ThumbnailLoadJob::setThumbnailBaseDir(mSandBox.mPath + "/thumbnails/");
+    mSandBox.fill();
+}
+
+void ThumbnailLoadJobTest::testLoadLocal()
+{
+    QDir dir(mSandBox.mPath);
+
+    // Create a list of items which will be thumbnailed
+    KFileItemList list;
+    Q_FOREACH(const QFileInfo & info, dir.entryInfoList(QDir::Files)) {
+        KUrl url("file://" + info.absoluteFilePath());
+        KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
+        list << item;
+    }
+
+    // Generate the thumbnails
+    QPointer<ThumbnailLoadJob> job = new ThumbnailLoadJob(list, ThumbnailGroup::Normal);
+    QSignalSpy spy(job, SIGNAL(thumbnailLoaded(KFileItem, QPixmap, QSize)));
+    // FIXME: job->exec() causes a double free(), so wait for the job to be
+    // deleted instead
+    //job->exec();
+    job->start();
+    while (job) {
+        QTest::qWait(100);
+    }
+
+    while (!ThumbnailLoadJob::isPendingThumbnailCacheEmpty()) {
+        QTest::qWait(100);
+    }
+
+    // Check we generated the correct number of thumbnails
+    QDir thumbnailDir = ThumbnailLoadJob::thumbnailBaseDir(ThumbnailGroup::Normal);
+    // There should be one file less because small.png is a png and is too
+    // small to have a thumbnail
+    QStringList entryList = thumbnailDir.entryList(QStringList("*.png"));
+    QCOMPARE(entryList.count(), mSandBox.mSizeHash.size() - 1);
+
+    // Check what was in the thumbnailLoaded() signals
+    QCOMPARE(spy.count(), mSandBox.mSizeHash.size());
+    QSignalSpy::ConstIterator it = spy.constBegin(),
+                              end = spy.constEnd();
+    for (; it != end; ++it) {
+        const QVariantList args = *it;
+        const KFileItem item = qvariant_cast<KFileItem>(args.at(0));
+        const QSize size = args.at(2).toSize();
+        const QSize expectedSize = mSandBox.mSizeHash.value(item.url().fileName());
+        QCOMPARE(size, expectedSize);
+    }
+}
+
+void ThumbnailLoadJobTest::testUseEmbeddedOrNot()
+{
+    QImage expectedThumbnail;
+    QPointer<ThumbnailLoadJob> job;
+    QPixmap thumbnailPix;
+    SandBox sandBox;
+    sandBox.initDir();
+    // This image is red and 256x128 but contains a white 128x64 thumbnail
+    sandBox.copyTestImage("embedded-thumbnail.jpg", 256, 128);
+
+    KFileItemList list;
+    KUrl url("file://" + QDir(sandBox.mPath).absoluteFilePath("embedded-thumbnail.jpg"));
+    list << KFileItem(KFileItem::Unknown, KFileItem::Unknown, url);
+
+    // Loading a normal thumbnail should bring the white one
+    job = new ThumbnailLoadJob(list, ThumbnailGroup::Normal);
+    QSignalSpy spy1(job, SIGNAL(thumbnailLoaded(KFileItem, QPixmap, QSize)));
+    // FIXME: job->exec() causes a double free(), so wait for the job to be
+    // deleted instead
+    //job->exec();
+    job->start();
+    while (job) {
+        QTest::qWait(100);
+    }
+
+    QCOMPARE(spy1.count(), 1);
+    expectedThumbnail = createColoredImage(128, 64, Qt::white);
+    thumbnailPix = qvariant_cast<QPixmap>(spy1.at(0).at(1));
+    fuzzyImageCompare(expectedThumbnail, thumbnailPix.toImage());
+
+    // Loading a large thumbnail should bring the red one
+    job = new ThumbnailLoadJob(list, ThumbnailGroup::Large);
+    QSignalSpy spy2(job, SIGNAL(thumbnailLoaded(KFileItem, QPixmap, QSize)));
+    job->start();
+    while (job) {
+        QTest::qWait(100);
+    }
+
+    QCOMPARE(spy2.count(), 1);
+    expectedThumbnail = createColoredImage(256, 128, Qt::red);
+    thumbnailPix = qvariant_cast<QPixmap>(spy2.at(0).at(1));
+    fuzzyImageCompare(expectedThumbnail, thumbnailPix.toImage());
+}
+
+void ThumbnailLoadJobTest::testLoadRemote()
+{
+    KUrl url = setUpRemoteTestDir("test.png");
+    if (!url.isValid()) {
+        return;
+    }
+    url.addPath("test.png");
+
+    KFileItemList list;
+    KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
+    list << item;
+
+    QPointer<ThumbnailLoadJob> job = new ThumbnailLoadJob(list, ThumbnailGroup::Normal);
+    // FIXME: job->exec() causes a double free(), so wait for the job to be
+    // deleted instead
+    //job->exec();
+    job->start();
+    while (job) {
+        QTest::qWait(100);
+    }
+    while (!ThumbnailLoadJob::isPendingThumbnailCacheEmpty()) {
+        QTest::qWait(100);
+    }
+
+    QDir thumbnailDir = ThumbnailLoadJob::thumbnailBaseDir(ThumbnailGroup::Normal);
+    QStringList entryList = thumbnailDir.entryList(QStringList("*.png"));
+    QCOMPARE(entryList.count(), 1);
+}

=== added file 'tests/auto/thumbnailloadjobtest.h'
--- tests/auto/thumbnailloadjobtest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/thumbnailloadjobtest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,57 @@
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef THUMBNAILLOADJOBTEST_H
+#define THUMBNAILLOADJOBTEST_H
+
+// Qt
+#include <QColor>
+#include <QHash>
+#include <QObject>
+#include <QSize>
+
+class SandBox
+{
+public:
+    SandBox();
+    void initDir();
+    void fill();
+    void createTestImage(const QString& name, int width, int height, const QColor& color);
+    void copyTestImage(const QString& name, int width, int height);
+
+    QHash<QString, QSize> mSizeHash;
+    QString mPath;
+};
+
+class ThumbnailLoadJobTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void init();
+    void initTestCase();
+    void testLoadLocal();
+    void testLoadRemote();
+    void testUseEmbeddedOrNot();
+
+private:
+    SandBox mSandBox;
+};
+
+#endif // THUMBNAILLOADJOBTEST_H

=== added file 'tests/auto/timeutilstest.cpp'
--- tests/auto/timeutilstest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/timeutilstest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,81 @@
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+
+#include "timeutilstest.moc"
+
+// libc
+#include <utime.h>
+
+// KDE
+#include <kfileitem.h>
+#include <ktemporaryfile.h>
+#include <qtest_kde.h>
+
+// Local
+#include "../lib/timeutils.h"
+
+#include "testutils.h"
+
+QTEST_KDEMAIN(TimeUtilsTest, GUI)
+
+using namespace Gwenview;
+
+static void touchFile(const QString& path)
+{
+    utime(QFile::encodeName(path).data(), 0);
+}
+
+void TimeUtilsTest::testPng()
+{
+    KUrl url = urlForTestFile("test.png");
+    KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
+    KDateTime dateTime = TimeUtils::dateTimeForFileItem(item);
+    QCOMPARE(dateTime, item.time(KFileItem::ModificationTime));
+}
+
+void TimeUtilsTest::testJpeg()
+{
+    KUrl url = urlForTestFile("orient6.jpg");
+    KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
+    KDateTime dateTime = TimeUtils::dateTimeForFileItem(item);
+
+    const KDateTime orient6DateTime = KDateTime::fromString("2003-03-25T02:02:21");
+    QCOMPARE(dateTime, orient6DateTime);
+}
+
+void TimeUtilsTest::testCache()
+{
+    KTemporaryFile tempFile;
+    QVERIFY(tempFile.open());
+    KUrl url = KUrl::fromLocalFile(tempFile.fileName());
+    KFileItem item1(KFileItem::Unknown, KFileItem::Unknown, url);
+    KDateTime dateTime1 = TimeUtils::dateTimeForFileItem(item1);
+    QCOMPARE(dateTime1, item1.time(KFileItem::ModificationTime));
+
+    QTest::qWait(1200);
+    touchFile(url.toLocalFile());
+
+    KFileItem item2(KFileItem::Unknown, KFileItem::Unknown, url);
+    KDateTime dateTime2 = TimeUtils::dateTimeForFileItem(item2);
+
+    QVERIFY(dateTime1 != dateTime2);
+
+    QCOMPARE(dateTime2, item2.time(KFileItem::ModificationTime));
+}

=== added file 'tests/auto/timeutilstest.h'
--- tests/auto/timeutilstest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/timeutilstest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,36 @@
+/*
+Gwenview: an image viewer
+Copyright 2008 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef TIMEUTILSTEST_H
+#define TIMEUTILSTEST_H
+
+// Qt
+#include <QObject>
+
+class TimeUtilsTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void testPng();
+    void testJpeg();
+    void testCache();
+};
+
+#endif /* TIMEUTILSTEST_H */

=== added file 'tests/auto/transformimageoperationtest.cpp'
--- tests/auto/transformimageoperationtest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/transformimageoperationtest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,69 @@
+/*
+Gwenview: an image viewer
+Copyright 2010 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+// Qt
+#include <QEventLoop>
+#include <QImage>
+
+// KDE
+#include <kdebug.h>
+#include <qtest_kde.h>
+
+// Local
+#include "../lib/document/documentfactory.h"
+#include "../lib/imageutils.h"
+#include "../lib/transformimageoperation.h"
+#include "testutils.h"
+
+#include "transformimageoperationtest.moc"
+
+QTEST_KDEMAIN(TransformImageOperationTest, GUI)
+
+using namespace Gwenview;
+
+void TransformImageOperationTest::initTestCase()
+{
+    qRegisterMetaType<KUrl>("KUrl");
+}
+
+void TransformImageOperationTest::init()
+{
+    DocumentFactory::instance()->clearCache();
+}
+
+void TransformImageOperationTest::testRotate90()
+{
+    KUrl url = urlForTestFile("test.png");
+    QImage image;
+
+    bool ok = image.load(url.toLocalFile());
+    QVERIFY2(ok, "Could not load 'test.png'");
+    QMatrix matrix = ImageUtils::transformMatrix(ROT_90);
+    image = image.transformed(matrix);
+
+    Document::Ptr doc = DocumentFactory::instance()->load(url);
+
+    TransformImageOperation* op = new TransformImageOperation(ROT_90);
+    QEventLoop loop;
+    connect(doc.data(), SIGNAL(allTasksDone()), &loop, SLOT(quit()));
+    op->applyToDocument(doc);
+    loop.exec();
+
+    QCOMPARE(image, doc->image());
+}

=== added file 'tests/auto/transformimageoperationtest.h'
--- tests/auto/transformimageoperationtest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/transformimageoperationtest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,39 @@
+/*
+Gwenview: an image viewer
+Copyright 2010 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef TRANSFORMIMAGEOPERATIONTEST_H
+#define TRANSFORMIMAGEOPERATIONTEST_H
+
+// Qt
+#include <QObject>
+
+// Local
+#include "../lib/document/document.h"
+
+class TransformImageOperationTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void testRotate90();
+    void initTestCase();
+    void init();
+};
+
+#endif // TRANSFORMIMAGEOPERATIONTEST_H

=== added file 'tests/auto/urlutilstest.cpp'
--- tests/auto/urlutilstest.cpp	1970-01-01 00:00:00 +0000
+++ tests/auto/urlutilstest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,56 @@
+/*
+Gwenview: an image viewer
+Copyright 2009 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#include "urlutilstest.moc"
+
+// Qt
+
+// KDE
+#include <kdebug.h>
+#include <qtest_kde.h>
+
+// Local
+#include "../lib/urlutils.h"
+
+QTEST_KDEMAIN(UrlUtilsTest, GUI)
+
+using namespace Gwenview;
+
+void UrlUtilsTest::testFixUserEnteredUrl()
+{
+    QFETCH(KUrl, in);
+    QFETCH(KUrl, expected);
+    KUrl out = UrlUtils::fixUserEnteredUrl(in);
+    QCOMPARE(out.url(), expected.url());
+}
+
+#define NEW_ROW(in, expected) QTest::newRow(QString(in).toLocal8Bit().data()) << KUrl(in) << KUrl(expected)
+void UrlUtilsTest::testFixUserEnteredUrl_data()
+{
+    QTest::addColumn<KUrl>("in");
+    QTest::addColumn<KUrl>("expected");
+
+    QString pwd = QDir::currentPath();
+
+    NEW_ROW("http://example.com", "http://example.com");
+    NEW_ROW("example.zip", "zip://" + pwd + "/example.zip");
+    NEW_ROW("file://" + pwd + "/example.zip", "zip://" + pwd + "/example.zip");
+    NEW_ROW("file://" + pwd + "/example.cbz", "zip://" + pwd + "/example.cbz");
+    NEW_ROW("file://" + pwd + "/example.jpg", "file://" + pwd + "/example.jpg");
+}

=== added file 'tests/auto/urlutilstest.h'
--- tests/auto/urlutilstest.h	1970-01-01 00:00:00 +0000
+++ tests/auto/urlutilstest.h	2011-12-15 14:17:54 +0000
@@ -0,0 +1,35 @@
+/*
+Gwenview: an image viewer
+Copyright 2009 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+#ifndef URLUTILSTEST_H
+#define URLUTILSTEST_H
+
+// Qt
+#include <QObject>
+
+class UrlUtilsTest : public QObject
+{
+    Q_OBJECT
+
+private Q_SLOTS:
+    void testFixUserEnteredUrl();
+    void testFixUserEnteredUrl_data();
+};
+
+#endif /* URLUTILSTEST_H */

=== added directory 'tests/data'
=== added file 'tests/data/160216_no_size_before_decoding.eps'
--- tests/data/160216_no_size_before_decoding.eps	1970-01-01 00:00:00 +0000
+++ tests/data/160216_no_size_before_decoding.eps	2011-12-15 14:17:54 +0000
@@ -0,0 +1,338 @@
+%!PS-Adobe-3.0 EPSF-3.0
+%%Creator: GIMP PostScript file plugin V 1.17 by Peter Kirchgessner
+%%Title: GwenviewCrashSample.eps
+%%CreationDate: Tue Apr  1 11:29:17 2008
+%%DocumentData: Clean7Bit
+%%LanguageLevel: 2
+%%Pages: 1
+%%BoundingBox: 14 14 115 115
+%%EndComments
+%%BeginProlog
+% Use own dictionary to avoid conflicts
+10 dict begin
+%%EndProlog
+%%Page: 1 1
+% Translate for offset
+14.173228346456694 14.173228346456694 translate
+% Translate to begin of first scanline
+0 99.999999999999986 translate
+99.999999999999986 -99.999999999999986 scale
+% Image geometry
+100 100 8
+% Transformation matrix
+[ 100 0 0 100 0 0 ]
+% Strings to hold RGB-samples per scanline
+/rstr 100 string def
+/gstr 100 string def
+/bstr 100 string def
+{currentfile /ASCII85Decode filter /RunLengthDecode filter rstr readstring pop}
+{currentfile /ASCII85Decode filter /RunLengthDecode filter gstr readstring pop}
+{currentfile /ASCII85Decode filter /RunLengthDecode filter bstr readstring pop}
+true 3
+%%BeginData:         2111 ASCII Bytes
+colorimage
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+SH+0~>
+SH+0~>
+Sc=3~>
+%%EndData
+showpage
+%%Trailer
+end
+%%EOF

=== added file 'tests/data/160382_corrupted.jpeg'
Binary files tests/data/160382_corrupted.jpeg and tests/data/160382_corrupted.jpeg differ
=== added file 'tests/data/185523_1frame_with_graphic_control_extension.gif'
Binary files tests/data/185523_1frame_with_graphic_control_extension.gif and tests/data/185523_1frame_with_graphic_control_extension.gif differ
=== added file 'tests/data/188191_does_not_load.tga'
Binary files tests/data/188191_does_not_load.tga and tests/data/188191_does_not_load.tga differ
=== added file 'tests/data/1frame.gif'
Binary files tests/data/1frame.gif and tests/data/1frame.gif differ
=== added file 'tests/data/1x10k.jpg'
Binary files tests/data/1x10k.jpg and tests/data/1x10k.jpg differ
=== added file 'tests/data/1x10k.png'
Binary files tests/data/1x10k.png and tests/data/1x10k.png differ
=== added file 'tests/data/40frames.gif'
Binary files tests/data/40frames.gif and tests/data/40frames.gif differ
=== added file 'tests/data/4frames.gif'
Binary files tests/data/4frames.gif and tests/data/4frames.gif differ
=== added file 'tests/data/embedded-thumbnail.jpg'
Binary files tests/data/embedded-thumbnail.jpg and tests/data/embedded-thumbnail.jpg differ
=== added file 'tests/data/empty.png'
=== added directory 'tests/data/import'
=== added file 'tests/data/import/pict0001.jpg'
Binary files tests/data/import/pict0001.jpg and tests/data/import/pict0001.jpg differ
=== added file 'tests/data/import/pict0002.jpg'
Binary files tests/data/import/pict0002.jpg and tests/data/import/pict0002.jpg differ
=== added file 'tests/data/import/pict0003.jpg'
Binary files tests/data/import/pict0003.jpg and tests/data/import/pict0003.jpg differ
=== added file 'tests/data/orient1_vflip.jpg'
Binary files tests/data/orient1_vflip.jpg and tests/data/orient1_vflip.jpg differ
=== added file 'tests/data/orient6-small.jpg'
Binary files tests/data/orient6-small.jpg and tests/data/orient6-small.jpg differ
=== added file 'tests/data/orient6.jpg'
Binary files tests/data/orient6.jpg and tests/data/orient6.jpg differ
=== added file 'tests/data/test.png'
Binary files tests/data/test.png and tests/data/test.png differ
=== added file 'tests/data/test.svg'
--- tests/data/test.svg	1970-01-01 00:00:00 +0000
+++ tests/data/test.svg	2011-12-15 14:17:54 +0000
@@ -0,0 +1,73 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="744.09448819"
+   height="1052.3622047"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.46"
+   sodipodi:docname="test.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape">
+  <defs
+     id="defs4">
+    <inkscape:perspective
+       sodipodi:type="inkscape:persp3d"
+       inkscape:vp_x="0 : 526.18109 : 1"
+       inkscape:vp_y="0 : 1000 : 0"
+       inkscape:vp_z="744.09448 : 526.18109 : 1"
+       inkscape:persp3d-origin="372.04724 : 350.78739 : 1"
+       id="perspective10" />
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="0.35"
+     inkscape:cx="375"
+     inkscape:cy="520"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     showgrid="false"
+     inkscape:window-width="640"
+     inkscape:window-height="703"
+     inkscape:window-x="632"
+     inkscape:window-y="69" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000;fill-opacity:1;stroke:#664010;stroke-width:2.4000001;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path2383"
+       sodipodi:cx="371.42856"
+       sodipodi:cy="440.93362"
+       sodipodi:rx="277.14285"
+       sodipodi:ry="285.71429"
+       d="M 648.57141,440.93362 A 277.14285,285.71429 0 1 1 94.285706,440.93362 A 277.14285,285.71429 0 1 1 648.57141,440.93362 z" />
+  </g>
+</svg>

=== added file 'tests/data/test.xcf'
Binary files tests/data/test.xcf and tests/data/test.xcf differ
=== removed directory 'tests/dirs_and_docs'
=== removed file 'tests/dirs_and_docs/test.png'
Binary files tests/dirs_and_docs/test.png and tests/dirs_and_docs/test.png differ
=== removed directory 'tests/docs_only'
=== removed file 'tests/docs_only/test.png'
Binary files tests/docs_only/test.png and tests/docs_only/test.png differ
=== removed file 'tests/documenttest.cpp'
--- tests/documenttest.cpp	2011-07-20 13:46:34 +0000
+++ tests/documenttest.cpp	1970-01-01 00:00:00 +0000
@@ -1,744 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-// Qt
-#include <QConicalGradient>
-#include <QImage>
-#include <QPainter>
-
-// KDE
-#include <kdebug.h>
-#include <kjobuidelegate.h>
-#include <kio/netaccess.h>
-#include <qtest_kde.h>
-
-// Local
-#include "../lib/abstractimageoperation.h"
-#include "../lib/document/abstractdocumenteditor.h"
-#include "../lib/document/documentjob.h"
-#include "../lib/document/documentfactory.h"
-#include "../lib/imagemetainfomodel.h"
-#include "../lib/imageutils.h"
-#include "../lib/transformimageoperation.h"
-#include "testutils.h"
-
-#include <exiv2/exif.hpp>
-
-#include "documenttest.moc"
-
-QTEST_KDEMAIN( DocumentTest, GUI )
-
-using namespace Gwenview;
-
-
-static void waitUntilMetaInfoLoaded(Document::Ptr doc) {
-	while (doc->loadingState() < Document::MetaInfoLoaded) {
-		QTest::qWait(100);
-	}
-}
-
-
-static bool waitUntilJobIsDone(DocumentJob* job) {
-	JobWatcher watcher(job);
-	watcher.wait();
-	return watcher.error() == KJob::NoError;
-}
-
-
-void DocumentTest::initTestCase() {
-	qRegisterMetaType<KUrl>("KUrl");
-}
-
-
-void DocumentTest::init() {
-	DocumentFactory::instance()->clearCache();
-}
-
-
-void DocumentTest::testLoad() {
-	QFETCH(QString, fileName);
-	QFETCH(QByteArray, expectedFormat);
-	QFETCH(int, expectedKindInt);
-	QFETCH(bool, expectedIsAnimated);
-	QFETCH(QImage, expectedImage);
-	MimeTypeUtils::Kind expectedKind = MimeTypeUtils::Kind(expectedKindInt);
-
-	KUrl url = urlForTestFile(fileName);
-	if (expectedKind != MimeTypeUtils::KIND_SVG_IMAGE) {
-		QVERIFY2(!expectedImage.isNull(), "Could not load test image");
-	}
-
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	QSignalSpy spy(doc.data(), SIGNAL(isAnimatedUpdated()));
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-	QCOMPARE(doc->loadingState(), Document::Loaded);
-
-	QCOMPARE(expectedKind, doc->kind());
-	QCOMPARE(expectedIsAnimated, doc->isAnimated());
-	QCOMPARE(spy.count(), doc->isAnimated() ? 1 : 0);
-	if (doc->kind() == MimeTypeUtils::KIND_RASTER_IMAGE) {
-		QCOMPARE(expectedImage, doc->image());
-		QCOMPARE(expectedFormat, doc->format());
-	}
-}
-
-#define NEW_ROW(fileName, format, kind, isAnimated) QTest::newRow(fileName) << fileName << QByteArray(format) << int(kind) << isAnimated << QImage(pathForTestFile(fileName))
-void DocumentTest::testLoad_data() {
-	QTest::addColumn<QString>("fileName");
-	QTest::addColumn<QByteArray>("expectedFormat");
-	QTest::addColumn<int>("expectedKindInt");
-	QTest::addColumn<bool>("expectedIsAnimated");
-	QTest::addColumn<QImage>("expectedImage");
-
-	NEW_ROW("test.png",
-	        "png", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-	NEW_ROW("160216_no_size_before_decoding.eps",
-	        "eps", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-	NEW_ROW("160382_corrupted.jpeg",
-	        "jpeg", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-	NEW_ROW("test.svg",
-	        "", MimeTypeUtils::KIND_SVG_IMAGE, false);
-	// FIXME: Test svgz
-	NEW_ROW("1x10k.png",
-	        "png", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-	NEW_ROW("1x10k.jpg",
-	        "jpeg", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-	NEW_ROW("4frames.gif",
-	        "gif", MimeTypeUtils::KIND_RASTER_IMAGE, true);
-	NEW_ROW("1frame.gif",
-	        "gif", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-	NEW_ROW("185523_1frame_with_graphic_control_extension.gif",
-	        "gif", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-	NEW_ROW("test.xcf",
-	        "xcf", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-	NEW_ROW("188191_does_not_load.tga",
-	        "tga", MimeTypeUtils::KIND_RASTER_IMAGE, false);
-}
-#undef NEW_ROW
-
-void DocumentTest::testLoadTwoPasses() {
-	KUrl url = urlForTestFile("test.png");
-	QImage image;
-	bool ok = image.load(url.toLocalFile());
-	QVERIFY2(ok, "Could not load 'test.png'");
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	waitUntilMetaInfoLoaded(doc);
-	QVERIFY2(doc->image().isNull(), "Image shouldn't have been loaded at this time");
-	QCOMPARE(doc->format().data(), "png");
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-	QCOMPARE(image, doc->image());
-}
-
-void DocumentTest::testLoadEmpty() {
-	KUrl url = urlForTestFile("empty.png");
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	while (doc->loadingState() <= Document::KindDetermined) {
-		QTest::qWait(100);
-	}
-	QCOMPARE(doc->loadingState(), Document::LoadingFailed);
-}
-
-#define NEW_ROW(fileName) QTest::newRow(fileName) << fileName
-void DocumentTest::testLoadDownSampled_data() {
-	QTest::addColumn<QString>("fileName");
-
-	NEW_ROW("orient6.jpg");
-	NEW_ROW("1x10k.jpg");
-}
-#undef NEW_ROW
-
-void DocumentTest::testLoadDownSampled() {
-	// Note: for now we only support down sampling on jpeg, do not use test.png
-	// here
-	QFETCH(QString, fileName);
-	KUrl url = urlForTestFile(fileName);
-	QImage image;
-	bool ok = image.load(url.toLocalFile());
-	QVERIFY2(ok, "Could not load test image");
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-
-	QSignalSpy downSampledImageReadySpy(doc.data(), SIGNAL(downSampledImageReady()));
-	QSignalSpy loadingFailedSpy(doc.data(), SIGNAL(loadingFailed(const KUrl&)));
-	QSignalSpy loadedSpy(doc.data(), SIGNAL(loaded(const KUrl&)));
-	bool ready = doc->prepareDownSampledImageForZoom(0.2);
-	QVERIFY2(!ready, "There should not be a down sampled image at this point");
-
-	while (downSampledImageReadySpy.count() == 0 && loadingFailedSpy.count() == 0 && loadedSpy.count() == 0) {
-		QTest::qWait(100);
-	}
-	QImage downSampledImage = doc->downSampledImageForZoom(0.2);
-	QVERIFY2(!downSampledImage.isNull(), "Down sampled image should not be null");
-
-	QSize expectedSize = doc->size() / 4;
-	if (expectedSize.isEmpty()) {
-		expectedSize = image.size();
-	}
-	QCOMPARE(downSampledImage.size(), expectedSize);
-}
-
-/**
- * Down sampling is not supported on png. We should get a complete image
- * instead.
- */
-void DocumentTest::testLoadDownSampledPng() {
-	KUrl url = urlForTestFile("test.png");
-	QImage image;
-	bool ok = image.load(url.toLocalFile());
-	QVERIFY2(ok, "Could not load test image");
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-
-	LoadingStateSpy stateSpy(doc);
-	connect(doc.data(), SIGNAL(loaded(const KUrl&)), &stateSpy, SLOT(readState()));
-
-	bool ready = doc->prepareDownSampledImageForZoom(0.2);
-	QVERIFY2(!ready, "There should not be a down sampled image at this point");
-
-	doc->waitUntilLoaded();
-
-	QCOMPARE(stateSpy.mCallCount, 1);
-	QCOMPARE(stateSpy.mState, Document::Loaded);
-}
-
-void DocumentTest::testLoadRemote() {
-	KUrl url = setUpRemoteTestDir("test.png");
-	if (!url.isValid()) {
-		return;
-	}
-	url.addPath("test.png");
-
-	QVERIFY2(KIO::NetAccess::exists(url, KIO::NetAccess::SourceSide, 0), "test url not found");
-
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-	QImage image = doc->image();
-	QCOMPARE(image.width(), 150);
-	QCOMPARE(image.height(), 100);
-}
-
-void DocumentTest::testLoadAnimated() {
-	KUrl srcUrl = urlForTestFile("40frames.gif");
-	Document::Ptr doc = DocumentFactory::instance()->load(srcUrl);
-	QSignalSpy spy(doc.data(), SIGNAL(imageRectUpdated(const QRect&)));
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-	QVERIFY(doc->isAnimated());
-
-	// Test we receive only one imageRectUpdated() until animation is started
-	// (the imageRectUpdated() is triggered by the loading of the first image)
-	QTest::qWait(1000);
-	QCOMPARE(spy.count(), 1);
-
-	// Test we now receive some imageRectUpdated()
-	doc->startAnimation();
-	QTest::qWait(1000);
-	int count = spy.count();
-	doc->stopAnimation();
-	QVERIFY2(count > 0, "No imageRectUpdated() signal received");
-
-	// Test we do not receive imageRectUpdated() anymore
-	QTest::qWait(1000);
-	QCOMPARE(count, spy.count());
-
-	// Start again, we should receive imageRectUpdated() again
-	doc->startAnimation();
-	QTest::qWait(1000);
-	QVERIFY2(spy.count() > count, "No imageRectUpdated() signal received after restarting");
-}
-
-void DocumentTest::testSaveRemote() {
-	KUrl dstUrl = setUpRemoteTestDir();
-	if (!dstUrl.isValid()) {
-		return;
-	}
-
-	KUrl srcUrl = urlForTestFile("test.png");
-	Document::Ptr doc = DocumentFactory::instance()->load(srcUrl);
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-
-	dstUrl.addPath("testSaveRemote.png");
-	QVERIFY(waitUntilJobIsDone(doc->save(dstUrl, "png")));
-}
-
-/**
- * Check that deleting a document while it is loading does not crash
- */
-void DocumentTest::testDeleteWhileLoading() {
-	{
-		KUrl url = urlForTestFile("test.png");
-		QImage image;
-		bool ok = image.load(url.toLocalFile());
-		QVERIFY2(ok, "Could not load 'test.png'");
-		Document::Ptr doc = DocumentFactory::instance()->load(url);
-	}
-	DocumentFactory::instance()->clearCache();
-	// Wait two seconds. If the test fails we will get a segfault while waiting
-	QTest::qWait(2000);
-}
-
-void DocumentTest::testLoadRotated() {
-	KUrl url = urlForTestFile("orient6.jpg");
-	QImage image;
-	bool ok = image.load(url.toLocalFile());
-	QVERIFY2(ok, "Could not load 'orient6.jpg'");
-	QMatrix matrix = ImageUtils::transformMatrix(ROT_90);
-	image = image.transformed(matrix);
-
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-	QCOMPARE(image, doc->image());
-}
-
-/**
- * Checks that asking the DocumentFactory the same document twice in a row does
- * not load it twice
- */
-void DocumentTest::testMultipleLoads() {
-	KUrl url = urlForTestFile("orient6.jpg");
-	Document::Ptr doc1 = DocumentFactory::instance()->load(url);
-	Document::Ptr doc2 = DocumentFactory::instance()->load(url);
-
-	QCOMPARE(doc1.data(), doc2.data());
-}
-
-void DocumentTest::testSaveAs() {
-	KUrl url = urlForTestFile("orient6.jpg");
-	DocumentFactory* factory = DocumentFactory::instance();
-	Document::Ptr doc = factory->load(url);
-	QSignalSpy savedSpy(doc.data(), SIGNAL(saved(const KUrl&, const KUrl&)));
-	QSignalSpy modifiedDocumentListChangedSpy(factory, SIGNAL(modifiedDocumentListChanged()));
-	QSignalSpy documentChangedSpy(factory, SIGNAL(documentChanged(const KUrl&)));
-	doc->startLoadingFullImage();
-
-	KUrl destUrl = urlForTestOutputFile("result.png");
-	QVERIFY(waitUntilJobIsDone(doc->save(destUrl, "png")));
-	QCOMPARE(doc->format().data(), "png");
-	QCOMPARE(doc->url(), destUrl);
-	QCOMPARE(doc->metaInfo()->getValueForKey("General.Name"), destUrl.fileName());
-
-	QVERIFY2(doc->loadingState() == Document::Loaded,
-		"Document is supposed to finish loading before saving"
-		);
-	
-	QTest::qWait(100); // saved() is emitted asynchronously
-	QCOMPARE(savedSpy.count(), 1);
-	QVariantList args = savedSpy.takeFirst();
-	QCOMPARE(args.at(0).value<KUrl>(), url);
-	QCOMPARE(args.at(1).value<KUrl>(), destUrl);
-
-	QImage image("result.png", "png");
-	QCOMPARE(doc->image(), image);
-
-	QVERIFY(!DocumentFactory::instance()->hasUrl(url));
-	QVERIFY(DocumentFactory::instance()->hasUrl(destUrl));
-
-	QCOMPARE(modifiedDocumentListChangedSpy.count(), 0); // No changes were made
-
-	QCOMPARE(documentChangedSpy.count(), 1);
-	args = documentChangedSpy.takeFirst();
-	QCOMPARE(args.at(0).value<KUrl>(), destUrl);
-}
-
-void DocumentTest::testLosslessSave() {
-	KUrl url1 = urlForTestFile("orient6.jpg");
-	Document::Ptr doc = DocumentFactory::instance()->load(url1);
-	doc->startLoadingFullImage();
-
-	KUrl url2 = urlForTestOutputFile("orient1.jpg");
-	QVERIFY(waitUntilJobIsDone(doc->save(url2, "jpeg")));
-
-	QImage image1;
-	QVERIFY(image1.load(url1.toLocalFile()));
-
-	QImage image2;
-	QVERIFY(image2.load(url2.toLocalFile()));
-
-	QCOMPARE(image1, image2);
-}
-
-void DocumentTest::testLosslessRotate() {
-	// Generate test image
-	QImage image1(200, 96, QImage::Format_RGB32);
-	{
-		QPainter painter(&image1);
-		QConicalGradient gradient(QPointF(100, 48), 100);
-		gradient.setColorAt(0, Qt::white);
-		gradient.setColorAt(1, Qt::blue);
-		painter.fillRect(image1.rect(), gradient);
-	}
-
-	KUrl url1 = urlForTestOutputFile("lossless1.jpg");
-	QVERIFY(image1.save(url1.toLocalFile(), "jpeg"));
-
-	// Load it as a Gwenview document
-	Document::Ptr doc = DocumentFactory::instance()->load(url1);
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-
-	// Rotate one time
-	QVERIFY(doc->editor());
-	doc->editor()->applyTransformation(ROT_90);
-
-	// Save it
-	KUrl url2 = urlForTestOutputFile("lossless2.jpg");
-	waitUntilJobIsDone(doc->save(url2, "jpeg"));
-
-	// Load the saved image
-	doc = DocumentFactory::instance()->load(url2);
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-
-	// Rotate the other way
-	QVERIFY(doc->editor());
-	doc->editor()->applyTransformation(ROT_270);
-	waitUntilJobIsDone(doc->save(url2, "jpeg"));
-
-	// Compare the saved images
-	QVERIFY(image1.load(url1.toLocalFile()));
-	QImage image2;
-	QVERIFY(image2.load(url2.toLocalFile()));
-
-	QCOMPARE(image1, image2);
-}
-
-void DocumentTest::testModifyAndSaveAs() {
-	QVariantList args;
-	class TestOperation : public AbstractImageOperation {
-	public:
-		void redo() {
-			QImage image(10, 10, QImage::Format_ARGB32);
-			image.fill(QColor(Qt::white).rgb());
-			document()->editor()->setImage(image);
-			finish(true);
-		}
-	};
-	KUrl url = urlForTestFile("orient6.jpg");
-	DocumentFactory* factory = DocumentFactory::instance();
-	Document::Ptr doc = factory->load(url);
-
-	QSignalSpy savedSpy(doc.data(), SIGNAL(saved(const KUrl&, const KUrl&)));
-	QSignalSpy modifiedDocumentListChangedSpy(factory, SIGNAL(modifiedDocumentListChanged()));
-	QSignalSpy documentChangedSpy(factory, SIGNAL(documentChanged(const KUrl&)));
-
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-	QVERIFY(!doc->isModified());
-	QCOMPARE(modifiedDocumentListChangedSpy.count(), 0);
-
-	// Modify image
-	QVERIFY(doc->editor());
-	TestOperation* op = new TestOperation;
-	op->applyToDocument(doc);
-	QVERIFY(doc->isModified());
-	QCOMPARE(modifiedDocumentListChangedSpy.count(), 1);
-	modifiedDocumentListChangedSpy.clear();
-	QList<KUrl> lst = factory->modifiedDocumentList();
-	QCOMPARE(lst.count(), 1);
-	QCOMPARE(lst.first(), url);
-	QCOMPARE(documentChangedSpy.count(), 1);
-	args = documentChangedSpy.takeFirst();
-	QCOMPARE(args.at(0).value<KUrl>(), url);
-
-	// Save it under a new name
-	KUrl destUrl = urlForTestOutputFile("modify.png");
-	QVERIFY(waitUntilJobIsDone(doc->save(destUrl, "png")));
-
-	// Wait a bit because save() will clear the undo stack when back to the
-	// event loop
-	QTest::qWait(100);
-	QVERIFY(!doc->isModified());
-
-	QVERIFY(!factory->hasUrl(url));
-	QVERIFY(factory->hasUrl(destUrl));
-	QCOMPARE(modifiedDocumentListChangedSpy.count(), 1);
-	QVERIFY(DocumentFactory::instance()->modifiedDocumentList().isEmpty());
-
-	QCOMPARE(documentChangedSpy.count(), 2);
-	KUrl::List modifiedUrls = KUrl::List() << url << destUrl;
-	QVERIFY(modifiedUrls.contains(url));
-	QVERIFY(modifiedUrls.contains(destUrl));
-}
-
-void DocumentTest::testMetaInfoJpeg() {
-	KUrl url = urlForTestFile("orient6.jpg");
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-
-	// We cleared the cache, so the document should not be loaded
-	Q_ASSERT(doc->loadingState() <= Document::KindDetermined);
-
-	// Wait until we receive the metaInfoUpdated() signal
-	QSignalSpy metaInfoUpdatedSpy(doc.data(), SIGNAL(metaInfoUpdated()));
-	while (metaInfoUpdatedSpy.count() == 0) {
-		QTest::qWait(100);
-	}
-
-	// Extract an exif key
-	QString value = doc->metaInfo()->getValueForKey("Exif.Image.Make");
-	QCOMPARE(value, QString::fromUtf8("Canon"));
-}
-
-
-void DocumentTest::testMetaInfoBmp() {
-	KUrl url = urlForTestOutputFile("metadata.bmp");
-	const int width = 200;
-	const int height = 100;
-	QImage image(width, height, QImage::Format_ARGB32);
-	image.fill(Qt::black);
-	image.save(url.toLocalFile(), "BMP");
-
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	QSignalSpy metaInfoUpdatedSpy(doc.data(), SIGNAL(metaInfoUpdated()));
-	waitUntilMetaInfoLoaded(doc);
-
-	Q_ASSERT(metaInfoUpdatedSpy.count() >= 1);
-
-	QString value = doc->metaInfo()->getValueForKey("General.ImageSize");
-	QString expectedValue = QString("%1x%2").arg(width).arg(height);
-	QCOMPARE(value, expectedValue);
-}
-
-
-void DocumentTest::testForgetModifiedDocument() {
-	QSignalSpy spy(DocumentFactory::instance(), SIGNAL(modifiedDocumentListChanged()));
-	DocumentFactory::instance()->forget(KUrl("file://does/not/exist.png"));
-	QCOMPARE(spy.count(), 0);
-
-	// Generate test image
-	QImage image1(200, 96, QImage::Format_RGB32);
-	{
-		QPainter painter(&image1);
-		QConicalGradient gradient(QPointF(100, 48), 100);
-		gradient.setColorAt(0, Qt::white);
-		gradient.setColorAt(1, Qt::blue);
-		painter.fillRect(image1.rect(), gradient);
-	}
-
-	KUrl url = urlForTestOutputFile("testForgetModifiedDocument.png");
-	QVERIFY(image1.save(url.toLocalFile(), "png"));
-
-	// Load it as a Gwenview document
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-
-	// Modify it
-	TransformImageOperation* op = new TransformImageOperation(ROT_90);
-	op->applyToDocument(doc);
-	QTest::qWait(100);
-
-	QCOMPARE(spy.count(), 1);
-
-	QList<KUrl> lst = DocumentFactory::instance()->modifiedDocumentList();
-	QCOMPARE(lst.length(), 1);
-	QCOMPARE(lst.first(), url);
-
-	// Forget it
-	DocumentFactory::instance()->forget(url);
-
-	QCOMPARE(spy.count(), 2);
-	lst = DocumentFactory::instance()->modifiedDocumentList();
-	QVERIFY(lst.isEmpty());
-}
-
-
-void DocumentTest::testModifiedAndSavedSignals() {
-	TransformImageOperation* op;
-
-	KUrl url = urlForTestFile("orient6.jpg");
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	QSignalSpy modifiedSpy(doc.data(), SIGNAL(modified(const KUrl&)));
-	QSignalSpy savedSpy(doc.data(), SIGNAL(saved(const KUrl&, const KUrl&)));
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-
-	QCOMPARE(modifiedSpy.count(), 0);
-	QCOMPARE(savedSpy.count(), 0);
-
-	op = new TransformImageOperation(ROT_90);
-	op->applyToDocument(doc);
-	QTest::qWait(100);
-	QCOMPARE(modifiedSpy.count(), 1);
-
-	op = new TransformImageOperation(ROT_90);
-	op->applyToDocument(doc);
-	QTest::qWait(100);
-	QCOMPARE(modifiedSpy.count(), 2);
-
-	doc->undoStack()->undo();
-	QCOMPARE(modifiedSpy.count(), 3);
-
-	doc->undoStack()->undo();
-	QCOMPARE(savedSpy.count(), 1);
-}
-
-class TestJob : public DocumentJob {
-public:
-	TestJob(QString* str, char ch)
-	: mStr(str)
-	, mCh(ch)
-	{}
-
-protected:
-	virtual void doStart() {
-		*mStr += mCh;
-		emitResult();
-	}
-
-private:
-	QString* mStr;
-	char mCh;
-};
-
-void DocumentTest::testJobQueue() {
-	KUrl url = urlForTestFile("orient6.jpg");
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-	QSignalSpy spy(doc.data(), SIGNAL(busyChanged(const KUrl&, bool)));
-
-	QString str;
-	doc->enqueueJob(new TestJob(&str, 'a'));
-	doc->enqueueJob(new TestJob(&str, 'b'));
-	doc->enqueueJob(new TestJob(&str, 'c'));
-	QVERIFY(doc->isBusy());
-	QEventLoop loop;
-	connect(doc.data(), SIGNAL(allTasksDone()),
-		&loop, SLOT(quit()));
-	loop.exec();
-	QVERIFY(!doc->isBusy());
-	QCOMPARE(spy.count(), 2);
-	QVariantList row = spy.takeFirst();
-	QCOMPARE(row.at(0).value<KUrl>(), url);
-	QVERIFY(row.at(1).toBool());
-	row = spy.takeFirst();
-	QCOMPARE(row.at(0).value<KUrl>(), url);
-	QVERIFY(!row.at(1).toBool());
-	QCOMPARE(str, QString("abc"));
-}
-
-
-class TestCheckDocumentEditorJob : public DocumentJob {
-public:
-	TestCheckDocumentEditorJob(int* hasEditor)
-	: mHasEditor(hasEditor)
-	{
-		*mHasEditor = -1;
-	}
-
-protected:
-	virtual void doStart() {
-		document()->waitUntilLoaded();
-		*mHasEditor = checkDocumentEditor() ? 1 : 0;
-		emitResult();
-	}
-
-private:
-	int* mHasEditor;
-};
-
-class TestUiDelegate : public KJobUiDelegate {
-public:
-	TestUiDelegate(bool* showErrorMessageCalled)
-	: mShowErrorMessageCalled(showErrorMessageCalled)
-	{
-		setAutoErrorHandlingEnabled(true);
-		*mShowErrorMessageCalled = false;
-	}
-
-	virtual void showErrorMessage() {
-		kDebug();
-		*mShowErrorMessageCalled = true;
-	}
-
-private:
-	bool* mShowErrorMessageCalled;
-};
-
-/**
- * Test that an error is reported when a DocumentJob fails because there is no
- * document editor available
- */
-void DocumentTest::testCheckDocumentEditor() {
-	int hasEditor;
-	bool showErrorMessageCalled;
-	QEventLoop loop;
-	Document::Ptr doc;
-	TestCheckDocumentEditorJob* job;
-
-	doc = DocumentFactory::instance()->load(urlForTestFile("orient6.jpg"));
-
-	job = new TestCheckDocumentEditorJob(&hasEditor);
-	job->setUiDelegate(new TestUiDelegate(&showErrorMessageCalled));
-	doc->enqueueJob(job);
-	connect(doc.data(), SIGNAL(allTasksDone()), &loop, SLOT(quit()));
-	loop.exec();
-	QVERIFY(!showErrorMessageCalled);
-	QCOMPARE(hasEditor, 1);
-
-	doc = DocumentFactory::instance()->load(urlForTestFile("test.svg"));
-
-	job = new TestCheckDocumentEditorJob(&hasEditor);
-	job->setUiDelegate(new TestUiDelegate(&showErrorMessageCalled));
-	doc->enqueueJob(job);
-	connect(doc.data(), SIGNAL(allTasksDone()), &loop, SLOT(quit()));
-	loop.exec();
-	QVERIFY(showErrorMessageCalled);
-	QCOMPARE(hasEditor, 0);
-}
-
-
-/**
- * An operation should only pushed to the document undo stack if it succeed
- */
-void DocumentTest::testUndoStackPush() {
-	class SuccessOperation : public AbstractImageOperation {
-	protected:
-		virtual void redo() {
-			QMetaObject::invokeMethod(this, "finish", Qt::QueuedConnection, Q_ARG(bool, true));
-		}
-	};
-
-	class FailureOperation : public AbstractImageOperation {
-	protected:
-		virtual void redo() {
-			QMetaObject::invokeMethod(this, "finish", Qt::QueuedConnection, Q_ARG(bool, false));
-		}
-	};
-
-	AbstractImageOperation* op;
-	Document::Ptr doc = DocumentFactory::instance()->load(urlForTestFile("orient6.jpg"));
-
-	// A successful operation should be added to the undo stack
-	op = new SuccessOperation;
-	op->applyToDocument(doc);
-	QTest::qWait(100);
-	QVERIFY(!doc->undoStack()->isClean());
-
-	// Reset
-	doc->undoStack()->undo();
-	QVERIFY(doc->undoStack()->isClean());
-
-	// A failed operation should not be added to the undo stack
-	op = new FailureOperation;
-	op->applyToDocument(doc);
-	QTest::qWait(100);
-	QVERIFY(doc->undoStack()->isClean());
-}

=== removed file 'tests/documenttest.h'
--- tests/documenttest.h	2011-07-20 13:46:34 +0000
+++ tests/documenttest.h	1970-01-01 00:00:00 +0000
@@ -1,130 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef DOCUMENTTEST_H
-#define DOCUMENTTEST_H
-
-// Qt
-#include <QObject>
-
-// KDE
-#include <kjob.h>
-
-// Local
-#include "../lib/document/document.h"
-
-class LoadingStateSpy : public QObject {
-	Q_OBJECT
-public:
-	LoadingStateSpy(const Gwenview::Document::Ptr& doc)
-	: mDocument(doc)
-	, mCallCount(0)
-	{
-	}
-
-public Q_SLOTS:
-	void readState() {
-		mCallCount++;
-		mState = mDocument->loadingState();
-	}
-
-public:
-	Gwenview::Document::Ptr mDocument;
-	int mCallCount;
-	Gwenview::Document::LoadingState mState;
-};
-
-
-class JobWatcher : public QObject {
-	Q_OBJECT
-public:
-	JobWatcher(KJob* job)
-	: mJob(job)
-	, mDone(false)
-	, mError(0)
-	{
-		connect(job, SIGNAL(result(KJob*)),
-			SLOT(slotResult(KJob*)));
-		connect(job, SIGNAL(destroyed(QObject*)),
-			SLOT(slotDestroyed()));
-	}
-
-	void wait() {
-		while (!mDone) {
-			QApplication::processEvents();
-		}
-	}
-
-	int error() const {
-		return mError;
-	}
-
-private Q_SLOTS:
-	void slotResult(KJob* job) {
-		mError = job->error();
-		mDone = true;
-	}
-
-	void slotDestroyed() {
-		kWarning() << "Destroyed";
-		mError = -1;
-		mDone = true;
-	}
-
-private:
-	KJob* mJob;
-	bool mDone;
-	int mError;
-};
-
-
-class DocumentTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void testLoad();
-	void testLoad_data();
-	void testLoadTwoPasses();
-	void testLoadEmpty();
-	void testLoadDownSampled();
-	void testLoadDownSampled_data();
-	void testLoadDownSampledPng();
-	void testLoadRemote();
-	void testLoadAnimated();
-	void testDeleteWhileLoading();
-	void testLoadRotated();
-	void testMultipleLoads();
-	void testSaveAs();
-	void testSaveRemote();
-	void testLosslessSave();
-	void testLosslessRotate();
-	void testModifyAndSaveAs();
-	void testMetaInfoJpeg();
-	void testMetaInfoBmp();
-	void testForgetModifiedDocument();
-	void testModifiedAndSavedSignals();
-	void testJobQueue();
-	void testCheckDocumentEditor();
-	void testUndoStackPush();
-
-	void initTestCase();
-	void init();
-};
-
-#endif // DOCUMENTTEST_H

=== removed file 'tests/embedded-thumbnail.jpg'
Binary files tests/embedded-thumbnail.jpg and tests/embedded-thumbnail.jpg differ
=== removed file 'tests/empty.png'
=== removed file 'tests/historymodeltest.cpp'
--- tests/historymodeltest.cpp	2011-07-20 13:46:34 +0000
+++ tests/historymodeltest.cpp	1970-01-01 00:00:00 +0000
@@ -1,115 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2009 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "historymodeltest.moc"
-
-// Qt
-#include <QDir>
-
-// KDE
-#include <kdebug.h>
-#include <kfileplacesmodel.h>
-#include <ktempdir.h>
-#include <qtest_kde.h>
-
-// Local
-#include "../lib/historymodel.h"
-
-QTEST_KDEMAIN(HistoryModelTest, GUI)
-
-using namespace Gwenview;
-
-void testModel(const HistoryModel& model, const KUrl& u1, const KUrl& u2) {
-	QModelIndex index;
-	KUrl url;
-	QCOMPARE(model.rowCount(), 2);
-
-	index = model.index(0, 0);
-	QVERIFY(index.isValid());
-	url = model.data(index, KFilePlacesModel::UrlRole).value<QUrl>();
-	QCOMPARE(url, u1);
-
-	index = model.index(1, 0);
-	QVERIFY(index.isValid());
-	url = model.data(index, KFilePlacesModel::UrlRole).value<QUrl>();
-	QCOMPARE(url, u2);
-
-}
-
-void HistoryModelTest::testAddUrl() {
-	KUrl u1 = KUrl::fromPath("/home");
-	QDateTime d1 = QDateTime::fromString("2008-02-03T12:34:56", Qt::ISODate);
-	KUrl u2 = KUrl::fromPath("/root");
-	QDateTime d2 = QDateTime::fromString("2009-01-29T23:01:47", Qt::ISODate);
-	KTempDir dir;
-	{
-		HistoryModel model(0, dir.name());
-		model.addUrl(u1, d1);
-		model.addUrl(u2, d2);
-		testModel(model, u2, u1);
-	}
-
-	HistoryModel model(0, dir.name());
-	testModel(model, u2, u1);
-
-	// Make u1 the most recent
-	QDateTime d3 = QDateTime::fromString("2009-03-24T22:42:15", Qt::ISODate);
-	model.addUrl(u1, d3);
-	testModel(model, u1, u2);
-}
-
-void HistoryModelTest::testGarbageCollect() {
-	KUrl u1 = KUrl::fromPath("/home");
-	QDateTime d1 = QDateTime::fromString("2008-02-03T12:34:56", Qt::ISODate);
-	KUrl u2 = KUrl::fromPath("/root");
-	QDateTime d2 = QDateTime::fromString("2009-01-29T23:01:47", Qt::ISODate);
-	KUrl u3 = KUrl::fromPath("/usr");
-	QDateTime d3 = QDateTime::fromString("2009-03-24T22:42:15", Qt::ISODate);
-
-	KTempDir dir;
-	{
-		HistoryModel model(0, dir.name(), 2);
-		model.addUrl(u1, d1);
-		model.addUrl(u2, d2);
-		testModel(model, u2, u1);
-		model.addUrl(u3, d3);
-	}
-
-	// Create a model with a larger history so that if garbage collecting fails
-	// to remove the collected url, the size of the model won't pass
-	// testModel()
-	HistoryModel model(0, dir.name(), 10);
-	testModel(model, u3, u2);
-}
-
-void HistoryModelTest::testRemoveRows() {
-	KUrl u1 = KUrl::fromPath("/home");
-	QDateTime d1 = QDateTime::fromString("2008-02-03T12:34:56", Qt::ISODate);
-	KUrl u2 = KUrl::fromPath("/root");
-	QDateTime d2 = QDateTime::fromString("2009-01-29T23:01:47", Qt::ISODate);
-
-	KTempDir dir;
-	HistoryModel model(0, dir.name(), 2);
-	model.addUrl(u1, d1);
-	model.addUrl(u2, d2);
-	model.removeRows(0, 1);
-	QCOMPARE(model.rowCount(), 1);
-	QDir qDir(dir.name());
-	QCOMPARE(qDir.entryList(QDir::Files | QDir::NoDotAndDotDot).count(), 1);
-}

=== removed file 'tests/historymodeltest.h'
--- tests/historymodeltest.h	2011-07-20 13:46:34 +0000
+++ tests/historymodeltest.h	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2009 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef HISTORYMODELTEST_H
-#define HISTORYMODELTEST_H
-
-// Qt
-#include <QObject>
-
-class HistoryModelTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void testAddUrl();
-	void testGarbageCollect();
-	void testRemoveRows();
-};
-
-#endif /* HISTORYMODELTEST_H */

=== removed file 'tests/imageloadbench.cpp'
--- tests/imageloadbench.cpp	2011-07-20 13:46:34 +0000
+++ tests/imageloadbench.cpp	1970-01-01 00:00:00 +0000
@@ -1,61 +0,0 @@
-#include <QBuffer>
-#include <QCoreApplication>
-#include <QDebug>
-#include <QFile>
-#include <QImage>
-#include <QImageReader>
-#include <QTime>
-
-#include <lib/imageformats/imageformats.h>
-
-const int ITERATIONS = 2;
-const QSize SCALED_SIZE(1280, 800);
-
-
-static void bench(QIODevice* device, const QString& outputName) {
-	QTime chrono;
-	chrono.start();
-	for (int iteration=0; iteration<ITERATIONS; ++iteration) {
-		qDebug() << "Iteration:" << iteration;
-
-		device->open(QIODevice::ReadOnly);
-		QImageReader reader(device);
-		QSize size = reader.size();
-		size.scale(SCALED_SIZE, Qt::KeepAspectRatio);
-		reader.setScaledSize(size);
-		QImage img = reader.read();
-		device->close();
-
-		if (iteration == ITERATIONS - 1) {
-			qDebug() << "time:" << chrono.elapsed();
-			img.save(outputName, "png");
-		}
-	}
-}
-
-
-int main(int argc, char** argv) {
-	QCoreApplication app(argc, argv);
-	if (argc != 2) {
-		qDebug() << "Usage: imageloadbench <file.jpg>";
-		return 1;
-	}
-
-	QString fileName = QString::fromUtf8(argv[1]);
-
-	QFile file(fileName);
-	if (!file.open(QIODevice::ReadOnly)) {
-		qDebug() << QString("Could not open '%1'").arg(fileName);
-		return 2;
-	}
-	QByteArray data = file.readAll();
-	QBuffer buffer(&data);
-
-	qDebug() << "Using Qt loader";
-	bench(&buffer, "qt.png");
-	Gwenview::ImageFormats::registerPlugins();
-	qDebug() << "Using Gwenview loader";
-	bench(&buffer, "gv.png");
-
-	return 0;
-}

=== removed file 'tests/imagescalertest.cpp'
--- tests/imagescalertest.cpp	2011-07-20 13:46:34 +0000
+++ tests/imagescalertest.cpp	1970-01-01 00:00:00 +0000
@@ -1,215 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include <qtest_kde.h>
-
-#include "imagescalertest.moc"
-
-#include "../lib/imagescaler.h"
-#include "../lib/document/documentfactory.h"
-
-#include "testutils.h"
-
-QTEST_KDEMAIN( ImageScalerTest, GUI )
-
-using namespace Gwenview;
-
-
-static void waitUntilMetaInfoLoaded(Document::Ptr doc) {
-	while (doc->loadingState() < Document::MetaInfoLoaded) {
-		QTest::qWait(100);
-	}
-}
-
-
-/**
- * Scale whole image in one pass
- */
-void ImageScalerTest::testScaleFullImage() {
-	const qreal zoom = 2;
-	KUrl url = urlForTestFile("test.png");
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-
-	ImageScaler scaler;
-	ImageScalerClient client(&scaler);
-	scaler.setDocument(doc);
-	scaler.setZoom(zoom);
-
-	// FIXME: Load full image for now, because ImageScalerClient does not wait
-	// when ImageScaler request a full image to be loaded asynchronously.
-	doc->startLoadingFullImage();
-	doc->waitUntilLoaded();
-
-	scaler.setDestinationRegion(QRect(QPoint(0,0), doc->size() * zoom));
-
-	QImage scaledImage = client.createFullImage();
-	QCOMPARE(doc->loadingState(), Document::Loaded);
-
-	QImage expectedImage = doc->image().scaled( doc->size() * zoom);
-	QCOMPARE(scaledImage, expectedImage);
-}
-
-
-#if 0
-/**
- * Scale parts of an image
- * In this test, the result image should be missing its bottom-right corner
- */
-void ImageScalerTest::testScalePartialImage() {
-	QImage image(10, 10, QImage::Format_ARGB32);
-	const int zoom = 2;
-	{
-		QPainter painter(&image);
-		painter.fillRect(image.rect(), Qt::white);
-		painter.drawText(0, image.height(), "X");
-	}
-
-	Gwenview::ImageScaler scaler;
-	ImageScalerClient client(&scaler);
-	scaler.setImage(&image);
-	scaler.setZoom(zoom);
-	QRegion region;
-	region |= QRect(
-		0, 0,
-		image.width() * zoom / 2, image.height() * zoom);
-
-	region |= QRect(
-		0, 0,
-		image.width() * zoom, image.height() * zoom / 2);
-	scaler.setDestinationRegion(region);
-
-	QImage expectedImage(image.size() * zoom, image.format());
-	expectedImage.fill(0);
-	{
-		QPainter painter(&expectedImage);
-		QImage tmp;
-		tmp= image.copy(0, 0,
-			expectedImage.width() / zoom / 2,
-			expectedImage.height() / zoom);
-		painter.drawImage(0, 0, tmp.scaled(tmp.size() * zoom));
-		tmp= image.copy(0, 0,
-			expectedImage.width() / zoom,
-			expectedImage.height() / zoom / 2);
-		painter.drawImage(0, 0, tmp.scaled(tmp.size() * zoom));
-	}
-
-	QImage scaledImage = client.createFullImage();
-
-	QCOMPARE(scaledImage, expectedImage);
-}
-
-
-
-/**
- * Scale whole image in two passes, not using exact pixel boundaries
- */
-void ImageScalerTest::testScaleFullImageTwoPasses() {
-	QFETCH(qreal, zoom);
-	QImage image(10, 10, QImage::Format_ARGB32);
-	{
-		QPainter painter(&image);
-		painter.fillRect(image.rect(), Qt::white);
-		painter.drawLine(0, 0, image.width(), image.height());
-	}
-
-	Gwenview::ImageScaler scaler;
-	ImageScalerClient client(&scaler);
-
-	scaler.setImage(&image);
-	scaler.setZoom(zoom);
-	int zWidth = int(image.width() * zoom);
-	int zHeight = int(image.width() * zoom);
-	int partialZWidth = zWidth / 3;
-	scaler.setDestinationRegion(
-		QRect(
-			0, 0,
-			partialZWidth, zHeight)
-		);
-
-	scaler.setDestinationRegion(
-		QRect(
-			partialZWidth, 0,
-			zWidth - partialZWidth, zHeight)
-		);
-
-	QImage expectedImage = image.scaled(image.size() * zoom);
-
-	QImage scaledImage = client.createFullImage();
-	QCOMPARE(expectedImage, scaledImage);
-}
-
-
-void ImageScalerTest::testScaleFullImageTwoPasses_data() {
-	QTest::addColumn<qreal>("zoom");
-
-	QTest::newRow("0.5") << 0.5;
-	QTest::newRow("2.0") << 2.0;
-	QTest::newRow("4.0") << 4.0;
-}
-
-
-/**
- * When zooming out, make sure that we don't crash when scaling an area which
- * have one dimension smaller than one pixel in the destination. 
- */
-void ImageScalerTest::testScaleThinArea() {
-	QImage image(10, 10, QImage::Format_ARGB32);
-	image.fill(0);
-
-	Gwenview::ImageScaler scaler;
-
-	const qreal zoom = 0.25;
-	scaler.setImage(&image);
-	scaler.setZoom(zoom);
-	scaler.setDestinationRegion(QRect(0, 0, image.width(), 2));
-}
-
-
-/**
- * Test instantiating a scaler without setting an image won't crash
- */
-void ImageScalerTest::testDontCrashWithoutImage() {
-	Gwenview::ImageScaler scaler;
-	scaler.setZoom(1.0);
-	scaler.setDestinationRegion(QRect(0, 0, 10, 10));
-}
-
-
-/**
- * Test that scaling down a big image (==bigger than MAX_CHUNK_AREA) does not
- * produce any gap
- */
-void ImageScalerTest::testScaleDownBigImage() {
-	QImage image(1704, 2272, QImage::Format_RGB32);
-	image.fill(255);
-
-	Gwenview::ImageScaler scaler;
-	ImageScalerClient client(&scaler);
-
-	const qreal zoom = 0.28125;
-	scaler.setImage(&image);
-	scaler.setZoom(zoom);
-	scaler.setDestinationRegion(QRect( QPoint(0, 0), image.size() * zoom));
-
-	QImage scaledImage = client.createFullImage();
-
-	QImage expectedImage = image.scaled(scaledImage.size());
-	QCOMPARE(expectedImage, scaledImage);
-}
-#endif

=== removed file 'tests/imagescalertest.h'
--- tests/imagescalertest.h	2011-07-20 13:46:34 +0000
+++ tests/imagescalertest.h	1970-01-01 00:00:00 +0000
@@ -1,99 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef IMAGESCALERTEST_H
-#define IMAGESCALERTEST_H
-
-#include "../lib/imagescaler.h"
-
-// Qt
-#include <QImage>
-#include <QPainter>
-
-// KDE
-#include <kdebug.h>
-
-class ImageScalerClient : public QObject {
-	Q_OBJECT
-public:
-	ImageScalerClient(Gwenview::ImageScaler* scaler)
-	{
-		connect(scaler, SIGNAL(scaledRect(int, int, const QImage&)),
-			SLOT(slotScaledRect(int, int, const QImage&)) );
-	}
-
-	struct ImageInfo {
-		int left;
-		int top;
-		QImage image;
-	};
-	QVector<ImageInfo> mImageInfoList;
-
-	QImage createFullImage() {
-		Q_ASSERT(mImageInfoList.size() > 0);
-		QImage::Format format = mImageInfoList[0].image.format();
-
-		int imageWidth = 0;
-		int imageHeight = 0;
-		Q_FOREACH(const ImageInfo& info, mImageInfoList) {
-			int right = info.left + info.image.width();
-			int bottom = info.top + info.image.height();
-			imageWidth = qMax(imageWidth, right);
-			imageHeight = qMax(imageHeight, bottom);
-		}
-
-		QImage image(imageWidth, imageHeight, format);
-		image.fill(0);
-		QPainter painter(&image);
-		Q_FOREACH(const ImageInfo& info, mImageInfoList) {
-			painter.drawImage(info.left, info.top, info.image);
-		}
-		return image;
-	}
-
-public Q_SLOTS:
-	void slotScaledRect(int left, int top, const QImage& image) {
-		ImageInfo info;
-		info.left = left;
-		info.top = top;
-		info.image = image;
-
-		mImageInfoList.append(info);
-	}
-};
-
-class ImageScalerTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void testScaleFullImage();
-
-	// FIXME Disabled for now, does not compile since ImageScaler::setImage() has
-	// been replaced with ImageScaler::setDocument()
-#if 0
-	void testScalePartialImage();
-	void testScaleFullImageTwoPasses();
-	void testScaleFullImageTwoPasses_data();
-	void testScaleThinArea();
-	void testDontCrashWithoutImage();
-	void testScaleDownBigImage();
-#endif
-};
-
-#endif // IMAGESCALERTEST_H

=== removed directory 'tests/import'
=== removed file 'tests/import/pict0001.jpg'
Binary files tests/import/pict0001.jpg and tests/import/pict0001.jpg differ
=== removed file 'tests/import/pict0002.jpg'
Binary files tests/import/pict0002.jpg and tests/import/pict0002.jpg differ
=== removed file 'tests/import/pict0003.jpg'
Binary files tests/import/pict0003.jpg and tests/import/pict0003.jpg differ
=== removed file 'tests/importertest.cpp'
--- tests/importertest.cpp	2011-07-20 13:46:34 +0000
+++ tests/importertest.cpp	1970-01-01 00:00:00 +0000
@@ -1,238 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2009 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "importertest.moc"
-
-// stdlib
-#include <sys/stat.h>
-
-// Qt
-#include <QSignalSpy>
-
-// KDE
-#include <kdatetime.h>
-#include <kdebug.h>
-#include <qtest_kde.h>
-
-// Local
-#include "../importer/fileutils.h"
-#include "../importer/importer.h"
-#include "../importer/filenameformater.h"
-#include "testutils.h"
-
-QTEST_KDEMAIN(ImporterTest, GUI)
-
-using namespace Gwenview;
-
-void ImporterTest::init() {
-	mDocumentList = KUrl::List()
-		<< urlForTestFile("import/pict0001.jpg")
-		<< urlForTestFile("import/pict0002.jpg")
-		<< urlForTestFile("import/pict0003.jpg")
-		;
-
-	mTempDir.reset(new KTempDir());
-}
-
-void ImporterTest::testContentsAreIdentical() {
-	QVERIFY(!FileUtils::contentsAreIdentical(mDocumentList[0], mDocumentList[1]));
-	QVERIFY(FileUtils::contentsAreIdentical(mDocumentList[0], mDocumentList[0]));
-
-	KUrl url1 = mDocumentList[0];
-	KUrl url2 = urlForTestOutputFile("foo");
-
-	// Test on a copy of a file
-	QFile::remove(url2.toLocalFile());
-	QFile::copy(url1.toLocalFile(), url2.toLocalFile());
-
-	QVERIFY(FileUtils::contentsAreIdentical(url1, url2));
-
-	// Alter one byte of the copy and test again
-	QFile file(url2.toLocalFile());
-	QVERIFY(file.open(QIODevice::ReadOnly));
-	QByteArray data = file.readAll();
-	file.close();
-	data[data.size() / 2] = 255 - data[data.size() / 2];
-
-	file.open(QIODevice::WriteOnly);
-	file.write(data);
-	file.close();
-
-	QVERIFY(!FileUtils::contentsAreIdentical(url1, url2));
-}
-
-void ImporterTest::testSuccessfulImport() {
-	KUrl destUrl = KUrl::fromPath(mTempDir->name() + "/foo");
-
-	Importer importer(0);
-	QSignalSpy maximumChangedSpy(&importer, SIGNAL(maximumChanged(int)));
-	QSignalSpy errorSpy(&importer, SIGNAL(error(const QString&)));
-
-	KUrl::List list = mDocumentList;
-
-	QEventLoop loop;
-	connect(&importer, SIGNAL(importFinished()), &loop, SLOT(quit()));
-	importer.start(list, destUrl);
-	loop.exec();
-
-	QCOMPARE(maximumChangedSpy.count(), 1);
-	QCOMPARE(maximumChangedSpy.takeFirst().at(0).toInt(), list.count() * 100);
-	QCOMPARE(errorSpy.count(), 0);
-
-	QCOMPARE(importer.importedUrlList().count(), list.count());
-	QCOMPARE(importer.importedUrlList(), list);
-	QCOMPARE(importer.skippedUrlList().count(), 0);
-	QCOMPARE(importer.renamedCount(), 0);
-
-	Q_FOREACH(const KUrl& src, list) {
-		KUrl dst = destUrl;
-		dst.addPath(src.fileName());
-		QVERIFY(FileUtils::contentsAreIdentical(src, dst));
-	}
-}
-
-void ImporterTest::testSkippedUrlList() {
-	KUrl destUrl = KUrl::fromPath(mTempDir->name() + "/foo");
-
-	Importer importer(0);
-
-	KUrl::List list = mDocumentList.mid(0, 1);
-
-	QEventLoop loop;
-	connect(&importer, SIGNAL(importFinished()), &loop, SLOT(quit()));
-	importer.start(list, destUrl);
-	loop.exec();
-
-	QCOMPARE(importer.importedUrlList().count(), 1);
-	QCOMPARE(importer.importedUrlList(), list);
-
-	list = mDocumentList;
-	KUrl::List expectedImportedList = mDocumentList.mid(1);
-	KUrl::List expectedSkippedList = mDocumentList.mid(0, 1);
-	importer.start(list, destUrl);
-	loop.exec();
-
-	QCOMPARE(importer.importedUrlList().count(), 2);
-	QCOMPARE(importer.importedUrlList(), expectedImportedList);
-	QCOMPARE(importer.skippedUrlList(), expectedSkippedList);
-	QCOMPARE(importer.renamedCount(), 0);
-}
-
-void ImporterTest::testRenamedCount() {
-	KUrl destUrl = KUrl::fromPath(mTempDir->name() + "/foo");
-
-	Importer importer(0);
-
-	KUrl::List list;
-	list << mDocumentList.first();
-
-	QEventLoop loop;
-	connect(&importer, SIGNAL(importFinished()), &loop, SLOT(quit()));
-	importer.start(list, destUrl);
-	loop.exec();
-
-	QCOMPARE(importer.importedUrlList().count(), 1);
-	QCOMPARE(importer.importedUrlList(), list);
-
-	// Modify imported document so that next import does not skip it
-	{
-		KUrl url = destUrl;
-		url.addPath(mDocumentList.first().fileName());
-		QFile file(url.toLocalFile());
-		QVERIFY(file.open(QIODevice::Append));
-		file.write("foo");
-	}
-
-	list = mDocumentList;
-	importer.start(list, destUrl);
-	loop.exec();
-
-	QCOMPARE(importer.importedUrlList().count(), 3);
-	QCOMPARE(importer.importedUrlList(), mDocumentList);
-	QCOMPARE(importer.skippedUrlList().count(), 0);
-	QCOMPARE(importer.renamedCount(), 1);
-}
-
-void ImporterTest::testFileNameFormater() {
-	QFETCH(QString, fileName);
-	QFETCH(QString, dateTime);
-	QFETCH(QString, format);
-	QFETCH(QString, expected);
-
-	KUrl url = KUrl("file://foo/bar/" + fileName);
-	FileNameFormater fileNameFormater(format);
-	QCOMPARE(fileNameFormater.format(url, KDateTime::fromString(dateTime)), expected);
-}
-
-#define NEW_ROW(fileName, dateTime, format, expected) QTest::newRow(fileName) << fileName << dateTime << format << expected
-void ImporterTest::testFileNameFormater_data() {
-	QTest::addColumn<QString>("fileName");
-	QTest::addColumn<QString>("dateTime");
-	QTest::addColumn<QString>("format");
-	QTest::addColumn<QString>("expected");
-
-	NEW_ROW("PICT0001.JPG", "20091024T225049", "{date}_{time}.{ext}", "2009-10-24_22-50-49.JPG");
-	NEW_ROW("PICT0001.JPG", "20091024T225049", "{date}_{time}.{ext.lower}", "2009-10-24_22-50-49.jpg");
-	NEW_ROW("PICT0001.JPG", "20091024T225049", "{name}.{ext}", "PICT0001.JPG");
-	NEW_ROW("PICT0001.JPG", "20091024T225049", "{name.lower}.{ext.lower}", "pict0001.jpg");
-	NEW_ROW("iLikeCurlies", "20091024T225049", "{{{name}}", "{iLikeCurlies}");
-	NEW_ROW("UnknownKeyword", "20091024T225049", "foo{unknown}bar", "foobar");
-	NEW_ROW("MissingClosingCurly", "20091024T225049", "foo{date", "foo");
-}
-
-void ImporterTest::testAutoRenameFormat() {
-	QStringList dates = QStringList()
-		<< "1979-02-23_10-20-00"
-		<< "2006-04-01_11-30-15"
-		<< "2009-10-01_21-15-27";
-	QCOMPARE(dates.count(), mDocumentList.count());
-
-	KUrl destUrl = KUrl::fromPath(mTempDir->name() + "foo");
-
-	Importer importer(0);
-	importer.setAutoRenameFormat("{date}_{time}.{ext}");
-	KUrl::List list = mDocumentList;
-
-	QEventLoop loop;
-	connect(&importer, SIGNAL(importFinished()), &loop, SLOT(quit()));
-	importer.start(list, destUrl);
-	loop.exec();
-
-	QCOMPARE(importer.importedUrlList().count(), list.count());
-	QCOMPARE(importer.importedUrlList(), list);
-
-	for (int pos=0; pos < dates.count(); ++pos) {
-		KUrl src = list[pos];
-		KUrl dst = destUrl;
-		dst.addPath(dates[pos] + ".jpg");
-		QVERIFY(FileUtils::contentsAreIdentical(src, dst));
-	}
-}
-
-void ImporterTest::testReadOnlyDestination() {
-	KUrl destUrl = KUrl::fromPath(mTempDir->name() + "/foo");
-	chmod(QFile::encodeName(mTempDir->name()), 0555);
-
-	Importer importer(0);
-	QSignalSpy errorSpy(&importer, SIGNAL(error(const QString&)));
-	importer.start(mDocumentList, destUrl);
-
-	QCOMPARE(errorSpy.count(), 1);
-	QVERIFY(importer.importedUrlList().isEmpty());
-}

=== removed file 'tests/importertest.h'
--- tests/importertest.h	2011-07-20 13:46:34 +0000
+++ tests/importertest.h	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2009 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef IMPORTERTEST_H
-#define IMPORTERTEST_H
-
-// stdc++
-#include <memory>
-
-// Qt
-#include <QObject>
-
-// KDE
-#include <ktempdir.h>
-#include <kurl.h>
-
-class ImporterTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void init();
-	void testContentsAreIdentical();
-	void testSuccessfulImport();
-	void testAutoRenameFormat();
-	void testReadOnlyDestination();
-	void testFileNameFormater();
-	void testFileNameFormater_data();
-	void testSkippedUrlList();
-	void testRenamedCount();
-
-private:
-	std::auto_ptr<KTempDir> mTempDir;
-	KUrl::List mDocumentList;
-};
-
-#endif /* IMPORTERTEST_H */

=== removed file 'tests/jpegcontenttest.cpp'
--- tests/jpegcontenttest.cpp	2011-07-20 13:46:34 +0000
+++ tests/jpegcontenttest.cpp	1970-01-01 00:00:00 +0000
@@ -1,298 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "jpegcontenttest.moc"
-#include <iostream>
-
-// Qt
-#include <QDir>
-#include <QFile>
-#include <QImage>
-#include <QString>
-
-// KDE
-#include <qtest_kde.h>
-#include <kdebug.h>
-#include <kfilemetainfo.h>
-
-// Local
-#include "../lib/orientation.h"
-#include "../lib/jpegcontent.h"
-#include "testutils.h"
-
-using namespace std;
-
-const char* ORIENT6_FILE="orient6.jpg";
-const char* ORIENT1_VFLIP_FILE="orient1_vflip.jpg";
-const char* CUT_FILE="cut.jpg";
-const char* TMP_FILE="tmp.jpg";
-const char* THUMBNAIL_FILE="test_thumbnail.jpg";
-
-const int ORIENT6_WIDTH=128;  // This size is the size *after* orientation
-const int ORIENT6_HEIGHT=256; // has been applied
-const QString ORIENT6_COMMENT="a comment";
-
-
-QTEST_KDEMAIN(JpegContentTest, GUI)
-
-
-void JpegContentTest::initTestCase() {
-	bool result;
-	QFile in(pathForTestFile(ORIENT6_FILE));
-	result=in.open(QIODevice::ReadOnly);
-	QVERIFY(result);
-	
-	QFileInfo info(in);
-	int size=info.size()/2;
-	
-	char* data=new char[size];
-	int readSize=in.read(data, size);
-	QCOMPARE(size,readSize);
-	
-	QFile out(CUT_FILE);
-	result=out.open(QIODevice::WriteOnly);
-	QVERIFY(result);
-	
-	int wroteSize=out.write(data, size);
-	QCOMPARE(size,wroteSize);
-	delete []data;
-}
-
-void JpegContentTest::cleanupTestCase() {
-	QDir::current().remove(CUT_FILE);
-}
-
-
-typedef QMap<QString,QString> MetaInfoMap;
-
-MetaInfoMap getMetaInfo(const QString& path) {
-	KFileMetaInfo fmi(path);
-	QStringList list=fmi.supportedKeys();
-	QStringList::ConstIterator it=list.constBegin();
-	MetaInfoMap map;
-	
-	for ( ; it!=list.constEnd(); ++it) {
-		KFileMetaInfoItem item=fmi.item(*it);
-		map[*it]=item.value().toString();
-	}
-
-	return map;
-}
-
-void compareMetaInfo(const QString& path1, const QString& path2, const QStringList& ignoredKeys) {
-	MetaInfoMap mim1=getMetaInfo(path1);
-	MetaInfoMap mim2=getMetaInfo(path2);
-
-	QCOMPARE(mim1.keys(),mim2.keys());
-	QList<QString> keys=mim1.keys();
-	QList<QString>::ConstIterator it=keys.constBegin();
-	for ( ; it!=keys.constEnd(); ++it) {
-		QString key=*it;
-		if (ignoredKeys.contains(key)) continue;
-
-		QString msg =
-			QString("Meta info differs for key '%1': v1=%2 v2=%3")
-				.arg(key)
-				.arg(mim1[key])
-				.arg(mim2[key]);
-
-		QVERIFY2(mim1[key] == mim2[key], msg.toUtf8());
-	}
-}
-
-
-void JpegContentTest::testResetOrientation() {
-	Gwenview::JpegContent content;
-	bool result;
-
-	// Test resetOrientation without transform
-	result=content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-
-	content.resetOrientation();
-
-	result=content.save(TMP_FILE);
-	QVERIFY(result);
-
-	result=content.load(TMP_FILE);
-	QVERIFY(result);
-	QCOMPARE(content.orientation(), Gwenview::NORMAL);
-
-	// Test resetOrientation with transform
-	result=content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-
-	content.resetOrientation();
-	content.transform(Gwenview::ROT_90);
-
-	result=content.save(TMP_FILE);
-	QVERIFY(result);
-
-	result=content.load(TMP_FILE);
-	QVERIFY(result);
-	QCOMPARE(content.orientation(), Gwenview::NORMAL);
-}
-
-
-/**
- * This function tests JpegContent::transform() by applying a ROT_90
- * transformation, saving, reloading and applying a ROT_270 to undo the ROT_90.
- * Saving and reloading are necessary because lossless transformation only
- * happens in JpegContent::save()
- */
-void JpegContentTest::testTransform() {
-	bool result;
-	QImage finalImage, expectedImage;
-
-	Gwenview::JpegContent content;
-	result = content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-
-	content.transform(Gwenview::ROT_90);
-	result = content.save(TMP_FILE);
-	QVERIFY(result);
-
-	result = content.load(TMP_FILE);
-	QVERIFY(result);
-	content.transform(Gwenview::ROT_270);
-	result = content.save(TMP_FILE);
-	QVERIFY(result);
-
-	result = finalImage.load(TMP_FILE);
-	QVERIFY(result);
-
-	result = expectedImage.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-
-	QCOMPARE(finalImage , expectedImage);
-}
-
-
-void JpegContentTest::testSetComment() {
-	QString comment = "test comment";
-	Gwenview::JpegContent content;
-	bool result;
-	result = content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-
-	content.setComment(comment);
-	QCOMPARE(content.comment() , comment);
-	result = content.save(TMP_FILE);
-	QVERIFY(result);
-
-	result = content.load(TMP_FILE);
-	QVERIFY(result);
-	QCOMPARE(content.comment() , comment);
-}
-
-
-void JpegContentTest::testReadInfo() {
-	Gwenview::JpegContent content;
-	bool result=content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-	QCOMPARE(int(content.orientation()), 6);
-	QCOMPARE(content.comment() , ORIENT6_COMMENT);
-	QCOMPARE(content.size() , QSize(ORIENT6_WIDTH, ORIENT6_HEIGHT));
-}
-
-void JpegContentTest::testThumbnail() {
-	Gwenview::JpegContent content;
-	bool result=content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-	QImage thumbnail=content.thumbnail();
-	result=thumbnail.save(THUMBNAIL_FILE, "JPEG");
-	QVERIFY(result);
-}
-
-void JpegContentTest::testMultipleRotations() {
-	// Test that rotating a file a lot of times does not cause findJxform() to fail
-	Gwenview::JpegContent content;
-	bool result=content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-	result = content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-
-	// 12*4 + 1 is the same as 1, since rotating four times brings you back
-	for(int loop=0; loop< 12*4 + 1; ++loop) {
-		content.transform(Gwenview::ROT_90);
-	}
-	result = content.save(TMP_FILE);
-	QVERIFY(result);
-
-	result = content.load(TMP_FILE);
-	QVERIFY(result);
-
-	QCOMPARE(content.size() , QSize(ORIENT6_HEIGHT, ORIENT6_WIDTH));
-	
-	
-	// Check the other meta info are still here
-	QStringList ignoredKeys;
-	ignoredKeys << "Orientation" << "Comment";
-	compareMetaInfo(pathForTestFile(ORIENT6_FILE), pathForTestFile(ORIENT1_VFLIP_FILE), ignoredKeys);
-}
-
-void JpegContentTest::testLoadTruncated() {
-	// Test that loading and manipulating a truncated file does not crash
-	Gwenview::JpegContent content;
-	bool result=content.load(CUT_FILE);
-	QVERIFY(result);
-	QCOMPARE(int(content.orientation()), 6);
-	QCOMPARE(content.comment() , ORIENT6_COMMENT);
-	content.transform(Gwenview::VFLIP);
-	kWarning() << "# Next function should output errors about incomplete image" ;
-	content.save(TMP_FILE);
-	kWarning() << "#" ;
-}
-
-void JpegContentTest::testRawData() {
-	Gwenview::JpegContent content;
-	bool result=content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-
-	QByteArray fileData;
-	QFile file(pathForTestFile(ORIENT6_FILE));
-	result = file.open(QIODevice::ReadOnly);
-	QVERIFY(result);
-	fileData = file.readAll();
-
-	QCOMPARE(content.rawData(), fileData);
-}
-
-void JpegContentTest::testSetImage() {
-	Gwenview::JpegContent content;
-	bool result=content.load(pathForTestFile(ORIENT6_FILE));
-	QVERIFY(result);
-
-	QImage image = QImage(400, 300, QImage::Format_RGB32);
-	image.fill(Qt::red);
-
-	content.setImage(image);
-
-	result = content.save(TMP_FILE);
-	QVERIFY(result);
-
-	result = content.load(TMP_FILE);
-	QVERIFY(result);
-
-	QCOMPARE(content.size(), image.size());
-
-	QStringList ignoredKeys;
-	ignoredKeys << "Orientation";
-	compareMetaInfo(pathForTestFile(ORIENT6_FILE), pathForTestFile(TMP_FILE), ignoredKeys);
-}

=== removed file 'tests/jpegcontenttest.h'
--- tests/jpegcontenttest.h	2011-07-20 13:46:34 +0000
+++ tests/jpegcontenttest.h	1970-01-01 00:00:00 +0000
@@ -1,43 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef JPEGCONTENTTEST_H
-#define JPEGCONTENTTEST_H
-
-// Qt
-#include <QObject>
-
-class JpegContentTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void initTestCase();
-	void cleanupTestCase();
-	void testReadInfo();
-	void testThumbnail();
-	void testResetOrientation();
-	void testTransform();
-	void testSetComment();
-	void testMultipleRotations();
-	void testLoadTruncated();
-	void testRawData();
-	void testSetImage();
-};
-
-#endif // JPEGCONTENTTEST_H

=== added directory 'tests/manual'
=== added file 'tests/manual/CMakeLists.txt'
--- tests/manual/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ tests/manual/CMakeLists.txt	2011-12-15 14:17:54 +0000
@@ -0,0 +1,20 @@
+include_directories(
+	${gwenview_SOURCE_DIR}
+    )
+# SlideContainer
+set(slidecontainertest_SRCS
+	slidecontainertest.cpp
+	)
+
+kde4_add_executable(slidecontainertest TEST ${slidecontainertest_SRCS})
+
+target_link_libraries(slidecontainertest ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} gwenviewlib)
+
+# imageloadbench
+set(imageloadbench_SRCS
+	imageloadbench.cpp
+	)
+
+kde4_add_executable(imageloadbench TEST ${imageloadbench_SRCS})
+
+target_link_libraries(imageloadbench ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} gwenviewlib)

=== added file 'tests/manual/imageloadbench.cpp'
--- tests/manual/imageloadbench.cpp	1970-01-01 00:00:00 +0000
+++ tests/manual/imageloadbench.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,61 @@
+#include <QBuffer>
+#include <QCoreApplication>
+#include <QDebug>
+#include <QFile>
+#include <QImage>
+#include <QImageReader>
+#include <QTime>
+
+#include <lib/imageformats/imageformats.h>
+
+const int ITERATIONS = 2;
+const QSize SCALED_SIZE(1280, 800);
+
+static void bench(QIODevice* device, const QString& outputName)
+{
+    QTime chrono;
+    chrono.start();
+    for (int iteration = 0; iteration < ITERATIONS; ++iteration) {
+        qDebug() << "Iteration:" << iteration;
+
+        device->open(QIODevice::ReadOnly);
+        QImageReader reader(device);
+        QSize size = reader.size();
+        size.scale(SCALED_SIZE, Qt::KeepAspectRatio);
+        reader.setScaledSize(size);
+        QImage img = reader.read();
+        device->close();
+
+        if (iteration == ITERATIONS - 1) {
+            qDebug() << "time:" << chrono.elapsed();
+            img.save(outputName, "png");
+        }
+    }
+}
+
+int main(int argc, char** argv)
+{
+    QCoreApplication app(argc, argv);
+    if (argc != 2) {
+        qDebug() << "Usage: imageloadbench <file.jpg>";
+        return 1;
+    }
+
+    QString fileName = QString::fromUtf8(argv[1]);
+
+    QFile file(fileName);
+    if (!file.open(QIODevice::ReadOnly)) {
+        qDebug() << QString("Could not open '%1'").arg(fileName);
+        return 2;
+    }
+    QByteArray data = file.readAll();
+    QBuffer buffer(&data);
+
+    qDebug() << "Using Qt loader";
+    bench(&buffer, "qt.png");
+    Gwenview::ImageFormats::registerPlugins();
+    qDebug() << "Using Gwenview loader";
+    bench(&buffer, "gv.png");
+
+    return 0;
+}

=== added file 'tests/manual/slidecontainertest.cpp'
--- tests/manual/slidecontainertest.cpp	1970-01-01 00:00:00 +0000
+++ tests/manual/slidecontainertest.cpp	2011-12-15 14:17:54 +0000
@@ -0,0 +1,65 @@
+// vim: set tabstop=4 shiftwidth=4 expandtab:
+/*
+Gwenview: an image viewer
+Copyright 2007 Aurélien Gâteau <agateau@kde.org>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
+
+*/
+// Qt
+#include <QApplication>
+#include <QLineEdit>
+#include <QPushButton>
+#include <QVBoxLayout>
+
+// Local
+#include <lib/slidecontainer.h>
+
+using namespace Gwenview;
+
+class Window : public QWidget
+{
+public:
+    Window()
+        : QWidget() {
+        SlideContainer* container = new SlideContainer(this);
+
+        QPushButton* inButton = new QPushButton(this);
+        inButton->setText("Slide &In");
+        connect(inButton, SIGNAL(clicked()), container, SLOT(slideIn()));
+
+        QPushButton* outButton = new QPushButton(this);
+        outButton->setText("Slide &Out");
+        connect(outButton, SIGNAL(clicked()), container, SLOT(slideOut()));
+
+        QVBoxLayout* layout = new QVBoxLayout(this);
+        layout->addWidget(inButton);
+        layout->addWidget(outButton);
+        layout->addWidget(container);
+
+        QLineEdit* content = new QLineEdit(container);
+        content->setText("Some long text. Some long text. Some long text. Some long text.");
+        container->setContent(content);
+    }
+};
+
+int main(int argc, char* argv[])
+{
+    QApplication app(argc, argv);
+    Window window;
+
+    window.show();
+    return app.exec();
+}

=== removed file 'tests/orient1_vflip.jpg'
Binary files tests/orient1_vflip.jpg and tests/orient1_vflip.jpg differ
=== removed file 'tests/orient6-small.jpg'
Binary files tests/orient6-small.jpg and tests/orient6-small.jpg differ
=== removed file 'tests/orient6.jpg'
Binary files tests/orient6.jpg and tests/orient6.jpg differ
=== removed file 'tests/paintutilstest.cpp'
--- tests/paintutilstest.cpp	2011-07-20 13:46:34 +0000
+++ tests/paintutilstest.cpp	1970-01-01 00:00:00 +0000
@@ -1,41 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include <qtest_kde.h>
-
-#include "../lib/paintutils.h"
-
-#include "paintutilstest.moc"
-
-QTEST_KDEMAIN( PaintUtilsTest, GUI )
-
-void PaintUtilsTest::testScaledRect_data() {
-	QTest::addColumn<QRectF>("input");
-	QTest::addColumn<QRect>("expected");
-
-	QTest::newRow("overflow right") << QRectF(1.0, 1.0, 2.7, 3.2) << QRect(1, 1, 3, 4);
-	QTest::newRow("overflow left")  << QRectF(0.5, 1.0, 2.0, 3.2) << QRect(0, 1, 3, 4);
-	QTest::newRow("overflow both")  << QRectF(0.5, 1.0, 2.6, 3.2) << QRect(0, 1, 4, 4);
-}
-
-void PaintUtilsTest::testScaledRect() {
-	QFETCH(QRectF, input);
-	QFETCH(QRect,  expected);
-	QCOMPARE(Gwenview::PaintUtils::containingRect(input), expected);
-}

=== removed file 'tests/paintutilstest.h'
--- tests/paintutilstest.h	2011-07-20 13:46:34 +0000
+++ tests/paintutilstest.h	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef PAINTUTILSTEST_H
-#define PAINTUTILSTEST_H
-
-// Qt
-
-// KDE
-
-class PaintUtilsTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void testScaledRect();
-	void testScaledRect_data();
-};
-
-#endif // PAINTUTILSTEST_H

=== removed file 'tests/placetreemodeltest.cpp'
--- tests/placetreemodeltest.cpp	2011-07-20 13:46:34 +0000
+++ tests/placetreemodeltest.cpp	1970-01-01 00:00:00 +0000
@@ -1,140 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2009 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "placetreemodeltest.moc"
-
-// Qt
-#include <QDir>
-#include <QFile>
-
-// KDE
-#include <kdebug.h>
-#include <kstandarddirs.h>
-#include <qtest_kde.h>
-
-// Local
-#include "../lib/placetreemodel.h"
-
-#define KEEP_TEMP_DIR
-
-QTEST_KDEMAIN(PlaceTreeModelTest, GUI)
-
-using namespace Gwenview;
-
-const char* BOOKMARKS_XML =
-"<?xml version='1.0' encoding='UTF-8'?>"
-"<!DOCTYPE xbel>"
-"<xbel xmlns:bookmark='http://www.freedesktop.org/standards/desktop-bookmarks' xmlns:mime='http://www.freedesktop.org/standards/shared-mime-info' xmlns:kdepriv='http://www.kde.org/kdepriv' dbusName='kfilePlaces' >"
-" <bookmark href='%1' >"
-"  <title>url1</title>"
-"  <info>"
-"   <metadata owner='http://freedesktop.org' >"
-"    <bookmark:icon name='user-home' />"
-"   </metadata>"
-"   <metadata owner='http://www.kde.org' >"
-"    <ID>1214343736/0</ID>"
-"    <isSystemItem>true</isSystemItem>"
-"   </metadata>"
-"  </info>"
-" </bookmark>"
-" <bookmark href='%2' >"
-"  <title>url2</title>"
-"  <info>"
-"   <metadata owner='http://freedesktop.org' >"
-"    <bookmark:icon name='user-home' />"
-"   </metadata>"
-"   <metadata owner='http://www.kde.org' >"
-"    <ID>1214343736/1</ID>"
-"    <isSystemItem>true</isSystemItem>"
-"   </metadata>"
-"  </info>"
-" </bookmark>"
-"</xbel>";
-
-
-void PlaceTreeModelTest::initTestCase() {
-	Q_ASSERT(mTempDir.exists());
-	QDir dir(mTempDir.name());
-
-	Q_ASSERT(dir.mkdir("url1"));
-	mUrl1 = KUrl::fromPath(dir.filePath("url1"));
-
-	Q_ASSERT(dir.mkdir("url2"));
-	mUrl2 = KUrl::fromPath(dir.filePath("url2"));
-
-	mUrl1Dirs << "aaa" << "zzz" << "bbb";
-	Q_FOREACH(const QString& dirName, mUrl1Dirs) {
-		dir.mkdir("url1/" + dirName);
-	}
-
-	QFile bookmark(KStandardDirs::locateLocal("data", "kfileplaces/bookmarks.xml"));
-	Q_ASSERT(bookmark.open(QIODevice::WriteOnly));
-
-	QString xml = QString(BOOKMARKS_XML)
-		.arg(mUrl1.toLocalFile())
-		.arg(mUrl2.toLocalFile())
-		;
-	bookmark.write(xml.toUtf8());
-
-#ifdef KEEP_TEMP_DIR
-	mTempDir.setAutoRemove(false);
-	kDebug() << "mTempDir:" << mTempDir.name();
-#endif
-}
-
-
-void PlaceTreeModelTest::testListPlaces() {
-	PlaceTreeModel model(0);
-	QCOMPARE(model.rowCount(), 2);
-
-	QModelIndex index;
-	index = model.index(0, 0);
-	QCOMPARE(model.urlForIndex(index), mUrl1);
-	index = model.index(1, 0);
-	QCOMPARE(model.urlForIndex(index), mUrl2);
-}
-
-
-void PlaceTreeModelTest::testListUrl1() {
-	PlaceTreeModel model(0);
-
-	QModelIndex index = model.index(0, 0);
-	QCOMPARE(model.urlForIndex(index), mUrl1);
-
-	// We should not have fetched content yet
-	QCOMPARE(model.rowCount(index), 0);
-	QVERIFY(model.canFetchMore(index));
-
-	while (model.canFetchMore(index)) {
-		model.fetchMore(index);
-	}
-	QTest::qWait(1000);
-	QCOMPARE(model.rowCount(index), mUrl1Dirs.length());
-
-	QStringList dirs = mUrl1Dirs;
-	dirs.sort();
-
-	for (int row = 0; row < dirs.count(); ++row) {
-		QModelIndex subIndex = model.index(row, 0, index);
-		QVERIFY(subIndex.isValid());
-
-		QString dirName = model.data(subIndex).toString();
-		QCOMPARE(dirName, dirs.value(row));
-	}
-}

=== removed file 'tests/placetreemodeltest.h'
--- tests/placetreemodeltest.h	2011-07-20 13:46:34 +0000
+++ tests/placetreemodeltest.h	1970-01-01 00:00:00 +0000
@@ -1,45 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2009 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef PLACETREEMODELTEST_H
-#define PLACETREEMODELTEST_H
-
-// Qt
-#include <QObject>
-#include <QStringList>
-
-// KDE
-#include <ktempdir.h>
-#include <kurl.h>
-
-class PlaceTreeModelTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void initTestCase();
-	void testListPlaces();
-	void testListUrl1();
-
-private:
-	KUrl mUrl1, mUrl2;
-	QStringList mUrl1Dirs;
-	KTempDir mTempDir;
-};
-
-#endif /* PLACETREEMODELTEST_H */

=== removed file 'tests/semanticinfobackendtest.cpp'
--- tests/semanticinfobackendtest.cpp	2011-07-20 13:46:34 +0000
+++ tests/semanticinfobackendtest.cpp	1970-01-01 00:00:00 +0000
@@ -1,138 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-// Local
-#include "semanticinfobackendtest.moc"
-
-// Qt
-#include <QSignalSpy>
-
-// KDE
-#include <kdebug.h>
-#include <krandom.h>
-#include <ktemporaryfile.h>
-#include <qtest_kde.h>
-
-// Local
-#include "testutils.h"
-#include <config-gwenview.h>
-
-#ifdef GWENVIEW_SEMANTICINFO_BACKEND_FAKE
-#include <lib/semanticinfo/fakesemanticinfobackend.h>
-
-#elif defined(GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK)
-#include <nepomuk/resourcemanager.h>
-#include <lib/semanticinfo/nepomuksemanticinfobackend.h>
-
-#else
-#ifdef __GNUC__
-	#error No metadata backend defined
-#endif
-#endif
-
-QTEST_KDEMAIN( Gwenview::SemanticInfoBackEndTest, GUI )
-
-namespace Gwenview {
-
-
-SemanticInfoBackEndClient::SemanticInfoBackEndClient(AbstractSemanticInfoBackEnd* backEnd)
-: mBackEnd(backEnd) {
-	connect(backEnd, SIGNAL(semanticInfoRetrieved(const KUrl&, const SemanticInfo&)),
-		SLOT(slotSemanticInfoRetrieved(const KUrl&, const SemanticInfo&)) );
-}
-
-
-void SemanticInfoBackEndClient::slotSemanticInfoRetrieved(const KUrl& url, const SemanticInfo& semanticInfo) {
-	mSemanticInfoForUrl[url] = semanticInfo;
-}
-
-
-void SemanticInfoBackEndTest::initTestCase() {
-#ifdef GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK
-	if (Nepomuk::ResourceManager::instance()->init() != 0) {
-		QSKIP("This test needs Nepomuk", SkipAll);
-	}
-#endif
-	qRegisterMetaType<KUrl>("KUrl");
-	qRegisterMetaType<QString>("SemanticInfoTag");
-}
-
-
-void SemanticInfoBackEndTest::init() {
-#ifdef GWENVIEW_SEMANTICINFO_BACKEND_FAKE
-	mBackEnd = new FakeSemanticInfoBackEnd(0, FakeSemanticInfoBackEnd::InitializeEmpty);
-#elif defined(GWENVIEW_SEMANTICINFO_BACKEND_NEPOMUK)
-	mBackEnd = new NepomukSemanticInfoBackEnd(0);
-#endif
-}
-
-void SemanticInfoBackEndTest::cleanup() {
-	delete mBackEnd;
-	mBackEnd = 0;
-}
-
-
-/**
- * Get and set the rating of a temp file
- */
-void SemanticInfoBackEndTest::testRating() {
-	KTemporaryFile temp;
-	temp.setSuffix(".metadatabackendtest");
-	QVERIFY(temp.open());
-
-	KUrl url;
-	url.setPath(temp.fileName());
-
-	SemanticInfoBackEndClient client(mBackEnd);
-	QSignalSpy spy(mBackEnd, SIGNAL(semanticInfoRetrieved(const KUrl&, const SemanticInfo&)) );
-	mBackEnd->retrieveSemanticInfo(url);
-	QVERIFY(waitForSignal(spy));
-
-	SemanticInfo semanticInfo = client.semanticInfoForUrl(url);
-	QCOMPARE(semanticInfo.mRating, 0);
-
-	semanticInfo.mRating = 5;
-	mBackEnd->storeSemanticInfo(url, semanticInfo);
-}
-
-
-void SemanticInfoBackEndTest::testTagForLabel() {
-	QSignalSpy spy(mBackEnd, SIGNAL(tagAdded(const SemanticInfoTag&, const QString&)) );
-
-	TagSet oldAllTags = mBackEnd->allTags();
-	QString label = "testTagForLabel-" + KRandom::randomString(5);
-	SemanticInfoTag tag1 = mBackEnd->tagForLabel(label);
-	QVERIFY(!tag1.isEmpty());
-	QVERIFY(!oldAllTags.contains(tag1));
-	QVERIFY(mBackEnd->allTags().contains(tag1));
-
-	// This is a new tag, we should receive a signal
-	QCOMPARE(spy.count(), 1);
-
-	SemanticInfoTag tag2 = mBackEnd->tagForLabel(label);
-	QCOMPARE(tag1, tag2);
-	// This is not a new tag, we should not receive a signal
-	QCOMPARE(spy.count(), 1);
-
-	QString label2 = mBackEnd->labelForTag(tag2);
-	QCOMPARE(label, label2);
-}
-
-
-} // namespace

=== removed file 'tests/semanticinfobackendtest.h'
--- tests/semanticinfobackendtest.h	2011-07-20 13:46:34 +0000
+++ tests/semanticinfobackendtest.h	1970-01-01 00:00:00 +0000
@@ -1,73 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef SEMANTICINFOBACKENDTEST_H
-#define SEMANTICINFOBACKENDTEST_H
-
-// Qt
-#include <QHash>
-#include <QObject>
-
-// KDE
-#include <kurl.h>
-
-// Local
-#include <lib/semanticinfo/abstractsemanticinfobackend.h>
-
-namespace Gwenview {
-
-/**
- * Helper class which gathers the metadata retrieved when
- * AbstractSemanticInfoBackEnd::retrieveSemanticInfo() is called.
- */
-class SemanticInfoBackEndClient : public QObject {
-	Q_OBJECT
-public:
-	SemanticInfoBackEndClient(AbstractSemanticInfoBackEnd*);
-
-	SemanticInfo semanticInfoForUrl(const KUrl& url) const {
-		return mSemanticInfoForUrl.value(url);
-	}
-
-private Q_SLOTS:
-	void slotSemanticInfoRetrieved(const KUrl&, const SemanticInfo&);
-
-private:
-	QHash<KUrl, SemanticInfo> mSemanticInfoForUrl;
-	AbstractSemanticInfoBackEnd* mBackEnd;
-};
-
-
-class SemanticInfoBackEndTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void initTestCase();
-	void init();
-	void cleanup();
-	void testRating();
-	void testTagForLabel();
-
-private:
-	AbstractSemanticInfoBackEnd* mBackEnd;
-};
-
-} // namespace
-
-#endif // SEMANTICINFOBACKENDTEST_H

=== removed file 'tests/slidecontainertest.cpp'
--- tests/slidecontainertest.cpp	2011-07-20 13:46:34 +0000
+++ tests/slidecontainertest.cpp	1970-01-01 00:00:00 +0000
@@ -1,66 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Cambridge, MA 02110-1301, USA.
-
-*/
-// Qt
-#include <QApplication>
-#include <QLineEdit>
-#include <QPushButton>
-#include <QVBoxLayout>
-
-// Local
-#include "../lib/slidecontainer.h"
-
-
-using namespace Gwenview;
-
-
-class Window : public QWidget {
-public:
-	Window()
-	: QWidget() {
-		SlideContainer* container = new SlideContainer(this);
-
-		QPushButton* inButton = new QPushButton(this);
-		inButton->setText("Slide &In");
-		connect(inButton, SIGNAL(clicked()), container, SLOT(slideIn()));
-
-		QPushButton* outButton = new QPushButton(this);
-		outButton->setText("Slide &Out");
-		connect(outButton, SIGNAL(clicked()), container, SLOT(slideOut()));
-
-		QVBoxLayout* layout = new QVBoxLayout(this);
-		layout->addWidget(inButton);
-		layout->addWidget(outButton);
-		layout->addWidget(container);
-
-		QLineEdit* content = new QLineEdit(container);
-		content->setText("Some long text. Some long text. Some long text. Some long text.");
-		container->setContent(content);
-	}
-};
-
-
-int main(int argc, char* argv[]) {
-	QApplication app(argc, argv);
-	Window window;
-
-	window.show();
-	return app.exec();
-}

=== removed file 'tests/sorteddirmodeltest.cpp'
--- tests/sorteddirmodeltest.cpp	2011-07-20 13:46:34 +0000
+++ tests/sorteddirmodeltest.cpp	1970-01-01 00:00:00 +0000
@@ -1,59 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2011 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-// Self
-#include <sorteddirmodeltest.moc>
-
-// Local
-#include <testutils.h>
-#include <lib/semanticinfo/sorteddirmodel.h>
-
-// Qt
-
-// KDE
-#include <qtest_kde.h>
-#include <kdirlister.h>
-
-using namespace Gwenview;
-
-QTEST_KDEMAIN(SortedDirModelTest, GUI)
-
-void SortedDirModelTest::testHasDocuments_data() {
-	QTest::addColumn<QString>("sandBoxDir");
-	QTest::addColumn<bool>("hasDocuments");
-	#define NEW_ROW(dir, hasDocuments) \
-		QTest::newRow(QString(dir).toLocal8Bit().data()) << pathForTestFile(dir) << hasDocuments
-	NEW_ROW("empty_dir", false);
-	NEW_ROW("dirs_only", false);
-	NEW_ROW("dirs_and_docs", true);
-	NEW_ROW("docs_only", true);
-	#undef NEW_ROW
-}
-
-void SortedDirModelTest::testHasDocuments() {
-	QFETCH(QString, sandBoxDir);
-	QFETCH(bool, hasDocuments);
-	SortedDirModel model;
-	QEventLoop loop;
-	connect(model.dirLister(), SIGNAL(completed()), &loop, SLOT(quit()));
-	model.dirLister()->openUrl(KUrl::fromPath(sandBoxDir));
-	loop.exec();
-	QCOMPARE(model.hasDocuments(), hasDocuments);
-}

=== removed file 'tests/sorteddirmodeltest.h'
--- tests/sorteddirmodeltest.h	2011-07-20 13:46:34 +0000
+++ tests/sorteddirmodeltest.h	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-// vim: set tabstop=4 shiftwidth=4 noexpandtab:
-/*
-Gwenview: an image viewer
-Copyright 2011 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef SORTEDDIRMODELTEST_H
-#define SORTEDDIRMODELTEST_H
-
-#include <QObject>
-
-class SortedDirModelTest : public QObject {
-	Q_OBJECT
-private Q_SLOTS:
-	void testHasDocuments_data();
-	void testHasDocuments();
-};
-
-#endif /* SORTEDDIRMODELTEST_H */

=== removed file 'tests/test.png'
Binary files tests/test.png and tests/test.png differ
=== removed file 'tests/test.svg'
--- tests/test.svg	2011-07-20 13:46:34 +0000
+++ tests/test.svg	1970-01-01 00:00:00 +0000
@@ -1,73 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://creativecommons.org/ns#"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   width="744.09448819"
-   height="1052.3622047"
-   id="svg2"
-   sodipodi:version="0.32"
-   inkscape:version="0.46"
-   sodipodi:docname="test.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape">
-  <defs
-     id="defs4">
-    <inkscape:perspective
-       sodipodi:type="inkscape:persp3d"
-       inkscape:vp_x="0 : 526.18109 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_z="744.09448 : 526.18109 : 1"
-       inkscape:persp3d-origin="372.04724 : 350.78739 : 1"
-       id="perspective10" />
-  </defs>
-  <sodipodi:namedview
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="1.0"
-     gridtolerance="10000"
-     guidetolerance="10"
-     objecttolerance="10"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="0.35"
-     inkscape:cx="375"
-     inkscape:cy="520"
-     inkscape:document-units="px"
-     inkscape:current-layer="layer1"
-     showgrid="false"
-     inkscape:window-width="640"
-     inkscape:window-height="703"
-     inkscape:window-x="632"
-     inkscape:window-y="69" />
-  <metadata
-     id="metadata7">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-      </cc:Work>
-    </rdf:RDF>
-  </metadata>
-  <g
-     inkscape:label="Layer 1"
-     inkscape:groupmode="layer"
-     id="layer1">
-    <path
-       sodipodi:type="arc"
-       style="fill:#000000;fill-opacity:1;stroke:#664010;stroke-width:2.4000001;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
-       id="path2383"
-       sodipodi:cx="371.42856"
-       sodipodi:cy="440.93362"
-       sodipodi:rx="277.14285"
-       sodipodi:ry="285.71429"
-       d="M 648.57141,440.93362 A 277.14285,285.71429 0 1 1 94.285706,440.93362 A 277.14285,285.71429 0 1 1 648.57141,440.93362 z" />
-  </g>
-</svg>

=== removed file 'tests/test.xcf'
Binary files tests/test.xcf and tests/test.xcf differ
=== removed file 'tests/testutils.cpp'
--- tests/testutils.cpp	2011-07-20 13:46:34 +0000
+++ tests/testutils.cpp	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2010 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "testutils.h"
-
-// KDE
-#include <kdebug.h>
-#include <kio/deletejob.h>
-#include <kio/netaccess.h>
-#include <kio/job.h>
-
-static void rm_rf(const QString& pathOrUrl) {
-	KIO::Job* job = KIO::del(pathOrUrl, KIO::HideProgressInfo);
-	job->setUiDelegate(0);
-	KIO::NetAccess::synchronousRun(job, 0);
-}
-
-static bool mkdir(const QString& pathOrUrl) {
-	KIO::Job* job = KIO::mkdir(pathOrUrl, -1);
-	job->setUiDelegate(0);
-	return KIO::NetAccess::synchronousRun(job, 0);
-}
-
-static bool cp(const QString& src, const QString& _dst) {
-	KIO::Job* job = KIO::file_copy(src, _dst, -1, KIO::Overwrite | KIO::HideProgressInfo);
-	job->setUiDelegate(0);
-	return KIO::NetAccess::synchronousRun(job, 0);
-}
-
-KUrl setUpRemoteTestDir(const QString& testFile) {
-	if (!qgetenv("NO_REMOTE_TESTS").isEmpty()) {
-		kWarning() << "Remote tests disabled";
-		return KUrl();
-	}
-
-	QString testDir("/tmp/gwenview-remote-tests/");
-	rm_rf(testDir);
-
-	if (!mkdir(testDir)) {
-		kFatal() << "Could not create dir" << testDir;
-		return KUrl();
-	}
-
-	if (!testFile.isEmpty()) {
-		if (!cp(pathForTestFile(testFile), testDir + testFile)) {
-			kFatal() << "Could not copy" << testFile << "to" << testDir;
-			return KUrl();
-		}
-	}
-
-	return KUrl("sftp://localhost" + testDir);
-}

=== removed file 'tests/testutils.h'
--- tests/testutils.h	2011-07-20 13:46:34 +0000
+++ tests/testutils.h	1970-01-01 00:00:00 +0000
@@ -1,98 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef TESTUTILS_H
-#define TESTUTILS_H
-
-#include <math.h>
-
-// Qt
-#include <QDir>
-#include <QImage>
-#include <QSignalSpy>
-#include <QTest>
-
-// KDE
-#include <kdebug.h>
-#include <kurl.h>
-
-
-/*
- * This file contains simple helpers to access test files
- */
-
-inline QString pathForTestFile(const QString& name) {
-	return QString("%1/%2").arg(KDESRCDIR).arg(name);
-}
-
-inline KUrl urlForTestFile(const QString& name) {
-	KUrl url;
-	url.setPath(pathForTestFile(name));
-	return url;
-}
-
-inline QString pathForTestOutputFile(const QString& name) {
-	return QString("%1/%2").arg(QDir::currentPath()).arg(name);
-}
-
-inline KUrl urlForTestOutputFile(const QString& name) {
-	KUrl url;
-	url.setPath(pathForTestOutputFile(name));
-	return url;
-}
-
-inline bool waitForSignal(const QSignalSpy& spy, int timeout = 5) {
-	for (int x = 0; x < timeout; ++x) {
-		if (spy.count() > 0) {
-			return true;
-		}
-		QTest::qWait(1000);
-	}
-	return false;
-}
-
-inline bool fuzzyImageCompare(const QImage& img1, const QImage& img2) {
-	if (img1.size() != img2.size()) {
-		kWarning() << "Different sizes" << img1.size() << img2.size();
-		return false;
-	}
-	if (img1.format() != img2.format()) {
-		kWarning() << "Different formats" << img1.format() << img2.format();
-		return false;
-	}
-
-	for(int posY = 0; posY < img1.height(); ++posY) {
-		for (int posX = 0; posX < img2.width(); ++posX) {
-			if (!(int)abs((double)img1.pixel(posX, posY) - img2.pixel(posX, posY)) > 2) {
-				kWarning() << "Different at" << QPoint(posX, posY);
-				return false;
-			}
-		}
-	}
-	return true;
-}
-
-/**
- * Returns the url of the remote url dir if remote test dir was successfully
- * set up.
- * If testFile is valid, it is copied into the test dir.
- */
-KUrl setUpRemoteTestDir(const QString& testFile = QString());
-
-#endif /* TESTUTILS_H */

=== removed file 'tests/thumbnailloadjobtest.cpp'
--- tests/thumbnailloadjobtest.cpp	2011-07-20 13:46:34 +0000
+++ tests/thumbnailloadjobtest.cpp	1970-01-01 00:00:00 +0000
@@ -1,224 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "thumbnailloadjobtest.moc"
-
-// Qt
-#include <QDir>
-#include <QImage>
-#include <QPainter>
-
-// KDE
-#include <qtest_kde.h>
-#include <kdebug.h>
-#include <kio/copyjob.h>
-#include <kio/deletejob.h>
-
-// Local
-#include "../lib/imageformats/imageformats.h"
-#include "../lib/thumbnailloadjob.h"
-#include "testutils.h"
-
-
-using namespace Gwenview;
-
-
-QTEST_KDEMAIN(ThumbnailLoadJobTest, GUI)
-
-
-SandBox::SandBox()
-: mPath(QDir::currentPath() + "/sandbox")
-{}
-
-
-void SandBox::initDir() {
-	KIO::Job* job;
-	QDir dir(mPath);
-	if (dir.exists()) {
-		KUrl sandBoxUrl("file://" + mPath);
-		job = KIO::del(sandBoxUrl);
-		QVERIFY2(job->exec(), "Couldn't delete sandbox");
-	}
-	dir.mkpath(".");
-}
-
-
-void SandBox::fill() {
-	initDir();
-	createTestImage("red.png", 300, 200, Qt::red);
-	createTestImage("blue.png", 200, 300, Qt::blue);
-	createTestImage("small.png", 50, 50, Qt::green);
-
-	copyTestImage("orient6.jpg", 128, 256);
-	copyTestImage("orient6-small.jpg", 32, 64);
-}
-
-
-void SandBox::copyTestImage(const QString& testFileName, int width, int height) {
-	KIO::Job* job = KIO::copy(pathForTestFile(testFileName), KUrl(mPath + '/' + testFileName));
-	QVERIFY2(job->exec(), "Couldn't copy test image");
-	mSizeHash.insert(testFileName, QSize(width, height));
-}
-
-
-static QImage createColoredImage(int width, int height, const QColor& color) {
-	QImage image(width, height, QImage::Format_RGB32);
-	QPainter painter(&image);
-	painter.fillRect(image.rect(), color);
-	return image;
-}
-
-
-void SandBox::createTestImage(const QString& name, int width, int height, const QColor& color) {
-	QImage image = createColoredImage(width, height, color);
-	image.save(mPath + '/' + name, "png");
-	mSizeHash.insert(name, QSize(width, height));
-}
-
-
-void ThumbnailLoadJobTest::initTestCase() {
-	qRegisterMetaType<KFileItem>("KFileItem");
-	Gwenview::ImageFormats::registerPlugins();
-}
-
-
-void ThumbnailLoadJobTest::init() {
-	ThumbnailLoadJob::setThumbnailBaseDir(mSandBox.mPath + "/thumbnails/");
-	mSandBox.fill();
-}
-
-
-void ThumbnailLoadJobTest::testLoadLocal() {
-	QDir dir(mSandBox.mPath);
-
-    // Create a list of items which will be thumbnailed
-	KFileItemList list;
-	Q_FOREACH(const QFileInfo& info, dir.entryInfoList(QDir::Files)) {
-		KUrl url("file://" + info.absoluteFilePath());
-		KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
-		list << item;
-	}
-
-    // Generate the thumbnails
-	QPointer<ThumbnailLoadJob> job = new ThumbnailLoadJob(list, ThumbnailGroup::Normal);
-	QSignalSpy spy(job, SIGNAL(thumbnailLoaded(const KFileItem&, const QPixmap&, const QSize&)));
-	// FIXME: job->exec() causes a double free(), so wait for the job to be
-	// deleted instead
-	//job->exec();
-	job->start();
-	while (job) {
-		QTest::qWait(100);
-	}
-
-	while (!ThumbnailLoadJob::isPendingThumbnailCacheEmpty()) {
-		QTest::qWait(100);
-	}
-
-    // Check we generated the correct number of thumbnails
-	QDir thumbnailDir = ThumbnailLoadJob::thumbnailBaseDir(ThumbnailGroup::Normal);
-	// There should be one file less because small.png is a png and is too
-	// small to have a thumbnail
-	QStringList entryList = thumbnailDir.entryList(QStringList("*.png"));
-	QCOMPARE(entryList.count(), mSandBox.mSizeHash.size() - 1);
-
-	// Check what was in the thumbnailLoaded() signals
-	QCOMPARE(spy.count(), mSandBox.mSizeHash.size());
-	QSignalSpy::ConstIterator it = spy.constBegin(),
-		end = spy.constEnd();
-	for (;it != end; ++it) {
-		const QVariantList args = *it;
-		const KFileItem item = qvariant_cast<KFileItem>(args.at(0));
-		const QSize size = args.at(2).toSize();
-		const QSize expectedSize = mSandBox.mSizeHash.value(item.url().fileName());
-		QCOMPARE(size, expectedSize);
-	}
-}
-
-
-void ThumbnailLoadJobTest::testUseEmbeddedOrNot() {
-	QImage expectedThumbnail;
-	QPointer<ThumbnailLoadJob> job;
-	QPixmap thumbnailPix;
-	SandBox sandBox;
-	sandBox.initDir();
-	// This image is red and 256x128 but contains a white 128x64 thumbnail
-	sandBox.copyTestImage("embedded-thumbnail.jpg", 256, 128);
-
-	KFileItemList list;
-	KUrl url("file://" + QDir(sandBox.mPath).absoluteFilePath("embedded-thumbnail.jpg"));
-	list << KFileItem(KFileItem::Unknown, KFileItem::Unknown, url);
-
-	// Loading a normal thumbnail should bring the white one
-	job = new ThumbnailLoadJob(list, ThumbnailGroup::Normal);
-	QSignalSpy spy1(job, SIGNAL(thumbnailLoaded(const KFileItem&, const QPixmap&, const QSize&)));
-	// FIXME: job->exec() causes a double free(), so wait for the job to be
-	// deleted instead
-	//job->exec();
-	job->start();
-	while (job) {
-		QTest::qWait(100);
-	}
-
-	QCOMPARE(spy1.count(), 1);
-	expectedThumbnail = createColoredImage(128, 64, Qt::white);
-	thumbnailPix = qvariant_cast<QPixmap>(spy1.at(0).at(1));
-	fuzzyImageCompare(expectedThumbnail, thumbnailPix.toImage());
-
-	// Loading a large thumbnail should bring the red one
-	job = new ThumbnailLoadJob(list, ThumbnailGroup::Large);
-	QSignalSpy spy2(job, SIGNAL(thumbnailLoaded(const KFileItem&, const QPixmap&, const QSize&)));
-	job->start();
-	while (job) {
-		QTest::qWait(100);
-	}
-
-	QCOMPARE(spy2.count(), 1);
-	expectedThumbnail = createColoredImage(256, 128, Qt::red);
-	thumbnailPix = qvariant_cast<QPixmap>(spy2.at(0).at(1));
-	fuzzyImageCompare(expectedThumbnail, thumbnailPix.toImage());
-}
-
-
-void ThumbnailLoadJobTest::testLoadRemote() {
-	KUrl url = setUpRemoteTestDir("test.png");
-	if (!url.isValid()) {
-		return;
-	}
-	url.addPath("test.png");
-
-	KFileItemList list;
-	KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
-	list << item;
-
-	QPointer<ThumbnailLoadJob> job = new ThumbnailLoadJob(list, ThumbnailGroup::Normal);
-	// FIXME: job->exec() causes a double free(), so wait for the job to be
-	// deleted instead
-	//job->exec();
-	job->start();
-	while (job) {
-		QTest::qWait(100);
-	}
-	while (!ThumbnailLoadJob::isPendingThumbnailCacheEmpty()) {
-		QTest::qWait(100);
-	}
-
-	QDir thumbnailDir = ThumbnailLoadJob::thumbnailBaseDir(ThumbnailGroup::Normal);
-	QStringList entryList = thumbnailDir.entryList(QStringList("*.png"));
-	QCOMPARE(entryList.count(), 1);
-}

=== removed file 'tests/thumbnailloadjobtest.h'
--- tests/thumbnailloadjobtest.h	2011-07-20 13:46:34 +0000
+++ tests/thumbnailloadjobtest.h	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2007 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef THUMBNAILLOADJOBTEST_H
-#define THUMBNAILLOADJOBTEST_H
-
-// Qt
-#include <QColor>
-#include <QHash>
-#include <QObject>
-#include <QSize>
-
-class SandBox {
-public:
-	SandBox();
-	void initDir();
-	void fill();
-	void createTestImage(const QString& name, int width, int height, const QColor& color);
-	void copyTestImage(const QString& name, int width, int height);
-
-	QHash<QString, QSize> mSizeHash;
-	QString mPath;
-};
-
-class ThumbnailLoadJobTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void init();
-	void initTestCase();
-	void testLoadLocal();
-	void testLoadRemote();
-	void testUseEmbeddedOrNot();
-
-private:
-	SandBox mSandBox;
-};
-
-#endif // THUMBNAILLOADJOBTEST_H

=== removed file 'tests/timeutilstest.cpp'
--- tests/timeutilstest.cpp	2011-07-20 13:46:34 +0000
+++ tests/timeutilstest.cpp	1970-01-01 00:00:00 +0000
@@ -1,79 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-
-#include "timeutilstest.moc"
-
-// libc
-#include <utime.h>
-
-// KDE
-#include <kfileitem.h>
-#include <ktemporaryfile.h>
-#include <qtest_kde.h>
-
-// Local
-#include "../lib/timeutils.h"
-
-#include "testutils.h"
-
-QTEST_KDEMAIN( TimeUtilsTest, GUI )
-
-using namespace Gwenview;
-
-static void touchFile(const QString& path) {
-	utime(QFile::encodeName(path).data(), 0);
-}
-
-void TimeUtilsTest::testPng() {
-	KUrl url = urlForTestFile("test.png");
-	KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
-	KDateTime dateTime = TimeUtils::dateTimeForFileItem(item);
-	QCOMPARE(dateTime, item.time(KFileItem::ModificationTime));
-}
-
-
-void TimeUtilsTest::testJpeg() {
-	KUrl url = urlForTestFile("orient6.jpg");
-	KFileItem item(KFileItem::Unknown, KFileItem::Unknown, url);
-	KDateTime dateTime = TimeUtils::dateTimeForFileItem(item);
-
-	const KDateTime orient6DateTime = KDateTime::fromString("2003-03-25T02:02:21");
-	QCOMPARE(dateTime, orient6DateTime);
-}
-
-
-void TimeUtilsTest::testCache() {
-	KTemporaryFile tempFile;
-	QVERIFY(tempFile.open());
-	KUrl url = KUrl::fromLocalFile(tempFile.fileName());
-	KFileItem item1(KFileItem::Unknown, KFileItem::Unknown, url);
-	KDateTime dateTime1 = TimeUtils::dateTimeForFileItem(item1);
-	QCOMPARE(dateTime1, item1.time(KFileItem::ModificationTime));
-
-	QTest::qWait(1200);
-	touchFile(url.toLocalFile());
-
-	KFileItem item2(KFileItem::Unknown, KFileItem::Unknown, url);
-	KDateTime dateTime2 = TimeUtils::dateTimeForFileItem(item2);
-
-	QVERIFY(dateTime1 != dateTime2);
-
-	QCOMPARE(dateTime2, item2.time(KFileItem::ModificationTime));
-}

=== removed file 'tests/timeutilstest.h'
--- tests/timeutilstest.h	2011-07-20 13:46:34 +0000
+++ tests/timeutilstest.h	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2008 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef TIMEUTILSTEST_H
-#define TIMEUTILSTEST_H
-
-// Qt
-#include <QObject>
-
-class TimeUtilsTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void testPng();
-	void testJpeg();
-	void testCache();
-};
-
-#endif /* TIMEUTILSTEST_H */

=== removed file 'tests/transformimageoperationtest.cpp'
--- tests/transformimageoperationtest.cpp	2011-07-20 13:46:34 +0000
+++ tests/transformimageoperationtest.cpp	1970-01-01 00:00:00 +0000
@@ -1,69 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2010 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-// Qt
-#include <QEventLoop>
-#include <QImage>
-
-// KDE
-#include <kdebug.h>
-#include <qtest_kde.h>
-
-// Local
-#include "../lib/document/documentfactory.h"
-#include "../lib/imageutils.h"
-#include "../lib/transformimageoperation.h"
-#include "testutils.h"
-
-#include "transformimageoperationtest.moc"
-
-QTEST_KDEMAIN( TransformImageOperationTest, GUI )
-
-using namespace Gwenview;
-
-
-void TransformImageOperationTest::initTestCase() {
-	qRegisterMetaType<KUrl>("KUrl");
-}
-
-
-void TransformImageOperationTest::init() {
-	DocumentFactory::instance()->clearCache();
-}
-
-
-void TransformImageOperationTest::testRotate90() {
-	KUrl url = urlForTestFile("test.png");
-	QImage image;
-
-	bool ok = image.load(url.toLocalFile());
-	QVERIFY2(ok, "Could not load 'test.png'");
-	QMatrix matrix = ImageUtils::transformMatrix(ROT_90);
-	image = image.transformed(matrix);
-
-	Document::Ptr doc = DocumentFactory::instance()->load(url);
-
-	TransformImageOperation* op = new TransformImageOperation(ROT_90);
-	QEventLoop loop;
-	connect(doc.data(), SIGNAL(allTasksDone()), &loop, SLOT(quit()));
-	op->applyToDocument(doc);
-	loop.exec();
-
-	QCOMPARE(image, doc->image());
-}

=== removed file 'tests/transformimageoperationtest.h'
--- tests/transformimageoperationtest.h	2011-07-20 13:46:34 +0000
+++ tests/transformimageoperationtest.h	1970-01-01 00:00:00 +0000
@@ -1,39 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2010 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef TRANSFORMIMAGEOPERATIONTEST_H
-#define TRANSFORMIMAGEOPERATIONTEST_H
-
-// Qt
-#include <QObject>
-
-// Local
-#include "../lib/document/document.h"
-
-
-class TransformImageOperationTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void testRotate90();
-	void initTestCase();
-	void init();
-};
-
-#endif // TRANSFORMIMAGEOPERATIONTEST_H

=== removed file 'tests/urlutilstest.cpp'
--- tests/urlutilstest.cpp	2011-07-20 13:46:34 +0000
+++ tests/urlutilstest.cpp	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2009 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#include "urlutilstest.moc"
-
-// Qt
-
-// KDE
-#include <kdebug.h>
-#include <qtest_kde.h>
-
-// Local
-#include "../lib/urlutils.h"
-
-QTEST_KDEMAIN(UrlUtilsTest, GUI)
-
-using namespace Gwenview;
-
-void UrlUtilsTest::testFixUserEnteredUrl() {
-	QFETCH(KUrl, in);
-	QFETCH(KUrl, expected);
-	KUrl out = UrlUtils::fixUserEnteredUrl(in);
-	QCOMPARE(out.url(), expected.url());
-}
-
-#define NEW_ROW(in, expected) QTest::newRow(QString(in).toLocal8Bit().data()) << KUrl(in) << KUrl(expected)
-void UrlUtilsTest::testFixUserEnteredUrl_data() {
-	QTest::addColumn<KUrl>("in");
-	QTest::addColumn<KUrl>("expected");
-
-	QString pwd = QDir::currentPath();
-
-	NEW_ROW("http://example.com", "http://example.com");
-	NEW_ROW("example.zip", "zip://" + pwd + "/example.zip");
-	NEW_ROW("file://" + pwd + "/example.zip", "zip://" + pwd + "/example.zip");
-	NEW_ROW("file://" + pwd + "/example.cbz", "zip://" + pwd + "/example.cbz");
-	NEW_ROW("file://" + pwd + "/example.jpg", "file://" + pwd + "/example.jpg");
-}

=== removed file 'tests/urlutilstest.h'
--- tests/urlutilstest.h	2011-07-20 13:46:34 +0000
+++ tests/urlutilstest.h	1970-01-01 00:00:00 +0000
@@ -1,34 +0,0 @@
-/*
-Gwenview: an image viewer
-Copyright 2009 Aurélien Gâteau <agateau@kde.org>
-
-This program is free software; you can redistribute it and/or
-modify it under the terms of the GNU General Public License
-as published by the Free Software Foundation; either version 2
-of the License, or (at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program; if not, write to the Free Software
-Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-
-*/
-#ifndef URLUTILSTEST_H
-#define URLUTILSTEST_H
-
-// Qt
-#include <QObject>
-
-class UrlUtilsTest : public QObject {
-	Q_OBJECT
-
-private Q_SLOTS:
-	void testFixUserEnteredUrl();
-	void testFixUserEnteredUrl_data();
-};
-
-#endif /* URLUTILSTEST_H */

